-----------------------------------------------------
-- Export file for user CISP@ORCL_228              --
-- Created by Administrator on 2021/8/26, 16:06:35 --
-----------------------------------------------------

set define off
spool cisp_20210826.log

prompt
prompt Creating table AA
prompt =================
prompt
create table AA
(
  a   VARCHAR2(100),
  b   VARCHAR2(100),
  c   VARCHAR2(100),
  d   VARCHAR2(100),
  e   VARCHAR2(100),
  f   VARCHAR2(100),
  h   VARCHAR2(100),
  i   VARCHAR2(100),
  j   VARCHAR2(100),
  k   VARCHAR2(100),
  o   VARCHAR2(100),
  p   VARCHAR2(100),
  q   VARCHAR2(100),
  r   VARCHAR2(100),
  s   VARCHAR2(100),
  t   VARCHAR2(100),
  u1  VARCHAR2(100),
  u2  VARCHAR2(100),
  u3  VARCHAR2(100),
  u4  VARCHAR2(100),
  u5  VARCHAR2(100),
  u6  VARCHAR2(100),
  u7  VARCHAR2(100),
  u8  VARCHAR2(100),
  u9  VARCHAR2(100),
  u10 VARCHAR2(100)
)
;

prompt
prompt Creating table A_A3_QTSZ
prompt ========================
prompt
create table A_A3_QTSZ
(
  yyb  VARCHAR2(10),
  zqsz NUMBER(18,2)
)
;

prompt
prompt Creating table A_BHG_DJHB
prompt =========================
prompt
create table A_BHG_DJHB
(
  zqzh VARCHAR2(10)
)
;

prompt
prompt Creating table A_HS08_SRPCONTRACT_1011
prompt ======================================
prompt
create table A_HS08_SRPCONTRACT_1011
(
  init_date               NUMBER(10) not null,
  sign_operator_no        VARCHAR2(18) not null,
  contract_id             VARCHAR2(32) not null,
  join_contract_id        VARCHAR2(32) not null,
  papercont_id            VARCHAR2(32) not null,
  srp_contract_type       CHAR(1) not null,
  branch_no               NUMBER(10) not null,
  fund_account            VARCHAR2(18) not null,
  client_id               VARCHAR2(18) not null,
  stock_account           VARCHAR2(20) not null,
  exchange_type           VARCHAR2(4) not null,
  stock_code              VARCHAR2(6) not null,
  stock_type              VARCHAR2(4) not null,
  money_type              VARCHAR2(3) not null,
  entrust_amount          NUMBER(19,2) not null,
  expire_year_rate        NUMBER(9,8) not null,
  entrust_balance         NUMBER(19,2) not null,
  back_balance            NUMBER(19,2) not null,
  date_back               NUMBER(10) not null,
  real_year_rate          NUMBER(9,8) not null,
  real_back_balance       NUMBER(19,2) not null,
  real_date_back          NUMBER(10) not null,
  srp_contract_status     CHAR(1) not null,
  date_clear              NUMBER(10) not null,
  sign_date               NUMBER(10) not null,
  entrust_date            NUMBER(10) not null,
  entrust_no              NUMBER(10) not null,
  remark                  VARCHAR2(2000) not null,
  position_str            VARCHAR2(100) not null,
  cbp_business_id         VARCHAR2(16) not null,
  fund_usage              VARCHAR2(2000) not null,
  assure_price            NUMBER(18,3) not null,
  srp_agent_flag          CHAR(1) not null,
  funder_no               NUMBER(10) not null,
  rate_mode               CHAR(1) not null,
  bonus_amount            NUMBER(19,2) not null,
  bonus_balance           NUMBER(19,2) not null,
  back_type               CHAR(1) not null,
  prev_status             CHAR(1) not null,
  sum_back_amount         NUMBER(19,2) not null,
  sum_back_balance        NUMBER(19,2) not null,
  stock_property          VARCHAR2(2) not null,
  lift_date               NUMBER(10) not null,
  repaid_balance          NUMBER(19,2) not null,
  settle_interest         NUMBER(19,2) not null,
  unsettle_interest       NUMBER(19,2) not null,
  report_id               VARCHAR2(32) not null,
  impawn_id               VARCHAR2(16) not null,
  executives_flag         CHAR(1) not null,
  limit_transfer_price    NUMBER(18,3) not null,
  limit_orig_value        NUMBER(18,3) not null,
  assure_ratio            NUMBER(9,8) not null,
  margin_focus_ratio      NUMBER(15,8) not null,
  margin_alert_ratio      NUMBER(15,8) not null,
  margin_treat_ratio      NUMBER(15,8) not null,
  integral_balance        NUMBER(19,2) not null,
  integral_update         NUMBER(10) not null,
  last_interest_date      NUMBER(10) not null,
  batch_unsettle_interest NUMBER(19,2) not null,
  srp_kind                CHAR(1) not null,
  ipo_pre_interest        NUMBER(19,2) not null,
  ipo_pre_fare            NUMBER(19,2) not null,
  ask_date_back           NUMBER(10) not null,
  ask_back_balance        NUMBER(19,2) not null,
  recoup_rate             NUMBER(9,8) not null,
  max_recoup_days         NUMBER(10) not null,
  recoup_balance          NUMBER(19,2) not null,
  fine_rate               NUMBER(14,13) not null,
  fine_interest           NUMBER(19,2) not null,
  back_principal          NUMBER(19,2) not null
)
;

prompt
prompt Creating table C_FUND
prompt =====================
prompt
create table C_FUND
(
  fund_account VARCHAR2(18)
)
;

prompt
prompt Creating table FUND_CODE
prompt ========================
prompt
create table FUND_CODE
(
  fund_code VARCHAR2(6),
  balance   NUMBER(19,2)
)
;

prompt
prompt Creating table JLSYYB
prompt =====================
prompt
create table JLSYYB
(
  yyb VARCHAR2(10)
)
;

prompt
prompt Creating table RZRQ_BANK
prompt ========================
prompt
create table RZRQ_BANK
(
  rzrq_bank_code VARCHAR2(20),
  hs_bank_name   VARCHAR2(20),
  hs_bank_code   VARCHAR2(20)
)
;

prompt
prompt Creating table RZRQ_HS_HIS_HISFUNDJOUR_Q_01
prompt ===========================================
prompt
create table RZRQ_HS_HIS_HISFUNDJOUR_Q_01
(
  init_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  serial_no         NUMBER(10) default 0,
  client_id         VARCHAR2(18) default ' ',
  fund_account      VARCHAR2(18) default ' ',
  money_type        VARCHAR2(3) default ' ',
  exchange_type     VARCHAR2(4) default ' ',
  curr_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  curr_time         NUMBER(10) default to_number(to_char(sysdate,'hh24miss')),
  business_flag     NUMBER(10) default 0,
  op_branch_no      NUMBER(10) default 0,
  operator_no       VARCHAR2(18) default ' ',
  op_station        VARCHAR2(255) default ' ',
  op_entrust_way    CHAR(10) default ' ',
  branch_no         NUMBER(10) default 0,
  bank_no           VARCHAR2(4) default ' ',
  occur_balance     NUMBER(19,2) default 0.0,
  post_balance      NUMBER(19,2) default 0.0,
  join_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  join_serial_no    NUMBER(10) default 0,
  bk_serial_no      VARCHAR2(20) default ' ',
  frozen_kind       CHAR(1) default ' ',
  join_info         VARCHAR2(100) default ' ',
  remark            VARCHAR2(2000) default ' ',
  real_status       CHAR(1) default ' ',
  position_str      VARCHAR2(100) default ' ',
  cancel_serialno   VARCHAR2(64) default ' ',
  client_group      NUMBER(10) default 0,
  room_code         NUMBER(10) default 0,
  asset_prop        CHAR(1) default ' ',
  limit_flag        NUMBER(10) default 0,
  risk_level        NUMBER(10) default 0,
  corp_client_group NUMBER(10) default 0,
  corp_risk_level   NUMBER(10) default 0,
  asset_level       CHAR(1) default ' ',
  client_name       VARCHAR2(60) default ' '
)
nologging;

prompt
prompt Creating table RZRQ_HS_HIS_HISFUNDJOUR_Q_02
prompt ===========================================
prompt
create table RZRQ_HS_HIS_HISFUNDJOUR_Q_02
(
  init_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  serial_no         NUMBER(10) default 0,
  client_id         VARCHAR2(18) default ' ',
  fund_account      VARCHAR2(18) default ' ',
  money_type        VARCHAR2(3) default ' ',
  exchange_type     VARCHAR2(4) default ' ',
  curr_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  curr_time         NUMBER(10) default to_number(to_char(sysdate,'hh24miss')),
  business_flag     NUMBER(10) default 0,
  op_branch_no      NUMBER(10) default 0,
  operator_no       VARCHAR2(18) default ' ',
  op_station        VARCHAR2(255) default ' ',
  op_entrust_way    CHAR(10) default ' ',
  branch_no         NUMBER(10) default 0,
  bank_no           VARCHAR2(4) default ' ',
  occur_balance     NUMBER(19,2) default 0.0,
  post_balance      NUMBER(19,2) default 0.0,
  join_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  join_serial_no    NUMBER(10) default 0,
  bk_serial_no      VARCHAR2(20) default ' ',
  frozen_kind       CHAR(1) default ' ',
  join_info         VARCHAR2(100) default ' ',
  remark            VARCHAR2(2000) default ' ',
  real_status       CHAR(1) default ' ',
  position_str      VARCHAR2(100) default ' ',
  cancel_serialno   VARCHAR2(64) default ' ',
  client_group      NUMBER(10) default 0,
  room_code         NUMBER(10) default 0,
  asset_prop        CHAR(1) default ' ',
  limit_flag        NUMBER(10) default 0,
  risk_level        NUMBER(10) default 0,
  corp_client_group NUMBER(10) default 0,
  corp_risk_level   NUMBER(10) default 0,
  asset_level       CHAR(1) default ' ',
  client_name       VARCHAR2(60) default ' '
)
nologging;

prompt
prompt Creating table RZRQ_HS_HIS_HISFUNDJOUR_Q_03
prompt ===========================================
prompt
create table RZRQ_HS_HIS_HISFUNDJOUR_Q_03
(
  init_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  serial_no         NUMBER(10) default 0,
  client_id         VARCHAR2(18) default ' ',
  fund_account      VARCHAR2(18) default ' ',
  money_type        VARCHAR2(3) default ' ',
  exchange_type     VARCHAR2(4) default ' ',
  curr_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  curr_time         NUMBER(10) default to_number(to_char(sysdate,'hh24miss')),
  business_flag     NUMBER(10) default 0,
  op_branch_no      NUMBER(10) default 0,
  operator_no       VARCHAR2(18) default ' ',
  op_station        VARCHAR2(255) default ' ',
  op_entrust_way    CHAR(10) default ' ',
  branch_no         NUMBER(10) default 0,
  bank_no           VARCHAR2(4) default ' ',
  occur_balance     NUMBER(19,2) default 0.0,
  post_balance      NUMBER(19,2) default 0.0,
  join_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  join_serial_no    NUMBER(10) default 0,
  bk_serial_no      VARCHAR2(20) default ' ',
  frozen_kind       CHAR(1) default ' ',
  join_info         VARCHAR2(100) default ' ',
  remark            VARCHAR2(2000) default ' ',
  real_status       CHAR(1) default ' ',
  position_str      VARCHAR2(100) default ' ',
  cancel_serialno   VARCHAR2(64) default ' ',
  client_group      NUMBER(10) default 0,
  room_code         NUMBER(10) default 0,
  asset_prop        CHAR(1) default ' ',
  limit_flag        NUMBER(10) default 0,
  risk_level        NUMBER(10) default 0,
  corp_client_group NUMBER(10) default 0,
  corp_risk_level   NUMBER(10) default 0,
  asset_level       CHAR(1) default ' ',
  client_name       VARCHAR2(60) default ' '
)
nologging;

prompt
prompt Creating table RZRQ_HS_HIS_HISFUNDJOUR_Q_04
prompt ===========================================
prompt
create table RZRQ_HS_HIS_HISFUNDJOUR_Q_04
(
  init_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  serial_no         NUMBER(10) default 0,
  client_id         VARCHAR2(18) default ' ',
  fund_account      VARCHAR2(18) default ' ',
  money_type        VARCHAR2(3) default ' ',
  exchange_type     VARCHAR2(4) default ' ',
  curr_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  curr_time         NUMBER(10) default to_number(to_char(sysdate,'hh24miss')),
  business_flag     NUMBER(10) default 0,
  op_branch_no      NUMBER(10) default 0,
  operator_no       VARCHAR2(18) default ' ',
  op_station        VARCHAR2(255) default ' ',
  op_entrust_way    CHAR(10) default ' ',
  branch_no         NUMBER(10) default 0,
  bank_no           VARCHAR2(4) default ' ',
  occur_balance     NUMBER(19,2) default 0.0,
  post_balance      NUMBER(19,2) default 0.0,
  join_date         NUMBER(10) default to_number(to_char(sysdate,'yyyymmdd')),
  join_serial_no    NUMBER(10) default 0,
  bk_serial_no      VARCHAR2(20) default ' ',
  frozen_kind       CHAR(1) default ' ',
  join_info         VARCHAR2(100) default ' ',
  remark            VARCHAR2(2000) default ' ',
  real_status       CHAR(1) default ' ',
  position_str      VARCHAR2(100) default ' ',
  cancel_serialno   VARCHAR2(64) default ' ',
  client_group      NUMBER(10) default 0,
  room_code         NUMBER(10) default 0,
  asset_prop        CHAR(1) default ' ',
  limit_flag        NUMBER(10) default 0,
  risk_level        NUMBER(10) default 0,
  corp_client_group NUMBER(10) default 0,
  corp_risk_level   NUMBER(10) default 0,
  asset_level       CHAR(1) default ' ',
  client_name       VARCHAR2(60) default ' '
)
nologging;

prompt
prompt Creating table TEMP
prompt ===================
prompt
create table TEMP
(
  aa VARCHAR2(20)
)
;

prompt
prompt Creating table T_ACT_D001
prompt =========================
prompt
create table T_ACT_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a004 NUMBER not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_ACT_D001
  is 'ָάȱ';
comment on column T_ACT_D001.p001
  is 'ָID';
comment on column T_ACT_D001.a002
  is 'ָ';
comment on column T_ACT_D001.a004
  is 'ID';
comment on column T_ACT_D001.a009
  is 'Դ';
comment on column T_ACT_D001.b099
  is 'ע';
comment on column T_ACT_D001.z100
  is '־';
comment on column T_ACT_D001.c100
  is 'ǰ׺';
comment on column T_ACT_D001.d100
  is '׺';
comment on column T_ACT_D001.e100
  is '';
alter table T_ACT_D001
  add constraint PK_T_ACT_D001 primary key (P001);

prompt
prompt Creating table T_ACT_D002
prompt =========================
prompt
create table T_ACT_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_ACT_D002
  is 'ֵ׼Ŀάȱ';
comment on column T_ACT_D002.p001
  is 'ֵ׼ĿID';
comment on column T_ACT_D002.a002
  is 'ֵ׼Ŀ';
comment on column T_ACT_D002.a009
  is 'Դ';
comment on column T_ACT_D002.b099
  is 'ע';
comment on column T_ACT_D002.z100
  is '־';
comment on column T_ACT_D002.c100
  is 'ǰ׺';
comment on column T_ACT_D002.d100
  is '׺';
comment on column T_ACT_D002.e100
  is '';
alter table T_ACT_D002
  add constraint PK_T_ACT_D002 primary key (P001);

prompt
prompt Creating table T_ACT_D003
prompt =========================
prompt
create table T_ACT_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER,
  n099 NUMBER
)
;
comment on table T_ACT_D003
  is 'Ŀάȱ';
comment on column T_ACT_D003.p001
  is 'ĿID';
comment on column T_ACT_D003.a002
  is 'Ŀ';
comment on column T_ACT_D003.a009
  is 'Դ';
comment on column T_ACT_D003.b099
  is 'ע';
comment on column T_ACT_D003.z100
  is '־';
comment on column T_ACT_D003.c100
  is 'ǰ׺ַ';
comment on column T_ACT_D003.d100
  is 'κ׺ַ';
comment on column T_ACT_D003.e100
  is '';
alter table T_ACT_D003
  add constraint PK_T_ACT_D003 primary key (P001);

prompt
prompt Creating table T_ACT_D004
prompt =========================
prompt
create table T_ACT_D004
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a005 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a009 NUMBER,
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_ACT_D004
  is 'ʲծĿάȱ';
comment on column T_ACT_D004.p001
  is 'ʲծĿID';
comment on column T_ACT_D004.a002
  is 'ʲծĿ';
comment on column T_ACT_D004.a005
  is 'ID';
comment on column T_ACT_D004.b099
  is 'ע';
comment on column T_ACT_D004.z100
  is '־';
comment on column T_ACT_D004.a009
  is 'Դ';
comment on column T_ACT_D004.c100
  is 'ǰ׺';
comment on column T_ACT_D004.d100
  is '׺';
comment on column T_ACT_D004.e100
  is '';
alter table T_ACT_D004
  add constraint PK_T_ACT_D004 primary key (P001);

prompt
prompt Creating table T_ACT_D005
prompt =========================
prompt
create table T_ACT_D005
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_ACT_D005
  is 'Ȩ䶯Ŀάȱ';
comment on column T_ACT_D005.p001
  is '䶯ĿID';
comment on column T_ACT_D005.a002
  is 'Ŀ';
comment on column T_ACT_D005.a009
  is 'Դ';
comment on column T_ACT_D005.b099
  is 'ע';
comment on column T_ACT_D005.z100
  is '־';
alter table T_ACT_D005
  add constraint PK_T_ACT_D005 primary key (P001);

prompt
prompt Creating table T_ACT_D006
prompt =========================
prompt
create table T_ACT_D006
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_ACT_D006
  is 'Ȩ䶯άȱ';
comment on column T_ACT_D006.p001
  is '䶯ID';
comment on column T_ACT_D006.a002
  is '䶯';
comment on column T_ACT_D006.a009
  is 'Դ';
comment on column T_ACT_D006.b099
  is 'ע';
comment on column T_ACT_D006.z100
  is '־';
comment on column T_ACT_D006.c100
  is 'ǰ׺';
comment on column T_ACT_D006.d100
  is '׺';
comment on column T_ACT_D006.e100
  is '';
alter table T_ACT_D006
  add constraint PK_T_ACT_D006 primary key (P001);

prompt
prompt Creating table T_ACT_F001
prompt =========================
prompt
create table T_ACT_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_ACT_F001
  is 'ʲծʵ';
comment on column T_ACT_F001.p001
  is 'ID';
comment on column T_ACT_F001.p002
  is 'ծĿID';
comment on column T_ACT_F001.p003
  is 'ָID';
comment on column T_ACT_F001.v
  is 'ֵָ';
comment on column T_ACT_F001.w100
  is 'ܲID';
alter table T_ACT_F001
  add constraint PK_ACT_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_ACT_F002
prompt =========================
prompt
create table T_ACT_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_ACT_F002
  is 'ʵ';
comment on column T_ACT_F002.p001
  is 'ID';
comment on column T_ACT_F002.p002
  is 'ָID';
comment on column T_ACT_F002.p003
  is 'ĿID';
comment on column T_ACT_F002.v
  is 'ֵָ';
comment on column T_ACT_F002.w100
  is 'ܲID';
alter table T_ACT_F002
  add constraint PK_T_ACT_F002 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_ACT_F003
prompt =========================
prompt
create table T_ACT_F003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_ACT_F003
  is 'Ȩ䶯ʵ';
comment on column T_ACT_F003.p001
  is 'ID';
comment on column T_ACT_F003.p002
  is '䶯ĿID';
comment on column T_ACT_F003.p003
  is '䶯ID';
comment on column T_ACT_F003.v
  is 'ֵָ';
comment on column T_ACT_F003.w100
  is 'ܲID';
alter table T_ACT_F003
  add constraint PK_T_ACT_F003 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_ACT_F004
prompt =========================
prompt
create table T_ACT_F004
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_ACT_F004
  is 'ʲֵ׼ʵ';
comment on column T_ACT_F004.p001
  is 'ID';
comment on column T_ACT_F004.p002
  is 'ָID';
comment on column T_ACT_F004.p003
  is 'ֵĿID';
comment on column T_ACT_F004.v
  is 'ֵָ';
comment on column T_ACT_F004.w100
  is 'ܲID';
alter table T_ACT_F004
  add constraint PK_T_ACT_F004 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B001_F001
prompt ==========================
prompt
create table T_B001_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  v    NUMBER(19,2)
)
;
comment on table T_B001_F001
  is 'ʲծάȱ';
comment on column T_B001_F001.p001
  is 'ID';
comment on column T_B001_F001.p002
  is 'ӪҵID';
comment on column T_B001_F001.p003
  is 'ʲծĿID';
comment on column T_B001_F001.p004
  is 'ָID';
comment on column T_B001_F001.v
  is 'ֵָ';
alter table T_B001_F001
  add constraint T_B001_F001 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B001_F002
prompt ==========================
prompt
create table T_B001_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  v    NUMBER(19,2)
)
;
comment on table T_B001_F002
  is 'άȱ';
comment on column T_B001_F002.p001
  is 'ID';
comment on column T_B001_F002.p002
  is 'ӪҵID';
comment on column T_B001_F002.p003
  is 'ĿID';
comment on column T_B001_F002.p004
  is 'ָID';
comment on column T_B001_F002.v
  is 'ֵָ';
alter table T_B001_F002
  add constraint T_B001_F002 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B002_F001
prompt ==========================
prompt
create table T_B002_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  v    NUMBER(19,2)
)
;
comment on table T_B002_F001
  is 'ͻʲάȱ';
comment on column T_B002_F001.p001
  is 'ID';
comment on column T_B002_F001.p002
  is 'ӪҵID';
comment on column T_B002_F001.p003
  is 'ͻʲĿID';
comment on column T_B002_F001.p004
  is 'ָID';
comment on column T_B002_F001.v
  is 'ֵָ';
alter table T_B002_F001
  add constraint T_B002_F001 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B002_F002
prompt ==========================
prompt
create table T_B002_F002
(
  p001 NUMBER,
  p002 NUMBER,
  p003 NUMBER,
  p004 NUMBER,
  v    NUMBER(19,2)
)
;
comment on table T_B002_F002
  is 'ͻʽֲάȱ';
comment on column T_B002_F002.p001
  is 'ID';
comment on column T_B002_F002.p002
  is 'ӪҵID';
comment on column T_B002_F002.p003
  is 'ͻʽֲĿID';
comment on column T_B002_F002.p004
  is 'ָID';
comment on column T_B002_F002.v
  is 'ֵ';

prompt
prompt Creating table T_B003_F001
prompt ==========================
prompt
create table T_B003_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER,
  p004 NUMBER not null
)
;
comment on table T_B003_F001
  is 'Ӫҵʽ˻ʵ';
comment on column T_B003_F001.p001
  is 'ID';
comment on column T_B003_F001.p002
  is 'ĿID';
comment on column T_B003_F001.p003
  is 'ָID';
comment on column T_B003_F001.v
  is 'ֵָ';
comment on column T_B003_F001.p004
  is 'ӪҵID';
alter table T_B003_F001
  add constraint PK_T_B003_F001 primary key (P002, P001, P003, P004);

prompt
prompt Creating table T_B003_F002
prompt ==========================
prompt
create table T_B003_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER,
  p004 NUMBER not null
)
;
comment on table T_B003_F002
  is 'Ӫҵ֤ȯ˻ʵ';
comment on column T_B003_F002.p001
  is 'ID';
comment on column T_B003_F002.p002
  is 'ĿID';
comment on column T_B003_F002.p003
  is 'ָID';
comment on column T_B003_F002.v
  is 'ֵָ';
comment on column T_B003_F002.p004
  is 'ӪҵID';
alter table T_B003_F002
  add constraint PK_B003_F002 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B003_F003
prompt ==========================
prompt
create table T_B003_F003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER,
  p004 NUMBER not null
)
;
comment on table T_B003_F003
  is 'Ӫҵ˻ʵ';
comment on column T_B003_F003.p001
  is 'ID';
comment on column T_B003_F003.p002
  is 'ĿID';
comment on column T_B003_F003.p003
  is 'ָID';
comment on column T_B003_F003.v
  is 'ֵָ';
comment on column T_B003_F003.p004
  is 'ӪҵID';
alter table T_B003_F003
  add constraint PK_B003_F003 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B003_F004
prompt ==========================
prompt
create table T_B003_F004
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  p004 NUMBER not null
)
;
comment on table T_B003_F004
  is 'Ӫҵ˻淶ʵ';
comment on column T_B003_F004.p001
  is 'ID';
comment on column T_B003_F004.p002
  is 'ĿID';
comment on column T_B003_F004.p003
  is 'ָID';
comment on column T_B003_F004.v
  is 'ֵָ';
comment on column T_B003_F004.p004
  is 'ӪҵID';
alter table T_B003_F004
  add constraint PK_B003_F004 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B003_F005
prompt ==========================
prompt
create table T_B003_F005
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  p004 NUMBER not null
)
;
comment on table T_B003_F005
  is 'Ӫҵ˻淶ʵ';
comment on column T_B003_F005.p001
  is 'ID';
comment on column T_B003_F005.p002
  is 'ĿID';
comment on column T_B003_F005.p003
  is 'ָID';
comment on column T_B003_F005.v
  is 'ֵָ';
comment on column T_B003_F005.p004
  is 'ӪҵID';
alter table T_B003_F005
  add constraint PK_B003_F005 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B004_F001
prompt ==========================
prompt
create table T_B004_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER,
  v    NUMBER(19,2),
  p004 NUMBER not null
)
;
comment on table T_B004_F001
  is '֤ȯάȱ';
comment on column T_B004_F001.p001
  is 'ID';
comment on column T_B004_F001.p002
  is '֤ȯĿID';
comment on column T_B004_F001.p003
  is 'ָID';
comment on column T_B004_F001.v
  is 'ֵָ';
comment on column T_B004_F001.p004
  is 'ӪҵID';
alter table T_B004_F001
  add constraint PK_T_B004_F001 primary key (P001, P002, P003, P004)
  disable
  novalidate;

prompt
prompt Creating table T_B004_F002
prompt ==========================
prompt
create table T_B004_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  v    NUMBER(19,2),
  p003 NUMBER,
  p004 NUMBER not null
)
;
comment on table T_B004_F002
  is '֤ȯײάȱ';
comment on column T_B004_F002.p001
  is 'ID';
comment on column T_B004_F002.p002
  is '֤ȯĿID(1013ɷתý׽
)';
comment on column T_B004_F002.v
  is 'ֵָ';
comment on column T_B004_F002.p003
  is 'ָID';
comment on column T_B004_F002.p004
  is 'ӪҵID';
alter table T_B004_F002
  add constraint PK_T_B004_F002 primary key (P001, P002, P003)
  disable
  novalidate;

prompt
prompt Creating table T_B00_D001
prompt =========================
prompt
create table T_B00_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a003 VARCHAR2(64),
  a004 DATE,
  a005 VARCHAR2(8),
  a006 VARCHAR2(128)
)
;
comment on table T_B00_D001
  is 'ҵάȣ';
comment on column T_B00_D001.p001
  is 'ҵID';
comment on column T_B00_D001.a002
  is 'ҵ';
comment on column T_B00_D001.a003
  is '׼ļĺ';
comment on column T_B00_D001.a004
  is 'ʼ';
comment on column T_B00_D001.a005
  is '״̬';
comment on column T_B00_D001.a006
  is 'ע';
alter table T_B00_D001
  add constraint P_B00_D001 primary key (P001);

prompt
prompt Creating table T_B00_D002
prompt =========================
prompt
create table T_B00_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D002
  is 'гάȣ';
comment on column T_B00_D002.p001
  is 'гID';
comment on column T_B00_D002.a002
  is 'г';
comment on column T_B00_D002.a009
  is 'Դ';
comment on column T_B00_D002.b099
  is 'ע';
comment on column T_B00_D002.z100
  is '־';
alter table T_B00_D002
  add constraint P_B00_D002 primary key (P001);

prompt
prompt Creating table T_B00_D003
prompt =========================
prompt
create table T_B00_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D003
  is 'ͻͣάȣ';
comment on column T_B00_D003.p001
  is 'ͻID';
comment on column T_B00_D003.a002
  is 'ͻ';
comment on column T_B00_D003.a009
  is 'Դ';
comment on column T_B00_D003.b099
  is 'ע';
comment on column T_B00_D003.z100
  is '־';
alter table T_B00_D003
  add constraint P_B00_D003 primary key (P001);

prompt
prompt Creating table T_B00_D004
prompt =========================
prompt
create table T_B00_D004
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a005 DATE,
  a006 DATE,
  b099 VARCHAR2(128),
  c001 NUMBER,
  d100 NUMBER,
  e100 DATE,
  e101 DATE,
  e102 DATE,
  f100 NUMBER default 1007002
)
;
comment on table T_B00_D004
  is 'ڣάȣ';
comment on column T_B00_D004.p001
  is 'ID';
comment on column T_B00_D004.a002
  is '';
comment on column T_B00_D004.a005
  is 'ʼ';
comment on column T_B00_D004.a006
  is 'ֹ';
comment on column T_B00_D004.b099
  is 'ע';
comment on column T_B00_D004.c001
  is 'ǰ';
comment on column T_B00_D004.d100
  is 'ڹر״̬';
comment on column T_B00_D004.e100
  is 'ͽֹ';
comment on column T_B00_D004.e101
  is '׼ֹ';
comment on column T_B00_D004.e102
  is '˽ֹ';
comment on column T_B00_D004.f100
  is 'ڳʼ״̬';
alter table T_B00_D004
  add constraint P_B00_D004 primary key (P001, A002);

prompt
prompt Creating table T_B00_D005
prompt =========================
prompt
create table T_B00_D005
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D005
  is 'ͶƷ֣άȣ';
comment on column T_B00_D005.p001
  is 'ͶƷID';
comment on column T_B00_D005.a002
  is 'ͶƷ';
comment on column T_B00_D005.a009
  is 'Դ';
comment on column T_B00_D005.b099
  is 'ע';
comment on column T_B00_D005.z100
  is '־';
alter table T_B00_D005
  add constraint P_B05_D005 primary key (P001);

prompt
prompt Creating table T_B00_D006
prompt =========================
prompt
create table T_B00_D006
(
  p001 NUMBER not null,
  f002 NUMBER not null,
  a003 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D006
  is 'ծȯࣨάȣ';
comment on column T_B00_D006.p001
  is 'ID';
comment on column T_B00_D006.f002
  is 'ͶƷID';
comment on column T_B00_D006.a003
  is 'ծȯ';
comment on column T_B00_D006.a009
  is 'Դ';
comment on column T_B00_D006.b099
  is 'ע';
comment on column T_B00_D006.z100
  is '־';
alter table T_B00_D006
  add constraint P_B00_D006 primary key (P001);

prompt
prompt Creating table T_B00_D007
prompt =========================
prompt
create table T_B00_D007
(
  p001 NUMBER not null,
  f002 NUMBER not null,
  a003 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D007
  is 'ࣨάȣ';
comment on column T_B00_D007.p001
  is 'ID';
comment on column T_B00_D007.f002
  is 'ͶƷID';
comment on column T_B00_D007.a003
  is '';
comment on column T_B00_D007.a009
  is 'Դ';
comment on column T_B00_D007.b099
  is 'ע';
comment on column T_B00_D007.z100
  is '־';
alter table T_B00_D007
  add constraint P_B00_D007 primary key (P001);

prompt
prompt Creating table T_B00_D008
prompt =========================
prompt
create table T_B00_D008
(
  p001 NUMBER not null,
  f002 NUMBER not null,
  a003 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D008
  is 'ͶƷࣨάȣ';
comment on column T_B00_D008.p001
  is 'ID';
comment on column T_B00_D008.f002
  is 'ͶƷID';
comment on column T_B00_D008.a003
  is 'Ͷ';
comment on column T_B00_D008.a009
  is 'Դ';
comment on column T_B00_D008.b099
  is 'ע';
comment on column T_B00_D008.z100
  is '־';
alter table T_B00_D008
  add constraint P_B00_D008 primary key (P001);

prompt
prompt Creating table T_B00_D009
prompt =========================
prompt
create table T_B00_D009
(
  p001 NUMBER not null,
  f002 NUMBER not null,
  a003 VARCHAR2(64) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D009
  is 'Ʊࣨάȣ';
comment on column T_B00_D009.p001
  is 'ID';
comment on column T_B00_D009.f002
  is 'ͶƷID';
comment on column T_B00_D009.a003
  is 'Ʊ';
comment on column T_B00_D009.a009
  is 'Դ';
comment on column T_B00_D009.b099
  is 'ע';
comment on column T_B00_D009.z100
  is '־';
alter table T_B00_D009
  add constraint P_B00_D009 primary key (P001);

prompt
prompt Creating table T_B00_D099
prompt =========================
prompt
create table T_B00_D099
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a003 VARCHAR2(255) not null,
  a006 NUMBER,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B00_D099
  is 'ֵָ꣨άȣ';
comment on column T_B00_D099.p001
  is 'ֵָID';
comment on column T_B00_D099.a002
  is 'ҵID';
comment on column T_B00_D099.a003
  is 'ָ';
comment on column T_B00_D099.a006
  is 'ID';
comment on column T_B00_D099.a009
  is 'Դ';
comment on column T_B00_D099.b099
  is 'ע';
comment on column T_B00_D099.z100
  is '־';
alter table T_B00_D099
  add constraint P_B00_D099 primary key (P001, A002);

prompt
prompt Creating table T_B00_D100
prompt =========================
prompt
create table T_B00_D100
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a003 VARCHAR2(255) not null,
  a006 NUMBER,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  z101 NUMBER
)
;
comment on table T_B00_D100
  is 'ܲʽ뿪ʻֵ';
comment on column T_B00_D100.p001
  is 'ֵָID';
comment on column T_B00_D100.a002
  is 'ҵID';
comment on column T_B00_D100.a003
  is 'ָ';
comment on column T_B00_D100.a006
  is 'ID';
comment on column T_B00_D100.a009
  is 'Դ';
comment on column T_B00_D100.b099
  is 'ע';
comment on column T_B00_D100.z100
  is '־';
comment on column T_B00_D100.z101
  is 'ֶ';

prompt
prompt Creating table T_B01_D001
prompt =========================
prompt
create table T_B01_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B01_D001
  is 'ʻͣάȣ';
comment on column T_B01_D001.p001
  is 'ʻID';
comment on column T_B01_D001.a002
  is 'ʻ';
comment on column T_B01_D001.a009
  is 'Դ';
comment on column T_B01_D001.b099
  is 'ע';
comment on column T_B01_D001.z100
  is '־';
alter table T_B01_D001
  add constraint P_B01_D001 primary key (P001);

prompt
prompt Creating table T_B01_D002
prompt =========================
prompt
create table T_B01_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B01_D002
  is '֣άȣ';
comment on column T_B01_D002.p001
  is 'ID';
comment on column T_B01_D002.a002
  is '';
comment on column T_B01_D002.a009
  is 'Դ';
comment on column T_B01_D002.b099
  is 'ע';
comment on column T_B01_D002.z100
  is '־';
alter table T_B01_D002
  add constraint P_B01_D002 primary key (P001);

prompt
prompt Creating table T_B01_D003
prompt =========================
prompt
create table T_B01_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B01_D003
  is 'ͣάȣ';
comment on column T_B01_D003.p001
  is 'ID';
comment on column T_B01_D003.a002
  is '';
comment on column T_B01_D003.a009
  is 'Դ';
comment on column T_B01_D003.b099
  is 'ע';
comment on column T_B01_D003.z100
  is '־';
alter table T_B01_D003
  add constraint P_B01_D003 primary key (P001);

prompt
prompt Creating table T_B01_DACT_B_R001
prompt ================================
prompt
create table T_B01_DACT_B_R001
(
  p001 NUMBER not null,
  p002 NUMBER,
  p003 NUMBER,
  v    NUMBER(19,2),
  p004 NUMBER not null
)
;
comment on table T_B01_DACT_B_R001
  is 'Ӫҵȯרܱάȱ';
comment on column T_B01_DACT_B_R001.p001
  is '';
comment on column T_B01_DACT_B_R001.p002
  is 'Ŀ';
comment on column T_B01_DACT_B_R001.p003
  is 'ָ';
comment on column T_B01_DACT_B_R001.v
  is 'ֵָ';
comment on column T_B01_DACT_B_R001.p004
  is 'Ӫҵid';

prompt
prompt Creating table T_B01_F001
prompt =========================
prompt
create table T_B01_F001
(
  p001 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  p002 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_B01_F001
  is '֤ȯʻʵ';
comment on column T_B01_F001.p001
  is 'ID';
comment on column T_B01_F001.p003
  is 'ֵָID';
comment on column T_B01_F001.v
  is 'ָ';
comment on column T_B01_F001.p002
  is '˻ID';
comment on column T_B01_F001.w100
  is 'ܲID';
alter table T_B01_F001
  add constraint PK_T_B01_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B01_F002
prompt =========================
prompt
create table T_B01_F002
(
  p001 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  p002 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_B01_F002
  is 'ʽʻʵ';
comment on column T_B01_F002.p001
  is 'ID';
comment on column T_B01_F002.p003
  is 'ֵָID';
comment on column T_B01_F002.v
  is 'ָ';
comment on column T_B01_F002.p002
  is 'ʻID';
comment on column T_B01_F002.w100
  is 'ܲID';
alter table T_B01_F002
  add constraint T_B01_F002 primary key (P001, P003, P002, W100);

prompt
prompt Creating table T_B01_F003
prompt =========================
prompt
create table T_B01_F003
(
  p001 VARCHAR2(8) not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  p002 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_B01_F003
  is 'ͻ׽ʽʵ';
comment on column T_B01_F003.p001
  is 'ID';
comment on column T_B01_F003.p003
  is 'ֵָID';
comment on column T_B01_F003.v
  is 'ָ';
comment on column T_B01_F003.p002
  is 'ID';
comment on column T_B01_F003.w100
  is 'ܲID';
alter table T_B01_F003
  add constraint PK_T_B01_F003 primary key (P001, P003, P002, W100);

prompt
prompt Creating table T_B01_F004
prompt =========================
prompt
create table T_B01_F004
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  p005 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B01_F004
  is '֤ȯҵָ꣨ʵ';
comment on column T_B01_F004.p001
  is 'ID';
comment on column T_B01_F004.p002
  is 'ͻID';
comment on column T_B01_F004.p003
  is 'ID';
comment on column T_B01_F004.p004
  is 'ͶƷID';
comment on column T_B01_F004.p005
  is 'ֵָID';
comment on column T_B01_F004.v
  is 'ָ';
comment on column T_B01_F004.w100
  is 'ܲID';
alter table T_B01_F004
  add constraint PK_T_B01_F004 primary key (P001, P002, P003, P004, P005, W100);

prompt
prompt Creating table T_B01_F005
prompt =========================
prompt
create table T_B01_F005
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B01_F005
  is 'ҵָ꣨ʵ';
comment on column T_B01_F005.p001
  is 'ID';
comment on column T_B01_F005.p002
  is 'ID';
comment on column T_B01_F005.p003
  is 'ƷID';
comment on column T_B01_F005.p004
  is 'ֵָID';
comment on column T_B01_F005.v
  is 'ָ';
comment on column T_B01_F005.w100
  is 'ܲID';
alter table T_B01_F005
  add constraint P_B01_F005 primary key (P001, P002, P003, P004, W100);

prompt
prompt Creating table T_B01_F006
prompt =========================
prompt
create table T_B01_F006
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  v    NUMBER(19,2),
  p003 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_B01_F006
  is '֤ȯҵָ꣨ʵ';
comment on column T_B01_F006.p001
  is 'ID';
comment on column T_B01_F006.p002
  is 'ֵָID';
comment on column T_B01_F006.v
  is 'ָ';
comment on column T_B01_F006.p003
  is '';
comment on column T_B01_F006.w100
  is 'ܲID';
alter table T_B01_F006
  add constraint P_B01_F006 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B01_F020
prompt =========================
prompt
create table T_B01_F020
(
  p001 NUMBER,
  p002 NUMBER,
  p003 NUMBER,
  v    NUMBER,
  w100 NUMBER
)
;
comment on table T_B01_F020
  is '˻ʵ';
comment on column T_B01_F020.p001
  is '';
comment on column T_B01_F020.p002
  is 'ĿID';
comment on column T_B01_F020.p003
  is 'ָID';
comment on column T_B01_F020.v
  is 'ֵ';
comment on column T_B01_F020.w100
  is 'ID';

prompt
prompt Creating table T_B02_F001
prompt =========================
prompt
create table T_B02_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B02_F001
  is 'Ӫҵ֤ȯͶʻָ꣨ʵ';
comment on column T_B02_F001.p001
  is 'ID';
comment on column T_B02_F001.p002
  is '֤ȯID';
comment on column T_B02_F001.p003
  is 'ͶƷID';
comment on column T_B02_F001.p004
  is 'ֵָID';
comment on column T_B02_F001.v
  is 'ָ';
comment on column T_B02_F001.w100
  is 'ܲID';
alter table T_B02_F001
  add constraint P_B02_F001 primary key (P001, P002, P003, P004, W100);

prompt
prompt Creating table T_B02_F005
prompt =========================
prompt
create table T_B02_F005
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B02_F005
  is 'ӪҵͶĩʵ';
comment on column T_B02_F005.p001
  is 'ID';
comment on column T_B02_F005.p002
  is 'ͶƷID';
comment on column T_B02_F005.p003
  is 'ֵָID';
comment on column T_B02_F005.v
  is 'ָ';
comment on column T_B02_F005.w100
  is 'ܲID';
alter table T_B02_F005
  add constraint P_B02_F005 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B02_F006
prompt =========================
prompt
create table T_B02_F006
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 VARCHAR2(16) not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B02_F006
  is 'Ӫҵָڻĩֲ֣ʵ';
comment on column T_B02_F006.p001
  is 'ID';
comment on column T_B02_F006.p002
  is 'ֵָID';
comment on column T_B02_F006.p003
  is 'Լ';
comment on column T_B02_F006.v
  is 'ָ';
comment on column T_B02_F006.w100
  is 'ܲID';
alter table T_B02_F006
  add constraint P_B02_F006 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B02_F008
prompt =========================
prompt
create table T_B02_F008
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 VARCHAR2(32) not null,
  p004 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B02_F008
  is '֤ȯͶҵֲרָ';
comment on column T_B02_F008.p001
  is '';
comment on column T_B02_F008.p002
  is 'Ʒ';
comment on column T_B02_F008.p003
  is '';
comment on column T_B02_F008.p004
  is 'ָ';
comment on column T_B02_F008.v
  is 'ֵָ';
comment on column T_B02_F008.w100
  is 'ܲID';
alter table T_B02_F008
  add constraint PK_T_B02_F008 primary key (P001, P002, P003, P004, W100);

prompt
prompt Creating table T_B02_F009
prompt =========================
prompt
create table T_B02_F009
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B02_F009
  is '֤ȯͶҵֲרָϼƱ';
comment on column T_B02_F009.p001
  is '';
comment on column T_B02_F009.p002
  is 'Ʒ';
comment on column T_B02_F009.p003
  is 'ָ';
comment on column T_B02_F009.v
  is 'ֵָ';
comment on column T_B02_F009.w100
  is 'ܲID';
alter table T_B02_F009
  add constraint PK_T_B02_F009 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B04_D001
prompt =========================
prompt
create table T_B04_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a003 VARCHAR2(4)
)
;
comment on table T_B04_D001
  is 'ʲƷ';
comment on column T_B04_D001.p001
  is 'ʲƷID';
comment on column T_B04_D001.a002
  is 'ʲƷ';
comment on column T_B04_D001.a009
  is 'Դ';
comment on column T_B04_D001.b099
  is 'ע';
comment on column T_B04_D001.z100
  is '־';
comment on column T_B04_D001.a003
  is 'Ϲֵ';
alter table T_B04_D001
  add constraint P_B04_D001 primary key (P001);

prompt
prompt Creating table T_B04_D003
prompt =========================
prompt
create table T_B04_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a003 VARCHAR2(4)
)
;

prompt
prompt Creating table T_B04_D011
prompt =========================
prompt
create table T_B04_D011
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a003 VARCHAR2(4)
)
;
comment on table T_B04_D011
  is 'ʲƷ';
comment on column T_B04_D011.p001
  is 'ʲƷID';
comment on column T_B04_D011.a002
  is 'ʲƷ';
comment on column T_B04_D011.a009
  is 'Դ';
comment on column T_B04_D011.b099
  is 'ע';
comment on column T_B04_D011.z100
  is '־';
comment on column T_B04_D011.a003
  is 'Ϲֵ';

prompt
prompt Creating table T_B04_F101
prompt =========================
prompt
create table T_B04_F101
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER,
  w100 NUMBER not null
)
;
comment on table T_B04_F101
  is 'ʲҵָ꣨ʽʵ';
comment on column T_B04_F101.p001
  is 'ID';
comment on column T_B04_F101.p002
  is 'ƻID';
comment on column T_B04_F101.p003
  is 'ĿID';
comment on column T_B04_F101.v
  is 'ֵָ';
comment on column T_B04_F101.w100
  is 'ܲID';
alter table T_B04_F101
  add constraint T_B04_F101 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B04_F102
prompt =========================
prompt
create table T_B04_F102
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on column T_B04_F102.p001
  is 'ID';
comment on column T_B04_F102.p002
  is 'ƻID';
comment on column T_B04_F102.p003
  is 'ĿID';
comment on column T_B04_F102.v
  is 'ֵָ';
comment on column T_B04_F102.w100
  is 'ܲID';
alter table T_B04_F102
  add constraint T_B04_F102 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B04_F103
prompt =========================
prompt
create table T_B04_F103
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER(18,4),
  w100 NUMBER not null
)
;
comment on table T_B04_F103
  is 'ʲҵֵָ꣨ʵ';
comment on column T_B04_F103.p001
  is 'ID';
comment on column T_B04_F103.p002
  is 'ƻID';
comment on column T_B04_F103.p003
  is 'ĿID';
comment on column T_B04_F103.v
  is 'ֵָ';
comment on column T_B04_F103.w100
  is 'ܲID';
alter table T_B04_F103
  add constraint T_B04_F103 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B04_F104
prompt =========================
prompt
create table T_B04_F104
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER,
  w100 NUMBER not null
)
;
comment on table T_B04_F104
  is 'ʲҵָ꣨Ͷάȣ';
comment on column T_B04_F104.p001
  is 'ID';
comment on column T_B04_F104.p002
  is 'ƻID';
comment on column T_B04_F104.p003
  is 'ĿID';
comment on column T_B04_F104.v
  is 'ֵָ';
comment on column T_B04_F104.w100
  is 'ܲID';
alter table T_B04_F104
  add constraint T_B04_F104 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B04_F105
prompt =========================
prompt
create table T_B04_F105
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER(18,4),
  w100 NUMBER not null
)
;
comment on table T_B04_F105
  is 'ʲҵʲάȣ';
comment on column T_B04_F105.p001
  is 'ID';
comment on column T_B04_F105.p002
  is 'ƻID';
comment on column T_B04_F105.p003
  is 'ĿID';
comment on column T_B04_F105.v
  is 'ֵָ';
comment on column T_B04_F105.w100
  is 'ܲID';
alter table T_B04_F105
  add constraint T_B04_F105 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B04_T011
prompt =========================
prompt
create table T_B04_T011
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a003 VARCHAR2(100),
  f004 NUMBER,
  f005 NUMBER,
  a004 DATE,
  a005 VARCHAR2(100),
  a006 VARCHAR2(100),
  a007 VARCHAR2(100),
  a008 VARCHAR2(100),
  a009 NUMBER(18,2),
  a010 NUMBER(18,2),
  a011 NUMBER(18,2),
  b001 NUMBER,
  a012 NUMBER(18,2),
  a013 NUMBER(18,2),
  a100 NUMBER
)
;
comment on column T_B04_T011.p001
  is 'ʲƷID';
comment on column T_B04_T011.a002
  is 'Ʒ';
comment on column T_B04_T011.a003
  is 'ƻ';
comment on column T_B04_T011.f004
  is '1';
comment on column T_B04_T011.f005
  is '2';
comment on column T_B04_T011.a004
  is '';
comment on column T_B04_T011.a005
  is 'Ͷ';
comment on column T_B04_T011.a006
  is 'й';
comment on column T_B04_T011.a007
  is 'ݶǼǻ';
comment on column T_B04_T011.a008
  is 'ƹ';
comment on column T_B04_T011.a009
  is 'Ͳ';
comment on column T_B04_T011.a010
  is '';
comment on column T_B04_T011.a011
  is 'йܷ';
comment on column T_B04_T011.b001
  is '¼״̬';
comment on column T_B04_T011.a012
  is 'ĩʽʽͶ';
comment on column T_B04_T011.a013
  is 'ʽгеεʽ';
comment on column T_B04_T011.a100
  is '˻';

prompt
prompt Creating table T_B050_F001
prompt ==========================
prompt
create table T_B050_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  p004 NUMBER not null
)
;
comment on table T_B050_F001
  is '۲Ʒάȱ';
comment on column T_B050_F001.p001
  is 'ID';
comment on column T_B050_F001.p002
  is '۲ƷĿID';
comment on column T_B050_F001.p003
  is 'ָID';
comment on column T_B050_F001.v
  is 'ֵָ';
comment on column T_B050_F001.p004
  is 'ӪҵID';
alter table T_B050_F001
  add constraint 1 primary key (P001, P002, P003, P004);

prompt
prompt Creating table T_B05_D001
prompt =========================
prompt
create table T_B05_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a003 VARCHAR2(16)
)
;
comment on table T_B05_D001
  is 'רʲƻͣάȣ';
comment on column T_B05_D001.p001
  is 'ƻID';
comment on column T_B05_D001.a002
  is 'ƻ';
comment on column T_B05_D001.a009
  is 'Դ';
comment on column T_B05_D001.b099
  is 'ע';
comment on column T_B05_D001.z100
  is '־';
comment on column T_B05_D001.a003
  is 'Ϲֵ';
alter table T_B05_D001
  add constraint P_B05_D001 primary key (P001);

prompt
prompt Creating table T_B05_D002
prompt =========================
prompt
create table T_B05_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B05_D002
  is 'ŵȼ';
comment on column T_B05_D002.p001
  is 'ŵȼID';
comment on column T_B05_D002.a002
  is 'ŵȼ';
comment on column T_B05_D002.a009
  is 'Դ';
comment on column T_B05_D002.b099
  is 'ע';
comment on column T_B05_D002.z100
  is '־';
alter table T_B05_D002
  add constraint P_B05_D002 primary key (P001);

prompt
prompt Creating table T_B05_F101
prompt =========================
prompt
create table T_B05_F101
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER,
  w100 NUMBER not null
)
;
comment on table T_B05_F101
  is 'רʲҵָ꣨ĩͻ';
comment on column T_B05_F101.p001
  is 'ID';
comment on column T_B05_F101.p002
  is 'ƻID';
comment on column T_B05_F101.p003
  is 'ĿID';
comment on column T_B05_F101.v
  is 'ֵָ';
comment on column T_B05_F101.w100
  is 'ܲID';

prompt
prompt Creating table T_B05_F102
prompt =========================
prompt
create table T_B05_F102
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B05_F102
  is 'רʲҵָ꣨ĩͻ';
comment on column T_B05_F102.p001
  is 'ID';
comment on column T_B05_F102.p002
  is 'ƻID';
comment on column T_B05_F102.p003
  is 'ĿID';
comment on column T_B05_F102.v
  is 'ֵָ';
comment on column T_B05_F102.w100
  is 'ܲID';

prompt
prompt Creating table T_B05_F103
prompt =========================
prompt
create table T_B05_F103
(
  p001 NUMBER not null,
  p002 VARCHAR2(32) not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B05_F103
  is 'רʲҵָ꣨ĩͻ';
comment on column T_B05_F103.p001
  is 'ID';
comment on column T_B05_F103.p002
  is 'ƻID';
comment on column T_B05_F103.p003
  is 'ĿID';
comment on column T_B05_F103.v
  is 'ֵָ';
comment on column T_B05_F103.w100
  is 'ܲID';

prompt
prompt Creating table T_B05_T001
prompt =========================
prompt
create table T_B05_T001
(
  p001 NUMBER not null,
  f002 NUMBER not null,
  f003 NUMBER not null,
  a003 VARCHAR2(64) not null,
  a004 VARCHAR2(64) not null,
  a005 VARCHAR2(64) not null,
  a006 NUMBER(19,2) not null,
  a007 VARCHAR2(64),
  a008 VARCHAR2(64),
  a009 NUMBER(5,2),
  a010 NUMBER(19) not null,
  a011 NUMBER(19,2) not null,
  a012 NUMBER(19,2),
  a013 VARCHAR2(64),
  a014 VARCHAR2(64),
  a015 DATE,
  a016 DATE,
  a017 VARCHAR2(128),
  b001 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_B05_T001
  is 'רʲƻƷ';
comment on column T_B05_T001.p001
  is 'ƷID';
comment on column T_B05_T001.f002
  is 'ƻID';
comment on column T_B05_T001.f003
  is 'ŵȼID';
comment on column T_B05_T001.a003
  is 'Ʒ';
comment on column T_B05_T001.a004
  is 'ƻ';
comment on column T_B05_T001.a005
  is 'ڲƷ';
comment on column T_B05_T001.a006
  is '׼';
comment on column T_B05_T001.a007
  is 'Ŀ';
comment on column T_B05_T001.a008
  is '';
comment on column T_B05_T001.a009
  is 'ƾ֤Ԥ';
comment on column T_B05_T001.a010
  is 'ʵʷзݶ';
comment on column T_B05_T001.a011
  is 'ʵʷн';
comment on column T_B05_T001.a012
  is 'ʽͶ';
comment on column T_B05_T001.a013
  is '';
comment on column T_B05_T001.a014
  is 'ʽ';
comment on column T_B05_T001.a015
  is '';
comment on column T_B05_T001.a016
  is '';
comment on column T_B05_T001.a017
  is 'ע';
comment on column T_B05_T001.b001
  is '¼״̬';
comment on column T_B05_T001.a100
  is '˱ʾ';
alter table T_B05_T001
  add constraint P_B05_T001 primary key (P001, A100);

prompt
prompt Creating table T_B05_T011
prompt =========================
prompt
create table T_B05_T011
(
  p001 NUMBER,
  p002 VARCHAR2(50),
  a002 NUMBER,
  a003 VARCHAR2(150),
  a004 NUMBER(18,2),
  a005 VARCHAR2(100),
  a006 VARCHAR2(100),
  a007 DATE,
  a008 DATE,
  a009 NUMBER(18,2),
  a010 VARCHAR2(100),
  a011 VARCHAR2(100),
  a012 VARCHAR2(100),
  a013 VARCHAR2(100),
  a014 NUMBER(18,2),
  a099 VARCHAR2(255),
  b001 NUMBER,
  a100 NUMBER
)
;
comment on table T_B05_T011
  is 'רƷ̨';
comment on column T_B05_T011.p001
  is 'ĿID';
comment on column T_B05_T011.p002
  is 'Ʒ';
comment on column T_B05_T011.a002
  is 'Ŀ';
comment on column T_B05_T011.a003
  is 'ڲƷ';
comment on column T_B05_T011.a004
  is '׼';
comment on column T_B05_T011.a005
  is 'Ŀ';
comment on column T_B05_T011.a006
  is '';
comment on column T_B05_T011.a007
  is '';
comment on column T_B05_T011.a008
  is '';
comment on column T_B05_T011.a009
  is 'ƾ֤Ԥ';
comment on column T_B05_T011.a010
  is 'ʼŵȼ';
comment on column T_B05_T011.a011
  is 'ĩŵȼ';
comment on column T_B05_T011.a012
  is '';
comment on column T_B05_T011.a013
  is 'ʽ';
comment on column T_B05_T011.a014
  is 'УƷʱʽͶ';
comment on column T_B05_T011.a099
  is 'ע';
comment on column T_B05_T011.b001
  is '¼״̬';
comment on column T_B05_T011.a100
  is '˻';

prompt
prompt Creating table T_B06_D001
prompt =========================
prompt
create table T_B06_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a003 NUMBER
)
;
comment on table T_B06_D001
  is 'Ŀͣάȣ';
comment on column T_B06_D001.p001
  is 'ĿID';
comment on column T_B06_D001.a002
  is 'Ŀ';
comment on column T_B06_D001.a009
  is 'Դ';
comment on column T_B06_D001.b099
  is 'ע';
comment on column T_B06_D001.z100
  is '־';
comment on column T_B06_D001.a003
  is 'ݱ';
alter table T_B06_D001
  add constraint P_B06_D001 primary key (P001);

prompt
prompt Creating table T_B06_D002
prompt =========================
prompt
create table T_B06_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B06_D002
  is 'ʽ';
comment on column T_B06_D002.p001
  is 'ʽID';
comment on column T_B06_D002.a002
  is 'ʽ';
comment on column T_B06_D002.a009
  is 'Դ';
comment on column T_B06_D002.b099
  is 'ע';
comment on column T_B06_D002.z100
  is '־';
alter table T_B06_D002
  add constraint P_B06_D002 primary key (P001);

prompt
prompt Creating table T_B06_D003
prompt =========================
prompt
create table T_B06_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B06_D003
  is '';
comment on column T_B06_D003.p001
  is 'ID';
comment on column T_B06_D003.a002
  is '';
comment on column T_B06_D003.a009
  is 'Դ';
comment on column T_B06_D003.b099
  is 'ע';
comment on column T_B06_D003.z100
  is '־';
alter table T_B06_D003
  add constraint P_B06_D003 primary key (P001);

prompt
prompt Creating table T_B06_D004
prompt =========================
prompt
create table T_B06_D004
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B06_D004
  is 'Ŀͣάȣ';
comment on column T_B06_D004.p001
  is 'ĿID';
comment on column T_B06_D004.a002
  is 'Ŀ';
comment on column T_B06_D004.a009
  is ' Դ';
comment on column T_B06_D004.b099
  is 'ע';
comment on column T_B06_D004.z100
  is '־';
alter table T_B06_D004
  add constraint P_B06_D004 primary key (P001);

prompt
prompt Creating table T_B06_D006
prompt =========================
prompt
create table T_B06_D006
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B06_D006
  is 'Υ洦άȱ';
comment on column T_B06_D006.p001
  is 'ID';
comment on column T_B06_D006.a002
  is '';
comment on column T_B06_D006.a009
  is 'Դ';
comment on column T_B06_D006.b099
  is 'ע';
comment on column T_B06_D006.z100
  is '־';
alter table T_B06_D006
  add constraint PK_T_B06_D006 primary key (P001);

prompt
prompt Creating table T_B06_D011
prompt =========================
prompt
create table T_B06_D011
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a003 VARCHAR2(4)
)
;
comment on table T_B06_D011
  is 'ʲƷ';
comment on column T_B06_D011.p001
  is 'ʲƷID';
comment on column T_B06_D011.a002
  is 'ʲƷ';
comment on column T_B06_D011.a009
  is 'Դ';
comment on column T_B06_D011.b099
  is 'ע';
comment on column T_B06_D011.z100
  is '־';
comment on column T_B06_D011.a003
  is 'Ϲֵ';

prompt
prompt Creating table T_B06_D012
prompt =========================
prompt
create table T_B06_D012
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B06_D012
  is 'ʲƷ';
comment on column T_B06_D012.p001
  is 'ҵϵID';
comment on column T_B06_D012.a002
  is 'ҵϵ˵';
comment on column T_B06_D012.b099
  is 'ע';
comment on column T_B06_D012.z100
  is '־';

prompt
prompt Creating table T_B06_F002
prompt =========================
prompt
create table T_B06_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B06_F002
  is 'ҵָ꣨ʵ';
comment on column T_B06_F002.p001
  is 'ID';
comment on column T_B06_F002.p002
  is 'ĿID';
comment on column T_B06_F002.p003
  is 'ID';
comment on column T_B06_F002.p004
  is 'ֵָID';
comment on column T_B06_F002.v
  is 'ָ';
comment on column T_B06_F002.w100
  is 'ܲID';
alter table T_B06_F002
  add constraint P_B06_F002 primary key (P001, P002, P003, P004, W100);

prompt
prompt Creating table T_B06_F104
prompt =========================
prompt
create table T_B06_F104
(
  p001 NUMBER not null,
  p002 VARCHAR2(50) not null,
  p003 NUMBER not null,
  v    VARCHAR2(100),
  w100 NUMBER not null
)
;
comment on table T_B06_F104
  is 'רʲҵָʵ(Ͷ)';
comment on column T_B06_F104.p001
  is 'ID';
comment on column T_B06_F104.p002
  is 'ĿID';
comment on column T_B06_F104.p003
  is 'ָID';
comment on column T_B06_F104.v
  is 'ָ';
comment on column T_B06_F104.w100
  is 'ܲID';

prompt
prompt Creating table T_B06_F105
prompt =========================
prompt
create table T_B06_F105
(
  p001 NUMBER not null,
  p002 VARCHAR2(50) not null,
  p003 NUMBER not null,
  v    NUMBER,
  w100 NUMBER not null
)
;
comment on table T_B06_F105
  is 'רʲҵָʵ(ʲ)';
comment on column T_B06_F105.p001
  is 'ID';
comment on column T_B06_F105.p002
  is 'ĿID';
comment on column T_B06_F105.p003
  is 'ָID';
comment on column T_B06_F105.v
  is 'ָ';
comment on column T_B06_F105.w100
  is 'ܲID';

prompt
prompt Creating table T_B06_T011
prompt =========================
prompt
create table T_B06_T011
(
  p001 NUMBER not null,
  a002 VARCHAR2(16),
  a003 VARCHAR2(64),
  a004 NUMBER,
  a005 NUMBER,
  b001 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_B06_T011
  is 'ʲƷ̨˱';
comment on column T_B06_T011.p001
  is 'ʲƷID';
comment on column T_B06_T011.a002
  is 'Ʒ';
comment on column T_B06_T011.a003
  is 'Ʒ';
comment on column T_B06_T011.a004
  is 'ͻ';
comment on column T_B06_T011.a005
  is '';
comment on column T_B06_T011.b001
  is '¼״̬';
comment on column T_B06_T011.a100
  is '˱ʾ';
alter table T_B06_T011
  add constraint P_B06_T011 primary key (P001, A100);

prompt
prompt Creating table T_B06_T012
prompt =========================
prompt
create table T_B06_T012
(
  p001 NUMBER not null,
  a002 VARCHAR2(50),
  a003 VARCHAR2(50),
  a004 VARCHAR2(50),
  a100 NUMBER not null
)
;
comment on table T_B06_T012
  is 'ʲƷ̨˱';
comment on column T_B06_T012.p001
  is 'ʲƷID';
comment on column T_B06_T012.a002
  is 'Ʒ';
comment on column T_B06_T012.a003
  is 'Ʒ';
comment on column T_B06_T012.a004
  is 'ͻ';
comment on column T_B06_T012.a100
  is '˱ʾ';
alter table T_B06_T012
  add constraint P_B06_T012 primary key (P001, A100);

prompt
prompt Creating table T_B07_F001
prompt =========================
prompt
create table T_B07_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER,
  w100 NUMBER not null
)
;
comment on table T_B07_F001
  is 'ʲҵָʵ()';
comment on column T_B07_F001.p001
  is 'ID';
comment on column T_B07_F001.p002
  is 'ĿID';
comment on column T_B07_F001.p003
  is 'ָID';
comment on column T_B07_F001.v
  is 'ָ';
comment on column T_B07_F001.w100
  is 'ܲID';

prompt
prompt Creating table T_B07_F002
prompt =========================
prompt
create table T_B07_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B07_F002
  is 'ʲҵָʵ(ʽ)';
comment on column T_B07_F002.p001
  is 'ID';
comment on column T_B07_F002.p002
  is 'ĿID';
comment on column T_B07_F002.p003
  is 'ָID';
comment on column T_B07_F002.v
  is 'ָ';
comment on column T_B07_F002.w100
  is 'ܲID';

prompt
prompt Creating table T_B07_F003
prompt =========================
prompt
create table T_B07_F003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER,
  w100 NUMBER not null
)
;
comment on table T_B07_F003
  is 'ʲҵָʵ(Ͷ)';
comment on column T_B07_F003.p001
  is 'ID';
comment on column T_B07_F003.p002
  is 'ĿID';
comment on column T_B07_F003.p003
  is 'ָID';
comment on column T_B07_F003.v
  is 'ָ';
comment on column T_B07_F003.w100
  is 'ܲID';

prompt
prompt Creating table T_B07_F004
prompt =========================
prompt
create table T_B07_F004
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER,
  w100 NUMBER not null
)
;
comment on table T_B07_F004
  is 'ʲҵָʵ(ʲ)';
comment on column T_B07_F004.p001
  is 'ID';
comment on column T_B07_F004.p002
  is 'ĿID';
comment on column T_B07_F004.p003
  is 'ָID';
comment on column T_B07_F004.v
  is 'ָ';
comment on column T_B07_F004.w100
  is 'ܲID';

prompt
prompt Creating table T_B08_D001
prompt =========================
prompt
create table T_B08_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B08_D001
  is 'мгҵࣨάȣ';
comment on column T_B08_D001.p001
  is 'ID';
comment on column T_B08_D001.a002
  is 'ҵ';
comment on column T_B08_D001.a009
  is 'Դ';
comment on column T_B08_D001.b099
  is 'ע';
comment on column T_B08_D001.z100
  is '־';
alter table T_B08_D001
  add constraint PK_B08_D001 primary key (P001);

prompt
prompt Creating table T_B08_D002
prompt =========================
prompt
create table T_B08_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B08_D002
  is 'еĶȯάȣ';
comment on column T_B08_D002.p001
  is 'ȯID';
comment on column T_B08_D002.a002
  is 'ȯ';
comment on column T_B08_D002.a009
  is 'Դ';
comment on column T_B08_D002.b099
  is 'ע';
comment on column T_B08_D002.z100
  is '־';
alter table T_B08_D002
  add constraint PK_B08_D002 primary key (P001);

prompt
prompt Creating table T_B08_F001
prompt =========================
prompt
create table T_B08_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B08_F001
  is 'мгҵָ꣨ʵ';
comment on column T_B08_F001.p001
  is 'ID';
comment on column T_B08_F001.p002
  is 'мгҵID';
comment on column T_B08_F001.p003
  is 'ָID';
comment on column T_B08_F001.v
  is 'ָ';
comment on column T_B08_F001.w100
  is 'ܲID';
alter table T_B08_F001
  add constraint PK_B08_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B08_F002
prompt =========================
prompt
create table T_B08_F002
(
  p001 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  p002 VARCHAR2(100) not null,
  w100 NUMBER not null
)
;
comment on table T_B08_F002
  is 'еĶȯ׻ָ꣨ʵ';
comment on column T_B08_F002.p001
  is 'ID';
comment on column T_B08_F002.p003
  is 'ָID';
comment on column T_B08_F002.v
  is 'ָ';
comment on column T_B08_F002.p002
  is 'ȯID';
comment on column T_B08_F002.w100
  is 'ܲID';
alter table T_B08_F002
  add constraint PK_T_B08_F002 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B09_D001
prompt =========================
prompt
create table T_B09_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32),
  a009 NUMBER,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a003 VARCHAR2(16)
)
;
comment on table T_B09_D001
  is 'Ȩ֤';
comment on column T_B09_D001.p001
  is 'ID';
comment on column T_B09_D001.a002
  is '';
comment on column T_B09_D001.a009
  is 'Դ';
comment on column T_B09_D001.z100
  is '־';
comment on column T_B09_D001.b099
  is 'ע';
comment on column T_B09_D001.a003
  is 'Ϲֵ';
alter table T_B09_D001
  add constraint PK_T_B09_D001 primary key (P001);

prompt
prompt Creating table T_B09_F001
prompt =========================
prompt
create table T_B09_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B09_F001
  is 'Ȩ֤ҵָ꣨ʵ';
comment on column T_B09_F001.p001
  is 'ID';
comment on column T_B09_F001.p002
  is 'Ȩ֤';
comment on column T_B09_F001.p003
  is 'ָ';
comment on column T_B09_F001.v
  is 'ֵָ';
comment on column T_B09_F001.w100
  is 'ܲID';
alter table T_B09_F001
  add constraint P_B09_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B09_F002
prompt =========================
prompt
create table T_B09_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B09_F002
  is 'Ȩ֤ϼ';
comment on column T_B09_F002.p001
  is '';
comment on column T_B09_F002.p002
  is 'ָ';
comment on column T_B09_F002.v
  is 'ֵָ';
comment on column T_B09_F002.w100
  is 'ܲID';
alter table T_B09_F002
  add constraint PK_T_B09_F002 primary key (P001, P002, W100);

prompt
prompt Creating table T_B09_T002
prompt =========================
prompt
create table T_B09_T002
(
  a002 VARCHAR2(32) not null,
  a003 VARCHAR2(128) not null,
  a004 NUMBER not null,
  p001 NUMBER not null,
  a100 NUMBER not null
)
;
comment on table T_B09_T002
  is 'Ȩ֤Ϣ';
comment on column T_B09_T002.a002
  is 'Ȩ֤';
comment on column T_B09_T002.a003
  is 'Ȩ֤';
comment on column T_B09_T002.a004
  is 'Ȩ֤';
comment on column T_B09_T002.p001
  is 'Ȩ֤ID';
comment on column T_B09_T002.a100
  is 'ID';
alter table T_B09_T002
  add constraint PK_B09_T002 primary key (P001, A100);

prompt
prompt Creating table T_B11_D001
prompt =========================
prompt
create table T_B11_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(50) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_B11_D001
  is 'Ϊڻ˾ṩxxĿֵ';
comment on column T_B11_D001.p001
  is 'ID';
comment on column T_B11_D001.a002
  is '';
comment on column T_B11_D001.z100
  is '־';
comment on column T_B11_D001.b099
  is 'ע';
comment on column T_B11_D001.a009
  is 'Դ';
alter table T_B11_D001
  add constraint PK_T_B11_D001 primary key (P001);

prompt
prompt Creating table T_B11_F003
prompt =========================
prompt
create table T_B11_F003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B11_F003
  is 'ڻмҵָʵ';
comment on column T_B11_F003.p001
  is 'ID';
comment on column T_B11_F003.p002
  is 'Ŀ';
comment on column T_B11_F003.p003
  is 'ָ';
comment on column T_B11_F003.v
  is 'ֵָ';
comment on column T_B11_F003.w100
  is 'ܲID';
alter table T_B11_F003
  add constraint PK_T_B11_F003 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B11_T001
prompt =========================
prompt
create table T_B11_T001
(
  p001 NUMBER not null,
  a002 VARCHAR2(128),
  b001 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_B11_T001
  is 'ڻмҵ˾';
comment on column T_B11_T001.p001
  is '˾ID';
comment on column T_B11_T001.a002
  is '';
comment on column T_B11_T001.b001
  is '¼״̬';
comment on column T_B11_T001.a100
  is '˻ID    zhouly  20130823';
alter table T_B11_T001
  add constraint PK_T_B11_T001 primary key (P001, A100);

prompt
prompt Creating table T_B11_T003
prompt =========================
prompt
create table T_B11_T003
(
  p001 NUMBER not null,
  a002 VARCHAR2(128),
  b001 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_B11_T003
  is 'ڻмҵ˾';
comment on column T_B11_T003.p001
  is 'Ŀ';
comment on column T_B11_T003.a002
  is '';
comment on column T_B11_T003.a100
  is '˻ ID     zhouly    20130823';
alter table T_B11_T003
  add constraint PK_T_B11_T003 primary key (P001, A100);

prompt
prompt Creating table T_B12_D001
prompt =========================
prompt
create table T_B12_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B12_D001
  is 'ҵࣨάȣ';
comment on column T_B12_D001.p001
  is 'ID';
comment on column T_B12_D001.a002
  is '';
comment on column T_B12_D001.a009
  is 'Դ';
comment on column T_B12_D001.b099
  is 'ע';
comment on column T_B12_D001.z100
  is '־';
alter table T_B12_D001
  add constraint P_B12_D001 primary key (P001);

prompt
prompt Creating table T_B12_D002
prompt =========================
prompt
create table T_B12_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B12_D002
  is 'ҵĿͣάȣ';
comment on column T_B12_D002.p001
  is 'ĿID';
comment on column T_B12_D002.a002
  is 'Ŀ';
comment on column T_B12_D002.a009
  is 'Դ';
comment on column T_B12_D002.b099
  is 'ע';
comment on column T_B12_D002.z100
  is '־';
alter table T_B12_D002
  add constraint P_B12_D002 primary key (P001);

prompt
prompt Creating table T_B12_F001
prompt =========================
prompt
create table T_B12_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B12_F001
  is 'ҵָ';
comment on column T_B12_F001.p001
  is 'ID';
comment on column T_B12_F001.p002
  is 'ĿID';
comment on column T_B12_F001.p003
  is 'ָID';
comment on column T_B12_F001.v
  is 'ֵָ';
comment on column T_B12_F001.w100
  is 'ܲID';
alter table T_B12_F001
  add constraint PK_B12_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B12_T002
prompt =========================
prompt
create table T_B12_T002
(
  p001 DATE not null,
  p002 NUMBER not null,
  p003 VARCHAR2(64) not null,
  a005 NUMBER(14,2) not null,
  a006 VARCHAR2(128),
  a004 NUMBER(14,2) not null,
  a100 NUMBER not null
)
;
comment on table T_B12_T002
  is 'ҵĿϸ';
comment on column T_B12_T002.p001
  is '';
comment on column T_B12_T002.p002
  is 'ĿID';
comment on column T_B12_T002.p003
  is 'ͻ';
comment on column T_B12_T002.a005
  is '';
comment on column T_B12_T002.a006
  is 'ע';
comment on column T_B12_T002.a004
  is 'ͬ';
comment on column T_B12_T002.a100
  is '˻ID';
alter table T_B12_T002
  add constraint P_B12_T002 primary key (P001, P002, P003, A100);

prompt
prompt Creating table T_B13_D001
prompt =========================
prompt
create table T_B13_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B13_D001
  is 'Ͷѯŷࣨάȣ';
comment on column T_B13_D001.p001
  is 'ŷID';
comment on column T_B13_D001.a002
  is 'ŷ';
comment on column T_B13_D001.a009
  is 'Դ';
comment on column T_B13_D001.b099
  is 'ע';
comment on column T_B13_D001.z100
  is '־';
alter table T_B13_D001
  add constraint P_B13_D001 primary key (P001);

prompt
prompt Creating table T_B13_D002
prompt =========================
prompt
create table T_B13_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B13_D002
  is '֤ȯͶѯҵ񱨸;άȣ';
comment on column T_B13_D002.p001
  is ';ID';
comment on column T_B13_D002.a002
  is ';';
comment on column T_B13_D002.a009
  is 'Դ';
comment on column T_B13_D002.b099
  is 'ע';
comment on column T_B13_D002.z100
  is '־';
alter table T_B13_D002
  add constraint P_B13_D002 primary key (P001);

prompt
prompt Creating table T_B13_D003
prompt =========================
prompt
create table T_B13_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
alter table T_B13_D003
  add constraint T_B13_D003_P001 primary key (P001);

prompt
prompt Creating table T_B13_D004
prompt =========================
prompt
create table T_B13_D004
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
comment on table T_B13_D004
  is '빫ý嵱ǰ״̬';
comment on column T_B13_D004.p001
  is '״̬ɣ';
comment on column T_B13_D004.a002
  is '״̬';
alter table T_B13_D004
  add constraint PK_T_B13_D004 primary key (P001);

prompt
prompt Creating table T_B14_D001
prompt =========================
prompt
create table T_B14_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B14_D001
  is 'ծعҵࣨάȣ';
comment on column T_B14_D001.p001
  is 'ծعҵID';
comment on column T_B14_D001.a002
  is 'ծعҵ';
comment on column T_B14_D001.a009
  is 'Դ';
comment on column T_B14_D001.b099
  is 'ע';
comment on column T_B14_D001.z100
  is '־';
alter table T_B14_D001
  add constraint P_B14_D001 primary key (P001);

prompt
prompt Creating table T_B14_D002
prompt =========================
prompt
create table T_B14_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B14_D002
  is 'ѺʽծعҵͳĿάȣ';
comment on column T_B14_D002.p001
  is 'ѺʽծعҵͳĿID';
comment on column T_B14_D002.a002
  is 'ѺʽծعҵͳĿ';
comment on column T_B14_D002.a009
  is 'Դ';
comment on column T_B14_D002.b099
  is 'ע';
comment on column T_B14_D002.z100
  is '־';
alter table T_B14_D002
  add constraint P_B14_D002 primary key (P001);

prompt
prompt Creating table T_B14_D003
prompt =========================
prompt
create table T_B14_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B14_D003
  is 'ծعҵάȣ';
comment on column T_B14_D003.p001
  is 'ծعҵID';
comment on column T_B14_D003.a002
  is 'ծعҵ';
comment on column T_B14_D003.a009
  is 'Դ';
comment on column T_B14_D003.b099
  is 'ע';
comment on column T_B14_D003.z100
  is '־';
alter table T_B14_D003
  add constraint P_B14_D003 primary key (P001);

prompt
prompt Creating table T_B14_F001
prompt =========================
prompt
create table T_B14_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  p005 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B14_F001
  is 'Ѻʽծعҵ񣨽ףָ꣨ʵ';
comment on column T_B14_F001.p001
  is 'ID';
comment on column T_B14_F001.p002
  is 'ծعҵID';
comment on column T_B14_F001.p003
  is 'ծعҵID';
comment on column T_B14_F001.p004
  is 'гID';
comment on column T_B14_F001.p005
  is 'ָID';
comment on column T_B14_F001.v
  is 'ָ';
comment on column T_B14_F001.w100
  is 'ܲID';
alter table T_B14_F001
  add constraint P_B14_F001 primary key (P001, P002, P003, P004, P005, W100);

prompt
prompt Creating table T_B14_F002
prompt =========================
prompt
create table T_B14_F002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B14_F002
  is 'ѺʽծعҵйܡǼǣָ꣨ʵ';
comment on column T_B14_F002.p001
  is 'ID';
comment on column T_B14_F002.p002
  is 'ѺʽծعҵͳĿID';
comment on column T_B14_F002.p003
  is 'гID';
comment on column T_B14_F002.p004
  is 'ָID';
comment on column T_B14_F002.v
  is 'ָ';
comment on column T_B14_F002.w100
  is 'ܲID';
alter table T_B14_F002
  add constraint P_B14_F002 primary key (P001, P002, P003, P004, W100);

prompt
prompt Creating table T_B14_F003
prompt =========================
prompt
create table T_B14_F003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  p005 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B14_F003
  is 'ʽծعҵ񣨽ףָ꣨ʵ';
comment on column T_B14_F003.p001
  is 'ID';
comment on column T_B14_F003.p002
  is 'ծعҵID';
comment on column T_B14_F003.p003
  is 'ծعҵID';
comment on column T_B14_F003.p004
  is 'гID';
comment on column T_B14_F003.p005
  is 'ָID';
comment on column T_B14_F003.v
  is 'ָ';
comment on column T_B14_F003.w100
  is 'ܲID';
alter table T_B14_F003
  add constraint P_B14_F003 primary key (P001, P002, P003, P004, P005, W100);

prompt
prompt Creating table T_B15_D001
prompt =========================
prompt
create table T_B15_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a003 NUMBER,
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(16)
)
;
comment on table T_B15_D001
  is 'ֵ֤ͨ';
comment on column T_B15_D001.p001
  is 'д';
comment on column T_B15_D001.a002
  is '';
comment on column T_B15_D001.a003
  is 'Ӧ֤ͨд';
alter table T_B15_D001
  add constraint PK_T_B15_D001 primary key (P001);

prompt
prompt Creating table T_B15_D002
prompt =========================
prompt
create table T_B15_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
comment on table T_B15_D002
  is 'ܽչάȱ';
comment on column T_B15_D002.p001
  is 'ID';
comment on column T_B15_D002.a002
  is 'Ŀ';
alter table T_B15_D002
  add constraint PK_T_B15_D002 primary key (P001);

prompt
prompt Creating table T_B15_F001
prompt =========================
prompt
create table T_B15_F001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B15_F001
  is 'ܽչ';
comment on column T_B15_F001.p001
  is 'ID';
comment on column T_B15_F001.p002
  is 'ָID';
comment on column T_B15_F001.v
  is 'ֵָ';
comment on column T_B15_F001.w100
  is 'ܲID';
alter table T_B15_F001
  add constraint PK_T_B15_F001 primary key (P001, P002, W100);

prompt
prompt Creating table T_B15_T001
prompt =========================
prompt
create table T_B15_T001
(
  a002 DATE,
  a003 DATE,
  a004 DATE,
  a005 VARCHAR2(8),
  a099 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_B15_T001
  is 'ܻϢ  ';
comment on column T_B15_T001.a002
  is '"ܿʼʵʩʱ
"';
comment on column T_B15_T001.a003
  is '"ʱ
"';
comment on column T_B15_T001.a004
  is '"˻׼
"';
comment on column T_B15_T001.a005
  is '"ϸ˻Ƿȫ(/)
"';
comment on column T_B15_T001.a099
  is '"ע
"';
comment on column T_B15_T001.a100
  is '˻   -- zhouly 20130822';

prompt
prompt Creating table T_B15_T002
prompt =========================
prompt
create table T_B15_T002
(
  p001 DATE not null,
  a002 VARCHAR2(255),
  a003 NUMBER,
  a004 NUMBER,
  a005 NUMBER,
  a006 NUMBER(19,2),
  a007 NUMBER,
  a008 VARCHAR2(8),
  a009 VARCHAR2(255),
  a010 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_B15_T002
  is 'ϵͳͳƱ';
comment on column T_B15_T002.p001
  is '¹ʱ';
comment on column T_B15_T002.a002
  is '¹';
comment on column T_B15_T002.a007
  is '';
comment on column T_B15_T002.a008
  is 'Ƿʧ';
comment on column T_B15_T002.a009
  is '"ǷӰ¹깺
"';
comment on column T_B15_T002.a010
  is 'ºȡĸĽʩ';
comment on column T_B15_T002.a100
  is '˱ʶ';

prompt
prompt Creating table T_B16_D001
prompt =========================
prompt
create table T_B16_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
comment on table T_B16_D001
  is '˻淶չ-ʽ˻άȱ';
comment on column T_B16_D001.p001
  is 'ID';
comment on column T_B16_D001.a002
  is 'Ŀ';
alter table T_B16_D001
  add constraint PK_T_B16_D001 primary key (P001);

prompt
prompt Creating table T_B16_D002
prompt =========================
prompt
create table T_B16_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
comment on table T_B16_D002
  is '˻淶չ-֤ȯ˻άȱ';
comment on column T_B16_D002.p001
  is 'ID';
comment on column T_B16_D002.a002
  is 'Ŀ';
alter table T_B16_D002
  add constraint PK_T_B16_D002 primary key (P001);

prompt
prompt Creating table T_B16_D003
prompt =========================
prompt
create table T_B16_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
comment on table T_B16_D003
  is '˻淶չ-ϸʽ˻άȱ';
comment on column T_B16_D003.p001
  is 'ID';
comment on column T_B16_D003.a002
  is 'Ŀ';
alter table T_B16_D003
  add constraint PK_T_B16_D003 primary key (P001);

prompt
prompt Creating table T_B16_D004
prompt =========================
prompt
create table T_B16_D004
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
comment on table T_B16_D004
  is '˻淶չ-ϸ֤ȯ˻ ';
comment on column T_B16_D004.p001
  is 'ID';
comment on column T_B16_D004.a002
  is 'Ŀ';
alter table T_B16_D004
  add constraint PK_T_B16_D004 primary key (P001);

prompt
prompt Creating table T_B16_D005
prompt =========================
prompt
create table T_B16_D005
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a009 NUMBER,
  b099 VARCHAR2(64),
  z100 VARCHAR2(8)
)
;
comment on table T_B16_D005
  is 'ʻ淶1031Ϣά';
comment on column T_B16_D005.p001
  is 'id';
comment on column T_B16_D005.a002
  is 'Ŀ';

prompt
prompt Creating table T_B30_A001
prompt =========================
prompt
create table T_B30_A001
(
  p001 NUMBER not null,
  a002 VARCHAR2(100) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_B30_A001
  is 'ΪȯĿֵ';
comment on column T_B30_A001.p001
  is 'ID';
comment on column T_B30_A001.a002
  is '';
comment on column T_B30_A001.z100
  is '־';
comment on column T_B30_A001.b099
  is 'ע';
comment on column T_B30_A001.a009
  is 'Դ';

prompt
prompt Creating table T_B30_F001
prompt =========================
prompt
create table T_B30_F001
(
  p001 VARCHAR2(16) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_B30_F001
  is 'ȯҵ񱨱άȱ';
comment on column T_B30_F001.p001
  is '';
comment on column T_B30_F001.p002
  is 'ĿID';
comment on column T_B30_F001.p003
  is 'ֵָID';
comment on column T_B30_F001.v
  is 'ָ';
comment on column T_B30_F001.w100
  is 'ID';

prompt
prompt Creating table T_B40_A001
prompt =========================
prompt
create table T_B40_A001
(
  p001 VARCHAR2(255),
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_B40_A001
  is 'ȯҵϸרܱ(ĩȯߵǰ10ͻϸ)';
comment on column T_B40_A001.p001
  is 'ͻ';
comment on column T_B40_A001.a002
  is 'ϼ';
comment on column T_B40_A001.a003
  is 'ʽ';
comment on column T_B40_A001.a004
  is 'ȯֵ';
comment on column T_B40_A001.a005
  is 'ֵ';
comment on column T_B40_A001.a006
  is 'άֵ%';
comment on column T_B40_A001.a100
  is '';
comment on column T_B40_A001.w100
  is 'ܲID';

prompt
prompt Creating table T_B40_A002
prompt =========================
prompt
create table T_B40_A002
(
  p001 VARCHAR2(25),
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_B40_A002
  is 'ĩάֵ͵10ͻϸάֵĿͻϸͳƣ';
comment on column T_B40_A002.p001
  is 'ͻ';
comment on column T_B40_A002.a002
  is 'ϼ';
comment on column T_B40_A002.a003
  is 'ʽ';
comment on column T_B40_A002.a004
  is 'ȯֵ';
comment on column T_B40_A002.a005
  is 'ֵ';
comment on column T_B40_A002.a006
  is 'άֵ%';
comment on column T_B40_A002.a100
  is '';
comment on column T_B40_A002.w100
  is 'ܲID';

prompt
prompt Creating table T_B40_A003
prompt =========================
prompt
create table T_B40_A003
(
  p001 VARCHAR2(25),
  a002 VARCHAR2(25),
  a003 NUMBER,
  a004 NUMBER,
  a005 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_B40_A003
  is 'ĩ֤ȯֵǰ10֤ȯ';
comment on column T_B40_A003.p001
  is '֤ȯ';
comment on column T_B40_A003.a002
  is '֤ȯ';
comment on column T_B40_A003.a003
  is 'ܹɱ';
comment on column T_B40_A003.a004
  is '֤ȯ';
comment on column T_B40_A003.a005
  is '֤ȯֵ';
comment on column T_B40_A003.a100
  is '';
comment on column T_B40_A003.w100
  is 'ܲID';

prompt
prompt Creating table T_B40_A004
prompt =========================
prompt
create table T_B40_A004
(
  p001 VARCHAR2(25),
  a002 VARCHAR2(25),
  a003 NUMBER,
  a004 NUMBER,
  a005 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_B40_A004
  is 'ĩȯ֤ȯֵǰ10֤ȯ';
comment on column T_B40_A004.p001
  is '֤ȯ';
comment on column T_B40_A004.a002
  is '֤ȯ';
comment on column T_B40_A004.a003
  is 'ܹɱ';
comment on column T_B40_A004.a004
  is '֤ȯ';
comment on column T_B40_A004.a005
  is '֤ȯֵ';
comment on column T_B40_A004.a100
  is '';
comment on column T_B40_A004.w100
  is 'ܲID';

prompt
prompt Creating table T_B40_A005
prompt =========================
prompt
create table T_B40_A005
(
  p001 VARCHAR2(25),
  a002 VARCHAR2(25),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_B40_A005
  is 'ĩֵǰ10֤ȯ';
comment on column T_B40_A005.p001
  is '֤ȯ';
comment on column T_B40_A005.a002
  is '֤ȯ';
comment on column T_B40_A005.a003
  is 'ĩֵԪ';
comment on column T_B40_A005.a004
  is 'ֵռ˾嵣ֵ%';
comment on column T_B40_A005.a100
  is '';
comment on column T_B40_A005.w100
  is 'ܲID';

prompt
prompt Creating table T_B40_A006
prompt =========================
prompt
create table T_B40_A006
(
  p001 VARCHAR2(25),
  a002 DATE,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_B40_A006
  is '10ǿƽֽϸ';
comment on column T_B40_A006.p001
  is 'ͻ';
comment on column T_B40_A006.a002
  is 'ƽʱ';
comment on column T_B40_A006.a003
  is 'ƽֽ';
comment on column T_B40_A006.a004
  is 'δʵծȨ';
comment on column T_B40_A006.a100
  is '';
comment on column T_B40_A006.w100
  is 'ܲID';

prompt
prompt Creating table T_B50_A001
prompt =========================
prompt
create table T_B50_A001
(
  p001 VARCHAR2(25),
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_B50_A001
  is 'ȯҵϸܱ';
comment on column T_B50_A001.p001
  is 'ͻ';
comment on column T_B50_A001.a002
  is 'ϼ';
comment on column T_B50_A001.a003
  is 'ʽ';
comment on column T_B50_A001.a004
  is 'ȯֵ';
comment on column T_B50_A001.a005
  is 'ֵ';
comment on column T_B50_A001.a006
  is 'άֵ%';
comment on column T_B50_A001.a100
  is '';
comment on column T_B50_A001.w100
  is 'ܲID';

prompt
prompt Creating table T_B50_F001
prompt =========================
prompt
create table T_B50_F001
(
  p001 NUMBER,
  p002 NUMBER,
  p003 NUMBER,
  v    NUMBER(19,2),
  w100 NUMBER
)
;
comment on table T_B50_F001
  is '֤ȯ˾۽ڲƷͳƱ-άȱ';

prompt
prompt Creating table T_B61_D001
prompt =========================
prompt
create table T_B61_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B61_D001
  is 'Ѻʽۻعױάȣ';
comment on column T_B61_D001.p001
  is 'ĿID';
comment on column T_B61_D001.a002
  is 'Ŀ';
comment on column T_B61_D001.a009
  is 'Դ';
comment on column T_B61_D001.b099
  is 'ע';
comment on column T_B61_D001.z100
  is '־';
alter table T_B61_D001
  add constraint P_B61_D001 primary key (P001);

prompt
prompt Creating table T_B61_F001
prompt =========================
prompt
create table T_B61_F001
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B61_F001
  is 'Ѻʽۻعʵ';
comment on column T_B61_F001.p001
  is '';
comment on column T_B61_F001.p002
  is 'ĿID';
comment on column T_B61_F001.p003
  is 'ָID1001-ڳ 1002- 1003-ڼ 1004-ĩ';
comment on column T_B61_F001.v
  is 'ֵָ';
alter table T_B61_F001
  add constraint PK_T_B61_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B61_F002
prompt =========================
prompt
create table T_B61_F002
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B61_F002
  is 'Ѻʽۻعۼҵģʵ';
comment on column T_B61_F002.p001
  is '';
comment on column T_B61_F002.p002
  is 'ĿID';
comment on column T_B61_F002.p003
  is 'ָID1001- 1002-ۼ';
comment on column T_B61_F002.v
  is 'ֵָ';
alter table T_B61_F002
  add constraint PK_T_B61_F002 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B61_F003
prompt =========================
prompt
create table T_B61_F003
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B61_F003
  is 'Ѻʽۻعʱʵ';
comment on column T_B61_F003.p001
  is '';
comment on column T_B61_F003.p002
  is 'ĿID';
comment on column T_B61_F003.p003
  is 'ָID1001- 1002-ʣ';
alter table T_B61_F003
  add constraint PK_T_B61_F003 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B62_D001
prompt =========================
prompt
create table T_B62_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B62_D001
  is 'Լʽױάȣ';
comment on column T_B62_D001.p001
  is 'ĿID';
comment on column T_B62_D001.a002
  is 'Ŀ';
comment on column T_B62_D001.a009
  is 'Դ';
comment on column T_B62_D001.b099
  is 'ע';
comment on column T_B62_D001.z100
  is '־';
alter table T_B62_D001
  add constraint P_B62_D001 primary key (P001);

prompt
prompt Creating table T_B62_F001
prompt =========================
prompt
create table T_B62_F001
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B62_F001
  is 'Լʽױʵ';
comment on column T_B62_F001.p001
  is '';
comment on column T_B62_F001.p002
  is 'ĿID';
comment on column T_B62_F001.p003
  is 'ָID1001-ڳ 1002- 1003-ڼ 1004-ĩ';
comment on column T_B62_F001.v
  is 'ֵָ';
alter table T_B62_F001
  add constraint PK_T_B62_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B62_F002
prompt =========================
prompt
create table T_B62_F002
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B62_F002
  is 'Լʽۼҵģʵ';
comment on column T_B62_F002.p001
  is '';
comment on column T_B62_F002.p002
  is 'ĿID';
comment on column T_B62_F002.p003
  is 'ָID1001- 1002-ۼ';
comment on column T_B62_F002.v
  is 'ֵָ';
alter table T_B62_F002
  add constraint PK_T_B62_F002 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B62_F003
prompt =========================
prompt
create table T_B62_F003
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B62_F003
  is 'Լʽʱʵ';
comment on column T_B62_F003.p001
  is '';
comment on column T_B62_F003.p002
  is 'ĿID';
comment on column T_B62_F003.p003
  is 'ָID1001- 1002-ʣ';
alter table T_B62_F003
  add constraint PK_T_B62_F003 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_D001
prompt =========================
prompt
create table T_B63_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(50) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B63_D001
  is 'ƱѺʽعױάȣ';
comment on column T_B63_D001.p001
  is 'ĿID';
comment on column T_B63_D001.a002
  is 'Ŀ';
comment on column T_B63_D001.a009
  is 'Դ';
comment on column T_B63_D001.b099
  is 'ע';
comment on column T_B63_D001.z100
  is '־';
alter table T_B63_D001
  add constraint P_B63_D001 primary key (P001);

prompt
prompt Creating table T_B63_D001_RH
prompt ============================
prompt
create table T_B63_D001_RH
(
  p001 NUMBER not null,
  a002 VARCHAR2(50) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B63_D001_RH
  is 'ƱѺʽعױ-ڻ㣨άȣ';
comment on column T_B63_D001_RH.p001
  is 'ĿID';
comment on column T_B63_D001_RH.a002
  is 'Ŀ';
comment on column T_B63_D001_RH.a009
  is 'Դ';
comment on column T_B63_D001_RH.b099
  is 'ע';
comment on column T_B63_D001_RH.z100
  is '־';
alter table T_B63_D001_RH
  add constraint P_B63_D001_RH primary key (P001);

prompt
prompt Creating table T_B63_D001_ZYZJ
prompt ==============================
prompt
create table T_B63_D001_ZYZJ
(
  p001 NUMBER not null,
  a002 VARCHAR2(50) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_B63_D001_ZYZJ
  is 'ƱѺʽعױ-ڻ㣨άȣ';
comment on column T_B63_D001_ZYZJ.p001
  is 'ĿID';
comment on column T_B63_D001_ZYZJ.a002
  is 'Ŀ';
comment on column T_B63_D001_ZYZJ.a009
  is 'Դ';
comment on column T_B63_D001_ZYZJ.b099
  is 'ע';
comment on column T_B63_D001_ZYZJ.z100
  is '־';
alter table T_B63_D001_ZYZJ
  add constraint P_B63_D001_ZYZJ primary key (P001);

prompt
prompt Creating table T_B63_F001
prompt =========================
prompt
create table T_B63_F001
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B63_F001
  is 'ƱѺʽعױʵ';
comment on column T_B63_F001.p001
  is '';
comment on column T_B63_F001.p002
  is 'ĿID';
comment on column T_B63_F001.p003
  is 'ָID1001-ڳ 1002- 1003-ڼ 1004-ĩ';
comment on column T_B63_F001.v
  is 'ֵָ';
alter table T_B63_F001
  add constraint PK_T_B63_F001 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F001_RH
prompt ============================
prompt
create table T_B63_F001_RH
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
nologging;
comment on table T_B63_F001_RH
  is 'ƱѺʽعױ-ڻ㣨ʵ';
comment on column T_B63_F001_RH.p001
  is '';
comment on column T_B63_F001_RH.p002
  is 'ĿID';
comment on column T_B63_F001_RH.p003
  is 'ָID1001-ڳ 1002- 1003-ڼ 1004-ĩ';
comment on column T_B63_F001_RH.v
  is 'ֵָ';
alter table T_B63_F001_RH
  add constraint PK_T_B63_F001_RH primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F001_ZYZJ
prompt ==============================
prompt
create table T_B63_F001_ZYZJ
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
nologging;
comment on table T_B63_F001_ZYZJ
  is 'ƱѺʽعױ-ڻ㣨ʵ';
comment on column T_B63_F001_ZYZJ.p001
  is '';
comment on column T_B63_F001_ZYZJ.p002
  is 'ĿID';
comment on column T_B63_F001_ZYZJ.p003
  is 'ָID1001-ڳ 1002- 1003-ڼ 1004-ĩ';
comment on column T_B63_F001_ZYZJ.v
  is 'ֵָ';
alter table T_B63_F001_ZYZJ
  add constraint PK_T_B63_F001_ZYZJ primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F002
prompt =========================
prompt
create table T_B63_F002
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B63_F002
  is 'ƱѺʽعۼҵģʵ';
comment on column T_B63_F002.p001
  is '';
comment on column T_B63_F002.p002
  is 'ĿID';
comment on column T_B63_F002.p003
  is 'ָID1001- 1002-ۼ';
comment on column T_B63_F002.v
  is 'ֵָ';
alter table T_B63_F002
  add constraint PK_T_B63_F002 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F002_RH
prompt ============================
prompt
create table T_B63_F002_RH
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
nologging;
comment on table T_B63_F002_RH
  is 'ƱѺʽعۼҵģʵ';
comment on column T_B63_F002_RH.p001
  is '';
comment on column T_B63_F002_RH.p002
  is 'ĿID';
comment on column T_B63_F002_RH.p003
  is 'ָID1001- 1002-ۼ';
comment on column T_B63_F002_RH.v
  is 'ֵָ';
alter table T_B63_F002_RH
  add constraint PK_T_B63_F002_RH primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F002_ZYZJ
prompt ==============================
prompt
create table T_B63_F002_ZYZJ
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
nologging;
comment on table T_B63_F002_ZYZJ
  is 'ƱѺʽعۼҵģʵ';
comment on column T_B63_F002_ZYZJ.p001
  is '';
comment on column T_B63_F002_ZYZJ.p002
  is 'ĿID';
comment on column T_B63_F002_ZYZJ.p003
  is 'ָID1001- 1002-ۼ';
comment on column T_B63_F002_ZYZJ.v
  is 'ֵָ';
alter table T_B63_F002_ZYZJ
  add constraint PK_T_B63_F002_ZYZJ primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F003
prompt =========================
prompt
create table T_B63_F003
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
;
comment on table T_B63_F003
  is 'ƱѺʽعʱʵ';
comment on column T_B63_F003.p001
  is '';
comment on column T_B63_F003.p002
  is 'ĿID';
comment on column T_B63_F003.p003
  is 'ָID1001- 1002-ʣ';
comment on column T_B63_F003.v
  is 'ֵָ';
alter table T_B63_F003
  add constraint PK_T_B63_F003 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F003_RH
prompt ============================
prompt
create table T_B63_F003_RH
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
nologging;
comment on table T_B63_F003_RH
  is 'ƱѺʽعʱʵ';
comment on column T_B63_F003_RH.p001
  is '';
comment on column T_B63_F003_RH.p002
  is 'ĿID';
comment on column T_B63_F003_RH.p003
  is 'ָID1001- 1002-ʣ';
comment on column T_B63_F003_RH.v
  is 'ֵָ';
alter table T_B63_F003_RH
  add constraint PK_T_B63_F003_RH primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B63_F003_ZYZJ
prompt ==============================
prompt
create table T_B63_F003_ZYZJ
(
  p001 VARCHAR2(8) not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(18,2),
  w100 NUMBER not null
)
nologging;
comment on table T_B63_F003_ZYZJ
  is 'ƱѺʽعʱʵ';
comment on column T_B63_F003_ZYZJ.p001
  is '';
comment on column T_B63_F003_ZYZJ.p002
  is 'ĿID';
comment on column T_B63_F003_ZYZJ.p003
  is 'ָID1001- 1002-ʣ';
comment on column T_B63_F003_ZYZJ.v
  is 'ֵָ';
alter table T_B63_F003_ZYZJ
  add constraint PK_T_B63_F003_ZYZJ primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_B99_T002
prompt =========================
prompt
create table T_B99_T002
(
  p001 NUMBER not null,
  p002 VARCHAR2(64) not null,
  a003 VARCHAR2(32),
  a004 VARCHAR2(100),
  a005 DATE,
  a006 NUMBER(14,2),
  a007 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_B99_T002
  is 'ITϵͳʹ';
comment on column T_B99_T002.p001
  is 'ϵͳ';
comment on column T_B99_T002.p002
  is 'ϵͳ';
comment on column T_B99_T002.a003
  is '汾';
comment on column T_B99_T002.a004
  is 'ṩ';
comment on column T_B99_T002.a005
  is 'ʱ';
comment on column T_B99_T002.a006
  is 'Ͷʽ';
comment on column T_B99_T002.a007
  is 'ע';
comment on column T_B99_T002.a100
  is '';
alter table T_B99_T002
  add constraint PK_T_B99_T002 primary key (P001, P002, A100);

prompt
prompt Creating table T_B99_T003
prompt =========================
prompt
create table T_B99_T003
(
  p001 VARCHAR2(64) not null,
  a002 NUMBER(14,2) not null,
  a003 VARCHAR2(128) not null,
  a004 VARCHAR2(32) not null,
  a005 VARCHAR2(128) not null,
  a006 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_B99_T003
  is 'Ӳ';
comment on column T_B99_T003.p001
  is '';
comment on column T_B99_T003.a002
  is '';
comment on column T_B99_T003.a003
  is '';
comment on column T_B99_T003.a004
  is 'ϵͳ';
comment on column T_B99_T003.a005
  is 'ݿ';
comment on column T_B99_T003.a006
  is 'ע';
comment on column T_B99_T003.a100
  is '';
alter table T_B99_T003
  add constraint PK_T_B99_T003 primary key (P001, A100);

prompt
prompt Creating table T_B99_T004
prompt =========================
prompt
create table T_B99_T004
(
  p001 VARCHAR2(255),
  p002 VARCHAR2(255),
  p003 VARCHAR2(255),
  p004 VARCHAR2(255),
  p005 VARCHAR2(255),
  p006 VARCHAR2(255),
  p007 VARCHAR2(255),
  p008 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a001 NUMBER,
  a100 NUMBER
)
;
comment on column T_B99_T004.p001
  is '¹';
comment on column T_B99_T004.p002
  is '¹ʷʱ估ʱ';
comment on column T_B99_T004.p003
  is '¹ʷԭ򼰾';
comment on column T_B99_T004.p004
  is '¹ѲȡӦʹʩ';
comment on column T_B99_T004.p005
  is '¹ʷ';
comment on column T_B99_T004.p006
  is '¹Ӱ췶Χ';
comment on column T_B99_T004.p007
  is 'ܲż֯';
comment on column T_B99_T004.p008
  is 'ע';
comment on column T_B99_T004.b001
  is '¼״̬';
comment on column T_B99_T004.a100
  is '';

prompt
prompt Creating table T_B99_T005
prompt =========================
prompt
create table T_B99_T005
(
  a002 NUMBER not null,
  a006 NUMBER not null,
  p001 NUMBER not null,
  a007 VARCHAR2(255),
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_B99_T005
  is 'Ӫҵ';
comment on column T_B99_T005.a002
  is 'Ƿüн';
comment on column T_B99_T005.a006
  is 'н׷ʽ';
comment on column T_B99_T005.p001
  is 'ID';
comment on column T_B99_T005.a007
  is 'ע';
comment on column T_B99_T005.a100
  is '';
alter table T_B99_T005
  add constraint PK_T_B99_T005 primary key (P001, A100);

prompt
prompt Creating table T_BKS_D001
prompt =========================
prompt
create table T_BKS_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_BKS_D001
  is 'ضƷϯλϢάȱ';
comment on column T_BKS_D001.p001
  is 'ĿID';
comment on column T_BKS_D001.a002
  is 'Ŀ';
comment on column T_BKS_D001.z100
  is '־';
comment on column T_BKS_D001.b099
  is 'ע';
alter table T_BKS_D001
  add constraint PK_T_BKS_D001 primary key (P001);

prompt
prompt Creating table T_BKS_D006
prompt =========================
prompt
create table T_BKS_D006
(
  p001 NUMBER not null,
  a002 VARCHAR2(128)
)
;
comment on table T_BKS_D006
  is '˾ҵӦı';
alter table T_BKS_D006
  add constraint PK_T_BKS_D006 primary key (P001);

prompt
prompt Creating table T_BKS_D007
prompt =========================
prompt
create table T_BKS_D007
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a003 VARCHAR2(64) not null,
  a006 NUMBER,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a004 VARCHAR2(255)
)
;
comment on table T_BKS_D007
  is 'ֵָ꣨άȣ';
comment on column T_BKS_D007.p001
  is 'ֵָID';
comment on column T_BKS_D007.a002
  is 'ҵID';
comment on column T_BKS_D007.a003
  is 'ָ';
comment on column T_BKS_D007.a006
  is 'ID';
comment on column T_BKS_D007.a009
  is 'Դ';
comment on column T_BKS_D007.b099
  is 'ע';
comment on column T_BKS_D007.z100
  is '־';
comment on column T_BKS_D007.a004
  is 'ֵλ';
alter table T_BKS_D007
  add constraint P_BKS_D007 primary key (P001);

prompt
prompt Creating table T_BKS_D008
prompt =========================
prompt
create table T_BKS_D008
(
  p001 NUMBER not null,
  a002 VARCHAR2(24) not null
)
;
comment on table T_BKS_D008
  is 'ϵͳֵ';
comment on column T_BKS_D008.p001
  is 'ϵͳд';
comment on column T_BKS_D008.a002
  is 'ϵͳ';

prompt
prompt Creating table T_BKS_D051
prompt =========================
prompt
create table T_BKS_D051
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 VARCHAR2(256),
  a004 VARCHAR2(128)
)
;
comment on table T_BKS_D051
  is 'ӪҵϢͳֵ';
comment on column T_BKS_D051.p001
  is '';
comment on column T_BKS_D051.a002
  is 'ҵID';
comment on column T_BKS_D051.a003
  is 'ͳ';
comment on column T_BKS_D051.a004
  is 'ָο';

prompt
prompt Creating table T_BKS_D052
prompt =========================
prompt
create table T_BKS_D052
(
  p001 VARCHAR2(24) not null,
  a001 VARCHAR2(100)
)
;
comment on table T_BKS_D052
  is 'ӪҵϢͳֵ';
comment on column T_BKS_D052.p001
  is 'ID';
comment on column T_BKS_D052.a001
  is 'ֵ';

prompt
prompt Creating table T_BKS_D053
prompt =========================
prompt
create table T_BKS_D053
(
  p001 VARCHAR2(24) not null,
  a001 VARCHAR2(100)
)
;
comment on table T_BKS_D053
  is 'ӪҵϢͳƱһ_ע_ֵ';
comment on column T_BKS_D053.p001
  is 'ID';
comment on column T_BKS_D053.a001
  is 'ֵ';

prompt
prompt Creating table T_BKS_D054
prompt =========================
prompt
create table T_BKS_D054
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 VARCHAR2(256),
  a004 VARCHAR2(128)
)
;
comment on table T_BKS_D054
  is 'ӪҵϢͳֵ';
comment on column T_BKS_D054.p001
  is '';
comment on column T_BKS_D054.a002
  is 'ҵID';
comment on column T_BKS_D054.a003
  is 'ͳ';
comment on column T_BKS_D054.a004
  is 'ָο';

prompt
prompt Creating table T_BKS_T001
prompt =========================
prompt
create table T_BKS_T001
(
  a004 NUMBER not null,
  a005 NUMBER not null,
  a006 NUMBER not null,
  a007 VARCHAR2(255),
  a100 NUMBER not null
)
;
comment on table T_BKS_T001
  is '֤ȯͶѯ';
comment on column T_BKS_T001.a004
  is ';';
comment on column T_BKS_T001.a005
  is '';
comment on column T_BKS_T001.a006
  is '';
comment on column T_BKS_T001.a007
  is 'ע';
comment on column T_BKS_T001.a100
  is '˻';
alter table T_BKS_T001
  add constraint PK_BKS_T001 primary key (A004, A005, A100);

prompt
prompt Creating table T_BKS_T002
prompt =========================
prompt
create table T_BKS_T002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a004 VARCHAR2(32) not null,
  a005 NUMBER not null,
  a006 VARCHAR2(32) not null,
  a007 VARCHAR2(8) not null,
  a008 VARCHAR2(8) not null,
  a009 DATE not null,
  a010 NUMBER not null,
  a011 NUMBER,
  a012 VARCHAR2(100),
  a003 DATE
)
;
comment on table T_BKS_T002
  is '빫ý';
comment on column T_BKS_T002.p001
  is 'ýĿ';
comment on column T_BKS_T002.p002
  is '';
comment on column T_BKS_T002.a004
  is 'ý';
comment on column T_BKS_T002.a005
  is 'Ŀ';
comment on column T_BKS_T002.a006
  is 'Ŀ';
comment on column T_BKS_T002.a007
  is 'Ŀʼʱ';
comment on column T_BKS_T002.a008
  is 'Ŀʱ';
comment on column T_BKS_T002.a009
  is 'ʼʱ';
comment on column T_BKS_T002.a010
  is 'ǰ״̬';
comment on column T_BKS_T002.a011
  is 'Ա';
comment on column T_BKS_T002.a012
  is 'Ա';
comment on column T_BKS_T002.a003
  is 'ʱ';
alter table T_BKS_T002
  add constraint PK_T_BKS_T002 primary key (P001, P002);

prompt
prompt Creating table T_BKS_T003
prompt =========================
prompt
create table T_BKS_T003
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 NUMBER,
  a004 NUMBER,
  a005 NUMBER,
  a006 VARCHAR2(2048),
  a100 NUMBER not null
)
;
comment on table T_BKS_T003
  is '˻';
comment on column T_BKS_T003.p001
  is '';
comment on column T_BKS_T003.a002
  is 'ڳ';
comment on column T_BKS_T003.a003
  is '';
comment on column T_BKS_T003.a004
  is 'ڼ';
comment on column T_BKS_T003.a005
  is 'ĩ';
comment on column T_BKS_T003.a100
  is '˻   -- zhouly   20130822';
alter table T_BKS_T003
  add constraint PK_BKS_T005 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T004
prompt =========================
prompt
create table T_BKS_T004
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 NUMBER,
  a004 NUMBER,
  a005 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_BKS_T004
  is '֤ȯͶѯԱ';
comment on column T_BKS_T004.p001
  is 'ѯز';
comment on column T_BKS_T004.a002
  is 'ڳ';
comment on column T_BKS_T004.a003
  is '';
comment on column T_BKS_T004.a004
  is 'ڼ';
comment on column T_BKS_T004.a005
  is 'ĩ';
comment on column T_BKS_T004.a100
  is '˻  ';
alter table T_BKS_T004
  add constraint PK_T_BKS_T004 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T005
prompt =========================
prompt
create table T_BKS_T005
(
  p001  NUMBER not null,
  p002  NUMBER not null,
  p003  NUMBER not null,
  p004  NUMBER not null,
  p005  VARCHAR2(64) not null,
  p006  VARCHAR2(64) not null,
  a007  VARCHAR2(32) not null,
  a008  DATE not null,
  a009  NUMBER(19,2) not null,
  a010  NUMBER(19,2) not null,
  a011  NUMBER(19,2) not null,
  a015  VARCHAR2(512),
  a016  NUMBER(19,2),
  a017  NUMBER(19,2),
  a018  NUMBER,
  users VARCHAR2(32),
  a100  NUMBER not null
)
;
comment on table T_BKS_T005
  is 'Ŀ';
comment on column T_BKS_T005.p001
  is 'ĿID';
comment on column T_BKS_T005.p002
  is 'ĿID';
comment on column T_BKS_T005.p003
  is 'ID';
comment on column T_BKS_T005.p004
  is 'ʽID';
comment on column T_BKS_T005.p005
  is '';
comment on column T_BKS_T005.p006
  is 'Ŀ';
comment on column T_BKS_T005.a007
  is '';
comment on column T_BKS_T005.a008
  is 'ʱ';
comment on column T_BKS_T005.a009
  is 'Ŀܽ';
comment on column T_BKS_T005.a010
  is '';
comment on column T_BKS_T005.a011
  is 'Ӷ';
comment on column T_BKS_T005.a015
  is 'ע';
comment on column T_BKS_T005.a016
  is '˾ְ';
comment on column T_BKS_T005.a017
  is 'սͶЭ';
comment on column T_BKS_T005.a018
  is '';
comment on column T_BKS_T005.a100
  is '';
alter table T_BKS_T005
  add constraint PK_T_BKS_T005 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T006
prompt =========================
prompt
create table T_BKS_T006
(
  p001 NUMBER not null,
  a003 VARCHAR2(256),
  a004 VARCHAR2(2048),
  a100 NUMBER
)
;
comment on table T_BKS_T006
  is 'Ϲ';
comment on column T_BKS_T006.p001
  is 'ĿID';
comment on column T_BKS_T006.a003
  is '';
comment on column T_BKS_T006.a100
  is '˻   --  zhouly   20130822';

prompt
prompt Creating table T_BKS_T007
prompt =========================
prompt
create table T_BKS_T007
(
  a002 NUMBER(14,5),
  a003 NUMBER(14,5)
)
;
comment on table T_BKS_T007
  is '';
comment on column T_BKS_T007.a002
  is 'Ԫ';
comment on column T_BKS_T007.a003
  is '۱һ';

prompt
prompt Creating table T_BKS_T007_20200430
prompt ==================================
prompt
create table T_BKS_T007_20200430
(
  a002 NUMBER(14,5),
  a003 NUMBER(14,5)
)
;

prompt
prompt Creating table T_BKS_T008
prompt =========================
prompt
create table T_BKS_T008
(
  p001 NUMBER not null,
  a002 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_BKS_T008
  is '˾ҵ';
comment on column T_BKS_T008.p001
  is '';
comment on column T_BKS_T008.a002
  is '';
comment on column T_BKS_T008.a100
  is '˻    zhouly    20130822';
alter table T_BKS_T008
  add constraint PK_T_BKS_T008 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T009
prompt =========================
prompt
create table T_BKS_T009
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 VARCHAR2(128),
  a100 NUMBER not null
)
;
comment on table T_BKS_T009
  is '֤ȯ˾ʾ';
comment on column T_BKS_T009.p001
  is 'ʾ';
comment on column T_BKS_T009.a002
  is 'ʾ';
comment on column T_BKS_T009.a003
  is 'ע';
comment on column T_BKS_T009.a100
  is '˻    --  zhouly    20130822';
alter table T_BKS_T009
  add constraint PK_T_BKS_T009 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T010
prompt =========================
prompt
create table T_BKS_T010
(
  p001 NUMBER not null,
  a002 NUMBER,
  b009 DATE,
  a100 NUMBER
)
;
comment on table T_BKS_T010
  is 'ϯλʹ';
comment on column T_BKS_T010.p001
  is 'ָ';
comment on column T_BKS_T010.a002
  is 'ֵָ';
comment on column T_BKS_T010.b009
  is '޸';
comment on column T_BKS_T010.a100
  is '˻ ';

prompt
prompt Creating table T_BKS_T011
prompt =========================
prompt
create table T_BKS_T011
(
  p001 NUMBER not null,
  a002 VARCHAR2(40) not null,
  a003 NUMBER not null,
  a004 VARCHAR2(255),
  a005 NUMBER(18,2),
  a006 VARCHAR2(30) not null,
  a100 NUMBER not null
)
;
comment on table T_BKS_T011
  is 'ʦ';
comment on column T_BKS_T011.p001
  is '';
comment on column T_BKS_T011.a002
  is 'ʦ';
comment on column T_BKS_T011.a003
  is '';
comment on column T_BKS_T011.a004
  is 'Ǳ׼';
comment on column T_BKS_T011.a005
  is 'շѣԪ';
comment on column T_BKS_T011.a006
  is 'ǩעʦ';
comment on column T_BKS_T011.a100
  is '˻   ';
alter table T_BKS_T011
  add constraint PK_T_BKS_T011 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T012
prompt =========================
prompt
create table T_BKS_T012
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a003 VARCHAR2(64),
  a004 VARCHAR2(64),
  a005 VARCHAR2(64),
  a100 NUMBER not null
)
;
comment on column T_BKS_T012.p001
  is 'Ϣ';
comment on column T_BKS_T012.a002
  is '';
comment on column T_BKS_T012.a003
  is 'ϵ绰';
comment on column T_BKS_T012.a004
  is 'ƶ绰';
comment on column T_BKS_T012.a005
  is 'ʼ';
comment on column T_BKS_T012.a100
  is '˻';
alter table T_BKS_T012
  add constraint PK_T_BKS_T012 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T013
prompt =========================
prompt
create table T_BKS_T013
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 NUMBER,
  a004 NUMBER,
  a005 VARCHAR2(2048),
  a100 NUMBER not null
)
;
comment on table T_BKS_T013
  is 'ۼƱĿ';
comment on column T_BKS_T013.p001
  is '"
"';
comment on column T_BKS_T013.a002
  is '"
"';
comment on column T_BKS_T013.a003
  is '"ۼѾͨ
"';
comment on column T_BKS_T013.a004
  is '"ۼδͨ
"';
comment on column T_BKS_T013.a100
  is '˻   -- zhouly   20130822';
alter table T_BKS_T013
  add constraint PK_T_BKS_T013 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T014
prompt =========================
prompt
create table T_BKS_T014
(
  a002 NUMBER,
  a003 NUMBER,
  a004 NUMBER(14,2),
  a005 DATE,
  a006 NUMBER,
  a007 NUMBER,
  a008 NUMBER(14,2),
  a009 NUMBER,
  a010 NUMBER,
  a011 NUMBER,
  a012 NUMBER,
  a013 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_BKS_T014
  is 'ʻ淶Ϣ';
comment on column T_BKS_T014.a002
  is '"ڳСʽ˻()
"';
comment on column T_BKS_T014.a003
  is '"ڳС֤ȯ˻()
"';
comment on column T_BKS_T014.a004
  is '"ڳС˻ʽܶ(Ԫ)
"';
comment on column T_BKS_T014.a005
  is '"˻׼
"';
comment on column T_BKS_T014.a006
  is '"˻׼ղϸʽ˻()
"';
comment on column T_BKS_T014.a007
  is '"˻׼ղϸ֤ȯ˻()
"';
comment on column T_BKS_T014.a008
  is '"˻׼ղϸ˻ʽܶ(Ԫ)
"';
comment on column T_BKS_T014.a009
  is '"1031ǰעδڵǼǹ˾
ϸ֤ȯ˻()"';
comment on column T_BKS_T014.a010
  is '"С˻ʽǷ(/)
"';
comment on column T_BKS_T014.a011
  is '"δ淶ϸ˻ʽǷ(/)
"';
comment on column T_BKS_T014.a012
  is '"С֤ȯ˻Ƿ(/)
"';
comment on column T_BKS_T014.a013
  is 'δ淶ϸ֤ȯ˻Ƿ(/)
';
comment on column T_BKS_T014.a100
  is '';

prompt
prompt Creating table T_BKS_T015
prompt =========================
prompt
create table T_BKS_T015
(
  a002 NUMBER(14,2),
  a003 NUMBER(14,2),
  a004 NUMBER(14,2),
  a005 NUMBER(14,2),
  a006 NUMBER(14,2),
  p001 NUMBER not null,
  a100 NUMBER
)
;
comment on table T_BKS_T015
  is 'ʻ淶1031Ϣ';
comment on column T_BKS_T015.a002
  is '"ݲӦ
"';
comment on column T_BKS_T015.a003
  is '"
"';
comment on column T_BKS_T015.a004
  is '"ϵ淶
"';
comment on column T_BKS_T015.a005
  is '"ϲ淶
"';
comment on column T_BKS_T015.a006
  is '"ϸ˻
"';
comment on column T_BKS_T015.p001
  is 'ID';
comment on column T_BKS_T015.a100
  is '˱ʾ';

prompt
prompt Creating table T_BKS_T016
prompt =========================
prompt
create table T_BKS_T016
(
  p001 VARCHAR2(16) not null,
  a002 VARCHAR2(128),
  a003 NUMBER not null,
  a004 NUMBER not null,
  a005 NUMBER(19,2),
  a006 VARCHAR2(32),
  a007 TIMESTAMP(6),
  a100 NUMBER not null
)
;
comment on table T_BKS_T016
  is 'Ӫ̨ʱ';
comment on column T_BKS_T016.p001
  is '';
comment on column T_BKS_T016.a002
  is '';
comment on column T_BKS_T016.a003
  is '';
comment on column T_BKS_T016.a004
  is 'ҵID(ͬıӦͬĴ룩(100 Ʊ(t_b00_d009) 200 (t_b00_d007) 300 ծȯ(t_b00_d006) 400 (t_b00_d008))';
comment on column T_BKS_T016.a005
  is 'ɱ ݶ';
comment on column T_BKS_T016.a006
  is 'û';
comment on column T_BKS_T016.a007
  is 'ʱ';
comment on column T_BKS_T016.a100
  is '˱ʶ';
alter table T_BKS_T016
  add constraint PK_T_BKS_T016 primary key (P001, A003, A004, A100);

prompt
prompt Creating table T_BKS_T017
prompt =========================
prompt
create table T_BKS_T017
(
  p001 NUMBER not null,
  a002 VARCHAR2(19),
  a003 VARCHAR2(19),
  a100 NUMBER not null
)
;
comment on table T_BKS_T017
  is '֤ȯ˾տָԤܱ׼';
comment on column T_BKS_T017.p001
  is 'Ŀ';
comment on column T_BKS_T017.a002
  is 'Ԥ׼';
comment on column T_BKS_T017.a003
  is 'ܱ׼';
comment on column T_BKS_T017.a100
  is '˻  -- zhouly    20130822';
alter table T_BKS_T017
  add constraint PK_T_BKS_T017 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T019
prompt =========================
prompt
create table T_BKS_T019
(
  p001 VARCHAR2(8) not null,
  a002 VARCHAR2(128),
  a003 NUMBER(19,2),
  a100 NUMBER not null
)
;
comment on table T_BKS_T019
  is 'ͨɱ';
comment on column T_BKS_T019.p001
  is '';
comment on column T_BKS_T019.a002
  is '';
comment on column T_BKS_T019.a003
  is 'ɱ/';
comment on column T_BKS_T019.a100
  is '˱ʶ';
alter table T_BKS_T019
  add constraint PK_T_BKS_T019 primary key (P001);

prompt
prompt Creating table T_BKS_T027
prompt =========================
prompt
create table T_BKS_T027
(
  p001 NUMBER not null,
  a001 NUMBER,
  a002 NUMBER,
  a003 NUMBER(19,2),
  a004 VARCHAR2(255),
  a100 NUMBER
)
;
comment on column T_BKS_T027.a100
  is '˱ʾ';

prompt
prompt Creating table T_BKS_T028
prompt =========================
prompt
create table T_BKS_T028
(
  p001 NUMBER not null,
  a001 NUMBER,
  a002 NUMBER,
  a003 NUMBER(19,2),
  a004 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_BKS_T028
  is 'Ϣϵͳ';
comment on column T_BKS_T028.p001
  is 'ӪҵID';
comment on column T_BKS_T028.a001
  is 'Ŀ';
comment on column T_BKS_T028.a002
  is 'ֵ(/)';
comment on column T_BKS_T028.a003
  is 'Ԫ/';
comment on column T_BKS_T028.a004
  is 'ע';
comment on column T_BKS_T028.a100
  is '';

prompt
prompt Creating table T_BKS_T029
prompt =========================
prompt
create table T_BKS_T029
(
  p001 NUMBER not null,
  a001 NUMBER,
  a002 NUMBER,
  a003 NUMBER(19,2),
  a004 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_BKS_T029
  is '߼иծ';
comment on column T_BKS_T029.p001
  is 'ӪҵID';
comment on column T_BKS_T029.a001
  is 'Ŀ';
comment on column T_BKS_T029.a002
  is 'ֵ(/)';
comment on column T_BKS_T029.a003
  is 'Ԫ/';
comment on column T_BKS_T029.a004
  is 'ע';
comment on column T_BKS_T029.a100
  is '';

prompt
prompt Creating table T_BKS_T030
prompt =========================
prompt
create table T_BKS_T030
(
  p001 NUMBER not null,
  a001 NUMBER,
  a002 NUMBER,
  a003 NUMBER(19,2),
  a004 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_BKS_T030
  is 'ش';
comment on column T_BKS_T030.p001
  is 'ӪҵID';
comment on column T_BKS_T030.a001
  is 'Ŀ';
comment on column T_BKS_T030.a002
  is 'ֵ(/)';
comment on column T_BKS_T030.a003
  is 'Ԫ/';
comment on column T_BKS_T030.a004
  is 'ע';
comment on column T_BKS_T030.a100
  is '';

prompt
prompt Creating table T_BKS_T031
prompt =========================
prompt
create table T_BKS_T031
(
  p001 NUMBER not null,
  p002 VARCHAR2(10) not null,
  a003 VARCHAR2(255) not null,
  a004 NUMBER not null,
  a100 NUMBER
)
;
comment on table T_BKS_T031
  is 'ϵͳжӦϵ';
comment on column T_BKS_T031.p001
  is '';
comment on column T_BKS_T031.p002
  is '̨д';
comment on column T_BKS_T031.a003
  is '̨';
comment on column T_BKS_T031.a004
  is 'ϵͳд';
comment on column T_BKS_T031.a100
  is '˱ʶ';

prompt
prompt Creating table T_BKS_T031_20201203
prompt ==================================
prompt
create table T_BKS_T031_20201203
(
  p001 NUMBER not null,
  p002 VARCHAR2(10) not null,
  a003 VARCHAR2(255) not null,
  a004 NUMBER not null,
  a100 NUMBER
)
;

prompt
prompt Creating table T_BKS_T032
prompt =========================
prompt
create table T_BKS_T032
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a003 VARCHAR2(64),
  a004 VARCHAR2(64),
  a005 VARCHAR2(64),
  p002 NUMBER not null,
  a100 NUMBER not null
)
;
comment on table T_BKS_T032
  is 'Ӫҵ';
comment on column T_BKS_T032.p001
  is 'Ϣ';
comment on column T_BKS_T032.a002
  is '';
comment on column T_BKS_T032.a003
  is 'ϵ绰';
comment on column T_BKS_T032.a004
  is 'ƶ绰';
comment on column T_BKS_T032.a005
  is 'ʼ';
comment on column T_BKS_T032.p002
  is 'ӪҵID';
comment on column T_BKS_T032.a100
  is '';
alter table T_BKS_T032
  add constraint PK_T_BKS_T032 primary key (P001, P002, A100);

prompt
prompt Creating table T_BKS_T033
prompt =========================
prompt
create table T_BKS_T033
(
  p001 NUMBER not null,
  p002 VARCHAR2(10) not null,
  a100 NUMBER not null
)
;
comment on table T_BKS_T033
  is 'вƷй˾֤ȯ˻';
comment on column T_BKS_T033.p001
  is 'г';
comment on column T_BKS_T033.p002
  is 'ɶ˺';
comment on column T_BKS_T033.a100
  is '˻    zhouly   20130823';
alter table T_BKS_T033
  add constraint PK_T_BKS_T033 primary key (P002, A100);

prompt
prompt Creating table T_BKS_T035
prompt =========================
prompt
create table T_BKS_T035
(
  p001 VARCHAR2(12) not null,
  a002 VARCHAR2(255),
  a003 VARCHAR2(50),
  a004 VARCHAR2(50),
  a005 VARCHAR2(50),
  a100 NUMBER not null
)
;
comment on column T_BKS_T035.p001
  is 'UPID';
comment on column T_BKS_T035.a002
  is '˾';
comment on column T_BKS_T035.a003
  is 'Ʊ';
comment on column T_BKS_T035.a004
  is '';
comment on column T_BKS_T035.a005
  is '';
comment on column T_BKS_T035.a100
  is '';
alter table T_BKS_T035
  add constraint PK_T_BKS_T035 primary key (P001, A100);

prompt
prompt Creating table T_BKS_T040
prompt =========================
prompt
create table T_BKS_T040
(
  p001 NUMBER,
  a002 NUMBER,
  a003 NUMBER,
  a100 NUMBER
)
;
comment on table T_BKS_T040
  is 'Ա';
comment on column T_BKS_T040.p001
  is 'Ŀ';
comment on column T_BKS_T040.a002
  is 'Ա';
comment on column T_BKS_T040.a003
  is ' УȡôҵʸԱ';
comment on column T_BKS_T040.a100
  is '˻   -- zhouly   20130822';

prompt
prompt Creating table T_BKS_T041
prompt =========================
prompt
create table T_BKS_T041
(
  p001 NUMBER,
  a002 NUMBER,
  a008 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_BKS_T041
  is 'һ֤ȯӪҵ';
comment on column T_BKS_T041.p001
  is 'Ŀ';
comment on column T_BKS_T041.a002
  is 'ĩ';
comment on column T_BKS_T041.a008
  is 'ע';
comment on column T_BKS_T041.a100
  is '˻   -- zhouly   20130822';

prompt
prompt Creating table T_BKS_T042
prompt =========================
prompt
create table T_BKS_T042
(
  p001 NUMBER,
  a002 NUMBER,
  a008 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_BKS_T042
  is 'ҵԱ';
comment on column T_BKS_T042.p001
  is 'Ŀ';
comment on column T_BKS_T042.a002
  is 'ĩ';
comment on column T_BKS_T042.a008
  is 'ע';
comment on column T_BKS_T042.a100
  is '˻   -- zhouly   20130822';

prompt
prompt Creating table T_BKS_T043
prompt =========================
prompt
create table T_BKS_T043
(
  p001 VARCHAR2(20) not null,
  a001 VARCHAR2(128),
  a100 NUMBER not null
)
;
comment on table T_BKS_T043
  is 'ʲƷϢ';
comment on column T_BKS_T043.p001
  is 'Ʒ';
comment on column T_BKS_T043.a001
  is 'ע';
comment on column T_BKS_T043.a100
  is '˻';
alter table T_BKS_T043
  add constraint T043_BKS primary key (P001, A100);

prompt
prompt Creating table T_BKS_T050
prompt =========================
prompt
create table T_BKS_T050
(
  p001 NUMBER(19,2)
)
;
comment on table T_BKS_T050
  is 'Ͷʱ';

prompt
prompt Creating table T_BKS_T051
prompt =========================
prompt
create table T_BKS_T051
(
  p001 NUMBER not null,
  a001 NUMBER,
  a002 VARCHAR2(100),
  a003 NUMBER,
  a100 NUMBER
)
;
comment on table T_BKS_T051
  is 'ӪҵϢͳƱ';
comment on column T_BKS_T051.p001
  is 'ӪҵID';
comment on column T_BKS_T051.a001
  is '';
comment on column T_BKS_T051.a002
  is 'ѡ';
comment on column T_BKS_T051.a003
  is 'ҵͣt_b00_d098';
comment on column T_BKS_T051.a100
  is '';

prompt
prompt Creating table T_BKS_T052
prompt =========================
prompt
create table T_BKS_T052
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a001 NUMBER,
  a100 NUMBER
)
;
comment on table T_BKS_T052
  is 'ӪҵϢͳƱ-';
comment on column T_BKS_T052.p001
  is 'ӪҵID';
comment on column T_BKS_T052.a002
  is 'Ŀֵ';
comment on column T_BKS_T052.a001
  is 'Ŀ';
comment on column T_BKS_T052.a100
  is '';

prompt
prompt Creating table T_BKS_T053
prompt =========================
prompt
create table T_BKS_T053
(
  p001 NUMBER not null,
  a001 NUMBER,
  a002 VARCHAR2(255),
  a100 NUMBER
)
;
comment on table T_BKS_T053
  is 'ӪҵϢͳƱһ_ע';
comment on column T_BKS_T053.p001
  is 'ӪҵID';
comment on column T_BKS_T053.a001
  is 'ĿID';
comment on column T_BKS_T053.a002
  is 'Ŀֵ';
comment on column T_BKS_T053.a100
  is '';

prompt
prompt Creating table T_BKS_T054
prompt =========================
prompt
create table T_BKS_T054
(
  p001 NUMBER not null,
  a001 NUMBER,
  a002 NUMBER,
  a003 NUMBER,
  a100 NUMBER
)
;
comment on table T_BKS_T054
  is 'ӪҵϢͳƱ';
comment on column T_BKS_T054.p001
  is 'ӪҵID';
comment on column T_BKS_T054.a001
  is '';
comment on column T_BKS_T054.a002
  is 'ѡ';
comment on column T_BKS_T054.a003
  is 'ҵͣt_b00_d098';
comment on column T_BKS_T054.a100
  is '˱ʾ';

prompt
prompt Creating table T_BKS_T064
prompt =========================
prompt
create table T_BKS_T064
(
  p001 NUMBER not null,
  a002 VARCHAR2(32),
  a003 VARCHAR2(32),
  a004 VARCHAR2(32),
  a100 NUMBER
)
;
comment on table T_BKS_T064
  is '֤ȯ˾ Ӫҵȯרܱ-';
comment on column T_BKS_T064.p001
  is 'Ӫҵid';
comment on column T_BKS_T064.a002
  is '';
comment on column T_BKS_T064.a003
  is 'E-mail';
comment on column T_BKS_T064.a004
  is 'ϵ绰';
comment on column T_BKS_T064.a100
  is '';

prompt
prompt Creating table T_BKS_T100
prompt =========================
prompt
create table T_BKS_T100
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20201102
prompt ==================================
prompt
create table T_BKS_T100_20201102
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20201201
prompt ==================================
prompt
create table T_BKS_T100_20201201
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210104
prompt ==================================
prompt
create table T_BKS_T100_20210104
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210201
prompt ==================================
prompt
create table T_BKS_T100_20210201
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210301
prompt ==================================
prompt
create table T_BKS_T100_20210301
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210401
prompt ==================================
prompt
create table T_BKS_T100_20210401
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210506
prompt ==================================
prompt
create table T_BKS_T100_20210506
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210601
prompt ==================================
prompt
create table T_BKS_T100_20210601
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210701
prompt ==================================
prompt
create table T_BKS_T100_20210701
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T100_20210802
prompt ==================================
prompt
create table T_BKS_T100_20210802
(
  jjdm VARCHAR2(20),
  jjmc VARCHAR2(254),
  fxzl NUMBER,
  syzl NUMBER,
  syfl NUMBER,
  fsfl NUMBER
)
;

prompt
prompt Creating table T_BKS_T101
prompt =========================
prompt
create table T_BKS_T101
(
  p001 NUMBER(12) not null,
  a001 VARCHAR2(100),
  a002 VARCHAR2(255),
  a003 VARCHAR2(20),
  a004 VARCHAR2(30),
  a005 VARCHAR2(255),
  a006 VARCHAR2(255),
  a007 CHAR(1),
  a008 CHAR(1),
  a009 CHAR(1),
  a010 CHAR(1),
  a011 CHAR(1),
  a012 CHAR(1),
  a013 VARCHAR2(255),
  a014 VARCHAR2(255),
  a100 NUMBER not null
)
;
comment on column T_BKS_T101.p001
  is '';
comment on column T_BKS_T101.a001
  is 'ͻʽ˻';
comment on column T_BKS_T101.a002
  is 'ͻʽ˻';
comment on column T_BKS_T101.a003
  is 'ͻ״̬';
comment on column T_BKS_T101.a004
  is 'ͻ֤';
comment on column T_BKS_T101.a005
  is 'ϵͳ';
comment on column T_BKS_T101.a006
  is '뷽';
comment on column T_BKS_T101.a007
  is 'ʲǷ';
comment on column T_BKS_T101.a008
  is 'ʣǷ';
comment on column T_BKS_T101.a009
  is 'ףǷ';
comment on column T_BKS_T101.a010
  is 'ͻʽܣǷ';
comment on column T_BKS_T101.a011
  is 'Ƿ';
comment on column T_BKS_T101.a012
  is 'ϿǷ';
comment on column T_BKS_T101.a013
  is '';
comment on column T_BKS_T101.a014
  is 'ע';
comment on column T_BKS_T101.a100
  is '˱ʶ';
alter table T_BKS_T101
  add constraint T_BKS_T101_PK primary key (P001, A100);

prompt
prompt Creating table T_BKS_T102
prompt =========================
prompt
create table T_BKS_T102
(
  p001 NUMBER(12) not null,
  a001 VARCHAR2(100),
  a002 VARCHAR2(255),
  a003 VARCHAR2(100),
  a004 VARCHAR2(255),
  a005 VARCHAR2(50),
  a006 VARCHAR2(12),
  a007 DATE,
  a008 DATE,
  a009 VARCHAR2(200),
  a010 VARCHAR2(255),
  a100 NUMBER not null,
  a011 NUMBER(12,2)
)
;
comment on column T_BKS_T102.a100
  is '˱ʶ';
alter table T_BKS_T102
  add constraint T_BKS_T102_PK primary key (P001, A100);

prompt
prompt Creating table T_BKS_ZYRHHY
prompt ===========================
prompt
create table T_BKS_ZYRHHY
(
  p001     VARCHAR2(256) not null,
  jyrq     VARCHAR2(256),
  hth      VARCHAR2(256),
  glhth    VARCHAR2(256),
  sbhtxh   VARCHAR2(256),
  htlx     VARCHAR2(256),
  fzjg     VARCHAR2(256),
  khbh     VARCHAR2(256),
  khxm     VARCHAR2(256),
  rcfmc    VARCHAR2(256),
  rcflx    VARCHAR2(256),
  zqdm     VARCHAR2(256),
  zqmc     VARCHAR2(256),
  wtsl     NUMBER,
  hgsl     NUMBER,
  ljbfjysl NUMBER,
  ljwymcsl NUMBER,
  wtje     NUMBER(19,2),
  yhje     NUMBER(19,2),
  dqrq     VARCHAR2(256),
  sjghrq   VARCHAR2(256),
  wtrq     NUMBER,
  jysc     VARCHAR2(10),
  xsbz     VARCHAR2(10),
  jgbs     VARCHAR2(10),
  hgll     NUMBER(19,4),
  sjghje   NUMBER(19,2),
  yjlx     NUMBER(19,2),
  sfwy     VARCHAR2(10),
  a100     NUMBER
)
;
comment on table T_BKS_ZYRHHY
  is '֤ȯ˾۽ڲƷͳƱ';
comment on column T_BKS_ZYRHHY.p001
  is 'Ʒ';
comment on column T_BKS_ZYRHHY.jyrq
  is '';
comment on column T_BKS_ZYRHHY.hth
  is 'ͬ';
comment on column T_BKS_ZYRHHY.glhth
  is 'ͬ';
comment on column T_BKS_ZYRHHY.sbhtxh
  is '걨ͬ';
comment on column T_BKS_ZYRHHY.htlx
  is 'ͬ';
comment on column T_BKS_ZYRHHY.fzjg
  is '֧';
comment on column T_BKS_ZYRHHY.khbh
  is 'ͻ';
comment on column T_BKS_ZYRHHY.khxm
  is 'ͻ';
comment on column T_BKS_ZYRHHY.rcfmc
  is 'ڳ';
comment on column T_BKS_ZYRHHY.rcflx
  is 'ڳ';
comment on column T_BKS_ZYRHHY.zqdm
  is '֤ȯ';
comment on column T_BKS_ZYRHHY.zqmc
  is '֤ȯ';
comment on column T_BKS_ZYRHHY.wtsl
  is 'ί';
comment on column T_BKS_ZYRHHY.hgsl
  is '';
comment on column T_BKS_ZYRHHY.ljbfjysl
  is 'ۼƲֽѺ';
comment on column T_BKS_ZYRHHY.ljwymcsl
  is 'ۼΥԼ';
comment on column T_BKS_ZYRHHY.wtje
  is 'ίн';
comment on column T_BKS_ZYRHHY.yhje
  is 'ѻ';
comment on column T_BKS_ZYRHHY.dqrq
  is '';
comment on column T_BKS_ZYRHHY.sjghrq
  is 'ʵʹ';

prompt
prompt Creating table T_BKS_ZYRHHY_20201110
prompt ====================================
prompt
create table T_BKS_ZYRHHY_20201110
(
  p001     NUMBER not null,
  jyrq     VARCHAR2(256),
  hth      VARCHAR2(256),
  glhth    VARCHAR2(256),
  sbhtxh   VARCHAR2(256),
  htlx     VARCHAR2(256),
  fzjg     VARCHAR2(256),
  khbh     VARCHAR2(256),
  khxm     VARCHAR2(256),
  rcfmc    VARCHAR2(256),
  rcflx    VARCHAR2(256),
  zqdm     VARCHAR2(256),
  zqmc     VARCHAR2(256),
  wtsl     NUMBER,
  hgsl     NUMBER,
  ljbfjysl NUMBER,
  ljwymcsl NUMBER,
  wtje     NUMBER,
  yhje     NUMBER,
  dqrq     VARCHAR2(256),
  sjghrq   VARCHAR2(256),
  sfwy     VARCHAR2(256),
  a100     NUMBER not null
)
;

prompt
prompt Creating table T_C13_3_BCHY
prompt ===========================
prompt
create table T_C13_3_BCHY
(
  hth VARCHAR2(100)
)
;

prompt
prompt Creating table T_CISP_COMMENTS_CONFIG
prompt =====================================
prompt
create table T_CISP_COMMENTS_CONFIG
(
  p001 VARCHAR2(30) not null,
  p002 VARCHAR2(1000),
  a003 VARCHAR2(16),
  a004 VARCHAR2(128),
  flag VARCHAR2(1) default 0
)
;
comment on table T_CISP_COMMENTS_CONFIG
  is '̨,ݱ,޸ֶñ';
comment on column T_CISP_COMMENTS_CONFIG.p001
  is 'id';
comment on column T_CISP_COMMENTS_CONFIG.p002
  is '';
comment on column T_CISP_COMMENTS_CONFIG.a003
  is 'ֶ';
comment on column T_CISP_COMMENTS_CONFIG.a004
  is 'ֶ';

prompt
prompt Creating table T_CISP_FORMULA
prompt =============================
prompt
create table T_CISP_FORMULA
(
  p001 VARCHAR2(16) not null,
  p002 VARCHAR2(16),
  a003 NUMBER not null,
  a004 CHAR(1) not null,
  a005 CHAR(1) not null,
  a006 VARCHAR2(4000) not null,
  a007 VARCHAR2(4000),
  a008 VARCHAR2(8),
  a009 CHAR(1),
  a010 VARCHAR2(4000) not null,
  a011 VARCHAR2(128),
  a012 NUMBER default 1001101 not null,
  p003 VARCHAR2(16)
)
;
comment on table T_CISP_FORMULA
  is 'ϵͳʽñ';
comment on column T_CISP_FORMULA.p001
  is '';
comment on column T_CISP_FORMULA.p002
  is 'ӱ(ڹΪ)';
comment on column T_CISP_FORMULA.a003
  is 'ID';
comment on column T_CISP_FORMULA.a004
  is 'ʱ(0:1·;1:1·;2:ȫ)';
comment on column T_CISP_FORMULA.a005
  is '(0:Ƚ;1:ֱ;2:)';
comment on column T_CISP_FORMULA.a006
  is '';
comment on column T_CISP_FORMULA.a007
  is 'ӹ(õ)';
comment on column T_CISP_FORMULA.a008
  is 'Ƚ(ֱõ)';
comment on column T_CISP_FORMULA.a009
  is 'С(Ƚõ)';
comment on column T_CISP_FORMULA.a010
  is 'ʾ';
comment on column T_CISP_FORMULA.a011
  is '';
comment on column T_CISP_FORMULA.a012
  is 'ʹ״̬( 1001101:Ч;1001102:Ч)';
comment on column T_CISP_FORMULA.p003
  is 'ű';

prompt
prompt Creating table T_CISP_HTWYBS
prompt ============================
prompt
create table T_CISP_HTWYBS
(
  contract_id VARCHAR2(20),
  wybs        VARCHAR2(10)
)
;

prompt
prompt Creating table T_CISP_LOG
prompt =========================
prompt
create table T_CISP_LOG
(
  p001 VARCHAR2(64),
  a002 VARCHAR2(128),
  a003 VARCHAR2(255),
  a004 VARCHAR2(4000),
  a005 DATE,
  a006 VARCHAR2(255),
  flag VARCHAR2(64),
  w100 NUMBER
)
;
comment on table T_CISP_LOG
  is '޸ļ¼־';
comment on column T_CISP_LOG.p001
  is 'id';
comment on column T_CISP_LOG.a002
  is 'ı';
comment on column T_CISP_LOG.a003
  is 'rowid';
comment on column T_CISP_LOG.a004
  is '޸';
comment on column T_CISP_LOG.a005
  is '޸ʱ';
comment on column T_CISP_LOG.a006
  is '޸';
comment on column T_CISP_LOG.flag
  is '1ݱ;  23: ̨ʣ4:';
comment on column T_CISP_LOG.w100
  is 'id';

prompt
prompt Creating table T_CISP_REPT_COUNTERSIGN
prompt ======================================
prompt
create table T_CISP_REPT_COUNTERSIGN
(
  reportcode VARCHAR2(64),
  reportdate NUMBER,
  fromuser   VARCHAR2(16),
  touser     VARCHAR2(16),
  tips       VARCHAR2(1024),
  createon   DATE,
  endon      DATE,
  feedback   VARCHAR2(1024),
  step       NUMBER,
  id         NUMBER not null
)
;
comment on column T_CISP_REPT_COUNTERSIGN.reportcode
  is '';
comment on column T_CISP_REPT_COUNTERSIGN.reportdate
  is 'id';
comment on column T_CISP_REPT_COUNTERSIGN.fromuser
  is 'ǩûid';
comment on column T_CISP_REPT_COUNTERSIGN.touser
  is 'ǩûid';
comment on column T_CISP_REPT_COUNTERSIGN.tips
  is 'ǩʾ';
comment on column T_CISP_REPT_COUNTERSIGN.createon
  is 'ǩʱ';
comment on column T_CISP_REPT_COUNTERSIGN.endon
  is 'ǩʱ';
comment on column T_CISP_REPT_COUNTERSIGN.feedback
  is 'ǩ';
comment on column T_CISP_REPT_COUNTERSIGN.step
  is '˲id';
comment on column T_CISP_REPT_COUNTERSIGN.id
  is 'ǩid';
alter table T_CISP_REPT_COUNTERSIGN
  add constraint PK primary key (ID);

prompt
prompt Creating table T_CSRC0120_B1_1
prompt ==============================
prompt
create table T_CSRC0120_B1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  g13     NUMBER(19,2),
  h13     NUMBER(19,2),
  c14     NUMBER(19,2),
  d14     NUMBER(19,2),
  g14     NUMBER(19,2),
  h14     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  g15     NUMBER(19,2),
  h15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  g16     NUMBER(19,2),
  h16     NUMBER(19,2),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  g17     NUMBER(19,2),
  h17     NUMBER(19,2),
  c18     NUMBER(19,2),
  d18     NUMBER(19,2),
  g18     NUMBER(19,2),
  h18     NUMBER(19,2),
  c19     NUMBER(19,2),
  d19     NUMBER(19,2),
  g19     NUMBER(19,2),
  h19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  g20     NUMBER(19,2),
  h20     NUMBER(19,2),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  g21     NUMBER(19,2),
  h21     NUMBER(19,2),
  c22     NUMBER(19,2),
  d22     NUMBER(19,2),
  g22     NUMBER(19,2),
  h22     NUMBER(19,2),
  c23     NUMBER(19,2),
  d23     NUMBER(19,2),
  g23     NUMBER(19,2),
  h23     NUMBER(19,2),
  c24     NUMBER(19,2),
  d24     NUMBER(19,2),
  g24     NUMBER(19,2),
  h24     NUMBER(19,2),
  c25     NUMBER(19,2),
  d25     NUMBER(19,2),
  g25     NUMBER(19,2),
  h25     NUMBER(19,2),
  c26     NUMBER(19,2),
  d26     NUMBER(19,2),
  g26     NUMBER(19,2),
  h26     NUMBER(19,2),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  g27     NUMBER(19,2),
  h27     NUMBER(19,2),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  g28     NUMBER(19,2),
  h28     NUMBER(19,2),
  c29     NUMBER(19,2),
  d29     NUMBER(19,2),
  g29     NUMBER(19,2),
  h29     NUMBER(19,2),
  c30     NUMBER(19,2),
  d30     NUMBER(19,2),
  g30     NUMBER(19,2),
  h30     NUMBER(19,2),
  c31     NUMBER(19,2),
  d31     NUMBER(19,2),
  c32     NUMBER(19,2),
  d32     NUMBER(19,2),
  g32     NUMBER(19,2),
  h32     NUMBER(19,2),
  c33     NUMBER(19,2),
  d33     NUMBER(19,2),
  g33     NUMBER(19,2),
  h33     NUMBER(19,2),
  c34     NUMBER(19,2),
  d34     NUMBER(19,2),
  g34     NUMBER(19,2),
  h34     NUMBER(19,2),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  g35     NUMBER(19,2),
  h35     NUMBER(19,2),
  c36     NUMBER(19,2),
  d36     NUMBER(19,2),
  g36     NUMBER(19,2),
  h36     NUMBER(19,2),
  c37     NUMBER(19,2),
  d37     NUMBER(19,2),
  g37     NUMBER(19,2),
  h37     NUMBER(19,2),
  c38     NUMBER(19,2),
  d38     NUMBER(19,2),
  g38     NUMBER(19,2),
  h38     NUMBER(19,2),
  c39     NUMBER(19,2),
  d39     NUMBER(19,2),
  g39     NUMBER(19,2),
  h39     NUMBER(19,2),
  g40     NUMBER(19,2),
  h40     NUMBER(19,2),
  g41     NUMBER(19,2),
  h41     NUMBER(19,2),
  c43     NUMBER(19,2),
  d43     NUMBER(19,2),
  g43     NUMBER(19,2),
  h43     NUMBER(19,2),
  c47     NUMBER(19,2),
  d47     NUMBER(19,2),
  g47     NUMBER(19,2),
  h47     NUMBER(19,2),
  c48     NUMBER(19,2),
  d48     NUMBER(19,2),
  g48     NUMBER(19,2),
  h48     NUMBER(19,2),
  c49     NUMBER(19,2),
  d49     NUMBER(19,2),
  c50     NUMBER(19,2),
  d50     NUMBER(19,2),
  g50     NUMBER(19,2),
  h50     NUMBER(19,2),
  c51     NUMBER(19,2),
  d51     NUMBER(19,2),
  g51     NUMBER(19,2),
  h51     NUMBER(19,2),
  c52     NUMBER(19,2),
  d52     NUMBER(19,2),
  g52     NUMBER(19,2),
  h52     NUMBER(19,2),
  c53     NUMBER(19,2),
  d53     NUMBER(19,2),
  c54     NUMBER(19,2),
  d54     NUMBER(19,2),
  g54     NUMBER(19,2),
  h54     NUMBER(19,2),
  c55     NUMBER(19,2),
  d55     NUMBER(19,2),
  g55     NUMBER(19,2),
  h55     NUMBER(19,2),
  c56     NUMBER(19,2),
  d56     NUMBER(19,2),
  g56     NUMBER(19,2),
  h56     NUMBER(19,2),
  c58     NUMBER(19,2),
  d58     NUMBER(19,2),
  g58     NUMBER(19,2),
  h58     NUMBER(19,2),
  c59     NUMBER(19,2),
  d59     NUMBER(19,2),
  g59     NUMBER(19,2),
  h59     NUMBER(19,2),
  c60     NUMBER(19,2),
  d60     NUMBER(19,2),
  c61     NUMBER(19,2),
  d61     NUMBER(19,2),
  c62     NUMBER(19,2),
  d62     NUMBER(19,2)
)
;

prompt
prompt Creating table T_CSRC0120_B2_1
prompt ==============================
prompt
create table T_CSRC0120_B2_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  c14     NUMBER(19,2),
  d14     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  c18     NUMBER(19,2),
  d18     NUMBER(19,2),
  c19     NUMBER(19,2),
  d19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  c22     NUMBER(19,2),
  d22     NUMBER(19,2),
  c23     NUMBER(19,2),
  d23     NUMBER(19,2),
  c24     NUMBER(19,2),
  d24     NUMBER(19,2),
  c25     NUMBER(19,2),
  d25     NUMBER(19,2),
  c26     NUMBER(19,2),
  d26     NUMBER(19,2),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  c29     NUMBER(19,2),
  d29     NUMBER(19,2),
  c30     NUMBER(19,2),
  d30     NUMBER(19,2),
  c31     NUMBER(19,2),
  d31     NUMBER(19,2),
  c32     NUMBER(19,2),
  d32     NUMBER(19,2),
  c33     NUMBER(19,2),
  d33     NUMBER(19,2),
  c34     NUMBER(19,2),
  d34     NUMBER(19,2),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  c36     NUMBER(19,2),
  d36     NUMBER(19,2),
  c37     NUMBER(19,2),
  d37     NUMBER(19,2),
  c38     NUMBER(19,2),
  d38     NUMBER(19,2),
  c39     NUMBER(19,2),
  d39     NUMBER(19,2),
  c40     NUMBER(19,2),
  d40     NUMBER(19,2),
  c41     NUMBER(19,2),
  d41     NUMBER(19,2),
  c42     NUMBER(19,2),
  d42     NUMBER(19,2),
  c43     NUMBER(19,2),
  d43     NUMBER(19,2),
  c44     NUMBER(19,2),
  d44     NUMBER(19,2),
  c45     NUMBER(19,2),
  d45     NUMBER(19,2),
  c46     NUMBER(19,2),
  d46     NUMBER(19,2),
  c47     NUMBER(19,2),
  d47     NUMBER(19,2),
  c48     NUMBER(19,2),
  d48     NUMBER(19,2),
  c49     NUMBER(19,2),
  d49     NUMBER(19,2),
  c50     NUMBER(19,2),
  d50     NUMBER(19,2),
  c51     NUMBER(19,2),
  d51     NUMBER(19,2),
  c52     NUMBER(19,2),
  d52     NUMBER(19,2),
  c53     NUMBER(19,2),
  d53     NUMBER(19,2),
  c54     NUMBER(19,2),
  d54     NUMBER(19,2),
  c55     NUMBER(19,2),
  d55     NUMBER(19,2),
  c56     NUMBER(19,2),
  d56     NUMBER(19,2),
  c57     NUMBER(19,2),
  d57     NUMBER(19,2),
  c58     NUMBER(19,2),
  d58     NUMBER(19,2),
  c59     NUMBER(19,2),
  d59     NUMBER(19,2),
  c60     NUMBER(19,2),
  d60     NUMBER(19,2),
  c61     NUMBER(19,2),
  d61     NUMBER(19,2),
  c62     NUMBER(19,2),
  d62     NUMBER(19,2),
  c63     NUMBER(19,2),
  d63     NUMBER(19,2),
  c66     NUMBER(19,2),
  d66     NUMBER(19,2),
  c67     NUMBER(19,2),
  d67     NUMBER(19,2),
  c68     NUMBER(19,2),
  d68     NUMBER(19,2)
)
;

prompt
prompt Creating table T_CSRC0120_Z_B1_1
prompt ================================
prompt
create table T_CSRC0120_Z_B1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  g13     NUMBER(19,2),
  h13     NUMBER(19,2),
  c14     NUMBER(19,2),
  d14     NUMBER(19,2),
  g14     NUMBER(19,2),
  h14     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  g15     NUMBER(19,2),
  h15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  g16     NUMBER(19,2),
  h16     NUMBER(19,2),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  g17     NUMBER(19,2),
  h17     NUMBER(19,2),
  c18     NUMBER(19,2),
  d18     NUMBER(19,2),
  g18     NUMBER(19,2),
  h18     NUMBER(19,2),
  c19     NUMBER(19,2),
  d19     NUMBER(19,2),
  g19     NUMBER(19,2),
  h19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  g20     NUMBER(19,2),
  h20     NUMBER(19,2),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  g21     NUMBER(19,2),
  h21     NUMBER(19,2),
  c22     NUMBER(19,2),
  d22     NUMBER(19,2),
  g22     NUMBER(19,2),
  h22     NUMBER(19,2),
  c23     NUMBER(19,2),
  d23     NUMBER(19,2),
  g23     NUMBER(19,2),
  h23     NUMBER(19,2),
  c24     NUMBER(19,2),
  d24     NUMBER(19,2),
  g24     NUMBER(19,2),
  h24     NUMBER(19,2),
  c25     NUMBER(19,2),
  d25     NUMBER(19,2),
  g25     NUMBER(19,2),
  h25     NUMBER(19,2),
  c26     NUMBER(19,2),
  d26     NUMBER(19,2),
  g26     NUMBER(19,2),
  h26     NUMBER(19,2),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  g27     NUMBER(19,2),
  h27     NUMBER(19,2),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  g28     NUMBER(19,2),
  h28     NUMBER(19,2),
  c29     NUMBER(19,2),
  d29     NUMBER(19,2),
  g29     NUMBER(19,2),
  h29     NUMBER(19,2),
  c30     NUMBER(19,2),
  d30     NUMBER(19,2),
  g30     NUMBER(19,2),
  h30     NUMBER(19,2),
  c31     NUMBER(19,2),
  d31     NUMBER(19,2),
  c32     NUMBER(19,2),
  d32     NUMBER(19,2),
  g32     NUMBER(19,2),
  h32     NUMBER(19,2),
  c33     NUMBER(19,2),
  d33     NUMBER(19,2),
  g33     NUMBER(19,2),
  h33     NUMBER(19,2),
  c34     NUMBER(19,2),
  d34     NUMBER(19,2),
  g34     NUMBER(19,2),
  h34     NUMBER(19,2),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  g35     NUMBER(19,2),
  h35     NUMBER(19,2),
  c36     NUMBER(19,2),
  d36     NUMBER(19,2),
  g36     NUMBER(19,2),
  h36     NUMBER(19,2),
  c37     NUMBER(19,2),
  d37     NUMBER(19,2),
  g37     NUMBER(19,2),
  h37     NUMBER(19,2),
  c38     NUMBER(19,2),
  d38     NUMBER(19,2),
  g38     NUMBER(19,2),
  h38     NUMBER(19,2),
  c39     NUMBER(19,2),
  d39     NUMBER(19,2),
  g39     NUMBER(19,2),
  h39     NUMBER(19,2),
  g40     NUMBER(19,2),
  h40     NUMBER(19,2),
  g41     NUMBER(19,2),
  h41     NUMBER(19,2),
  g42     NUMBER(19,2),
  h42     NUMBER(19,2),
  g43     NUMBER(19,2),
  h43     NUMBER(19,2),
  c45     NUMBER(19,2),
  d45     NUMBER(19,2),
  g45     NUMBER(19,2),
  h45     NUMBER(19,2)
)
;

prompt
prompt Creating table T_CSRC0120_Z_B2_1
prompt ================================
prompt
create table T_CSRC0120_Z_B2_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  c14     NUMBER(19,2),
  d14     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  c18     NUMBER(19,2),
  d18     NUMBER(19,2),
  c19     NUMBER(19,2),
  d19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  c22     NUMBER(19,2),
  d22     NUMBER(19,2),
  c23     NUMBER(19,2),
  d23     NUMBER(19,2),
  c24     NUMBER(19,2),
  d24     NUMBER(19,2),
  c25     NUMBER(19,2),
  d25     NUMBER(19,2),
  c26     NUMBER(19,2),
  d26     NUMBER(19,2),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  c29     NUMBER(19,2),
  d29     NUMBER(19,2),
  c30     NUMBER(19,2),
  d30     NUMBER(19,2),
  c31     NUMBER(19,2),
  d31     NUMBER(19,2),
  c32     NUMBER(19,2),
  d32     NUMBER(19,2),
  c33     NUMBER(19,2),
  d33     NUMBER(19,2),
  c34     NUMBER(19,2),
  d34     NUMBER(19,2),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  c36     NUMBER(19,2),
  d36     NUMBER(19,2),
  c37     NUMBER(19,2),
  d37     NUMBER(19,2),
  c38     NUMBER(19,2),
  d38     NUMBER(19,2),
  c39     NUMBER(19,2),
  d39     NUMBER(19,2),
  c40     NUMBER(19,2),
  d40     NUMBER(19,2),
  c41     NUMBER(19,2),
  d41     NUMBER(19,2),
  c42     NUMBER(19,2),
  d42     NUMBER(19,2),
  c43     NUMBER(19,2),
  d43     NUMBER(19,2),
  c44     NUMBER(19,2),
  d44     NUMBER(19,2),
  c45     NUMBER(19,2),
  d45     NUMBER(19,2),
  c46     NUMBER(19,2),
  d46     NUMBER(19,2),
  c47     NUMBER(19,2),
  d47     NUMBER(19,2),
  c48     NUMBER(19,2),
  d48     NUMBER(19,2),
  c49     NUMBER(19,2),
  d49     NUMBER(19,2),
  c50     NUMBER(19,2),
  d50     NUMBER(19,2),
  c51     NUMBER(19,2),
  d51     NUMBER(19,2),
  c52     NUMBER(19,2),
  d52     NUMBER(19,2),
  c53     NUMBER(19,2),
  d53     NUMBER(19,2),
  c54     NUMBER(19,2),
  d54     NUMBER(19,2),
  c55     NUMBER(19,2),
  d55     NUMBER(19,2),
  c56     NUMBER(19,2),
  d56     NUMBER(19,2),
  c57     NUMBER(19,2),
  d57     NUMBER(19,2),
  c58     NUMBER(19,2),
  d58     NUMBER(19,2),
  c59     NUMBER(19,2),
  d59     NUMBER(19,2),
  c60     NUMBER(19,2),
  d60     NUMBER(19,2),
  c61     NUMBER(19,2),
  d61     NUMBER(19,2),
  c62     NUMBER(19,2),
  d62     NUMBER(19,2),
  c63     NUMBER(19,2),
  d63     NUMBER(19,2),
  c64     NUMBER(19,2),
  d64     NUMBER(19,2),
  c65     NUMBER(19,2),
  d65     NUMBER(19,2),
  c66     NUMBER(19,2),
  d66     NUMBER(19,2),
  c67     NUMBER(19,2),
  d67     NUMBER(19,2),
  c68     NUMBER(19,2),
  d68     NUMBER(19,2),
  c69     NUMBER(19,2),
  d69     NUMBER(19,2),
  c70     NUMBER(19,2),
  d70     NUMBER(19,2),
  c71     NUMBER(19,2),
  d71     NUMBER(19,2),
  c74     NUMBER(19,2),
  d74     NUMBER(19,2),
  c75     NUMBER(19,2),
  d75     NUMBER(19,2),
  c76     NUMBER(19,2),
  d76     NUMBER(19,2)
)
;

prompt
prompt Creating table T_CSRC0128_C4_1
prompt ==============================
prompt
create table T_CSRC0128_C4_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(100),
  c3      VARCHAR2(30),
  d3      VARCHAR2(30),
  e3      DATE,
  f3      VARCHAR2(100),
  g3      VARCHAR2(100),
  h3      VARCHAR2(100),
  i3      VARCHAR2(100),
  j3      NUMBER(18,2),
  k3      NUMBER(18,2),
  l3      NUMBER(18,2),
  m3      NUMBER(18),
  n3      NUMBER(18),
  o3      NUMBER(18),
  p3      NUMBER(18,2),
  q3      NUMBER(18,2),
  r3      NUMBER(18,2),
  s3      NUMBER(18,2),
  t3      NUMBER(18,2),
  u3      NUMBER(18,2),
  v3      NUMBER(18,2),
  w3      NUMBER(18,2),
  x3      NUMBER(18,4),
  y3      NUMBER(18,4),
  z3      NUMBER(18,4),
  aa3     NUMBER(18,4)
)
;

prompt
prompt Creating table T_CSRC0128_C4_2
prompt ==============================
prompt
create table T_CSRC0128_C4_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      VARCHAR2(60),
  b3      VARCHAR2(150),
  c3      NUMBER(18,2),
  d3      VARCHAR2(100),
  e3      VARCHAR2(100),
  f3      DATE,
  g3      DATE,
  h3      NUMBER(18,2),
  i3      NUMBER(18),
  j3      NUMBER(18),
  k3      NUMBER(18),
  l3      VARCHAR2(100),
  m3      VARCHAR2(100),
  n3      VARCHAR2(100),
  o3      VARCHAR2(100),
  p3      NUMBER(18),
  q3      NUMBER(18,2),
  r3      NUMBER(18,2),
  s3      NUMBER(18,2),
  t3      NUMBER(18,2),
  u3      NUMBER(18,2),
  v3      NUMBER(18,2),
  w3      NUMBER(18,2),
  x3      NUMBER(18,2),
  y3      NUMBER(18,2),
  z3      NUMBER(18,2),
  aa3     NUMBER(18,2),
  ab3     NUMBER(18,2),
  ac3     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0128_C4_3
prompt ==============================
prompt
create table T_CSRC0128_C4_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b3      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18,2),
  g3      NUMBER(18,2),
  h3      NUMBER(18,2),
  i3      NUMBER(18,2),
  b4      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18,2),
  g4      NUMBER(18,2),
  h4      NUMBER(18,2),
  i4      NUMBER(18,2),
  b5      NUMBER(18),
  c5      NUMBER(18),
  d5      NUMBER(18),
  e5      NUMBER(18),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  h5      NUMBER(18,2),
  i5      NUMBER(18,2),
  b6      NUMBER(18),
  c6      NUMBER(18),
  d6      NUMBER(18),
  e6      NUMBER(18),
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  h6      NUMBER(18,2),
  i6      NUMBER(18,2),
  b7      NUMBER(18),
  c7      NUMBER(18),
  d7      NUMBER(18),
  e7      NUMBER(18),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  h7      NUMBER(18,2),
  i7      NUMBER(18,2),
  b8      NUMBER(18),
  c8      NUMBER(18),
  d8      NUMBER(18),
  e8      NUMBER(18),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  h8      NUMBER(18,2),
  i8      NUMBER(18,2),
  b9      NUMBER(18),
  c9      NUMBER(18),
  d9      NUMBER(18),
  e9      NUMBER(18),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  h9      NUMBER(18,2),
  i9      NUMBER(18,2),
  b10     NUMBER(18),
  c10     NUMBER(18),
  d10     NUMBER(18),
  e10     NUMBER(18),
  f10     NUMBER(18,2),
  g10     NUMBER(18,2),
  h10     NUMBER(18,2),
  i10     NUMBER(18,2),
  b11     NUMBER(18),
  c11     NUMBER(18),
  d11     NUMBER(18),
  e11     NUMBER(18),
  f11     NUMBER(18,2),
  g11     NUMBER(18,2),
  h11     NUMBER(18,2),
  i11     NUMBER(18,2),
  b12     NUMBER(18),
  c12     NUMBER(18),
  d12     NUMBER(18),
  e12     NUMBER(18),
  f12     NUMBER(18,2),
  g12     NUMBER(18,2),
  h12     NUMBER(18,2),
  i12     NUMBER(18,2),
  b14     VARCHAR2(50),
  e14     VARCHAR2(50),
  h14     VARCHAR2(50),
  b15     VARCHAR2(50),
  e15     VARCHAR2(50),
  h15     VARCHAR2(50),
  b16     VARCHAR2(50),
  e16     VARCHAR2(50),
  h16     VARCHAR2(50),
  b17     VARCHAR2(50),
  e17     VARCHAR2(50),
  h17     VARCHAR2(50)
)
;

prompt
prompt Creating table T_CSRC0128_E1_3_1
prompt ================================
prompt
create table T_CSRC0128_E1_3_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  e6      NUMBER(18,2),
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  h6      NUMBER(18,2),
  i6      NUMBER(18,2),
  j6      NUMBER(18,2),
  k6      NUMBER(18,2),
  l6      NUMBER(18,2),
  m6      NUMBER(18,2),
  n6      NUMBER(18,2),
  o6      NUMBER(18,2),
  p6      NUMBER(18,2),
  q6      NUMBER(18,2),
  r6      NUMBER(18,2),
  s6      NUMBER(18,2),
  t6      NUMBER(18,2),
  u6      NUMBER(18,2),
  v6      NUMBER(18,2),
  w6      NUMBER(18,2),
  x6      NUMBER(18,2),
  y6      VARCHAR2(200),
  z6      NUMBER(18,2),
  aa6     NUMBER(18,2),
  ab6     NUMBER(18,2),
  ac6     VARCHAR2(200),
  ad6     NUMBER(18,2),
  ae6     NUMBER(18,2),
  af6     NUMBER(18,2),
  ag6     NUMBER(18,2),
  ah6     NUMBER(18,2),
  ai6     NUMBER(18,2),
  aj6     NUMBER(18,2),
  ak6     NUMBER(18,2),
  al6     NUMBER(18,2),
  am6     NUMBER(18,2),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  e7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  h7      NUMBER(18,2),
  i7      NUMBER(18,2),
  j7      NUMBER(18,2),
  k7      NUMBER(18,2),
  l7      NUMBER(18,2),
  m7      NUMBER(18,2),
  n7      NUMBER(18,2),
  o7      NUMBER(18,2),
  p7      NUMBER(18,2),
  q7      NUMBER(18,2),
  r7      NUMBER(18,2),
  s7      NUMBER(18,2),
  t7      NUMBER(18,2),
  u7      NUMBER(18,2),
  v7      NUMBER(18,2),
  w7      NUMBER(18,2),
  x7      NUMBER(18,2),
  y7      VARCHAR2(200),
  z7      NUMBER(18,2),
  aa7     NUMBER(18,2),
  ab7     NUMBER(18,2),
  ac7     VARCHAR2(200),
  ad7     NUMBER(18,2),
  ae7     NUMBER(18,2),
  af7     NUMBER(18,2),
  ag7     NUMBER(18,2),
  ah7     NUMBER(18,2),
  ai7     NUMBER(18,2),
  aj7     NUMBER(18,2),
  ak7     NUMBER(18,2),
  al7     NUMBER(18,2),
  am7     NUMBER(18,2),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  e8      NUMBER(18,2),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  h8      NUMBER(18,2),
  i8      NUMBER(18,2),
  j8      NUMBER(18,2),
  k8      NUMBER(18,2),
  l8      NUMBER(18,2),
  m8      NUMBER(18,2),
  n8      NUMBER(18,2),
  o8      NUMBER(18,2),
  p8      NUMBER(18,2),
  q8      NUMBER(18,2),
  r8      NUMBER(18,2),
  s8      NUMBER(18,2),
  t8      NUMBER(18,2),
  u8      NUMBER(18,2),
  v8      NUMBER(18,2),
  w8      NUMBER(18,2),
  x8      NUMBER(18,2),
  y8      VARCHAR2(200),
  z8      NUMBER(18,2),
  aa8     NUMBER(18,2),
  ab8     NUMBER(18,2),
  ac8     VARCHAR2(200),
  ad8     NUMBER(18,2),
  ae8     NUMBER(18,2),
  af8     NUMBER(18,2),
  ag8     NUMBER(18,2),
  ah8     NUMBER(18,2),
  ai8     NUMBER(18,2),
  aj8     NUMBER(18,2),
  ak8     NUMBER(18,2),
  al8     NUMBER(18,2),
  am8     NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  h9      NUMBER(18,2),
  i9      NUMBER(18,2),
  j9      NUMBER(18,2),
  k9      NUMBER(18,2),
  l9      NUMBER(18,2),
  m9      NUMBER(18,2),
  n9      NUMBER(18,2),
  o9      NUMBER(18,2),
  p9      NUMBER(18,2),
  q9      NUMBER(18,2),
  r9      NUMBER(18,2),
  s9      NUMBER(18,2),
  t9      NUMBER(18,2),
  u9      NUMBER(18,2),
  v9      NUMBER(18,2),
  w9      NUMBER(18,2),
  x9      NUMBER(18,2),
  y9      VARCHAR2(200),
  z9      NUMBER(18,2),
  aa9     NUMBER(18,2),
  ab9     NUMBER(18,2),
  ac9     VARCHAR2(200),
  ad9     NUMBER(18,2),
  ae9     NUMBER(18,2),
  af9     NUMBER(18,2),
  ag9     NUMBER(18,2),
  ah9     NUMBER(18,2),
  ai9     NUMBER(18,2),
  aj9     NUMBER(18,2),
  ak9     NUMBER(18,2),
  al9     NUMBER(18,2),
  am9     NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  g10     NUMBER(18,2),
  h10     NUMBER(18,2),
  i10     NUMBER(18,2),
  j10     NUMBER(18,2),
  k10     NUMBER(18,2),
  l10     NUMBER(18,2),
  m10     NUMBER(18,2),
  n10     NUMBER(18,2),
  o10     NUMBER(18,2),
  p10     NUMBER(18,2),
  q10     NUMBER(18,2),
  r10     NUMBER(18,2),
  s10     NUMBER(18,2),
  t10     NUMBER(18,2),
  u10     NUMBER(18,2),
  v10     NUMBER(18,2),
  w10     NUMBER(18,2),
  x10     NUMBER(18,2),
  y10     VARCHAR2(200),
  z10     NUMBER(18,2),
  aa10    NUMBER(18,2),
  ab10    NUMBER(18,2),
  ac10    VARCHAR2(200),
  ad10    NUMBER(18,2),
  ae10    NUMBER(18,2),
  af10    NUMBER(18,2),
  ag10    NUMBER(18,2),
  ah10    NUMBER(18,2),
  ai10    NUMBER(18,2),
  aj10    NUMBER(18,2),
  ak10    NUMBER(18,2),
  al10    NUMBER(18,2),
  am10    NUMBER(18,2),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  e11     NUMBER(18,2),
  f11     NUMBER(18,2),
  g11     NUMBER(18,2),
  h11     NUMBER(18,2),
  i11     NUMBER(18,2),
  j11     NUMBER(18,2),
  k11     NUMBER(18,2),
  l11     NUMBER(18,2),
  m11     NUMBER(18,2),
  n11     NUMBER(18,2),
  o11     NUMBER(18,2),
  p11     NUMBER(18,2),
  q11     NUMBER(18,2),
  r11     NUMBER(18,2),
  s11     NUMBER(18,2),
  t11     NUMBER(18,2),
  u11     NUMBER(18,2),
  v11     NUMBER(18,2),
  w11     NUMBER(18,2),
  x11     NUMBER(18,2),
  y11     VARCHAR2(200),
  z11     NUMBER(18,2),
  aa11    NUMBER(18,2),
  ab11    NUMBER(18,2),
  ac11    VARCHAR2(200),
  ad11    NUMBER(18,2),
  ae11    NUMBER(18,2),
  af11    NUMBER(18,2),
  ag11    NUMBER(18,2),
  ah11    NUMBER(18,2),
  ai11    NUMBER(18,2),
  aj11    NUMBER(18,2),
  ak11    NUMBER(18,2),
  al11    NUMBER(18,2),
  am11    NUMBER(18,2),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  e12     NUMBER(18,2),
  f12     NUMBER(18,2),
  g12     NUMBER(18,2),
  h12     NUMBER(18,2),
  i12     NUMBER(18,2),
  j12     NUMBER(18,2),
  k12     NUMBER(18,2),
  l12     NUMBER(18,2),
  m12     NUMBER(18,2),
  n12     NUMBER(18,2),
  o12     NUMBER(18,2),
  p12     NUMBER(18,2),
  q12     NUMBER(18,2),
  r12     NUMBER(18,2),
  s12     NUMBER(18,2),
  t12     NUMBER(18,2),
  u12     NUMBER(18,2),
  v12     NUMBER(18,2),
  w12     NUMBER(18,2),
  x12     NUMBER(18,2),
  y12     VARCHAR2(200),
  z12     NUMBER(18,2),
  aa12    NUMBER(18,2),
  ab12    NUMBER(18,2),
  ac12    VARCHAR2(200),
  ad12    NUMBER(18,2),
  ae12    NUMBER(18,2),
  af12    NUMBER(18,2),
  ag12    NUMBER(18,2),
  ah12    NUMBER(18,2),
  ai12    NUMBER(18,2),
  aj12    NUMBER(18,2),
  ak12    NUMBER(18,2),
  al12    NUMBER(18,2),
  am12    NUMBER(18,2),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  e13     NUMBER(18,2),
  f13     NUMBER(18,2),
  g13     NUMBER(18,2),
  h13     NUMBER(18,2),
  i13     NUMBER(18,2),
  j13     NUMBER(18,2),
  k13     NUMBER(18,2),
  l13     NUMBER(18,2),
  m13     NUMBER(18,2),
  n13     NUMBER(18,2),
  o13     NUMBER(18,2),
  p13     NUMBER(18,2),
  q13     NUMBER(18,2),
  r13     NUMBER(18,2),
  s13     NUMBER(18,2),
  t13     NUMBER(18,2),
  u13     NUMBER(18,2),
  v13     NUMBER(18,2),
  w13     NUMBER(18,2),
  x13     NUMBER(18,2),
  y13     VARCHAR2(200),
  z13     NUMBER(18,2),
  aa13    NUMBER(18,2),
  ab13    NUMBER(18,2),
  ac13    VARCHAR2(200),
  ad13    NUMBER(18,2),
  ae13    NUMBER(18,2),
  af13    NUMBER(18,2),
  ag13    NUMBER(18,2),
  ah13    NUMBER(18,2),
  ai13    NUMBER(18,2),
  aj13    NUMBER(18,2),
  ak13    NUMBER(18,2),
  al13    NUMBER(18,2),
  am13    NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  e14     NUMBER(18,2),
  f14     NUMBER(18,2),
  g14     NUMBER(18,2),
  h14     NUMBER(18,2),
  i14     NUMBER(18,2),
  j14     NUMBER(18,2),
  k14     NUMBER(18,2),
  l14     NUMBER(18,2),
  m14     NUMBER(18,2),
  n14     NUMBER(18,2),
  o14     NUMBER(18,2),
  p14     NUMBER(18,2),
  q14     NUMBER(18,2),
  r14     NUMBER(18,2),
  s14     NUMBER(18,2),
  t14     NUMBER(18,2),
  u14     NUMBER(18,2),
  v14     NUMBER(18,2),
  w14     NUMBER(18,2),
  x14     NUMBER(18,2),
  y14     VARCHAR2(200),
  z14     NUMBER(18,2),
  aa14    NUMBER(18,2),
  ab14    NUMBER(18,2),
  ac14    VARCHAR2(200),
  ad14    NUMBER(18,2),
  ae14    NUMBER(18,2),
  af14    NUMBER(18,2),
  ag14    NUMBER(18,2),
  ah14    NUMBER(18,2),
  ai14    NUMBER(18,2),
  aj14    NUMBER(18,2),
  ak14    NUMBER(18,2),
  al14    NUMBER(18,2),
  am14    NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  e15     NUMBER(18,2),
  f15     NUMBER(18,2),
  g15     NUMBER(18,2),
  h15     NUMBER(18,2),
  i15     NUMBER(18,2),
  j15     NUMBER(18,2),
  k15     NUMBER(18,2),
  l15     NUMBER(18,2),
  m15     NUMBER(18,2),
  n15     NUMBER(18,2),
  o15     NUMBER(18,2),
  p15     NUMBER(18,2),
  q15     NUMBER(18,2),
  r15     NUMBER(18,2),
  s15     NUMBER(18,2),
  t15     NUMBER(18,2),
  u15     NUMBER(18,2),
  v15     NUMBER(18,2),
  w15     NUMBER(18,2),
  x15     NUMBER(18,2),
  z15     NUMBER(18,2),
  aa15    NUMBER(18,2),
  ab15    NUMBER(18,2),
  ad15    NUMBER(18,2),
  ae15    NUMBER(18,2),
  af15    NUMBER(18,2),
  ag15    NUMBER(18,2),
  ah15    NUMBER(18,2),
  ai15    NUMBER(18,2),
  aj15    NUMBER(18,2),
  ak15    NUMBER(18,2),
  al15    NUMBER(18,2),
  am15    NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC0128_E1_3_2
prompt ================================
prompt
create table T_CSRC0128_E1_3_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a5      NUMBER(12),
  b5      VARCHAR2(255),
  c5      VARCHAR2(50),
  d5      VARCHAR2(50),
  e5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  h5      NUMBER(18,2),
  i5      NUMBER(18,2),
  j5      NUMBER(18,2),
  k5      NUMBER(18,2),
  l5      NUMBER(18,2),
  m5      NUMBER(18,2),
  n5      NUMBER(18,2),
  o5      NUMBER(18,2),
  p5      NUMBER(18,2),
  q5      NUMBER(18,2),
  r5      NUMBER(18,2),
  s5      NUMBER(18,2),
  t5      NUMBER(18,2),
  u5      NUMBER(18,2),
  v5      NUMBER(18,2),
  w5      NUMBER(18,2),
  x5      VARCHAR2(255),
  y5      NUMBER(18,2),
  z5      NUMBER(18,2),
  aa5     NUMBER(18,2),
  ab5     NUMBER(18,2),
  ac5     NUMBER(18,2),
  ad5     NUMBER(18,2),
  ae5     NUMBER(18,2),
  af5     NUMBER(18,2),
  ag5     NUMBER(18,2),
  ah5     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC0128_E1_3_3
prompt ================================
prompt
create table T_CSRC0128_E1_3_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a5      NUMBER(12),
  b5      VARCHAR2(255),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  e5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  h5      NUMBER(18,2),
  i5      NUMBER(18,2),
  j5      NUMBER(18,2),
  k5      NUMBER(18,2),
  l5      NUMBER(18,2),
  m5      NUMBER(18,2),
  n5      NUMBER(18,2),
  o5      NUMBER(18,2),
  p5      NUMBER(18,2),
  q5      NUMBER(18,2),
  r5      NUMBER(18,2),
  s5      NUMBER(18,2),
  t5      NUMBER(18,2),
  u5      VARCHAR2(255),
  v5      NUMBER(18,2),
  w5      NUMBER(18,2),
  x5      NUMBER(18,2),
  y5      VARCHAR2(255),
  z5      NUMBER(18,2),
  aa5     NUMBER(18,2),
  ab5     NUMBER(18,2),
  ac5     NUMBER(18,2),
  ad5     NUMBER(18,2),
  ae5     NUMBER(18,2),
  af5     NUMBER(18,2),
  ag5     NUMBER(18,2),
  ah5     NUMBER(18,2),
  ai5     NUMBER(18,2)
)
;
comment on table T_CSRC0128_E1_3_3
  is 'ʲҵͶʼʲüܱ--רҵ';

prompt
prompt Creating table T_CSRC0225_G_1
prompt =============================
prompt
create table T_CSRC0225_G_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      VARCHAR2(100),
  b3      VARCHAR2(100),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  g3      NUMBER(18,2),
  h3      NUMBER(18),
  i3      NUMBER(18,2),
  j3      NUMBER(18),
  k3      NUMBER(18,2),
  l3      NUMBER(18,2),
  m3      NUMBER(18,2),
  n3      NUMBER(18),
  o3      NUMBER(18),
  p3      NUMBER(18),
  q3      NUMBER(18),
  r3      NUMBER(18,2),
  s3      NUMBER(18),
  t3      NUMBER(18)
)
;
comment on table T_CSRC0225_G_1
  is '֤ȯ˾ָڻרܱʲҵ񣨷޶ض';

prompt
prompt Creating table T_CSRC0225_G_2
prompt =============================
prompt
create table T_CSRC0225_G_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(100),
  c3      VARCHAR2(100),
  d3      VARCHAR2(100),
  e3      NUMBER(18),
  f3      NUMBER(18),
  g3      NUMBER(18,2),
  h3      NUMBER(18),
  i3      NUMBER(18,2),
  j3      NUMBER(18),
  k3      NUMBER(18,2),
  l3      NUMBER(18,2),
  m3      NUMBER(18,2),
  n3      NUMBER(18),
  o3      NUMBER(18),
  p3      NUMBER(18),
  q3      NUMBER(18),
  r3      NUMBER(18),
  s3      NUMBER(18,2),
  t3      NUMBER(18),
  u3      NUMBER(18)
)
;
comment on table T_CSRC0225_G_2
  is '֤ȯ˾ָڻרܱʲҵ񣨷޶ض';

prompt
prompt Creating table T_CSRC0225_G_3
prompt =============================
prompt
create table T_CSRC0225_G_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(100),
  c3      VARCHAR2(100),
  d3      VARCHAR2(100),
  e3      NUMBER(18),
  f3      NUMBER(18),
  g3      NUMBER(18,2),
  h3      NUMBER(18),
  i3      NUMBER(18,2),
  j3      NUMBER(18),
  k3      NUMBER(18,2),
  l3      NUMBER(18,2),
  m3      NUMBER(18,2),
  n3      NUMBER(18),
  o3      NUMBER(18),
  p3      NUMBER(18),
  q3      NUMBER(18),
  r3      NUMBER(18),
  s3      NUMBER(18,2),
  t3      NUMBER(18),
  u3      NUMBER(18),
  v3      NUMBER(18)
)
;
comment on table T_CSRC0225_G_3
  is '֤ȯ˾ָڻרܱ޶ضʲҵ';

prompt
prompt Creating table T_CSRC0225_G_4
prompt =============================
prompt
create table T_CSRC0225_G_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(100),
  c3      VARCHAR2(100),
  d3      VARCHAR2(100),
  e3      NUMBER(18),
  f3      NUMBER(18),
  g3      NUMBER(18,2),
  h3      NUMBER(18),
  i3      NUMBER(18,2),
  j3      NUMBER(18),
  k3      NUMBER(18,2),
  l3      NUMBER(18,2),
  m3      NUMBER(18,2),
  n3      NUMBER(18),
  o3      NUMBER(18),
  p3      NUMBER(18),
  q3      NUMBER(18),
  r3      NUMBER(18),
  s3      NUMBER(18,2),
  t3      NUMBER(18),
  u3      NUMBER(18),
  v3      NUMBER(18)
)
;
comment on table T_CSRC0225_G_4
  is '֤ȯ˾ָڻרܱʲҵ';

prompt
prompt Creating table T_CSRC0320_A4_1
prompt ==============================
prompt
create table T_CSRC0320_A4_1
(
  bbq     VARCHAR2(8) not null,
  userid  VARCHAR2(18) not null,
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  c3      NUMBER(19,2),
  e3      NUMBER(19,2),
  c4      NUMBER(19,2),
  e4      NUMBER(19,2),
  c5      NUMBER(19,2),
  e5      NUMBER(19,2),
  c6      NUMBER(19,2),
  e6      NUMBER(19,2),
  c7      NUMBER(19,2),
  e7      NUMBER(19,2),
  c8      NUMBER(19,2),
  e8      NUMBER(19,2),
  c9      NUMBER(19,2),
  e9      NUMBER(19,2),
  c10     NUMBER(19,2),
  e10     NUMBER(19,2),
  c11     NUMBER(19,2),
  e11     NUMBER(19,2),
  c12     NUMBER(19,2),
  e12     NUMBER(19,2),
  c13     NUMBER(19,2),
  e13     NUMBER(19,2),
  c14     NUMBER(19,2),
  e14     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  c18     NUMBER(19,2),
  e18     NUMBER(19,2),
  c19     NUMBER(19,2),
  e19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  c21     NUMBER(19,2),
  e21     NUMBER(19,2),
  c22     NUMBER(19,2),
  e22     NUMBER(19,2),
  c23     NUMBER(19,2),
  e23     NUMBER(19,2),
  c24     NUMBER(19,2),
  e24     NUMBER(19,2),
  c25     NUMBER(19,2),
  e25     NUMBER(19,2),
  c26     NUMBER(19,2),
  e26     NUMBER(19,2),
  c27     NUMBER(19,2),
  e27     NUMBER(19,2),
  c28     NUMBER(19,2),
  e28     NUMBER(19,2),
  c29     NUMBER(19,2),
  e29     NUMBER(19,2),
  c30     NUMBER(19,2),
  e30     NUMBER(19,2),
  c31     NUMBER(19,2),
  e31     NUMBER(19,2),
  c32     NUMBER(19,2),
  e32     NUMBER(19,2),
  c33     NUMBER(19,2),
  e33     NUMBER(19,2),
  c34     NUMBER(19,2),
  e34     NUMBER(19,2),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  e35     NUMBER(19,2),
  c36     NUMBER(19,2),
  d36     NUMBER(19,2),
  e36     NUMBER(19,2),
  c37     NUMBER(19,2),
  e37     NUMBER(19,2),
  c38     NUMBER(19,2),
  e38     NUMBER(19,2),
  c39     NUMBER(19,2),
  e39     NUMBER(19,2),
  c40     NUMBER(19,2),
  d40     NUMBER(19,2),
  e40     NUMBER(19,2),
  c41     NUMBER(19,2),
  d41     NUMBER(19,2),
  e41     NUMBER(19,2),
  c42     NUMBER(19,2),
  e42     NUMBER(19,2),
  c43     NUMBER(19,2),
  e43     NUMBER(19,2),
  c44     NUMBER(19,2),
  e44     NUMBER(19,2),
  c45     NUMBER(19,2),
  e45     NUMBER(19,2),
  c46     NUMBER(19,2),
  e46     NUMBER(19,2),
  c47     NUMBER(19,2),
  d47     NUMBER(19,2),
  e47     NUMBER(19,2),
  c48     NUMBER(19,2),
  d48     NUMBER(19,2),
  e48     NUMBER(19,2),
  c49     NUMBER(19,2),
  e49     NUMBER(19,2),
  c50     NUMBER(19,2),
  e50     NUMBER(19,2),
  c51     NUMBER(19,2),
  e51     NUMBER(19,2),
  c52     NUMBER(19,2),
  d52     NUMBER(19,2),
  e52     NUMBER(19,2),
  c53     NUMBER(19,2),
  d53     NUMBER(19,2),
  e53     NUMBER(19,2),
  c54     NUMBER(19,2),
  e54     NUMBER(19,2),
  c55     NUMBER(19,2),
  e55     NUMBER(19,2),
  c56     NUMBER(19,2),
  e56     NUMBER(19,2),
  c57     NUMBER(19,2),
  d57     NUMBER(19,2),
  e57     NUMBER(19,2),
  c58     NUMBER(19,2),
  d58     NUMBER(19,2),
  e58     NUMBER(19,2),
  c59     NUMBER(19,2),
  e59     NUMBER(19,2),
  c60     NUMBER(19,2),
  d60     NUMBER(19,2),
  e60     NUMBER(19,2),
  c61     NUMBER(19,2),
  d61     NUMBER(19,2),
  e61     NUMBER(19,2),
  c62     NUMBER(19,2),
  e62     NUMBER(19,2),
  c63     NUMBER(19,2),
  d63     NUMBER(19,2),
  e63     NUMBER(19,2),
  c64     NUMBER(19,2),
  d64     NUMBER(19,2),
  e64     NUMBER(19,2),
  c65     NUMBER(19,2),
  d65     NUMBER(19,2),
  e65     NUMBER(19,2),
  c66     NUMBER(19,2),
  e66     NUMBER(19,2),
  c67     NUMBER(19,2),
  e67     NUMBER(19,2),
  c68     NUMBER(19,2),
  e68     NUMBER(19,2),
  c69     NUMBER(19,2),
  e69     NUMBER(19,2),
  c70     NUMBER(19,2),
  e70     NUMBER(19,2),
  c71     NUMBER(19,2),
  d71     NUMBER(19,2),
  e71     NUMBER(19,2),
  c72     NUMBER(19,2),
  d72     NUMBER(19,2),
  e72     NUMBER(19,2),
  c73     NUMBER(19,2),
  e73     NUMBER(19,2),
  c74     NUMBER(19,2),
  e74     NUMBER(19,2),
  c75     NUMBER(19,2),
  d75     NUMBER(19,2),
  e75     NUMBER(19,2),
  c76     NUMBER(19,2),
  e76     NUMBER(19,2),
  c77     NUMBER(19,2),
  e77     NUMBER(19,2),
  c78     NUMBER(19,2),
  d78     NUMBER(19,2),
  e78     NUMBER(19,2),
  c79     NUMBER(19,2),
  d79     NUMBER(19,2),
  e79     NUMBER(19,2),
  e80     NUMBER(19,2)
)
;

prompt
prompt Creating table T_CSRC0320_A4_2
prompt ==============================
prompt
create table T_CSRC0320_A4_2
(
  bbq     VARCHAR2(8) not null,
  userid  VARCHAR2(18) not null,
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  c3      NUMBER(19,2),
  e3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  c6      NUMBER(19,2),
  e6      NUMBER(19,2),
  c7      NUMBER(19,2),
  e7      NUMBER(19,2),
  c8      NUMBER(19,2),
  e8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  c10     NUMBER(19,2),
  e10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  c14     NUMBER(19,2),
  e14     NUMBER(19,2),
  c15     NUMBER(19,2),
  e15     NUMBER(19,2),
  c16     NUMBER(19,2),
  e16     NUMBER(19,2),
  c17     NUMBER(19,2),
  e17     NUMBER(19,2),
  c18     NUMBER(19,2),
  e18     NUMBER(19,2),
  c19     NUMBER(19,2),
  e19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  c22     NUMBER(19,2),
  e22     NUMBER(19,2),
  c23     NUMBER(19,2),
  e23     NUMBER(19,2),
  c24     NUMBER(19,2),
  e24     NUMBER(19,2),
  c25     NUMBER(19,2),
  e25     NUMBER(19,2),
  c26     NUMBER(19,2),
  e26     NUMBER(19,2),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  e28     NUMBER(19,2),
  c29     NUMBER(19,2),
  e29     NUMBER(19,2),
  c30     NUMBER(19,2),
  e30     NUMBER(19,2),
  c31     NUMBER(19,2),
  e31     NUMBER(19,2),
  c32     NUMBER(19,2),
  e32     NUMBER(19,2),
  c33     NUMBER(19,2),
  e33     NUMBER(19,2),
  c34     NUMBER(19,2),
  d34     NUMBER(19,2),
  e34     NUMBER(19,2),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  e35     NUMBER(19,2),
  c36     NUMBER(19,2),
  e36     NUMBER(19,2),
  c37     NUMBER(19,2),
  e37     NUMBER(19,2),
  c38     NUMBER(19,2),
  e38     NUMBER(19,2),
  c39     NUMBER(19,2),
  d39     NUMBER(19,2),
  e39     NUMBER(19,2),
  c40     NUMBER(19,2),
  e40     NUMBER(19,2),
  c41     NUMBER(19,2),
  e41     NUMBER(19,2),
  c42     NUMBER(19,2),
  d42     NUMBER(19,2),
  e42     NUMBER(19,2),
  c43     NUMBER(19,2),
  e43     NUMBER(19,2),
  c44     NUMBER(19,2),
  e44     NUMBER(19,2),
  c45     NUMBER(19,2),
  e45     NUMBER(19,2),
  c46     NUMBER(19,2),
  d46     NUMBER(19,2),
  e46     NUMBER(19,2),
  c47     NUMBER(19,2),
  e47     NUMBER(19,2),
  c48     NUMBER(19,2),
  e48     NUMBER(19,2),
  c49     NUMBER(19,2),
  d49     NUMBER(19,2),
  e49     NUMBER(19,2),
  c50     NUMBER(19,2),
  e50     NUMBER(19,2),
  c51     NUMBER(19,2),
  d51     NUMBER(19,2),
  e51     NUMBER(19,2),
  c52     NUMBER(19,2),
  e52     NUMBER(19,2),
  c53     NUMBER(19,2),
  e53     NUMBER(19,2),
  c54     NUMBER(19,2),
  e54     NUMBER(19,2),
  c55     NUMBER(19,2),
  e55     NUMBER(19,2),
  c56     NUMBER(19,2),
  e56     NUMBER(19,2),
  c57     NUMBER(19,2),
  e57     NUMBER(19,2),
  c58     NUMBER(19,2),
  d58     NUMBER(19,2),
  e58     NUMBER(19,2),
  c59     NUMBER(19,2),
  d59     NUMBER(19,2),
  e59     NUMBER(19,2),
  c60     NUMBER(19,2),
  d60     NUMBER(19,2),
  e60     NUMBER(19,2),
  c61     NUMBER(19,2),
  e61     NUMBER(19,2),
  c62     NUMBER(19,2),
  e62     NUMBER(19,2),
  c63     NUMBER(19,2),
  e63     NUMBER(19,2),
  c64     NUMBER(19,2),
  d64     NUMBER(19,2),
  e64     NUMBER(19,2),
  c65     NUMBER(19,2),
  d65     NUMBER(19,2),
  e65     NUMBER(19,2),
  c66     NUMBER(19,2),
  e66     NUMBER(19,2),
  c67     NUMBER(19,2),
  e67     NUMBER(19,2),
  c68     NUMBER(19,2),
  e68     NUMBER(19,2),
  c69     NUMBER(19,2),
  e69     NUMBER(19,2),
  c70     NUMBER(19,2),
  e70     NUMBER(19,2),
  c71     NUMBER(19,2),
  e71     NUMBER(19,2),
  c72     NUMBER(19,2),
  d72     NUMBER(19,2),
  e72     NUMBER(19,2),
  e73     NUMBER(19,2)
)
;

prompt
prompt Creating table T_CSRC0328_B_A0
prompt ==============================
prompt
create table T_CSRC0328_B_A0
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b3      VARCHAR2(1),
  c3      NUMBER,
  e3      VARCHAR2(255),
  b4      VARCHAR2(1),
  c4      NUMBER,
  e4      VARCHAR2(255),
  b5      VARCHAR2(1),
  c5      NUMBER(19,2),
  e5      VARCHAR2(255),
  b6      VARCHAR2(1),
  c6      NUMBER(19,2),
  e6      VARCHAR2(255),
  b7      VARCHAR2(1),
  c7      NUMBER(19,2),
  e7      VARCHAR2(255),
  b8      VARCHAR2(1),
  c8      NUMBER(19,2),
  e8      VARCHAR2(255),
  b9      VARCHAR2(1),
  c9      NUMBER,
  e9      VARCHAR2(255),
  b10     VARCHAR2(1),
  c10     NUMBER(19,2),
  e10     VARCHAR2(255),
  b11     VARCHAR2(1),
  c11     NUMBER,
  e11     VARCHAR2(255),
  b12     VARCHAR2(1),
  c12     NUMBER(19,2),
  e12     VARCHAR2(255),
  b13     VARCHAR2(1),
  c13     NUMBER,
  e13     VARCHAR2(255),
  b14     VARCHAR2(1),
  c14     NUMBER,
  e14     VARCHAR2(255),
  b16     VARCHAR2(1),
  c16     NUMBER,
  e16     VARCHAR2(255),
  b17     VARCHAR2(1),
  c17     NUMBER,
  e17     VARCHAR2(255),
  b18     VARCHAR2(1),
  c18     NUMBER,
  e18     VARCHAR2(255),
  b19     VARCHAR2(1),
  c19     NUMBER,
  e19     VARCHAR2(255),
  b20     VARCHAR2(1),
  c20     NUMBER,
  e20     VARCHAR2(255),
  b21     VARCHAR2(1),
  c21     NUMBER,
  e21     VARCHAR2(255),
  b22     VARCHAR2(1),
  c22     NUMBER,
  e22     VARCHAR2(255),
  b23     VARCHAR2(1),
  c23     NUMBER,
  e23     VARCHAR2(255),
  b24     VARCHAR2(1),
  c24     NUMBER,
  e24     VARCHAR2(255),
  b25     VARCHAR2(1),
  c25     NUMBER,
  e25     VARCHAR2(255),
  b26     VARCHAR2(1),
  c26     NUMBER,
  e26     VARCHAR2(255),
  b28     VARCHAR2(1),
  c28     NUMBER,
  e28     VARCHAR2(255),
  b29     VARCHAR2(1),
  c29     NUMBER,
  e29     VARCHAR2(255),
  b30     VARCHAR2(1),
  c30     NUMBER,
  e30     VARCHAR2(255),
  b31     VARCHAR2(1),
  c31     NUMBER(19,2),
  e31     VARCHAR2(255),
  b32     VARCHAR2(1),
  c32     NUMBER(19,2),
  e32     VARCHAR2(255),
  b33     VARCHAR2(1),
  c33     NUMBER(19,2),
  e33     VARCHAR2(255),
  b34     VARCHAR2(1),
  c34     NUMBER,
  e34     VARCHAR2(255),
  b35     VARCHAR2(1),
  c35     NUMBER(19,2),
  e35     VARCHAR2(255),
  b36     VARCHAR2(1),
  c36     NUMBER(19,2),
  e36     VARCHAR2(255),
  b37     VARCHAR2(1),
  c37     NUMBER(19,2),
  e37     VARCHAR2(255),
  b38     VARCHAR2(1),
  c38     NUMBER,
  e38     VARCHAR2(255),
  b40     VARCHAR2(1),
  c40     NUMBER,
  e40     VARCHAR2(255),
  b41     VARCHAR2(1),
  c41     NUMBER,
  e41     VARCHAR2(255),
  b42     VARCHAR2(1),
  c42     NUMBER,
  e42     VARCHAR2(255),
  b43     VARCHAR2(1),
  c43     NUMBER,
  e43     VARCHAR2(255)
)
;
comment on table T_CSRC0328_B_A0
  is '֤ȯӪҵܱʾ';

prompt
prompt Creating table T_CSRC0328_B_A1_1
prompt ================================
prompt
create table T_CSRC0328_B_A1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  c18     NUMBER(19,2),
  d18     NUMBER(19,2),
  c19     NUMBER(19,2),
  d19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  c22     NUMBER(19,2),
  d22     NUMBER(19,2),
  c23     NUMBER(19,2),
  d23     NUMBER(19,2),
  c24     NUMBER(19,2),
  d24     NUMBER(19,2),
  c25     NUMBER(19,2),
  d25     NUMBER(19,2),
  c26     NUMBER(19,2),
  d26     NUMBER(19,2),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  c29     NUMBER(19,2),
  d29     NUMBER(19,2),
  c30     NUMBER(19,2),
  d30     NUMBER(19,2),
  c31     NUMBER(19,2),
  d31     NUMBER(19,2),
  b32     VARCHAR2(255)
)
;
comment on table T_CSRC0328_B_A1_1
  is 'Ӫҵʲ';

prompt
prompt Creating table T_CSRC0328_B_A2_1
prompt ================================
prompt
create table T_CSRC0328_B_A2_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      VARCHAR2(255),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      VARCHAR2(255),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      VARCHAR2(255),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      VARCHAR2(255),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      VARCHAR2(255),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      VARCHAR2(255),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      VARCHAR2(255),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     VARCHAR2(255),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     VARCHAR2(255),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     VARCHAR2(255),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     VARCHAR2(255),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     VARCHAR2(255),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     VARCHAR2(255),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     VARCHAR2(255),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     VARCHAR2(255),
  d20     NUMBER,
  e20     NUMBER(19,2),
  f20     VARCHAR2(255),
  d21     NUMBER,
  e21     NUMBER(19,2),
  f21     VARCHAR2(255),
  d22     NUMBER,
  e22     NUMBER(19,2),
  f22     VARCHAR2(255),
  d23     NUMBER,
  e23     NUMBER(19,2),
  f23     VARCHAR2(255),
  d24     NUMBER,
  e24     NUMBER(19,2),
  f24     VARCHAR2(255),
  d25     NUMBER,
  e25     NUMBER(19,2),
  f25     VARCHAR2(255),
  d26     NUMBER,
  e26     NUMBER(19,2),
  f26     VARCHAR2(255),
  d27     NUMBER,
  e27     NUMBER(19,2),
  f27     VARCHAR2(255),
  d28     NUMBER,
  e28     NUMBER(19,2),
  f28     VARCHAR2(255),
  d29     NUMBER,
  e29     NUMBER(19,2),
  f29     VARCHAR2(255),
  d30     NUMBER,
  e30     NUMBER(19,2),
  f30     VARCHAR2(255),
  d31     NUMBER,
  e31     NUMBER(19,2),
  f31     VARCHAR2(255),
  d32     NUMBER,
  e32     NUMBER(19,2),
  f32     VARCHAR2(255),
  d33     NUMBER,
  e33     NUMBER(19,2),
  f33     VARCHAR2(255),
  d34     NUMBER,
  e34     NUMBER(19,2),
  f34     VARCHAR2(255),
  d35     NUMBER,
  e35     NUMBER(19,2),
  f35     VARCHAR2(255),
  d36     NUMBER,
  e36     NUMBER(19,2),
  f36     VARCHAR2(255)
)
;
comment on table T_CSRC0328_B_A2_1
  is 'Ӫҵͻʲ״';

prompt
prompt Creating table T_CSRC0328_B_A3_1
prompt ================================
prompt
create table T_CSRC0328_B_A3_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      NUMBER(19,2),
  g2      NUMBER(19,2),
  h2      VARCHAR2(255),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      VARCHAR2(255),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      VARCHAR2(255),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      VARCHAR2(255),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      VARCHAR2(255),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      VARCHAR2(255),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      VARCHAR2(255),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      VARCHAR2(255),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     VARCHAR2(255),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     VARCHAR2(255),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     VARCHAR2(255),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  h14     VARCHAR2(255),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  h15     VARCHAR2(255),
  d16     NUMBER(19,2),
  f16     NUMBER(19,2),
  h16     VARCHAR2(255),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  h17     VARCHAR2(255),
  d18     NUMBER(19,2),
  f18     NUMBER(19,2),
  h18     VARCHAR2(255),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  h19     VARCHAR2(255),
  d20     NUMBER(19,2),
  h20     VARCHAR2(255),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  h21     VARCHAR2(255),
  d22     NUMBER(19,2),
  f22     NUMBER(19,2),
  h22     VARCHAR2(255),
  d24     NUMBER(19,2),
  f24     NUMBER(19,2),
  g24     NUMBER(19,2),
  h24     VARCHAR2(255),
  d25     NUMBER(19,2),
  f25     NUMBER(19,2),
  g25     NUMBER(19,2),
  h25     VARCHAR2(255),
  d26     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  g26     NUMBER(19,2),
  h26     VARCHAR2(255),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  g27     NUMBER(19,2),
  h27     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0328_B_A4_1
prompt ================================
prompt
create table T_CSRC0328_B_A4_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  d14     NUMBER(19,2),
  d15     NUMBER(19,2),
  c16     VARCHAR2(255),
  c18     NUMBER(19,2),
  c19     NUMBER(19,2)
)
;
comment on table T_CSRC0328_B_A4_1
  is 'Ӫҵ֤ȯ';

prompt
prompt Creating table T_CSRC0328_B_B00
prompt ===============================
prompt
create table T_CSRC0328_B_B00
(
  bbq      VARCHAR2(8),
  userid   VARCHAR2(18),
  btype    VARCHAR2(1),
  option1  VARCHAR2(12),
  shtag    VARCHAR2(1),
  upid     VARCHAR2(18),
  g6       DATE,
  username VARCHAR2(255),
  i9       NUMBER(19,2),
  c10      VARCHAR2(255),
  c11      NUMBER(19,2),
  i11      NUMBER(19,2),
  i12      NUMBER(19,2),
  c13      NUMBER(19,2),
  i13      NUMBER(19,2),
  i14      NUMBER(19,2),
  c18      VARCHAR2(24),
  f18      VARCHAR2(24),
  i18      VARCHAR2(24),
  c19      VARCHAR2(24),
  f19      VARCHAR2(24),
  i19      VARCHAR2(24),
  l19      VARCHAR2(50)
)
;

prompt
prompt Creating table T_CSRC0619_F1_1
prompt ==============================
prompt
create table T_CSRC0619_F1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(255),
  c3      VARCHAR2(50),
  d3      VARCHAR2(255),
  e3      VARCHAR2(20),
  f3      NUMBER(12),
  g3      VARCHAR2(255),
  h3      CHAR(1),
  i3      CHAR(1),
  j3      CHAR(1),
  k3      VARCHAR2(255),
  l3      VARCHAR2(24),
  m3      VARCHAR2(255)
)
;
comment on table T_CSRC0619_F1_1
  is '֤ȯ˾ϢϵͳⲿӪ';

prompt
prompt Creating table T_CSRC0619_F1_2
prompt ==============================
prompt
create table T_CSRC0619_F1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(255),
  c3      VARCHAR2(50),
  d3      VARCHAR2(255),
  e3      VARCHAR2(20),
  f3      NUMBER(12),
  g3      VARCHAR2(255),
  h3      CHAR(1),
  i3      CHAR(1),
  j3      CHAR(1),
  k3      VARCHAR2(255),
  l3      VARCHAR2(24),
  m3      VARCHAR2(255)
)
;
comment on table T_CSRC0619_F1_2
  is '֤ȯ˾ϢϵͳⲿӪ';

prompt
prompt Creating table T_CSRC0619_F2_1
prompt ==============================
prompt
create table T_CSRC0619_F2_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(100),
  c3      VARCHAR2(255),
  d3      VARCHAR2(20),
  e3      VARCHAR2(30),
  f3      VARCHAR2(255),
  g3      VARCHAR2(255),
  h3      CHAR(1),
  i3      CHAR(1),
  j3      CHAR(1),
  k3      CHAR(1),
  l3      CHAR(1),
  m3      CHAR(1),
  n3      VARCHAR2(255),
  o3      NUMBER(18,2),
  p3      NUMBER(18,2),
  q3      NUMBER(18,2),
  r3      VARCHAR2(255)
)
;
comment on table T_CSRC0619_F2_1
  is '뽻ⲿϢϵͳ漰˻ϸ';

prompt
prompt Creating table T_CSRC0619_F2_2
prompt ==============================
prompt
create table T_CSRC0619_F2_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(100),
  c2      VARCHAR2(255),
  d2      VARCHAR2(100),
  e2      VARCHAR2(255),
  f2      VARCHAR2(50),
  g2      VARCHAR2(12),
  h2      DATE,
  i2      DATE,
  j2      VARCHAR2(200),
  k2      NUMBER(18,2),
  l2      NUMBER(12,2),
  m2      VARCHAR2(255)
)
;
comment on table T_CSRC0619_F2_2
  is '뽻ⲿϢϵͳ漰˻ϸ';

prompt
prompt Creating table T_CSRC0619_F_XXB
prompt ===============================
prompt
create table T_CSRC0619_F_XXB
(
  bbq      VARCHAR2(8),
  userid   VARCHAR2(18),
  btype    VARCHAR2(1),
  option1  VARCHAR2(12),
  shtag    VARCHAR2(1),
  upid     VARCHAR2(18),
  username VARCHAR2(200),
  b2       VARCHAR2(100),
  d2       VARCHAR2(100),
  b3       VARCHAR2(100),
  b4       VARCHAR2(100),
  d4       VARCHAR2(100),
  b5       VARCHAR2(100),
  d5       VARCHAR2(100),
  b6       VARCHAR2(100),
  b7       VARCHAR2(100),
  d7       VARCHAR2(100),
  b8       VARCHAR2(100),
  d8       VARCHAR2(100),
  b9       VARCHAR2(100),
  b10      VARCHAR2(100),
  d10      VARCHAR2(100),
  b11      VARCHAR2(100),
  d11      VARCHAR2(100),
  b12      VARCHAR2(100),
  d12      VARCHAR2(100),
  b13      VARCHAR2(100),
  d13      VARCHAR2(100),
  b14      VARCHAR2(100),
  d14      VARCHAR2(100),
  b15      VARCHAR2(100),
  d15      VARCHAR2(100),
  b16      VARCHAR2(100),
  d16      VARCHAR2(100),
  b17      VARCHAR2(100),
  d17      VARCHAR2(100)
)
;
comment on table T_CSRC0619_F_XXB
  is '֤ȯ˾Ϣϵͳⲿ뱨';

prompt
prompt Creating table T_CSRC0623_B_R_R1
prompt ================================
prompt
create table T_CSRC0623_B_R_R1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  f2      NUMBER,
  g2      NUMBER,
  f3      NUMBER,
  g3      NUMBER,
  f4      NUMBER,
  g4      NUMBER,
  f5      NUMBER,
  g5      NUMBER,
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  f10     NUMBER,
  f11     NUMBER,
  f12     NUMBER,
  f13     NUMBER(18,2),
  f14     NUMBER(18,2),
  f15     NUMBER(18,2),
  f16     VARCHAR2(100),
  f17     NUMBER(18,2),
  f18     VARCHAR2(100),
  f19     NUMBER(18,2),
  f20     VARCHAR2(100),
  f21     NUMBER(18,2),
  f22     VARCHAR2(100),
  f23     NUMBER(18,2),
  f24     VARCHAR2(100),
  f25     NUMBER(18,2),
  f26     VARCHAR2(100),
  f27     NUMBER(18,2),
  f28     NUMBER(18,2),
  g28     NUMBER(18,2),
  f29     NUMBER(18,2),
  g29     NUMBER(18,2),
  f30     NUMBER(18,2),
  g30     NUMBER(18,2),
  f31     NUMBER(18,2),
  g31     NUMBER(18,2),
  f32     NUMBER(18,2),
  g32     NUMBER(18,2)
)
;
comment on table T_CSRC0623_B_R_R1
  is '֤ȯ˾Ӫҵȯҵ¶רͳƱ';

prompt
prompt Creating table T_CSRC0623_B_R_XXB
prompt =================================
prompt
create table T_CSRC0623_B_R_XXB
(
  bbq      VARCHAR2(8),
  userid   VARCHAR2(18),
  btype    VARCHAR2(1),
  option1  VARCHAR2(12),
  shtag    VARCHAR2(1),
  upid     VARCHAR2(18),
  username VARCHAR2(150),
  d3       VARCHAR2(20),
  b5       VARCHAR2(50),
  d5       VARCHAR2(25)
)
;
comment on table T_CSRC0623_B_R_XXB
  is '';

prompt
prompt Creating table T_CSRC0624_E1_11_1
prompt =================================
prompt
create table T_CSRC0624_E1_11_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(50),
  c2      DATE,
  d2      DATE,
  e2      NUMBER(12),
  f2      NUMBER(18,2),
  g2      VARCHAR2(20),
  h2      NUMBER(18,2),
  i2      NUMBER(18,2),
  j2      VARCHAR2(50)
)
;
comment on table T_CSRC0624_E1_11_1
  is '֤ȯ˾μծ¶ȱμծȯ';

prompt
prompt Creating table T_CSRC0624_E1_11_2
prompt =================================
prompt
create table T_CSRC0624_E1_11_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(50),
  c2      DATE,
  d2      DATE,
  e2      NUMBER(12),
  f2      NUMBER(18,2),
  g2      VARCHAR2(20),
  h2      NUMBER(18,2),
  i2      NUMBER(18,2)
)
;
comment on table T_CSRC0624_E1_11_2
  is '֤ȯ˾μծ¶ȱμծ';

prompt
prompt Creating table T_CSRC0707_A3_1
prompt ==============================
prompt
create table T_CSRC0707_A3_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      VARCHAR2(255),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      VARCHAR2(255),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      VARCHAR2(255),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      VARCHAR2(255),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     VARCHAR2(255),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     VARCHAR2(255),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     VARCHAR2(255),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  g13     VARCHAR2(255),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  g16     VARCHAR2(255),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  g17     VARCHAR2(255),
  c18     NUMBER(19,2),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  g18     VARCHAR2(255),
  c19     NUMBER(19,2),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  g19     VARCHAR2(255),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  g21     VARCHAR2(255),
  c22     NUMBER(19,2),
  d22     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  g22     VARCHAR2(255),
  c23     NUMBER(19,2),
  d23     NUMBER(19,2),
  e23     NUMBER(19,2),
  f23     NUMBER(19,2),
  g23     VARCHAR2(255),
  c24     NUMBER(19,2),
  d24     NUMBER(19,2),
  e24     NUMBER(19,2),
  f24     NUMBER(19,2),
  g24     VARCHAR2(255),
  c25     NUMBER(19,2),
  d25     NUMBER(19,2),
  e25     NUMBER(19,2),
  f25     NUMBER(19,2),
  g25     VARCHAR2(255),
  c26     NUMBER(19,2),
  d26     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  g26     VARCHAR2(255),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  g27     VARCHAR2(255),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  e28     NUMBER(19,2),
  f28     NUMBER(19,2),
  g28     VARCHAR2(255),
  c29     NUMBER(19,2),
  d29     NUMBER(19,2),
  e29     NUMBER(19,2),
  f29     NUMBER(19,2),
  g29     VARCHAR2(255),
  c31     NUMBER(19,2),
  d31     NUMBER(19,2),
  e31     NUMBER(19,2),
  f31     NUMBER(19,2),
  g31     VARCHAR2(255),
  c34     NUMBER(19,2),
  d34     NUMBER(19,2),
  e34     NUMBER(19,2),
  f34     NUMBER(19,2),
  g34     VARCHAR2(255),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  e35     NUMBER(19,2),
  f35     NUMBER(19,2),
  g35     VARCHAR2(255),
  c36     NUMBER(19,2),
  d36     NUMBER(19,2),
  e36     NUMBER(19,2),
  f36     NUMBER(19,2),
  g36     VARCHAR2(255),
  c37     NUMBER(19,2),
  d37     NUMBER(19,2),
  e37     NUMBER(19,2),
  f37     NUMBER(19,2),
  g37     VARCHAR2(255),
  c38     NUMBER(19,2),
  d38     NUMBER(19,2),
  e38     NUMBER(19,2),
  f38     NUMBER(19,2),
  g38     VARCHAR2(255)
)
;
comment on table T_CSRC0707_A3_1
  is 'ͻ׽ʽȫԼܱ';

prompt
prompt Creating table T_CSRC0707_B0
prompt ============================
prompt
create table T_CSRC0707_B0
(
  bbq      VARCHAR2(8),
  userid   VARCHAR2(18),
  btype    VARCHAR2(1),
  option1  VARCHAR2(12),
  shtag    VARCHAR2(1),
  upid     VARCHAR2(18),
  username VARCHAR2(50),
  g8       DATE,
  c11      VARCHAR2(24),
  g11      VARCHAR2(24),
  k11      VARCHAR2(24),
  c13      VARCHAR2(20),
  g13      VARCHAR2(24),
  c15      VARCHAR2(20),
  f15      VARCHAR2(24),
  i15      VARCHAR2(24),
  l15      VARCHAR2(24),
  c17      VARCHAR2(20),
  f17      VARCHAR2(24),
  i17      VARCHAR2(24),
  l17      VARCHAR2(24),
  d21      VARCHAR2(24),
  c19      NUMBER,
  i19      NUMBER
)
;

prompt
prompt Creating table T_CSRC0707_B1
prompt ============================
prompt
create table T_CSRC0707_B1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b3      CHAR(1),
  c3      VARCHAR2(255),
  b4      CHAR(1),
  c4      VARCHAR2(255),
  b6      CHAR(1),
  c6      VARCHAR2(255),
  b7      CHAR(1),
  c7      VARCHAR2(255),
  b9      CHAR(1),
  c9      VARCHAR2(255),
  b10     CHAR(1),
  c10     VARCHAR2(255),
  b13     CHAR(1),
  c13     VARCHAR2(255),
  b14     CHAR(1),
  c14     VARCHAR2(255),
  b16     CHAR(1),
  c16     VARCHAR2(255),
  b17     CHAR(1),
  c17     VARCHAR2(255),
  b19     CHAR(1),
  c19     VARCHAR2(255),
  b20     CHAR(1),
  c20     VARCHAR2(255),
  b22     CHAR(1),
  c22     VARCHAR2(255),
  b23     CHAR(1),
  c23     VARCHAR2(255),
  b25     CHAR(1),
  c25     VARCHAR2(255),
  b26     CHAR(1),
  c26     VARCHAR2(255),
  b28     CHAR(1),
  c28     VARCHAR2(255),
  b29     CHAR(1),
  c29     VARCHAR2(255),
  b30     CHAR(1),
  c30     VARCHAR2(255),
  b32     CHAR(1),
  c32     VARCHAR2(255),
  b33     CHAR(1),
  c33     VARCHAR2(255),
  b35     CHAR(1),
  c35     VARCHAR2(255),
  b36     CHAR(1),
  c36     VARCHAR2(255),
  b38     CHAR(1),
  c38     VARCHAR2(255),
  b39     CHAR(1),
  c39     VARCHAR2(255),
  b41     CHAR(1),
  c41     VARCHAR2(255),
  b42     CHAR(1),
  c42     VARCHAR2(255),
  b44     CHAR(1),
  c44     VARCHAR2(255),
  b45     CHAR(1),
  c45     VARCHAR2(255),
  b47     CHAR(1),
  c47     VARCHAR2(255),
  b48     CHAR(1),
  c48     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_B2
prompt ============================
prompt
create table T_CSRC0707_B2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b2      VARCHAR2(100),
  c2      VARCHAR2(100),
  d2      VARCHAR2(100),
  e2      VARCHAR2(255),
  b3      VARCHAR2(100),
  c3      VARCHAR2(100),
  d3      VARCHAR2(100),
  e3      VARCHAR2(255),
  b4      VARCHAR2(100),
  c4      VARCHAR2(100),
  d4      VARCHAR2(100),
  e4      VARCHAR2(255),
  b5      VARCHAR2(100),
  c5      VARCHAR2(100),
  d5      VARCHAR2(100),
  e5      VARCHAR2(255),
  b6      VARCHAR2(100),
  c6      VARCHAR2(100),
  d6      VARCHAR2(100),
  e6      VARCHAR2(255),
  b7      VARCHAR2(100),
  c7      VARCHAR2(100),
  d7      VARCHAR2(100),
  e7      VARCHAR2(255),
  b8      VARCHAR2(100),
  c8      VARCHAR2(100),
  d8      VARCHAR2(100),
  e8      VARCHAR2(255),
  b9      VARCHAR2(100),
  c9      VARCHAR2(100),
  d9      VARCHAR2(100),
  e9      VARCHAR2(255),
  b10     VARCHAR2(100),
  c10     VARCHAR2(100),
  d10     VARCHAR2(100),
  e10     VARCHAR2(255),
  b11     VARCHAR2(100),
  c11     VARCHAR2(100),
  d11     VARCHAR2(100),
  e11     VARCHAR2(255),
  b12     VARCHAR2(100),
  c12     VARCHAR2(100),
  d12     VARCHAR2(100),
  e12     VARCHAR2(255),
  b13     VARCHAR2(100),
  c13     VARCHAR2(100),
  d13     VARCHAR2(100),
  e13     VARCHAR2(255),
  b14     VARCHAR2(100),
  c14     VARCHAR2(100),
  d14     VARCHAR2(100),
  e14     VARCHAR2(255),
  b15     VARCHAR2(100),
  c15     VARCHAR2(100),
  d15     VARCHAR2(100),
  e15     VARCHAR2(255),
  b16     VARCHAR2(100),
  c16     VARCHAR2(100),
  d16     VARCHAR2(100),
  e16     VARCHAR2(255),
  b17     VARCHAR2(100),
  c17     VARCHAR2(100),
  d17     VARCHAR2(100),
  e17     VARCHAR2(255),
  b18     VARCHAR2(100),
  c18     VARCHAR2(100),
  d18     VARCHAR2(100),
  e18     VARCHAR2(255),
  b19     VARCHAR2(100),
  c19     VARCHAR2(100),
  d19     VARCHAR2(100),
  e19     VARCHAR2(255),
  b20     VARCHAR2(100),
  c20     VARCHAR2(100),
  d20     VARCHAR2(100),
  e20     VARCHAR2(255),
  b21     VARCHAR2(100),
  c21     VARCHAR2(100),
  d21     VARCHAR2(100),
  e21     VARCHAR2(255),
  b22     VARCHAR2(100),
  c22     VARCHAR2(100),
  d22     VARCHAR2(100),
  e22     VARCHAR2(255),
  b23     VARCHAR2(100),
  c23     VARCHAR2(100),
  d23     VARCHAR2(100),
  e23     VARCHAR2(255),
  b24     VARCHAR2(100),
  c24     VARCHAR2(100),
  d24     VARCHAR2(100),
  e24     VARCHAR2(255),
  b25     VARCHAR2(100),
  c25     VARCHAR2(100),
  d25     VARCHAR2(100),
  e25     VARCHAR2(255),
  b26     VARCHAR2(100),
  c26     VARCHAR2(100),
  d26     VARCHAR2(100),
  e26     VARCHAR2(255),
  b27     VARCHAR2(100),
  c27     VARCHAR2(100),
  d27     VARCHAR2(100),
  e27     VARCHAR2(255),
  b28     VARCHAR2(100),
  c28     VARCHAR2(100),
  d28     VARCHAR2(100),
  e28     VARCHAR2(255),
  b29     VARCHAR2(100),
  c29     VARCHAR2(100),
  d29     VARCHAR2(100),
  e29     VARCHAR2(255),
  b30     VARCHAR2(100),
  c30     VARCHAR2(100),
  d30     VARCHAR2(100),
  e30     VARCHAR2(255),
  b31     VARCHAR2(100),
  c31     VARCHAR2(100),
  d31     VARCHAR2(100),
  e31     VARCHAR2(255),
  b32     VARCHAR2(100),
  c32     VARCHAR2(100),
  d32     VARCHAR2(100),
  e32     VARCHAR2(255),
  b33     VARCHAR2(100),
  c33     VARCHAR2(100),
  d33     VARCHAR2(100),
  e33     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_B3_1
prompt ==============================
prompt
create table T_CSRC0707_B3_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      NUMBER(19,2),
  g2      NUMBER(19,2),
  h2      NUMBER(19,2),
  i2      NUMBER(19,2),
  j2      NUMBER(19,2),
  k2      NUMBER(19,2),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  i3      NUMBER(19,2),
  j3      NUMBER(19,2),
  k3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      NUMBER(19,2),
  k4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  i5      NUMBER(19,2),
  j5      NUMBER(19,2),
  k5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  i6      NUMBER(19,2),
  j6      NUMBER(19,2),
  k6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  i7      NUMBER(19,2),
  j7      NUMBER(19,2),
  k7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  i8      NUMBER(19,2),
  j8      NUMBER(19,2),
  k8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  i9      NUMBER(19,2),
  j9      NUMBER(19,2),
  k9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  i10     NUMBER(19,2),
  j10     NUMBER(19,2),
  k10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     NUMBER(19,2),
  i11     NUMBER(19,2),
  j11     NUMBER(19,2),
  k11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     NUMBER(19,2),
  i12     NUMBER(19,2),
  j12     NUMBER(19,2),
  k12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  g13     NUMBER(19,2),
  h13     NUMBER(19,2),
  i13     NUMBER(19,2),
  j13     NUMBER(19,2),
  k13     NUMBER(19,2),
  c14     NUMBER(19,2),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  g14     NUMBER(19,2),
  h14     NUMBER(19,2),
  i14     NUMBER(19,2),
  j14     NUMBER(19,2),
  k14     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  g15     NUMBER(19,2),
  h15     NUMBER(19,2),
  i15     NUMBER(19,2),
  j15     NUMBER(19,2),
  k15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  g16     NUMBER(19,2),
  h16     NUMBER(19,2),
  i16     NUMBER(19,2),
  j16     NUMBER(19,2),
  k16     NUMBER(19,2),
  c17     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  g17     NUMBER(19,2),
  h17     NUMBER(19,2),
  i17     NUMBER(19,2),
  j17     NUMBER(19,2),
  k17     NUMBER(19,2),
  c18     NUMBER(19,2),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  g18     NUMBER(19,2),
  h18     NUMBER(19,2),
  i18     NUMBER(19,2),
  j18     NUMBER(19,2),
  k18     NUMBER(19,2),
  c19     NUMBER(19,2),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  g19     NUMBER(19,2),
  h19     NUMBER(19,2),
  i19     NUMBER(19,2),
  j19     NUMBER(19,2),
  k19     NUMBER(19,2),
  c20     NUMBER(19,2),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  f20     NUMBER(19,2),
  g20     NUMBER(19,2),
  h20     NUMBER(19,2),
  i20     NUMBER(19,2),
  j20     NUMBER(19,2),
  k20     NUMBER(19,2),
  c21     NUMBER(19,2),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  g21     NUMBER(19,2),
  h21     NUMBER(19,2),
  i21     NUMBER(19,2),
  j21     NUMBER(19,2),
  k21     NUMBER(19,2),
  c22     NUMBER(19,2),
  d22     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  g22     NUMBER(19,2),
  h22     NUMBER(19,2),
  i22     NUMBER(19,2),
  j22     NUMBER(19,2),
  k22     NUMBER(19,2),
  c23     NUMBER(19,2),
  d23     NUMBER(19,2),
  e23     NUMBER(19,2),
  f23     NUMBER(19,2),
  g23     NUMBER(19,2),
  h23     NUMBER(19,2),
  i23     NUMBER(19,2),
  j23     NUMBER(19,2),
  k23     NUMBER(19,2),
  c24     NUMBER(19,2),
  d24     NUMBER(19,2),
  e24     NUMBER(19,2),
  f24     NUMBER(19,2),
  g24     NUMBER(19,2),
  h24     NUMBER(19,2),
  i24     NUMBER(19,2),
  j24     NUMBER(19,2),
  k24     NUMBER(19,2),
  c25     NUMBER(19,2),
  d25     NUMBER(19,2),
  e25     NUMBER(19,2),
  f25     NUMBER(19,2),
  g25     NUMBER(19,2),
  h25     NUMBER(19,2),
  i25     NUMBER(19,2),
  j25     NUMBER(19,2),
  k25     NUMBER(19,2),
  c26     NUMBER(19,2),
  d26     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  g26     NUMBER(19,2),
  h26     NUMBER(19,2),
  i26     NUMBER(19,2),
  j26     NUMBER(19,2),
  k26     NUMBER(19,2),
  c27     NUMBER(19,2),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  g27     NUMBER(19,2),
  h27     NUMBER(19,2),
  i27     NUMBER(19,2),
  j27     NUMBER(19,2),
  k27     NUMBER(19,2),
  c28     NUMBER(19,2),
  d28     NUMBER(19,2),
  e28     NUMBER(19,2),
  f28     NUMBER(19,2),
  g28     NUMBER(19,2),
  h28     NUMBER(19,2),
  i28     NUMBER(19,2),
  j28     NUMBER(19,2),
  k28     NUMBER(19,2),
  c29     NUMBER(19,2),
  d29     NUMBER(19,2),
  e29     NUMBER(19,2),
  f29     NUMBER(19,2),
  g29     NUMBER(19,2),
  h29     NUMBER(19,2),
  i29     NUMBER(19,2),
  j29     NUMBER(19,2),
  k29     NUMBER(19,2),
  c30     NUMBER(19,2),
  d30     NUMBER(19,2),
  e30     NUMBER(19,2),
  f30     NUMBER(19,2),
  g30     NUMBER(19,2),
  h30     NUMBER(19,2),
  i30     NUMBER(19,2),
  j30     NUMBER(19,2),
  k30     NUMBER(19,2),
  c31     NUMBER(19,2),
  d31     NUMBER(19,2),
  e31     NUMBER(19,2),
  f31     NUMBER(19,2),
  g31     NUMBER(19,2),
  h31     NUMBER(19,2),
  i31     NUMBER(19,2),
  j31     NUMBER(19,2),
  k31     NUMBER(19,2),
  c32     NUMBER(19,2),
  d32     NUMBER(19,2),
  e32     NUMBER(19,2),
  f32     NUMBER(19,2),
  g32     NUMBER(19,2),
  h32     NUMBER(19,2),
  i32     NUMBER(19,2),
  j32     NUMBER(19,2),
  k32     NUMBER(19,2),
  c33     NUMBER(19,2),
  d33     NUMBER(19,2),
  e33     NUMBER(19,2),
  f33     NUMBER(19,2),
  g33     NUMBER(19,2),
  h33     NUMBER(19,2),
  i33     NUMBER(19,2),
  j33     NUMBER(19,2),
  k33     NUMBER(19,2),
  c34     NUMBER(19,2),
  d34     NUMBER(19,2),
  e34     NUMBER(19,2),
  f34     NUMBER(19,2),
  g34     NUMBER(19,2),
  h34     NUMBER(19,2),
  i34     NUMBER(19,2),
  j34     NUMBER(19,2),
  k34     NUMBER(19,2),
  c35     NUMBER(19,2),
  d35     NUMBER(19,2),
  e35     NUMBER(19,2),
  f35     NUMBER(19,2),
  g35     NUMBER(19,2),
  h35     NUMBER(19,2),
  i35     NUMBER(19,2),
  j35     NUMBER(19,2),
  k35     NUMBER(19,2),
  c36     NUMBER(19,2),
  d36     NUMBER(19,2),
  e36     NUMBER(19,2),
  f36     NUMBER(19,2),
  g36     NUMBER(19,2),
  h36     NUMBER(19,2),
  i36     NUMBER(19,2),
  j36     NUMBER(19,2),
  k36     NUMBER(19,2),
  c37     NUMBER(19,2),
  d37     NUMBER(19,2),
  e37     NUMBER(19,2),
  f37     NUMBER(19,2),
  g37     NUMBER(19,2),
  h37     NUMBER(19,2),
  i37     NUMBER(19,2),
  j37     NUMBER(19,2),
  k37     NUMBER(19,2)
)
;
comment on table T_CSRC0707_B3_1
  is 'Ȩ䶯';

prompt
prompt Creating table T_CSRC0707_B4_1
prompt ==============================
prompt
create table T_CSRC0707_B4_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  g13     NUMBER(19,2),
  c14     NUMBER(19,2),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  g14     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  g15     NUMBER(19,2),
  c16     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  g16     NUMBER(19,2)
)
;
comment on table T_CSRC0707_B4_1
  is 'ʲֵ׼ܱ';

prompt
prompt Creating table T_CSRC0707_C11_1
prompt ===============================
prompt
create table T_CSRC0707_C11_1
(
  bbq     VARCHAR2(8) not null,
  userid  VARCHAR2(18) not null,
  btype   VARCHAR2(1) not null,
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1) not null,
  c2      VARCHAR2(100),
  c3      VARCHAR2(100),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  c11     NUMBER(19,2),
  e11     NUMBER(19,2)
)
;
comment on table T_CSRC0707_C11_1
  is 'Ϊڻ˾ṩмҵܱ';
alter table T_CSRC0707_C11_1
  add constraint PK_T_CSRC0707_C11_1 primary key (BBQ, USERID);

prompt
prompt Creating table T_CSRC0707_C1_1
prompt ==============================
prompt
create table T_CSRC0707_C1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      NUMBER(19,2),
  k4      VARCHAR2(255),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  i5      NUMBER(19,2),
  j5      NUMBER(19,2),
  k5      VARCHAR2(255),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  i6      NUMBER(19,2),
  j6      NUMBER(19,2),
  k6      VARCHAR2(255),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  i7      NUMBER(19,2),
  j7      NUMBER(19,2),
  k7      VARCHAR2(255),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  i8      NUMBER(19,2),
  j8      NUMBER(19,2),
  k8      VARCHAR2(255),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  i9      NUMBER(19,2),
  j9      NUMBER(19,2),
  k9      VARCHAR2(255),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  i10     NUMBER(19,2),
  j10     NUMBER(19,2),
  k10     VARCHAR2(255),
  k11     VARCHAR2(8),
  e12     NUMBER,
  f12     NUMBER,
  h12     NUMBER,
  j12     NUMBER,
  k12     VARCHAR2(255),
  e13     NUMBER,
  f13     NUMBER,
  h13     NUMBER,
  j13     NUMBER,
  k13     VARCHAR2(255),
  e14     NUMBER,
  f14     NUMBER,
  h14     NUMBER,
  j14     NUMBER,
  k14     VARCHAR2(255),
  e15     NUMBER,
  f15     NUMBER,
  h15     NUMBER,
  j15     NUMBER,
  k15     VARCHAR2(255),
  e16     NUMBER,
  f16     NUMBER,
  h16     NUMBER,
  j16     NUMBER,
  k16     VARCHAR2(255),
  e17     NUMBER,
  f17     NUMBER,
  h17     NUMBER,
  j17     NUMBER,
  k17     VARCHAR2(255),
  e18     NUMBER,
  f18     NUMBER,
  h18     NUMBER,
  j18     NUMBER,
  k18     VARCHAR2(255),
  e19     NUMBER,
  f19     NUMBER,
  h19     NUMBER,
  j19     NUMBER,
  k19     VARCHAR2(255),
  e20     NUMBER,
  f20     NUMBER,
  h20     NUMBER,
  j20     NUMBER,
  k20     VARCHAR2(255),
  e21     NUMBER,
  f21     NUMBER,
  h21     NUMBER,
  j21     NUMBER,
  k21     VARCHAR2(255),
  e22     NUMBER,
  f22     NUMBER,
  h22     NUMBER,
  j22     NUMBER,
  k22     VARCHAR2(255),
  e23     NUMBER,
  f23     NUMBER,
  h23     NUMBER,
  j23     NUMBER,
  k23     VARCHAR2(255),
  e24     NUMBER,
  f24     NUMBER,
  h24     NUMBER,
  j24     NUMBER,
  k24     VARCHAR2(255),
  e25     NUMBER,
  f25     NUMBER,
  h25     NUMBER,
  j25     NUMBER,
  k25     VARCHAR2(255),
  e26     NUMBER,
  f26     NUMBER,
  h26     NUMBER,
  j26     NUMBER,
  k26     VARCHAR2(255),
  e27     NUMBER,
  f27     NUMBER,
  h27     NUMBER,
  j27     NUMBER,
  k27     VARCHAR2(255),
  e28     NUMBER,
  f28     NUMBER,
  h28     NUMBER,
  j28     NUMBER,
  k28     VARCHAR2(255),
  e29     NUMBER,
  f29     NUMBER,
  h29     NUMBER,
  j29     NUMBER,
  k29     VARCHAR2(255),
  e30     NUMBER,
  f30     NUMBER,
  h30     NUMBER,
  j30     NUMBER,
  k30     VARCHAR2(255),
  e31     NUMBER,
  f31     NUMBER,
  h31     NUMBER,
  j31     NUMBER,
  k31     VARCHAR2(255),
  e32     NUMBER,
  f32     NUMBER,
  h32     NUMBER,
  j32     NUMBER,
  k32     VARCHAR2(255),
  e33     NUMBER,
  f33     NUMBER,
  h33     NUMBER,
  j33     NUMBER,
  k33     VARCHAR2(255),
  e34     NUMBER,
  f34     NUMBER,
  h34     NUMBER,
  j34     NUMBER,
  k34     VARCHAR2(255),
  e35     NUMBER,
  f35     NUMBER,
  h35     NUMBER,
  j35     NUMBER,
  k35     VARCHAR2(255),
  e36     NUMBER,
  f36     NUMBER,
  h36     NUMBER,
  j36     NUMBER,
  k36     VARCHAR2(255),
  e37     NUMBER,
  f37     NUMBER,
  h37     NUMBER,
  j37     NUMBER,
  k37     VARCHAR2(255),
  e38     NUMBER,
  f38     NUMBER,
  h38     NUMBER,
  j38     NUMBER,
  k38     VARCHAR2(255),
  e39     NUMBER,
  f39     NUMBER,
  h39     NUMBER,
  j39     NUMBER,
  k39     VARCHAR2(255),
  e40     NUMBER,
  f40     NUMBER,
  h40     NUMBER,
  j40     NUMBER,
  k40     VARCHAR2(255),
  e42     NUMBER,
  f42     NUMBER,
  h42     NUMBER,
  j42     NUMBER,
  k42     VARCHAR2(255),
  e43     NUMBER,
  f43     NUMBER,
  h43     NUMBER,
  j43     NUMBER,
  k43     VARCHAR2(255),
  e44     NUMBER,
  f44     NUMBER,
  h44     NUMBER,
  j44     NUMBER,
  k44     VARCHAR2(255),
  e45     NUMBER,
  f45     NUMBER,
  h45     NUMBER,
  j45     NUMBER,
  k45     VARCHAR2(255),
  e46     NUMBER,
  f46     NUMBER,
  h46     NUMBER,
  j46     NUMBER,
  k46     VARCHAR2(255),
  e47     NUMBER,
  f47     NUMBER,
  h47     NUMBER,
  j47     NUMBER,
  k47     VARCHAR2(255),
  e48     NUMBER,
  f48     NUMBER,
  h48     NUMBER,
  j48     NUMBER,
  k48     VARCHAR2(255),
  e49     NUMBER,
  f49     NUMBER,
  h49     NUMBER,
  j49     NUMBER,
  k49     VARCHAR2(255),
  e52     NUMBER,
  k52     VARCHAR2(255),
  e53     NUMBER,
  k53     VARCHAR2(255),
  e54     NUMBER,
  k54     VARCHAR2(255),
  e55     NUMBER,
  k55     VARCHAR2(255),
  e56     NUMBER,
  k56     VARCHAR2(255),
  e58     NUMBER,
  k58     VARCHAR2(255),
  e59     NUMBER,
  k59     VARCHAR2(255),
  e60     NUMBER,
  k60     VARCHAR2(255)
)
;
comment on table T_CSRC0707_C1_1
  is 'ҵܱ---ʽ뿪';

prompt
prompt Creating table T_CSRC0707_C1_2
prompt ==============================
prompt
create table T_CSRC0707_C1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  f20     NUMBER(19,2),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  d22     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  d23     NUMBER(19,2),
  e23     NUMBER(19,2),
  f23     NUMBER(19,2),
  d24     NUMBER(19,2),
  e24     NUMBER(19,2),
  f24     NUMBER(19,2),
  d25     NUMBER(19,2),
  e25     NUMBER(19,2),
  f25     NUMBER(19,2),
  d26     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  d28     NUMBER(19,2),
  e28     NUMBER(19,2),
  f28     NUMBER(19,2),
  d29     NUMBER(19,2),
  e29     NUMBER(19,2),
  f29     NUMBER(19,2),
  d30     NUMBER(19,2),
  e30     NUMBER(19,2),
  f30     NUMBER(19,2),
  d31     NUMBER(19,2),
  e31     NUMBER(19,2),
  f31     NUMBER(19,2),
  d32     NUMBER(19,2),
  e32     NUMBER(19,2),
  f32     NUMBER(19,2),
  d34     NUMBER(19,2),
  d35     NUMBER(19,2),
  d36     NUMBER(19,2),
  d37     NUMBER(19,2)
)
;
comment on table T_CSRC0707_C1_2
  is 'ҵܱ---';

prompt
prompt Creating table T_CSRC0707_C1_3
prompt ==============================
prompt
create table T_CSRC0707_C1_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      VARCHAR2(255),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      VARCHAR2(255),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      VARCHAR2(255),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      VARCHAR2(255),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      VARCHAR2(255),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      VARCHAR2(255),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      VARCHAR2(255),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_C2_1
prompt ==============================
prompt
create table T_CSRC0707_C2_1
(
  bbq     VARCHAR2(8) not null,
  userid  VARCHAR2(18) not null,
  btype   VARCHAR2(1) not null,
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1) not null,
  c2      NUMBER,
  c3      NUMBER,
  c4      NUMBER,
  c5      NUMBER,
  c6      NUMBER,
  c7      NUMBER,
  c8      VARCHAR2(100),
  c9      VARCHAR2(100),
  c10     VARCHAR2(100),
  c13     NUMBER,
  d13     NUMBER,
  e13     NUMBER,
  d14     NUMBER,
  e14     NUMBER,
  c15     NUMBER,
  d15     NUMBER,
  e15     NUMBER,
  c16     NUMBER,
  d16     NUMBER,
  e16     NUMBER,
  c17     NUMBER,
  d17     NUMBER,
  e17     NUMBER,
  c14     NUMBER
)
;
comment on table T_CSRC0707_C2_1
  is '뱣ҵܱ---ҵ';
alter table T_CSRC0707_C2_1
  add constraint PK_T_CSRC0707_C2_1 primary key (BBQ, USERID, BTYPE, SHTAG);

prompt
prompt Creating table T_CSRC0707_C2_2
prompt ==============================
prompt
create table T_CSRC0707_C2_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      NUMBER(19,2),
  k4      NUMBER(19,2),
  l4      NUMBER(19,2),
  m4      NUMBER(19,2),
  n4      NUMBER(19,2),
  o4      NUMBER(19,2),
  p4      NUMBER(19,2),
  q4      NUMBER(19,2),
  r4      NUMBER(19,2),
  s4      NUMBER(19,2),
  t4      NUMBER(19,2),
  u4      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  i5      NUMBER(19,2),
  j5      NUMBER(19,2),
  k5      NUMBER(19,2),
  l5      NUMBER(19,2),
  m5      NUMBER(19,2),
  n5      NUMBER(19,2),
  o5      NUMBER(19,2),
  p5      NUMBER(19,2),
  q5      NUMBER(19,2),
  r5      NUMBER(19,2),
  s5      NUMBER(19,2),
  t5      NUMBER(19,2),
  u5      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  i6      NUMBER(19,2),
  j6      NUMBER(19,2),
  k6      NUMBER(19,2),
  l6      NUMBER(19,2),
  m6      NUMBER(19,2),
  n6      NUMBER(19,2),
  o6      NUMBER(19,2),
  p6      NUMBER(19,2),
  q6      NUMBER(19,2),
  r6      NUMBER(19,2),
  s6      NUMBER(19,2),
  t6      NUMBER(19,2),
  u6      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  i7      NUMBER(19,2),
  j7      NUMBER(19,2),
  k7      NUMBER(19,2),
  l7      NUMBER(19,2),
  m7      NUMBER(19,2),
  n7      NUMBER(19,2),
  o7      NUMBER(19,2),
  p7      NUMBER(19,2),
  q7      NUMBER(19,2),
  r7      NUMBER(19,2),
  s7      NUMBER(19,2),
  t7      NUMBER(19,2),
  u7      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  i8      NUMBER(19,2),
  j8      NUMBER(19,2),
  k8      NUMBER(19,2),
  l8      NUMBER(19,2),
  m8      NUMBER(19,2),
  n8      NUMBER(19,2),
  o8      NUMBER(19,2),
  p8      NUMBER(19,2),
  q8      NUMBER(19,2),
  r8      NUMBER(19,2),
  s8      NUMBER(19,2),
  t8      NUMBER(19,2),
  u8      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  i9      NUMBER(19,2),
  j9      NUMBER(19,2),
  k9      NUMBER(19,2),
  l9      NUMBER(19,2),
  m9      NUMBER(19,2),
  n9      NUMBER(19,2),
  o9      NUMBER(19,2),
  p9      NUMBER(19,2),
  q9      NUMBER(19,2),
  r9      NUMBER(19,2),
  s9      NUMBER(19,2),
  t9      NUMBER(19,2),
  u9      NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  i10     NUMBER(19,2),
  j10     NUMBER(19,2),
  k10     NUMBER(19,2),
  l10     NUMBER(19,2),
  m10     NUMBER(19,2),
  n10     NUMBER(19,2),
  o10     NUMBER(19,2),
  p10     NUMBER(19,2),
  q10     NUMBER(19,2),
  r10     NUMBER(19,2),
  s10     NUMBER(19,2),
  t10     NUMBER(19,2),
  u10     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     NUMBER(19,2),
  i11     NUMBER(19,2),
  j11     NUMBER(19,2),
  k11     NUMBER(19,2),
  l11     NUMBER(19,2),
  m11     NUMBER(19,2),
  n11     NUMBER(19,2),
  o11     NUMBER(19,2),
  p11     NUMBER(19,2),
  q11     NUMBER(19,2),
  r11     NUMBER(19,2),
  s11     NUMBER(19,2),
  t11     NUMBER(19,2),
  u11     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     NUMBER(19,2),
  i12     NUMBER(19,2),
  j12     NUMBER(19,2),
  k12     NUMBER(19,2),
  l12     NUMBER(19,2),
  m12     NUMBER(19,2),
  n12     NUMBER(19,2),
  o12     NUMBER(19,2),
  p12     NUMBER(19,2),
  q12     NUMBER(19,2),
  r12     NUMBER(19,2),
  s12     NUMBER(19,2),
  t12     NUMBER(19,2),
  u12     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  g13     NUMBER(19,2),
  h13     NUMBER(19,2),
  i13     NUMBER(19,2),
  j13     NUMBER(19,2),
  k13     NUMBER(19,2),
  l13     NUMBER(19,2),
  m13     NUMBER(19,2),
  n13     NUMBER(19,2),
  o13     NUMBER(19,2),
  p13     NUMBER(19,2),
  q13     NUMBER(19,2),
  r13     NUMBER(19,2),
  s13     NUMBER(19,2),
  t13     NUMBER(19,2),
  u13     NUMBER(19,2),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  g14     NUMBER(19,2),
  h14     NUMBER(19,2),
  i14     NUMBER(19,2),
  j14     NUMBER(19,2),
  k14     NUMBER(19,2),
  l14     NUMBER(19,2),
  m14     NUMBER(19,2),
  n14     NUMBER(19,2),
  o14     NUMBER(19,2),
  p14     NUMBER(19,2),
  q14     NUMBER(19,2),
  r14     NUMBER(19,2),
  s14     NUMBER(19,2),
  t14     NUMBER(19,2),
  u14     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  g15     NUMBER(19,2),
  h15     NUMBER(19,2),
  i15     NUMBER(19,2),
  j15     NUMBER(19,2),
  k15     NUMBER(19,2),
  l15     NUMBER(19,2),
  m15     NUMBER(19,2),
  n15     NUMBER(19,2),
  o15     NUMBER(19,2),
  p15     NUMBER(19,2),
  q15     NUMBER(19,2),
  r15     NUMBER(19,2),
  s15     NUMBER(19,2),
  t15     NUMBER(19,2),
  u15     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  g16     NUMBER(19,2),
  h16     NUMBER(19,2),
  i16     NUMBER(19,2),
  j16     NUMBER(19,2),
  k16     NUMBER(19,2),
  l16     NUMBER(19,2),
  m16     NUMBER(19,2),
  n16     NUMBER(19,2),
  o16     NUMBER(19,2),
  p16     NUMBER(19,2),
  q16     NUMBER(19,2),
  r16     NUMBER(19,2),
  s16     NUMBER(19,2),
  t16     NUMBER(19,2),
  u16     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  g17     NUMBER(19,2),
  h17     NUMBER(19,2),
  i17     NUMBER(19,2),
  j17     NUMBER(19,2),
  k17     NUMBER(19,2),
  l17     NUMBER(19,2),
  m17     NUMBER(19,2),
  n17     NUMBER(19,2),
  o17     NUMBER(19,2),
  p17     NUMBER(19,2),
  q17     NUMBER(19,2),
  r17     NUMBER(19,2),
  s17     NUMBER(19,2),
  t17     NUMBER(19,2),
  u17     NUMBER(19,2),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  g18     NUMBER(19,2),
  h18     NUMBER(19,2),
  i18     NUMBER(19,2),
  j18     NUMBER(19,2),
  k18     NUMBER(19,2),
  l18     NUMBER(19,2),
  m18     NUMBER(19,2),
  n18     NUMBER(19,2),
  o18     NUMBER(19,2),
  p18     NUMBER(19,2),
  q18     NUMBER(19,2),
  r18     NUMBER(19,2),
  s18     NUMBER(19,2),
  t18     NUMBER(19,2),
  u18     NUMBER(19,2),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  g19     NUMBER(19,2),
  h19     NUMBER(19,2),
  i19     NUMBER(19,2),
  j19     NUMBER(19,2),
  k19     NUMBER(19,2),
  l19     NUMBER(19,2),
  m19     NUMBER(19,2),
  n19     NUMBER(19,2),
  o19     NUMBER(19,2),
  p19     NUMBER(19,2),
  q19     NUMBER(19,2),
  r19     NUMBER(19,2),
  s19     NUMBER(19,2),
  t19     NUMBER(19,2),
  u19     NUMBER(19,2),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  f20     NUMBER(19,2),
  g20     NUMBER(19,2),
  h20     NUMBER(19,2),
  i20     NUMBER(19,2),
  j20     NUMBER(19,2),
  k20     NUMBER(19,2),
  l20     NUMBER(19,2),
  m20     NUMBER(19,2),
  n20     NUMBER(19,2),
  o20     NUMBER(19,2),
  p20     NUMBER(19,2),
  q20     NUMBER(19,2),
  r20     NUMBER(19,2),
  s20     NUMBER(19,2),
  t20     NUMBER(19,2),
  u20     NUMBER(19,2),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  g21     NUMBER(19,2),
  h21     NUMBER(19,2),
  i21     NUMBER(19,2),
  j21     NUMBER(19,2),
  k21     NUMBER(19,2),
  l21     NUMBER(19,2),
  m21     NUMBER(19,2),
  n21     NUMBER(19,2),
  o21     NUMBER(19,2),
  p21     NUMBER(19,2),
  q21     NUMBER(19,2),
  r21     NUMBER(19,2),
  s21     NUMBER(19,2),
  t21     NUMBER(19,2),
  u21     NUMBER(19,2),
  d22     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  g22     NUMBER(19,2),
  h22     NUMBER(19,2),
  i22     NUMBER(19,2),
  j22     NUMBER(19,2),
  k22     NUMBER(19,2),
  l22     NUMBER(19,2),
  m22     NUMBER(19,2),
  n22     NUMBER(19,2),
  o22     NUMBER(19,2),
  p22     NUMBER(19,2),
  q22     NUMBER(19,2),
  r22     NUMBER(19,2),
  s22     NUMBER(19,2),
  t22     NUMBER(19,2),
  u22     NUMBER(19,2)
)
;
comment on table T_CSRC0707_C2_2
  is 'ҵܱ---ģ';

prompt
prompt Creating table T_CSRC0707_C3_1
prompt ==============================
prompt
create table T_CSRC0707_C3_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  i5      NUMBER(19,2),
  j5      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  i6      NUMBER(19,2),
  j6      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  i7      NUMBER(19,2),
  j7      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  i8      NUMBER(19,2),
  j8      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  i9      NUMBER(19,2),
  j9      NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  i10     NUMBER(19,2),
  j10     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     NUMBER(19,2),
  i11     NUMBER(19,2),
  j11     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     NUMBER(19,2),
  i12     NUMBER(19,2),
  j12     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  g13     NUMBER(19,2),
  h13     NUMBER(19,2),
  i13     NUMBER(19,2),
  j13     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  g14     NUMBER(19,2),
  h14     NUMBER(19,2),
  i14     NUMBER(19,2),
  j14     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  g15     NUMBER(19,2),
  h15     NUMBER(19,2),
  i15     NUMBER(19,2),
  j15     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  g16     NUMBER(19,2),
  h16     NUMBER(19,2),
  i16     NUMBER(19,2),
  j16     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  g17     NUMBER(19,2),
  h17     NUMBER(19,2),
  i17     NUMBER(19,2),
  j17     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  g18     NUMBER(19,2),
  h18     NUMBER(19,2),
  i18     NUMBER(19,2),
  j18     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  g19     NUMBER(19,2),
  h19     NUMBER(19,2),
  i19     NUMBER(19,2),
  j19     NUMBER(19,2),
  e20     NUMBER(19,2),
  f20     NUMBER(19,2),
  g20     NUMBER(19,2),
  h20     NUMBER(19,2),
  i20     NUMBER(19,2),
  j20     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  g21     NUMBER(19,2),
  h21     NUMBER(19,2),
  i21     NUMBER(19,2),
  j21     NUMBER(19,2),
  k21     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  g22     NUMBER(19,2),
  h22     NUMBER(19,2),
  i22     NUMBER(19,2),
  j22     NUMBER(19,2),
  k22     NUMBER(19,2),
  e23     NUMBER(19,2),
  f23     NUMBER(19,2),
  g23     NUMBER(19,2),
  h23     NUMBER(19,2),
  i23     NUMBER(19,2),
  j23     NUMBER(19,2),
  k23     NUMBER(19,2),
  e24     NUMBER(19,2),
  f24     NUMBER(19,2),
  g24     NUMBER(19,2),
  h24     NUMBER(19,2),
  i24     NUMBER(19,2),
  j24     NUMBER(19,2),
  k24     NUMBER(19,2),
  e25     NUMBER(19,2),
  f25     NUMBER(19,2),
  g25     NUMBER(19,2),
  h25     NUMBER(19,2),
  i25     NUMBER(19,2),
  j25     NUMBER(19,2),
  k25     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  g26     NUMBER(19,2),
  h26     NUMBER(19,2),
  i26     NUMBER(19,2),
  j26     NUMBER(19,2),
  k26     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  g27     NUMBER(19,2),
  h27     NUMBER(19,2),
  i27     NUMBER(19,2),
  j27     NUMBER(19,2),
  k27     NUMBER(19,2),
  e28     NUMBER(19,2),
  f28     NUMBER(19,2),
  g28     NUMBER(19,2),
  h28     NUMBER(19,2),
  i28     NUMBER(19,2),
  j28     NUMBER(19,2),
  k28     NUMBER(19,2),
  e29     NUMBER(19,2),
  f29     NUMBER(19,2),
  g29     NUMBER(19,2),
  h29     NUMBER(19,2),
  i29     NUMBER(19,2),
  j29     NUMBER(19,2),
  k29     NUMBER(19,2),
  e30     NUMBER(19,2),
  f30     NUMBER(19,2),
  g30     NUMBER(19,2),
  h30     NUMBER(19,2),
  i30     NUMBER(19,2),
  j30     NUMBER(19,2),
  k30     NUMBER(19,2),
  e31     NUMBER(19,2),
  f31     NUMBER(19,2),
  g31     NUMBER(19,2),
  h31     NUMBER(19,2),
  i31     NUMBER(19,2),
  j31     NUMBER(19,2),
  k31     NUMBER(19,2),
  e32     NUMBER(19,2),
  f32     NUMBER(19,2),
  g32     NUMBER(19,2),
  h32     NUMBER(19,2),
  i32     NUMBER(19,2),
  j32     NUMBER(19,2),
  k32     NUMBER(19,2),
  e33     NUMBER(19,2),
  f33     NUMBER(19,2),
  g33     NUMBER(19,2),
  h33     NUMBER(19,2),
  i33     NUMBER(19,2),
  j33     NUMBER(19,2),
  k33     NUMBER(19,2),
  e34     NUMBER(19,2),
  f34     NUMBER(19,2),
  g34     NUMBER(19,2),
  h34     NUMBER(19,2),
  i34     NUMBER(19,2),
  j34     NUMBER(19,2),
  k34     NUMBER(19,2),
  e38     NUMBER(19,2),
  f38     NUMBER(19,2),
  g38     NUMBER(19,2),
  h38     NUMBER(19,2),
  i38     NUMBER(19,2),
  j38     NUMBER(19,2),
  k38     NUMBER(19,2),
  e39     NUMBER(19,2),
  f39     NUMBER(19,2),
  g39     NUMBER(19,2),
  h39     NUMBER(19,2),
  i39     NUMBER(19,2),
  j39     NUMBER(19,2),
  k39     NUMBER(19,2),
  e40     NUMBER(19,2),
  f40     NUMBER(19,2),
  g40     NUMBER(19,2),
  h40     NUMBER(19,2),
  i40     NUMBER(19,2),
  j40     NUMBER(19,2),
  k40     NUMBER(19,2),
  e41     NUMBER(19,2),
  f41     NUMBER(19,2),
  g41     NUMBER(19,2),
  h41     NUMBER(19,2),
  i41     NUMBER(19,2),
  j41     NUMBER(19,2),
  k41     NUMBER(19,2),
  e42     NUMBER(19,2),
  f42     NUMBER(19,2),
  g42     NUMBER(19,2),
  h42     NUMBER(19,2),
  i42     NUMBER(19,2),
  j42     NUMBER(19,2),
  k42     NUMBER(19,2),
  e43     NUMBER(19,2),
  f43     NUMBER(19,2),
  g43     NUMBER(19,2),
  h43     NUMBER(19,2),
  i43     NUMBER(19,2),
  j43     NUMBER(19,2),
  k43     NUMBER(19,2),
  e44     NUMBER(19,2),
  f44     NUMBER(19,2),
  g44     NUMBER(19,2),
  h44     NUMBER(19,2),
  i44     NUMBER(19,2),
  j44     NUMBER(19,2),
  k44     NUMBER(19,2),
  e45     NUMBER(19,2),
  f45     NUMBER(19,2),
  g45     NUMBER(19,2),
  h45     NUMBER(19,2),
  i45     NUMBER(19,2),
  j45     NUMBER(19,2),
  k45     NUMBER(19,2),
  d46     VARCHAR2(255),
  d47     VARCHAR2(255)
)
;
comment on table T_CSRC0707_C3_1
  is '֤ȯͶҵܱ---ƱծȯͶ';

prompt
prompt Creating table T_CSRC0707_C3_2
prompt ==============================
prompt
create table T_CSRC0707_C3_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(19,2),
  b3      VARCHAR2(50),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  i3      NUMBER(19,2)
)
;
comment on table T_CSRC0707_C3_2
  is '֤ȯͶҵ---ָڻͶ';

prompt
prompt Creating table T_CSRC0707_C5_1
prompt ==============================
prompt
create table T_CSRC0707_C5_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  i3      NUMBER(19,2),
  j3      VARCHAR2(255),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      VARCHAR2(255),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  i5      NUMBER(19,2),
  j5      VARCHAR2(255),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  i6      NUMBER(19,2),
  j6      VARCHAR2(255),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  i7      NUMBER(19,2),
  j7      VARCHAR2(255),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  i8      NUMBER(19,2),
  j8      VARCHAR2(255),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  i9      NUMBER(19,2),
  j9      VARCHAR2(255),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  i10     NUMBER(19,2),
  j10     VARCHAR2(255),
  d11     VARCHAR2(255)
)
;
comment on table T_CSRC0707_C5_1
  is 'ҵܱ---ҵ';

prompt
prompt Creating table T_CSRC0707_C6_1
prompt ==============================
prompt
create table T_CSRC0707_C6_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      NUMBER(19,2),
  g2      VARCHAR2(255),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      VARCHAR2(255),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      VARCHAR2(255),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      VARCHAR2(255),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2)
)
;
comment on table T_CSRC0707_C6_1
  is '֤ȯͶѯҵܱ---оѯҵ';

prompt
prompt Creating table T_CSRC0707_C6_1_1
prompt ================================
prompt
create table T_CSRC0707_C6_1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(19,2),
  b2      VARCHAR2(100),
  c2      VARCHAR2(100),
  d2      NUMBER(19,2),
  e2      VARCHAR2(100)
)
;
comment on table T_CSRC0707_C6_1_1
  is '֤ȯͶѯҵܱ---оѯҵ񣨸';

prompt
prompt Creating table T_CSRC0707_C7_1
prompt ==============================
prompt
create table T_CSRC0707_C7_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  i3      NUMBER(19,2),
  j3      NUMBER(19,2),
  k3      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      NUMBER(19,2),
  k4      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  i5      NUMBER(19,2),
  j5      NUMBER(19,2),
  k5      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  i6      NUMBER(19,2),
  j6      NUMBER(19,2),
  k6      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  i7      NUMBER(19,2),
  j7      NUMBER(19,2),
  k7      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  i8      NUMBER(19,2),
  j8      NUMBER(19,2),
  k8      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  i9      NUMBER(19,2),
  j9      NUMBER(19,2),
  k9      NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  i10     NUMBER(19,2),
  j10     NUMBER(19,2),
  k10     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     NUMBER(19,2),
  i11     NUMBER(19,2),
  j11     NUMBER(19,2),
  k11     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     NUMBER(19,2),
  i12     NUMBER(19,2),
  j12     NUMBER(19,2),
  k12     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  g13     NUMBER(19,2),
  h13     NUMBER(19,2),
  i13     NUMBER(19,2),
  j13     NUMBER(19,2),
  k13     NUMBER(19,2),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  g14     NUMBER(19,2),
  h14     NUMBER(19,2),
  i14     NUMBER(19,2),
  j14     NUMBER(19,2),
  k14     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  g15     NUMBER(19,2),
  h15     NUMBER(19,2),
  i15     NUMBER(19,2),
  j15     NUMBER(19,2),
  k15     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  g16     NUMBER(19,2),
  h16     NUMBER(19,2),
  i16     NUMBER(19,2),
  j16     NUMBER(19,2),
  k16     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  g17     NUMBER(19,2),
  h17     NUMBER(19,2),
  i17     NUMBER(19,2),
  j17     NUMBER(19,2),
  k17     NUMBER(19,2),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  g18     NUMBER(19,2),
  h18     NUMBER(19,2),
  i18     NUMBER(19,2),
  j18     NUMBER(19,2),
  k18     NUMBER(19,2),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  g19     NUMBER(19,2),
  h19     NUMBER(19,2),
  i19     NUMBER(19,2),
  j19     NUMBER(19,2),
  k19     NUMBER(19,2),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  f20     NUMBER(19,2),
  g20     NUMBER(19,2),
  h20     NUMBER(19,2),
  i20     NUMBER(19,2),
  j20     NUMBER(19,2),
  k20     NUMBER(19,2),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  g21     NUMBER(19,2),
  h21     NUMBER(19,2),
  i21     NUMBER(19,2),
  j21     NUMBER(19,2),
  k21     NUMBER(19,2),
  d22     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  g22     NUMBER(19,2),
  h22     NUMBER(19,2),
  i22     NUMBER(19,2),
  j22     NUMBER(19,2),
  k22     NUMBER(19,2),
  d23     NUMBER(19,2),
  e23     NUMBER(19,2),
  f23     NUMBER(19,2),
  g23     NUMBER(19,2),
  h23     NUMBER(19,2),
  i23     NUMBER(19,2),
  j23     NUMBER(19,2),
  k23     NUMBER(19,2),
  d24     NUMBER(19,2),
  e24     NUMBER(19,2),
  f24     NUMBER(19,2),
  g24     NUMBER(19,2),
  h24     NUMBER(19,2),
  i24     NUMBER(19,2),
  j24     NUMBER(19,2),
  k24     NUMBER(19,2),
  d25     NUMBER(19,2),
  e25     NUMBER(19,2),
  f25     NUMBER(19,2),
  g25     NUMBER(19,2),
  h25     NUMBER(19,2),
  i25     NUMBER(19,2),
  j25     NUMBER(19,2),
  k25     NUMBER(19,2),
  d26     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  g26     NUMBER(19,2),
  h26     NUMBER(19,2),
  i26     NUMBER(19,2),
  j26     NUMBER(19,2),
  k26     NUMBER(19,2),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  g27     NUMBER(19,2),
  h27     NUMBER(19,2),
  i27     NUMBER(19,2),
  j27     NUMBER(19,2),
  k27     NUMBER(19,2),
  d28     NUMBER(19,2),
  e28     NUMBER(19,2),
  f28     NUMBER(19,2),
  g28     NUMBER(19,2),
  h28     NUMBER(19,2),
  i28     NUMBER(19,2),
  j28     NUMBER(19,2),
  k28     NUMBER(19,2),
  d31     NUMBER(19,2),
  e31     NUMBER(19,2),
  f31     NUMBER(19,2),
  g31     NUMBER(19,2),
  d32     NUMBER(19,2),
  e32     NUMBER(19,2),
  f32     NUMBER(19,2),
  g32     NUMBER(19,2),
  d33     NUMBER(19,2),
  e33     NUMBER(19,2),
  f33     NUMBER(19,2),
  g33     NUMBER(19,2),
  d34     NUMBER(19,2),
  e34     NUMBER(19,2),
  f34     NUMBER(19,2),
  g34     NUMBER(19,2),
  d35     NUMBER(19,2),
  e35     NUMBER(19,2),
  f35     NUMBER(19,2),
  g35     NUMBER(19,2),
  d36     NUMBER(19,2),
  e36     NUMBER(19,2),
  f36     NUMBER(19,2),
  g36     NUMBER(19,2),
  d37     NUMBER(19,2),
  e37     NUMBER(19,2),
  f37     NUMBER(19,2),
  g37     NUMBER(19,2),
  d38     NUMBER(19,2),
  e38     NUMBER(19,2),
  f38     NUMBER(19,2),
  g38     NUMBER(19,2),
  d39     NUMBER(19,2),
  e39     NUMBER(19,2),
  f39     NUMBER(19,2),
  g39     NUMBER(19,2),
  d40     NUMBER(19,2),
  e40     NUMBER(19,2),
  f40     NUMBER(19,2),
  g40     NUMBER(19,2),
  d41     NUMBER(19,2),
  e41     NUMBER(19,2),
  f41     NUMBER(19,2),
  g41     NUMBER(19,2),
  d42     NUMBER(19,2),
  e42     NUMBER(19,2),
  f42     NUMBER(19,2),
  g42     NUMBER(19,2),
  d43     NUMBER(19,2),
  e43     NUMBER(19,2),
  f43     NUMBER(19,2),
  g43     NUMBER(19,2),
  d44     NUMBER(19,2),
  e44     NUMBER(19,2),
  f44     NUMBER(19,2),
  g44     NUMBER(19,2),
  d45     NUMBER(19,2),
  e45     NUMBER(19,2),
  f45     NUMBER(19,2),
  g45     NUMBER(19,2),
  d46     NUMBER(19,2),
  e46     NUMBER(19,2),
  f46     NUMBER(19,2),
  g46     NUMBER(19,2)
)
;
comment on table T_CSRC0707_C7_1
  is 'ծȯعҵܱѺʽծȯع';

prompt
prompt Creating table T_CSRC0707_C7_2
prompt ==============================
prompt
create table T_CSRC0707_C7_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  i3      NUMBER(19,2),
  j3      NUMBER(19,2),
  k3      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      NUMBER(19,2),
  k4      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  h5      NUMBER(19,2),
  i5      NUMBER(19,2),
  j5      NUMBER(19,2),
  k5      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  h6      NUMBER(19,2),
  i6      NUMBER(19,2),
  j6      NUMBER(19,2),
  k6      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  h7      NUMBER(19,2),
  i7      NUMBER(19,2),
  j7      NUMBER(19,2),
  k7      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  h8      NUMBER(19,2),
  i8      NUMBER(19,2),
  j8      NUMBER(19,2),
  k8      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  h9      NUMBER(19,2),
  i9      NUMBER(19,2),
  j9      NUMBER(19,2),
  k9      NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  h10     NUMBER(19,2),
  i10     NUMBER(19,2),
  j10     NUMBER(19,2),
  k10     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  h11     NUMBER(19,2),
  i11     NUMBER(19,2),
  j11     NUMBER(19,2),
  k11     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  h12     NUMBER(19,2),
  i12     NUMBER(19,2),
  j12     NUMBER(19,2),
  k12     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  h13     NUMBER(19,2),
  i13     NUMBER(19,2),
  j13     NUMBER(19,2),
  k13     NUMBER(19,2),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  h14     NUMBER(19,2),
  i14     NUMBER(19,2),
  j14     NUMBER(19,2),
  k14     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  h15     NUMBER(19,2),
  i15     NUMBER(19,2),
  j15     NUMBER(19,2),
  k15     NUMBER(19,2),
  d16     NUMBER(19,2),
  e16     NUMBER(19,2),
  f16     NUMBER(19,2),
  h16     NUMBER(19,2),
  i16     NUMBER(19,2),
  j16     NUMBER(19,2),
  k16     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  h17     NUMBER(19,2),
  i17     NUMBER(19,2),
  j17     NUMBER(19,2),
  k17     NUMBER(19,2),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  h18     NUMBER(19,2),
  i18     NUMBER(19,2),
  j18     NUMBER(19,2),
  k18     NUMBER(19,2),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  h19     NUMBER(19,2),
  i19     NUMBER(19,2),
  j19     NUMBER(19,2),
  k19     NUMBER(19,2),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  f20     NUMBER(19,2),
  h20     NUMBER(19,2),
  i20     NUMBER(19,2),
  j20     NUMBER(19,2),
  k20     NUMBER(19,2),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  h21     NUMBER(19,2),
  i21     NUMBER(19,2),
  j21     NUMBER(19,2),
  k21     NUMBER(19,2),
  d22     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  h22     NUMBER(19,2),
  i22     NUMBER(19,2),
  j22     NUMBER(19,2),
  k22     NUMBER(19,2),
  d23     NUMBER(19,2),
  e23     NUMBER(19,2),
  f23     NUMBER(19,2),
  h23     NUMBER(19,2),
  i23     NUMBER(19,2),
  j23     NUMBER(19,2),
  k23     NUMBER(19,2),
  d24     NUMBER(19,2),
  e24     NUMBER(19,2),
  f24     NUMBER(19,2),
  h24     NUMBER(19,2),
  i24     NUMBER(19,2),
  j24     NUMBER(19,2),
  k24     NUMBER(19,2),
  d25     NUMBER(19,2),
  e25     NUMBER(19,2),
  f25     NUMBER(19,2),
  h25     NUMBER(19,2),
  i25     NUMBER(19,2),
  j25     NUMBER(19,2),
  k25     NUMBER(19,2),
  d26     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  h26     NUMBER(19,2),
  i26     NUMBER(19,2),
  j26     NUMBER(19,2),
  k26     NUMBER(19,2),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  h27     NUMBER(19,2),
  i27     NUMBER(19,2),
  j27     NUMBER(19,2),
  k27     NUMBER(19,2),
  d28     NUMBER(19,2),
  e28     NUMBER(19,2),
  f28     NUMBER(19,2),
  h28     NUMBER(19,2),
  i28     NUMBER(19,2),
  j28     NUMBER(19,2),
  k28     NUMBER(19,2),
  g5      NUMBER(19,2),
  g6      NUMBER(19,2),
  g7      NUMBER(19,2),
  g8      NUMBER(19,2),
  g9      NUMBER(19,2),
  g10     NUMBER(19,2),
  g11     NUMBER(19,2),
  g12     NUMBER(19,2),
  g13     NUMBER(19,2),
  g14     NUMBER(19,2),
  g15     NUMBER(19,2),
  g16     NUMBER(19,2),
  g17     NUMBER(19,2),
  g18     NUMBER(19,2),
  g19     NUMBER(19,2),
  g20     NUMBER(19,2),
  g21     NUMBER(19,2),
  g22     NUMBER(19,2),
  g23     NUMBER(19,2),
  g24     NUMBER(19,2),
  g25     NUMBER(19,2),
  g26     NUMBER(19,2),
  g27     NUMBER(19,2),
  g28     NUMBER(19,2)
)
;
comment on table T_CSRC0707_C7_2
  is 'ծȯعҵܱʽծȯع';
comment on column T_CSRC0707_C7_2.i8
  is 'I';

prompt
prompt Creating table T_CSRC0707_C8_1
prompt ==============================
prompt
create table T_CSRC0707_C8_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b2      NUMBER(19,2),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      NUMBER(19,2),
  b3      NUMBER(19,2),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  b4      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  b5      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  b6      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  b7      NUMBER(19,2),
  c7      NUMBER(19,2),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  b8      NUMBER(19,2),
  c8      NUMBER(19,2),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  b9      NUMBER(19,2),
  c9      NUMBER(19,2),
  d9      NUMBER(19,2),
  e9      NUMBER(19,2),
  f9      NUMBER(19,2),
  b10     NUMBER(19,2),
  c10     NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  b11     NUMBER(19,2),
  c11     NUMBER(19,2),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  b12     NUMBER(19,2),
  c12     NUMBER(19,2),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  b13     NUMBER(19,2),
  c13     NUMBER(19,2),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  b14     NUMBER(19,2),
  c14     NUMBER(19,2),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  b15     NUMBER(19,2),
  c15     NUMBER(19,2),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2)
)
;
comment on table T_CSRC0707_C8_1
  is 'мгܱ';

prompt
prompt Creating table T_CSRC0707_C8_1_1
prompt ================================
prompt
create table T_CSRC0707_C8_1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(100),
  b2      NUMBER(19,2),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      NUMBER(19,2)
)
;
comment on table T_CSRC0707_C8_1_1
  is 'мгܱ';

prompt
prompt Creating table T_CSRC0707_C9_1
prompt ==============================
prompt
create table T_CSRC0707_C9_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a4      VARCHAR2(12),
  b4      NUMBER(19,2),
  c4      VARCHAR2(100),
  d4      VARCHAR2(50),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  i4      NUMBER(19,2),
  j4      NUMBER(19,2),
  k4      NUMBER(19,2),
  l4      NUMBER(19,2),
  m4      NUMBER(19,2),
  n4      NUMBER(19,2),
  o4      NUMBER(19,2),
  p4      NUMBER(19,2),
  q4      NUMBER(19,2),
  r4      NUMBER(19,2),
  s4      NUMBER(19,2),
  t4      NUMBER(19,2)
)
;
comment on table T_CSRC0707_C9_1
  is 'Ȩ֤ܱ';

prompt
prompt Creating table T_CSRC0707_D1_1_1
prompt ================================
prompt
create table T_CSRC0707_D1_1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      VARCHAR2(1),
  c2      VARCHAR2(255),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      NUMBER(19,2),
  g2      NUMBER(19,2),
  h2      NUMBER(19,2),
  i2      VARCHAR2(1),
  j2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D1_1_2
prompt ================================
prompt
create table T_CSRC0707_D1_1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      VARCHAR2(255),
  b3      VARCHAR2(255),
  c3      NUMBER(8,2),
  d3      NUMBER(8,2),
  e3      NUMBER(8,2),
  f3      NUMBER(8,2),
  g3      NUMBER(8,2),
  h3      VARCHAR2(255),
  i3      VARCHAR2(255),
  j3      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D1_1_3
prompt ================================
prompt
create table T_CSRC0707_D1_1_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      DATE,
  c2      VARCHAR2(255),
  d2      CHAR(1),
  e2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D2_1_1
prompt ================================
prompt
create table T_CSRC0707_D2_1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      DATE,
  c2      CHAR(1),
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255),
  g2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D2_1_2
prompt ================================
prompt
create table T_CSRC0707_D2_1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      DATE,
  c2      VARCHAR2(255),
  d2      CHAR(1),
  e2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D2_1_3
prompt ================================
prompt
create table T_CSRC0707_D2_1_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D2_1_4
prompt ================================
prompt
create table T_CSRC0707_D2_1_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      DATE,
  c2      VARCHAR2(1),
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D2_1_5
prompt ================================
prompt
create table T_CSRC0707_D2_1_5
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      DATE,
  c2      VARCHAR2(255),
  d2      CHAR(1),
  e2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D2_1_6
prompt ================================
prompt
create table T_CSRC0707_D2_1_6
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      DATE,
  e2      VARCHAR2(255),
  f2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D2_2
prompt ==============================
prompt
create table T_CSRC0707_D2_2
(
  bbq     VARCHAR2(8) not null,
  userid  VARCHAR2(18) not null,
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b2      NUMBER(19,2),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      NUMBER(19,2),
  b3      NUMBER(19,2),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  b4      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  b5      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  b6      NUMBER(19,2),
  c6      NUMBER(19,2),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2)
)
;
alter table T_CSRC0707_D2_2
  add constraint PK_T_CSRC_D2_2 primary key (BBQ, USERID);

prompt
prompt Creating table T_CSRC0707_D3_1_1
prompt ================================
prompt
create table T_CSRC0707_D3_1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      CHAR(1),
  c2      VARCHAR2(255),
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D3_1_2
prompt ================================
prompt
create table T_CSRC0707_D3_1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      VARCHAR2(255),
  c2      NUMBER,
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D3_1_3
prompt ================================
prompt
create table T_CSRC0707_D3_1_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      VARCHAR2(255),
  c2      NUMBER,
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D3_1_4
prompt ================================
prompt
create table T_CSRC0707_D3_1_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      VARCHAR2(255),
  c2      NUMBER,
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255),
  g2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D4_1_1
prompt ================================
prompt
create table T_CSRC0707_D4_1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      VARCHAR2(12),
  b3      VARCHAR2(255),
  c3      VARCHAR2(255),
  d3      CHAR(1),
  e3      NUMBER,
  f3      VARCHAR2(255),
  g3      VARCHAR2(255),
  h3      NUMBER,
  i3      NUMBER,
  j3      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D4_1_2
prompt ================================
prompt
create table T_CSRC0707_D4_1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      VARCHAR2(24),
  b3      VARCHAR2(255),
  c3      VARCHAR2(255),
  d3      VARCHAR2(1),
  e3      NUMBER,
  f3      VARCHAR2(255),
  g3      VARCHAR2(255),
  h3      NUMBER,
  i3      NUMBER,
  j3      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D5_1_1
prompt ================================
prompt
create table T_CSRC0707_D5_1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER,
  b3      VARCHAR2(255),
  c3      VARCHAR2(255),
  d3      NUMBER,
  e3      NUMBER,
  f3      VARCHAR2(255),
  g3      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D5_1_2
prompt ================================
prompt
create table T_CSRC0707_D5_1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER,
  b3      VARCHAR2(255),
  c3      VARCHAR2(255),
  d3      NUMBER,
  e3      NUMBER,
  f3      VARCHAR2(255),
  g3      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D5_1_3
prompt ================================
prompt
create table T_CSRC0707_D5_1_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER,
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      VARCHAR2(255),
  e2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D6_1
prompt ==============================
prompt
create table T_CSRC0707_D6_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      VARCHAR2(255),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      VARCHAR2(255),
  e2      NUMBER,
  f2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0707_D7_1
prompt ==============================
prompt
create table T_CSRC0707_D7_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b2      VARCHAR2(10),
  c2      VARCHAR2(40),
  d2      VARCHAR2(25),
  e2      VARCHAR2(255),
  f2      NUMBER(19,2),
  g2      VARCHAR2(30),
  b3      VARCHAR2(10),
  c3      VARCHAR2(40),
  d3      VARCHAR2(25),
  e3      VARCHAR2(255),
  f3      NUMBER(19,2),
  g3      VARCHAR2(30),
  b4      VARCHAR2(10),
  c4      VARCHAR2(40),
  d4      VARCHAR2(25),
  e4      VARCHAR2(255),
  f4      NUMBER(19,2),
  g4      VARCHAR2(30),
  b5      VARCHAR2(10),
  c5      VARCHAR2(40),
  d5      VARCHAR2(25),
  e5      VARCHAR2(255),
  f5      NUMBER(19,2),
  g5      VARCHAR2(30),
  b6      VARCHAR2(10),
  c6      VARCHAR2(40),
  d6      VARCHAR2(25),
  e6      VARCHAR2(255),
  f6      NUMBER(19,2),
  g6      VARCHAR2(30)
)
;

prompt
prompt Creating table T_CSRC0707_E1_1
prompt ==============================
prompt
create table T_CSRC0707_E1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(200),
  c2      VARCHAR2(200),
  d2      VARCHAR2(200),
  e2      VARCHAR2(200),
  f2      NUMBER(19,2),
  g2      NUMBER(19,2),
  h2      VARCHAR2(200),
  i2      NUMBER(19,2),
  j2      VARCHAR2(255)
)
;
comment on table T_CSRC0707_E1_1
  is 'Ŀϸרܱ';

prompt
prompt Creating table T_CSRC0707_E1_2
prompt ==============================
prompt
create table T_CSRC0707_E1_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  b4      VARCHAR2(200),
  c4      VARCHAR2(200),
  d4      NUMBER(19,2),
  e4      NUMBER(19,2),
  f4      NUMBER(19,2),
  g4      NUMBER(19,2),
  h4      NUMBER(19,2),
  b5      VARCHAR2(200),
  c5      VARCHAR2(200),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2),
  g5      NUMBER(19,2),
  h5      NUMBER(19,2),
  b6      VARCHAR2(200),
  c6      VARCHAR2(200),
  d6      NUMBER(19,2),
  e6      NUMBER(19,2),
  f6      NUMBER(19,2),
  g6      NUMBER(19,2),
  h6      NUMBER(19,2),
  b7      VARCHAR2(200),
  c7      VARCHAR2(200),
  d7      NUMBER(19,2),
  e7      NUMBER(19,2),
  f7      NUMBER(19,2),
  g7      NUMBER(19,2),
  h7      NUMBER(19,2),
  b8      VARCHAR2(200),
  c8      VARCHAR2(200),
  d8      NUMBER(19,2),
  e8      NUMBER(19,2),
  f8      NUMBER(19,2),
  g8      NUMBER(19,2),
  h8      NUMBER(19,2),
  f9      NUMBER(19,2),
  g9      NUMBER(19,2),
  h9      NUMBER(19,2),
  d10     NUMBER(19,2),
  e10     NUMBER(19,2),
  f10     NUMBER(19,2),
  g10     NUMBER(19,2),
  h10     NUMBER(19,2),
  b11     VARCHAR2(200),
  c11     VARCHAR2(200),
  d11     NUMBER(19,2),
  e11     NUMBER(19,2),
  f11     NUMBER(19,2),
  g11     NUMBER(19,2),
  h11     NUMBER(19,2),
  b12     VARCHAR2(200),
  c12     VARCHAR2(200),
  d12     NUMBER(19,2),
  e12     NUMBER(19,2),
  f12     NUMBER(19,2),
  g12     NUMBER(19,2),
  h12     NUMBER(19,2),
  b13     VARCHAR2(200),
  c13     VARCHAR2(200),
  d13     NUMBER(19,2),
  e13     NUMBER(19,2),
  f13     NUMBER(19,2),
  g13     NUMBER(19,2),
  h13     NUMBER(19,2),
  b14     VARCHAR2(200),
  c14     VARCHAR2(200),
  d14     NUMBER(19,2),
  e14     NUMBER(19,2),
  f14     NUMBER(19,2),
  g14     NUMBER(19,2),
  h14     NUMBER(19,2),
  b15     VARCHAR2(200),
  c15     VARCHAR2(200),
  d15     NUMBER(19,2),
  e15     NUMBER(19,2),
  f15     NUMBER(19,2),
  g15     NUMBER(19,2),
  h15     NUMBER(19,2),
  f16     NUMBER(19,2),
  g16     NUMBER(19,2),
  h16     NUMBER(19,2),
  d17     NUMBER(19,2),
  e17     NUMBER(19,2),
  f17     NUMBER(19,2),
  g17     NUMBER(19,2),
  h17     NUMBER(19,2),
  b18     VARCHAR2(255),
  c18     VARCHAR2(255),
  d18     NUMBER(19,2),
  e18     NUMBER(19,2),
  f18     NUMBER(19,2),
  g18     NUMBER(19,2),
  h18     NUMBER(19,2),
  b19     VARCHAR2(255),
  c19     VARCHAR2(255),
  d19     NUMBER(19,2),
  e19     NUMBER(19,2),
  f19     NUMBER(19,2),
  g19     NUMBER(19,2),
  h19     NUMBER(19,2),
  b20     VARCHAR2(255),
  c20     VARCHAR2(255),
  d20     NUMBER(19,2),
  e20     NUMBER(19,2),
  f20     NUMBER(19,2),
  g20     NUMBER(19,2),
  h20     NUMBER(19,2),
  b21     VARCHAR2(255),
  c21     VARCHAR2(255),
  d21     NUMBER(19,2),
  e21     NUMBER(19,2),
  f21     NUMBER(19,2),
  g21     NUMBER(19,2),
  h21     NUMBER(19,2),
  b22     VARCHAR2(255),
  c22     VARCHAR2(255),
  d22     NUMBER(19,2),
  e22     NUMBER(19,2),
  f22     NUMBER(19,2),
  g22     NUMBER(19,2),
  h22     NUMBER(19,2),
  f23     NUMBER(19,2),
  g23     NUMBER(19,2),
  h23     NUMBER(19,2),
  d24     NUMBER(19,2),
  e24     NUMBER(19,2),
  f24     NUMBER(19,2),
  g24     NUMBER(19,2),
  h24     NUMBER(19,2),
  b25     VARCHAR2(255),
  c25     VARCHAR2(255),
  d25     NUMBER(19,2),
  e25     NUMBER(19,2),
  f25     NUMBER(19,2),
  g25     NUMBER(19,2),
  h25     NUMBER(19,2),
  b26     VARCHAR2(255),
  c26     VARCHAR2(255),
  d26     NUMBER(19,2),
  e26     NUMBER(19,2),
  f26     NUMBER(19,2),
  g26     NUMBER(19,2),
  h26     NUMBER(19,2),
  b27     VARCHAR2(255),
  c27     VARCHAR2(255),
  d27     NUMBER(19,2),
  e27     NUMBER(19,2),
  f27     NUMBER(19,2),
  g27     NUMBER(19,2),
  h27     NUMBER(19,2),
  b28     VARCHAR2(255),
  c28     VARCHAR2(255),
  d28     NUMBER(19,2),
  e28     NUMBER(19,2),
  f28     NUMBER(19,2),
  g28     NUMBER(19,2),
  h28     NUMBER(19,2),
  b29     VARCHAR2(255),
  c29     VARCHAR2(255),
  d29     NUMBER(19,2),
  e29     NUMBER(19,2),
  f29     NUMBER(19,2),
  g29     NUMBER(19,2),
  h29     NUMBER(19,2),
  f30     NUMBER(19,2),
  g30     NUMBER(19,2),
  h30     NUMBER(19,2),
  d31     NUMBER(19,2),
  e31     NUMBER(19,2),
  f31     NUMBER(19,2),
  g31     NUMBER(19,2),
  h31     NUMBER(19,2),
  b32     VARCHAR2(255),
  c32     VARCHAR2(255),
  d32     NUMBER(19,2),
  e32     NUMBER(19,2),
  f32     NUMBER(19,2),
  g32     NUMBER(19,2),
  h32     NUMBER(19,2),
  b33     VARCHAR2(255),
  c33     VARCHAR2(255),
  d33     NUMBER(19,2),
  e33     NUMBER(19,2),
  f33     NUMBER(19,2),
  g33     NUMBER(19,2),
  h33     NUMBER(19,2),
  b34     VARCHAR2(255),
  c34     VARCHAR2(255),
  d34     NUMBER(19,2),
  e34     NUMBER(19,2),
  f34     NUMBER(19,2),
  g34     NUMBER(19,2),
  h34     NUMBER(19,2),
  b35     VARCHAR2(255),
  c35     VARCHAR2(255),
  d35     NUMBER(19,2),
  e35     NUMBER(19,2),
  f35     NUMBER(19,2),
  g35     NUMBER(19,2),
  h35     NUMBER(19,2),
  b36     VARCHAR2(255),
  c36     VARCHAR2(255),
  d36     NUMBER(19,2),
  e36     NUMBER(19,2),
  f36     NUMBER(19,2),
  g36     NUMBER(19,2),
  h36     NUMBER(19,2)
)
;
comment on table T_CSRC0707_E1_2
  is '֤ȯͶҵֲרܱ';

prompt
prompt Creating table T_CSRC0707_E1_4
prompt ==============================
prompt
create table T_CSRC0707_E1_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER,
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      VARCHAR2(255)
)
;
comment on table T_CSRC0707_E1_4
  is 'Ŀϸרܱ';

prompt
prompt Creating table T_CSRC0707_E1_5
prompt ==============================
prompt
create table T_CSRC0707_E1_5
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d2      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  c4      NUMBER(19,2),
  c5      NUMBER(19,2),
  d5      NUMBER(19,2),
  e5      NUMBER(19,2),
  f5      NUMBER(19,2)
)
;
comment on table T_CSRC0707_E1_5
  is 'ضƷϯλϢרܱ';

prompt
prompt Creating table T_CSRC0707_E1_6_1
prompt ================================
prompt
create table T_CSRC0707_E1_6_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      DATE,
  g2      VARCHAR2(255)
)
;
comment on table T_CSRC0707_E1_6_1
  is '֤ȯ˾Ϣϵͳרܱʹϵͳ';

prompt
prompt Creating table T_CSRC0707_E1_6_2
prompt ================================
prompt
create table T_CSRC0707_E1_6_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      NUMBER(19,2),
  c2      VARCHAR2(255),
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255)
)
;
comment on table T_CSRC0707_E1_6_2
  is '֤ȯ˾ϢϵͳרܱӲ';

prompt
prompt Creating table T_CSRC0707_E1_6_3
prompt ================================
prompt
create table T_CSRC0707_E1_6_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      VARCHAR2(255),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255),
  g2      VARCHAR2(255),
  h2      VARCHAR2(255),
  i2      VARCHAR2(255)
)
;
comment on table T_CSRC0707_E1_6_3
  is '֤ȯ˾Ϣϵͳרܱ¹ʱ';

prompt
prompt Creating table T_CSRC0707_E1_6_4
prompt ================================
prompt
create table T_CSRC0707_E1_6_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(1),
  c2      NUMBER(19,2),
  d2      NUMBER(19,2),
  e2      NUMBER(19,2),
  f2      VARCHAR2(255),
  g2      VARCHAR2(255)
)
;
comment on table T_CSRC0707_E1_6_4
  is '֤ȯ˾ϢϵͳרܱӪҵ';

prompt
prompt Creating table T_CSRC0707_E1_7
prompt ==============================
prompt
create table T_CSRC0707_E1_7
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b4      VARCHAR2(255),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  e4      NUMBER(18,2),
  f4      NUMBER(18,2),
  g4      NUMBER(18,2),
  b5      VARCHAR2(255),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  e5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  b6      VARCHAR2(255),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  e6      NUMBER(18,2),
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  b7      VARCHAR2(255),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  e7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  b8      VARCHAR2(255),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  e8      NUMBER(18,2),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  b9      VARCHAR2(255),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  b10     VARCHAR2(255),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  g10     NUMBER(18,2),
  b11     VARCHAR2(255),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  e11     NUMBER(18,2),
  f11     NUMBER(18,2),
  g11     NUMBER(18,2),
  b12     VARCHAR2(255),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  e12     NUMBER(18,2),
  f12     NUMBER(18,2),
  g12     NUMBER(18,2),
  b13     VARCHAR2(255),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  e13     NUMBER(18,2),
  f13     NUMBER(18,2),
  g13     NUMBER(18,2),
  b17     VARCHAR2(255),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  e17     NUMBER(18,2),
  f17     NUMBER(18,2),
  g17     NUMBER(18,2),
  b18     VARCHAR2(255),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  e18     NUMBER(18,2),
  f18     NUMBER(18,2),
  g18     NUMBER(18,2),
  b19     VARCHAR2(255),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     NUMBER(18,2),
  f19     NUMBER(18,2),
  g19     NUMBER(18,2),
  b20     VARCHAR2(255),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  e20     NUMBER(18,2),
  f20     NUMBER(18,2),
  g20     NUMBER(18,2),
  b21     VARCHAR2(255),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  e21     NUMBER(18,2),
  f21     NUMBER(18,2),
  g21     NUMBER(18,2),
  b22     VARCHAR2(255),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  e22     NUMBER(18,2),
  f22     NUMBER(18,2),
  g22     NUMBER(18,2),
  b23     VARCHAR2(255),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  e23     NUMBER(18,2),
  f23     NUMBER(18,2),
  g23     NUMBER(18,2),
  b24     VARCHAR2(255),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  e24     NUMBER(18,2),
  f24     NUMBER(18,2),
  g24     NUMBER(18,2),
  b25     VARCHAR2(255),
  c25     NUMBER(18,2),
  d25     NUMBER(18,2),
  e25     NUMBER(18,2),
  f25     NUMBER(18,2),
  g25     NUMBER(18,2),
  b26     VARCHAR2(255),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  e26     NUMBER(18,2),
  f26     NUMBER(18,2),
  g26     NUMBER(18,2),
  b30     VARCHAR2(255),
  c30     VARCHAR2(100),
  d30     NUMBER(18,2),
  e30     NUMBER(18),
  f30     NUMBER(18,2),
  b31     VARCHAR2(255),
  c31     VARCHAR2(100),
  d31     NUMBER(18,2),
  e31     NUMBER(18),
  f31     NUMBER(18,2),
  b32     VARCHAR2(255),
  c32     VARCHAR2(100),
  d32     NUMBER(18,2),
  e32     NUMBER(18),
  f32     NUMBER(18,2),
  b33     VARCHAR2(255),
  c33     VARCHAR2(100),
  d33     NUMBER(18,2),
  e33     NUMBER(18),
  f33     NUMBER(18,2),
  b34     VARCHAR2(255),
  c34     VARCHAR2(100),
  d34     NUMBER(18,2),
  e34     NUMBER(18),
  f34     NUMBER(18,2),
  b35     VARCHAR2(255),
  c35     VARCHAR2(100),
  d35     NUMBER(18,2),
  e35     NUMBER(18),
  f35     NUMBER(18,2),
  b36     VARCHAR2(255),
  c36     VARCHAR2(100),
  d36     NUMBER(18,2),
  e36     NUMBER(18),
  f36     NUMBER(18,2),
  b37     VARCHAR2(255),
  c37     VARCHAR2(100),
  d37     NUMBER(18,2),
  e37     NUMBER(18),
  f37     NUMBER(18,2),
  b38     VARCHAR2(255),
  c38     VARCHAR2(100),
  d38     NUMBER(18,2),
  e38     NUMBER(18),
  f38     NUMBER(18,2),
  b39     VARCHAR2(255),
  c39     VARCHAR2(100),
  d39     NUMBER(18,2),
  e39     NUMBER(18),
  f39     NUMBER(18,2),
  b43     VARCHAR2(255),
  c43     VARCHAR2(100),
  d43     NUMBER(18,2),
  e43     NUMBER(18),
  f43     NUMBER(18,2),
  b44     VARCHAR2(255),
  c44     VARCHAR2(100),
  d44     NUMBER(18,2),
  e44     NUMBER(18),
  f44     NUMBER(18,2),
  b45     VARCHAR2(255),
  c45     VARCHAR2(100),
  d45     NUMBER(18,2),
  e45     NUMBER(18),
  f45     NUMBER(18,2),
  b46     VARCHAR2(255),
  c46     VARCHAR2(100),
  d46     NUMBER(18,2),
  e46     NUMBER(18),
  f46     NUMBER(18,2),
  b47     VARCHAR2(255),
  c47     VARCHAR2(100),
  d47     NUMBER(18,2),
  e47     NUMBER(18),
  f47     NUMBER(18,2),
  b48     VARCHAR2(255),
  c48     VARCHAR2(100),
  d48     NUMBER(18,2),
  e48     NUMBER(18),
  f48     NUMBER(18,2),
  b49     VARCHAR2(255),
  c49     VARCHAR2(100),
  d49     NUMBER(18,2),
  e49     NUMBER(18),
  f49     NUMBER(18,2),
  b50     VARCHAR2(255),
  c50     VARCHAR2(100),
  d50     NUMBER(18,2),
  e50     NUMBER(18),
  f50     NUMBER(18,2),
  b51     VARCHAR2(255),
  c51     VARCHAR2(100),
  d51     NUMBER(18,2),
  e51     NUMBER(18),
  f51     NUMBER(18,2),
  b52     VARCHAR2(255),
  c52     VARCHAR2(100),
  d52     NUMBER(18,2),
  e52     NUMBER(18),
  f52     NUMBER(18,2),
  b55     VARCHAR2(255),
  c55     VARCHAR2(100),
  d55     NUMBER(18,2),
  e55     NUMBER(18,2),
  b56     VARCHAR2(255),
  c56     VARCHAR2(100),
  d56     NUMBER(18,2),
  e56     NUMBER(18,2),
  b57     VARCHAR2(255),
  c57     VARCHAR2(100),
  d57     NUMBER(18,2),
  e57     NUMBER(18,2),
  b58     VARCHAR2(255),
  c58     VARCHAR2(100),
  d58     NUMBER(18,2),
  e58     NUMBER(18,2),
  b59     VARCHAR2(255),
  c59     VARCHAR2(100),
  d59     NUMBER(18,2),
  e59     NUMBER(18,2),
  b60     VARCHAR2(255),
  c60     VARCHAR2(100),
  d60     NUMBER(18,2),
  e60     NUMBER(18,2),
  b61     VARCHAR2(255),
  c61     VARCHAR2(100),
  d61     NUMBER(18,2),
  e61     NUMBER(18,2),
  b62     VARCHAR2(255),
  c62     VARCHAR2(100),
  d62     NUMBER(18,2),
  e62     NUMBER(18,2),
  b63     VARCHAR2(255),
  c63     VARCHAR2(100),
  d63     NUMBER(18,2),
  e63     NUMBER(18,2),
  b64     VARCHAR2(255),
  c64     VARCHAR2(100),
  d64     NUMBER(18,2),
  e64     NUMBER(18,2),
  b67     VARCHAR2(255),
  c67     DATE,
  d67     NUMBER(18,2),
  e67     NUMBER(18,2),
  b68     VARCHAR2(255),
  c68     DATE,
  d68     NUMBER(18,2),
  e68     NUMBER(18,2),
  b69     VARCHAR2(255),
  c69     DATE,
  d69     NUMBER(18,2),
  e69     NUMBER(18,2),
  b70     VARCHAR2(255),
  c70     DATE,
  d70     NUMBER(18,2),
  e70     NUMBER(18,2),
  b71     VARCHAR2(255),
  c71     DATE,
  d71     NUMBER(18,2),
  e71     NUMBER(18,2),
  b72     VARCHAR2(255),
  c72     DATE,
  d72     NUMBER(18,2),
  e72     NUMBER(18,2),
  b73     VARCHAR2(255),
  c73     DATE,
  d73     NUMBER(18,2),
  e73     NUMBER(18,2),
  b74     VARCHAR2(255),
  c74     DATE,
  d74     NUMBER(18,2),
  e74     NUMBER(18,2),
  b75     VARCHAR2(255),
  c75     DATE,
  d75     NUMBER(18,2),
  e75     NUMBER(18,2),
  b76     VARCHAR2(255),
  c76     DATE,
  d76     NUMBER(18,2),
  e76     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC0707_E1_7_3
prompt ================================
prompt
create table T_CSRC0707_E1_7_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a4      NUMBER,
  b4      VARCHAR2(255),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  e4      NUMBER(18,2),
  f4      NUMBER(18,2),
  g4      NUMBER(18,2)
)
;
comment on table T_CSRC0707_E1_7_3
  is 'ȯҵϸܱ';

prompt
prompt Creating table T_CSRC0707_E1_8_1
prompt ================================
prompt
create table T_CSRC0707_E1_8_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      DATE,
  c3      VARCHAR2(200),
  d3      VARCHAR2(200),
  e3      NUMBER(18,2),
  f3      VARCHAR2(200),
  g3      DATE,
  h3      DATE,
  i3      NUMBER(18,2),
  j3      VARCHAR2(200),
  k3      VARCHAR2(200),
  l3      VARCHAR2(20),
  m3      VARCHAR2(200),
  n3      VARCHAR2(200),
  o3      DATE
)
;
comment on table T_CSRC0707_E1_8_1
  is '֤ȯ˾ʻרܱ-ϸ';

prompt
prompt Creating table T_CSRC0707_E1_8_2
prompt ================================
prompt
create table T_CSRC0707_E1_8_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER,
  b3      VARCHAR2(200),
  c3      NUMBER(19,2),
  d3      NUMBER(19,2),
  e3      NUMBER(19,2),
  f3      NUMBER(19,2),
  g3      NUMBER(19,2),
  h3      NUMBER(19,2),
  i3      NUMBER(19,2),
  j3      NUMBER(19,2),
  k3      NUMBER(19,2),
  l3      NUMBER(19,2),
  m3      NUMBER(19,2),
  n3      NUMBER(19,2),
  o3      NUMBER(19,2),
  p3      NUMBER(19,2),
  q3      NUMBER(19,2),
  r3      NUMBER(19,2),
  s3      NUMBER(19,2)
)
;
comment on table T_CSRC0707_E1_8_2
  is '֤ȯ˾ʻרܱ-ܱ';

prompt
prompt Creating table T_CSRC0710_0_3
prompt =============================
prompt
create table T_CSRC0710_0_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      DATE,
  b2      VARCHAR2(255),
  c2      NUMBER,
  d2      NUMBER,
  e2      NUMBER,
  f2      NUMBER,
  g2      NUMBER,
  h2      VARCHAR2(1),
  i2      VARCHAR2(255),
  j2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0710_0_6
prompt =============================
prompt
create table T_CSRC0710_0_6
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  a4      NUMBER(19,2),
  b4      NUMBER(19,2),
  c4      NUMBER(19,2),
  d4      NUMBER(19,2),
  e4      VARCHAR2(1),
  f4      VARCHAR2(255)
)
;
comment on table T_CSRC0710_0_6
  is 'ܽչ';

prompt
prompt Creating table T_CSRC0730_E1_10
prompt ===============================
prompt
create table T_CSRC0730_E1_10
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      NUMBER(18,2),
  e2      VARCHAR2(255),
  f2      NUMBER(18,2),
  g2      NUMBER(18,2),
  h2      NUMBER(18,2),
  i2      VARCHAR2(255),
  j2      NUMBER(18,2),
  k2      NUMBER(12),
  l2      VARCHAR2(255)
)
;
comment on table T_CSRC0730_E1_10
  is '֤ȯ˾Ͷҵ¶ȱ';
comment on column T_CSRC0730_E1_10.a2
  is '

';
comment on column T_CSRC0730_E1_10.b2
  is 'Ͷӹ˾';
comment on column T_CSRC0730_E1_10.c2
  is '֤ȯ˾';
comment on column T_CSRC0730_E1_10.d2
  is 'עʱ';
comment on column T_CSRC0730_E1_10.e2
  is 'ע';
comment on column T_CSRC0730_E1_10.f2
  is 'ʲ';
comment on column T_CSRC0730_E1_10.g2
  is 'ʲ';
comment on column T_CSRC0730_E1_10.h2
  is 'ۼƾ';
comment on column T_CSRC0730_E1_10.i2
  is 'ͶʵƷֻĿ';
comment on column T_CSRC0730_E1_10.j2
  is 'ͶʵĽ';
comment on column T_CSRC0730_E1_10.k2
  is 'Ա';
comment on column T_CSRC0730_E1_10.l2
  is '³ܾ

ֻź';

prompt
prompt Creating table T_CSRC0730_E1_9
prompt ==============================
prompt
create table T_CSRC0730_E1_9
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      NUMBER(18,2),
  e2      VARCHAR2(255),
  f2      NUMBER(18,2),
  g2      NUMBER(18,2),
  h2      NUMBER(18,2),
  i2      NUMBER(12),
  j2      NUMBER(18,2),
  k2      NUMBER(12),
  l2      NUMBER(18,2),
  m2      NUMBER(12),
  n2      NUMBER(18,2),
  o2      NUMBER(12),
  p2      VARCHAR2(255)
)
;
comment on table T_CSRC0730_E1_9
  is '֤ȯ˾ֱͶҵ¶ȱ';
comment on column T_CSRC0730_E1_9.a2
  is '

';
comment on column T_CSRC0730_E1_9.b2
  is 'ֱͶӹ˾';
comment on column T_CSRC0730_E1_9.c2
  is '֤ȯ˾';
comment on column T_CSRC0730_E1_9.d2
  is 'עʱ';
comment on column T_CSRC0730_E1_9.e2
  is 'ע';
comment on column T_CSRC0730_E1_9.f2
  is 'ʲ';
comment on column T_CSRC0730_E1_9.g2
  is 'ʲ';
comment on column T_CSRC0730_E1_9.h2
  is 'ۼƾ';
comment on column T_CSRC0730_E1_9.i2
  is 'ۼͶ

Ŀ';
comment on column T_CSRC0730_E1_9.j2
  is 'ۼͶ

ʽܶ';
comment on column T_CSRC0730_E1_9.k2
  is 'ֱͶ

';
comment on column T_CSRC0730_E1_9.l2
  is 'ֱͶļ

ʽܶ';
comment on column T_CSRC0730_E1_9.m2
  is 'ֱͶͶ

Ŀ';
comment on column T_CSRC0730_E1_9.n2
  is 'ֱͶͶ

ʽܶ';
comment on column T_CSRC0730_E1_9.o2
  is 'ֱͶӹ˾

Ա';
comment on column T_CSRC0730_E1_9.p2
  is 'ֱͶӹ˾³ܾ

ֻź';

prompt
prompt Creating table T_CSRC0811_ZQGS_1
prompt ================================
prompt
create table T_CSRC0811_ZQGS_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      VARCHAR2(50),
  d2      VARCHAR2(50),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255),
  g2      VARCHAR2(50),
  c3      VARCHAR2(50),
  d3      VARCHAR2(50),
  e3      VARCHAR2(255),
  f3      VARCHAR2(255),
  g3      VARCHAR2(50),
  c4      VARCHAR2(50),
  d4      VARCHAR2(50),
  e4      VARCHAR2(255),
  f4      VARCHAR2(255),
  g4      VARCHAR2(50),
  c5      VARCHAR2(50),
  d5      VARCHAR2(50),
  e5      VARCHAR2(255),
  f5      VARCHAR2(255),
  g5      VARCHAR2(50),
  c6      VARCHAR2(50),
  d6      VARCHAR2(50),
  e6      VARCHAR2(255),
  f6      VARCHAR2(255),
  g6      VARCHAR2(50),
  d8      VARCHAR2(255),
  d9      VARCHAR2(4000),
  d10     VARCHAR2(255),
  d12     VARCHAR2(50),
  e12     VARCHAR2(255),
  d13     VARCHAR2(50),
  e13     VARCHAR2(255),
  d14     VARCHAR2(50),
  e14     VARCHAR2(255),
  d15     VARCHAR2(50),
  e15     VARCHAR2(255),
  d16     VARCHAR2(50),
  e16     VARCHAR2(255),
  d17     VARCHAR2(50),
  e17     VARCHAR2(255),
  d18     VARCHAR2(50),
  e18     VARCHAR2(255),
  d19     VARCHAR2(50),
  e19     VARCHAR2(255),
  d20     VARCHAR2(50),
  e20     VARCHAR2(255),
  d21     VARCHAR2(50),
  e21     VARCHAR2(255),
  d23     NUMBER(12),
  e23     VARCHAR2(255),
  d24     NUMBER(12),
  e24     VARCHAR2(255),
  d26     VARCHAR2(50),
  e26     VARCHAR2(50),
  d27     NUMBER(12),
  d28     NUMBER(12),
  d29     NUMBER(12),
  d30     NUMBER(12),
  d31     NUMBER(12),
  d32     NUMBER(12),
  d33     NUMBER(12),
  d34     NUMBER(12),
  d35     NUMBER(12),
  d36     NUMBER(12),
  d37     NUMBER(12),
  d38     NUMBER(12),
  d39     NUMBER(12),
  d40     NUMBER(12),
  d41     NUMBER(12),
  d42     NUMBER(12),
  d44     DATE,
  d45     CHAR(1),
  d46     VARCHAR2(255),
  d47     CHAR(1),
  d48     VARCHAR2(4000),
  d50     NUMBER(12,2),
  d51     NUMBER(12,2),
  d52     NUMBER(12,2),
  d53     NUMBER(12,2),
  d54     NUMBER(12,2),
  d55     NUMBER(12,2),
  d56     NUMBER(12,2),
  d57     NUMBER(12,2),
  d59     NUMBER(12),
  d60     NUMBER(12),
  d61     NUMBER(12),
  d62     NUMBER(12),
  d63     NUMBER(12),
  d64     VARCHAR2(4000),
  d65     VARCHAR2(4000),
  d66     VARCHAR2(4000),
  d68     VARCHAR2(50),
  e68     VARCHAR2(50),
  f68     VARCHAR2(50),
  g68     VARCHAR2(255),
  h68     VARCHAR2(255),
  i68     VARCHAR2(50),
  d69     VARCHAR2(50),
  e69     VARCHAR2(50),
  f69     VARCHAR2(50),
  g69     VARCHAR2(255),
  h69     VARCHAR2(255),
  i69     VARCHAR2(50),
  d71     CHAR(1),
  e71     NUMBER(12),
  f71     VARCHAR2(255),
  g71     VARCHAR2(4000),
  h71     CHAR(1),
  d73     CHAR(1),
  d74     CHAR(1),
  d75     CHAR(1),
  d77     NUMBER(12),
  d78     NUMBER(12),
  d80     VARCHAR2(100),
  e80     VARCHAR2(100),
  f80     VARCHAR2(100),
  g80     VARCHAR2(255),
  h80     VARCHAR2(255),
  i80     VARCHAR2(50),
  d81     NUMBER(12),
  a83     VARCHAR2(4000),
  d83     DATE,
  e83     VARCHAR2(4000),
  f83     CHAR(1),
  g83     VARCHAR2(4000),
  h83     VARCHAR2(4000),
  a84     VARCHAR2(4000),
  d84     DATE,
  e84     VARCHAR2(4000),
  f84     CHAR(1),
  g84     VARCHAR2(4000),
  h84     VARCHAR2(4000),
  a85     VARCHAR2(4000),
  d85     DATE,
  e85     VARCHAR2(4000),
  f85     CHAR(1),
  g85     VARCHAR2(4000),
  h85     VARCHAR2(4000),
  a86     VARCHAR2(4000),
  d86     DATE,
  e86     VARCHAR2(4000),
  f86     CHAR(1),
  g86     VARCHAR2(4000),
  h86     VARCHAR2(4000)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_2_1
prompt ==================================
prompt
create table T_CSRC0811_ZQGS_2_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(100),
  c2      VARCHAR2(100),
  d2      CHAR(1),
  e2      CHAR(1),
  f2      CHAR(1),
  g2      VARCHAR2(100),
  h2      CHAR(1),
  i2      VARCHAR2(100),
  j2      VARCHAR2(20),
  k2      VARCHAR2(20),
  l2      VARCHAR2(20),
  m2      DATE,
  n2      VARCHAR2(20),
  o2      VARCHAR2(20),
  p2      VARCHAR2(255),
  q2      NUMBER(12),
  r2      DATE,
  s2      VARCHAR2(255),
  t2      CHAR(1)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_2_2
prompt ==================================
prompt
create table T_CSRC0811_ZQGS_2_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(255),
  c3      CHAR(1),
  d3      NUMBER(12,2),
  e3      NUMBER(12,2),
  f3      CHAR(1),
  g3      VARCHAR2(50),
  h3      CHAR(1),
  i3      VARCHAR2(50),
  j3      VARCHAR2(50),
  k3      VARCHAR2(100),
  l3      VARCHAR2(50),
  m3      VARCHAR2(100),
  n3      NUMBER(12),
  o3      NUMBER(12,2)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_2_3
prompt ==================================
prompt
create table T_CSRC0811_ZQGS_2_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(100),
  c2      NUMBER(12,2),
  d2      NUMBER(12,2),
  e2      NUMBER(18),
  f2      NUMBER(18),
  g2      DATE,
  h2      NUMBER(12,2),
  i2      NUMBER(12,2),
  j2      NUMBER(12),
  k2      NUMBER(12,2),
  l2      NUMBER(12),
  m2      CHAR(1),
  n2      NUMBER(12,2),
  o2      NUMBER(12),
  p2      NUMBER(12,2),
  q2      NUMBER(12,2),
  r2      VARCHAR2(50)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_2_4
prompt ==================================
prompt
create table T_CSRC0811_ZQGS_2_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d1      NUMBER(12),
  d2      NUMBER(12),
  d3      CHAR(1),
  d4      CHAR(1),
  d5      NUMBER(12),
  d6      CHAR(1),
  d7      CHAR(1),
  d8      NUMBER(12),
  d9      NUMBER(12,2),
  d11     VARCHAR2(24),
  d12     VARCHAR2(24),
  d13     VARCHAR2(24),
  d14     VARCHAR2(24),
  d15     VARCHAR2(24),
  d16     VARCHAR2(24),
  d18     NUMBER(12),
  d19     NUMBER(12),
  d20     NUMBER(12),
  d21     VARCHAR2(24),
  d22     VARCHAR2(24),
  d23     VARCHAR2(255),
  d24     CHAR(1),
  d25     CHAR(1),
  d26     VARCHAR2(24),
  d27     VARCHAR2(24),
  d28     CHAR(1),
  d29     CHAR(1),
  d30     CHAR(1),
  d31     VARCHAR2(255),
  d32     CHAR(1),
  d33     VARCHAR2(255),
  d34     CHAR(1),
  d35     VARCHAR2(255),
  d36     CHAR(1),
  d37     VARCHAR2(255),
  d38     CHAR(1),
  d39     VARCHAR2(255),
  d40     CHAR(1),
  d41     CHAR(1),
  d42     CHAR(1),
  d43     CHAR(1),
  d44     CHAR(1),
  d45     CHAR(1),
  d46     CHAR(1),
  d47     CHAR(1),
  d48     CHAR(1),
  d49     CHAR(1),
  d50     CHAR(1),
  d51     CHAR(1),
  d52     CHAR(1),
  d53     CHAR(1),
  d54     CHAR(1),
  d55     CHAR(1),
  d56     CHAR(1),
  d57     CHAR(1),
  d58     CHAR(1),
  d60     NUMBER(12),
  d61     NUMBER(12),
  d62     NUMBER(12),
  d63     NUMBER(12),
  d64     NUMBER(12),
  d65     NUMBER(12),
  d66     NUMBER(12),
  d67     NUMBER(12),
  d69     NUMBER(12),
  d70     NUMBER(12),
  d71     NUMBER(12),
  d72     NUMBER(12),
  d73     NUMBER(12),
  d74     NUMBER(12),
  d75     NUMBER(12),
  d76     NUMBER(12),
  d78     NUMBER(12),
  d79     NUMBER(12),
  d80     NUMBER(12),
  d81     NUMBER(12),
  d82     NUMBER(12),
  d84     NUMBER(12),
  d85     NUMBER(12),
  d86     NUMBER(12),
  d87     NUMBER(12),
  d88     NUMBER(12),
  d90     NUMBER(12),
  d91     NUMBER(12),
  d92     NUMBER(12),
  d93     NUMBER(12),
  d94     NUMBER(12)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_3
prompt ================================
prompt
create table T_CSRC0811_ZQGS_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(255),
  c2      VARCHAR2(255),
  d2      VARCHAR2(24),
  e2      VARCHAR2(255),
  f2      VARCHAR2(255),
  g2      VARCHAR2(255),
  h2      VARCHAR2(255),
  i2      VARCHAR2(255),
  j2      VARCHAR2(24),
  k2      VARCHAR2(255),
  l2      VARCHAR2(255),
  m2      VARCHAR2(24),
  n2      VARCHAR2(50),
  o2      CHAR(1),
  p2      CHAR(1),
  q2      NUMBER(12),
  r2      NUMBER(12),
  s2      NUMBER(12),
  t2      NUMBER(12,2),
  u2      NUMBER(12,2),
  v2      NUMBER(12,2)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_3_1
prompt ==================================
prompt
create table T_CSRC0811_ZQGS_3_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(100),
  c3      VARCHAR2(100),
  d3      VARCHAR2(24),
  e3      VARCHAR2(100),
  f3      VARCHAR2(100),
  g3      CHAR(1),
  h3      NUMBER(12),
  i3      NUMBER(12),
  j3      NUMBER(12),
  k3      NUMBER(12,2),
  l3      NUMBER(12,2),
  m3      NUMBER(12,2),
  n3      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_3_2
prompt ==================================
prompt
create table T_CSRC0811_ZQGS_3_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(100),
  c2      VARCHAR2(100),
  d2      VARCHAR2(100),
  e2      VARCHAR2(100),
  f2      VARCHAR2(24),
  g2      VARCHAR2(12),
  h2      NUMBER(12,2),
  i2      NUMBER(12,2),
  j2      VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_4
prompt ================================
prompt
create table T_CSRC0811_ZQGS_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b3      DATE,
  b4      DATE,
  b5      VARCHAR2(255),
  b6      VARCHAR2(255),
  b7      VARCHAR2(255),
  b9      CHAR(1),
  b10     CHAR(1),
  b11     CHAR(1),
  b12     CHAR(1),
  b13     CHAR(1),
  b15     NUMBER(12),
  a17     VARCHAR2(4000),
  b17     DATE,
  c17     VARCHAR2(4000),
  d17     VARCHAR2(4000),
  a18     VARCHAR2(4000),
  b18     DATE,
  c18     VARCHAR2(4000),
  d18     VARCHAR2(4000),
  a19     VARCHAR2(4000),
  b19     DATE,
  c19     VARCHAR2(4000),
  d19     VARCHAR2(4000),
  a20     VARCHAR2(4000),
  b20     DATE,
  c20     VARCHAR2(4000),
  d20     VARCHAR2(4000),
  a21     VARCHAR2(4000),
  b21     DATE,
  c21     VARCHAR2(4000),
  d21     VARCHAR2(4000),
  a22     VARCHAR2(4000),
  b22     DATE,
  c22     VARCHAR2(4000),
  d22     VARCHAR2(4000),
  a23     VARCHAR2(4000),
  b23     DATE,
  c23     VARCHAR2(4000),
  d23     VARCHAR2(4000),
  a24     VARCHAR2(4000),
  b24     DATE,
  c24     VARCHAR2(4000),
  d24     VARCHAR2(4000),
  a25     VARCHAR2(4000),
  b25     DATE,
  c25     VARCHAR2(4000),
  d25     VARCHAR2(4000),
  a26     VARCHAR2(4000),
  b26     DATE,
  c26     VARCHAR2(4000),
  d26     VARCHAR2(4000),
  a27     VARCHAR2(4000),
  b27     DATE,
  c27     VARCHAR2(4000),
  d27     VARCHAR2(4000),
  a28     VARCHAR2(4000),
  b28     DATE,
  c28     VARCHAR2(4000),
  d28     VARCHAR2(4000),
  a29     VARCHAR2(4000),
  b29     DATE,
  c29     VARCHAR2(4000),
  d29     VARCHAR2(4000),
  a30     VARCHAR2(4000),
  b30     DATE,
  c30     VARCHAR2(4000),
  d30     VARCHAR2(4000),
  a31     VARCHAR2(4000),
  b31     DATE,
  c31     VARCHAR2(4000),
  d31     VARCHAR2(4000),
  a32     VARCHAR2(4000),
  b32     DATE,
  c32     VARCHAR2(4000),
  d32     VARCHAR2(4000),
  a33     VARCHAR2(4000),
  b33     DATE,
  c33     VARCHAR2(4000),
  d33     VARCHAR2(4000),
  a34     VARCHAR2(4000),
  b34     DATE,
  c34     VARCHAR2(4000),
  d34     VARCHAR2(4000),
  a35     VARCHAR2(4000),
  b35     DATE,
  c35     VARCHAR2(4000),
  d35     VARCHAR2(4000),
  a36     VARCHAR2(4000),
  b36     DATE,
  c36     VARCHAR2(4000),
  d36     VARCHAR2(4000),
  a37     VARCHAR2(4000),
  b37     DATE,
  c37     VARCHAR2(4000),
  d37     VARCHAR2(4000),
  a38     VARCHAR2(4000),
  b38     DATE,
  c38     VARCHAR2(4000),
  d38     VARCHAR2(4000),
  a39     VARCHAR2(4000),
  b39     DATE,
  c39     VARCHAR2(4000),
  d39     VARCHAR2(4000),
  a40     VARCHAR2(4000),
  b40     DATE,
  c40     VARCHAR2(4000),
  d40     VARCHAR2(4000),
  a41     VARCHAR2(4000),
  b41     DATE,
  c41     VARCHAR2(4000),
  d41     VARCHAR2(4000),
  a42     VARCHAR2(4000),
  b42     DATE,
  c42     VARCHAR2(4000),
  d42     VARCHAR2(4000),
  a43     VARCHAR2(4000),
  b43     DATE,
  c43     VARCHAR2(4000),
  d43     VARCHAR2(4000),
  a44     VARCHAR2(4000),
  b44     DATE,
  c44     VARCHAR2(4000),
  d44     VARCHAR2(4000)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_5
prompt ================================
prompt
create table T_CSRC0811_ZQGS_5
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      VARCHAR2(12),
  g2      VARCHAR2(12),
  k2      VARCHAR2(12),
  o2      VARCHAR2(12),
  c4      VARCHAR2(255),
  e4      VARCHAR2(255),
  g4      VARCHAR2(255),
  i4      VARCHAR2(255),
  k4      VARCHAR2(255),
  m4      VARCHAR2(255),
  o4      VARCHAR2(255),
  q4      VARCHAR2(255),
  c5      VARCHAR2(24),
  e5      VARCHAR2(24),
  g5      VARCHAR2(24),
  i5      VARCHAR2(24),
  k5      VARCHAR2(24),
  m5      VARCHAR2(24),
  o5      VARCHAR2(24),
  q5      VARCHAR2(24),
  c6      DATE,
  e6      DATE,
  g6      DATE,
  i6      DATE,
  k6      DATE,
  m6      DATE,
  o6      DATE,
  q6      DATE,
  c7      VARCHAR2(255),
  e7      VARCHAR2(255),
  g7      VARCHAR2(255),
  i7      VARCHAR2(255),
  k7      VARCHAR2(255),
  m7      VARCHAR2(255),
  o7      VARCHAR2(255),
  q7      VARCHAR2(255),
  c8      CHAR(1),
  e8      CHAR(1),
  g8      CHAR(1),
  i8      CHAR(1),
  k8      CHAR(1),
  m8      CHAR(1),
  o8      CHAR(1),
  q8      CHAR(1),
  c9      CHAR(1),
  e9      CHAR(1),
  g9      CHAR(1),
  i9      CHAR(1),
  k9      CHAR(1),
  m9      CHAR(1),
  o9      CHAR(1),
  q9      CHAR(1),
  c10     NUMBER(12,2),
  g10     NUMBER(12,2),
  k10     NUMBER(12,2),
  o10     NUMBER(12,2),
  c11     NUMBER(12,2),
  g11     NUMBER(12,2),
  k11     NUMBER(12,2),
  o11     NUMBER(12,2),
  c12     CHAR(1),
  e12     CHAR(1),
  g12     CHAR(1),
  i12     CHAR(1),
  k12     CHAR(1),
  m12     CHAR(1),
  o12     CHAR(1),
  q12     CHAR(1),
  c13     NUMBER(12,2),
  e13     NUMBER(12,2),
  g13     NUMBER(12,2),
  i13     NUMBER(12,2),
  k13     NUMBER(12,2),
  m13     NUMBER(12,2),
  o13     NUMBER(12,2),
  q13     NUMBER(12,2),
  c14     NUMBER(12,2),
  e14     NUMBER(12,2),
  g14     NUMBER(12,2),
  i14     NUMBER(12,2),
  k14     NUMBER(12,2),
  m14     NUMBER(12,2),
  o14     NUMBER(12,2),
  q14     NUMBER(12,2),
  c15     NUMBER(12,2),
  e15     NUMBER(12,2),
  g15     NUMBER(12,2),
  i15     NUMBER(12,2),
  k15     NUMBER(12,2),
  m15     NUMBER(12,2),
  o15     NUMBER(12,2),
  q15     NUMBER(12,2),
  c16     CHAR(1),
  e16     CHAR(1),
  g16     CHAR(1),
  i16     CHAR(1),
  k16     CHAR(1),
  m16     CHAR(1),
  o16     CHAR(1),
  q16     CHAR(1),
  c17     CHAR(1),
  e17     CHAR(1),
  g17     CHAR(1),
  i17     CHAR(1),
  k17     CHAR(1),
  m17     CHAR(1),
  o17     CHAR(1),
  q17     CHAR(1),
  c18     CHAR(1),
  e18     CHAR(1),
  g18     CHAR(1),
  i18     CHAR(1),
  k18     CHAR(1),
  m18     CHAR(1),
  o18     CHAR(1),
  q18     CHAR(1),
  c19     CHAR(1),
  e19     CHAR(1),
  g19     CHAR(1),
  i19     CHAR(1),
  k19     CHAR(1),
  m19     CHAR(1),
  o19     CHAR(1),
  q19     CHAR(1),
  c20     VARCHAR2(100),
  e20     VARCHAR2(100),
  g20     VARCHAR2(100),
  i20     VARCHAR2(100),
  k20     VARCHAR2(100),
  m20     VARCHAR2(100),
  o20     VARCHAR2(100),
  q20     VARCHAR2(100),
  c21     CHAR(1),
  e21     CHAR(1),
  g21     CHAR(1),
  i21     CHAR(1),
  k21     CHAR(1),
  m21     CHAR(1),
  o21     CHAR(1),
  q21     CHAR(1),
  c22     NUMBER(12,2),
  e22     NUMBER(12,2),
  g22     NUMBER(12,2),
  i22     NUMBER(12,2),
  k22     NUMBER(12,2),
  m22     NUMBER(12,2),
  o22     NUMBER(12,2),
  q22     NUMBER(12,2),
  c23     CHAR(1),
  e23     CHAR(1),
  g23     CHAR(1),
  i23     CHAR(1),
  k23     CHAR(1),
  m23     CHAR(1),
  o23     CHAR(1),
  q23     CHAR(1),
  c24     NUMBER(12,2),
  e24     NUMBER(12,2),
  g24     NUMBER(12,2),
  i24     NUMBER(12,2),
  k24     NUMBER(12,2),
  m24     NUMBER(12,2),
  o24     NUMBER(12,2),
  q24     NUMBER(12,2),
  c25     VARCHAR2(255),
  e25     VARCHAR2(255),
  g25     VARCHAR2(255),
  i25     VARCHAR2(255),
  k25     VARCHAR2(255),
  m25     VARCHAR2(255),
  o25     VARCHAR2(255),
  q25     VARCHAR2(255),
  c26     NUMBER(12,2),
  e26     NUMBER(12,2),
  g26     NUMBER(12,2),
  i26     NUMBER(12,2),
  k26     NUMBER(12,2),
  m26     NUMBER(12,2),
  o26     NUMBER(12,2),
  q26     NUMBER(12,2),
  c27     VARCHAR2(12),
  e27     VARCHAR2(12),
  g27     VARCHAR2(12),
  i27     VARCHAR2(12),
  k27     VARCHAR2(12),
  m27     VARCHAR2(12),
  o27     VARCHAR2(12),
  q27     VARCHAR2(12),
  c28     VARCHAR2(255),
  e28     VARCHAR2(255),
  g28     VARCHAR2(255),
  i28     VARCHAR2(255),
  k28     VARCHAR2(255),
  m28     VARCHAR2(255),
  o28     VARCHAR2(255),
  q28     VARCHAR2(255),
  c29     CHAR(1),
  e29     CHAR(1),
  g29     CHAR(1),
  i29     CHAR(1),
  k29     CHAR(1),
  m29     CHAR(1),
  o29     CHAR(1),
  q29     CHAR(1),
  c30     NUMBER(12,2),
  e30     NUMBER(12,2),
  g30     NUMBER(12,2),
  i30     NUMBER(12,2),
  k30     NUMBER(12,2),
  m30     NUMBER(12,2),
  o30     NUMBER(12,2),
  q30     NUMBER(12,2),
  c31     CHAR(1),
  e31     CHAR(1),
  g31     CHAR(1),
  i31     CHAR(1),
  k31     CHAR(1),
  m31     CHAR(1),
  o31     CHAR(1),
  q31     CHAR(1),
  c32     NUMBER(12,2),
  e32     NUMBER(12,2),
  g32     NUMBER(12,2),
  i32     NUMBER(12,2),
  k32     NUMBER(12,2),
  m32     NUMBER(12,2),
  o32     NUMBER(12,2),
  q32     NUMBER(12,2),
  c33     CHAR(1),
  e33     CHAR(1),
  g33     CHAR(1),
  i33     CHAR(1),
  k33     CHAR(1),
  m33     CHAR(1),
  o33     CHAR(1),
  q33     CHAR(1),
  c34     VARCHAR2(255),
  e34     VARCHAR2(255),
  g34     VARCHAR2(255),
  i34     VARCHAR2(255),
  k34     VARCHAR2(255),
  m34     VARCHAR2(255),
  o34     VARCHAR2(255),
  q34     VARCHAR2(255),
  c35     CHAR(1),
  e35     CHAR(1),
  g35     CHAR(1),
  i35     CHAR(1),
  k35     CHAR(1),
  m35     CHAR(1),
  o35     CHAR(1),
  q35     CHAR(1),
  c36     CHAR(1),
  e36     CHAR(1),
  g36     CHAR(1),
  i36     CHAR(1),
  k36     CHAR(1),
  m36     CHAR(1),
  o36     CHAR(1),
  q36     CHAR(1),
  c37     CHAR(1),
  e37     CHAR(1),
  g37     CHAR(1),
  i37     CHAR(1),
  k37     CHAR(1),
  m37     CHAR(1),
  o37     CHAR(1),
  q37     CHAR(1),
  c38     CHAR(1),
  e38     CHAR(1),
  g38     CHAR(1),
  i38     CHAR(1),
  k38     CHAR(1),
  m38     CHAR(1),
  o38     CHAR(1),
  q38     CHAR(1),
  c39     CHAR(1),
  e39     CHAR(1),
  g39     CHAR(1),
  i39     CHAR(1),
  k39     CHAR(1),
  m39     CHAR(1),
  o39     CHAR(1),
  q39     CHAR(1),
  c41     VARCHAR2(12),
  e41     VARCHAR2(12),
  g41     VARCHAR2(12),
  i41     VARCHAR2(12),
  k41     VARCHAR2(12),
  m41     VARCHAR2(12),
  o41     VARCHAR2(12),
  q41     VARCHAR2(12),
  c42     VARCHAR2(255),
  e42     VARCHAR2(255),
  g42     VARCHAR2(255),
  i42     VARCHAR2(255),
  k42     VARCHAR2(255),
  m42     VARCHAR2(255),
  o42     VARCHAR2(255),
  q42     VARCHAR2(255),
  c43     VARCHAR2(24),
  e43     VARCHAR2(24),
  g43     VARCHAR2(24),
  i43     VARCHAR2(24),
  k43     VARCHAR2(24),
  m43     VARCHAR2(24),
  o43     VARCHAR2(24),
  q43     VARCHAR2(24),
  c44     DATE,
  e44     DATE,
  g44     DATE,
  i44     DATE,
  k44     DATE,
  m44     DATE,
  o44     DATE,
  q44     DATE,
  c45     VARCHAR2(255),
  e45     VARCHAR2(255),
  g45     VARCHAR2(255),
  i45     VARCHAR2(255),
  k45     VARCHAR2(255),
  m45     VARCHAR2(255),
  o45     VARCHAR2(255),
  q45     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_6
prompt ================================
prompt
create table T_CSRC0811_ZQGS_6
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(255),
  c3      VARCHAR2(50),
  d3      VARCHAR2(50),
  e3      VARCHAR2(25),
  f3      VARCHAR2(255),
  g3      VARCHAR2(255),
  h3      VARCHAR2(50),
  i3      VARCHAR2(50),
  j3      VARCHAR2(50),
  k3      CHAR(1),
  l3      CHAR(1),
  m3      DATE,
  n3      DATE,
  o3      CHAR(1),
  p3      CHAR(1),
  q3      CHAR(1),
  r3      CHAR(1),
  s3      CHAR(1),
  t3      CHAR(1),
  u3      CHAR(1),
  v3      CHAR(1),
  w3      CHAR(1),
  x3      CHAR(1),
  y3      CHAR(1),
  z3      CHAR(1),
  aa3     CHAR(1)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_7
prompt ================================
prompt
create table T_CSRC0811_ZQGS_7
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      NUMBER(12),
  b3      VARCHAR2(100),
  c3      DATE,
  d3      VARCHAR2(50),
  e3      VARCHAR2(50),
  f3      NUMBER(12,2),
  g3      VARCHAR2(50),
  h3      VARCHAR2(50),
  i3      VARCHAR2(50),
  j3      CHAR(1),
  k3      CHAR(1),
  l3      VARCHAR2(255),
  m3      VARCHAR2(50),
  n3      VARCHAR2(50),
  o3      CHAR(1),
  p3      CHAR(1),
  q3      CHAR(1),
  r3      NUMBER(12),
  s3      NUMBER(12),
  t3      NUMBER(12),
  u3      NUMBER(18,2),
  v3      NUMBER(18,2),
  w3      CHAR(1),
  x3      VARCHAR2(20),
  y3      VARCHAR2(20),
  z3      VARCHAR2(20),
  aa3     VARCHAR2(20),
  ab3     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC0811_ZQGS_XXB
prompt ==================================
prompt
create table T_CSRC0811_ZQGS_XXB
(
  bbq      VARCHAR2(8),
  userid   VARCHAR2(18),
  btype    VARCHAR2(1),
  option1  VARCHAR2(12),
  shtag    VARCHAR2(1),
  upid     VARCHAR2(18),
  username VARCHAR2(100),
  b2       VARCHAR2(100),
  b3       VARCHAR2(100)
)
;

prompt
prompt Creating table T_CSRC0822_C13_1
prompt ===============================
prompt
create table T_CSRC0822_C13_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18),
  d2      NUMBER(18),
  e2      NUMBER(18),
  f2      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18),
  c5      NUMBER(18),
  d5      NUMBER(18),
  e5      NUMBER(18),
  f5      NUMBER(18),
  c6      NUMBER(18),
  d6      NUMBER(18),
  e6      NUMBER(18),
  f6      NUMBER(18),
  c7      NUMBER(18),
  d7      NUMBER(18),
  e7      NUMBER(18),
  f7      NUMBER(18),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  e8      NUMBER(18,2),
  f8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  c11     NUMBER(18,2),
  f11     NUMBER(18,2),
  c12     NUMBER(18,2),
  f12     NUMBER(18,2),
  c13     NUMBER(18,2),
  f13     NUMBER(18,2),
  c14     NUMBER(18,2),
  f14     NUMBER(18,2),
  c15     NUMBER(18,2),
  f15     NUMBER(18,2),
  c16     NUMBER(18,2),
  f16     NUMBER(18,2),
  c17     NUMBER(18,2),
  f17     NUMBER(18,2),
  c18     NUMBER(18,2),
  f18     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2)
)
;
comment on table T_CSRC0822_C13_1
  is 'Ѻʽۻع׼ܱ';

prompt
prompt Creating table T_CSRC0822_C13_2
prompt ===============================
prompt
create table T_CSRC0822_C13_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18),
  d2      NUMBER(18),
  e2      NUMBER(18),
  f2      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18),
  c5      NUMBER(18),
  d5      NUMBER(18),
  e5      NUMBER(18),
  f5      NUMBER(18),
  c6      NUMBER(18),
  d6      NUMBER(18),
  e6      NUMBER(18),
  f6      NUMBER(18),
  c7      NUMBER(18),
  d7      NUMBER(18),
  e7      NUMBER(18),
  f7      NUMBER(18),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  e8      NUMBER(18,2),
  f8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  c11     NUMBER(18,2),
  f11     NUMBER(18,2),
  c12     NUMBER(18,2),
  f12     NUMBER(18,2),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  e13     NUMBER(18,2),
  f13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  e14     NUMBER(18,2),
  f14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  e15     NUMBER(18,2),
  f15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  e16     NUMBER(18,2),
  f16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  e17     NUMBER(18,2),
  f17     NUMBER(18,2),
  c18     NUMBER(18),
  f18     NUMBER(18),
  c19     NUMBER(18),
  f19     NUMBER(18),
  c20     NUMBER(18),
  f20     NUMBER(18),
  c21     NUMBER(18,2),
  f21     NUMBER(18,2),
  c22     NUMBER(18,2),
  f22     NUMBER(18,2),
  c23     NUMBER(18,2),
  f23     NUMBER(18,2),
  c24     NUMBER(18,2),
  f24     NUMBER(18,2),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  a38     VARCHAR2(255),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  e38     NUMBER(18,2),
  f38     NUMBER(18,2),
  a39     VARCHAR2(255),
  c39     NUMBER(18,2),
  d39     NUMBER(18,2),
  e39     NUMBER(18,2),
  f39     NUMBER(18,2),
  a40     VARCHAR2(255),
  c40     NUMBER(18,2),
  d40     NUMBER(18,2),
  e40     NUMBER(18,2),
  f40     NUMBER(18,2),
  a41     VARCHAR2(255),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  e41     NUMBER(18,2),
  f41     NUMBER(18,2),
  a42     VARCHAR2(255),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  e42     NUMBER(18,2),
  f42     NUMBER(18,2),
  a44     VARCHAR2(255),
  c44     NUMBER(18),
  d44     NUMBER(18,2),
  e44     NUMBER(18,2),
  f44     NUMBER(18,2),
  a45     VARCHAR2(255),
  c45     NUMBER(18),
  d45     NUMBER(18,2),
  e45     NUMBER(18,2),
  f45     NUMBER(18,2),
  a46     VARCHAR2(255),
  c46     NUMBER(18),
  d46     NUMBER(18,2),
  e46     NUMBER(18,2),
  f46     NUMBER(18,2),
  a47     VARCHAR2(255),
  c47     NUMBER(18),
  d47     NUMBER(18,2),
  e47     NUMBER(18,2),
  f47     NUMBER(18,2),
  a48     VARCHAR2(255),
  c48     NUMBER(18),
  d48     NUMBER(18,2),
  e48     NUMBER(18,2),
  f48     NUMBER(18,2)
)
;
comment on table T_CSRC0822_C13_2
  is 'Լʽ֤ȯ׼ܱ';

prompt
prompt Creating table T_CSRC0822_C13_3
prompt ===============================
prompt
create table T_CSRC0822_C13_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18),
  d2      NUMBER(18),
  e2      NUMBER(18),
  f2      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18),
  c5      NUMBER(18),
  d5      NUMBER(18),
  e5      NUMBER(18),
  f5      NUMBER(18),
  c6      NUMBER(18),
  d6      NUMBER(18),
  e6      NUMBER(18),
  f6      NUMBER(18),
  c7      NUMBER(18),
  d7      NUMBER(18),
  e7      NUMBER(18),
  f7      NUMBER(18),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  e8      NUMBER(18,2),
  f8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  c11     NUMBER(18,2),
  f11     NUMBER(18,2),
  c12     NUMBER(18,2),
  f12     NUMBER(18,2),
  c13     NUMBER(18,2),
  f13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  e14     NUMBER(18,2),
  f14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  e15     NUMBER(18,2),
  f15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  e16     NUMBER(18,2),
  f16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  e17     NUMBER(18,2),
  f17     NUMBER(18,2),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  e18     NUMBER(18,2),
  f18     NUMBER(18,2),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     NUMBER(18,2),
  f19     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  e20     NUMBER(18,2),
  f20     NUMBER(18,2),
  c21     NUMBER(18),
  f21     NUMBER(18),
  c22     NUMBER(18),
  f22     NUMBER(18),
  c23     NUMBER(18),
  f23     NUMBER(18),
  c24     NUMBER(18,2),
  f24     NUMBER(18,2),
  c25     NUMBER(18,2),
  f25     NUMBER(18,2),
  c26     NUMBER(18,2),
  f26     NUMBER(18,2),
  c27     NUMBER(18,2),
  f27     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  c32     NUMBER(18,2),
  d32     NUMBER(18,2),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  a47     VARCHAR2(255),
  c47     NUMBER(18,2),
  d47     NUMBER(18,2),
  e47     NUMBER(18,2),
  f47     NUMBER(18,2),
  a48     VARCHAR2(255),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  e48     NUMBER(18,2),
  f48     NUMBER(18,2),
  a49     VARCHAR2(255),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  e49     NUMBER(18,2),
  f49     NUMBER(18,2),
  a50     VARCHAR2(255),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  e50     NUMBER(18,2),
  f50     NUMBER(18,2),
  a51     VARCHAR2(255),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  e51     NUMBER(18,2),
  f51     NUMBER(18,2),
  a53     VARCHAR2(255),
  c53     NUMBER(18),
  d53     NUMBER(18,2),
  e53     NUMBER(18,2),
  f53     NUMBER(18,2),
  a54     VARCHAR2(255),
  c54     NUMBER(18),
  d54     NUMBER(18,2),
  e54     NUMBER(18,2),
  f54     NUMBER(18,2),
  a55     VARCHAR2(255),
  c55     NUMBER(18),
  d55     NUMBER(18,2),
  e55     NUMBER(18,2),
  f55     NUMBER(18,2),
  a56     VARCHAR2(255),
  c56     NUMBER(18),
  d56     NUMBER(18,2),
  e56     NUMBER(18,2),
  f56     NUMBER(18,2),
  a57     VARCHAR2(255),
  c57     NUMBER(18),
  d57     NUMBER(18,2),
  e57     NUMBER(18,2),
  f57     NUMBER(18,2)
)
;
comment on table T_CSRC0822_C13_3
  is 'ƱѺʽعҵܱ';

prompt
prompt Creating table T_CSRC0822_C13_3_RH
prompt ==================================
prompt
create table T_CSRC0822_C13_3_RH
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18),
  d2      NUMBER(18),
  e2      NUMBER(18),
  f2      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18),
  c5      NUMBER(18),
  d5      NUMBER(18),
  e5      NUMBER(18),
  f5      NUMBER(18),
  c6      NUMBER(18),
  d6      NUMBER(18),
  e6      NUMBER(18),
  f6      NUMBER(18),
  c7      NUMBER(18),
  d7      NUMBER(18),
  e7      NUMBER(18),
  f7      NUMBER(18),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  e8      NUMBER(18,2),
  f8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  c11     NUMBER(18,2),
  f11     NUMBER(18,2),
  c12     NUMBER(18,2),
  f12     NUMBER(18,2),
  c13     NUMBER(18,2),
  f13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  e14     NUMBER(18,2),
  f14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  e15     NUMBER(18,2),
  f15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  e16     NUMBER(18,2),
  f16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  e17     NUMBER(18,2),
  f17     NUMBER(18,2),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  e18     NUMBER(18,2),
  f18     NUMBER(18,2),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     NUMBER(18,2),
  f19     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  e20     NUMBER(18,2),
  f20     NUMBER(18,2),
  c21     NUMBER(18),
  f21     NUMBER(18),
  c22     NUMBER(18),
  f22     NUMBER(18),
  c23     NUMBER(18),
  f23     NUMBER(18),
  c24     NUMBER(18,2),
  f24     NUMBER(18,2),
  c25     NUMBER(18,2),
  f25     NUMBER(18,2),
  c26     NUMBER(18,2),
  f26     NUMBER(18,2),
  c27     NUMBER(18,2),
  f27     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  c32     NUMBER(18,2),
  d32     NUMBER(18,2),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  a47     VARCHAR2(255),
  c47     NUMBER(18,2),
  d47     NUMBER(18,2),
  e47     NUMBER(18,2),
  f47     NUMBER(18,2),
  a48     VARCHAR2(255),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  e48     NUMBER(18,2),
  f48     NUMBER(18,2),
  a49     VARCHAR2(255),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  e49     NUMBER(18,2),
  f49     NUMBER(18,2),
  a50     VARCHAR2(255),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  e50     NUMBER(18,2),
  f50     NUMBER(18,2),
  a51     VARCHAR2(255),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  e51     NUMBER(18,2),
  f51     NUMBER(18,2),
  a53     VARCHAR2(255),
  c53     NUMBER(18),
  d53     NUMBER(18,2),
  e53     NUMBER(18,2),
  f53     NUMBER(18,2),
  a54     VARCHAR2(255),
  c54     NUMBER(18),
  d54     NUMBER(18,2),
  e54     NUMBER(18,2),
  f54     NUMBER(18,2),
  a55     VARCHAR2(255),
  c55     NUMBER(18),
  d55     NUMBER(18,2),
  e55     NUMBER(18,2),
  f55     NUMBER(18,2),
  a56     VARCHAR2(255),
  c56     NUMBER(18),
  d56     NUMBER(18,2),
  e56     NUMBER(18,2),
  f56     NUMBER(18,2),
  a57     VARCHAR2(255),
  c57     NUMBER(18),
  d57     NUMBER(18,2),
  e57     NUMBER(18,2),
  f57     NUMBER(18,2)
)
;
comment on table T_CSRC0822_C13_3_RH
  is 'ƱѺʽعҵܱ-ڻ';

prompt
prompt Creating table T_CSRC0822_C13_3_ZYZJ
prompt ====================================
prompt
create table T_CSRC0822_C13_3_ZYZJ
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18),
  d2      NUMBER(18),
  e2      NUMBER(18),
  f2      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18),
  c5      NUMBER(18),
  d5      NUMBER(18),
  e5      NUMBER(18),
  f5      NUMBER(18),
  c6      NUMBER(18),
  d6      NUMBER(18),
  e6      NUMBER(18),
  f6      NUMBER(18),
  c7      NUMBER(18),
  d7      NUMBER(18),
  e7      NUMBER(18),
  f7      NUMBER(18),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  e8      NUMBER(18,2),
  f8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  c11     NUMBER(18,2),
  f11     NUMBER(18,2),
  c12     NUMBER(18,2),
  f12     NUMBER(18,2),
  c13     NUMBER(18,2),
  f13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  e14     NUMBER(18,2),
  f14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  e15     NUMBER(18,2),
  f15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  e16     NUMBER(18,2),
  f16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  e17     NUMBER(18,2),
  f17     NUMBER(18,2),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  e18     NUMBER(18,2),
  f18     NUMBER(18,2),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     NUMBER(18,2),
  f19     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  e20     NUMBER(18,2),
  f20     NUMBER(18,2),
  c21     NUMBER(18),
  f21     NUMBER(18),
  c22     NUMBER(18),
  f22     NUMBER(18),
  c23     NUMBER(18),
  f23     NUMBER(18),
  c24     NUMBER(18,2),
  f24     NUMBER(18,2),
  c25     NUMBER(18,2),
  f25     NUMBER(18,2),
  c26     NUMBER(18,2),
  f26     NUMBER(18,2),
  c27     NUMBER(18,2),
  f27     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  c32     NUMBER(18,2),
  d32     NUMBER(18,2),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  a47     VARCHAR2(255),
  c47     NUMBER(18,2),
  d47     NUMBER(18,2),
  e47     NUMBER(18,2),
  f47     NUMBER(18,2),
  a48     VARCHAR2(255),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  e48     NUMBER(18,2),
  f48     NUMBER(18,2),
  a49     VARCHAR2(255),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  e49     NUMBER(18,2),
  f49     NUMBER(18,2),
  a50     VARCHAR2(255),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  e50     NUMBER(18,2),
  f50     NUMBER(18,2),
  a51     VARCHAR2(255),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  e51     NUMBER(18,2),
  f51     NUMBER(18,2),
  a53     VARCHAR2(255),
  c53     NUMBER(18),
  d53     NUMBER(18,2),
  e53     NUMBER(18,2),
  f53     NUMBER(18,2),
  a54     VARCHAR2(255),
  c54     NUMBER(18),
  d54     NUMBER(18,2),
  e54     NUMBER(18,2),
  f54     NUMBER(18,2),
  a55     VARCHAR2(255),
  c55     NUMBER(18),
  d55     NUMBER(18,2),
  e55     NUMBER(18,2),
  f55     NUMBER(18,2),
  a56     VARCHAR2(255),
  c56     NUMBER(18),
  d56     NUMBER(18,2),
  e56     NUMBER(18,2),
  f56     NUMBER(18,2),
  a57     VARCHAR2(255),
  c57     NUMBER(18),
  d57     NUMBER(18,2),
  e57     NUMBER(18,2),
  f57     NUMBER(18,2)
)
;
comment on table T_CSRC0822_C13_3_ZYZJ
  is 'ƱѺʽعҵܱ-ʽ';

prompt
prompt Creating table T_CSRC1107_A1
prompt ============================
prompt
create table T_CSRC1107_A1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  f3      NUMBER(18,2),
  g3      NUMBER(18,2),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  f4      NUMBER(18,2),
  g4      NUMBER(18,2),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  f10     NUMBER(18,2),
  g10     NUMBER(18,2),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  f11     NUMBER(18,2),
  g11     NUMBER(18,2),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  f12     NUMBER(18,2),
  g12     NUMBER(18,2),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  f13     NUMBER(18,2),
  g13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  g14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  g15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  g16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  g17     NUMBER(18,2),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  g18     NUMBER(18,2),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  g19     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  g20     NUMBER(18,2),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  g21     NUMBER(18,2),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  g22     NUMBER(18,2),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  f23     NUMBER(18,2),
  g23     NUMBER(18,2),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  f24     NUMBER(18,2),
  g24     NUMBER(18,2),
  c25     NUMBER(18,2),
  d25     NUMBER(18,2),
  f25     NUMBER(18,2),
  g25     NUMBER(18,2),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  f26     NUMBER(18,2),
  g26     NUMBER(18,2),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  f27     NUMBER(18,2),
  g27     NUMBER(18,2),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  f28     NUMBER(18,2),
  g28     NUMBER(18,2),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  f29     NUMBER(18,2),
  g29     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  f30     NUMBER(18,2),
  g30     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  f31     NUMBER(18,2),
  g31     NUMBER(18,2),
  c32     NUMBER(18,2),
  d32     NUMBER(18,2),
  f32     NUMBER(18,2),
  g32     NUMBER(18,2),
  a34     VARCHAR2(4000),
  a36     VARCHAR2(4000)
)
;

prompt
prompt Creating table T_CSRC1107_A1_20200619
prompt =====================================
prompt
create table T_CSRC1107_A1_20200619
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  f3      NUMBER(18,2),
  g3      NUMBER(18,2),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  f4      NUMBER(18,2),
  g4      NUMBER(18,2),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  f10     NUMBER(18,2),
  g10     NUMBER(18,2),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  f11     NUMBER(18,2),
  g11     NUMBER(18,2),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  f12     NUMBER(18,2),
  g12     NUMBER(18,2),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  f13     NUMBER(18,2),
  g13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  g14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  g15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  g16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  g17     NUMBER(18,2),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  g18     NUMBER(18,2),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  g19     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  g20     NUMBER(18,2),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  g21     NUMBER(18,2),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  g22     NUMBER(18,2),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  f23     NUMBER(18,2),
  g23     NUMBER(18,2),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  f24     NUMBER(18,2),
  g24     NUMBER(18,2),
  c25     NUMBER(18,2),
  d25     NUMBER(18,2),
  f25     NUMBER(18,2),
  g25     NUMBER(18,2),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  f26     NUMBER(18,2),
  g26     NUMBER(18,2),
  a28     VARCHAR2(2000),
  a30     VARCHAR2(2000)
)
;

prompt
prompt Creating table T_CSRC1107_A2
prompt ============================
prompt
create table T_CSRC1107_A2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  f3      NUMBER(18,2),
  g3      NUMBER(18,2),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  f4      NUMBER(18,2),
  g4      NUMBER(18,2),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  f10     NUMBER(18,2),
  g10     NUMBER(18,2),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  f11     NUMBER(18,2),
  g11     NUMBER(18,2),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  f12     NUMBER(18,2),
  g12     NUMBER(18,2),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  f13     NUMBER(18,2),
  g13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  g14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  g15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  g16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  g17     NUMBER(18,2),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  g18     NUMBER(18,2),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  g19     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  g20     NUMBER(18,2),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  g21     NUMBER(18,2),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  g22     NUMBER(18,2),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  f23     NUMBER(18,2),
  g23     NUMBER(18,2),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  f24     NUMBER(18,2),
  g24     NUMBER(18,2),
  c25     NUMBER(18,2),
  d25     NUMBER(18,2),
  f25     NUMBER(18,2),
  g25     NUMBER(18,2),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  f26     NUMBER(18,2),
  g26     NUMBER(18,2),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  f27     NUMBER(18,2),
  g27     NUMBER(18,2),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  f28     NUMBER(18,2),
  g28     NUMBER(18,2),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  f29     NUMBER(18,2),
  g29     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  f30     NUMBER(18,2),
  g30     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  f31     NUMBER(18,2),
  g31     NUMBER(18,2),
  c32     NUMBER(18,2),
  d32     NUMBER(18,2),
  f32     NUMBER(18,2),
  g32     NUMBER(18,2),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  f33     NUMBER(18,2),
  g33     NUMBER(18,2),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  f34     NUMBER(18,2),
  g34     NUMBER(18,2),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  f35     NUMBER(18,2),
  g35     NUMBER(18,2),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  f36     NUMBER(18,2),
  g36     NUMBER(18,2),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  f37     NUMBER(18,2),
  g37     NUMBER(18,2),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  f38     NUMBER(18,2),
  g38     NUMBER(18,2),
  c39     NUMBER(18,2),
  d39     NUMBER(18,2),
  f39     NUMBER(18,2),
  g39     NUMBER(18,2),
  c40     NUMBER(18,2),
  d40     NUMBER(18,2),
  f40     NUMBER(18,2),
  g40     NUMBER(18,2),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  f41     NUMBER(18,2),
  g41     NUMBER(18,2),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  f42     NUMBER(18,2),
  g42     NUMBER(18,2),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  f43     NUMBER(18,2),
  g43     NUMBER(18,2),
  c44     NUMBER(18,2),
  d44     NUMBER(18,2),
  f44     NUMBER(18,2),
  g44     NUMBER(18,2),
  c45     NUMBER(18,2),
  d45     NUMBER(18,2),
  f45     NUMBER(18,2),
  g45     NUMBER(18,2),
  c46     NUMBER(18,2),
  d46     NUMBER(18,2),
  f46     NUMBER(18,2),
  g46     NUMBER(18,2),
  c47     NUMBER(18,2),
  d47     NUMBER(18,2),
  f47     NUMBER(18,2),
  g47     NUMBER(18,2),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  f48     NUMBER(18,2),
  g48     NUMBER(18,2),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  f49     NUMBER(18,2),
  g49     NUMBER(18,2),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  f50     NUMBER(18,2),
  g50     NUMBER(18,2),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  f51     NUMBER(18,2),
  g51     NUMBER(18,2),
  c52     NUMBER(18,2),
  d52     NUMBER(18,2),
  f52     NUMBER(18,2),
  g52     NUMBER(18,2),
  c53     NUMBER(18,2),
  d53     NUMBER(18,2),
  f53     NUMBER(18,2),
  g53     NUMBER(18,2),
  c54     NUMBER(18,2),
  d54     NUMBER(18,2),
  f54     NUMBER(18,2),
  g54     NUMBER(18,2),
  c55     NUMBER(18,2),
  d55     NUMBER(18,2),
  f55     NUMBER(18,2),
  g55     NUMBER(18,2),
  c56     NUMBER(18,2),
  d56     NUMBER(18,2),
  f56     NUMBER(18,2),
  g56     NUMBER(18,2),
  c57     NUMBER(18,2),
  d57     NUMBER(18,2),
  f57     NUMBER(18,2),
  g57     NUMBER(18,2),
  c58     NUMBER(18,2),
  d58     NUMBER(18,2),
  f58     NUMBER(18,2),
  g58     NUMBER(18,2),
  c59     NUMBER(18,2),
  d59     NUMBER(18,2),
  f59     NUMBER(18,2),
  g59     NUMBER(18,2),
  c60     NUMBER(18,2),
  d60     NUMBER(18,2),
  f60     NUMBER(18,2),
  g60     NUMBER(18,2),
  c61     NUMBER(18,2),
  d61     NUMBER(18,2),
  f61     NUMBER(18,2),
  g61     NUMBER(18,2),
  c62     NUMBER(18,2),
  d62     NUMBER(18,2),
  f62     NUMBER(18,2),
  g62     NUMBER(18,2),
  c63     NUMBER(18,2),
  d63     NUMBER(18,2),
  f63     NUMBER(18,2),
  g63     NUMBER(18,2),
  c64     NUMBER(18,2),
  d64     NUMBER(18,2),
  f64     NUMBER(18,2),
  g64     NUMBER(18,2),
  c65     NUMBER(18,2),
  d65     NUMBER(18,2),
  f65     NUMBER(18,2),
  g65     NUMBER(18,2),
  c66     NUMBER(18,2),
  d66     NUMBER(18,2),
  f66     NUMBER(18,2),
  g66     NUMBER(18,2),
  c67     NUMBER(18,2),
  d67     NUMBER(18,2),
  f67     NUMBER(18,2),
  g67     NUMBER(18,2),
  c68     NUMBER(18,2),
  d68     NUMBER(18,2),
  f68     NUMBER(18,2),
  g68     NUMBER(18,2),
  c69     NUMBER(18,2),
  d69     NUMBER(18,2),
  f69     NUMBER(18,2),
  g69     NUMBER(18,2),
  c70     NUMBER(18,2),
  d70     NUMBER(18,2),
  f70     NUMBER(18,2),
  g70     NUMBER(18,2),
  c71     NUMBER(18,2),
  d71     NUMBER(18,2),
  f71     NUMBER(18,2),
  g71     NUMBER(18,2),
  c72     NUMBER(18,2),
  d72     NUMBER(18,2),
  f72     NUMBER(18,2),
  g72     NUMBER(18,2),
  c73     NUMBER(18,2),
  d73     NUMBER(18,2),
  f73     NUMBER(18,2),
  g73     NUMBER(18,2),
  c74     NUMBER(18,2),
  d74     NUMBER(18,2),
  f74     NUMBER(18,2),
  g74     NUMBER(18,2),
  c75     NUMBER(18,2),
  d75     NUMBER(18,2),
  f75     NUMBER(18,2),
  g75     NUMBER(18,2),
  c76     NUMBER(18,2),
  d76     NUMBER(18,2),
  f76     NUMBER(18,2),
  g76     NUMBER(18,2),
  c77     NUMBER(18,2),
  d77     NUMBER(18,2),
  f77     NUMBER(18,2),
  g77     NUMBER(18,2),
  c78     NUMBER(18,2),
  d78     NUMBER(18,2),
  f78     NUMBER(18,2),
  g78     NUMBER(18,2),
  c79     NUMBER(18,2),
  d79     NUMBER(18,2),
  f79     NUMBER(18,2),
  g79     NUMBER(18,2),
  c80     NUMBER(18,2),
  d80     NUMBER(18,2),
  f80     NUMBER(18,2),
  g80     NUMBER(18,2),
  c81     NUMBER(18,2),
  d81     NUMBER(18,2),
  f81     NUMBER(18,2),
  g81     NUMBER(18,2),
  c82     NUMBER(18,2),
  d82     NUMBER(18,2),
  f82     NUMBER(18,2),
  g82     NUMBER(18,2),
  c83     NUMBER(18,2),
  d83     NUMBER(18,2),
  f83     NUMBER(18,2),
  g83     NUMBER(18,2),
  c84     NUMBER(18,2),
  d84     NUMBER(18,2),
  f84     NUMBER(18,2),
  g84     NUMBER(18,2),
  c85     NUMBER(18,2),
  d85     NUMBER(18,2),
  f85     NUMBER(18,2),
  g85     NUMBER(18,2),
  c86     NUMBER(18,2),
  d86     NUMBER(18,2),
  f86     NUMBER(18,2),
  g86     NUMBER(18,2),
  c87     NUMBER(18,2),
  d87     NUMBER(18,2),
  f87     NUMBER(18,2),
  g87     NUMBER(18,2),
  c88     NUMBER(18,2),
  d88     NUMBER(18,2),
  f88     NUMBER(18,2),
  g88     NUMBER(18,2),
  c89     NUMBER(18,2),
  d89     NUMBER(18,2),
  f89     NUMBER(18,2),
  g89     NUMBER(18,2),
  c90     NUMBER(18,2),
  d90     NUMBER(18,2),
  f90     NUMBER(18,2),
  g90     NUMBER(18,2),
  c91     NUMBER(18,2),
  d91     NUMBER(18,2),
  f91     NUMBER(18,2),
  g91     NUMBER(18,2),
  c92     NUMBER(18,2),
  d92     NUMBER(18,2),
  f92     NUMBER(18,2),
  g92     NUMBER(18,2),
  c93     NUMBER(18,2),
  d93     NUMBER(18,2),
  f93     NUMBER(18,2),
  g93     NUMBER(18,2),
  c94     NUMBER(18,2),
  d94     NUMBER(18,2),
  f94     NUMBER(18,2),
  g94     NUMBER(18,2),
  c95     NUMBER(18,2),
  d95     NUMBER(18,2),
  f95     NUMBER(18,2),
  g95     NUMBER(18,2),
  c96     NUMBER(18,2),
  d96     NUMBER(18,2),
  f96     NUMBER(18,2),
  g96     NUMBER(18,2),
  c97     NUMBER(18,2),
  d97     NUMBER(18,2),
  f97     NUMBER(18,2),
  g97     NUMBER(18,2),
  c98     NUMBER(18,2),
  d98     NUMBER(18,2),
  f98     NUMBER(18,2),
  g98     NUMBER(18,2),
  c99     NUMBER(18,2),
  d99     NUMBER(18,2),
  f99     NUMBER(18,2),
  g99     NUMBER(18,2),
  c100    NUMBER(18,2),
  d100    NUMBER(18,2),
  f100    NUMBER(18,2),
  g100    NUMBER(18,2),
  c101    NUMBER(18,2),
  d101    NUMBER(18,2),
  f101    NUMBER(18,2),
  g101    NUMBER(18,2),
  a102    VARCHAR2(4000)
)
;

prompt
prompt Creating table T_CSRC1107_A2_20200619
prompt =====================================
prompt
create table T_CSRC1107_A2_20200619
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  f3      NUMBER(18,2),
  g3      NUMBER(18,2),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  f4      NUMBER(18,2),
  g4      NUMBER(18,2),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      NUMBER(18,2),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  f6      NUMBER(18,2),
  g6      NUMBER(18,2),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  f8      NUMBER(18,2),
  g8      NUMBER(18,2),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      NUMBER(18,2),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  f10     NUMBER(18,2),
  g10     NUMBER(18,2),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  f11     NUMBER(18,2),
  g11     NUMBER(18,2),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  f12     NUMBER(18,2),
  g12     NUMBER(18,2),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  f13     NUMBER(18,2),
  g13     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  g14     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  g15     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  g16     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  g17     NUMBER(18,2),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  g18     NUMBER(18,2),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  g19     NUMBER(18,2),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  g20     NUMBER(18,2),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  g21     NUMBER(18,2),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  g22     NUMBER(18,2),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  f23     NUMBER(18,2),
  g23     NUMBER(18,2),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  f24     NUMBER(18,2),
  g24     NUMBER(18,2),
  c25     NUMBER(18,2),
  d25     NUMBER(18,2),
  f25     NUMBER(18,2),
  g25     NUMBER(18,2),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  f26     NUMBER(18,2),
  g26     NUMBER(18,2),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  f27     NUMBER(18,2),
  g27     NUMBER(18,2),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  f28     NUMBER(18,2),
  g28     NUMBER(18,2),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  f29     NUMBER(18,2),
  g29     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  f30     NUMBER(18,2),
  g30     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  f31     NUMBER(18,2),
  g31     NUMBER(18,2),
  c32     NUMBER(18,2),
  d32     NUMBER(18,2),
  f32     NUMBER(18,2),
  g32     NUMBER(18,2),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  f33     NUMBER(18,2),
  g33     NUMBER(18,2),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  f34     NUMBER(18,2),
  g34     NUMBER(18,2),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  f35     NUMBER(18,2),
  g35     NUMBER(18,2),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  f36     NUMBER(18,2),
  g36     NUMBER(18,2),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  f37     NUMBER(18,2),
  g37     NUMBER(18,2),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  f38     NUMBER(18,2),
  g38     NUMBER(18,2),
  c39     NUMBER(18,2),
  d39     NUMBER(18,2),
  f39     NUMBER(18,2),
  g39     NUMBER(18,2),
  c40     NUMBER(18,2),
  d40     NUMBER(18,2),
  f40     NUMBER(18,2),
  g40     NUMBER(18,2),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  f41     NUMBER(18,2),
  g41     NUMBER(18,2),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  f42     NUMBER(18,2),
  g42     NUMBER(18,2),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  f43     NUMBER(18,2),
  g43     NUMBER(18,2),
  c44     NUMBER(18,2),
  d44     NUMBER(18,2),
  f44     NUMBER(18,2),
  g44     NUMBER(18,2),
  c45     NUMBER(18,2),
  d45     NUMBER(18,2),
  f45     NUMBER(18,2),
  g45     NUMBER(18,2),
  c46     NUMBER(18,2),
  d46     NUMBER(18,2),
  f46     NUMBER(18,2),
  g46     NUMBER(18,2),
  c47     NUMBER(18,2),
  d47     NUMBER(18,2),
  f47     NUMBER(18,2),
  g47     NUMBER(18,2),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  f48     NUMBER(18,2),
  g48     NUMBER(18,2),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  f49     NUMBER(18,2),
  g49     NUMBER(18,2),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  f50     NUMBER(18,2),
  g50     NUMBER(18,2),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  f51     NUMBER(18,2),
  g51     NUMBER(18,2),
  c52     NUMBER(18,2),
  d52     NUMBER(18,2),
  f52     NUMBER(18,2),
  g52     NUMBER(18,2),
  c53     NUMBER(18,2),
  d53     NUMBER(18,2),
  f53     NUMBER(18,2),
  g53     NUMBER(18,2),
  c54     NUMBER(18,2),
  d54     NUMBER(18,2),
  f54     NUMBER(18,2),
  g54     NUMBER(18,2),
  c55     NUMBER(18,2),
  d55     NUMBER(18,2),
  f55     NUMBER(18,2),
  g55     NUMBER(18,2),
  c56     NUMBER(18,2),
  d56     NUMBER(18,2),
  f56     NUMBER(18,2),
  g56     NUMBER(18,2),
  c57     NUMBER(18,2),
  d57     NUMBER(18,2),
  f57     NUMBER(18,2),
  g57     NUMBER(18,2),
  c58     NUMBER(18,2),
  d58     NUMBER(18,2),
  f58     NUMBER(18,2),
  g58     NUMBER(18,2),
  c59     NUMBER(18,2),
  d59     NUMBER(18,2),
  f59     NUMBER(18,2),
  g59     NUMBER(18,2),
  c60     NUMBER(18,2),
  d60     NUMBER(18,2),
  f60     NUMBER(18,2),
  g60     NUMBER(18,2),
  c61     NUMBER(18,2),
  d61     NUMBER(18,2),
  f61     NUMBER(18,2),
  g61     NUMBER(18,2),
  c62     NUMBER(18,2),
  d62     NUMBER(18,2),
  f62     NUMBER(18,2),
  g62     NUMBER(18,2),
  c63     NUMBER(18,2),
  d63     NUMBER(18,2),
  f63     NUMBER(18,2),
  g63     NUMBER(18,2),
  c64     NUMBER(18,2),
  d64     NUMBER(18,2),
  f64     NUMBER(18,2),
  g64     NUMBER(18,2),
  a66     VARCHAR2(2000)
)
;

prompt
prompt Creating table T_CSRC1107_A3
prompt ============================
prompt
create table T_CSRC1107_A3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d2      NUMBER(18,2),
  f2      NUMBER(18,2),
  d3      NUMBER(18,2),
  f3      NUMBER(18,2),
  d4      NUMBER(18,2),
  f4      NUMBER(18,2),
  d5      NUMBER(18,2),
  f5      NUMBER(18,2),
  d6      NUMBER(18,2),
  f6      NUMBER(18,2),
  d7      NUMBER(18,2),
  f7      NUMBER(18,2),
  d8      NUMBER(18,2),
  f8      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  d10     NUMBER(18,2),
  f10     NUMBER(18,2),
  d11     NUMBER(18,2),
  f11     NUMBER(18,2),
  d12     NUMBER(18,2),
  f12     NUMBER(18,2),
  d13     NUMBER(18,2),
  f13     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  d23     NUMBER(18,2),
  f23     NUMBER(18,2),
  d24     NUMBER(18,2),
  f24     NUMBER(18,2),
  d25     NUMBER(18,2),
  f25     NUMBER(18,2),
  d26     NUMBER(18,2),
  f26     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC1107_A3_20200619
prompt =====================================
prompt
create table T_CSRC1107_A3_20200619
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d2      NUMBER(18,2),
  f2      NUMBER(18,2),
  d3      NUMBER(18,2),
  f3      NUMBER(18,2),
  d4      NUMBER(18,2),
  f4      NUMBER(18,2),
  d5      NUMBER(18,2),
  f5      NUMBER(18,2),
  d6      NUMBER(18,2),
  f6      NUMBER(18,2),
  d7      NUMBER(18,2),
  f7      NUMBER(18,2),
  d8      NUMBER(18,2),
  f8      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  d10     NUMBER(18,2),
  f10     NUMBER(18,2),
  d11     NUMBER(18,2),
  f11     NUMBER(18,2),
  d12     NUMBER(18,2),
  f12     NUMBER(18,2),
  d13     NUMBER(18,2),
  f13     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  d23     NUMBER(18,2),
  f23     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC1107_A4
prompt ============================
prompt
create table T_CSRC1107_A4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  e2      NUMBER(18,2),
  c3      NUMBER(18,2),
  e3      NUMBER(18,2),
  c4      NUMBER(18,2),
  e4      NUMBER(18,2),
  c5      NUMBER(18,2),
  e5      NUMBER(18,2),
  c6      NUMBER(18,2),
  e6      NUMBER(18,2),
  c7      NUMBER(18,2),
  e7      NUMBER(18,2),
  c8      NUMBER(18,2),
  e8      NUMBER(18,2),
  c9      NUMBER(18,2),
  e9      NUMBER(18,2),
  c10     NUMBER(18,2),
  e10     NUMBER(18,2),
  c11     NUMBER(18,2),
  e11     NUMBER(18,2),
  c12     NUMBER(18,2),
  e12     NUMBER(18,2),
  c13     NUMBER(18,2),
  e13     NUMBER(18,2),
  c14     NUMBER(18,2),
  e14     NUMBER(18,2),
  c15     NUMBER(18,2),
  e15     NUMBER(18,2),
  c16     NUMBER(18,2),
  e16     NUMBER(18,2),
  c17     NUMBER(18,2),
  e17     NUMBER(18,2),
  c18     NUMBER(18,2),
  e18     NUMBER(18,2),
  c19     NUMBER(18,2),
  e19     NUMBER(18,2),
  c20     NUMBER(18,2),
  e20     NUMBER(18,2),
  c21     NUMBER(18,2),
  e21     NUMBER(18,2),
  c22     NUMBER(18,2),
  e22     NUMBER(18,2),
  c23     NUMBER(18,2),
  e23     NUMBER(18,2),
  c24     NUMBER(18,2),
  e24     NUMBER(18,2),
  c25     NUMBER(18,2),
  e25     NUMBER(18,2),
  c26     NUMBER(18,2),
  e26     NUMBER(18,2),
  c27     NUMBER(18,2),
  e27     NUMBER(18,2),
  c28     NUMBER(18,2),
  e28     NUMBER(18,2),
  c29     NUMBER(18,2),
  e29     NUMBER(18,2),
  c30     NUMBER(18,2),
  e30     NUMBER(18,2),
  c31     NUMBER(18,2),
  e31     NUMBER(18,2),
  c32     NUMBER(18,2),
  e32     NUMBER(18,2),
  c33     NUMBER(18,2),
  e33     NUMBER(18,2),
  c34     NUMBER(18,2),
  e34     NUMBER(18,2),
  c35     NUMBER(18,2),
  e35     NUMBER(18,2),
  c36     NUMBER(18,2),
  e36     NUMBER(18,2),
  c37     NUMBER(18,2),
  e37     NUMBER(18,2),
  c38     NUMBER(18,2),
  e38     NUMBER(18,2),
  c39     NUMBER(18,2),
  e39     NUMBER(18,2),
  c40     NUMBER(18,2),
  e40     NUMBER(18,2),
  c41     NUMBER(18,2),
  e41     NUMBER(18,2),
  c42     NUMBER(18,2),
  e42     NUMBER(18,2),
  c43     NUMBER(18,2),
  e43     NUMBER(18,2),
  c44     NUMBER(18,2),
  e44     NUMBER(18,2),
  c45     NUMBER(18,2),
  e45     NUMBER(18,2),
  c46     NUMBER(18,2),
  e46     NUMBER(18,2),
  c47     NUMBER(18,2),
  e47     NUMBER(18,2),
  c48     NUMBER(18,2),
  e48     NUMBER(18,2),
  c49     NUMBER(18,2),
  e49     NUMBER(18,2),
  c50     NUMBER(18,2),
  e50     NUMBER(18,2),
  c51     NUMBER(18,2),
  e51     NUMBER(18,2),
  c52     NUMBER(18,2),
  e52     NUMBER(18,2),
  c53     NUMBER(18,2),
  e53     NUMBER(18,2),
  c54     NUMBER(18,2),
  e54     NUMBER(18,2),
  c55     NUMBER(18,2),
  e55     NUMBER(18,2),
  c56     NUMBER(18,2),
  e56     NUMBER(18,2),
  c57     NUMBER(18,2),
  e57     NUMBER(18,2),
  c58     NUMBER(18,2),
  e58     NUMBER(18,2),
  c59     NUMBER(18,2),
  e59     NUMBER(18,2),
  c60     NUMBER(18,2),
  e60     NUMBER(18,2),
  c61     NUMBER(18,2),
  e61     NUMBER(18,2),
  c62     NUMBER(18,2),
  e62     NUMBER(18,2),
  c63     NUMBER(18,2),
  e63     NUMBER(18,2),
  c64     NUMBER(18,2),
  e64     NUMBER(18,2),
  c65     NUMBER(18,2),
  e65     NUMBER(18,2),
  c66     NUMBER(18,2),
  e66     NUMBER(18,2),
  c67     NUMBER(18,2),
  e67     NUMBER(18,2),
  c68     NUMBER(18,2),
  e68     NUMBER(18,2),
  c69     NUMBER(18,2),
  e69     NUMBER(18,2),
  c70     NUMBER(18,2),
  e70     NUMBER(18,2),
  c71     NUMBER(18,2),
  e71     NUMBER(18,2),
  c72     NUMBER(18,2),
  e72     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC1107_A4_20200619
prompt =====================================
prompt
create table T_CSRC1107_A4_20200619
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  e2      NUMBER(18,2),
  c3      NUMBER(18,2),
  e3      NUMBER(18,2),
  c4      NUMBER(18,2),
  e4      NUMBER(18,2),
  c5      NUMBER(18,2),
  e5      NUMBER(18,2),
  c6      NUMBER(18,2),
  e6      NUMBER(18,2),
  c7      NUMBER(18,2),
  e7      NUMBER(18,2),
  c8      NUMBER(18,2),
  e8      NUMBER(18,2),
  c9      NUMBER(18,2),
  e9      NUMBER(18,2),
  c10     NUMBER(18,2),
  e10     NUMBER(18,2),
  c11     NUMBER(18,2),
  e11     NUMBER(18,2),
  c12     NUMBER(18,2),
  e12     NUMBER(18,2),
  c13     NUMBER(18,2),
  e13     NUMBER(18,2),
  c14     NUMBER(18,2),
  e14     NUMBER(18,2),
  c15     NUMBER(18,2),
  e15     NUMBER(18,2),
  c16     NUMBER(18,2),
  e16     NUMBER(18,2),
  c17     NUMBER(18,2),
  e17     NUMBER(18,2),
  c18     NUMBER(18,2),
  e18     NUMBER(18,2),
  c19     NUMBER(18,2),
  e19     NUMBER(18,2),
  c20     NUMBER(18,2),
  e20     NUMBER(18,2),
  c21     NUMBER(18,2),
  e21     NUMBER(18,2),
  c22     NUMBER(18,2),
  e22     NUMBER(18,2),
  c23     NUMBER(18,2),
  e23     NUMBER(18,2),
  c24     NUMBER(18,2),
  e24     NUMBER(18,2),
  c25     NUMBER(18,2),
  e25     NUMBER(18,2),
  c26     NUMBER(18,2),
  e26     NUMBER(18,2),
  c27     NUMBER(18,2),
  e27     NUMBER(18,2),
  c28     NUMBER(18,2),
  e28     NUMBER(18,2),
  c29     NUMBER(18,2),
  e29     NUMBER(18,2),
  c30     NUMBER(18,2),
  e30     NUMBER(18,2),
  c31     NUMBER(18,2),
  e31     NUMBER(18,2),
  c32     NUMBER(18,2),
  e32     NUMBER(18,2),
  c33     NUMBER(18,2),
  e33     NUMBER(18,2),
  c34     NUMBER(18,2),
  e34     NUMBER(18,2),
  c35     NUMBER(18,2),
  e35     NUMBER(18,2),
  c36     NUMBER(18,2),
  e36     NUMBER(18,2),
  c37     NUMBER(18,2),
  e37     NUMBER(18,2),
  c38     NUMBER(18,2),
  e38     NUMBER(18,2),
  c39     NUMBER(18,2),
  e39     NUMBER(18,2),
  c40     NUMBER(18,2),
  e40     NUMBER(18,2),
  c41     NUMBER(18,2),
  e41     NUMBER(18,2),
  c42     NUMBER(18,2),
  e42     NUMBER(18,2),
  c43     NUMBER(18,2),
  e43     NUMBER(18,2),
  c44     NUMBER(18,2),
  e44     NUMBER(18,2),
  c45     NUMBER(18,2),
  e45     NUMBER(18,2),
  c46     NUMBER(18,2),
  e46     NUMBER(18,2),
  c47     NUMBER(18,2),
  e47     NUMBER(18,2),
  c48     NUMBER(18,2),
  e48     NUMBER(18,2),
  c49     NUMBER(18,2),
  e49     NUMBER(18,2),
  c50     NUMBER(18,2),
  e50     NUMBER(18,2),
  c51     NUMBER(18,2),
  e51     NUMBER(18,2),
  c52     NUMBER(18,2),
  e52     NUMBER(18,2),
  c53     NUMBER(18,2),
  e53     NUMBER(18,2),
  c54     NUMBER(18,2),
  e54     NUMBER(18,2),
  c55     NUMBER(18,2),
  e55     NUMBER(18,2),
  c56     NUMBER(18,2),
  e56     NUMBER(18,2),
  c57     NUMBER(18,2),
  e57     NUMBER(18,2),
  c58     NUMBER(18,2),
  e58     NUMBER(18,2),
  c59     NUMBER(18,2),
  e59     NUMBER(18,2),
  c60     NUMBER(18,2),
  e60     NUMBER(18,2),
  c61     NUMBER(18,2),
  e61     NUMBER(18,2),
  c62     NUMBER(18,2),
  e62     NUMBER(18,2),
  c63     NUMBER(18,2),
  e63     NUMBER(18,2),
  c64     NUMBER(18,2),
  e64     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC1107_A5
prompt ============================
prompt
create table T_CSRC1107_A5
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  e2      NUMBER(18,2),
  c3      NUMBER(18,2),
  e3      NUMBER(18,2),
  c4      NUMBER(18,2),
  e4      NUMBER(18,2),
  c5      NUMBER(18,2),
  e5      NUMBER(18,2),
  c6      NUMBER(18,2),
  e6      NUMBER(18,2),
  c7      NUMBER(18,2),
  e7      NUMBER(18,2),
  c8      NUMBER(18,2),
  e8      NUMBER(18,2),
  c9      NUMBER(18,2),
  e9      NUMBER(18,2),
  c10     NUMBER(18,2),
  e10     NUMBER(18,2),
  c11     NUMBER(18,2),
  e11     NUMBER(18,2),
  c12     NUMBER(18,2),
  e12     NUMBER(18,2),
  c13     NUMBER(18,2),
  e13     NUMBER(18,2),
  c14     NUMBER(18,2),
  e14     NUMBER(18,2),
  c15     NUMBER(18,2),
  e15     NUMBER(18,2),
  c16     NUMBER(18,2),
  e16     NUMBER(18,2),
  c17     NUMBER(18,2),
  e17     NUMBER(18,2),
  c18     NUMBER(18,2),
  e18     NUMBER(18,2),
  c19     NUMBER(18,2),
  e19     NUMBER(18,2),
  c20     NUMBER(18,2),
  e20     NUMBER(18,2),
  c21     NUMBER(18,2),
  e21     NUMBER(18,2),
  c22     NUMBER(18,2),
  e22     NUMBER(18,2),
  c23     NUMBER(18,2),
  e23     NUMBER(18,2),
  c24     NUMBER(18,2),
  e24     NUMBER(18,2),
  c25     NUMBER(18,2),
  e25     NUMBER(18,2),
  c26     NUMBER(18,2),
  e26     NUMBER(18,2),
  c27     NUMBER(18,2),
  e27     NUMBER(18,2),
  c28     NUMBER(18,2),
  e28     NUMBER(18,2),
  c29     NUMBER(18,2),
  e29     NUMBER(18,2),
  c30     NUMBER(18,2),
  e30     NUMBER(18,2),
  c31     NUMBER(18,2),
  e31     NUMBER(18,2),
  c32     NUMBER(18,2),
  e32     NUMBER(18,2),
  c33     NUMBER(18,2),
  e33     NUMBER(18,2),
  c34     NUMBER(18,2),
  e34     NUMBER(18,2),
  c35     NUMBER(18,2),
  e35     NUMBER(18,2),
  c36     NUMBER(18,2),
  e36     NUMBER(18,2),
  c37     NUMBER(18,2),
  e37     NUMBER(18,2),
  c38     NUMBER(18,2),
  e38     NUMBER(18,2),
  c39     NUMBER(18,2),
  e39     NUMBER(18,2),
  c40     NUMBER(18,2),
  e40     NUMBER(18,2),
  c41     NUMBER(18,2),
  e41     NUMBER(18,2),
  c42     NUMBER(18,2),
  e42     NUMBER(18,2),
  c43     NUMBER(18,2),
  e43     NUMBER(18,2),
  c44     NUMBER(18,2),
  e44     NUMBER(18,2),
  c45     NUMBER(18,2),
  e45     NUMBER(18,2),
  c46     NUMBER(18,2),
  e46     NUMBER(18,2),
  c47     NUMBER(18,2),
  e47     NUMBER(18,2),
  c48     NUMBER(18,2),
  e48     NUMBER(18,2),
  c49     NUMBER(18,2),
  e49     NUMBER(18,2),
  c50     NUMBER(18,2),
  e50     NUMBER(18,2),
  c51     NUMBER(18,2),
  e51     NUMBER(18,2),
  c52     NUMBER(18,2),
  e52     NUMBER(18,2),
  c53     NUMBER(18,2),
  e53     NUMBER(18,2),
  c54     NUMBER(18,2),
  e54     NUMBER(18,2),
  c55     NUMBER(18,2),
  e55     NUMBER(18,2),
  c56     NUMBER(18,2),
  e56     NUMBER(18,2),
  c57     NUMBER(18,2),
  e57     NUMBER(18,2),
  c58     NUMBER(18,2),
  e58     NUMBER(18,2),
  c59     NUMBER(18,2),
  e59     NUMBER(18,2),
  c60     NUMBER(18,2),
  e60     NUMBER(18,2),
  c61     NUMBER(18,2),
  e61     NUMBER(18,2),
  c62     NUMBER(18,2),
  e62     NUMBER(18,2),
  c63     NUMBER(18,2),
  e63     NUMBER(18,2),
  c64     NUMBER(18,2),
  e64     NUMBER(18,2),
  c65     NUMBER(18,2),
  e65     NUMBER(18,2),
  c66     NUMBER(18,2),
  e66     NUMBER(18,2),
  c67     NUMBER(18,2),
  e67     NUMBER(18,2),
  c68     NUMBER(18,2),
  e68     NUMBER(18,2),
  c69     NUMBER(18,2),
  e69     NUMBER(18,2),
  c70     NUMBER(18,2),
  e70     NUMBER(18,2),
  c71     NUMBER(18,2),
  e71     NUMBER(18,2),
  c72     NUMBER(18,2),
  e72     NUMBER(18,2),
  c73     NUMBER(18,2),
  e73     NUMBER(18,2),
  c74     NUMBER(18,2),
  e74     NUMBER(18,2),
  c75     NUMBER(18,2),
  e75     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC1107_A5_20200619
prompt =====================================
prompt
create table T_CSRC1107_A5_20200619
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  e2      NUMBER(18,2),
  c3      NUMBER(18,2),
  e3      NUMBER(18,2),
  c4      NUMBER(18,2),
  e4      NUMBER(18,2),
  c5      NUMBER(18,2),
  e5      NUMBER(18,2),
  c6      NUMBER(18,2),
  e6      NUMBER(18,2),
  c7      NUMBER(18,2),
  e7      NUMBER(18,2),
  c8      NUMBER(18,2),
  e8      NUMBER(18,2),
  c9      NUMBER(18,2),
  e9      NUMBER(18,2),
  c10     NUMBER(18,2),
  e10     NUMBER(18,2),
  c11     NUMBER(18,2),
  e11     NUMBER(18,2),
  c12     NUMBER(18,2),
  e12     NUMBER(18,2),
  c13     NUMBER(18,2),
  e13     NUMBER(18,2),
  c14     NUMBER(18,2),
  e14     NUMBER(18,2),
  c15     NUMBER(18,2),
  e15     NUMBER(18,2),
  c16     NUMBER(18,2),
  e16     NUMBER(18,2),
  c17     NUMBER(18,2),
  e17     NUMBER(18,2),
  c18     NUMBER(18,2),
  e18     NUMBER(18,2),
  c19     NUMBER(18,2),
  e19     NUMBER(18,2),
  c20     NUMBER(18,2),
  e20     NUMBER(18,2),
  c21     NUMBER(18,2),
  e21     NUMBER(18,2),
  c22     NUMBER(18,2),
  e22     NUMBER(18,2),
  c23     NUMBER(18,2),
  e23     NUMBER(18,2),
  c24     NUMBER(18,2),
  e24     NUMBER(18,2),
  c25     NUMBER(18,2),
  e25     NUMBER(18,2),
  c26     NUMBER(18,2),
  e26     NUMBER(18,2),
  c27     NUMBER(18,2),
  e27     NUMBER(18,2),
  c28     NUMBER(18,2),
  e28     NUMBER(18,2),
  c29     NUMBER(18,2),
  e29     NUMBER(18,2),
  c30     NUMBER(18,2),
  e30     NUMBER(18,2),
  c31     NUMBER(18,2),
  e31     NUMBER(18,2),
  c32     NUMBER(18,2),
  e32     NUMBER(18,2),
  c33     NUMBER(18,2),
  e33     NUMBER(18,2),
  c34     NUMBER(18,2),
  e34     NUMBER(18,2),
  c35     NUMBER(18,2),
  e35     NUMBER(18,2),
  c36     NUMBER(18,2),
  e36     NUMBER(18,2),
  c37     NUMBER(18,2),
  e37     NUMBER(18,2),
  c38     NUMBER(18,2),
  e38     NUMBER(18,2),
  c39     NUMBER(18,2),
  e39     NUMBER(18,2),
  c40     NUMBER(18,2),
  e40     NUMBER(18,2),
  c41     NUMBER(18,2),
  e41     NUMBER(18,2),
  c42     NUMBER(18,2),
  e42     NUMBER(18,2),
  c43     NUMBER(18,2),
  e43     NUMBER(18,2),
  c44     NUMBER(18,2),
  e44     NUMBER(18,2),
  c45     NUMBER(18,2),
  e45     NUMBER(18,2),
  c46     NUMBER(18,2),
  e46     NUMBER(18,2),
  c47     NUMBER(18,2),
  e47     NUMBER(18,2),
  c48     NUMBER(18,2),
  e48     NUMBER(18,2),
  c49     NUMBER(18,2),
  e49     NUMBER(18,2),
  c50     NUMBER(18,2),
  e50     NUMBER(18,2),
  c51     NUMBER(18,2),
  e51     NUMBER(18,2),
  c52     NUMBER(18,2),
  e52     NUMBER(18,2),
  c53     NUMBER(18,2),
  e53     NUMBER(18,2),
  c54     NUMBER(18,2),
  e54     NUMBER(18,2),
  c55     NUMBER(18,2),
  e55     NUMBER(18,2),
  c56     NUMBER(18,2),
  e56     NUMBER(18,2),
  c57     NUMBER(18,2),
  e57     NUMBER(18,2),
  c58     NUMBER(18,2),
  e58     NUMBER(18,2),
  c59     NUMBER(18,2),
  e59     NUMBER(18,2),
  c60     NUMBER(18,2),
  e60     NUMBER(18,2),
  c61     NUMBER(18,2),
  e61     NUMBER(18,2),
  c62     NUMBER(18,2),
  e62     NUMBER(18,2),
  c63     NUMBER(18,2),
  e63     NUMBER(18,2),
  c64     NUMBER(18,2),
  e64     NUMBER(18,2),
  c65     NUMBER(18,2),
  e65     NUMBER(18,2)
)
;

prompt
prompt Creating table T_CSRC1107_A6
prompt ============================
prompt
create table T_CSRC1107_A6
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  d2      NUMBER(18,2),
  g2      VARCHAR2(255),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  g3      VARCHAR2(255),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  g4      VARCHAR2(255),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  g5      VARCHAR2(255),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  g6      VARCHAR2(255),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  g7      VARCHAR2(255),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  g8      VARCHAR2(255),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  g9      VARCHAR2(255),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  g10     VARCHAR2(255),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  g11     VARCHAR2(255),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  g12     VARCHAR2(255),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  g13     VARCHAR2(255),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  g14     VARCHAR2(255),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  g15     VARCHAR2(255),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  g16     VARCHAR2(255),
  a19     VARCHAR2(255),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  g19     VARCHAR2(255),
  a20     VARCHAR2(255),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  g20     VARCHAR2(255),
  a21     VARCHAR2(255),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  g21     VARCHAR2(255),
  a22     VARCHAR2(255),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  g22     VARCHAR2(255),
  a23     VARCHAR2(255),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  g23     VARCHAR2(255),
  a26     VARCHAR2(255),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  g26     VARCHAR2(255),
  a27     VARCHAR2(255),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  g27     VARCHAR2(255),
  a28     VARCHAR2(255),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  g28     VARCHAR2(255),
  a29     VARCHAR2(255),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  g29     VARCHAR2(255),
  a30     VARCHAR2(255),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  g30     VARCHAR2(255),
  a33     VARCHAR2(255),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  g33     VARCHAR2(255),
  a34     VARCHAR2(255),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  g34     VARCHAR2(255),
  a35     VARCHAR2(255),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  g35     VARCHAR2(255),
  a36     VARCHAR2(255),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  g36     VARCHAR2(255),
  a37     VARCHAR2(255),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  g37     VARCHAR2(255),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  g38     VARCHAR2(255),
  a41     VARCHAR2(255),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  g41     VARCHAR2(255),
  a42     VARCHAR2(255),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  g42     VARCHAR2(255),
  a43     VARCHAR2(255),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  g43     VARCHAR2(255),
  a44     VARCHAR2(255),
  c44     NUMBER(18,2),
  d44     NUMBER(18,2),
  g44     VARCHAR2(255),
  a45     VARCHAR2(255),
  c45     NUMBER(18,2),
  d45     NUMBER(18,2),
  g45     VARCHAR2(255),
  a48     VARCHAR2(255),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  g48     VARCHAR2(255),
  a49     VARCHAR2(255),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  g49     VARCHAR2(255),
  a50     VARCHAR2(255),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  g50     VARCHAR2(255),
  a51     VARCHAR2(255),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  g51     VARCHAR2(255),
  a52     VARCHAR2(255),
  c52     NUMBER(18,2),
  d52     NUMBER(18,2),
  g52     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC1107_A6_20200619
prompt =====================================
prompt
create table T_CSRC1107_A6_20200619
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  d2      NUMBER(18,2),
  e2      VARCHAR2(25),
  f2      VARCHAR2(25),
  g2      VARCHAR2(100),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  e3      VARCHAR2(25),
  f3      VARCHAR2(25),
  g3      VARCHAR2(100),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  e4      VARCHAR2(25),
  f4      VARCHAR2(25),
  g4      VARCHAR2(100),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  e5      VARCHAR2(25),
  f5      VARCHAR2(25),
  g5      VARCHAR2(100),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  e6      VARCHAR2(25),
  f6      VARCHAR2(25),
  g6      VARCHAR2(100),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  e7      VARCHAR2(25),
  f7      VARCHAR2(25),
  g7      VARCHAR2(100),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  g8      VARCHAR2(100),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  g9      VARCHAR2(100),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  g10     VARCHAR2(100),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  g11     VARCHAR2(100),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  g12     VARCHAR2(100),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  g13     VARCHAR2(100),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  g14     VARCHAR2(100),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  g15     VARCHAR2(100),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  g16     VARCHAR2(100),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  g17     VARCHAR2(100),
  a19     VARCHAR2(60),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     VARCHAR2(25),
  f19     VARCHAR2(25),
  g19     VARCHAR2(100),
  a20     VARCHAR2(60),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  e20     VARCHAR2(25),
  f20     VARCHAR2(25),
  g20     VARCHAR2(100),
  a21     VARCHAR2(60),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  e21     VARCHAR2(25),
  f21     VARCHAR2(25),
  g21     VARCHAR2(100),
  a22     VARCHAR2(60),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  e22     VARCHAR2(25),
  f22     VARCHAR2(25),
  g22     VARCHAR2(100),
  a23     VARCHAR2(60),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  e23     VARCHAR2(25),
  f23     VARCHAR2(25),
  g23     VARCHAR2(100),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  g24     VARCHAR2(100),
  a26     VARCHAR2(60),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  e26     VARCHAR2(25),
  f26     VARCHAR2(25),
  g26     VARCHAR2(100),
  a27     VARCHAR2(60),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  e27     VARCHAR2(25),
  f27     VARCHAR2(25),
  g27     VARCHAR2(100),
  a28     VARCHAR2(60),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  e28     VARCHAR2(25),
  f28     VARCHAR2(25),
  g28     VARCHAR2(100),
  a29     VARCHAR2(60),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  e29     VARCHAR2(25),
  f29     VARCHAR2(25),
  g29     VARCHAR2(100),
  a30     VARCHAR2(60),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  e30     VARCHAR2(25),
  f30     VARCHAR2(25),
  g30     VARCHAR2(100),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  g31     VARCHAR2(100),
  a33     VARCHAR2(60),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  e33     VARCHAR2(25),
  f33     VARCHAR2(25),
  g33     VARCHAR2(100),
  a34     VARCHAR2(60),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  e34     VARCHAR2(25),
  f34     VARCHAR2(25),
  g34     VARCHAR2(100),
  a35     VARCHAR2(60),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  e35     VARCHAR2(25),
  f35     VARCHAR2(25),
  g35     VARCHAR2(100),
  a36     VARCHAR2(60),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  e36     VARCHAR2(25),
  f36     VARCHAR2(25),
  g36     VARCHAR2(100),
  a37     VARCHAR2(60),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  e37     VARCHAR2(25),
  f37     VARCHAR2(25),
  g37     VARCHAR2(100),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  g38     VARCHAR2(100),
  c39     NUMBER(18,2),
  d39     NUMBER(18,2),
  g39     VARCHAR2(100),
  a41     VARCHAR2(60),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  e41     VARCHAR2(25),
  f41     VARCHAR2(25),
  g41     VARCHAR2(100),
  a42     VARCHAR2(60),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  e42     VARCHAR2(25),
  f42     VARCHAR2(25),
  g42     VARCHAR2(100),
  a43     VARCHAR2(60),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  e43     VARCHAR2(25),
  f43     VARCHAR2(25),
  g43     VARCHAR2(100),
  a44     VARCHAR2(60),
  c44     NUMBER(18,2),
  d44     NUMBER(18,2),
  e44     VARCHAR2(25),
  f44     VARCHAR2(25),
  g44     VARCHAR2(100),
  a45     VARCHAR2(60),
  c45     NUMBER(18,2),
  d45     NUMBER(18,2),
  e45     VARCHAR2(25),
  f45     VARCHAR2(25),
  g45     VARCHAR2(100),
  c46     NUMBER(18,2),
  d46     NUMBER(18,2),
  g46     VARCHAR2(100),
  a48     VARCHAR2(60),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  e48     VARCHAR2(25),
  f48     VARCHAR2(25),
  g48     VARCHAR2(100),
  a49     VARCHAR2(60),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  e49     VARCHAR2(25),
  f49     VARCHAR2(25),
  g49     VARCHAR2(100),
  a50     VARCHAR2(60),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  e50     VARCHAR2(25),
  f50     VARCHAR2(25),
  g50     VARCHAR2(100),
  a51     VARCHAR2(60),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  e51     VARCHAR2(25),
  f51     VARCHAR2(25),
  g51     VARCHAR2(100),
  a52     VARCHAR2(60),
  c52     NUMBER(18,2),
  d52     NUMBER(18,2),
  e52     VARCHAR2(25),
  f52     VARCHAR2(25),
  g52     VARCHAR2(100)
)
;

prompt
prompt Creating table T_CSRC1107_A7
prompt ============================
prompt
create table T_CSRC1107_A7
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  e4      NUMBER(18,2),
  f4      NUMBER(18,2),
  g4      VARCHAR2(255),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  e5      NUMBER(18,2),
  f5      NUMBER(18,2),
  g5      VARCHAR2(255),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  e6      NUMBER(18,2),
  f6      NUMBER(18,2),
  g6      VARCHAR2(255),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  e9      NUMBER(18,2),
  f9      NUMBER(18,2),
  g9      VARCHAR2(255),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  e10     NUMBER(18,2),
  f10     NUMBER(18,2),
  g10     VARCHAR2(255),
  c11     NUMBER(18,2),
  d11     NUMBER(18,2),
  e11     NUMBER(18,2),
  f11     NUMBER(18,2),
  g11     VARCHAR2(255),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  e12     NUMBER(18,2),
  f12     NUMBER(18,2),
  g12     VARCHAR2(255),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  e13     NUMBER(18,2),
  f13     NUMBER(18,2),
  g13     VARCHAR2(255),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  e16     NUMBER(18,2),
  f16     NUMBER(18,2),
  g16     VARCHAR2(255),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  e17     NUMBER(18,2),
  f17     NUMBER(18,2),
  g17     VARCHAR2(255),
  c18     NUMBER(18,2),
  d18     NUMBER(18,2),
  e18     NUMBER(18,2),
  f18     NUMBER(18,2),
  g18     VARCHAR2(255),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     NUMBER(18,2),
  f19     NUMBER(18,2),
  g19     VARCHAR2(255),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  e21     NUMBER(18,2),
  f21     NUMBER(18,2),
  g21     VARCHAR2(255),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  e22     NUMBER(18,2),
  f22     NUMBER(18,2),
  g22     VARCHAR2(255),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  e23     NUMBER(18,2),
  f23     NUMBER(18,2),
  g23     VARCHAR2(255),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  e24     NUMBER(18,2),
  f24     NUMBER(18,2),
  g24     VARCHAR2(255),
  c25     NUMBER(18,2),
  d25     NUMBER(18,2),
  e25     NUMBER(18,2),
  f25     NUMBER(18,2),
  g25     VARCHAR2(255),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  e26     NUMBER(18,2),
  f26     NUMBER(18,2),
  g26     VARCHAR2(255),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  e27     NUMBER(18,2),
  f27     NUMBER(18,2),
  g27     VARCHAR2(255),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  e28     NUMBER(18,2),
  f28     NUMBER(18,2),
  g28     VARCHAR2(255),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  e29     NUMBER(18,2),
  f29     NUMBER(18,2),
  g29     VARCHAR2(255),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  e31     NUMBER(18,2),
  f31     NUMBER(18,2),
  g31     VARCHAR2(255),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  e34     NUMBER(18,2),
  f34     NUMBER(18,2),
  g34     VARCHAR2(255),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  e35     NUMBER(18,2),
  f35     NUMBER(18,2),
  g35     VARCHAR2(255),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  e36     NUMBER(18,2),
  f36     NUMBER(18,2),
  g36     VARCHAR2(255),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  e37     NUMBER(18,2),
  f37     NUMBER(18,2),
  g37     VARCHAR2(255),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  e38     NUMBER(18,2),
  f38     NUMBER(18,2),
  g38     VARCHAR2(255)
)
;
comment on table T_CSRC1107_A7
  is 'ͻ׽ʽȫԼܱ';

prompt
prompt Creating table T_CSRC1110_B_B0
prompt ==============================
prompt
create table T_CSRC1110_B_B0
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  f2      VARCHAR2(10),
  f3      VARCHAR2(1),
  f4      VARCHAR2(1),
  f5      VARCHAR2(1),
  f6      VARCHAR2(1),
  f7      VARCHAR2(1),
  f8      VARCHAR2(1),
  f9      VARCHAR2(1),
  f10     VARCHAR2(1),
  f11     VARCHAR2(1),
  f12     VARCHAR2(1),
  f13     VARCHAR2(1),
  f14     VARCHAR2(1),
  f15     VARCHAR2(1),
  f16     VARCHAR2(1),
  f17     VARCHAR2(1),
  f18     VARCHAR2(1),
  f19     VARCHAR2(1),
  f20     VARCHAR2(1),
  f21     VARCHAR2(1),
  f22     VARCHAR2(1),
  f23     VARCHAR2(1),
  f24     VARCHAR2(1),
  f25     VARCHAR2(1),
  f26     VARCHAR2(1),
  f27     VARCHAR2(1),
  f28     VARCHAR2(1),
  f29     VARCHAR2(1),
  f30     VARCHAR2(1),
  f31     VARCHAR2(1),
  f32     VARCHAR2(12),
  f33     VARCHAR2(1),
  f34     VARCHAR2(1),
  f35     VARCHAR2(1),
  f36     VARCHAR2(1),
  f37     VARCHAR2(1),
  f38     VARCHAR2(1),
  f39     VARCHAR2(12),
  f40     VARCHAR2(1),
  f41     VARCHAR2(1),
  f42     VARCHAR2(1),
  f43     VARCHAR2(1),
  f44     VARCHAR2(1),
  f45     VARCHAR2(1),
  f46     VARCHAR2(1),
  f47     VARCHAR2(24),
  f48     VARCHAR2(12),
  f49     VARCHAR2(12),
  f50     VARCHAR2(12),
  f51     VARCHAR2(1),
  f52     VARCHAR2(1),
  f53     VARCHAR2(1),
  f54     VARCHAR2(1),
  f55     VARCHAR2(1),
  f56     VARCHAR2(1),
  f57     VARCHAR2(1),
  f58     VARCHAR2(1),
  f59     VARCHAR2(1),
  f60     VARCHAR2(1),
  f61     VARCHAR2(1),
  f62     VARCHAR2(1),
  f63     VARCHAR2(1),
  f64     VARCHAR2(1),
  f65     VARCHAR2(1),
  f66     VARCHAR2(1),
  f67     VARCHAR2(1),
  f68     VARCHAR2(1),
  f69     VARCHAR2(1),
  f70     VARCHAR2(12),
  f71     VARCHAR2(12),
  f72     VARCHAR2(1),
  f73     VARCHAR2(1),
  f74     VARCHAR2(1),
  f75     VARCHAR2(1),
  f77     VARCHAR2(1),
  f79     VARCHAR2(1),
  f80     VARCHAR2(1),
  f81     VARCHAR2(1),
  f82     VARCHAR2(1),
  f83     VARCHAR2(1),
  f84     VARCHAR2(1),
  f85     VARCHAR2(1),
  f86     VARCHAR2(1),
  f87     VARCHAR2(1),
  f88     VARCHAR2(1),
  f89     VARCHAR2(1),
  f90     VARCHAR2(1),
  f91     VARCHAR2(1),
  f92     VARCHAR2(24),
  f93     VARCHAR2(1),
  f94     VARCHAR2(1),
  f95     VARCHAR2(1),
  f96     VARCHAR2(1),
  f97     VARCHAR2(1),
  f98     VARCHAR2(1),
  f99     VARCHAR2(1),
  f100    VARCHAR2(1),
  f101    VARCHAR2(1),
  f102    VARCHAR2(1),
  f103    VARCHAR2(1),
  f104    VARCHAR2(1),
  f105    VARCHAR2(1),
  f106    VARCHAR2(1),
  f107    VARCHAR2(1),
  f108    VARCHAR2(1),
  f109    VARCHAR2(1),
  f110    VARCHAR2(1),
  f111    VARCHAR2(1),
  f112    VARCHAR2(1),
  f113    VARCHAR2(1),
  f114    VARCHAR2(1),
  f115    VARCHAR2(1),
  f116    VARCHAR2(1),
  f117    VARCHAR2(1),
  f118    VARCHAR2(1),
  f119    VARCHAR2(1),
  f120    VARCHAR2(12),
  f121    VARCHAR2(1),
  f122    VARCHAR2(1),
  f123    VARCHAR2(1),
  f124    VARCHAR2(1),
  f125    VARCHAR2(1),
  f126    VARCHAR2(12),
  f127    VARCHAR2(1),
  f128    VARCHAR2(1),
  f129    VARCHAR2(1),
  f130    VARCHAR2(1),
  f131    VARCHAR2(1),
  f132    VARCHAR2(1),
  f133    VARCHAR2(1),
  f134    VARCHAR2(1),
  f135    VARCHAR2(1),
  f136    VARCHAR2(1),
  f137    VARCHAR2(1),
  f138    VARCHAR2(1),
  e139    VARCHAR2(255)
)
;
comment on table T_CSRC1110_B_B0
  is '֤ȯӪҵϢͳƱһ';

prompt
prompt Creating table T_CSRC1110_B_B1
prompt ==============================
prompt
create table T_CSRC1110_B_B1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  f2      NUMBER(19,2),
  f3      NUMBER(19,2),
  f4      NUMBER(19,2),
  f5      NUMBER(19,2),
  f6      NUMBER(19,2),
  f7      NUMBER(19,2),
  f8      NUMBER(19,2),
  f9      NUMBER(19,2),
  f10     NUMBER(19,2),
  f11     NUMBER(19,2),
  f12     NUMBER(19,2),
  f13     NUMBER(19,2),
  f14     NUMBER(19,2),
  f15     NUMBER(19,2),
  f16     NUMBER(19,2),
  f17     NUMBER(19,2),
  f18     NUMBER(19,2),
  f19     NUMBER(19,2),
  f20     NUMBER(19,2),
  f21     VARCHAR2(101),
  f22     NUMBER(19,2),
  f23     NUMBER(19,2),
  e24     VARCHAR2(255)
)
;
comment on table T_CSRC1110_B_B1
  is '֤ȯӪҵϢͳƱ';

prompt
prompt Creating table T_CSRC1110_B_XXB
prompt ===============================
prompt
create table T_CSRC1110_B_XXB
(
  bbq      VARCHAR2(8),
  userid   VARCHAR2(18),
  btype    VARCHAR2(1),
  option1  VARCHAR2(12),
  shtag    VARCHAR2(1),
  upid     VARCHAR2(18),
  username VARCHAR2(255),
  c11      VARCHAR2(24),
  f11      VARCHAR2(100),
  c13      VARCHAR2(50),
  f13      VARCHAR2(100)
)
;
comment on table T_CSRC1110_B_XXB
  is '֤ȯӪҵϢͳƱ';

prompt
prompt Creating table T_CSRC1212_C10_1
prompt ===============================
prompt
create table T_CSRC1212_C10_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d2      NUMBER(18),
  f2      NUMBER(18),
  d3      NUMBER(18),
  f3      NUMBER(18),
  d4      NUMBER(18),
  f4      NUMBER(18),
  d5      NUMBER(18),
  f5      NUMBER(18),
  d6      NUMBER(18),
  f6      NUMBER(18),
  d7      NUMBER(18),
  f7      NUMBER(18),
  d8      NUMBER(18),
  f8      NUMBER(18),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  d10     NUMBER(18,2),
  f10     NUMBER(18,2),
  d11     NUMBER(18,2),
  f11     NUMBER(18,2),
  d12     NUMBER(18,2),
  f12     NUMBER(18,2),
  d13     NUMBER(18,2),
  f13     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  d23     NUMBER(18),
  f23     NUMBER(18),
  d24     NUMBER(18),
  f24     NUMBER(18),
  d25     NUMBER(18),
  f25     NUMBER(18),
  d26     NUMBER(18,2),
  f26     NUMBER(18,2),
  d27     NUMBER(18,2),
  f27     NUMBER(18,2),
  d28     NUMBER(18,2),
  f28     NUMBER(18,2),
  d29     NUMBER(18,2),
  f29     NUMBER(18,2),
  d30     NUMBER(18,2),
  f30     NUMBER(18,2),
  d31     NUMBER(18),
  f31     NUMBER(18),
  d32     NUMBER(18),
  f32     NUMBER(18),
  d33     NUMBER(18),
  f33     NUMBER(18),
  d34     NUMBER(18,2),
  f34     NUMBER(18,2),
  d35     NUMBER(18,2),
  f35     NUMBER(18,2),
  d36     NUMBER(18,2),
  f36     NUMBER(18,2),
  d37     NUMBER(18,2),
  f37     NUMBER(18,2),
  d38     NUMBER(18,2),
  f38     NUMBER(18,2),
  d39     NUMBER(18,2),
  f39     NUMBER(18,2),
  d40     NUMBER(18,2),
  f40     NUMBER(18,2),
  d41     NUMBER(18,2),
  f41     NUMBER(18,2),
  d42     NUMBER(18,2),
  f42     NUMBER(18,2),
  d43     NUMBER(18,2),
  f43     NUMBER(18,2),
  d44     NUMBER(18,2),
  f44     NUMBER(18,2),
  d45     NUMBER(18,2),
  f45     NUMBER(18,2),
  b46     VARCHAR2(255)
)
;
comment on table T_CSRC1212_C10_1
  is 'ȯҵܱ';

prompt
prompt Creating table T_CSRC1219_C14_1
prompt ===============================
prompt
create table T_CSRC1219_C14_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c3      NUMBER(12),
  d3      NUMBER(12),
  e3      NUMBER(12),
  f3      NUMBER(12),
  g3      NUMBER(18,2),
  h3      NUMBER(18,2),
  i3      NUMBER(18,2),
  j3      NUMBER(18,2),
  k3      NUMBER(18,2),
  l3      NUMBER(18,2),
  m3      NUMBER(18,2),
  n3      NUMBER(18,2),
  c4      NUMBER(12),
  d4      NUMBER(12),
  e4      NUMBER(12),
  f4      NUMBER(12),
  g4      NUMBER(18,2),
  h4      NUMBER(18,2),
  i4      NUMBER(18,2),
  j4      NUMBER(18,2),
  k4      NUMBER(18,2),
  l4      NUMBER(18,2),
  m4      NUMBER(18,2),
  n4      NUMBER(18,2),
  c5      NUMBER(12),
  d5      NUMBER(12),
  e5      NUMBER(12),
  f5      NUMBER(12),
  g5      NUMBER(18,2),
  h5      NUMBER(18,2),
  i5      NUMBER(18,2),
  j5      NUMBER(18,2),
  k5      NUMBER(18,2),
  l5      NUMBER(18,2),
  m5      NUMBER(18,2),
  n5      NUMBER(18,2),
  c6      NUMBER(12),
  d6      NUMBER(12),
  e6      NUMBER(12),
  f6      NUMBER(12),
  g6      NUMBER(18,2),
  h6      NUMBER(18,2),
  i6      NUMBER(18,2),
  j6      NUMBER(18,2),
  k6      NUMBER(18,2),
  l6      NUMBER(18,2),
  m6      NUMBER(18,2),
  n6      NUMBER(18,2),
  c7      NUMBER(12),
  d7      NUMBER(12),
  e7      NUMBER(12),
  f7      NUMBER(12),
  g7      NUMBER(18,2),
  h7      NUMBER(18,2),
  i7      NUMBER(18,2),
  j7      NUMBER(18,2),
  k7      NUMBER(18,2),
  l7      NUMBER(18,2),
  m7      NUMBER(18,2),
  n7      NUMBER(18,2)
)
;
comment on table T_CSRC1219_C14_1
  is '֤ȯ˾÷ջ͹ҵ¶ȱ';

prompt
prompt Creating table T_CSRC1219_C14_2
prompt ===============================
prompt
create table T_CSRC1219_C14_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      VARCHAR2(50),
  b3      VARCHAR2(20),
  c3      VARCHAR2(255),
  d3      NUMBER(12),
  e3      NUMBER(12),
  f3      NUMBER(18,2),
  g3      NUMBER(18,2),
  h3      NUMBER(18,2),
  i3      NUMBER(18,2),
  j3      NUMBER(18,2),
  k3      NUMBER(18,2)
)
;
comment on table T_CSRC1219_C14_2
  is '֤ȯ˾ƷӪҵ¶ȱ';

prompt
prompt Creating table T_CSRC1219_C14_3
prompt ===============================
prompt
create table T_CSRC1219_C14_3
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b2      NUMBER(18),
  c2      NUMBER(18),
  d2      NUMBER(18),
  e2      NUMBER(18),
  b3      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  b5      NUMBER(18,2),
  d5      NUMBER(18,2),
  b6      NUMBER(18,2),
  d6      NUMBER(18,2),
  b7      NUMBER(18,2),
  d7      NUMBER(18,2),
  b9      NUMBER(18,2),
  d9      NUMBER(18,2),
  b10     NUMBER(18,2),
  d10     NUMBER(18,2),
  b11     NUMBER(18),
  d11     NUMBER(18)
)
;
comment on table T_CSRC1219_C14_3
  is '֤ȯ˾ҵ¶ȱ';

prompt
prompt Creating table T_CSRC1219_C14_4
prompt ===============================
prompt
create table T_CSRC1219_C14_4
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a3      VARCHAR2(20),
  b3      VARCHAR2(20),
  c3      VARCHAR2(20),
  d3      NUMBER(12),
  e3      NUMBER(12),
  f3      NUMBER(12),
  g3      NUMBER(12),
  h3      NUMBER(18,2),
  i3      NUMBER(18,2),
  j3      NUMBER(18,2),
  k3      NUMBER(18,2),
  l3      NUMBER(18,2),
  m3      NUMBER(18,2),
  n3      NUMBER(18,2),
  o3      NUMBER(18,2)
)
;
comment on table T_CSRC1219_C14_4
  is '֤ȯ˾ȨƷҵ¶ȱ';

prompt
prompt Creating table T_CSRC1219_C14_5
prompt ===============================
prompt
create table T_CSRC1219_C14_5
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b3      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  g3      NUMBER(18),
  b4      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18),
  g4      NUMBER(18),
  b7      NUMBER(18,2),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  e7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  b9      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  b12     NUMBER(18),
  c12     NUMBER(18),
  d12     NUMBER(18),
  f12     NUMBER(18),
  g12     NUMBER(18),
  b13     NUMBER(18),
  c13     NUMBER(18),
  d13     NUMBER(18),
  f13     NUMBER(18),
  g13     NUMBER(18),
  b14     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  g14     NUMBER(18,2),
  b15     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  g15     NUMBER(18,2),
  b17     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  b18     NUMBER(18,2),
  d18     NUMBER(18,2),
  f18     NUMBER(18,2),
  b19     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  b20     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  b22     NUMBER(18),
  b23     NUMBER(18,2),
  b24     NUMBER(18,2),
  b25     NUMBER(18),
  b28     NUMBER(18,2),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  f28     NUMBER(18,2),
  g28     NUMBER(18,2),
  b29     NUMBER(18,2),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  f29     NUMBER(18,2),
  g29     NUMBER(18,2),
  b30     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  f30     NUMBER(18,2),
  g30     NUMBER(18,2),
  b31     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  f31     NUMBER(18,2),
  g31     NUMBER(18,2),
  b34     NUMBER(18),
  c34     NUMBER(18),
  d34     NUMBER(18),
  f34     NUMBER(18),
  g34     NUMBER(18),
  b35     NUMBER(18,2),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  f35     NUMBER(18,2),
  g35     NUMBER(18,2),
  b36     NUMBER(18,2),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  f36     NUMBER(18,2),
  g36     NUMBER(18,2),
  b37     NUMBER(18,2),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  f37     NUMBER(18,2),
  g37     NUMBER(18,2),
  a39     VARCHAR2(4000)
)
;
comment on table T_CSRC1219_C14_5
  is 'ȨȨҵ';

prompt
prompt Creating table T_CSRC1219_C14_6
prompt ===============================
prompt
create table T_CSRC1219_C14_6
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  b3      NUMBER(18),
  c3      NUMBER(18),
  d3      NUMBER(18),
  e3      NUMBER(18),
  f3      NUMBER(18),
  g3      NUMBER(18),
  b4      NUMBER(18),
  c4      NUMBER(18),
  d4      NUMBER(18),
  e4      NUMBER(18),
  f4      NUMBER(18),
  g4      NUMBER(18),
  b7      NUMBER(18,2),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  e7      NUMBER(18,2),
  f7      NUMBER(18,2),
  g7      NUMBER(18,2),
  b9      NUMBER(18,2),
  d9      NUMBER(18,2),
  f9      NUMBER(18,2),
  b12     NUMBER(18),
  c12     NUMBER(18),
  d12     NUMBER(18),
  f12     NUMBER(18),
  g12     NUMBER(18),
  b13     NUMBER(18),
  c13     NUMBER(18),
  d13     NUMBER(18),
  f13     NUMBER(18),
  g13     NUMBER(18),
  b14     NUMBER(18,2),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  f14     NUMBER(18,2),
  g14     NUMBER(18,2),
  b15     NUMBER(18,2),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  f15     NUMBER(18,2),
  g15     NUMBER(18,2),
  b16     NUMBER(18,2),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  f16     NUMBER(18,2),
  g16     NUMBER(18,2),
  b17     NUMBER(18,2),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  f17     NUMBER(18,2),
  g17     NUMBER(18,2),
  b19     NUMBER(18,2),
  d19     NUMBER(18,2),
  f19     NUMBER(18,2),
  b20     NUMBER(18,2),
  d20     NUMBER(18,2),
  f20     NUMBER(18,2),
  b21     NUMBER(18,2),
  d21     NUMBER(18,2),
  f21     NUMBER(18,2),
  b22     NUMBER(18,2),
  d22     NUMBER(18,2),
  f22     NUMBER(18,2),
  b24     NUMBER(18),
  b25     NUMBER(18,2),
  b26     NUMBER(18,2),
  b27     NUMBER(18),
  b30     NUMBER(18,2),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  f30     NUMBER(18,2),
  g30     NUMBER(18,2),
  b31     NUMBER(18,2),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  f31     NUMBER(18,2),
  g31     NUMBER(18,2),
  b32     NUMBER(18,2),
  c32     NUMBER(18,2),
  d32     NUMBER(18,2),
  f32     NUMBER(18,2),
  g32     NUMBER(18,2),
  b33     NUMBER(18,2),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  f33     NUMBER(18,2),
  g33     NUMBER(18,2),
  b36     NUMBER(18),
  c36     NUMBER(18),
  d36     NUMBER(18),
  f36     NUMBER(18),
  g36     NUMBER(18),
  b37     NUMBER(18,2),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  f37     NUMBER(18,2),
  g37     NUMBER(18,2),
  b38     NUMBER(18,2),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  f38     NUMBER(18,2),
  g38     NUMBER(18,2),
  b39     NUMBER(18,2),
  c39     NUMBER(18,2),
  d39     NUMBER(18,2),
  f39     NUMBER(18,2),
  g39     NUMBER(18,2),
  b42     NUMBER(18),
  c42     NUMBER(18),
  d42     NUMBER(18),
  f42     NUMBER(18),
  g42     NUMBER(18),
  b43     NUMBER(18),
  c43     NUMBER(18),
  d43     NUMBER(18),
  f43     NUMBER(18),
  g43     NUMBER(18),
  b44     NUMBER(18,2),
  c44     NUMBER(18,2),
  d44     NUMBER(18,2),
  f44     NUMBER(18,2),
  g44     NUMBER(18,2),
  a46     VARCHAR2(4000)
)
;
comment on table T_CSRC1219_C14_6
  is 'ԹƱҵ';

prompt
prompt Creating table T_CSRC1219_C14_7
prompt ===============================
prompt
create table T_CSRC1219_C14_7
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(255),
  c2      DATE,
  d2      DATE,
  e2      NUMBER(12),
  f2      NUMBER(18,2),
  g2      NUMBER(18,2),
  h2      NUMBER(18,2),
  i2      NUMBER(18,2),
  j2      VARCHAR2(255),
  k2      NUMBER(18,2),
  l2      VARCHAR2(12),
  m2      VARCHAR2(255)
)
;
comment on table T_CSRC1219_C14_7
  is '֤ȯ˾жڹ˾ծȯ¶ȱ';

prompt
prompt Creating table T_CSRC1219_C14_8
prompt ===============================
prompt
create table T_CSRC1219_C14_8
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  ishj    VARCHAR2(1),
  a2      NUMBER(12),
  b2      VARCHAR2(255),
  c2      VARCHAR2(12),
  d2      DATE,
  e2      DATE,
  f2      NUMBER(12,2),
  g2      NUMBER(18,2),
  h2      NUMBER(18,2),
  i2      NUMBER(18,2),
  j2      NUMBER(18,2)
)
;
comment on table T_CSRC1219_C14_8
  is '֤ȯ˾ƾ֤¶ȱ';

prompt
prompt Creating table T_CSRC1226_A1_1
prompt ==============================
prompt
create table T_CSRC1226_A1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  m3      NUMBER(18,2),
  n3      NUMBER(18,2),
  p3      NUMBER(18,2),
  q3      NUMBER(18,2),
  m4      NUMBER(18,2),
  n4      NUMBER(18,2),
  p4      NUMBER(18,2),
  q4      NUMBER(18,2),
  m5      NUMBER(18,2),
  n5      NUMBER(18,2),
  p5      NUMBER(18,2),
  q5      NUMBER(18,2),
  m6      NUMBER(18,2),
  n6      NUMBER(18,2),
  p6      NUMBER(18,2),
  q6      NUMBER(18,2),
  m7      NUMBER(18,2),
  n7      NUMBER(18,2),
  p7      NUMBER(18,2),
  q7      NUMBER(18,2),
  m8      NUMBER(18,2),
  n8      NUMBER(18,2),
  p8      NUMBER(18,2),
  q8      NUMBER(18,2),
  m9      NUMBER(18,2),
  n9      NUMBER(18,2),
  p9      NUMBER(18,2),
  q9      NUMBER(18,2),
  m10     NUMBER(18,2),
  n10     NUMBER(18,2),
  p10     NUMBER(18,2),
  q10     NUMBER(18,2),
  m11     NUMBER(18,2),
  n11     NUMBER(18,2),
  p11     NUMBER(18,2),
  q11     NUMBER(18,2),
  m12     NUMBER(18,2),
  n12     NUMBER(18,2),
  p12     NUMBER(18,2),
  q12     NUMBER(18,2),
  m13     NUMBER(18,2),
  n13     NUMBER(18,2),
  p13     NUMBER(18,2),
  q13     NUMBER(18,2),
  m14     NUMBER(18,2),
  n14     NUMBER(18,2),
  p14     NUMBER(18,2),
  q14     NUMBER(18,2),
  m15     NUMBER(18,2),
  n15     NUMBER(18,2),
  p15     NUMBER(18,2),
  q15     NUMBER(18,2),
  m16     NUMBER(18,2),
  n16     NUMBER(18,2),
  p16     NUMBER(18,2),
  q16     NUMBER(18,2),
  m17     NUMBER(18,2),
  n17     NUMBER(18,2),
  p17     NUMBER(18,2),
  q17     NUMBER(18,2),
  m18     NUMBER(18,2),
  n18     NUMBER(18,2),
  p18     NUMBER(18,2),
  q18     NUMBER(18,2),
  m19     NUMBER(18,2),
  n19     NUMBER(18,2),
  p19     NUMBER(18,2),
  q19     NUMBER(18,2),
  m20     NUMBER(18,2),
  n20     NUMBER(18,2),
  p20     NUMBER(18,2),
  q20     NUMBER(18,2),
  m21     NUMBER(18,2),
  n21     NUMBER(18,2),
  p21     NUMBER(18,2),
  q21     NUMBER(18,2),
  m22     NUMBER(18,2),
  n22     NUMBER(18,2),
  p22     NUMBER(18,2),
  q22     NUMBER(18,2),
  m23     NUMBER(18,2),
  n23     NUMBER(18,2),
  p23     NUMBER(18,2),
  q23     NUMBER(18,2),
  m24     NUMBER(18,2),
  n24     NUMBER(18,2),
  p24     NUMBER(18,2),
  q24     NUMBER(18,2),
  m25     NUMBER(18,2),
  n25     NUMBER(18,2),
  p25     NUMBER(18,2),
  q25     NUMBER(18,2),
  m26     NUMBER(18,2),
  n26     NUMBER(18,2),
  p26     NUMBER(18,2),
  q26     NUMBER(18,2),
  m27     NUMBER(18,2),
  n27     NUMBER(18,2),
  p27     NUMBER(18,2),
  q27     NUMBER(18,2),
  m28     NUMBER(18,2),
  n28     NUMBER(18,2),
  p28     NUMBER(18,2),
  q28     NUMBER(18,2),
  m29     NUMBER(18,2),
  n29     NUMBER(18,2),
  p29     NUMBER(18,2),
  q29     NUMBER(18,2),
  m30     NUMBER(18,2),
  n30     NUMBER(18,2),
  p30     NUMBER(18,2),
  q30     NUMBER(18,2),
  m31     NUMBER(18,2),
  n31     NUMBER(18,2),
  p31     NUMBER(18,2),
  q31     NUMBER(18,2),
  m32     NUMBER(18,2),
  n32     NUMBER(18,2),
  p32     NUMBER(18,2),
  q32     NUMBER(18,2),
  m33     NUMBER(18,2),
  n33     NUMBER(18,2),
  o33     NUMBER(12),
  p33     NUMBER(18,2),
  q33     NUMBER(18,2),
  m34     NUMBER(18,2),
  n34     NUMBER(18,2),
  p34     NUMBER(18,2),
  q34     NUMBER(18,2),
  m35     NUMBER(18,2),
  n35     NUMBER(18,2),
  p35     NUMBER(18,2),
  q35     NUMBER(18,2),
  m36     NUMBER(18,2),
  n36     NUMBER(18,2),
  p36     NUMBER(18,2),
  q36     NUMBER(18,2),
  m37     NUMBER(18,2),
  n37     NUMBER(18,2),
  p37     NUMBER(18,2),
  q37     NUMBER(18,2),
  m38     NUMBER(18,2),
  n38     NUMBER(18,2),
  p38     NUMBER(18,2),
  q38     NUMBER(18,2),
  m39     NUMBER(18,2),
  n39     NUMBER(18,2),
  p39     NUMBER(18,2),
  q39     NUMBER(18,2),
  m40     NUMBER(18,2),
  n40     NUMBER(18,2),
  p40     NUMBER(18,2),
  q40     NUMBER(18,2),
  m41     NUMBER(18,2),
  n41     NUMBER(18,2),
  p41     NUMBER(18,2),
  q41     NUMBER(18,2),
  m42     NUMBER(18,2),
  n42     NUMBER(18,2),
  p42     NUMBER(18,2),
  q42     NUMBER(18,2),
  m43     NUMBER(18,2),
  n43     NUMBER(18,2),
  p43     NUMBER(18,2),
  q43     NUMBER(18,2),
  m44     NUMBER(18,2),
  n44     NUMBER(18,2),
  p44     NUMBER(18,2),
  q44     NUMBER(18,2),
  m45     NUMBER(18,2),
  n45     NUMBER(18,2),
  p45     NUMBER(18,2),
  q45     NUMBER(18,2),
  m46     NUMBER(18,2),
  n46     NUMBER(18,2),
  p46     NUMBER(18,2),
  q46     NUMBER(18,2),
  m47     NUMBER(18,2),
  n47     NUMBER(18,2),
  p47     NUMBER(18,2),
  q47     NUMBER(18,2),
  m48     NUMBER(18,2),
  n48     NUMBER(18,2),
  p48     NUMBER(18,2),
  q48     NUMBER(18,2),
  m49     NUMBER(18,2),
  n49     NUMBER(18,2),
  o49     NUMBER(12),
  p49     NUMBER(18,2),
  q49     NUMBER(18,2),
  m50     NUMBER(18,2),
  n50     NUMBER(18,2),
  p50     NUMBER(18,2),
  q50     NUMBER(18,2),
  m51     NUMBER(18,2),
  n51     NUMBER(18,2),
  p51     NUMBER(18,2),
  q51     NUMBER(18,2),
  m52     NUMBER(18,2),
  n52     NUMBER(18,2),
  p52     NUMBER(18,2),
  q52     NUMBER(18,2),
  m53     NUMBER(18,2),
  n53     NUMBER(18,2),
  p53     NUMBER(18,2),
  q53     NUMBER(18,2),
  m54     NUMBER(18,2),
  n54     NUMBER(18,2),
  p54     NUMBER(18,2),
  q54     NUMBER(18,2),
  m55     NUMBER(18,2),
  n55     NUMBER(18,2),
  p55     NUMBER(18,2),
  q55     NUMBER(18,2),
  m56     NUMBER(18,2),
  n56     NUMBER(18,2),
  p56     NUMBER(18,2),
  q56     NUMBER(18,2),
  m57     NUMBER(18,2),
  n57     NUMBER(18,2),
  p57     NUMBER(18,2),
  q57     NUMBER(18,2),
  m58     NUMBER(18,2),
  n58     NUMBER(18,2),
  p58     NUMBER(18,2),
  q58     NUMBER(18,2),
  m59     NUMBER(18,2),
  n59     NUMBER(18,2),
  p59     NUMBER(18,2),
  q59     NUMBER(18,2),
  m60     NUMBER(18,2),
  n60     NUMBER(18,2),
  p60     NUMBER(18,2),
  q60     NUMBER(18,2),
  m61     NUMBER(18,2),
  n61     NUMBER(18,2),
  p61     NUMBER(18,2),
  q61     NUMBER(18,2),
  m62     NUMBER(18,2),
  n62     NUMBER(18,2),
  p62     NUMBER(18,2),
  q62     NUMBER(18,2),
  m63     NUMBER(18,2),
  n63     NUMBER(18,2),
  p63     NUMBER(18,2),
  q63     NUMBER(18,2),
  m64     NUMBER(18,2),
  n64     NUMBER(18,2),
  p64     NUMBER(18,2),
  q64     NUMBER(18,2),
  m65     NUMBER(18,2),
  n65     NUMBER(18,2),
  p65     NUMBER(18,2),
  q65     NUMBER(18,2),
  m66     NUMBER(18,2),
  n66     NUMBER(18,2),
  p66     NUMBER(18,2),
  q66     NUMBER(18,2),
  m67     NUMBER(18,2),
  n67     NUMBER(18,2),
  p67     NUMBER(18,2),
  q67     NUMBER(18,2),
  m68     NUMBER(18,2),
  n68     NUMBER(18,2),
  p68     NUMBER(18,2),
  q68     NUMBER(18,2),
  m69     NUMBER(18,2),
  n69     NUMBER(18,2),
  p69     NUMBER(18,2),
  q69     NUMBER(18,2),
  m70     NUMBER(18,2),
  n70     NUMBER(18,2),
  p70     NUMBER(18,2),
  q70     NUMBER(18,2),
  m71     NUMBER(18,2),
  n71     NUMBER(18,2),
  p71     NUMBER(18,2),
  q71     NUMBER(18,2),
  m72     NUMBER(18,2),
  n72     NUMBER(18,2),
  p72     NUMBER(18,2),
  q72     NUMBER(18,2),
  m73     NUMBER(18,2),
  n73     NUMBER(18,2),
  p73     NUMBER(18,2),
  q73     NUMBER(18,2),
  m74     NUMBER(18,2),
  n74     NUMBER(18,2),
  p74     NUMBER(18,2),
  q74     NUMBER(18,2),
  m75     NUMBER(18,2),
  n75     NUMBER(18,2),
  p75     NUMBER(18,2),
  q75     NUMBER(18,2),
  m76     NUMBER(18,2),
  n76     NUMBER(18,2),
  p76     NUMBER(18,2),
  q76     NUMBER(18,2),
  m77     NUMBER(18,2),
  n77     NUMBER(18,2),
  p77     NUMBER(18,2),
  q77     NUMBER(18,2),
  m78     NUMBER(18,2),
  n78     NUMBER(18,2),
  p78     NUMBER(18,2),
  q78     NUMBER(18,2),
  m79     NUMBER(18,2),
  n79     NUMBER(18,2),
  p79     NUMBER(18,2),
  q79     NUMBER(18,2),
  m80     NUMBER(18,2),
  n80     NUMBER(18,2),
  p80     NUMBER(18,2),
  q80     NUMBER(18,2),
  m81     NUMBER(18,2),
  n81     NUMBER(18,2),
  p81     NUMBER(18,2),
  q81     NUMBER(18,2),
  m82     NUMBER(18,2),
  n82     NUMBER(18,2),
  o82     NUMBER(12),
  p82     NUMBER(18,2),
  q82     NUMBER(18,2),
  m83     NUMBER(18,2),
  n83     NUMBER(18,2),
  p83     NUMBER(18,2),
  q83     NUMBER(18,2),
  m84     NUMBER(18,2),
  n84     NUMBER(18,2),
  p84     NUMBER(18,2),
  q84     NUMBER(18,2),
  m85     NUMBER(18,2),
  n85     NUMBER(18,2),
  o85     NUMBER(12),
  p85     NUMBER(18,2),
  q85     NUMBER(18,2),
  m86     NUMBER(18,2),
  n86     NUMBER(18,2),
  p86     NUMBER(18,2),
  q86     NUMBER(18,2),
  m87     NUMBER(18,2),
  n87     NUMBER(18,2),
  o87     NUMBER(12),
  p87     NUMBER(18,2),
  q87     NUMBER(18,2),
  m88     NUMBER(18,2),
  n88     NUMBER(18,2),
  o88     NUMBER(12),
  p88     NUMBER(18,2),
  q88     NUMBER(18,2),
  m89     NUMBER(18,2),
  n89     NUMBER(18,2),
  p89     NUMBER(18,2),
  q89     NUMBER(18,2),
  a91     VARCHAR2(2000),
  a93     VARCHAR2(2000)
)
;

prompt
prompt Creating table T_CSRC1226_A2_1
prompt ==============================
prompt
create table T_CSRC1226_A2_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  d2      NUMBER(18,2),
  e2      VARCHAR2(25),
  f2      VARCHAR2(25),
  g2      VARCHAR2(100),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  e3      VARCHAR2(25),
  f3      VARCHAR2(25),
  g3      VARCHAR2(100),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  g4      VARCHAR2(100),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  g5      VARCHAR2(100),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  g6      VARCHAR2(100),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  g7      VARCHAR2(100),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  g8      VARCHAR2(100),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  g9      VARCHAR2(100),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  g10     VARCHAR2(100),
  a12     VARCHAR2(60),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  e12     VARCHAR2(25),
  f12     VARCHAR2(25),
  g12     VARCHAR2(100),
  a13     VARCHAR2(60),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  e13     VARCHAR2(25),
  f13     VARCHAR2(25),
  g13     VARCHAR2(100),
  a14     VARCHAR2(60),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  e14     VARCHAR2(25),
  f14     VARCHAR2(25),
  g14     VARCHAR2(100),
  a15     VARCHAR2(60),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  e15     VARCHAR2(25),
  f15     VARCHAR2(25),
  g15     VARCHAR2(100),
  a16     VARCHAR2(60),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  e16     VARCHAR2(25),
  f16     VARCHAR2(25),
  g16     VARCHAR2(100),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  g17     VARCHAR2(100),
  a19     VARCHAR2(60),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     VARCHAR2(25),
  f19     VARCHAR2(25),
  g19     VARCHAR2(100),
  a20     VARCHAR2(60),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  e20     VARCHAR2(25),
  f20     VARCHAR2(25),
  g20     VARCHAR2(100),
  a21     VARCHAR2(60),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  e21     VARCHAR2(25),
  f21     VARCHAR2(25),
  g21     VARCHAR2(100),
  a22     VARCHAR2(60),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  e22     VARCHAR2(25),
  f22     VARCHAR2(25),
  g22     VARCHAR2(100),
  a23     VARCHAR2(60),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  e23     VARCHAR2(25),
  f23     VARCHAR2(25),
  g23     VARCHAR2(100),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  g24     VARCHAR2(100),
  a26     VARCHAR2(60),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  e26     VARCHAR2(25),
  f26     VARCHAR2(25),
  g26     VARCHAR2(100),
  a27     VARCHAR2(60),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  e27     VARCHAR2(25),
  f27     VARCHAR2(25),
  g27     VARCHAR2(100),
  a28     VARCHAR2(60),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  e28     VARCHAR2(25),
  f28     VARCHAR2(25),
  g28     VARCHAR2(100),
  a29     VARCHAR2(60),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  e29     VARCHAR2(25),
  f29     VARCHAR2(25),
  g29     VARCHAR2(100),
  a30     VARCHAR2(60),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  e30     VARCHAR2(25),
  f30     VARCHAR2(25),
  g30     VARCHAR2(100),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  g31     VARCHAR2(100),
  a33     VARCHAR2(60),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  e33     VARCHAR2(25),
  f33     VARCHAR2(25),
  g33     VARCHAR2(100),
  a34     VARCHAR2(60),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  e34     VARCHAR2(25),
  f34     VARCHAR2(25),
  g34     VARCHAR2(100),
  a35     VARCHAR2(60),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  e35     VARCHAR2(25),
  f35     VARCHAR2(25),
  g35     VARCHAR2(100),
  a36     VARCHAR2(60),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  e36     VARCHAR2(25),
  f36     VARCHAR2(25),
  g36     VARCHAR2(100),
  a37     VARCHAR2(60),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  e37     VARCHAR2(25),
  f37     VARCHAR2(25),
  g37     VARCHAR2(100),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  g38     VARCHAR2(100),
  a40     VARCHAR2(60),
  c40     NUMBER(18,2),
  d40     NUMBER(18,2),
  e40     VARCHAR2(25),
  f40     VARCHAR2(25),
  g40     VARCHAR2(100),
  a41     VARCHAR2(60),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  e41     VARCHAR2(25),
  f41     VARCHAR2(25),
  g41     VARCHAR2(100),
  a42     VARCHAR2(60),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  e42     VARCHAR2(25),
  f42     VARCHAR2(25),
  g42     VARCHAR2(100),
  a43     VARCHAR2(60),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  e43     VARCHAR2(25),
  f43     VARCHAR2(25),
  g43     VARCHAR2(100),
  a44     VARCHAR2(60),
  c44     NUMBER(18,2),
  d44     NUMBER(18,2),
  e44     VARCHAR2(25),
  f44     VARCHAR2(25),
  g44     VARCHAR2(100),
  c45     NUMBER(18,2),
  d45     NUMBER(18,2),
  g45     VARCHAR2(100),
  a47     VARCHAR2(60),
  c47     NUMBER(18,2),
  d47     NUMBER(18,2),
  e47     VARCHAR2(25),
  f47     VARCHAR2(25),
  g47     VARCHAR2(100),
  a48     VARCHAR2(60),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  e48     VARCHAR2(25),
  f48     VARCHAR2(25),
  g48     VARCHAR2(100),
  a49     VARCHAR2(60),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  e49     VARCHAR2(25),
  f49     VARCHAR2(25),
  g49     VARCHAR2(100),
  a50     VARCHAR2(60),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  e50     VARCHAR2(25),
  f50     VARCHAR2(25),
  g50     VARCHAR2(100),
  a51     VARCHAR2(60),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  e51     VARCHAR2(25),
  f51     VARCHAR2(25),
  g51     VARCHAR2(100)
)
;
comment on table T_CSRC1226_A2_1
  is '֤ȯ˾տָܱ()';

prompt
prompt Creating table T_CSRC1226_A2_2
prompt ==============================
prompt
create table T_CSRC1226_A2_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d1      VARCHAR2(12),
  o4      NUMBER(18,2),
  p4      NUMBER(18,2),
  h5      NUMBER(18,2),
  i5      NUMBER(18,2),
  o5      NUMBER(18,2),
  p5      NUMBER(18,2),
  o6      NUMBER(18,2),
  p6      NUMBER(18,2),
  h7      NUMBER(18,2),
  i7      NUMBER(18,2),
  o7      NUMBER(18,2),
  p7      NUMBER(18,2),
  h8      NUMBER(18,2),
  i8      NUMBER(18,2),
  o8      NUMBER(18,2),
  p8      NUMBER(18,2),
  h9      NUMBER(18,2),
  i9      NUMBER(18,2),
  o9      NUMBER(18,2),
  p9      NUMBER(18,2),
  h10     NUMBER(18,2),
  i10     NUMBER(18,2),
  o10     NUMBER(18,2),
  p10     NUMBER(18,2),
  h11     NUMBER(18,2),
  i11     NUMBER(18,2),
  o11     NUMBER(18,2),
  p11     NUMBER(18,2),
  h12     NUMBER(18,2),
  i12     NUMBER(18,2),
  o12     NUMBER(18,2),
  p12     NUMBER(18,2),
  h13     NUMBER(18,2),
  i13     NUMBER(18,2),
  o13     NUMBER(18,2),
  p13     NUMBER(18,2),
  h14     NUMBER(18,2),
  i14     NUMBER(18,2),
  o14     NUMBER(18,2),
  p14     NUMBER(18,2),
  h15     NUMBER(18,2),
  i15     NUMBER(18,2),
  o15     NUMBER(18,2),
  p15     NUMBER(18,2),
  h16     NUMBER(18,2),
  i16     NUMBER(18,2),
  o16     NUMBER(18,2),
  p16     NUMBER(18,2),
  h17     NUMBER(18,2),
  i17     NUMBER(18,2),
  o17     NUMBER(18,2),
  p17     NUMBER(18,2),
  h18     NUMBER(18,2),
  i18     NUMBER(18,2),
  o18     NUMBER(18,2),
  p18     NUMBER(18,2),
  h19     NUMBER(18,2),
  i19     NUMBER(18,2),
  o19     NUMBER(18,2),
  p19     NUMBER(18,2),
  h20     NUMBER(18,2),
  i20     NUMBER(18,2),
  o20     NUMBER(18,2),
  p20     NUMBER(18,2),
  h21     NUMBER(18,2),
  i21     NUMBER(18,2),
  o21     NUMBER(18,2),
  p21     NUMBER(18,2),
  h22     NUMBER(18,2),
  i22     NUMBER(18,2),
  o22     NUMBER(18,2),
  p22     NUMBER(18,2),
  h23     NUMBER(18,2),
  i23     NUMBER(18,2),
  o23     NUMBER(18,2),
  p23     NUMBER(18,2),
  h24     NUMBER(18,2),
  i24     NUMBER(18,2),
  o24     NUMBER(18,2),
  p24     NUMBER(18,2),
  h25     NUMBER(18,2),
  i25     NUMBER(18,2),
  o25     NUMBER(18,2),
  p25     NUMBER(18,2),
  h26     NUMBER(18,2),
  i26     NUMBER(18,2),
  o26     NUMBER(18,2),
  p26     NUMBER(18,2),
  h27     NUMBER(18,2),
  i27     NUMBER(18,2),
  o27     NUMBER(18,2),
  p27     NUMBER(18,2),
  h28     NUMBER(18,2),
  i28     NUMBER(18,2),
  o28     NUMBER(18,2),
  p28     NUMBER(18,2),
  h29     NUMBER(18,2),
  i29     NUMBER(18,2),
  o29     NUMBER(18,2),
  p29     NUMBER(18,2),
  h30     NUMBER(18,2),
  i30     NUMBER(18,2),
  o30     NUMBER(18,2),
  p30     NUMBER(18,2),
  h31     NUMBER(18,2),
  i31     NUMBER(18,2),
  o31     NUMBER(18,2),
  p31     NUMBER(18,2),
  h32     NUMBER(18,2),
  i32     NUMBER(18,2),
  o32     NUMBER(18,2),
  p32     NUMBER(18,2),
  h33     NUMBER(18,2),
  i33     NUMBER(18,2),
  o33     NUMBER(18,2),
  p33     NUMBER(18,2),
  h34     NUMBER(18,2),
  i34     NUMBER(18,2),
  o34     NUMBER(18,2),
  p34     NUMBER(18,2),
  h35     NUMBER(18,2),
  i35     NUMBER(18,2),
  o35     NUMBER(18,2),
  p35     NUMBER(18,2),
  h36     NUMBER(18,2),
  i36     NUMBER(18,2),
  o36     NUMBER(18,2),
  p36     NUMBER(18,2),
  h37     NUMBER(18,2),
  i37     NUMBER(18,2),
  o37     NUMBER(18,2),
  p37     NUMBER(18,2),
  h38     NUMBER(18,2),
  i38     NUMBER(18,2),
  o38     NUMBER(18,2),
  p38     NUMBER(18,2),
  h39     NUMBER(18,2),
  i39     NUMBER(18,2),
  o39     NUMBER(18,2),
  p39     NUMBER(18,2),
  h40     NUMBER(18,2),
  i40     NUMBER(18,2),
  o40     NUMBER(18,2),
  p40     NUMBER(18,2),
  h41     NUMBER(18,2),
  i41     NUMBER(18,2),
  o41     NUMBER(18,2),
  p41     NUMBER(18,2),
  o42     NUMBER(18,2),
  p42     NUMBER(18,2),
  h43     NUMBER(18,2),
  i43     NUMBER(18,2),
  o43     NUMBER(18,2),
  p43     NUMBER(18,2),
  h44     NUMBER(18,2),
  i44     NUMBER(18,2),
  o44     NUMBER(18,2),
  p44     NUMBER(18,2),
  h45     NUMBER(18,2),
  i45     NUMBER(18,2),
  o45     NUMBER(18,2),
  p45     NUMBER(18,2),
  h46     NUMBER(18,2),
  i46     NUMBER(18,2),
  o46     NUMBER(18,2),
  p46     NUMBER(18,2),
  o47     NUMBER(18,2),
  p47     NUMBER(18,2),
  h48     NUMBER(18,2),
  i48     NUMBER(18,2),
  o48     NUMBER(18,2),
  p48     NUMBER(18,2),
  h49     NUMBER(18,2),
  i49     NUMBER(18,2),
  o49     NUMBER(18,2),
  p49     NUMBER(18,2),
  h50     NUMBER(18,2),
  i50     NUMBER(18,2),
  o50     NUMBER(18,2),
  p50     NUMBER(18,2),
  h51     NUMBER(18,2),
  i51     NUMBER(18,2),
  o51     NUMBER(18,2),
  p51     NUMBER(18,2),
  o52     NUMBER(18,2),
  p52     NUMBER(18,2),
  h53     NUMBER(18,2),
  i53     NUMBER(18,2),
  o53     NUMBER(18,2),
  p53     NUMBER(18,2),
  h54     NUMBER(18,2),
  i54     NUMBER(18,2),
  o54     NUMBER(18,2),
  p54     NUMBER(18,2),
  o55     NUMBER(18,2),
  p55     NUMBER(18,2),
  h56     NUMBER(18,2),
  i56     NUMBER(18,2),
  o56     NUMBER(18,2),
  p56     NUMBER(18,2),
  h57     NUMBER(18,2),
  i57     NUMBER(18,2),
  o57     NUMBER(18,2),
  p57     NUMBER(18,2),
  o58     NUMBER(18,2),
  p58     NUMBER(18,2),
  h59     NUMBER(18,2),
  i59     NUMBER(18,2),
  o59     NUMBER(18,2),
  p59     NUMBER(18,2),
  h60     NUMBER(18,2),
  i60     NUMBER(18,2),
  o60     NUMBER(18,2),
  p60     NUMBER(18,2),
  h61     NUMBER(18,2),
  i61     NUMBER(18,2),
  o61     NUMBER(18,2),
  p61     NUMBER(18,2),
  h62     NUMBER(18,2),
  i62     NUMBER(18,2),
  o62     NUMBER(18,2),
  p62     NUMBER(18,2),
  h63     NUMBER(18,2),
  i63     NUMBER(18,2),
  o63     NUMBER(18,2),
  p63     NUMBER(18,2),
  o64     NUMBER(18,2),
  p64     NUMBER(18,2),
  a66     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC1226_Z_A1_1
prompt ================================
prompt
create table T_CSRC1226_Z_A1_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  m3      NUMBER(18,2),
  n3      NUMBER(18,2),
  p3      NUMBER(18,2),
  q3      NUMBER(18,2),
  m4      NUMBER(18,2),
  n4      NUMBER(18,2),
  p4      NUMBER(18,2),
  q4      NUMBER(18,2),
  m5      NUMBER(18,2),
  n5      NUMBER(18,2),
  p5      NUMBER(18,2),
  q5      NUMBER(18,2),
  m6      NUMBER(18,2),
  n6      NUMBER(18,2),
  p6      NUMBER(18,2),
  q6      NUMBER(18,2),
  m7      NUMBER(18,2),
  n7      NUMBER(18,2),
  p7      NUMBER(18,2),
  q7      NUMBER(18,2),
  m8      NUMBER(18,2),
  n8      NUMBER(18,2),
  p8      NUMBER(18,2),
  q8      NUMBER(18,2),
  m9      NUMBER(18,2),
  n9      NUMBER(18,2),
  p9      NUMBER(18,2),
  q9      NUMBER(18,2),
  m10     NUMBER(18,2),
  n10     NUMBER(18,2),
  p10     NUMBER(18,2),
  q10     NUMBER(18,2),
  m11     NUMBER(18,2),
  n11     NUMBER(18,2),
  p11     NUMBER(18,2),
  q11     NUMBER(18,2),
  m12     NUMBER(18,2),
  n12     NUMBER(18,2),
  p12     NUMBER(18,2),
  q12     NUMBER(18,2),
  m13     NUMBER(18,2),
  n13     NUMBER(18,2),
  p13     NUMBER(18,2),
  q13     NUMBER(18,2),
  m14     NUMBER(18,2),
  n14     NUMBER(18,2),
  p14     NUMBER(18,2),
  q14     NUMBER(18,2),
  m15     NUMBER(18,2),
  n15     NUMBER(18,2),
  p15     NUMBER(18,2),
  q15     NUMBER(18,2),
  m16     NUMBER(18,2),
  n16     NUMBER(18,2),
  p16     NUMBER(18,2),
  q16     NUMBER(18,2),
  m17     NUMBER(18,2),
  n17     NUMBER(18,2),
  p17     NUMBER(18,2),
  q17     NUMBER(18,2),
  m18     NUMBER(18,2),
  n18     NUMBER(18,2),
  p18     NUMBER(18,2),
  q18     NUMBER(18,2),
  m19     NUMBER(18,2),
  n19     NUMBER(18,2),
  p19     NUMBER(18,2),
  q19     NUMBER(18,2),
  m20     NUMBER(18,2),
  n20     NUMBER(18,2),
  p20     NUMBER(18,2),
  q20     NUMBER(18,2),
  m21     NUMBER(18,2),
  n21     NUMBER(18,2),
  p21     NUMBER(18,2),
  q21     NUMBER(18,2),
  m22     NUMBER(18,2),
  n22     NUMBER(18,2),
  p22     NUMBER(18,2),
  q22     NUMBER(18,2),
  m23     NUMBER(18,2),
  n23     NUMBER(18,2),
  p23     NUMBER(18,2),
  q23     NUMBER(18,2),
  m24     NUMBER(18,2),
  n24     NUMBER(18,2),
  p24     NUMBER(18,2),
  q24     NUMBER(18,2),
  m25     NUMBER(18,2),
  n25     NUMBER(18,2),
  p25     NUMBER(18,2),
  q25     NUMBER(18,2),
  m26     NUMBER(18,2),
  n26     NUMBER(18,2),
  p26     NUMBER(18,2),
  q26     NUMBER(18,2),
  m27     NUMBER(18,2),
  n27     NUMBER(18,2),
  p27     NUMBER(18,2),
  q27     NUMBER(18,2),
  m28     NUMBER(18,2),
  n28     NUMBER(18,2),
  p28     NUMBER(18,2),
  q28     NUMBER(18,2),
  m29     NUMBER(18,2),
  n29     NUMBER(18,2),
  p29     NUMBER(18,2),
  q29     NUMBER(18,2),
  m30     NUMBER(18,2),
  n30     NUMBER(18,2),
  p30     NUMBER(18,2),
  q30     NUMBER(18,2),
  m31     NUMBER(18,2),
  n31     NUMBER(18,2),
  p31     NUMBER(18,2),
  q31     NUMBER(18,2),
  m32     NUMBER(18,2),
  n32     NUMBER(18,2),
  p32     NUMBER(18,2),
  q32     NUMBER(18,2),
  m33     NUMBER(18,2),
  n33     NUMBER(18,2),
  o33     NUMBER(12),
  p33     NUMBER(18,2),
  q33     NUMBER(18,2),
  m34     NUMBER(18,2),
  n34     NUMBER(18,2),
  p34     NUMBER(18,2),
  q34     NUMBER(18,2),
  m35     NUMBER(18,2),
  n35     NUMBER(18,2),
  p35     NUMBER(18,2),
  q35     NUMBER(18,2),
  m36     NUMBER(18,2),
  n36     NUMBER(18,2),
  p36     NUMBER(18,2),
  q36     NUMBER(18,2),
  m37     NUMBER(18,2),
  n37     NUMBER(18,2),
  p37     NUMBER(18,2),
  q37     NUMBER(18,2),
  m38     NUMBER(18,2),
  n38     NUMBER(18,2),
  p38     NUMBER(18,2),
  q38     NUMBER(18,2),
  m39     NUMBER(18,2),
  n39     NUMBER(18,2),
  p39     NUMBER(18,2),
  q39     NUMBER(18,2),
  m40     NUMBER(18,2),
  n40     NUMBER(18,2),
  p40     NUMBER(18,2),
  q40     NUMBER(18,2),
  m41     NUMBER(18,2),
  n41     NUMBER(18,2),
  p41     NUMBER(18,2),
  q41     NUMBER(18,2),
  m42     NUMBER(18,2),
  n42     NUMBER(18,2),
  p42     NUMBER(18,2),
  q42     NUMBER(18,2),
  m43     NUMBER(18,2),
  n43     NUMBER(18,2),
  p43     NUMBER(18,2),
  q43     NUMBER(18,2),
  m44     NUMBER(18,2),
  n44     NUMBER(18,2),
  p44     NUMBER(18,2),
  q44     NUMBER(18,2),
  m45     NUMBER(18,2),
  n45     NUMBER(18,2),
  p45     NUMBER(18,2),
  q45     NUMBER(18,2),
  m46     NUMBER(18,2),
  n46     NUMBER(18,2),
  p46     NUMBER(18,2),
  q46     NUMBER(18,2),
  m47     NUMBER(18,2),
  n47     NUMBER(18,2),
  p47     NUMBER(18,2),
  q47     NUMBER(18,2),
  m48     NUMBER(18,2),
  n48     NUMBER(18,2),
  p48     NUMBER(18,2),
  q48     NUMBER(18,2),
  m49     NUMBER(18,2),
  n49     NUMBER(18,2),
  o49     NUMBER(12),
  p49     NUMBER(18,2),
  q49     NUMBER(18,2),
  m50     NUMBER(18,2),
  n50     NUMBER(18,2),
  p50     NUMBER(18,2),
  q50     NUMBER(18,2),
  m51     NUMBER(18,2),
  n51     NUMBER(18,2),
  p51     NUMBER(18,2),
  q51     NUMBER(18,2),
  m52     NUMBER(18,2),
  n52     NUMBER(18,2),
  p52     NUMBER(18,2),
  q52     NUMBER(18,2),
  m53     NUMBER(18,2),
  n53     NUMBER(18,2),
  p53     NUMBER(18,2),
  q53     NUMBER(18,2),
  m54     NUMBER(18,2),
  n54     NUMBER(18,2),
  p54     NUMBER(18,2),
  q54     NUMBER(18,2),
  m55     NUMBER(18,2),
  n55     NUMBER(18,2),
  p55     NUMBER(18,2),
  q55     NUMBER(18,2),
  m56     NUMBER(18,2),
  n56     NUMBER(18,2),
  p56     NUMBER(18,2),
  q56     NUMBER(18,2),
  m57     NUMBER(18,2),
  n57     NUMBER(18,2),
  p57     NUMBER(18,2),
  q57     NUMBER(18,2),
  m58     NUMBER(18,2),
  n58     NUMBER(18,2),
  p58     NUMBER(18,2),
  q58     NUMBER(18,2),
  m59     NUMBER(18,2),
  n59     NUMBER(18,2),
  p59     NUMBER(18,2),
  q59     NUMBER(18,2),
  m60     NUMBER(18,2),
  n60     NUMBER(18,2),
  p60     NUMBER(18,2),
  q60     NUMBER(18,2),
  m61     NUMBER(18,2),
  n61     NUMBER(18,2),
  p61     NUMBER(18,2),
  q61     NUMBER(18,2),
  m62     NUMBER(18,2),
  n62     NUMBER(18,2),
  p62     NUMBER(18,2),
  q62     NUMBER(18,2),
  m63     NUMBER(18,2),
  n63     NUMBER(18,2),
  p63     NUMBER(18,2),
  q63     NUMBER(18,2),
  m64     NUMBER(18,2),
  n64     NUMBER(18,2),
  p64     NUMBER(18,2),
  q64     NUMBER(18,2),
  m65     NUMBER(18,2),
  n65     NUMBER(18,2),
  p65     NUMBER(18,2),
  q65     NUMBER(18,2),
  m66     NUMBER(18,2),
  n66     NUMBER(18,2),
  p66     NUMBER(18,2),
  q66     NUMBER(18,2),
  m67     NUMBER(18,2),
  n67     NUMBER(18,2),
  p67     NUMBER(18,2),
  q67     NUMBER(18,2),
  m68     NUMBER(18,2),
  n68     NUMBER(18,2),
  p68     NUMBER(18,2),
  q68     NUMBER(18,2),
  m69     NUMBER(18,2),
  n69     NUMBER(18,2),
  p69     NUMBER(18,2),
  q69     NUMBER(18,2),
  m70     NUMBER(18,2),
  n70     NUMBER(18,2),
  p70     NUMBER(18,2),
  q70     NUMBER(18,2),
  m71     NUMBER(18,2),
  n71     NUMBER(18,2),
  p71     NUMBER(18,2),
  q71     NUMBER(18,2),
  m72     NUMBER(18,2),
  n72     NUMBER(18,2),
  p72     NUMBER(18,2),
  q72     NUMBER(18,2),
  m73     NUMBER(18,2),
  n73     NUMBER(18,2),
  p73     NUMBER(18,2),
  q73     NUMBER(18,2),
  m74     NUMBER(18,2),
  n74     NUMBER(18,2),
  p74     NUMBER(18,2),
  q74     NUMBER(18,2),
  m75     NUMBER(18,2),
  n75     NUMBER(18,2),
  p75     NUMBER(18,2),
  q75     NUMBER(18,2),
  m76     NUMBER(18,2),
  n76     NUMBER(18,2),
  p76     NUMBER(18,2),
  q76     NUMBER(18,2),
  m77     NUMBER(18,2),
  n77     NUMBER(18,2),
  p77     NUMBER(18,2),
  q77     NUMBER(18,2),
  m78     NUMBER(18,2),
  n78     NUMBER(18,2),
  p78     NUMBER(18,2),
  q78     NUMBER(18,2),
  m79     NUMBER(18,2),
  n79     NUMBER(18,2),
  p79     NUMBER(18,2),
  q79     NUMBER(18,2),
  m80     NUMBER(18,2),
  n80     NUMBER(18,2),
  p80     NUMBER(18,2),
  q80     NUMBER(18,2),
  m81     NUMBER(18,2),
  n81     NUMBER(18,2),
  p81     NUMBER(18,2),
  q81     NUMBER(18,2),
  m82     NUMBER(18,2),
  n82     NUMBER(18,2),
  o82     NUMBER(12),
  p82     NUMBER(18,2),
  q82     NUMBER(18,2),
  m83     NUMBER(18,2),
  n83     NUMBER(18,2),
  p83     NUMBER(18,2),
  q83     NUMBER(18,2),
  m84     NUMBER(18,2),
  n84     NUMBER(18,2),
  p84     NUMBER(18,2),
  q84     NUMBER(18,2),
  m85     NUMBER(18,2),
  n85     NUMBER(18,2),
  o85     NUMBER(12),
  p85     NUMBER(18,2),
  q85     NUMBER(18,2),
  m86     NUMBER(18,2),
  n86     NUMBER(18,2),
  p86     NUMBER(18,2),
  q86     NUMBER(18,2),
  m87     NUMBER(18,2),
  n87     NUMBER(18,2),
  o87     NUMBER(12),
  p87     NUMBER(18,2),
  q87     NUMBER(18,2),
  m88     NUMBER(18,2),
  n88     NUMBER(18,2),
  o88     NUMBER(12),
  p88     NUMBER(18,2),
  q88     NUMBER(18,2),
  m89     NUMBER(18,2),
  n89     NUMBER(18,2),
  p89     NUMBER(18,2),
  q89     NUMBER(18,2),
  a91     VARCHAR2(2000),
  a93     VARCHAR2(2000)
)
;

prompt
prompt Creating table T_CSRC1226_Z_A2_1
prompt ================================
prompt
create table T_CSRC1226_Z_A2_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c2      NUMBER(18,2),
  d2      NUMBER(18,2),
  e2      VARCHAR2(25),
  f2      VARCHAR2(25),
  g2      VARCHAR2(100),
  c3      NUMBER(18,2),
  d3      NUMBER(18,2),
  e3      VARCHAR2(25),
  f3      VARCHAR2(25),
  g3      VARCHAR2(100),
  c4      NUMBER(18,2),
  d4      NUMBER(18,2),
  g4      VARCHAR2(100),
  c5      NUMBER(18,2),
  d5      NUMBER(18,2),
  g5      VARCHAR2(100),
  c6      NUMBER(18,2),
  d6      NUMBER(18,2),
  g6      VARCHAR2(100),
  c7      NUMBER(18,2),
  d7      NUMBER(18,2),
  g7      VARCHAR2(100),
  c8      NUMBER(18,2),
  d8      NUMBER(18,2),
  g8      VARCHAR2(100),
  c9      NUMBER(18,2),
  d9      NUMBER(18,2),
  g9      VARCHAR2(100),
  c10     NUMBER(18,2),
  d10     NUMBER(18,2),
  g10     VARCHAR2(100),
  a12     VARCHAR2(60),
  c12     NUMBER(18,2),
  d12     NUMBER(18,2),
  e12     VARCHAR2(25),
  f12     VARCHAR2(25),
  g12     VARCHAR2(100),
  a13     VARCHAR2(60),
  c13     NUMBER(18,2),
  d13     NUMBER(18,2),
  e13     VARCHAR2(25),
  f13     VARCHAR2(25),
  g13     VARCHAR2(100),
  a14     VARCHAR2(60),
  c14     NUMBER(18,2),
  d14     NUMBER(18,2),
  e14     VARCHAR2(25),
  f14     VARCHAR2(25),
  g14     VARCHAR2(100),
  a15     VARCHAR2(60),
  c15     NUMBER(18,2),
  d15     NUMBER(18,2),
  e15     VARCHAR2(25),
  f15     VARCHAR2(25),
  g15     VARCHAR2(100),
  a16     VARCHAR2(60),
  c16     NUMBER(18,2),
  d16     NUMBER(18,2),
  e16     VARCHAR2(25),
  f16     VARCHAR2(25),
  g16     VARCHAR2(100),
  c17     NUMBER(18,2),
  d17     NUMBER(18,2),
  g17     VARCHAR2(100),
  a19     VARCHAR2(60),
  c19     NUMBER(18,2),
  d19     NUMBER(18,2),
  e19     VARCHAR2(25),
  f19     VARCHAR2(25),
  g19     VARCHAR2(100),
  a20     VARCHAR2(60),
  c20     NUMBER(18,2),
  d20     NUMBER(18,2),
  e20     VARCHAR2(25),
  f20     VARCHAR2(25),
  g20     VARCHAR2(100),
  a21     VARCHAR2(60),
  c21     NUMBER(18,2),
  d21     NUMBER(18,2),
  e21     VARCHAR2(25),
  f21     VARCHAR2(25),
  g21     VARCHAR2(100),
  a22     VARCHAR2(60),
  c22     NUMBER(18,2),
  d22     NUMBER(18,2),
  e22     VARCHAR2(25),
  f22     VARCHAR2(25),
  g22     VARCHAR2(100),
  a23     VARCHAR2(60),
  c23     NUMBER(18,2),
  d23     NUMBER(18,2),
  e23     VARCHAR2(25),
  f23     VARCHAR2(25),
  g23     VARCHAR2(100),
  c24     NUMBER(18,2),
  d24     NUMBER(18,2),
  g24     VARCHAR2(100),
  a26     VARCHAR2(60),
  c26     NUMBER(18,2),
  d26     NUMBER(18,2),
  e26     VARCHAR2(25),
  f26     VARCHAR2(25),
  g26     VARCHAR2(100),
  a27     VARCHAR2(60),
  c27     NUMBER(18,2),
  d27     NUMBER(18,2),
  e27     VARCHAR2(25),
  f27     VARCHAR2(25),
  g27     VARCHAR2(100),
  a28     VARCHAR2(60),
  c28     NUMBER(18,2),
  d28     NUMBER(18,2),
  e28     VARCHAR2(25),
  f28     VARCHAR2(25),
  g28     VARCHAR2(100),
  a29     VARCHAR2(60),
  c29     NUMBER(18,2),
  d29     NUMBER(18,2),
  e29     VARCHAR2(25),
  f29     VARCHAR2(25),
  g29     VARCHAR2(100),
  a30     VARCHAR2(60),
  c30     NUMBER(18,2),
  d30     NUMBER(18,2),
  e30     VARCHAR2(25),
  f30     VARCHAR2(25),
  g30     VARCHAR2(100),
  c31     NUMBER(18,2),
  d31     NUMBER(18,2),
  g31     VARCHAR2(100),
  a33     VARCHAR2(60),
  c33     NUMBER(18,2),
  d33     NUMBER(18,2),
  e33     VARCHAR2(25),
  f33     VARCHAR2(25),
  g33     VARCHAR2(100),
  a34     VARCHAR2(60),
  c34     NUMBER(18,2),
  d34     NUMBER(18,2),
  e34     VARCHAR2(25),
  f34     VARCHAR2(25),
  g34     VARCHAR2(100),
  a35     VARCHAR2(60),
  c35     NUMBER(18,2),
  d35     NUMBER(18,2),
  e35     VARCHAR2(25),
  f35     VARCHAR2(25),
  g35     VARCHAR2(100),
  a36     VARCHAR2(60),
  c36     NUMBER(18,2),
  d36     NUMBER(18,2),
  e36     VARCHAR2(25),
  f36     VARCHAR2(25),
  g36     VARCHAR2(100),
  a37     VARCHAR2(60),
  c37     NUMBER(18,2),
  d37     NUMBER(18,2),
  e37     VARCHAR2(25),
  f37     VARCHAR2(25),
  g37     VARCHAR2(100),
  c38     NUMBER(18,2),
  d38     NUMBER(18,2),
  g38     VARCHAR2(100),
  a40     VARCHAR2(60),
  c40     NUMBER(18,2),
  d40     NUMBER(18,2),
  e40     VARCHAR2(25),
  f40     VARCHAR2(25),
  g40     VARCHAR2(100),
  a41     VARCHAR2(60),
  c41     NUMBER(18,2),
  d41     NUMBER(18,2),
  e41     VARCHAR2(25),
  f41     VARCHAR2(25),
  g41     VARCHAR2(100),
  a42     VARCHAR2(60),
  c42     NUMBER(18,2),
  d42     NUMBER(18,2),
  e42     VARCHAR2(25),
  f42     VARCHAR2(25),
  g42     VARCHAR2(100),
  a43     VARCHAR2(60),
  c43     NUMBER(18,2),
  d43     NUMBER(18,2),
  e43     VARCHAR2(25),
  f43     VARCHAR2(25),
  g43     VARCHAR2(100),
  a44     VARCHAR2(60),
  c44     NUMBER(18,2),
  d44     NUMBER(18,2),
  e44     VARCHAR2(25),
  f44     VARCHAR2(25),
  g44     VARCHAR2(100),
  c45     NUMBER(18,2),
  d45     NUMBER(18,2),
  g45     VARCHAR2(100),
  a47     VARCHAR2(60),
  c47     NUMBER(18,2),
  d47     NUMBER(18,2),
  e47     VARCHAR2(25),
  f47     VARCHAR2(25),
  g47     VARCHAR2(100),
  a48     VARCHAR2(60),
  c48     NUMBER(18,2),
  d48     NUMBER(18,2),
  e48     VARCHAR2(25),
  f48     VARCHAR2(25),
  g48     VARCHAR2(100),
  a49     VARCHAR2(60),
  c49     NUMBER(18,2),
  d49     NUMBER(18,2),
  e49     VARCHAR2(25),
  f49     VARCHAR2(25),
  g49     VARCHAR2(100),
  a50     VARCHAR2(60),
  c50     NUMBER(18,2),
  d50     NUMBER(18,2),
  e50     VARCHAR2(25),
  f50     VARCHAR2(25),
  g50     VARCHAR2(100),
  a51     VARCHAR2(60),
  c51     NUMBER(18,2),
  d51     NUMBER(18,2),
  e51     VARCHAR2(25),
  f51     VARCHAR2(25),
  g51     VARCHAR2(100)
)
;
comment on table T_CSRC1226_Z_A2_1
  is '֤ȯ˾տָܱ()';

prompt
prompt Creating table T_CSRC1226_Z_A2_2
prompt ================================
prompt
create table T_CSRC1226_Z_A2_2
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  d1      VARCHAR2(12),
  o4      NUMBER(18,2),
  p4      NUMBER(18,2),
  h5      NUMBER(18,2),
  i5      NUMBER(18,2),
  o5      NUMBER(18,2),
  p5      NUMBER(18,2),
  o6      NUMBER(18,2),
  p6      NUMBER(18,2),
  h7      NUMBER(18,2),
  i7      NUMBER(18,2),
  o7      NUMBER(18,2),
  p7      NUMBER(18,2),
  h8      NUMBER(18,2),
  i8      NUMBER(18,2),
  o8      NUMBER(18,2),
  p8      NUMBER(18,2),
  h9      NUMBER(18,2),
  i9      NUMBER(18,2),
  o9      NUMBER(18,2),
  p9      NUMBER(18,2),
  h10     NUMBER(18,2),
  i10     NUMBER(18,2),
  o10     NUMBER(18,2),
  p10     NUMBER(18,2),
  h11     NUMBER(18,2),
  i11     NUMBER(18,2),
  o11     NUMBER(18,2),
  p11     NUMBER(18,2),
  h12     NUMBER(18,2),
  i12     NUMBER(18,2),
  o12     NUMBER(18,2),
  p12     NUMBER(18,2),
  h13     NUMBER(18,2),
  i13     NUMBER(18,2),
  o13     NUMBER(18,2),
  p13     NUMBER(18,2),
  h14     NUMBER(18,2),
  i14     NUMBER(18,2),
  o14     NUMBER(18,2),
  p14     NUMBER(18,2),
  h15     NUMBER(18,2),
  i15     NUMBER(18,2),
  o15     NUMBER(18,2),
  p15     NUMBER(18,2),
  h16     NUMBER(18,2),
  i16     NUMBER(18,2),
  o16     NUMBER(18,2),
  p16     NUMBER(18,2),
  h17     NUMBER(18,2),
  i17     NUMBER(18,2),
  o17     NUMBER(18,2),
  p17     NUMBER(18,2),
  h18     NUMBER(18,2),
  i18     NUMBER(18,2),
  o18     NUMBER(18,2),
  p18     NUMBER(18,2),
  h19     NUMBER(18,2),
  i19     NUMBER(18,2),
  o19     NUMBER(18,2),
  p19     NUMBER(18,2),
  h20     NUMBER(18,2),
  i20     NUMBER(18,2),
  o20     NUMBER(18,2),
  p20     NUMBER(18,2),
  h21     NUMBER(18,2),
  i21     NUMBER(18,2),
  o21     NUMBER(18,2),
  p21     NUMBER(18,2),
  h22     NUMBER(18,2),
  i22     NUMBER(18,2),
  o22     NUMBER(18,2),
  p22     NUMBER(18,2),
  h23     NUMBER(18,2),
  i23     NUMBER(18,2),
  o23     NUMBER(18,2),
  p23     NUMBER(18,2),
  h24     NUMBER(18,2),
  i24     NUMBER(18,2),
  o24     NUMBER(18,2),
  p24     NUMBER(18,2),
  h25     NUMBER(18,2),
  i25     NUMBER(18,2),
  o25     NUMBER(18,2),
  p25     NUMBER(18,2),
  h26     NUMBER(18,2),
  i26     NUMBER(18,2),
  o26     NUMBER(18,2),
  p26     NUMBER(18,2),
  h27     NUMBER(18,2),
  i27     NUMBER(18,2),
  o27     NUMBER(18,2),
  p27     NUMBER(18,2),
  h28     NUMBER(18,2),
  i28     NUMBER(18,2),
  o28     NUMBER(18,2),
  p28     NUMBER(18,2),
  h29     NUMBER(18,2),
  i29     NUMBER(18,2),
  o29     NUMBER(18,2),
  p29     NUMBER(18,2),
  h30     NUMBER(18,2),
  i30     NUMBER(18,2),
  o30     NUMBER(18,2),
  p30     NUMBER(18,2),
  h31     NUMBER(18,2),
  i31     NUMBER(18,2),
  o31     NUMBER(18,2),
  p31     NUMBER(18,2),
  h32     NUMBER(18,2),
  i32     NUMBER(18,2),
  o32     NUMBER(18,2),
  p32     NUMBER(18,2),
  h33     NUMBER(18,2),
  i33     NUMBER(18,2),
  o33     NUMBER(18,2),
  p33     NUMBER(18,2),
  h34     NUMBER(18,2),
  i34     NUMBER(18,2),
  o34     NUMBER(18,2),
  p34     NUMBER(18,2),
  h35     NUMBER(18,2),
  i35     NUMBER(18,2),
  o35     NUMBER(18,2),
  p35     NUMBER(18,2),
  h36     NUMBER(18,2),
  i36     NUMBER(18,2),
  o36     NUMBER(18,2),
  p36     NUMBER(18,2),
  h37     NUMBER(18,2),
  i37     NUMBER(18,2),
  o37     NUMBER(18,2),
  p37     NUMBER(18,2),
  h38     NUMBER(18,2),
  i38     NUMBER(18,2),
  o38     NUMBER(18,2),
  p38     NUMBER(18,2),
  h39     NUMBER(18,2),
  i39     NUMBER(18,2),
  o39     NUMBER(18,2),
  p39     NUMBER(18,2),
  h40     NUMBER(18,2),
  i40     NUMBER(18,2),
  o40     NUMBER(18,2),
  p40     NUMBER(18,2),
  h41     NUMBER(18,2),
  i41     NUMBER(18,2),
  o41     NUMBER(18,2),
  p41     NUMBER(18,2),
  o42     NUMBER(18,2),
  p42     NUMBER(18,2),
  h43     NUMBER(18,2),
  i43     NUMBER(18,2),
  o43     NUMBER(18,2),
  p43     NUMBER(18,2),
  h44     NUMBER(18,2),
  i44     NUMBER(18,2),
  o44     NUMBER(18,2),
  p44     NUMBER(18,2),
  h45     NUMBER(18,2),
  i45     NUMBER(18,2),
  o45     NUMBER(18,2),
  p45     NUMBER(18,2),
  h46     NUMBER(18,2),
  i46     NUMBER(18,2),
  o46     NUMBER(18,2),
  p46     NUMBER(18,2),
  o47     NUMBER(18,2),
  p47     NUMBER(18,2),
  h48     NUMBER(18,2),
  i48     NUMBER(18,2),
  o48     NUMBER(18,2),
  p48     NUMBER(18,2),
  h49     NUMBER(18,2),
  i49     NUMBER(18,2),
  o49     NUMBER(18,2),
  p49     NUMBER(18,2),
  h50     NUMBER(18,2),
  i50     NUMBER(18,2),
  o50     NUMBER(18,2),
  p50     NUMBER(18,2),
  h51     NUMBER(18,2),
  i51     NUMBER(18,2),
  o51     NUMBER(18,2),
  p51     NUMBER(18,2),
  o52     NUMBER(18,2),
  p52     NUMBER(18,2),
  h53     NUMBER(18,2),
  i53     NUMBER(18,2),
  o53     NUMBER(18,2),
  p53     NUMBER(18,2),
  h54     NUMBER(18,2),
  i54     NUMBER(18,2),
  o54     NUMBER(18,2),
  p54     NUMBER(18,2),
  o55     NUMBER(18,2),
  p55     NUMBER(18,2),
  h56     NUMBER(18,2),
  i56     NUMBER(18,2),
  o56     NUMBER(18,2),
  p56     NUMBER(18,2),
  h57     NUMBER(18,2),
  i57     NUMBER(18,2),
  o57     NUMBER(18,2),
  p57     NUMBER(18,2),
  o58     NUMBER(18,2),
  p58     NUMBER(18,2),
  h59     NUMBER(18,2),
  i59     NUMBER(18,2),
  o59     NUMBER(18,2),
  p59     NUMBER(18,2),
  h60     NUMBER(18,2),
  i60     NUMBER(18,2),
  o60     NUMBER(18,2),
  p60     NUMBER(18,2),
  h61     NUMBER(18,2),
  i61     NUMBER(18,2),
  o61     NUMBER(18,2),
  p61     NUMBER(18,2),
  h62     NUMBER(18,2),
  i62     NUMBER(18,2),
  o62     NUMBER(18,2),
  p62     NUMBER(18,2),
  h63     NUMBER(18,2),
  i63     NUMBER(18,2),
  o63     NUMBER(18,2),
  p63     NUMBER(18,2),
  o64     NUMBER(18,2),
  p64     NUMBER(18,2),
  a66     VARCHAR2(255)
)
;

prompt
prompt Creating table T_CSRC1227_C12_1
prompt ===============================
prompt
create table T_CSRC1227_C12_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c5      NUMBER,
  d5      NUMBER(19,2),
  e5      NUMBER,
  f5      NUMBER(19,2),
  g5      NUMBER,
  h5      NUMBER(19,2),
  i5      NUMBER,
  j5      NUMBER(19,2),
  k5      NUMBER,
  l5      NUMBER(19,2),
  m5      VARCHAR2(255),
  c6      NUMBER,
  d6      NUMBER(19,2),
  e6      NUMBER,
  f6      NUMBER(19,2),
  g6      NUMBER,
  h6      NUMBER(19,2),
  i6      NUMBER,
  j6      NUMBER(19,2),
  k6      NUMBER,
  l6      NUMBER(19,2),
  m6      VARCHAR2(255),
  c7      NUMBER,
  d7      NUMBER(19,2),
  e7      NUMBER,
  f7      NUMBER(19,2),
  g7      NUMBER,
  h7      NUMBER(19,2),
  i7      NUMBER,
  j7      NUMBER(19,2),
  k7      NUMBER,
  l7      NUMBER(19,2),
  m7      VARCHAR2(255),
  c8      NUMBER,
  d8      NUMBER(19,2),
  e8      NUMBER,
  f8      NUMBER(19,2),
  g8      NUMBER,
  h8      NUMBER(19,2),
  i8      NUMBER,
  j8      NUMBER(19,2),
  k8      NUMBER,
  l8      NUMBER(19,2),
  m8      VARCHAR2(255),
  c9      NUMBER,
  d9      NUMBER(19,2),
  e9      NUMBER,
  f9      NUMBER(19,2),
  g9      NUMBER,
  h9      NUMBER(19,2),
  i9      NUMBER,
  j9      NUMBER(19,2),
  k9      NUMBER,
  l9      NUMBER(19,2),
  m9      VARCHAR2(255),
  c10     NUMBER,
  d10     NUMBER(19,2),
  e10     NUMBER,
  f10     NUMBER(19,2),
  g10     NUMBER,
  h10     NUMBER(19,2),
  i10     NUMBER,
  j10     NUMBER(19,2),
  k10     NUMBER,
  l10     NUMBER(19,2),
  m10     VARCHAR2(255),
  c11     NUMBER,
  d11     NUMBER(19,2),
  e11     NUMBER,
  f11     NUMBER(19,2),
  g11     NUMBER,
  h11     NUMBER(19,2),
  i11     NUMBER,
  j11     NUMBER(19,2),
  k11     NUMBER,
  l11     NUMBER(19,2),
  m11     VARCHAR2(255),
  c12     NUMBER,
  d12     NUMBER(19,2),
  e12     NUMBER,
  f12     NUMBER(19,2),
  g12     NUMBER,
  h12     NUMBER(19,2),
  i12     NUMBER,
  j12     NUMBER(19,2),
  k12     NUMBER,
  l12     NUMBER(19,2),
  m12     VARCHAR2(255),
  c13     NUMBER,
  d13     NUMBER(19,2),
  e13     NUMBER,
  f13     NUMBER(19,2),
  g13     NUMBER,
  h13     NUMBER(19,2),
  i13     NUMBER,
  j13     NUMBER(19,2),
  k13     NUMBER,
  l13     NUMBER(19,2),
  m13     VARCHAR2(255),
  c15     NUMBER,
  d15     NUMBER(19,2),
  e15     NUMBER,
  f15     NUMBER(19,2),
  g15     NUMBER,
  h15     NUMBER(19,2),
  i15     NUMBER,
  j15     NUMBER(19,2),
  k15     NUMBER,
  l15     NUMBER(19,2),
  m15     VARCHAR2(255),
  c16     NUMBER,
  d16     NUMBER(19,2),
  e16     NUMBER,
  f16     NUMBER(19,2),
  g16     NUMBER,
  h16     NUMBER(19,2),
  i16     NUMBER,
  j16     NUMBER(19,2),
  k16     NUMBER,
  l16     NUMBER(19,2),
  m16     VARCHAR2(255),
  c17     NUMBER,
  d17     NUMBER(19,2),
  e17     NUMBER,
  f17     NUMBER(19,2),
  g17     NUMBER,
  h17     NUMBER(19,2),
  i17     NUMBER,
  j17     NUMBER(19,2),
  k17     NUMBER,
  l17     NUMBER(19,2),
  m17     VARCHAR2(255),
  c18     NUMBER,
  d18     NUMBER(19,2),
  e18     NUMBER,
  f18     NUMBER(19,2),
  g18     NUMBER,
  h18     NUMBER(19,2),
  i18     NUMBER,
  j18     NUMBER(19,2),
  k18     NUMBER,
  l18     NUMBER(19,2),
  m18     VARCHAR2(255),
  c19     NUMBER,
  d19     NUMBER(19,2),
  e19     NUMBER,
  f19     NUMBER(19,2),
  g19     NUMBER,
  h19     NUMBER(19,2),
  i19     NUMBER,
  j19     NUMBER(19,2),
  k19     NUMBER,
  l19     NUMBER(19,2),
  m19     VARCHAR2(255),
  c20     NUMBER,
  d20     NUMBER(19,2),
  e20     NUMBER,
  f20     NUMBER(19,2),
  g20     NUMBER,
  h20     NUMBER(19,2),
  i20     NUMBER,
  j20     NUMBER(19,2),
  k20     NUMBER,
  l20     NUMBER(19,2),
  m20     VARCHAR2(255),
  c21     NUMBER,
  d21     NUMBER(19,2),
  e21     NUMBER,
  f21     NUMBER(19,2),
  g21     NUMBER,
  h21     NUMBER(19,2),
  i21     NUMBER,
  j21     NUMBER(19,2),
  k21     NUMBER,
  l21     NUMBER(19,2),
  m21     VARCHAR2(255),
  c23     NUMBER,
  d23     NUMBER(19,2),
  e23     NUMBER,
  f23     NUMBER(19,2),
  g23     NUMBER,
  h23     NUMBER(19,2),
  i23     NUMBER,
  j23     NUMBER(19,2),
  k23     NUMBER,
  l23     NUMBER(19,2),
  m23     VARCHAR2(255),
  c24     NUMBER,
  d24     NUMBER(19,2),
  e24     NUMBER,
  f24     NUMBER(19,2),
  g24     NUMBER,
  h24     NUMBER(19,2),
  i24     NUMBER,
  j24     NUMBER(19,2),
  k24     NUMBER,
  l24     NUMBER(19,2),
  m24     VARCHAR2(255),
  c25     NUMBER,
  d25     NUMBER(19,2),
  e25     NUMBER,
  f25     NUMBER(19,2),
  g25     NUMBER,
  h25     NUMBER(19,2),
  i25     NUMBER,
  j25     NUMBER(19,2),
  k25     NUMBER,
  l25     NUMBER(19,2),
  m25     VARCHAR2(255),
  c26     NUMBER,
  d26     NUMBER(19,2),
  e26     NUMBER,
  f26     NUMBER(19,2),
  g26     NUMBER,
  h26     NUMBER(19,2),
  i26     NUMBER,
  j26     NUMBER(19,2),
  k26     NUMBER,
  l26     NUMBER(19,2),
  m26     VARCHAR2(255),
  c28     NUMBER,
  d28     NUMBER(19,2),
  e28     NUMBER,
  f28     NUMBER(19,2),
  g28     NUMBER,
  h28     NUMBER(19,2),
  i28     NUMBER,
  j28     NUMBER(19,2),
  k28     NUMBER,
  l28     NUMBER(19,2),
  m28     VARCHAR2(255),
  c29     NUMBER,
  d29     NUMBER(19,2),
  e29     NUMBER,
  f29     NUMBER(19,2),
  g29     NUMBER,
  h29     NUMBER(19,2),
  i29     NUMBER,
  j29     NUMBER(19,2),
  k29     NUMBER,
  l29     NUMBER(19,2),
  m29     VARCHAR2(255),
  c30     NUMBER,
  d30     NUMBER(19,2),
  e30     NUMBER,
  f30     NUMBER(19,2),
  g30     NUMBER,
  h30     NUMBER(19,2),
  i30     NUMBER,
  j30     NUMBER(19,2),
  k30     NUMBER,
  l30     NUMBER(19,2),
  m30     VARCHAR2(255),
  d32     NUMBER(19,2),
  f32     NUMBER(19,2),
  m32     VARCHAR2(255),
  d33     NUMBER(19,2),
  f33     NUMBER(19,2),
  m33     VARCHAR2(255)
)
;
comment on table T_CSRC1227_C12_1
  is '֤ȯ˾۽ڲƷͳƱ';

prompt
prompt Creating table T_CSRC1228_B_A5_1
prompt ================================
prompt
create table T_CSRC1228_B_A5_1
(
  bbq     VARCHAR2(8),
  userid  VARCHAR2(18),
  btype   VARCHAR2(1),
  option1 VARCHAR2(12),
  shtag   VARCHAR2(1),
  c5      NUMBER,
  d5      NUMBER(19,2),
  e5      NUMBER,
  f5      NUMBER(19,2),
  g5      NUMBER,
  h5      NUMBER(19,2),
  i5      NUMBER,
  j5      NUMBER(19,2),
  k5      NUMBER,
  l5      NUMBER(19,2),
  m5      VARCHAR2(255),
  c6      NUMBER,
  d6      NUMBER(19,2),
  e6      NUMBER,
  f6      NUMBER(19,2),
  g6      NUMBER,
  h6      NUMBER(19,2),
  i6      NUMBER,
  j6      NUMBER(19,2),
  k6      NUMBER,
  l6      NUMBER(19,2),
  m6      VARCHAR2(255),
  c7      NUMBER,
  d7      NUMBER(19,2),
  e7      NUMBER,
  f7      NUMBER(19,2),
  g7      NUMBER,
  h7      NUMBER(19,2),
  i7      NUMBER,
  j7      NUMBER(19,2),
  k7      NUMBER,
  l7      NUMBER(19,2),
  m7      VARCHAR2(255),
  c8      NUMBER,
  d8      NUMBER(19,2),
  e8      NUMBER,
  f8      NUMBER(19,2),
  g8      NUMBER,
  h8      NUMBER(19,2),
  i8      NUMBER,
  j8      NUMBER(19,2),
  k8      NUMBER,
  l8      NUMBER(19,2),
  m8      VARCHAR2(255),
  c9      NUMBER,
  d9      NUMBER(19,2),
  e9      NUMBER,
  f9      NUMBER(19,2),
  g9      NUMBER,
  h9      NUMBER(19,2),
  i9      NUMBER,
  j9      NUMBER(19,2),
  k9      NUMBER,
  l9      NUMBER(19,2),
  m9      VARCHAR2(255),
  c10     NUMBER,
  d10     NUMBER(19,2),
  e10     NUMBER,
  f10     NUMBER(19,2),
  g10     NUMBER,
  h10     NUMBER(19,2),
  i10     NUMBER,
  j10     NUMBER(19,2),
  k10     NUMBER,
  l10     NUMBER(19,2),
  m10     VARCHAR2(255),
  c11     NUMBER,
  d11     NUMBER(19,2),
  e11     NUMBER,
  f11     NUMBER(19,2),
  g11     NUMBER,
  h11     NUMBER(19,2),
  i11     NUMBER,
  j11     NUMBER(19,2),
  k11     NUMBER,
  l11     NUMBER(19,2),
  m11     VARCHAR2(255),
  c12     NUMBER,
  d12     NUMBER(19,2),
  e12     NUMBER,
  f12     NUMBER(19,2),
  g12     NUMBER,
  h12     NUMBER(19,2),
  i12     NUMBER,
  j12     NUMBER(19,2),
  k12     NUMBER,
  l12     NUMBER(19,2),
  m12     VARCHAR2(255),
  c13     NUMBER,
  d13     NUMBER(19,2),
  e13     NUMBER,
  f13     NUMBER(19,2),
  g13     NUMBER,
  h13     NUMBER(19,2),
  i13     NUMBER,
  j13     NUMBER(19,2),
  k13     NUMBER,
  l13     NUMBER(19,2),
  m13     VARCHAR2(255),
  c15     NUMBER,
  d15     NUMBER(19,2),
  e15     NUMBER,
  f15     NUMBER(19,2),
  g15     NUMBER,
  h15     NUMBER(19,2),
  i15     NUMBER,
  j15     NUMBER(19,2),
  k15     NUMBER,
  l15     NUMBER(19,2),
  m15     VARCHAR2(255),
  c16     NUMBER,
  d16     NUMBER(19,2),
  e16     NUMBER,
  f16     NUMBER(19,2),
  g16     NUMBER,
  h16     NUMBER(19,2),
  i16     NUMBER,
  j16     NUMBER(19,2),
  k16     NUMBER,
  l16     NUMBER(19,2),
  m16     VARCHAR2(255),
  c17     NUMBER,
  d17     NUMBER(19,2),
  e17     NUMBER,
  f17     NUMBER(19,2),
  g17     NUMBER,
  h17     NUMBER(19,2),
  i17     NUMBER,
  j17     NUMBER(19,2),
  k17     NUMBER,
  l17     NUMBER(19,2),
  m17     VARCHAR2(255),
  c18     NUMBER,
  d18     NUMBER(19,2),
  e18     NUMBER,
  f18     NUMBER(19,2),
  g18     NUMBER,
  h18     NUMBER(19,2),
  i18     NUMBER,
  j18     NUMBER(19,2),
  k18     NUMBER,
  l18     NUMBER(19,2),
  m18     VARCHAR2(255),
  c19     NUMBER,
  d19     NUMBER(19,2),
  e19     NUMBER,
  f19     NUMBER(19,2),
  g19     NUMBER,
  h19     NUMBER(19,2),
  i19     NUMBER,
  j19     NUMBER(19,2),
  k19     NUMBER,
  l19     NUMBER(19,2),
  m19     VARCHAR2(255),
  c20     NUMBER,
  d20     NUMBER(19,2),
  e20     NUMBER,
  f20     NUMBER(19,2),
  g20     NUMBER,
  h20     NUMBER(19,2),
  i20     NUMBER,
  j20     NUMBER(19,2),
  k20     NUMBER,
  l20     NUMBER(19,2),
  m20     VARCHAR2(255),
  c21     NUMBER,
  d21     NUMBER(19,2),
  e21     NUMBER,
  f21     NUMBER(19,2),
  g21     NUMBER,
  h21     NUMBER(19,2),
  i21     NUMBER,
  j21     NUMBER(19,2),
  k21     NUMBER,
  l21     NUMBER(19,2),
  m21     VARCHAR2(255),
  c23     NUMBER,
  d23     NUMBER(19,2),
  e23     NUMBER,
  f23     NUMBER(19,2),
  g23     NUMBER,
  h23     NUMBER(19,2),
  i23     NUMBER,
  j23     NUMBER(19,2),
  k23     NUMBER,
  l23     NUMBER(19,2),
  m23     VARCHAR2(255),
  c24     NUMBER,
  d24     NUMBER(19,2),
  e24     NUMBER,
  f24     NUMBER(19,2),
  g24     NUMBER,
  h24     NUMBER(19,2),
  i24     NUMBER,
  j24     NUMBER(19,2),
  k24     NUMBER,
  l24     NUMBER(19,2),
  m24     VARCHAR2(255),
  c25     NUMBER,
  d25     NUMBER(19,2),
  e25     NUMBER,
  f25     NUMBER(19,2),
  g25     NUMBER,
  h25     NUMBER(19,2),
  i25     NUMBER,
  j25     NUMBER(19,2),
  k25     NUMBER,
  l25     NUMBER(19,2),
  m25     VARCHAR2(255),
  c26     NUMBER,
  d26     NUMBER(19,2),
  e26     NUMBER,
  f26     NUMBER(19,2),
  g26     NUMBER,
  h26     NUMBER(19,2),
  i26     NUMBER,
  j26     NUMBER(19,2),
  k26     NUMBER,
  l26     NUMBER(19,2),
  m26     VARCHAR2(255),
  c28     NUMBER,
  d28     NUMBER(19,2),
  e28     NUMBER,
  f28     NUMBER(19,2),
  g28     NUMBER,
  h28     NUMBER(19,2),
  i28     NUMBER,
  j28     NUMBER(19,2),
  k28     NUMBER,
  l28     NUMBER(19,2),
  m28     VARCHAR2(255),
  c29     NUMBER,
  d29     NUMBER(19,2),
  e29     NUMBER,
  f29     NUMBER(19,2),
  g29     NUMBER,
  h29     NUMBER(19,2),
  i29     NUMBER,
  j29     NUMBER(19,2),
  k29     NUMBER,
  l29     NUMBER(19,2),
  m29     VARCHAR2(255),
  c30     NUMBER,
  d30     NUMBER(19,2),
  e30     NUMBER,
  f30     NUMBER(19,2),
  g30     NUMBER,
  h30     NUMBER(19,2),
  i30     NUMBER,
  j30     NUMBER(19,2),
  k30     NUMBER,
  l30     NUMBER(19,2),
  m30     VARCHAR2(255),
  d32     NUMBER(19,2),
  f32     NUMBER(19,2),
  m32     VARCHAR2(255),
  d33     NUMBER(19,2),
  f33     NUMBER(19,2),
  m33     VARCHAR2(255)
)
;
comment on table T_CSRC1228_B_A5_1
  is '֤ȯ˾۽ڲƷͳƱ';

prompt
prompt Creating table T_CTL_D001
prompt =========================
prompt
create table T_CTL_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(33) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_CTL_D001
  is 'ɶֵ';
comment on column T_CTL_D001.p001
  is 'ɶID';
comment on column T_CTL_D001.a002
  is 'ɶ';
comment on column T_CTL_D001.z100
  is '־';
comment on column T_CTL_D001.b099
  is 'ע';
alter table T_CTL_D001
  add constraint PK_T_CTL_D001 primary key (P001);

prompt
prompt Creating table T_CTL_D002
prompt =========================
prompt
create table T_CTL_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_CTL_D002
  is '¡²ʽֵ';
comment on column T_CTL_D002.p001
  is 'ʽID';
comment on column T_CTL_D002.a002
  is 'ʽ';
comment on column T_CTL_D002.z100
  is '־';
comment on column T_CTL_D002.b099
  is 'ע';
alter table T_CTL_D002
  add constraint PK_T_CTL_D002 primary key (P001);

prompt
prompt Creating table T_CTL_D003
prompt =========================
prompt
create table T_CTL_D003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 VARCHAR2(32) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_CTL_D003
  is '¡¡߹ְ';
comment on column T_CTL_D003.p001
  is 'ְID';
comment on column T_CTL_D003.p002
  is 'ְ';
comment on column T_CTL_D003.a003
  is 'ְ';
comment on column T_CTL_D003.z100
  is '־';
comment on column T_CTL_D003.b099
  is 'ע';
alter table T_CTL_D003
  add constraint PK_T_CTL_D003 primary key (P001, P002);

prompt
prompt Creating table T_CTL_D004
prompt =========================
prompt
create table T_CTL_D004
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_CTL_D004
  is 'ֵ';
comment on column T_CTL_D004.p001
  is 'ID';
comment on column T_CTL_D004.a002
  is '';
comment on column T_CTL_D004.z100
  is '־';
comment on column T_CTL_D004.b099
  is 'ע';
alter table T_CTL_D004
  add constraint PK_T_CTL_D004 primary key (P001);

prompt
prompt Creating table T_CTL_D005
prompt =========================
prompt
create table T_CTL_D005
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_CTL_D005
  is 'ֵ';
comment on column T_CTL_D005.p001
  is 'ID';
comment on column T_CTL_D005.a002
  is '';
comment on column T_CTL_D005.z100
  is '־';
comment on column T_CTL_D005.b099
  is 'ע';
alter table T_CTL_D005
  add constraint PK_T_CTL_D005 primary key (P001);

prompt
prompt Creating table T_CTL_D006
prompt =========================
prompt
create table T_CTL_D006
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_CTL_D006
  is '鷽ʽֵ';
comment on column T_CTL_D006.p001
  is '鷽ʽID';
comment on column T_CTL_D006.a002
  is '鷽ʽ';
comment on column T_CTL_D006.z100
  is '־';
comment on column T_CTL_D006.b099
  is 'ע';
alter table T_CTL_D006
  add constraint PK_T_CTL_D006 primary key (P001);

prompt
prompt Creating table T_CTL_D007
prompt =========================
prompt
create table T_CTL_D007
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  z100 VARCHAR2(8),
  b099 VARCHAR2(128),
  a009 NUMBER
)
;
comment on table T_CTL_D007
  is 'ֵ';
comment on column T_CTL_D007.p001
  is 'ID';
comment on column T_CTL_D007.a002
  is '';
comment on column T_CTL_D007.z100
  is '־';
comment on column T_CTL_D007.b099
  is 'ע';
alter table T_CTL_D007
  add constraint PK_T_CTL_D007 primary key (P001);

prompt
prompt Creating table T_CTL_D009
prompt =========================
prompt
create table T_CTL_D009
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a009 NUMBER
)
;
comment on table T_CTL_D009
  is '˾ֵ';
comment on column T_CTL_D009.p001
  is '˾ID';
comment on column T_CTL_D009.a002
  is '˾';
comment on column T_CTL_D009.b099
  is 'ע˵';
comment on column T_CTL_D009.z100
  is '־';
alter table T_CTL_D009
  add constraint PK_T_CTL_D009 primary key (P001);

prompt
prompt Creating table T_CTL_D010
prompt =========================
prompt
create table T_CTL_D010
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a009 NUMBER
)
;
comment on table T_CTL_D010
  is 'ϵͳֵ';
comment on column T_CTL_D010.p001
  is 'ϵͳID';
comment on column T_CTL_D010.a002
  is 'ϵͳ';
comment on column T_CTL_D010.b099
  is 'ע˵';
comment on column T_CTL_D010.z100
  is '־';
alter table T_CTL_D010
  add constraint PK_T_CTL_D010 primary key (P001);

prompt
prompt Creating table T_CTL_D011
prompt =========================
prompt
create table T_CTL_D011
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  a009 NUMBER
)
;
alter table T_CTL_D011
  add constraint PK_T_CTL_D011 primary key (P001);

prompt
prompt Creating table T_CTL_D013
prompt =========================
prompt
create table T_CTL_D013
(
  p001 NUMBER not null,
  a002 VARCHAR2(32)
)
;
comment on table T_CTL_D013
  is 'ҵ';
comment on column T_CTL_D013.p001
  is 'ɣ';
comment on column T_CTL_D013.a002
  is '';
alter table T_CTL_D013
  add constraint PK_T_CTL_D013 primary key (P001);

prompt
prompt Creating table T_CTL_T001
prompt =========================
prompt
create table T_CTL_T001
(
  p001 NUMBER not null,
  a002 VARCHAR2(128) not null,
  a003 NUMBER not null,
  f004 NUMBER not null,
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER,
  a009 NUMBER,
  a010 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a004 NUMBER(19,2),
  a100 NUMBER not null
)
;
comment on table T_CTL_T001
  is 'ɶϢ̨ʱ';
comment on column T_CTL_T001.p001
  is 'ɶID';
comment on column T_CTL_T001.a002
  is 'ɶ';
comment on column T_CTL_T001.a003
  is 'ǷΪй˾';
comment on column T_CTL_T001.f004
  is 'ɶID';
comment on column T_CTL_T001.a005
  is 'ڳʽ߹ɷ';
comment on column T_CTL_T001.a006
  is 'ĩʻֹ';
comment on column T_CTL_T001.a007
  is 'ֹɱ';
comment on column T_CTL_T001.a008
  is 'Ѻ򶳽ɷ';
comment on column T_CTL_T001.a009
  is 'Ƿɶйϵ';
comment on column T_CTL_T001.a010
  is 'ע';
comment on column T_CTL_T001.b001
  is '¼״̬';
comment on column T_CTL_T001.b009
  is '޸';
comment on column T_CTL_T001.a004
  is 'ڳʻֹ';
comment on column T_CTL_T001.a100
  is '';
alter table T_CTL_T001
  add constraint PK_T_CTL_T001 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T002
prompt =========================
prompt
create table T_CTL_T002
(
  p001 NUMBER not null,
  a003 NUMBER(6,2) not null,
  a004 NUMBER(6,2) not null,
  a005 NUMBER(6,2) not null,
  a006 VARCHAR2(255),
  a002 NUMBER(6,2) not null,
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T002
  is 'ʵʿ˳ֹϢ';
comment on column T_CTL_T002.p001
  is 'ɶID';
comment on column T_CTL_T002.a003
  is 'ӳֹɱ';
comment on column T_CTL_T002.a004
  is 'Эֹɱ';
comment on column T_CTL_T002.a005
  is 'ʽֹɱ';
comment on column T_CTL_T002.a006
  is 'ע';
comment on column T_CTL_T002.a002
  is 'ֱӳֹɱ';
comment on column T_CTL_T002.b001
  is 'ǷЧ';
comment on column T_CTL_T002.b009
  is '޸';
comment on column T_CTL_T002.a100
  is '';
alter table T_CTL_T002
  add constraint PK_T_CTL_T002 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T004
prompt =========================
prompt
create table T_CTL_T004
(
  p001 VARCHAR2(64) not null,
  a002 DATE not null,
  a003 VARCHAR2(255) not null,
  a004 NUMBER not null,
  a005 VARCHAR2(255),
  a006 VARCHAR2(8) not null,
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T004
  is 'ɶᡢ»ᡢ»';
comment on column T_CTL_T004.p001
  is '';
comment on column T_CTL_T004.a002
  is 'ٿ';
comment on column T_CTL_T004.a003
  is '';
comment on column T_CTL_T004.a004
  is 'Ƿͨ';
comment on column T_CTL_T004.a005
  is 'ע';
comment on column T_CTL_T004.a006
  is '';
comment on column T_CTL_T004.b001
  is '¼״̬';
comment on column T_CTL_T004.b009
  is '޸';
comment on column T_CTL_T004.a100
  is '';
alter table T_CTL_T004
  add constraint PK_T_CTL_T004 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T005
prompt =========================
prompt
create table T_CTL_T005
(
  p001 NUMBER not null,
  a002 VARCHAR2(128) not null,
  a003 VARCHAR2(32) not null,
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T005
  is 'λְ';
comment on column T_CTL_T005.p001
  is '';
comment on column T_CTL_T005.a002
  is '˾';
comment on column T_CTL_T005.a003
  is 'ְID';
comment on column T_CTL_T005.b001
  is 'ְ״̬';
comment on column T_CTL_T005.b009
  is '޸';
comment on column T_CTL_T005.a100
  is '';
alter table T_CTL_T005
  add constraint PK_T_CTL_T005 primary key (P001, A002, A100);

prompt
prompt Creating table T_CTL_T006
prompt =========================
prompt
create table T_CTL_T006
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  f003 NUMBER not null,
  a004 DATE not null,
  a005 NUMBER(19,2) not null,
  a006 NUMBER not null,
  a007 NUMBER not null,
  f008 NUMBER not null,
  a009 VARCHAR2(128) not null,
  a010 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T006
  is '»Ա';
comment on column T_CTL_T006.p001
  is 'ID';
comment on column T_CTL_T006.a002
  is '';
comment on column T_CTL_T006.f003
  is 'ְID';
comment on column T_CTL_T006.a004
  is 'ְ';
comment on column T_CTL_T006.a005
  is 'н';
comment on column T_CTL_T006.a006
  is 'й˾ɷ';
comment on column T_CTL_T006.a007
  is 'й˾Ȩ';
comment on column T_CTL_T006.f008
  is 'ʽID';
comment on column T_CTL_T006.a009
  is 'ְʸļ';
comment on column T_CTL_T006.a010
  is 'ע';
comment on column T_CTL_T006.b001
  is 'ְ״̬';
comment on column T_CTL_T006.b009
  is '޸';
comment on column T_CTL_T006.a100
  is '˱ʶ';
alter table T_CTL_T006
  add constraint PK_T_CTL_T006 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T007
prompt =========================
prompt
create table T_CTL_T007
(
  p001 NUMBER not null,
  p002 DATE not null,
  a003 NUMBER(10,2) not null,
  a004 VARCHAR2(255),
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T007
  is '߹³ȡ';
comment on column T_CTL_T007.p001
  is '߹ID';
comment on column T_CTL_T007.p002
  is 'ȡ';
comment on column T_CTL_T007.a003
  is '³';
comment on column T_CTL_T007.a004
  is 'ע';
comment on column T_CTL_T007.b009
  is '޸';
comment on column T_CTL_T007.a100
  is '';
alter table T_CTL_T007
  add constraint PK_T_CTL_T007 primary key (P001, P002, A100);

prompt
prompt Creating table T_CTL_T008
prompt =========================
prompt
create table T_CTL_T008
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a003 NUMBER not null,
  f004 NUMBER not null,
  a005 DATE not null,
  a006 NUMBER(19,2) not null,
  a007 NUMBER not null,
  a008 NUMBER not null,
  a009 VARCHAR2(128),
  a010 VARCHAR2(255),
  f011 NUMBER,
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T008
  is '߹ܳԱ̨ʱ';
comment on column T_CTL_T008.p001
  is '߹ID';
comment on column T_CTL_T008.a002
  is '';
comment on column T_CTL_T008.a003
  is 'ǷΪʵʿפ';
comment on column T_CTL_T008.f004
  is 'ְID';
comment on column T_CTL_T008.a005
  is 'ְ';
comment on column T_CTL_T008.a006
  is 'н';
comment on column T_CTL_T008.a007
  is 'й˾ɷ';
comment on column T_CTL_T008.a008
  is 'й˾Ȩ';
comment on column T_CTL_T008.a009
  is 'ְʸļ';
comment on column T_CTL_T008.a010
  is 'ע';
comment on column T_CTL_T008.f011
  is 'ְID';
comment on column T_CTL_T008.b001
  is 'ְ״̬';
comment on column T_CTL_T008.b009
  is '޸';
comment on column T_CTL_T008.a100
  is '˱ʶ';
alter table T_CTL_T008
  add constraint PK_T_CTL_T008 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T011
prompt =========================
prompt
create table T_CTL_T011
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a003 VARCHAR2(128) not null,
  a004 VARCHAR2(128),
  a005 NUMBER(19,2) not null,
  a006 NUMBER(7,2) not null,
  a007 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a008 VARCHAR2(255),
  a009 NUMBER,
  a010 NUMBER(19,2),
  a100 NUMBER not null
)
;
comment on table T_CTL_T011
  is 'ҵ';
comment on column T_CTL_T011.p001
  is 'ҵID';
comment on column T_CTL_T011.a002
  is '';
comment on column T_CTL_T011.a003
  is '';
comment on column T_CTL_T011.a004
  is 'ע';
comment on column T_CTL_T011.a005
  is 'Ͷʽ';
comment on column T_CTL_T011.a006
  is 'ֹɱ';
comment on column T_CTL_T011.a007
  is 'ע';
comment on column T_CTL_T011.b001
  is '¼״̬';
comment on column T_CTL_T011.b009
  is '޸';
comment on column T_CTL_T011.a008
  is 'פ߹ְ';
comment on column T_CTL_T011.a009
  is 'ҵ';
comment on column T_CTL_T011.a010
  is 'ȨͶ澻ֵ';
comment on column T_CTL_T011.a100
  is '';
alter table T_CTL_T011
  add constraint PK_T_CTL_T011 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T012
prompt =========================
prompt
create table T_CTL_T012
(
  p001 NUMBER not null,
  a002 VARCHAR2(128) not null,
  a003 VARCHAR2(64) not null,
  a004 DATE not null,
  a005 NUMBER(19,2) not null,
  a006 VARCHAR2(255) not null,
  a007 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T012
  is '';
comment on column T_CTL_T012.p001
  is '˾ID';
comment on column T_CTL_T012.a002
  is '˾';
comment on column T_CTL_T012.a003
  is 'ϵ';
comment on column T_CTL_T012.a004
  is '';
comment on column T_CTL_T012.a005
  is '׽';
comment on column T_CTL_T012.a006
  is '';
comment on column T_CTL_T012.a007
  is 'ע';
comment on column T_CTL_T012.b001
  is '¼״̬';
comment on column T_CTL_T012.b009
  is '޸';
comment on column T_CTL_T012.a100
  is '';
alter table T_CTL_T012
  add constraint PK_T_CTL_T012 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T017
prompt =========================
prompt
create table T_CTL_T017
(
  p001 DATE not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  a005 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a006 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_CTL_T017
  is 'רҵڲ˼̨ʱ';
comment on column T_CTL_T017.p001
  is '';
comment on column T_CTL_T017.p002
  is 'ҵID';
comment on column T_CTL_T017.p003
  is 'ID';
comment on column T_CTL_T017.p004
  is '鷽ʽID';
comment on column T_CTL_T017.a005
  is '';
comment on column T_CTL_T017.b001
  is '¼״̬';
comment on column T_CTL_T017.b009
  is '޸';
comment on column T_CTL_T017.a006
  is '';
comment on column T_CTL_T017.a100
  is '';
alter table T_CTL_T017
  add constraint PK_T_CTL_T017 primary key (P001, P002, P003, P004, A100);

prompt
prompt Creating table T_CTL_T018
prompt =========================
prompt
create table T_CTL_T018
(
  p001 DATE not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  a005 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a006 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_CTL_T018
  is 'ҵڲ˼̨ʱ';
comment on column T_CTL_T018.p001
  is '';
comment on column T_CTL_T018.p002
  is 'ID';
comment on column T_CTL_T018.p003
  is 'ID';
comment on column T_CTL_T018.p004
  is '鷽ʽID';
comment on column T_CTL_T018.a005
  is '';
comment on column T_CTL_T018.b001
  is '¼״̬';
comment on column T_CTL_T018.b009
  is '޸';
comment on column T_CTL_T018.a006
  is '';
comment on column T_CTL_T018.a100
  is '';
alter table T_CTL_T018
  add constraint PK_T_CTL_T018 primary key (P001, P002, P003, P004, A100);

prompt
prompt Creating table T_CTL_T019
prompt =========================
prompt
create table T_CTL_T019
(
  p001 DATE not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  a005 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a006 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_CTL_T019
  is 'ֹ˾ܲڲ˼';
comment on column T_CTL_T019.p001
  is '';
comment on column T_CTL_T019.p002
  is 'ֹ˾/ܲID';
comment on column T_CTL_T019.p003
  is 'ID';
comment on column T_CTL_T019.p004
  is '鷽ʽID';
comment on column T_CTL_T019.a005
  is '';
comment on column T_CTL_T019.b001
  is '¼״̬';
comment on column T_CTL_T019.b009
  is '޸';
comment on column T_CTL_T019.a006
  is '';
comment on column T_CTL_T019.a100
  is '';
alter table T_CTL_T019
  add constraint PK_T_CTL_T019 primary key (P001, P002, P003, P004, A100);

prompt
prompt Creating table T_CTL_T020
prompt =========================
prompt
create table T_CTL_T020
(
  p001 DATE not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  a005 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a006 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_CTL_T020
  is 'Ӫҵڲ˼';
comment on column T_CTL_T020.p001
  is '';
comment on column T_CTL_T020.p002
  is '';
comment on column T_CTL_T020.p003
  is 'ID';
comment on column T_CTL_T020.p004
  is '鷽ʽID';
comment on column T_CTL_T020.a005
  is '';
comment on column T_CTL_T020.b001
  is '¼״̬';
comment on column T_CTL_T020.b009
  is '޸';
comment on column T_CTL_T020.a006
  is '';
comment on column T_CTL_T020.a100
  is '';
alter table T_CTL_T020
  add constraint PK_T_CTL_T020 primary key (P001, P002, P003, P004, A100);

prompt
prompt Creating table T_CTL_T021
prompt =========================
prompt
create table T_CTL_T021
(
  p001 DATE not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  a005 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a006 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_CTL_T021
  is 'ڲ˼';
comment on column T_CTL_T021.p001
  is '';
comment on column T_CTL_T021.p002
  is '';
comment on column T_CTL_T021.p003
  is 'ID';
comment on column T_CTL_T021.p004
  is '鷽ʽID';
comment on column T_CTL_T021.a005
  is '';
comment on column T_CTL_T021.b001
  is '¼״̬';
comment on column T_CTL_T021.b009
  is '޸';
comment on column T_CTL_T021.a006
  is '';
comment on column T_CTL_T021.a100
  is '';
alter table T_CTL_T021
  add constraint PK_T_CTL_T021 primary key (P001, P002, P003, P004, A100);

prompt
prompt Creating table T_CTL_T022
prompt =========================
prompt
create table T_CTL_T022
(
  p001 DATE not null,
  p002 VARCHAR2(255) not null,
  p003 NUMBER not null,
  p004 NUMBER not null,
  a005 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a006 NUMBER,
  a100 NUMBER not null
)
;
comment on table T_CTL_T022
  is 'ؼλԱڲ˼';
comment on column T_CTL_T022.p001
  is '';
comment on column T_CTL_T022.p002
  is 'λԱ';
comment on column T_CTL_T022.p003
  is 'ID';
comment on column T_CTL_T022.p004
  is '鷽ʽID';
comment on column T_CTL_T022.a005
  is '';
comment on column T_CTL_T022.b001
  is '¼״̬';
comment on column T_CTL_T022.b009
  is '޸';
comment on column T_CTL_T022.a006
  is '';
comment on column T_CTL_T022.a100
  is '';
alter table T_CTL_T022
  add constraint PK_T_CTL_T022 primary key (P001, P002, P003, P004, A100);

prompt
prompt Creating table T_CTL_T023
prompt =========================
prompt
create table T_CTL_T023
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  f003 NUMBER not null,
  a004 DATE not null,
  a005 NUMBER(19,2) not null,
  a006 NUMBER not null,
  a007 NUMBER not null,
  f008 NUMBER not null,
  a009 VARCHAR2(255) not null,
  a010 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T023
  is '»Ա';
comment on column T_CTL_T023.p001
  is 'ID';
comment on column T_CTL_T023.a002
  is '';
comment on column T_CTL_T023.f003
  is 'ְID';
comment on column T_CTL_T023.a004
  is 'ְ';
comment on column T_CTL_T023.a005
  is 'н';
comment on column T_CTL_T023.a006
  is 'й˾ɷ';
comment on column T_CTL_T023.a007
  is 'й˾Ȩ';
comment on column T_CTL_T023.f008
  is 'ʽID';
comment on column T_CTL_T023.a009
  is 'ְʸļ';
comment on column T_CTL_T023.a010
  is 'ע';
comment on column T_CTL_T023.b001
  is 'ְ״̬';
comment on column T_CTL_T023.b009
  is '޸';
comment on column T_CTL_T023.a100
  is '˱ʶ';
alter table T_CTL_T023
  add constraint PK_T_CTL_T023 primary key (P001, A100);

prompt
prompt Creating table T_CTL_T026
prompt =========================
prompt
create table T_CTL_T026
(
  p001 NUMBER not null,
  p002 DATE not null,
  a003 NUMBER(10,2) not null,
  a004 VARCHAR2(255),
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T026
  is '³ȡ';
comment on column T_CTL_T026.p001
  is 'ID';
comment on column T_CTL_T026.p002
  is 'ȡ';
comment on column T_CTL_T026.a003
  is '³';
comment on column T_CTL_T026.a004
  is 'ע';
comment on column T_CTL_T026.b009
  is '޸';
comment on column T_CTL_T026.a100
  is '';
alter table T_CTL_T026
  add constraint PK_T_CTL_T026 primary key (P001, P002, A100);

prompt
prompt Creating table T_CTL_T028
prompt =========================
prompt
create table T_CTL_T028
(
  p001 NUMBER not null,
  p002 DATE not null,
  a003 NUMBER(10,2) not null,
  a004 VARCHAR2(255),
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T028
  is '³ȡ';
comment on column T_CTL_T028.p001
  is 'ID';
comment on column T_CTL_T028.p002
  is 'ȡ';
comment on column T_CTL_T028.a003
  is '³';
comment on column T_CTL_T028.a004
  is 'ע';
comment on column T_CTL_T028.b009
  is '޸';
comment on column T_CTL_T028.a100
  is '';
alter table T_CTL_T028
  add constraint PK_T_CTL_T028 primary key (P001, P002, A100);

prompt
prompt Creating table T_CTL_T037
prompt =========================
prompt
create table T_CTL_T037
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a003 VARCHAR2(255),
  a004 NUMBER,
  a005 VARCHAR2(255),
  a006 VARCHAR2(255),
  a007 VARCHAR2(255),
  a008 VARCHAR2(255),
  b001 NUMBER,
  b009 DATE,
  a100 NUMBER not null
)
;
comment on table T_CTL_T037
  is 'ίԱԱ';
comment on column T_CTL_T037.p001
  is 'ID ';
comment on column T_CTL_T037.a002
  is '';
comment on column T_CTL_T037.a003
  is '';
comment on column T_CTL_T037.a004
  is 'ǷΪίԱ';
comment on column T_CTL_T037.a005
  is 'ְ';
comment on column T_CTL_T037.a006
  is '';
comment on column T_CTL_T037.a007
  is 'ίԱְ';
comment on column T_CTL_T037.a008
  is 'עϢ';
comment on column T_CTL_T037.b001
  is '¼״̬';
comment on column T_CTL_T037.b009
  is '޸';
comment on column T_CTL_T037.a100
  is '';
alter table T_CTL_T037
  add constraint PK_T_CTL_T037 primary key (P001, A002, A100);

prompt
prompt Creating table T_DACT_001
prompt =========================
prompt
create table T_DACT_001
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a100 NUMBER not null,
  w100 NUMBER not null,
  a004 NUMBER
)
;
comment on table T_DACT_001
  is 'ʲծԭʼ';
comment on column T_DACT_001.p001
  is 'ָID';
comment on column T_DACT_001.a002
  is 'ĩ';
comment on column T_DACT_001.a003
  is '';
comment on column T_DACT_001.a100
  is '';
comment on column T_DACT_001.w100
  is 'ܲID';
alter table T_DACT_001
  add constraint PK_T_DACT_001 primary key (P001, W100);

prompt
prompt Creating table T_DACT_002
prompt =========================
prompt
create table T_DACT_002
(
  p001 VARCHAR2(128) not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a100 NUMBER not null,
  w100 NUMBER not null,
  a004 NUMBER(19,2)
)
;
comment on table T_DACT_002
  is 'ʲծܱ';
comment on column T_DACT_002.p001
  is 'ָID';
comment on column T_DACT_002.a002
  is 'ĩ';
comment on column T_DACT_002.a003
  is 'ڳ';
comment on column T_DACT_002.a100
  is 'ڻ';
comment on column T_DACT_002.w100
  is 'ܲID';
alter table T_DACT_002
  add constraint PK_T_DACT_002 primary key (P001, W100);

prompt
prompt Creating table T_DACT_003
prompt =========================
prompt
create table T_DACT_003
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DACT_003
  is 'ܱ';
comment on column T_DACT_003.p001
  is '       Ŀ';
comment on column T_DACT_003.a002
  is ' ڽ';
comment on column T_DACT_003.a003
  is 'ۼƽ';
comment on column T_DACT_003.a100
  is '';
comment on column T_DACT_003.w100
  is 'ܲID';
alter table T_DACT_003
  add constraint PK_T_DACT_003 primary key (P001, W100);

prompt
prompt Creating table T_DACT_004
prompt =========================
prompt
create table T_DACT_004
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a010 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DACT_004
  is 'Ȩ棨ɶȨ棩䶯ܱ';
comment on column T_DACT_004.p001
  is '    Ŀ ';
comment on column T_DACT_004.a002
  is 'ʵʱɱ';
comment on column T_DACT_004.a003
  is 'ʱ';
comment on column T_DACT_004.a004
  is ' ';
comment on column T_DACT_004.a005
  is 'ӯ๫ ';
comment on column T_DACT_004.a006
  is ' һ׼ ';
comment on column T_DACT_004.a007
  is ' δ ';
comment on column T_DACT_004.a008
  is 'ұ';
comment on column T_DACT_004.a009
  is ' Ȩϼ';
comment on column T_DACT_004.a100
  is '';
comment on column T_DACT_004.a010
  is '׷׼';
comment on column T_DACT_004.w100
  is 'ܲID';
alter table T_DACT_004
  add constraint PK_T_DACT_004 primary key (P001, W100);

prompt
prompt Creating table T_DACT_005
prompt =========================
prompt
create table T_DACT_005
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DACT_005
  is 'ʲֵ׼ܱ';
comment on column T_DACT_005.p001
  is '     Ŀ';
comment on column T_DACT_005.a002
  is '';
comment on column T_DACT_005.a003
  is 'ڼ';
comment on column T_DACT_005.a004
  is 'ڼת';
comment on column T_DACT_005.a005
  is 'ڼת';
comment on column T_DACT_005.a006
  is 'ĩ ';
comment on column T_DACT_005.a100
  is '';
comment on column T_DACT_005.w100
  is 'ܲID';
alter table T_DACT_005
  add constraint PK_T_DACT_005 primary key (P001, W100);

prompt
prompt Creating table T_DACT_B_R001
prompt ============================
prompt
create table T_DACT_B_R001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2)
)
;
comment on table T_DACT_B_R001
  is 'Ӫҵȯݱ';
comment on column T_DACT_B_R001.p001
  is 'Ӫҵid';
comment on column T_DACT_B_R001.p002
  is 'Ŀ';
comment on column T_DACT_B_R001.a002
  is 'ĩ';
comment on column T_DACT_B_R001.a003
  is 'ڳ';
alter table T_DACT_B_R001
  add constraint PK_T_DACT_B_R001 primary key (P002, P001);

prompt
prompt Creating table T_DACT_B_R001_20190904
prompt =====================================
prompt
create table T_DACT_B_R001_20190904
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2)
)
;

prompt
prompt Creating table T_DACT_B_R002
prompt ============================
prompt
create table T_DACT_B_R002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a002 VARCHAR2(100) not null,
  a003 NUMBER(19,2) not null
)
;
comment on table T_DACT_B_R002
  is 'Ӫҵȯݱ';
comment on column T_DACT_B_R002.p001
  is 'Ӫҵid';
comment on column T_DACT_B_R002.p002
  is 'Ŀid';
comment on column T_DACT_B_R002.a002
  is '֤ȯ';
comment on column T_DACT_B_R002.a003
  is 'ۼ/ֵ';
alter table T_DACT_B_R002
  add constraint PK_T_DACT_B_R002 primary key (P001, A002, P002, A003);

prompt
prompt Creating table T_DA_01_001
prompt ==========================
prompt
create table T_DA_01_001
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DA_01_001
  is '֤ȯ˾ʱ';
comment on column T_DA_01_001.p001
  is 'Ŀ';
comment on column T_DA_01_001.a005
  is '"ӦĽ
ڳ
"';
comment on column T_DA_01_001.a006
  is '"ӦĽ
ĩ
"';
comment on column T_DA_01_001.a100
  is '';
comment on column T_DA_01_001.w100
  is 'ܲID';
alter table T_DA_01_001
  add constraint PK_T_DA_01_001 primary key (P001, W100);

prompt
prompt Creating table T_DA_01_002
prompt ==========================
prompt
create table T_DA_01_002
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a006 VARCHAR2(128),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DA_01_002
  is '֤ȯ˾տָܱ';
comment on column T_DA_01_002.p001
  is 'Ŀ';
comment on column T_DA_01_002.a002
  is 'ڳ';
comment on column T_DA_01_002.a003
  is 'ĩ';
comment on column T_DA_01_002.a006
  is 'ע';
comment on column T_DA_01_002.a100
  is '';
comment on column T_DA_01_002.w100
  is 'ܲID';
alter table T_DA_01_002
  add constraint PK_T_DA_01_002 primary key (P001, W100);

prompt
prompt Creating table T_DA_01_003
prompt ==========================
prompt
create table T_DA_01_003
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 VARCHAR2(128),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DA_01_003
  is 'ͻ׽ʽȫԼܱ';
comment on column T_DA_01_003.p001
  is 'Ŀ';
comment on column T_DA_01_003.a002
  is '';
comment on column T_DA_01_003.a003
  is 'Ԫ';
comment on column T_DA_01_003.a004
  is '۱';
comment on column T_DA_01_003.a005
  is '۳Һϼ';
comment on column T_DA_01_003.a006
  is 'ע';
comment on column T_DA_01_003.a100
  is '';
comment on column T_DA_01_003.w100
  is 'ܲID';
alter table T_DA_01_003
  add constraint PK_T_DA_01_003 primary key (P001, W100);

prompt
prompt Creating table T_DA_01_004
prompt ==========================
prompt
create table T_DA_01_004
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DA_01_004
  is '֤ȯ˾ʱ׼';
comment on column T_DA_01_004.p001
  is 'Ŀ';
comment on column T_DA_01_004.a005
  is '"ʱ
ڳ
"';
comment on column T_DA_01_004.a006
  is '"ʱ
ĩ
"';
comment on column T_DA_01_004.a100
  is '';
comment on column T_DA_01_004.w100
  is 'ܲID';
alter table T_DA_01_004
  add constraint PK_T_DA_01_004 primary key (P001, W100);

prompt
prompt Creating table T_DA_02_001
prompt ==========================
prompt
create table T_DA_02_001
(
  p001 VARCHAR2(128) not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a006 VARCHAR2(128),
  a100 NUMBER,
  a004 NUMBER not null,
  a005 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DA_02_001
  is '֤ȯ˾տָܱһַծȯ֤ȯĳɱ뾻ʱıǰ֤ȯ';
comment on column T_DA_02_001.p001
  is 'Ŀ';
comment on column T_DA_02_001.a002
  is 'ڳ';
comment on column T_DA_02_001.a003
  is 'ĩ';
comment on column T_DA_02_001.a006
  is 'ע';
comment on column T_DA_02_001.a100
  is '';
comment on column T_DA_02_001.a004
  is 'ݱӦķ(1004;1005;1006;1007;1008)';
comment on column T_DA_02_001.a005
  is 'γ';
comment on column T_DA_02_001.w100
  is 'ܲID';
alter table T_DA_02_001
  add constraint PK_QWM primary key (P001, A004, A005, W100);

prompt
prompt Creating table T_DB1_01_001
prompt ===========================
prompt
create table T_DB1_01_001
(
  p001 NUMBER not null,
  a002 NUMBER,
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB1_01_001
  is 'ܽչ';
comment on column T_DB1_01_001.p001
  is 'ID';
comment on column T_DB1_01_001.a002
  is 'Ŀ';
comment on column T_DB1_01_001.a100
  is '';
comment on column T_DB1_01_001.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_01_001
prompt ==========================
prompt
create table T_DB_01_001
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_001
  is 'ҵܱͻ׽ʽ';
comment on column T_DB_01_001.p001
  is 'Ŀ';
comment on column T_DB_01_001.p002
  is '';
comment on column T_DB_01_001.a003
  is '';
comment on column T_DB_01_001.a100
  is '';
comment on column T_DB_01_001.w100
  is 'ܲID';
alter table T_DB_01_001
  add constraint PK_T_DB_01_001 primary key (P001, P002, W100);

prompt
prompt Creating table T_DB_01_001_20200407
prompt ===================================
prompt
create table T_DB_01_001_20200407
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;

prompt
prompt Creating table T_DB_01_002
prompt ==========================
prompt
create table T_DB_01_002
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a100 NUMBER,
  a003 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_01_002
  is 'ҵܱʽ˻';
comment on column T_DB_01_002.p001
  is 'Ŀ';
comment on column T_DB_01_002.p002
  is '˻';
comment on column T_DB_01_002.a100
  is '';
comment on column T_DB_01_002.a003
  is '';
comment on column T_DB_01_002.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_01_003
prompt ==========================
prompt
create table T_DB_01_003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER,
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_003
  is 'ҵ֤ȯ';
comment on column T_DB_01_003.p001
  is 'Ŀ';
comment on column T_DB_01_003.p002
  is 'ʻ';
comment on column T_DB_01_003.a003
  is '';
comment on column T_DB_01_003.a100
  is '';
comment on column T_DB_01_003.w100
  is 'ܲID';
alter table T_DB_01_003
  add constraint PK_T_DB_01_003 primary key (P001, P002, W100);

prompt
prompt Creating table T_DB_01_004
prompt ==========================
prompt
create table T_DB_01_004
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_004
  is 'ҵܱ׻';
comment on column T_DB_01_004.p001
  is 'Ŀ';
comment on column T_DB_01_004.a002
  is '';
comment on column T_DB_01_004.a003
  is '½׽';
comment on column T_DB_01_004.a004
  is 'ۼƽ׽';
comment on column T_DB_01_004.a100
  is '';
comment on column T_DB_01_004.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_01_005
prompt ==========================
prompt
create table T_DB_01_005
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a003 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_01_005
  is 'ҵܱϽ';
comment on column T_DB_01_005.p001
  is '';
comment on column T_DB_01_005.a002
  is '½';
comment on column T_DB_01_005.a100
  is '';
comment on column T_DB_01_005.a003
  is 'ۼƽ';
comment on column T_DB_01_005.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_01_006
prompt ==========================
prompt
create table T_DB_01_006
(
  p001 NUMBER not null,
  a002 NUMBER not null,
  a003 NUMBER(19,2),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_01_006
  is 'ҵֵܱ';
comment on column T_DB_01_006.p001
  is 'Ŀ';
comment on column T_DB_01_006.a002
  is '';
comment on column T_DB_01_006.a003
  is 'ָй֤ȯֵ';
comment on column T_DB_01_006.a100
  is '';
comment on column T_DB_01_006.w100
  is 'ܲID';
alter table T_DB_01_006
  add constraint KRCS primary key (P001, A002, A100, W100);

prompt
prompt Creating table T_DB_01_007
prompt ==========================
prompt
create table T_DB_01_007
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a003 NUMBER not null,
  w100 NUMBER not null
)
;

prompt
prompt Creating table T_DB_01_008
prompt ==========================
prompt
create table T_DB_01_008
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_008
  is 'ҵ--';
comment on column T_DB_01_008.p001
  is 'Ŀ';
comment on column T_DB_01_008.a002
  is '';
comment on column T_DB_01_008.a100
  is '';
comment on column T_DB_01_008.w100
  is 'ܲID';
alter table T_DB_01_008
  add constraint PK_T_DB_01_008 primary key (P001, W100);

prompt
prompt Creating table T_DB_01_009
prompt ==========================
prompt
create table T_DB_01_009
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_009
  is 'ҵ--ʲ';
comment on column T_DB_01_009.p001
  is 'Ŀ';
comment on column T_DB_01_009.a002
  is '';
comment on column T_DB_01_009.a100
  is '';
comment on column T_DB_01_009.w100
  is 'ܲID';
alter table T_DB_01_009
  add constraint PK_T_DB_01_09 primary key (P001, W100);

prompt
prompt Creating table T_DB_01_010
prompt ==========================
prompt
create table T_DB_01_010
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_010
  is 'ҵ--ծ';
comment on column T_DB_01_010.p001
  is 'Ŀ';
comment on column T_DB_01_010.a002
  is '';
comment on column T_DB_01_010.a100
  is '';
comment on column T_DB_01_010.w100
  is 'ܲID';
alter table T_DB_01_010
  add constraint PK_DB_01_010 primary key (P001, W100);

prompt
prompt Creating table T_DB_01_011
prompt ==========================
prompt
create table T_DB_01_011
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_011
  is 'ҵ--ծ';
comment on column T_DB_01_011.p001
  is 'Ŀ';
comment on column T_DB_01_011.a002
  is '';
comment on column T_DB_01_011.a100
  is '';
comment on column T_DB_01_011.w100
  is 'ܲID';
alter table T_DB_01_011
  add constraint PK_DB_01_011 primary key (P001, W100);

prompt
prompt Creating table T_DB_01_012
prompt ==========================
prompt
create table T_DB_01_012
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_012
  is 'ҵ--Ҹծ';
comment on column T_DB_01_012.p001
  is 'Ŀ';
comment on column T_DB_01_012.a002
  is '';
comment on column T_DB_01_012.a100
  is '';
comment on column T_DB_01_012.w100
  is 'ܲID';
alter table T_DB_01_012
  add constraint PK_DB_01_012 primary key (P001, W100);

prompt
prompt Creating table T_DB_01_013
prompt ==========================
prompt
create table T_DB_01_013
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_013
  is 'ҵ--Ҹծ';
comment on column T_DB_01_013.p001
  is 'Ŀ';
comment on column T_DB_01_013.a002
  is '';
comment on column T_DB_01_013.a100
  is '';
comment on column T_DB_01_013.w100
  is 'ܲID';
alter table T_DB_01_013
  add constraint PK_DB_01_013 primary key (P001, W100);

prompt
prompt Creating table T_DB_01_014
prompt ==========================
prompt
create table T_DB_01_014
(
  p001 NUMBER not null,
  a002 NUMBER,
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_01_014
  is 'ҵ--ҵ';
comment on column T_DB_01_014.p001
  is 'Ŀ';
comment on column T_DB_01_014.a002
  is '';
comment on column T_DB_01_014.a100
  is '';
comment on column T_DB_01_014.w100
  is 'ܲID';
alter table T_DB_01_014
  add constraint PK_DB_01_014 primary key (P001, W100);

prompt
prompt Creating table T_DB_01_020
prompt ==========================
prompt
create table T_DB_01_020
(
  p001 NUMBER,
  a002 NUMBER,
  a003 NUMBER,
  a004 NUMBER,
  a005 NUMBER,
  a099 VARCHAR2(255),
  w100 NUMBER,
  a100 NUMBER
)
;
comment on table T_DB_01_020
  is '׵˻';
comment on column T_DB_01_020.p001
  is 'Ŀ';
comment on column T_DB_01_020.a002
  is 'ڳ';
comment on column T_DB_01_020.a003
  is '';
comment on column T_DB_01_020.a004
  is 'ڼ';
comment on column T_DB_01_020.a005
  is 'ĩ';
comment on column T_DB_01_020.a099
  is 'ע';
comment on column T_DB_01_020.w100
  is 'ID';

prompt
prompt Creating table T_DB_01_D002
prompt ===========================
prompt
create table T_DB_01_D002
(
  p001 NUMBER,
  a002 VARCHAR2(100),
  a003 NUMBER,
  a004 VARCHAR2(10),
  c100 VARCHAR2(20),
  d100 VARCHAR2(20),
  e100 VARCHAR2(20)
)
;
comment on table T_DB_01_D002
  is '˻Ŀ';
comment on column T_DB_01_D002.p001
  is 'ĿID';
comment on column T_DB_01_D002.a002
  is 'Ŀ';
comment on column T_DB_01_D002.a003
  is '';
comment on column T_DB_01_D002.a004
  is '־';

prompt
prompt Creating table T_DB_03_001
prompt ==========================
prompt
create table T_DB_03_001
(
  p001 NUMBER not null,
  a100 NUMBER not null,
  a001 NUMBER,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER,
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_001
  is 'ҵ--״η';
comment on column T_DB_03_001.p001
  is 'Ŀ';
comment on column T_DB_03_001.a100
  is '';
comment on column T_DB_03_001.a001
  is '';
comment on column T_DB_03_001.a002
  is 'Ŀܳ';
comment on column T_DB_03_001.a003
  is '˾ܳ';
comment on column T_DB_03_001.a004
  is 'Ӷ';
comment on column T_DB_03_001.a005
  is 'ڱ';
comment on column T_DB_03_001.a006
  is 'ڱĿܳ';
comment on column T_DB_03_001.a007
  is 'ڱ깫˾ܳ';
comment on column T_DB_03_001.a008
  is 'ڱӶ';
comment on column T_DB_03_001.w100
  is 'ܲID';
alter table T_DB_03_001
  add constraint PK_T_DB_01_012 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_003
prompt ==========================
prompt
create table T_DB_03_003
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER,
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_003
  is 'ҵ-';
comment on column T_DB_03_003.p001
  is 'Ŀ';
comment on column T_DB_03_003.a002
  is 'Ŀܳ';
comment on column T_DB_03_003.a100
  is '';
comment on column T_DB_03_003.a001
  is '';
comment on column T_DB_03_003.a003
  is '˾ܳ';
comment on column T_DB_03_003.a004
  is 'Ӷ';
comment on column T_DB_03_003.a005
  is 'ڱ';
comment on column T_DB_03_003.a006
  is 'ڱĿܳ';
comment on column T_DB_03_003.a007
  is 'ڱ깫˾ܳ';
comment on column T_DB_03_003.a008
  is 'ڱӶ';
comment on column T_DB_03_003.w100
  is 'ܲID';
alter table T_DB_03_003
  add constraint PK_T_DB_03_003 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_005
prompt ==========================
prompt
create table T_DB_03_005
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_005
  is 'ҵ-';
comment on column T_DB_03_005.p001
  is 'Ŀ';
comment on column T_DB_03_005.a002
  is 'Ŀܳ';
comment on column T_DB_03_005.a100
  is '';
comment on column T_DB_03_005.a001
  is '';
comment on column T_DB_03_005.a003
  is '˾ܳ';
comment on column T_DB_03_005.a004
  is 'Ӷ';
comment on column T_DB_03_005.a005
  is 'ڱۼƳ';
comment on column T_DB_03_005.a006
  is 'ڱۼĿܳ';
comment on column T_DB_03_005.a007
  is 'ڱۼƹ˾ܳ';
comment on column T_DB_03_005.a008
  is 'ڱۼƳӶ';
comment on column T_DB_03_005.w100
  is 'ܲID';
alter table T_DB_03_005
  add constraint PK_T_DB_03_005 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_007
prompt ==========================
prompt
create table T_DB_03_007
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_007
  is 'ҵ-ծȯ';
comment on column T_DB_03_007.p001
  is 'Ŀ';
comment on column T_DB_03_007.a002
  is 'Ŀܳ()';
comment on column T_DB_03_007.a100
  is '';
comment on column T_DB_03_007.a001
  is '()';
comment on column T_DB_03_007.a003
  is '˾ܳ()';
comment on column T_DB_03_007.a004
  is 'Ӷ()';
comment on column T_DB_03_007.a005
  is '(ڱۼ)';
comment on column T_DB_03_007.a006
  is 'Ŀܳ(ڱۼ)';
comment on column T_DB_03_007.a007
  is '˾ܳ(ڱۼ)';
comment on column T_DB_03_007.a008
  is 'Ӷ(ڱۼ)';
comment on column T_DB_03_007.w100
  is 'ܲID';
alter table T_DB_03_007
  add constraint PK_T_DB_03_007 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_009
prompt ==========================
prompt
create table T_DB_03_009
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_009
  is 'ҵ-';
comment on column T_DB_03_009.p001
  is 'Ŀ';
comment on column T_DB_03_009.a002
  is 'Ŀܳ';
comment on column T_DB_03_009.a100
  is '';
comment on column T_DB_03_009.a001
  is '';
comment on column T_DB_03_009.a003
  is '˾ܳ';
comment on column T_DB_03_009.a004
  is 'Ӷ';
comment on column T_DB_03_009.a005
  is 'ڱۼƳ';
comment on column T_DB_03_009.a006
  is 'ڱۼĿܳ';
comment on column T_DB_03_009.a007
  is 'ڱۼƹ˾ܳ';
comment on column T_DB_03_009.a008
  is 'ڱۼƳӶ';
comment on column T_DB_03_009.w100
  is 'ܲID';
alter table T_DB_03_009
  add constraint PK_T_DB_03_009 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_011
prompt ==========================
prompt
create table T_DB_03_011
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_011
  is 'ҵ-״η';
comment on column T_DB_03_011.p001
  is 'Ŀ';
comment on column T_DB_03_011.a002
  is '˾';
comment on column T_DB_03_011.a100
  is '';
comment on column T_DB_03_011.a001
  is '';
comment on column T_DB_03_011.a003
  is 'Ӷ';
comment on column T_DB_03_011.a004
  is 'ڱۼƳ';
comment on column T_DB_03_011.a005
  is 'ڱۼƱ˾';
comment on column T_DB_03_011.a006
  is 'ڱۼƳӶ';
comment on column T_DB_03_011.w100
  is 'ܲID';
alter table T_DB_03_011
  add constraint PK_T_DB_03_011 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_013
prompt ==========================
prompt
create table T_DB_03_013
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER,
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_013
  is 'ҵ-';
comment on column T_DB_03_013.p001
  is 'Ŀ';
comment on column T_DB_03_013.a002
  is '˾';
comment on column T_DB_03_013.a100
  is '';
comment on column T_DB_03_013.a001
  is '';
comment on column T_DB_03_013.a003
  is 'Ӷ';
comment on column T_DB_03_013.a004
  is 'ڱ';
comment on column T_DB_03_013.a005
  is 'ڱ걾˾';
comment on column T_DB_03_013.a006
  is 'ڱӶ';
comment on column T_DB_03_013.w100
  is 'ܲID';
alter table T_DB_03_013
  add constraint PK_T_DB_03_013 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_015
prompt ==========================
prompt
create table T_DB_03_015
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER,
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_015
  is 'ҵ-';
comment on column T_DB_03_015.p001
  is 'Ŀ';
comment on column T_DB_03_015.a002
  is '˾';
comment on column T_DB_03_015.a100
  is '';
comment on column T_DB_03_015.a001
  is '';
comment on column T_DB_03_015.a003
  is 'Ӷ';
comment on column T_DB_03_015.a004
  is 'ڱ';
comment on column T_DB_03_015.a005
  is 'ڱ걾˾';
comment on column T_DB_03_015.a006
  is 'ڱӶ';
comment on column T_DB_03_015.w100
  is 'ܲID';
alter table T_DB_03_015
  add constraint PK_T_DB_03_015 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_017
prompt ==========================
prompt
create table T_DB_03_017
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_017
  is 'ҵ-ծȯ';
comment on column T_DB_03_017.p001
  is 'Ŀ';
comment on column T_DB_03_017.a002
  is '˾ڣ';
comment on column T_DB_03_017.a100
  is '';
comment on column T_DB_03_017.a001
  is 'ڣ';
comment on column T_DB_03_017.a003
  is 'Ӷ루ڣ';
comment on column T_DB_03_017.a004
  is 'ڱۼƣ';
comment on column T_DB_03_017.a005
  is '˾ڱۼƣ';
comment on column T_DB_03_017.a006
  is 'Ӷ루ڱۼƣ';
comment on column T_DB_03_017.w100
  is 'ܲID';
alter table T_DB_03_017
  add constraint PK_T_DB_03_017 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_019
prompt ==========================
prompt
create table T_DB_03_019
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER,
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_019
  is 'ҵ-';
comment on column T_DB_03_019.p001
  is 'Ŀ';
comment on column T_DB_03_019.a002
  is '˾';
comment on column T_DB_03_019.a100
  is '';
comment on column T_DB_03_019.a001
  is '';
comment on column T_DB_03_019.a003
  is 'Ӷ';
comment on column T_DB_03_019.a004
  is 'ڱ';
comment on column T_DB_03_019.a005
  is 'ڱ걾˾';
comment on column T_DB_03_019.a006
  is 'ڱӶ';
comment on column T_DB_03_019.w100
  is 'ܲID';
alter table T_DB_03_019
  add constraint PK_T_DB_03_019 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_021
prompt ==========================
prompt
create table T_DB_03_021
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_021
  is 'ҵ-ڰת״η';
comment on column T_DB_03_021.p001
  is 'Ŀ';
comment on column T_DB_03_021.a002
  is 'Խʲ';
comment on column T_DB_03_021.a100
  is '';
comment on column T_DB_03_021.a001
  is '';
comment on column T_DB_03_021.a003
  is 'ɹ۽ʲ';
comment on column T_DB_03_021.a004
  is 'ʲ';
comment on column T_DB_03_021.w100
  is 'ܲID';
alter table T_DB_03_021
  add constraint PK_T_DB_03_021 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_022
prompt ==========================
prompt
create table T_DB_03_022
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_022
  is 'ҵ-ڰת';
comment on column T_DB_03_022.p001
  is 'Ŀ';
comment on column T_DB_03_022.a002
  is 'Խʲ';
comment on column T_DB_03_022.a100
  is '';
comment on column T_DB_03_022.a001
  is '';
comment on column T_DB_03_022.a003
  is 'ɹ۽ʲ';
comment on column T_DB_03_022.a004
  is 'ʲ';
comment on column T_DB_03_022.w100
  is 'ܲID';
alter table T_DB_03_022
  add constraint PK_T_DB_03_022 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_023
prompt ==========================
prompt
create table T_DB_03_023
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_023
  is 'ҵ-ڰת';
comment on column T_DB_03_023.p001
  is 'Ŀ';
comment on column T_DB_03_023.a002
  is 'Խʲ';
comment on column T_DB_03_023.a100
  is '';
comment on column T_DB_03_023.a001
  is '';
comment on column T_DB_03_023.a003
  is 'ɹ۽ʲ';
comment on column T_DB_03_023.a004
  is 'ʲ';
comment on column T_DB_03_023.w100
  is 'ܲID';
alter table T_DB_03_023
  add constraint PK_T_DB_03_023 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_024
prompt ==========================
prompt
create table T_DB_03_024
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_024
  is 'ҵ-ڰתծȯ';
comment on column T_DB_03_024.p001
  is 'Ŀ';
comment on column T_DB_03_024.a002
  is 'Խʲ';
comment on column T_DB_03_024.a100
  is '';
comment on column T_DB_03_024.a001
  is '';
comment on column T_DB_03_024.a003
  is 'ɹ۽ʲ';
comment on column T_DB_03_024.a004
  is 'ʲ';
comment on column T_DB_03_024.w100
  is 'ܲID';
alter table T_DB_03_024
  add constraint PK_T_DB_03_024 primary key (P001, W100);

prompt
prompt Creating table T_DB_03_025
prompt ==========================
prompt
create table T_DB_03_025
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a001 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_03_025
  is 'ҵ-ڰת״';
comment on column T_DB_03_025.p001
  is 'Ŀ';
comment on column T_DB_03_025.a002
  is 'Խʲ';
comment on column T_DB_03_025.a100
  is '';
comment on column T_DB_03_025.a001
  is '';
comment on column T_DB_03_025.a003
  is 'ɹ۽ʲ';
comment on column T_DB_03_025.a004
  is 'ʲ';
comment on column T_DB_03_025.w100
  is 'ܲID';
alter table T_DB_03_025
  add constraint PK_T_DB_03_025 primary key (P001, W100);

prompt
prompt Creating table T_DB_04_001
prompt ==========================
prompt
create table T_DB_04_001
(
  p001 VARCHAR2(8) not null,
  a002 NUMBER not null,
  a003 VARCHAR2(64),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a008 NUMBER(19,2),
  a010 NUMBER not null,
  a011 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_04_001
  is '֤ȯͶҵ';

prompt
prompt Creating table T_DB_04_001_BK
prompt =============================
prompt
create table T_DB_04_001_BK
(
  p001 VARCHAR2(8),
  a002 NUMBER,
  a003 VARCHAR2(64),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a008 NUMBER(19,2),
  a010 NUMBER,
  a011 NUMBER(19,2),
  a012 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_04_001_BK
  is '֤ȯͶҵ񣭹ƱƱɱڱ䶯ڱڳʼʱݴڴ˴ԱͱȽϣ';
comment on column T_DB_04_001_BK.p001
  is '֤ȯ';
comment on column T_DB_04_001_BK.a002
  is '֤ȯ(ԹƱ1Ϊͨ 10121017ֱΪϺͨ;ͨͳһΪ1)';
comment on column T_DB_04_001_BK.a003
  is '֤ȯ';
comment on column T_DB_04_001_BK.a004
  is 'ڳɱ';
comment on column T_DB_04_001_BK.a005
  is '';
comment on column T_DB_04_001_BK.a006
  is 'ڼ';
comment on column T_DB_04_001_BK.a007
  is 'ĩɱ';
comment on column T_DB_04_001_BK.a009
  is 'ĩֵ';
comment on column T_DB_04_001_BK.a100
  is '';
comment on column T_DB_04_001_BK.a008
  is 'ĩʼֵ';
comment on column T_DB_04_001_BK.a010
  is 'ID(Ʊ100200)';
comment on column T_DB_04_001_BK.a011
  is 'ĩֲ';
comment on column T_DB_04_001_BK.a012
  is 'Ʊ(t_b00_d009)';
comment on column T_DB_04_001_BK.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_04_002
prompt ==========================
prompt
create table T_DB_04_002
(
  p001 VARCHAR2(16) not null,
  a003 VARCHAR2(64),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a010 NUMBER(19,2),
  a100 NUMBER,
  a009 NUMBER(19,2),
  a011 NUMBER not null,
  a012 NUMBER(19,2),
  w100 NUMBER not null,
  a002 NUMBER not null
)
;
comment on table T_DB_04_002
  is '֤ȯͶҵ';
alter table T_DB_04_002
  add constraint PK_T_DB_04_002 primary key (P001, W100);

prompt
prompt Creating table T_DB_04_002_02_01
prompt ================================
prompt
create table T_DB_04_002_02_01
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a100 NUMBER,
  a009 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_04_002_02_01
  is '֤ȯͶҵծȯ-̶沿';
comment on column T_DB_04_002_02_01.p001
  is 'Ŀ';
comment on column T_DB_04_002_02_01.p002
  is 'С';
comment on column T_DB_04_002_02_01.a003
  is 'ڳɱ';
comment on column T_DB_04_002_02_01.a004
  is '';
comment on column T_DB_04_002_02_01.a005
  is 'ڼ';
comment on column T_DB_04_002_02_01.a006
  is 'ĩɱ';
comment on column T_DB_04_002_02_01.a007
  is 'ĩֵ';
comment on column T_DB_04_002_02_01.a008
  is 'ĩֵ';
comment on column T_DB_04_002_02_01.a100
  is '';
comment on column T_DB_04_002_02_01.a009
  is 'ĩ̯ɱ';
comment on column T_DB_04_002_02_01.w100
  is 'ܲID';
alter table T_DB_04_002_02_01
  add constraint PK_T_DB_04_002_02_01 primary key (P001, P002, W100);

prompt
prompt Creating table T_DB_04_002_02_02
prompt ================================
prompt
create table T_DB_04_002_02_02
(
  p001 NUMBER not null,
  p003 VARCHAR2(32) not null,
  a004 VARCHAR2(64),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_04_002_02_02
  is '֤ȯͶҵծȯ/бǰ-̶沿';
comment on column T_DB_04_002_02_02.p001
  is '(ծȯ)';
comment on column T_DB_04_002_02_02.p003
  is '֤ȯ';
comment on column T_DB_04_002_02_02.a004
  is '֤ȯ';
comment on column T_DB_04_002_02_02.a005
  is 'ĩ';
comment on column T_DB_04_002_02_02.a006
  is 'ĩɱ';
comment on column T_DB_04_002_02_02.a007
  is 'ĩ湫ʼֵ';
comment on column T_DB_04_002_02_02.a008
  is 'ĩֵ';
comment on column T_DB_04_002_02_02.a100
  is 'ûID';
comment on column T_DB_04_002_02_02.w100
  is 'ܲID';
alter table T_DB_04_002_02_02
  add constraint PK_DB_04_002_02_02 primary key (P001, P003, W100);

prompt
prompt Creating table T_DB_04_003
prompt ==========================
prompt
create table T_DB_04_003
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_04_003
  is '֤ȯͶҵ񣭽Խʲĩϸ';
comment on column T_DB_04_003.p001
  is '';
comment on column T_DB_04_003.a002
  is 'гɱ';
comment on column T_DB_04_003.a003
  is 'ʼֵ䶯';
comment on column T_DB_04_003.a100
  is '';
comment on column T_DB_04_003.w100
  is 'ܲID';
alter table T_DB_04_003
  add constraint PK_T_DB_04_003 primary key (P001, W100);

prompt
prompt Creating table T_DB_04_004
prompt ==========================
prompt
create table T_DB_04_004
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_04_004
  is '֤ȯͶҵ񣭿ɹʲĩϸ';
comment on column T_DB_04_004.p001
  is '';
comment on column T_DB_04_004.a002
  is 'гɱ';
comment on column T_DB_04_004.a003
  is 'ʼֵ䶯';
comment on column T_DB_04_004.a004
  is '';
comment on column T_DB_04_004.a100
  is '';
comment on column T_DB_04_004.w100
  is 'ܲID';
alter table T_DB_04_004
  add constraint PK_T_DB_04_004 primary key (P001, W100);

prompt
prompt Creating table T_DB_04_005
prompt ==========================
prompt
create table T_DB_04_005
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_04_005
  is '֤ȯͶҵ񣭳ڽʲĩϸ';
comment on column T_DB_04_005.p001
  is '';
comment on column T_DB_04_005.a002
  is 'гɱ';
comment on column T_DB_04_005.a003
  is '';
comment on column T_DB_04_005.a100
  is '';
comment on column T_DB_04_005.w100
  is 'ܲID';
alter table T_DB_04_005
  add constraint PK_T_DB_04_005 primary key (P001, W100);

prompt
prompt Creating table T_DB_04_006
prompt ==========================
prompt
create table T_DB_04_006
(
  p001 NUMBER not null,
  a002 VARCHAR2(800) not null,
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_04_006
  is '֤ȯͶҵط˵';
comment on column T_DB_04_006.p001
  is 'Ŀ';
comment on column T_DB_04_006.a002
  is 'Ŀ';
comment on column T_DB_04_006.a100
  is '';
comment on column T_DB_04_006.w100
  is 'ܲID';
alter table T_DB_04_006
  add constraint PK_T_DB_04_006 primary key (P001, W100);

prompt
prompt Creating table T_DB_04_007
prompt ==========================
prompt
create table T_DB_04_007
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER,
  a008 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_04_007
  is '֤ȯͶҵ񣭹ָڻͶ';
comment on column T_DB_04_007.p001
  is 'Լ';
comment on column T_DB_04_007.a002
  is 'Լݶ';
comment on column T_DB_04_007.a003
  is 'ͷͷ';
comment on column T_DB_04_007.a004
  is 'ͷͷ';
comment on column T_DB_04_007.a005
  is '徻ͷ';
comment on column T_DB_04_007.a006
  is 'ĩֵ';
comment on column T_DB_04_007.a007
  is 'ڱǿƽִΣ';
comment on column T_DB_04_007.a008
  is 'ڱǿƽֵĺԼݶ';
comment on column T_DB_04_007.a100
  is '';
comment on column T_DB_04_007.w100
  is 'ܲID';
alter table T_DB_04_007
  add constraint PK_T_DB_04_007 primary key (P001, W100);

prompt
prompt Creating table T_DB_05_020
prompt ==========================
prompt
create table T_DB_05_020
(
  p001 NUMBER not null,
  a002 DATE,
  a003 VARCHAR2(255),
  a004 VARCHAR2(255),
  a005 NUMBER(19,2),
  a006 VARCHAR2(255),
  a007 DATE,
  a008 DATE,
  a009 NUMBER(19,2),
  a010 VARCHAR2(200),
  a011 VARCHAR2(200),
  a012 NUMBER(19,2),
  a013 VARCHAR2(200),
  a014 VARCHAR2(200),
  a015 DATE,
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_05_020
  is '֤ȯ˾ʻרܱ-ϸ';
comment on column T_DB_05_020.p001
  is '';
comment on column T_DB_05_020.a002
  is '';
comment on column T_DB_05_020.a003
  is '̶Ϣ֧';
comment on column T_DB_05_020.a004
  is 'Ϣ֧';
comment on column T_DB_05_020.a005
  is '屾Ԫ';
comment on column T_DB_05_020.a006
  is 'Լ';
comment on column T_DB_05_020.a007
  is 'Ϣ';
comment on column T_DB_05_020.a008
  is '';
comment on column T_DB_05_020.a009
  is '̶-ʣࣨ%';
comment on column T_DB_05_020.a010
  is '̶-֧Ƶ';
comment on column T_DB_05_020.a011
  is '̶-Ϣ׼';
comment on column T_DB_05_020.a012
  is '-ʣࣨ%';
comment on column T_DB_05_020.a013
  is '-֧Ƶ';
comment on column T_DB_05_020.a014
  is '-Ϣ׼';
comment on column T_DB_05_020.a015
  is '״Ϣ֧գ';
comment on column T_DB_05_020.a100
  is '';
comment on column T_DB_05_020.w100
  is 'ܲid';

prompt
prompt Creating table T_DB_05_025
prompt ==========================
prompt
create table T_DB_05_025
(
  p001 NUMBER,
  a001 VARCHAR2(200),
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a013 NUMBER(19,2),
  a014 NUMBER(19,2),
  a015 NUMBER(19,2),
  a016 NUMBER(19,2),
  a017 NUMBER(19,2),
  a018 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_05_025
  is '֤ȯ˾ʻרܱ';
comment on column T_DB_05_025.p001
  is 'ID';
comment on column T_DB_05_025.a001
  is '׶';
comment on column T_DB_05_025.a002
  is 'ڽ-չ̶Լ屾';
comment on column T_DB_05_025.a003
  is 'ڽ-ո̶Լ屾';
comment on column T_DB_05_025.a004
  is 'ڽ-ʽԼ屾';
comment on column T_DB_05_025.a005
  is 'ڽ-ʵ ע1';
comment on column T_DB_05_025.a006
  is 'ĩֲ-չ̶Լ屾';
comment on column T_DB_05_025.a007
  is 'ĩֲ-չ̶Լֵ
';
comment on column T_DB_05_025.a008
  is 'ĩֲ-ո̶Լ屾
';
comment on column T_DB_05_025.a009
  is 'ĩֲ-ո̶Լֵ
';
comment on column T_DB_05_025.a010
  is 'ĩֲ-ʽԼ屾
';
comment on column T_DB_05_025.a011
  is 'ĩֲ-ʽԼֵ
';
comment on column T_DB_05_025.a012
  is 'ĩֲ-ЧԳյĺԼ屾 ע2
';
comment on column T_DB_05_025.a013
  is 'ĩֲ-ЧԳյĺԼֵ ע2
';
comment on column T_DB_05_025.a014
  is 'ĩֲ-ĩֲֺԼδʵ ע3
';
comment on column T_DB_05_025.a015
  is 'ڱۼ-չ̶Լ屾
';
comment on column T_DB_05_025.a016
  is 'ڱۼ-ո̶Լ屾
';
comment on column T_DB_05_025.a017
  is 'ڱۼ-ʽԼ屾
';
comment on column T_DB_05_025.a018
  is 'ڱۼ-ʵ ע1
';
comment on column T_DB_05_025.a100
  is '';
comment on column T_DB_05_025.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_05_101
prompt ==========================
prompt
create table T_DB_05_101
(
  p001 VARCHAR2(24) not null,
  a002 NUMBER(18),
  a003 NUMBER(18),
  a004 NUMBER(18),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_05_101
  is 'ʲҵĩͻ';
comment on column T_DB_05_101.p001
  is 'Ʒ';
comment on column T_DB_05_101.a002
  is '˿ͻ';
comment on column T_DB_05_101.a003
  is 'ͻ';
comment on column T_DB_05_101.a004
  is 'ϼ';
comment on column T_DB_05_101.a100
  is '';
comment on column T_DB_05_101.w100
  is 'ܲID';
alter table T_DB_05_101
  add constraint PK_T_DB_05_002_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_05_102
prompt ==========================
prompt
create table T_DB_05_102
(
  p001 VARCHAR2(24) not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  a008 NUMBER(18,2),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_05_102
  is 'ʲҵʽ';
comment on column T_DB_05_102.p001
  is 'Ʒ';
comment on column T_DB_05_102.a002
  is 'ڳ';
comment on column T_DB_05_102.a003
  is '';
comment on column T_DB_05_102.a004
  is 'ڼ';
comment on column T_DB_05_102.a006
  is 'ĩ';
comment on column T_DB_05_102.a007
  is 'и˿ͻ';
comment on column T_DB_05_102.a008
  is 'лͻ';
comment on column T_DB_05_102.a100
  is '';
comment on column T_DB_05_102.w100
  is 'ܲID';
alter table T_DB_05_102
  add constraint PK_T_DB_05_003_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_05_103
prompt ==========================
prompt
create table T_DB_05_103
(
  p001 VARCHAR2(24) not null,
  a002 NUMBER(18,4),
  a003 NUMBER(18,4),
  a004 NUMBER(18,4),
  a005 NUMBER(18,4),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_05_103
  is 'ʲҵ񣭾ֵ';
comment on column T_DB_05_103.p001
  is 'Ʒ';
comment on column T_DB_05_103.a002
  is 'ڳλֵ';
comment on column T_DB_05_103.a003
  is 'ĩλֵ';
comment on column T_DB_05_103.a004
  is 'ۼƵλֶ';
comment on column T_DB_05_103.a005
  is 'ۼƵλֵ';
comment on column T_DB_05_103.a100
  is '';
comment on column T_DB_05_103.w100
  is 'ܲID';
alter table T_DB_05_103
  add constraint PK_T_DB_05_004_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_05_104
prompt ==========================
prompt
create table T_DB_05_104
(
  p001 VARCHAR2(50) not null,
  a001 NUMBER(18,2),
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  a008 NUMBER(18,2),
  a009 NUMBER(18,2),
  a010 NUMBER(18,2),
  a011 NUMBER(18,2),
  a012 NUMBER(18,2),
  a013 NUMBER(18,2),
  a014 NUMBER(18,2),
  a015 NUMBER(18,2),
  a016 NUMBER(18,2),
  a017 NUMBER(18,2),
  a018 NUMBER(18,2),
  a019 NUMBER(18,2),
  a020 NUMBER(18,2),
  a021 NUMBER(18,2),
  a022 NUMBER(18,2),
  w100 NUMBER not null,
  a100 NUMBER,
  a023 NUMBER(18,2)
)
;
comment on table T_DB_05_104
  is 'ʹܱ--ҵE1-3-2Ͷ';
comment on column T_DB_05_104.p001
  is 'Ŀ';
comment on column T_DB_05_104.a001
  is 'ĩн';
comment on column T_DB_05_104.a002
  is 'гɱ(Ʊ)';
comment on column T_DB_05_104.a003
  is 'ʼֵ
(Ʊ)';
comment on column T_DB_05_104.a004
  is 'гɱ()';
comment on column T_DB_05_104.a005
  is 'ʼֵ
()';
comment on column T_DB_05_104.a006
  is 'гɱ(ծȯ)';
comment on column T_DB_05_104.a007
  is 'ʼֵ
(ծȯ)';
comment on column T_DB_05_104.a008
  is 'гɱ(ʲ֧֤ȯ)';
comment on column T_DB_05_104.a009
  is 'ʼֵ
(ʲ֧֤ȯ)';
comment on column T_DB_05_104.a010
  is 'ĩ֤';
comment on column T_DB_05_104.a011
  is 'гɱ(Ƽƻ)';
comment on column T_DB_05_104.a012
  is 'ʼֵ
(Ƽƻ';
comment on column T_DB_05_104.a013
  is 'гɱ(мƻ)';
comment on column T_DB_05_104.a014
  is 'ʼֵ
(мƻ';
comment on column T_DB_05_104.a015
  is 'гɱ(רʲƻ)';
comment on column T_DB_05_104.a016
  is 'ʼֵ
(רʲƻ';
comment on column T_DB_05_104.a017
  is 'ĩ';
comment on column T_DB_05_104.a018
  is 'гɱ(';
comment on column T_DB_05_104.a019
  is 'ʼֵ
(';
comment on column T_DB_05_104.a020
  is 'гɱ(ϼƣ';
comment on column T_DB_05_104.a021
  is 'ʼֵ
(ϼƣ';
comment on column T_DB_05_104.a022
  is 'ʣʽ';
comment on column T_DB_05_104.w100
  is 'ܲID';
comment on column T_DB_05_104.a100
  is '';
comment on column T_DB_05_104.a023
  is 'ĩʲֵ';
alter table T_DB_05_104
  add constraint PK_T_DB_06_011 primary key (P001, W100);

prompt
prompt Creating table T_DB_05_105
prompt ==========================
prompt
create table T_DB_05_105
(
  p001 VARCHAR2(50) not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  w100 NUMBER not null,
  a100 NUMBER not null
)
;
comment on table T_DB_05_105
  is 'ʹܱ--ҵE1-3-2ʲ';
comment on column T_DB_05_105.p001
  is 'ĿID';
comment on column T_DB_05_105.a002
  is 'عծȯع';
comment on column T_DB_05_105.a003
  is 'عծȯع';
comment on column T_DB_05_105.a004
  is 'ʹģ';
comment on column T_DB_05_105.a005
  is 'ȯģ';
comment on column T_DB_05_105.a006
  is 'άֵ';
comment on column T_DB_05_105.a007
  is '֤ȯ';
comment on column T_DB_05_105.w100
  is 'ܲID';
comment on column T_DB_05_105.a100
  is '';
alter table T_DB_05_105
  add constraint PK_DB_06_012 primary key (P001, A100, W100);

prompt
prompt Creating table T_DB_06_101
prompt ==========================
prompt
create table T_DB_06_101
(
  p001 VARCHAR2(24) not null,
  a002 NUMBER(18),
  a003 NUMBER(18),
  a004 NUMBER(18),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_06_101
  is 'רʲҵĩͻ';
comment on column T_DB_06_101.p001
  is 'Ʒ';
comment on column T_DB_06_101.a002
  is '˿ͻ';
comment on column T_DB_06_101.a003
  is 'ͻ';
comment on column T_DB_06_101.a004
  is 'ϼ';
comment on column T_DB_06_101.a100
  is '';
comment on column T_DB_06_101.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_06_102
prompt ==========================
prompt
create table T_DB_06_102
(
  p001 VARCHAR2(24) not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_06_102
  is 'רʲҵʵʷйģ';
comment on column T_DB_06_102.p001
  is 'Ʒ';
comment on column T_DB_06_102.a002
  is 'ݶ';
comment on column T_DB_06_102.a003
  is '˿ͻ';
comment on column T_DB_06_102.a004
  is 'ͻ';
comment on column T_DB_06_102.a005
  is 'ܽ';
comment on column T_DB_06_102.a006
  is 'ʽ𱨸ĩ';
comment on column T_DB_06_102.a100
  is '';
comment on column T_DB_06_102.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_06_103
prompt ==========================
prompt
create table T_DB_06_103
(
  p001 VARCHAR2(24) not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  a008 NUMBER(18,2),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_06_103
  is 'רʲҵ񣭲Ʒֽռ֧';
comment on column T_DB_06_103.p001
  is 'Ʒ';
comment on column T_DB_06_103.a002
  is 'ʵս';
comment on column T_DB_06_103.a003
  is 'Ӧս';
comment on column T_DB_06_103.a004
  is 'ۼʵս';
comment on column T_DB_06_103.a005
  is 'ۼӦս';
comment on column T_DB_06_103.a006
  is 'ƷۼӦܽ';
comment on column T_DB_06_103.a007
  is 'У';
comment on column T_DB_06_103.a008
  is 'Уμƾ֤ӦӦ';
comment on column T_DB_06_103.a100
  is '';
comment on column T_DB_06_103.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_06_104
prompt ==========================
prompt
create table T_DB_06_104
(
  p001 VARCHAR2(50),
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  a008 NUMBER(18,2),
  a009 NUMBER(18,2),
  a010 NUMBER(18,2),
  a011 NUMBER(18,2),
  a012 NUMBER(18,2),
  a013 NUMBER(18,2),
  a014 NUMBER(18,2),
  a015 NUMBER(18,2),
  a016 NUMBER(18,2),
  a017 NUMBER(18,2),
  a022 NUMBER(18,2),
  a023 NUMBER(18,2),
  a024 VARCHAR2(255),
  a025 NUMBER(18,2),
  a026 NUMBER(18,2),
  a027 NUMBER(18,2),
  a028 VARCHAR2(255),
  a029 NUMBER(18,2),
  a030 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_06_104
  is 'רʲҵͶ';
comment on column T_DB_06_104.p001
  is 'Ŀ';
comment on column T_DB_06_104.a002
  is 'ĩн';
comment on column T_DB_06_104.a003
  is 'Ʊɱ';
comment on column T_DB_06_104.a004
  is 'Ʊֵ';
comment on column T_DB_06_104.a005
  is 'ɱ';
comment on column T_DB_06_104.a006
  is 'ֵ';
comment on column T_DB_06_104.a007
  is 'ծȯɱ';
comment on column T_DB_06_104.a008
  is 'ծȯֵ';
comment on column T_DB_06_104.a009
  is 'ʲ֧֤ȯɱ';
comment on column T_DB_06_104.a010
  is 'ʲ֧֤ȯֵ';
comment on column T_DB_06_104.a011
  is 'ڻĩ֤';
comment on column T_DB_06_104.a012
  is 'Ƽƻɱ';
comment on column T_DB_06_104.a013
  is 'Ƽƻֵ';
comment on column T_DB_06_104.a014
  is 'мƻɱ';
comment on column T_DB_06_104.a015
  is 'мƻֵ';
comment on column T_DB_06_104.a016
  is 'רʲƻɱ';
comment on column T_DB_06_104.a017
  is 'רʲƻֵ';
comment on column T_DB_06_104.a022
  is 'ʲȨƻɱ';
comment on column T_DB_06_104.a023
  is 'ʲȨƻֵ';
comment on column T_DB_06_104.a024
  is 'ע';
comment on column T_DB_06_104.a025
  is 'Эڴ';
comment on column T_DB_06_104.a026
  is 'гɱ';
comment on column T_DB_06_104.a027
  is 'йʼֵ';
comment on column T_DB_06_104.a028
  is 'ע';
comment on column T_DB_06_104.a029
  is 'ʣʽ';
comment on column T_DB_06_104.a030
  is 'ĩʲֵ';

prompt
prompt Creating table T_DB_06_105
prompt ==========================
prompt
create table T_DB_06_105
(
  p001 VARCHAR2(50),
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_06_105
  is 'רʲҵʲ';
comment on column T_DB_06_105.p001
  is 'Ŀ';
comment on column T_DB_06_105.a002
  is 'ծȯعع';
comment on column T_DB_06_105.a003
  is 'ծȯعع';
comment on column T_DB_06_105.a004
  is 'ȯʹģ';
comment on column T_DB_06_105.a005
  is 'ȯȯģ';
comment on column T_DB_06_105.a006
  is 'ȯάֵ';
comment on column T_DB_06_105.a007
  is '֤ȯ֤ȯ';

prompt
prompt Creating table T_DB_07_101
prompt ==========================
prompt
create table T_DB_07_101
(
  p001 NUMBER,
  a002 NUMBER,
  a003 NUMBER,
  a004 NUMBER,
  a006 NUMBER,
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_07_101
  is 'ʲҵ񣨻';

prompt
prompt Creating table T_DB_07_102
prompt ==========================
prompt
create table T_DB_07_102
(
  p001 NUMBER,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_07_102
  is 'ʲҵʽ';

prompt
prompt Creating table T_DB_07_103
prompt ==========================
prompt
create table T_DB_07_103
(
  p001 NUMBER,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  a008 NUMBER(18,2),
  a009 NUMBER(18,2),
  a010 NUMBER(18,2),
  a011 NUMBER(18,2),
  a012 NUMBER(18,2),
  a013 NUMBER(18,2),
  a014 NUMBER(18,2),
  a015 NUMBER(18,2),
  a016 NUMBER(18,2),
  a017 NUMBER(18,2),
  a018 NUMBER(18,2),
  a019 NUMBER(18,2),
  a020 NUMBER(18,2),
  a021 NUMBER(18,2),
  a022 NUMBER(18,2),
  a023 NUMBER(18,2),
  a024 VARCHAR2(255),
  a025 NUMBER(18,2),
  a026 NUMBER(18,2),
  a027 NUMBER(18,2),
  a028 VARCHAR2(255),
  a029 NUMBER(18,2),
  a030 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_07_103
  is 'ʲҵͶ';
comment on column T_DB_07_103.p001
  is 'Ŀ';
comment on column T_DB_07_103.a002
  is 'ĩн';
comment on column T_DB_07_103.a003
  is 'Ʊɱ';
comment on column T_DB_07_103.a004
  is 'Ʊֵ';
comment on column T_DB_07_103.a005
  is 'ɱ';
comment on column T_DB_07_103.a006
  is 'ֵ';
comment on column T_DB_07_103.a007
  is 'ծȯɱ';
comment on column T_DB_07_103.a008
  is 'ծȯֵ';
comment on column T_DB_07_103.a009
  is 'ʲ֧֤ȯɱ';
comment on column T_DB_07_103.a010
  is 'ʲ֧֤ȯֵ';
comment on column T_DB_07_103.a011
  is 'ڻĩ֤';
comment on column T_DB_07_103.a012
  is 'Ƽƻɱ';
comment on column T_DB_07_103.a013
  is 'Ƽƻֵ';
comment on column T_DB_07_103.a014
  is 'мƻɱ';
comment on column T_DB_07_103.a015
  is 'мƻֵ';
comment on column T_DB_07_103.a016
  is 'רʲƻɱ';
comment on column T_DB_07_103.a017
  is 'רʲƻֵ';
comment on column T_DB_07_103.a018
  is 'гжһƱ--гɱ';
comment on column T_DB_07_103.a019
  is 'гжһƱ--ʼֵ';
comment on column T_DB_07_103.a020
  is 'гжһƱ-Ȩת-гɱ';
comment on column T_DB_07_103.a021
  is 'гжһƱ-Ȩת-ʼֵ';
comment on column T_DB_07_103.a022
  is 'ʲȨƻɱ';
comment on column T_DB_07_103.a023
  is 'ʲȨƻֵ';
comment on column T_DB_07_103.a024
  is 'ע';
comment on column T_DB_07_103.a025
  is 'Эڴ';
comment on column T_DB_07_103.a026
  is 'гɱ';
comment on column T_DB_07_103.a027
  is 'йʼֵ';
comment on column T_DB_07_103.a028
  is 'ע';
comment on column T_DB_07_103.a029
  is 'ʣʽ';
comment on column T_DB_07_103.a030
  is 'ĩʲֵ';

prompt
prompt Creating table T_DB_07_104
prompt ==========================
prompt
create table T_DB_07_104
(
  p001 NUMBER,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a007 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER
)
;
comment on table T_DB_07_104
  is 'ʲҵʲ';
comment on column T_DB_07_104.p001
  is 'Ŀ';
comment on column T_DB_07_104.a002
  is 'ծȯعع';
comment on column T_DB_07_104.a003
  is 'ծȯعع';
comment on column T_DB_07_104.a004
  is 'ȯʹģ';
comment on column T_DB_07_104.a005
  is 'ȯȯģ';
comment on column T_DB_07_104.a006
  is 'ȯάֵ';
comment on column T_DB_07_104.a007
  is '֤ȯ֤ȯ';

prompt
prompt Creating table T_DB_07_D001
prompt ===========================
prompt
create table T_DB_07_D001
(
  p001 NUMBER,
  a002 VARCHAR2(255),
  z100 NUMBER
)
;
comment on column T_DB_07_D001.p001
  is 'Ŀ';
comment on column T_DB_07_D001.a002
  is 'Ŀ';
comment on column T_DB_07_D001.z100
  is 'ЧЧ';

prompt
prompt Creating table T_DB_08_001
prompt ==========================
prompt
create table T_DB_08_001
(
  p001 NUMBER not null,
  a002 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER,
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 VARCHAR2(128),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_08_001
  is 'ҵ';
comment on column T_DB_08_001.p001
  is 'Ŀ';
comment on column T_DB_08_001.a002
  is 'ǩԼͻ';
comment on column T_DB_08_001.a003
  is 'ǩԼͬܽ';
comment on column T_DB_08_001.a004
  is 'ʵֲ';
comment on column T_DB_08_001.a005
  is 'ڱۼǩԼͻ';
comment on column T_DB_08_001.a006
  is 'ڱۼǩԼͬܽ';
comment on column T_DB_08_001.a007
  is 'ڱۼʵֲ';
comment on column T_DB_08_001.a008
  is 'ע';
comment on column T_DB_08_001.a100
  is '';
comment on column T_DB_08_001.w100
  is 'ܲID';
alter table T_DB_08_001
  add constraint PK_T_DB_08_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_08_002
prompt ==========================
prompt
create table T_DB_08_002
(
  p001 NUMBER not null,
  a100 NUMBER,
  a002 VARCHAR2(128),
  w100 NUMBER not null
)
;
comment on table T_DB_08_002
  is 'ҵ񲹳';
comment on column T_DB_08_002.p001
  is 'Ŀ';
comment on column T_DB_08_002.a100
  is '';
comment on column T_DB_08_002.a002
  is 'Ŀ';
comment on column T_DB_08_002.w100
  is 'ܲID';
alter table T_DB_08_002
  add constraint PK_T_DB_08_002 primary key (P001, W100);

prompt
prompt Creating table T_DB_09_001
prompt ==========================
prompt
create table T_DB_09_001
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_09_001
  is 'ѺʽծȯعӪ';
comment on column T_DB_09_001.p001
  is 'Ŀ';
comment on column T_DB_09_001.a002
  is 'Ͻĩδڽ';
comment on column T_DB_09_001.a003
  is 'ĩδڽ';
comment on column T_DB_09_001.a004
  is 'мгĩδڽ';
comment on column T_DB_09_001.a007
  is 'Ͻ·ܶ';
comment on column T_DB_09_001.a008
  is '·ܶ';
comment on column T_DB_09_001.a009
  is 'мг·ܶ';
comment on column T_DB_09_001.a100
  is '';
comment on column T_DB_09_001.a010
  is 'ϽۼƱ귢ܶ';
comment on column T_DB_09_001.a011
  is 'ۼƱ귢ܶ';
comment on column T_DB_09_001.a012
  is 'мۼƱ귢ܶ';
comment on column T_DB_09_001.w100
  is 'ܲID';
alter table T_DB_09_001
  add constraint PK_T_DB_09_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_09_002
prompt ==========================
prompt
create table T_DB_09_002
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_09_002
  is 'Ѻʽծȯعʲ';
comment on column T_DB_09_002.p001
  is 'Ŀ';
comment on column T_DB_09_002.a002
  is 'Ͻĩδڽ';
comment on column T_DB_09_002.a003
  is 'ĩδڽ';
comment on column T_DB_09_002.a004
  is 'мгĩδڽ';
comment on column T_DB_09_002.a007
  is 'Ͻ·ܶ';
comment on column T_DB_09_002.a008
  is '·ܶ';
comment on column T_DB_09_002.a009
  is 'мг·ܶ';
comment on column T_DB_09_002.a100
  is '';
comment on column T_DB_09_002.a010
  is 'ϽۼƱ귢ܶ';
comment on column T_DB_09_002.a011
  is 'ۼƱ귢ܶ';
comment on column T_DB_09_002.a012
  is 'мۼƱ귢ܶ';
comment on column T_DB_09_002.w100
  is 'ܲID';
alter table T_DB_09_002
  add constraint PK_T_DB_09_002 primary key (P001, W100);

prompt
prompt Creating table T_DB_09_003
prompt ==========================
prompt
create table T_DB_09_003
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  w100 NUMBER not null,
  a006 NUMBER
)
;
comment on table T_DB_09_003
  is 'Ѻʽծȯعҵ';
comment on column T_DB_09_003.p001
  is 'Ŀ';
comment on column T_DB_09_003.a002
  is 'Ͻĩδڽ';
comment on column T_DB_09_003.a003
  is 'ĩδڽ';
comment on column T_DB_09_003.a004
  is 'мгĩδڽ';
comment on column T_DB_09_003.a007
  is 'Ͻ·ܶ';
comment on column T_DB_09_003.a008
  is '·ܶ';
comment on column T_DB_09_003.a009
  is 'мг·ܶ';
comment on column T_DB_09_003.a100
  is '';
comment on column T_DB_09_003.a010
  is 'ϽۼƱ귢ܶ';
comment on column T_DB_09_003.a011
  is 'ۼƱ귢ܶ';
comment on column T_DB_09_003.a012
  is 'мۼƱ귢ܶ';
comment on column T_DB_09_003.w100
  is 'ܲID';
comment on column T_DB_09_003.a006
  is 'ͻ(0Ǿҵ1Ӫ2Ϊʹ)';
alter table T_DB_09_003
  add constraint PK_T_DB_09_003 primary key (P001, W100);

prompt
prompt Creating table T_DB_10_001
prompt ==========================
prompt
create table T_DB_10_001
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_10_001
  is 'ծȯйӪ';
comment on column T_DB_10_001.p001
  is 'Ŀ';
comment on column T_DB_10_001.a002
  is 'ܶ';
comment on column T_DB_10_001.a003
  is 'Ͻ';
comment on column T_DB_10_001.a004
  is '';
comment on column T_DB_10_001.a005
  is 'мг';
comment on column T_DB_10_001.a100
  is '';
comment on column T_DB_10_001.w100
  is 'ܲID';
alter table T_DB_10_001
  add constraint PK_T_DB_10_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_10_002
prompt ==========================
prompt
create table T_DB_10_002
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_10_002
  is 'ծȯйʲ';
comment on column T_DB_10_002.p001
  is 'Ŀ';
comment on column T_DB_10_002.a002
  is 'ܶ';
comment on column T_DB_10_002.a003
  is 'Ͻ';
comment on column T_DB_10_002.a004
  is '';
comment on column T_DB_10_002.a005
  is 'мг';
comment on column T_DB_10_002.a100
  is '';
comment on column T_DB_10_002.w100
  is 'ܲID';
alter table T_DB_10_002
  add constraint PK_T_DB_10_002 primary key (P001, W100);

prompt
prompt Creating table T_DB_10_003
prompt ==========================
prompt
create table T_DB_10_003
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null,
  a006 NUMBER
)
;
comment on table T_DB_10_003
  is 'ծȯйͿͻ';
comment on column T_DB_10_003.p001
  is 'Ŀ';
comment on column T_DB_10_003.a002
  is 'ܶ';
comment on column T_DB_10_003.a003
  is 'Ͻ';
comment on column T_DB_10_003.a004
  is '';
comment on column T_DB_10_003.a005
  is 'мг';
comment on column T_DB_10_003.a100
  is '';
comment on column T_DB_10_003.w100
  is 'ܲID';
comment on column T_DB_10_003.a006
  is 'ͻ(0Ǿҵ1Ӫ2Ϊʹ)';
alter table T_DB_10_003
  add constraint PK_T_DB_10_003 primary key (P001, W100);

prompt
prompt Creating table T_DB_11_001
prompt ==========================
prompt
create table T_DB_11_001
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_11_001
  is 'ʽծȯعӪ';
comment on column T_DB_11_001.p001
  is 'Ŀ';
comment on column T_DB_11_001.a002
  is 'Ͻĩδڽ';
comment on column T_DB_11_001.a003
  is 'ĩδڽ';
comment on column T_DB_11_001.a004
  is 'мгĩδڽ';
comment on column T_DB_11_001.a007
  is 'Ͻ·ܶ';
comment on column T_DB_11_001.a008
  is '·ܶ';
comment on column T_DB_11_001.a009
  is 'мг·ܶ';
comment on column T_DB_11_001.a100
  is '';
comment on column T_DB_11_001.a010
  is 'ϽۼƱ귢ܶ';
comment on column T_DB_11_001.a011
  is 'ۼƱ귢ܶ';
comment on column T_DB_11_001.a012
  is 'мۼƱ귢ܶ';
comment on column T_DB_11_001.w100
  is 'ܲID';
alter table T_DB_11_001
  add constraint PK_T_DB_11_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_11_002
prompt ==========================
prompt
create table T_DB_11_002
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_11_002
  is 'ʽծȯعʲ';
comment on column T_DB_11_002.p001
  is 'Ŀ';
comment on column T_DB_11_002.a002
  is 'Ͻĩδڽ';
comment on column T_DB_11_002.a003
  is 'ĩδڽ';
comment on column T_DB_11_002.a004
  is 'мгĩδڽ';
comment on column T_DB_11_002.a007
  is 'Ͻ·ܶ';
comment on column T_DB_11_002.a008
  is '·ܶ';
comment on column T_DB_11_002.a009
  is 'мг·ܶ';
comment on column T_DB_11_002.a100
  is '';
comment on column T_DB_11_002.a010
  is 'ϽۼƱ귢ܶ';
comment on column T_DB_11_002.a011
  is 'ۼƱ귢ܶ';
comment on column T_DB_11_002.a012
  is 'мۼƱ귢ܶ';
comment on column T_DB_11_002.w100
  is 'ܲID';
alter table T_DB_11_002
  add constraint PK_T_DB_11_002 primary key (P001, W100);

prompt
prompt Creating table T_DB_11_003
prompt ==========================
prompt
create table T_DB_11_003
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a100 NUMBER,
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  w100 NUMBER not null,
  a006 NUMBER
)
;
comment on table T_DB_11_003
  is 'ʽծȯعͿͻ';
comment on column T_DB_11_003.p001
  is 'Ŀ';
comment on column T_DB_11_003.a002
  is 'Ͻĩδڽ';
comment on column T_DB_11_003.a003
  is 'ĩδڽ';
comment on column T_DB_11_003.a004
  is 'мгĩδڽ';
comment on column T_DB_11_003.a007
  is 'Ͻ·ܶ';
comment on column T_DB_11_003.a008
  is '·ܶ';
comment on column T_DB_11_003.a009
  is 'мг·ܶ';
comment on column T_DB_11_003.a100
  is '';
comment on column T_DB_11_003.a010
  is 'ϽۼƱ귢ܶ';
comment on column T_DB_11_003.a011
  is 'ۼƱ귢ܶ';
comment on column T_DB_11_003.a012
  is 'мۼƱ귢ܶ';
comment on column T_DB_11_003.w100
  is 'ܲID';
comment on column T_DB_11_003.a006
  is 'ͻ(0Ǿҵ1Ӫ2Ϊʹ)';
alter table T_DB_11_003
  add constraint PK_T_DB_11_003 primary key (P001, W100);

prompt
prompt Creating table T_DB_12_001
prompt ==========================
prompt
create table T_DB_12_001
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_12_001
  is 'мг';
comment on column T_DB_12_001.p001
  is 'Ŀ';
comment on column T_DB_12_001.a002
  is 'ڳ';
comment on column T_DB_12_001.a003
  is '';
comment on column T_DB_12_001.a004
  is 'ڼ';
comment on column T_DB_12_001.a006
  is 'ڱۼƷ';
comment on column T_DB_12_001.a100
  is '';
comment on column T_DB_12_001.w100
  is 'ܲID';
alter table T_DB_12_001
  add constraint PK_T_DB_12_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_12_002
prompt ==========================
prompt
create table T_DB_12_002
(
  p001 VARCHAR2(100) not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a006 NUMBER(19,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_12_002
  is 'мгȯ';
comment on column T_DB_12_002.p001
  is 'ȯID';
comment on column T_DB_12_002.a002
  is 'ڳ';
comment on column T_DB_12_002.a003
  is '';
comment on column T_DB_12_002.a004
  is 'ڼ';
comment on column T_DB_12_002.a006
  is 'ۼƷ';
comment on column T_DB_12_002.a100
  is '';
comment on column T_DB_12_002.w100
  is 'ܲID';
alter table T_DB_12_002
  add constraint PK_T_DB_12_002 primary key (P001, W100);

prompt
prompt Creating table T_DB_13_001
prompt ==========================
prompt
create table T_DB_13_001
(
  p001 VARCHAR2(16) not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a013 NUMBER(19,2),
  a100 NUMBER,
  a014 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_13_001
  is 'ϹȨ֤';
comment on column T_DB_13_001.p001
  is 'Ȩ֤ID';
comment on column T_DB_13_001.a003
  is 'ۼȨ֤';
comment on column T_DB_13_001.a004
  is 'ۼȨ֤ע';
comment on column T_DB_13_001.a005
  is 'УȨ֤ע';
comment on column T_DB_13_001.a006
  is 'ۼȨ֤';
comment on column T_DB_13_001.a007
  is 'ĩʣȨֵ֤';
comment on column T_DB_13_001.a008
  is 'ĩʣȨ֤루ʵ֣';
comment on column T_DB_13_001.a009
  is 'ĩɳ';
comment on column T_DB_13_001.a010
  is 'ĩֵ';
comment on column T_DB_13_001.a011
  is 'ĩܳɱ';
comment on column T_DB_13_001.a012
  is 'ĩϹȨ֤ռʽ';
comment on column T_DB_13_001.a013
  is 'Ȩ֤ۼʵ';
comment on column T_DB_13_001.a100
  is '';
comment on column T_DB_13_001.a014
  is 'УȨ֤ۼʵ';
comment on column T_DB_13_001.w100
  is 'ܲID';
alter table T_DB_13_001
  add constraint PK_T_DB_13_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_15_001
prompt ==========================
prompt
create table T_DB_15_001
(
  p001 NUMBER not null,
  a002 NUMBER,
  a100 NUMBER,
  a003 NUMBER,
  a004 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_15_001
  is 'Ϊڻ˾ṩмҵ-ҵ';
comment on column T_DB_15_001.p001
  is '"Ŀ
"';
comment on column T_DB_15_001.a002
  is 'ڳ';
comment on column T_DB_15_001.a100
  is '';
comment on column T_DB_15_001.a003
  is '';
comment on column T_DB_15_001.a004
  is 'ڼ';
comment on column T_DB_15_001.w100
  is 'ܲID';
alter table T_DB_15_001
  add constraint PK_DB_15_001 primary key (P001, W100);

prompt
prompt Creating table T_DB_15_002
prompt ==========================
prompt
create table T_DB_15_002
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a100 NUMBER,
  a003 NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_DB_15_002
  is 'Ϊڻ˾ṩмҵ-Ӷ';
comment on column T_DB_15_002.p001
  is 'Ŀ';
comment on column T_DB_15_002.a002
  is 'ڷ';
comment on column T_DB_15_002.a100
  is '';
comment on column T_DB_15_002.a003
  is 'ڱۼ';
comment on column T_DB_15_002.w100
  is 'ܲID';
alter table T_DB_15_002
  add constraint PK_DB_15_002 primary key (P001, W100);

prompt
prompt Creating table T_DB_30_001
prompt ==========================
prompt
create table T_DB_30_001
(
  p001 NUMBER not null,
  a002 NUMBER(19,2),
  a003 NUMBER(19,2),
  w100 NUMBER,
  a100 NUMBER
)
;
comment on table T_DB_30_001
  is 'Ϊȯݱ';
comment on column T_DB_30_001.p001
  is 'ĿID';
comment on column T_DB_30_001.a002
  is '';
comment on column T_DB_30_001.a003
  is '';
comment on column T_DB_30_001.w100
  is 'ID';
comment on column T_DB_30_001.a100
  is '';

prompt
prompt Creating table T_DB_30_002
prompt ==========================
prompt
create table T_DB_30_002
(
  p001 NUMBER not null,
  a001 VARCHAR2(255),
  w100 NUMBER,
  a100 NUMBER
)
;
comment on table T_DB_30_002
  is 'ȯעݱ';

prompt
prompt Creating table T_DB_31_03
prompt =========================
prompt
create table T_DB_31_03
(
  p001 VARCHAR2(100) not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  w100 NUMBER
)
;
comment on table T_DB_31_03
  is '뽻ⲿϢϵͳ漰˻';
comment on column T_DB_31_03.p001
  is 'ͻʽ˻';
comment on column T_DB_31_03.a002
  is 'ͻʽ˻Ԫ';
comment on column T_DB_31_03.a003
  is 'ͻʲԪ';
comment on column T_DB_31_03.a004
  is '½Ԫ';
comment on column T_DB_31_03.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_31_04
prompt =========================
prompt
create table T_DB_31_04
(
  p001 VARCHAR2(100) not null,
  a002 NUMBER(18,2),
  w100 NUMBER
)
;
comment on table T_DB_31_04
  is '뽻ⲿϢϵͳ漰˻ϸ';
comment on column T_DB_31_04.p001
  is '֤ȯʻ';
comment on column T_DB_31_04.a002
  is 'ĩֵϼƣԪ';
comment on column T_DB_31_04.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_50_001
prompt ==========================
prompt
create table T_DB_50_001
(
  p001 NUMBER,
  a002 NUMBER,
  a003 NUMBER(19,2),
  a004 NUMBER,
  a005 NUMBER(19,2),
  a006 NUMBER,
  a007 NUMBER(19,2),
  a008 NUMBER,
  a009 NUMBER(19,2),
  a010 NUMBER,
  a011 NUMBER(19,2),
  a099 VARCHAR2(255),
  a100 NUMBER,
  w100 NUMBER,
  a012 NUMBER(19,2)
)
;
comment on table T_DB_50_001
  is '֤ȯ˾۽ڲƷͳƱ';

prompt
prompt Creating table T_DB_50_D001
prompt ===========================
prompt
create table T_DB_50_D001
(
  p001 NUMBER,
  a002 VARCHAR2(255),
  z100 NUMBER
)
;
comment on table T_DB_50_D001
  is '֤ȯ˾۽ڲƷͳƱ-ֵ';
comment on column T_DB_50_D001.p001
  is 'Ŀ';
comment on column T_DB_50_D001.a002
  is 'Ŀ';
comment on column T_DB_50_D001.z100
  is 'ЧЧ';

prompt
prompt Creating table T_DB_61_001
prompt ==========================
prompt
create table T_DB_61_001
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_61_001
  is 'Ѻʽۻعױ';
comment on column T_DB_61_001.p001
  is 'Ŀ';
comment on column T_DB_61_001.a002
  is 'ڳ';
comment on column T_DB_61_001.a003
  is '';
comment on column T_DB_61_001.a004
  is 'ڼ';
comment on column T_DB_61_001.a005
  is 'ĩ';
comment on column T_DB_61_001.a100
  is '';
comment on column T_DB_61_001.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_61_002
prompt ==========================
prompt
create table T_DB_61_002
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_61_002
  is 'Ѻʽۻعױۼҵģ';
comment on column T_DB_61_002.p001
  is 'Ŀ';
comment on column T_DB_61_002.a002
  is '';
comment on column T_DB_61_002.a003
  is 'ڱۼ';
comment on column T_DB_61_002.a100
  is '';
comment on column T_DB_61_002.w100
  is 'ܲID';
alter table T_DB_61_002
  add constraint PK_T_DB_61_002 primary key (P001, W100, A100);

prompt
prompt Creating table T_DB_61_003
prompt ==========================
prompt
create table T_DB_61_003
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER not null,
  w100 NUMBER not null
)
;
comment on table T_DB_61_003
  is 'Ѻʽۻعױعʣ';
comment on column T_DB_61_003.p001
  is 'Ŀ';
comment on column T_DB_61_003.a002
  is '';
comment on column T_DB_61_003.a003
  is '';
comment on column T_DB_61_003.a100
  is '';
comment on column T_DB_61_003.w100
  is 'ܲID';
alter table T_DB_61_003
  add constraint PK_T_DB_61_003 primary key (P001, W100, A100);

prompt
prompt Creating table T_DB_62_001
prompt ==========================
prompt
create table T_DB_62_001
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_62_001
  is 'Լʽױ';
comment on column T_DB_62_001.p001
  is 'Ŀ';
comment on column T_DB_62_001.a002
  is 'ڳ';
comment on column T_DB_62_001.a003
  is '';
comment on column T_DB_62_001.a004
  is 'ڼ';
comment on column T_DB_62_001.a005
  is 'ĩ';
comment on column T_DB_62_001.a100
  is '';
comment on column T_DB_62_001.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_62_002
prompt ==========================
prompt
create table T_DB_62_002
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_62_002
  is 'Լʽױۼҵģ';
comment on column T_DB_62_002.p001
  is 'Ŀ';
comment on column T_DB_62_002.a002
  is '';
comment on column T_DB_62_002.a003
  is 'ڱۼ';
comment on column T_DB_62_002.a100
  is '';
comment on column T_DB_62_002.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_62_003
prompt ==========================
prompt
create table T_DB_62_003
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_62_003
  is 'Լʽױعʣ';
comment on column T_DB_62_003.p001
  is 'Ŀ';
comment on column T_DB_62_003.a002
  is '';
comment on column T_DB_62_003.a003
  is '';
comment on column T_DB_62_003.a100
  is '';
comment on column T_DB_62_003.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_62_004
prompt ==========================
prompt
create table T_DB_62_004
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_62_004
  is 'Լʽױؽ׽ǰ5';
comment on column T_DB_62_004.p001
  is 'ͻID';
comment on column T_DB_62_004.a002
  is 'ͻ';
comment on column T_DB_62_004.a003
  is 'ؽ';
comment on column T_DB_62_004.a004
  is '֤ȯֵ';
comment on column T_DB_62_004.a005
  is 'Լϱ';
comment on column T_DB_62_004.a006
  is 'ռʱ';
comment on column T_DB_62_004.a100
  is '';
comment on column T_DB_62_004.w100
  is 'ܲID';
comment on column T_DB_62_004.pm
  is '';
alter table T_DB_62_004
  add constraint PK_T_DB_62_004 primary key (PM, W100);

prompt
prompt Creating table T_DB_62_005
prompt ==========================
prompt
create table T_DB_62_005
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_62_005
  is 'Լʽױعֵǰ5';
comment on column T_DB_62_005.p001
  is '֤ȯ';
comment on column T_DB_62_005.a002
  is '֤ȯ';
comment on column T_DB_62_005.a003
  is '֤ȯ';
comment on column T_DB_62_005.a004
  is '֤ȯֵ';
comment on column T_DB_62_005.a005
  is 'ռܹɱ';
comment on column T_DB_62_005.a006
  is 'ռʱ';
comment on column T_DB_62_005.a100
  is '';
comment on column T_DB_62_005.w100
  is 'ܲID';
comment on column T_DB_62_005.pm
  is '';
alter table T_DB_62_005
  add constraint PK_T_DB_62_005 primary key (PM, W100);

prompt
prompt Creating table T_DB_63_001
prompt ==========================
prompt
create table T_DB_63_001
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_63_001
  is 'ƱѺʽعױ';
comment on column T_DB_63_001.p001
  is 'Ŀ';
comment on column T_DB_63_001.a002
  is 'ڳ';
comment on column T_DB_63_001.a003
  is '';
comment on column T_DB_63_001.a004
  is 'ڼ';
comment on column T_DB_63_001.a005
  is 'ĩ';
comment on column T_DB_63_001.a100
  is '';
comment on column T_DB_63_001.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_001_RH
prompt =============================
prompt
create table T_DB_63_001_RH
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
nologging;
comment on table T_DB_63_001_RH
  is 'ƱѺʽعױ';
comment on column T_DB_63_001_RH.p001
  is 'Ŀ';
comment on column T_DB_63_001_RH.a002
  is 'ڳ';
comment on column T_DB_63_001_RH.a003
  is '';
comment on column T_DB_63_001_RH.a004
  is 'ڼ';
comment on column T_DB_63_001_RH.a005
  is 'ĩ';
comment on column T_DB_63_001_RH.a100
  is '';
comment on column T_DB_63_001_RH.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_001_ZYZJ
prompt ===============================
prompt
create table T_DB_63_001_ZYZJ
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
nologging;
comment on table T_DB_63_001_ZYZJ
  is 'ƱѺʽعױ';
comment on column T_DB_63_001_ZYZJ.p001
  is 'Ŀ';
comment on column T_DB_63_001_ZYZJ.a002
  is 'ڳ';
comment on column T_DB_63_001_ZYZJ.a003
  is '';
comment on column T_DB_63_001_ZYZJ.a004
  is 'ڼ';
comment on column T_DB_63_001_ZYZJ.a005
  is 'ĩ';
comment on column T_DB_63_001_ZYZJ.a100
  is '';
comment on column T_DB_63_001_ZYZJ.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_002
prompt ==========================
prompt
create table T_DB_63_002
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_63_002
  is 'ƱѺʽعױۼҵģ';
comment on column T_DB_63_002.p001
  is 'Ŀ';
comment on column T_DB_63_002.a002
  is '';
comment on column T_DB_63_002.a003
  is 'ڱۼ';
comment on column T_DB_63_002.a100
  is '';
comment on column T_DB_63_002.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_002_RH
prompt =============================
prompt
create table T_DB_63_002_RH
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
nologging;
comment on table T_DB_63_002_RH
  is 'ƱѺʽعױۼҵģ';
comment on column T_DB_63_002_RH.p001
  is 'Ŀ';
comment on column T_DB_63_002_RH.a002
  is '';
comment on column T_DB_63_002_RH.a003
  is 'ڱۼ';
comment on column T_DB_63_002_RH.a100
  is '';
comment on column T_DB_63_002_RH.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_002_ZYZJ
prompt ===============================
prompt
create table T_DB_63_002_ZYZJ
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
nologging;
comment on table T_DB_63_002_ZYZJ
  is 'ƱѺʽعױۼҵģ';
comment on column T_DB_63_002_ZYZJ.p001
  is 'Ŀ';
comment on column T_DB_63_002_ZYZJ.a002
  is '';
comment on column T_DB_63_002_ZYZJ.a003
  is 'ڱۼ';
comment on column T_DB_63_002_ZYZJ.a100
  is '';
comment on column T_DB_63_002_ZYZJ.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_003
prompt ==========================
prompt
create table T_DB_63_003
(
  p001 NUMBER not null,
  a002 NUMBER(18,3),
  a003 NUMBER(18,3),
  a100 NUMBER,
  w100 NUMBER not null
)
;
comment on table T_DB_63_003
  is 'ƱѺʽعױعʣ';
comment on column T_DB_63_003.p001
  is 'Ŀ';
comment on column T_DB_63_003.a002
  is '';
comment on column T_DB_63_003.a003
  is '';
comment on column T_DB_63_003.a100
  is '';
comment on column T_DB_63_003.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_003_RH
prompt =============================
prompt
create table T_DB_63_003_RH
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
nologging;
comment on table T_DB_63_003_RH
  is 'ƱѺʽعױعʣ';
comment on column T_DB_63_003_RH.p001
  is 'Ŀ';
comment on column T_DB_63_003_RH.a002
  is '';
comment on column T_DB_63_003_RH.a003
  is '';
comment on column T_DB_63_003_RH.a100
  is '';
comment on column T_DB_63_003_RH.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_003_ZYZJ
prompt ===============================
prompt
create table T_DB_63_003_ZYZJ
(
  p001 NUMBER not null,
  a002 NUMBER(18,2),
  a003 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null
)
nologging;
comment on table T_DB_63_003_ZYZJ
  is 'ƱѺʽعױعʣ';
comment on column T_DB_63_003_ZYZJ.p001
  is 'Ŀ';
comment on column T_DB_63_003_ZYZJ.a002
  is '';
comment on column T_DB_63_003_ZYZJ.a003
  is '';
comment on column T_DB_63_003_ZYZJ.a100
  is '';
comment on column T_DB_63_003_ZYZJ.w100
  is 'ܲID';

prompt
prompt Creating table T_DB_63_004
prompt ==========================
prompt
create table T_DB_63_004
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_63_004
  is 'ƱѺʽعױؽ׽ǰ5';
comment on column T_DB_63_004.p001
  is 'ͻID';
comment on column T_DB_63_004.a002
  is 'ͻ';
comment on column T_DB_63_004.a003
  is 'ؽ';
comment on column T_DB_63_004.a004
  is '֤ȯֵ';
comment on column T_DB_63_004.a005
  is 'Լϱ';
comment on column T_DB_63_004.a006
  is 'ռʱ';
comment on column T_DB_63_004.a100
  is '';
comment on column T_DB_63_004.w100
  is 'ܲID';
comment on column T_DB_63_004.pm
  is '';
alter table T_DB_63_004
  add constraint PK_T_DB_63_004 primary key (PM, W100);

prompt
prompt Creating table T_DB_63_004_RH
prompt =============================
prompt
create table T_DB_63_004_RH
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_63_004_RH
  is 'ƱѺʽعױؽ׽ǰ5';
comment on column T_DB_63_004_RH.p001
  is 'ͻID';
comment on column T_DB_63_004_RH.a002
  is 'ͻ';
comment on column T_DB_63_004_RH.a003
  is 'ؽ';
comment on column T_DB_63_004_RH.a004
  is '֤ȯֵ';
comment on column T_DB_63_004_RH.a005
  is 'Լϱ';
comment on column T_DB_63_004_RH.a006
  is 'ռʱ';
comment on column T_DB_63_004_RH.a100
  is '';
comment on column T_DB_63_004_RH.w100
  is 'ܲID';
comment on column T_DB_63_004_RH.pm
  is '';
alter table T_DB_63_004_RH
  add constraint PK_T_DB_63_004_RH primary key (PM, W100);

prompt
prompt Creating table T_DB_63_004_ZYZJ
prompt ===============================
prompt
create table T_DB_63_004_ZYZJ
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18,2),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_63_004_ZYZJ
  is 'ƱѺʽعױؽ׽ǰ5';
comment on column T_DB_63_004_ZYZJ.p001
  is 'ͻID';
comment on column T_DB_63_004_ZYZJ.a002
  is 'ͻ';
comment on column T_DB_63_004_ZYZJ.a003
  is 'ؽ';
comment on column T_DB_63_004_ZYZJ.a004
  is '֤ȯֵ';
comment on column T_DB_63_004_ZYZJ.a005
  is 'Լϱ';
comment on column T_DB_63_004_ZYZJ.a006
  is 'ռʱ';
comment on column T_DB_63_004_ZYZJ.a100
  is '';
comment on column T_DB_63_004_ZYZJ.w100
  is 'ܲID';
comment on column T_DB_63_004_ZYZJ.pm
  is '';

prompt
prompt Creating table T_DB_63_005
prompt ==========================
prompt
create table T_DB_63_005
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_63_005
  is 'ƱѺʽعױعֵǰ5';
comment on column T_DB_63_005.p001
  is '֤ȯ';
comment on column T_DB_63_005.a002
  is '֤ȯ';
comment on column T_DB_63_005.a003
  is '֤ȯ';
comment on column T_DB_63_005.a004
  is '֤ȯֵ';
comment on column T_DB_63_005.a005
  is 'ռܹɱ';
comment on column T_DB_63_005.a006
  is 'ռʱ';
comment on column T_DB_63_005.a100
  is '';
comment on column T_DB_63_005.w100
  is 'ܲID';
comment on column T_DB_63_005.pm
  is 'NUMBER';
alter table T_DB_63_005
  add constraint PK_T_DB_63_005 primary key (PM, W100);

prompt
prompt Creating table T_DB_63_005_RH
prompt =============================
prompt
create table T_DB_63_005_RH
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_63_005_RH
  is 'ƱѺʽعױعֵǰ5';
comment on column T_DB_63_005_RH.p001
  is '֤ȯ';
comment on column T_DB_63_005_RH.a002
  is '֤ȯ';
comment on column T_DB_63_005_RH.a003
  is '֤ȯ';
comment on column T_DB_63_005_RH.a004
  is '֤ȯֵ';
comment on column T_DB_63_005_RH.a005
  is 'ռܹɱ';
comment on column T_DB_63_005_RH.a006
  is 'ռʱ';
comment on column T_DB_63_005_RH.a100
  is '';
comment on column T_DB_63_005_RH.w100
  is 'ܲID';
comment on column T_DB_63_005_RH.pm
  is 'NUMBER';
alter table T_DB_63_005_RH
  add constraint PK_T_DB_63_005_RH primary key (PM, W100);

prompt
prompt Creating table T_DB_63_005_ZYZJ
prompt ===============================
prompt
create table T_DB_63_005_ZYZJ
(
  p001 VARCHAR2(32),
  a002 VARCHAR2(64),
  a003 NUMBER(18),
  a004 NUMBER(18,2),
  a005 NUMBER(18,2),
  a006 NUMBER(18,2),
  a100 NUMBER,
  w100 NUMBER not null,
  pm   NUMBER not null
)
;
comment on table T_DB_63_005_ZYZJ
  is 'ƱѺʽعױعֵǰ5';
comment on column T_DB_63_005_ZYZJ.p001
  is '֤ȯ';
comment on column T_DB_63_005_ZYZJ.a002
  is '֤ȯ';
comment on column T_DB_63_005_ZYZJ.a003
  is '֤ȯ';
comment on column T_DB_63_005_ZYZJ.a004
  is '֤ȯֵ';
comment on column T_DB_63_005_ZYZJ.a005
  is 'ռܹɱ';
comment on column T_DB_63_005_ZYZJ.a006
  is 'ռʱ';
comment on column T_DB_63_005_ZYZJ.a100
  is '';
comment on column T_DB_63_005_ZYZJ.w100
  is 'ܲID';
comment on column T_DB_63_005_ZYZJ.pm
  is 'NUMBER';
alter table T_DB_63_005_ZYZJ
  add constraint PK_T_DB_63_005_ZYZJ primary key (PM, W100);

prompt
prompt Creating table T_DB_B1_01
prompt =========================
prompt
create table T_DB_B1_01
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2)
)
;
comment on table T_DB_B1_01
  is 'ʲծ״';
comment on column T_DB_B1_01.p001
  is 'ӪҵID';
comment on column T_DB_B1_01.p002
  is 'Ŀ';
comment on column T_DB_B1_01.a003
  is 'ĩ';
comment on column T_DB_B1_01.a004
  is '';
alter table T_DB_B1_01
  add constraint PK_T_DB_B1_01 primary key (P001, P002);

prompt
prompt Creating table T_DB_B1_02
prompt =========================
prompt
create table T_DB_B1_02
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2)
)
;
comment on table T_DB_B1_02
  is '';
comment on column T_DB_B1_02.p001
  is 'ӪҵID';
comment on column T_DB_B1_02.p002
  is 'Ŀ';
comment on column T_DB_B1_02.a003
  is 'ڽ';
comment on column T_DB_B1_02.a004
  is 'ڱۼƽ';
alter table T_DB_B1_02
  add constraint PK_T_DB_B1_02 primary key (P001, P002);

prompt
prompt Creating table T_DB_B1_03
prompt =========================
prompt
create table T_DB_B1_03
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 VARCHAR2(255)
)
;
comment on table T_DB_B1_03
  is 'ʲע';
comment on column T_DB_B1_03.p001
  is 'ӪҵID';
comment on column T_DB_B1_03.p002
  is 'ĿID';
comment on column T_DB_B1_03.a003
  is 'Ŀ';
alter table T_DB_B1_03
  add constraint PK_T_DB_B1_03 primary key (P001, P002);

prompt
prompt Creating table T_DB_B1_D001
prompt ===========================
prompt
create table T_DB_B1_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(64),
  a003 NUMBER,
  a004 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_DB_B1_D001
  is 'ʲֵ';
comment on column T_DB_B1_D001.p001
  is 'ĿID';
comment on column T_DB_B1_D001.a002
  is 'Ŀ';
comment on column T_DB_B1_D001.a003
  is '';
comment on column T_DB_B1_D001.a004
  is '־';
comment on column T_DB_B1_D001.c100
  is 'ǰ׺';
comment on column T_DB_B1_D001.d100
  is '׺';
comment on column T_DB_B1_D001.e100
  is '';
alter table T_DB_B1_D001
  add constraint PK_T_DB_B1_D001 primary key (P001);

prompt
prompt Creating table T_DB_B2_01
prompt =========================
prompt
create table T_DB_B2_01
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 VARCHAR2(255)
)
;
comment on table T_DB_B2_01
  is 'ʽʲ';
comment on column T_DB_B2_01.p001
  is 'ӪҵID';
comment on column T_DB_B2_01.p002
  is 'Ŀ';
comment on column T_DB_B2_01.a003
  is 'ĩ';
comment on column T_DB_B2_01.a004
  is 'ڳ';
comment on column T_DB_B2_01.a005
  is 'ע';
alter table T_DB_B2_01
  add constraint PK_T_DB_B2_01 primary key (P001, P002);

prompt
prompt Creating table T_DB_B2_02
prompt =========================
prompt
create table T_DB_B2_02
(
  p001 NUMBER not null,
  p002 VARCHAR2(10) not null,
  a003 VARCHAR2(24) not null,
  a004 NUMBER,
  a005 NUMBER(19,2),
  a006 NUMBER,
  a007 NUMBER(19,2),
  a100 VARCHAR2(255)
)
;
comment on table T_DB_B2_02
  is 'ʽֲ';
comment on column T_DB_B2_02.p001
  is 'ӪҵID';
comment on column T_DB_B2_02.p002
  is 'д';
comment on column T_DB_B2_02.a003
  is '';
comment on column T_DB_B2_02.a004
  is 'ڳͻ';
comment on column T_DB_B2_02.a005
  is 'ڳʽ';
comment on column T_DB_B2_02.a006
  is 'ĩͻ';
comment on column T_DB_B2_02.a007
  is 'ĩʽ';
comment on column T_DB_B2_02.a100
  is 'ע';
alter table T_DB_B2_02
  add constraint PK_T_DB_B2_02 primary key (P001, P002);

prompt
prompt Creating table T_DB_B2_D001
prompt ===========================
prompt
create table T_DB_B2_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(42),
  a003 NUMBER,
  a004 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on column T_DB_B2_D001.p001
  is 'ĿID';
comment on column T_DB_B2_D001.a002
  is 'Ŀ';
comment on column T_DB_B2_D001.a003
  is '';
comment on column T_DB_B2_D001.a004
  is '־';
comment on column T_DB_B2_D001.c100
  is 'ǰ׺';
comment on column T_DB_B2_D001.d100
  is '׺';
comment on column T_DB_B2_D001.e100
  is '';
alter table T_DB_B2_D001
  add constraint T_DB_B2_D001_PK primary key (P001);

prompt
prompt Creating table T_DB_B3_01
prompt =========================
prompt
create table T_DB_B3_01
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(10),
  a005 VARCHAR2(255)
)
;
comment on table T_DB_B3_01
  is 'ʽ˻';
comment on column T_DB_B3_01.p001
  is 'ӪҵID';
comment on column T_DB_B3_01.p002
  is 'Ŀ';
comment on column T_DB_B3_01.a003
  is '';
comment on column T_DB_B3_01.a005
  is 'ע';
alter table T_DB_B3_01
  add constraint PK_T_DB_B3_01 primary key (P001, P002);

prompt
prompt Creating table T_DB_B3_02
prompt =========================
prompt
create table T_DB_B3_02
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(10),
  a004 NUMBER(10),
  a005 VARCHAR2(255)
)
;
comment on table T_DB_B3_02
  is '֤ȯ˻';
comment on column T_DB_B3_02.p001
  is 'ӪҵID';
comment on column T_DB_B3_02.p002
  is 'Ŀ';
comment on column T_DB_B3_02.a003
  is 'Aɣ';
comment on column T_DB_B3_02.a004
  is 'Bɣ';
comment on column T_DB_B3_02.a005
  is 'ע';
alter table T_DB_B3_02
  add constraint PK_T_DB_B3_02 primary key (P001, P002);

prompt
prompt Creating table T_DB_B3_03
prompt =========================
prompt
create table T_DB_B3_03
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(10),
  a004 VARCHAR2(255)
)
;
comment on table T_DB_B3_03
  is '˻';
comment on column T_DB_B3_03.p001
  is 'ӪҵID';
comment on column T_DB_B3_03.p002
  is 'Ŀ';
comment on column T_DB_B3_03.a003
  is 'Aɣ';
comment on column T_DB_B3_03.a004
  is 'ע';
alter table T_DB_B3_03
  add constraint PK_T_DB_B3_03 primary key (P001, P002);

prompt
prompt Creating table T_DB_B3_04
prompt =========================
prompt
create table T_DB_B3_04
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 VARCHAR2(255)
)
;
comment on table T_DB_B3_04
  is '˻淶';
comment on column T_DB_B3_04.p001
  is 'ӪҵID';
comment on column T_DB_B3_04.p002
  is 'Ŀ';
comment on column T_DB_B3_04.a003
  is '';
comment on column T_DB_B3_04.a004
  is 'ͻ׽ʽ';
comment on column T_DB_B3_04.a005
  is 'ĩָй֤ȯֵ';
comment on column T_DB_B3_04.a006
  is 'ע';
alter table T_DB_B3_04
  add constraint PK_T_DB_B3_04 primary key (P001, P002);

prompt
prompt Creating table T_DB_B3_05
prompt =========================
prompt
create table T_DB_B3_05
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 VARCHAR2(255)
)
;
comment on table T_DB_B3_05
  is '˻䶯';
comment on column T_DB_B3_05.p001
  is 'ӪҵID';
comment on column T_DB_B3_05.p002
  is 'Ŀ';
comment on column T_DB_B3_05.a003
  is '';
comment on column T_DB_B3_05.a004
  is 'ڹ淶';
comment on column T_DB_B3_05.a005
  is 'ڼ/ָף';
comment on column T_DB_B3_05.a006
  is 'ע';
comment on column T_DB_B3_05.a007
  is 'ע';
alter table T_DB_B3_05
  add constraint PK_T_DB_B3_05 primary key (P001, P002);

prompt
prompt Creating table T_DB_B3_D001
prompt ===========================
prompt
create table T_DB_B3_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32),
  a003 NUMBER,
  a004 VARCHAR2(8),
  a099 NUMBER
)
;
comment on table T_DB_B3_D001
  is '˻Ŀֵ';
comment on column T_DB_B3_D001.p001
  is 'ĿID';
comment on column T_DB_B3_D001.a002
  is 'Ŀ';
comment on column T_DB_B3_D001.a003
  is '';
comment on column T_DB_B3_D001.a004
  is '־';
alter table T_DB_B3_D001
  add constraint PK_T_DB_B3_D001 primary key (P001);

prompt
prompt Creating table T_DB_B4_01
prompt =========================
prompt
create table T_DB_B4_01
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2)
)
;
comment on table T_DB_B4_01
  is 'Ӫҵ֤ȯ';
comment on column T_DB_B4_01.p001
  is 'ӪҵID';
comment on column T_DB_B4_01.p002
  is 'Ŀ';
comment on column T_DB_B4_01.a003
  is '֤ȯױڽ';
comment on column T_DB_B4_01.a004
  is '֤ȯۼƽ';
comment on column T_DB_B4_01.a005
  is 'ѱ';
comment on column T_DB_B4_01.a006
  is 'ۼ';
comment on column T_DB_B4_01.a007
  is 'ĩָй֤ȯֵ';
alter table T_DB_B4_01
  add constraint PK_T_DB_B4_01 primary key (P001, P002);

prompt
prompt Creating table T_DB_B4_01_20190904
prompt ==================================
prompt
create table T_DB_B4_01_20190904
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2)
)
;

prompt
prompt Creating table T_DB_B4_01_20200106
prompt ==================================
prompt
create table T_DB_B4_01_20200106
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2)
)
;

prompt
prompt Creating table T_DB_B4_02
prompt =========================
prompt
create table T_DB_B4_02
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2)
)
;
comment on table T_DB_B4_02
  is 'Ӫҵɷݽ';
comment on column T_DB_B4_02.p001
  is 'ӪҵID';
comment on column T_DB_B4_02.p002
  is 'Ŀ';
comment on column T_DB_B4_02.a003
  is 'ڽ׽--';
comment on column T_DB_B4_02.a004
  is 'ڽ׽--۱';
comment on column T_DB_B4_02.a005
  is 'ڽ׽--Ԫ';
comment on column T_DB_B4_02.a006
  is 'ڱۼƽ--';
comment on column T_DB_B4_02.a007
  is 'ڱۼƽ--۱';
comment on column T_DB_B4_02.a008
  is 'ڱۼƽ--Ԫ';

prompt
prompt Creating table T_DB_B4_02_20190904
prompt ==================================
prompt
create table T_DB_B4_02_20190904
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2)
)
;

prompt
prompt Creating table T_DB_B4_02_20200106
prompt ==================================
prompt
create table T_DB_B4_02_20200106
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2)
)
;

prompt
prompt Creating table T_DB_B4_03
prompt =========================
prompt
create table T_DB_B4_03
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a013 NUMBER(19,2),
  a014 NUMBER(19,2)
)
;
comment on table T_DB_B4_03
  is 'Ӫҵֳױ';
comment on column T_DB_B4_03.p001
  is 'ӪҵID';
comment on column T_DB_B4_03.p002
  is 'Ŀ';
comment on column T_DB_B4_03.a003
  is '֤ȯ()';
comment on column T_DB_B4_03.a004
  is '֤ȯԪ()';
comment on column T_DB_B4_03.a005
  is '֤ȯ׸۱()';
comment on column T_DB_B4_03.a006
  is '֤ȯ(ڱۼ)';
comment on column T_DB_B4_03.a007
  is '֤ȯԪ(ڱۼ)';
comment on column T_DB_B4_03.a008
  is '֤ȯ׸۱(ڱۼ)';
comment on column T_DB_B4_03.a009
  is '()';
comment on column T_DB_B4_03.a010
  is 'Ԫ()';
comment on column T_DB_B4_03.a011
  is 'Ѹ۱()';
comment on column T_DB_B4_03.a012
  is '(ڱۼ)';
comment on column T_DB_B4_03.a013
  is 'Ԫ(ڱۼ)';
comment on column T_DB_B4_03.a014
  is 'Ѹ۱(ڱۼ)';
alter table T_DB_B4_03
  add constraint PK_T_DB_B4_03 primary key (P001, P002);

prompt
prompt Creating table T_DB_B4_03_20190904
prompt ==================================
prompt
create table T_DB_B4_03_20190904
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a013 NUMBER(19,2),
  a014 NUMBER(19,2)
)
;

prompt
prompt Creating table T_DB_B4_03_20200106
prompt ==================================
prompt
create table T_DB_B4_03_20200106
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a013 NUMBER(19,2),
  a014 NUMBER(19,2)
)
;

prompt
prompt Creating table T_DB_B4_04
prompt =========================
prompt
create table T_DB_B4_04
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 VARCHAR2(255)
)
;
comment on table T_DB_B4_04
  is 'ʲע';
comment on column T_DB_B4_04.p001
  is 'ӪҵID';
comment on column T_DB_B4_04.p002
  is 'ĿID';
comment on column T_DB_B4_04.a003
  is 'Ŀ';
alter table T_DB_B4_04
  add constraint PK_T_DB_B4_04 primary key (P001, P002);

prompt
prompt Creating table T_DB_B4_D001
prompt ===========================
prompt
create table T_DB_B4_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a003 NUMBER not null,
  a004 VARCHAR2(8)
)
;
comment on table T_DB_B4_D001
  is 'ӪҵĿֵ';
comment on column T_DB_B4_D001.p001
  is 'ĿID';
comment on column T_DB_B4_D001.a002
  is 'Ŀ';
comment on column T_DB_B4_D001.a003
  is '';
comment on column T_DB_B4_D001.a004
  is '־';
alter table T_DB_B4_D001
  add constraint PK_T_DB_B4_D001 primary key (P001)
  disable
  novalidate;

prompt
prompt Creating table T_DB_B50_01
prompt ==========================
prompt
create table T_DB_B50_01
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a099 VARCHAR2(255)
)
;
comment on table T_DB_B50_01
  is 'Ӫҵ۽ڲƷͳƱ';
comment on column T_DB_B50_01.p001
  is 'ӪҵID';
comment on column T_DB_B50_01.p002
  is 'Ŀ';
comment on column T_DB_B50_01.a003
  is '';
comment on column T_DB_B50_01.a004
  is 'ӽ';
comment on column T_DB_B50_01.a005
  is 'ڱۼ';
comment on column T_DB_B50_01.a006
  is 'ڱۼӽ';
comment on column T_DB_B50_01.a007
  is '¼';
comment on column T_DB_B50_01.a008
  is '¼ٽ';
comment on column T_DB_B50_01.a009
  is 'ڱۼƼ';
comment on column T_DB_B50_01.a010
  is 'ڱۼƼٽ';
comment on column T_DB_B50_01.a011
  is 'ĩ';
comment on column T_DB_B50_01.a012
  is 'ĩ';
comment on column T_DB_B50_01.a099
  is 'ע';
alter table T_DB_B50_01
  add constraint ӪҵA5_1ID primary key (P001, P002);

prompt
prompt Creating table T_DB_B50_01_20190904
prompt ===================================
prompt
create table T_DB_B50_01_20190904
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a099 VARCHAR2(255)
)
;

prompt
prompt Creating table T_DB_B50_01_20200106
prompt ===================================
prompt
create table T_DB_B50_01_20200106
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 NUMBER(19,2),
  a008 NUMBER(19,2),
  a009 NUMBER(19,2),
  a010 NUMBER(19,2),
  a011 NUMBER(19,2),
  a012 NUMBER(19,2),
  a099 VARCHAR2(255)
)
;

prompt
prompt Creating table T_DB_B5_01
prompt =========================
prompt
create table T_DB_B5_01
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  a003 NUMBER(19,2),
  a004 NUMBER(19,2),
  a005 NUMBER(19,2),
  a006 NUMBER(19,2),
  a007 VARCHAR2(255)
)
;
comment on table T_DB_B5_01
  is '۲Ʒ';
comment on column T_DB_B5_01.p001
  is 'ӪҵID';
comment on column T_DB_B5_01.p002
  is 'Ŀ';
comment on column T_DB_B5_01.a003
  is 'ڽ';
comment on column T_DB_B5_01.a004
  is '';
comment on column T_DB_B5_01.a005
  is 'ۼƽ';
comment on column T_DB_B5_01.a006
  is 'ۼ';
comment on column T_DB_B5_01.a007
  is 'ע';
alter table T_DB_B5_01
  add constraint ӪҵID primary key (P001, P002);

prompt
prompt Creating table T_DB_B5_D001
prompt ===========================
prompt
create table T_DB_B5_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(32) not null,
  a003 NUMBER,
  a004 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_DB_B5_D001
  is '۲Ʒֵ';
comment on column T_DB_B5_D001.p001
  is 'ĿID';
comment on column T_DB_B5_D001.a002
  is 'Ŀ';
comment on column T_DB_B5_D001.a003
  is '';
comment on column T_DB_B5_D001.a004
  is '־';
comment on column T_DB_B5_D001.c100
  is 'ǰ׺';
comment on column T_DB_B5_D001.d100
  is '׺';
comment on column T_DB_B5_D001.e100
  is '';
alter table T_DB_B5_D001
  add constraint ĿID primary key (P001);

prompt
prompt Creating table T_DB_B_R_001
prompt ===========================
prompt
create table T_DB_B_R_001
(
  p001 NUMBER not null,
  a002 VARCHAR2(100) not null,
  a003 NUMBER not null,
  a004 VARCHAR2(100)
)
;
comment on table T_DB_B_R_001
  is 'ӪҵȯרܱĿֵ';
comment on column T_DB_B_R_001.p001
  is 'Ŀ';
comment on column T_DB_B_R_001.a002
  is 'Ŀ';
comment on column T_DB_B_R_001.a003
  is '';

prompt
prompt Creating table T_ETL_ATJJ
prompt =========================
prompt
create table T_ETL_ATJJ
(
  dljy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;

prompt
prompt Creating table T_ETL_BCZL
prompt =========================
prompt
create table T_ETL_BCZL
(
  jylx INTEGER,
  je   NUMBER(14,2),
  bz   INTEGER
)
;
comment on table T_ETL_BCZL
  is 'ͻ׽ʽ-';
comment on column T_ETL_BCZL.jylx
  is ' 1-ɷת,2֤ȯҵ,3֤ȯҵ֧';
comment on column T_ETL_BCZL.je
  is '';
comment on column T_ETL_BCZL.bz
  is ' 0- 1-۱ 2-Ԫ';

prompt
prompt Creating table T_ETL_BIZ_DATA
prompt =============================
prompt
create table T_ETL_BIZ_DATA
(
  reportid        VARCHAR2(100),
  proid           NUMBER,
  protype         VARCHAR2(32),
  currency        VARCHAR2(16),
  endbalance      NUMBER,
  beginbalance    NUMBER,
  ncbalance       NUMBER,
  periodbalance   NUMBER,
  perioddrbalance NUMBER,
  periodcrbalance NUMBER,
  company         VARCHAR2(64) default 0,
  begindrbalance  NUMBER,
  begincrbalance  NUMBER,
  enddrbalance    NUMBER,
  endcrbalance    NUMBER
)
;
comment on table T_ETL_BIZ_DATA
  is 'ֵָ(ɲϵͳĿ)';
comment on column T_ETL_BIZ_DATA.reportid
  is 'ID';
comment on column T_ETL_BIZ_DATA.proid
  is 'ĿID';
comment on column T_ETL_BIZ_DATA.protype
  is 'Ŀ(Ӧt_krcs_cwcjprotype)';
comment on column T_ETL_BIZ_DATA.currency
  is '';
comment on column T_ETL_BIZ_DATA.endbalance
  is 'ĩ';
comment on column T_ETL_BIZ_DATA.beginbalance
  is 'ڳ';
comment on column T_ETL_BIZ_DATA.ncbalance
  is '';
comment on column T_ETL_BIZ_DATA.periodbalance
  is '';
comment on column T_ETL_BIZ_DATA.perioddrbalance
  is 'ڽ跽';
comment on column T_ETL_BIZ_DATA.periodcrbalance
  is 'ڴ';
comment on column T_ETL_BIZ_DATA.company
  is '˾(Ӫҵ)';
comment on column T_ETL_BIZ_DATA.begindrbalance
  is 'ڳ跽';
comment on column T_ETL_BIZ_DATA.begincrbalance
  is 'ڳ';
comment on column T_ETL_BIZ_DATA.enddrbalance
  is 'ĩ跽';
comment on column T_ETL_BIZ_DATA.endcrbalance
  is 'ĩ';

prompt
prompt Creating table T_ETL_C13_1_JE
prompt =============================
prompt
create table T_ETL_C13_1_JE
(
  xm   INTEGER,
  jylx INTEGER,
  je   NUMBER(19,6)
)
;

prompt
prompt Creating table T_ETL_C13_1_SL
prompt =============================
prompt
create table T_ETL_C13_1_SL
(
  xm   INTEGER,
  jylx INTEGER,
  sl   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C13_1_YWGM
prompt ===============================
prompt
create table T_ETL_C13_1_YWGM
(
  xm      INTEGER,
  maxrate NUMBER(18,2),
  minrate NUMBER(18,2)
)
;

prompt
prompt Creating table T_ETL_C13_2_JE
prompt =============================
prompt
create table T_ETL_C13_2_JE
(
  xm   INTEGER,
  jylx INTEGER,
  je   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C13_2_SL
prompt =============================
prompt
create table T_ETL_C13_2_SL
(
  xm   INTEGER,
  jylx INTEGER,
  sl   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C13_2_YWMX1
prompt ================================
prompt
create table T_ETL_C13_2_YWMX1
(
  dm   VARCHAR2(32),
  mc   VARCHAR2(64),
  je   NUMBER(19,2),
  sz   NUMBER(19,2),
  bl_a NUMBER(19,4),
  bl_b NUMBER(19,4)
)
;

prompt
prompt Creating table T_ETL_C13_2_YWMX2
prompt ================================
prompt
create table T_ETL_C13_2_YWMX2
(
  mc       VARCHAR2(64),
  sl       NUMBER(19,2),
  sz       NUMBER(19,2),
  bl_a     NUMBER(19,4),
  bl_b     NUMBER(19,4),
  stk_name VARCHAR2(64)
)
;

prompt
prompt Creating table T_ETL_C13_3_JE
prompt =============================
prompt
create table T_ETL_C13_3_JE
(
  xm   INTEGER,
  jylx INTEGER,
  je   NUMBER(19,6)
)
;

prompt
prompt Creating table T_ETL_C13_3_JE20200831
prompt =====================================
prompt
create table T_ETL_C13_3_JE20200831
(
  xm   INTEGER,
  jylx INTEGER,
  je   NUMBER(19,6)
)
;

prompt
prompt Creating table T_ETL_C13_3_JE_RH
prompt ================================
prompt
create table T_ETL_C13_3_JE_RH
(
  xm   INTEGER,
  jylx INTEGER,
  je   NUMBER(19,6)
)
;

prompt
prompt Creating table T_ETL_C13_3_JE_ZYZJ
prompt ==================================
prompt
create table T_ETL_C13_3_JE_ZYZJ
(
  xm   INTEGER,
  jylx INTEGER,
  je   NUMBER(19,6)
)
;

prompt
prompt Creating table T_ETL_C13_3_SL
prompt =============================
prompt
create table T_ETL_C13_3_SL
(
  xm   INTEGER,
  jylx INTEGER,
  sl   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C13_3_SL20200831
prompt =====================================
prompt
create table T_ETL_C13_3_SL20200831
(
  xm   INTEGER,
  jylx INTEGER,
  sl   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C13_3_SL_RH
prompt ================================
prompt
create table T_ETL_C13_3_SL_RH
(
  xm   INTEGER,
  jylx INTEGER,
  sl   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C13_3_SL_ZYZJ
prompt ==================================
prompt
create table T_ETL_C13_3_SL_ZYZJ
(
  xm   INTEGER,
  jylx INTEGER,
  sl   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C13_3_YCL
prompt ==============================
prompt
create table T_ETL_C13_3_YCL
(
  jyrq   NUMBER,
  hth    VARCHAR2(32),
  glhth  VARCHAR2(32),
  sbhtxh VARCHAR2(32),
  htlx   VARCHAR2(32),
  fzjg   VARCHAR2(100),
  khbm   VARCHAR2(32),
  khxm   VARCHAR2(32),
  rcfmc  VARCHAR2(100),
  rcflx  VARCHAR2(32),
  zqdm   VARCHAR2(32),
  zqmc   VARCHAR2(32),
  wtsl   NUMBER(19,2),
  hgsl   NUMBER(19,2),
  jysl   NUMBER(19,2),
  wymcsl NUMBER(19,2),
  wtje   NUMBER(19,2),
  yhje   NUMBER(19,2),
  dqrq   NUMBER,
  sjghrq NUMBER,
  wtrq   NUMBER,
  jysc   VARCHAR2(10),
  xsbz   VARCHAR2(10),
  jgbs   VARCHAR2(32),
  hgll   NUMBER(19,4),
  sjghje NUMBER(19,2),
  yjlx   NUMBER(19,2),
  sfwy   VARCHAR2(32)
)
;

prompt
prompt Creating table T_ETL_C13_3_YCL01
prompt ================================
prompt
create table T_ETL_C13_3_YCL01
(
  jyrq   NUMBER,
  hth    VARCHAR2(32),
  glhth  VARCHAR2(32),
  sbhtxh VARCHAR2(32),
  htlx   VARCHAR2(32),
  fzjg   VARCHAR2(100),
  khbm   VARCHAR2(32),
  khxm   VARCHAR2(32),
  rcfmc  VARCHAR2(100),
  rcflx  VARCHAR2(32),
  zqdm   VARCHAR2(32),
  zqmc   VARCHAR2(32),
  wtsl   NUMBER(19,2),
  hgsl   NUMBER(19,2),
  jysl   NUMBER(19,2),
  wymcsl NUMBER(19,2),
  wtje   NUMBER(19,2),
  yhje   NUMBER(19,2),
  dqrq   NUMBER,
  sjghrq NUMBER,
  wtrq   NUMBER,
  jysc   VARCHAR2(10),
  xsbz   VARCHAR2(10),
  jgbs   VARCHAR2(32),
  hgll   NUMBER(19,4),
  sjghje NUMBER(19,2),
  yjlx   NUMBER(19,2),
  sfwy   VARCHAR2(32)
)
;

prompt
prompt Creating table T_ETL_C13_3_YCL_BAK
prompt ==================================
prompt
create table T_ETL_C13_3_YCL_BAK
(
  jyrq   NUMBER,
  hth    VARCHAR2(32),
  glhth  VARCHAR2(32),
  sbhtxh VARCHAR2(32),
  htlx   VARCHAR2(32),
  fzjg   VARCHAR2(100),
  khbm   VARCHAR2(32),
  khxm   VARCHAR2(32),
  rcfmc  VARCHAR2(100),
  rcflx  VARCHAR2(32),
  zqdm   VARCHAR2(32),
  zqmc   VARCHAR2(32),
  wtsl   NUMBER(19,2),
  hgsl   NUMBER(19,2),
  jysl   NUMBER(19,2),
  wymcsl NUMBER(19,2),
  wtje   NUMBER(19,2),
  yhje   NUMBER(19,2),
  dqrq   NUMBER,
  sjghrq NUMBER,
  wtrq   NUMBER,
  jysc   VARCHAR2(10),
  xsbz   VARCHAR2(10),
  jgbs   VARCHAR2(32),
  hgll   NUMBER(19,4),
  sjghje NUMBER(19,2),
  yjlx   NUMBER(19,2),
  sfwy   VARCHAR2(32)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX1
prompt ================================
prompt
create table T_ETL_C13_3_YWMX1
(
  dm   VARCHAR2(32),
  mc   VARCHAR2(64),
  je   NUMBER(19,2),
  sz   NUMBER(19,2),
  bl_a NUMBER(19,4),
  bl_b NUMBER(19,4)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX120200831
prompt ========================================
prompt
create table T_ETL_C13_3_YWMX120200831
(
  dm   VARCHAR2(32),
  mc   VARCHAR2(64),
  je   NUMBER(19,2),
  sz   NUMBER(19,2),
  bl_a NUMBER(19,4),
  bl_b NUMBER(19,4)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX1_RH
prompt ===================================
prompt
create table T_ETL_C13_3_YWMX1_RH
(
  dm   VARCHAR2(32),
  mc   VARCHAR2(64),
  je   NUMBER(19,2),
  sz   NUMBER(19,2),
  bl_a NUMBER(19,4),
  bl_b NUMBER(19,4)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX1_ZYZJ
prompt =====================================
prompt
create table T_ETL_C13_3_YWMX1_ZYZJ
(
  dm   VARCHAR2(32),
  mc   VARCHAR2(64),
  je   NUMBER(19,2),
  sz   NUMBER(19,2),
  bl_a NUMBER(19,4),
  bl_b NUMBER(19,4)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX2
prompt ================================
prompt
create table T_ETL_C13_3_YWMX2
(
  mc       VARCHAR2(64),
  sl       NUMBER(19,2),
  sz       NUMBER(19,2),
  bl_a     NUMBER(19,4),
  bl_b     NUMBER(19,4),
  stk_name VARCHAR2(64)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX220200831
prompt ========================================
prompt
create table T_ETL_C13_3_YWMX220200831
(
  mc       VARCHAR2(64),
  sl       NUMBER(19,2),
  sz       NUMBER(19,2),
  bl_a     NUMBER(19,4),
  bl_b     NUMBER(19,4),
  stk_name VARCHAR2(64)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX2_RH
prompt ===================================
prompt
create table T_ETL_C13_3_YWMX2_RH
(
  mc       VARCHAR2(64),
  sl       NUMBER(19,2),
  sz       NUMBER(19,2),
  bl_a     NUMBER(19,4),
  bl_b     NUMBER(19,4),
  stk_name VARCHAR2(64)
)
;

prompt
prompt Creating table T_ETL_C13_3_YWMX2_ZYZJ
prompt =====================================
prompt
create table T_ETL_C13_3_YWMX2_ZYZJ
(
  mc       VARCHAR2(64),
  sl       NUMBER(19,2),
  sz       NUMBER(19,2),
  bl_a     NUMBER(19,4),
  bl_b     NUMBER(19,4),
  stk_name VARCHAR2(64)
)
;

prompt
prompt Creating table T_ETL_C7_1_BCZL
prompt ==============================
prompt
create table T_ETL_C7_1_BCZL
(
  xm        NUMBER,
  tgjeze    NUMBER(19,2),
  shajstgje NUMBER(19,2),
  shejstgje NUMBER(19,2),
  yhjtgje   NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_C7_1_YMWDQJE
prompt =================================
prompt
create table T_ETL_C7_1_YMWDQJE
(
  xm         NUMBER,
  shajswdq   NUMBER(19,2),
  shejswdq   NUMBER(19,2),
  yhjwdq     NUMBER(19,2),
  byshajsfse NUMBER(19,2),
  byshejsfse NUMBER(19,2),
  byyhjfse   NUMBER(19,2),
  bnshajsfse NUMBER(19,2),
  bnshejsfse NUMBER(19,2),
  bnyhjfse   NUMBER(19,2),
  khlb       VARCHAR2(100),
  zqlb       VARCHAR2(100)
)
;
comment on column T_ETL_C7_1_YMWDQJE.xm
  is '1:ծйܽ 2ծ׼ȯ 3ծйܽ 4ծ׼ȯйܽ';

prompt
prompt Creating table T_ETL_DLDFGZ
prompt ===========================
prompt
create table T_ETL_DLDFGZ
(
  dljy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;
comment on table T_ETL_DLDFGZ
  is 'Ҹծ';
comment on column T_ETL_DLDFGZ.dljy
  is 'ڴ';
comment on column T_ETL_DLDFGZ.yjsr
  is 'ڴӶ';

prompt
prompt Creating table T_ETL_DLDFQTZ
prompt ============================
prompt
create table T_ETL_DLDFQTZ
(
  dljy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;
comment on table T_ETL_DLDFQTZ
  is 'Ҹծ';
comment on column T_ETL_DLDFQTZ.dljy
  is 'ڴ';
comment on column T_ETL_DLDFQTZ.yjsr
  is 'ڴӶ';

prompt
prompt Creating table T_ETL_DLKXH
prompt ==========================
prompt
create table T_ETL_DLKXH
(
  jylx INTEGER,
  bz   INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_DLKXH
  is '֤ȯʻ-';
comment on column T_ETL_DLKXH.jylx
  is ' 1- 2-';
comment on column T_ETL_DLKXH.bz
  is ' 1-ңAɣ 2-B 3-B';
comment on column T_ETL_DLKXH.sl
  is '';

prompt
prompt Creating table T_ETL_DXGZ
prompt =========================
prompt
create table T_ETL_DXGZ
(
  dljy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;
comment on table T_ETL_DXGZ
  is 'ծ';
comment on column T_ETL_DXGZ.dljy
  is 'ڴ';
comment on column T_ETL_DXGZ.yjsr
  is 'ڴӶ';

prompt
prompt Creating table T_ETL_DXJJ
prompt =========================
prompt
create table T_ETL_DXJJ
(
  dljy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;
comment on table T_ETL_DXJJ
  is '';
comment on column T_ETL_DXJJ.dljy
  is 'ڴ';
comment on column T_ETL_DXJJ.yjsr
  is 'ڴӶ';

prompt
prompt Creating table T_ETL_DXQTZ
prompt ==========================
prompt
create table T_ETL_DXQTZ
(
  dljy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;
comment on table T_ETL_DXQTZ
  is 'ծ';
comment on column T_ETL_DXQTZ.dljy
  is 'ڴ';
comment on column T_ETL_DXQTZ.yjsr
  is 'ڴӶ';

prompt
prompt Creating table T_ETL_DXZCGL
prompt ===========================
prompt
create table T_ETL_DXZCGL
(
  dljy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;
comment on table T_ETL_DXZCGL
  is 'ʲ';
comment on column T_ETL_DXZCGL.dljy
  is 'ڴ';
comment on column T_ETL_DXZCGL.yjsr
  is 'ڴӶ';

prompt
prompt Creating table T_ETL_FZCJY_ZJZH
prompt ===============================
prompt
create table T_ETL_FZCJY_ZJZH
(
  zhlx INTEGER,
  jylx INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_FZCJY_ZJZH
  is 'ҵ -  - ʽ˻';
comment on column T_ETL_FZCJY_ZJZH.zhlx
  is '˻ 1-˻ 2-ϸ˻ 3-˻ 4-˻';
comment on column T_ETL_FZCJY_ZJZH.jylx
  is ' 1- 2-ڼ 3-ĩ';
comment on column T_ETL_FZCJY_ZJZH.sl
  is '';

prompt
prompt Creating table T_ETL_FZCJY_ZQZH
prompt ===============================
prompt
create table T_ETL_FZCJY_ZQZH
(
  zhlx INTEGER,
  jylx INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_FZCJY_ZQZH
  is 'ҵ -  - ֤ȯ˻';
comment on column T_ETL_FZCJY_ZQZH.zhlx
  is '˻ 1-˻ 2-ϸ˻ 3-˻ 4-˻';
comment on column T_ETL_FZCJY_ZQZH.jylx
  is ' 1- 2-ڼ 3-ĩ';
comment on column T_ETL_FZCJY_ZQZH.sl
  is '';

prompt
prompt Creating table T_ETL_JY
prompt =======================
prompt
create table T_ETL_JY
(
  khlx INTEGER,
  zqlx INTEGER,
  jylx INTEGER,
  je   NUMBER(14,2)
)
;
comment on table T_ETL_JY
  is 'ҵܱ - ';
comment on column T_ETL_JY.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_JY.zqlx
  is '֤ȯ 1-A 2-B 3-B 4- 5-ETF 6-LOF 7-ծȯ 8-Ȩ֤ 9-Ȩ֤ 10- 11-ȯ 12-ϽA 13-ϽB 14-Ͻ׻B';
comment on column T_ETL_JY.jylx
  is ' 1- 2-ָй';
comment on column T_ETL_JY.je
  is '';

prompt
prompt Creating table T_ETL_JY_RZRQ
prompt ============================
prompt
create table T_ETL_JY_RZRQ
(
  khlx INTEGER,
  zqlx INTEGER,
  jylx INTEGER,
  je   NUMBER(14,2)
)
;
comment on table T_ETL_JY_RZRQ
  is 'ҵܱ - ';
comment on column T_ETL_JY_RZRQ.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_JY_RZRQ.zqlx
  is '֤ȯ 1-A 2-B 3-B 4- 5-ETF 6-LOF 7-ծȯ 8-Ȩ֤ 9-Ȩ֤ 10- 11-ȯ 12-ϽA 13-ϽB 14-Ͻ׻B';
comment on column T_ETL_JY_RZRQ.jylx
  is ' 1- 2-ָй';
comment on column T_ETL_JY_RZRQ.je
  is '';

prompt
prompt Creating table T_ETL_KHJYJSZJ
prompt =============================
prompt
create table T_ETL_KHJYJSZJ
(
  khlx INTEGER,
  jylx INTEGER,
  bz   INTEGER,
  je   NUMBER(14,2)
)
;
comment on table T_ETL_KHJYJSZJ
  is 'ҵ񣭿ͻ׽ʽ';
comment on column T_ETL_KHJYJSZJ.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_KHJYJSZJ.jylx
  is ' 1- 2-ȡ 3ĩ';
comment on column T_ETL_KHJYJSZJ.bz
  is ' 0- 1-۱ 2-Ԫ';
comment on column T_ETL_KHJYJSZJ.je
  is '';

prompt
prompt Creating table T_ETL_LR
prompt =======================
prompt
create table T_ETL_LR
(
  xm   INTEGER,
  bqje NUMBER(18,2),
  bnlj NUMBER(18,2)
)
;
comment on table T_ETL_LR
  is 'ܱETL';
comment on column T_ETL_LR.xm
  is 'Ŀ';
comment on column T_ETL_LR.bqje
  is 'ڽ';
comment on column T_ETL_LR.bnlj
  is 'ۼ';

prompt
prompt Creating table T_ETL_QTJJ
prompt =========================
prompt
create table T_ETL_QTJJ
(
  qtjy NUMBER(14,2),
  yjsr NUMBER(14,2)
)
;
comment on table T_ETL_QTJJ
  is '';
comment on column T_ETL_QTJJ.qtjy
  is 'ڴ';
comment on column T_ETL_QTJJ.yjsr
  is 'ڴӶ';

prompt
prompt Creating table T_ETL_RZRQ_C10
prompt =============================
prompt
create table T_ETL_RZRQ_C10
(
  xm NUMBER,
  je NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_SFCG
prompt =========================
prompt
create table T_ETL_SFCG
(
  moneytype VARCHAR2(2),
  fundbal   NUMBER(14,2)
)
;
comment on table T_ETL_SFCG
  is ' ';

prompt
prompt Creating table T_ETL_XSJRCP_FSE
prompt ===============================
prompt
create table T_ETL_XSJRCP_FSE
(
  xm     NUMBER,
  bqzjsl NUMBER,
  bqzjje NUMBER(19,2),
  bnzjsl NUMBER,
  bqjssl NUMBER,
  bqjsje NUMBER(19,2),
  bnjssl NUMBER
)
;
comment on table T_ETL_XSJRCP_FSE
  is '˾۽ڲƷ';

prompt
prompt Creating table T_ETL_XSJRCP_QMYE
prompt ================================
prompt
create table T_ETL_XSJRCP_QMYE
(
  xm   NUMBER,
  qmsl NUMBER,
  qmje NUMBER(19,2)
)
;
comment on table T_ETL_XSJRCP_QMYE
  is '˾۽ڲƷ';

prompt
prompt Creating table T_ETL_XSJRCP_QMYE_20190401
prompt =========================================
prompt
create table T_ETL_XSJRCP_QMYE_20190401
(
  xm   NUMBER,
  qmsl NUMBER,
  qmje NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_YHJSCYZ
prompt ============================
prompt
create table T_ETL_YHJSCYZ
(
  xm   INTEGER,
  bqzj NUMBER(14,2),
  bqjs NUMBER(14,2),
  qmye NUMBER(14,2)
)
;
comment on table T_ETL_YHJSCYZ
  is 'C8-1 мг';
comment on column T_ETL_YHJSCYZ.xm
  is 'Ŀ';
comment on column T_ETL_YHJSCYZ.bqzj
  is '';
comment on column T_ETL_YHJSCYZ.bqjs
  is 'ڼ';
comment on column T_ETL_YHJSCYZ.qmye
  is 'ĩ';

prompt
prompt Creating table T_ETL_YYB_DBZZ
prompt =============================
prompt
create table T_ETL_YYB_DBZZ
(
  yyb  VARCHAR2(10),
  bz   INTEGER,
  jyje NUMBER(18,2)
)
;
comment on table T_ETL_YYB_DBZZ
  is 'ҵܱ - Ӫҵ - ת';
comment on column T_ETL_YYB_DBZZ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_DBZZ.bz
  is ' 0- 1-۱ 2-Ԫ';
comment on column T_ETL_YYB_DBZZ.jyje
  is '׽';

prompt
prompt Creating table T_ETL_YYB_JJZH
prompt =============================
prompt
create table T_ETL_YYB_JJZH
(
  yyb  VARCHAR2(10),
  khlx INTEGER,
  jylx INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_YYB_JJZH
  is 'ҵ - Ӫҵ - ʻ';
comment on column T_ETL_YYB_JJZH.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_JJZH.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_YYB_JJZH.jylx
  is ' 1- 2-ڼ 3-ĩ';
comment on column T_ETL_YYB_JJZH.sl
  is '';

prompt
prompt Creating table T_ETL_YYB_KHJYJSZJ
prompt =================================
prompt
create table T_ETL_YYB_KHJYJSZJ
(
  yyb  VARCHAR2(10),
  jylx INTEGER,
  je   NUMBER(18,2)
)
;
comment on table T_ETL_YYB_KHJYJSZJ
  is 'ҵ - Ӫҵ - ͻ׽ʽ';
comment on column T_ETL_YYB_KHJYJSZJ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_KHJYJSZJ.jylx
  is ' 1-̨ͻ׽ʽ';
comment on column T_ETL_YYB_KHJYJSZJ.je
  is '';

prompt
prompt Creating table T_ETL_YYB_KHJYJSZJ_RZRQ
prompt ======================================
prompt
create table T_ETL_YYB_KHJYJSZJ_RZRQ
(
  yyb  VARCHAR2(10),
  jylx INTEGER,
  je   NUMBER(18,2)
)
;
comment on table T_ETL_YYB_KHJYJSZJ_RZRQ
  is 'ҵ - Ӫҵ - ͻ׽ʽ';
comment on column T_ETL_YYB_KHJYJSZJ_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_KHJYJSZJ_RZRQ.jylx
  is ' 1-̨ͻ׽ʽ';
comment on column T_ETL_YYB_KHJYJSZJ_RZRQ.je
  is '';

prompt
prompt Creating table T_ETL_YYB_KHZJFB
prompt ===============================
prompt
create table T_ETL_YYB_KHZJFB
(
  yyb  VARCHAR2(10),
  yhdm VARCHAR2(10),
  yhmc VARCHAR2(50),
  khsl INTEGER,
  zjye NUMBER(18,2)
)
;
comment on table T_ETL_YYB_KHZJFB
  is 'ҵ - Ӫҵ - ͻʽֲ';
comment on column T_ETL_YYB_KHZJFB.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_KHZJFB.yhdm
  is 'д';
comment on column T_ETL_YYB_KHZJFB.yhmc
  is '';
comment on column T_ETL_YYB_KHZJFB.khsl
  is 'ͻ';
comment on column T_ETL_YYB_KHZJFB.zjye
  is 'ʽ';

prompt
prompt Creating table T_ETL_YYB_KHZJFB_RZRQ
prompt ====================================
prompt
create table T_ETL_YYB_KHZJFB_RZRQ
(
  yyb   VARCHAR2(10),
  yhdm  VARCHAR2(10),
  yhmc  VARCHAR2(20),
  khsl  INTEGER,
  zjye  NUMBER(18,2),
  zzjzh INTEGER
)
;
comment on table T_ETL_YYB_KHZJFB_RZRQ
  is 'ҵ - Ӫҵ - ͻʽֲ';
comment on column T_ETL_YYB_KHZJFB_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_KHZJFB_RZRQ.yhdm
  is 'д';
comment on column T_ETL_YYB_KHZJFB_RZRQ.yhmc
  is '';
comment on column T_ETL_YYB_KHZJFB_RZRQ.khsl
  is 'ͻ';
comment on column T_ETL_YYB_KHZJFB_RZRQ.zjye
  is 'ʽ';
comment on column T_ETL_YYB_KHZJFB_RZRQ.zzjzh
  is 'ʽ˺';

prompt
prompt Creating table T_ETL_YYB_RZRQ_JYQK
prompt ==================================
prompt
create table T_ETL_YYB_RZRQ_JYQK
(
  lx        NUMBER,
  branch    NUMBER,
  secu_name VARCHAR2(50),
  sz        NUMBER(19,2),
  id        NUMBER
)
;
comment on table T_ETL_YYB_RZRQ_JYQK
  is '֤ȯӪҵȯҵ¶רͳƱ-';
comment on column T_ETL_YYB_RZRQ_JYQK.lx
  is '1-룬2-';

prompt
prompt Creating table T_ETL_YYB_RZRQ_JYQK_UNION
prompt ========================================
prompt
create table T_ETL_YYB_RZRQ_JYQK_UNION
(
  lx        NUMBER,
  branch    NUMBER,
  secu_name VARCHAR2(50),
  sz        NUMBER(19,2),
  id        NUMBER
)
;

prompt
prompt Creating table T_ETL_YYB_RZRQ_SRQK
prompt ==================================
prompt
create table T_ETL_YYB_RZRQ_SRQK
(
  yyb NUMBER,
  je  NUMBER(19,2)
)
;
comment on table T_ETL_YYB_RZRQ_SRQK
  is 'Ӫҵȯҵ¶רͳƱ-';

prompt
prompt Creating table T_ETL_YYB_RZRQ_TJB
prompt =================================
prompt
create table T_ETL_YYB_RZRQ_TJB
(
  yyb NUMBER,
  xm  NUMBER,
  je  NUMBER(18,2)
)
;
comment on table T_ETL_YYB_RZRQ_TJB
  is '֤ȯӪҵȯҵ¶רͳƱ';
comment on column T_ETL_YYB_RZRQ_TJB.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_RZRQ_TJB.xm
  is 'Ŀ';
comment on column T_ETL_YYB_RZRQ_TJB.je
  is '';

prompt
prompt Creating table T_ETL_YYB_SY
prompt ===========================
prompt
create table T_ETL_YYB_SY
(
  yyb  VARCHAR2(10),
  xm   INTEGER,
  bqje NUMBER(18,2)
)
;
comment on table T_ETL_YYB_SY
  is 'Ӫҵ';
comment on column T_ETL_YYB_SY.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_SY.xm
  is 'Ŀ';
comment on column T_ETL_YYB_SY.bqje
  is 'ڽ';

prompt
prompt Creating table T_ETL_YYB_XSJRCP_FSE
prompt ===================================
prompt
create table T_ETL_YYB_XSJRCP_FSE
(
  yyb    NUMBER,
  xm     NUMBER,
  bqzjsl NUMBER,
  bqzjje NUMBER(19,2),
  bnzjsl NUMBER,
  bqjssl NUMBER,
  bqjsje NUMBER(19,2),
  bnjssl NUMBER
)
;
comment on table T_ETL_YYB_XSJRCP_FSE
  is 'Ӫҵ۽ڲƷ';
comment on column T_ETL_YYB_XSJRCP_FSE.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_XSJRCP_FSE.xm
  is 'Ŀ';
comment on column T_ETL_YYB_XSJRCP_FSE.bqzjsl
  is '';
comment on column T_ETL_YYB_XSJRCP_FSE.bqzjje
  is 'ӽ';
comment on column T_ETL_YYB_XSJRCP_FSE.bnzjsl
  is '';
comment on column T_ETL_YYB_XSJRCP_FSE.bqjssl
  is 'ڼ';
comment on column T_ETL_YYB_XSJRCP_FSE.bqjsje
  is 'ڼٽ';
comment on column T_ETL_YYB_XSJRCP_FSE.bnjssl
  is '';

prompt
prompt Creating table T_ETL_YYB_XSJRCP_QMYE
prompt ====================================
prompt
create table T_ETL_YYB_XSJRCP_QMYE
(
  yyb  NUMBER,
  xm   NUMBER,
  qmsl NUMBER,
  qmje NUMBER(19,2)
)
;
comment on table T_ETL_YYB_XSJRCP_QMYE
  is 'Ӫҵ۽ڲƷ';
comment on column T_ETL_YYB_XSJRCP_QMYE.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_XSJRCP_QMYE.xm
  is 'Ŀ';
comment on column T_ETL_YYB_XSJRCP_QMYE.qmsl
  is 'ĩ';

prompt
prompt Creating table T_ETL_YYB_YJL
prompt ============================
prompt
create table T_ETL_YYB_YJL
(
  yyb   NUMBER,
  maxsl NUMBER(19,2),
  minsl NUMBER(19,2)
)
;

prompt
prompt Creating table T_ETL_YYB_ZCFZ
prompt =============================
prompt
create table T_ETL_YYB_ZCFZ
(
  yyb  VARCHAR2(10),
  xm   INTEGER,
  qmye NUMBER(18,2),
  ncye NUMBER(18,2)
)
;
comment on table T_ETL_YYB_ZCFZ
  is 'ʲծ״';
comment on column T_ETL_YYB_ZCFZ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZCFZ.xm
  is 'Ŀ';
comment on column T_ETL_YYB_ZCFZ.qmye
  is 'ĩ';
comment on column T_ETL_YYB_ZCFZ.ncye
  is '';

prompt
prompt Creating table T_ETL_YYB_ZHBD_ZJZH
prompt ==================================
prompt
create table T_ETL_YYB_ZHBD_ZJZH
(
  yyb  VARCHAR2(10),
  zhlx INTEGER,
  jylx INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_YYB_ZHBD_ZJZH
  is 'ҵ - Ӫҵ - ˻䶯 - ʽ˻';
comment on column T_ETL_YYB_ZHBD_ZJZH.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZHBD_ZJZH.zhlx
  is '˻ 1-ϸ˻ 2-ϸ˻ 3-С˻ 4-˻';
comment on column T_ETL_YYB_ZHBD_ZJZH.jylx
  is ' 1- 2-ڹ淶 3-ڼ/ָ 4-ע';
comment on column T_ETL_YYB_ZHBD_ZJZH.sl
  is '';

prompt
prompt Creating table T_ETL_YYB_ZHBD_ZQZH
prompt ==================================
prompt
create table T_ETL_YYB_ZHBD_ZQZH
(
  yyb  VARCHAR2(10),
  zhlx INTEGER,
  jylx INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_YYB_ZHBD_ZQZH
  is 'ҵ - Ӫҵ - ˻䶯 - ֤ȯ˻';
comment on column T_ETL_YYB_ZHBD_ZQZH.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZHBD_ZQZH.zhlx
  is '˻ 1-ϸ˻ 2-ϸ˻ 3-С˻ 4-˻';
comment on column T_ETL_YYB_ZHBD_ZQZH.jylx
  is ' 1- 2-ڹ淶 3-ڼ/ָ 4-ע';
comment on column T_ETL_YYB_ZHBD_ZQZH.sl
  is '';

prompt
prompt Creating table T_ETL_YYB_ZHGF_ZJZH
prompt ==================================
prompt
create table T_ETL_YYB_ZHGF_ZJZH
(
  yyb  VARCHAR2(10),
  jylx INTEGER,
  sl   INTEGER,
  zjye NUMBER(18,2)
)
;
comment on table T_ETL_YYB_ZHGF_ZJZH
  is 'ҵ - Ӫҵ - ˻淶 - ʽ˻';
comment on column T_ETL_YYB_ZHGF_ZJZH.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZHGF_ZJZH.jylx
  is ' 1-ϸʽ˻ 2-ϸ˻ 3-С˻ 4-˻5.ϸʽʻ';
comment on column T_ETL_YYB_ZHGF_ZJZH.sl
  is '';
comment on column T_ETL_YYB_ZHGF_ZJZH.zjye
  is 'ʽ';

prompt
prompt Creating table T_ETL_YYB_ZHGF_ZJZH_RZRQ
prompt =======================================
prompt
create table T_ETL_YYB_ZHGF_ZJZH_RZRQ
(
  yyb  VARCHAR2(10),
  jylx INTEGER,
  sl   INTEGER,
  zjye NUMBER(18,2)
)
;
comment on table T_ETL_YYB_ZHGF_ZJZH_RZRQ
  is 'ҵ - Ӫҵ - ˻淶 - ʽ˻';
comment on column T_ETL_YYB_ZHGF_ZJZH_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZHGF_ZJZH_RZRQ.jylx
  is ' 1-ϸʽ˻ 2-ϸ˻ 3-С˻ 4-˻5.ϸʽʻ';
comment on column T_ETL_YYB_ZHGF_ZJZH_RZRQ.sl
  is '';
comment on column T_ETL_YYB_ZHGF_ZJZH_RZRQ.zjye
  is 'ʽ';

prompt
prompt Creating table T_ETL_YYB_ZHGF_ZQZH
prompt ==================================
prompt
create table T_ETL_YYB_ZHGF_ZQZH
(
  yyb  VARCHAR2(10),
  jylx INTEGER,
  sl   INTEGER,
  zqsz NUMBER(18,2)
)
;
comment on table T_ETL_YYB_ZHGF_ZQZH
  is 'ҵ - Ӫҵ - ˻淶 - ֤ȯ˻';
comment on column T_ETL_YYB_ZHGF_ZQZH.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZHGF_ZQZH.jylx
  is ' 1-ϸ˻ 2-ϸ˻ 3-С˻ 4-˻';
comment on column T_ETL_YYB_ZHGF_ZQZH.sl
  is '';
comment on column T_ETL_YYB_ZHGF_ZQZH.zqsz
  is '֤ȯֵ';

prompt
prompt Creating table T_ETL_YYB_ZHGF_ZQZH_RZRQ
prompt =======================================
prompt
create table T_ETL_YYB_ZHGF_ZQZH_RZRQ
(
  yyb  VARCHAR2(10),
  jylx INTEGER,
  sl   INTEGER,
  zqsz NUMBER(18,2)
)
;
comment on table T_ETL_YYB_ZHGF_ZQZH_RZRQ
  is 'ҵ - Ӫҵ - ˻淶 - ֤ȯ˻';
comment on column T_ETL_YYB_ZHGF_ZQZH_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZHGF_ZQZH_RZRQ.jylx
  is ' 1-ϸ˻ 2-ϸ˻ 3-С˻ 4-˻';
comment on column T_ETL_YYB_ZHGF_ZQZH_RZRQ.sl
  is '';
comment on column T_ETL_YYB_ZHGF_ZQZH_RZRQ.zqsz
  is '֤ȯֵ';

prompt
prompt Creating table T_ETL_YYB_ZJZH
prompt =============================
prompt
create table T_ETL_YYB_ZJZH
(
  yyb  VARCHAR2(10),
  khlx INTEGER,
  jylx INTEGER,
  bz   INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_YYB_ZJZH
  is 'ҵ - Ӫҵ - ʽʻ';
comment on column T_ETL_YYB_ZJZH.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZJZH.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_YYB_ZJZH.jylx
  is ' 1- 2-ڼ 3-ĩ';
comment on column T_ETL_YYB_ZJZH.bz
  is ' 0- 1-۱ 2-Ԫ';
comment on column T_ETL_YYB_ZJZH.sl
  is '';

prompt
prompt Creating table T_ETL_YYB_ZJZH_RZRQ
prompt ==================================
prompt
create table T_ETL_YYB_ZJZH_RZRQ
(
  yyb  VARCHAR2(10),
  khlx INTEGER,
  jylx INTEGER,
  bz   INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_YYB_ZJZH_RZRQ
  is 'ҵ - Ӫҵ - ʽʻ';
comment on column T_ETL_YYB_ZJZH_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZJZH_RZRQ.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_YYB_ZJZH_RZRQ.jylx
  is ' 1- 2-ڼ 3-ĩ';
comment on column T_ETL_YYB_ZJZH_RZRQ.bz
  is ' 0- 1-۱ 2-Ԫ';
comment on column T_ETL_YYB_ZJZH_RZRQ.sl
  is '';

prompt
prompt Creating table T_ETL_YYB_ZQJY
prompt =============================
prompt
create table T_ETL_YYB_ZQJY
(
  yyb  VARCHAR2(10),
  zqlx INTEGER,
  jyje NUMBER(18,2),
  sxf  NUMBER(14,2)
)
;
comment on table T_ETL_YYB_ZQJY
  is 'ҵܱ - Ӫҵ - ֤ȯ';
comment on column T_ETL_YYB_ZQJY.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZQJY.zqlx
  is '֤ȯ 1-A 2-B 3-B 4- 5-ծȯ 6-Ȩ֤ 7-֤ȯ 8-ծȯʻع 9-ծȯȯع 10-Ͻ(A) 11-Ͻ(B) 12-Ͻ(B) 20-Уֳ(A) 21-Уֳ(B) 22--Уֳ(B)';
comment on column T_ETL_YYB_ZQJY.jyje
  is '׽';
comment on column T_ETL_YYB_ZQJY.sxf
  is '';

prompt
prompt Creating table T_ETL_YYB_ZQJY_RZRQ
prompt ==================================
prompt
create table T_ETL_YYB_ZQJY_RZRQ
(
  yyb  VARCHAR2(10),
  zqlx INTEGER,
  jyje NUMBER(18,2),
  sxf  NUMBER(14,2)
)
;
comment on table T_ETL_YYB_ZQJY_RZRQ
  is 'ҵܱ - Ӫҵ - ֤ȯ';
comment on column T_ETL_YYB_ZQJY_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZQJY_RZRQ.zqlx
  is '֤ȯ 1-A 2-B 3-B 4- 5-ծȯ 6-Ȩ֤ 7-֤ȯ 8-ծȯʻع 9-ծȯȯع 10-Ͻ(A) 11-Ͻ(B) 12-Ͻ(B) 20-Уֳ(A) 21-Уֳ(B) 22--Уֳ(B)';
comment on column T_ETL_YYB_ZQJY_RZRQ.jyje
  is '׽';
comment on column T_ETL_YYB_ZQJY_RZRQ.sxf
  is '';

prompt
prompt Creating table T_ETL_YYB_ZQSZ
prompt =============================
prompt
create table T_ETL_YYB_ZQSZ
(
  yyb  VARCHAR2(10),
  zqlx INTEGER,
  zqsz NUMBER(18,2)
)
;
comment on table T_ETL_YYB_ZQSZ
  is 'ҵܱ - Ӫҵ - ֤ȯֵ';
comment on column T_ETL_YYB_ZQSZ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZQSZ.zqlx
  is '֤ȯ 1-A 2-B 3-B 4- 5-ծȯ 6-Ȩ֤ 7-֤ȯ';
comment on column T_ETL_YYB_ZQSZ.zqsz
  is '֤ȯֵ';

prompt
prompt Creating table T_ETL_YYB_ZQSZ_RZRQ
prompt ==================================
prompt
create table T_ETL_YYB_ZQSZ_RZRQ
(
  yyb  VARCHAR2(10),
  zqlx INTEGER,
  zqsz NUMBER(18,2)
)
;
comment on table T_ETL_YYB_ZQSZ_RZRQ
  is 'ҵܱ - Ӫҵ - ֤ȯֵ';
comment on column T_ETL_YYB_ZQSZ_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZQSZ_RZRQ.zqlx
  is '֤ȯ 1-A 2-B 3-B 4- 5-ծȯ 6-Ȩ֤ 7-֤ȯ';
comment on column T_ETL_YYB_ZQSZ_RZRQ.zqsz
  is '֤ȯֵ';

prompt
prompt Creating table T_ETL_YYB_ZQZH
prompt =============================
prompt
create table T_ETL_YYB_ZQZH
(
  yyb  VARCHAR2(10),
  khlx INTEGER,
  jylx INTEGER,
  bz   INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_YYB_ZQZH
  is 'ҵ - Ӫҵ - ֤ȯʻ';
comment on column T_ETL_YYB_ZQZH.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZQZH.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_YYB_ZQZH.jylx
  is ' 1- 2-ڼ 3-ĩ';
comment on column T_ETL_YYB_ZQZH.bz
  is ' 0- 1-۱ 2-Ԫ';
comment on column T_ETL_YYB_ZQZH.sl
  is '';

prompt
prompt Creating table T_ETL_YYB_ZQZH_RZRQ
prompt ==================================
prompt
create table T_ETL_YYB_ZQZH_RZRQ
(
  yyb  VARCHAR2(10),
  khlx INTEGER,
  jylx INTEGER,
  bz   INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_YYB_ZQZH_RZRQ
  is 'ҵ - Ӫҵ - ֤ȯʻ';
comment on column T_ETL_YYB_ZQZH_RZRQ.yyb
  is 'Ӫҵ';
comment on column T_ETL_YYB_ZQZH_RZRQ.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_YYB_ZQZH_RZRQ.jylx
  is ' 1- 2-ڼ 3-ĩ';
comment on column T_ETL_YYB_ZQZH_RZRQ.bz
  is ' 0- 1-۱ 2-Ԫ';
comment on column T_ETL_YYB_ZQZH_RZRQ.sl
  is '';

prompt
prompt Creating table T_ETL_ZCFZ
prompt =========================
prompt
create table T_ETL_ZCFZ
(
  xm   INTEGER,
  qmye NUMBER(18,2),
  ncye NUMBER(18,2)
)
;
comment on table T_ETL_ZCFZ
  is 'ʲծ״';
comment on column T_ETL_ZCFZ.xm
  is 'Ŀ';
comment on column T_ETL_ZCFZ.qmye
  is 'ĩ';
comment on column T_ETL_ZCFZ.ncye
  is '';

prompt
prompt Creating table T_ETL_ZJZH
prompt =========================
prompt
create table T_ETL_ZJZH
(
  khlx INTEGER,
  jylx INTEGER,
  bz   INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_ZJZH
  is 'ҵʽʻ';
comment on column T_ETL_ZJZH.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_ZJZH.jylx
  is ' 1- 2- 3-ĩ';
comment on column T_ETL_ZJZH.bz
  is ' 0- 1-۱ 2-Ԫ';
comment on column T_ETL_ZJZH.sl
  is '';

prompt
prompt Creating table T_ETL_ZQZH
prompt =========================
prompt
create table T_ETL_ZQZH
(
  khlx INTEGER,
  jylx INTEGER,
  sc   INTEGER,
  bz   INTEGER,
  sl   INTEGER
)
;
comment on table T_ETL_ZQZH
  is 'ҵ֤ȯʻ';
comment on column T_ETL_ZQZH.khlx
  is 'ͻ 0- 1-';
comment on column T_ETL_ZQZH.jylx
  is ' 1- 2- 3-ת 4-ڼ 5- 6-ת 7-ĩ';
comment on column T_ETL_ZQZH.sc
  is 'г 0- 1-';
comment on column T_ETL_ZQZH.bz
  is ' 1- 2-۱ 3-Ԫ';
comment on column T_ETL_ZQZH.sl
  is '';

prompt
prompt Creating table T_ETL_ZYSZQHG_ZY_GS
prompt ==================================
prompt
create table T_ETL_ZYSZQHG_ZY_GS
(
  item               NUMBER,
  xm                 NUMBER,
  ordamount_wdq      NUMBER(19,2),
  ordamount_wdq_shg  NUMBER(19,2),
  ordamount_wdq_she  NUMBER(19,2),
  ordamount_wdq_cnbd NUMBER(19,2),
  ordamount_y        NUMBER(19,2),
  ordamount_y_shg    NUMBER(19,2),
  ordamount_y_she    NUMBER(19,2),
  ordamount_y_cnbd   NUMBER(19,2)
)
;

prompt
prompt Creating table T_FORMULA_DICT
prompt =============================
prompt
create table T_FORMULA_DICT
(
  p001 VARCHAR2(16) not null,
  a002 NUMBER not null,
  a003 VARCHAR2(32) not null,
  a004 VARCHAR2(16) not null,
  a005 VARCHAR2(128)
)
;
comment on table T_FORMULA_DICT
  is 'ʽֵ';
comment on column T_FORMULA_DICT.p001
  is '';
comment on column T_FORMULA_DICT.a002
  is 'ֵ';
comment on column T_FORMULA_DICT.a003
  is 'ֵ';
comment on column T_FORMULA_DICT.a004
  is 'ֵֶ';
comment on column T_FORMULA_DICT.a005
  is 'ֵ';

prompt
prompt Creating table T_FREE_FORMULA
prompt =============================
prompt
create table T_FREE_FORMULA
(
  p001 VARCHAR2(16) not null,
  p002 VARCHAR2(16),
  a003 NUMBER not null,
  a004 CHAR(1),
  a005 CHAR(1),
  a006 VARCHAR2(4000),
  a007 VARCHAR2(4000),
  a008 VARCHAR2(8),
  a009 CHAR(1),
  a010 VARCHAR2(4000),
  a011 VARCHAR2(128),
  a012 NUMBER default 1001101 not null,
  p003 VARCHAR2(16)
)
;
comment on column T_FREE_FORMULA.p001
  is '';
comment on column T_FREE_FORMULA.p002
  is 'ӱ(ڹΪ)';
comment on column T_FREE_FORMULA.a003
  is 'ID';
comment on column T_FREE_FORMULA.a004
  is 'ʱ(0:1·;1:1·;2:ȫ)';
comment on column T_FREE_FORMULA.a005
  is '(0:Ƚ;1:ֱ;2:)';
comment on column T_FREE_FORMULA.a006
  is '';
comment on column T_FREE_FORMULA.a007
  is 'ӹ(õ)';
comment on column T_FREE_FORMULA.a008
  is 'Ƚ(ֱõ)';
comment on column T_FREE_FORMULA.a009
  is 'С(Ƚõ)';
comment on column T_FREE_FORMULA.a010
  is 'ʾ';
comment on column T_FREE_FORMULA.a011
  is '';
comment on column T_FREE_FORMULA.a012
  is 'ʹ״̬( 1001101:Ч;1001102:Ч)';
comment on column T_FREE_FORMULA.p003
  is 'ű';

prompt
prompt Creating table T_IDX_D001
prompt =========================
prompt
create table T_IDX_D001
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a004 NUMBER,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_IDX_D001
  is 'ļָάȱ';
comment on column T_IDX_D001.p001
  is 'ָID';
comment on column T_IDX_D001.a002
  is 'ָ';
comment on column T_IDX_D001.a004
  is 'ID';
comment on column T_IDX_D001.a009
  is 'Դ';
comment on column T_IDX_D001.b099
  is 'ע';
comment on column T_IDX_D001.z100
  is '־';
alter table T_IDX_D001
  add constraint PK_T_IDX_D001 primary key (P001);

prompt
prompt Creating table T_IDX_D002
prompt =========================
prompt
create table T_IDX_D002
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a003 NUMBER(7,2),
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_IDX_D002
  is 'ʱĿάȱ';
comment on column T_IDX_D002.p001
  is 'ָID';
comment on column T_IDX_D002.a002
  is 'ָ';
comment on column T_IDX_D002.a003
  is 'ۿ۱';
comment on column T_IDX_D002.a009
  is 'Դ';
comment on column T_IDX_D002.b099
  is 'ע';
comment on column T_IDX_D002.z100
  is '־';
comment on column T_IDX_D002.c100
  is 'ǰ׺';
comment on column T_IDX_D002.d100
  is '׺';
comment on column T_IDX_D002.e100
  is '';
alter table T_IDX_D002
  add constraint T_IDX_D002_PRIMARY primary key (P001);

prompt
prompt Creating table T_IDX_D003
prompt =========================
prompt
create table T_IDX_D003
(
  p001 NUMBER not null,
  a002 VARCHAR2(128) not null,
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_IDX_D003
  is 'տĿάȱ';
comment on column T_IDX_D003.p001
  is 'ĿID';
comment on column T_IDX_D003.a002
  is 'Ŀ';
comment on column T_IDX_D003.a009
  is 'Դ';
comment on column T_IDX_D003.b099
  is 'ע';
comment on column T_IDX_D003.z100
  is '־';
comment on column T_IDX_D003.c100
  is 'ǰ׺';
comment on column T_IDX_D003.d100
  is '׺';
comment on column T_IDX_D003.e100
  is '';
alter table T_IDX_D003
  add constraint PK_T_IDX_D003 primary key (P001);

prompt
prompt Creating table T_IDX_D004
prompt =========================
prompt
create table T_IDX_D004
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a003 VARCHAR2(8),
  a004 VARCHAR2(128),
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_IDX_D004
  is 'ͻʽȫĿάȱ';
comment on column T_IDX_D004.p001
  is 'ĿID';
comment on column T_IDX_D004.a002
  is 'Ŀ';
comment on column T_IDX_D004.a003
  is '־';
comment on column T_IDX_D004.a004
  is 'ע';
comment on column T_IDX_D004.a009
  is 'Դ';
comment on column T_IDX_D004.b099
  is 'ע';
comment on column T_IDX_D004.z100
  is '־';
alter table T_IDX_D004
  add constraint PK_T_IDX_D004 primary key (P001);

prompt
prompt Creating table T_IDX_D005
prompt =========================
prompt
create table T_IDX_D005
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a003 VARCHAR2(8) not null,
  a004 VARCHAR2(128),
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8)
)
;
comment on table T_IDX_D005
  is 'ǰγ';
comment on column T_IDX_D005.p001
  is 'ĿID';
comment on column T_IDX_D005.a002
  is 'Ŀ';
comment on column T_IDX_D005.a003
  is '־';
comment on column T_IDX_D005.a004
  is 'ע';
comment on column T_IDX_D005.a009
  is 'Դ';
comment on column T_IDX_D005.b099
  is 'ע';
comment on column T_IDX_D005.z100
  is '־';
alter table T_IDX_D005
  add constraint PK_T_IDX_D005 primary key (P001);

prompt
prompt Creating table T_IDX_D006
prompt =========================
prompt
create table T_IDX_D006
(
  p001 NUMBER not null,
  a002 VARCHAR2(64) not null,
  a003 NUMBER(12,2),
  a009 NUMBER,
  b099 VARCHAR2(128),
  z100 VARCHAR2(8),
  c100 VARCHAR2(32),
  d100 VARCHAR2(32),
  e100 NUMBER
)
;
comment on table T_IDX_D006
  is 'ʱ׼Ŀάȱ';
comment on column T_IDX_D006.p001
  is 'ָID';
comment on column T_IDX_D006.a002
  is 'ָ';
comment on column T_IDX_D006.a003
  is 'ۿ۱';
comment on column T_IDX_D006.a009
  is 'Դ';
comment on column T_IDX_D006.b099
  is 'ע';
comment on column T_IDX_D006.z100
  is '־';
comment on column T_IDX_D006.c100
  is 'ǰ׺';
comment on column T_IDX_D006.d100
  is '׺';
comment on column T_IDX_D006.e100
  is '';
alter table T_IDX_D006
  add constraint PK_T_IDX_D006 primary key (P001);

prompt
prompt Creating table T_IDX_F003
prompt =========================
prompt
create table T_IDX_F003
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2) not null,
  w100 NUMBER not null
)
;
comment on table T_IDX_F003
  is 'ͻʽȫָʵ';
comment on column T_IDX_F003.p001
  is 'ID';
comment on column T_IDX_F003.p002
  is 'ĿID';
comment on column T_IDX_F003.p003
  is 'ָID';
comment on column T_IDX_F003.v
  is 'ֵָ';
comment on column T_IDX_F003.w100
  is 'ܲID';
alter table T_IDX_F003
  add constraint PK_T_IDX_F003 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_IDX_F004
prompt =========================
prompt
create table T_IDX_F004
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2) not null,
  w100 NUMBER not null
)
;
comment on table T_IDX_F004
  is 'ʱ()ʵ';
comment on column T_IDX_F004.p001
  is 'ID';
comment on column T_IDX_F004.p002
  is 'ĿID';
comment on column T_IDX_F004.p003
  is 'ָID';
comment on column T_IDX_F004.v
  is 'ֵָ';
comment on column T_IDX_F004.w100
  is 'ܲID';
alter table T_IDX_F004
  add constraint PK_T_IDX_F004 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_IDX_F005
prompt =========================
prompt
create table T_IDX_F005
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2),
  w100 NUMBER not null
)
;
comment on table T_IDX_F005
  is 'տָ()ʵ';
comment on column T_IDX_F005.p001
  is 'ID';
comment on column T_IDX_F005.p002
  is 'ĿID';
comment on column T_IDX_F005.p003
  is 'ָID';
comment on column T_IDX_F005.v
  is 'ֵָ';
comment on column T_IDX_F005.w100
  is 'ܲID';
alter table T_IDX_F005
  add constraint PK_T_IDX_F005 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_IDX_F006
prompt =========================
prompt
create table T_IDX_F006
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 NUMBER not null,
  v    NUMBER(19,2) not null,
  w100 NUMBER not null
)
;
comment on table T_IDX_F006
  is 'ʱ׼ʵ';
comment on column T_IDX_F006.p001
  is 'ID';
comment on column T_IDX_F006.p002
  is 'ĿID';
comment on column T_IDX_F006.p003
  is 'ָID';
comment on column T_IDX_F006.v
  is 'ֵָ';
comment on column T_IDX_F006.w100
  is 'ܲID';
alter table T_IDX_F006
  add constraint PK_T_IDX_F006 primary key (P001, P002, P003, W100);

prompt
prompt Creating table T_KRCS_CWCJ_CONFIG
prompt =================================
prompt
create table T_KRCS_CWCJ_CONFIG
(
  reportid           VARCHAR2(16),
  proid              NUMBER,
  proname            VARCHAR2(128),
  protype            VARCHAR2(1),
  formular           VARCHAR2(8),
  subjcode           VARCHAR2(16),
  subjname           VARCHAR2(64),
  colname            VARCHAR2(64),
  balanorient        VARCHAR2(1),
  orgid              VARCHAR2(16),
  productcode        VARCHAR2(16),
  productcode_height VARCHAR2(16)
)
;
comment on column T_KRCS_CWCJ_CONFIG.reportid
  is 'ID';
comment on column T_KRCS_CWCJ_CONFIG.proid
  is 'ĿID';
comment on column T_KRCS_CWCJ_CONFIG.proname
  is 'Ŀ';
comment on column T_KRCS_CWCJ_CONFIG.protype
  is 'ȡֵͣ0ĩ123ڳ';
comment on column T_KRCS_CWCJ_CONFIG.formular
  is '+   -';
comment on column T_KRCS_CWCJ_CONFIG.subjcode
  is 'Ŀ';
comment on column T_KRCS_CWCJ_CONFIG.subjname
  is 'Ŀ';
comment on column T_KRCS_CWCJ_CONFIG.colname
  is 'ֶ';
comment on column T_KRCS_CWCJ_CONFIG.balanorient
  is 'Ŀ1跽2';
comment on column T_KRCS_CWCJ_CONFIG.orgid
  is '˾ΣIDͳض';
comment on column T_KRCS_CWCJ_CONFIG.productcode
  is 'ƷΣoracleϵͳ൱ڶĿѲϵͳԲã';

prompt
prompt Creating table T_KRCS_CWCJ_CONFIG_20190404
prompt ==========================================
prompt
create table T_KRCS_CWCJ_CONFIG_20190404
(
  reportid           VARCHAR2(16),
  proid              NUMBER,
  proname            VARCHAR2(128),
  protype            VARCHAR2(1),
  formular           VARCHAR2(8),
  subjcode           VARCHAR2(16),
  subjname           VARCHAR2(64),
  colname            VARCHAR2(64),
  balanorient        VARCHAR2(1),
  orgid              VARCHAR2(16),
  productcode        VARCHAR2(16),
  productcode_height VARCHAR2(16)
)
;

prompt
prompt Creating table T_KRCS_CWCJ_CONFIG_20210203
prompt ==========================================
prompt
create table T_KRCS_CWCJ_CONFIG_20210203
(
  reportid           VARCHAR2(16),
  proid              NUMBER,
  proname            VARCHAR2(128),
  protype            VARCHAR2(1),
  formular           VARCHAR2(8),
  subjcode           VARCHAR2(16),
  subjname           VARCHAR2(64),
  colname            VARCHAR2(64),
  balanorient        VARCHAR2(1),
  orgid              VARCHAR2(16),
  productcode        VARCHAR2(16),
  productcode_height VARCHAR2(16)
)
;

prompt
prompt Creating table T_KRCS_CW_HL
prompt ===========================
prompt
create table T_KRCS_CW_HL
(
  from_currency   VARCHAR2(15),
  to_currency     VARCHAR2(15),
  conversion_date DATE,
  conversion_rate NUMBER
)
;

prompt
prompt Creating table T_MAP_CWXT_KM_UNFI
prompt =================================
prompt
create table T_MAP_CWXT_KM_UNFI
(
  company                VARCHAR2(25),
  acctsubjcode           VARCHAR2(25),
  begin_balance_dr       NUMBER,
  begin_balance_cr       NUMBER,
  local_begin_balance_dr NUMBER,
  local_begin_balance_cr NUMBER,
  period_net_dr          NUMBER,
  period_net_cr          NUMBER,
  local_period_net_dr    NUMBER,
  local_period_net_cr    NUMBER,
  period_name            VARCHAR2(15),
  period_year            NUMBER(15),
  period_num             NUMBER(15),
  nc_balance_dr          NUMBER,
  nc_balance_cr          NUMBER,
  local_nc_balance_dr    NUMBER,
  local_nc_balance_cr    NUMBER,
  beginbalance           NUMBER,
  endbalance             NUMBER,
  ncbalance              NUMBER,
  periodbalance          NUMBER,
  local_beginbalance     NUMBER,
  local_endbalance       NUMBER,
  local_ncbalance        NUMBER,
  local_periodbalance    NUMBER,
  currency               VARCHAR2(15),
  enddrbalance           NUMBER,
  local_enddrbalance     NUMBER,
  endcrbalance           NUMBER,
  local_endcrbalance     NUMBER
)
;
comment on table T_MAP_CWXT_KM_UNFI
  is 'ѲͶӰ';
comment on column T_MAP_CWXT_KM_UNFI.company
  is '˾';
comment on column T_MAP_CWXT_KM_UNFI.acctsubjcode
  is 'Ŀ';
comment on column T_MAP_CWXT_KM_UNFI.begin_balance_dr
  is 'ԭڳ跽';
comment on column T_MAP_CWXT_KM_UNFI.begin_balance_cr
  is 'ԭڳ';
comment on column T_MAP_CWXT_KM_UNFI.local_begin_balance_dr
  is 'ڳ跽';
comment on column T_MAP_CWXT_KM_UNFI.local_begin_balance_cr
  is 'ڳ';
comment on column T_MAP_CWXT_KM_UNFI.period_net_dr
  is 'ԭڼ跽';
comment on column T_MAP_CWXT_KM_UNFI.period_net_cr
  is 'ԭڼ';
comment on column T_MAP_CWXT_KM_UNFI.local_period_net_dr
  is 'ڼ跽';
comment on column T_MAP_CWXT_KM_UNFI.local_period_net_cr
  is 'ڼ';
comment on column T_MAP_CWXT_KM_UNFI.period_name
  is 'ڼ';
comment on column T_MAP_CWXT_KM_UNFI.period_year
  is '';
comment on column T_MAP_CWXT_KM_UNFI.period_num
  is '·';
comment on column T_MAP_CWXT_KM_UNFI.nc_balance_dr
  is 'ԭ跽';
comment on column T_MAP_CWXT_KM_UNFI.nc_balance_cr
  is 'ԭ';
comment on column T_MAP_CWXT_KM_UNFI.local_nc_balance_dr
  is '跽';
comment on column T_MAP_CWXT_KM_UNFI.local_nc_balance_cr
  is '';
comment on column T_MAP_CWXT_KM_UNFI.beginbalance
  is 'ԭڳ';
comment on column T_MAP_CWXT_KM_UNFI.endbalance
  is 'ԭĩ';
comment on column T_MAP_CWXT_KM_UNFI.ncbalance
  is 'ԭ';
comment on column T_MAP_CWXT_KM_UNFI.periodbalance
  is 'ԭҵ';
comment on column T_MAP_CWXT_KM_UNFI.local_beginbalance
  is 'ڳ';
comment on column T_MAP_CWXT_KM_UNFI.local_endbalance
  is 'ĩ';
comment on column T_MAP_CWXT_KM_UNFI.local_ncbalance
  is '';
comment on column T_MAP_CWXT_KM_UNFI.local_periodbalance
  is 'ҵ';
comment on column T_MAP_CWXT_KM_UNFI.currency
  is '';
comment on column T_MAP_CWXT_KM_UNFI.enddrbalance
  is 'ԭĩ跽';
comment on column T_MAP_CWXT_KM_UNFI.local_enddrbalance
  is 'ĩ跽';
comment on column T_MAP_CWXT_KM_UNFI.endcrbalance
  is 'ԭĩ';
comment on column T_MAP_CWXT_KM_UNFI.local_endcrbalance
  is 'ĩ';

prompt
prompt Creating table T_SYS_T017
prompt =========================
prompt
create table T_SYS_T017
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 VARCHAR2(32) not null,
  a004 VARCHAR2(128) not null,
  a005 NUMBER,
  a006 DATE
)
;
comment on table T_SYS_T017
  is 'Ի־';
comment on column T_SYS_T017.p001
  is '';
comment on column T_SYS_T017.p002
  is '';
comment on column T_SYS_T017.p003
  is '';
comment on column T_SYS_T017.a004
  is 'ʼ';
comment on column T_SYS_T017.a005
  is 'Ƿɹ';
comment on column T_SYS_T017.a006
  is '';
create index IDX_T_SYS_T017 on T_SYS_T017 (P001, P002);

prompt
prompt Creating table T_SYS_T018
prompt =========================
prompt
create table T_SYS_T018
(
  p001 NUMBER not null,
  p002 NUMBER not null,
  p003 VARCHAR2(64) not null,
  a004 VARCHAR2(128) not null,
  a005 NUMBER,
  a006 DATE not null
)
;
comment on table T_SYS_T018
  is 'ݲɼ־';
comment on column T_SYS_T018.p001
  is 'ݱ';
comment on column T_SYS_T018.p002
  is '';
comment on column T_SYS_T018.p003
  is 'Դ';
comment on column T_SYS_T018.a004
  is 'ݲɼ';
comment on column T_SYS_T018.a005
  is 'Ƿɹ 0-ɹ 1-ʧ';
comment on column T_SYS_T018.a006
  is '';
alter table T_SYS_T018
  add constraint PK_T_SYS_T018 primary key (P001, P002, P003, A006, A004);

prompt
prompt Creating table T_SYS_T029
prompt =========================
prompt
create table T_SYS_T029
(
  p001 VARCHAR2(8) not null,
  a002 NUMBER not null,
  a003 VARCHAR2(4000),
  a004 VARCHAR2(512),
  a005 VARCHAR2(16) not null,
  a006 DATE,
  a007 VARCHAR2(8),
  a008 NUMBER not null
)
;
comment on table T_SYS_T029
  is 'Ϣ';
comment on column T_SYS_T029.p001
  is '';
comment on column T_SYS_T029.a002
  is 'ϢID';
comment on column T_SYS_T029.a003
  is 'ϸϢ';
comment on column T_SYS_T029.a004
  is 'Ŀ';
comment on column T_SYS_T029.a005
  is '';
comment on column T_SYS_T029.a006
  is '';
comment on column T_SYS_T029.a007
  is '';
comment on column T_SYS_T029.a008
  is 'ܲӪҵIDţID';

prompt
prompt Creating table T_SYS_T050
prompt =========================
prompt
create table T_SYS_T050
(
  p001 NUMBER,
  p002 VARCHAR2(64),
  a003 VARCHAR2(256)
)
;
comment on table T_SYS_T050
  is 'ETLDBתñ';
comment on column T_SYS_T050.p001
  is 'ID';
comment on column T_SYS_T050.p002
  is 'ݱ';
comment on column T_SYS_T050.a003
  is 'ע';

prompt
prompt Creating table T_ZYRHHY_KHXX
prompt ============================
prompt
create table T_ZYRHHY_KHXX
(
  khbh  VARCHAR2(100),
  rcflx VARCHAR2(100),
  jgbs  VARCHAR2(10),
  bbg   NUMBER
)
;

prompt
prompt Creating sequence OPTION1_SEQ
prompt =============================
prompt
create sequence OPTION1_SEQ
minvalue 1
maxvalue 999999999999999999999999999
start with 111587
increment by 1
cache 20;

prompt
prompt Creating sequence SEQ_KRCSV3_COUNTERSIGN
prompt ========================================
prompt
create sequence SEQ_KRCSV3_COUNTERSIGN
minvalue 1
maxvalue 999999999999999999999999999
start with 881
increment by 1
cache 20;

prompt
prompt Creating view V_IDX_D002_0801
prompt =============================
prompt
create or replace force view v_idx_d002_0801 as
select "P001","A002","A003","A009","B099","Z100","C100","D100","E100"
    from cisp.T_IDX_D002
    WHERE P001 not in (15800,15900,16000,16100,16301,16302,18000);

prompt
prompt Creating view V_IDX_D003_0801
prompt =============================
prompt
create or replace force view v_idx_d003_0801 as
select "P001","A002","A009","B099","Z100","C100","D100","E100"
    from T_IDX_D003
    where p001 not in(1007,1008,1009,1010,1011,1012,1013,1014,1015,1016,1022);

prompt
prompt Creating type SPLIT_TYPE
prompt ========================
prompt
CREATE OR REPLACE TYPE "SPLIT_TYPE"                                          IS TABLE OF VARCHAR2 (4000)
/

prompt
prompt Creating type T_CAT
prompt ===================
prompt
CREATE OR REPLACE TYPE "T_CAT"                                          as object
(
union_mc VARCHAR2(256),
static function ODCIAggregateInitialize(sctx IN OUT t_cat) return number,
member function ODCIAggregateIterate(self IN OUT t_cat,value IN varchar2) return number,
member function ODCIAggregateTerminate(self IN t_cat,returnValue OUT varchar2, flags IN number) return number,
member function ODCIAggregateMerge(self IN OUT t_cat,ctx2 IN t_cat) return number
)
/

prompt
prompt Creating function CATSTR
prompt ========================
prompt
create or replace function catstr(v_mc varchar2) return varchar2 PARALLEL_ENABLE AGGREGATE USING t_cat;
/

prompt
prompt Creating function CISP_FORMULA_DICT_VALUE
prompt =========================================
prompt
create or replace function cisp_formula_dict_value(v_table  varchar2,
                                                   v_zd varchar2,
                                                   v_userid    varchar2)
  return varchar2 is
  /**********************************************
  *
  *: Ƚ͹ʽֵȡֵ
  *v_table 룬A1-1
  *      v_zd ֵ
  *      v_userid ǲ,ǲID,ܲӪҵ,ǻ
  ***********************************************/
  v_zdTable varchar(32);
  v_cell varchar2(64);
  v_condition varchar(64);
  v_sql   varchar(128);
  v_result  varchar(10);
  v_count  int;

begin
  select A003,A004,A005 into v_zdTable,v_cell,v_condition from t_formula_dict where P001 = v_table and A002 = v_zd;
  v_sql := 'select count(1) from '||v_zdTable||' where '||v_condition;
  execute  immediate v_sql into v_count;
  if v_count = 0 then
    return 'unexist';
  end if;

  v_sql := 'select nvl('||v_cell||',0) from '||v_zdTable||' where '||v_condition;
  execute  immediate v_sql into v_result;
  return nvl(v_result,0);
end cisp_formula_dict_value;
/

prompt
prompt Creating function CISP_GET_FORMULA
prompt ==================================
prompt
create or replace function cisp_get_formula(v_table  varchar2,
                                            v_table2  varchar2,
                                            v_bbq    varchar2
  )
   /**********************************************
  *
  *: ӱͱڵõع
  *v_table 룬A1-1
  *      v_table2 ӱ,A2-1,Ϊڹ,v_table2Ϊ
  *      v_bbq жǲűǹ˾/Ӫҵ
  *
  ***********************************************/
  return varchar2 is
  v_condition varchar2(1000);
  v_krcs_sql varchar2(4000);
  v_free_sql varchar2(4000);
  v_sql varchar2(4000);
begin
  v_condition := 'select a.a003 from t_cisp_formula a,t_free_formula b where a.p001 = b.p001 and nvl(a.p002,0) = nvl(b.p002,0) and a.a003 = b.a003 and a.a012=b.a012 and a.a012=1001101';
  v_condition := v_condition||' and a.p001 ='''||v_table||''' and nvl(a.p002,0)=nvl('''||v_table2||''',0)';
  if substr(v_bbq,5,2)=1 then
     v_krcs_sql := 'select a003,a005,a006,a007,a008,a009,a010,a011,p003 from t_cisp_formula where p001='''||v_table||''' and nvl(p002,0)=nvl('''||v_table2||''',0) and a012=1001101 and a004 in(0,2)';
     v_free_sql := 'select a003,a005,a006,a007,a008,a009,a010,a011,p003 from t_free_formula where p001='''||v_table||''' and nvl(p002,0)=nvl('''||v_table2||''',0) and a012=1001101 and a004 in(0,2)';
  else
     v_krcs_sql := 'select a003,a005,a006,a007,a008,a009,a010,a011,p003 from t_cisp_formula where p001='''||v_table||''' and nvl(p002,0)=nvl('''||v_table2||''',0) and a012=1001101 and a004 in(1,2)';
     v_free_sql := 'select a003,a005,a006,a007,a008,a009,a010,a011,p003 from t_free_formula where p001='''||v_table||''' and nvl(p002,0)=nvl('''||v_table2||''',0) and a012=1001101 and a004 in(1,2)';
  end if;

  v_krcs_sql := v_krcs_sql || ' and a003 not in('||v_condition||')';
  v_sql := v_krcs_sql|| ' union ' || v_free_sql;
  return v_sql;
end cisp_get_formula;
/

prompt
prompt Creating function F_LAST_REPORT_DATE
prompt ====================================
prompt
create or replace function f_last_report_date
  (
          in_this_report_date   in   varchar2,
          in_report_date_type   in   varchar2

  )
  return   varchar2   is
  /*
          ݱںͻȡһ
  */
          v_date   date;
          v_date_string varchar2(16);
  begin

          v_date_string:=replace(in_this_report_date,'-','');
          if in_report_date_type='1013001' then /* ± */
             v_date:=to_date(v_date_string, 'YYYYMM');
             return to_char(add_months(v_date, -1), 'YYYYMM')||'--';
          elsif in_report_date_type='1013002' then /* Ǽ */
             v_date:=to_date(v_date_string, 'YYYYMM');
             return to_char(add_months(v_date, -3), 'YYYYMM')||'--';
          elsif in_report_date_type='1013007' then /* ձ */
             v_date:=to_date(v_date_string, 'YYYYMMDD');
             return to_char(v_date-1, 'YYYYMMDD');
          end if;
  end   f_last_report_date;
/

prompt
prompt Creating function IS_CELL_NUMBER
prompt ================================
prompt
CREATE OR REPLACE FUNCTION is_cell_number(parmin VARCHAR2) RETURN NUMBER IS
--жϴĲǷΪ
  val NUMBER;
BEGIN
  val := TO_NUMBER(NVL(parmin, 'a'));
  RETURN 1;
EXCEPTION
  WHEN OTHERS THEN
    RETURN 0;
END;
/

prompt
prompt Creating function CISP_MAIN_EQUATION
prompt ====================================
prompt
create or replace function cisp_main_equation(v_table  varchar2,
                                               v_userid varchar2,
                                               v_bbq    varchar2,
                                               v_cell    varchar2)
  return varchar2 is
  /**********************************************
  *
  *: Ƚ͹ʽ
  *v_table 룬A1-1
  *      v_userid ǲ,ǲID,ܲӪҵ,ǻ
  *      v_bbq 
  *      v_cellԪ񡡿ʽC2/B1-1:C2/10/ZD:1001/SQ:A2/MX:A2/HJ:A2/C4-1:HJ:A2/SQ:HJ:A2
  ***********************************************/
  v_str varchar(128);
  v_rebbq varchar(8);   --,ȡ
  v_bbqtype varchar(7); --,ڼһ
  v_zdid   varchar(10);   --ֵID,ڲֵ

  v_retable varchar(16); --
  v_recell varchar(1000);    --Ҫѯֶ
  v_condition varchar(1000); --ѯ
  v_sql varchar(1000);
  v_tablename varchar(32);   --
  v_count   int;
  v_result  varchar(1000);
begin

  v_rebbq := v_bbq;
  v_retable := v_table;
  v_str := v_cell;
  v_recell:= v_cell;
  v_condition := ' and 1=1';

  /* ԴĵԪʽд*/
  if( is_cell_number(v_cell) =1) then
     return v_cell||';'||v_cell;
  end if;

  if instr(v_str,'ZD',1,1) > 0 then --ZD:1001
     --ֵ
     v_zdid := substr(v_str, 4);
     v_result := cisp_formula_dict_value(v_retable,v_zdid,v_userid);
     return v_str||';'||v_result;
  end if;

  if instr(v_str,'SQ',1,1) > 0  then-- SQ:A2ͣںϼơSQ:HJ:A2
    select distinct a006 into v_bbqtype from krcs.t_sys_t004 where a007=1008001 and a005= v_table;
    v_rebbq := f_last_report_date(v_bbq,v_bbqtype);
    v_recell  := substr(v_str,instr(v_str,':',1,1)+1);
    if instr(v_str,'HJ',1,1) > 0 then --ںϼơSQ:HJ:A2 Ӵ
      v_recell  := 'sum(nvl('||substr(v_str,instr(v_str,':',1,2)+1)||',0))';
      v_condition := ' and ishj=1';
    end if;
  elsif instr(v_str,'MX',1,1) > 0  then --ϸ MX:A2
    v_recell := 'sum(nvl('||substr(v_str,instr(v_str,':',1,1)+1)||',0))';
    v_condition := ' and ishj=0';
  elsif instr(v_str,'HJ',1,1) > 0 and instr(v_str,':',1,2) = 0 then -- ϼ HJ:A2
    v_recell := 'sum(nvl('||substr(v_str,instr(v_str,':',1,1)+1)||',0))';
    v_condition := ' and ishj=1';
  elsif instr(v_str,'HJ',1,1) > 0 and instr(v_str,':',1,2) > 0 then  --ϼ C4-1:HJ:A2
    v_retable := substr(v_str,0,instr(v_str,'HJ',1,1)-2);
    --v_recell := replace(v_str,v_retable,'');
    v_recell := 'sum(nvl('||substr(v_str,instr(v_str,':',1,2)+1)||',0))';
    v_condition := ' and ishj=1';
  elsif instr(v_str,':',1,1) > 0 then -- B1-1:C2
    v_retable := substr(v_str,0,instr(v_str,':',1,1)-1);
    v_recell := replace(v_recell,v_retable||':','');
  end if;--C2Ͳ

  /*ֵ͹ʽ*/
  select distinct B002 into v_tablename from  krcs.t_sys_t004 where a007=1008001 and a005= v_retable;
  if v_rebbq<>v_bbq then--,ѯǷ
    v_sql := 'select count(1) from '||v_tablename||' where userid='||v_userid||' and bbq='''||v_rebbq||'''';
    execute immediate v_sql into v_count;
    if v_count =0 then
       v_result:= v_cell||';unexist';
       return v_result;
    end if;
  end if;
  v_sql := 'select '||v_recell||' from '||v_tablename||' where userid='||v_userid||' and bbq='''||v_rebbq||'''';
  v_sql := v_sql||v_condition;
  execute immediate v_sql into v_result;

  --ֵ𣬷ֹּ ע(--)
  return v_cell||';('||nvl(v_result,0)||')';
end cisp_main_equation;
/

prompt
prompt Creating function F_GETCOMMENTS
prompt ===============================
prompt
CREATE OR REPLACE FUNCTION f_getcomments(v_table varchar2,colname VARCHAR2) RETURN varchar IS
--ݱֶλȡıע
  v_sql varchar2(1000);
  v_result varchar2(1000);
BEGIN
  v_sql := 'select T.a004   from  t_cisp_comments_config t where  upper(t.p001)=upper('''||v_table||''') AND upper(t.a003)=upper('''||colname||''')';

  execute immediate (v_sql) into v_result;

  RETURN v_result;

END;
/

prompt
prompt Creating function F_WITHOUT_ZERO
prompt ================================
prompt
create or replace function f_without_zero(v_formula       in varchar2)
  return varchar2 is
  /**********************************************
  *
  *ܣжʽǷгΪ0formulaаΪ0򷵻'false'򷵻'true'
  *formula ʽ229.28/(68.59-63.59-0)
  ***********************************************/
  v_return varchar2(8); --ֵ
  v_result number(19, 2);
  v_sql    varchar2(2000);
  v_left   varchar2(1000);
  v_right  varchar2(1000);
begin
  v_return := 'true';
  v_sql    := 'select ' || v_formula || ' from dual';
  execute immediate (v_sql) into v_result;
  return v_return;
  exception
  when zero_divide then
    v_return := 'false';
    return v_return;
end;
/

prompt
prompt Creating function IS_NUMBER
prompt ===========================
prompt
CREATE OR REPLACE FUNCTION is_number(parmin VARCHAR2) RETURN NUMBER IS
--жϴĲǷΪ
  val NUMBER;
  v_sql varchar2(1000);
  v_result varchar2(1000);
BEGIN
  v_sql := 'select '||parmin ||' from dual';
  execute immediate (v_sql) into v_result;
  val := TO_NUMBER(NVL(v_result, 'a'));
  RETURN 1;
EXCEPTION
  when zero_divide then
    RETURN 1;
  WHEN OTHERS THEN
    RETURN 0;
END;
/

prompt
prompt Creating function KRCS_GET_DEPTID_BY_DATATABLE
prompt ==============================================
prompt
create or replace function krcs_get_deptid_by_datatable(v_datatable varchar2)
  return varchar2 is
  v_deptid number;
  /*
    ݱõӦĲID
  */
begin
    select P001 into v_deptid from t_sys_t050 where P002 = v_datatable;
    return v_deptid;
end;
/

prompt
prompt Creating function KRCS_REPORTAUDIT_SHOW
prompt =======================================
prompt
create or replace function krcs_reportaudit_show(v_task     number, --̺
                                                 v_step     number, --̲
                                                 v_repid    number, --ID
                                                 v_orgid    number, --IDܲIDIDӪҵID
                                                 v_kjaxuser varchar2)
  return varchar2 is
  v_result number; --
  v_count  number;
  v_curischoice number; --ǰǷѡ
  v_isfirststep number; --Ƿһ

  /**
  ˽
  **/
begin
  v_result := 0;


  select A007, A005
    into v_curischoice, v_isfirststep
    from krcs.t_sys_t061
   where p001 = v_task
     and p002 = v_step;

  --ѡжϸòӦĻǷڿѡд
  if v_curischoice = 1001101 then
    select count(*)
      into v_count
      from krcs.t_sys_t064
     where p001 = v_task
       and p002 = v_step
       and p003 = v_orgid;
    --ڣʾòӦ
    if v_count = 0 then
      v_result := 0;
      return v_result;
    end if;

  end if;
  --жϸû״̬
  --ڳʼʱὫñӦ¼ɾԲΪһ¼ûеʱΪδ
  --ǵһܼ¼Ϊգǲʾǰһ˹Уһ¼¼
  select count(*)
    into v_count
    from krcs.t_sys_t066
   where p001 = v_task
     and p002 = v_step
     and p003 = v_repid
     and p004 = v_orgid
     and p005 = v_kjaxuser;

  --ûм¼
  if v_count = 0 then
    --ǵһ裬жϸûǷڸò˽ɫ
    if v_isfirststep = 1001101 then
      select count(*)
        into v_count
        from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role ur,krcs.t_sys_t001 d
       where a.p001 = v_task
         and a.p002 = v_step
         and a.p005 = v_repid
         and ur.p001=b.p001
         and d.p001=ur.a002
         and d.a006=v_task
         and ((c.A004 = 0 and a.p004 = b.p002) --ǹ˾ˣŵ100000
             or (c.A004 <> 0 and a.p004 = v_orgid)) --Ƿ֧ˣŵǷ֧IDID
         and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
             (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID
         and ((a.p003 is not null and ur.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
         and b.p001 = v_KJAXUSER
         and b.a011 = 1001101
         and c.p001 = a.p001
         and c.p002 = a.p002
         and not exists --̹УһûЧΪЧ
      --һ˼¼¼ʾ
       (select *
                from krcs.t_sys_t066
               where p001 = v_task
                 and p002 > v_step
                 and p003 = v_repid
                 and p004 = v_orgid);
      if v_count > 0 then
        v_result := 1;
      end if;
    end if;

  end if;

  --м¼жǷδ
  if v_count > 0 then
    select count(*)
      into v_count
      from krcs.t_sys_t066
     where p001 = v_task
       and p002 = v_step
       and p003 = v_repid
       and p004 = v_orgid
       and p005 = v_kjaxuser
       and a006 is null;
    if v_count > 0 then
      v_result := 1;
    end if;

  end if;

  return v_result;
end krcs_reportaudit_show;
/

prompt
prompt Creating function PPP
prompt =====================
prompt
create or replace function ppp(v_p002 number,v_jgid number) return varchar2
is
tmp varchar2(120);

cursor rad_A002 is select A002 from T_DACT_B_R002 where p002 = v_p002 and p001 = v_jgid;
V_A002 rad_A002%rowtype;

begin
     open rad_A002;
     fetch rad_A002 into V_A002;
           if V_A002.A002 is null then
               select '' into tmp from dual;
           else
               select A002 into tmp from T_DACT_B_R002 where p002 = v_p002 and p001 = v_jgid;
           end if;
     return(tmp);
     close rad_A002;
end;
/

prompt
prompt Creating function SPLIT
prompt =======================
prompt
CREATE OR REPLACE FUNCTION split(p_str       IN VARCHAR2,
                                 p_delimiter IN VARCHAR2) RETURN split_type IS
  j        INT := 0;
  i        INT := 1;
  len      INT := 0;
  len1     INT := 0;
  str      VARCHAR2(4000);
  my_split split_type := split_type();
BEGIN
  len  := LENGTH(p_str);
  len1 := LENGTH(p_delimiter);
  WHILE j < len LOOP
    j := INSTR(p_str, p_delimiter, i);
    IF j = 0 THEN
      j   := len;
      str := SUBSTR(p_str, i);
      my_split.EXTEND;
      my_split(my_split.COUNT) := str;
      IF i >= len THEN
        EXIT;
      END IF;
    ELSE
      str := SUBSTR(p_str, i, j - i);
      i   := j + len1;
      my_split.EXTEND;
      my_split(my_split.COUNT) := str;
    END IF;
  END LOOP;
  RETURN my_split;
END split;
/

prompt
prompt Creating procedure CISP_CHECK_DIRECT_CONDITION
prompt ==============================================
prompt
create or replace procedure cisp_check_direct_condition(errcode out int,
                                               errmsg out varchar2,
                                               v_table  varchar2,
                                               v_userid varchar2,
                                               v_bbq    varchar2,
                                               v_a006 varchar2,
                                               v_a008 varchar2)
                                               is
  /**********************************************
  *
  *: ֱ͹ʽ
  *v_table 룬A1-1
  *      v_userid ǲ,ǲID,ܲӪҵ,ǻ
  *      v_bbq 
  *      v_a006 
  *v_a008 Ƚ
  ***********************************************/
  v_sql varchar(1000);
  v_tablename varchar(32);
  v_count int;
begin
  errcode :=0;
  errmsg :='';

  select distinct B002 into v_tablename from  krcs.t_sys_t004 where a007=1008001 and a005= v_table;/*õ*/
  v_sql := 'select count(1) from '||v_tablename||' where userid='||v_userid||' and bbq='''||v_bbq||''' and '||v_a006;

  execute immediate (v_sql) into v_count;
  v_sql := 'select count(1) from dual where '||v_count||v_a008;
  execute immediate (v_sql) into errcode;
  return;
end cisp_check_direct_condition;
/

prompt
prompt Creating procedure CISP_CHECK_EQUATION
prompt ======================================
prompt
create or replace procedure cisp_check_equation(errcode out int,
                                               errmsg out varchar2,
                                               v_table  varchar2,
                                               v_table2  varchar2,
                                               v_userid varchar2,
                                               v_bbq    varchar2,
                                               v_a006 varchar2,
                                               v_a009 varchar2,
                                               v_p003 varchar2)
                                               is
  /**********************************************
  *
  *: Ƚ͹ʽ
  *v_table 룬A1-1
  *      v_table ӱ룬B1-1
  *      v_userid ǲ,ǲID,ܲӪҵ,ǻ
  *      v_bbq 
  *      v_a006 
  *v_a009 ʱСλ
  *v_p003 ű
  ***********************************************/
  v_formuala varchar(4000);
  v_formuala_temp varchar(4000);
  type curtype is ref cursor;
  c_work curtype;
  v_cell varchar(1000);
  v_sql varchar(1000);
  v_cell_value_list varchar(1000); --ܼĵԪֵ B1-1:A2;10
  v_cell_value_list_temp varchar(1000);
  v_index1      int;
  v_index2      int;
  v_cell_formula varchar(1000);
  v_cell_value   varchar(1000);
  v_equation_str varchar(100);  --Ƚʽ:=,>,<,>=,<=
  v_equation_inx varchar(100);   --Ƚʽλ
  v_left        varchar(1000);
  v_right        varchar(1000);
  v_left_num     varchar(100);
  v_right_num    varchar(100);
  v_format       varchar(100);
begin
    v_formuala_temp := v_a006;
    v_formuala := v_a006;
    v_formuala := replace(v_formuala, v_table2, 'TABLE2');--ַ滻,ֹмű滻
    v_formuala := replace(v_formuala, v_p003, 'TABLE3');--ַ滻,ֹмű滻
    v_formuala := replace(v_formuala, '+', '|');
    v_formuala := replace(v_formuala, '-', '|');
    v_formuala := replace(v_formuala, '*', '|');
    v_formuala := replace(v_formuala, '/', '|');
    v_formuala := replace(v_formuala, '(', '|');
    v_formuala := replace(v_formuala, ')', '|');
    v_formuala := replace(v_formuala, '^', '|');
    v_formuala := replace(v_formuala, '%', '|');
    v_formuala := replace(v_formuala, '!', '|');
    v_formuala := replace(v_formuala, '&', '|');
    v_formuala := replace(v_formuala, '>=', '|');
    v_formuala := replace(v_formuala, '>', '|');
    v_formuala := replace(v_formuala, '<=', '|');
    v_formuala := replace(v_formuala, '<', '|');
    v_formuala := replace(v_formuala, '=', '|');
    v_formuala := replace(v_formuala, 'null', '');
    v_formuala := replace(v_formuala, '||', '|');
    v_formuala := replace(v_formuala, 'TABLE2' ,v_table2);--ַ滻ر
    v_formuala := replace(v_formuala, 'TABLE3' ,v_p003);--ַ滻ر

    open c_work for select column_value from table(split(v_formuala, '|'));

    loop
      fetch c_work
      into v_cell;
      exit when c_work%notfound;
      if(is_number(v_cell) = 0) then --modify
        v_sql := cisp_main_equation(v_table,v_userid,v_bbq,v_cell);
        v_cell_value_list := v_cell_value_list || v_sql || ';';
      end if;
    end loop;
    close c_work;

    --Ҳֵ,(ֵ)
    if instr(v_cell_value_list, 'unexist', 1)> 0 then
      errcode :=2;
      if instr(substr(v_cell_value_list, 0, instr(v_cell_value_list, 'unexist', 1)), 'SQ', 1)>0 then
        errmsg :='ʽ'||v_a006||'Ҳ<font color=red></font>!';
      elsif instr(substr(v_cell_value_list, 0, instr(v_cell_value_list, 'unexist', 1)), 'ZD', 1)>0 then
        errmsg :='ʽ'||v_a006||'Ҳ<font color=red>ֵ</font>!';
      else
        errmsg :='ʽ'||v_a006||'Ҳ!';
      end if;
      return;
    end if;

    v_index2 :=1;

    v_cell_value_list_temp := v_cell_value_list;

    loop
       v_index1 := instr(v_cell_value_list_temp, ';', v_index2);
       exit when v_index1 <= 0;
       v_cell_formula := substr(v_cell_value_list_temp, v_index2, v_index1 - v_index2);
       v_index2    := v_index1 + 1;
       v_index1    := instr(v_cell_value_list_temp, ';', v_index2);
       exit when v_index1 <= 0;
       v_cell_value:= substr(v_cell_value_list_temp, v_index2, v_index1 - v_index2);
       v_index2  := v_index1 + 1;
       --滻ֵĵһַ
       v_formuala_temp := Replace(SUBSTR(v_formuala_temp,1,INSTR(v_formuala_temp, v_cell_formula, 1, 1) +length(v_cell_formula)),
                                    v_cell_formula,
                                    v_cell_value)
                            || SUBSTR(v_formuala_temp,
                                      INSTR(v_formuala_temp, v_cell_formula, 1, 1) + length(v_cell_formula) + 1,
                                      length(v_formuala_temp));
    end loop;

    if instr(v_formuala_temp, '>=', 1) >0 then
      v_equation_str := '>=';
    elsif instr(v_formuala_temp, '<=', 1) >0 then
      v_equation_str := '<=';
    elsif instr(v_formuala_temp, '<', 1) >0 then
      v_equation_str := '>';
    elsif instr(v_formuala_temp, '>', 1) >0 then
      v_equation_str := '>';
    else
      v_equation_str := '=';
    end if;

    v_equation_inx := instr(v_formuala_temp, v_equation_str, 1);
    v_left := substr(v_formuala_temp, 0, v_equation_inx-1);
    v_right := substr(v_formuala_temp, v_equation_inx+length(v_equation_str));

    --жʽǷΪֵʽ (ıȽڴ˴)
    if is_number(v_left) = 0  or is_number(v_right) = 0 then
      v_sql := 'select count(1) from dual where '''||v_left||''' = '''||v_right||'''';
      execute immediate (v_sql) into errcode;
      return;
    end if;

    --Ϊ0
    if f_without_zero(v_left)='false' or f_without_zero(v_right)='false' then
      errcode :=2;
      errmsg :='ʽ'||v_a006||'Ϊ<font color=red>0</font>!';
      return;
    end if;

    v_sql := 'select '||v_left||' from dual';
    execute immediate (v_sql) into v_left_num;
    v_left_num := round(to_number(v_left_num),v_a009);
    v_sql := 'select '||v_right||' from dual';
    execute immediate (v_sql) into v_right_num;
    v_right_num := round(to_number(v_right_num),v_a009);

    --жϹʽǷȷ
    v_sql := 'select count(*) from dual where '||v_left_num||v_equation_str||v_right_num;
    execute immediate (v_sql) into errcode;

    if(errcode = 0) then
      --ֵ0.06תַ.06
      v_format:='999,999,999,999,999,990.';
      for i in 1..v_a009 Loop
         v_format:=v_format||'0';
      end Loop;
      v_sql := 'select trim(to_char('||v_left_num||'-('||v_right_num||'),'''||v_format||''')) from dual';
      execute immediate (v_sql) into errmsg;
    end if;
    return;
end cisp_check_equation;
/

prompt
prompt Creating procedure CISP_CHECK_INDIRECT_CONDITION
prompt ================================================
prompt
create or replace procedure cisp_check_indirect_condition(errcode out int,
                                               errmsg out varchar2,
                                               v_table  varchar2,
                                               v_userid varchar2,
                                               v_bbq    varchar2,
                                               v_a006 varchar2,
                                               v_a007 varchar2)
                                               is
  /**********************************************
  *
  *: ͹ʽ
  *v_table 룬A1-1
  *      v_userid ǲ,ǲID,ܲӪҵ,ǻ
  *      v_bbq 
  *      v_a006 
  *v_a007 ӹ
  ***********************************************/
  v_sql varchar(1000);
  v_retable varchar(32);
  v_tablename varchar(32);
  v_count int;
  v_condition varchar(1000); --ӹ
begin
  errcode :=0;
  errmsg :='';
  v_retable := v_table;
  v_condition := v_a007;
  select distinct B002 into v_tablename from  krcs.t_sys_t004 where a007=1008001 and a005= v_retable;/*õ*/
  v_sql := 'select count(1) from '||v_tablename||' where userid='||v_userid||' and bbq='''||v_bbq||''' and '||v_a006;
  execute immediate (v_sql) into v_count;
  if v_count=0 then/*ȷ*/
    errcode :=1;
    return;
  end if;

  if instr(v_condition,':',1,1) > 0 then /*ӹ*/
    v_retable:= substr(v_condition, 0, instr(v_condition,':',1,1)-1);
    select distinct B002 into v_tablename from  krcs.t_sys_t004 where a007=1008001 and a005= v_retable;/*õ乴*/
    v_condition := substr(v_condition, instr(v_condition,':',1,1)+1);
  end if;

  v_sql := 'select count(1) from '||v_tablename||' where userid='||v_userid||' and bbq='''||v_bbq||''' and '||v_condition;
  execute immediate (v_sql) into errcode;
  return;

end cisp_check_indirect_condition;
/

prompt
prompt Creating procedure CISP_CHECK_REPORT
prompt ====================================
prompt
create or replace procedure cisp_check_report(errcode    out int,
                                              errmsg     out varchar2,
                                              v_KJAXUSER varchar2,
                                              v_TASK varchar2,
                                              v_table    varchar2,
                                              v_table2   varchar2,
                                              v_type     varchar2) is
  /**********************************************
  *ڴ洢
  *: ݱѯ֤ȯԶ年ʽ,й
  *v_table 룬A1-1
  *      v_table2 ӱ,A2-1,Ϊڹ,v_table2Ϊ
  *      v_type жǲűǹ˾/Ӫҵ
  *
  ***********************************************/
  v_userid varchar(16);
  v_bbq varchar(8);
  v_tablename varchar(32);
  v_tableCname varchar(64);
  v_tablename2 varchar(32);
  v_tableCname2 varchar(64);
  v_sql  varchar(4000);
  v_count int;
  v_flag  int;
  type curtype is ref cursor;
  c_work curtype;

  --ǹ
  v_A003 number;        --ID
  v_A005 varchar(1);    --(0:Ƚ;1:ֱ;2:)
  v_A006 varchar(128);  --
  v_A007 varchar(128);  --ӹ(õ)
  v_A008 varchar(8);    --Ƚ(ֱõ)
  v_A009 varchar(1);    --Ƚ(ֱõ)
  v_A010 varchar(1024); --ʾ
  v_A011 varchar(128);  --
  v_P003 varchar(32);   --ű

  v_result_code varchar(1000); --ؽ
  v_result_msg varchar(1000);  --ؽϢ
  v_sum  int;
begin

  --ǲ,õID,ܲӪҵ,õ
  select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
    from krcs.T_SYS_USER a, krcs.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

  --õǰں
  select distinct a.p001||'--',b.B002,b.A004 into v_bbq,v_tablename,v_tableCname from t_b00_d004 a,krcs.t_sys_t004 b
  where a.A002 = b.A006
    and a.C001=1001101
    and a.D100=1006002
    and b.a007=1008001
    and b.a005 = v_table;

  --ѯǷм¼
  v_sql := 'select count(1) from '||v_tablename||' where userid='||v_userid||' and bbq='''||v_bbq||'''';
  execute  immediate (v_sql) into v_count;
  if(v_count=0) then
       errcode:=1;
       errmsg:=v_tableCname||'ûݣδ';
       return;
  end if;

  --ӱ벻Ϊ,õӱ,ѯӱǷм¼
  if(v_table2 is not null) then
      select distinct  B002,A004 into v_tablename2,v_tableCname2 from krcs.t_sys_t004 where a007=1008001 and a005 = v_table;

   --жǷΪֹܷ
      select count(1) into v_flag from krcs.t_sys_t004 a,krcs.t_sys_t004 b
      where a.a005=v_table and b.a005=v_table2 and a.a002<>b.a002
      and a.a007=1008001 and b.a007=1008001;
      if(v_flag = 0) then
        v_sql := 'select count(1) from '||v_tablename2||' where userid='||v_userid||' and bbq='''||v_bbq||'''';
      else
        v_sql := 'select count(1) from '||v_tablename2||' where userid like '''||substr(v_userid,0,4)||'%'' and bbq='''||v_bbq||'''';
      end if;
      execute  immediate v_sql into v_count;
      if(v_count=0) then
          errcode:=1;
          errmsg:=v_tableCname2||'ûݣδ';
          return;
      end if;
  end if;

  delete from T_SYS_T029 where P001=v_table and nvl(A007,0)=nvl(v_table2,0) and a008=v_userid;/* ɾѾڵĴ־*/
  commit;
  --õѯʽ
  v_sql :=  cisp_get_formula(v_table,v_table2,v_bbq);

  v_sum := 0;
  --ѭÿʽӦ
  open c_work for v_sql;
  loop
    fetch c_work
    into v_A003, v_A005, v_A006, v_A007, v_A008, v_A009, v_A010, v_A011 ,v_P003;
    exit when c_work%notfound;


    if(v_A006 is not null) then
      --ʽ

      --Ƚ͹
      if v_A005 = 0 then
        cisp_check_equation(v_result_code,v_result_msg,v_table,v_table2,v_userid,v_bbq,v_A006,v_A009,v_P003);
        if v_result_code=2 then
          v_A010:=v_result_msg;
        elsif v_result_code=0 then
          v_A010 := replace(v_A010,'v_count',v_result_msg);
      end if;
      --ֱ͹
      elsif v_A005 = 1 then
      cisp_check_direct_condition(v_result_code,v_result_msg,v_table,v_userid,v_bbq,v_A006,v_A008);
      --͹
      elsif v_A005 = 2 then
      cisp_check_indirect_condition(v_result_code,v_result_msg,v_table,v_userid,v_bbq,v_A006,v_A007);
      end if;

      if v_result_code=0 or v_result_code=2 then
      insert into t_sys_t029(p001,a002,a003,a004,a005,a006,a007,a008)
        values(v_table,v_A003,v_A010,v_A011,v_KJAXUSER,sysdate,v_table2,v_userid);
      v_sum := v_sum +1;
      end if;
    end if;
  end loop;
  close c_work;

  if v_sum >0 then
    errcode :=1;
    errmsg := 'ɣ '||v_sum||' ';
  else
    errcode :=1;
    errmsg := 'ɣûз';
    insert into T_SYS_T029(P001,A002,A003,A004,A005,A006,A007,A008)
             values (v_table,100,'','',v_KJAXUSER,sysdate,v_table2,v_userid);
  end if;
end cisp_check_report;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_110006001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_110006001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;   /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      delete from t_b15_f001 where p001=v_date and p002>=1001 and p002<=1005 and w100 = v_bmid;

      insert into t_b15_f001(p001,p002,v,w100)
             select v_date,p001,a002,v_bmid
             from t_db1_01_001 where P001<>1001
             and w100 = v_bmid;

      insert into t_b15_f001(p001,p002,v,w100)
             select v_date,p001,a002/*+(select a002 from t_db1_01_001 where P001=1002)*/,v_bmid
             from t_db1_01_001 where P001=1001
             and w100 = v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=110006001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID110006001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 110006001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,a004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=110006001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_110006001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111001001
prompt ============================================
prompt
create or replace procedure CISP_CONVERT_DT_111001001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_org number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';
     /* õǰ */
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;

      delete from t_idx_f004 where p001=v_date and p003>=1001001 and p003<=1001004 and w100=v_bmid;

      --γȱ
      insert into t_idx_f004(p001,p002,p003,v,w100)
             select v_date,b.p001,1001001,nvl(a.a002,0),v_bmid
               from t_da_01_001 a,
                    T_IDX_D002 b
              where b.p001 = a.p001(+)
                and a.a100 =v_org
                and a.w100=v_bmid;

      insert into t_idx_f004(p001,p002,p003,v,w100)
             select v_date,b.p001,1001002,nvl(a.a003,0),v_bmid
               from t_da_01_001 a,
                    T_IDX_D002 b
              where b.p001 = a.p001(+)
                and a.a100 = v_org
                and a.w100=v_bmid;

      insert into t_idx_f004(p001,p002,p003,v,w100)
             select v_date,c.p001,1001003,
                    nvl(a.a002,0)*nvl(c.A003,0)/100,v_bmid
             from t_da_01_001 a,
                    T_IDX_D002 c
              where c.p001 = a.p001(+)
                and a.a100 = v_org
                and a.w100=v_bmid;

      insert into t_idx_f004(p001,p002,p003,v,w100)
             select v_date,c.p001,1001004,
             nvl(a.a003,0)*nvl(c.A003,0)/100,v_bmid
             from t_da_01_001 a,
                    T_IDX_D002 c
              where c.p001 = a.p001(+)
                and a.a100 = v_org
              and a.w100 =v_bmid;
      commit;
      --γȱ
       update t_idx_f004 a set a.v = (select nvl(v,0)
                                  from t_idx_f004
                                 where p002 = 11000
                                   and p003 = a.p003-2 and p001=v_date and w100 =v_bmid
                                 )
       where p002 = 11000 and p003 in(1001003,1001004) and p001=v_date and w100 =v_bmid;
       commit;
       --γȱ

      delete t_idx_f004 where p001=v_date and p002=12100;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,12100,p003,sum(v),v_bmid
             from t_idx_f004
              where  p002 between 12110 and 12190
               and p001=v_date
               and w100 =v_bmid
           group by p003;

      --γȱ
      --ȴ  ۿǰȯ = ۿǰе + ۿǰ޵
      --        ۿۺȯ = ۿǰȯ * ۿ۱
      --        ۿǰҵծȯ(˾ծȯ) = ۿǰе + ۿǰ޵
      --        ۿۺҵծȯ(˾ծȯ) = ۿǰҵծȯ(˾ծȯ) * ۿ۱


      delete t_idx_f004 where p001=v_date and p002=12400;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,12400,p003,sum(v),v_bmid
             from t_idx_f004
              where  p002 between 12410 and 12450
               and p001=v_date
               and w100 =v_bmid
           group by p003;
      commit;

      delete t_idx_f004 where p001=v_date and p002=12700;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,12700,p003,sum(v),v_bmid
             from t_idx_f004
              where  p002 between 12710  and 12730
               and p001=v_date
               and w100 =v_bmid
           group by p003;
      commit;


      delete t_idx_f004 where p001=v_date and p002=12000 and w100=v_bmid;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,12000,p003,sum(v),v_bmid
             from t_idx_f004
              where (p002 = 12100
                  or (p002 between 12200 and 12900 and p002 not in(12400,12700)))
               and p001=v_date
               and w100 =v_bmid
           group by p003;
       commit;


      --ȨȨȷķ
      update t_idx_f004 a set a.v =(select nvl(a.a002, 0) *nvl(c.A003, 0) / 100
                                    from t_da_01_001 a, T_IDX_D002 c
                                    where c.p001 = a.p001(+)
                                    and a.p001 = 16303
                                    and a.a100=v_org
                                    and a.w100 =v_bmid)
      where a.p002 = 16303 and a.p003 in(1001003)
      and a.p001=v_date and w100 =v_bmid;

      update t_idx_f004 a set a.v =(select nvl(a.a003, 0) *nvl(c.A003, 0) / 100
                                    from t_da_01_001 a, T_IDX_D002 c
                                    where c.p001 = a.p001(+)
                                    and a.p001 = 16303
                                    and a.a100=v_org
                                    and a.w100 =v_bmid)
      where a.p002 = 16303 and a.p003 in(1001004)
      and a.p001=v_date and w100 =v_bmid;

      --̶ʲ
      update t_idx_f004 a set a.v =(select nvl(a.a002, 0) *nvl(c.A003, 0) / 100
                                    from t_da_01_001 a, T_IDX_D002 c
                                    where c.p001 = a.p001(+)
                                    and a.p001 = 16304
                                    and a.a100=v_org
                                    and a.w100 =v_bmid)
      where a.p002 = 16304 and a.p003 in(1001003)
      and a.p001=v_date and w100 =v_bmid;

      update t_idx_f004 a set a.v =(select nvl(a.a003, 0) *nvl(c.A003, 0) / 100
                                    from t_da_01_001 a, T_IDX_D002 c
                                    where c.p001 = a.p001(+)
                                    and a.p001 = 16304
                                    and a.a100=v_org
                                    and a.w100 =v_bmid)
      where a.p002 = 16304 and a.p003 in(1001004)
      and a.p001=v_date and w100 =v_bmid;

      commit;

      --õӦ ʲķյϼ ڳĩ


  delete t_idx_f004 where p001=v_date and p002=14000 AND W100=v_bmid;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,14000,p003,sum(v),v_bmid
             from t_idx_f004
              where p002  between 14100 and 14300
               and p001=v_date
               and w100 =v_bmid
           group by p003;


commit;
      --õ       ֤ ڳĩ
      --γȱ
      update t_idx_f004 a set a.v = (
                              select nvl(sum(v),0)
                                from t_idx_f004
                               where p002 between 15601 and 15604
                                 and p003 = a.p003 and p001=v_date
                                 and w100 =v_bmid
                                )
      where a.p002 = 15600 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date and w100 =v_bmid;


      --õ       ڹȨͶʣй˾ĹȨͶʣڳĩ
      --γ
      update t_idx_f004 a set a.v = (
                              select nvl(sum(v),0)
                                from t_idx_f004
                               where p002 between 15701 and 15706
                                 and p003 = a.p003 and p001=v_date
                                 and w100 =v_bmid
                                )
      where a.p002 = 15700 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date and w100 =v_bmid;

      --õ       ̶ʲڳĩ
      --γ
      update t_idx_f004 a set a.v = (
                              select nvl(sum(v),0)
                                from t_idx_f004
                               where p002 between 16303 and 16304
                                 and p003 = a.p003 and p001=v_date
                                 and w100 =v_bmid
                                )
      where a.p002 = 16300 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date and w100 =v_bmid;

      --õ       ʲڳĩ
      --γ
      update t_idx_f004 a set a.v = (
                              select nvl(sum(v),0)
                                from t_idx_f004
                               where p002 between 16401 and 16402
                                 and p003 = a.p003 and p001=v_date
                                 and w100 =v_bmid
                                )
      where a.p002 = 16400 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date and w100 =v_bmid;


      --õ       Ӧտڳĩ
      --γ
      update t_idx_f004 a set a.v = (
                              select nvl(sum(v),0)
                                from t_idx_f004
                               where p002 between 16901 and 16904
                                 and p003 = a.p003 and p001=v_date
                                 and w100 =v_bmid
                                )
      where a.p002 = 16900 and a.p003 in(1001003,1001004) and a.p001=v_date and w100 =v_bmid;


      --õʲĿķյϼڳĩ
      --γ


 delete t_idx_f004 where p001=v_date and p002=15000 and w100=v_bmid;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,15000,p003,sum(v),v_bmid
             from t_idx_f004
              where p002 between 15100 and 17500
               and p002 not in (15600,15700,16300,16400,16900,15800,15900,16000,16100)
               and p001=v_date
               and w100 =v_bmid
           group by p003;


commit;
      --õиծķյϼڳĩ
      --γ

delete t_idx_f004 where p001=v_date and p002=19000 and w100=v_bmid;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,19000,p003,sum(v),v_bmid
             from t_idx_f004
              where  p002 in(19100,19101,19200)
               and p001=v_date
               and w100 =v_bmid
           group by p003;


commit;
      --õ й֤϶Ŀϼ ڳĩ
      --γ

delete t_idx_f004 where p001=v_date and p002=20000 and w100=v_bmid;
      insert into t_idx_f004(p001,p002,p003,v,w100)
         select v_date,20000,p003,sum(v),v_bmid
             from t_idx_f004
              where p002 between 20100 and 20200
               and p001=v_date
               and w100 =v_bmid
           group by p003;


commit;
      --õ ӣй֤׼Ŀ ڳĩ
      --γ
      update t_idx_f004 a set a.v = (
                              select nvl(sum(v),0)
                                from t_idx_f004
                               where p002 in(21100,21101)
                                 and p003 = a.p003 and p001=v_date
                                 and w100 =v_bmid
                                )
      where a.p002 = 21000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date and w100 =v_bmid;

         commit;
      --õ ʱ ڳĩ
   delete t_idx_f004 where p002=99999   and p003 in (1001003,1001004) and p001=v_date and w100=v_bmid;
   commit;
   insert into t_idx_f004(p001,p002,p003,v,w100)
             select v_date,99999,1001003,
             (select sum(decode(p002,11000,v,21000,v,-v)) from t_idx_f004
              where  p002 in (11000,12000,14000,15000,18001,19000,20000,21000)
              and p003=1001003 and p001=v_date
               and w100 =v_bmid)
              ,v_bmid
             from dual;

  insert into t_idx_f004(p001,p002,p003,v,w100)
             select v_date,99999,1001004,
            (select sum(decode(p002,11000,v,21000,v,-v)) from t_idx_f004
                    where  p002 in (11000,12000,14000,15000,18001,19000,20000,21000)
                and p003=1001004 and p001=v_date
               and w100 =v_bmid)
              ,v_bmid
             from dual;

      update krcs.t_sys_t022 set A007=1010001 where P001=111001001  and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111001001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111001001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111001001  and a004=v_bmid;
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_CONVERT_DT_111001001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002001
prompt ============================================
prompt
create or replace procedure CISP_CONVERT_DT_111002001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_org number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;

      delete from t_idx_f005 where p001=v_date and p003=1002001 or p003=1002002 and w100 =v_bmid;


      --γ
      insert into t_idx_f005(p001,p002,p003,v,w100)
      select v_date,p001,1002001,nvl(a002,0),v_bmid
        from T_DA_01_002
       where ((p001 between 1001 and 1006) or (p001 between 1023 and 1040) or (p001 between 1049 and 1101))
       and w100 =v_bmid and a100=v_org;

      insert into t_idx_f005(p001,p002,p003,v,w100)
      select v_date,p001,1002002,nvl(a003,0),v_bmid
        from T_DA_01_002
       where ((p001 between 1001 and 1006) or (p001 between 1023 and 1040)  or (p001 between 1049 and 1101))
       and w100 =v_bmid and a100=v_org ;


      update krcs.t_sys_t022 set A007=1010001 where P001=111002001  and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002001  and a004=v_bmid;
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_CONVERT_DT_111002001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002002
prompt ============================================
prompt
create or replace procedure CISP_CONVERT_DT_111002002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_org number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
	select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;

      update krcs.t_sys_t022 set A007=1010001 where P001=111002002 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 11100200;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_CONVERT_DT_111002002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002003
prompt ============================================
prompt
create or replace procedure CISP_CONVERT_DT_111002003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002003 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002003;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_CONVERT_DT_111002003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002004
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002004 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002004;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002004 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002005
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002005(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002005 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002005'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002005;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002005 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002005!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002006
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002006(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002006 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002006'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002006;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002006 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002006!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002007
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002007(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002007 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002007'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002007;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002007 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002007!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002008
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002008(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002008 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002008'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002008;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002008 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002008!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002009
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002009(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002009 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002009'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002009 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002009 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002009!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002010
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002010(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002010 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002010'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002010;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002010 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002010!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002011
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002011(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002011 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002011'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002011;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002011 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002011!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111002012
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111002012(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
      /*  ǰ5 ݱת ת Ҫκβֻ޸״̬ */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      update krcs.t_sys_t022 set A007=1010001 where P001=111002012 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111002012'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 111002012;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111002012 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111002012!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111003001
prompt ============================================
prompt
create or replace procedure CISP_convert_DT_111003001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_org number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      /* ֤ȯ˾ʱ׼(),added by Mr Zhao on 2008.7.31 */
      /* õǰ */
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;

      delete from t_idx_f006 where p001=v_date and p003>=1001001 and p003<=1001004
      and w100 =v_bmid;

      --Ĭϵõеļ¼ ĬΪӦ =*ΪվΪ0
      insert into t_idx_f006(p001,p002,p003,v,w100)
             select v_date,b.p001,1001001,nvl(a.a002,0),v_bmid
               from (select * from t_da_01_004 where  w100 =v_bmid and a100=v_org)a,
                    T_IDX_D006 b
              where b.p001 = a.p001(+);

      insert into t_idx_f006(p001,p002,p003,v,w100)
             select v_date,b.p001,1001002,nvl(a.a003,0),v_bmid
               from (select * from t_da_01_004 where  w100 =v_bmid and a100=v_org) a,
                    T_IDX_D006 b
              where b.p001 = a.p001(+);

      insert into t_idx_f006(p001,p002,p003,v,w100)
             select v_date,c.p001,1001003,
                    nvl(a.a002,0)*nvl(c.A003,0)/100,v_bmid
             from (select * from t_da_01_004 where  w100 =v_bmid and a100=v_org) a,
                    T_IDX_D006 c
              where c.p001 = a.p001(+);

      insert into t_idx_f006(p001,p002,p003,v,w100)
             select v_date,c.p001,1001004,
             nvl(a.a003,0)*nvl(c.A003,0)/100,v_bmid
             from (select * from t_da_01_004 where  w100 =v_bmid and a100=v_org) a,
                    T_IDX_D006 c
              where c.p001 = a.p001(+) ;


      --õ 1ҵʱ׼
      update t_idx_f006 a set a.v = (select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 12000 and 12000
                                   and p003 = a.p003 and p001=v_date
                                   and w100 =v_bmid
                                 )
       where a.p002 = 11000 and a.p003 in (1001001,1001002,1001003,1001004) and a.p001=v_date
         and w100 =v_bmid;


       --õ 2Ӫҵʱ׼
       --У1֤ȯƷͶʹģ
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 15000 and 17000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 14000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;

      --     2Ȩ֤ȯͶʹģ
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 19000 and 24000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 18000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;
      --     3̶֤ȯͶʹģ
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 26000 and 29000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 25000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;

      --        (4) ЧԳյӪȨ֤ȯͶ
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 in (30005,30010)
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 30000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;

       --        (5) ЧԳյĹ̶֤ȯͶ  modified(add) by  wull 2012-3-20
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 in (30105,30110)
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 30100 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;


      --  Ӫҵʱ׼
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 in (14000,18000,25000,30000,30100)
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 13000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;


      -- õ 3ҵʱ׼
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 32000 and 35000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 31000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;


      --õ 4ʲҵʱ׼
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 37000 and 39000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 36000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date and
        w100 =v_bmid;

      --õ 5ȯҵʱ׼
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 41000 and 42000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 40000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;

      --õ 6֧ʱ׼
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 44000 and 45000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 43000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;

      --õ 7Ӫ˷ʱ׼
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 47000 and 47000
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 46000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;


   --8ʱ׼
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 between 48005 and 48005
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 48000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;



      --õ ʱ׼֮
      update t_idx_f006 a set a.v = (
                                select nvl(sum(v),0)
                                  from t_idx_f006
                                 where p002 in (11000,13000,31000,36000,40000,43000,46000,48000)
                                   and p003 = a.p003
                                   and p001 = v_date
                                   and w100 =v_bmid
                                )
      where a.p002 = 49000 and a.p003 in(1001001,1001002,1001003,1001004) and a.p001=v_date
        and w100 =v_bmid;


      update krcs.t_sys_t022 set A007=1010001 where P001=111003001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID1001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 111003001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111003001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_convert_DT_111003001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111004001
prompt ============================================
prompt
create or replace procedure CISP_CONVERT_DT_111004001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_HL1 number(19,5);
      v_HL2 number(19,5);
      v_bmid number;
      v_org number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ'; /* ͻ׽ʽȫԼܱ,heqh update 2008.1.16*/


      select nvl(sum(a002),0) into v_HL1 from t_bks_t007 ;--$
      select nvl(sum(a003),0) into v_HL2 from t_bks_t007 ;--hk$ 

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;

      delete from t_idx_f003 where p001=v_date and p003>=1003001
                                               and p003<=1003004
                                               and w100 =v_bmid;

      insert into t_idx_f003(p001,p002,p003,v,w100)
                    select v_date,p001,1003001,nvl(a002,0),v_bmid
                    from T_DA_01_003
                    where w100 =v_bmid and a100=v_org;

      insert into t_idx_f003(p001,p002,p003,v,w100)
                    select v_date,p001,1003003,nvl(a003,0),v_bmid
                    from T_DA_01_003
                    where w100 =v_bmid and a100=v_org;

      insert into t_idx_f003(p001,p002,p003,v,w100)
                    select v_date,p001,1003002,nvl(a004,0),v_bmid
                    from T_DA_01_003
                    where w100 =v_bmid and a100=v_org;

      --ϵͳ
      insert into t_idx_f003(p001,p002,p003,v,w100)
                    select v_date,p001,1003004,nvl(a005,0),v_bmid
                    from T_DA_01_003
                    where w100 =v_bmid
                    and p001 not in (1200,1300)
		    and a100=v_org;

      insert into t_idx_f003(p001,p002,p003,v,w100)
      select v_date,p001,1003004,nvl(a002,0)+round(nvl(a003,0)*v_HL1,2)+round(nvl(a004,0)*v_HL2,2),v_bmid
      from T_DA_01_003
      where p001 in (1200,1300)
      and w100 =v_bmid and a100=v_org;

      update krcs.t_sys_t022 set A007=1010001 where P001=111004001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111004001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 111004001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111004001  and a004=v_bmid; /*޸ת״̬ */
                errcode := 0 ;
                errmsg := 'ڴ洢CISP_CONVERT_DT_111004001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111501001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_111501001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_temp1 varchar(256);
      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID


      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete t_act_f001 where p001=v_date and w100 =v_bmid;

      insert into T_ACT_F001(P001,P002,P003,V,W100)
           select v_date,p001,1003002,a002,v_bmid
           from T_DACT_001
           where w100 =v_bmid;

      insert into T_ACT_F001(P001,P002,P003,V,W100)
           select v_date,p001,1003001,a003,v_bmid
           from T_DACT_001
           where w100 =v_bmid;

      insert into T_ACT_F001(P001,P002,P003,V,W100)
           select v_date,p001,1003002,a002,v_bmid
           from T_DACT_002
           where w100 =v_bmid;

      insert into T_ACT_F001(P001,P002,P003,V,W100)
           select v_date,p001,1003001,a003,v_bmid
           from T_DACT_002
           where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(111501001,111501002) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111501001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 111501001;
      SELECT 'ݱתID111501002'||A002||'' INTO v_temp1 FROM krcs.T_SYS_T011 WHERE P001 = 111501002 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp1,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(111501001,111501002) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_111501001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111502001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_111502001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_act_f002 where p002 in (1002001,1002002) and p001=v_date and w100 =v_bmid;
      insert into t_act_f002(p001,p002,p003,v,w100)
             select v_date,1002001,p001,A002,v_bmid
             from t_dact_003
             where w100 =v_bmid;

      insert into t_act_f002(p001,p002,p003,v,w100)
             select v_date,1002002,p001,nvl(A002,0)+nvl(A003,0),v_bmid
             from t_dact_003
             where w100 =v_bmid;
      update krcs.t_sys_t022 set A007=1010001 where P001=111502001  and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111502001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 111502001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111502001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_111502001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111503001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_111503001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_act_f003 where p001=v_date and p003>=1001 and p003<=1009 and w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1001,a002,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1002,a003,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1003,a004,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1004,a005,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1005,a006,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1006,a007,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1007,a008,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1008,a009,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      insert into t_act_f003(p001,p002,p003,v,w100)
             select v_date,p001,1009,a010,v_bmid
             from t_dact_004
             where w100 =v_bmid;
      update krcs.t_sys_t022 set A007=1010001 where P001=111503001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111503001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 111503001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111503001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_111503001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_111504001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_111504001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ!';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_act_f004 where p001=v_date and p002>=1001001 and p002<=1001005
                               and w100 =v_bmid;
      insert into t_act_f004(p001,p003,p002,v,w100)
             select v_date,p001,1001001,A002,v_bmid
             from t_dact_005
             where w100 =v_bmid;
      insert into t_act_f004(p001,p003,p002,v,w100)
             select v_date,p001,1001002,A003,v_bmid
             from t_dact_005
             where w100 =v_bmid;
      insert into t_act_f004(p001,p003,p002,v,w100)
             select v_date,p001,1001003,A004,v_bmid
             from t_dact_005
             where w100 =v_bmid;
      insert into t_act_f004(p001,p003,p002,v,w100)
             select v_date,p001,1001004,A005,v_bmid
             from t_dact_005
             where w100 =v_bmid;
      insert into t_act_f004(p001,p003,p002,v,w100)
             select v_date,p001,1001005,A006,v_bmid
             from t_dact_005
             where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=111504001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID111504001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 111504001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=111504001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_111504001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112001001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112001001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp  varchar(256);
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
     -- v_hkrate_sq number;v_amrate_sq number;
      v_hk number;v_hkrate number;
      v_am number;v_amrate number;
      v_sum number;
      v_org1 number;v_org2 number;v_org3 number;v_org4 number;v_org5 number;v_org6 number;
      v_per1 number;v_per2 number;v_per3 number;v_per4 number;v_per5 number;v_per6 number;
      v_add1 number;v_add2 number;v_add3 number;v_add4 number;v_add5 number;v_add6 number;
      v_rdu1 number;v_rdu2 number;v_rdu3 number;v_rdu4 number;v_rdu5 number;v_rdu6 number;
      v_borg1 number;v_borg2 number;v_borg3 number;v_borg4 number;v_borg5 number;v_borg6 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ!';


      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select a002 into v_amrate from t_bks_t007;
      select a003 into v_hkrate from t_bks_t007;

      declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
        v_hk number;
        v_am number;
        v_sum number;
      cursor c_work is
           select p001,p002,nvl(a003,0) from t_db_01_001 where p001=1001102 and w100 =v_bmid;
      begin
      open c_work;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;
          v_add1:=0;v_add2:=0;v_add3:=0;v_add4:=0;v_add5:=0;v_add6:=0;
          select count(*) into v_count from t_db_01_001 where p001=1001102 and w100 =v_bmid;
      loop
         fetch c_work into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_add1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_add2:=v_EP003;
                 v_add3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_add4:=v_EP003;
                 v_add5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001102 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001102,a003,v_bmid
                      from T_DB_01_001 where p001=1001102 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001102,a003,v_bmid
                      from T_DB_01_001 where p001=1001102 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001102,v_hk,v_bmid);

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001102,a003,v_bmid
                      from T_DB_01_001 where p001=1001102 and p002=1004
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001102,v_am,v_bmid);

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001102,v_sum,v_bmid);
      v_add6:=v_sum;
      close c_work;
      end;
      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;
      cursor c_work1 is
           select p001,p002,a003 from t_db_01_001 where p001=1001103 and w100 =v_bmid;
      begin
      open c_work1;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;select count(*) into v_count from t_db_01_001 where p001=1001103 and w100 =v_bmid;
          v_rdu1:=0; v_rdu2:=0; v_rdu3:=0; v_rdu4:=0; v_rdu5:=0; v_rdu6:=0;
      loop
         fetch c_work1 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_rdu1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_rdu2:=v_EP003;
                 v_rdu3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_rdu4:=v_EP003;
                 v_rdu5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work1%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001103 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001103,a003,v_bmid
                      from T_DB_01_001 where p001=1001103 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001103,a003,v_bmid
                      from T_DB_01_001 where p001=1001103 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001103,v_hk,v_bmid );

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001103,a003,v_bmid
                      from T_DB_01_001 where p001=1001103 and p002=1004
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001103,v_am,v_bmid );

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001103,v_sum,v_bmid );
      v_rdu6:=v_sum;
      close c_work1;
      end;

      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;

      cursor c_work2 is
           select p001,p002,a003 from t_db_01_001 where p001=1001106 and w100 =v_bmid;
  begin
      open c_work2;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;select count(*) into v_count from t_db_01_001 where p001=1001106 and w100 =v_bmid;
          v_org1:=0; v_org2:=0; v_org3:=0; v_org4:=0; v_org5:=0; v_org6:=0;
      loop
         fetch c_work2 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_org1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_org2:=v_EP003;
                 v_org3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_org4:=v_EP003;
                 v_org5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work2%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001106 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001106,a003,v_bmid
                      from T_DB_01_001 where p001=1001106 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001106,a003,v_bmid
                      from T_DB_01_001 where p001=1001106 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001106,v_hk,v_bmid );

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001106,a003,v_bmid
                      from T_DB_01_001 where p001=1001106 and p002=1004
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001106,v_am,v_bmid );
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001106,v_sum,v_bmid );
      v_org6:=v_sum;
      close c_work2;
      end;

      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;

      cursor c_work3 is
           select p001,p002,a003 from t_db_01_001 where p001=1001107 and w100 =v_bmid;
  begin
      open c_work3;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;
          select count(*) into v_count from t_db_01_001 where p001=1001107 and w100 =v_bmid;
          v_per1:=0;v_per2:=0;v_per3:=0;v_per4:=0;v_per5:=0;v_per6:=0;
      loop
         fetch c_work3 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_per1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_per2:=v_EP003;
                 v_per3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_per4:=v_EP003;
                 v_per5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work3%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001107 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001107,a003,v_bmid
                      from T_DB_01_001 where p001=1001107 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001107,a003,v_bmid
                      from T_DB_01_001 where p001=1001107 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001107,v_hk,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001107,a003,v_bmid
                      from T_DB_01_001 where p001=1001107 and p002=1004
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001107,v_am,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001107,v_sum,v_bmid);
      v_per6:=v_sum;
      close c_work3;
      end;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001105 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1001,1001105,v_org1+v_per1,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1002,1001105,v_org2+v_per2,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001105,v_org3+v_per3,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1004,1001105,v_org4+v_per4,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001105,v_org5+v_per5,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001105,v_org6+v_per6,v_bmid);

      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;
      cursor c_work4 is
           select p001,p002,a003 from t_db_01_001 where p001=1001101 and w100 =v_bmid;
  begin
      open c_work4;
          --v_hk:=0;
          --v_am:=0;
          v_sum:=0;select count(*) into v_count from t_db_01_001 where p001=1001101 and w100 =v_bmid;
          v_borg1:=0; v_borg2:=0; v_borg3:=0; v_borg4:=0; v_borg5:=0; v_borg6:=0;
      loop
         fetch c_work4 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_borg1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 --v_hk:=round(v_EP003*v_hkrate,2);
                 v_borg2:=v_EP003;
                 --v_borg3:=v_hk;
                 --v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1003) then
                 --v_hk:=v_EP003;
                 v_borg3:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1004) then
                 --v_am:=round(v_EP003*v_amrate,2);
                 v_borg4:=v_EP003;
                 --v_borg5:=v_am;
                 --v_sum:=v_sum+v_am;
              end if;
              if(v_EP002=1005) then
                 --v_am:=v_EP003;
                 v_borg5:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work4%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001101 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1001
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1002
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                  select v_date,1003,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1003
                      and w100 =v_bmid;
                  -- values (v_date,1003,1001101,v_hk,v_bmid); --ڳת
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1004
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) 
             select v_date,1005,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1005
                      and w100 =v_bmid;
      --values (v_date,1005,1001101,v_am,v_bmid);--ڳת

      insert into t_b01_f003(p001,p002,p003,v,w100)
            select v_date,1006,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002 =1006
                      and w100 =v_bmid; 
      -- values (v_date,1006,1001101,v_sum,v_bmid);--ڳת
      v_borg6:=v_sum;
      close c_work4;
      end;

      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001104 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1001,1001104,(v_org1+v_per1)-v_borg1-v_add1+v_rdu1,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1002,1001104,(v_org2+v_per2)-v_borg2-v_add2+v_rdu2,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001104,(v_org3+v_per3)-v_borg3-v_add3+v_rdu3,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1004,1001104,(v_org4+v_per4)-v_borg4-v_add4+v_rdu4,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001104,(v_org5+v_per5)-v_borg5-v_add5+v_rdu5,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001104,(v_org6+v_per6)-v_borg6-v_add6+v_rdu6,v_bmid);


      update krcs.t_sys_t022 set A007=1010001 where P001=112001001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112001001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112001001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112001001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112001001!';
                return;
end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112001001_BK
prompt ===============================================
prompt
create or replace procedure cisp_convert_DT_112001001_bk(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp  varchar(256);
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
     -- v_hkrate_sq number;v_amrate_sq number;
      v_hk number;v_hkrate number;
      v_am number;v_amrate number;
      v_sum number;
      v_org1 number;v_org2 number;v_org3 number;v_org4 number;v_org5 number;v_org6 number;
      v_per1 number;v_per2 number;v_per3 number;v_per4 number;v_per5 number;v_per6 number;
      v_add1 number;v_add2 number;v_add3 number;v_add4 number;v_add5 number;v_add6 number;
      v_rdu1 number;v_rdu2 number;v_rdu3 number;v_rdu4 number;v_rdu5 number;v_rdu6 number;
      v_borg1 number;v_borg2 number;v_borg3 number;v_borg4 number;v_borg5 number;v_borg6 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ!';


      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select a002 into v_amrate from t_bks_t007;
      select a003 into v_hkrate from t_bks_t007;

      declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
        v_hk number;
        v_am number;
        v_sum number;
      cursor c_work is
           select p001,p002,nvl(a003,0) from t_db_01_001 where p001=1001102 and w100 =v_bmid;
      begin
      open c_work;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;
          v_add1:=0;v_add2:=0;v_add3:=0;v_add4:=0;v_add5:=0;v_add6:=0;
          select count(*) into v_count from t_db_01_001 where p001=1001102 and w100 =v_bmid;
      loop
         fetch c_work into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_add1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_add2:=v_EP003;
                 v_add3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_add4:=v_EP003;
                 v_add5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001102 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001102,a003,v_bmid
                      from T_DB_01_001 where p001=1001102 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001102,a003,v_bmid
                      from T_DB_01_001 where p001=1001102 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001102,v_hk,v_bmid);

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001102,a003,v_bmid
                      from T_DB_01_001 where p001=1001102 and p002=1004
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001102,v_am,v_bmid);

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001102,v_sum,v_bmid);
      v_add6:=v_sum;
      close c_work;
      end;
      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;
      cursor c_work1 is
           select p001,p002,a003 from t_db_01_001 where p001=1001103 and w100 =v_bmid;
      begin
      open c_work1;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;select count(*) into v_count from t_db_01_001 where p001=1001103 and w100 =v_bmid;
          v_rdu1:=0; v_rdu2:=0; v_rdu3:=0; v_rdu4:=0; v_rdu5:=0; v_rdu6:=0;
      loop
         fetch c_work1 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_rdu1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_rdu2:=v_EP003;
                 v_rdu3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_rdu4:=v_EP003;
                 v_rdu5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work1%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001103 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001103,a003,v_bmid
                      from T_DB_01_001 where p001=1001103 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001103,a003,v_bmid
                      from T_DB_01_001 where p001=1001103 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001103,v_hk,v_bmid );

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001103,a003,v_bmid
                      from T_DB_01_001 where p001=1001103 and p002=1004
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001103,v_am,v_bmid );

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001103,v_sum,v_bmid );
      v_rdu6:=v_sum;
      close c_work1;
      end;

      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;

      cursor c_work2 is
           select p001,p002,a003 from t_db_01_001 where p001=1001106 and w100 =v_bmid;
  begin
      open c_work2;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;select count(*) into v_count from t_db_01_001 where p001=1001106 and w100 =v_bmid;
          v_org1:=0; v_org2:=0; v_org3:=0; v_org4:=0; v_org5:=0; v_org6:=0;
      loop
         fetch c_work2 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_org1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_org2:=v_EP003;
                 v_org3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_org4:=v_EP003;
                 v_org5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work2%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001106 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001106,a003,v_bmid
                      from T_DB_01_001 where p001=1001106 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001106,a003,v_bmid
                      from T_DB_01_001 where p001=1001106 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001106,v_hk,v_bmid );

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001106,a003,v_bmid
                      from T_DB_01_001 where p001=1001106 and p002=1004
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001106,v_am,v_bmid );
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001106,v_sum,v_bmid );
      v_org6:=v_sum;
      close c_work2;
      end;

      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;

      cursor c_work3 is
           select p001,p002,a003 from t_db_01_001 where p001=1001107 and w100 =v_bmid;
  begin
      open c_work3;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;
          select count(*) into v_count from t_db_01_001 where p001=1001107 and w100 =v_bmid;
          v_per1:=0;v_per2:=0;v_per3:=0;v_per4:=0;v_per5:=0;v_per6:=0;
      loop
         fetch c_work3 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_per1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_per2:=v_EP003;
                 v_per3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_per4:=v_EP003;
                 v_per5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work3%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001107 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001107,a003,v_bmid
                      from T_DB_01_001 where p001=1001107 and p002=1001
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001107,a003,v_bmid
                      from T_DB_01_001 where p001=1001107 and p002=1002
                      and w100 =v_bmid;

      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001107,v_hk,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001107,a003,v_bmid
                      from T_DB_01_001 where p001=1001107 and p002=1004
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001107,v_am,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001107,v_sum,v_bmid);
      v_per6:=v_sum;
      close c_work3;
      end;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001105 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1001,1001105,v_org1+v_per1,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1002,1001105,v_org2+v_per2,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001105,v_org3+v_per3,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1004,1001105,v_org4+v_per4,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001105,v_org5+v_per5,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001105,v_org6+v_per6,v_bmid);

      declare
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_hk number;
      v_am number;
      v_sum number;
      cursor c_work4 is
           select p001,p002,a003 from t_db_01_001 where p001=1001101 and w100 =v_bmid;
  begin
      open c_work4;
          v_hk:=0;
          v_am:=0;
          v_sum:=0;select count(*) into v_count from t_db_01_001 where p001=1001101 and w100 =v_bmid;
          v_borg1:=0; v_borg2:=0; v_borg3:=0; v_borg4:=0; v_borg5:=0; v_borg6:=0;
      loop
         fetch c_work4 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_borg1:=v_EP003;
                 v_sum:=v_sum+v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_hk:=round(v_EP003*v_hkrate,2);
                 v_borg2:=v_EP003;
                 v_borg3:=v_hk;
                 v_sum:=v_sum+v_hk;
              end if;
              if(v_EP002=1004) then
                 v_am:=round(v_EP003*v_amrate,2);
                 v_borg4:=v_EP003;
                 v_borg5:=v_am;
                 v_sum:=v_sum+v_am;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work4%notfound;
      end loop;
      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001101 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1001,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1001
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1002,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1002
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001101,v_hk,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100)
                      select v_date,1004,1001101,a003,v_bmid
                      from T_DB_01_001 where p001=1001101 and p002=1004
                      and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001101,v_am,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001101,v_sum,v_bmid);
      v_borg6:=v_sum;
      close c_work4;
      end;

      delete t_b01_f003 where p001=v_date and p002>=1001 and p002<=1006 and p003=1001104 and w100 =v_bmid;
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1001,1001104,(v_org1+v_per1)-v_borg1-v_add1+v_rdu1,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1002,1001104,(v_org2+v_per2)-v_borg2-v_add2+v_rdu2,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1003,1001104,(v_org3+v_per3)-v_borg3-v_add3+v_rdu3,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1004,1001104,(v_org4+v_per4)-v_borg4-v_add4+v_rdu4,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1005,1001104,(v_org5+v_per5)-v_borg5-v_add5+v_rdu5,v_bmid);
      insert into t_b01_f003(p001,p002,p003,v,w100) values (v_date,1006,1001104,(v_org6+v_per6)-v_borg6-v_add6+v_rdu6,v_bmid);


      update krcs.t_sys_t022 set A007=1010001 where P001=112001001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112001001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112001001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112001001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112001001!';
                return;
end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112001002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112001002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_beg1 number;v_beg2 number;v_beg3 number;
      v_open1 number;v_open2 number;v_open3 number;
      v_close1 number;v_close2 number;v_close3 number;

      v_xmzzc1 number;v_xmzzc2 number;v_xmzzc3 number;
      v_bhgzzc1 number;v_bhgzzc2 number;v_bhgzzc3 number;
      v_zczxm1 number;v_zczxm2 number;v_zczxm3 number;
      v_zczbhg1 number;v_zczbhg2 number;v_zczbhg3 number;
       v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work is
           select p001,p002,nvl(a003,0) from t_db_01_002 where p001=1001001 and w100 =v_bmid;
      begin
      open c_work;
          v_beg1:=0;v_beg2:=0;v_beg3:=0;
          select count(*) into v_count from t_db_01_002 where p001=1001001 and w100 =v_bmid;
      loop
         fetch c_work into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_beg1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_beg2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_beg3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work%notfound;
      end loop;
      close c_work;
      end;

        declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work1 is
           select p001,p002,nvl(a003,0) from t_db_01_002 where p001=1001002 and w100 =v_bmid;
      begin
      open c_work1;
          v_open1:=0;v_open2:=0;v_open3:=0;
          select count(*) into v_count from t_db_01_002 where p001=1001002 and w100 =v_bmid;
      loop
         fetch c_work1 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_open1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_open2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_open3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work1%notfound;
      end loop;
      close c_work1;
      end;

       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work2 is
           select p001,p002,nvl(a003,0) from t_db_01_002 where p001=1001003 and w100 =v_bmid;
      begin
      open c_work2;
          v_close1:=0;v_close2:=0;v_close3:=0;
          select count(*) into v_count from t_db_01_002 where p001=1001003 and w100 =v_bmid;
      loop
         fetch c_work2 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_close1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_close2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_close3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work2%notfound;
      end loop;
      close c_work2;
      end;

       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work3 is
           select p001,p002,nvl(a003,0) from t_db_01_002 where p001=1001020 and w100 =v_bmid;
      begin
      open c_work3;
          v_xmzzc1:=0;v_xmzzc2:=0;v_xmzzc3:=0;
          select count(*) into v_count from t_db_01_002 where p001=1001020 and w100 =v_bmid;
      loop
         fetch c_work3 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_xmzzc1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_xmzzc2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_xmzzc3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work3%notfound;
      end loop;
      close c_work3;
      end;


       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work4 is
           select p001,p002,nvl(a003,0) from t_db_01_002 where p001=1001021 and w100 =v_bmid;
      begin
      open c_work4;
          v_bhgzzc1:=0;v_bhgzzc2:=0;v_bhgzzc3:=0;
          select count(*) into v_count from t_db_01_002 where p001=1001021 and w100 =v_bmid;
      loop
         fetch c_work4 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_bhgzzc1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_bhgzzc2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_bhgzzc3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work4%notfound;
      end loop;
      close c_work4;
      end;


       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work5 is
           select p001,p002,nvl(a003,0) from t_db_01_002 where p001=1001022 and w100 =v_bmid;
      begin
      open c_work5;
          v_zczxm1:=0;v_zczxm2:=0;v_zczxm3:=0;
          select count(*) into v_count from t_db_01_002 where p001=1001022 and w100 =v_bmid;
      loop
         fetch c_work5 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_zczxm1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_zczxm2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_zczxm3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work5%notfound;
      end loop;
      close c_work5;
      end;



       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work6 is
           select p001,p002,nvl(a003,0) from t_db_01_002 where p001=1001023 and w100 =v_bmid;
      begin
      open c_work6;
          v_zczbhg1:=0;v_zczbhg2:=0;v_zczbhg3:=0;
          select count(*) into v_count from t_db_01_002 where p001=1001023 and w100 =v_bmid;
      loop
         fetch c_work6 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_zczbhg1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_zczbhg2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_zczbhg3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work6%notfound;
      end loop;
      close c_work6;
      end;
      --end

      delete t_b01_f002 where p001=v_date and p002>=1001 and p002<=1003 and w100 =v_bmid;
      delete t_b01_f002 where p001=v_date and p002=1004 and p003 in (1001001,1001002,1001017,1001018,1001019,1001003,1001020,1001021,1001022,1001023,1001004,1001005,1001006) and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1001,P001,nvl(a003,0),v_bmid
      from T_DB_01_002 WHERE P002=1001
      and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1002,P001,nvl(a003,0),v_bmid
      from T_DB_01_002 WHERE P002=1002 and w100 =v_bmid;


      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1003,P001,nvl(a003,0),v_bmid
      from T_DB_01_002 WHERE P002=1003 and w100 =v_bmid;


      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001001,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001001 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001002,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001002 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001003,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001003 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001005,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001005 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001006,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001006 and w100 =v_bmid;

      --ʽ˻Ͽ
       insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001017,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001017 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001018,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001018 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001019,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001019 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001020,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001020 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001021,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001021 and w100 =v_bmid;

        insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001022,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001022 and w100 =v_bmid;

      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001023,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001=1001023 and w100 =v_bmid;
      
      
      delete t_b01_f002 where p001=v_date and p002>=1001 and p002<=1004 and p003=1001004 and w100 =v_bmid;
      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1001,1001004,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001 in (1001005,1001006) 
      and p002=1001 and w100 =v_bmid;
      commit;
      
      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1002,1001004,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001 in (1001005,1001006) 
      and p002=1002 and w100 =v_bmid;
      commit;
      
      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1003,1001004,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001 in (1001005,1001006) 
      and p002=1003 and w100 =v_bmid;
      commit;
      
      insert into t_b01_f002(p001,p002,p003,v,w100)
      select v_date,1004,1001004,nvl(sum(a003),0),v_bmid
      from T_DB_01_002 WHERE P001 in (1001005,1001006) 
      and p002 in (1001,1002,1003) and w100 =v_bmid;
      
     
      
      --insert into t_b01_f002(p001,p002,p003,v,w100) values (v_date,1001,1001004,v_beg1+v_open1-v_close1+v_xmzzc1+v_bhgzzc1-v_zczxm1-v_zczbhg1,v_bmid);
      --insert into t_b01_f002(p001,p002,p003,v,w100) values (v_date,1003,1001004,v_beg2+v_open2-v_close2+v_xmzzc2+v_bhgzzc2-v_zczxm2-v_zczbhg2,v_bmid);
      --insert into t_b01_f002(p001,p002,p003,v,w100) values (v_date,1002,1001004,v_beg3+v_open3-v_close3+v_xmzzc3+v_bhgzzc3-v_zczxm3-v_zczbhg3,v_bmid);
      --insert into t_b01_f002(p001,p002,p003,v,w100) values (v_date,1004,1001004,(v_beg1+v_open1-v_close1+v_xmzzc1+v_bhgzzc1-v_zczxm1-v_zczbhg1)+
      --(v_beg2+v_open2-v_close2+v_xmzzc2+v_bhgzzc2-v_zczxm2-v_zczbhg2)+(v_beg3+v_open3-v_close3+v_xmzzc3+v_bhgzzc3-v_zczxm3-v_zczbhg3),v_bmid);
      update krcs.t_sys_t022 set A007=1010001 where P001=112001002 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112001002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112001002;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112001002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112001002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112001003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112001003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_EP001 integer;
      v_EP002 integer;
      v_EP003 number;
      v_count integer;
      v_beg1 number;v_beg2 number;v_beg3 number;
      v_open1 number;v_open2 number;v_open3 number;
      v_input1 number;v_input2 number;v_input3 number;
      v_close1 number;v_close2 number;v_close3 number;
      v_output1 number;v_output2 number;v_output3 number;
       v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work is
           select p001,p002,nvl(a003,0) from t_db_01_003 where p001=1001007 and w100 =v_bmid;
      begin
      open c_work;
          v_beg1:=0;v_beg2:=0;v_beg3:=0;
          select count(*) into v_count from t_db_01_003 where p001=1001007 and w100 =v_bmid;
      loop
         fetch c_work into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_beg1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_beg2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_beg3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work%notfound;
      end loop;
      close c_work;
      end;

       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work1 is
           select p001,p002,a003 from t_db_01_003 where p001=1001008 and w100 =v_bmid;
      begin
      open c_work1;
          v_open1:=0;v_open2:=0;v_open3:=0;
          select count(*) into v_count from t_db_01_003 where p001=1001008 and w100 =v_bmid;
      loop
         fetch c_work1 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_open1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_open2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_open3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work1%notfound;
      end loop;
      close c_work1;
      end;

       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work2 is
           select p001,p002,a003 from t_db_01_003 where p001=1001009 and w100 =v_bmid;
      begin
      open c_work2;
          v_input1:=0;v_input2:=0;v_input3:=0;
          select count(*) into v_count from t_db_01_003 where p001=1001009 and w100 =v_bmid;
      loop
         fetch c_work2 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_input1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_input2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_input3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work2%notfound;
      end loop;
      close c_work2;
      end;

      declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work3 is
           select p001,p002,a003 from t_db_01_003 where p001=1001010 and w100 =v_bmid;
      begin
      open c_work3;
          v_close1:=0;v_close2:=0;v_close3:=0;
          select count(*) into v_count from t_db_01_003 where p001=1001010 and w100 =v_bmid;
      loop
         fetch c_work3 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_close1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_close2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_close3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work3%notfound;
      end loop;
      close c_work3;
      end;

       declare
        v_EP001 integer;
        v_EP002 integer;
        v_EP003 number;
        v_count integer;
      cursor c_work4 is
           select p001,p002,a003 from t_db_01_003 where p001=1001011 and w100 =v_bmid;
      begin
      open c_work4;
          v_output1:=0;v_output2:=0;v_output3:=0;
          select count(*) into v_count from t_db_01_003 where p001=1001011 and w100 =v_bmid;
      loop
         fetch c_work4 into v_EP001,v_EP002,v_EP003;
         if(v_count !=0) then
              if(v_EP002=1001) then
                 v_output1:=v_EP003;
              end if;
              if(v_EP002=1003) then
                 v_output2:=v_EP003;
              end if;
              if(v_EP002=1002) then
                 v_output3:=v_EP003;
              end if;
         end if ;
         v_count:=v_count -1;
         exit when c_work4%notfound;
      end loop;
      close c_work4;
      end;

      delete t_b01_f001 where p001=v_date and p002>=1001 and p002<=1003 and w100 =v_bmid;
      delete t_b01_f001 where p001=v_date and p002=1004 and p003 in (1001007,1001008,1001009,1001010,1001011,1001012,1001013,1001014,1001015,1001016,1001024,1001025,1001026,1001027,1001028,1001029) and w100 =v_bmid;
      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1001,P001,a003,v_bmid
      from T_DB_01_003 WHERE P002=1001
      and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1003,P001,a003,v_bmid
      from T_DB_01_003 WHERE P002=1003
      and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1002,P001,a003,v_bmid
      from T_DB_01_003 WHERE P002=1002
      and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001007,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001007 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001008,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001008 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001009,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001009 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001010,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001010 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001011,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001011 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001013,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001013 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001014,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001014 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001015,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001015 and w100 =v_bmid;

      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001016,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001016 and w100 =v_bmid;
      --֤ȯ˻Ͽ
      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001024,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001024 and w100 =v_bmid;


      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001025,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001025 and w100 =v_bmid;


      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001026,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001026 and w100 =v_bmid;


      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001027,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001027 and w100 =v_bmid;


      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001028,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001028 and w100 =v_bmid;


      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001029,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001=1001029 and w100 =v_bmid;
      
      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1001,1001012,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001 in (1001013,1001014) and p002=1001
      and w100 =v_bmid;
      
      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1002,1001012,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001 in (1001013,1001014) and p002=1002
      and w100 =v_bmid;
      
      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1003,1001012,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001 in (1001013,1001014) and p002=1003
      and w100 =v_bmid;
      
      insert into t_b01_f001(p001,p002,p003,v,w100)
      select v_date,1004,1001012,sum(a003),v_bmid
      from T_DB_01_003 WHERE p001 in (1001013,1001014) 
      and p002 in (1001,1002,1003)
      and w100 =v_bmid;

      --insert into t_b01_f001 (p001,p002,p003,v,w100) values (v_date,1001,1001012,v_beg1+v_open1+v_input1-v_close1-v_output1,v_bmid) ;
      --insert into t_b01_f001 (p001,p002,p003,v,w100) values (v_date,1003,1001012,v_beg2+v_open2+v_input2-v_close2-v_output2,v_bmid) ;
      --insert into t_b01_f001 (p001,p002,p003,v,w100) values (v_date,1002,1001012,v_beg3+v_open3+v_input3-v_close3-v_output3,v_bmid) ;
      --insert into t_b01_f001 (p001,p002,p003,v,w100) values (v_date,1004,1001012,(v_beg1+v_open1+v_input1-v_close1-v_output1)+(v_beg2+v_open2+v_input2-v_close2-v_output2)+(v_beg3+v_open3+v_input3-v_close3-v_output3),v_bmid) ;
      update krcs.t_sys_t022 set A007=1010001 where P001=112001003 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112001003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112001003;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112001003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112001003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112001004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112001004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)
is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
begin
     errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from T_B01_F020
      where p001=v_date and w100 =v_bmid;

      --ڳ
      insert into T_B01_F020(P001,P002,P003,V,W100)
      select v_date,P001,1004001,A002, v_bmid
      from T_DB_01_020 a
      where w100 =v_bmid;

      --
      insert into T_B01_F020(P001,P002,P003,V,W100)
      select v_date,P001,1004002,A003 , v_bmid
      from T_DB_01_020 a
      where w100 =v_bmid;

      --ڼ
      insert into T_B01_F020(P001,P002,P003,V,W100)
      select v_date,P001,1004003,A004 , v_bmid
      from T_DB_01_020 a
      where w100 =v_bmid;

      --ĩ
      insert into T_B01_F020(P001,P002,P003,V,W100)
      select v_date,P001,1004004,A005 , v_bmid
      from T_DB_01_020 a
      where w100 =v_bmid;

      SELECT 'ݱתID112001004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112001004 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112001004 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112001004!';
                return;


end cisp_convert_DT_112001004;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112002001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112002001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_HL1 number(19,5);v_HL2 number(19,5);
      v_E01 number(19,2);v_E02 number(19,2);v_E03 number(19,2);v_E04 number(19,2);
      v_E05 number(19,2);v_E06 number(19,2);v_E07 number(19,2);v_E08 number(19,2);
      v_E11 number(19,2);v_E12 number(19,2);v_E13 number(19,2);v_E14 number(19,2);
      v_E15 number(19,2);v_E16 number(19,2);v_E17 number(19,2);v_E18 number(19,2);
      v_EP101 number(19,2);v_EP102 number(19,2);v_EP103 number(19,2);
      v_EP201 number(19,2);v_EP202 number(19,2);v_EP203 number(19,2);
      v_EP111 number(19,2); v_EP222 number(19,2);v_EP333 number(19,2); v_EP444 number(19,2);
      v_bmid number;
      v_status number;
  begin



      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      select nvl(sum(a002),0) into v_HL1 from t_bks_t007 ;--$
      select nvl(sum(a003),0) into v_HL2 from t_bks_t007 ;--hk$ 
      --B
      select nvl(sum(a003),0) into v_E01 from t_db_01_004
      where p001=1001102 and a002=1001 and w100 =v_bmid;--B

      select nvl(sum(a004),0) into v_E02 from t_db_01_004
      where p001=1001102 and a002=1001 and w100 =v_bmid;--ڱۼB()

      select nvl(sum(a003),0) into v_E03 from t_db_01_004
      where p001=1001103 and a002=1001 and w100 =v_bmid;--ڻB

      select nvl(sum(a004),0) into v_E04 from t_db_01_004
      where p001=1001103 and a002=1001 and w100 =v_bmid;--ڱۼƻB()

      select nvl(sum(a003),0) into v_E05 from t_db_01_004
      where p001=1001102 and a002=1002 and w100 =v_bmid;--B

      select nvl(sum(a004),0) into v_E06 from t_db_01_004
      where p001=1001102 and a002=1002 and w100 =v_bmid;--ڱۼB()

      select nvl(sum(a003),0) into v_E07 from t_db_01_004
      where p001=1001103 and a002=1002 and w100 =v_bmid;--ڻB

      select nvl(sum(a004),0) into v_E08 from t_db_01_004
      where p001=1001103 and a002=1002 and w100 =v_bmid;--ڱۼƻB()

      v_E11:=nvl(v_E01*v_HL2,0);--Brmb
      v_E12:=v_E11+v_E02;       --ۼBrmb

      v_E13:=nvl(v_E03*v_HL1,0);--ڻBrmb
      v_E14:=v_E13+v_E04;       --ۼƻBrmb

      v_E15:=nvl(v_E05*v_HL2,0);--Brmb
      v_E16:=v_E15+v_E06;       --ۼBrmb

      v_E17:=nvl(v_E07*v_HL1,0); --ڻBrmb
      v_E18:=v_E17+v_E08;        --ۼƻBrmb

      v_EP101:=v_E11+v_E13;      --bɻrmb
      v_EP102:=v_E15+v_E17;      --bɸrmb
      v_EP103:=v_EP101+v_EP102;   --brmbϼ

      v_EP201:=v_E12+v_E14;       --ۼbɻrmb
      v_EP202:=v_E16+v_E18;       --ۼbɸrmb
      v_EP203:=v_EP201+v_EP202;   --ۼbrmbϼ

      v_EP111:=nvl(v_E01,0)+nvl(v_E05,0);        --B
      v_EP222:=nvl(v_E02,0)+nvl(v_E06,0);        --ۼB
      v_EP333:=nvl(v_E03,0)+nvl(v_E07,0);        --ڻB
      v_EP444:=nvl(v_E04,0)+nvl(v_E08,0);        --ۼƻB


      delete t_b01_f004 where p001=v_date and (p005=1001201 or p005=1001205) and w100 =v_bmid;

     --Bĸ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
            select v_date,A002,1001,P001,1001201,nvl(A003,0),v_bmid
            FROM t_db_01_004 WHERE P001!=1001102 and P001!=1001103 and w100 =v_bmid;
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,A002,1001,P001,1001205,nvl(A004,0)+nvl(A003,0),v_bmid
             FROM t_db_01_004 WHERE P001!=1001102 and P001!=1001103 and w100 =v_bmid;
      --bķС
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1004,1001,p001,1001201,nvl(sum(A003),0),v_bmid
             FROM t_db_01_004 WHERE P001!=1001102 and P001!=1001103 and w100 =v_bmid
             GROUP BY P001;
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1004,1001,p001,1001205,nvl(sum(nvl(A003,0)+nvl(A004,0)),0),v_bmid
             FROM t_db_01_004 WHERE P001!=1001102 and P001!=1001103 and w100 =v_bmid
             GROUP BY P001;

     --BҷС
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1002,1001102,1001201,v_E01,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1002,1001102,1001205,v_E02,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1004,1001103,1001201,v_E03,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1004,1001103,1001205,v_E04,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1002,1001102,1001201,v_E05,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1002,1001102,1001205,v_E06,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1004,1001103,1001201,v_E07,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1004,1001103,1001205,v_E08,v_bmid );

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1002,1001102,1001201,v_EP111,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1002,1001102,1001205,v_EP222,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1004,1001103,1001201,v_EP333,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1004,1001103,1001205,v_EP444,v_bmid );



     --Brmb
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1003,1001102,1001201,v_E11,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1003,1001102,1001205,v_E12,v_bmid );
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1005,1001103,1001201,v_E13,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1005,1001103,1001205,v_E14,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1003,1001102,1001201,v_E15,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1003,1001102,1001205,v_E16,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1005,1001103,1001201,v_E17,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1005,1001103,1001205,v_E18,v_bmid);
      --BС
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1006,1001120,1001201,v_EP101,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1006,1001120,1001201,v_EP102,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1006,1001120,1001201,v_EP103,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1006,1001120,1001205,v_EP201,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1006,1001120,1001205,v_EP202,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1006,1001120,1001205,v_EP203,v_bmid);

      --ܼ
      --
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1001,1006,1099000,1001201,
                    (select nvl(sum(A003),0)+v_EP101
                    FROM t_db_01_004
                    WHERE P001 IN (1001101,1002000,1003000,1004000,1005000,1006001,1006002) AND A002=1001
                    and w100 =v_bmid)
                    ,v_bmid
             from dual;
      --˱
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1002,1006,1099000,1001201,
                    (select nvl(sum(A003),0)+v_EP102
                    FROM t_db_01_004
                    WHERE P001 IN (1001101,1002000,1003000,1004000,1005000,1006001,1006002) AND A002=1002
                    and w100 =v_bmid)
                    ,v_bmid
             from dual;
      --СƱ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1004,1006,1099000,1001201,
                    (select nvl(sum(A003),0)+v_EP103
                    FROM t_db_01_004
                    WHERE P001 IN (1001101,1002000,1003000,1004000,1005000,1006001,1006002)
                    and w100 =v_bmid)
                    ,v_bmid
             from dual;


      --ۼ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1001,1006,1099000,1001205,
                    (select nvl(sum(A004),0)+nvl(sum(A003),0)+v_EP201
                    FROM t_db_01_004
                    WHERE P001 IN (1001101,1002000,1003000,1004000,1005000,1006001,1006002) AND A002=1001
                    and w100 =v_bmid)
                    ,v_bmid
             from dual;

      --ۼ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1002,1006,1099000,1001205,
                   (select nvl(sum(A004),0)+nvl(sum(A003),0)+v_EP202
                   FROM t_db_01_004
                   WHERE P001 IN (1001101,1002000,1003000,1004000,1005000,1006001,1006002) AND A002=1002
                   and w100 =v_bmid)
                   ,v_bmid
             from dual;

      --ϼۼ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1004,1006,1099000,1001205,
                    (select nvl(sum(A004),0)+nvl(sum(A003),0)+v_EP203
                    FROM t_db_01_004
                    WHERE P001 IN (1001101,1002000,1003000,1004000,1005000,1006001,1006002)
                    and w100 =v_bmid)
                    ,v_bmid
      from dual;


      update krcs.t_sys_t022 set A007=1010001 where P001=112002001 and a004=v_bmid;  --޸ת״̬
      SELECT 'ݱתID112002001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112002001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);




      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112002001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112002001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112002002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112002002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_EE001 number(19,2);v_EE002 number(19,2);v_EE003 number(19,2);
      v_EE004 number(19,2);v_EE005 number(19,2);v_EE006 number(19,2);
      v_EE011 number(19,2);v_EE012 number(19,2);v_EE013 number(19,2);
      v_EE014 number(19,2);v_EE015 number(19,2);v_EE016 number(19,2);
      v_HL1 number(19,5);  v_HL2 number(19,5);
      v_status number;
      v_bmid number;
  begin


      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b01_f004 where p001=v_date  and (p005=1001202 or p005=1001204)
                               and w100 =v_bmid;
      select nvl(sum(a002),0) into v_HL1 from t_bks_t007;  --$
      select nvl(sum(a003),0) into v_HL2 from t_bks_t007;  --rmb

      select nvl(sum(a002),0) into v_EE001 from t_db_01_005
       where p001=1001 and w100 =v_bmid;  --rmb

      select nvl(sum(a002),0) into v_EE002 from t_db_01_005
      where p001=1004 and w100 =v_bmid;  --hk$
      v_EE003:=nvl(v_EE002*v_HL2,0);
                                  --hk$rmb
      select sum(a002) into v_EE004 from t_db_01_005
      where p001=1002 and w100 =v_bmid;  --$
      v_EE005:=nvl(v_EE004*v_HL1,0);                                --$rmb 
      v_EE006:=v_EE001+v_EE003+v_EE005 ;                             --rmbϼƱ

      select nvl(sum(a003),0)+nvl(sum(a002),0) into v_EE011 from t_db_01_005
      where p001=1001 and w100 =v_bmid;  --rmbۼ

      select nvl(sum(a003),0) into v_EE012 from t_db_01_005
      where p001=1004 and w100 =v_bmid;  --hk$
      v_EE013:=v_EE012+v_EE003;                               --hk$ۼ

      select nvl(sum(a003),0) into v_EE014 from t_db_01_005
      where p001=1002 and w100 =v_bmid; --$
      v_EE015:=v_EE014+ v_EE005;                               --$rmbۼ

       v_EE016:=v_EE011+v_EE013+v_EE015 ;                           --rmbϼۼ
--(ԭҴ)
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
      select v_date,1004,P001,1099000,1001202,A002,v_bmid
      from  t_db_01_005
      where w100 =v_bmid;
--ۼ (ԭҴ)
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
      select v_date,1004,P001,1099000,1001204, nvl(sum(a003)+sum(a002),0),v_bmid
      from  t_db_01_005
      where w100 =v_bmid
      group by p001 ;
--RMB
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1003,1099000,1001202,v_EE003,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1005,1099000,1001202,v_EE005,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1006,1099000,1001202,v_EE006,v_bmid);
--ۼ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1003,1099000,1001204,v_EE013,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1005,1099000,1001204,v_EE015,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1006,1099000,1001204,v_EE016,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112002002 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112002002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112002002 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);


      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112002002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112002002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112002003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112002003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar2(256);
      v_HL1 number(19,5);v_HL2 number(19,5);
      v_EP101 number(19,2);v_EP102 number(19,2);v_EP103 number(19,2);
      v_E01 number(19,2);v_E03 number(19,2);v_E05 number(19,2);v_E07 number(19,2);
      v_E11 number(19,2);v_E13 number(19,2);v_E15 number(19,2);v_E17 number(19,2);
      v_EP111 number(19,2);v_EP333 number(19,2);
      v_status number;
      v_bmid number;
  begin
    --  update by zhouly  20130822  ˻ͲID

      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select a002 into v_HL1 from t_bks_t007/* where a100 =v_org*/;--$
      select a003 into v_HL2 from t_bks_t007/* where a100 =v_org*/;--hk$

      --BƱ
      select nvl(sum(a003),0) into v_E01 from t_db_01_006
      where p001=1001102 and a002=1001 and w100 =v_bmid;--Bֵ
      select nvl(sum(a003),0) into v_E03 from t_db_01_006
      where p001=1001103 and a002=1001 and w100 =v_bmid;--Bֵ
      select nvl(sum(a003),0) into v_E05 from t_db_01_006
      where p001=1001102 and a002=1002 and w100 =v_bmid;--Bֵ
      select nvl(sum(a003),0) into v_E07 from t_db_01_006
      where p001=1001103 and a002=1002 and w100 =v_bmid;--Bֵ

      v_E11:=nvl(v_E01*v_HL2,0);--Brmbֵ
      v_E13:=nvl(v_E03*v_HL1,0);--Brmb ֵ
      v_E15:=nvl(v_E05*v_HL2,0);--Brmbֵ
      v_E17:=nvl(v_E07*v_HL1,0); --ڻBrmb

      v_EP101:=v_E11+v_E13;      --bɻrmb
      v_EP102:=v_E15+v_E17;      --bɸrmb
      v_EP103:=v_EP101+v_EP102;   --brmbϼ
      v_EP111:=nvl(v_E01,0)+nvl(v_E05,0);        --B
      v_EP333:=nvl(v_E03,0)+nvl(v_E07,0);        --ڻB

      delete t_b01_f004 where p001=v_date and p005=1001203 and w100 =v_bmid;

     --Bĸ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
            select v_date,A002,1001,P001,1001203,nvl(A003,0),v_bmid
            FROM t_db_01_006
            WHERE P001!=1001102 and P001!=1001103 and w100 =v_bmid;

      --bķС
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             select v_date,1004,1001,p001,1001203,nvl(sum(A003),0),v_bmid
             FROM t_db_01_006
             WHERE P001!=1001102 and P001!=1001103 and w100 =v_bmid
             GROUP BY P001;


     --BҷС
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1002,1001102,1001203,v_E01,v_bmid);

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1004,1001103,1001203,v_E03,v_bmid);

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1002,1001102,1001203,v_E05,v_bmid);

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1004,1001103,1001203,v_E07,v_bmid);


      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1002,1001102,1001203,v_EP111,v_bmid);

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1004,1001103,1001203,v_EP333,v_bmid);




     --Brmb
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1003,1001102,1001203,v_E11,v_bmid);

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1005,1001103,1001203,v_E13,v_bmid);

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1003,1001102,1001203,v_E15,v_bmid);

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1005,1001103,1001203,v_E17,v_bmid);

      --BС
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1001,1006,1001120,1001203,v_EP101,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1002,1006,1001120,1001203,v_EP102,v_bmid);
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
             values( v_date,1004,1006,1001120,1001203,v_EP103,v_bmid);


      --ܼ
      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
                      select v_date,1001,1006,1099000,1001203,(select sum(A003)+v_EP101
                      FROM t_db_01_006 WHERE P001 IN (1001101,1002000,1003000,1004000,1005000) AND A002=1001
                      and w100 =v_bmid)
                      ,v_bmid
                      from dual;

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
                      select v_date,1002,1006,1099000,1001203,(select sum(A003)+v_EP102
                      FROM t_db_01_006 WHERE P001 IN (1001101,1002000,1003000,1004000,1005000) AND A002=1002
                      and w100 =v_bmid)
                      ,v_bmid
                      from dual;

      insert into t_b01_f004(p001,p002,p003,p004,p005,v,w100)
                      select v_date,1004,1006,1099000,1001203,(select sum(A003)+v_EP103
                      FROM t_db_01_006 WHERE P001 IN (1001101,1002000,1003000,1004000,1005000)
                      and w100 =v_bmid)
                      ,v_bmid
                      from dual;



     update krcs.t_sys_t022 set A007=1010001 where P001=112002003 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112002003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112002003;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);


      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112002003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112002003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112002004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112002004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_EP001 number(19,2);v_EP002 number(19,2);v_EP003 number(19,2);
      v_EP004 number(19,2);v_EP005 number(19,2);v_EP006 number(19,2);
      v_EP011 number(19,2);v_EP012 number(19,2);v_EP013 number(19,2);
      v_EP014 number(19,2);v_EP015 number(19,2);v_EP016 number(19,2);
      v_EP101 number(19,2);v_EP102 number(19,2);v_EP103 number(19,2);
      v_EP104 number(19,2);v_EP105 number(19,2);v_EP106 number(19,2);
      v_EP111 number(19,2);v_EP112 number(19,2);v_EP113 number(19,2);
      v_EP114 number(19,2);v_EP115 number(19,2);v_EP116 number(19,2);
      v_HL1 number(19,5);v_HL2 number(19,5);
      v_bmid number;
      v_status number;
  begin

      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b01_f006 where p001=v_date and w100 =v_bmid;

      select a002 into v_HL1 from t_bks_t007/* where a100 =v_org*/;--$
      select a003 into v_HL2 from t_bks_t007/* where a100 =v_org*/;--hk$
      select nvl(sum(a002),0) into v_EP001 from t_db_01_007
      where p001=1001301 and a003=1001 and w100 =v_bmid;--rmb

      select nvl(sum(a002),0) into v_EP002 from t_db_01_007
      where p001=1001301 and a003=1002 and w100 =v_bmid;--hk$
      v_EP003:=nvl(v_EP002*v_HL2,0) ;                                       --hk$
      select nvl(sum(a002),0) into v_EP004 from t_db_01_007
      where p001=1001301 and a003=1004 and w100 =v_bmid; --$
      v_EP005:=nvl(v_EP004*v_HL1,0) ;                                       --$
      v_EP006:=nvl(v_EP001,0)+v_EP003+v_EP005;                              --Һϼ
      select nvl(sum(a002),0) into v_EP011 from t_db_01_007
      where p001=1001302 and a003=1001 and w100 =v_bmid;--֧rmb
      select nvl(sum(a002),0) into v_EP012 from t_db_01_007
      where p001=1001302 and a003=1002 and w100 =v_bmid;--֧hk$
      v_EP013:=nvl(v_EP012*v_HL2,0);                                        --֧hk$
      select nvl(sum(a002),0) into v_EP014 from t_db_01_007
      where p001=1001302 and a003=1004 and w100 =v_bmid;--֧$
      v_EP015:=nvl(v_EP014*v_HL1,0) ;                                       --֧$
      v_EP016:=nvl(v_EP011,0)+v_EP013+v_EP015 ;                             --֧Һϼ

      select nvl(sum(a002),0) into v_EP101 from t_db_01_007
      where p001=1001303 and a003=1001 and w100 =v_bmid;--콻׽rmb
      select nvl(sum(a002),0) into v_EP102 from t_db_01_007
      where p001=1001303 and a003=1002 and w100 =v_bmid;--콻׽hk$
      v_EP103:=nvl(v_EP102*v_HL2,0)  ;                                      --콻׽hk$

      select nvl(sum(a002),0) into v_EP104 from t_db_01_007
      where p001=1001303 and a003=1004 and w100 =v_bmid;--콻׽$
      v_EP105:=nvl(v_EP104*v_HL1,0);                                        --콻׽$
      v_EP106:=nvl(v_EP101,0)+v_EP103+v_EP105  ;                            --콻׽Һϼ

      select nvl(sum(a002),0)+v_EP101 into v_EP111 from t_db_01_007
      where p001=1001304 and a003=1001 and w100 =v_bmid;--ۼƽrmb

      select nvl(sum(a002),0) into v_EP112 from t_db_01_007
      where p001=1001304 and a003=1002 and w100 =v_bmid;--ۼƽhk$
      v_EP113:=v_EP112+v_EP103 ;                                       --ۼƽhk$

      select nvl(sum(a002),0) into v_EP114 from t_db_01_007
      where p001=1001304 and a003=1004 and w100 =v_bmid;--ۼƽ$
      v_EP115:=v_EP114+v_EP105;                                       --ۼƽ$

      v_EP116:=nvl(v_EP111,0)+v_EP113+v_EP115 ;                              --ۼƽҺϼ

      insert into t_b01_f006(p001,p002,p003,v,w100)
                    select v_date,p001,a003,a002,v_bmid
                    from t_db_01_007
                   where (p001<>1001304 or a003<>1001)
                     and (p001<>1001304 or a003<>1002)
                     and (p001<>1001304 or a003<>1004)
                     and w100 =v_bmid;

      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001301,1003,v_EP003,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001301,1005,v_EP005,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001301,1006,v_EP006,v_bmid);

      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001302,1003,v_EP013,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001302,1005,v_EP015,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001302,1006,v_EP016,v_bmid);

      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001303,1003,v_EP103,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001303,1005,v_EP105,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001303,1006,v_EP106,v_bmid);

      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001304,1001,v_EP111,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001304,1002,v_EP112,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001304,1003,v_EP113,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001304,1004,v_EP114,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001304,1005,v_EP115,v_bmid);
      insert into t_b01_f006(p001,p002,p003,v,w100)
                      values(v_date,1001304,1006,v_EP116,v_bmid);


      update krcs.t_sys_t022 set A007=1010001 where P001=112002004 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112002004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112002004;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);


   commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112002004 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112002004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112003001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112003001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_EP007 number;
      v_EP008 number;
       v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b01_f005
      where p001=v_date and p002 =1001 and p003=11001 and w100 =v_bmid;

      select sum(a002) into v_EP003 from t_db_01_008
      where p001=1001403 and w100 =v_bmid;
      select sum(a002) into v_EP004 from t_db_01_008
      where p001=1001404 and w100 =v_bmid;
      select sum(a002) into v_EP005 from t_db_01_008
      where p001=1001405 and w100 =v_bmid;
      select sum(a002) into v_EP006 from t_db_01_008
      where p001=1001406 and w100 =v_bmid;

      v_EP007:=nvl(v_EP003,0)+nvl(v_EP004,0);
      v_EP008:=nvl(v_EP005,0)+nvl(v_EP006,0);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1001,11001,1001403,v_EP003,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1001,11001,1001405,v_EP005,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1001,11001,1001404,v_EP007,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1001,11001,1001406,v_EP008,v_bmid);


      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001405 and p002!=1111 and p001=v_date and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001406 and p002!=1111 and p001=v_date and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001405 and 1001406
      and w100 =v_bmid;

      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001405,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001406,v_EP002,v_bmid);

      v_EP001 := 0 ;
      v_EP002 := 0 ;
      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001403 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001404 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001403 and 1001404
      and w100 =v_bmid;

      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001403,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001404,v_EP002,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112003001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112003001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112003001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112003001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112003001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112003002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112003002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_EP007 number;
      v_EP008 number;
       v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      delete from t_b01_f005
      where p001=v_date and p002 =1002 and p003=11001 and w100 =v_bmid;

      select sum(a002) into v_EP003
      from t_db_01_009
      where p001=1001403 and w100 =v_bmid;

      select sum(a002) into v_EP004
      from t_db_01_009
      where p001=1001404 and w100 =v_bmid;

      select sum(a002) into v_EP005
      from t_db_01_009
      where p001=1001405 and w100 =v_bmid;

      select sum(a002) into v_EP006
      from t_db_01_009
      where p001=1001406 and w100 =v_bmid;

      v_EP007:=nvl(v_EP003,0)+nvl(v_EP004,0);
      v_EP008:=nvl(v_EP005,0)+nvl(v_EP006,0);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1002,11001,1001403,v_EP003,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1002,11001,1001405,v_EP005,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1002,11001,1001404,v_EP007,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1002,11001,1001406,v_EP008,v_bmid);

      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001405 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001406 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001405 and 1001406
      and w100 =v_bmid;

      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001405,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001406,v_EP002,v_bmid);

      v_EP001 := 0 ;
      v_EP002 := 0 ;
      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001403 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001404 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001403 and 1001404
      and w100 =v_bmid;

      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001403,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001404,v_EP002,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112003002 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112003002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112003002;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112003002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112003002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112003003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112003003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_EP007 number;
      v_EP008 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b01_f005
      where p001=v_date and p002 =1003 and p003=11001
      and w100 =v_bmid;

      select sum(a002) into v_EP003
      from t_db_01_010
      where p001=1001403 and w100 =v_bmid;

      select sum(a002) into v_EP004
      from t_db_01_010
      where p001=1001404 and w100 =v_bmid;

      select sum(a002) into v_EP005
      from t_db_01_010
      where p001=1001405 and w100 =v_bmid;

      select sum(a002) into v_EP006
      from t_db_01_010
      where p001=1001406 and w100 =v_bmid;

      v_EP007:=nvl(v_EP003,0)+nvl(v_EP004,0);
      v_EP008:=nvl(v_EP005,0)+nvl(v_EP006,0);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1003,11001,1001403,v_EP003,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1003,11001,1001405,v_EP005,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1003,11001,1001404,v_EP007,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1003,11001,1001406,v_EP008,v_bmid);

      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001405 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001406 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001405 and 1001406
      and w100 =v_bmid;

      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001405,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001406,v_EP002,v_bmid);

      v_EP001 := 0 ;
      v_EP002 := 0 ;
      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001403 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001404 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001403 and 1001404
      and w100 =v_bmid;

      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001403,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001404,v_EP002,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112003003 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112003003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112003003;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112003003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112003003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112003004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112003004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_EP007 number;
      v_EP008 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID


      delete from t_b01_f005
      where p001=v_date and p002 =1004 and p003=11001
      and w100 =v_bmid;

      select sum(a002) into v_EP003
      from t_db_01_011
      where p001=1001403 and w100 =v_bmid;

      select sum(a002) into v_EP004
      from t_db_01_011
      where p001=1001404 and w100 =v_bmid;

      select sum(a002) into v_EP005
      from t_db_01_011
      where p001=1001405 and w100 =v_bmid;

      select sum(a002) into v_EP006
      from t_db_01_011
      where p001=1001406 and w100 =v_bmid;

      v_EP007:=nvl(v_EP003,0)+nvl(v_EP004,0);
      v_EP008:=nvl(v_EP005,0)+nvl(v_EP006,0);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1004,11001,1001403,nvl(v_EP003,0),v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1004,11001,1001405,nvl(v_EP005,0),v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1004,11001,1001404,nvl(v_EP007,0),v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1004,11001,1001406,nvl(v_EP008,0),v_bmid);

      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001405 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001406 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001405 and 1001406
      and w100 =v_bmid;

      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001405,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001406,v_EP002,v_bmid);

      v_EP001 := 0 ;
      v_EP002 := 0 ;
      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001403 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001404 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001403 and 1001404
      and w100 =v_bmid;
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001403,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001404,v_EP002,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112003004 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112003004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112003004 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112003004 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112003004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112003005
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112003005(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_EP007 number;
      v_EP008 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b01_f005
      where p001=v_date and p002 =1005 and p003=11001 and w100 =v_bmid;

      select sum(a002) into v_EP003
      from t_db_01_012
      where p001=1001403 and w100 =v_bmid;

      select sum(a002) into v_EP004
      from t_db_01_012
      where p001=1001404 and w100 =v_bmid;

      select sum(a002) into v_EP005
      from t_db_01_012
      where p001=1001405 and w100 =v_bmid;

      select sum(a002) into v_EP006
      from t_db_01_012
      where p001=1001406 and w100 =v_bmid;
      v_EP007:=nvl(v_EP003,0)+nvl(v_EP004,0);
      v_EP008:=nvl(v_EP005,0)+nvl(v_EP006,0);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1005,11001,1001403,v_EP003,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1005,11001,1001405,v_EP005,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1005,11001,1001404,v_EP007,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1005,11001,1001406,v_EP008,v_bmid);

      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001405 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001406 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001405 and 1001406
      and w100 =v_bmid;
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001405,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001406,v_EP002,v_bmid);

      v_EP001 := 0 ;
      v_EP002 := 0 ;
      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001403 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001404 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001403 and 1001404
      and w100 =v_bmid;
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001403,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001404,v_EP002,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112003005 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112003005'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112003005;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112003005 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112003005!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112003006
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112003006(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_EP007 number;
      v_EP008 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b01_f005
      where p001=v_date and p002=1006 and p003=11001 and w100 =v_bmid;

      select sum(a002) into v_EP003
      from t_db_01_013
      where p001=1001403 and w100 =v_bmid;

      select sum(a002) into v_EP004
      from t_db_01_013
      where p001=1001404 and w100 =v_bmid;

      select sum(a002) into v_EP005
      from t_db_01_013
      where p001=1001405 and w100 =v_bmid;

      select sum(a002) into v_EP006
      from t_db_01_013
      where p001=1001406 and w100 =v_bmid;
      v_EP007:=nvl(v_EP003,0)+nvl(v_EP004,0);
      v_EP008:=nvl(v_EP005,0)+nvl(v_EP006,0);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1006,11001,1001403,nvl(v_EP003,0),v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1006,11001,1001405,nvl(v_EP005,0),v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1006,11001,1001404,nvl(v_EP007,0),v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1006,11001,1001406,nvl(v_EP008,0),v_bmid);


      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001405 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001406 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001405 and 1001406
      and w100 =v_bmid;
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001405,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001406,v_EP002,v_bmid);

      v_EP001 := 0 ;
      v_EP002 := 0 ;
      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001403 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001404 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001403 and 1001404
      and w100 =v_bmid;
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001403,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001404,v_EP002,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112003006 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112003006'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112003006;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112003006 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112003006!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112003007
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112003007(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_EP007 number;
      v_EP008 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b01_f005
      where p001=v_date and p002=1099 and p003=11001
      and w100 =v_bmid;

      select sum(a002) into v_EP003
      from t_db_01_014
      where p001=1001403 and w100 =v_bmid;

      select sum(a002) into v_EP004
      from t_db_01_014
      where p001=1001404 and w100 =v_bmid;

      select sum(a002) into v_EP005
      from t_db_01_014
      where p001=1001405 and w100 =v_bmid;

      select sum(a002) into v_EP006
      from t_db_01_014
      where p001=1001406 and w100 =v_bmid;

      v_EP007:=nvl(v_EP003,0)+nvl(v_EP004,0);
      v_EP008:=nvl(v_EP005,0)+nvl(v_EP006,0);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1099,11001,1001403,v_EP003,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1099,11001,1001405,v_EP005,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1099,11001,1001404,v_EP007,v_bmid);
      insert into t_b01_f005 (p001,p002,p003,p004,v,w100)
          values(v_date,1099,11001,1001406,v_EP008,v_bmid);

      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001405 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001406 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001405 and 1001406
      and w100 =v_bmid;
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001405,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001406,v_EP002,v_bmid);


      v_EP001 := 0 ;
      v_EP002 := 0 ;
      select sum(v) into v_EP001
      from t_b01_f005
      where p004=1001403 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      select sum(v) into v_EP002
      from t_b01_f005
      where p004=1001404 and p002!=1111 and p001=v_date
      and w100 =v_bmid;

      delete from t_b01_f005
      where p001=v_date and p002=1111 and p003=11001 and p004 between 1001403 and 1001404
      and w100 =v_bmid;
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001403,v_EP001,v_bmid);
      insert into t_b01_f005(p001,p002,p003,p004,v,w100)
             values(v_date,1111,11001,1001404,v_EP002,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112003007 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112003007'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112003007;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112003007 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112003007!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b06_f002 where P001=v_date AND P003=1001
             and P004 in (1006001,1006002,1006003,1006004,1006005,1006006,1006007,1006008)
             and p002 in (select P001 from t_db_03_001 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001, 1006001,nvl(A001,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006003,nvl(A002,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006005, nvl(A003,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006007, nvl(A004,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001, 1006002,nvl(A001,0)+nvl(A005,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006004,nvl(A002,0)+nvl(A006,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006006, nvl(A003,0)+nvl(A007,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006008, nvl(A004,0)+nvl(A008,0),v_bmid
                    from t_db_03_001
                    where w100 =v_bmid;

      delete from t_b06_f002
      where p001=v_date and p002=1111
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013  and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015  and p001=v_date
      and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001=112005001 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112005001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      --v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       delete from t_b06_f002
           where P001=v_date AND P003=1001
             and P004 in (1006001,1006002,1006003,1006004,1006005,1006006,1006007,1006008)
             and p002 in (select P001 from t_db_03_003 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006001, nvl(A001,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006003, nvl(A002,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006005, nvl(A003,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001,1001 , 1006007, nvl(A004,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006002, nvl(A001,0)+nvl(A005,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006004, nvl(A002,0)+nvl(A006,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006006, nvl(A003,0)+nvl(A007,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001,1001 , 1006008, nvl(A004,0)+nvl(A008,0),v_bmid
                    from t_db_03_003
                    where w100 =v_bmid;

      delete from t_b06_f002 where p001=v_date and p002=1111
      and w100 =v_bmid;


      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;

      update krcs.t_sys_t022 set A007=1010001 where P001=112005002 and a004=v_bmid; /*޸ת״̬ */


      SELECT 'ݱתID112005002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005002;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       delete from t_b06_f002
           where P001=v_date AND P003=1001
             and P004 in (1006001,1006002,1006003,1006004,1006005,1006006,1006007,1006008)
             and p002 in (select P001 from t_db_03_005 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006001, nvl(A001,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006003, nvl(A002,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006005, nvl(A003,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006007, nvl(A004,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006002, nvl(A001,0)+nvl(A005,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006004, nvl(A002,0)+nvl(A006,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006006, nvl(A003,0)+nvl(A007,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1001 , 1006008, nvl(A004,0)+nvl(A008,0),v_bmid
                    from t_db_03_005
                    where w100 =v_bmid;

     delete from t_b06_f002 where p001=v_date and p002=1111
     and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005003 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005003 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       delete from t_b06_f002
           where P001=v_date AND P003=1001
             and P004 in (1006001,1006002,1006003,1006004,1006005,1006006,1006007,1006008)
             and p002 in (select P001 from t_db_03_007 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006001,nvl(A001,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006003,nvl(A002,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006005,nvl(A003,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006007,nvl(A004,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006002,nvl(A001,0)+nvl(A005,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006004,nvl(A002,0)+nvl(A006,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006006,nvl(A003,0)+nvl(A007,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006008,nvl(A004,0)+nvl(A008,0),v_bmid
             from t_db_03_007
             where w100 =v_bmid;

     delete from t_b06_f002 where p001=v_date and p002=1111
     and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;

      update krcs.t_sys_t022 set A007=1010001 where P001=112005004 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005004;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005004 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005005
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005005(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
     -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       delete from t_b06_f002
           where P001=v_date AND P003=1001
             and P004 in (1006001,1006002,1006003,1006004,1006005,1006006,1006007,1006008)
             and p002 in (select P001 from t_db_03_009 where w100 =v_bmid)
             and w100 =v_bmid;

       insert into t_b06_f002(p001,p002,p003,p004,v,w100 )
             select v_date,p001,1001,1006001,nvl(A001,0),(select a012 from krcs.t_sys_user where p001 =v_KJAXUSER)
             from t_db_03_009
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006003,nvl(A002,0),v_bmid
             from t_db_03_009
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006005,nvl(A003,0),v_bmid
             from t_db_03_009
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006007,nvl(A004,0),v_bmid
             from t_db_03_009
             where w100 =v_bmid;

       insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006002,nvl(A001,0)+nvl(A005,0),v_bmid
             from t_db_03_009
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006004,nvl(A002,0)+nvl(A006,0),v_bmid
             from t_db_03_009
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006006,nvl(A003,0)+nvl(A007,0),v_bmid
             from t_db_03_009
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1001,1006008,nvl(A004,0)+nvl(A008,0),v_bmid
             from t_db_03_009
             where w100 =v_bmid;

      delete from t_b06_f002 where p001=v_date and p002=1111
      and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005005 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005005'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005005 ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005005 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005005!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005006
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005006(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b06_f002
           where p001=v_date AND P003=1002
             and P004 in (1006001,1006002,1006005,1006006,1006007,1006008)
             and p002 in (select P001 from t_db_03_011 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006001,nvl(A001,0),v_bmid
             from t_db_03_011
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006005,nvl(A002,0),v_bmid
             from t_db_03_011
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006007,nvl(A003,0),v_bmid
             from t_db_03_011
             where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006002,nvl(A001,0)+nvl(A004,0),v_bmid
             from t_db_03_011
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006006,nvl(A002,0)+nvl(A005,0),v_bmid
             from t_db_03_011
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006008,nvl(A003,0)+nvl(A006,0),v_bmid
             from t_db_03_011
             where w100 =v_bmid;

      delete from t_b06_f002 where p001=v_date and p002=1111
      and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005006 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005006'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005006;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005006 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005006!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005007
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005007(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       delete from t_b06_f002
           where p001=v_date AND P003=1002
             and P004 in (1006001,1006005,1006007,1006002,1006006,1006008)
             and p002 in (select P001 from t_db_03_013 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006001,nvl(A001,0),v_bmid
             from t_db_03_013
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006005,nvl(A002,0),v_bmid
             from t_db_03_013
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006007,nvl(A003,0),v_bmid
             from t_db_03_013
             where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006002,nvl(A001,0)+nvl(A004,0),v_bmid
             from t_db_03_013
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006006,nvl(A002,0)+nvl(A005,0),v_bmid
             from t_db_03_013
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006008,nvl(A003,0)+nvl(A006,0),v_bmid
             from t_db_03_013
             where w100 =v_bmid;

      delete from t_b06_f002 where p001=v_date and p002=1111
      and w100 =v_bmid;

       --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005007 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005007'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005007;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005007 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005007!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005008
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005008(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
     -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       delete from t_b06_f002
           where p001=v_date AND P003=1002
             and P004 in (1006001,1006005,1006007,1006002,1006006,1006008)
             and p002 in (select P001 from t_db_03_015 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006001,nvl(A001,0),v_bmid
             from t_db_03_015
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006005,nvl(A002,0),v_bmid
             from t_db_03_015
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006007,nvl(A003,0),v_bmid
             from t_db_03_015
             where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006002,nvl(A001,0)+nvl(A004,0),v_bmid
             from t_db_03_015
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006006,nvl(A002,0)+nvl(A005,0),v_bmid
             from t_db_03_015
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006008,nvl(A003,0)+nvl(A006,0),v_bmid
             from t_db_03_015
             where w100 =v_bmid;

      delete from t_b06_f002 where p001=v_date and p002=1111
      and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005008 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005008'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005008;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005008 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005008!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005009
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005009(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b06_f002
           where p001=v_date AND P003=1002
             and P004 in (1006001,1006005,1006007,1006002,1006006,1006008)
             and p002 in (select P001 from t_db_03_017 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006001,nvl(A001,0),v_bmid
             from t_db_03_017
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006005,nvl(A002,0),v_bmid
             from t_db_03_017
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006007,nvl(A003,0),v_bmid
             from t_db_03_017
             where w100 =v_bmid;
             insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006002,nvl(A001,0)+nvl(A004,0),v_bmid
             from t_db_03_017
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006006,nvl(A002,0)+nvl(A005,0),v_bmid
             from t_db_03_017
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006008,nvl(A003,0)+nvl(A006,0),v_bmid
             from t_db_03_017
             where w100 =v_bmid;

      delete from t_b06_f002 where p001=v_date and p002=1111
      and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005009 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005009'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005009;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005009 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005009!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005010
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005010(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
       v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
     -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b06_f002
           where p001=v_date AND P003=1002
             and P004 in (1006001,1006005,1006007,1006002,1006006,1006008)
             and p002 in (select P001 from t_db_03_019 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006001,nvl(A001,0),v_bmid
             from t_db_03_019
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006005,nvl(A002,0),v_bmid
             from t_db_03_019
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006007,nvl(A003,0),v_bmid
             from t_db_03_019
             where w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006002,nvl(A001,0)+nvl(A004,0),v_bmid
             from t_db_03_019
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006006,nvl(A002,0)+nvl(A005,0),v_bmid
             from t_db_03_019
             where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date,p001,1002,1006008,nvl(A003,0)+nvl(A006,0),v_bmid
             from t_db_03_019
             where w100 =v_bmid;

 delete from t_b06_f002 where p001=v_date and p002=1111
 and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005010 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005010'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005010;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005010 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005010!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005011
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005011(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      -- v_count number;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete from t_b06_f002
           where P001=v_date AND P003=1003
             and P004 in (1006009,1006011,1006013,1006015)
             and p002 in (select P001 from t_db_03_021 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003, 1006009, nvl(A001,0),v_bmid
                    from t_db_03_021
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006011, nvl(A002,0),v_bmid
                    from t_db_03_021
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006013, nvl(A003,0),v_bmid
                    from t_db_03_021
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006015, nvl(A004,0),v_bmid
                    from t_db_03_021
                    where w100 =v_bmid;

     delete from t_b06_f002 where p001=v_date and p002=1111
     and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005011 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005011'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005011;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005011 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005011!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005012
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005012(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

       /* ҵ񣨱ڰתɣ*/
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       delete from t_b06_f002
           where P001=v_date AND P003=1003
             and P004 in (1006009,1006011,1006013,1006015)
             and p002 in (select P001 from t_db_03_022 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003, 1006009, nvl(A001,0),v_bmid
                    from t_db_03_022
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006011,nvl(A002,0),v_bmid
                    from t_db_03_022
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006013,nvl(A003,0),v_bmid
                    from t_db_03_022
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006015, nvl(A004,0),v_bmid
                    from t_db_03_022
                    where w100 =v_bmid;

    delete from t_b06_f002 where p001=v_date and p002=1111
    and w100 =v_bmid;

    --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005012 and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID112005012'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005012;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005012 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005012!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005013
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005013(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
 /* ҵ񣨱ڰת*/
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       delete from t_b06_f002
           where P001=v_date AND P003=1003
             and P004 in (1006009,1006011,1006013,1006015)
             and p002 in (select P001 from t_db_03_023 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003, 1006009, nvl(A001,0),v_bmid
                    from t_db_03_023
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006011, nvl(A002,0),v_bmid
                    from t_db_03_023
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006013, nvl(A003,0),v_bmid
                    from t_db_03_023
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006015, nvl(A004,0),v_bmid
                    from t_db_03_023
                    where w100 =v_bmid;
 delete from t_b06_f002 where p001=v_date and p002=1111
 and w100 =v_bmid;

--select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005013 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005013'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005013;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005013 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005013!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005014
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005014(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
      --v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
 /* ҵ񣨱ڰתծȯУ*/
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       delete from t_b06_f002
           where P001=v_date AND P003=1003
             and P004 in (1006009,1006011,1006013,1006015)
             and p002 in (select P001 from t_db_03_024 where w100 =v_bmid)
             and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003, 1006009, nvl(A001,0),v_bmid
                    from t_db_03_024
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006011, nvl(A002,0),v_bmid
                    from t_db_03_024
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006013, nvl(A003,0),v_bmid
                    from t_db_03_024
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006015, nvl(A004,0),v_bmid
                    from t_db_03_024
                    where w100 =v_bmid;

 delete from t_b06_f002 where p001=v_date and p002=1111
 and w100 =v_bmid;

 --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;


      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005014 and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112005014'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005014;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005014 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005014!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112005015
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112005015(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_ES001 number;v_ES002 number;v_ES003 number;v_ES004 number;
      v_ES005 number;v_ES006 number;v_ES007 number;v_ES008 number;
      v_EP001 number;v_EP002 number;v_EP003 number;v_EP004 number;
      v_EP005 number;v_EP006 number;
      v_EE001 number;v_EE002 number;v_EE003 number;v_EE004 number;
      v_bmid number;
     -- v_count number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
 /* ҵ񣨱ڰת״*/
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      delete t_b06_f002
       where p001=v_date
         and p002 in (select P001 from t_db_03_025 where w100 =v_bmid)
         and p003 = 1003
         and p004 in (1006009,1006011,1006013,1006015)
         and w100 =v_bmid;

      delete t_b06_f002
         where p001=v_date
          and p002=1111
          and p003 between 1001 and 1003
          and p004 between 1006001 and 1006015
          and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003, 1006009, nvl(A001,0),v_bmid
                    from t_db_03_025
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006011,nvl(A002,0),v_bmid
                    from t_db_03_025
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006013, nvl(A003,0),v_bmid
                    from t_db_03_025
                    where w100 =v_bmid;
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             select v_date, P001, 1003 , 1006015, nvl(A004,0),v_bmid
                    from t_db_03_025
                    where w100 =v_bmid;


      delete from t_b06_f002 where p001=v_date and p002=1111
      and w100 =v_bmid;

      --select count(*)into v_count from t_b06_f002 where p002=1111;
      select nvl(sum(v),0) into v_ES001
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES002
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006003 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES003
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES004
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES005
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES006
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006004 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES007
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_ES008
      from t_b06_f002
      where p002!=1111 and p003=1001 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006001 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP002
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006005 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP003
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006007 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP004
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006002 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP005
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006006 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EP006
      from t_b06_f002
      where p002!=1111 and p003=1002 and p004=1006008 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE001
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006009 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE002
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006011 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE003
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006013 and p001=v_date
      and w100 =v_bmid;

      select nvl(sum(v),0) into v_EE004
      from t_b06_f002
      where p002!=1111 and p003=1003 and p004=1006015 and p001=v_date
      and w100 =v_bmid;

      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006001,nvl(v_ES001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006003,nvl(v_ES002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006005,nvl(v_ES003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006007,nvl(v_ES004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006002,nvl(v_ES005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006004,nvl(v_ES006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006006,nvl(v_ES007,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1001,1006008,nvl(v_ES008,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006001,nvl(v_EP001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006005,nvl(v_EP002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006007,nvl(v_EP003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006002,nvl(v_EP004,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006006,nvl(v_EP005,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1002,1006008,nvl(v_EP006,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006009,nvl(v_EE001,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006011,nvl(v_EE002,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006013,nvl(v_EE003,0),v_bmid);
      insert into t_b06_f002(p001,p002,p003,p004,v,w100)
             values(v_date,1111,1003,1006015,nvl(v_EE004,0),v_bmid);
      --end if;
      update krcs.t_sys_t022 set A007=1010001 where P001=112005015 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112005015'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112005015;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112005015 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112005015!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112006001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112006001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);

       v_bmid number;
  /*
   ֤ȯͶҵ(Խʲĩϸ)
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      delete t_b02_f005
      where p003 in (1002100,1002101) and w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,p001,1002100,a002,v_bmid
           from t_DB_04_003
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,p001,1002101,a003,v_bmid
           from t_DB_04_003
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,1099000,1002100,nvl(sum(a002),0),v_bmid
           from t_DB_04_003
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,1099000,1002101,nvl(sum(a003),0),v_bmid
           from t_DB_04_003
           where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=112006001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112006001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112006001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112006001  and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112006001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112006002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112006002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);

      v_bmid number;
  /*
   ֤ȯͶҵ(ɹʲĩϸ)
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';


      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      delete t_b02_f005
      where p001=v_date and p003>=1002102 and p003<=1002104
      and w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,p001,1002102,a002,v_bmid
           from t_DB_04_004
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,p001,1002103,a003,v_bmid
           from t_DB_04_004
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,p001,1002104,a004,v_bmid
           from t_DB_04_004
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,1099000,1002102,nvl(sum(a002),0),v_bmid
           from t_DB_04_004
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,1099000,1002103,nvl(sum(a003),0),v_bmid
           from t_DB_04_004
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,1099000,1002104,nvl(sum(a004),0),v_bmid
           from t_DB_04_004
           where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=112006002  and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID112006002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112006002 ;/*ݱת־*/
       INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=6007  and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112006002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112006003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112006003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);

       v_bmid number;
   /*
   ֤ȯͶҵ(еڽʲĩϸ)
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;/* õǰ */
       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      delete t_b02_f005 where p001=v_date and p003>=1002105 and p003<=1002106
      and w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,p001,1002105,a002,v_bmid
           from t_DB_04_005
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,p001,1002106,a003,v_bmid
           from t_DB_04_005
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,1099000,1002105,nvl(sum(a002),0),v_bmid
           from t_DB_04_005
           where w100 =v_bmid;

      insert into t_b02_f005(p001,p002,p003,v,w100)
           select v_date,1099000,1002106,nvl(sum(a003),0),v_bmid
           from t_DB_04_005
           where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=112006003  and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID112006003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112006003 ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112006003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112006003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112006004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112006004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
   /*
   ֤ȯͶҵ(ط˵)
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;  /* õǰ */
      update krcs.t_sys_t022 set A007=1010001 where P001=112006004  and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112006004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112006004;/*ݱת־*/

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112006004 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112006004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112007001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112007001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
 /*֤ȯͶҵ񣨹ָڻͶʣ*/

     begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;/* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      delete t_b02_f006 where p001=v_date and p002>=1002201 and p002<=1002214
      and w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002201,p001,a002,v_bmid
      from T_DB_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002202,p001,a003,v_bmid
      from T_DB_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002203,p001,a004,v_bmid
      from T_DB_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002204,p001,a005,v_bmid
      from T_DB_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002205,p001,a006,v_bmid
      from T_DB_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002206,p001,a007,v_bmid
      from T_DB_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002207,p001,a008,v_bmid
      from T_DB_04_007
      where w100 =v_bmid;



      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002209,9999,sum(a003),v_bmid
      from t_db_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002210,9999,sum(a004),v_bmid
      from t_db_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002211,9999,sum(a005),v_bmid
      from t_db_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002212,9999,sum(a006),v_bmid
      from t_db_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002213,9999,sum(a007),v_bmid
      from t_db_04_007
      where w100 =v_bmid;

      insert into t_b02_f006(p001,p002,p003,v,w100)
      select v_date,1002214,9999,sum(a008),v_bmid
      from t_db_04_007
      where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=112007001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112007001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112007001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112007001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112007001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112008001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112008001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_orgid number;

  /*
   ʲҵĩͻ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_orgid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b04_f101 where p001=v_date and w100 = v_bmid;

      --˿ͻ
      insert into t_b04_f101(p001,p002,p003,v,w100)
        select v_date,b.a002,1004701,nvl(a.a002,0),v_bmid
        from T_DB_05_101 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.w100 = v_bmid;
      --ͻ
      insert into t_b04_f101(p001,p002,p003,v,w100)
        select v_date,b.a002,1004702,nvl(a.a003,0),v_bmid
        from T_DB_05_101 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.w100 = v_bmid;
      --ϼ(ֹϼ޸ø˿ͻ+ͻ)
      insert into t_b04_f101(p001,p002,p003,v,w100)
        select v_date,b.a002,1004703,nvl(a.a002,0)+nvl(a.a003,0),v_bmid
        from T_DB_05_101 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.w100 = v_bmid;


      update krcs.t_sys_t022 set A007=1010001 where P001=112008001 and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID112008001'||A002||'' INTO v_temp FROM krcs.t_sys_t011
        WHERE P001 = 112008001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
     exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112008001 and a004=v_bmid;
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112008001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112008002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112008002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_orgid number;

   /*
   ʲҵʽ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_orgid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b04_f102 where p001=v_date and w100 = v_bmid;

      --ڳ
      insert into t_b04_f102(p001,p002,p003,v,w100)
        select v_date,b.a002,1004801,nvl(a.a002,0),v_bmid
        from T_DB_05_102 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.a100 = b.a100
        and a.w100 = v_bmid;
      --
      insert into t_b04_f102(p001,p002,p003,v,w100)
        select v_date,b.a002,1004802,nvl(a.a003,0),v_bmid
        from T_DB_05_102 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.a100 = b.a100
        and a.w100 = v_bmid;
      --ڼ
      insert into t_b04_f102(p001,p002,p003,v,w100)
        select v_date,b.a002,1004803,nvl(a.a004,0),v_bmid
        from T_DB_05_102 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.a100 = b.a100
        and a.w100 = v_bmid;

      --ĩ
      insert into t_b04_f102(p001,p002,p003,v,w100)
        select v_date,b.a002,1004805,nvl(a.a006,0),v_bmid
        from T_DB_05_102 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.a100 = b.a100
        and a.w100 = v_bmid;
      --и˿ͻ
      insert into t_b04_f102(p001,p002,p003,v,w100)
        select v_date,b.a002,1004806,nvl(a.a007,0),v_bmid
        from T_DB_05_102 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and a.a100 = b.a100
        and a.w100 = v_bmid
        and b.a100 = v_orgid;
      --лͻ
      insert into t_b04_f102(p001,p002,p003,v,w100)
        select v_date,b.a002,1004807,nvl(a.a008,0),v_bmid
        from T_DB_05_102 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.a100 = b.a100
        and a.w100 = v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=112008002 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112008002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112008002 ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
    /*  exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112008002 and a004 = v_bmid; \*޸ת״̬ *\
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112008002!';
                return;*/
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112008003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112008003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_orgid number;
  /*
   ʲҵ񣨾ֵ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';/* õǰ */
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_orgid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b04_f103 where p001=v_date and w100 = v_bmid;

      --ڳλֵ
      insert into t_b04_f103(p001,p002,p003,v,w100)
        select v_date,b.a002,1004901,nvl(a.a002,0),v_bmid
        from T_DB_05_103 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.w100 = v_bmid;
      --ĩλֵ
      insert into t_b04_f103(p001,p002,p003,v,w100)
        select v_date,b.a002,1004902,nvl(a.a003,0),v_bmid
        from T_DB_05_103 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.w100 = v_bmid;
      --ۼƵλֶ
      insert into t_b04_f103(p001,p002,p003,v,w100)
        select v_date,b.a002,1004903,nvl(a.a004,0),v_bmid
        from T_DB_05_103 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.w100 = v_bmid;
      --ۼƵλֵ
      insert into t_b04_f103(p001,p002,p003,v,w100)
        select v_date,b.a002,1004904,nvl(a.a005,0),v_bmid
        from T_DB_05_103 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
        and b.a100 = v_orgid
        and a.w100 = v_bmid;


      update krcs.t_sys_t022 set A007=1010001 where P001=112008003 and a004 = v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112008003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112008003 ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=7103 and a004 = v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112008003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112009001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112009001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
       v_org number;
  /*
   רʲҵĩͻ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
	select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;
      delete t_b05_F101 where p001=v_date and w100 =v_bmid;

      --˿ͻ
      insert into t_b05_F101(p001,p002,p003,v,w100)
        select v_date,b.p002,1001,nvl(a.a002,0),v_bmid
        from T_DB_06_101 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
        and a.w100 =v_bmid
	and b.a100=v_org;
      --ͻ
      insert into t_b05_F101(p001,p002,p003,v,w100)
        select v_date,b.p002,1002,nvl(a.a003,0),v_bmid
        from T_DB_06_101 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --ϼ(ֹϼ޸ø˿ͻ+ͻ)
      insert into t_b05_F101(p001,p002,p003,v,w100)
        select v_date,b.p002,1003,nvl(a.a002,0)+nvl(a.a003,0),v_bmid
        from T_DB_06_101 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;


      update krcs.t_sys_t022 set A007=1010001 where P001=112009001 and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID112009001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112009001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
     exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112009001 and a004=v_bmid;
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112009001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112009002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112009002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_org number;
   /*
   רʲҵʵʷйģԪ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;

      delete t_b05_f102 where p001=v_date and w100 =v_bmid;

      --ݶ
      insert into t_b05_f102(p001,p002,p003,v,w100)
        select v_date,b.p002,1001,nvl(a.a002,0),v_bmid
        from T_DB_06_102 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --˿ͻ
      insert into t_b05_f102(p001,p002,p003,v,w100)
        select v_date,b.p002,1002,nvl(a.a003,0),v_bmid
        from T_DB_06_102 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --ͻ
      insert into t_b05_f102(p001,p002,p003,v,w100)
        select v_date,b.p002,1003,nvl(a.a004,0),v_bmid
        from T_DB_06_102 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --ܽ
      insert into t_b05_f102(p001,p002,p003,v,w100)
        select v_date,b.p002,1004,nvl(a.a003,0)+nvl(a.a004,0),v_bmid
        from T_DB_06_102 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --ʽ𱨸ĩ
      insert into t_b05_f102(p001,p002,p003,v,w100)
        select v_date,b.p002,1005,nvl(a.a006,0),v_bmid
        from T_DB_06_102 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;


      update krcs.t_sys_t022 set A007=1010001 where P001=112009002 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112009002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112009002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112009002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112009002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112009003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112009003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_org number;
  /*
   רʲҵ񣨾ֵ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';/* õǰ */
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select p002 into v_org from krcs.t_sys_user where p001 =v_KJAXUSER;

      delete t_b05_f103 where p001=v_date and w100 =v_bmid;

      --ʵս
      insert into t_b05_f103(p001,p002,p003,v,w100)
        select v_date,b.p002,1001,nvl(a.a002,0),v_bmid
        from T_DB_06_103 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --Ӧս
      insert into t_b05_f103(p001,p002,p003,v,w100)
        select v_date,b.p002,1002,nvl(a.a003,0),v_bmid
        from T_DB_06_103 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --ۼʵս
      insert into t_b05_f103(p001,p002,p003,v,w100)
        select v_date,b.p002,1003,nvl(a.a002,0)+nvl(a.a004,0),v_bmid
        from T_DB_06_103 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
      --ۼӦս
      insert into t_b05_f103(p001,p002,p003,v,w100)
        select v_date,b.p002,1004,nvl(a.a003,0)+nvl(a.a005,0),v_bmid
        from T_DB_06_103 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
     --ƷۼӦܽ
      insert into t_b05_f103(p001,p002,p003,v,w100)
        select v_date,b.p002,1005,nvl(a.a006,0),v_bmid
        from T_DB_06_103 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
     --У
      insert into t_b05_f103(p001,p002,p003,v,w100)
        select v_date,b.p002,1006,nvl(a.a007,0),v_bmid
        from T_DB_06_103 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;
     --Уμƾ֤ӦӦ
      insert into t_b05_f103(p001,p002,p003,v,w100)
        select v_date,b.p002,1007,nvl(a.a008,0),v_bmid
        from T_DB_06_103 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
	and b.a100=v_org
        and a.w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=112009003 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112009003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112009003;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112009003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112009003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112010001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112010001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
   /*
   ʲҵ񣨻
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --õǰ

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete T_B07_F001 where p001=v_date
      and w100 =v_bmid;
     --
      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,p001,1001,nvl(a002,0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid;

      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,p001,1002,nvl(a003,0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid;

      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,p001,1003,nvl(a004,0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid;



      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,p001,1005,nvl(a006,0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid;

      --ϸϼ
      delete from T_B07_F001 where p001 = v_date and p002 = 1200 and w100 = v_bmid;
      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1200,1001,nvl(sum(a002),0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1200,1002,nvl(sum(a003),0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1200,1003,nvl(sum(a004),0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid
      and p001 between 1210 and 1270;



      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1200,1005,nvl(sum(a006),0),v_bmid
      from T_DB_07_101
      where w100 =v_bmid
      and p001 between 1210 and 1270;
     --ϼ
      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1300,1001,nvl(sum(v),0),v_bmid
      from T_B07_F001
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1001;

      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1300,1002,nvl(sum(v),0),v_bmid
      from T_B07_F001
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1002;

      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1300,1003,nvl(sum(v),0),v_bmid
      from T_B07_F001
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1003;



      insert into T_B07_F001(p001,p002,p003,v,w100)
      select v_date,1300,1005,nvl(sum(v),0),v_bmid
      from T_B07_F001
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1005;

      update krcs.t_sys_t022 set A007=1010001 where P001=112010001 and a004=v_bmid; --޸ת״̬
      SELECT 'ݱתID112010001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112010001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112010001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112010001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112010002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112010002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
   /*
   ʲҵ񣨻
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --õǰ

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete T_B07_F002 where p001=v_date
      and w100 =v_bmid;
      --
      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,p001,1001,nvl(a002,0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid;

      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,p001,1002,nvl(a003,0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid;

      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,p001,1003,nvl(a004,0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid;



      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,p001,1005,nvl(a006,0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid;


      --ϸϼ
      delete from T_B07_F002 where p001 = v_date and p002 = 1200 and w100 = v_bmid;
      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1200,1001,nvl(sum(a002),0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1200,1002,nvl(sum(a003),0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1200,1003,nvl(sum(a004),0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid
      and p001 between 1210 and 1270;



      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1200,1005,nvl(sum(a006),0),v_bmid
      from T_DB_07_102
      where w100 =v_bmid
      and p001 between 1210 and 1270;
     --ϼ
      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1300,1001,nvl(sum(v),0),v_bmid
      from T_B07_F002
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1001;

      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1300,1002,nvl(sum(v),0),v_bmid
      from T_B07_F002
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1002;

      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1300,1003,nvl(sum(v),0),v_bmid
      from T_B07_F002
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1003;

      /*insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1300,1004,nvl(sum(v),0),v_bmid
      from T_B07_F002
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1004;*/

      insert into T_B07_F002(p001,p002,p003,v,w100)
      select v_date,1300,1005,nvl(sum(v),0),v_bmid
      from T_B07_F002
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1005;

      update krcs.t_sys_t022 set A007=1010001 where P001=112010002 and a004=v_bmid; --޸ת״̬
      SELECT 'ݱתID112010002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112010002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112010002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112010002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112011001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112011001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_status number;
      v_EP001 number;
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP005 number;
      v_EP006 number;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete from t_b12_f001 where p001=v_date and w100 =v_bmid;

      insert into T_B12_F001(P001,P002,P003,V,W100) select v_date,p001,1012001,nvl(a002,0),v_bmid from t_db_08_001
      where w100 =v_bmid;
      insert into T_B12_F001(P001,P002,P003,V,W100) select v_date,p001,1012002,nvl(a003,0),v_bmid from t_db_08_001
      where w100 =v_bmid;
      insert into T_B12_F001(P001,P002,P003,V,W100) select v_date,p001,1012003,nvl(a004,0),v_bmid from t_db_08_001
      where w100 =v_bmid;
      insert into T_B12_F001(P001,P002,P003,V,W100) select v_date,p001,1012004,nvl(a005,0)+nvl(a002,0),v_bmid from t_db_08_001
      where w100 =v_bmid;
      insert into T_B12_F001(P001,P002,P003,V,W100) select v_date,p001,1012005,nvl(a006,0)+nvl(a003,0),v_bmid from t_db_08_001
      where w100 =v_bmid;
      insert into T_B12_F001(P001,P002,P003,V,W100) select v_date,p001,1012006,nvl(a007,0)+nvl(a004,0),v_bmid from t_db_08_001
      where w100 =v_bmid;

      select nvl(sum(v),0) into v_EP001 from t_b12_f001 where p003=1012001 and p001=v_date
      and w100 =v_bmid;
      select nvl(sum(v),0) into v_EP002 from t_b12_f001 where p003=1012002 and p001=v_date
      and w100 =v_bmid;
      select nvl(sum(v),0) into v_EP003 from t_b12_f001 where p003=1012003 and p001=v_date
      and w100 =v_bmid;
      select nvl(sum(v),0) into v_EP004 from t_b12_f001 where p003=1012004 and p001=v_date
      and w100 =v_bmid;
      select nvl(sum(v),0) into v_EP005 from t_b12_f001 where p003=1012005 and p001=v_date
      and w100 =v_bmid;
      select nvl(sum(v),0) into v_EP006 from t_b12_f001 where p003=1012006 and p001=v_date
      and w100 =v_bmid;

      insert into t_b12_f001(p001,p002,p003,v,w100) values (v_date,1008,1012001,v_EP001,v_bmid);
      insert into t_b12_f001(p001,p002,p003,v,w100) values (v_date,1008,1012002,v_EP002,v_bmid);
      insert into t_b12_f001(p001,p002,p003,v,w100) values (v_date,1008,1012003,v_EP003,v_bmid);
      insert into t_b12_f001(p001,p002,p003,v,w100) values (v_date,1008,1012004,v_EP004,v_bmid);
      insert into t_b12_f001(p001,p002,p003,v,w100) values (v_date,1008,1012005,v_EP005,v_bmid);
      insert into t_b12_f001(p001,p002,p003,v,w100) values (v_date,1008,1012006,v_EP006,v_bmid);

      update krcs.t_sys_t022 set A007=1010001 where P001 in (112011001,112011002) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'תݱ112011001'||A002 INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112011001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'תݱ112011002'||A002 INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112011002;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);


      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in (112011001,112011002) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112011001!';
                return;


  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112014001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112014001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp                varchar(256);
      v_type                number;                               -- Ӫ1001 ʲҵ1002 Ϳͻ1003 ϼ1004
      v_xm                  number;                               --Ŀ ȯع
      v_market              number;                               --г Ϻ1001 1002 мг1003

      v_shjsymwdqje         number(20,2);                         --Ͻĩδڽ
      v_szjsymwdqje         number(20,2);                         --ĩδڽ
      v_yhscymwdqje         number(20,2);                         --мгĩδڽ
      v_shjsbyfsze          number(20,2);                         --Ͻ·ܶ
      v_szjsbyfsze          number(20,2);                         --·ܶ
      v_yhscbyfsze          number(20,2);                         --мг·ܶ
      v_shjssyljbnfsze      number(20,2);                         --ϽۼƱ귢ܶ
      v_szjssyljbnfsze      number(20,2);                         --ۼƱ귢ܶ
      v_yhscsyljbnfsze      number(20,2);                         --мۼƱ귢ܶ

      v_sum_ymwdqje_ze      number(20,2);                         --ĩδܶ
      v_sum_ymwdqje_shjs    number(20,2);                         --ĩδϽܶ
      v_sum_ymwdqje_szjs    number(20,2);                         --ĩδܶ
      v_sum_ymwdqje_yhjsc   number(20,2);                         --ĩδмгܶ
      v_sum_bnfselj_ze      number(20,2);                         --귢ۼܶ
      v_sum_bnfselj_shjs    number(20,2);                         --귢ۼϽܶ
      v_sum_bnfselj_szjs    number(20,2);                         --귢ۼܶ
      v_sum_bnfselj_yhjsc   number(20,2);                         --귢ۼмгܶ
      v_status              integer;
      v_bmid number;

      cursor cur_rzrq is                               --ȯα Ŀͷ
             select *
               from (
                   select 1001 as TYPE,a.P001,nvl(a.A002,0),nvl(a.A003,0),nvl(a.A004,0),
                          nvl(a.A007,0),nvl(a.A008,0),nvl(a.A009,0),nvl(a.A010,0),
                          nvl(a.A011,0),nvl(a.A012,0)   --Ӫ
                     from T_DB_09_001 a
                     where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                   union
                   select 1002 as TYPE,b.P001,nvl(b.A002,0),nvl(b.A003,0),nvl(b.A004,0),
                          nvl(b.A007,0),nvl(b.A008,0),nvl(b.A009,0),nvl(b.A010,0),
                          nvl(b.A011,0),nvl(b.A012,0)  --Ϳͻ
                     from T_DB_09_002 b
                     where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                   union
                   select 1003 as TYPE,b.P001,nvl(b.A002,0),nvl(b.A003,0),nvl(b.A004,0),
                          nvl(b.A007,0),nvl(b.A008,0),nvl(b.A009,0),nvl(b.A010,0),nvl(b.A011,0),
                          nvl(b.A012,0)
                     from T_DB_09_003 b
                     where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                    )
               order by p001;

     cursor cur_rzrq_sum1 is
             select p001,nvl(sum(A002),0)+nvl(sum(A003),0)+nvl(sum(A004),0), ----ȯα Ŀϼ
                    nvl(sum(A002),0),
                    nvl(sum(A003),0),
                    nvl(sum(A004),0),
                    nvl(sum(A007),0)+nvl(sum(A008),0)+nvl(sum(A009),0)
                    +nvl(sum(A010),0)+nvl(sum(A011),0)+nvl(sum(A012),0),
                    nvl(sum(A007),0)+nvl(sum(A010),0),
                    nvl(sum(A008),0)+nvl(sum(A011),0),
                    nvl(sum(A009),0)+nvl(sum(A012),0)
                    from (

                       select 1001 as TYPE,a.P001,nvl(a.A002,0) as A002,nvl(a.A003,0) as A003,
                              nvl(a.A004,0) as A004,nvl(a.A007,0) as A007,nvl(a.A008,0) as A008,
                              nvl(a.A009,0) as A009,nvl(a.A010,0) as A010,nvl(a.A011,0) as A011,
                              nvl(a.A012,0) as A012   --Ӫ
                         from T_DB_09_001 a
                         where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                       union
                       select 1002 as TYPE,b.P001,nvl(b.A002,0) as A002,nvl(b.A003,0) as A003,
                              nvl(b.A004,0) as A004,nvl(b.A007,0) as A007,nvl(b.A008,0) as A008,
                              nvl(b.A009,0) as A009,nvl(b.A010,0) as A010,nvl(b.A011,0) as A011,
                              nvl(b.A012,0) as A012   --ʲ
                         from T_DB_09_002 b
                         where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                       union
                       select 1003 as TYPE,c.P001,nvl(c.A002,0) as A002,nvl(c.A003,0) as A003,
                              nvl(c.A004,0) as A004,nvl(c.A007,0) as A007,nvl(c.A008,0) as A008,
                              nvl(c.A009,0) as A009,nvl(c.A010,0) as A010,nvl(c.A011,0) as A011,
                              nvl(c.A012,0) as A012
                         from T_DB_09_003 c
                         where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                        )
                    group by p001

                    union

                    select 1101,nvl(sum(A002),0)+nvl(sum(A003),0)+nvl(sum(A004),0),--ծȯʻعܼ
                      nvl(sum(A002),0),
                      nvl(sum(A003),0),
                      nvl(sum(A004),0),
                      nvl(sum(A007),0)+nvl(sum(A008),0)+nvl(sum(A009),0)
                      +nvl(sum(A010),0)+nvl(sum(A011),0)+nvl(sum(A012),0),
                      nvl(sum(A007),0)+nvl(sum(A010),0),
                      nvl(sum(A008),0)+nvl(sum(A011),0),
                      nvl(sum(A009),0)+nvl(sum(A012),0)
                      from (

                         select 1001 as TYPE,a.P001,nvl(a.A002,0) as A002,nvl(a.A003,0) as A003,
                                nvl(a.A004,0) as A004,nvl(a.A007,0) as A007,nvl(a.A008,0) as A008,
                                nvl(a.A009,0) as A009,nvl(a.A010,0) as A010,nvl(a.A011,0) as A011,
                                nvl(a.A012,0) as A012   --Ӫ
                           from T_DB_09_001 a
                           where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                         union
                         select 1002 as TYPE,b.P001,nvl(b.A002,0) as A002,nvl(b.A003,0) as A003,
                                nvl(b.A004,0) as A004,nvl(b.A007,0) as A007,nvl(b.A008,0) as A008,
                                nvl(b.A009,0) as A009,nvl(b.A010,0) as A010,nvl(b.A011,0) as A011,
                                nvl(b.A012,0) as A012   --ʲ
                           from T_DB_09_002 b
                           where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                         union
                         select 1003 as TYPE,c.P001,nvl(c.A002,0) as A002,nvl(c.A003,0) as A003,
                                nvl(c.A004,0) as A004,nvl(c.A007,0) as A007,nvl(c.A008,0) as A008,
                                nvl(c.A009,0) as A009,nvl(c.A010,0) as A010,nvl(c.A011,0) as A011,
                                nvl(c.A012,0) as A012
                           from T_DB_09_003 c
                           where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                          )
                      where p001 in (1001,1003,1098)

                      union

                      select 1102,nvl(sum(A002),0)+nvl(sum(A003),0)+nvl(sum(A004),0),     --ծȯȯعܼ
                            nvl(sum(A002),0),
                            nvl(sum(A003),0),
                            nvl(sum(A004),0),
                            nvl(sum(A007),0)+nvl(sum(A008),0)+nvl(sum(A009),0)
                            +nvl(sum(A010),0)+nvl(sum(A011),0)+nvl(sum(A012),0),
                            nvl(sum(A007),0)+nvl(sum(A010),0),
                            nvl(sum(A008),0)+nvl(sum(A011),0),
                            nvl(sum(A009),0)+nvl(sum(A012),0)
                            from (

                               select 1001 as TYPE,a.P001,nvl(a.A002,0) as A002,nvl(a.A003,0) as A003,
                                      nvl(a.A004,0) as A004,nvl(a.A007,0) as A007,nvl(a.A008,0) as A008,
                                      nvl(a.A009,0) as A009,nvl(a.A010,0) as A010,nvl(a.A011,0) as A011,
                                      nvl(a.A012,0) as A012   --Ӫ
                                 from T_DB_09_001 a
                                 where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                               union
                               select 1002 as TYPE,b.P001,nvl(b.A002,0) as A002,nvl(b.A003,0) as A003,
                                      nvl(b.A004,0) as A004,nvl(b.A007,0) as A007,nvl(b.A008,0) as A008,
                                      nvl(b.A009,0) as A009,nvl(b.A010,0) as A010,nvl(b.A011,0) as A011,
                                      nvl(b.A012,0) as A012   --ʲ
                                 from T_DB_09_002 b
                                 where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                               union
                               select 1003 as TYPE,c.P001,nvl(c.A002,0) as A002,nvl(c.A003,0) as A003,
                                      nvl(c.A004,0) as A004,nvl(c.A007,0) as A007,nvl(c.A008,0) as A008,
                                      nvl(c.A009,0) as A009,nvl(c.A010,0) as A010,nvl(c.A011,0) as A011,
                                      nvl(c.A012,0) as A012
                                 from T_DB_09_003 c
                                 where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                                )
                            where p001 in (1002,1004,1099);
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete from t_b14_f001 where p001=v_date and w100 =v_bmid;
      --------------------------------------------------------------------------
      ---------------------------ϲ-------------------------------------
      --------------------------------------------------------------------------
      open cur_rzrq;
      fetch cur_rzrq into v_type,v_xm,v_shjsymwdqje,v_szjsymwdqje,v_yhscymwdqje,
                          v_shjsbyfsze,v_szjsbyfsze,v_yhscbyfsze,
                          v_shjssyljbnfsze,v_szjssyljbnfsze,v_yhscsyljbnfsze;
      while cur_rzrq%found
      loop
             --гϺ
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1001,1014001,v_shjsymwdqje,v_bmid);
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1001,1014002,v_shjsbyfsze+v_shjssyljbnfsze,v_bmid);
             --г
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1002,1014001,v_szjsymwdqje,v_bmid);
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1002,1014002,v_szjsbyfsze+v_szjssyljbnfsze,v_bmid);
             --гмг
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1003,1014001,v_yhscymwdqje,v_bmid);
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1003,1014002,v_yhscbyfsze+v_yhscsyljbnfsze,v_bmid);
             --õָ꣨ĩδڽ  õĿͷӦĺϼ
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1000,1014001,v_shjsymwdqje+v_szjsymwdqje+v_yhscymwdqje,v_bmid);
             insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1000,1014002,v_shjsbyfsze+v_shjssyljbnfsze
                                                   +v_szjsbyfsze+v_szjssyljbnfsze
                                                   +v_yhscbyfsze+v_yhscsyljbnfsze,v_bmid);
             fetch cur_rzrq into v_type,v_xm,v_shjsymwdqje,v_szjsymwdqje,v_yhscymwdqje,
                   v_shjsbyfsze,v_szjsbyfsze,v_yhscbyfsze,
                   v_shjssyljbnfsze,v_szjssyljbnfsze,v_yhscsyljbnfsze;
      end loop;
      close cur_rzrq;
      --ϼƼ¼ĿϼƺͰȯʻعܼơծȯȯعܼƣ
      open cur_rzrq_sum1;
      fetch cur_rzrq_sum1
            into v_xm,v_sum_ymwdqje_ze,v_sum_ymwdqje_shjs,v_sum_ymwdqje_szjs,v_sum_ymwdqje_yhjsc,
            v_sum_bnfselj_ze,v_sum_bnfselj_shjs,v_sum_bnfselj_szjs,v_sum_bnfselj_yhjsc;
      while cur_rzrq_sum1%found
      loop
           --ܶ
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1000,1014001,v_sum_ymwdqje_ze,v_bmid);
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1000,1014002,v_sum_bnfselj_ze,v_bmid);
           --Ͻ
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1001,1014001,v_sum_ymwdqje_shjs,v_bmid);
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1001,1014002,v_sum_bnfselj_shjs,v_bmid);
           --
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1002,1014001,v_sum_ymwdqje_szjs,v_bmid);
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1002,1014002,v_sum_bnfselj_szjs,v_bmid);
           --мг
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1003,1014001,v_sum_ymwdqje_yhjsc,v_bmid);
           insert into t_B14_F001(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1003,1014002,v_sum_bnfselj_yhjsc,v_bmid);

           fetch cur_rzrq_sum1
               into v_xm,v_sum_ymwdqje_ze,v_sum_ymwdqje_shjs,v_sum_ymwdqje_szjs,v_sum_ymwdqje_yhjsc,
               v_sum_bnfselj_ze,v_sum_bnfselj_shjs,v_sum_bnfselj_szjs,v_sum_bnfselj_yhjsc;
      end loop;
      close cur_rzrq_sum1;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112014001,112014002,112014003) and a004=v_bmid; /*޸ת״̬ */

      SELECT 'ݱתID112014001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112014001 ;/*ݱת־*/
      SELECT 'ݱתID112014002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112014002 ;
      SELECT 'ݱתID112014003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112014003 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
           update krcs.t_sys_t022 set A007=1010002 where P001 in(112014001,112014002,112014003) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112014001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112014004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112014004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp                varchar(256);
      v_type                number;                               -- Ӫ1001 ʲҵ1002 Ϳͻ1003 ϼ1004
      v_xm                  number;                               --Ŀ ȯع
      v_market              number;                               --г Ϻ1001 1002 мг1003

      v_shjs         number(20,2);                         --Ͻ
      v_szjs         number(20,2);                         --
      v_yhsc         number(20,2);                         --мг
      v_ze          number(20,2);                         --ܶ
      v_status      integer;
      v_bmid number;


      cursor cur_rzrq is                               --ȯα Ŀͷ
          select *
          from
          (

          select 1001 as type,P001,nvl(a.A003,0)+nvl(a.A004,0)+nvl(a.A005,0) as hj,
                 nvl(a.A003,0) as a003,nvl(a.A004,0) as a004,nvl(a.A005,0) as a005
            from T_DB_10_001 a
            where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
          union
          select 1002 as type,P001,nvl(b.A003,0)+nvl(b.A004,0)+nvl(b.a005,0) as hj,
                 nvl(b.A003,0) as a003,nvl(b.A004,0) as a004,nvl(b.a005,0) as a005
            from T_DB_10_002 b
            where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
          union
          select 1003 as type,P001,nvl(c.A003,0)+nvl(c.A004,0)+nvl(c.a005,0) as hj,
                 nvl(c.A003,0) as a003,nvl(c.A004,0) as a004,nvl(c.a005,0) as a005
            from T_DB_10_003 c
            where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
           )
           order by p001;

      cursor cur_rzrq_sum is                        --ϼ
             select p001,sum(hj),sum(a003),sum(a004),sum(a005)
               from
               (
                select 1001 as type,P001,nvl(a.A003,0)+nvl(a.A004,0)+nvl(a.A005,0) as hj,
                       nvl(a.A003,0) as a003,nvl(a.A004,0) as a004,nvl(a.A005,0) as a005
                  from T_DB_10_001 a
                  where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                union
                select 1002 as type,P001,nvl(b.A003,0)+nvl(b.A004,0)+nvl(b.a005,0) as hj,
                       nvl(b.A003,0) as a003,nvl(b.A004,0) as a004,nvl(b.a005,0) as a005
                  from T_DB_10_002 b
                  where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                union
                select 1003 as type,P001,nvl(c.A003,0)+nvl(c.A004,0)+nvl(c.a005,0) as hj,
                       nvl(c.A003,0) as a003,nvl(c.A004,0) as a004,nvl(c.a005,0) as a005
                  from T_DB_10_003 c
                  where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                )
                group by p001;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete from t_b14_f002 where p001=v_date and w100 =v_bmid;
      --------------------------------------------------------------------------
      ---------------------------ϲ-----------------------------------
      --------------------------------------------------------------------------
      open cur_rzrq;
      fetch cur_rzrq into v_type,v_xm,v_ze,v_shjs,v_szjs,v_yhsc;
      while cur_rzrq%found
      loop
             --Ͻ
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1001,v_type,v_shjs,v_bmid);
             --
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1002,v_type,v_szjs,v_bmid);
             --мг
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1003,v_type,v_yhsc,v_bmid);
             --ܶ
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1000,v_type,v_ze,v_bmid);
             fetch cur_rzrq into v_type,v_xm,v_ze,v_shjs,v_szjs,v_yhsc;
      end loop;
      close cur_rzrq;
      --ϼƼ¼
      open cur_rzrq_sum;
      fetch cur_rzrq_sum into v_xm,v_ze,v_shjs,v_szjs,v_yhsc;
      while cur_rzrq_sum%found
      loop
             --Ͻ
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1001,1004,v_shjs,v_bmid);
             --
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1002,1004,v_szjs,v_bmid);
             --мг
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1003,1004,v_yhsc,v_bmid);
             --ܶ
             insert into t_B14_F002(P001,P002,P003,P004,V,W100)
             values(v_date,v_xm,1000,1004,v_ze,v_bmid);
             fetch cur_rzrq_sum into v_xm,v_ze,v_shjs,v_szjs,v_yhsc;
      end loop;
      close cur_rzrq_sum;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112014004,112014005,112014006) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112014004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112014004;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

      SELECT 'ݱתID112014005'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112014005;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

      SELECT 'ݱתID112014006'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112014006 ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112014004,112014005,112014006) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112014004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112015001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112015001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp                varchar(256);
      v_type                number;                               -- Ӫ1001 ʲҵ1002 Ϳͻ1003 ϼ1004
      v_xm                  number;                               --Ŀ ȯع
      ----v_market              number;                               --г Ϻ1001 1002 мг1003

      v_shjsymwdqje         number(20,2);                         --Ͻĩδڽ
      v_szjsymwdqje         number(20,2);                         --ĩδڽ
      v_yhscymwdqje         number(20,2);                         --мгĩδڽ
      v_shjsbyfsze          number(20,2);                         --Ͻ·ܶ
      v_szjsbyfsze          number(20,2);                         --·ܶ
      v_yhscbyfsze          number(20,2);                         --мг·ܶ
      v_shjssyljbnfsze      number(20,2);                         --ϽۼƱ귢ܶ
      v_szjssyljbnfsze      number(20,2);                         --ۼƱ귢ܶ
      v_yhscsyljbnfsze      number(20,2);                         --мۼƱ귢ܶ

      v_sum_ymwdqje_ze      number(20,2);                         --ĩδܶ
      v_sum_ymwdqje_shjs    number(20,2);                         --ĩδϽܶ
      v_sum_ymwdqje_szjs    number(20,2);                         --ĩδܶ
      v_sum_ymwdqje_yhjsc   number(20,2);                         --ĩδмгܶ
      v_sum_bnfselj_ze      number(20,2);                         --귢ۼܶ
      v_sum_bnfselj_shjs    number(20,2);                         --귢ۼϽܶ
      v_sum_bnfselj_szjs    number(20,2);                         --귢ۼܶ
      v_sum_bnfselj_yhjsc   number(20,2);                         --귢ۼмгܶ
      v_status              integer;
      v_bmid number;

      cursor cur_rzrq is                               --ȯα Ŀͷ
             select *
               from (
                   select 1001 as TYPE,a.P001,nvl(a.A002,0),nvl(a.A003,0),nvl(a.A004,0),
                          nvl(a.A007,0),nvl(a.A008,0),nvl(a.A009,0),nvl(a.A010,0),
                          nvl(a.A011,0),nvl(a.A012,0)   --Ӫ
                     from T_DB_11_001 a
                     where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                   union
                   select 1002 as TYPE,b.P001,nvl(b.A002,0),nvl(b.A003,0),nvl(b.A004,0),
                          nvl(b.A007,0),nvl(b.A008,0),nvl(b.A009,0),nvl(b.A010,0),
                          nvl(b.A011,0),nvl(b.A012,0)  --ʲ
                     from T_DB_11_002 b
                     where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                   union
                   select 1003 as TYPE,b.P001,nvl(b.A002,0),nvl(b.A003,0),nvl(b.A004,0),
                          nvl(b.A007,0),nvl(b.A008,0),nvl(b.A009,0),nvl(b.A010,0),nvl(b.A011,0),
                          nvl(b.A012,0)                --Ϳͻ
                     from T_DB_11_003 b
                     where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                    )
               order by p001;

     cursor cur_rzrq_sum1 is
             select p001,nvl(sum(A002),0)+nvl(sum(A003),0)+nvl(sum(A004),0), ----ȯα Ŀϼ
                    nvl(sum(A002),0),
                    nvl(sum(A003),0),
                    nvl(sum(A004),0),
                    nvl(sum(A007),0)+nvl(sum(A008),0)+nvl(sum(A009),0)
                    +nvl(sum(A010),0)+nvl(sum(A011),0)+nvl(sum(A012),0),
                    nvl(sum(A007),0)+nvl(sum(A010),0),
                    nvl(sum(A008),0)+nvl(sum(A011),0),
                    nvl(sum(A009),0)+nvl(sum(A012),0)
                    from (
                       select 1001 as TYPE,a.P001,nvl(a.A002,0) as A002,nvl(a.A003,0) as A003,
                              nvl(a.A004,0) as A004,nvl(a.A007,0) as A007,nvl(a.A008,0) as A008,
                              nvl(a.A009,0) as A009,nvl(a.A010,0) as A010,nvl(a.A011,0) as A011,
                              nvl(a.A012,0) as A012   --Ӫ
                         from T_DB_11_001 a
                         where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                       union
                       select 1002 as TYPE,b.P001,nvl(b.A002,0) as A002,nvl(b.A003,0) as A003,
                              nvl(b.A004,0) as A004,nvl(b.A007,0) as A007,nvl(b.A008,0) as A008,
                              nvl(b.A009,0) as A009,nvl(b.A010,0) as A010,nvl(b.A011,0) as A011,
                              nvl(b.A012,0) as A012   --ʲ
                         from T_DB_11_002 b
                         where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                       union
                       select 1003 as TYPE,c.P001,nvl(c.A002,0) as A002,nvl(c.A003,0) as A003,
                              nvl(c.A004,0) as A004,nvl(c.A007,0) as A007,nvl(c.A008,0) as A008,
                              nvl(c.A009,0) as A009,nvl(c.A010,0) as A010,nvl(c.A011,0) as A011,
                              nvl(c.A012,0) as A012   --ҵ
                         from T_DB_11_003 c
                         where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                        )
                    group by p001

                    union

                    select 1101,nvl(sum(A002),0)+nvl(sum(A003),0)+nvl(sum(A004),0),--ծȯʻعܼ
                      nvl(sum(A002),0),
                      nvl(sum(A003),0),
                      nvl(sum(A004),0),
                      nvl(sum(A007),0)+nvl(sum(A008),0)+nvl(sum(A009),0)
                      +nvl(sum(A010),0)+nvl(sum(A011),0)+nvl(sum(A012),0),
                      nvl(sum(A007),0)+nvl(sum(A010),0),
                      nvl(sum(A008),0)+nvl(sum(A011),0),
                      nvl(sum(A009),0)+nvl(sum(A012),0)
                      from (
                         select 1001 as TYPE,a.P001,nvl(a.A002,0) as A002,nvl(a.A003,0) as A003,
                                nvl(a.A004,0) as A004,nvl(a.A007,0) as A007,nvl(a.A008,0) as A008,
                                nvl(a.A009,0) as A009,nvl(a.A010,0) as A010,nvl(a.A011,0) as A011,
                                nvl(a.A012,0) as A012   --Ӫ
                           from T_DB_11_001 a
                           where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                         union
                         select 1002 as TYPE,b.P001,nvl(b.A002,0) as A002,nvl(b.A003,0) as A003,
                                nvl(b.A004,0) as A004,nvl(b.A007,0) as A007,nvl(b.A008,0) as A008,
                                nvl(b.A009,0) as A009,nvl(b.A010,0) as A010,nvl(b.A011,0) as A011,
                                nvl(b.A012,0) as A012   --ʲ
                           from T_DB_11_002 b
                           where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                         union
                         select 1003 as TYPE,c.P001,nvl(c.A002,0) as A002,nvl(c.A003,0) as A003,
                                nvl(c.A004,0) as A004,nvl(c.A007,0) as A007,nvl(c.A008,0) as A008,
                                nvl(c.A009,0) as A009,nvl(c.A010,0) as A010,nvl(c.A011,0) as A011,
                                nvl(c.A012,0) as A012   --ҵ
                           from T_DB_11_003 c
                           where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                          )
                      where p001 in (1001,1003,1098)

                      union

                      select 1102,nvl(sum(A002),0)+nvl(sum(A003),0)+nvl(sum(A004),0),     --ծȯȯعܼ
                            nvl(sum(A002),0),
                            nvl(sum(A003),0),
                            nvl(sum(A004),0),
                            nvl(sum(A007),0)+nvl(sum(A008),0)+nvl(sum(A009),0)
                            +nvl(sum(A010),0)+nvl(sum(A011),0)+nvl(sum(A012),0),
                            nvl(sum(A007),0)+nvl(sum(A010),0),
                            nvl(sum(A008),0)+nvl(sum(A011),0),
                            nvl(sum(A009),0)+nvl(sum(A012),0)
                            from (
                               select 1001 as TYPE,a.P001,nvl(a.A002,0) as A002,nvl(a.A003,0) as A003,
                                      nvl(a.A004,0) as A004,nvl(a.A007,0) as A007,nvl(a.A008,0) as A008,
                                      nvl(a.A009,0) as A009,nvl(a.A010,0) as A010,nvl(a.A011,0) as A011,
                                      nvl(a.A012,0) as A012   --Ӫ
                                 from T_DB_11_001 a
                                 where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                               union
                               select 1002 as TYPE,b.P001,nvl(b.A002,0) as A002,nvl(b.A003,0) as A003,
                                      nvl(b.A004,0) as A004,nvl(b.A007,0) as A007,nvl(b.A008,0) as A008,
                                      nvl(b.A009,0) as A009,nvl(b.A010,0) as A010,nvl(b.A011,0) as A011,
                                      nvl(b.A012,0) as A012   --ʲ
                                 from T_DB_11_002 b
                                 where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                               union
                               select 1003 as TYPE,c.P001,nvl(c.A002,0) as A002,nvl(c.A003,0) as A003,
                                      nvl(c.A004,0) as A004,nvl(c.A007,0) as A007,nvl(c.A008,0) as A008,
                                      nvl(c.A009,0) as A009,nvl(c.A010,0) as A010,nvl(c.A011,0) as A011,
                                      nvl(c.A012,0) as A012   --ҵ
                                 from T_DB_11_003 c
                                 where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER)
                                )
                            where p001 in (1002,1004,1099);
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete from t_b14_f003 where p001=v_date and w100 =v_bmid;
      --------------------------------------------------------------------------
      ---------------------------ϲ-------------------------------------
      --------------------------------------------------------------------------
      open cur_rzrq;
      fetch cur_rzrq into v_type,v_xm,v_shjsymwdqje,v_szjsymwdqje,v_yhscymwdqje,
                          v_shjsbyfsze,v_szjsbyfsze,v_yhscbyfsze,
                          v_shjssyljbnfsze,v_szjssyljbnfsze,v_yhscsyljbnfsze;
      while cur_rzrq%found
      loop
             --гϺ
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1001,1014001,v_shjsymwdqje,v_bmid);
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1001,1014002,v_shjsbyfsze+v_shjssyljbnfsze,v_bmid);
             --г
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1002,1014001,v_szjsymwdqje,v_bmid);
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1002,1014002,v_szjsbyfsze+v_szjssyljbnfsze,v_bmid);
             --гмг
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1003,1014001,v_yhscymwdqje,v_bmid);
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1003,1014002,v_yhscbyfsze+v_yhscsyljbnfsze,v_bmid);
             --õָ꣨ĩδڽ  õĿͷӦĺϼ
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1000,1014001,v_shjsymwdqje+v_szjsymwdqje+v_yhscymwdqje,v_bmid);
             insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
             values(v_date,v_xm,v_type,1000,1014002,v_shjsbyfsze+v_shjssyljbnfsze
                                                   +v_szjsbyfsze+v_szjssyljbnfsze
                                                   +v_yhscbyfsze+v_yhscsyljbnfsze,v_bmid);
             fetch cur_rzrq into v_type,v_xm,v_shjsymwdqje,v_szjsymwdqje,v_yhscymwdqje,
                   v_shjsbyfsze,v_szjsbyfsze,v_yhscbyfsze,
                   v_shjssyljbnfsze,v_szjssyljbnfsze,v_yhscsyljbnfsze;
      end loop;
      close cur_rzrq;
      --ϼƼ¼ĿϼƺͰȯʻعܼơծȯȯعܼƣ
      open cur_rzrq_sum1;
      fetch cur_rzrq_sum1
            into v_xm,v_sum_ymwdqje_ze,v_sum_ymwdqje_shjs,v_sum_ymwdqje_szjs,v_sum_ymwdqje_yhjsc,
            v_sum_bnfselj_ze,v_sum_bnfselj_shjs,v_sum_bnfselj_szjs,v_sum_bnfselj_yhjsc;
      while cur_rzrq_sum1%found
      loop
           --ܶ
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1000,1014001,v_sum_ymwdqje_ze,v_bmid);
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1000,1014002,v_sum_bnfselj_ze,v_bmid);
           --Ͻ
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1001,1014001,v_sum_ymwdqje_shjs,v_bmid);
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1001,1014002,v_sum_bnfselj_shjs,v_bmid);
           --
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1002,1014001,v_sum_ymwdqje_szjs,v_bmid);
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1002,1014002,v_sum_bnfselj_szjs,v_bmid);
           --мг
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1003,1014001,v_sum_ymwdqje_yhjsc,v_bmid);
           insert into t_B14_F003(P001,P002,P003,P004,P005,V,W100)
           values(v_date,v_xm,1004,1003,1014002,v_sum_bnfselj_yhjsc,v_bmid);

           fetch cur_rzrq_sum1
               into v_xm,v_sum_ymwdqje_ze,v_sum_ymwdqje_shjs,v_sum_ymwdqje_szjs,v_sum_ymwdqje_yhjsc,
               v_sum_bnfselj_ze,v_sum_bnfselj_shjs,v_sum_bnfselj_szjs,v_sum_bnfselj_yhjsc;
      end loop;
      close cur_rzrq_sum1;


      update krcs.t_sys_t022 set A007=1010001 where P001 in(112015001,112015002,112015003) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112015001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112015001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID112015002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112015002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID112015003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112015003;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112015001,112015002,112015003) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112015001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112016001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112016001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete t_b08_f001 where p003>=1008001 and p003<=1008005 and p001=v_date
      and w100 =v_bmid;

      --ݱû1001ͬҵ裩1005ծȯع1006ծȯع룩1009ծȯعڳȽǰݿγʵ
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,p001,1008001,nvl(a002,0),v_bmid from t_db_12_001
      where w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,p001,1008002,nvl(a003,0),v_bmid from t_db_12_001
      where w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,p001,1008003,nvl(a004,0),v_bmid from t_db_12_001
      where w100 =v_bmid;

      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1001,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1001 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1002,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1002 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1003,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1003 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1004,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1004 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1005,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1005 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1006,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1006 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1007,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1007 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1008,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1008 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1010,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1010 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1011,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1011 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1012,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1012 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1013,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1013 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1014,1008004,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)),v_bmid
      from t_db_12_001 where p001=1014 and w100 =v_bmid;

      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1001,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1001 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1002,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1002 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1003,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1003 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1004,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1004 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1005,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1005 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1006,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1006 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1007,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1007 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1008,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1008 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1010,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1010 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1011,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1011 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1012,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1012 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1013,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1013 and w100 =v_bmid;
      insert into T_B08_F001(p001,p002,p003,v,W100) select v_date,1014,1008005,sum(nvl(a002,0)+nvl(a003,0)-nvl(a004,0)-nvl(a006,0)),v_bmid
      from t_db_12_001 where p001=1014 and w100 =v_bmid;




      commit;

      update krcs.t_sys_t022 set A007=1010001 where P001 = 112016001  and A010=1013001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112016001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112016001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);


      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 = 112016001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112016001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112017001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112017001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_EP001 varchar2(100);
      v_EP002 number;
      v_EP003 number;
      v_EP004 number;
      v_EP006 number;
      v_count integer;
      v_status integer;
      v_bmid number;
      cursor c_work is
         select p001,nvl(a002,0),nvl(a003,0),nvl(a004,0),nvl(a006,0) from t_db_12_002
         where w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER);
  begin
     select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete t_b08_f002 where p003>=1008001 and p003<=1008005 and p001=v_date
      and w100 =v_bmid;

      insert into t_b08_f002(p001,p002,p003,v,w100)
        select v_date,p001,1008001,nvl(a002,0),v_bmid
        from t_db_12_002
        where w100 =v_bmid;
      insert into t_b08_f002(p001,p002,p003,v,w100)
        select v_date,p001,1008002,nvl(a003,0),v_bmid
        from t_db_12_002
        where w100 =v_bmid;
      insert into t_b08_f002(p001,p002,p003,v,w100)
        select v_date,p001,1008003,nvl(a004,0),v_bmid
        from t_db_12_002
        where w100 =v_bmid;
      open c_work;
      select count(*) into v_count from t_db_12_002
      where w100 =v_bmid;
      loop
        fetch c_work into v_EP001,v_EP002,v_EP003,v_EP004,v_EP006;
        if(v_count!=0) then
          insert into t_b08_f002(p001,p002,p003,v,w100)
            select v_date,v_EP001,1008004,nvl(sum(v_EP002+v_EP003-v_EP004),0),v_bmid
            from t_db_12_002 where p001=v_EP001 and w100 =v_bmid;

          insert into t_b08_f002(p001,p002,p003,v,w100)
            select v_date,v_EP001,1008005,nvl(sum(v_EP002+v_EP003-v_EP004-v_EP006),0),v_bmid
            from t_db_12_002 where p001=v_EP001 and w100 =v_bmid;
         end if;
         v_count:=v_count-1;
         exit when c_work%notfound;
      end loop;
      close c_work;

      update krcs.t_sys_t022 set A007=1010001 where P001 = 112017001  and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112017001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112017001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 = 112017001  and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112017001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112018001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112018001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
      v_org number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      /* ϹȨ֤ϼ*/
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b09_f001 where p001=v_date and p003>=1009001 and p003<=1009016
      and w100 =v_bmid;
  --Ȩ֤
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009001,nvl(b.a003,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009002,nvl(b.a004,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009003,nvl(b.a005,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009004,nvl(b.a006,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009005,nvl(b.a003-b.a004-b.a006,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009006,nvl(b.a007,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009007,nvl(b.a008,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009008,nvl(b.a009,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009009,nvl(b.a010,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009010,nvl(b.a011,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009011,nvl(b.a012,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009012,nvl(b.a010-b.a011,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009013,nvl(b.a008-b.a007,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009014,nvl(b.a010-b.a011+b.a008-b.a007,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009015,nvl(b.a013,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;
      insert into t_b09_f001(p001,p002,p003,v,w100) select v_date,a.p001,1009016,nvl(b.a014,0),v_bmid
      from t_b09_t002 a,T_DB_13_001 b where a.a002=b.p001 and b.w100=v_bmid and a.a100 =v_org;

     delete from t_b09_f002 where p001=v_date and p002>=1009001 and p002<=1009016  and w100=v_bmid;
 --ϼ
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009001,nvl(sum(a003),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009002,nvl(sum(a004),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009003,nvl(sum(a005),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009004,nvl(sum(a006),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009005,nvl(sum(a003-a004-a006),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009006,nvl(sum(a007),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009007,nvl(sum(a008),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009008,nvl(sum(a009),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009009,nvl(sum(a010),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009010,nvl(sum(a011),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009011,nvl(sum(a012),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009012,nvl(sum(a010-a011),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009013,nvl(sum(a008-a007),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009014,nvl(sum(a010-a011+a008-a007),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009015,nvl(sum(a013),0),v_bmid from T_DB_13_001 where w100=v_bmid;
     insert into t_b09_f002(p001,p002,v,w100) select v_date,1009016,nvl(sum(a014),0),v_bmid from T_DB_13_001 where w100=v_bmid;



      update krcs.t_sys_t022 set A007=1010001 where P001=112018001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112018001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112018001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      /*exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=112018001 and a004=v_bmid; \*޸ת״̬ *\
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112018001!';
                return;*/

  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112019001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112019001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int; --
      v_temp varchar(256);

       v_bmid number;--ID

  begin
      errcode := 1;
      errmsg := 'תݱɹ';



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001 ;/* õǰ */
       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

       --ɾȯάȱ
      delete t_b30_f001 where p001=v_date and w100 =v_bmid;

      --ݱݲάȱ
      --뱾
      insert into t_b30_f001(p001,p002,p003,v,w100)
      select v_date,p001,1206001,a002,v_bmid
      from t_DB_30_001
      where w100 =v_bmid and p001 <> 10450;

      --뱾ƽԴĿھΪ
      --1ڱ 2ڱ 3ڱڱ

      --1ڱcisp_etl_rzrq_c10_1ݱת洢Уʱֱȡݱеı
      insert into t_b30_f001(p001,p002,p003,v,w100)
      select v_date,p001,1206002,a002,v_bmid
      from t_DB_30_001
      where w100 =v_bmid
      and p001 in (10010,10050,10060,10070,10080,10090,10190,10200,10210,10250,10260,10270,10280,10290,10300,10340,10400,10410);--,10400,10410,10440);

      --2ڱʱֱȡݱеı
      insert into t_b30_f001(p001,p002,p003,v,w100)
      select v_date,p001,1206002,a003,v_bmid
      from t_DB_30_001
      where w100 =v_bmid
      and p001 in (10020,10100,10110,10120);

      --ڱڱ,ʱݱеıӱ
      insert into t_b30_f001(p001,p002,p003,v,w100)
      select v_date,p001,1206002,nvl(a002,0)+nvl(a003,0),v_bmid
      from t_DB_30_001
      where w100 =v_bmid
      and p001 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10350,10360,10370,10380,10390,10420,10430);

      commit;

      /*-- ۼҵƽ
      insert into t_b30_f001
        (p001, p002, p003, v, w100)
        select v_date, 10400, 1206002, round(b.v / a.v * 1000, 2), v_bmid
          from (select v
                  from t_b30_f001 t
                 where t.p003 = '1206002'
                   and t.p002 = '10140'
                   and t.w100 =v_bmid
                   and t.p001 = v_date) a,
               (select v
                  from t_b30_f001 t
                 where t.p003 = '1206002'
                   and t.p002 = '10370'
                   and t.w100=v_bmid
                   and t.p001 = v_date) b;
       -- ۼȯҵƽ
      insert into t_b30_f001(p001,p002,p003,v,w100)
      select v_date, 10410, 1206002, round(b.v / a.v * 1000, 2), v_bmid
        from (select v
                from t_b30_f001 t
               where t.p003 = '1206002'
                 and t.p002 = '10150'
                 and t.w100 =v_bmid
                 and t.p001 = v_date) a,
             (select v
                from t_b30_f001 t
               where t.p003 = '1206002'
                 and t.p002 = '10380'
                 and t.w100=v_bmid
                 and t.p001 = v_date) b;*/
       -- ۼȯͻ֤ȯ׵ƽӶ
      insert into t_b30_f001(p001,p002,p003,v,w100)
      select v_date, 10440, 1206002, round(b.v / a.v * 1000, 2), v_bmid
        from (select v
                from t_b30_f001 t
               where t.p003 = '1206002'
                 and t.p002 = '10420'
                 and t.w100=v_bmid
                 and t.p001 = v_date) a,
             (select v
                from t_b30_f001 t
               where t.p003 = '1206002'
                 and t.p002 = '10430'
                 and t.w100 =v_bmid
                 and t.p001 = v_date) b;


      update krcs.t_sys_t022 set A007=1010001 where P001 in(112019001,112019002)  and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID112019001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 =112019001  ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID112019002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 =112019002  ;/*ݱת־*/
           INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112019001,112019002)  and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112019001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112020001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112020001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_hwd  number;        --γ
      v_qcs  number;        --ڳ(ҵܣ
      v_bqzj number;        --(ҵܣ
      v_bqjs number;        --ڼ(ҵܣ
      v_qms number;         --ĩ(ҵܣ
      v_bqfs number;        --ڷ
      v_sqbllj number;      --ڱۼƷ
      v_bllj number;        --ۼ
      v_status integer;
      v_bmid number;


      --ҵݱ
      cursor cur_work1 is
             select p001,
                    nvl(a002,0),
                    nvl(a003,0),
                    nvl(a004,0)
               from t_db_15_001
               where w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);
      --Ӷݱȡ
      cursor cur_work2 is
             select p001,
                    nvl(a002,0),
                    nvl(a003,0)
               from t_db_15_002
               where w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);

  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      --ɾ
      delete from t_b11_f003 where p001=v_date and w100=v_bmid;

      --ҵݱγȱ
      --A0021011001 ڳ
      --A0031011002 
      --A0041011003 ڼ
      -- ĩ 1011004 = 1011001+1011002-1011003
      open cur_work1;
      fetch cur_work1 into v_hwd,v_qcs,v_bqzj,v_bqjs;
      while cur_work1%found
      loop
            insert into t_b11_f003(p001,P002,P003,v,w100)
            values(v_date,v_hwd,1011001,v_qcs,v_bmid);
            insert into t_b11_f003(p001,P002,P003,v,w100)
            values(v_date,v_hwd,1011002,v_bqzj,v_bmid);
            insert into t_b11_f003(p001,P002,P003,v,w100)
            values(v_date,v_hwd,1011003,v_bqjs,v_bmid);
            v_qms := v_qcs+v_bqzj-v_bqjs;
            insert into t_b11_f003(p001,P002,P003,v,w100)
            values(v_date,v_hwd,1011004,v_qms,v_bmid);


            fetch cur_work1 into v_hwd,v_qcs,v_bqzj,v_bqjs;
      end loop;


      open cur_work2;
      fetch cur_work2 into v_hwd,v_bqfs,v_sqbllj;
      while cur_work2%found
      loop
            insert into t_b11_f003(p001,P002,P003,v,w100)
            values(v_date,v_hwd,1011101,v_bqfs,v_bmid);
            v_bllj :=  v_sqbllj + v_bqfs;
            insert into t_b11_f003(p001,P002,P003,v,w100)
            values(v_date,v_hwd,1011102,v_bllj,v_bmid);
      fetch cur_work2 into v_hwd,v_bqfs,v_sqbllj;
      end loop;

      update krcs.t_sys_t022 set A007=1010001 where P001 in (112020001,112020002) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112020001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112020001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID112020002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112020002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in (112020001,112020002) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112020001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112021001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112021001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B50_F001 where p001=v_date and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1001,a002,v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1002,a003,v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1003,nvl(a004,0)+nvl(a002,0),v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1004,nvl(a005,0)+nvl(a003,0),v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1005,a006,v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1006,a007,v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1007,nvl(a008,0)+nvl(a006,0),v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1008,nvl(a009,0)+nvl(a007,0),v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1009,a010,v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,p001,1010,a011,v_bmid
           from T_DB_50_001
           where w100 =v_bmid;

      -- (һ)ͷࣺϼ
      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1001,sum(a002),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1002,sum(a003),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1003,sum(nvl(a004,0)+nvl(a002,0)),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1004,sum(nvl(a005,0)+nvl(a003,0)),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1005,sum(a006),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1006,sum(a007),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1007,sum(nvl(a008,0)+nvl(a006,0)),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1008,sum(nvl(a009,0)+nvl(a007,0)),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1009,sum(a010),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1090,1010,sum(a011),v_bmid
           from T_DB_50_001
           where p001 in (1010,1020,1050,1060,1070,1080)
           and w100 =v_bmid;

      --  ࣺϼ
      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1001,sum(a002),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1002,sum(a003),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1003,sum(nvl(a004,0)+nvl(a002,0)),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1004,sum(nvl(a005,0)+nvl(a003,0)),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1005,sum(a006),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1006,sum(a007),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1007,sum(nvl(a008,0)+nvl(a006,0)),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1008,sum(nvl(a009,0)+nvl(a007,0)),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1009,sum(a010),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1140,1010,sum(a011),v_bmid
           from T_DB_50_001
           where p001 in (1100,1110,1120,1130)
           and w100 =v_bmid;
       --   ۷ʽࣺϼ
      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1001,sum(a002),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1002,sum(a003),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1003,sum(nvl(a004,0)+nvl(a002,0)),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1004,sum(nvl(a005,0)+nvl(a003,0)),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1005,sum(a006),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1006,sum(a007),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1007,sum(nvl(a008,0)+nvl(a006,0)),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1008,sum(nvl(a009,0)+nvl(a007,0)),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1009,sum(a010),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1200,1010,sum(a011),v_bmid
           from T_DB_50_001
           where p001 in (1170,1180,1190)
           and w100 =v_bmid;


       --    ģͷࣺϼ
      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1001,sum(a002),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1002,sum(a003),v_bmid
           from T_DB_50_001
           where p001 in (1210,1220)
           and w100 =v_bmid;

      insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1003,sum(nvl(a004,0)+nvl(a002,0)),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1004,sum(nvl(a005,0)+nvl(a003,0)),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1005,sum(a006),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1006,sum(a007),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1007,sum(nvl(a008,0)+nvl(a006,0)),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1008,sum(nvl(a009,0)+nvl(a007,0)),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1009,sum(a010),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

       insert into T_B50_F001(P001,P002,P003,V,W100)
           select v_date,1230,1010,sum(a011),v_bmid
           from T_DB_50_001
           where p001 in  (1210,1220)
           and w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112021001) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112021001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112021001;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112021001) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112021001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112022001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112022001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B61_F001 where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B61_F001(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_61_001
        where w100 =v_bmid;
      insert into T_B61_F001(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_61_001
        where w100 =v_bmid;
      insert into T_B61_F001(P001,P002,P003,V,W100)
        select v_date,p001,1003,a004,v_bmid
        from T_DB_61_001
        where w100 =v_bmid;
      insert into T_B61_F001(P001,P002,P003,V,W100)
        select v_date,p001,1004,a005,v_bmid
        from T_DB_61_001
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112022001) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112022001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112022001;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(20611) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112022001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112022002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112022002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B61_F002 where p001=v_date and w100 =v_bmid;
      --ۼҵģ
      insert into T_B61_F002(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_61_002
        where w100 =v_bmid;
      insert into T_B61_F002(P001,P002,P003,V,W100)
        select v_date,p001,1002,nvl(a003,0)+nvl(a002,0),v_bmid
        from T_DB_61_002
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112022002) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112022002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112022002;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112022002) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112022002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112022003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112022003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B61_F003 where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B61_F003(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_61_003
        where w100 =v_bmid;
      insert into T_B61_F003(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_61_003
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112022003) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112022003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112022003;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112022003) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112022003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112023001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112023001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B62_F001 where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B62_F001(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_62_001
        where w100 =v_bmid;
      insert into T_B62_F001(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_62_001
        where w100 =v_bmid;
      insert into T_B62_F001(P001,P002,P003,V,W100)
        select v_date,p001,1003,a004,v_bmid
        from T_DB_62_001
        where w100 =v_bmid;
      insert into T_B62_F001(P001,P002,P003,V,W100)
        select v_date,p001,1004,a005,v_bmid
        from T_DB_62_001
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112023001) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112023001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112023001 ;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112023001) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112023001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112023002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112023002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B62_F002 where p001=v_date and w100 =v_bmid;
      --ۼҵģ
      insert into T_B62_F002(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_62_002
        where w100 =v_bmid;
      insert into T_B62_F002(P001,P002,P003,V,W100)
        select v_date,p001,1002,nvl(a003,0)+nvl(a002,0),v_bmid
        from T_DB_62_002
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112023002) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112023002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112023002;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112023002) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112023002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112023003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112023003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B62_F003 where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B62_F003(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_62_003
        where w100 =v_bmid;
      insert into T_B62_F003(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_62_003
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112023003) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112023003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112023003;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112023003) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112023003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112023004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112023004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112023004) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112021001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112023004;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;

      exception when others then
                rollback;
                errcode := 0;
		update krcs.t_sys_t022 set A007=1010002 where P001 in(112023004) and a004=v_bmid; /*޸ת״̬ */
                errmsg := 'ڴ洢cisp_convert_DT_112023004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112024001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F001 where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B63_F001(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_001
        where w100 =v_bmid;
      insert into T_B63_F001(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_63_001
        where w100 =v_bmid;
      insert into T_B63_F001(P001,P002,P003,V,W100)
        select v_date,p001,1003,a004,v_bmid
        from T_DB_63_001
        where w100 =v_bmid;
      insert into T_B63_F001(P001,P002,P003,V,W100)
        select v_date,p001,1004,a005,v_bmid
        from T_DB_63_001
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024001) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024001 ;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024001) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024001_RH
prompt ===============================================
prompt
create or replace procedure cisp_convert_DT_112024001_RH(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F001_RH where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B63_F001_RH(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_001_RH
        where w100 =v_bmid;
      insert into T_B63_F001_RH(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_63_001_RH
        where w100 =v_bmid;
      insert into T_B63_F001_RH(P001,P002,P003,V,W100)
        select v_date,p001,1003,a004,v_bmid
        from T_DB_63_001_RH
        where w100 =v_bmid;
      insert into T_B63_F001_RH(P001,P002,P003,V,W100)
        select v_date,p001,1004,a005,v_bmid
        from T_DB_63_001_RH
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024006) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024006'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024006 ;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024006) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024001_RH!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024001_ZYZJ
prompt =================================================
prompt
create or replace procedure cisp_convert_DT_112024001_ZYZJ(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F001_ZYZJ where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B63_F001_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_001_ZYZJ
        where w100 =v_bmid;
      insert into T_B63_F001_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_63_001_ZYZJ
        where w100 =v_bmid;
      insert into T_B63_F001_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1003,a004,v_bmid
        from T_DB_63_001_ZYZJ
        where w100 =v_bmid;
      insert into T_B63_F001_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1004,a005,v_bmid
        from T_DB_63_001_ZYZJ
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024011) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024011'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024011 ;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024011) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024001_ZYZJ!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112024002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F002 where p001=v_date and w100 =v_bmid;
      --ۼҵģ
      insert into T_B63_F002(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_002
        where w100 =v_bmid;
      insert into T_B63_F002(P001,P002,P003,V,W100)
        select v_date,p001,1002,nvl(a003,0)+nvl(a002,0),v_bmid
        from T_DB_63_002
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024002) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024002;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024002) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024002_RH
prompt ===============================================
prompt
create or replace procedure cisp_convert_DT_112024002_RH(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F002_RH where p001=v_date and w100 =v_bmid;
      --ۼҵģ
      insert into T_B63_F002_RH(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_002_RH
        where w100 =v_bmid;
      insert into T_B63_F002_RH(P001,P002,P003,V,W100)
        select v_date,p001,1002,nvl(a003,0)+nvl(a002,0),v_bmid
        from T_DB_63_002_RH
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024008) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024008'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024008;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024008) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024002_RH!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024002_ZYZJ
prompt =================================================
prompt
create or replace procedure cisp_convert_DT_112024002_ZYZJ(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F002_ZYZJ where p001=v_date and w100 =v_bmid;
      --ۼҵģ
      insert into T_B63_F002_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_002_ZYZJ
        where w100 =v_bmid;
      insert into T_B63_F002_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1002,nvl(a003,0)+nvl(a002,0),v_bmid
        from T_DB_63_002_ZYZJ
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024012) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024012'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024012;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024012) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024002_ZYZJ!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112024003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F003 where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B63_F003(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_003
        where w100 =v_bmid;
      insert into T_B63_F003(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_63_003
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024003) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024003'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024003;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024003) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024003_RH
prompt ===============================================
prompt
create or replace procedure cisp_convert_DT_112024003_RH(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F003_RH where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B63_F003_RH(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_003_RH
        where w100 =v_bmid;
      insert into T_B63_F003_RH(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_63_003_RH
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024008) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024008'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024008;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024008) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024003_RH!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024003_ZYZJ
prompt =================================================
prompt
create or replace procedure cisp_convert_DT_112024003_ZYZJ(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      delete T_B63_F003_ZYZJ where p001=v_date and w100 =v_bmid;
      --ع
      insert into T_B63_F003_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1001,a002,v_bmid
        from T_DB_63_003_ZYZJ
        where w100 =v_bmid;
      insert into T_B63_F003_ZYZJ(P001,P002,P003,V,W100)
        select v_date,p001,1002,a003,v_bmid
        from T_DB_63_003_ZYZJ
        where w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024013) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024013'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 112024013;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;

      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in(112024013) and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_112024003_ZYZJ!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_112024004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024004) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112024004;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;

      exception when others then
                rollback;
                errcode := 0;
    update krcs.t_sys_t022 set A007=1010002 where P001 in(112024004) and a004=v_bmid; /*޸ת״̬ */
                errmsg := 'ڴ洢cisp_convert_DT_112024004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024004_RH
prompt ===============================================
prompt
create or replace procedure cisp_convert_DT_112024004_RH(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024009) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024009'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112024009;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;

      exception when others then
                rollback;
                errcode := 0;
    update krcs.t_sys_t022 set A007=1010002 where P001 in(112024009) and a004=v_bmid; /*޸ת״̬ */
                errmsg := 'ڴ洢cisp_convert_DT_112024004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024004_ZYZJ
prompt =================================================
prompt
create or replace procedure cisp_convert_DT_112024004_ZYZJ(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024014) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024014'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112024014;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;

      exception when others then
                rollback;
                errcode := 0;
    update krcs.t_sys_t022 set A007=1010002 where P001 in(112024014) and a004=v_bmid; /*޸ת״̬ */
                errmsg := 'ڴ洢cisp_convert_DT_112024004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_112024014_ZYZJ
prompt =================================================
prompt
create or replace procedure cisp_convert_DT_112024014_ZYZJ(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_temp varchar(256);

      v_status integer;
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
      select P001 into v_date FROM T_B00_D004_ZYZJ WHERE C001=1001101 and A002=1013001; /* õǰ */

      update krcs.t_sys_t022 set A007=1010001 where P001 in(112024014) and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID112024014'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 112024014;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;

      exception when others then
                rollback;
                errcode := 0;
    update krcs.t_sys_t022 set A007=1010002 where P001 in(112024014) and a004=v_bmid; /*޸ת״̬ */
                errmsg := 'ڴ洢cisp_convert_DT_112024014!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113002001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113002001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      -- v_bmid                number;                                                    --ID

      v_status              number;                                                    --ݱ״̬
      v_date                int;                                                       --
      v_date_last           int;                                                       --
      v_wd                  number;                                                    --γ
      v_ccsl                number(20,2);                                              --ֲ
      v_qc                  number(20,2);                                              --ڳֲֳɱ
      v_cccb                number(20,2);                                              --ֲֳɱ
      v_cccb_sum            number(20,2);                                              --ֲֳɱ(sum)
      v_cccb_last           number(20,2);                                              --ֲֳɱ()
      v_cccb_last_sum       number(20,2);                                              --ֲֳɱ()(sum)
      v_dqsz                number(20,2);                                              --ǰֵ
      v_dqgysz              number(20,2);                                              --ǰֵ
      v_dqsz_sum            number(20,2);                                              --ǰֵ(sum)
      v_dqgysz_sum          number(20,2);                                              --ǰֵ(sum)
      v_in                  number(20,2);                                              --ֵ
      v_in_sum              number(20,2);                                              --ֵ(sum)
      v_out                 number(20,2);                                              --ֵ
      v_out_sum             number(20,2);                                              --ֵ(sum)
      v_tycb                number(20,2);                                              --̯ɱ
      v_tycb_sum            number(20,2);                                              --̯ɱ(sum)
      v_temp                varchar(256);
      v_bqbd        number(20,2);
      v_facttype            number;                                                    --γͣƱծȯ
      v_tzpz                number;                                                    --ͶƷ

      v_caltype             number;                                                    --㱾ӡٵķʽ
      /**********************************Ҫ ֲ  ************************************/


      v_zqdm                                varchar(16);                      --֤ȯ
      v_zqmc                                varchar(256);                    --֤ȯ
      v_qmzmcb                              number(20,2);                    --ĩɱ
      v_qmzmcb_sum                          number(20,2);                    --ĩɱ()
      v_qmzmcb_q5m_sum                      number(20,2);                    --ĩɱ(ǰ5)
      v_qmzmgyjz                            number(20,2);                    --ĩ湫ʼֵ
      v_qmzmgyjz_sum                        number(20,2);                    --ĩ湫ʼֵ()
      v_qmzmgyjz_q5m_sum                    number(20,2);                    --ĩ湫ʼֵ(ǰ5)
      v_qmsz                                number(20,2);                    --ĩֵ
      v_qmsz_sum                            number(20,2);                    --ĩֵ()
      v_qmsz_q5m_sum                        number(20,2);                    --ĩֵ(ǰ5)
      v_qmcysl                              number(20,2);                    --ĩ
      v_qmcysl_q5m_sum                      number(20,2);                    --ĩ(ǰ5)
      v_qmcybl                              number(20,2);                    --ĩб
      v_row                                 number;

      v_orgid number;
      v_bmid number;


      /************************************************************************************************/

      cursor cur_work is                                                               --γα ԽΪ׼
            select P001,100,1001000 from t_b00_d009                                    --Ʊ
            union
            select P001,200,1002000 from t_b00_d007                                    --
            union
            select P001,300,1003000 from t_b00_d006                                    --ծȯ
            union
            select P001,400,1005000 from t_b00_d008;                                   --

     /**********************************Ҫ ֲ   α*************************************/

     v_gb number(20,2); --ɱ
     --Ʊɱ(ͨ)
      cursor cur_gb_gp is
           select distinct a.p001 AS P001,b.A005 as P002
             from t_db_04_001 a ,
                  (select * from t_bks_t016 where a004 = 100 and a003 not in (1012,1017)
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER))  b
            where a.p001=b.p001(+)
              and a.a002 = b.a003(+)
              and a.a010 = 100
              and a.a002 NOT IN (1012,1017)
              and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);

     --Ʊɱ(ͨ)
      cursor cur_gb_xzgp is
           select distinct a.p001 AS P001,b.A005 as P002
             from t_db_04_001 a ,
                  (select * from t_bks_t016 where a004 = 100 and a003 in (1012,1017)
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER))  b
            where a.p001=b.p001(+)
              and a.a002=b.a003(+)
              and a.a010 = 100
              and a.a002 IN (1012,1017)
              and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);

     --ܷݶ
      cursor cur_gb_jj is
           select distinct a.p001 AS P001,b.A005 as P002
             from t_db_04_001 a ,
                  (select * from t_bks_t016 where a004 = 200
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b
            where a.p001=b.p001(+)
              and a.a002 = b.a003(+)
              and a.a010 = 200
              and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);

     --ծȯ                   uinon жϹ̶沿ȵǰ5֤ȯǷ
      cursor cur_gb_zq is
           select distinct a.p001 AS P001,b.A005 as P002
             from t_db_04_002 a ,
                  (select * from t_bks_t016 where a004 = 300
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER))  b
            where a.p001=b.p001(+)
              and a.a002 = b.a003(+)
              and a.a011 = 300
              and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
            union
            select distinct a.p003 AS P001,b.A005 as P002
             from t_db_04_002_02_02 a,
                  (select * from t_bks_t016 where a004 = 300
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER))  b
            where a.p003 = b.p001(+)
              and a.p001 = 300
              and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);

     --               uinon жϹ̶沿ȵǰ5֤ȯǷйɱ
      cursor cur_gb_qt is
           select distinct a.p001 AS P001,b.A005 as P002
             from t_db_04_002 a ,
                  (select * from t_bks_t016 where a004 = 400
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER))  b
            where a.p001=b.p001(+)
              and a.a002 = b.a003(+)
              and a.a011 = 400
              and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
            union
            select distinct a.p003 AS P001,b.A005 as P002
             from t_db_04_002_02_02 a,
                  (select * from t_bks_t016 where a004 = 400
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER))  b
            where a.p003 = b.p001(+)
              and a.p001 = 400
              and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);


      --õƱĩֱֲǰ5          ע⽫ͬͨƱͷͨƱΪһ¼
      cursor cur_gp is
      select zqdm,zqmc,qmcysl,qmcybl,qmzmcb,qmzmgyjz,nvl(qmsz,0) as qmsz
        from (
                select m.*, nvl(b.a002,m.zqdm) as zqmc, m.qmcysl/b.a005*100 as qmcybl
                  from (select a.p001 as zqdm,                           --֤ȯ
                               max(a.a002) as zqlx,
                               SUM(a.a011) as qmcysl,                    --ĩ
                               SUM(a.a007) as qmzmcb,                    --ĩɱ
                               SUM(a.a008) as qmzmgyjz,                  --ĩ湫ʼֵ
                               SUM(a.a009) as qmsz                       --ĩֵ
                          from t_db_04_001 a
                         where a.a010 = 100
                           and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                         GROUP BY a.P001--,a.a002
                         order by a.p001
                       ) m left join
                       (select distinct p001,a002,a003,a005 from T_BKS_T016 where a004=100
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b on m.zqdm=b.p001 and m.zqlx = b.a003
                 where m.qmcysl > 0
                 order by qmcybl desc
             )
       where rownum<=5;

      --õĩɱĩֱֲǰ5
      cursor cur_jj is
      select * from (
      select zqdm,zqmc,qmcysl,qmcybl,qmzmcb,qmzmgyjz,nvl(qmsz,0) as qmsz
        from (
                select m.*, nvl(b.a002,m.zqdm) as zqmc, m.qmcysl/b.a005*100 as qmcybl
                  from (select a.p001 as zqdm,                           --֤ȯ
                               a.a002 as zqlx,                           --֤ȯ
                               SUM(a.a011) as qmcysl,                    --ĩ
                               SUM(a.a007) as qmzmcb,                    --ĩɱ
                               SUM(a.a008) as qmzmgyjz,                  --ĩ湫ʼֵ
                               SUM(a.a009) as qmsz                       --ĩֵ
                          from t_db_04_001 a
                         where a.a010 = 200
                           and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                         GROUP BY a.P001,a.a002
                         order by a.p001
                       ) m,
                       (select distinct p001,a002,a003,a005 from T_BKS_T016 where a004=200
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b where m.zqdm=b.p001 and m.zqlx = b.a003
                 and m.qmcysl > 0
                 order by qmzmcb desc
             )
       where rownum<=5
      )
      order by qmcybl desc;

      --õծȯĩɱĩֱֲǰ5
      cursor cur_zq is
      select * from (
      select zqdm,zqmc,qmcysl,qmcybl,qmzmcb,qmzmgyjz,nvl(qmsz,0) as qmsz
        from (
                select m.*, nvl(b.a002,m.zqdm) as zqmc, m.qmcysl/b.a005*100 as qmcybl
                  from (select zqdm,
                               zqlx,
                               sum(qmcysl) as qmcysl,
                               sum(qmzmcb) as qmzmcb,
                               sum(qmzmgyjz) as qmzmgyjz,
                               sum(qmsz) as qmsz
                          from (select p001 as zqdm,
                                       a002 as zqlx,
                                       a012 as qmcysl,                      --ĩ
                                       a007 as qmzmcb,                      --ĩɱ
                                       a008 as qmzmgyjz,                    --ĩ湫ʼֵ
                                       a009 as qmsz                         --ĩֵ
                                  from t_db_04_002
                                 where a011 = 300
                                   and w100 = v_bmid

                               )
                         group by zqdm,zqlx
                       ) m left join
                       (select distinct p001,a002,a003,a005 from T_BKS_T016 where a004=300 and a100=(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b on m.zqdm=b.p001 and m.zqlx = b.a003
                 where m.qmcysl > 0
                 order by qmzmcb desc
             )
       where rownum<=5
      )
      order by qmcybl desc;


      --õȨ֤ĩɱĩֱֲǰ5
      cursor cur_qz is
      select * from (
      select zqdm,zqmc,qmcysl,qmcybl,qmzmcb,qmzmgyjz,nvl(qmsz,0) as qmsz
        from (
                select m.*, nvl(b.a002,m.zqdm) as zqmc, m.qmcysl/b.a005*100 as qmcybl
                  from (select zqdm,
                               zqlx,
                               sum(qmcysl) as qmcysl,
                               sum(qmzmcb) as qmzmcb,
                               sum(qmzmgyjz) as qmzmgyjz,
                               sum(qmsz) as qmsz
                          from (select p001 as zqdm,
                                       a002 as zqlx,
                                       a012 as qmcysl,                      --ĩ
                                       a007 as qmzmcb,                      --ĩɱ
                                       a008 as qmzmgyjz,                    --ĩ湫ʼֵ
                                       a009 as qmsz                         --ĩֵ
                                  from t_db_04_002
                                 where a011 = 400
                                   and a002 = 1001
                                   and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                                union all
                                select p003 as zqdm,
                                       1 as zqlx,
                                       a005 as qmcysl,                      --ĩ
                                       a006 as qmzmcb,                      --ĩɱ
                                       a007 as qmzmgyjz,                    --ĩ湫ʼֵ
                                       a008 as qmsz                         --ĩֵ
                                  from t_db_04_002_02_02
                                 where p001 = 400
                                   and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                               )
                         group by zqdm,zqlx
                       ) m left join
                       (select distinct p001,a002,a003,a005 from T_BKS_T016 where a004=400 and a003=1001
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b on m.zqdm=b.p001 and m.zqlx=b.a003
                 where m.qmcysl > 0
                 order by qmzmcb desc
             )
       where rownum<=5
      )
      order by qmcybl desc;

      --ծȯ֤ȯɱǰ
      cursor cur_other is
      select *
        from (
                select *
                  from (
                          --Ʊ
                          select zqdm,zqmc,qmcysl,qmcybl,qmzmcb,qmzmgyjz,nvl(qmsz,0) as qmsz
                            from (
                                    select m.*, nvl(b.a002,m.zqdm) as zqmc, m.qmcysl/b.a005*100 as qmcybl
                                      from (select a.p001 as zqdm,                           --֤ȯ
                                                   max(a.a002) as zqlx,
                                                   SUM(a.a011) as qmcysl,                    --ĩ
                                                   SUM(a.a007) as qmzmcb,                    --ĩɱ
                                                   SUM(a.a008) as qmzmgyjz,                  --ĩ湫ʼֵ
                                                   SUM(a.a009) as qmsz                       --ĩֵ
                                              from t_db_04_001 a
                                             where a.a010 = 100
                                               and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                                             GROUP BY a.P001--,a.a002
                                             order by a.p001
                                           ) m left join
                                           (select distinct p001,a002,a003,a005 from T_BKS_T016 where a004=100
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b on m.zqdm=b.p001 and m.zqlx = b.a003
                                     where m.qmcysl > 0
                                     order by qmzmcb desc
                                 )

                          union

                          --
                          select zqdm,zqmc,qmcysl,qmcybl,qmzmcb,qmzmgyjz,nvl(qmsz,0) as qmsz
                            from (
                                    select m.*, nvl(b.a002,m.zqdm) as zqmc, m.qmcysl/b.a005*100 as qmcybl
                                      from (select a.p001 as zqdm,                           --֤ȯ
                                                   a.a002 as zqlx,
                                                   SUM(a.a011) as qmcysl,                    --ĩ
                                                   SUM(a.a007) as qmzmcb,                    --ĩɱ
                                                   SUM(a.a008) as qmzmgyjz,                  --ĩ湫ʼֵ
                                                   SUM(a.a009) as qmsz                       --ĩֵ
                                              from t_db_04_001 a
                                             where a.a010 = 200
                                               and a.w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                                             GROUP BY a.P001,a.a002
                                             order by a.p001
                                           ) m,
                                           (select distinct p001,a002,a003,a005 from T_BKS_T016 where a004=200
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b where m.zqdm=b.p001 and m.zqlx = b.a003
                                       and m.qmcysl > 0
                                     order by qmzmcb desc
                                 )

                          union

                          --
                          select zqdm,zqmc,qmcysl,qmcybl,qmzmcb,qmzmgyjz,nvl(qmsz,0) as qmsz
                            from (
                                    select m.*, nvl(b.a002,m.zqdm) as zqmc, m.qmcysl/b.a005*100 as qmcybl
                                      from (select zqdm,
                                                   zqlx,
                                                   sum(qmcysl) as qmcysl,
                                                   sum(qmzmcb) as qmzmcb,
                                                   sum(qmzmgyjz) as qmzmgyjz,
                                                   sum(qmsz) as qmsz
                                              from (select p001 as zqdm,
                                                           a002 as zqlx,
                                                           a012 as qmcysl,                      --ĩ
                                                           a007 as qmzmcb,                      --ĩɱ
                                                           a008 as qmzmgyjz,                    --ĩ湫ʼֵ
                                                           a009 as qmsz                         --ĩֵ
                                                      from t_db_04_002
                                                     where a011 = 400
                                                       and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                                                    union all
                                                    select p003 as zqdm,
                                                           1 as zqlx,
                                                           a005 as qmcysl,                      --ĩ
                                                           a006 as qmzmcb,                      --ĩɱ
                                                           a007 as qmzmgyjz,                    --ĩ湫ʼֵ
                                                           a008 as qmsz                         --ĩֵ
                                                      from t_db_04_002_02_02
                                                     where p001 = 400
                                                       and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
                                                   )
                                             group by zqdm,zqlx
                                           ) m left join
                                           (select distinct p001,a002,a003,a005 from T_BKS_T016 where a004=400
                      and a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)) b on m.zqdm=b.p001 and m.zqlx = b.a003
                                     where m.qmcysl > 0
                                     order by qmzmcb desc
                                 )
                       ) t2
                 order by t2.qmzmcb desc
             )
       where rownum <= 5
       order by qmcybl desc;


    /**********************************************************************************************/


  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      /*select A012 into v_bmid
        from krcs.t_sys_user
       where p001 = v_KJAXUSER;*/
    SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
    select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID



      open cur_gb_gp;
      fetch cur_gb_gp into v_zqdm,v_gb;
      while cur_gb_gp%found
      loop
            if v_gb is null then
               errcode := 0;
               errmsg :='ͨƱ'||v_zqdm||'Ĺɱδά';
               close cur_gb_gp;
               return;
            end if;
            if v_gb <=0 then
               errcode :=0;
               errmsg :='ͨƱ'||v_zqdm||'ĹɱСڻ0';
               close cur_gb_gp;
               return;
            end if;
            fetch cur_gb_gp into v_zqdm,v_gb;
      end loop;
      close cur_gb_gp;

      open cur_gb_xzgp;
      fetch cur_gb_xzgp into v_zqdm,v_gb;
      while cur_gb_xzgp%found
      loop
            if v_gb is null then
               errcode := 0;
               errmsg :='ͨƱ'||v_zqdm||'Ĺɱδά';
               close cur_gb_xzgp;
               return;
            end if;
            if v_gb <=0 then
               errcode :=0;
               errmsg :='ͨƱ'||v_zqdm||'ĹɱСڻ0';
               close cur_gb_xzgp;
               return;
            end if;
            fetch cur_gb_xzgp into v_zqdm,v_gb;
      end loop;
      close cur_gb_xzgp;



      open cur_gb_zq;
      fetch cur_gb_zq into v_zqdm,v_gb;
      while cur_gb_zq%found
      loop
            if v_gb is null then
               errcode := 0;
               errmsg :='ծȯ'||v_zqdm||'δά';
               close cur_gb_zq;
               return;
            end if;
            if v_gb <=0 then
               errcode :=0;
               errmsg :='ծȯ'||v_zqdm||'Сڻ0';
               close cur_gb_zq;
               return;
            end if;
            fetch cur_gb_zq into v_zqdm,v_gb;
      end loop;
      close cur_gb_zq;

      open cur_gb_qt;
      fetch cur_gb_qt into v_zqdm,v_gb;
      while cur_gb_qt%found
      loop
            if v_gb is null then
               errcode := 0;
               errmsg :=''||v_zqdm||'δά';
               close cur_gb_qt;
               return;
            end if;
            if v_gb <=0 then
               errcode :=0;
               errmsg :=''||v_zqdm||'Сڻ0';
               close cur_gb_qt;
               return;
            end if;
            fetch cur_gb_qt into v_zqdm,v_gb;
      end loop;
      close cur_gb_qt;


      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select to_number(to_char(to_date(v_date, 'YYYYMM') + interval '-1' month, 'YYYYMM')) month --·
      into   v_date_last
      from dual;
      delete t_b02_f001 where p001=v_date and w100=v_bmid;

       v_cccb_last_sum := 0;
       v_cccb_sum :=  0;
       v_dqsz_sum := 0;
       v_dqgysz_sum := 0;
       v_in_sum := 0;
       v_out_sum := 0;
       v_tycb_sum := 0;

      --
      open cur_work;
      fetch cur_work into v_wd,v_facttype,v_tzpz;
      while cur_work%found
      loop
             if(v_facttype = 100 or v_facttype = 200) then
                 if(v_facttype = 100) then
                 select nvl(sum(a.a004),0)                              --ڳ ο
                   into v_qc
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.a002 = v_wd
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a005),0)                              --
                   into v_in
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.a002 = v_wd
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a006),0)                              --ڼ
                   into v_out
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.a002 = v_wd
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a007),0)                              --ĩɱ
                   into v_cccb
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.a002 = v_wd
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a009),0)                              --ĩֵ
                   into v_dqsz
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.a002 = v_wd
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a008),0)                              --ĩʼֵ
                   into v_dqgysz
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.a002 = v_wd
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a011),0)                              --ֲ
                   into v_ccsl
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.a002 = v_wd
                    and a.w100 = v_bmid;
                                                         --̯ɱƱΪ0
                end if;

                if(v_facttype = 200) then
                 select nvl(sum(a.a004),0)                              --ڳ ο
                   into v_qc
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a005),0)                              --
                   into v_in
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a006),0)                              --ڼ
                   into v_out
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a007),0)                              --ĩɱ
                   into v_cccb
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a009),0)                              --ĩֵ
                   into v_dqsz
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a008),0)                              --ĩʼֵ
                   into v_dqgysz
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a011),0)                              --ֲ
                   into v_ccsl
                   from t_db_04_001 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a010 = v_facttype
                    and a.w100 = v_bmid;
                 end if;
                 v_tycb := 0;
             end if;

             if(v_facttype = 300 or v_facttype = 400) then
                 select nvl(sum(a.a004),0)                              --ڳ ο
                   into v_qc
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                  --ӻܵݱȡֵ
                  select v_qc + nvl(sum(A003),0)
                    into v_qc
                    from t_db_04_002_02_01
                   where p001 = v_facttype
                     and p002 = v_wd
                     and w100 = v_bmid;

                 select nvl(sum(a.a005),0)                              --
                   into v_in
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                  --ӻܵݱȡֵ
                  select v_in + nvl(sum(A004),0)
                    into v_in
                    from t_db_04_002_02_01
                   where p001 = v_facttype
                     and p002 = v_wd
                     and w100 = v_bmid;


                 select nvl(sum(a.a006),0)                              --ڼ
                   into v_out
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                  --ӻܵݱȡֵ
                  select v_out + nvl(sum(A005),0)
                    into v_out
                    from t_db_04_002_02_01
                   where p001 = v_facttype
                     and p002 = v_wd
                     and w100 = v_bmid;

                 select nvl(sum(a.a007),0)                              --ĩɱ
                   into v_cccb
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                  --ӻܵݱȡֵ
                  select v_cccb + nvl(sum(A006),0)
                    into v_cccb
                    from t_db_04_002_02_01
                   where p001 = v_facttype
                     and p002 = v_wd
                     and w100 = v_bmid;


                 select nvl(sum(a.a009),0)                              --ĩֵ
                   into v_dqsz
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                  --ӻܵݱȡֵ
                  select v_dqsz + nvl(sum(A008),0)
                    into v_dqsz
                    from t_db_04_002_02_01
                   where p001 = v_facttype
                     and p002 = v_wd
                     and w100 = v_bmid;


                 select nvl(sum(a.a008),0)                              --ĩʼֵ
                   into v_dqgysz
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                  --ӻܵݱȡֵ
                  select v_dqgysz + nvl(sum(A007),0)
                    into v_dqgysz
                    from t_db_04_002_02_01
                   where p001 = v_facttype
                     and p002 = v_wd
                     and w100 = v_bmid;

                 select nvl(sum(a.a012),0)                              --ֲ
                   into v_ccsl
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                 select nvl(sum(a.a010),0)                              --̯ɱ
                   into v_tycb
                   from t_db_04_002 a,
                        t_bks_t016 b
                  where a.p001 = b.p001
                    and a.a002 = b.a003
                    and b.A004 = v_facttype
                    and b.A003 = v_wd
                    and b.a100 = v_orgid
                    and a.a011 = v_facttype
                    and a.w100 = v_bmid;

                  --ӻܵݱȡֵ
                  select v_tycb + nvl(sum(A009),0)
                    into v_tycb
                    from t_db_04_002_02_01
                   where p001 = v_facttype
                     and p002 = v_wd
                     and w100 = v_bmid;

             end if;

             select nvl(sum(v),0) into v_cccb_last                    --õĩɱ   ڳ
               from t_b02_f001
              where p001 = v_date_last
                and p002 = v_wd
                and p003 = v_tzpz
                and p004 = 1002004
                and w100 = v_bmid;


             insert into t_b02_f001(p001,p002,p003,p004,w100,v)            --ĩɱ
             values(v_date,v_wd,v_tzpz,1002004,v_bmid,nvl(v_cccb,0));

             insert into t_b02_f001(p001,p002,p003,p004,w100,v)            --ĩʼֵ
             values(v_date,v_wd,v_tzpz,1002005,v_bmid,nvl(v_dqgysz,0));

             insert into t_b02_f001(p001,p002,p003,p004,w100,v)            --ĩֵ
             values(v_date,v_wd,v_tzpz,1002006,v_bmid,nvl(v_dqsz,0));

             insert into t_b02_f001(p001,p002,p003,p004,w100,v)            --ֲ
             values(v_date,v_wd,v_tzpz,1002008,v_bmid,nvl(v_ccsl,0));

             insert into t_b02_f001(p001,p002,p003,p004,w100,v)            --̯ɱ
             values(v_date,v_wd,v_tzpz,1002007,v_bmid,nvl(v_tycb,0));



             /*
               Ʊб䶯ԱӡڼٵӰ
               ĳƱϹ֤180ɷݹɣ֤һͨƱ
               ֤180ڼмϸùƱڳɱ
               ֤һͨƱڱмϸùƱڳɱƴ
             */
             IF v_facttype = 100 THEN
                 SELECT NVL(SUM(A007),0) INTO v_bqbd FROM T_DB_04_001_BK WHERE A012 = v_wd AND P001 NOT IN (SELECT P001 FROM T_BKS_T016 WHERE A004 = 100 AND A003 = v_wd
                    and a100 = v_orgid) AND W100=v_bmid;
                 v_out := v_out + v_bqbd;

                 SELECT NVL(SUM(A007),0) INTO v_bqbd FROM T_DB_04_001_BK WHERE A012 <> v_wd AND P001 IN (SELECT P001 FROM T_BKS_T016 WHERE A004 = 100 AND A003 = v_wd
                    and a100 = v_orgid) AND W100=v_bmid;
                 v_in := v_in + v_bqbd;
             END IF;

             insert into t_b02_f001(p001,p002,p003,p004,w100,v)        --ڳ
             values(v_date,v_wd,v_tzpz,1002001,v_bmid,nvl(v_cccb_last,0));


             --üӡ
             /*select count(*) into v_caltype from t_sys_t069 where p001 = 1;
             if v_cccb > v_cccb_last and v_caltype > 0 then
                  v_out :=0;
                  v_in := v_cccb - v_cccb_last;
             end if;
             if v_cccb <= v_cccb_last and v_caltype > 0 then
                  v_out := v_cccb_last - v_cccb;
                  v_in := 0;
             end if;*/


             v_out := v_cccb_last+v_in-v_cccb;

             if v_out<0 then
                v_in := v_in - v_out;
                v_out :=0;
             end if;


             insert into t_b02_f001(p001,p002,p003,p004,w100,v)        --
             values(v_date,v_wd,v_tzpz,1002002,v_bmid,nvl(v_in,0));

             insert into t_b02_f001(p001,p002,p003,p004,w100,v)        --ڼ
             values(v_date,v_wd,v_tzpz,1002003,v_bmid,nvl(v_out,0));



             --ϼֵ
             v_cccb_last_sum :=  v_cccb_last_sum + v_cccb_last;
             v_cccb_sum :=  v_cccb_sum + v_cccb_last + v_in - v_out;
             v_dqsz_sum := v_dqsz_sum +  v_dqsz;
             v_dqgysz_sum := v_dqgysz_sum +  v_dqgysz;
             v_in_sum := v_in_sum + v_in;
             v_out_sum := v_out_sum + v_out;
             v_tycb_sum := v_tycb_sum + v_tycb;

             fetch cur_work into v_wd,v_facttype,v_tzpz;
      end loop;
      close cur_work;



      --ϼֵ ϼȡ109900010990000
     insert into t_b02_f001(p001,p002,p003,p004,w100,v)
      values(v_date,1099000,1099000,1002001,v_bmid,nvl(v_cccb_last_sum,0));
      insert into t_b02_f001(p001,p002,p003,p004,w100,v)
      values(v_date,1099000,1099000,1002002,v_bmid,nvl(v_in_sum,0));
      insert into t_b02_f001(p001,p002,p003,p004,w100,v)
      values(v_date,1099000,1099000,1002003,v_bmid,nvl(v_out_sum,0));
      insert into t_b02_f001(p001,p002,p003,p004,w100,v)
      values(v_date,1099000,1099000,1002004,v_bmid,nvl(v_cccb_sum,0));
      insert into t_b02_f001(p001,p002,p003,p004,w100,v)
      values(v_date,1099000,1099000,1002005,v_bmid,nvl(v_dqgysz_sum,0));
      insert into t_b02_f001(p001,p002,p003,p004,w100,v)
      values(v_date,1099000,1099000,1002006,v_bmid,nvl(v_dqsz_sum,0));
      insert into t_b02_f001(p001,p002,p003,p004,w100,v)
      values(v_date,1099000,1099000,1002007,v_bmid,nvl(v_tycb_sum,0));



      /**********************************Ҫֲ άת ***********************************/

      delete from t_b02_f008 where p001=v_date and w100=v_bmid;
      delete from t_b02_f009 where p001=v_date and w100=v_bmid;
       ---------------------------------------------------------------------------
    ----------------------------Ʊֲϸ-------------------------------
    ---------------------------------------------------------------------------

    --ȡͷйƱĩɱʼֵĩֵܺ
    select nvl(sum(a.a007),0)
      into v_qmzmcb_sum                    --ĩɱ
      from t_db_04_001 a
     where a.a010=100
       and a.w100=v_bmid;

    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1001,1002004,v_bmid,v_qmzmcb_sum);

    select nvl(sum(a.a008),0)
      into v_qmzmgyjz_sum                  --ĩ湫ʼֵ
      from t_db_04_001 a
     where a.a010=100
       and a.w100=v_bmid;

     insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1001,1002005,v_bmid,v_qmzmgyjz_sum);

    select nvl(sum(a.a009),0)
      into v_qmsz_sum                      --ĩֵ
      from t_db_04_001 a
     where a.a010=100
       and a.w100=v_bmid;

     insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1001,1002006,v_bmid,v_qmsz_sum);


    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --Ʊճбǰ5Ʊѭα
    v_row := 4;
    open cur_gp;
    fetch cur_gp into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_gp%found
    loop
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1001,v_zqdm,1002009,v_bmid,v_qmcysl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1001,v_zqdm,1002000,v_bmid,v_qmcybl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1001,v_zqdm,1002004,v_bmid,v_qmzmcb);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1001,v_zqdm,1002005,v_bmid,v_qmzmgyjz);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1001,v_zqdm,1002006,v_bmid,v_qmsz);
          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_gp into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_gp;

    --õձǰ5ĩܺ
    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1001,1002009,v_bmid,v_qmcysl_q5m_sum);

     --õ5
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1001,'qtgp',1002004,v_bmid,v_qmzmcb_sum - v_qmzmcb_q5m_sum) ;
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1001,'qtgp',1002005,v_bmid,v_qmzmgyjz_sum - v_qmzmgyjz_q5m_sum);
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1001,'qtgp',1002006,v_bmid,v_qmsz_sum - v_qmsz_q5m_sum);

    ----------------------------------------------------------------------------
    ------------------------------Ʊ----------------------------------
    ----------------------------------------------------------------------------

 /****************************************************************************************************/

    ---------------------------------------------------------------------------
    ----------------------------ֲϸ-------------------------------
    ---------------------------------------------------------------------------

    --ȡͷлĩɱʼֵĩֵܺ
    select nvl(sum(a.a007),0)
      into v_qmzmcb_sum                    --ĩɱ
      from t_db_04_001 a
     where a.a010 = 200
       and a.w100=v_bmid;

   insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1002,1002004,v_bmid,v_qmzmcb_sum);

    select nvl(sum(a.a008),0)
      into v_qmzmgyjz_sum                  --ĩ湫ʼֵ
      from t_db_04_001 a
     where a.a010 = 200
       and a.w100=v_bmid;

   insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1002,1002005,v_bmid,v_qmzmgyjz_sum) ;

    select nvl(sum(a.a009),0)
      into v_qmsz_sum                      --ĩֵ
      from t_db_04_001 a
     where a.a010 = 200
       and a.w100=v_bmid;

    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1002,1002006,v_bmid,v_qmsz_sum);


    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --ճбǰ5Ʊѭα
    v_row := 11;
    open cur_jj;
    fetch cur_jj into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_jj%found
    loop
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1002,v_zqdm,1002009,v_bmid,v_qmcysl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1002,v_zqdm,1002000,v_bmid,v_qmcybl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1002,v_zqdm,1002004,v_bmid,v_qmzmcb);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1002,v_zqdm,1002005,v_bmid,v_qmzmgyjz);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1002,v_zqdm,1002006,v_bmid,v_qmsz);
          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_jj into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_jj;


    --õձǰ5ĩܺ
    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1002,1002009,v_bmid,v_qmcysl_q5m_sum);

    --õ5
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1002,'qtjj',1002004,v_bmid,v_qmzmcb_sum - v_qmzmcb_q5m_sum) ;
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1002,'qtjj',1002005,v_bmid,v_qmzmgyjz_sum - v_qmzmgyjz_q5m_sum) ;
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1002,'qtjj',1002006,v_bmid,v_qmsz_sum - v_qmsz_q5m_sum) ;


    ----------------------------------------------------------------------------
    ----------------------------------------------------------------
    ----------------------------------------------------------------------------

  /************************************************************************************************/

  ---------------------------------------------------------------------------
    ----------------------------ծȯֲϸ-------------------------------
    ---------------------------------------------------------------------------

    --ȡͷծȯĩɱʼֵĩֵܺ
    select nvl(sum(a.a007),0)
      into v_qmzmcb_sum                    --ĩɱ
      from t_db_04_002 a
     where a.a011 = 300
       and a.w100 = v_bmid;

    select v_qmzmcb_sum + nvl(sum(a.a006),0)
      into v_qmzmcb_sum
      from t_db_04_002_02_01 a
     where a.p001 = 300
       and a.w100=v_bmid;

  insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1003,1002004,v_bmid,v_qmzmcb_sum);

    select nvl(sum(a.a008),0)
      into v_qmzmgyjz_sum                  --ĩ湫ʼֵ
      from t_db_04_002 a
     where a.a011 = 300
       and a.w100 = v_bmid;

    select v_qmzmgyjz_sum + nvl(sum(a.a007),0)
      into v_qmzmgyjz_sum
      from t_db_04_002_02_01 a
     where a.p001 = 300
       and a.w100=v_bmid;

   insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1003,1002005,v_bmid,v_qmzmgyjz_sum) ;

    select nvl(sum(a.a009),0)
      into v_qmsz_sum                      --ĩֵ
      from t_db_04_002 a
     where a.a011 = 300
       and a.w100 = v_bmid;

    select v_qmsz_sum + nvl(sum(a.a008),0)
      into v_qmsz_sum
      from t_db_04_002_02_01 a
     where a.p001 = 300
       and a.w100=v_bmid;

   insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1003,1002006,v_bmid,v_qmsz_sum) ;


    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --ծȯճбǰ5Ʊѭα
    v_row := 18;
    open cur_zq;
    fetch cur_zq into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_zq%found
    loop
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1003,v_zqdm,1002009,v_bmid,v_qmcysl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1003,v_zqdm,1002000,v_bmid,v_qmcybl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1003,v_zqdm,1002004,v_bmid,v_qmzmcb);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1003,v_zqdm,1002005,v_bmid,v_qmzmgyjz);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1003,v_zqdm,1002006,v_bmid,v_qmsz);
          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_zq into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_zq;

    --õձǰ5ĩܺͣĩɱĩʼֵĩֵܺ
    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1003,1002009,v_bmid,v_qmcysl_q5m_sum);

    --õ5
   insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1003,'qtzq',1002004,v_bmid,v_qmzmcb_sum - v_qmzmcb_q5m_sum) ;
   insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1003,'qtzq',1002005,v_bmid,v_qmzmgyjz_sum - v_qmzmgyjz_q5m_sum) ;
   insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1003,'qtzq',1002006,v_bmid,v_qmsz_sum - v_qmsz_q5m_sum) ;


    ----------------------------------------------------------------------------
    ------------------------------ծȯ----------------------------------
    ----------------------------------------------------------------------------

/*****************************************************************************************************************************/

   ---------------------------------------------------------------------------
    ----------------------------Ȩֲ֤ϸ-------------------------------
    ---------------------------------------------------------------------------
    --ȡͷȨ֤ĩɱʼֵĩֵܺ
    select nvl(sum(a.a007),0)
      into v_qmzmcb_sum                    --ĩɱ
      from t_db_04_002 a,
           t_bks_t016 b
     where a.p001 = b.p001
       and a.a011 = 400
       and b.a004 = 400
       and b.a003 = 1001
       and b.a100 = v_orgid
       and a.w100 = v_bmid;

    select v_qmzmcb_sum + nvl(sum(a.a006),0)
      into v_qmzmcb_sum
      from t_db_04_002_02_01 a
     where a.p001 = 400
       and a.p002 = 1001
       and a.w100 = v_bmid;

  insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1004,1002004,v_bmid,v_qmzmcb_sum);

    select nvl(sum(a.a008),0)
      into v_qmzmgyjz_sum                  --ĩ湫ʼֵ
      from t_db_04_002 a,
           t_bks_t016 b
     where a.p001 = b.p001
       and a.a011 = 400
       and b.a004 = 400
       and b.a003 = 1001
       and b.a100 = v_orgid
       and a.w100 = v_bmid;

    select v_qmzmgyjz_sum + nvl(sum(a.a007),0)
      into v_qmzmgyjz_sum
      from t_db_04_002_02_01 a
     where a.p001 = 400
       and a.p002 = 1001
       and a.w100 = v_bmid;

    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1004,1002005,v_bmid,v_qmzmgyjz_sum) ;

    select nvl(sum(a.a009),0)
      into v_qmsz_sum                      --ĩֵ
      from t_db_04_002 a,
           t_bks_t016 b
     where a.p001 = b.p001
       and a.a011 = 400
       and b.a004 = 400
       and b.a003 = 1001
       and b.a100 = v_orgid
       and a.w100 = v_bmid;

    select v_qmsz_sum + nvl(sum(a.a008),0)
      into v_qmsz_sum
      from t_db_04_002_02_01 a
     where a.p001 = 400
       and a.p002 = 1001
       and a.w100 = v_bmid;

    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1004,1002006,v_bmid,v_qmsz_sum) ;

    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --Ȩ֤ճбǰ5Ʊѭα
    v_row := 25;
    open cur_qz;
    fetch cur_qz into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_qz%found
    loop
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1004,v_zqdm,1002009,v_bmid,v_qmcysl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1004,v_zqdm,1002000,v_bmid,v_qmcybl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1004,v_zqdm,1002004,v_bmid,v_qmzmcb);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1004,v_zqdm,1002005,v_bmid,v_qmzmgyjz);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1004,v_zqdm,1002006,v_bmid,v_qmsz);
          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_qz into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_qz;


    --õձǰ5ĩܺͣȨ֤ĩɱĩʼֵĩֵܺ
    insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1004,1002009,v_bmid,v_qmcysl_q5m_sum);

    --õ5
    --ĩɱ
   insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1004,'qtqz',1002004,v_bmid,v_qmzmcb_sum - v_qmzmcb_q5m_sum) ;

    --ĩ湫ʼֵ
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1004,'qtqz',1002005,v_bmid,v_qmzmgyjz_sum - v_qmzmgyjz_q5m_sum) ;

    --ĩֵ
    insert into t_b02_f008(p001,p002,p003,p004,w100,v) values (v_date,1004,'qtqz',1002006,v_bmid,v_qmsz_sum - v_qmsz_q5m_sum) ;


    ----------------------------------------------------------------------------
    ------------------------------Ȩ֤----------------------------------
    ----------------------------------------------------------------------------
/*************************************************************************************************************************/

---------------------------------------------------------------------------
    ----------------------------ծȯɱǰ5ϸ--------------------------
    ---------------------------------------------------------------------------

    v_qmcysl_q5m_sum := 0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    v_row := 32;
    open cur_other;
    fetch cur_other into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_other%found
    loop
          dbms_output.put_line(v_date||',1005,'||v_zqdm||',1002009,'||v_bmid||v_qmcysl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1005,v_zqdm,1002009,v_bmid,v_qmcysl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1005,v_zqdm,1002000,v_bmid,v_qmcybl);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1005,v_zqdm,1002004,v_bmid,v_qmzmcb);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1005,v_zqdm,1002005,v_bmid,v_qmzmgyjz);
          insert into t_b02_f008(p001,p002,p003,p004,w100,v) values(v_date,1005,v_zqdm,1002006,v_bmid,v_qmsz);

          v_qmcysl_q5m_sum := v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum := v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum := v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum := v_qmsz_q5m_sum + v_qmsz;
          v_row := v_row + 1;
          fetch cur_other into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_other;


     insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1005,1002009,v_bmid,v_qmcysl_q5m_sum);

     insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1005,1002004,v_bmid,v_qmzmcb_q5m_sum);

     insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1005,1002005,v_bmid,v_qmzmgyjz_q5m_sum) ;

     insert into t_b02_f009(p001,p002,p003,w100,v) values(v_date,1005,1002006,v_bmid,v_qmsz_q5m_sum);

    ----------------------------------------------------------------------------
    ----------------------------ծȯǰ5---------------------------
    ----------------------------------------------------------------------------

      update krcs.t_sys_t022 set A007=1010001
      where P001 in (113002001,113002002,113002003,113002004,113002005,113002006,113002007,113002008,113002009)  and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113002001'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002002'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002003'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002003 ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002004'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002004;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002005'||NVL(A002,'')||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002005;/*ݱת־*/
     INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002006'||NVL(A002,'')||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002006;/*ݱת־*/
     INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002007'||NVL(A002,'')||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002007;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002008'||NVL(A002,'')||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002008;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      SELECT 'ݱתID113002009'||A002||'' INTO v_temp FROM krcs.t_sys_t011 WHERE P001 = 113002009;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001 in (113002001,113002002,113002003,113002004,113002005,113002006,113002007,113002008,113002009)
                 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113002001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113003001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113003001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
   /*
   ʲҵͶ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --õǰ

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete T_B07_F003 where p001=v_date
      and w100 =v_bmid;
     --
      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1001,nvl(a002,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1002,nvl(a003,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1003,nvl(a004,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1004,nvl(a005,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1005,nvl(a006,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1006,nvl(a007,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1007,nvl(a008,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1008,nvl(a009,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1009,nvl(a010,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1010,nvl(a011,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1011,nvl(a012,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1012,nvl(a013,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1013,nvl(a014,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1014,nvl(a015,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1015,nvl(a016,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1016,nvl(a017,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1017,nvl(a018,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1018,nvl(a019,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1019,nvl(a020,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1020,nvl(a021,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1021,nvl(a022,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1022,nvl(a023,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;


      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1023,nvl(a025,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1024,nvl(a026,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1025,nvl(a027,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;


      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1026,nvl(a003,0)+nvl(a005,0)+nvl(a007,0)+nvl(a009,0)+nvl(a012,0)+nvl(a014,0)
                              +nvl(a016,0)+nvl(a018,0)+nvl(a020,0)+nvl(a022,0)+nvl(a025,0)+nvl(a026,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1027,nvl(a004,0)+nvl(a006,0)+nvl(a008,0)+nvl(a010,0)+nvl(a011,0)+nvl(a013,0)
                              +nvl(a015,0)+nvl(a017,0)+nvl(a019,0)+nvl(a021,0)+nvl(a023,0)+nvl(a025,0)+nvl(a027,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1028,nvl(a029,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,p001,1029,nvl(a030,0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid;






      --ϸϼ
      delete from T_B07_F003 where p001 = v_date and p002 = 1200 and w100 = v_bmid;
      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1001,nvl(sum(a002),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1002,nvl(sum(a003),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1003,nvl(sum(a004),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1004,nvl(sum(a005),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1005,nvl(sum(a006),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1006,nvl(sum(a007),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1007,nvl(sum(a008),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1008,nvl(sum(a009),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1009,nvl(sum(a010),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1010,nvl(sum(a011),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1011,nvl(sum(a012),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1012,nvl(sum(a013),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1013,nvl(sum(a014),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1014,nvl(sum(a015),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1015,nvl(sum(a016),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1016,nvl(sum(a017),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1017,nvl(sum(a018),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1018,nvl(sum(a019),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1019,nvl(sum(a020),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1020,nvl(sum(a021),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1021,nvl(sum(a022),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1022,nvl(sum(a023),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1023,nvl(sum(a025),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1024,nvl(sum(a026),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1025,nvl(sum(a027),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1026,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p001 = v_date
      and p002 between 1210 and 1270
      and p003 = 1026;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1027,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p001 = v_date
      and p002 between 1210 and 1270
      and p003 = 1027;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1028,nvl(sum(a029),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1200,1029,nvl(sum(a030),0),v_bmid
      from T_DB_07_103
      where w100 =v_bmid
      and p001 between 1210 and 1270;
     --ϼ
      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1001,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1001;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1002,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1002;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1003,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1003;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1004,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1004;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1005,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1005;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1006,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1006;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1007,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1007;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1008,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1008;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1009,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1009;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1010,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1010;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1011,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1011;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1012,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1012;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1013,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1013;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1014,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1014;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1015,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1015;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1016,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1016;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1017,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1017;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1018,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1018;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1019,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1019;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1020,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1020;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1021,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1021;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1022,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1022;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1023,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1023;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1024,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1024;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1025,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1025;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1026,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1026;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1027,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1027;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1028,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1028;

      insert into T_B07_F003(p001,p002,p003,v,w100)
      select v_date,1300,1029,nvl(sum(v),0),v_bmid
      from T_B07_F003
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1029;

      update krcs.t_sys_t022 set A007=1010001 where P001=113003001 and a004=v_bmid; --޸ת״̬
      SELECT 'ݱתID113003001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113003001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113003001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113003001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113003002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113003002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)is
      v_date int;
      v_temp varchar(256);
       v_bmid number;
   /*
   ʲҵ񣨻
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --õǰ

      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete T_B07_F004 where p001=v_date
      and w100 =v_bmid;
      --
      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,p001,1001,nvl(a002,0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,p001,1002,nvl(a003,0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,p001,1003,nvl(a004,0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,p001,1004,nvl(a005,0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,p001,1005,nvl(a006,0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,p001,1006,nvl(a007,0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid;


      --ϸϼ
      delete from T_B07_F004 where p001 = v_date and p002 = 1200 and w100 = v_bmid;
      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1200,1001,nvl(sum(a002),0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1200,1002,nvl(sum(a003),0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1200,1003,nvl(sum(a004),0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1200,1004,nvl(sum(a005),0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1200,1005,nvl(sum(a006),0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid
      and p001 between 1210 and 1270;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1200,1006,nvl(sum(a007),0),v_bmid
      from T_DB_07_104
      where w100 =v_bmid
      and p001 between 1210 and 1270;
     --ϼ
      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1300,1001,nvl(sum(v),0),v_bmid
      from T_B07_F004
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1001;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1300,1002,nvl(sum(v),0),v_bmid
      from T_B07_F004
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1002;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1300,1003,nvl(sum(v),0),v_bmid
      from T_B07_F004
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1003;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1300,1004,nvl(sum(v),0),v_bmid
      from T_B07_F004
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1004;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1300,1005,nvl(sum(v),0),v_bmid
      from T_B07_F004
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1005;

      insert into T_B07_F004(p001,p002,p003,v,w100)
      select v_date,1300,1006,nvl(sum(v),0),v_bmid
      from T_B07_F004
      where w100 =v_bmid
      and p002 in (1100,1200)
      and p001 = v_date
      and p003 = 1006;

      update krcs.t_sys_t022 set A007=1010001 where P001=113003002 and a004=v_bmid; --޸ת״̬
      SELECT 'ݱתID113003002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113003002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113003002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113003002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113004001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113004001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
   /*
   ʲҵʽ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b04_f104 where p001=v_date and w100 =v_bmid;

      --ĩн
      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005801,nvl(a.a001,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(Ʊ)
      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005802,nvl(a.a002,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʼֵ(Ʊ)
      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005803,nvl(a.a003,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --гɱ()
      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005804,nvl(a.a004,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʼֵ()
      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005805,nvl(a.a005,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

      --гɱ(ծȯ)
      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005806,nvl(a.a006,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʼֵ(ծȯ)

      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005807,nvl(a.a007,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --гɱ(ʲ֧֤ȯ)
      insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005808,nvl(a.a008,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ(ʲ֧֤ȯ)

        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005809,nvl(a.a009,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ĩ֤
         insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005810,nvl(a.a010,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(Ƽƻ)
        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005811,nvl(a.a011,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ(Ƽƻ

         insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005812,nvl(a.a012,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(мƻ)
        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005813,nvl(a.a013,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ( мƻ

         insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005814,nvl(a.a014,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(רʲƻ)
        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005815,nvl(a.a015,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ(רʲƻ

         insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005816,nvl(a.a016,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ĩ
        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005817,nvl(a.a017,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(
         insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005818,nvl(a.a018,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ(

        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005819,nvl(a.a019,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --гɱ(ϼƣ
        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005820,nvl(a.a020,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.b001=1002001
        and a.w100 =v_bmid;
        --ʼֵ(ϼƣ

         insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005821,nvl(a.a021,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʣʽ

        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005822,nvl(a.a022,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and b.b001=1002001
          and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ĩʲֵ
        insert into t_b04_f104(p001,p002,p003,v,w100)
        select v_date,b.a002,1005823,nvl(a.a023,0),v_bmid
        from T_DB_05_104 a,t_b04_t011 b
        where b.a002 = a.p001
        and a.a100=b.a100
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.b001=1002001
        and a.w100 =v_bmid;


      update KRCS.t_sys_t022 set A007=1010001 where P001=113004001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113004001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113004001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update KRCS.t_sys_t022 set A007=1010002 where P001=113004001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113004001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113004002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113004002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
  /*
   ʲҵĩͻ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b04_f105 where p001=v_date and w100 =v_bmid;

      --ع
      insert into t_b04_f105(p001,p002,p003,v,w100)
        select v_date,b.a002,1005701,nvl(a.a002,0),v_bmid
        from T_DB_05_105 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
        and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ع
      insert into t_b04_f105(p001,p002,p003,v,w100)
        select v_date,b.a002,1005702,nvl(a.a003,0),v_bmid
        from T_DB_05_105 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʹģ

      insert into t_b04_f105(p001,p002,p003,v,w100)
        select v_date,b.a002,1005703,nvl(a.a004,0),v_bmid
        from T_DB_05_105 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
          and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

          --ȯģ

      insert into t_b04_f105(p001,p002,p003,v,w100)
        select v_date,b.a002,1005704,nvl(a.a005,0),v_bmid
        from T_DB_05_105 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
          and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --άֵ
       insert into t_b04_f105(p001,p002,p003,v,w100)
        select v_date,b.a002,1005705,nvl(a.a006,0),v_bmid
        from T_DB_05_105 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
          and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

          --֤ȯ

      insert into t_b04_f105(p001,p002,p003,v,w100)
        select v_date,b.a002,1005706,nvl(a.a007,0),v_bmid
        from T_DB_05_105 a,t_b04_t011 b
        where b.A002 = a.P001
        and b.b001=1002001
          and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

      update KRCS.t_sys_t022 set A007=1010001 where P001=113004002 and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID113004002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113004002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
     exception when others then
                rollback;
                update KRCS.t_sys_t022 set A007=1010002 where P001=113004002 and a004=v_bmid;
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113004002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113005001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113005001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
   /*
   רʲҵʽ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b06_f104 where p001=v_date and w100 =v_bmid;

      --ĩн
      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005801,nvl(a.a002,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
        and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(Ʊ)
      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005802,nvl(a.a003,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʼֵ(Ʊ)
      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005803,nvl(a.a004,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --гɱ()
      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005804,nvl(a.a005,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʼֵ()
      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005805,nvl(a.a006,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

      --гɱ(ծȯ)
      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005806,nvl(a.a007,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʼֵ(ծȯ)

      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005807,nvl(a.a008,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --гɱ(ʲ֧֤ȯ)
      insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005808,nvl(a.a009,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ(ʲ֧֤ȯ)

        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005809,nvl(a.a010,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ĩ֤
         insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005810,nvl(a.a011,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(Ƽƻ)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005811,nvl(a.a012,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ(Ƽƻ

         insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005812,nvl(a.a013,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(мƻ)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005813,nvl(a.a014,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ( мƻ

         insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005814,nvl(a.a015,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --гɱ(רʲƻ)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005815,nvl(a.a016,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʼֵ(רʲƻ

         insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005816,nvl(a.a017,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʲȨ(гɱ)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005817,nvl(a.a022,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʲȨ(ʼֵ)
         insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005818,nvl(a.a023,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --ʲȨ(vע)

        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005819,nvl(a.a024,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --Эڴ
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005820,nvl(a.a025,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --()(гɱ)
         insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005821,nvl(a.a026,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --()(ʼֵ)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005822,nvl(a.a027,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --(vע)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005823,nvl(a.a028,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --ϼ(гɱ)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005824,nvl(a.a003,0)+nvl(a.a005,0)+nvl(a.a007,0)+nvl(a.a009,0)+nvl(a.a011,0)
        +nvl(a.a012,0)+nvl(a.a014,0)+nvl(a.a016,0)+nvl(a.a022,0)+nvl(a.a025,0)+nvl(a.a026,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --ϼ(ʼֵ)
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005825,nvl(a.a004,0)+nvl(a.a006,0)+nvl(a.a008,0)+nvl(a.a010,0)+nvl(a.a011,0)
        +nvl(a.a013,0)+nvl(a.a015,0)+nvl(a.a017,0)+nvl(a.a023,0)+nvl(a.a025,0)+nvl(a.a027,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --ʣʽ
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005826,nvl(a.a029,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

        --ĩʲֵ
        insert into t_b06_f104(p001,p002,p003,v,w100)
        select v_date,b.p002,1005827,nvl(a.a030,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.p001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;


      update krcs.t_sys_t022 set A007=1010001 where P001=113005001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113005001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113005001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113005001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113005001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113005002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113005002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
  /*
   ʲҵĩͻ
  */
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

      delete t_b06_f105 where p001=v_date and w100 =v_bmid;

      --ع
      insert into t_b06_f105(p001,p002,p003,v,w100)
        select v_date,b.p002,1005701,nvl(a.a002,0),v_bmid
        from T_DB_06_105 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ع
      insert into t_b06_f105(p001,p002,p003,v,w100)
        select v_date,b.p002,1005702,nvl(a.a003,0),v_bmid
        from T_DB_06_105 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
      --ʹģ

      insert into t_b06_f105(p001,p002,p003,v,w100)
        select v_date,b.p002,1005703,nvl(a.a004,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

          --ȯģ

      insert into t_b06_f105(p001,p002,p003,v,w100)
        select v_date,b.p002,1005704,nvl(a.a005,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;
        --άֵ
       insert into t_b06_f105(p001,p002,p003,v,w100)
        select v_date,b.p002,1005705,nvl(a.a006,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

          --֤ȯ

      insert into t_b06_f105(p001,p002,p003,v,w100)
        select v_date,b.p002,1005706,nvl(a.a007,0),v_bmid
        from T_DB_06_104 a,t_b05_t011 b
        where b.p002 = a.P001
        and b.b001=1002001
         and a.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and b.a100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER)
        and a.w100 =v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=113005002 and a004=v_bmid; /*޸ת״̬ */
       SELECT 'ݱתID113005002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113005002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
     exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113005002 and a004=v_bmid;
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113005002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113012001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113012001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
      v_count number;
      v_countRpt number;
      cursor my_cur(bmid number) is
             select t.p001,t.a002,t.a003,t.a004,t.a005,t.a006 from t_b40_a001 t where t.w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER);


  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      --delete from t_csrc0707_e1_7 t where t.bbq =v_date and t.userid =v_bmid;

      v_count :=0;
      for cur_113012001 in my_cur(v_bmid) loop
          v_count :=v_count +1;
          if(v_count =1) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_date and userid = v_bmid;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b4,c4,d4,e4,f4,g4)values
                 (v_date,v_bmid,'0',null,'0',cur_113012001.p001,cur_113012001.a002,cur_113012001.a003,cur_113012001.a004,cur_113012001.a005,cur_113012001.a006);
             else
                 update t_csrc0707_e1_7 t
                    set t.b4 = cur_113012001.p001,
                        t.c4 = cur_113012001.a002,
                        t.d4 = cur_113012001.a003,
                        t.e4 = cur_113012001.a004,
                        t.f4 = cur_113012001.a005,
                        t.g4 = cur_113012001.a006
                        where t.bbq = v_date and t.userid = v_bmid;
             end if;
          end if;


          if(v_count=2) then
             update t_csrc0707_e1_7 t
                    set t.b5 = cur_113012001.p001,
                        t.c5 = cur_113012001.a002,
                        t.d5 = cur_113012001.a003,
                        t.e5 = cur_113012001.a004,
                        t.f5 = cur_113012001.a005,
                        t.g5 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;

          end if;


          if(v_count=3) then
             update t_csrc0707_e1_7 t
                    set t.b6 = cur_113012001.p001,
                        t.c6 = cur_113012001.a002,
                        t.d6 = cur_113012001.a003,
                        t.e6 = cur_113012001.a004,
                        t.f6 = cur_113012001.a005,
                        t.g6 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=4) then
             update t_csrc0707_e1_7 t
                    set t.b7 = cur_113012001.p001,
                        t.c7 = cur_113012001.a002,
                        t.d7 = cur_113012001.a003,
                        t.e7 = cur_113012001.a004,
                        t.f7 = cur_113012001.a005,
                        t.g7 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=5) then
             update t_csrc0707_e1_7 t
                    set t.b8 = cur_113012001.p001,
                        t.c8 = cur_113012001.a002,
                        t.d8 = cur_113012001.a003,
                        t.e8 = cur_113012001.a004,
                        t.f8 = cur_113012001.a005,
                        t.g8 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=6) then
             update t_csrc0707_e1_7 t
                    set t.b9 = cur_113012001.p001,
                        t.c9 = cur_113012001.a002,
                        t.d9 = cur_113012001.a003,
                        t.e9 = cur_113012001.a004,
                        t.f9 = cur_113012001.a005,
                        t.g9 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=7) then
             update t_csrc0707_e1_7 t
                    set t.b10 = cur_113012001.p001,
                        t.c10 = cur_113012001.a002,
                        t.d10 = cur_113012001.a003,
                        t.e10 = cur_113012001.a004,
                        t.f10 = cur_113012001.a005,
                        t.g10 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=8) then
             update t_csrc0707_e1_7 t
                    set t.b11 = cur_113012001.p001,
                        t.c11 = cur_113012001.a002,
                        t.d11 = cur_113012001.a003,
                        t.e11 = cur_113012001.a004,
                        t.f11 = cur_113012001.a005,
                        t.g11 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=9) then
             update t_csrc0707_e1_7 t
                    set t.b12 = cur_113012001.p001,
                        t.c12 = cur_113012001.a002,
                        t.d12 = cur_113012001.a003,
                        t.e12 = cur_113012001.a004,
                        t.f12 = cur_113012001.a005,
                        t.g12 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=10) then
             update t_csrc0707_e1_7 t
                    set t.b13 = cur_113012001.p001,
                        t.c13 = cur_113012001.a002,
                        t.d13 = cur_113012001.a003,
                        t.e13 = cur_113012001.a004,
                        t.f13 = cur_113012001.a005,
                        t.g13 = cur_113012001.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;
      end loop;

      commit;

      update krcs.t_sys_t022 set A007=1010001 where P001=113012001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113012001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113012001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
     /* exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113012001 and a004=v_bmid; \*޸ת״̬ *\
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113012001!';
                return;*/
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113012002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113012002(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
      v_count number;
      v_countRpt number;
      cursor my_cur(bmid number) is
             select t.p001,t.a002,t.a003,t.a004,t.a005,t.a006 from t_b40_a002 t where t.w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER);


  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      --delete from t_csrc0707_e1_7 t where t.bbq =v_date and t.userid =v_bmid;

      v_count :=0;
      for cur_113012002 in my_cur(v_bmid) loop
          v_count :=v_count +1;
          if(v_count =1) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_date and userid = v_bmid;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b17,c17,d17,e17,f17,g17)values
                (v_date,v_bmid,'0',null,'0',cur_113012002.p001,cur_113012002.a002,cur_113012002.a003,cur_113012002.a004,cur_113012002.a005,cur_113012002.a006);
             else
                 update t_csrc0707_e1_7 t
                    set t.b17 = cur_113012002.p001,
                        t.c17 = cur_113012002.a002,
                        t.d17 = cur_113012002.a003,
                        t.e17 = cur_113012002.a004,
                        t.f17 = cur_113012002.a005,
                        t.g17 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
             end if;
          end if;


          if(v_count=2) then
             update t_csrc0707_e1_7 t
                    set t.b18 = cur_113012002.p001,
                        t.c18 = cur_113012002.a002,
                        t.d18 = cur_113012002.a003,
                        t.e18 = cur_113012002.a004,
                        t.f18 = cur_113012002.a005,
                        t.g18 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;

          end if;


          if(v_count=3) then
             update t_csrc0707_e1_7 t
                    set t.b19 = cur_113012002.p001,
                        t.c19 = cur_113012002.a002,
                        t.d19 = cur_113012002.a003,
                        t.e19 = cur_113012002.a004,
                        t.f19 = cur_113012002.a005,
                        t.g19 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=4) then
             update t_csrc0707_e1_7 t
                    set t.b20 = cur_113012002.p001,
                        t.c20 = cur_113012002.a002,
                        t.d20 = cur_113012002.a003,
                        t.e20 = cur_113012002.a004,
                        t.f20 = cur_113012002.a005,
                        t.g20 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=5) then
             update t_csrc0707_e1_7 t
                    set t.b21 = cur_113012002.p001,
                        t.c21 = cur_113012002.a002,
                        t.d21 = cur_113012002.a003,
                        t.e21 = cur_113012002.a004,
                        t.f21 = cur_113012002.a005,
                        t.g21 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=6) then
             update t_csrc0707_e1_7 t
                    set t.b22 = cur_113012002.p001,
                        t.c22 = cur_113012002.a002,
                        t.d22 = cur_113012002.a003,
                        t.e22 = cur_113012002.a004,
                        t.f22 = cur_113012002.a005,
                        t.g22 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=7) then
             update t_csrc0707_e1_7 t
                    set t.b23 = cur_113012002.p001,
                        t.c23 = cur_113012002.a002,
                        t.d23 = cur_113012002.a003,
                        t.e23 = cur_113012002.a004,
                        t.f23 = cur_113012002.a005,
                        t.g23 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=8) then
             update t_csrc0707_e1_7 t
                    set t.b24 = cur_113012002.p001,
                        t.c24 = cur_113012002.a002,
                        t.d24 = cur_113012002.a003,
                        t.e24 = cur_113012002.a004,
                        t.f24 = cur_113012002.a005,
                        t.g24 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=9) then
            update t_csrc0707_e1_7 t
                    set t.b25 = cur_113012002.p001,
                        t.c25 = cur_113012002.a002,
                        t.d25 = cur_113012002.a003,
                        t.e25 = cur_113012002.a004,
                        t.f25 = cur_113012002.a005,
                        t.g25 = cur_113012002.a006
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=10) then
             update t_csrc0707_e1_7 t
                    set t.b26= cur_113012002.p001,
                        t.c26= cur_113012002.a002,
                        t.d26 = cur_113012002.a003,
                        t.e26 = cur_113012002.a004,
                        t.f26 = cur_113012002.a005,
                        t.g26 = cur_113012002.a006
              where t.bbq = v_date and t.userid = v_bmid;
          end if;
      end loop;

      commit;



      update krcs.t_sys_t022 set A007=1010001 where P001=113012002  and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113012002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113012002 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113012002 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113012002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113012003
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113012003(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
      v_count number;
      v_countRpt number;
      cursor my_cur(bmid number) is
             select t.p001,t.a002,t.a003,t.a004,t.a005 from t_b40_a003 t where t.w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER);


  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      --delete from t_csrc0707_e1_7 t where t.bbq =v_date and t.userid =v_bmid;

      v_count :=0;
      for cur_113012003 in my_cur(v_bmid) loop
          v_count :=v_count +1;
          if(v_count =1) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_date and userid = v_bmid;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b30,c30,d30,e30,f30)values
                (v_date,v_bmid,'0',null,'0',cur_113012003.p001,cur_113012003.a002,cur_113012003.a003,cur_113012003.a004,cur_113012003.a005);
             else
                 update t_csrc0707_e1_7 t
                    set t.b30 = cur_113012003.p001,
                        t.c30 = cur_113012003.a002,
                        t.d30 = cur_113012003.a003,
                        t.e30 = cur_113012003.a004,
                        t.f30 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
             end if;
          end if;


          if(v_count=2) then
             update t_csrc0707_e1_7 t
                  set t.b31 = cur_113012003.p001,
                      t.c31 = cur_113012003.a002,
                      t.d31 = cur_113012003.a003,
                      t.e31 = cur_113012003.a004,
                      t.f31 = cur_113012003.a005
                      where t.bbq = v_date and t.userid = v_bmid;

          end if;


          if(v_count=3) then
             update t_csrc0707_e1_7 t
                    set t.b32 = cur_113012003.p001,
                        t.c32 = cur_113012003.a002,
                        t.d32 = cur_113012003.a003,
                        t.e32 = cur_113012003.a004,
                        t.f32 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=4) then
             update t_csrc0707_e1_7 t
                    set t.b33 = cur_113012003.p001,
                        t.c33 = cur_113012003.a002,
                        t.d33 = cur_113012003.a003,
                        t.e33 = cur_113012003.a004,
                        t.f33 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=5) then
             update t_csrc0707_e1_7 t
                    set t.b34 = cur_113012003.p001,
                        t.c34 = cur_113012003.a002,
                        t.d34 = cur_113012003.a003,
                        t.e34 = cur_113012003.a004,
                        t.f34 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=6) then
             update t_csrc0707_e1_7 t
                    set t.b35 = cur_113012003.p001,
                        t.c35 = cur_113012003.a002,
                        t.d35 = cur_113012003.a003,
                        t.e35 = cur_113012003.a004,
                        t.f35 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=7) then
             update t_csrc0707_e1_7 t
                    set t.b36 = cur_113012003.p001,
                        t.c36 = cur_113012003.a002,
                        t.d36 = cur_113012003.a003,
                        t.e36 = cur_113012003.a004,
                        t.f36 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=8) then
             update t_csrc0707_e1_7 t
                    set t.b37 = cur_113012003.p001,
                        t.c37 = cur_113012003.a002,
                        t.d37 = cur_113012003.a003,
                        t.e37 = cur_113012003.a004,
                        t.f37 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=9) then
            update t_csrc0707_e1_7 t
                    set t.b38 = cur_113012003.p001,
                        t.c38 = cur_113012003.a002,
                        t.d38 = cur_113012003.a003,
                        t.e38 = cur_113012003.a004,
                        t.f38 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=10) then
             update t_csrc0707_e1_7 t
                    set t.b39 = cur_113012003.p001,
                        t.c39 = cur_113012003.a002,
                        t.d39 = cur_113012003.a003,
                        t.e39 = cur_113012003.a004,
                        t.f39 = cur_113012003.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;
      end loop;

      commit;



      update krcs.t_sys_t022 set A007=1010001 where P001=113012003 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113012003'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113012003 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113012003 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113012003!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113012004
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113012004(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
      v_count number;
      v_countRpt number;
      cursor my_cur(bmid number) is
             select t.p001,t.a002,t.a003,t.a004,t.a005 from t_b40_a004 t where t.w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER);


  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      --delete from t_csrc0707_e1_7 t where t.bbq =v_date and t.userid =v_bmid;

      v_count :=0;
      for cur_113012004 in my_cur(v_bmid) loop
          v_count :=v_count +1;
          if(v_count =1) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_date and userid = v_bmid;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b43,c43,d43,e43,f43)values
                (v_date,v_bmid,'0',null,'0',cur_113012004.p001,cur_113012004.a002,cur_113012004.a003,cur_113012004.a004,cur_113012004.a005);
             else
                 update t_csrc0707_e1_7 t
                    set t.b43 = cur_113012004.p001,
                        t.c43 = cur_113012004.a002,
                        t.d43 = cur_113012004.a003,
                        t.e43 = cur_113012004.a004,
                        t.f43 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
             end if;
          end if;


          if(v_count=2) then
            update t_csrc0707_e1_7 t
                    set t.b44 = cur_113012004.p001,
                        t.c44 = cur_113012004.a002,
                        t.d44 = cur_113012004.a003,
                        t.e44 = cur_113012004.a004,
                        t.f44 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;


          if(v_count=3) then
             update t_csrc0707_e1_7 t
                    set t.b45 = cur_113012004.p001,
                        t.c45 = cur_113012004.a002,
                        t.d45 = cur_113012004.a003,
                        t.e45 = cur_113012004.a004,
                        t.f45 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=4) then
             update t_csrc0707_e1_7 t
                    set t.b46 = cur_113012004.p001,
                        t.c46 = cur_113012004.a002,
                        t.d46 = cur_113012004.a003,
                        t.e46 = cur_113012004.a004,
                        t.f46 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=5) then
             update t_csrc0707_e1_7 t
                    set t.b47 = cur_113012004.p001,
                        t.c47 = cur_113012004.a002,
                        t.d47 = cur_113012004.a003,
                        t.e47 = cur_113012004.a004,
                        t.f47 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=6) then
             update t_csrc0707_e1_7 t
                    set t.b48 = cur_113012004.p001,
                        t.c48 = cur_113012004.a002,
                        t.d48 = cur_113012004.a003,
                        t.e48 = cur_113012004.a004,
                        t.f48 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=7) then
             update t_csrc0707_e1_7 t
                    set t.b49 = cur_113012004.p001,
                        t.c49 = cur_113012004.a002,
                        t.d49 = cur_113012004.a003,
                        t.e49 = cur_113012004.a004,
                        t.f49 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=8) then
             update t_csrc0707_e1_7 t
                    set t.b50 = cur_113012004.p001,
                        t.c50 = cur_113012004.a002,
                        t.d50 = cur_113012004.a003,
                        t.e50 = cur_113012004.a004,
                        t.f50 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=9) then
            update t_csrc0707_e1_7 t
                    set t.b51 = cur_113012004.p001,
                        t.c51 = cur_113012004.a002,
                        t.d51 = cur_113012004.a003,
                        t.e51 = cur_113012004.a004,
                        t.f51 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=10) then
             update t_csrc0707_e1_7 t
                    set t.b52 = cur_113012004.p001,
                        t.c52 = cur_113012004.a002,
                        t.d52 = cur_113012004.a003,
                        t.e52 = cur_113012004.a004,
                        t.f52 = cur_113012004.a005
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;
      end loop;

      commit;

      update krcs.t_sys_t022 set A007=1010001 where P001=113012004 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113012004'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113012004;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113012004 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113012004!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113012005
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113012005(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
      v_count number;
      v_countRpt number;
      cursor my_cur(bmid number) is
             select t.p001,t.a002,t.a003,t.a004 from t_b40_a005 t where t.w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER);


  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      --delete from t_csrc0707_e1_7 t where t.bbq =v_date and t.userid =v_bmid;

      v_count :=0;
      for cur_113012005 in my_cur(v_bmid) loop
          v_count :=v_count +1;
          if(v_count =1) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_date and userid = v_bmid;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b55,c55,d55,e55)values
                (v_date,v_bmid,'0',null,'0',cur_113012005.p001,cur_113012005.a002,cur_113012005.a003,cur_113012005.a004);
             else
                 update t_csrc0707_e1_7 t
                    set t.b55 = cur_113012005.p001,
                        t.c55 = cur_113012005.a002,
                        t.d55 = cur_113012005.a003,
                        t.e55 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
             end if;
          end if;


          if(v_count=2) then
            update t_csrc0707_e1_7 t
                    set t.b56 = cur_113012005.p001,
                        t.c56 = cur_113012005.a002,
                        t.d56 = cur_113012005.a003,
                        t.e56 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;


          if(v_count=3) then
             update t_csrc0707_e1_7 t
                    set t.b57 = cur_113012005.p001,
                        t.c57 = cur_113012005.a002,
                        t.d57 = cur_113012005.a003,
                        t.e57 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=4) then
             update t_csrc0707_e1_7 t
                    set t.b58 = cur_113012005.p001,
                        t.c58 = cur_113012005.a002,
                        t.d58 = cur_113012005.a003,
                        t.e58 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=5) then
             update t_csrc0707_e1_7 t
                    set t.b59 = cur_113012005.p001,
                        t.c59 = cur_113012005.a002,
                        t.d59 = cur_113012005.a003,
                        t.e59 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=6) then
             update t_csrc0707_e1_7 t
                    set t.b60 = cur_113012005.p001,
                        t.c60 = cur_113012005.a002,
                        t.d60 = cur_113012005.a003,
                        t.e60 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=7) then
             update t_csrc0707_e1_7 t
                    set t.b61 = cur_113012005.p001,
                        t.c61 = cur_113012005.a002,
                        t.d61 = cur_113012005.a003,
                        t.e61 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=8) then
             update t_csrc0707_e1_7 t
                    set t.b62 = cur_113012005.p001,
                        t.c62 = cur_113012005.a002,
                        t.d62 = cur_113012005.a003,
                        t.e62 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=9) then
            update t_csrc0707_e1_7 t
                    set t.b63 = cur_113012005.p001,
                        t.c63 = cur_113012005.a002,
                        t.d63 = cur_113012005.a003,
                        t.e63 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=10) then
             update t_csrc0707_e1_7 t
                    set t.b64 = cur_113012005.p001,
                        t.c64 = cur_113012005.a002,
                        t.d64 = cur_113012005.a003,
                        t.e64 = cur_113012005.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;
      end loop;

      commit;



      update krcs.t_sys_t022 set A007=1010001 where P001=113012005 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113012005'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113012005;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113012005 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113012005!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113012006
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113012006(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
      v_count number;
      v_countRpt number;
      cursor my_cur(bmid number) is
             select t.p001,t.a002,t.a003,t.a004 from t_b40_a006 t where t.w100 =(select a012 from krcs.t_sys_user where  p001 =v_KJAXUSER);


  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      --delete from t_csrc0707_e1_7 t where t.bbq =v_date and t.userid =v_bmid;

      v_count :=0;
      for cur_113012006 in my_cur(v_bmid) loop
          v_count :=v_count +1;
          if(v_count =1) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_date and userid = v_bmid;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b67,c67,d67,e67)values
                (v_date,v_bmid,'0',null,'0',cur_113012006.p001,cur_113012006.a002,cur_113012006.a003,cur_113012006.a004);
             else
                 update t_csrc0707_e1_7 t
                    set t.b67 = cur_113012006.p001,
                        t.c67 = cur_113012006.a002,
                        t.d67 = cur_113012006.a003,
                        t.e67 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
             end if;
          end if;


          if(v_count=2) then
            update t_csrc0707_e1_7 t
                    set t.b68 = cur_113012006.p001,
                        t.c68 = cur_113012006.a002,
                        t.d68 = cur_113012006.a003,
                        t.e68 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;


          if(v_count=3) then
             update t_csrc0707_e1_7 t
                    set t.b69 = cur_113012006.p001,
                        t.c69 = cur_113012006.a002,
                        t.d69 = cur_113012006.a003,
                        t.e69 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=4) then
             update t_csrc0707_e1_7 t
                    set t.b70 = cur_113012006.p001,
                        t.c70 = cur_113012006.a002,
                        t.d70 = cur_113012006.a003,
                        t.e70 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=5) then
             update t_csrc0707_e1_7 t
                    set t.b71 = cur_113012006.p001,
                        t.c71 = cur_113012006.a002,
                        t.d71 = cur_113012006.a003,
                        t.e71 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=6) then
             update t_csrc0707_e1_7 t
                    set t.b72 = cur_113012006.p001,
                        t.c72 = cur_113012006.a002,
                        t.d72 = cur_113012006.a003,
                        t.e72 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=7) then
             update t_csrc0707_e1_7 t
                    set t.b73 = cur_113012006.p001,
                        t.c73 = cur_113012006.a002,
                        t.d73 = cur_113012006.a003,
                        t.e73 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=8) then
             update t_csrc0707_e1_7 t
                    set t.b74 = cur_113012006.p001,
                        t.c74 = cur_113012006.a002,
                        t.d74 = cur_113012006.a003,
                        t.e74 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=9) then
            update t_csrc0707_e1_7 t
                    set t.b75 = cur_113012006.p001,
                        t.c75 = cur_113012006.a002,
                        t.d75 = cur_113012006.a003,
                        t.e75 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;

          if(v_count=10) then
             update t_csrc0707_e1_7 t
                    set t.b76 = cur_113012006.p001,
                        t.c76 = cur_113012006.a002,
                        t.d76 = cur_113012006.a003,
                        t.e76 = cur_113012006.a004
                        where t.bbq = v_date and t.userid = v_bmid;
          end if;
      end loop;

      commit;



      update krcs.t_sys_t022 set A007=1010001 where P001=113012006 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113012006'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113012006 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113012006 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113012006!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113013001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113013001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
      v_count number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';


       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      delete from t_csrc0707_e1_7_3 t where t.bbq =v_date and t.userid =v_bmid;

      insert into t_csrc0707_e1_7_3(BBQ,userid,btype,option1,shtag,ishj,a4,b4,c4,d4,e4,f4,g4)
             select v_date,v_bmid,'0',null,'0','0',rownum,t.p001,t.a002,t.a003,t.a004,t.a005,t.a006 from t_b50_a001 t where t.w100 =v_bmid;

      --ϼ
      select count(*) into v_count from t_b50_a001 t
             where t.w100 =v_bmid;

      insert into t_csrc0707_e1_7_3(BBQ,userid,btype,option1,shtag,ishj,c4,d4,e4,f4,g4)
             select v_date,v_bmid,'0',null,'0','1',sum(t.a002),sum(a003),sum(t.a004),sum(t.a005),0 from t_b50_a001 t where t.w100 =v_bmid;
      commit;

      update krcs.t_sys_t022 set A007=1010001 where P001=113013001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113013001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113013001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113013001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113013001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113014001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113014001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(20);
      v_bmid number;
      v_temp varchar2(256);
  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

     delete from t_csrc0707_e1_8_1 t where t.bbq=v_date and t.userid=v_bmid;
     commit;
     insert into t_csrc0707_e1_8_1
          (BBQ,userid,btype, option1,shtag,ishj,A3,B3,
           C3,D3,E3, F3,G3,H3,I3,J3,K3,L3,M3,N3,O3)
          select v_date,v_bmid,'0',null,'0', '0',t.p001,t.a002,t.a003,t.a004,t.a005,t.a006,
          t.a007,t.a008,t.a009,t.a010,t.a011,t.a012,t.a013,t.a014,t.a015
            from t_db_05_020 t
           where t.w100 = v_bmid;

      update krcs.t_sys_t022 set A007=1010001 where P001=113014001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113014001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113014001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113014001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113014001!';
                return;
 end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113015001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113015001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date varchar2(40);
      v_temp varchar(256);
      v_bmid number;
     -- v_count number;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';




       select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID
       select P001||'--' into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; --ȡǰ


      delete from t_csrc0707_e1_8_2 t where t.bbq =v_date and t.userid =v_bmid;

      insert into t_csrc0707_e1_8_2(BBQ,userid,btype,option1,shtag,ishj,A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3)
             select v_date,v_bmid,'0',null,'0','0',rownum,t.a001,t.a002,t.a003,t.a004,t.a005,t.a006,t.a007,t.a008,t.a009,t.a010,
             t.a011,t.a012,t.a013,t.a014,t.a002+t.a015,t.a003+t.a016,t.a004+t.a017,t.a005+t.a018
             from t_db_05_025 t where t.w100 =v_bmid;



      update krcs.t_sys_t022 set A007=1010001 where P001=113015001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113015001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113015001 ;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113015001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113015001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113104001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113104001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select t.a012 into v_bmid from krcs.t_sys_user t where t.p001=v_KJAXUSER;
      update krcs.t_sys_t022 set A007=1010001 where P001=113104001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113104001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113104001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,a004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113104001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113104001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_113105001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_113105001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2) is
      v_date int;
      v_temp varchar(256);
      v_bmid number;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select t.a012 into v_bmid from krcs.t_sys_user t where t.p001=v_KJAXUSER;
      update krcs.t_sys_t022 set A007=1010001 where P001=113105001 and a004=v_bmid; /*޸ת״̬ */
      SELECT 'ݱתID113105001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 113105001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,a004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t022 set A007=1010002 where P001=113105001 and a004=v_bmid; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_113105001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120503001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_120503001(
  /*
  ʲծ״
  */
      errcode out int,
      errmsg out varchar2,
      V_KJAXUSER varchar2,v_TASK varchar2)
  is
      v_date int;
      v_temp varchar(256);
      V_ORGANID NUMERIC;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      delete T_B001_F001 /* ɾǰͬһ */
      where P001=v_date
      and P002 =V_ORGANID ;

      insert into T_B001_F001(P001,P002,P003,P004,V) select v_date,V_ORGANID,P002,1025001,A003 from T_DB_B1_01 a where a.p001=V_ORGANID;
      insert into T_B001_F001(P001,P002,P003,P004,V) select v_date,V_ORGANID,P002,1025002,A004 from T_DB_B1_01 a where a.p001=V_ORGANID;

      update krcs.t_sys_t012 set A007=1010001 where P001=101 and a004 =V_ORGANID; /*޸ת״̬ */
      SELECT 'ݱתID120503001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120503001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(V_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t012 set A007=1010002 where P001 =120503001 and a004 =V_ORGANID; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_120503001!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120503002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_120503002(
  /*
  ʲծ״
  */
      errcode out int,
      errmsg out varchar2,
      V_KJAXUSER varchar2,v_TASK varchar2)
  is
      v_date int;
      v_temp varchar(256);
      V_ORGANID NUMERIC;
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      delete T_B001_F002 /* ɾǰͬһ */
      where P001=v_date
      and P002 =V_ORGANID ;

      insert into T_B001_F002(P001,P002,P003,P004,V) select v_date,V_ORGANID,P002,1026001,nvl(A003,0) from T_DB_B1_02 a where a.p001=V_ORGANID;
      insert into T_B001_F002(P001,P002,P003,P004,V) select v_date,V_ORGANID,P002,1026002,nvl(A003,0)+nvl(A004,0) from T_DB_B1_02 a where a.p001=V_ORGANID;

      update krcs.t_sys_t012 set A007=1010001 where P001 IN (120503002,120503003) and a004 =V_ORGANID; /*޸ת״̬ */
      SELECT 'ݱתID120503002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120503002;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(V_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
     exception when others then
                rollback;
                update krcs.t_sys_t012 set A007=1010002 where P001 IN (120503002,120503003) and a004 =V_ORGANID;
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_120503002!';
                return;
  end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120504001
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120504001(
  /*
    ݱ201Ӫҵʽʲתʵ
  */
       errcode out int,       ---ش
       errmsg out varchar2,   ---Ϣ
       v_KJAXUSER varchar2,v_TASK varchar2    ---û
       )
  is
       v_date int;            ---
       v_temp varchar(256);
       V_ORGANID NUMERIC;

  begin
       errcode := 1;
       errmsg := 'תݱɹ';

      select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      delete T_B002_F001 /* ɾǰͬһ */
      where P001=v_date
      and P002 =V_ORGANID ;

      insert into T_B002_F001(P001,P002,P003,P004,V) select v_date,V_ORGANID,P002,1027001,A003 from T_DB_B2_01 a where a.p001=V_ORGANID;
      insert into T_B002_F001(P001,P002,P003,P004,V) select v_date,V_ORGANID,P002,1027002,A004 from T_DB_B2_01 a where a.p001=V_ORGANID;

      update krcs.t_sys_t012 set A007=1010001 where P001=120504001 and a004 =V_ORGANID; /*޸ת״̬ */
      SELECT 'ݱתID120504001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120504001;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
     exception when others then
              rollback;
              update krcs.t_sys_t012 set A007=1010002 where P001=120504001 and a004 =V_ORGANID;
              errcode := 0;
              errmsg := 'ڴ洢cisp_convert_DT_120504001';
              return;
end cisp_convert_dt_120504001;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120504002
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120504002(
  /*Ӫҵܿͻʽֲתʵ
    */
       errcode out int,       ---ش
       errmsg out varchar2,   ---Ϣ
       v_KJAXUSER varchar2,v_TASK varchar2    ---û
       )
  is
       v_date int;            ---
       v_temp varchar(256);
       V_ORGANID NUMERIC;

  begin
       errcode := 1;
       errmsg := 'תݱɹ';

      select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;
      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      delete T_B002_F002 /* ɾǰͬһ */
      where P001=v_date
      and P002 =V_ORGANID ;

       --ڳ--
       insert into T_B002_F002(P001,P002,P003,P004,V)
       select v_date,V_ORGANID,b.a004,1028001,sum(a.a004)
       from T_DB_B2_02 a, t_bks_t031 b
       where a.p002 = b.p002 and a.p001=V_ORGANID and b.p001=V_ORGANID
       group by b.a004;
        --ڳ--
       insert into T_B002_F002(P001,P002,P003,P004,V)
       select v_date,V_ORGANID,b.a004,1028002,sum(a.a005)
       from T_DB_B2_02 a, t_bks_t031 b
       where a.p002 = b.p002 and a.p001=V_ORGANID and b.p001=V_ORGANID
       group by b.a004;
         --ĩ--
       insert into T_B002_F002(P001,P002,P003,P004,V)
       select v_date,V_ORGANID,b.a004,1028003,sum(a.a006)
       from T_DB_B2_02 a, t_bks_t031 b
       where a.p002 = b.p002 and a.p001=V_ORGANID and b.p001=V_ORGANID
       group by b.a004;
       --ĩ--
       insert into T_B002_F002(P001,P002,P003,P004,V)
       select v_date,V_ORGANID,b.a004,1028004,sum(a.a007)
       from T_DB_B2_02 a, t_bks_t031 b
       where a.p002 = b.p002 and a.p001=V_ORGANID and b.p001=V_ORGANID
       group by b.a004;
       --ϼ--
       insert into T_B002_F002(P001,P002,P003,P004,V)
       select v_date,V_ORGANID,2000,P004,sum(V)
       from T_B002_F002
       where p001=v_date and p002=V_ORGANID
       group by P004;


      update krcs.t_sys_t012 set A007=1010001 where P001=120504002 and a004 =V_ORGANID; /*޸ת״̬ */
      SELECT 'ݱתID120504002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120504002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
   /*   commit;
      exception when others then
              rollback;
              update krcs.t_sys_t012 set A007=1010002 where P001=120504002 and a004 =V_ORGANID; \*޸ת״̬ *\
              errcode := 0;
              errmsg := 'ڴ洢cisp_convert_DT_120504002';
              return;*/
end cisp_convert_dt_120504002;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120505001
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120505001(
       errcode out int,       ---ش
       errmsg out varchar2,   ---Ϣ
       v_KJAXUSER varchar2,v_TASK varchar2    ---û
       ) is
       v_date int;            ---
       v_p001 number;         ---ӪҵID
       v_p002 number;         ---ĿID
       v_temp varchar(256);

       cursor cur_project is ---ӪҵID,ĿID
       select P001,P002 from T_DB_B3_01
        where p001 in  (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);

begin
      errcode := 1;
      errmsg := 'תݱɹ';
  /* Ӫҵʽ˻תʵ
    */

       select P001 into v_date from T_B00_D004 where C001=1001101 and A002=1013001; ----õǰ

       delete T_B003_F001 where p001=v_date
          and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER);     --ɾʵ

       open  cur_project;
       fetch cur_project into v_p001,v_p002;
       while cur_project%found
        loop
       insert into T_B003_F001(P001,P002,P003,P004,v)   --Aɣ
            select v_date,P002, 2007001,v_p001,nvl(a.A003,0)
              from T_DB_B3_01 a where a.P001=v_p001 and a.P002=v_p002;

       fetch cur_project into v_p001,v_p002;
       end loop;
       close cur_project;

      update krcs.t_sys_t012 set A007=1010001 where P001=120505001 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
      SELECT 'ݱתID120505001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120505001 ;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
              rollback;
              update krcs.t_sys_t012 set A007=1010002 where P001=120505001 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
              errcode := 0;
              errmsg := 'ڴ洢cisp_convert_DT_120505001';
              return;
end cisp_convert_dt_120505001;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120505002
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120505002(
       errcode out int,       ---ش
       errmsg out varchar2,   ---Ϣ
       v_KJAXUSER varchar2,v_TASK varchar2    ---û
       ) is
       v_date int;            ---
       v_p001 number;         ---ӪҵID
       v_p002 number;         ---ĿID
       v_temp varchar(256);

       cursor cur_project is ---ӪҵID,ĿID
       select P001,P002 from T_DB_B3_02
        where p001 in  (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);

begin
      errcode := 1;
      errmsg := 'תݱɹ';
  /*Ӫҵ֤ȯ˻תʵ
    */

       select P001 into v_date from T_B00_D004 where C001=1001101 and A002=1013001; ----õǰ

       delete T_B003_F002 where P001=v_date
          and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER);     --ɾʵ

       open  cur_project;
       fetch cur_project into v_p001,v_p002;
       while cur_project%found
        loop
       insert into T_B003_F002(P001,P002,P003,P004,v)   --Aɣ
            select v_date,P002, 2008001,v_p001,nvl(a.A003,0)
              from T_DB_B3_02 a where a.P001=v_p001 and a.P002=v_p002;
       insert into T_B003_F002(P001,P002,P003,P004,v)   --Bɣ
            select v_date,P002, 2008002,v_p001,nvl(a.A004,0)
              from T_DB_B3_02 a where a.P001=v_p001 and a.P002=v_p002;
       insert into T_B003_F002(P001,P002,P003,P004,v)   --ϼƣ
            select v_date,P002, 2008003,v_p001,nvl((nvl(a.A003,0)+nvl(a.A004,0)),0)
              from T_DB_B3_02 a where a.P001=v_p001 and a.P002=v_p002;
       fetch cur_project into v_p001,v_p002;
       end loop;
       close cur_project;

      update krcs.t_sys_t012 set A007=1010001 where P001=120505002 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
      SELECT 'ݱתID120505002'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120505002;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
              rollback;
              update krcs.t_sys_t012 set A007=1010002 where P001=120505002 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
              errcode := 0;
              errmsg := 'ڴ洢cisp_convert_DT_120505002';
              return;
end cisp_convert_dt_120505002;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120505003
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120505003(
       errcode out int,       ---ش
       errmsg out varchar2,   ---Ϣ
       v_KJAXUSER varchar2,v_TASK varchar2    ---û
       ) is
       v_date int;            ---
       v_p001 number;         ---ӪҵID
       v_p002 number;         ---ĿID
       v_temp varchar(256);

       cursor cur_project is ---ӪҵID,ĿID
       select P001,P002 from T_DB_B3_03
        where p001 in  (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);

begin
      errcode := 1;
      errmsg := 'תݱɹ';
  /*Ӫҵ˻תʵ
    */

       select P001 into v_date from T_B00_D004 where C001=1001101 and A002=1013001; ----õǰ

       delete T_B003_F003 where p001=v_date
          and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER);     --ɾʵ

       open  cur_project;
       fetch cur_project into v_p001,v_p002;
       while cur_project%found
        loop
       insert into T_B003_F003(P001,P002,P003,P004,v)   --Aɣ
            select v_date,P002, 2009001,v_p001,nvl(a.A003,0)
              from T_DB_B3_03 a where a.P001=v_p001 and a.P002=v_p002;
       insert into T_B003_F003(P001,P002,P003,P004,v)   --ϼƣ
            select v_date,P002, 2009002,v_p001,nvl(a.A003,0)
              from T_DB_B3_03 a where a.P001=v_p001 and a.P002=v_p002;
       fetch cur_project into v_p001,v_p002;
       end loop;
       close cur_project;

      update krcs.t_sys_t012 set A007=1010001 where P001=120505003 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
      SELECT 'ݱתID120505003'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120505003;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
              rollback;
              update krcs.t_sys_t012 set A007=1010002 where P001=120505003 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
              errcode := 0;
              errmsg := 'ڴ洢cisp_convert_DT_120505003';
              return;
end cisp_convert_dt_120505003;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120505004
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120505004(
       errcode out int,       ---ش
       errmsg out varchar2,   ---Ϣ
       v_KJAXUSER varchar2,v_TASK varchar2    ---û
       ) is
       v_date int;            ---
       v_p001 number;         ---ӪҵID
       v_p002 number;         ---ĿID
       v_temp varchar(256);

       cursor cur_project is ---ӪҵID,ĿID
       select P001,P002 from T_DB_B3_04
        where p001 in  (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);

begin
      errcode := 1;
      errmsg := 'תݱɹ';
  /*Ӫҵ˻淶תʵ
    */

       select P001 into v_date from T_B00_D004 where C001=1001101 and A002=1013001; ----õǰ

       delete T_B003_F004 where p001=v_date
          and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER);     --ɾʵ

        open  cur_project;
       fetch cur_project into v_p001,v_p002;
       while cur_project%found
        loop
       insert into T_B003_F004(P001,P002,P003,P004,v)   --
            select v_date,P002, 2010001,v_p001,nvl(a.A003,0)
              from T_DB_B3_04 a where a.P001=v_p001 and a.P002=v_p002;
       insert into T_B003_F004(P001,P002,P003,P004,v)   --ͻ׽ʽԪ
            select v_date,P002, 2010002,v_p001,nvl(a.A004,0)
              from T_DB_B3_04 a where a.P001=v_p001 and a.P002=v_p002;
       insert into T_B003_F004(P001,P002,P003,P004,v)   --ĩָй֤ȯֵԪ
            select v_date,P002, 2010003,v_p001,nvl(a.A005,0)
              from T_DB_B3_04 a where a.P001=v_p001 and a.P002=v_p002;
       fetch cur_project into v_p001,v_p002;
       end loop;
       close cur_project;

      update krcs.t_sys_t012 set A007=1010001 where P001=120505004 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
      SELECT 'ݱתID120505004'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120505004;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
              rollback;
              update krcs.t_sys_t012 set A007=1010002 where P001=120505004 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
              errcode := 0;
              errmsg := 'ڴ洢cisp_convert_DT_120505004';
              return;

end cisp_convert_dt_120505004;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120505005
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120505005(
       errcode out int,       ---ش
       errmsg out varchar2,   ---Ϣ
       v_KJAXUSER varchar2,v_TASK varchar2    ---û
       ) is
       v_date int;            ---
       v_p001 number;         ---ӪҵID
       v_p002 number;         ---ĿID
       v_temp varchar(256);

       cursor cur_project is ---ӪҵID,ĿID
       select P001,P002 from T_DB_B3_05
        where p001 in  (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);

begin
      errcode := 1;
      errmsg := 'תݱɹ';
  /*Ӫҵ˻䶯תʵ
   */

       select P001 into v_date from T_B00_D004 where C001=1001101 and A002=1013001; ----õǰ

       delete T_B003_F005 where p001=v_date
          and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER);     --ɾʵ

        open  cur_project;
       fetch cur_project into v_p001,v_p002;
       while cur_project%found
        loop
       insert into T_B003_F005(P001,P002,P003,P004,v)   --
            select v_date,P002, 2012001,v_p001,nvl(a.A003,0)
              from T_DB_B3_05 a where a.P001=v_p001 and a.P002=v_p002;

       insert into T_B003_F005(P001,P002,P003,P004,v)   --ڹ淶
            select v_date,P002, 2012002,v_p001,nvl(a.A004,0)
              from T_DB_B3_05 a where a.P001=v_p001 and a.P002=v_p002;

       insert into T_B003_F005(P001,P002,P003,P004,v)   --ڼ/ָף
            select v_date,P002, 2012003,v_p001,nvl(a.A005,0)
              from T_DB_B3_05 a where a.P001=v_p001 and a.P002=v_p002;

       insert into T_B003_F005(P001,P002,P003,P004,v)   --ע
            select v_date,P002, 2012004,v_p001,nvl(a.A006,0)
              from T_DB_B3_05 a where a.P001=v_p001 and a.P002=v_p002;
       fetch cur_project into v_p001,v_p002;
       end loop;
       close cur_project;

      update krcs.t_sys_t012 set A007=1010001 where P001=120505005 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
      SELECT 'ݱתID120505005'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120505005;/*ݱת־*/
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
              rollback;
              update krcs.t_sys_t012 set A007=1010002 where P001=120505005 and a004=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
              errcode := 0;
              errmsg := 'ڴ洢cisp_convert_DT_120505005';
              return;

end cisp_convert_dt_120505005;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120506001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_120506001(
      /*Ӫҵ֤ȯת */
      errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      V_DATE int;
      V_TEMP varchar(256);
      V_ORGANID NUMERIC;
      v_HL1 number(19,5);--$
      v_HL2 number(19,5);--hk$ 

      v_E01 number;--֤ȯױڽ B
      v_E02 number;--֤ȯױڽ hkB
      v_E03 number;--֤ȯۼƽ B
      v_E04 number;--֤ȯۼƽ hkB
      v_E05 number;--ѱ B
      v_E06 number;--ѱ hkB
      v_E07 number;--ۼ B
      v_E08 number;--ۼ hkB
      v_E09 number;--ĩָй֤ȯֵ B
      v_E10 number;--ĩָй֤ȯֵ hkB

      v_EP101 number;--֤ȯױڽ BRMB
      v_EP102 number;--֤ȯױڽ hkBRMB
      /*v_EP103 number;--֤ȯۼƽ BRMB
      v_EP104 number;--֤ȯۼƽ hkBRMB*/
      v_EP105 number;--ѱ BRMB
      v_EP106 number;--ѱ hkBRMB
      /*v_EP107 number;--ۼ BRMB
      v_EP108 number;--ۼ hkBRMB*/
      v_EP109 number;--ĩָй֤ȯֵ BRMB
      v_EP110 number;--ĩָй֤ȯֵ hkBRMB
      v_EPP01 number;--B ֤ȯױڽ
      v_EPP02 number;--B ֤ȯۼƽ
      v_EPP03 number;--B ѱ
      v_EPP04 number;--B ۼ
      v_EPP05 number;--B ĩָй֤ȯֵ
      v_count1 integer;
      v_count2 integer;

  begin
      errcode := 1;
      errmsg := 'תݱɹ';
      select P001 into V_DATE from T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

       select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;

      select nvl(sum(a002),0) into v_HL1 from t_bks_t007 ;--$
      select nvl(sum(a003),0) into v_HL2 from t_bks_t007 ;--hk$ 
      --B
      select count(*) into v_count1 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1002;--֤ȯױڽ B
      if v_count1 > 0 then
        select nvl(sum(A003),0) into v_E01 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1002;--֤ȯױڽ B

        select nvl(A004,0) into v_E03 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1002;--֤ȯڱۼƽ B

        select nvl(A005,0) into v_E05 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1002;--ѱ B(ң

        select nvl(A006,0) into v_E07 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1002;--ڱۼ B

        select nvl(sum(A007),0) into v_E09 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1002;--ĩָй֤ȯֵ B

      end if;
      select count(*) into v_count2 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1003;--֤ȯױڽ B
      if v_count2 > 0 then

        select nvl(sum(A003),0) into v_E02 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1003;--֤ȯױڽ hkB

        select nvl(A004,0) into v_E04 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1003;--֤ȯڱۼƽ hkB

        select nvl(A005,0) into v_E06 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1003;--ѱ hkB(ң

        select nvl(A006,0) into v_E08 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1003;--ڱۼ hkB

        select nvl(sum(A007),0) into v_E10 from T_DB_B4_01 where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and P002=1003;--ĩָй֤ȯֵ hkB
      end if;

      v_EP101:=round(nvl(v_E01*v_HL1,0),2);--֤ȯױڽ BRMB
      v_EP102:=round(nvl(v_E02*v_HL2,0),2);--֤ȯױڽ hkBRMB

      /*
      v_EP105:=round(nvl(v_E05*v_HL1,0),2);--ѱ BRMB
      v_EP106:=round(nvl(v_E06*v_HL2,0),2);--ѱ hkBRMB
      */

      --BBΪԭ add wull
      v_EP105:=round(nvl(v_E05*v_HL1,0),2);--ѱ BRMB
      v_EP106:=round(nvl(v_E06*v_HL2,0),2);--ѱ hkBRMB
      --end

      v_EP109:=round(nvl(v_E09*v_HL1,0),2);--ĩָй֤ȯֵ BRMB
      v_EP110:=round(nvl(v_E10*v_HL2,0),2);--ĩָй֤ȯֵ hkBRMB

      v_EPP01:=v_EP101+v_EP102;                  --B ֤ȯױڽ
      v_EPP02:=v_E03+v_E04+v_EP101+v_EP102;      --B ֤ȯױۼƽ

      --Ϻ֤ȯʽ뻦BBΪ delete wull
      /*
        v_EPP03:=v_E05+v_E06;      --B ѱ
        v_EPP04:=v_E07+v_E08+v_E05+v_E06;      --B ѱۼ
      */
      --뻦BBΪԭҵĴʽ  add wull
        v_EPP03:=v_EP105+v_EP106;      --B ѱ
        v_EPP04:=v_E07+v_E08+v_EP105+v_EP106;      --B ѱۼ
      --end

      v_EPP05:=v_EP109+v_EP110;      --B ĩָй֤ȯֵ

     ---ɾ֤ȯάȱT_B004_F001
     delete from T_B004_F001 where P001=V_DATE and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and p002 not in(1012,1016);

     --B, ϼĸ
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE, P002,2005001, A003,P001
            from T_DB_B4_01
            where P002 !=1002 and P002 !=1003 and
                  P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE, P002, 2005002, nvl(A003,0)+nvl(A004,0),P001
            from T_DB_B4_01
            where P002 !=1002 and P002 !=1003 and
                  P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE, P002, 2005003, A005,P001
            from T_DB_B4_01
            where P002 !=1002 and P002 !=1003 and
                  P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE, P002, 2005004, nvl(A005,0)+nvl(A006,0),P001
            from T_DB_B4_01
            where P002 !=1002 and P002 !=1003 and
                  P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE, P002, 2005005, A007,P001
            from T_DB_B4_01
            where P002 !=1002 and P002 !=1003 and
                  P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

     --Brmb

     --ϺBrmb(ڽ׽)
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1014,2005001,v_EP101,V_ORGANID
            from dual;

     --ϺBrmb(ۼƽ׽)
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1014,2005002,v_EP101+v_E03,V_ORGANID
             from dual;
     --ϺBrmb()
     --Ϻ֤ȯʽBΪ delete wull
     /*insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1014,2005003,v_E05,V_ORGANID
            from dual;
      */
     --BΪԭҴʽ  add wull
      insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1014,2005003,v_EP105,V_ORGANID
            from dual;
     --end

     --ϺBrmb(ۼ)
     --Ϻ֤ȯʽBΪ  delete wull
     /*insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1014,2005004,v_E05+v_E07,V_ORGANID
            from dual;
            */
     --BΪԭҴʽ  add wull
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1014,2005004,v_EP105+v_E07,V_ORGANID
            from dual;
     --end

      --ϺBrmb(ָйֵ)
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1014,2005005,v_EP109,V_ORGANID
            from dual;


     --Brmb
     --Brmb(ڽ׽)
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1015,2005001,v_EP102,V_ORGANID
            from dual;
     --Brmb(ۼƽ׽)
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1015,2005002,v_EP102+v_E04,V_ORGANID
             from dual;

     --Brmb()
     --Ϻ֤ȯʽBΪ  delete wull
     /*insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1015,2005003,v_E06,V_ORGANID
             from dual;*/
     --BΪԭҴʽ   add wull
      insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1015,2005003,v_EP106,V_ORGANID
             from dual;
     --end

      --Brmb(ۼ)
     --Ϻ֤ȯʽBΪ   delete wull
     /*insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1015,2005004,v_E06+v_E08,V_ORGANID
           from dual;*/
     --BΪԭҴʽ    add wull
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1015,2005004,v_EP106+v_E08,V_ORGANID
           from dual;
     --end

      --Brmb(ָйֵ)
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1015,2005005,v_EP110,V_ORGANID
             from dual;







     --Bңڽ׽
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1004,2005001, v_EPP01,V_ORGANID
            from dual;
     --Bңۼƽ׽
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1004,2005002,v_EPP02,V_ORGANID
             from dual;
    --Bң룩
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE, 1004, 2005003, v_EPP03,V_ORGANID
            from dual;
    --Bңۼ룩
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1004,2005004,v_EPP04,V_ORGANID
            from dual;
     --Bңָйֵ
     insert into T_B004_F001(P001, P002, P003, V, P004)
          select V_DATE,1004,2005005,v_EPP05,V_ORGANID
             from dual;

      --ϼ
      --֤ȯױڽϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE,1011,2005001,V_ORGANID,sum(v)
           from  T_B004_F001
           where p004=V_ORGANID and p003= 2005001 and p002 not in (1002,1003,1014,1015,1012,1016) and p001=V_DATE;
      --֤ȯױۼƽϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE,1011,2005002,V_ORGANID,sum(v)
           from  T_B004_F001
           where p004=V_ORGANID and p003= 2005002 and p002 not in (1002,1003,1014,1015,1012,1016) and p001=V_DATE;
      --֤ȯۼƽϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE,1011,2005003,V_ORGANID,sum(v)
           from  T_B004_F001
           where p004=V_ORGANID and p003= 2005003 and p002 not in (1002,1003,1014,1015,1012,1016) and p001=V_DATE;
      --ѱۼϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE,1011,2005004,V_ORGANID,sum(v)
           from  T_B004_F001
           where p004=V_ORGANID and p003= 2005004 and p002 not in (1002,1003,1014,1015,1012,1016) and p001=V_DATE;

      --ĩָй֤ȯֵϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE,1011,2005005,V_ORGANID,sum(v)
           from  T_B004_F001
           where p004=V_ORGANID and p003= 2005005 and p002 not in (1002,1003,1014,1015,1009,1010) and p001=V_DATE;
      --ϼ
      --֤ȯױڽϼ
      /*insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE,1011,2005001,P001,
                  (select nvl(sum(A003),0)+v_EPP01
                  from T_DB_B4_01
                  where P002 in (1001,1005,1006,1007,1008,1009,1010)
                    and  P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER))
            from T_DB_B4_01
            where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) ;
      --֤ȯۼƽϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE, 1011, 2005002,P001,
                  (select nvl(sum(A003+A004),0)+v_EPP02
                  from T_DB_B4_01
                  where P002 in (1001,1005,1006,1007,1008,1009,1010)
                    and P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER))
            from T_DB_B4_01
          ѱϼ  where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);
      --ѱϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE, 1011, 2005003,P001,
                  (select nvl(sum(A005),0)+v_EPP03
                  from T_DB_B4_01
                  where P002 in (1001,1005,1006,1007,1008,1009,1010)
                    and P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER))
            from T_DB_B4_01
            where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) ;
      --ۼϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE, 1011, 2005004,P001,
                  (select nvl(sum(A005+A006),0)+v_EPP04
                  from T_DB_B4_01
                  where P002 in (1001,1005,1006,1007,1008,1009,1010)
                    and  P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER))
            from T_DB_B4_01
            where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) ;
      --ĩָй֤ȯֵϼ
      insert into T_B004_F001(P001, P002, P003,P004, V)
           select V_DATE, 1011, 2005005,P001,
                  (select nvl(sum(A007),0)+v_EPP05
                  from T_DB_B4_01
                  where P002 in (1001,1005,1006,1007,1008)
                    and P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER))
            from T_DB_B4_01
            where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER) ; */

      update krcs.t_sys_t012 set A007 = 1010001 where P001 = 120506001 and a004=V_ORGANID; /*޸ת״̬ */
      select 'ݱתID120506001' || A002 || ''
        into V_TEMP
        from krcs.T_SYS_T011
       where P001 = 120506001; /*ݱת־*/
      insert into krcs.T_SYS_LOG(P001, P002, A003)
           values (v_KJAXUSER, sysdate, V_TEMP);
      commit;
     exception
        when others then
          rollback;
          update krcs.t_sys_t012 set A007 = 1010002 where P001 = 120506001 and a004=V_ORGANID;
          errcode := 0;
          errmsg  := 'ڴ洢cisp_convert_DT_120506001';
          return;
end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120506002
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_120506002(
/*Ӫҵ֤ȯ(ݱ)תת
*/
  errcode    out int, --ش
  errmsg     out varchar2, --Ϣ
  v_KJAXUSER varchar2,v_TASK varchar2 --û
 )
 is
  V_DATE int; --
  V_TEMP varchar(256);  --¼־
  V_COUNT integer;  --ݱ401δ˵ļ¼
  v_my number(19,5);  --Ԫ
  v_gb number(19,5);  --۱һ
begin
   errcode := 1;
   errmsg := 'תݱɹ!!';

   select nvl(sum(a002),0) into v_my from t_bks_t007 ;--$
   select nvl(sum(a003),0) into v_gb from t_bks_t007 ;--hk$ 



  select P001
    into V_DATE
    from T_B00_D004
   where C001 = 1001101
     and A002 = 1013001; ----õǰ

 /*** ɾʵ(֤ȯײάȱT_B004_F002)***/

  delete from T_B004_F002 where P001=V_date
     and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

  insert into T_B004_F002(P001, P002, P003, V, P004) --ڽ׽
          select V_DATE, P002, 2011001,nvl((nvl(A003,0) + nvl(A004,0)*v_gb + nvl(A005,0)*v_my),0),P001
            from T_DB_B4_02
            where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);
  insert into T_B004_F002(P001, P002, P003, V, P004) --ۼƽ
          select V_DATE, P002, 2011002,nvl((nvl(A003,0) + nvl(A004,0)*v_gb + nvl(A005,0)*v_my + nvl(A006,0) + nvl(A007,0) + nvl(A008,0)),0),P001
            from T_DB_B4_02
            where P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

  update krcs.t_sys_t012 set A007 = 1010001 where P001 = 120506002 and a004 =(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
  select 'ݱתID120506002' || A002 || ''
    into V_TEMP
    from krcs.T_SYS_T011
   where P001 = 120506002; /*ݱת־*/
  insert into krcs.T_SYS_LOG(P001, P002, A003)
       values (v_KJAXUSER, sysdate, V_TEMP);
  commit;
  exception
    when others then
      rollback;
      update krcs.t_sys_t012 set A007 = 1010002 where P001 = 120506002 and a004 =(select P002 from krcs.t_sys_user where P001=v_KJAXUSER); /*޸ת״̬ */
      errcode := 0;
      errmsg  := 'ڴ洢cisp_convert_DT_120506002';
      return;
end;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120506003
prompt ============================================
prompt
create or replace procedure cisp_convert_dt_120506003(

   errcode out int,
   errmsg out varchar2,
   v_KJAXUSER varchar2,v_TASK varchar2)
is
   V_TEMP varchar(256);
   v_date int;
   V_ORGANID NUMERIC;
   v_EE001 number(19,2);
   v_EE002 number(19,2);
   v_EE003 number(19,2);
   v_EE004 number(19,2);
   v_EE005 number(19,2);
   v_EE006 number(19,2);
   v_EE007 number(19,2);
   v_EE008 number(19,2);
   v_EE009 number(19,2);
   v_EE010 number(19,2);
   v_EE011 number(19,2);
   v_EE012 number(19,2);
   v_EE013 number(19,2);
   v_EE014 number(19,2);
   v_EE015 number(19,2);
   v_EE016 number(19,2);
   v_EE017 number(19,2);
   v_EE018 number(19,2);
   v_EE019 number(19,2);
   v_EE020 number(19,2);
   v_EE021 number(19,2);
   v_EE022 number(19,2);
   v_EE023 number(19,2);
   v_EE024 number(19,2);
   v_EE025 number(19,2);
   v_EE026 number(19,2);
   v_EE027 number(19,2);
   v_EE028 number(19,2);
   v_EE029 number(19,2);
   v_EE030 number(19,2);
   v_EE031 number(19,2);
   v_EE032 number(19,2);
   v_EE033 number(19,2);
   v_EE034 number(19,2);
   v_EE035 number(19,2);
   v_EE036 number(19,2);
   v_EE037 number(19,2);
   v_EE038 number(19,2);
   v_EE039 number(19,2);
   v_EE040 number(19,2);

   v_HL1 number(19,5);
   v_HL2 number(19,5);


begin
   errcode := 1;
   errmsg := 'תݱɹ';

   select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */

   select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;
    ---ɾ֤ȯάȱT_B004_F001
    delete from T_B004_F001
    where P001=V_DATE and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER) and p002 in(1012,1016);

    select nvl(sum(a002),0) into v_HL1 from t_bks_t007;  --my
    select nvl(sum(a003),0) into v_HL2 from t_bks_t007;  --gb

    --ֳףڽ׽
    select nvl(sum(a003),0) into v_EE001 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --rmb
    select nvl(sum(a004),0) into v_EE002 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --my
    v_EE003:=nvl(v_EE002*v_HL1,0);  --my
    select nvl(sum(a005),0) into v_EE004 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --gb
    v_EE005:=nvl(v_EE004*v_HL2,0);  --gb

    v_EE006:=v_EE001+v_EE003+v_EE005; --ֳױ֤ȯ׽

    --ֳףۼƽ׽
    select nvl(sum(a006),0) into v_EE007 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --rmb
    select nvl(sum(a007),0) into v_EE008 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --my()
    select nvl(sum(a008),0) into v_EE009 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --gb()

    v_EE010:=v_EE001+v_EE003+v_EE005+v_EE007+v_EE008+v_EE009; --ֳױۼƽ׽


    --ֳף
    select nvl(sum(a009),0) into v_EE011 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --rmb
    select nvl(sum(a010),0) into v_EE012 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --my
    v_EE013:=nvl(v_EE012*v_HL1,0);  --my
    select nvl(sum(a011),0) into v_EE014 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --gb
    v_EE015:=nvl(v_EE014*v_HL2,0);  --gb

    v_EE016:=v_EE011+v_EE013+v_EE015; --ֳױ

    --ֳףۼ
    select nvl(sum(a012),0) into v_EE017 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --rmb
    select nvl(sum(a013),0) into v_EE018 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --my()
    select nvl(sum(a014),0) into v_EE019 from t_db_b4_03 where p001=V_ORGANID and p002=1016; --gb()

    v_EE020:=v_EE011+v_EE013+v_EE015+v_EE017+v_EE018+v_EE019; --ֳױۼ





     --Ͻףڽ׽
    select nvl(sum(a003),0) into v_EE021 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --rmb
    select nvl(sum(a004),0) into v_EE022 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --my
    v_EE023:=nvl(v_EE022*v_HL1,0);  --my
    select nvl(sum(a005),0) into v_EE024 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --gb
    v_EE025:=nvl(v_EE024*v_HL2,0) ; --gb

    v_EE026:=v_EE021+v_EE023+v_EE025; --Ͻױ֤ȯ׽

    --Ͻףۼƽ׽
    select nvl(sum(a006),0) into v_EE027 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --rmb
    select nvl(sum(a007),0) into v_EE028 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --my()
    select nvl(sum(a008),0) into v_EE029 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --gb()

    v_EE030:=v_EE021+v_EE023+v_EE025+v_EE027+v_EE028+v_EE029; --Ͻױۼƽ׽


    --Ͻף
    select nvl(sum(a009),0) into v_EE031 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --rmb
    select nvl(sum(a010),0) into v_EE032 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --my
    v_EE033:=nvl(v_EE032*v_HL1,0) ; --my
    select nvl(sum(a011),0) into v_EE034 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --gb
    v_EE035:=nvl(v_EE034*v_HL2,0) ; --gb

    v_EE036:=v_EE031+v_EE033+v_EE035; --Ͻױ֤ȯ׽

    --Ͻףۼ
    select nvl(sum(a012),0) into v_EE037 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --rmb
    select nvl(sum(a013),0) into v_EE038 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --my()
    select nvl(sum(a014),0) into v_EE039 from t_db_b4_03 where p001=V_ORGANID and p002=1012; --gb()

    v_EE040:=v_EE031+v_EE033+v_EE035+v_EE037+v_EE038+v_EE039; --Ͻױۼƽ׽

    --ֳױڽ׽
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1016,2005001,v_EE006,V_ORGANID
           from dual;

    --ֳױۼƽ׽
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1016,2005002,v_EE010,V_ORGANID
           from dual;

    --ֳױ
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1016,2005003,v_EE016,V_ORGANID
           from dual;

    --ֳױۼ
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1016,2005004,v_EE020,V_ORGANID
           from dual;

     --Ͻױڽ׽
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1012,2005001,v_EE026,V_ORGANID
           from dual;

    --Ͻױۼƽ׽
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1012,2005002,v_EE030,V_ORGANID
           from dual;

    --Ͻױ
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1012,2005003,v_EE036,V_ORGANID
           from dual;

    --Ͻױۼ
    insert into T_B004_F001(P001, P002, P003, V, P004)
           select v_date,1012,2005004,v_EE040,V_ORGANID
           from dual;

    update krcs.t_sys_t012 set A007 = 1010001 where P001 in(120506003,120506004,120506005) and a004 =V_ORGANID; /*޸ת״̬ */
      select 'ݱתID120506003' || A002 || ''
        into V_TEMP
        from krcs.T_SYS_T011
       where P001 = 120506003; /*ݱת־*/
      insert into krcs.T_SYS_LOG(P001, P002, A003)
           values (v_KJAXUSER, sysdate, V_TEMP);
      commit;
     exception
        when others then
          rollback;
          update krcs.t_sys_t012 set A007 = 1010002 where P001 in(120506003,120506004,120506005) and a004 =V_ORGANID;
          errcode := 0;
          errmsg  := 'ڴ洢cisp_convert_DT_120506003';
          return;

end cisp_convert_dt_120506003;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_120507001
prompt ============================================
prompt
create or replace procedure CISP_CONVERT_DT_120507001(
       /*Ӫҵ۲Ʒתʵ
       */
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2)
is
       v_date int;
       v_temp varchar(256);
       /*v_status integer;*/
       v_user integer;
       /*v_data1 number;
       v_data2 number;
       v_data3 number;
       v_data4 number;
       v_data5 number;
       v_data6 number;
       v_data7 number;
       v_data8 number;
       v_count integer;*/
begin
       errcode := 1;
       errmsg := 'תݱɹ';

       SELECT P002 into v_user FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;



      select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001; /* õǰ */
      delete T_B050_F001 where p001=v_date and p004=v_user;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1001,a003,p001
           from T_DB_B50_01
           where P001 =v_user ;

      insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1002,a004,p001
           from T_DB_B50_01
           where P001 =v_user ;

      insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1003,nvl(a005,0)/*+nvl(a003,0)*/,p001
           from T_DB_B50_01
           where P001 =v_user ;

      insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1004,nvl(a006,0)+nvl(a004,0),p001
           from T_DB_B50_01
           where P001 =v_user ;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1005,a007,p001
           from T_DB_B50_01
           where P001 =v_user ;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1006,a008,p001
           from T_DB_B50_01
           where P001 =v_user ;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1007,nvl(a009,0)/*+nvl(a007,0)*/,p001
           from T_DB_B50_01
           where P001 =v_user ;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1008,nvl(a010,0)+nvl(a008,0),p001
           from T_DB_B50_01
           where P001 =v_user ;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1009,a011,p001
           from T_DB_B50_01
           where P001 =v_user ;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,p002,1010,a012,p001
           from T_DB_B50_01
           where P001 =v_user ;



        -- (һ)ͷࣺϼ
      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1001,sum(a003),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1002,sum(a004),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1003,sum(nvl(a005,0)/*+nvl(a003,0)*/),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1004,sum(nvl(a006,0)+nvl(a004,0)),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1005,sum(a007),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1006,sum(a008),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1007,sum(nvl(a009,0)/*+nvl(a007,0)*/),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1008,sum(nvl(a010,0)+nvl(a008,0)),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1009,sum(a011),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1090,1010,sum(a012),p001
           from T_DB_b50_01
           where p002 in (1010,1020,1050,1060,1070,1080)
           and p001 =v_user group by p001;
        --  ࣺϼ
      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1001,sum(a003),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1002,sum(a004),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1003,sum(nvl(a005,0)/*+nvl(a003,0)*/),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1004,sum(nvl(a006,0)+nvl(a004,0)),v_user
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1005,sum(a007),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1006,sum(a008),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1007,sum(nvl(a009,0)/*+nvl(a007,0)*/),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1008,sum(nvl(a010,0)+nvl(a008,0)),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1009,sum(a011),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1140,1010,sum(a012),p001
           from T_DB_b50_01
           where p002 in (1100,1110,1120,1130)
           and p001 =v_user group by p001;

       --   ۷ʽࣺϼ
      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1001,sum(a003),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 =v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1002,sum(a004),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1003,sum(nvl(a005,0)/*+nvl(a003,0)*/),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1004,sum(nvl(a006,0)+nvl(a004,0)),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1005,sum(a007),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1006,sum(a008),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1007,sum(nvl(a009,0)/*+nvl(a007,0)*/),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1008,sum(nvl(a010,0)+nvl(a008,0)),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1009,sum(a011),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,p004)
           select v_date,1200,1010,sum(a012),p001
           from T_DB_b50_01
           where p002 in (1170,1180,1190)
           and p001 = v_user group by p001;

       --    ģͷࣺϼ
      insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1001,sum(a003),p001
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1002,sum(a004),p001
           from T_DB_b50_01
           where p002 in (1210,1220)
           and P001 = v_user group by p001;

      insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1003,sum(nvl(a005,0)/*+nvl(a003,0)*/),p001
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1004,sum(nvl(a006,0)+nvl(a004,0)),p001
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1005,sum(a007),p001
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1006,sum(a008),v_user
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1007,sum(nvl(a009,0)/*+nvl(a007,0)*/),p001
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1008,sum(nvl(a010,0)+nvl(a008,0)),v_user
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1009,sum(a011),p001
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       insert into T_B050_F001(P001,P002,P003,V,P004)
           select v_date,1230,1010,sum(a012),v_user
           from T_DB_b50_01
           where p002 in  (1210,1220)
           and P001 = v_user group by p001;

       update krcs.t_sys_t012 set A007=1010001 where P001=120507001 and a004 =v_user; /*޸ת״̬ */
      SELECT 'ݱתID120507001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 120507001;
      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t012 set A007=1010002 where P001 = 120507001 and a004 =v_user ; /*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_120507001!';
                return;
end CISP_CONVERT_DT_120507001;
/

prompt
prompt Creating procedure CISP_CONVERT_DT_121002001
prompt ============================================
prompt
create or replace procedure cisp_convert_DT_121002001(errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2)  is
      v_date int;
      v_bmid number;
      v_temp varchar(256);
  begin
      errcode := 1;
      errmsg := 'תݱɹ';

      select max(P001) into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001 ; /* õǰ */
      select P002 into v_bmid from krcs.t_sys_user where P001=v_KJAXUSER;

      delete from T_B01_DACT_B_R001
      where p001=v_date
      and P004 = (select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

      insert into T_B01_DACT_B_R001(P001,  P002,  P003,  V,  P004)
             select v_date,b.p002,1001,b.a002,b.p001 from T_DACT_B_R001 b
             where b.P001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

      insert into T_B01_DACT_B_R001(P001,  P002,  P003,  V, P004)
             select v_date,b.p002,1002,b.a003,b.p001 from T_DACT_B_R001 b
             where b.p001=(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

      delete from T_B01_DACT_B_R001 t
      where t.p001 = v_date
        and t.p002 in (1009,1010, 1011, 1012, 1013, 1014)
        and t.p003 = 1002;

      update krcs.t_sys_t012 set A007 = 1010001 where P001 = 121002001 and a004 =(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);

      SELECT 'ݱתID121002001'||A002||'' INTO v_temp FROM krcs.T_SYS_T011 WHERE P001 = 121002001;

      INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
      commit;
      exception when others then
                rollback;
                update krcs.t_sys_t012 set A007 = 1010002 where P001 = 121002001 and a004 =(select P002 from krcs.t_sys_user where P001=v_KJAXUSER);
                errcode := 0;
                errmsg := 'ڴ洢cisp_convert_DT_121002001!';
                return;
 end;
/

prompt
prompt Creating procedure CISP_DEL_B04_T011
prompt ====================================
prompt
create or replace procedure cisp_del_B04_t011(
errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer)
    is
     v_orgid number;
     v_bmid number;


begin
    errcode:=1;
    errmsg:='ɾɹ';
  SELECT P002 into v_orgid FROM krcs.T_SYS_USER WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID
  delete from cisp.t_b04_t011
  where P001=v_P001 and a100 = v_orgid ;

  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ҵ̨ IDT003ɾʲ
ƷƷID<font color=red>'||v_P001||'</font>',v_task);

end;
/

prompt
prompt Creating procedure CISP_DEL_B05T001
prompt ===================================
prompt
create or replace procedure cisp_del_B05T001(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int
) is
orgid int;

begin
     select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
     delete from cisp.t_b05_t001 where p001=v_p001 and A100=orgid;
     insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾרʲƷ ID:['||v_p001||']',v_task);
     errcode := 1;
     errmsg := 'ɾɹ!';
end cisp_del_B05T001;
/

prompt
prompt Creating procedure CISP_DEL_B06_T011
prompt ====================================
prompt
create or replace procedure cisp_del_B06_T011(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int
) is
begin
  delete from cisp.t_b06_t011 where p001=v_p001 and A100=(select p002 from krcs.t_sys_user where p001=kjaxuser);
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾʲƷ ID:['||v_p001||']',V_TASK);
  errcode := 1;
  errmsg := 'ɾɹ!';
end;
/

prompt
prompt Creating procedure CISP_DEL_B08_D002
prompt ====================================
prompt
create or replace procedure cisp_del_b08_d002(
       errcode  out int,
       errmsg   out varchar2,
       kjaxuser  varchar2,
       v_task    varchar2,
       v_p001    int
) is
begin
  delete from cisp.t_b08_d002 where p001=v_p001;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾȯ ID:'||v_p001||']',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end cisp_del_b08_d002;
/

prompt
prompt Creating procedure CISP_DEL_B09_T002
prompt ====================================
prompt
create or replace procedure cisp_del_b09_t002(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int
) is
orgid int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;

  delete from cisp.t_b09_t002 where p001=v_p001 and A100=orgid;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾȨϢ  ID:['||v_p001||']',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end cisp_del_b09_t002;
/

prompt
prompt Creating procedure CISP_DEL_B12_T002
prompt ====================================
prompt
create or replace procedure CISP_del_b12_t002(
                            errcode out int,
                            errmsg out varchar2,
                            kjaxuser varchar2,
                            v_task varchar2,
                            v_p001 varchar2,
                            v_p002 int,
                            v_p003 varchar2
) is
orgid int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  delete from cisp.t_b12_t002 where p001=to_date(v_p001,'yyyy-mm-dd') and p002=v_p002 and p003=v_p003 and A100=orgid;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾĿϸ ID['||v_p002||']',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end CISP_del_b12_t002;
/

prompt
prompt Creating procedure CISP_DEL_BKSB11T001
prompt ======================================
prompt
create or replace procedure cisp_del_BKSB11T001(
       errcode            out int,
       errmsg             out varchar2,
       kjaxuser               varchar2,
       v_task                 varchar2,
       v_p001                 int
) is

       v_orgid int;
begin
       select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
       delete from cisp.t_b11_t001 where p001=v_p001 and A100=v_orgid;

       insert into krcs.t_sys_log(P001,p002,a003,a004)values
       (kjaxuser,sysdate,'ڻмҵȫʻʵʣعڻ˾ɾ:ID['||v_p001||'ɹ!',v_task);

       errcode := 1;
       errmsg := 'ɾɹ!';
end ;
/

prompt
prompt Creating procedure CISP_DEL_BKSB11T003
prompt ======================================
prompt
create or replace procedure cisp_del_BKSB11T003(
       errcode            out int,
       errmsg             out varchar2,
       kjaxuser               varchar2,
       v_task                 varchar2,
       v_p001                 int
) is

       v_orgid int;
begin
       select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
       delete from cisp.t_b11_t003 where p001=v_p001 and A100=v_orgid;

       insert into krcs.t_sys_log(P001,p002,a003,a004)values
       (kjaxuser,sysdate,'ɾṩмҵڻ˾ :ID['||v_p001||'ɹ!',v_task);

       errcode := 1;
       errmsg := 'ɾɹ!';
end ;
/

prompt
prompt Creating procedure CISP_DEL_BKST002
prompt ===================================
prompt
create or replace procedure cisp_DEL_BKST002(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int
) is
begin
  delete from cisp.t_bks_t002 where p001=v_p001 and p002=(select p002 from krcs.t_sys_user where p001=kjaxuser);
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾý ID:['||v_p001||']',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end cisp_DEL_BKST002;
/

prompt
prompt Creating procedure CISP_DEL_BKST003
prompt ===================================
prompt
create or replace procedure cisp_del_BKST003(error_code out int,
                                             errmsg     out varchar2,
                                             kjaxuser   varchar2,
                                             v_task     varchar2,
                                             v_p001     int) is
  v_orgid int;
begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  delete from cisp.t_bks_t006
   where p001 = v_p001
     and A100 = v_orgid;
  insert into krcs.t_sys_log
    (P001, p002, a003, a004)
  values
    (kjaxuser,
     sysdate,
     'ɾϹ ID[' || v_p001 || ']ɹ!',
     v_task);
  error_code := 1;
  errmsg     := 'ɾɹ!';
end cisp_del_BKST003;
/

prompt
prompt Creating procedure CISP_DEL_BKST005
prompt ===================================
prompt
create or replace procedure cisp_del_BKST005(
       error_code out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int
) is
  v_orgid int;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
  delete from cisp.t_bks_t005 where p001=v_p001 and A100=v_orgid;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾĿ ID['||v_p001||']ɹ1',v_task);
  error_code := 1;
  errmsg := 'ɾɹ!';
end cisp_del_BKST005;
/

prompt
prompt Creating procedure CISP_DEL_BKST031
prompt ===================================
prompt
create or replace procedure CISP_DEL_BKST031(
     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     V_TASK     varchar2,
     V_P001     varchar2,

     logP001    varchar2,
     logA002    varchar2)
  is

     V_ORGANID  NUMERIC;
     v_orgid      int;
  begin
       errcode:=1;
       errmsg:='ɾгɹ';

       select a.P002 into V_ORGANID
       from krcs.T_SYS_USER a
       where  a.P001 = V_KJAXUSER;

       select x.w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;

       delete from cisp.T_BKS_T031 where P002=V_P001 and P001=V_ORGANID and A100=v_orgid;

   insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (V_KJAXUSER,sysdate,'ҵ̨ˣID031ɾжӦϵ'||logP001||'<font color=red>' ||logA002 || '</font>',v_task);

  end CISP_DEL_BKST031;
/

prompt
prompt Creating procedure CISP_DEL_BKST033
prompt ===================================
prompt
create or replace procedure cisp_del_bkst033(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int,
       v_p002 varchar2,
       logA002 varchar2

) is
  orgid int;

begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;

    delete from  cisp.t_bks_t033 where p001=v_p001 and p002=v_p002 and A100=orgid;
    insert into krcs.t_sys_log(P001,p002,a003,a004)values(kjaxuser,sysdate,'ɾвƷй˾֤˻:ID['||v_p001||']',v_task);
    errcode := 1;
    errmsg := 'ɾɹ!';
end cisp_del_bkst033;
/

prompt
prompt Creating procedure CISP_DEL_BKST043
prompt ===================================
prompt
create or replace procedure cisp_del_bkst043(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 varchar2
) is
begin
  delete from cisp.t_bks_t043 where p001=v_p001 and A100=(select p002 from krcs.t_sys_user where p001=kjaxuser);
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾʲƷϢ ID['||v_p001||']',v_task);
  errcode :=1;
  errmsg := 'ɾɹ!';
end cisp_del_bkst043;
/

prompt
prompt Creating procedure CISP_DEL_BKST101
prompt ===================================
prompt
create or replace procedure cisp_DEL_BKST101(
          errcode    out int,
          errmsg     out varchar2,
          V_KJAXUSER varchar2,
          V_TASK     varchar2,
          V_P001     integer
)  is
          v_orgid int ;
begin
          errcode:=1;
          errmsg:='ɾɹ';
         select p002 into v_orgid from krcs.t_sys_user where p001 = V_kjaxuser;

         delete from cisp.T_BKS_T101 where p001=V_P001 and A100=v_orgid;
         insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (V_KJAXUSER,sysdate,'ҵ̨ˣɾɹ뽻ⲿϢϵͳ漰˻ɹ ID'||V_P001||'',v_task);
         commit;
  end cisp_DEL_BKST101;
/

prompt
prompt Creating procedure CISP_DEL_BKST102
prompt ===================================
prompt
create or replace procedure cisp_DEL_BKST102(
      errcode    out int,
      errmsg     out varchar2,
      V_KJAXUSER varchar2,
      V_TASK     varchar2,
      V_P001     integer

 )is
      v_orgid int;
  begin
         errcode:=1;
         errmsg:='ɾɹ';
         select p002 into v_orgid from krcs.t_sys_user where p001 = V_kjaxuser;

         delete from cisp.T_BKS_T102 where p001=V_P001 and a100=v_orgid;
         insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (V_KJAXUSER,sysdate,'ҵ̨ˣɾɹ뽻ⲿϢϵͳ漰˻ϸɹ ID'||V_P001||'',v_task);
         commit;
end cisp_DEL_BKST102;
/

prompt
prompt Creating procedure CISP_DEL_BKSZYRHHY
prompt =====================================
prompt
create or replace procedure cisp_DEL_BKSZYRHHY(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int
) is
begin
  delete from cisp.T_BKS_ZYRHHY where p001=v_p001 and a100=(select p002 from krcs.t_sys_user where p001=kjaxuser);
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ɾڻԼ̨ ID:['||v_p001||']',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end cisp_DEL_BKSZYRHHY;
/

prompt
prompt Creating procedure CISP_DEL_BKS_T016
prompt ====================================
prompt
create or replace procedure CISP_DEL_BKS_T016(errcode    out int,
                                              errmsg     out varchar2,
                                              v_KJAXUSER varchar2,
                                              v_TASK     varchar2,
                                              VP001      varchar2,
                                              VA003      numeric) is
  V_A003 numeric;
  V_A004 numeric;
  V_ORG  number;
begin
  errcode := 1;
  errmsg  := 'ɾɹ';
  V_A003  := substr(VA003, 4, 7);
  V_A004  := substr(VA003, 1, 3);

  select p002 into V_ORG from krcs.t_sys_user where p001 = v_KJAXUSER;

  delete from T_BKS_T016
   where P001 = VP001
     and A003 = V_A003
     and A004 = V_A004
     and A100 = V_ORG;
  --ͨƱͬɾT_BKS_T019
  if VA003 = '1001012' or VA003 = '1001017' then
    delete from t_bks_t019 where P001 = VP001 and A100 = V_ORG;
  end if;

  insert into KRCS.T_SYS_LOG
    (P001, P002, A003 ,A004)
  values
    (v_KJAXUSER,
     sysdate,
     '֤ȯϢIDBKS_T016ɾ֤ȯϢ--ɱࣻ룺<font color=red>' ||
     VP001 || '</font>',
     v_TASK);

exception
  when others then
    errcode := 0;
    errmsg  := '洢̷';
    return;
end;
/

prompt
prompt Creating procedure CISP_DEL_BKS_T019
prompt ====================================
prompt
create or replace procedure CISP_DEL_BKS_T019(errcode    out int,
                                              errmsg     out varchar2,
                                              v_KJAXUSER varchar2,
                                              v_TASK     varchar2,
                                              VP001      varchar2,
                                              VA003      numeric) is
  V_A003 numeric;
  V_A004 numeric;
  V_ORG  number;
begin
  errcode := 1;
  errmsg  := 'ɾɹ';
  V_A003  := substr(VA003, 4, 7);
  V_A004  := substr(VA003, 1, 3);

  select p002 into V_ORG from krcs.t_sys_user where p001 = v_KJAXUSER;

  delete from T_BKS_T016
   where P001 = VP001
     and A003 = V_A003
     and A004 = V_A004
     and A100 = V_ORG;
  delete from T_BKS_T019 where P001 = VP001 and A100 = V_ORG;
  insert into KRCS.T_SYS_LOG
    (P001, P002, A003 ,A004)
  values
    (v_KJAXUSER,
     sysdate,
     '֤ȯϢIDBKS_T019ɾ֤ȯϢ--ɱࣻ룺<font color=red>' ||
     VP001 || '</font>',
     v_TASK);

exception
  when others then
    errcode := 0;
    errmsg  := '洢̷';
    return;
end;
/

prompt
prompt Creating procedure CISP_DEL_DT_112007001
prompt ========================================
prompt
create or replace procedure cisp_del_DT_112007001(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_task     varchar2,
                                             v_p001     int) is
begin
  delete from cisp.T_DB_04_007
   where P001 = v_P001
     AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);

 insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ ֤ȯͶҵ񣨹ָڻͶʣID: 112007001',v_task);
 errcode := 1;
 errmsg := 'ɾɹ!';
end;
/

prompt
prompt Creating procedure CISP_DEL_DT_112008001
prompt ========================================
prompt
create or replace procedure cisp_del_DT_112008001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2)
    is
begin
    errcode:=1;
    errmsg:='ɾɹ';
  delete from cisp.T_DB_05_101
  where P001=v_P001
  AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
  and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ ʲҵ--ĩͻ ID:112008001',v_task);
  commit;


end;
/

prompt
prompt Creating procedure CISP_DEL_DT_112008002
prompt ========================================
prompt
create or replace procedure cisp_del_DT_112008002(
errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task    varchar2,
    v_P001 varchar2)
    is
begin
    errcode:=1;
    errmsg:='ɾɹ';
  delete from T_DB_05_102
  where P001=v_P001
  AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
  and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
  commit;

  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112008002ɾʲҵ201301£ʽ',v_Task);

end;
/

prompt
prompt Creating procedure CISP_DEL_DT_112008003
prompt ========================================
prompt
create or replace procedure cisp_del_DT_112008003(errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 varchar2)
    is
begin
    errcode:=1;
    errmsg:='ɾɹ';
  delete from cisp.T_DB_05_103
  where P001=v_P001
  AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
  and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
  commit;

  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112008003ɾʲҵ-ֵ',v_task);

end;
/

prompt
prompt Creating procedure CISP_DEL_DT_113002001
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113002001(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_Task     varchar2,
                                             v_p001     varchar2,
                                             v_A002     int) is
begin
  delete from cisp.T_DB_04_001
   where A010 = 100
     AND A002 not in (1012, 1017)
     AND A002 = V_A002
     AND P001 = V_P001
     AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);

    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ ֤ȯͶҵ-ͨ ID: 113002001',v_task);
    errcode := 1;
    errmsg := 'ɾɹ!';
end ;
/

prompt
prompt Creating procedure CISP_DEL_DT_113002002
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113002002(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_task     varchar2,
                                             v_p001     varchar2,
                                             v_A002     int) is
begin

  delete from cisp.T_DB_04_001
   where A010 = 100
     AND A002 in (1012, 1017)
     AND A002 = V_A002
     AND P001 = V_P001
     AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);

  insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ֤ȯͶҵ-ͨ ID:113002002',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';

end ;
/

prompt
prompt Creating procedure CISP_DEL_DT_113002003
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113002003(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_task     varchar2,
                                             v_p001     varchar2,
                                             v_A002     int) is
begin
  delete from cisp.T_DB_04_001
   where P001 = V_P001
     AND A002 = V_A002
     AND A010 = 200
     AND A002 = V_A002
     AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);

   insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ ֤ȯͶҵ񣨻 ID:113002003',v_task);
   errcode := 1;
   errmsg := 'ɾɹ!';
end ;
/

prompt
prompt Creating procedure CISP_DEL_DT_113002004
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113002004(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_task     varchar2,
                                             v_p001     varchar2,
                                             v_A002     int) is
begin
  delete from cisp.T_DB_04_002
   where P001 = V_P001
     AND A011 = 300
     AND A002 = V_A002
     AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);

  insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ ֤ȯͶҵծȯ ID:113002004 ',V_TASK);
  errcode := 1;
  errmsg := 'ɾɹ!';
end ;
/

prompt
prompt Creating procedure CISP_DEL_DT_113002005
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113002005(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_task     varchar2,
                                             v_p001     varchar2,
                                             v_A002     int) is
begin
  delete from cisp.T_DB_04_002
   where P001 = V_P001
     AND A011 = 400
     AND A002 = V_A002
     AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);

  insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ ֤ȯͶҵ ID:113002005',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end;
/

prompt
prompt Creating procedure CISP_DEL_DT_113002008
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113002008(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_kjaxuser varchar2,
                                                  v_task     varchar2,
                                                  v_p003     varchar2) is
  depid int;
  orgid int;
begin
  select p002 into orgid from krcs.t_sys_user where p001 = v_kjaxuser;
  select a012 into depid from krcs.t_sys_user where p001 = v_kjaxuser;
  delete from cisp.T_DB_04_002_02_02
   where P001 = 300
     AND p003 = V_P003
     AND A100 = orgid
     AND W100 = depid;
  delete from cisp.t_bks_t016 where p001=v_p003 and a100=orgid;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'ɾ ֤ȯͶҵծȯбǰ-̶沿 ID113002008',v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end cisp_del_DT_113002008;
/

prompt
prompt Creating procedure CISP_DEL_DT_113002009
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113002009(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_kjaxuser varchar2,
                                                  v_task     varchar2,
                                                  v_p003     varchar2) is
begin
  delete from cisp.T_DB_04_002_02_02
   where P001 = 400
     AND p003 = V_P003
     AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001 = v_kjaxuser)
     AND W100 IN (select a012 from krcs.t_sys_user where P001 = v_kjaxuser);
  delete from cisp.t_bks_t016 where p001=v_p003 and A100=(select p002 from krcs.t_sys_user where p001=v_kjaxuser);
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'֤ȯͶҵбǰ-̶沿 ID:113002009',V_TASK);
  errcode := 1;
  errmsg := 'ɾɹ!';
end cisp_del_DT_113002009;
/

prompt
prompt Creating procedure CISP_DEL_DT_113014001
prompt ========================================
prompt
create or replace procedure cisp_del_DT_113014001(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_kjaxuser varchar2,
                                                  v_task     varchar2,
                                                  v_p001     int) is
begin
  delete from cisp.T_DB_05_020
   where P001 = v_p001
     AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);

  insert into krcs.t_sys_log
    (p001, p002, a003, a004)
  values
    (v_kjaxuser,
     sysdate,
     'ɾ ֤ȯ˾ʻרܱ-ϸ ID:113014001',
     v_task);
  errcode := 1;
  errmsg := 'ɾɹ!';
end cisp_del_DT_113014001;
/

prompt
prompt Creating procedure CISP_END_REPORTDATE
prompt ======================================
prompt
create or replace procedure cisp_end_reportdate(
    errcode out int,
    errmsg out varchar2,
    kjaxuser varchar2,
    v_task    varchar2,
    v_P001 integer,
    v_P002 integer)
  is
  begin
    DELETE krcs.T_HIS_T004 WHERE D001=v_P001 AND D002=v_P002;

    --ñڱʷ
    INSERT INTO krcs.T_HIS_T004(P001,A002,A003,A004,A005,A006,B001,B002,C001,D001,D002)
           SELECT a.P001,a.A002,a.A003,a.A004,a.A005,a.A006,a.B001,a.B002,b.a008,v_P001,v_P002
                  FROM krcs.T_SYS_T004 a,krcs.T_SYS_T014 b where a.p001 =b.p001 and a.a006 = v_P002 and a.a002 in (11,12);


    UPDATE T_B00_D004 SET C001=1001102, D100=1006001 WHERE P001=v_P001 AND A002=v_P002;
    commit;
    errcode := 1;
    errmsg  := 'رձڳɹ';
  end;
/

prompt
prompt Creating procedure CISP_ETL_BCZL
prompt ================================
prompt
create or replace procedure cisp_etl_bczl is
  v_bmid number;  --ID
begin
  v_bmid:=50001;
/*
  select A012 into v_bmid
    from krcs.t_sys_user
   where p001 = 'yyzx'; */ --ҵ  ֱ 20150708

    --
         delete from t_db_01_007 where p001 in (1001301,1001302,1001303) and w100=v_bmid;
     insert into t_db_01_007(p001,a002,a003,a100,w100)
       select decode(jylx,1,1001303,  --ɷתý
                          2,1001301,  --֤ȯ
                          3,1001302), --֤ȯ֧
              je,
              decode(bz,0,1001, --
                        1,1002, --HK$
                        2,1004), --$
              100000,
              v_bmid
       from t_etl_bczl;

     commit;
             insert into t_sys_t018(P001,P002,P003,A004,A005,A006) values (3007,1013001,'ϵͳ','ɼ֤ȯײ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(P001,P002,P003,A004,A005,A006) values (3007,1013001,'ϵͳ','ɼ֤ȯײ',1001102,sysdate);

end cisp_etl_bczl;
/

prompt
prompt Creating procedure CISP_ETL_BJHG_JYB
prompt ====================================
prompt
create or replace procedure cisp_etl_bjhg_jyb is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008;
  declare
    v_xm    number;
    v_sl    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is

        select decode(xm,
                    1,1010, --ǩԼͻ
                    2,1011, --Уͻ
                    3,1012, --˿ͻ
                    4,1020, --ڴؽ׿ͻ
                    5,1021, --Уͻ
                    6,1022  --˿ͻ
                    ) as xm,
             sl as sl,
             jylx as jylx
        from t_etl_c13_1_sl t;

    cursor cur_ydsgh2 is

      select decode(xm,
                    7,1030,  --ѺרֵԪ
                    8,1031,  --УϺг
                    9,1032,  --г
                    10,1040,  --δڻعԪ
                    11,1041,  --Уعʣ1
                    12,1042,  --عʣ30ڣ
                    13,1043,  --عʣ30
                    14,1044,  --Уͻ
                    15,1045,  --˿ͻ
                    16,1050,  --վδڻعԪ
                    17,1060  --Ѻ
                    ) as xm,je,jylx
        from t_etl_c13_1_je t where xm between 7 and 17;
 
 
  begin
    update t_db_61_001 t set t.a003=0,t.a004=0,t.a005=0 where t.w100='50008' and t.a100='100000';
 commit;
    --ʲծα
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_sl, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_61_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_61_001
             set a003 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        elsif v_jylx = 2 then
          update t_db_61_001
             set a003 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_61_001
             set a005 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_61_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        elsif v_jylx = 2 then
          insert into t_db_61_001
            (P001, A004, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_61_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_sl, v_jylx;
    end loop;
    close cur_ydsgh1;

    open cur_ydsgh2;
    fetch cur_ydsgh2
      into v_xm, v_je, v_jylx;

    while cur_ydsgh2%found loop
      select count(*)
        into v_count
        from t_db_61_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_61_001
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        elsif v_jylx = 2 then
          update t_db_61_001
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_61_001
             set a005 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_61_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
        elsif v_jylx = 2 then
          insert into t_db_61_001
            (P001, A004, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
        else
          insert into t_db_61_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh2
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh2;


    --ɰٷ add by jiangbt 20140211
   /* update t_db_63_001 set a005=a005*100 where p001 = 1070 and w100 = v_bmid;
    commit;
    */
    --Ѻ֤ȯֵԪ
    --ڳĩǼ
    --ĩڳ 
    --cisp_etl_gpzy_bqsjcl;

   
   
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_BJHG_JYB_HGLL
prompt =========================================
prompt
create or replace procedure cisp_etl_bjhg_jyb_hgll is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008; --ýײ
  
  declare
    v_xm    number;
    v_maxrate  number(18,2);
    v_minrate  number(18,2);
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    36,1111,
                    37,1112,
                    38,1113) as xm,t.maxrate,t.minrate
        from T_ETL_C13_1_YWGM t where xm between 36 and 38;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_maxrate, v_minrate;

     while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from T_DB_61_003
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
          update T_DB_61_003
             set a002 = v_maxrate,a003=v_minrate
           where p001 = v_xm
             and w100 = v_bmid;
      else
          insert into T_DB_61_003
            (P001, A002, A003,A100, W100)
          values
            (v_xm, v_maxrate,v_minrate, 100000, v_bmid);
      end if;
      fetch cur_ydsgh1
        into v_xm, v_maxrate, v_minrate;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211
    --update t_db_63_003 set a002 = a002*100,a003=a003*100 where w100=v_bmid;
    --commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_BJHG_JYB_LJYWGM
prompt ===========================================
prompt
create or replace procedure cisp_etl_bjhg_jyb_ljywgm is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  
 v_bmid:=50008; --ýײ
 
  declare
    v_xm    number;
    v_je    number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    18,1070,	--ۼҵģԪ
                    19,1071,	--У
                    20,1072,	--
                    21,1073,	--
                    22,1080	--֧ͻϢԪ
             ) as xm,je
        from t_etl_c13_3_je t where xm between 18 and 22;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from T_DB_61_002
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
          update T_DB_61_002
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
      else
          insert into T_DB_61_002
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je;
    end loop;
    close cur_ydsgh1;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_BQSJCL
prompt =======================================
prompt
create or replace procedure cisp_etl_gpzy_bqsjcl is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع ݴ
  v_bmid:=50008;   --ýײ
  declare
    v_xm number;
    v_qc number;
    v_zj number;
    v_qm number;
    v_bqzj number;
    v_bqjs number;

      cursor cur_bqsj1 is
      select p001, a002, a003, a005, w100
        from t_db_63_001 t
       where t.p001 in
             (1010,1011,1012,1020,1021,1022,1030,1031,1032,1036,1037)
         and w100 = v_bmid;

    cursor cur_bqsj2 is
      select p001, a002,a005, w100
        from t_db_63_001 t
       where t.p001 in
             (/*1040,*/1041,1042,1043,1044)
         and w100 = v_bmid;
  begin
    open cur_bqsj1;
    fetch cur_bqsj1
      into v_xm, v_qc, v_zj, v_qm, v_bmid;

    while cur_bqsj1%found loop
      update t_db_63_001
         set a004 = nvl(v_qc,0) + nvl(v_zj,0) - nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      fetch cur_bqsj1
        into v_xm, v_qc, v_zj, v_qm, v_bmid;
    end loop;
    close cur_bqsj1;

    open cur_bqsj2;
    fetch cur_bqsj2
      into v_xm, v_qc, v_qm, v_bmid;

    while cur_bqsj2%found loop
      if nvl(v_qm,0)-nvl(v_qc,0)>0 then
      update t_db_63_001
         set a003 = nvl(v_qm,0)-nvl(v_qc,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      else
      update t_db_63_001
         set a004 = nvl(v_qc,0)-nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      end if;
      commit;
      fetch cur_bqsj2
        into v_xm, v_qc, v_qm, v_bmid;
    end loop;
    close cur_bqsj2;

    select sum(a003) into v_bqzj from t_db_63_001 where p001 in (1041,1043);
    select sum(a004) into v_bqjs from t_db_63_001 where p001 in (1041,1043);
    update t_db_63_001 set a003 = v_bqzj,a004 = v_bqjs where p001 = 1040;
    commit;
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_BZHG_JYB
prompt ====================================
prompt
create or replace procedure cisp_etl_bzhg_jyb is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008;
  declare
    v_xm    number;
    v_sl    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is

        select decode(xm,
                    1,1010, --ǩԼͻ
                    2,1011, --Уͻ
                    3,1012, --˿ͻ
                    4,1020, --ڴؽ׿ͻ
                    5,1021, --Уͻ
                    6,1022  --˿ͻ
                    ) as xm,
             sl as sl,
             jylx as jylx
        from t_etl_c13_1_sl t;

    cursor cur_ydsgh2 is

      select decode(xm,
                    7,1030,--ؽ׽Ԫ
                    8,1031,--УϺгؽ׽
                    9,1032,--  гؽ׽
                    10,1033,--Уʣ1
                    11,1034,--عʣ1ڣ
                    12,1035,--    عʣ1
                    13,1036,--  Уͻ
                    14,1037,--     ˿ͻ
                    15,1040,--Ѻ֤ȯֵԪ
                    16,1041,-- УϺг֤ȯֵ
                    17,1042,--    У۹ֵ
                    18,1043,--     г֤ȯֵ
                    19,1044,--   У۹ֵ
                    20,1050,--ΥԼͻ
                    21,1051,--Уͻ
                    22,1052,--      ˿ͻ
                    23,1060,--ΥԼԪ
                    24,1061,--   Уͻ
                    25,1062,--           ˿ͻ
                    26,1070--Լϱ(%)
                    ) as xm,je,jylx
        from t_etl_c13_1_je t where xm between 7 and 26;
 
 
  begin
    update t_db_61_001 t set t.a003=0,t.a004=0,t.a005=0 where t.w100='50008' and t.a100='100000';
 commit;
    --ʲծα
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_sl, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_61_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_61_001
             set a003 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_61_001
             set a005 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_61_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_61_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_sl, v_jylx;
    end loop;
    close cur_ydsgh1;

    open cur_ydsgh2;
    fetch cur_ydsgh2
      into v_xm, v_je, v_jylx;

    while cur_ydsgh2%found loop
      select count(*)
        into v_count
        from t_db_61_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_61_001
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_61_001
             set a005 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_61_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_61_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh2
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh2;


    --ɰٷ add by jiangbt 20140211
   /* update t_db_63_001 set a005=a005*100 where p001 = 1070 and w100 = v_bmid;
    commit;
    */
    --Ѻ֤ȯֵԪ
    --ڳĩǼ
    --ĩڳ 
    cisp_etl_gpzy_bqsjcl;

   
   
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_DLDFGZ
prompt ==================================
prompt
create or replace procedure cisp_etl_dldfgz is
  v_bmid number;  --ID
begin

 /* select A012 into v_bmid
    from krcs.t_sys_user
   where p001 = 'jgkhb'; */ --͹ܲ
   v_bmid:=50008;

    --Ҹծ
         delete from t_db_01_012 where p001 in (1001403,1001405) and w100=v_bmid;
     insert into t_db_01_012
       select 1001403, dljy, 100000, v_bmid from t_etl_dldfgz
         union
       select 1001405, yjsr, 100000, v_bmid from t_etl_dldfgz;

     commit;
      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3012,1013001,'ϵͳ','ɼҸծ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3012,1013001,'ϵͳ','ɼҸծ',1001102,sysdate);

end cisp_etl_dldfgz;
/

prompt
prompt Creating procedure CISP_ETL_DLDFQTZ
prompt ===================================
prompt
create or replace procedure cisp_etl_dldfqtz is
  v_bmid number;  --ID
begin

 /* select A012 into v_bmid
    from krcs.t_sys_user
   where p001 = 'jgkhb';*/  --͹ܲ
   v_bmid:=50008;

  --Ҹծ
       delete from t_db_01_013 where p001 in (1001403,1001405) and w100=v_bmid;
     insert into t_db_01_013
       select 1001403, dljy, 100000, v_bmid from t_etl_dldfqtz
         union
       select 1001405, yjsr, 100000, v_bmid from t_etl_dldfqtz;

     commit;
      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3013,1013001,'ϵͳ','ɼҸծ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3013,1013001,'ϵͳ','ɼҸծ',1001102,sysdate);

end cisp_etl_dldfqtz;
/

prompt
prompt Creating procedure CISP_ETL_DXGZ
prompt ================================
prompt
create or replace procedure cisp_etl_dxgz is
  v_bmid number;  --ID
begin


   v_bmid:=50008;

       delete from t_db_01_010 where p001 in (1001403,1001405) and w100=v_bmid;
     insert into t_db_01_010
       select 1001403, dljy, 100000, v_bmid from t_etl_dxgz
         union
       select 1001405, yjsr, 100000, v_bmid from t_etl_dxgz;

     commit;
             insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3010,1013001,'ϵͳ','ɼծ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3010,1013001,'ϵͳ','ɼծ',1001102,sysdate);

end cisp_etl_dxgz;
/

prompt
prompt Creating procedure CISP_ETL_DXJJ
prompt ================================
prompt
create or replace procedure cisp_etl_dxjj is
  v_bmid number;  --ID
begin

   v_bmid:=50008;

   --
        delete from t_db_01_008 where p001 in (1001403,1001405) and w100=v_bmid;
     insert into t_db_01_008
       select 1001403, dljy, 100000, v_bmid from t_etl_dxjj
         union
       select 1001405, yjsr, 100000, v_bmid from t_etl_dxjj;

     commit;
             insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3008,1013001,'ϵͳ','ɼ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3008,1013001,'ϵͳ','ɼ',1001102,sysdate);

end cisp_etl_dxjj;
/

prompt
prompt Creating procedure CISP_ETL_DXQTZ
prompt =================================
prompt
create or replace procedure cisp_etl_dxqtz is
  v_bmid number;  --ID
begin

  /*select A012 into v_bmid
    from krcs.t_sys_user
   where p001 = 'jgkhb'; */ --͹ܲ
   v_bmid:=50008;

  --ծ
       delete from t_db_01_011 where p001 in (1001403,1001405) and w100=v_bmid;
     insert into t_db_01_011
       select 1001403, dljy, 100000, v_bmid from t_etl_dxqtz
         union
       select 1001405, yjsr, 100000, v_bmid from t_etl_dxqtz;

     commit;
                  insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3011,1013001,'ϵͳ','ɼծ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3011,1013001,'ϵͳ','ɼծ',1001102,sysdate);

end cisp_etl_dxqtz;
/

prompt
prompt Creating procedure CISP_ETL_DXZCGL
prompt ==================================
prompt
create or replace procedure cisp_etl_dxzcgl
is
  v_bmid number;  --ID

--ʲ
begin

/*  select A012 into v_bmid
    from krcs.t_sys_user
   where p001 = 'lsywb02'; */ --͹ܲ
   v_bmid:=50008;

     delete from t_db_01_009 where p001 in (1001403,1001405) and w100=v_bmid;
     insert into t_db_01_009
       select 1001403, dljy, 100000, v_bmid from t_etl_dxzcgl
         union
       select 1001405, yjsr, 100000, v_bmid from t_etl_dxzcgl;

     commit;
       insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3009,1013001,'ϵͳ','ɼʲ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3009,1013001,'ϵͳ','ɼʲ',1001102,sysdate);


end cisp_etl_dxzcgl;
/

prompt
prompt Creating procedure CISP_ETL_FZCJY_ZJZH
prompt ======================================
prompt
create or replace procedure cisp_ETL_FZCJY_ZJZH is

    v_bmid number;  --ID
    v_count number;
begin
   v_bmid:=50001; --͹ܲ

    --ʽ˻
     /*ʽ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001000 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zjzh where zhlx=1 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zjzh where zhlx=1 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zjzh where zhlx=1 and jylx=3)
        where p001=10001000 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001000,
            (select sl from t_etl_fzcjy_zjzh where zhlx=1 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zjzh where zhlx=1 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zjzh where zhlx=1 and jylx=3) as qm,
            v_bmid,
            100000
       from dual;
     end if;

     /*ϸʽ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001010 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zjzh where zhlx=2 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zjzh where zhlx=2 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zjzh where zhlx=2 and jylx=3)
        where p001=10001010 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001010,
            (select sl from t_etl_fzcjy_zjzh where zhlx=2 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zjzh where zhlx=2 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zjzh where zhlx=2 and jylx=3) as qm,
            v_bmid,
            100000
       from dual;
     end if;

     /*ʽ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001020 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zjzh where zhlx=3 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zjzh where zhlx=3 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zjzh where zhlx=3 and jylx=3)
        where p001=10001020 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001020,
            (select sl from t_etl_fzcjy_zjzh where zhlx=3 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zjzh where zhlx=3 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zjzh where zhlx=3 and jylx=3) as qm,
            v_bmid,
            100000
       from dual ;
     end if;

     /*ʽ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001030 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zjzh where zhlx=4 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zjzh where zhlx=4 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zjzh where zhlx=4 and jylx=3)
        where p001=10001030 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001030,
            (select sl from t_etl_fzcjy_zjzh where zhlx=4 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zjzh where zhlx=4 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zjzh where zhlx=4 and jylx=3) as qm,
            v_bmid,
            100000
       from dual;
     end if;
     --ڼ=ڳ-ĩ>0
     update T_DB_01_020
     set a004 = (case when nvl(a002,0)-nvl(a005,0)>0 then nvl(a002,0)-nvl(a005,0) else 0 end)
     where p001 in(10001000,10001010,10001020,10001030);
     commit;
     
      --=ڳ-ĩ<0
     update T_DB_01_020
     set a003 = (case when nvl(a002,0)-nvl(a005,0)<0 then abs(nvl(a002,0)-nvl(a005,0)) else 0 end)
     where p001 in(10001000,10001010,10001020,10001030);
     commit;


      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3020,1013001,'ϵͳ','ɼ-ʽ˻',1001101,sysdate);
      exception
      when others then
        rollback;
      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3020,1013001,'ϵͳ','ɼ-ʽ˻',1001102,sysdate);



end;
/

prompt
prompt Creating procedure CISP_ETL_FZCJY_ZQZH
prompt ======================================
prompt
create or replace procedure CISP_ETL_FZCJY_ZQZH is
    v_bmid number;  --ID
    v_count number;
begin
    v_bmid:=50001;  --͹ܲ

    --֤ȯ˻
     /*֤ȯ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001005 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zqzh where zhlx=1 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zqzh where zhlx=1 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zqzh where zhlx=1 and jylx=3)
        where p001=10001005 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001005,
            (select sl from t_etl_fzcjy_zqzh where zhlx=1 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zqzh where zhlx=1 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zqzh where zhlx=1 and jylx=3) as qm,
            v_bmid,
            100000
       from dual;
     end if;

     /*ϸ֤ȯ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001015 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zqzh where zhlx=2 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zqzh where zhlx=2 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zqzh where zhlx=2 and jylx=3)
        where p001=10001015 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001015,
            (select sl from t_etl_fzcjy_zqzh where zhlx=2 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zqzh where zhlx=2 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zqzh where zhlx=2 and jylx=3) as qm,
            v_bmid,
            100000
       from dual;
     end if;

     /*֤ȯ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001025 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zqzh where zhlx=3 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zqzh where zhlx=3 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zqzh where zhlx=3 and jylx=3)
        where p001=10001025 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001025,
            (select sl from t_etl_fzcjy_zqzh where zhlx=3 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zqzh where zhlx=3 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zqzh where zhlx=3 and jylx=3) as qm,
            v_bmid,
            100000
       from dual ;
     end if;

     /*֤ȯ˻*/
     select count(*) into v_count
     from T_DB_01_020
     where p001 = 10001035 and w100=v_bmid;
     if(v_count > 0) then
        update T_DB_01_020
        set a003 =(select sl from t_etl_fzcjy_zqzh where zhlx=4 and jylx=1),
            a004 =(select sl from t_etl_fzcjy_zqzh where zhlx=4 and jylx=2),
            a005 =(select sl from t_etl_fzcjy_zqzh where zhlx=4 and jylx=3)
        where p001=10001035 and w100=v_bmid;
     else
     insert into T_DB_01_020(P001,a003,a004,a005,w100,A100)
     select 10001035,
            (select sl from t_etl_fzcjy_zqzh where zhlx=4 and jylx=1) as cj,
            (select sl from t_etl_fzcjy_zqzh where zhlx=4 and jylx=2) as js,
            (select sl from t_etl_fzcjy_zqzh where zhlx=4 and jylx=3) as qm,
            v_bmid,
            100000
       from dual;
     end if;
     --ڼ=ڳ-ĩ>0Ǽ
     update T_DB_01_020
     set a004 = (case when  nvl(a002,0)-nvl(a005,0)>0 then nvl(a002,0)-nvl(a005,0) else 0 end)
     where p001 in (10001005,10001015,10001025,10001035);
     commit;
      --=ڳ-ĩ<0
     update T_DB_01_020
     set a003 = (case when  nvl(a002,0)-nvl(a005,0)< 0 then abs(nvl(a002,0)+nvl(a003,0)-nvl(a005,0)) else 0 end)
     where p001 in (10001005,10001015,10001025,10001035);
     commit;

      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3020,1013001,'ϵͳ','ɼ-֤ȯ˻',1001101,sysdate);
      exception
      when others then
        rollback;
      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3020,1013001,'ϵͳ','ɼ-֤ȯ˻',1001102,sysdate);


end CISP_ETL_FZCJY_ZQZH;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_BQSJCL_RH
prompt ==========================================
prompt
create or replace procedure cisp_etl_gpzy_bqsjcl_rh is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع ݴ
  v_bmid:=50008;   --ýײ
  declare
    v_xm number;
    v_qc number;
    v_zj number;
    v_qm number;
    v_bqzj number;
    v_bqjs number;

      cursor cur_bqsj1 is
      select p001, a002, a003, a005, w100
        from t_db_63_001_rh t
       where t.p001 in
             (1010,1011,1012,1020,1021,1022,1030,1031,1032,1036,1037)
         and w100 = v_bmid;

    cursor cur_bqsj2 is
      select p001, a002,a005, w100
        from t_db_63_001_rh t
       where t.p001 in
             (/*1040,*/1041,1042,1043,1044)
         and w100 = v_bmid;
  begin
    open cur_bqsj1;
    fetch cur_bqsj1
      into v_xm, v_qc, v_zj, v_qm, v_bmid;

    while cur_bqsj1%found loop
      update t_db_63_001_rh
         set a004 = nvl(v_qc,0) + nvl(v_zj,0) - nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      fetch cur_bqsj1
        into v_xm, v_qc, v_zj, v_qm, v_bmid;
    end loop;
    close cur_bqsj1;

    open cur_bqsj2;
    fetch cur_bqsj2
      into v_xm, v_qc, v_qm, v_bmid;

    while cur_bqsj2%found loop
      if nvl(v_qm,0)-nvl(v_qc,0)>0 then
      update t_db_63_001_rh
         set a003 = nvl(v_qm,0)-nvl(v_qc,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      else
      update t_db_63_001_rh
         set a004 = nvl(v_qc,0)-nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      end if;
      commit;
      fetch cur_bqsj2
        into v_xm, v_qc, v_qm, v_bmid;
    end loop;
    close cur_bqsj2;

    select sum(a003) into v_bqzj from t_db_63_001_rh where p001 in (1041,1043);
    select sum(a004) into v_bqjs from t_db_63_001_rh where p001 in (1041,1043);
    update t_db_63_001_rh set a003 = v_bqzj,a004 = v_bqjs where p001 = 1040;
    commit;
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_BQSJCL_ZYZJ
prompt ============================================
prompt
create or replace procedure cisp_etl_gpzy_bqsjcl_zyzj is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع ݴ
  v_bmid:=50008;   --ýײ
  declare
    v_xm number;
    v_qc number;
    v_zj number;
    v_qm number;
    v_bqzj number;
    v_bqjs number;

      cursor cur_bqsj1 is
      select p001, a002, a003, a005, w100
        from t_db_63_001_zyzj t
       where t.p001 in
             (1010,1011,1012,1020,1021,1022,1030,1031,1032,1036,1037)
         and w100 = v_bmid;

    cursor cur_bqsj2 is
      select p001, a002,a005, w100
        from t_db_63_001_zyzj t
       where t.p001 in
             (/*1040,*/1041,1042,1043,1044)
         and w100 = v_bmid;
  begin
    open cur_bqsj1;
    fetch cur_bqsj1
      into v_xm, v_qc, v_zj, v_qm, v_bmid;

    while cur_bqsj1%found loop
      update t_db_63_001_zyzj
         set a004 = nvl(v_qc,0) + nvl(v_zj,0) - nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      fetch cur_bqsj1
        into v_xm, v_qc, v_zj, v_qm, v_bmid;
    end loop;
    close cur_bqsj1;

    open cur_bqsj2;
    fetch cur_bqsj2
      into v_xm, v_qc, v_qm, v_bmid;

    while cur_bqsj2%found loop
      if nvl(v_qm,0)-nvl(v_qc,0)>0 then
      update t_db_63_001_zyzj
         set a003 = nvl(v_qm,0)-nvl(v_qc,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      else
      update t_db_63_001_zyzj
         set a004 = nvl(v_qc,0)-nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      end if;
      commit;
      fetch cur_bqsj2
        into v_xm, v_qc, v_qm, v_bmid;
    end loop;
    close cur_bqsj2;

    select sum(a003) into v_bqzj from t_db_63_001_zyzj where p001 in (1041,1043);
    select sum(a004) into v_bqjs from t_db_63_001_zyzj where p001 in (1041,1043);
    update t_db_63_001_zyzj set a003 = v_bqzj,a004 = v_bqjs where p001 = 1040;
    commit;
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB
prompt ====================================
prompt
create or replace procedure cisp_etl_gpzy_jyb is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008;
  declare
    v_xm    number;
    v_sl    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is

        select decode(xm,
                    1,1010, --ǩԼͻ
                    2,1011, --Уͻ
                    3,1012, --˿ͻ
                    4,1020, --ڴؽ׿ͻ
                    5,1021, --Уͻ
                    6,1022  --˿ͻ
                    ) as xm,
             sl as sl,
             jylx as jylx
        from t_etl_c13_3_sl t;

    cursor cur_ydsgh2 is

      select decode(xm,
                    7,1030,--ؽ׽Ԫ
                    8,1031,--УϺгؽ׽
                    9,1032,--  гؽ׽
                    10,1033,--Уʣ1
                    11,1034,--عʣ1ڣ
                    12,1035,--    عʣ1
                    13,1036,--  Уͻ
                    14,1037,--     ˿ͻ
                    15,1040,--Ѻ֤ȯֵԪ
                    16,1041,-- УϺг֤ȯֵ
                    17,1042,--    У۹ֵ
                    18,1043,--     г֤ȯֵ
                    19,1044,--   У۹ֵ
                    20,1050,--ΥԼͻ
                    21,1051,--Уͻ
                    22,1052,--      ˿ͻ
                    23,1060,--ΥԼԪ
                    24,1061,--   Уͻ
                    25,1062,--           ˿ͻ
                    26,1070--Լϱ(%)
                    ) as xm,je,jylx
        from t_etl_c13_3_je t where xm between 7 and 26;
 
 
  begin
    update t_db_63_001 t set t.a003=0,t.a004=0,t.a005=0 where t.w100='50008' and t.a100='100000';
 commit;
    --ʲծα
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_sl, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_001
             set a003 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_001
             set a005 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_63_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_sl, v_jylx;
    end loop;
    close cur_ydsgh1;

    open cur_ydsgh2;
    fetch cur_ydsgh2
      into v_xm, v_je, v_jylx;

    while cur_ydsgh2%found loop
      select count(*)
        into v_count
        from t_db_63_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_001
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_001
             set a005 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_63_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh2
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh2;


    --ɰٷ add by jiangbt 20140211
   /* update t_db_63_001 set a005=a005*100 where p001 = 1070 and w100 = v_bmid;
    commit;
    */
    --Ѻ֤ȯֵԪ
    --ڳĩǼ
    --ĩڳ 
    cisp_etl_gpzy_bqsjcl;

   
   
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_HGLL
prompt =========================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_hgll is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008; --ýײ
  
  declare
    v_xm    number;
    v_je    varchar2(10);
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    36,1111,
                    37,1112,
                    38,1113) as xm,je,jylx
        from t_etl_c13_3_je t where xm between 36 and 38;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_003
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_003
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_003
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_003
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
        else
          update t_db_63_003
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211
    --update t_db_63_003 set a002 = a002*100,a003=a003*100 where w100=v_bmid;
    --commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_HGLL_RH
prompt ============================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_hgll_rh is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008; --ýײ
  
  declare
    v_xm    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    36,1111,
                    37,1112,
                    38,1113) as xm,je,jylx
        from t_etl_c13_3_je_rh t where xm between 36 and 38;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_003_rh
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_003_rh
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_003_rh
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_003_rh
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
        else
          update t_db_63_003_rh
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211
    --update t_db_63_003 set a002 = a002*100,a003=a003*100 where w100=v_bmid;
    --commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_HGLL_ZYZJ
prompt ==============================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_hgll_zyzj is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008; --ýײ
  
  declare
    v_xm    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    36,1111,
                    37,1112,
                    38,1113) as xm,je,jylx
        from t_etl_c13_3_je_zyzj t where xm between 36 and 38;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_003_zyzj
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_003_zyzj
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_003_zyzj
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_003_zyzj
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
        else
          update t_db_63_003_zyzj
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211
    --update t_db_63_003 set a002 = a002*100,a003=a003*100 where w100=v_bmid;
    --commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_LJYWGM
prompt ===========================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ljywgm is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  
 v_bmid:=50008; --ýײ
 
  declare
    v_xm    number;
    v_je    number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    27,1080,
                    28,1081,
                    29,1082,
                    30,1083,
                    31,1090,
                    32,1100,
                    33,1101,
                    34,1102,
                    35,1103) as xm,je
        from t_etl_c13_3_je t where xm between 27 and 35;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_002
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
          update t_db_63_002
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
      else
          insert into t_db_63_002
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je;
    end loop;
    close cur_ydsgh1;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_LJYWGM_RH
prompt ==============================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ljywgm_rh is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  
 v_bmid:=50008; --ýײ
 
  declare
    v_xm    number;
    v_je    number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    27,1080,
                    28,1081,
                    29,1082,
                    30,1083,
                    31,1090,
                    32,1100,
                    33,1101,
                    34,1102,
                    35,1103) as xm,je
        from t_etl_c13_3_je_rh t where xm between 27 and 35;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_002_rh
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
          update t_db_63_002_rh
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
      else
          insert into t_db_63_002_rh
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je;
    end loop;
    close cur_ydsgh1;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_LJYWGM_ZYZJ
prompt ================================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ljywgm_zyzj is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  
 v_bmid:=50008; --ýײ
 
  declare
    v_xm    number;
    v_je    number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    27,1080,
                    28,1081,
                    29,1082,
                    30,1083,
                    31,1090,
                    32,1100,
                    33,1101,
                    34,1102,
                    35,1103) as xm,je
        from t_etl_c13_3_je_zyzj t where xm between 27 and 35;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_002_zyzj
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
          update t_db_63_002_zyzj
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
      else
          insert into t_db_63_002_zyzj
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je;
    end loop;
    close cur_ydsgh1;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_RH
prompt =======================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_rh is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008;
  declare
    v_xm    number;
    v_sl    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is

        select decode(xm,
                    1,1010, --ǩԼͻ
                    2,1011, --Уͻ
                    3,1012, --˿ͻ
                    4,1020, --ڴؽ׿ͻ
                    5,1021, --Уͻ
                    6,1022  --˿ͻ
                    ) as xm,
             sl as sl,
             jylx as jylx
        from t_etl_c13_3_sl_rh t;

    cursor cur_ydsgh2 is

      select decode(xm,
                    7,1030,--ؽ׽Ԫ
                    8,1031,--УϺгؽ׽
                    9,1032,--  гؽ׽
                    10,1033,--Уʣ1
                    11,1034,--عʣ1ڣ
                    12,1035,--    عʣ1
                    13,1036,--  Уͻ
                    14,1037,--     ˿ͻ
                    15,1040,--Ѻ֤ȯֵԪ
                    16,1041,-- УϺг֤ȯֵ
                    17,1042,--    У۹ֵ
                    18,1043,--     г֤ȯֵ
                    19,1044,--   У۹ֵ
                    20,1050,--ΥԼͻ
                    21,1051,--Уͻ
                    22,1052,--      ˿ͻ
                    23,1060,--ΥԼԪ
                    24,1061,--   Уͻ
                    25,1062,--           ˿ͻ
                    26,1070--Լϱ(%)
                    ) as xm,je,jylx
        from t_etl_c13_3_je_rh t where xm between 7 and 26;

  begin
   update t_db_63_001_rh t set t.a003=0,t.a004=0,t.a005=0 where t.w100='50008' and t.a100='100000';
 commit;
    --ʲծα
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_sl, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_001_rh
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_001_rh
             set a003 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_001_rh
             set a005 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_001_rh
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_63_001_rh
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_sl, v_jylx;
    end loop;
    close cur_ydsgh1;

    open cur_ydsgh2;
    fetch cur_ydsgh2
      into v_xm, v_je, v_jylx;

    while cur_ydsgh2%found loop
      select count(*)
        into v_count
        from t_db_63_001_rh
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_001_rh
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_001_rh
             set a005 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_001_rh
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_63_001_rh
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh2
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh2;


    --ɰٷ add by jiangbt 20140211
   /* update t_db_63_001 set a005=a005*100 where p001 = 1070 and w100 = v_bmid;
    commit;
    */
    --Ѻ֤ȯֵԪ
    --ڳĩǼ
    --ĩڳ 
    cisp_etl_gpzy_bqsjcl_rh;


  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_YWMX1
prompt ==========================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ywmx1 is
  v_bmid number; --ID
  v_jzb  number(19,2);
  v_bbq  varchar2(8);
  cot number;
begin
  --֤ȯ˾Լʽ֤ȯ
  v_bmid:=50008; --ýײ
  select to_char(p001)||'--'
    into v_bbq
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
   
  select count(t.G26) into cot  from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  
  if cot>0 then 
   select nvl(t.G26,0) into v_jzb from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  else
   v_jzb:=0;
  end if;
   declare
    v_dm    varchar2(32);
    v_mc    varchar2(64);
    v_je    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    cursor cur_ydsgh1 is
      select dm, mc, je, sz, bl_a, bl_b, rownum from (select dm, mc, je, sz, bl_a, bl_b
        from t_etl_c13_3_ywmx1 t
       order by je desc) a where rownum <6;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_dm,v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;

    delete from t_db_63_004;
    commit;
    while cur_ydsgh1%found loop
          insert into t_db_63_004
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;
    end loop;
    close cur_ydsgh1;

  --ɰٷ add by jiangbt 20140211 ʱ
  update t_db_63_004 set a006 = (case when v_jzb = 0 then 0 else (a003/V_JZB)*100 end) where w100=v_bmid;
  commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_YWMX1_RH
prompt =============================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ywmx1_rh is
  v_bmid number; --ID
  v_jzb  number(19,2);
  v_bbq  varchar2(8);
  cot number;
begin
  --֤ȯ˾Լʽ֤ȯ
  v_bmid:=50008; --ýײ
  select to_char(p001)||'--'
    into v_bbq
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select count(t.G26) into cot  from T_CSRC1107_A1 t where T.BBQ=v_bbq;

  if cot>0 then
   select nvl(t.G26,0) into v_jzb from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  else
   v_jzb:=0;
  end if;
  
   declare
    v_dm    varchar2(32);
    v_mc    varchar2(64);
    v_je    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    cursor cur_ydsgh1 is
      select dm, mc, je, sz, bl_a, bl_b, rownum from (select dm, mc, je, sz, bl_a, bl_b
        from t_etl_c13_3_ywmx1_rh t
       order by je desc) a where rownum <6;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_dm,v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;

    delete from t_db_63_004_rh;
    commit;
    while cur_ydsgh1%found loop
          insert into t_db_63_004_rh
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;
    end loop;
    close cur_ydsgh1;

  --ɰٷ add by jiangbt 20140211 ʱ
  update t_db_63_004_rh set a006 = (case when v_jzb = 0 then 0 else (a003/V_JZB)*100 end) where w100=v_bmid;
  commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_YWMX1_ZYZJ
prompt ===============================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ywmx1_zyzj is
  v_bmid number; --ID
  v_jzb  number(19,2);
  v_bbq  varchar2(8);
  cot number;
begin
  --֤ȯ˾Լʽ֤ȯ
  v_bmid:=50008; --ýײ
  select to_char(p001)||'--'
    into v_bbq
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select count(t.G26) into cot  from T_CSRC1107_A1 t where T.BBQ=v_bbq;

  if cot>0 then
   select nvl(t.G26,0) into v_jzb from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  else
   v_jzb:=0;
  end if;
   declare
    v_dm    varchar2(32);
    v_mc    varchar2(64);
    v_je    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    cursor cur_ydsgh1 is
      select dm, mc, je, sz, bl_a, bl_b, rownum from (select dm, mc, je, sz, bl_a, bl_b
        from t_etl_c13_3_ywmx1_zyzj t
       order by je desc) a where rownum <6;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_dm,v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;

    delete from T_DB_63_004_zyzj;
    commit;
    while cur_ydsgh1%found loop
          insert into T_DB_63_004_zyzj
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;
    end loop;
    close cur_ydsgh1;

  --ɰٷ add by jiangbt 20140211 ʱ
  update T_DB_63_004_zyzj set a006 = (case when v_jzb = 0 then 0 else (a003/V_JZB)*100 end) where w100=v_bmid;
  commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_YWMX2
prompt ==========================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ywmx2 is
  v_bmid number; --ID
  v_jzb  number(19,2);
  v_bbq  varchar2(8);
  cot number;
begin
  --֤ȯ˾Լʽ֤ȯ 
  v_bmid:=50008;  --ýײ
  select to_char(p001)||'--'
    into v_bbq
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
     
  select count(t.G26) into cot  from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  
  if cot>0 then 
   select nvl(t.G26,0) into v_jzb from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  else
   v_jzb:=0;
  end if;
  
  declare
    v_mc    varchar2(64);
    v_sl    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    v_stkname varchar2(64);
    cursor cur_ydsgh1 is
      select mc, sl, sz, bl_a, bl_b, rownum, stk_name
        from t_etl_c13_3_ywmx2 t
       where rownum < 6 order by sz desc;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;

    delete from t_db_63_005;
    commit;
    while cur_ydsgh1%found loop
          insert into t_db_63_005
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_mc, v_stkname, v_sl, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211 ʱ
    update t_db_63_005 set a006 = (case when v_jzb=0 then 0 else (a004/V_JZB)*100 end) where w100=v_bmid;
    commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_YWMX2_RH
prompt =============================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ywmx2_rh is
  v_bmid number; --ID
  v_jzb  number(19,2);
  v_bbq  varchar2(8);
  cot number;
begin
  --֤ȯ˾Լʽ֤ȯ 
  v_bmid:=50008;  --ýײ
  select to_char(p001)||'--'
    into v_bbq
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
     
  select count(t.G26) into cot  from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  
  if cot>0 then 
   select nvl(t.G26,0) into v_jzb from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  else
   v_jzb:=0;
  end if;
  
  declare
    v_mc    varchar2(64);
    v_sl    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    v_stkname varchar2(64);
    cursor cur_ydsgh1 is
      select mc, sl, sz, bl_a, bl_b, rownum, stk_name
        from t_etl_c13_3_ywmx2_rh t
       where rownum < 6 order by sz desc;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;

    delete from t_db_63_005_rh;
    commit;
    while cur_ydsgh1%found loop
          insert into t_db_63_005_rh
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_mc, v_stkname, v_sl, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211 ʱ
    update t_db_63_005_rh set a006 = (case when v_jzb=0 then 0 else (a004/V_JZB)*100 end) where w100=v_bmid;
    commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_YWMX2_ZYZJ
prompt ===============================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_ywmx2_zyzj is
  v_bmid number; --ID
  v_jzb  number(19,2);
  v_bbq  varchar2(8);
  cot number;
begin
  --֤ȯ˾Լʽ֤ȯ 
  v_bmid:=50008;  --ýײ
  select to_char(p001)||'--'
    into v_bbq
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
     
  select count(t.G26) into cot  from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  
  if cot>0 then 
   select nvl(t.G26,0) into v_jzb from T_CSRC1107_A1 t where T.BBQ=v_bbq;
  else
   v_jzb:=0;
  end if;
  
  declare
    v_mc    varchar2(64);
    v_sl    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    v_stkname varchar2(64);
    cursor cur_ydsgh1 is
      select mc, sl, sz, bl_a, bl_b, rownum, stk_name
        from t_etl_c13_3_ywmx2_zyzj t
       where rownum < 6 order by sz desc;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;

    delete from t_db_63_005_zyzj;
    commit;
    while cur_ydsgh1%found loop
          insert into t_db_63_005_zyzj
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_mc, v_stkname, v_sl, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211 ʱ
    update t_db_63_005_zyzj set a006 = (case when v_jzb=0 then 0 else (a004/V_JZB)*100 end) where w100=v_bmid;
    commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_GPZY_JYB_ZYZJ
prompt =========================================
prompt
create or replace procedure cisp_etl_gpzy_jyb_zyzj is
  v_bmid number; --ID
begin
  --֤ȯ˾ƱѺʽع֤ȯ
  v_bmid:=50008;
  declare
    v_xm    number;
    v_sl    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is

        select decode(xm,
                    1,1010, --ǩԼͻ
                    2,1011, --Уͻ
                    3,1012, --˿ͻ
                    4,1020, --ڴؽ׿ͻ
                    5,1021, --Уͻ
                    6,1022  --˿ͻ
                    ) as xm,
             sl as sl,
             jylx as jylx
        from t_etl_c13_3_sl_zyzj t;

    cursor cur_ydsgh2 is

      select decode(xm,
                    7,1030,--ؽ׽Ԫ
                    8,1031,--УϺгؽ׽
                    9,1032,--  гؽ׽
                    10,1033,--Уʣ1
                    11,1034,--عʣ1ڣ
                    12,1035,--    عʣ1
                    13,1036,--  Уͻ
                    14,1037,--     ˿ͻ
                    15,1040,--Ѻ֤ȯֵԪ
                    16,1041,-- УϺг֤ȯֵ
                    17,1042,--    У۹ֵ
                    18,1043,--     г֤ȯֵ
                    19,1044,--   У۹ֵ
                    20,1050,--ΥԼͻ
                    21,1051,--Уͻ
                    22,1052,--      ˿ͻ
                    23,1060,--ΥԼԪ
                    24,1061,--   Уͻ
                    25,1062,--           ˿ͻ
                    26,1070--Լϱ(%)
                    ) as xm,je,jylx
        from t_etl_c13_3_je_zyzj t where xm between 7 and 26;

  begin
  update t_db_63_001_zyzj t set t.a003=0,t.a004=0,t.a005=0 where t.w100='50008' and t.a100='100000';
 commit;
    --ʲծα
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_sl, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_63_001_zyzj
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_001_zyzj
             set a003 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_001_zyzj
             set a005 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_001_zyzj
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_63_001_zyzj
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_sl, v_jylx;
    end loop;
    close cur_ydsgh1;

    open cur_ydsgh2;
    fetch cur_ydsgh2
      into v_xm, v_je, v_jylx;

    while cur_ydsgh2%found loop
      select count(*)
        into v_count
        from t_db_63_001_zyzj
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_63_001_zyzj
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_63_001_zyzj
             set a005 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_63_001_zyzj
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_63_001_zyzj
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh2
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh2;


    --ɰٷ add by jiangbt 20140211
   /* update t_db_63_001 set a005=a005*100 where p001 = 1070 and w100 = v_bmid;
    commit;
    */
    --Ѻ֤ȯֵԪ
    --ڳĩǼ
    --ĩڳ 
    cisp_etl_gpzy_bqsjcl_zyzj;


  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_KHJYJSZJZL
prompt ======================================
prompt
create or replace procedure cisp_etl_khjyjszjzl is
  v_bmid number;  --ID(ҵ)


begin
/*
  select A012 into v_bmid
    from t_sys_user
   where p001 = 'yyzx';  --͹ܲ
*/

  v_bmid :=50001;    --add by qinp  ҵ
  
   delete from t_db_01_001 where p001 in (1001102,1001103,1001106,1001107);
    --ͻ׽ʽ
    --ڴ
    insert into t_db_01_001
      select 1001102,
             decode(bz, 0, 1001, 1, 1002, 2, 1004),
             sum(je),
             100000,
             v_bmid
      from t_etl_khjyjszj
      where jylx = 1
      group by bz;

    --ȡ
    insert into t_db_01_001
      select 1001103,
             decode(bz, 0, 1001, 1, 1002, 2, 1004),
             sum(je),
             100000,
             v_bmid
      from t_etl_khjyjszj
      where jylx = 2
      group by bz;

    --
    insert into t_db_01_001
      select 1001106,
             decode(bz, 0, 1001, 1, 1002, 2, 1004),
             je,
             100000,
             v_bmid
      from t_etl_khjyjszj
      where jylx = 3
        and khlx = 1;

    --˱
    insert into t_db_01_001
      select 1001107,
             decode(bz, 0, 1001, 1, 1002, 2, 1004),
             je,
             100000,
             v_bmid
      from t_etl_khjyjszj
      where jylx = 3
        and khlx = 0;


    commit;
        insert into t_sys_t018(P001,P002,P003,A004,A005,A006) values (3001,1013001,'ϵͳ','ɼͻ׽ʽ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(P001,P002,P003,A004,A005,A006) values (3001,1013001,'ϵͳ','ɼͻ׽ʽ',1001102,sysdate);

end cisp_etl_khjyjszjzl;
/

prompt
prompt Creating procedure CISP_ETL_LR
prompt ==============================
prompt
create or replace procedure cisp_etl_lr is
begin
  --ܲ
  /*author:
    date:2009-06-20
  */
   declare
    v_xm    number;
    v_bqje  number(19, 2); --ڷ
    v_count number;
    cursor cur_lr is
    select decode(xm,
              1010,1010,      --һӪҵ
              1020,1020,              --ѼӶ
              1030,1030,              --У֤ȯҵ
              1040,1040,              --У֤ȯҵ
              1050,1050,              --׵Ԫϯλ޾
              1060,1060,              --۽ڲƷ
              1070,1070,              --Ͷҵ
              1080,1080,              --Уҵ
              1090,1090,              --ҵ
              1100,1100,              --ҵ
              1110,1110,              --Уҵ
              1120,1120,              --УͶѯҵ
              1130,1130,              --Уʲҵ
              1140,1140,              --Уļҵ루󼯺ϣ
              1150,1150,              --ʲҵ
              1160,1160,              --ʲҵ
              1170,1170,              --רʲҵ
              1180,1180,              --Ϣ
              1190,1190,              --У1.Ϣ
              1200,1200,              --УŽͬҵϢ
              1210,1210,              --УʽϢ
              1220,1220,              --ͻʽϢ
              1230,1230,              --ҵϢ
              1240,1240,              --УȯҵϢ
              1250,1250,              --ԼϢ
              1260,1260,              --ƱѺعϢ
              1280,1280,              --2.Ϣ֧
              1290,1290,              --УعʲϢ֧
              1300,1300,              --УۻعϢ֧
              1310,1310,              --ʽϢ֧
              1320,1320,              --УתͨϢ֧
              1330,1330,              --ծȯϢ֧
              1340,1340,              --Ͷ
              1350,1350,              --УӪҵͺӪҵͶ
              1360,1360,              --ӹ˾Ͷ
              1370,1370,              --ԽڹߵͶ
              1380,1380,              --ɹ۽ʲͶ
              1390,1390,              --ڽʲͶ
              1400,1400,              --ڹߵͶ
              1410,1410,              --ʼֵ䶯
              1420,1420,              --УԽڹ߹ʼֵ䶯
              1430,1430,              --ڹ߹ʼֵ䶯
              1440,1440,              --
              1450,1450,              --ҵ
              2010,2010,              --Ӫҵ֧
              2020,2020,              --Ӫҵ˰𼰸
              2030,2030,              --ҵ񼰹
              2040,2040,              --У۾ɼ̯
              2050,2050,              --豸޷
              2060,2060,              --ְн
              2070,2070,              --֤ȯͶ߱
              2080,2080,              --ʲֵʧ
              2090,2090,              --ҵɱ
              3010,3010,              --Ӫҵ
              3020,3020,              --ӣӪҵ
              3030,3030,              --Ӫҵ֧
              4010,4010,              --ġܶ
              4020,4020,              --˰
              5010,5010,              --塢
              6010,6010,              --ۺ
              7010,7010,              --ߡۺܶ
              8010,8010,              --ʽܷ
              8020,8020               --֤ȯ˱֧
             -- 8030,8030              --֤ȯҵڲӪԱְн ֹ
                    ) as xm,
             bqje
        from t_etl_lr;

    begin
    --α
    open cur_lr;
    fetch cur_lr
      into v_xm, v_bqje;

      while cur_lr%found loop
      select count(*)
        into v_count
        from t_dact_003
       where p001 = v_xm
         and w100 = krcs_get_deptid_by_datatable('T_DACT_003');
      if v_count > 0 then
        update t_dact_003
           set a002 = v_bqje
         where p001 = v_xm
           and w100 = krcs_get_deptid_by_datatable('T_DACT_003');
      else
        insert into t_dact_003
          (P001, A002, A100, W100)
        values
          (v_xm,
           v_bqje,
           100000,
           krcs_get_deptid_by_datatable('T_DACT_003'));
      end if;
      fetch cur_lr
        into v_xm, v_bqje;
    end loop;
    close cur_lr;
    end;

    insert    into t_sys_t018(p001, P002, P003, A004, A005, A006) values(2003,
                                                                         1013001,
                                                                         'ϵͳ',
                                                                         'ɼܲ',
                                                                         1001101,
                                                                         sysdate);
    exception when others then rollback;
    insert    into t_sys_t018(p001, P002, P003, A004, A005, A006) values(2003,
                                                                         1013001,
                                                                         'ϵͳ',
                                                                         'ɼܲ',
                                                                         1001102,
                                                                         sysdate);
commit;
  end;
/

prompt
prompt Creating procedure CISP_ETL_QTJJ
prompt ================================
prompt
create or replace procedure cisp_etl_qtjj is
  v_bmid number;  --ID
begin

   v_bmid:=50008;

   --
        delete from t_db_01_014 where p001 in (1001403,1001405) and w100=v_bmid;
     insert into t_db_01_014
       select 1001403, qtjy, 100000, v_bmid from t_etl_qtjj
         union
       select 1001405, yjsr, 100000, v_bmid from t_etl_qtjj;

     commit;
             insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3008,1013001,'ϵͳ','ɼ',1001101,sysdate);
             commit;
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (3008,1013001,'ϵͳ','ɼ',1001102,sysdate);

end cisp_etl_qtjj;
/

prompt
prompt Creating procedure CISP_ETL_RZRQ_C10_1
prompt ======================================
prompt
create or replace procedure cisp_etl_rzrq_c10_1 is
   v_bmid number; --ID
begin
  --֤ȯ˾ȯҵ ĳɽڲƷ
  /*author:wull
    date:2011-10-26
  */
  v_bmid:=50008;
  --select A012 into v_bmid from krcs.t_sys_user where p001 = 'ZB115001'; --ýײ

  declare
    v_xm    number;
    v_qmye  number(19, 2); --ĩ
    v_count number;
    cursor cur_rzrq is

      select decode(xm,1,10010,
                 2,10020,
                 3,10030,
                 4,10040,
                 5,10050,
                 6,10060,
                 7,10070,
                 8,10080,
                 9,10090,
                 10,10100,
                 11,10110,
                 12,10120,
                 13,10130,
                 14,10140,
                 15,10150,
                 16,10160,
                 17,10170,
                 18,10180,
                 19,10190,
                 20,10200,
                 21,10210,
                 22,10220,
                 23,10230,
                 24,10240,
                 25,10250,
                 26,10260,
                 27,10270,
                 28,10280,
                 29,10290,
                 30,10300,
                 31,10310,
                 32,10320,
                 33,10330,
                 34,10340,
                 35,10350,
                 36,10360,
                 37,10370,
                 38,10380,
                 39,10390,
                 40,10400,
                 41,10410,
                 42,10420,
                 43,10430,
                 44,10440) as xm,
      je as qmye
from t_etl_rzrq_c10 t;



  begin
    --ʲծα
    open cur_rzrq;
    fetch cur_rzrq
      into v_xm, v_qmye;

    while cur_rzrq%found loop
      select count(*)
        into v_count
        from T_DB_30_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        update T_DB_30_001
           set a002 = v_qmye
         where p001 = v_xm
           and w100 = v_bmid;
      else
        insert into T_DB_30_001
          (P001, A002, A100, W100)
        values
          (v_xm,
           v_qmye,
           100000,
           v_bmid);
      end if;
      fetch cur_rzrq
        into v_xm, v_qmye;
    end loop;
    close cur_rzrq;



    insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(160001, 1013001, 'ȯϵͳ', '֤ȯ˾ȯҵ', 1001101, sysdate);

    update T_DB_30_001 set a003 = a002
    where p001 in (10010,10050,10060,10070,10080,10090,10190,10200,10210,10250,10260,10270,10280,10290,10300);
    exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ȯϵͳ','ܲ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ȯϵͳ','ܲ',1001102,sysdate);
    end;
  end;
/

prompt
prompt Creating procedure CISP_ETL_RZRQ_YYB_ZXTJ_JYQK
prompt ==============================================
prompt
create or replace procedure cisp_etl_rzrq_yyb_zxtj_jyqk is

begin

delete from T_ETL_YYB_RZRQ_JYQK;
insert into T_ETL_YYB_RZRQ_JYQK ( LX,
  BRANCH ,
  SECU_NAME ,
  SZ ,
  ID )
select '1', tt.BRANCH, tt.secu_name, tt.SZ, tt.rank
  from (select t.BRANCH,
               t.secu_name,
               t.SZ,
               row_number() over(partition by t.branch order by sum(t.SZ) desc) rank
          from T_ETL_YYB_RZRQ_JYQK_UNION t
         where t.lx = '1'
         group by t.branch, t.secu_name, t.SZ) tt
 where tt.rank <= 3;
insert into T_ETL_YYB_RZRQ_JYQK ( LX,
  BRANCH ,
  SECU_NAME ,
  SZ ,
  ID )
select '2', tt.BRANCH, tt.secu_name, tt.SZ, tt.rank
  from (select t.BRANCH,
               t.secu_name,
               t.SZ,
               row_number() over(partition by t.branch order by sum(t.SZ) desc) rank
          from T_ETL_YYB_RZRQ_JYQK_UNION t
         where t.lx = '2'
         group by t.branch, t.secu_name, t.SZ) tt
 where tt.rank <= 3;
commit;
  delete from T_DACT_B_R002;
  insert into T_DACT_B_R002(P001,p002,A002,A003)
  select   branch,
           decode(id,1,2001,
                 2,2002,
                 3,2003) as xm,
           t.secu_name,
           t.sz
    from T_ETL_YYB_RZRQ_JYQK t
    where t.lx = 1;


  insert into T_DACT_B_R002(P001,p002,A002,A003)
  select  branch,
          decode(id,1,2004,
                 2,2005,
                 3,2006) as xm,
           t.secu_name,
           t.sz
    from T_ETL_YYB_RZRQ_JYQK t
    where t.lx = 2;

    insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(309, 1013001, 'ȯϵͳ', 'Ӫҵȯҵ¶רͳ-', 1001101, sysdate);

  exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);

  end;
/

prompt
prompt Creating procedure CISP_ETL_RZRQ_YYB_ZXTJ_SRQK
prompt ==============================================
prompt
create or replace procedure cisp_etl_rzrq_yyb_zxtj_srqk is

begin
  --Ӫҵȯҵ¶רͳƱ-
  /*author:wull
    date:2011-10-26
  */
  declare
    v_yyb   number;
    v_xm    number;
    v_qmye  number(19, 2); --ĩ
    v_count number;
    cursor cur_srqk is

      select yyb,
             1019 as xm,
             je
        from T_ETL_YYB_RZRQ_SRQK t ;
begin
    open cur_srqk;
    fetch cur_srqk
      into  v_yyb,v_xm,v_qmye;

    while cur_srqk%found loop
      select count(*)
        into v_count
        from T_DACT_B_R001
       where p001 = v_yyb and p002 = v_xm;

      if v_count > 0 then
        update T_DACT_B_R001
           set a002 = v_qmye
         where p001 = v_yyb and p002 = v_xm;
      else
        insert into T_DACT_B_R001(P001,P002,A002) values (v_yyb,v_xm,v_qmye);
      end if;
      fetch cur_srqk
      into v_yyb,v_xm,v_qmye;
    end loop;
    close cur_srqk;


    end;


    insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(302, 1013001, 'ϵͳ', 'Ӫҵȯҵ¶רͳƱ-', 1001101, sysdate);
    exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (302,1013001,'ϵͳ','Ӫҵȯҵ¶רͳƱ-',1001102,sysdate);


 /* exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);*/

  end;
/

prompt
prompt Creating procedure CISP_ETL_RZRQ_YYB_ZXTJ_TJB
prompt =============================================
prompt
create or replace procedure cisp_etl_rzrq_yyb_zxtj_tjb
is
begin

declare
    v_yyb  number;
    v_xm number;
    v_bqje  number(19, 2);
    v_count number;
    cursor cur_work is
     select yyb,
     decode(xm,'1','1001',
     '2','1002',
     '3','1003',
     '4','1004',
     '5','1005',
     '6','1006',
     '7','1007',
     '8','1008',
     '9','1009',
     '10','1010',
     '11','1011',
     '12','1012',
     '13','1013',
     '14','1014',
     '27','1015',
     '28','1016',
     '29','1017',
     '30','1018'
     ) as xm,
      je as qmye
      from T_ETL_YYB_RZRQ_TJB;
  begin

    open cur_work;
    fetch cur_work
      into  v_yyb,v_xm,v_bqje;

    while cur_work%found loop
      select count(*)
        into v_count
        from T_DACT_B_R001
       where p001 = v_yyb and p002 = v_xm;

      if v_count > 0 then
        update T_DACT_B_R001
           set a002 = v_bqje
         where p001 = v_yyb and p002 = v_xm;
      else
        insert into T_DACT_B_R001(P001,P002,A002) values (v_yyb,v_xm,v_bqje);
      end if;
      fetch cur_work
      into v_yyb,v_xm,v_bqje;
    end loop;


     commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (302,1013001,'ϵͳ','ɼ֤ȯ˾Ӫҵȯҵ¶רͳƱ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (302,1013001,'ϵͳ','ɼ֤ȯ˾Ӫҵȯҵ¶רͳƱ',1001102,sysdate);
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_SFCG
prompt ================================
prompt
create or replace procedure cisp_etl_sfcg is
  v_bmid number;  --ID
begin

 /* select A012 into v_bmid
    from t_sys_user
   where p001 = 'ZB103001'; */
   v_bmid:=50001; --͹ܲ

    --ܽչ
     delete from t_db1_01_001 where p001 in (1001,1002,1003,1004,1005) and w100=v_bmid;
     insert into t_db1_01_001(p001,a002,a100,w100)
       --select decode(moneytype,3,1001,4,1002,0,1003,1,1004,2,1005),fundbal,100000,v_bmid
        select decode(moneytype,1,1001,2,1002,3,1003),fundbal,100000,v_bmid
       from t_etl_sfcg /*where moneytype<>3*/;
     commit;
      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (19001,1013001,'ϵͳ','ɼܽչ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (19001,1013001,'ϵͳ','ɼܽչ',1001102,sysdate);

end cisp_etl_sfcg;
/

prompt
prompt Creating procedure CISP_ETL_XSJRCP
prompt ==================================
prompt
create or replace procedure cisp_etl_XSJRCP is


begin



  --۽ڲƷͳƱ

    --α1
  declare
    v_xm  number;
    v_bqzjsl  number;
    v_bqzjje    number(19, 2);
    v_bnzjsl number;
    v_bqjssl  number;
    v_bqjsje    number(19, 2);
    v_bnjssl number;
    v_qmsl number;
    v_qmje number(19,2);
    v_count number;
    v_w100 number;
    cursor cur_work is
      select  
              decode(xm,1,1010, --֤ȯͶʻ
                 2,1020, --֤ȯ˾ʲƻ
                 3,1030, -- У˾ʲƻ
                 4,1040, --˾ʲƻ
                 5,1050, --ҵƲƷ
                 6,1060, --вƷ
                 7,1070, --ղƷ
                 8,1080, --ڲƷ
                 10,1100,--̶ڲƷ
                 11,1110,--ȨڲƷ
                 12,1120,--ڲƷ
                 13,1130,--ڲƷ
                 15,1150,-- УṹڲƷ
                 16,1160,-- ϸ߷սڲƷ
                 17,1170,--
                 18,1180,--۷ʽ
                 19,1190,--ܿͻʽ
                 21,1210,--
                 22,1220, --˹
                 24,1240,  --
                 25,1250  --
                 ) as xm,
                 bqzjsl,
                 bqzjje,
                 bnzjsl,
                 bqjssl,
                 bqjsje,
                 bnjssl
      from t_etl_xsjrcp_fse t
      where xm between 1 and 25;

    --α2

    cursor cur_work1 is
      select 
              decode(xm,1,1010, --֤ȯͶʻ
                 2,1020, --֤ȯ˾ʲƻ
                 3,1030, -- У˾ʲƻ
                 4,1040, --˾ʲƻ
                 5,1050, --ҵƲƷ
                 6,1060, --вƷ
                 7,1070, --ղƷ
                 8,1080, --ڲƷ
                 10,1100,--̶ڲƷ
                 11,1110,--ȨڲƷ
                 12,1120,--ڲƷ
                 13,1130,--ڲƷ
                 15,1150,-- УṹڲƷ
                 16,1160,-- ϸ߷սڲƷ
                 17,1170,--
                 18,1180,--۷ʽ
                 19,1190,--ܿͻʽ
                 21,1210,--
                 22,1220 --˹
                 ) as xm,
                 qmsl,
                 qmje
      from t_etl_xsjrcp_qmye t
      where xm between 1 and 22;

  --ʼα1
  begin
  
   -- select a012 into v_w100 from krcs.t_sys_user where p001 = 'ZB116001';
   v_w100:=50008;
    
    open cur_work;
    fetch cur_work
      into v_xm,v_bqzjsl,v_bqzjje,v_bnzjsl,v_bqjssl,v_bqjsje,v_bnjssl;

      update T_DB_50_001 set a002=0,a003=0,a004=0,a006=0,a007=0,a008=0 where p001 between 1010 and 1250;

    while cur_work%found loop
      select count(*)
        into v_count
        from T_DB_50_001
       where p001 = v_xm;

      if v_count > 0 then
        update T_DB_50_001
           set a002 = v_bqzjsl,
               a003 = v_bqzjje,
               a004 = v_bnzjsl,
               a006 = v_bqjssl,
               a007 = v_bqjsje,
               a008 = v_bnjssl,
               a100 = '100000',
               w100 = v_w100
         where p001 = v_xm;
      else
        insert into T_DB_50_001
          (P001, a002, A003,A004,A006,a007,a008,a100,w100)
        values
          (v_xm, v_bqzjsl,v_bqzjje,v_bnzjsl,v_bqjssl,v_bqjsje,v_bnjssl,'100000',v_w100);
      end if;
      
      update  T_DB_50_001 set a004 = nvl(a004,0) - nvl(a002,0),
                              a008 = nvl(a008,0) - nvl(a006,0)
                          where p001 = v_xm;
      
      
      fetch cur_work
        into v_xm,v_bqzjsl,v_bqzjje,v_bnzjsl,v_bqjssl,v_bqjsje,v_bnjssl;
    end loop;
    close cur_work;
   --α1


   ----ʼα2

    open cur_work1;
    fetch cur_work1
      into v_xm,v_qmsl,v_qmje;

    update T_DB_50_001 set a010=0,a011=0 where p001 between 1010 and 1220 ;

    while cur_work1%found loop
      select count(*)
        into v_count
        from T_DB_50_001
       where p001 = v_xm;

      if v_count > 0 then
        update T_DB_50_001
           set a010 = v_qmsl,
               a011 = v_qmje
         where  p001 = v_xm;
      else
        insert into T_DB_50_001
          (P001, A010, a011)
        values
          (v_xm,v_qmsl,v_qmje);
      end if;

      fetch cur_work1
        into v_xm,v_qmsl,v_qmje;
    end loop;
    close cur_work1;


    commit;
    insert into t_sys_t018(P001, P002, P003, A004, A005, A006)
    values(501, 1013001, 'ϵͳ', 'ɼ֤ȯ˾۽ڲƷͳƱ', 1001101, sysdate);
  exception
    when others then
      rollback;
      insert into t_sys_t018(P001, P002, P003, A004, A005, A006)
      values(501,1013001,'ϵͳ','ɼ֤ȯ˾۽ڲƷͳƱ',1001102,sysdate);

  end;

end;
/

prompt
prompt Creating procedure CISP_ETL_YDGH_BQSJCL
prompt =======================================
prompt
create or replace procedure cisp_etl_ydgh_bqsjcl is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ ݴ
  --select A012 into v_bmid from t_sys_user where p001 = 'ZB115001'; --ýײ
  v_bmid:=50008;
  declare
    v_xm number;
    v_qc number;
    v_zj number;
    v_qm number;
    --v_bq number;
    cursor cur_bqsj1 is
      select p001, a002, a003, a005, w100
        from t_db_62_001 t
       where t.p001 in
             (1010, 1011, 1012, 1020, 1021, 1022, 1030, 1031, 1032, 1035, 1036)
         and w100 = v_bmid;

    cursor cur_bqsj2 is
      select p001, a002, a003, a005, w100
        from t_db_62_001 t
       where t.p001 in
             (1041, 1042)
             --(1040, 1041, 1042)
         and w100 = v_bmid;
  begin
    --ʲծα
    open cur_bqsj1;
    fetch cur_bqsj1
      into v_xm, v_qc, v_zj, v_qm, v_bmid;

    while cur_bqsj1%found loop
      update t_db_62_001
         set a004 = nvl(v_qc,0) + nvl(v_zj,0) - nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      commit;
      fetch cur_bqsj1
        into v_xm, v_qc, v_zj, v_qm, v_bmid;
    end loop;
    close cur_bqsj1;

    open cur_bqsj2;
    fetch cur_bqsj2
      into v_xm, v_qc, v_zj, v_qm, v_bmid;

    while cur_bqsj2%found loop
      if nvl(v_qm,0)-nvl(v_qc,0)>0 then
      update t_db_62_001
         set a003 = nvl(v_qm,0)-nvl(v_qc,0)
       where p001 = v_xm
         and w100 = v_bmid;
      else
      update t_db_62_001
         set a004 = nvl(v_qc,0)-nvl(v_qm,0)
       where p001 = v_xm
         and w100 = v_bmid;
      end if;
      commit;
      fetch cur_bqsj2
        into v_xm, v_qc, v_zj, v_qm, v_bmid;
    end loop;
    close cur_bqsj2;

    delete from t_db_62_001 where p001 = 1040;
    commit;
    insert into t_db_62_001
      select 1040,
             sum(nvl(a002, 0)),
             sum(nvl(a003, 0)),
             sum(nvl(a004, 0)),
             sum(nvl(a005, 0)),
             100000,
             v_bmid
        from t_db_62_001
       where p001 in (1041, 1042);
    commit;

  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_YDGH_JYB
prompt ====================================
prompt
create or replace procedure cisp_etl_ydgh_jyb is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  --select A012 into v_bmid from t_sys_user where p001 = 'ZB115001'; --ýײ
  v_bmid:=50008;
  declare
    v_xm    number;
    v_sl    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is

      select decode(xm,
                    1,1010, --ǩԼͻ
                    2,1011, --Уͻ
                    3,1012, --˿ͻ
                    4,1020, --ڴؽ׿ͻ
                    5,1021, --Уͻ
                    6,1022  --˿ͻ
                    ) as xm,
             sl as sl,
             jylx as jylx
        from t_etl_c13_2_sl t;

    cursor cur_ydsgh2 is

      select decode(xm,
                    7,1030,  --ؽ׽Ԫ
                    8,1031,  --УϺгؽ׽
                    9,1032,  --гؽ׽
                    10,1033, --Уʣ1
                    11,1034, --ʣ1
                    12,1035, --Уͻ
                    13,1036, --˿ͻ
                    14,1040, --ر֤ȯֵԪ
                    15,1041, --УϺг֤ȯֵ
                    16,1042, --г֤ȯֵ
                    17,1050, --ΥԼͻ
                    18,1051, --Уͻ
                    19,1052, --˿ͻ
                    20,1060, --ΥԼԪ
                    21,1061, --Уͻ
                    22,1062, --˿ͻ
                    23,1070  --Լϱ
                    ) as xm,je,jylx
        from t_etl_c13_2_je t where xm between 7 and 23;

  begin
    --ʲծα
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_sl, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_62_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_62_001
             set a003 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_62_001
             set a005 = v_sl
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_62_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_62_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_sl, v_jylx;
    end loop;
    close cur_ydsgh1;

    open cur_ydsgh2;
    fetch cur_ydsgh2
      into v_xm, v_je, v_jylx;

    while cur_ydsgh2%found loop
      select count(*)
        into v_count
        from t_db_62_001
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_62_001
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_62_001
             set a005 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_62_001
            (P001, A003, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        else
          insert into t_db_62_001
            (P001, A005, A100, W100)
          values
            (v_xm, v_sl, 100000, v_bmid);
        end if;
      end if;
      fetch cur_ydsgh2
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh2;

    --ĩԼϱɰٷ add by jiangbt 20140211
    --update t_db_62_001 set a005=a005*100 where p001 = 1070 and w100 = v_bmid;
    --commit;

    cisp_etl_ydgh_bqsjcl;
    /*insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(160001, 1013001, 'ȯϵͳ', '֤ȯ˾ȯҵ', 1001101, sysdate);

    update T_DB_30_001 set a003 = a002
    where p001 in (10010,10050,10060,10070,10080,10090,10190,10200,10210,10250,10260,10270,10280,10290,10300);
    exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);*/
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_YDGH_JYB_HGLL
prompt =========================================
prompt
create or replace procedure cisp_etl_ydgh_jyb_hgll is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  --select A012 into v_bmid from t_sys_user where p001 = 'ZB115001'; --ýײ
   v_bmid:=50008;
  declare
    v_xm    number;
    v_je    number;
    v_jylx  number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    28,1101,
                    29,1102) as xm,je,jylx
        from t_etl_c13_2_je t where xm between 28 and 29;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je, v_jylx;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_62_003
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
        if v_jylx = 1 then
          update t_db_62_003
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        else
          update t_db_62_003
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      else
        if v_jylx = 1 then
          insert into t_db_62_003
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
        else
          update t_db_62_003
             set a003 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
        end if;
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je, v_jylx;
    end loop;
    close cur_ydsgh1;


    /*insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(160001, 1013001, 'ȯϵͳ', '֤ȯ˾ȯҵ', 1001101, sysdate);

    update T_DB_30_001 set a003 = a002
    where p001 in (10010,10050,10060,10070,10080,10090,10190,10200,10210,10250,10260,10270,10280,10290,10300);
    exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);*/
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_YDGH_JYB_LJYWGM
prompt ===========================================
prompt
create or replace procedure cisp_etl_ydgh_jyb_ljywgm is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  --select A012 into v_bmid from t_sys_user where p001 = 'ZB115001'; --ýײ
   v_bmid:=50008;
  declare
    v_xm    number;
    v_je    number;
    v_count number;
    cursor cur_ydsgh1 is
      select decode(xm,
                    24,1080,
                    25,1081,
                    26,1082,
                    27,1090) as xm,je
        from t_etl_c13_2_je t where xm between 24 and 27;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_xm, v_je;

    while cur_ydsgh1%found loop
      select count(*)
        into v_count
        from t_db_62_002
       where p001 = v_xm
         and w100 = v_bmid;
      if v_count > 0 then
          update t_db_62_002
             set a002 = v_je
           where p001 = v_xm
             and w100 = v_bmid;
      else
          insert into t_db_62_002
            (P001, A002, A100, W100)
          values
            (v_xm, v_je, 100000, v_bmid);
      end if;
      fetch cur_ydsgh1
        into v_xm, v_je;
    end loop;
    close cur_ydsgh1;

    /*insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(160001, 1013001, 'ȯϵͳ', '֤ȯ˾ȯҵ', 1001101, sysdate);

    update T_DB_30_001 set a003 = a002
    where p001 in (10010,10050,10060,10070,10080,10090,10190,10200,10210,10250,10260,10270,10280,10290,10300);
    exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);*/
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_YDGH_JYB_YWMX1
prompt ==========================================
prompt
create or replace procedure cisp_etl_ydgh_jyb_ywmx1 is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  --select A012 into v_bmid from t_sys_user where p001 = 'ZB115001'; --ýײ
   v_bmid:=50008;
  declare
    v_dm    varchar2(32);
    v_mc    varchar2(64);
    v_je    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    cursor cur_ydsgh1 is
      select dm, mc, je, sz, bl_a, bl_b, rownum
        from t_etl_c13_2_ywmx1 t
       where rownum < 6
       order by je desc;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_dm,v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;

    delete from t_db_62_004;
    commit;
    while cur_ydsgh1%found loop
          insert into t_db_62_004
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_dm, v_mc, v_je, v_sz, v_bl_a, v_bl_b, v_pm;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211
    --update t_db_62_004 set a005=a005*100,a006=a006*100 where w100 = v_bmid;
   -- commit;

    /*insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(160001, 1013001, 'ȯϵͳ', '֤ȯ˾ȯҵ', 1001101, sysdate);

    update T_DB_30_001 set a003 = a002
    where p001 in (10010,10050,10060,10070,10080,10090,10190,10200,10210,10250,10260,10270,10280,10290,10300);
    exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);*/
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_YDGH_JYB_YWMX2
prompt ==========================================
prompt
create or replace procedure cisp_etl_ydgh_jyb_ywmx2 is
  v_bmid number; --ID
begin
  --֤ȯ˾Լʽ֤ȯ
  --select A012 into v_bmid from t_sys_user where p001 = 'ZB115001'; --ýײ
   v_bmid:=50008;
  declare
    v_mc    varchar2(64);
    v_sl    number;
    v_sz    number;
    v_bl_a  number;
    v_bl_b  number;
    v_pm    number;
    v_stkname varchar2(64);
    cursor cur_ydsgh1 is
      select mc, sl, sz, bl_a, bl_b, rownum,stk_name
        from t_etl_c13_2_ywmx2 t
       where rownum < 6;

  begin
    open cur_ydsgh1;
    fetch cur_ydsgh1
      into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;

    delete from t_db_62_005;
    commit;
    while cur_ydsgh1%found loop
          insert into t_db_62_005
            (P001, A002, A003, A004, A005, A006, A100, W100, PM)
          values
            (v_mc, v_stkname, v_sl, v_sz, v_bl_a, v_bl_b, 100000, v_bmid, v_pm);
      fetch cur_ydsgh1
        into v_mc, v_sl, v_sz, v_bl_a, v_bl_b, v_pm, v_stkname;
    end loop;
    close cur_ydsgh1;

    --ɰٷ add by jiangbt 20140211
    --update t_db_62_005 set a005=a005*100,a006=a006*100 where w100 = v_bmid;
    --commit;

    /*insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(160001, 1013001, 'ȯϵͳ', '֤ȯ˾ȯҵ', 1001101, sysdate);

    update T_DB_30_001 set a003 = a002
    where p001 in (10010,10050,10060,10070,10080,10090,10190,10200,10210,10250,10260,10270,10280,10290,10300);
    exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);*/
  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_YHJSCYZ_C8_1
prompt ========================================
prompt
create or replace procedure cisp_etl_yhjscyz_c8_1
is
    v_bmid number; --ID
begin
  --C8-1мг
  /*author:ΰ
    date:20101222 14:29:09
  */
  --select A012 into v_bmid from t_sys_user where p001 = 'bgywzb'; --ƻ
  v_bmid:=60004;

  declare
    v_xm number;
    v_bqzj  number(19, 2);
    v_bqjs  number(19, 2);
    v_count number;
    cursor cur_work is
      select decode(xm,1,1001  ,--ͬҵ
                       2,1002  ,--  ͬҵ--ʽ
                       3,1003    ,--ͬҵ--ʽ
                       4,1004    ,--ծȯȯ
                       5,1005    ,--ծȯع
                       6,1006    ,--ծȯع
                       7,1007    ,--ծȯع--Ѻʽ
                       8,1008    ,--ծȯع--ʽ
                       9,1009    ,--ծȯعڳ
                       10,1010    ,--ծȯعڳ--Ѻʽ
                       11,1011    ,--ծȯعڳ--ʽ
                       12,1012    ,--ծȯԶ
                       13,1013    ,--еĶȯ
                       14,1014     --
                    ),
                     bqzj,--
                     bqjs--ڼ
        from t_etl_yhjscyz;
  begin
    open cur_work;
    fetch cur_work
      into v_xm,v_bqzj,v_bqjs;

    while cur_work%found loop
      select count(*)
        into v_count
        from T_DB_12_001
       where p001 = v_xm
       and w100 = v_bmid;

      if v_count > 0 then
        update T_DB_12_001
           set a003 = v_bqzj,
               a004 = v_bqjs
         where p001 = v_xm
         and w100 = v_bmid;
      else
        insert into T_DB_12_001(P001,A003,A004,A100,W100) values (v_xm,v_bqzj,v_bqjs,100000,v_bmid);
      end if;
      fetch cur_work
      into v_xm,v_bqzj,v_bqjs;
    end loop;

     commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (1001,14001,'C8-1','мг',14001,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (1001,14001,'14001','мг',14001,sysdate);



  end;
end;
/

prompt
prompt Creating procedure CISP_ETL_YYB_DBZZ
prompt ====================================
prompt
create or replace procedure cisp_etl_yyb_dbzz
is
begin
  --Ӫҵɷתý
  /*author:
    date:2008-06-10
  */

  insert into T_DB_B4_02( P001, P002, A003, A004, A005, A006, A007, A008  )
    select p001, 1013, 0, 0, 0, 0, 0, 0
      from KRCS.T_CTL_T036 t
     where a008 = 1023008
       and b001 = 1001101
       and not exists(
               select 1
                 from T_DB_B4_02
                where p001 = t.p001
                  and p002 = 1013
           );

    update T_DB_B4_02 t
       set a003 = (select jyje from T_ETL_YYB_DBZZ where t.p001 =yyb and bz=0),
           a004 = (select jyje from T_ETL_YYB_DBZZ where t.p001 =yyb and bz=1),
           a005 = (select jyje from T_ETL_YYB_DBZZ where t.p001 =yyb and bz=2);
   commit;


     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (402,1013001,'ϵͳ','ɼӪҵɷתý',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (402,1013001,'ϵͳ','ɼӪҵɷתý',1001102,sysdate);

end cisp_etl_yyb_dbzz;
/

prompt
prompt Creating procedure CISP_ETL_YYB_JJZH
prompt ====================================
prompt
create or replace procedure cisp_etl_yyb_jjzh
is
begin

  --Ӫҵ˻-˻
  /*author:
    date:2008-06-10
  */
     delete from t_db_b3_03 where p002 in (1002, 1003, 1004, 1005,1006,1007,1008,1009,1010,1011);
     insert into t_db_b3_03(p001,p002,a003)
       --
      select distinct t.yyb, 1002, nvl((select 
              nvl(sum(sl),0)
       from t_etl_yyb_jjzh
       where khlx in (0,1) and jylx=1
       and yyb=t.yyb
       group by yyb),0) 
    from t_etl_yyb_jjzh t
       union
       select t.yyb,
              1006,--ֳ
              nvl(zj,0)-nvl(wskh,0)-nvl(jzkh,0)
        from(
             select  t.yyb,
                     (select sum(sl) as zj from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =1) as zj,
                     (select sum(sl) as zj from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =12 ) as wskh,
                     (select sum(sl) as qm from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =13 ) as jzkh
             from t_etl_yyb_jjzh t
             group by t.yyb
            ) t
       union
       select yyb,
              1007, --Ͽ
              nvl(sum(sl),0)
             
       from t_etl_yyb_jjzh
       where khlx in (0,1) and jylx=12
       group by yyb
       union
       select yyb,
              1008,--ֳ
              sum(sl)
       from t_etl_yyb_jjzh
       where khlx in (0,1) and jylx=13
       group by yyb
       union
       select yyb,
              1010,--ֳ
              sum(sl)
       from t_etl_yyb_jjzh
       where khlx in (0,1) and jylx=22
       group by yyb
       union
       --ڼ
     /* select yyb,
              1003,
              sum(sl)
       from t_etl_yyb_jjzh
       where khlx in (0,1) and jylx=2
       group by yyb
      */
      --ڳ+-ĩڼ update by wull in shanghai stock 2008-7-29
       select t.yyb,
              1003,
              nvl(qc,0)+nvl(zj,0)-nvl(qm,0)
        from(
             select  t.yyb,
                     (select a003 as qc from t_db_b3_03 where p001=t.yyb and  p002=1001) as qc,
                     (select sum(sl) as zj from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =1 ) as zj,
                     (select sum(sl) as qm from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =3 ) as qm
             from t_etl_yyb_jjzh t
             group by t.yyb
            ) t
       union

       select t.yyb,
              1009,--ֳ
              nvl(qc,0)+nvl(zj,0)-nvl(qm,0)-nvl(wsxh,0)
        from(
             select  t.yyb,
                     (select a003 as qc from t_db_b3_03 where p001=t.yyb and  p002=1001) as qc,
                     (select sum(sl) as zj from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =1 ) as zj,
                     (select sum(sl) as qm from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =3 ) as qm,
                     (select sum(sl) as wsxh from t_etl_yyb_jjzh where yyb=t.yyb and khlx in (0,1) and jylx =22 ) as wsxh
             from t_etl_yyb_jjzh t
             group by t.yyb
            ) t
       union
       --ĩ
       select yyb,
              1004,
              sum(sl)
       from t_etl_yyb_jjzh
       where khlx in (0,1) and jylx=3
       group by yyb
       union
       --У
       select yyb,
              1005,
              sum(sl)
       from t_etl_yyb_jjzh
       where khlx =1 and jylx=3
       group by yyb;
       commit;

    --ڲɱΪΪ0м뵽ȥ
    update t_db_b3_03 a
       set A003 =   A003 - (select (case when sum(b.A003) < 0 then sum(b.A003) else 0 end)
                               from t_db_b3_03 b
                              where b.p002 = 1003
                                and b.p001 = a.p001)
     where p002 = 1002;
     commit;
    -- С 0ʱϿ
    update t_db_b3_03 a
       set A003 =   A003 - (select (case when sum(b.A003) < 0 then sum(b.A003) else 0 end)
                               from t_db_b3_03 b
                              where b.p002 = 1003
                                and b.p001 = a.p001)
     where p002 = 1007;
     commit;     

    update t_db_b3_03
       set A003 = 0
     where p002 = 1003
       and A003 < 0;
       commit;

       update t_db_b3_03
       set A003 = 0
     where p002 = 1009
       and A003 < 0;

      commit;
     /* update t_db_b3_03 a set a003=
      (select sum(a003) from t_db_b3_03 b where a.p001=b.p001 and b.p002 in(1006,1007,1008))
      where a.p002=1002;
      commit;*/

      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (303,1013001,'ϵͳ','ɼӪҵ˻-˻',1001101,sysdate);
      exception
      when others then
        rollback;
      insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (303,1013001,'ϵͳ','ɼӪҵ˻-˻',1001102,sysdate);



end cisp_etl_yyb_jjzh;
/

prompt
prompt Creating procedure CISP_ETL_YYB_KHJYJSZJ
prompt ========================================
prompt
create or replace procedure cisp_etl_yyb_khjyjszj
is
begin

  --Ӫҵ̨ͻ׽ʽ

 declare
    v_yyb  number;
    v_jylx number;
    v_je  number(19, 2);
    v_count number;
    cursor cur_work is
      select yyb,
             decode(jylx,1,1001,
                         2,1002,
                         3,1003,
                         5,1005,
                         4,1004,
                         6,1006,
                         7,1007,
                         9,1009,
                         10,1010,
                         11,1011,
                         13,1013,
                         14,2001),
             je
      from (
            select yyb,jylx,sum(je) je
            from (
              select yyb,jylx,je from t_etl_yyb_khjyjszj
              union all
              select yyb,jylx,je from t_etl_yyb_khjyjszj_rzrq
            )
            group by yyb,jylx
        );

  begin
    update T_DB_B2_01 set A003 = 0 where p002 in(1001,1002,1003,1004,1005,1006,1007,1009,1010,1011,1013,2001);
    open cur_work;
    fetch cur_work
      into  v_yyb,v_jylx,v_je;

    while cur_work%found loop
      select count(*)
        into v_count
        from T_DB_B2_01
       where p001 = v_yyb and p002 = v_jylx;

      if v_count > 0 then
        update T_DB_B2_01
           set A003 = v_je
         where p001 = v_yyb and p002 = v_jylx;
      else
        insert into T_DB_B2_01(P001,P002,A003) values (v_yyb,v_jylx,v_je);
      end if;
      fetch cur_work
      into v_yyb,v_jylx,v_je;
    end loop;
 end;
    --ͻʲеģͻ׽ʽֻпͻʲϼƳִزʱҪ¼
    insert into t_db_b2_01( p001, p002, a003 )
              select p001,1008,0
                from krcs.t_ctl_t036 a
               where a008 = 1023008
                 and not exists(
                     select 1
                     from t_db_b2_01
                     where p001 = a.p001
                       and p002 = 1008);

     update t_db_b2_01 t
        set a003=(
                  select sum(decode(p002,1001,a003,-a003))
                    from t_db_b2_01
                   where p001 = t.p001
                     and p002 in(1001,1002,1003,1004,1005,1006,1007)
              )
      where p002=1008;

    --ͻʲеģͻʲϼƣң,ֻпͻʲϼƳִزʱҪ¼ϼ
    insert into t_db_b2_01( p001, p002, a003 )
              select p001,1012,0
                from krcs.t_ctl_t036 a
               where a008 = 1023008
                 and not exists(
                     select 1
                     from t_db_b2_01
                     where p001 = a.p001
                       and p002 = 1012);

     update t_db_b2_01 t
        set a003=(
                  select sum(a003)
                    from t_db_b2_01
                   where p001 = t.p001
                     and p002 in(1001,1009,1010,1011)
              )
      where p002=1012;

     commit;

  /*   insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (201,1013001,'ϵͳ','ɼӪҵͻʲ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (201,1013001,'ϵͳ','ɼӪҵͻʲ',1001102,sysdate);
 commit;*/
end cisp_etl_yyb_khjyjszj;
/

prompt
prompt Creating procedure CISP_ETL_YYB_KHZJFB
prompt ======================================
prompt
create or replace procedure cisp_etl_yyb_khzjfb
is
begin

  --Ӫҵͻʽֲ
  /*author:wuxg
    date:2015-07-10
  */
declare
    v_yyb  number;
    v_yhdm  varchar(10);
    v_yhmc  varchar(20);
    v_khsl  number;
    v_zjye  number(19, 2);
    v_count number;
    cursor cur_work is
      select yyb,
             yhdm,
             yhmc,
             khsl,
             zjye
      from (select a.yyb,a.yhdm,a.yhmc as yhmc,sum(a.khsl) khsl,sum(a.zjye) zjye
            from
            ( select yyb,yhdm,yhmc,khsl,zjye from t_etl_yyb_khzjfb
              union all
              select a.yyb,b.hs_bank_code,b.hs_bank_name,a.khsl,a.zjye from t_etl_yyb_khzjfb_rzrq a ,rzrq_bank b
              where a.yhdm=b.rzrq_bank_code
            ) a
            group by a.yyb,a.yhdm,a.yhmc
            );
  begin
    update T_DB_B2_02 set A006 = 0,A007=0;
    open cur_work;
    fetch cur_work
      into  v_yyb,v_yhdm,v_yhmc,v_khsl,v_zjye;

    while cur_work%found loop
      select count(*)
        into v_count
        from T_DB_B2_02
       where p001 = v_yyb and p002=v_yhdm;

      if v_count > 0 then
        update T_DB_B2_02
           set A006 = v_khsl,A007=v_zjye
         where p001 = v_yyb and p002=v_yhdm;
      else
        insert into T_DB_B2_02(P001,P002,A003,A006,A007) values (v_yyb,v_yhdm,v_yhmc,v_khsl,v_zjye);
      end if;
      fetch cur_work
      into v_yyb,v_yhdm,v_yhmc,v_khsl,v_zjye;
    end loop;
      commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (202,1013001,'ϵͳ','ɼӪҵͻʽֲ',1001101,sysdate);
      exception
      when others then
        rollback;
     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (202,1013001,'ϵͳ','ɼӪҵͻʽֲ',1001102,sysdate);


  end;
end cisp_etl_yyb_khzjfb;
/

prompt
prompt Creating procedure CISP_ETL_YYB_SY
prompt ==================================
prompt
create or replace procedure cisp_etl_yyb_sy
is
begin
 --Ӫҵ
  /*author:
    date:2008-06-10
  */

declare
    v_yyb  number;
    v_xm number;
    v_bqje  number(19, 2);
    v_count number;
    cursor cur_work is
      select a.yyb,
             decode(a.xm,1,2001,-- Ӫҵ
                          2,2002,--   УѼӶ
                          3,2003,--         Ϣ
                          4,2004,-- Ӫҵ֧
                          5,2005,--   У֧
                          6,2006,--         Ӷ֧
                          7,2007,--        Ϣ֧
                          8,2008,--        Ӫҵ˰𼰸
                          9,2009,--        ҵ񼰹
                          10,2010,--       У۾ɼ̯
                          11,2011,--             豸޷
                          12,2012,--              ְн
                          13,2013,--              豸ת
                          14,2014,--Ӫҵ
                          15,2015,--ܶ
                          16,2016,--˰
                          17,2017),--
              a.bqje
        from T_ETL_YYB_SY a;
  begin
      update t_db_b1_02 set a003 = 0;
    open cur_work;
    fetch cur_work
      into  v_yyb,v_xm,v_bqje;

    while cur_work%found loop
      select count(*)
        into v_count
        from t_db_b1_02
       where p001 = v_yyb and p002 = v_xm;

      if v_count > 0 then
        update t_db_b1_02
           set a003 = v_bqje
         where p001 = v_yyb and p002 = v_xm;
      else
        insert into t_db_b1_02(P001,P002,A003) values (v_yyb,v_xm,v_bqje);
      end if;
      fetch cur_work
      into v_yyb,v_xm,v_bqje;
    end loop;

     commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (102,1013001,'ϵͳ','ɼӪҵ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (102,1013001,'ϵͳ','ɼӪҵ',1001102,sysdate);



  end;

end;
/

prompt
prompt Creating procedure CISP_ETL_YYB_XSJRCP
prompt ======================================
prompt
create or replace procedure cisp_etl_yyb_XSJRCP is


begin

  --۽ڲƷͳƱ

 --α1
  declare
    v_yyb number;
    v_xm  number;
    v_bqzjsl  number;
    v_bqzjje    number(19, 2);
    v_bnzjsl number;
    v_bqjssl  number;
    v_bqjsje    number(19, 2);
    v_bnjssl number;
    v_qmsl number;
    v_qmje number(19,2);
    v_count number;
    cursor cur_work is
      select  yyb,
              decode(xm,1,1010, --֤ȯͶʻ
                 2,1020, --֤ȯ˾ʲƻ
                 3,1030, -- У˾ʲƻ
                 4,1040, --˾ʲƻ
                 5,1050, --ҵƲƷ
                 6,1060, --вƷ
                 7,1070, --ղƷ
                 8,1080, --ڲƷ
                 10,1100,--̶ڲƷ
                 11,1110,--ȨڲƷ
                 12,1120,--ڲƷ
                 13,1130,--ڲƷ
                 15,1150,-- УṹڲƷ
                 16,1160,-- ϸ߷սڲƷ
                 17,1170,--
                 18,1180,--۷ʽ
                 19,1190,--ܿͻʽ
                 21,1210,--
                 22,1220,--˹
                 24,1240,--
                 25,1250 --
                 ) as xm,
                 bqzjsl,
                 bqzjje,
                 bnzjsl,
                 bqjssl,
                 bqjsje,
                 bnjssl
      from t_etl_yyb_xsjrcp_fse t
      where xm between 1 and 25 and yyb is not null
      ;



    --α2

    cursor cur_work1 is
      select  yyb,
              decode(xm,1,1010, --֤ȯͶʻ
                 2,1020, --֤ȯ˾ʲƻ
                 3,1030, -- У˾ʲƻ
                 4,1040, --˾ʲƻ
                 5,1050, --ҵƲƷ
                 6,1060, --вƷ
                 7,1070, --ղƷ
                 8,1080, --ڲƷ
                 10,1100,--̶ڲƷ
                 11,1110,--ȨڲƷ
                 12,1120,--ڲƷ
                 13,1130,--ڲƷ
                 15,1150,-- УṹڲƷ
                 16,1160,-- ϸ߷սڲƷ
                 17,1170,--
                 18,1180,--۷ʽ
                 19,1190,--ܿͻʽ
                 21,1210,--
                 22,1220 --˹
                 ) as xm,
                 qmsl,
                 qmje
      from t_etl_yyb_xsjrcp_qmye t
      where xm between 1 and 22
      and yyb is not null
      ;

 
  --ʼα1
  begin
    open cur_work;
    fetch cur_work
      into v_yyb,v_xm,v_bqzjsl,v_bqzjje,v_bnzjsl,v_bqjssl,v_bqjsje,v_bnjssl;

      update T_DB_B50_01 set a003=0,a004=0,a005=0,a007=0,a008=0,a009=0 where p002 between 1010 and 1250 /*and p001 =v_yyb*/ ;
commit;
    while cur_work%found loop
      select count(*)
        into v_count
        from T_DB_B50_01
       where p001 = v_yyb
         and p002 = v_xm;

      if v_count > 0 then
        update T_DB_B50_01
           set a003 = v_bqzjsl,
               a004 = v_bqzjje,
               a005 = nvl(v_bnzjsl,0)/* - nvl(v_bqzjsl,0)*/,
               a007 = v_bqjssl,
               a008 = v_bqjsje,
               a009 = nvl(v_bnjssl,0)/* -nvl(v_bqjssl,0)*/
         where p001 = v_yyb
           and p002 = v_xm;
      else
        insert into T_DB_B50_01
          (P001, p002, A003,A004,A005,a007,a008,a009)
        values
          (v_yyb,v_xm, v_bqzjsl,v_bqzjje,v_bnzjsl,v_bqjssl,v_bqjsje,v_bnjssl);
      end if;
      commit;
      fetch cur_work
        into v_yyb,v_xm,v_bqzjsl,v_bqzjje,v_bnzjsl,v_bqjssl,v_bqjsje,v_bnjssl;
    end loop;
    close cur_work;
   --α1



   ----ʼα2
  
    open cur_work1;
    fetch cur_work1
      into v_yyb,v_xm,v_qmsl,v_qmje;

    update T_DB_B50_01 set a011=0,a012=0 where p002 between 1010 and 1220 /*and p001 =v_yyb*/;
commit;
    while cur_work1%found loop
      select count(*)
        into v_count
        from T_DB_B50_01
       where p001 = v_yyb
         and p002 = v_xm;

      if v_count > 0 then
        update T_DB_B50_01
           set a011 = v_qmsl,
               a012 = v_qmje
         where p001 = v_yyb
           and p002 = v_xm;
      else
        insert into T_DB_B50_01
          (P001, p002,A011, a012)
        values
          (v_yyb,v_xm,v_qmsl,v_qmje);
      end if;

      fetch cur_work1
        into v_yyb,v_xm,v_qmsl,v_qmje;
    end loop;
    close cur_work1;


    commit;
    insert into t_sys_t018(P001, P002, P003, A004, A005, A006)
    values(501, 1013001, 'ϵͳ', 'ɼӪҵ۽ڲƷͳƱ', 1001101, sysdate);
  exception
    when others then
      rollback;
      insert into t_sys_t018(P001, P002, P003, A004, A005, A006)
      values(501,1013001,'ϵͳ','ɼӪҵ۽ڲƷͳƱ',1001102,sysdate);

  end;




end;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZCFZ
prompt ====================================
prompt
create or replace procedure cisp_etl_yyb_zcfz
is
begin
 --Ӫҵʲծ
  /*author:
    date:2008-06-10
  */

declare
    v_yyb  number;
    v_xm number;
    v_qmye  number(19, 2);
    v_ncye  number(19, 2);
    v_count number;
    --ʲծ
    cursor zcfz is
      select a.yyb,
             decode(a.xm,1,1001,-- ʲܶ
                          2,1002,-- Удʽ
                          3,1003,--       Ӧտڲ
                          4,1004,--       ڲ
                          5,1005,--       ̶ʲԭֵ
                          6,1006,--       ̶ʲֵ
                          7,1007,--ծܶ
                          8,1008,--У֤ȯ
                          9,1009,--      У֤ȯ-
                          10,1010,--      Ӧڲ
                          11,1011,--      ڲ
                          12,1012),--ʲֵ
              a.qmye,
              a.ncye
       from T_ETL_YYB_ZCFZ a
       where a.xm not in (24);

     --ͻʲ
    cursor khzc is
      select a.yyb,
             decode(a.xm,9,1001,
                        24,1004),
             a.qmye
       from T_ETL_YYB_ZCFZ a
       where a.xm in (9,24);
  begin
    --ʲծα
    update t_db_b1_01 set a003 = 0/*,a004 = 0*/;
    --update T_DB_B2_01 set a003 = 0 where P002 in(1001,1004);

    open zcfz;
    fetch zcfz
      into  v_yyb,v_xm,v_qmye,v_ncye;

    while zcfz%found loop
      select count(*)
        into v_count
        from t_db_b1_01
       where p001 = v_yyb and p002 = v_xm;
    if v_count > 0 then
        update t_db_b1_01
           set a003 = v_qmye/*,a004 = v_ncye*/
         where p001 = v_yyb and p002 = v_xm;
    else
        insert into t_db_b1_01(P001,P002,A003,A004) values (v_yyb,v_xm,v_qmye,v_ncye);
    end if;
    fetch zcfz
    into v_yyb,v_xm,v_qmye,v_ncye;
    end loop;
    close zcfz;

    --򿪿ͻʲα
  /*  open khzc;
    fetch khzc
      into  v_yyb,v_xm,v_qmye;

    while khzc%found loop
      select count(*)
        into v_count
        from T_DB_B2_01
       where p001 = v_yyb and p002 = v_xm;
    if v_count > 0 then
        update T_DB_B2_01
           set a003 = v_qmye
         where p001 = v_yyb and p002 = v_xm;
    else
        insert into T_DB_B2_01(P001,P002,A003) values (v_yyb,v_xm,v_qmye);
    end if;
    fetch khzc
    into v_yyb,v_xm,v_qmye;
    end loop;
    close khzc;
    commit;

    --ͻʲеģͻ׽ʽ
    insert into t_db_b2_01( p001, p002, a003 )
              select p001,1008,0
                from krcs.t_ctl_t036 a
               where a008 = 1023008
                 and not exists(
                     select 1
                     from t_db_b2_01
                     where p001 = a.p001
                       and p002 = 1008);

     update t_db_b2_01 t
        set a003=(
                  select sum(decode(p002,1001,a003,-a003))
                    from t_db_b2_01
                   where p001 = t.p001
                     and p002 in(1001,1002,1003,1004,1005,1006,1007)
              )
      where p002=1008;


      --ͻʲеģͻʲϼƣң
    insert into t_db_b2_01( p001, p002, a003 )
              select p001,1012,0
                from krcs.t_ctl_t036 a
               where a008 = 1023008
                 and not exists(
                     select 1
                     from t_db_b2_01
                     where p001 = a.p001
                       and p002 = 1012);

     update t_db_b2_01 t
        set a003=(
                  select sum(a003)
                    from t_db_b2_01
                   where p001 = t.p001
                     and p002 in(1001,1009,1010,1011)
              )
      where p002=1012;*/

    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (101,1013001,'ϵͳ','ɼӪҵʲծ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (101,1013001,'ϵͳ','ɼӪҵʲծ',1001102,sysdate);



  end;

end;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZHBD_ZJZH
prompt =========================================
prompt
create or replace procedure CISP_ETL_YYB_ZHBD_ZJZH
is
 --Ӫҵ˻䶯-ʽ˻
  /*author:
    date:2008-07-23
  */
begin
    delete from t_db_b3_05 where p002 in (2003,2005);
    insert into t_db_b3_05(p001,p002,a003,a004,a005,a006)
      select yyb,
             2003,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 1 and zhlx in (2) and yyb = t.yyb) as cj,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 2 and zhlx in (2) and yyb = t.yyb) as gf,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 3 and zhlx in (2) and yyb = t.yyb) as jh,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 4 and zhlx in (2) and yyb = t.yyb) as zx
     from T_ETL_YYB_ZHBD_ZJZH t
     union
     select yyb,
             2005,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 1 and zhlx in (3) and yyb = t.yyb) as cj,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 2 and zhlx in (3) and yyb = t.yyb) as gf,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 3 and zhlx in (3) and yyb = t.yyb) as jh,
             (select sl from T_ETL_YYB_ZHBD_ZJZH where jylx = 4 and zhlx in (3) and yyb = t.yyb) as zx
     from T_ETL_YYB_ZHBD_ZJZH t;
  commit;
  insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (305,1013001,'ϵͳ','ɼӪҵ˻䶯-ʽ˻',1001101,sysdate);
      exception
      when others then
        rollback;
  insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (305,1013001,'ϵͳ','ɼӪҵ˻䶯-ʽ˻',1001102,sysdate);


end CISP_ETL_YYB_ZHBD_ZJZH;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZHBD_ZQZH
prompt =========================================
prompt
create or replace procedure CISP_ETL_YYB_ZHBD_ZQZH
is
   --Ӫҵ˻䶯-֤ȯ˻
  /*author:
    date:2008-07-23
  */
begin
    delete from t_db_b3_05 where p002 in (2004,2006);
    insert into t_db_b3_05(p001,p002,a003,a004,a005,a006)
      select yyb,
             2004,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 1 and zhlx in (2) and yyb = t.yyb) as cj,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 2 and zhlx in (2) and yyb = t.yyb) as gf,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 3 and zhlx in (2) and yyb = t.yyb) as jh,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 4 and zhlx in (2) and yyb = t.yyb) as zx
     from T_ETL_YYB_ZHBD_ZQZH t
     union
     select yyb,
             2006,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 1 and zhlx in (3) and yyb = t.yyb) as cj,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 2 and zhlx in (3) and yyb = t.yyb) as gf,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 3 and zhlx in (3) and yyb = t.yyb) as jh,
             (select sl from T_ETL_YYB_ZHBD_ZQZH where jylx = 4 and zhlx in (3) and yyb = t.yyb) as zx
     from T_ETL_YYB_ZHBD_ZQZH t;
  commit;
  insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (305,1013001,'ϵͳ','ɼӪҵ˻䶯-֤ȯ˻',1001101,sysdate);
      exception
      when others then
        rollback;
  insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (305,1013001,'ϵͳ','ɼӪҵ˻䶯-֤ȯ˻',1001102,sysdate);


end CISP_ETL_YYB_ZHBD_ZQZH;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZHGF_ZJZH
prompt =========================================
prompt
create or replace procedure cisp_etl_yyb_zhgf_zjzh
is
begin

  --Ӫҵ˻淶-ʽ˻
  /*author
    date:2008-06-10
  */
     delete from t_db_b3_04 where P002 in (2001,2003,2005,2007,2009) or p002 is null ;
     insert into t_db_b3_04(p001,p002,a003,a004)
      select yyb,jylx,sum(sl),sum(zjye) from (
      select yyb,
             decode(jylx,1,2001,--ϸʽ˻
                         2,2003,--ϸʽ˻
                         3,2005,--Сʽ˻
                         4,2007,--ʽ˻
                         5,2009) jylx,--ϸʽ˻
             sl,
             zjye
      from t_etl_yyb_zhgf_zjzh where jylx!=55

     union

     select yyb,
             decode(jylx,1,2001,--ϸʽ˻
                         2,2003,--ϸʽ˻
                         3,2005,--Сʽ˻
                         4,2007,
                         5,2009) jylx,--ʽ˻
             sl,
             zjye
      from t_etl_yyb_zhgf_zjzh_rzrq
      where jylx!=55 ) group by yyb,jylx;
     commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (304,1013001,'ϵͳ','ɼӪҵ˻淶-ʽ˻',1001101,sysdate);
      exception
      when others then
        rollback;
     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (304,1013001,'ϵͳ','ɼӪҵ˻淶-ʽ˻',1001102,sysdate);


end cisp_etl_yyb_zhgf_zjzh;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZHGF_ZQZH
prompt =========================================
prompt
create or replace procedure cisp_etl_yyb_zhgf_zqzh
is
begin
  --Ӫҵ˻淶-֤ȯ˻
  /*author:
    date:2008-06-10
  */
     delete from t_db_b3_04 where P002 in (2002,2004,2006,2008);
     insert into t_db_b3_04(p001,p002,a003,a005)
      select yyb, jylx, sum(sl) sl, sum(zqsz) zqsz
      from (select yyb,
               decode(jylx,
                      1,
                      2002, --ϸ֤ȯ˻
                      2,
                      2004, --ϸ֤ȯ˻
                      3,
                      2006, --С֤ȯ˻
                      4,
                      2008) as jylx, --֤ȯ˻
               sl,
               zqsz
          from t_etl_yyb_zhgf_zqzh
        union
        select yyb,
               decode(jylx,
                      1,
                      2002, --ϸ֤ȯ˻
                      2,
                      2004, --ϸ֤ȯ˻
                      3,
                      2006, --С֤ȯ˻
                      4,
                      2008) as jylx, --֤ȯ˻
               sl,
               zqsz
          from t_etl_yyb_zhgf_zqzh_rzrq)
      group by yyb, jylx;
     commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (304,1013001,'ϵͳ','ɼӪҵ˻淶-֤ȯ˻',1001101,sysdate);
      exception
      when others then
        rollback;
     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (304,1013001,'ϵͳ','ɼӪҵ˻淶-֤ȯ˻',1001102,sysdate);

end cisp_etl_yyb_zhgf_zqzh;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZJZH
prompt ====================================
prompt
create or replace procedure cisp_etl_yyb_zjzh is
begin

  --Ӫҵ˻-ʽ˻
  /*author:
    date:2008-06-10
  */
  delete from t_db_b3_01 where P002 in (1002, 1003, 1004, 1005,1006,1007,1008,1009,1010,1011);
  insert into t_db_b3_01
    (p001, p002, a003)
  --
      select yyb, 1002, sum(hs)
      from (
             select t.YYB ,
                    1002,
                    sum(sl) hs
              from t_etl_yyb_zjzh t
             where khlx in (0, 1)
               and jylx = 1
               and bz = 9
             group by t.yyb

            union all
            select t.YYB ,
                   1002,
                   sum(sl) hs
              from t_etl_yyb_zjzh_rzrq t
             where khlx in (0, 1)
               and jylx = 1
               and bz = 9
             group by t.yyb
         )
     group by yyb
    union
    select t.yyb, 1006, nvl(zj, 0) - nvl(wskh, 0) - nvl(jzkh, 0) as hs   --ٹ񿪻 = ٹ- - ֤
      from (select t.YYB,
                   1006,
                   (select sum(sl) as zj
                      from (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 9
                       and yyb = t.yyb) as zj,
                   (select sum(sl) as wskh
                      from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
                     where khlx in (0, 1)
                       and jylx = 12
                       and bz = 9
                       and yyb = t.yyb) as wskh,
                   (select sum(sl) as jzkh
                      from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
                     where khlx in (0, 1)
                       and jylx = 13
                       and bz = 9
                       and yyb = t.yyb) as jzkh

            /* (select a004 as qc from t_db_b3_01 where p001=t.yyb and p002 =1001) as bg_qc,
                           (select sum(sl) as zj from t_etl_yyb_zjzh where khlx in (0,1) and jylx=1 and bz in (1,2) and yyb = t.yyb) as bg_zj,
                           (select sum(sl) as qm from t_etl_yyb_zjzh where khlx in (0,1) and jylx=3 and bz in (1,2) and yyb = t.yyb) as bg_qm */
              from t_etl_yyb_zjzh t
             group by t.yyb) t
    union
    select t.YYB,
           1007, --Ͽ
           (select sum(sl)
              from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
             where khlx in (0, 1)
               and jylx = 12
               and bz = 9
               and yyb = t.yyb) as hs
    /*(select sum(sl) from t_etl_yyb_zjzh where khlx in (0,1) and jylx=1 and bz in (1,2) and yyb = t.yyb) as bg   --b1*/
      from t_etl_yyb_zjzh t
     group by t.yyb

    union
    select t.YYB,
           1008, --֤
           (select sum(sl)
              from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
             where khlx in (0, 1)
               and jylx = 13
               and bz = 9
               and yyb = t.yyb) as hs
    /*(select sum(sl) from t_etl_yyb_zjzh where khlx in (0,1) and jylx=1 and bz in (1,2) and yyb = t.yyb) as bg   --b1*/
      from t_etl_yyb_zjzh t
     group by t.yyb
    union

    --ڳ+-ĩڼ update by wull in shanghai stock 2008-7-29
    select t.yyb, 1003, nvl(qc, 0) + nvl(zj, 0) - nvl(qm, 0) as hs
      from (select t.YYB,
                   1003,
                   (select a003 as qc
                      from t_db_b3_01
                     where p001 = t.yyb
                       and p002 = 1001) as qc,
                   (
                    select sum(sl) as zj
                    from (
                          select yyb,khlx,jylx,bz,sum(sl) as sl
                          from (
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                               )
                           group by yyb,khlx,jylx,bz
                          )
                   where khlx in (0, 1)
                     and jylx = 1
                     and bz = 9
                     and yyb = t.yyb
                     group by yyb
                   ) as zj,
                   (
                   select sum(sl) as zj
                    from (
                          select yyb,khlx,jylx,bz,sum(sl) as sl
                          from (
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                               )
                           group by yyb,khlx,jylx,bz
                          )
                   where khlx in (0, 1)
                     and jylx = 3
                     and bz = 9
                     and yyb = t.yyb
                     group by yyb
                   ) as qm
             from t_etl_yyb_zjzh t
             group by t.yyb) t

    union

    --ٹ ȡ
    select t.yyb,
           1009,
           nvl(qc, 0) + nvl(zj, 0) - nvl(qm, 0) - nvl(wsxh, 0) as hs
      from (select t.YYB,
                   1009,
                   (select a003 as qc
                      from t_db_b3_01
                     where p001 = t.yyb
                       and p002 = 1001) as qc,
                   (select sum(sl) as zj
                      from (select yyb, khlx, jylx, bz, sum(sl) as sl
                              from (select yyb, khlx, jylx, bz, sl
                                      from t_etl_yyb_zjzh
                                    union all
                                    select yyb, khlx, jylx, bz, sl
                                      from t_etl_yyb_zjzh_rzrq)
                             group by yyb, khlx, jylx, bz)
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 9
                       and yyb = t.yyb
                     group by yyb) as zj,
                   (select sum(sl)
                      from (select yyb, khlx, jylx, bz, sl
                              from t_etl_yyb_zjzh
                            union all
                            select yyb, khlx, jylx, bz, sl
                              from t_etl_yyb_zjzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 22
                       and bz = 9
                       and yyb = t.yyb) as wsxh,
                   (select sum(sl) as zj
                      from (select yyb, khlx, jylx, bz, sum(sl) as sl
                              from (select yyb, khlx, jylx, bz, sl
                                      from t_etl_yyb_zjzh
                                    union all
                                    select yyb, khlx, jylx, bz, sl
                                      from t_etl_yyb_zjzh_rzrq)
                             group by yyb, khlx, jylx, bz)
                     where khlx in (0, 1)
                       and jylx = 3
                       and bz = 9
                       and yyb = t.yyb
                     group by yyb) as qm
              from t_etl_yyb_zjzh t
             group by t.yyb) t

    union
    
     select t.YYB,
            1010, --
            (select sum(sl)
               from (select yyb, khlx, jylx, bz, sl
                       from t_etl_yyb_zjzh
                     union all
                     select yyb, khlx, jylx, bz, sl from t_etl_yyb_zjzh_rzrq)
              where khlx in (0, 1)
                and jylx = 22
                and bz = 9
                and yyb = t.yyb) as hs
       from t_etl_yyb_zjzh t
      group by t.yyb
      
     union all 
    --ĩ
     select yyb,1004,sum(hs)
       from(select t.YYB,
                   1004,
               (select sum(sl)
                  from t_etl_yyb_zjzh
                 where khlx in (0, 1)
                   and jylx = 3
                   and bz = 9
                   and yyb = t.yyb) as hs --
                from t_etl_yyb_zjzh t
                group by t.yyb
             union
              select t.YYB,
                     1004,
                 (select sum(sl)
                  from t_etl_yyb_zjzh_rzrq
                 where khlx in (0, 1)
                   and jylx = 3
                   and bz = 9
                   and yyb = t.yyb) as hs --
          from t_etl_yyb_zjzh t
         group by t.yyb )
      group by yyb
    union
    --:
     select yyb, 1005, sum(hs)
  from (select t.YYB, 1005, sum(sl) hs
          from t_etl_yyb_zjzh t
         where khlx = 1
           and jylx = 3
           and bz = 9
           and yyb = t.yyb
         group by t.yyb

        union
        select t.YYB, 1005, sum(sl) hs
          from t_etl_yyb_zjzh_rzrq t
         where khlx = 1
           and jylx = 3
           and bz = 9
           and yyb = t.yyb
         group by t.yyb)
      group by yyb;

  --ڲɱΪΪ0м뵽ȥ
  update t_db_b3_01 a
     set A003 = A003 - (select (case
                                 when b.A003 < 0 then
                                  b.A003
                                 else
                                  0
                               end)
                          from t_db_b3_01 b
                         where b.p002 = 1003
                           and b.p001 = a.p001)
   where p002 = 1002;
   
  --ڼΪʱŵϿ
  update t_db_b3_01 a
   set A003 = A003 - (select (case
                               when b.A003 < 0 then
                                b.A003
                               else
                                0
                             end)
                        from t_db_b3_01 b
                       where b.p002 = 1003
                         and b.p001 = a.p001)
 where p002 = 1007;

 --ڼΪʱΪ0
  update t_db_b3_01
     set A003 = 0
   where p002 = 1003
     and A003 < 0;
     
 --ֳΪʱΪ0
  update t_db_b3_01
     set A003 = 0
   where p002 = 1009
     and A003 < 0;

  commit;

  insert into t_sys_t018
    (p001, P002, P003, A004, A005, A006)
     values (301,1013001,'ϵͳ','ɼӪҵ˻-ʽ˻',1001101, sysdate);
exception
  when others then
    rollback;
    insert into t_sys_t018
      (p001, P002, P003, A004, A005, A006)
    values  (301,1013001,'ϵͳ','ɼӪҵ˻-ʽ˻',1001102,sysdate);

end ;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZJZH_20190506
prompt =============================================
prompt
create or replace procedure cisp_etl_yyb_zjzh_20190506 is
begin

  --Ӫҵ˻-ʽ˻
  /*author:
    date:2008-06-10
  */
  delete from t_db_b3_01 where P002 in (1002, 1003, 1004, 1005,1006,1007,1008,1009,1010,1011);
  insert into t_db_b3_01
    (p001, p002, a003)
  --
      select yyb, 1002, sum(hs)
      from (
             select t.YYB ,
                    1002,
                    sum(sl) hs
              from t_etl_yyb_zjzh t
             where khlx in (0, 1)
               and jylx = 1
               and bz = 9
             group by t.yyb

            union all
            select t.YYB ,
                   1002,
                   sum(sl) hs
              from t_etl_yyb_zjzh_rzrq t
             where khlx in (0, 1)
               and jylx = 1
               and bz = 9
             group by t.yyb
         )
     group by yyb
    union
    select t.yyb, 1006, nvl(zj, 0) - nvl(wskh, 0) - nvl(jzkh, 0) as hs   --ٹ񿪻 = ٹ- - ֤
      from (select t.YYB,
                   1006,
                   (select sum(sl) as zj
                      from (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 9
                       and yyb = t.yyb) as zj,
                   (select sum(sl) as wskh
                      from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
                     where khlx in (0, 1)
                       and jylx = 12
                       and bz = 9
                       and yyb = t.yyb) as wskh,
                   (select sum(sl) as jzkh
                      from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
                     where khlx in (0, 1)
                       and jylx = 13
                       and bz = 9
                       and yyb = t.yyb) as jzkh

            /* (select a004 as qc from t_db_b3_01 where p001=t.yyb and p002 =1001) as bg_qc,
                           (select sum(sl) as zj from t_etl_yyb_zjzh where khlx in (0,1) and jylx=1 and bz in (1,2) and yyb = t.yyb) as bg_zj,
                           (select sum(sl) as qm from t_etl_yyb_zjzh where khlx in (0,1) and jylx=3 and bz in (1,2) and yyb = t.yyb) as bg_qm */
              from t_etl_yyb_zjzh t
             group by t.yyb) t
    union
    select t.YYB,
           1007, --Ͽ
           (select sum(sl)
              from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
             where khlx in (0, 1)
               and jylx = 12
               and bz = 9
               and yyb = t.yyb) as hs
    /*(select sum(sl) from t_etl_yyb_zjzh where khlx in (0,1) and jylx=1 and bz in (1,2) and yyb = t.yyb) as bg   --b1*/
      from t_etl_yyb_zjzh t
     group by t.yyb

    union
    select t.YYB,
           1008, --֤
           (select sum(sl)
              from  (
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                           select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                            )
             where khlx in (0, 1)
               and jylx = 13
               and bz = 9
               and yyb = t.yyb) as hs
    /*(select sum(sl) from t_etl_yyb_zjzh where khlx in (0,1) and jylx=1 and bz in (1,2) and yyb = t.yyb) as bg   --b1*/
      from t_etl_yyb_zjzh t
     group by t.yyb
    union

    --ڳ+-ĩڼ update by wull in shanghai stock 2008-7-29
    select t.yyb, 1003, nvl(qc, 0) + nvl(zj, 0) - nvl(qm, 0) as hs
      from (select t.YYB,
                   1003,
                   (select a003 as qc
                      from t_db_b3_01
                     where p001 = t.yyb
                       and p002 = 1001) as qc,
                   (
                    select sum(sl) as zj
                    from (
                          select yyb,khlx,jylx,bz,sum(sl) as sl
                          from (
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                               )
                           group by yyb,khlx,jylx,bz
                          )
                   where khlx in (0, 1)
                     and jylx = 1
                     and bz = 9
                     and yyb = t.yyb
                     group by yyb
                   ) as zj,
                   (
                   select sum(sl) as zj
                    from (
                          select yyb,khlx,jylx,bz,sum(sl) as sl
                          from (
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                               )
                           group by yyb,khlx,jylx,bz
                          )
                   where khlx in (0, 1)
                     and jylx = 3
                     and bz = 9
                     and yyb = t.yyb
                     group by yyb
                   ) as qm
             from t_etl_yyb_zjzh t
             group by t.yyb) t

    union

    --ٹ
    select t.yyb, 1009, nvl(qc, 0) + nvl(zj, 0) - nvl(qm, 0) as hs
      from (select t.YYB,
                   1009,
                   (select a003 as qc
                      from t_db_b3_01
                     where p001 = t.yyb
                       and p002 = 1001) as qc,
                   (
                    select sum(sl) as zj
                    from (
                          select yyb,khlx,jylx,bz,sum(sl) as sl
                          from (
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                               )
                           group by yyb,khlx,jylx,bz
                          )
                   where khlx in (0, 1)
                     and jylx = 1
                     and bz = 9
                     and yyb = t.yyb
                     group by yyb
                   ) as zj,
                   (
                   select sum(sl) as zj
                    from (
                          select yyb,khlx,jylx,bz,sum(sl) as sl
                          from (
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh
                              union all
                              select yyb,khlx,jylx,bz,sl from t_etl_yyb_zjzh_rzrq
                               )
                           group by yyb,khlx,jylx,bz
                          )
                   where khlx in (0, 1)
                     and jylx = 3
                     and bz = 9
                     and yyb = t.yyb
                     group by yyb
                   ) as qm
             from t_etl_yyb_zjzh t
             group by t.yyb) t

    union
    --ĩ
    /*select t.YYB,
           1004,
           (select sum(sl)
              from t_etl_yyb_zjzh
             where khlx in (0, 1)
               and jylx = 3
               and bz = 9
               and yyb = t.yyb) as hs --

      from t_etl_yyb_zjzh t
     group by t.yyb*/
     select yyb,1004,sum(hs)
       from(select t.YYB,
                   1004,
               (select sum(sl)
                  from t_etl_yyb_zjzh
                 where khlx in (0, 1)
                   and jylx = 3
                   and bz = 9
                   and yyb = t.yyb) as hs --
                from t_etl_yyb_zjzh t
                group by t.yyb
             union
              select t.YYB,
                     1004,
                 (select sum(sl)
                  from t_etl_yyb_zjzh_rzrq
                 where khlx in (0, 1)
                   and jylx = 3
                   and bz = 9
                   and yyb = t.yyb) as hs --
          from t_etl_yyb_zjzh t
         group by t.yyb )
      group by yyb
    union
    --:
   /* select t.YYB,
           1005,
           (select sum(sl)
              from t_etl_yyb_zjzh
             where khlx = 1
               and jylx = 3
               and bz = 9
               and yyb = t.yyb) as hs --

      from t_etl_yyb_zjzh t
     group by t.yyb;*/

     select yyb, 1005, sum(hs)
  from (select t.YYB, 1005, sum(sl) hs
          from t_etl_yyb_zjzh t
         where khlx = 1
           and jylx = 3
           and bz = 9
           and yyb = t.yyb
         group by t.yyb

        union
        select t.YYB, 1005, sum(sl) hs
          from t_etl_yyb_zjzh_rzrq t
         where khlx = 1
           and jylx = 3
           and bz = 9
           and yyb = t.yyb
         group by t.yyb)
      group by yyb;

  --ڲɱΪΪ0м뵽ȥ
  update t_db_b3_01 a
     set A003 = A003 - (select (case when b.A003 < 0 then b.A003 else 0 end)
                             from t_db_b3_01 b
                            where b.p002 = 1003
                              and b.p001 = a.p001)
   where p002 = 1002;
  update t_db_b3_01
     set A003 = 0
   where p002 = 1003
     and A003 < 0;



     --ڲɱΪΪ0м뵽ȥ
  update t_db_b3_01 a
     set A003 = A003 - (select (case when b.A003 < 0 then b.A003 else 0 end)
                             from t_db_b3_01 b
                            where b.p002 = 1009
                              and b.p001 = a.p001)
   where p002 = 1006;
  update t_db_b3_01
     set A003 = 0
   where p002 = 1009
     and A003 < 0;

  commit;

  insert into t_sys_t018
    (p001, P002, P003, A004, A005, A006)
     values (301,1013001,'ϵͳ','ɼӪҵ˻-ʽ˻',1001101, sysdate);
exception
  when others then
    rollback;
    insert into t_sys_t018
      (p001, P002, P003, A004, A005, A006)
    values  (301,1013001,'ϵͳ','ɼӪҵ˻-ʽ˻',1001102,sysdate);

end ;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZQJY
prompt ====================================
prompt
create or replace procedure cisp_etl_yyb_zqjy
is
begin
 --Ӫҵ֤ȯ
  /*author:
    date:2008-06-10
  */

declare
    v_yyb  number;
    v_zqlx number;
    v_jyje  number(19, 2);
    v_zqsz number(19, 2);
    v_count number;
    cursor cur_work is
       select t.yyb,
                     decode(t.zqlx,
                            1,
                            1001, -- A
                            3,
                            1002, --B
                            2,
                            1003, --B
                            4,
                            1005, --
                            5,
                            1006, --ծȯ
                            6,
                            1007, --Ȩ֤
                            7,
                            1008, --֤ȯ
                            8,
                            1009, --ծȯʻع
                            9,
                            1010), --ծȯȯع
                     sum(t.jyje),
                     sum(t.zqsz)
                from (select t.yyb, t.zqlx, t.jyje, 0 zqsz
                        from t_etl_yyb_zqjy t
                      union all
                      select t.yyb, t.zqlx, t.jyje, 0 zqsz
                        from t_etl_yyb_zqjy_rzrq t
                      union all
                      select yyb, zqlx, 0 jyje, zqsz
                        from t_etl_yyb_zqsz
                      union all
                      select yyb, zqlx, 0 jyje, zqsz
                        from t_etl_yyb_zqsz_rzrq) t
               where t.zqlx not in (10, 11, 12, 20, 21, 22) 
               group by t.yyb, t.zqlx ;
  begin

	update t_db_b4_01
	   set a003 = 0,a007=0;
    open cur_work;
    fetch cur_work
      into  v_yyb,v_zqlx,v_jyje,v_zqsz;

    while cur_work%found loop
      select count(*)
        into v_count
        from t_db_b4_01
       where p001 = v_yyb and p002 = v_zqlx;

      if v_count > 0 then
        update t_db_b4_01
           set a003 = v_jyje,a007=v_zqsz
         where p001 = v_yyb and p002 = v_zqlx;
      else
        insert into t_db_b4_01(P001,P002,A003,A007) values (v_yyb,v_zqlx,v_jyje,v_zqsz);
      end if;
      fetch cur_work
      into v_yyb,v_zqlx,v_jyje,v_zqsz;
    end loop;

     commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (401,1013001,'ϵͳ','ɼӪҵ֤ȯ',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (401,1013001,'ϵͳ','ɼӪҵ֤ȯ',1001102,sysdate);



  end;

end cisp_etl_yyb_zqjy;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZQJY_FXC
prompt ========================================
prompt
create or replace procedure CISP_ETL_YYB_ZQJY_FXC is
  --Ӫҵ֤ȯ-ֳ
  /*author:
    date:2008-06-10
  */
begin

   insert into T_DB_B4_03
    (P001,
     P002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A012,
     A013,
     A014)
    select p001, 1012, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
      from krcs.T_CTL_T036 t
     where a008 = 1023008
       and b001 = 1001101
       and not exists (select 1
              from T_DB_B4_03
             where p001 = t.p001
               and p002 = 1012);

  insert into T_DB_B4_03
    (P001,
     P002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A012,
     A013,
     A014)
    select p001, 1016, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
      from KRCS.T_CTL_T036 t
     where a008 = 1023008
       and b001 = 1001101
       and not exists (select 1
              from T_DB_B4_03
             where p001 = t.p001
               and p002 = 1016);

  update T_DB_B4_03 t
     set (a003, a009) = (select jyje, sxf
                           from (select yyb,
                                        zqlx,
                                        sum(jyje) jyje,
                                        sum(sxf) sxf
                                   from (select yyb, jyje, sxf, zqlx
                                           from T_ETL_YYB_ZQJY
                                         union all
                                         select yyb, jyje, sxf, zqlx
                                           from t_etl_yyb_zqjy_rzrq)
                                  group by yyb, zqlx)
                          where yyb = t.p001
                            and zqlx = 10)
   where p002 = 1012;

  update T_DB_B4_03 t
     set (a003, a009) = (select jyje, sxf
                           from (select yyb,
                                        zqlx,
                                        sum(jyje) jyje,
                                        sum(sxf) sxf
                                   from (select yyb, jyje, sxf, zqlx
                                           from T_ETL_YYB_ZQJY
                                         union all
                                         select yyb, jyje, sxf, zqlx
                                           from t_etl_yyb_zqjy_rzrq)
                                  group by yyb, zqlx)
                          where yyb = t.p001
                            and zqlx = 20)
   where p002 = 1016;

  update T_DB_B4_03 t
     set (a004, a010) = (select jyje, sxf
                           from (select yyb,
                                        zqlx,
                                        sum(jyje) jyje,
                                        sum(sxf) sxf
                                   from (select yyb, jyje, sxf, zqlx
                                           from T_ETL_YYB_ZQJY
                                         union all
                                         select yyb, jyje, sxf, zqlx
                                           from t_etl_yyb_zqjy_rzrq)
                                  group by yyb, zqlx)
                          where yyb = t.p001
                            and zqlx = 12)
   where p002 = 1012;

  update T_DB_B4_03 t
     set (a004, a010) = (select jyje, sxf
                           from (select yyb,
                                        zqlx,
                                        sum(jyje) jyje,
                                        sum(sxf) sxf
                                   from (select yyb, jyje, sxf, zqlx
                                           from T_ETL_YYB_ZQJY
                                         union all
                                         select yyb, jyje, sxf, zqlx
                                           from t_etl_yyb_zqjy_rzrq)
                                  group by yyb, zqlx)
                          where yyb = t.p001
                            and zqlx = 22)
   where p002 = 1016;

  update T_DB_B4_03 t
     set (a005, a011) = (select jyje, sxf
                           from (select yyb,
                                        zqlx,
                                        sum(jyje) jyje,
                                        sum(sxf) sxf
                                   from (select yyb, jyje, sxf, zqlx
                                           from T_ETL_YYB_ZQJY
                                         union all
                                         select yyb, jyje, sxf, zqlx
                                           from t_etl_yyb_zqjy_rzrq)
                                  group by yyb, zqlx)
                          where yyb = t.p001
                            and zqlx = 11)
   where p002 = 1012;

  update T_DB_B4_03 t
     set (a005, a011) = (select jyje, sxf
                           from (select yyb,
                                        zqlx,
                                        sum(jyje) jyje,
                                        sum(sxf) sxf
                                   from (select yyb, jyje, sxf, zqlx
                                           from T_ETL_YYB_ZQJY
                                         union all
                                         select yyb, jyje, sxf, zqlx
                                           from t_etl_yyb_zqjy_rzrq)
                                  group by yyb, zqlx)
                          where yyb = t.p001
                            and zqlx = 21)
   where p002 = 1016;

  commit;

  insert into t_sys_t018
    (p001, P002, P003, A004, A005, A006) values (403, 1013001, 'ϵͳ', 'ɼӪҵ֤ȯ--ֳ', 1001101, sysdate);
exception
  when others then
    rollback;
    insert into t_sys_t018
      (p001, P002, P003, A004, A005, A006)
    values (403,1013001,'ϵͳ','ɼӪҵ֤ȯ--ֳ',1001102,sysdate);
end CISP_ETL_YYB_ZQJY_FXC;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZQJY_GTSXF
prompt ==========================================
prompt
create or replace procedure cisp_etl_yyb_zqjy_gtsxf
is
begin
 --Ӫҵ֤ȯ
  /*author:wuz
    date:2009-04-22
    ЩͻҪӹ̨ȡѣʶչ˴洢̣ҪȡûDTS ֤ȯס֤ȯִֵ
  */

declare
    v_yyb  number;
    v_zqlx number;
    v_sxf  number(19, 2);
    v_count number;
    cursor cur_work is
      select a.yyb,
             decode(a.zqlx,1,1001,-- A
                          3,1002,--B
                          2,1003,--B
                          4,1005,--
                          5,1006,--ծȯ
                          6,1007,--Ȩ֤
                          7,1008,--֤ȯ
                          8,1009,--ծȯʻع
                          9,1010),--ծȯȯع
              a.sxf
       from  (select yyb,zqlx,sum(sxf) sxf from (
      select  t.yyb,t.zqlx,t.sxf from t_etl_yyb_zqjy t
      union all
      select  t.yyb,t.zqlx,t.sxf from t_etl_yyb_zqjy_rzrq t  )group by yyb,zqlx) a where a.zqlx between 1 and 9;
  begin

        update t_db_b4_01
           set a005 = 0;
    open cur_work;
    fetch cur_work
      into  v_yyb,v_zqlx,v_sxf;

    while cur_work%found loop
      select count(*)
        into v_count
        from t_db_b4_01
       where p001 = v_yyb and p002 = v_zqlx;

      if v_count > 0 then
        update t_db_b4_01
           set a005 = v_sxf
         where p001 = v_yyb and p002 = v_zqlx;
      else
        insert into t_db_b4_01(P001,P002,A005) values (v_yyb,v_zqlx,v_sxf);
      end if;
      fetch cur_work
      into v_yyb,v_zqlx,v_sxf;
    end loop;

     commit;

     insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (401,1013001,'̨ϵͳ','ɼӪҵ֤ȯ-',1001101,sysdate);
      exception
      when others then
        rollback;
    insert into t_sys_t018(p001,P002,P003,A004,A005,A006) values (401,1013001,'̨ϵͳ','ɼӪҵ֤ȯ-',1001102,sysdate);



  end;

end;
/

prompt
prompt Creating procedure CISP_ETL_YYB_ZQZH
prompt ====================================
prompt
create or replace procedure cisp_etl_yyb_zqzh is
begin

  --Ӫҵ˻-֤ȯ˻
  /*author:
    date:2008-06-10
  */
  delete from t_db_b3_02
   where P002 in
         (1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011);
  insert into t_db_b3_02
    (p001, p002, a003, a004)
  --
    select t.YYB,
           1002,
           (select sum(sl)
              from (select yyb, khlx, jylx, bz, sl
                      from t_etl_yyb_zqzh
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 0
                    union all
                    select yyb, khlx, jylx, bz, sl
                      from t_etl_yyb_zqzh_rzrq
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 0)
             where yyb = t.yyb
             group by yyb) as ag, --a
           (select sum(sl)
              from (select yyb, khlx, jylx, bz, sl
                      from t_etl_yyb_zqzh
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz in (1, 2)
                    union all
                    select yyb, khlx, jylx, bz, sl
                      from t_etl_yyb_zqzh_rzrq
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz in (1, 2))
             where yyb = t.yyb
             group by yyb) as bg --b
      from t_etl_yyb_zqzh t
     group by t.yyb
    union
    select t.yyb,
           1006,
           nvl(ag_zj, 0) - nvl(ag_wskh, 0) - nvl(ag_jzkh, 0) as ag,
           nvl(bg_zj, 0) - nvl(bg_wskh, 0) - nvl(bg_jzkh, 0) as bg
      from (select t.YYB,
                   1006,
                   (select sum(sl) as zj
                      from (select yyb, khlx, jylx, bz, sl
                              from t_etl_yyb_zqzh
                             where khlx in (0, 1)
                               and jylx = 1
                               and bz = 0
                            union all
                            select yyb, khlx, jylx, bz, sl
                              from t_etl_yyb_zqzh_rzrq
                             where khlx in (0, 1)
                               and jylx = 1
                               and bz = 0)
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 0
                       and yyb = t.yyb) as ag_zj,
                   (select sum(sl) as qm
                      from (select yyb, khlx, jylx, bz, sl
                              from t_etl_yyb_zqzh
                             where khlx in (0, 1)
                               and jylx = 1
                               and bz in (1, 2)
                            union all
                            select yyb, khlx, jylx, bz, sl
                              from t_etl_yyb_zqzh_rzrq
                             where khlx in (0, 1)
                               and jylx = 1
                               and bz in (1, 2))
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_zj,
                   (select sum(sl) as zj
                      from t_etl_yyb_zqzh
                     where khlx in (0, 1)
                       and jylx = 12
                       and bz = 0
                       and yyb = t.yyb) as ag_wskh,
                   (select sum(sl) as qm
                      from t_etl_yyb_zqzh
                     where khlx in (0, 1)
                       and jylx = 12
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_wskh,
                   (select sum(sl) as zj
                      from t_etl_yyb_zqzh
                     where khlx in (0, 1)
                       and jylx = 13
                       and bz = 0
                       and yyb = t.yyb) as ag_jzkh,
                   (select sum(sl) as qm
                      from t_etl_yyb_zqzh
                     where khlx in (0, 1)
                       and jylx = 13
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_jzkh
              from t_etl_yyb_zqzh t
             group by t.yyb) t
    union
    select t.YYB,
           1007, --Ͽ
           (select sum(sl)
              from t_etl_yyb_zqzh
             where khlx in (0, 1)
               and jylx = 12
               and bz = 0
               and yyb = t.yyb) as ag, --a1
           (select sum(sl)
              from t_etl_yyb_zqzh
             where khlx in (0, 1)
               and jylx = 12
               and bz in (1, 2)
               and yyb = t.yyb) as bg --b1
      from t_etl_yyb_zqzh t
     group by t.yyb
    union
    select t.YYB,
           1008, --֤
           (select sum(sl)
              from t_etl_yyb_zqzh
             where khlx in (0, 1)
               and jylx = 13
               and bz = 0
               and yyb = t.yyb) as ag, --a1|
           (select sum(sl)
              from t_etl_yyb_zqzh
             where khlx in (0, 1)
               and jylx = 13
               and bz in (1, 2)
               and yyb = t.yyb) as bg --b1|
      from t_etl_yyb_zqzh t
     group by t.yyb
    --ڼ
    
    --ڳ+-ĩڼ update by wull in shanghai stock 2008-7-29
    union
    select t.yyb,
           1003,
           nvl(ag_qc, 0) + nvl(ag_zj, 0) - nvl(ag_qm, 0) as ag,
           nvl(bg_qc, 0) + nvl(bg_zj, 0) - nvl(bg_qm, 0) as bg
      from (select t.YYB,
                   1003,
                   (select a003 as qc
                      from t_db_b3_02
                     where p001 = t.yyb
                       and p002 = 1001) as ag_qc,
                   (select sum(sl) as zj
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 0
                       and yyb = t.yyb) as ag_zj,
                   (select sum(sl) as qm
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 3
                       and bz = 0
                       and yyb = t.yyb) as ag_qm,
                   
                   (select a004 as qc
                      from t_db_b3_02
                     where p001 = t.yyb
                       and p002 = 1001) as bg_qc,
                   (select sum(sl) as zj
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_zj,
                   (select sum(sl) as qm
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 3
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_qm
              from t_etl_yyb_zqzh t
             group by t.yyb) t
    union
    
    select t.YYB,
           1010, --
           (select sum(sl)
              from t_etl_yyb_zqzh
             where khlx in (0, 1)
               and jylx = 22
               and bz = 0
               and yyb = t.yyb) as ag, --a1
           (select sum(sl)
              from t_etl_yyb_zqzh
             where khlx in (0, 1)
               and jylx = 22
               and bz in (1, 2)
               and yyb = t.yyb) as bg --b1
      from t_etl_yyb_zqzh t
     group by t.yyb
    union
    
    select t.yyb,
           
           1009, --ֳ
           nvl(ag_qc, 0) + nvl(ag_zj, 0) - nvl(ag_qm, 0) - nvl(ag_wsxh, 0) as ag,
           nvl(bg_qc, 0) + nvl(bg_zj, 0) - nvl(bg_qm, 0) - nvl(bg_wsxh, 0) as bg
      from (select t.YYB,
                   1009, --ֳ
                   (select a003 as qc
                      from t_db_b3_02
                     where p001 = t.yyb
                       and p002 = 1001) as ag_qc,
                   (select sum(sl) as zj
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz = 0
                       and yyb = t.yyb) as ag_zj,
                   (select sum(sl) as qm
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 3
                       and bz = 0
                       and yyb = t.yyb) as ag_qm,
                   (select sum(sl) as wsxh
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 22
                       and bz = 0
                       and yyb = t.yyb) as ag_wsxh,
                   
                   (select a004 as qc
                      from t_db_b3_02
                     where p001 = t.yyb
                       and p002 = 1001) as bg_qc,
                   (select sum(sl) as zj
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 1
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_zj,
                   (select sum(sl) as qm
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 3
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_qm,
                   (select sum(sl) as wsxh
                      from (select *
                              from t_etl_yyb_zqzh
                            union all
                            select *
                              from t_etl_yyb_zqzh_rzrq)
                     where khlx in (0, 1)
                       and jylx = 22
                       and bz in (1, 2)
                       and yyb = t.yyb) as bg_wsxh
              from t_etl_yyb_zqzh t
             group by t.yyb) t
    
    union
    --ĩ
    
    select t.YYB,
           1004,
           (select sum(sl)
              from (select *
                      from t_etl_yyb_zqzh
                    union all
                    select *
                      from t_etl_yyb_zqzh_rzrq)
             where khlx in (0, 1)
               and jylx = 3
               and bz = 0
               and yyb = t.yyb) as ag, --a
           (select sum(sl)
              from (select *
                      from t_etl_yyb_zqzh
                    union all
                    select *
                      from t_etl_yyb_zqzh_rzrq)
             where khlx in (0, 1)
               and jylx = 3
               and bz in (1, 2)
               and yyb = t.yyb) as bg --b
      from t_etl_yyb_zqzh t
     group by t.yyb
    
    union
    --:
    select t.YYB,
           1005,
           (select sum(sl)
              from (select *
                      from t_etl_yyb_zqzh
                    union all
                    select *
                      from t_etl_yyb_zqzh_rzrq)
             where khlx = 1
               and jylx = 3
               and bz = 0
               and yyb = t.yyb) as ag, --a
           (select sum(sl)
              from (select *
                      from t_etl_yyb_zqzh
                    union all
                    select *
                      from t_etl_yyb_zqzh_rzrq)
             where khlx = 1
               and jylx = 3
               and bz in (1, 2)
               and yyb = t.yyb) as bg --b
      from t_etl_yyb_zqzh t
     group by t.yyb;

  --ڲɱΪΪ0뵽ȥ
  update t_db_b3_02 a
     set A003 = nvl(A003, 0) - (select (case
                                         when b.A003 < 0 then
                                          b.A003
                                         else
                                          0
                                       end)
                                  from t_db_b3_02 b
                                 where b.p002 = 1003
                                   and b.p001 = a.p001)
   where p002 = 1002;
  ----B
  update t_db_b3_02 a
     set A004 = nvl(A004, 0) - (select (case
                                         when b.A004 < 0 then
                                          b.A004
                                         else
                                          0
                                       end)
                                  from t_db_b3_02 b
                                 where b.p002 = 1003
                                   and b.p001 = a.p001)
   where p002 = 1002;
   
   ----С0 Ͽ
     update t_db_b3_02 a
     set A003 = nvl(A003, 0) - (select (case
                                         when b.A003 < 0 then
                                          b.A003
                                         else
                                          0
                                       end)
                                  from t_db_b3_02 b
                                 where b.p002 = 1003
                                   and b.p001 = a.p001)
   where p002 = 1007;
  ----B
  update t_db_b3_02 a
     set A004 = nvl(A004, 0) - (select (case
                                         when b.A004 < 0 then
                                          b.A004
                                         else
                                          0
                                       end)
                                  from t_db_b3_02 b
                                 where b.p002 = 1003
                                   and b.p001 = a.p001)
   where p002 = 1007;

  update t_db_b3_02
     set A003 = 0
   where p002 = 1003
     and A003 < 0;

  update t_db_b3_02
     set A004 = 0
   where p002 = 1003
     and A004 < 0;

  commit;

  update t_db_b3_02
     set A003 = 0
   where p002 = 1009
     and A003 < 0;

  update t_db_b3_02
     set A004 = 0
   where p002 = 1009
     and A004 < 0;

  insert into t_sys_t018
    (p001, P002, P003, A004, A005, A006)
  values
    (302,
     1013001,
     'ϵͳ',
     'ɼӪҵ˻-֤ȯ˻',
     1001101,
     sysdate);
exception
  when others then
    rollback;
    insert into t_sys_t018
      (p001, P002, P003, A004, A005, A006)
    values
      (302,
       1013001,
       'ϵͳ',
       'ɼӪҵ˻-֤ȯ˻',
       1001102,
       sysdate);
  
end cisp_etl_yyb_zqzh;
/

prompt
prompt Creating procedure CISP_ETL_ZCFZ
prompt ================================
prompt
create or replace procedure cisp_etl_zcfz is
begin
  --ܲʲծ
  /*author:
    date:2009-06-20
  */
  declare
    v_xm    number;
    v_qmye  number(19, 2); --ĩ
    v_count number;
    cursor cur_zcfz is
      select decode(xm,
                    1010,100010,--ʽ
                    1020,100020,--ʽ
                    1030,100030,--ʽ
                    1040,100040,--ͻʽ
                    1050,100050,--ͻʽ
                    1060,100060,--㱸
                    1070,100070,--б
                    1080,100080,--ͻ
                    1090,100090,--ñ
                    1100,100100,--ʽ
                    1110,100110,--ڳʽ
                    1120,100120,--Խʲ
                    1130,100130,--֤ȯ
                    1140,100140,--ʲ
                    1150,100150,--뷵۽ʲ
                    1160,100160,--Լڳʽ
                    1170,100170,--ƱѺعڳʽ
                    1180,100180,--ӦϢ
                    1190,100190,--֤
                    1200,100200,--ױ֤
                    1210,100210,--ñ֤
                    1220,100220,--Լ֤
                    1230,100230,--ɹ۽
                    1240,100240,--Ͷ
                    1250,100250,--ڹȨͶ
                    1260,100260,--ͶԷز
                    1270,100270,--̶ʲ
                    1280,100280,--ڽ
                    1290,100290,--ʲ
                    1300,100300,--
                    1310,100310,--˰ʲ
                    1320,100320,--ʲ
                    1330,100330,--Ӧȯͻ
                    1340,100340,--Ӧտ
                    1350,100350,--Ӧչ
                    1360,100360,--ծʲ
                    1370,100370,--ڴ̯
                    1380,109999,--ʲϼ
                    1390,200010,--ڽ
                    1400,200020,--Ѻ
                    1410,200030,--ý
                    1420,200040,--ʽ
                    1430,200050,--תͨʽ
                    1440,200060,--Խڸծ
                    1450,200070,--ڸծ
                    1460,200080,--عʲ
                    1470,200090,--ۻعʽ
                    1480,200100,--֤ȯ
                    1490,200110,--ý״֤ȯ
                    1500,200120,--֤ȯ
                    1510,200130,--Ӧְн
                    1520,200140,--Ӧ˰
                    1530,200150,--ӦϢ
                    1540,200160,--ԤƸծ
                    1550,200170,--ڽ
                    1560,200180,--Ӧծȯ
                    1570,200190,--Ӧȯ
                    1580,200200,--Ӧ˾ծȯ
                    1590,200210,--˰ծ
                    1600,200220,--ծ
                    1610,200230,--Ӧ
                    1620,200240,--Ӧ
                    1630,200250,--μծ
                    1640,200260,--ڴμծ
                    1650,200270,--ڴμծ
                    1660,209999,--ծϼ
                    1670,300010,--ʵʱɱ
                    1690,300020,--ʱ
                    1700,300030,--
                    1710,300040,--ӯ๫
                    1720,300050,--һ׼
                    1730,300060,--׷׼
                    1740,300070,--δ
                    1750,300080,--ұ
                    1760,309999,--Ȩϼ
                    1770,409999--ծȨܼ
                    ) as xm,
             qmye
        from t_etl_zcfz;

    /*cursor cur_zcfz_bczl is
      select decode(xm,
                    1,
                    510010, --д-йͻ
                    2,
                    601200, --㱸𣭿ͻйͻ
                    3,
                    601300, --йܿͻʽ
                    4,
                    601400, --Ӧտ
                    5,
                    601500, --Ͷ
                    6,
                    601501, --Ͷʳɱ
                    7,
                    601502, --ʵδ
                    8,
                    609999, --ʲܼ
                    9,
                    501100, --ʽ
                    10,
                    501200, --Ӧ
                    11,
                    509999, --иծܼ
                    \*12,
                    709000, --Ʒ*\
                    13,
                    809000, --иծ
                    14,
                    890001 --Уⵣܽ
                    ) as xm,
             qmye
        from t_etl_zcfz_bczl
        where xm <> 12;*/


      /*  cursor cur_zcfz_bczl_dbp is
      select decode(xm,

                    12,
                    709000 --Ʒ*\

                    ) as xm,
             qmye
        from t_etl_zcfz_bczl
        where xm = 12;*/

  begin
    --ʲծα
    open cur_zcfz;
    fetch cur_zcfz
      into v_xm, v_qmye;

    while cur_zcfz%found loop
      select count(*)
        into v_count
        from t_dact_001
       where p001 = v_xm
         and w100 = krcs_get_deptid_by_datatable('T_DACT_001');
      if v_count > 0 then
        update t_dact_001
           set a002 = v_qmye
         where p001 = v_xm
           and w100 = krcs_get_deptid_by_datatable('T_DACT_001');
      else
        insert into t_dact_001
          (P001, A002, A100, W100)
        values
          (v_xm,
           v_qmye,
           100000,
           krcs_get_deptid_by_datatable('T_DACT_001'));
      end if;
      fetch cur_zcfz
        into v_xm, v_qmye;
    end loop;
    close cur_zcfz;

    /*--ʲծα
    open cur_zcfz_bczl;
    fetch cur_zcfz_bczl
      into v_xm, v_qmye;

    while cur_zcfz_bczl%found loop
      select count(*)
        into v_count
        from t_dact_002
       where p001 = v_xm
         and w100 = krcs_get_deptid_by_datatable('T_DACT_002');
      if v_count > 0 then
        update t_dact_002
           set a002 = v_qmye
         where p001 = v_xm
           and w100 = krcs_get_deptid_by_datatable('T_DACT_002');
      else
        insert into t_dact_002
          (P001, A002, A100, W100)
        values
          (v_xm,
           v_qmye,
           100000,
           krcs_get_deptid_by_datatable('T_DACT_002'));
      end if;
      fetch cur_zcfz_bczl
        into v_xm, v_qmye;
    end loop;
    close cur_zcfz_bczl;



    open cur_zcfz_bczl_dbp;
    fetch cur_zcfz_bczl_dbp
      into v_xm, v_qmye;

    while cur_zcfz_bczl_dbp%found loop
      select count(*)
        into v_count
        from t_dact_002
       where p001 = v_xm
         and w100 = 30001;
      if v_count > 0 then
        update t_dact_002
           set a002 = v_qmye
         where p001 = v_xm
           and w100 = 30001;
      else
        insert into t_dact_002
          (P001, A002, A100, W100)
        values
          (v_xm,
           v_qmye,
           100000,
           30001);
      end if;
      fetch cur_zcfz_bczl_dbp
        into v_xm, v_qmye;
    end loop;
    close cur_zcfz_bczl_dbp;*/

    --update t_dact_002 set w100=30001 where p001=709000 and w100=50009;

/*   insert into t_dact_002 (P001, A002, A100, W100) --н
      select 510030,
           sum(a001),
           100000,
           krcs_get_deptid_by_datatable('T_DACT_001') from T_DB_05_104; */
   update t_dact_002 set a002 = (select sum(a001) from T_DB_05_104 ) where p001 = 510030;
   commit;
/*   insert into t_dact_002 (P001, A002, A100, W100) --н
      select 510040,
           sum(a002),
           100000,
           krcs_get_deptid_by_datatable('T_DACT_001') from T_DB_07_103 where p001 in (1100,1200); */

   update t_dact_002 set a002 = (select sum(a002) from T_DB_07_103 where p001 in (1100,1200)) where p001 = 510040;
   commit;

/*   insert into t_dact_002 (P001, A002, A100, W100) --оֵ
      select 510090,
           sum(a023),
           100000,
           krcs_get_deptid_by_datatable('T_DACT_001') from T_DB_05_104; */
   update t_dact_002 set a002 = (select sum(a023) from T_DB_05_104 ) where p001 = 510090;
   commit;
/*   insert into t_dact_002 (P001, A002, A100, W100) --оֵ
      select 510100,
           sum(a030),
           100000,
           krcs_get_deptid_by_datatable('T_DACT_001') from T_DB_07_103 where p001 in (1100,1200);*/

   update t_dact_002 set a002 = (select sum(a030) from T_DB_07_103 where p001 in (1100,1200)) where p001 = 510100;
   commit;
   delete  t_dact_002 where p001 in (510010,510060);
   commit;
   insert into t_dact_002 (P001, A002,A003, A100, W100)
   select 510010,sum(A002),sum(A003),A100,W100 from t_dact_002 where p001 in (510030,510040)
   group by A100,W100;
   commit;
   insert into t_dact_002 (P001, A002,A003, A100, W100)
   select 510060,sum(A002),sum(A003),A100,W100 from t_dact_002 where p001 in (510090,510100)
      group by A100,W100;
   commit;

/*   insert into t_dact_002 (P001, A002, A100, W100) --ȯ
      select 520040,
           sum(a002),
           100000,
           krcs_get_deptid_by_datatable('T_DACT_001') from T_DB_30_001 where p001 = '10250';*/
 update t_dact_002 set a002 = (select sum(a002) from T_DB_30_001 where p001 = '10250') where p001 = 520040;
   commit;


    insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
    values(2001, 1013001, 'ϵͳ', 'ɼܲʲծ', 1001101, sysdate);
    insert into t_sys_t018 (p001, P002, P003, A004, A005, A006)
    values(2002,1013001,'ϵͳ','ɼܲʲծ',1001101,sysdate);
 /* exception
    when others then
      rollback;
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2001,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);
      insert into t_sys_t018(p001, P002, P003, A004, A005, A006)
      values(2002,1013001,'ϵͳ','ɼܲʲծ',1001102,sysdate);*/
    end;
  end;
/

prompt
prompt Creating procedure CISP_ETL_ZJZH
prompt ================================
prompt
create or replace procedure cisp_etl_zjzh is
  v_bmid number; --ID
begin
  v_bmid:=50001;
 --select A012 into v_bmid from t_sys_user where p001 = 'yyzx'; --Ǽǽ
  delete from t_db_01_002
   where p001 in (1001002, 1001003, 1001005, 1001006,1001017,1001018,1001019,1001020,1001021,1001022,1001023)
     and w100 = v_bmid;
  --ʽʻ
  --
  insert into t_db_01_002
    select 1001002,
           decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sum(sl),
           v_bmid
      from t_etl_zjzh
     where jylx in (1,2)
     group by bz;
   commit;

  --Ͽ
  insert into t_db_01_002
    select 1001018,
           decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sum(sl),
           v_bmid
      from t_etl_zjzh
     where jylx = 12
     group by bz;
   commit;
    
  --֤
  insert into t_db_01_002
    select 1001019,
           decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sum(sl),
           v_bmid
      from t_etl_zjzh
     where jylx = 13
     group by bz;
  commit;
  --ֳ = ܿ - Ͽ-֤
  insert into t_db_01_002
  select 1001017,
           a.bz,
           100000,
           nvl(a.sl, 0) - nvl(b.sl, 0) - nvl(c.sl, 0),
           v_bmid
      from (select p002 as bz, nvl(a003, 0) as sl
              from t_db_01_002
             where p001 = 1001002
               and w100 = v_bmid) a, --?3?
           (select p002 as bz, nvl(a003, 0) as sl
              from t_db_01_002
             where p001 = 1001018
               and w100 = v_bmid) b, --???
           (select p002 as bz, nvl(a003, 0) as sl
              from t_db_01_002
             where p001 = 1001019
               and w100 = v_bmid) c --?2??
     where a.bz = b.bz(+)
       and a.bz = c.bz(+);
   commit;
 --ת
  insert into t_db_01_002
    select 1001020,
           1001,--decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sum(a004),
           v_bmid
      from t_db_01_020
     where p001 = 10001000
     /*group by bz*/;
   commit;
   
  --ϸת
  insert into t_db_01_002
    select 1001021,
           1001,--decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sum(a004),
           v_bmid
      from t_db_01_020
     where p001 = 10001010;
     --group by bz;
     commit;

   --ת
   insert into t_db_01_002
    select 1001022,
           1001,--decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sum(a003),
           v_bmid
      from t_db_01_020
     where p001 = 10001000;
     --group by bz;
     commit;

   --תϸ
   insert into t_db_01_002
    select 1001023,
           1001,--decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sum(a003),
           v_bmid
      from t_db_01_020
     where p001 = 10001010;
     --group by bz;
     commit;


  --
  --ڳ¿ĩȥ㱾 update by wull in shanghai stock 2008-7-28
  insert into t_db_01_002
    select 1001003,
           a.bz,
           100000,
           nvl(a.sl, 0) + nvl(c.sl, 0) - nvl(b.sl, 0) + nvl(d.sl, 0)  + nvl(e.sl, 0) - nvl(f.sl, 0) - nvl(g.sl, 0),
           v_bmid
      from (select p002 as bz, nvl(a003, 0) as sl
              from t_db_01_002
             where p001 = 1001001
               and w100 = v_bmid) a, --ڳ
           (select decode(bz, 0, 1001, 1, 1003, 2, 1002) as bz,
                   sum(sl) as sl
              from t_etl_zjzh
             where khlx in (0, 1)
               and jylx = 3
             group by bz) b, --ĩ
           (select decode(bz, 0, 1001, 1, 1003, 2, 1002) as bz,
                   sum(sl) as sl
              from t_etl_zjzh
             where khlx in (0, 1)
               and jylx in (1,2)
             group by bz) c, --¿
           (select p002 as bz,
                   nvl(a003,0) as sl
              from t_db_01_002
             where  p001 = 1001020   --Сת
             ) d,
           (select p002 as bz,
                   nvl(a003,0) as sl
              from t_db_01_002
             where p001 = 1001021  --ϸת
              ) e,
           (select p002 as bz,
                   nvl(a003,0) as sl
              from t_db_01_002
             where p001 = 1001022 --תС
             ) f,
           (select p002 as bz,
                    nvl(a003,0) as sl
              from t_db_01_002
             where  p001 = 1001023
             ) g --תϸ
     where a.bz = b.bz(+)
       and a.bz = c.bz(+)
       and a.bz = d.bz(+)
       and a.bz = e.bz(+)
       and a.bz = f.bz(+)
       and a.bz = g.bz(+);
       commit;

  --ĩ
  insert into t_db_01_002
    select 1001005,
           decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sl,
           v_bmid
      from t_etl_zjzh
     where jylx = 3
       and khlx = 1;
    commit;   

  --ĩ
  insert into t_db_01_002
    select 1001006,
           decode(bz, 0, 1001, 1, 1003, 2, 1002),
           100000,
           sl,
           v_bmid
      from t_etl_zjzh
     where jylx = 3
       and khlx = 0;

  commit;
  --ڲɱΪΪ0м뵽ȥ
  update t_db_01_002 a
     set A003 = A003 - (select (case when b.A003<0 then b.A003 else 0 end)
                             from t_db_01_002 b
                            where b.p001 = 1001003
                              and b.p002 = a.p002
                              and b.w100 = a.w100)
   where p001 = 1001002;
   commit;
  
  --ڿֳϡ֤ƽ¼ֳ
  update t_db_01_002 a
     set A003 = A003 - (select (case when b.A003<0 then b.A003 else 0 end)
                             from t_db_01_002 b
                            where b.p001 = 1001003
                              and b.p002 = a.p002
                              and b.w100 = a.w100)
   where p001 = 1001017;
   commit;

  update t_db_01_002
     set A003 = 0
   where p001 = 1001003
     and A003 < 0
     and w100 = v_bmid;
     commit;

end cisp_etl_zjzh;
/

prompt
prompt Creating procedure CISP_ETL_ZQJY
prompt ================================
prompt
create or replace procedure cisp_etl_zqjy is
  v_bmid number;  --ID
begin
  v_bmid:=50001;
  /*select A012 into v_bmid
    from krcs.t_sys_user
   where p001 = 'yyzx';*/  --͹ܲ

  --֤ȯ
  --
  declare
    v_khlx  number;
    v_zqlx  number;
    v_je    number(19, 2);
    v_count number;
    cursor cur_work is
      select decode(khlx, 0, 1002, 1, 1001),
             decode(zqlx,
                    1,
                    1001101, --A
                    2,
                    1001102, --B
                    3,
                    1001103, --B
                    4,
                    1002000, --
                    5,
                    1002001, --ETF
                    6,
                    1002002, --LOF
                    7,
                    1003000, --ծȯ
                    8,
                    1004000, --Ȩ֤
                    9,
                    1005000, --Ȩ֤
                    10,
                    1006001, --ʻع
                    11,
                    1006002), --ȯع
             je
        from (select khlx,zqlx,sum(je) je,jylx from (select khlx,zqlx,je,jylx  from t_etl_jy
              union all
              select khlx,zqlx,je,jylx  from t_etl_jy_rzrq) group by khlx,zqlx,jylx)
              where zqlx between 1 and 11
               and jylx = 1; --½

  begin
  update t_db_01_004 set a003=0;
    open cur_work;
    fetch cur_work
      into v_khlx, v_zqlx, v_je;

    while cur_work%found loop
      select count(*)
        into v_count
        from t_db_01_004
       where p001 = v_zqlx
         and a002 = v_khlx
         and A100 = 100000
         and w100 = v_bmid;
      if v_count > 0 then
        update t_db_01_004
           set A003 = v_je
         where p001 = v_zqlx
           and a002 = v_khlx
           and w100 = v_bmid;
      else
        insert into t_db_01_004
          (P001, A002, A003, A100, W100)
        values
          (v_zqlx, v_khlx, v_je, 100000, v_bmid);
      end if;

      fetch cur_work
        into v_khlx, v_zqlx, v_je;
    end loop;

    commit;
    insert into t_sys_t018
      (P001, P002, P003, A004, A005, A006)
    values
      (3004, 1013001, 'ϵͳ', 'ɼ֤ȯ', 1001101, sysdate);
  exception
    when others then
      rollback;
      insert into t_sys_t018
        (P001, P002, P003, A004, A005, A006)
      values
        (3004,
         1013001,
         'ϵͳ',
         'ɼ֤ȯ',
         1001102,
         sysdate);

  end;
  --ָй
  begin
    delete from t_db_01_006
     where p001 in (1001101, 1001102, 1001103, 1002000, 1002001, 1002002,
            1003000, 1004000, 1005000) and w100=v_bmid;
    insert into t_db_01_006
      (p001, a002, a003, a100, w100)
      select decode(zqlx,
                    1,
                    1001101, --A
                    2,
                    1001102, --B
                    3,
                    1001103, --B
                    4,
                    1002000, --
                    5,
                    1002001, --ETF
                    6,
                    1002002, --LOF
                    7,
                    1003000, --ծȯ
                    8,
                    1004000, --Ȩ֤
                    9,
                    1005000 --Ȩ֤
                    ),
             decode(khlx, 0, 1002, 1, 1001),
             je,
             100000,
             v_bmid
         from  (select khlx,zqlx,sum(je) je,jylx from (select khlx,zqlx,je,jylx  from t_etl_jy
    union all
    select khlx,zqlx,je,jylx  from t_etl_jy_rzrq) group by khlx,zqlx,jylx)
       where zqlx between 1 and 9
         and jylx = 2; --ָй
    commit;
    insert into t_sys_t018
      (P001, P002, P003, A004, A005, A006)
    values
      (3005,
       1013001,
       'ϵͳ',
       'ɼ֤ȯйֵ',
       1001101,
       sysdate);
  exception
    when others then
      rollback;
      insert into t_sys_t018
        (P001, P002, P003, A004, A005, A006)
      values
        (3005,
         1013001,
         'ϵͳ',
         'ɼ֤ȯйֵ',
         1001102,
         sysdate);

  end;

  --Ͻ
  declare
    v_zqlx number;
    v_je   number;
    v_jgh  number;
    v_count number;
    cursor cur_work is
      select decode(zqlx,
                    12,
                    1001, --
                    13,
                    1004, --۱
                    14,
                    1002), --Ԫ
             sum(je),
             100000
         from 
          (select khlx,zqlx,sum(je) je,jylx from (select khlx,zqlx,je,jylx  from t_etl_jy
    union all
    select khlx,zqlx,je,jylx  from t_etl_jy_rzrq) group by khlx,zqlx,jylx)
       where jylx = 1
         and zqlx in ('12', '13', '14')
       group by zqlx;

  begin
    open cur_work;
    fetch cur_work
      into v_zqlx, v_je, v_jgh;
    while cur_work%found loop
      select count(*) into v_count
        from t_db_01_005
       where P001 = v_zqlx
         and A100 = v_jgh
         and W100 = v_bmid;
      if v_count > 0 then
         update t_db_01_005 set A002 = v_je, A100 = v_jgh where p001 = v_zqlx and w100 = v_bmid;
      else
         insert into t_db_01_005(P001,A002,A100,W100)values(v_zqlx,v_je,v_jgh,v_bmid);
      end if;
      fetch cur_work
        into v_zqlx, v_je, v_jgh;
    end loop;
    close cur_work;

    commit;
    insert into t_sys_t018
      (P001, P002, P003, A004, A005, A006)
    values
      (3006, 1013001, 'ϵͳ', 'ɼϽ', 1001101, sysdate);
  exception
    when others then
      rollback;
      insert into t_sys_t018
        (P001, P002, P003, A004, A005, A006)
      values
        (3006,
         1013001,
         'ϵͳ',
         'ɼϽ',
         1001102,
         sysdate);

  end;

end cisp_etl_zqjy;
/

prompt
prompt Creating procedure CISP_ETL_ZQZH
prompt ================================
prompt
create or replace procedure cisp_etl_zqzh is
  v_bmid number; --ҵ񲿲ID
begin

  --select A012 into v_bmid from t_sys_user where p001 = 'yyzx';
  v_bmid :=50001;
  --֤ȯʻ
  delete from t_db_01_003
   where p001 in (1001008, 1001010, 1001009, 1001011, 1001013, 1001014,
          1001016, 1001015,1001024,1001025,1001026,1001028)
     and w100 = v_bmid;
     commit;
  --
  insert into t_db_01_003
    select 1001008 ,--׿           
           t.bz,sum(t.sl),
           100000,
           v_bmid
      from (select (case bz WHEN 0 THEN 1001 --RMB
                WHEN 1 THEN 1003 --HK$
                WHEN 2 THEN  1002  end) bz, --$
          /* decode(jylx,'3',-sl,sl)*/ sl sl         
      from t_etl_dlkxh 
      where JYLX IN ('5') )t
     group by t.bz;
  
  --Ͽ  
  insert into t_db_01_003
    select 1001025 ,--Ͽ           
           t.bz,sum(t.sl),
           100000,
           v_bmid
      from (select (case bz WHEN 0 THEN 1001 --RMB
                WHEN 1 THEN 1003 --HK$
                WHEN 2 THEN  1002  end) bz, --$
            sl         
      from t_etl_dlkxh 
      where JYLX IN ('11') )t
     group by t.bz;
   
  --֤  
   insert into t_db_01_003
    select 1001026 ,--֤           
           t.bz,sum(t.sl),
           100000,
           v_bmid
      from (select (case bz WHEN 0 THEN 1001 --RMB
                WHEN 1 THEN 1003 --HK$
                WHEN 2 THEN  1002  end) bz, --$
            sl         
      from t_etl_dlkxh 
      where JYLX IN ('12') )t
     group by t.bz;
     commit;
     
 --ֳ = ܿ - Ͽ-֤
  insert into t_db_01_003
  select 1001024,
           a.bz,
           nvl(a.sl, 0) - nvl(b.sl, 0) - nvl(c.sl, 0),
           100000,
           v_bmid
      from (select p002 as bz, nvl(a003, 0) as sl
              from t_db_01_003
             where p001 = 1001008
               and w100 = v_bmid) a,
           (select p002 as bz, nvl(a003, 0) as sl
              from t_db_01_003
             where p001 = 1001025
               and w100 = v_bmid) b,
           (select p002 as bz, nvl(a003, 0) as sl
              from t_db_01_003
             where p001 = 1001026
               and w100 = v_bmid) c
     where a.bz = b.bz(+)
       and a.bz = c.bz(+);

commit;
  --ת
  insert into t_db_01_003
    select 1001009, t1.bz, sum(t1.sl), 100000, v_bmid
      from (select (case bz
                     WHEN 0 THEN
                      1001 --RMB
                     WHEN 1 THEN
                      1003 --HK$
                     WHEN 2 THEN
                      1002
                   END) bz, --$
                    sl
              from t_etl_dlkxh
             where jylx = 3          
          ) t1
     group by t1.bz;
commit;
  --ת
  insert into t_db_01_003
    select 1001011, t1.bz, sum(t1.sl), 100000, v_bmid
      from (select (case bz
                     WHEN 0 THEN
                      1001 --RMB
                     WHEN 1 THEN
                      1003 --HK$
                     WHEN 2 THEN
                      1002
                   END) bz, --$
                   sl sl
              from t_etl_dlkxh
             where jylx = 4
            ) t1
     group by t1.bz;
commit;
  --ĩС
  insert into t_db_01_003
    select decode(sc, 0, 1001013, 1001014),
           decode(bz, 0, 1001, 1, 1003, 2, 1002),
           sum(sl),
           100000,
           v_bmid
      from t_etl_zqzh
     where jylx = 7
     group by sc, bz;

  --ĩ
  insert into t_db_01_003
    select decode(khlx, 0, 1001016, 1001015),
           decode(bz, 0, 1001, 1, 1003, 2, 1002),
           sum(sl),
           100000,
           v_bmid
      from t_etl_zqzh
     where jylx = 7
     group by khlx, bz;
commit;
  --Ϊ˱֤ƽϵ㣺-
  delete from t_db_01_003
   where p001 = 1001010
     and w100 = v_bmid; ---
     commit;
  insert into t_db_01_003
    (p001, p002, a003, a100, w100)
     select 1001010,
           a.p002,
           nvl(a.qc, 0) + nvl(b.dlkh, 0) + nvl(c.zr, 0) - nvl(d.zc, 0) -
           nvl(e.qmss, 0) - nvl(f.qmhs, 0),
           100000,
           v_bmid
      from (select p002, a003 as qc
              from t_db_01_003
             where p001 = 1001007
               and w100 = v_bmid) a, --ڳ
           (select p002, a003 as dlkh
              from t_db_01_003
             where p001 = 1001008
               and w100 = v_bmid) b, --
           (select p002, a003 as zr
              from t_db_01_003
             where p001 = 1001009
               and w100 = v_bmid) c, --ת
           (select p002, a003 as zc
              from t_db_01_003
             where p001 = 1001011
               and w100 = v_bmid) d, --ת
           (select p002, a003 as qmss
              from t_db_01_003
             where p001 = 1001013
               and w100 = v_bmid) e, --ĩ
           (select p002, a003 as qmhs
              from t_db_01_003
             where p001 = 1001014
               and w100 = v_bmid) f --ĩ
     where a.p002 = b.p002(+)
       and a.p002 = c.p002(+)
       and a.p002 = d.p002(+)
       and a.p002 = e.p002(+)
       and a.p002 = f.p002(+);
       commit;

  update t_db_01_003 a
     set A003 = nvl(A003,0) - (select (case when b.A003 < 0 then b.A003 else 0 end)
                             from t_db_01_003 b
                            where b.p001 = 1001010
                            and a.p002 = b.p002
                            )
   where a.p001 = 1001008;
   commit;

  update t_db_01_003 a
     set A003 = nvl(A003,0) - (select (case when b.A003 < 0 then b.A003 else 0 end)
                             from t_db_01_003 b
                            where b.p001 = 1001010
                            and a.p002 = b.p002
                            )
   where a.p001 = 1001024;
   commit;
   
   update t_db_01_003 set a003 = 0 where p001 = 1001010 and a003 <0;
   commit;
   
   
   --
   --
  insert into t_db_01_003
    select 1001028, t1.bz, sum(t1.sl), 100000, v_bmid
      from (select (case bz
                     WHEN 0 THEN
                      1001 --RMB
                     WHEN 1 THEN
                      1003 --HK$
                     WHEN 2 THEN
                      1002
                   END) bz, --$
                   sl sl
              from t_etl_dlkxh
             where jylx = 21
            ) t1
     group by t1.bz;
   --֤  
   insert into t_db_01_003
    select 1001029, t1.bz, sum(t1.sl), 100000, v_bmid
      from (select (case bz
                     WHEN 0 THEN
                      1001 --RMB
                     WHEN 1 THEN
                      1003 --HK$
                     WHEN 2 THEN
                      1002
                   END) bz, --$
                   sl sl
              from t_etl_dlkxh
             where jylx = 22
            ) t1
     group by t1.bz;
  commit;
  
    delete from t_db_01_003
   where p001 = 1001027
     and w100 = v_bmid; ---ֳ
     commit;
  insert into t_db_01_003
    (p001, p002, a003, a100, w100)
    select 1001027,
           a.p002,
           nvl(a.hs, 0) - nvl(b.hs, 0) - nvl(c.hs, 0),
           100000,
           v_bmid
      from (select p002, a003 as hs
              from t_db_01_003
             where p001 = 1001010
               and w100 = v_bmid) a, --
           (select p002, a003 as hs
              from t_db_01_003
             where p001 = 1001028
               and w100 = v_bmid) b, --
           (select p002, a003 as hs
              from t_db_01_003
             where p001 = 1001029
               and w100 = v_bmid) c --֤ 
     where a.p002 = b.p002(+)
       and a.p002 = c.p002(+);
  commit;   

  insert into t_sys_t018
    (P001, P002, P003, A004, A005, A006)
  values
    (3003,
     1013001,
     'ϵͳ',
     'ɼ֤ȯ˻',
     1001101,
     sysdate);
     commit;
exception
  when others then
    rollback;
    insert into t_sys_t018
      (P001, P002, P003, A004, A005, A006)
    values
      (3003, 1013001, 'ϵͳ', 'ɼ֤ȯ˻', 1001102, sysdate);

end cisp_etl_zqzh;
/

prompt
prompt Creating procedure CISP_INIT_REPORTDATE
prompt =======================================
prompt
create or replace procedure cisp_init_reportdate(
    errcode out int,
    errmsg out varchar2,
    kjaxuser varchar2,
    v_TASK varchar2,
    v_P001 integer,
    v_P002 integer
)
is
    v_EB003 varchar2(256);
    v_Ecmd  varchar2(1024);
    v_date  integer;
    v_F100  integer;
    v_my number(19,5);
    v_gb number(19,5);
    v_frid number;
    v_bmid number;

    cursor c_work is
    select distinct b.B003   --Ӫҵݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T012) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 12
    union
    select distinct b.B003   --ݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T022) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 11;

begin

     --Ƿʼ
     select F100 into v_F100 from T_B00_D004 where P001=v_P001 and A002=v_P002 and c001 =1001101 and D100=1006002;
     if v_F100 = 1007001 then
        errcode := 1;
        errmsg  := 'ʼ, !';
        return;
     end if;
     
     --ѳʼ־ 20200703 ӳĩβŲǰ棬ֹظʼť
     update T_B00_D004 set F100=1007001 where P001=v_P001 and A002=v_P002;
     commit;

     select nvl(sum(a002),0) into v_my from t_bks_t007;  --us$ 
     select nvl(sum(a003),0) into v_gb from t_bks_t007;  --hk$ 

     DELETE FROM T_SYS_T017 WHERE P002=v_P002;

     --˾Աҵ̨
     update t_bks_t040 set A002=0,A003=0;

         --Ӫҵ˾״̬λȫ״̬
         update KRCS.T_SYS_T014
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002,
                A016 = 1009002,
                A020 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --ű״̬λȫ״̬
         update KRCS.T_SYS_T024
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002
          where A006 = v_P002
            AND A002 = 11;

         --Ӫҵ˾еĵ״̬ûʱΪ
         update KRCS.T_SYS_T014
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --űеĵ״̬ûʱΪ
         update KRCS.T_SYS_T024
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 = 11;

         commit;

     --ݱλȫ״̬λ
     open c_work;
     loop
         fetch c_work into v_EB003;
         if v_EB003 is not null then
             if v_EB003 = 'T_DB_04_001' then
                update t_db_04_001
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A011 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶʹƱ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002' then
                update t_db_04_002
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A010 = 0,
                       A012 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶծȯT_DB_04_002',1001101,sysdate);
            elsif v_EB003 = 'T_DB_B2_02' then
                update t_db_b2_02
                   set A004 = A006,
                       A005 = A007,
                       A100 = null;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽֲ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_004' then
                 update t_db_01_004
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0)*decode(p001,1001102,v_gb,1001103,v_my,1) + nvl(A004,0) end),
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ׻ܱT_DB_01_004',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_005' then
                 update t_db_01_005
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0)*decode(P001,1001,1,1002,v_my,1004,v_gb) + nvl(A003,0) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵϽױT_DB_01_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_007' then
                 update t_db_01_007  a
                    set a.A002 = (case when substr(v_P001,5,2)='01' then 0 else nvl(a.A002,0)+(select nvl(b.A002,0)*decode(b.a003,1001,1,1002,v_gb,1004,v_my) from t_db_01_007 b where b.P001=1001303 and b.A003=a.a003 and b.W100=a.W100) end)
                  where a.P001=1001304
                  and a.A003 in (1001,1002,1004)
                  and exists(select 1
                               from t_db_01_007 b
                               where b.P001=1001303
                                 and b.A003=a.a003
                                 and b.W100=a.W100);

                 update t_db_01_007
                    set A002 = 0
                  where P001 <> 1001304 and w100=v_bmid;

                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񲹳T_DB_01_007',1001101,sysdate);
             elsif v_EB003 = 'T_DB_08_001' then
                 update t_db_08_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + nvl(A005,0) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + nvl(A007,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A008 = null;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_08_001',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_001' then
                 update t_db_09_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعӪT_DB_09_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_09_002' then
                 update t_db_09_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعʲT_DB_09_002',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_003' then
                 update t_db_09_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعT_DB_09_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_11_001' then
                 update t_db_11_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪT_DB_11_001',1001101,sysdate);
               elsif v_EB003 = 'T_DB_11_002' then
                 update t_db_11_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعʲT_DB_11_002',1001101,sysdate);

               elsif v_EB003 = 'T_DB_11_003' then
                 update t_db_11_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ񣩡T_DB_11_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_12_001' then
                 update t_db_12_001
                    set A006 = 0,
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼмгT_DB_12_001',1001101,sysdate);
            /* elsif v_EB003 = 'T_DB_12_002' then
                 update t_db_12_002
                    set A006 =(case when substr(v_P001,5,2)='01' then 0 else nvl(A006,0) + nvl(A003,0)+nvl(A004,0) end),
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006\*,w100*\) VALUES(v_P001,v_P002,'ݱ','ʼмгȯ14002',1001101,sysdate\*,v_frid*\);
            */ elsif v_EB003 = 'T_DB_B4_03' then
                 update T_DB_B4_03
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004*v_my,0) + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005*v_gb,0) + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0,
                        a012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        a013 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A010*v_my,0) + nvl(A013,0) end),
                        a014 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A011*v_gb,0) + nvl(A014,0) end),
                        a009 = 0,
                        a010 = 0,
                        a011 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵֳױT_DB_B4_03',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_02' then
                 update t_db_b4_02
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0)*v_gb + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005,0)*v_my + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0;
                 insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵɷݽT_DB_B4_02',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_001' then
                 update t_db_03_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ״ηУT_DB_03_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_04' then
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʡT_DB_B4_04',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_003' then
                 update t_db_03_003
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵɣT_DB_03_003',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_005' then
                 update t_db_03_005
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_007' then
                 update t_db_03_007
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯУT_DB_03_007',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_009' then
                 update t_db_03_009
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_009',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_011' then
                 update t_db_03_011
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸״ηУT_DB_03_011',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_013' then
                 update t_db_03_013
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ɣT_DB_03_013',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_015' then
                 update t_db_03_015
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_015',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_017' then
                 update t_db_03_017
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ծȯУT_DB_03_017',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_019' then
                 update t_db_03_019
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_019',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002_02_01' then
                 update T_DB_04_002_02_01
                    set A003 = A006,
                        A004 = 0,
                        A005 = 0,
                        A006 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','֤ȯͶҵ(ծȯ,)--̶',1001101,sysdate);
             elsif v_EB003 = 'T_DA_01_004' then
                 update T_DA_01_004
                    set A002 = A003,
                        A003 = 0,
                        A005 = A006,
                        A006 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ׼',1001101,sysdate);


            elsif v_EB003 = 'T_DB_61_001' then
                 update T_DB_61_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_61_002' then
                 update t_db_03_019
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻعҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_001' then
                 update T_DB_62_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽ׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_002' then
                 update T_DB_62_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_001' then
                 update T_DB_63_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_002' then
                 update T_DB_63_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽعҵģ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_63_001_RH' then
                 update T_DB_63_001_RH
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽع׼_ڻ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_002_RH' then
                 update T_DB_63_002_RH
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽعҵģ_ڻ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_63_001_ZYZJ' then
                 update T_DB_63_001_ZYZJ
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽع׼_ʽ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_002_ZYZJ' then
                 update T_DB_63_002_ZYZJ
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽعҵģ_ʽ',1001101,sysdate);
             else
                 v_Ecmd := 'delete from '||v_EB003;
                 execute immediate v_Ecmd;
             end if;
         end if;

         exit when c_work%notfound;
     end loop;
     close c_work;

    --λӪҵݱ״̬
    update KRCS.T_SYS_T012
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 12;

    --λݱ״̬
    update KRCS.T_SYS_T022
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 11;


     --ݱеǷ롢ûʱΪ
     --Ӫҵݱ
     update KRCS.T_SYS_T012
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 12;

     --ݱ
     update KRCS.T_SYS_T022
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 11;

     --Ӫҵ˾״̬λȫ״̬
     update KRCS.T_SYS_T014
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002,
            A016 = 1009002
      where A006 = v_P002
        AND A002 IN(11,12);

     --ű״̬λȫ״̬
     update KRCS.T_SYS_T024
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002
      where A006 = v_P002
        AND A002 = 11;

     --
     delete from T_SYS_T029 t where P001 IN(SELECT A005 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     --V10״̬
     delete from KRCS.t_sys_t066 where P003 IN(SELECT P001 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     if (v_P002=1013001) then  -- ±

        --ʱ
        select max(P001) INTO v_date from t_idx_f004 where P003=1001002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001102,sysdate);
        else
           insert into T_DA_01_001(p001,A002,A100,W100)
           select p002,v,(select t1.w100 from KRCS.T_CTL_T036 t1 where t1.p001=t.w100),W100
             from t_idx_f004 t
            where P003 = 1001002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001101,sysdate);
        end if ;

        --֤ȯ˾տָܱ
        select max(P001) INTO v_date from t_idx_f005 where P003=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001102,sysdate);
        else
           insert into T_DA_01_002(p001,A002,A100,W100)
           select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from t_idx_f005 t1
            where P003 = 1002002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001101,sysdate);
        end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001102,sysdate);
        else
         if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 < 501100                                      --ųϵ
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           else
           insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 < 501100                                      --ųϵ
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           end if;
         end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 >= 501100
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
           else
           insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 >= 501100
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
          end if;
        end if ;


        --ܱ
        select max(P001) INTO v_date from t_act_f002 where P002=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾',1001102,sysdate);
        else
           insert into t_dact_003(p001,a003,a100,w100)
           select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),w100
           from t_act_f002 t1
           where p002 = 1002002
           and p001 = v_date;

          if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_dact_003 set A003=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾',1001101,sysdate);
        end if;

        --ʲֵ׼
        select max(P001) INTO v_date from T_ACT_F004 where P002=1001005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001102,sysdate);
        else
          if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001005
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         else
          insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001001
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         end if;
        end if ;

        --ҵ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001102,sysdate);
        else
           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001404;

           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_008 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001101,sysdate);
        end if;

        --ҵʲƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001102,sysdate);
        else
           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001404;

           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_009 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001101,sysdate);
        end if;

        --ҵծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1003;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001102,sysdate);
        else
           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001404;

           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_010 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001101,sysdate);
        end if;

        --ҵծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001102,sysdate);
        else
           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001404;

           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_011 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001101,sysdate);
        end if;

        --ҵҸծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001102,sysdate);
        else
           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001404;

           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_012 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001101,sysdate);
        end if;

        --ҵҸծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1006;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001102,sysdate);
        else
           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001404;

           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_013 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001101,sysdate);
        end if;

        --ҵͻʽ
        select max(P001) into v_date from T_B01_F003 where P002=1001 and P003=1001105;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001102,sysdate);
        else
           insert into T_DB_01_001(P001,P002,A003,A100,W100)
           select 1001101,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F003 t1
            where P003=1001105
              and p001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001101,sysdate);
        end if;

        --ҵʽʻ
        select max(P001) into v_date from T_B01_F002 where P002=1001 and P003=1001004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001102,sysdate);
        else
           insert into T_DB_01_002(P001,P002,A003,A100,W100)
           select 1001001,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F002 t1
            where p001 = v_date
              and P003=1001004
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001101,sysdate);
        end if;

        --ҵ˻
      select max(p001) into v_date from T_B01_F020 where p003 = 1004004;
       if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001102,sysdate);
        else
        insert into T_DB_01_020 (P001,A002,W100,A100)
        select p002,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
        from T_B01_F020 t1
        where p001 = v_date
        and p003 = 1004004;

         insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001101,sysdate);
        end if;

        --ҵ֤ȯʻ
        select max(P001) into v_date from T_B01_F001 where P002=1001 and P003=1001012;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001102,sysdate);
        else
           insert into T_DB_01_003(P001,P002,A003,A100,W100)
           select 1001007,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F001 t1
            where p001 = v_date
              and P003=1001012
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001101,sysdate);
        end if;

        --ҵƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵƷ',1001102,sysdate);
        else
           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001404;

           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_014 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҵ',1001101,sysdate);
        end if;

        --ʼܲC12-ڲƷͳƱ add by 2013-01-18
        select max(P001) INTO v_date from T_B50_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_50_001(p001,/*a004,*/a005,a009,a100,w100)
           select p002,
                 /*(select v
                  from T_B50_F001
                  where p003 = 1003
                  and p001 = a.p001
                  and p002 = a.p002
                  ) as a003,*/
                  (select v
                  from T_B50_F001
                  where p003 = 1004
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  ) as a005,
                  decode(a.p001,1240,0,1250,0,
                  (select v
                  from T_B50_F001
                  where p003 = 1008
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  )) as a009,
                  100000,
                  a.w100
             from (select distinct p001,p002,w100
                   from T_B50_F001
                   where p001 = v_date
                     and p002 not in (1230,1200,1090,1140)
                     and p003 in (1008,1004) )a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_50_001 set /*A004=0,*/a005=0,a009=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵҵܣ
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001102,sysdate);
        else
           insert into T_DB_15_001(P001,A002,A100,W100)
           select A.P002,A.V,(select w100 from KRCS.T_CTL_T036 t where t.p001=a.w100),A.W100
             from T_B11_F003 A, T_B11_D001 B
            where A.P002(+)=B.P001
              and B.P001!=1099
              and A.P003=1011004
              and A.P001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵӶ룩
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011102 AND P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001102,sysdate);
        else
           insert into T_DB_15_002(P001,A003,A100,W100)
           select P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B11_F003 t1
            where P003=1011102
              and P002=1099
              and P001=v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_15_002 SET A003=0; -- ꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001101,sysdate);
        end if;

        --ʽծȯعӪ ޸ĳɺT_DB_09_003һķʽ modified by wuzhao 2009/9/28
        /*select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1001 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001102,sysdate);
        else
           insert into T_DB_11_001(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1001
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_001 a
              set A011=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_001 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_001 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001101,sysdate);
        end if;

        --ʽծȯعҵ
        select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1003 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001102,sysdate);
        else
           insert into T_DB_11_003(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1003
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_003 a
              SET A011=(SELECT V FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_003 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_003 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001101,sysdate);
        end if;*/

        --ʻչ
   /*     select max(p001) into v_date FROM T_B15_F001 where P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001102,sysdate);
        else
           insert into t_db1_01_001(P001,A002,A100,W100)
           select P002,V, (select w100 from KRCS.T_CTL_T036 t where t.p001=w100), W100
             from T_B15_F001
            where P001=v_date
              and P002 = 1001;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001101,sysdate);
        end if;*/

        ----------------------ʲ-----------------------------


         --ʼC4-1ʲҵ
     select max(P001) INTO v_date from t_b04_f102 where P003=1004805;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_05_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f102
            where p001= v_date
              and p003 = 1004805;

           insert into T_DB_05_103(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f103
            where p001= v_date
              and p003 = 1004902;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

     --ʼC4-3ʲҵ
     select max(P001) INTO v_date from T_B07_F001 where P003=1005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_07_101(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F001
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert into T_DB_07_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F002
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

        ----------------------Ӫҵ-------------------------------
        --ʲծ״
        select max(P001) INTO v_date from t_b001_f001 where P004=1025001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʲծ״',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
              then
             insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025001
                and p001 = substr(to_char(v_P001-13),0,4)||'12';

             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
             else
              insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025002
                and p001 = v_date;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
           end if;
        end if ;

        --
        select max(P001) INTO v_date from t_b001_f002 where P004=1026002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ',1001102,sysdate);
        else
           insert into t_db_b1_02(p001,p002,A004)
           select p002,P003,v
             from t_b001_f002
            where P004=1026002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b1_02 set A004=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ',1001101,sysdate);
        end if;


        --ͻʲ
        select max(P001) INTO v_date from t_b002_f001 where P004=1027001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001102,sysdate);
        else
           insert into t_db_b2_01(p001,p002,A004)
           select p002,P003,v
             from t_b002_f001
            where P004=1027001
              and p001 = v_date;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001101,sysdate);
        end if;

        --ʽ˻
        select max(P001) INTO v_date from t_b003_f001 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʽ˻',1001102,sysdate);
        else
           insert into t_db_b3_01(p001,p002,A003)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f001
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2007001) as v1
             from (select distinct p001, p004 from t_b003_f001 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʽ˻',1001101,sysdate);
        end if;

        --֤ȯ˻
        select max(P001) INTO v_date from t_b003_f002 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001102,sysdate);
        else
           insert into t_db_b3_02(p001,p002,A003,A004)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008001) as v1,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008002) as v1
             from (select distinct p001, p004 from t_b003_f002 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001101,sysdate);
        end if;

        --˻
        select max(P001) INTO v_date from t_b003_f003 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ˻',1001102,sysdate);
        else
           insert into t_db_b3_03(p001,p002,A003)
           select p004,1001,v
             from t_b003_f003
            where P002=1004
              and p001 = v_date
              and p003 = 2009001;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ˻',1001101,sysdate);
        end if;

        --֤ȯ
        select max(P001) INTO v_date from t_b004_f001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001102,sysdate);
        else
           insert into t_db_b4_01(p001,p002,A004,A006)
           select a.p004,
                  decode(a.p002,1001,1001,
                              1005,1005,
                              1006,1006,
                              1007,1007,
                              1008,1008,
                              1009,1009,
                              1010,1010,
                              1014,1002,
                              1015,1003),
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005002) as v1,
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005004) as v1
             from (select distinct p001,p002, p004 from t_b004_f001 where p001 = v_date and p002 not in (1004,1011,1012,1013,1016)) a;

            if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_01 set A004=0,A006=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001101,sysdate);
        end if;

        --ɷݽ
        /* select max(P001) INTO v_date from t_b004_f002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        else
           insert into t_db_b4_02(p001,p002,A004)
           select p004,P002,v
             from t_b004_f002
            where P003=2011002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_02 set A004=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        end if;
        */

         --ʼȯҵ¶רͳ



        --֤ȯӪҵȯҵ¶רͳƱ
        select max(P001) INTO v_date from T_B01_DACT_B_R001 where P003=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001102,sysdate);
        else
           insert into T_DACT_B_R001(p001,p002,A003)
           select p004,P002,v
             from T_B01_DACT_B_R001
            where P003=1001
              and p001 = v_date
              and p002 not in (1009,1010,1011,1012,1013,1014);

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DACT_B_R001 set A002=0,A003=0 where p002 = 1019; -- Сȯ0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001101,sysdate);
        end if;


        --ʼC10-1update by 20120220 wull
      select max(P001) INTO v_date from t_b30_f001 ;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001102,sysdate);
        else
            --ʼ  ƽͺԴʼ,ʼΪ
            -- 1ڱ 2ڱ 3ڱڱ

            --1ڱkrcs_etl_rzrq_c10_1ݱת洢Уʱֱȡݱеı

            --2ڱ ʱֱȡݱеı
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10020,10100,10110,10120);

            --3ڱڱʱݱеıӱ
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);

            --ʼ ---


            --±ڡ
            --ʽ˻ڳ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10050)
            where t.p001 = 10020;

            --ڳȯ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10190)
            where t.p001 = 10100;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10200)
            where t.p001 = 10110;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10210)
            where t.p001 = 10120;



            --겿Ŀ0ִ0
             if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_30_001 set A003=0
              where p001 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);
            
            -- ڳʽ˻ձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10050)
            where t.p001 = 10020;
            commit;

            -- ڳȯձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10190)
            where t.p001 = 10100;
            commit;

             -- ڳʽձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10200)
            where t.p001 = 10110;
            commit;

             -- ڳȯձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10210)
            where t.p001 = 10120;
            commit;
                             
           end if;

            --ڳʼ --

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001101,sysdate);
        end if;



        --ʼӪҵڲƷͳƱadd by 2013-01-18

        select max(P001) INTO v_date from T_B050_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_B50_01(p001,p002,a006,a010)
           select p004,
                  p002,
                  (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1004) as v1,
                   decode(a.p002,1240,0,1250,0,
                    (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1008) ) as v2
             from (select distinct p001,p002, p004 from T_B050_F001 where p001 = v_date and p002 not in (1230,1200,1090,1140)) a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_B50_01 set /*A004=0,*/a006=0,a010=0; -- 0;
           end if;

       ---C12-1B-A5-1гɽ add by zhenyj 20190220
        delete from kods.a_hs_his_secumdealinfo_temp2;
        delete from kods.a_hs_his_secumdealinfo_bn_t2;
        insert into kods.a_hs_his_secumdealinfo_temp2
          select * from kods.a_hs_his_secumdealinfo_temp;
        insert into kods.a_hs_his_secumdealinfo_bn_t2
          select * from kods.a_hs_his_secumdealinfo_bn_t1;
        commit;


   --CISP_INIT_REPORTDATE_AFTER(v_P002);
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001101,sysdate);
        end if;

     end if;


     if (v_P002=1013002) then  -- 
        errcode := 1;
     end if;

     if (v_P002=1013003) then  -- 걨
        errcode := 1;
     end if;

     commit;
     errcode := 1;
     errmsg  := 'ʼڳɹ';
/*
     EXCEPTION WHEN OTHERS THEN
        rollback;
        errcode := 0;
        errmsg  := 'ʼʧ'||sqlerrm;
        RETURN;*/
end;
/

prompt
prompt Creating procedure CISP_INIT_REPORTDATE_20190212
prompt ================================================
prompt
create or replace procedure cisp_init_reportdate_20190212(
    errcode out int,
    errmsg out varchar2,
    kjaxuser varchar2,
    v_TASK varchar2,
    v_P001 integer,
    v_P002 integer
)
is
    --v_EP001 integer;
    v_EB003 varchar2(256);
    v_Ecmd  varchar2(1024);
   /* v_version varchar2(1);*/
    v_date  integer;
    v_F100  integer;
    v_my number(19,5);
    v_gb number(19,5);
    v_frid number;
    --v_orgid number;
    v_bmid number;

    cursor c_work is
    select distinct b.B003   --Ӫҵݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T012) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 12
    union
    select distinct b.B003   --ݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T022) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 11;

begin

     --Ƿʼ
     select F100 into v_F100 from T_B00_D004 where P001=v_P001 and A002=v_P002 and c001 =1001101 and D100=1006002;
     if v_F100 = 1007001 then
        errcode := 1;
        errmsg  := 'ʼ, !';
        return;
     end if;

     select nvl(sum(a002),0) into v_my from t_bks_t007;  --us$ 
     select nvl(sum(a003),0) into v_gb from t_bks_t007;  --hk$ 

     DELETE FROM T_SYS_T017 WHERE P002=v_P002;

     --˾Աҵ̨
     update t_bks_t040 set A002=0,A003=0;

         --Ӫҵ˾״̬λȫ״̬
         update KRCS.T_SYS_T014
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002,
                A016 = 1009002,
                A020 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --ű״̬λȫ״̬
         update KRCS.T_SYS_T024
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002
          where A006 = v_P002
            AND A002 = 11;

         --Ӫҵ˾еĵ״̬ûʱΪ
         update KRCS.T_SYS_T014
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --űеĵ״̬ûʱΪ
         update KRCS.T_SYS_T024
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 = 11;

         commit;

     --ݱλȫ״̬λ
     open c_work;
     loop
         fetch c_work into v_EB003;
         if v_EB003 is not null then
             if v_EB003 = 'T_DB_04_001' then
                update t_db_04_001
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A011 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶʹƱ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002' then
                update t_db_04_002
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A010 = 0,
                       A012 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶծȯT_DB_04_002',1001101,sysdate);
            elsif v_EB003 = 'T_DB_B2_02' then
                update t_db_b2_02
                   set A004 = A006,
                       A005 = A007,
                       A100 = null;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽֲ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_004' then
                 update t_db_01_004
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0)*decode(p001,1001102,v_gb,1001103,v_my,1) + nvl(A004,0) end),
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ׻ܱT_DB_01_004',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_005' then
                 update t_db_01_005
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0)*decode(P001,1001,1,1002,v_my,1004,v_gb) + nvl(A003,0) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵϽױT_DB_01_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_007' then
                 update t_db_01_007  a
                    set a.A002 = (case when substr(v_P001,5,2)='01' then 0 else nvl(a.A002,0)+(select nvl(b.A002,0)*decode(b.a003,1001,1,1002,v_gb,1004,v_my) from t_db_01_007 b where b.P001=1001303 and b.A003=a.a003 and b.W100=a.W100) end)
                  where a.P001=1001304
                  and a.A003 in (1001,1002,1004)
                  and exists(select 1
                               from t_db_01_007 b
                               where b.P001=1001303
                                 and b.A003=a.a003
                                 and b.W100=a.W100);

                 update t_db_01_007
                    set A002 = 0
                  where P001 <> 1001304 and w100=v_bmid;

                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񲹳T_DB_01_007',1001101,sysdate);
             elsif v_EB003 = 'T_DB_08_001' then
                 update t_db_08_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + nvl(A005,0) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + nvl(A007,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A008 = null;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_08_001',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_001' then
                 update t_db_09_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعӪT_DB_09_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_09_002' then
                 update t_db_09_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعʲT_DB_09_002',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_003' then
                 update t_db_09_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعT_DB_09_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_11_001' then
                 update t_db_11_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪT_DB_11_001',1001101,sysdate);
               elsif v_EB003 = 'T_DB_11_002' then
                 update t_db_11_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعʲT_DB_11_002',1001101,sysdate);

               elsif v_EB003 = 'T_DB_11_003' then
                 update t_db_11_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ񣩡T_DB_11_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_12_001' then
                 update t_db_12_001
                    set A006 = 0,
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼмгT_DB_12_001',1001101,sysdate);
            /* elsif v_EB003 = 'T_DB_12_002' then
                 update t_db_12_002
                    set A006 =(case when substr(v_P001,5,2)='01' then 0 else nvl(A006,0) + nvl(A003,0)+nvl(A004,0) end),
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006\*,w100*\) VALUES(v_P001,v_P002,'ݱ','ʼмгȯ14002',1001101,sysdate\*,v_frid*\);
            */ elsif v_EB003 = 'T_DB_B4_03' then
                 update T_DB_B4_03
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004*v_my,0) + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005*v_gb,0) + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0,
                        a012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        a013 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A010*v_my,0) + nvl(A013,0) end),
                        a014 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A011*v_gb,0) + nvl(A014,0) end),
                        a009 = 0,
                        a010 = 0,
                        a011 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵֳױT_DB_B4_03',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_02' then
                 update t_db_b4_02
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0)*v_gb + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005,0)*v_my + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0;
                 insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵɷݽT_DB_B4_02',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_001' then
                 update t_db_03_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ״ηУT_DB_03_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_04' then
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʡT_DB_B4_04',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_003' then
                 update t_db_03_003
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵɣT_DB_03_003',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_005' then
                 update t_db_03_005
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_007' then
                 update t_db_03_007
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯУT_DB_03_007',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_009' then
                 update t_db_03_009
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_009',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_011' then
                 update t_db_03_011
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸״ηУT_DB_03_011',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_013' then
                 update t_db_03_013
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ɣT_DB_03_013',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_015' then
                 update t_db_03_015
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_015',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_017' then
                 update t_db_03_017
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ծȯУT_DB_03_017',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_019' then
                 update t_db_03_019
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_019',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002_02_01' then
                 update T_DB_04_002_02_01
                    set A003 = A006,
                        A004 = 0,
                        A005 = 0,
                        A006 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','֤ȯͶҵ(ծȯ,)--̶',1001101,sysdate);
             elsif v_EB003 = 'T_DA_01_004' then
                 update T_DA_01_004
                    set A002 = A003,
                        A003 = 0,
                        A005 = A006,
                        A006 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ׼',1001101,sysdate);


            elsif v_EB003 = 'T_DB_61_001' then
                 update T_DB_61_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_61_002' then
                 update t_db_03_019
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻعҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_001' then
                 update T_DB_62_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽ׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_002' then
                 update T_DB_62_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_001' then
                 update T_DB_63_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_002' then
                 update T_DB_63_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽعҵģ',1001101,sysdate);
             else
                 v_Ecmd := 'delete from '||v_EB003;
                 execute immediate v_Ecmd;
             end if;
         end if;

         exit when c_work%notfound;
     end loop;
     close c_work;

    --λӪҵݱ״̬
    update KRCS.T_SYS_T012
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 12;

    --λݱ״̬
    update KRCS.T_SYS_T022
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 11;


     --ݱеǷ롢ûʱΪ
     --Ӫҵݱ
     update KRCS.T_SYS_T012
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 12;

     --ݱ
     update KRCS.T_SYS_T022
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 11;

     --Ӫҵ˾״̬λȫ״̬
     update KRCS.T_SYS_T014
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002,
            A016 = 1009002
      where A006 = v_P002
        AND A002 IN(11,12);

     --ű״̬λȫ״̬
     update KRCS.T_SYS_T024
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002
      where A006 = v_P002
        AND A002 = 11;

     --
     delete from T_SYS_T029 t where P001 IN(SELECT A005 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     --V10״̬
     delete from KRCS.t_sys_t066 where P003 IN(SELECT P001 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     if (v_P002=1013001) then  -- ±

        --ʱ
        select max(P001) INTO v_date from t_idx_f004 where P003=1001002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001102,sysdate);
        else
           insert into T_DA_01_001(p001,A002,A100,W100)
           select p002,v,(select t1.w100 from KRCS.T_CTL_T036 t1 where t1.p001=t.w100),W100
             from t_idx_f004 t
            where P003 = 1001002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001101,sysdate);
        end if ;

        --֤ȯ˾տָܱ
        select max(P001) INTO v_date from t_idx_f005 where P003=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001102,sysdate);
        else
           insert into T_DA_01_002(p001,A002,A100,W100)
           select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from t_idx_f005 t1
            where P003 = 1002002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001101,sysdate);
        end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001102,sysdate);
        else
         if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 < 501100                                      --ųϵ
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           else
           insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 < 501100                                      --ųϵ
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           end if;
         end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 >= 501100
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
           else
           insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 >= 501100
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
          end if;
        end if ;


        --ܱ
        select max(P001) INTO v_date from t_act_f002 where P002=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾',1001102,sysdate);
        else
           insert into t_dact_003(p001,a003,a100,w100)
           select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),w100
           from t_act_f002 t1
           where p002 = 1002002
           and p001 = v_date;

          if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_dact_003 set A003=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾',1001101,sysdate);
        end if;

        --ʲֵ׼
        select max(P001) INTO v_date from T_ACT_F004 where P002=1001005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001102,sysdate);
        else
          if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001005
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         else
          insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001001
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         end if;
        end if ;

        --ҵ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001102,sysdate);
        else
           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001404;

           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_008 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001101,sysdate);
        end if;

        --ҵʲƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001102,sysdate);
        else
           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001404;

           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_009 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001101,sysdate);
        end if;

        --ҵծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1003;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001102,sysdate);
        else
           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001404;

           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_010 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001101,sysdate);
        end if;

        --ҵծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001102,sysdate);
        else
           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001404;

           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_011 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001101,sysdate);
        end if;

        --ҵҸծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001102,sysdate);
        else
           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001404;

           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_012 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001101,sysdate);
        end if;

        --ҵҸծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1006;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001102,sysdate);
        else
           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001404;

           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_013 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001101,sysdate);
        end if;

        --ҵͻʽ
        select max(P001) into v_date from T_B01_F003 where P002=1001 and P003=1001105;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001102,sysdate);
        else
           insert into T_DB_01_001(P001,P002,A003,A100,W100)
           select 1001101,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F003 t1
            where P003=1001105
              and p001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001101,sysdate);
        end if;

        --ҵʽʻ
        select max(P001) into v_date from T_B01_F002 where P002=1001 and P003=1001004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001102,sysdate);
        else
           insert into T_DB_01_002(P001,P002,A003,A100,W100)
           select 1001001,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F002 t1
            where p001 = v_date
              and P003=1001004
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001101,sysdate);
        end if;

        --ҵ˻
      select max(p001) into v_date from T_B01_F020 where p003 = 1004004;
       if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001102,sysdate);
        else
        insert into T_DB_01_020 (P001,A002,W100,A100)
        select p002,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
        from T_B01_F020 t1
        where p001 = v_date
        and p003 = 1004004;

         insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001101,sysdate);
        end if;

        --ҵ֤ȯʻ
        select max(P001) into v_date from T_B01_F001 where P002=1001 and P003=1001012;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001102,sysdate);
        else
           insert into T_DB_01_003(P001,P002,A003,A100,W100)
           select 1001007,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F001 t1
            where p001 = v_date
              and P003=1001012
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001101,sysdate);
        end if;

        --ҵƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵƷ',1001102,sysdate);
        else
           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001404;

           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_014 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҵ',1001101,sysdate);
        end if;

        --ʼܲC12-ڲƷͳƱ add by 2013-01-18
        select max(P001) INTO v_date from T_B50_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_50_001(p001,/*a004,*/a005,a009,a100,w100)
           select p002,
                 /*(select v
                  from T_B50_F001
                  where p003 = 1003
                  and p001 = a.p001
                  and p002 = a.p002
                  ) as a003,*/
                  (select v
                  from T_B50_F001
                  where p003 = 1004
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  ) as a005,
                  decode(a.p001,1240,0,1250,0,
                  (select v
                  from T_B50_F001
                  where p003 = 1008
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  )) as a009,
                  100000,
                  a.w100
             from (select distinct p001,p002,w100
                   from T_B50_F001
                   where p001 = v_date
                     and p002 not in (1230,1200,1090,1140)
                     and p003 in (1008,1004) )a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_50_001 set /*A004=0,*/a005=0,a009=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵҵܣ
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001102,sysdate);
        else
           insert into T_DB_15_001(P001,A002,A100,W100)
           select A.P002,A.V,(select w100 from KRCS.T_CTL_T036 t where t.p001=a.w100),A.W100
             from T_B11_F003 A, T_B11_D001 B
            where A.P002(+)=B.P001
              and B.P001!=1099
              and A.P003=1011004
              and A.P001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵӶ룩
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011102 AND P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001102,sysdate);
        else
           insert into T_DB_15_002(P001,A003,A100,W100)
           select P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B11_F003 t1
            where P003=1011102
              and P002=1099
              and P001=v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_15_002 SET A003=0; -- ꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001101,sysdate);
        end if;

        --ʽծȯعӪ ޸ĳɺT_DB_09_003һķʽ modified by wuzhao 2009/9/28
        /*select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1001 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001102,sysdate);
        else
           insert into T_DB_11_001(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1001
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_001 a
              set A011=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_001 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_001 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001101,sysdate);
        end if;

        --ʽծȯعҵ
        select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1003 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001102,sysdate);
        else
           insert into T_DB_11_003(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1003
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_003 a
              SET A011=(SELECT V FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_003 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_003 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001101,sysdate);
        end if;*/

        --ʻչ
   /*     select max(p001) into v_date FROM T_B15_F001 where P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001102,sysdate);
        else
           insert into t_db1_01_001(P001,A002,A100,W100)
           select P002,V, (select w100 from KRCS.T_CTL_T036 t where t.p001=w100), W100
             from T_B15_F001
            where P001=v_date
              and P002 = 1001;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001101,sysdate);
        end if;*/

        ----------------------ʲ-----------------------------


         --ʼC4-1ʲҵ
     select max(P001) INTO v_date from t_b04_f102 where P003=1004805;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_05_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f102
            where p001= v_date
              and p003 = 1004805;

           insert into T_DB_05_103(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f103
            where p001= v_date
              and p003 = 1004902;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

     --ʼC4-3ʲҵ
     select max(P001) INTO v_date from T_B07_F001 where P003=1005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_07_101(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F001
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert into T_DB_07_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F002
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

        ----------------------Ӫҵ-------------------------------
        --ʲծ״
        select max(P001) INTO v_date from t_b001_f001 where P004=1025001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʲծ״',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
              then
             insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025001
                and p001 = substr(to_char(v_P001-13),0,4)||'12';

             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
             else
              insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025002
                and p001 = v_date;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
           end if;
        end if ;

        --
        select max(P001) INTO v_date from t_b001_f002 where P004=1026002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ',1001102,sysdate);
        else
           insert into t_db_b1_02(p001,p002,A004)
           select p002,P003,v
             from t_b001_f002
            where P004=1026002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b1_02 set A004=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ',1001101,sysdate);
        end if;


        --ͻʲ
        select max(P001) INTO v_date from t_b002_f001 where P004=1027001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001102,sysdate);
        else
           insert into t_db_b2_01(p001,p002,A004)
           select p002,P003,v
             from t_b002_f001
            where P004=1027001
              and p001 = v_date;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001101,sysdate);
        end if;

        --ʽ˻
        select max(P001) INTO v_date from t_b003_f001 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʽ˻',1001102,sysdate);
        else
           insert into t_db_b3_01(p001,p002,A003)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f001
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2007001) as v1
             from (select distinct p001, p004 from t_b003_f001 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʽ˻',1001101,sysdate);
        end if;

        --֤ȯ˻
        select max(P001) INTO v_date from t_b003_f002 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001102,sysdate);
        else
           insert into t_db_b3_02(p001,p002,A003,A004)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008001) as v1,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008002) as v1
             from (select distinct p001, p004 from t_b003_f002 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001101,sysdate);
        end if;

        --˻
        select max(P001) INTO v_date from t_b003_f003 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ˻',1001102,sysdate);
        else
           insert into t_db_b3_03(p001,p002,A003)
           select p004,1001,v
             from t_b003_f003
            where P002=1004
              and p001 = v_date
              and p003 = 2009001;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ˻',1001101,sysdate);
        end if;

        --֤ȯ
        select max(P001) INTO v_date from t_b004_f001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001102,sysdate);
        else
           insert into t_db_b4_01(p001,p002,A004,A006)
           select a.p004,
                  decode(a.p002,1001,1001,
                              1005,1005,
                              1006,1006,
                              1007,1007,
                              1008,1008,
                              1009,1009,
                              1010,1010,
                              1014,1002,
                              1015,1003),
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005002) as v1,
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005004) as v1
             from (select distinct p001,p002, p004 from t_b004_f001 where p001 = v_date and p002 not in (1004,1011,1012,1013,1016)) a;

            if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_01 set A004=0,A006=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001101,sysdate);
        end if;

        --ɷݽ
        /* select max(P001) INTO v_date from t_b004_f002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        else
           insert into t_db_b4_02(p001,p002,A004)
           select p004,P002,v
             from t_b004_f002
            where P003=2011002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_02 set A004=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        end if;
        */

         --ʼȯҵ¶רͳ



        --֤ȯӪҵȯҵ¶רͳƱ
        select max(P001) INTO v_date from T_B01_DACT_B_R001 where P003=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001102,sysdate);
        else
           insert into T_DACT_B_R001(p001,p002,A003)
           select p004,P002,v
             from T_B01_DACT_B_R001
            where P003=1001
              and p001 = v_date
              and p002 not in (1009,1010,1011,1012,1013,1014);

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DACT_B_R001 set A002=0,A003=0 where p002 = 1019; -- Сȯ0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001101,sysdate);
        end if;


        --ʼC10-1update by 20120220 wull
      select max(P001) INTO v_date from t_b30_f001 ;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001102,sysdate);
        else
            --ʼ  ƽͺԴʼ,ʼΪ
            -- 1ڱ 2ڱ 3ڱڱ

            --1ڱkrcs_etl_rzrq_c10_1ݱת洢Уʱֱȡݱеı

            --2ڱ ʱֱȡݱеı
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10020,10100,10110,10120);

            --3ڱڱʱݱеıӱ
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);

            --ʼ ---


            --±ڡ
            --ʽ˻ڳ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10050)
            where t.p001 = 10020;

            --ڳȯ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10190)
            where t.p001 = 10100;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10200)
            where t.p001 = 10110;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10210)
            where t.p001 = 10120;



            --겿Ŀ0ִ0
             if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_30_001 set A003=0
              where p001 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);
           end if;

            --ڳʼ --

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001101,sysdate);
        end if;



        --ʼӪҵڲƷͳƱadd by 2013-01-18

        select max(P001) INTO v_date from T_B050_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_B50_01(p001,p002,a006,a010)
           select p004,
                  p002,
                  (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1004) as v1,
                   decode(a.p002,1240,0,1250,0,
                    (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1008) ) as v2
             from (select distinct p001,p002, p004 from T_B050_F001 where p001 = v_date and p002 not in (1230,1200,1090,1140)) a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_B50_01 set /*A004=0,*/a006=0,a010=0; -- 0;
           end if;




   --CISP_INIT_REPORTDATE_AFTER(v_P002);




           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001101,sysdate);
        end if;

     end if;


     if (v_P002=1013002) then  -- 
        errcode := 1;
     end if;

     if (v_P002=1013003) then  -- 걨
        errcode := 1;
     end if;

     --ѳʼ־
     update T_B00_D004 set F100=1007001 where P001=v_P001 and A002=v_P002;

     commit;
     errcode := 1;
     errmsg  := 'ʼڳɹ';
/*
     EXCEPTION WHEN OTHERS THEN
        rollback;
        errcode := 0;
        errmsg  := 'ʼʧ'||sqlerrm;
        RETURN;*/
end;
/

prompt
prompt Creating procedure CISP_INIT_REPORTDATE_20190220
prompt ================================================
prompt
create or replace procedure cisp_init_reportdate_20190220(
    errcode out int,
    errmsg out varchar2,
    kjaxuser varchar2,
    v_TASK varchar2,
    v_P001 integer,
    v_P002 integer
)
is
    --v_EP001 integer;
    v_EB003 varchar2(256);
    v_Ecmd  varchar2(1024);
   /* v_version varchar2(1);*/
    v_date  integer;
    v_F100  integer;
    v_my number(19,5);
    v_gb number(19,5);
    v_frid number;
    --v_orgid number;
    v_bmid number;

    cursor c_work is
    select distinct b.B003   --Ӫҵݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T012) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 12
    union
    select distinct b.B003   --ݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T022) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 11;

begin

     --Ƿʼ
     select F100 into v_F100 from T_B00_D004 where P001=v_P001 and A002=v_P002 and c001 =1001101 and D100=1006002;
     if v_F100 = 1007001 then
        errcode := 1;
        errmsg  := 'ʼ, !';
        return;
     end if;

     select nvl(sum(a002),0) into v_my from t_bks_t007;  --us$ 
     select nvl(sum(a003),0) into v_gb from t_bks_t007;  --hk$ 

     DELETE FROM T_SYS_T017 WHERE P002=v_P002;

     --˾Աҵ̨
     update t_bks_t040 set A002=0,A003=0;

         --Ӫҵ˾״̬λȫ״̬
         update KRCS.T_SYS_T014
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002,
                A016 = 1009002,
                A020 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --ű״̬λȫ״̬
         update KRCS.T_SYS_T024
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002
          where A006 = v_P002
            AND A002 = 11;

         --Ӫҵ˾еĵ״̬ûʱΪ
         update KRCS.T_SYS_T014
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --űеĵ״̬ûʱΪ
         update KRCS.T_SYS_T024
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 = 11;

         commit;

     --ݱλȫ״̬λ
     open c_work;
     loop
         fetch c_work into v_EB003;
         if v_EB003 is not null then
             if v_EB003 = 'T_DB_04_001' then
                update t_db_04_001
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A011 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶʹƱ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002' then
                update t_db_04_002
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A010 = 0,
                       A012 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶծȯT_DB_04_002',1001101,sysdate);
            elsif v_EB003 = 'T_DB_B2_02' then
                update t_db_b2_02
                   set A004 = A006,
                       A005 = A007,
                       A100 = null;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽֲ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_004' then
                 update t_db_01_004
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0)*decode(p001,1001102,v_gb,1001103,v_my,1) + nvl(A004,0) end),
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ׻ܱT_DB_01_004',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_005' then
                 update t_db_01_005
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0)*decode(P001,1001,1,1002,v_my,1004,v_gb) + nvl(A003,0) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵϽױT_DB_01_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_007' then
                 update t_db_01_007  a
                    set a.A002 = (case when substr(v_P001,5,2)='01' then 0 else nvl(a.A002,0)+(select nvl(b.A002,0)*decode(b.a003,1001,1,1002,v_gb,1004,v_my) from t_db_01_007 b where b.P001=1001303 and b.A003=a.a003 and b.W100=a.W100) end)
                  where a.P001=1001304
                  and a.A003 in (1001,1002,1004)
                  and exists(select 1
                               from t_db_01_007 b
                               where b.P001=1001303
                                 and b.A003=a.a003
                                 and b.W100=a.W100);

                 update t_db_01_007
                    set A002 = 0
                  where P001 <> 1001304 and w100=v_bmid;

                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񲹳T_DB_01_007',1001101,sysdate);
             elsif v_EB003 = 'T_DB_08_001' then
                 update t_db_08_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + nvl(A005,0) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + nvl(A007,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A008 = null;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_08_001',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_001' then
                 update t_db_09_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعӪT_DB_09_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_09_002' then
                 update t_db_09_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعʲT_DB_09_002',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_003' then
                 update t_db_09_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعT_DB_09_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_11_001' then
                 update t_db_11_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪT_DB_11_001',1001101,sysdate);
               elsif v_EB003 = 'T_DB_11_002' then
                 update t_db_11_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعʲT_DB_11_002',1001101,sysdate);

               elsif v_EB003 = 'T_DB_11_003' then
                 update t_db_11_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ񣩡T_DB_11_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_12_001' then
                 update t_db_12_001
                    set A006 = 0,
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼмгT_DB_12_001',1001101,sysdate);
            /* elsif v_EB003 = 'T_DB_12_002' then
                 update t_db_12_002
                    set A006 =(case when substr(v_P001,5,2)='01' then 0 else nvl(A006,0) + nvl(A003,0)+nvl(A004,0) end),
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006\*,w100*\) VALUES(v_P001,v_P002,'ݱ','ʼмгȯ14002',1001101,sysdate\*,v_frid*\);
            */ elsif v_EB003 = 'T_DB_B4_03' then
                 update T_DB_B4_03
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004*v_my,0) + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005*v_gb,0) + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0,
                        a012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        a013 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A010*v_my,0) + nvl(A013,0) end),
                        a014 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A011*v_gb,0) + nvl(A014,0) end),
                        a009 = 0,
                        a010 = 0,
                        a011 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵֳױT_DB_B4_03',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_02' then
                 update t_db_b4_02
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0)*v_gb + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005,0)*v_my + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0;
                 insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵɷݽT_DB_B4_02',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_001' then
                 update t_db_03_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ״ηУT_DB_03_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_04' then
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʡT_DB_B4_04',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_003' then
                 update t_db_03_003
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵɣT_DB_03_003',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_005' then
                 update t_db_03_005
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_007' then
                 update t_db_03_007
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯУT_DB_03_007',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_009' then
                 update t_db_03_009
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_009',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_011' then
                 update t_db_03_011
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸״ηУT_DB_03_011',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_013' then
                 update t_db_03_013
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ɣT_DB_03_013',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_015' then
                 update t_db_03_015
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_015',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_017' then
                 update t_db_03_017
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ծȯУT_DB_03_017',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_019' then
                 update t_db_03_019
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_019',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002_02_01' then
                 update T_DB_04_002_02_01
                    set A003 = A006,
                        A004 = 0,
                        A005 = 0,
                        A006 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','֤ȯͶҵ(ծȯ,)--̶',1001101,sysdate);
             elsif v_EB003 = 'T_DA_01_004' then
                 update T_DA_01_004
                    set A002 = A003,
                        A003 = 0,
                        A005 = A006,
                        A006 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ׼',1001101,sysdate);


            elsif v_EB003 = 'T_DB_61_001' then
                 update T_DB_61_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_61_002' then
                 update t_db_03_019
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻعҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_001' then
                 update T_DB_62_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽ׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_002' then
                 update T_DB_62_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_001' then
                 update T_DB_63_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_002' then
                 update T_DB_63_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽعҵģ',1001101,sysdate);
             else
                 v_Ecmd := 'delete from '||v_EB003;
                 execute immediate v_Ecmd;
             end if;
         end if;

         exit when c_work%notfound;
     end loop;
     close c_work;

    --λӪҵݱ״̬
    update KRCS.T_SYS_T012
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 12;

    --λݱ״̬
    update KRCS.T_SYS_T022
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 11;


     --ݱеǷ롢ûʱΪ
     --Ӫҵݱ
     update KRCS.T_SYS_T012
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 12;

     --ݱ
     update KRCS.T_SYS_T022
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 11;

     --Ӫҵ˾״̬λȫ״̬
     update KRCS.T_SYS_T014
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002,
            A016 = 1009002
      where A006 = v_P002
        AND A002 IN(11,12);

     --ű״̬λȫ״̬
     update KRCS.T_SYS_T024
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002
      where A006 = v_P002
        AND A002 = 11;

     --
     delete from T_SYS_T029 t where P001 IN(SELECT A005 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     --V10״̬
     delete from KRCS.t_sys_t066 where P003 IN(SELECT P001 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     if (v_P002=1013001) then  -- ±

        --ʱ
        select max(P001) INTO v_date from t_idx_f004 where P003=1001002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001102,sysdate);
        else
           insert into T_DA_01_001(p001,A002,A100,W100)
           select p002,v,(select t1.w100 from KRCS.T_CTL_T036 t1 where t1.p001=t.w100),W100
             from t_idx_f004 t
            where P003 = 1001002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001101,sysdate);
        end if ;

        --֤ȯ˾տָܱ
        select max(P001) INTO v_date from t_idx_f005 where P003=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001102,sysdate);
        else
           insert into T_DA_01_002(p001,A002,A100,W100)
           select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from t_idx_f005 t1
            where P003 = 1002002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001101,sysdate);
        end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001102,sysdate);
        else
         if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 < 501100                                      --ųϵ
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           else
           insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 < 501100                                      --ųϵ
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           end if;
         end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 >= 501100
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
           else
           insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 >= 501100
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
          end if;
        end if ;


        --ܱ
        select max(P001) INTO v_date from t_act_f002 where P002=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾',1001102,sysdate);
        else
           insert into t_dact_003(p001,a003,a100,w100)
           select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),w100
           from t_act_f002 t1
           where p002 = 1002002
           and p001 = v_date;

          if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_dact_003 set A003=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾',1001101,sysdate);
        end if;

        --ʲֵ׼
        select max(P001) INTO v_date from T_ACT_F004 where P002=1001005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001102,sysdate);
        else
          if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001005
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         else
          insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001001
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         end if;
        end if ;

        --ҵ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001102,sysdate);
        else
           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001404;

           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_008 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001101,sysdate);
        end if;

        --ҵʲƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001102,sysdate);
        else
           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001404;

           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_009 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001101,sysdate);
        end if;

        --ҵծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1003;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001102,sysdate);
        else
           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001404;

           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_010 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001101,sysdate);
        end if;

        --ҵծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001102,sysdate);
        else
           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001404;

           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_011 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001101,sysdate);
        end if;

        --ҵҸծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001102,sysdate);
        else
           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001404;

           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_012 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001101,sysdate);
        end if;

        --ҵҸծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1006;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001102,sysdate);
        else
           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001404;

           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_013 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001101,sysdate);
        end if;

        --ҵͻʽ
        select max(P001) into v_date from T_B01_F003 where P002=1001 and P003=1001105;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001102,sysdate);
        else
           insert into T_DB_01_001(P001,P002,A003,A100,W100)
           select 1001101,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F003 t1
            where P003=1001105
              and p001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001101,sysdate);
        end if;

        --ҵʽʻ
        select max(P001) into v_date from T_B01_F002 where P002=1001 and P003=1001004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001102,sysdate);
        else
           insert into T_DB_01_002(P001,P002,A003,A100,W100)
           select 1001001,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F002 t1
            where p001 = v_date
              and P003=1001004
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001101,sysdate);
        end if;

        --ҵ˻
      select max(p001) into v_date from T_B01_F020 where p003 = 1004004;
       if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001102,sysdate);
        else
        insert into T_DB_01_020 (P001,A002,W100,A100)
        select p002,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
        from T_B01_F020 t1
        where p001 = v_date
        and p003 = 1004004;

         insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001101,sysdate);
        end if;

        --ҵ֤ȯʻ
        select max(P001) into v_date from T_B01_F001 where P002=1001 and P003=1001012;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001102,sysdate);
        else
           insert into T_DB_01_003(P001,P002,A003,A100,W100)
           select 1001007,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F001 t1
            where p001 = v_date
              and P003=1001012
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001101,sysdate);
        end if;

        --ҵƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵƷ',1001102,sysdate);
        else
           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001404;

           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_014 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҵ',1001101,sysdate);
        end if;

        --ʼܲC12-ڲƷͳƱ add by 2013-01-18
        select max(P001) INTO v_date from T_B50_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_50_001(p001,/*a004,*/a005,a009,a100,w100)
           select p002,
                 /*(select v
                  from T_B50_F001
                  where p003 = 1003
                  and p001 = a.p001
                  and p002 = a.p002
                  ) as a003,*/
                  (select v
                  from T_B50_F001
                  where p003 = 1004
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  ) as a005,
                  decode(a.p001,1240,0,1250,0,
                  (select v
                  from T_B50_F001
                  where p003 = 1008
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  )) as a009,
                  100000,
                  a.w100
             from (select distinct p001,p002,w100
                   from T_B50_F001
                   where p001 = v_date
                     and p002 not in (1230,1200,1090,1140)
                     and p003 in (1008,1004) )a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_50_001 set /*A004=0,*/a005=0,a009=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵҵܣ
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001102,sysdate);
        else
           insert into T_DB_15_001(P001,A002,A100,W100)
           select A.P002,A.V,(select w100 from KRCS.T_CTL_T036 t where t.p001=a.w100),A.W100
             from T_B11_F003 A, T_B11_D001 B
            where A.P002(+)=B.P001
              and B.P001!=1099
              and A.P003=1011004
              and A.P001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵӶ룩
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011102 AND P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001102,sysdate);
        else
           insert into T_DB_15_002(P001,A003,A100,W100)
           select P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B11_F003 t1
            where P003=1011102
              and P002=1099
              and P001=v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_15_002 SET A003=0; -- ꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001101,sysdate);
        end if;

        --ʽծȯعӪ ޸ĳɺT_DB_09_003һķʽ modified by wuzhao 2009/9/28
        /*select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1001 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001102,sysdate);
        else
           insert into T_DB_11_001(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1001
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_001 a
              set A011=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_001 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_001 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001101,sysdate);
        end if;

        --ʽծȯعҵ
        select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1003 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001102,sysdate);
        else
           insert into T_DB_11_003(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1003
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_003 a
              SET A011=(SELECT V FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_003 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_003 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001101,sysdate);
        end if;*/

        --ʻչ
   /*     select max(p001) into v_date FROM T_B15_F001 where P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001102,sysdate);
        else
           insert into t_db1_01_001(P001,A002,A100,W100)
           select P002,V, (select w100 from KRCS.T_CTL_T036 t where t.p001=w100), W100
             from T_B15_F001
            where P001=v_date
              and P002 = 1001;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001101,sysdate);
        end if;*/

        ----------------------ʲ-----------------------------


         --ʼC4-1ʲҵ
     select max(P001) INTO v_date from t_b04_f102 where P003=1004805;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_05_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f102
            where p001= v_date
              and p003 = 1004805;

           insert into T_DB_05_103(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f103
            where p001= v_date
              and p003 = 1004902;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

     --ʼC4-3ʲҵ
     select max(P001) INTO v_date from T_B07_F001 where P003=1005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_07_101(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F001
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert into T_DB_07_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F002
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

        ----------------------Ӫҵ-------------------------------
        --ʲծ״
        select max(P001) INTO v_date from t_b001_f001 where P004=1025001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʲծ״',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
              then
             insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025001
                and p001 = substr(to_char(v_P001-13),0,4)||'12';

             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
             else
              insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025002
                and p001 = v_date;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
           end if;
        end if ;

        --
        select max(P001) INTO v_date from t_b001_f002 where P004=1026002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ',1001102,sysdate);
        else
           insert into t_db_b1_02(p001,p002,A004)
           select p002,P003,v
             from t_b001_f002
            where P004=1026002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b1_02 set A004=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ',1001101,sysdate);
        end if;


        --ͻʲ
        select max(P001) INTO v_date from t_b002_f001 where P004=1027001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001102,sysdate);
        else
           insert into t_db_b2_01(p001,p002,A004)
           select p002,P003,v
             from t_b002_f001
            where P004=1027001
              and p001 = v_date;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001101,sysdate);
        end if;

        --ʽ˻
        select max(P001) INTO v_date from t_b003_f001 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʽ˻',1001102,sysdate);
        else
           insert into t_db_b3_01(p001,p002,A003)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f001
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2007001) as v1
             from (select distinct p001, p004 from t_b003_f001 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʽ˻',1001101,sysdate);
        end if;

        --֤ȯ˻
        select max(P001) INTO v_date from t_b003_f002 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001102,sysdate);
        else
           insert into t_db_b3_02(p001,p002,A003,A004)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008001) as v1,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008002) as v1
             from (select distinct p001, p004 from t_b003_f002 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001101,sysdate);
        end if;

        --˻
        select max(P001) INTO v_date from t_b003_f003 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ˻',1001102,sysdate);
        else
           insert into t_db_b3_03(p001,p002,A003)
           select p004,1001,v
             from t_b003_f003
            where P002=1004
              and p001 = v_date
              and p003 = 2009001;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ˻',1001101,sysdate);
        end if;

        --֤ȯ
        select max(P001) INTO v_date from t_b004_f001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001102,sysdate);
        else
           insert into t_db_b4_01(p001,p002,A004,A006)
           select a.p004,
                  decode(a.p002,1001,1001,
                              1005,1005,
                              1006,1006,
                              1007,1007,
                              1008,1008,
                              1009,1009,
                              1010,1010,
                              1014,1002,
                              1015,1003),
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005002) as v1,
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005004) as v1
             from (select distinct p001,p002, p004 from t_b004_f001 where p001 = v_date and p002 not in (1004,1011,1012,1013,1016)) a;

            if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_01 set A004=0,A006=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001101,sysdate);
        end if;

        --ɷݽ
        /* select max(P001) INTO v_date from t_b004_f002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        else
           insert into t_db_b4_02(p001,p002,A004)
           select p004,P002,v
             from t_b004_f002
            where P003=2011002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_02 set A004=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        end if;
        */

         --ʼȯҵ¶רͳ



        --֤ȯӪҵȯҵ¶רͳƱ
        select max(P001) INTO v_date from T_B01_DACT_B_R001 where P003=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001102,sysdate);
        else
           insert into T_DACT_B_R001(p001,p002,A003)
           select p004,P002,v
             from T_B01_DACT_B_R001
            where P003=1001
              and p001 = v_date
              and p002 not in (1009,1010,1011,1012,1013,1014);

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DACT_B_R001 set A002=0,A003=0 where p002 = 1019; -- Сȯ0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001101,sysdate);
        end if;


        --ʼC10-1update by 20120220 wull
      select max(P001) INTO v_date from t_b30_f001 ;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001102,sysdate);
        else
            --ʼ  ƽͺԴʼ,ʼΪ
            -- 1ڱ 2ڱ 3ڱڱ

            --1ڱkrcs_etl_rzrq_c10_1ݱת洢Уʱֱȡݱеı

            --2ڱ ʱֱȡݱеı
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10020,10100,10110,10120);

            --3ڱڱʱݱеıӱ
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);

            --ʼ ---


            --±ڡ
            --ʽ˻ڳ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10050)
            where t.p001 = 10020;

            --ڳȯ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10190)
            where t.p001 = 10100;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10200)
            where t.p001 = 10110;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10210)
            where t.p001 = 10120;



            --겿Ŀ0ִ0
             if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_30_001 set A003=0
              where p001 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);
            
            -- ڳʽ˻ձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10050)
            where t.p001 = 10020;
            commit;

            -- ڳȯձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10190)
            where t.p001 = 10100;
            commit;

             -- ڳʽձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10200)
            where t.p001 = 10110;
            commit;

             -- ڳȯձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10210)
            where t.p001 = 10120;
            commit;
                             
           end if;

            --ڳʼ --

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001101,sysdate);
        end if;



        --ʼӪҵڲƷͳƱadd by 2013-01-18

        select max(P001) INTO v_date from T_B050_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_B50_01(p001,p002,a006,a010)
           select p004,
                  p002,
                  (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1004) as v1,
                   decode(a.p002,1240,0,1250,0,
                    (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1008) ) as v2
             from (select distinct p001,p002, p004 from T_B050_F001 where p001 = v_date and p002 not in (1230,1200,1090,1140)) a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_B50_01 set /*A004=0,*/a006=0,a010=0; -- 0;
           end if;
                
        ---C12-1B-A5-1гɽ add by zhenyj 20190220
        delete from kods.a_hs_his_secumdealinfo_temp2;
        insert into kods.a_hs_his_secumdealinfo_temp2
          select * from kods.a_hs_his_secumdealinfo_temp;
        commit;
        
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001101,sysdate);
        end if;

     end if;


     if (v_P002=1013002) then  -- 
        errcode := 1;
     end if;

     if (v_P002=1013003) then  -- 걨
        errcode := 1;
     end if;

     --ѳʼ־
     update T_B00_D004 set F100=1007001 where P001=v_P001 and A002=v_P002;

     commit;

    commit;
    
     errcode := 1;
     errmsg  := 'ʼڳɹ';
/*
     EXCEPTION WHEN OTHERS THEN
        rollback;
        errcode := 0;
        errmsg  := 'ʼʧ'||sqlerrm;
        RETURN;*/
end;
/

prompt
prompt Creating procedure CISP_INIT_REPORTDATE_20200703
prompt ================================================
prompt
create or replace procedure cisp_init_reportdate_20200703(
    errcode out int,
    errmsg out varchar2,
    kjaxuser varchar2,
    v_TASK varchar2,
    v_P001 integer,
    v_P002 integer
)
is
    --v_EP001 integer;
    v_EB003 varchar2(256);
    v_Ecmd  varchar2(1024);
   /* v_version varchar2(1);*/
    v_date  integer;
    v_F100  integer;
    v_my number(19,5);
    v_gb number(19,5);
    v_frid number;
    --v_orgid number;
    v_bmid number;

    cursor c_work is
    select distinct b.B003   --Ӫҵݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T012) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 12
    union
    select distinct b.B003   --ݱ
      from (select distinct p001,a010 from KRCS.T_SYS_T022) a,
           KRCS.T_SYS_T011 b
     where a.P001 = b.P001
       and a.A010 = v_P002
       and b.P002 = 11;

begin

     --Ƿʼ
     select F100 into v_F100 from T_B00_D004 where P001=v_P001 and A002=v_P002 and c001 =1001101 and D100=1006002;
     if v_F100 = 1007001 then
        errcode := 1;
        errmsg  := 'ʼ, !';
        return;
     end if;

     select nvl(sum(a002),0) into v_my from t_bks_t007;  --us$ 
     select nvl(sum(a003),0) into v_gb from t_bks_t007;  --hk$ 

     DELETE FROM T_SYS_T017 WHERE P002=v_P002;

     --˾Աҵ̨
     update t_bks_t040 set A002=0,A003=0;

         --Ӫҵ˾״̬λȫ״̬
         update KRCS.T_SYS_T014
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002,
                A016 = 1009002,
                A020 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --ű״̬λȫ״̬
         update KRCS.T_SYS_T024
            set A009 = 1016002,
                A010 = 1015002,
                A011 = 1009002,
                A012 = 1020002
          where A006 = v_P002
            AND A002 = 11;

         --Ӫҵ˾еĵ״̬ûʱΪ
         update KRCS.T_SYS_T014
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 IN(11,12);

         --űеĵ״̬ûʱΪ
         update KRCS.T_SYS_T024
            set A013 = null,
                A014 = null,
                A015 = null
          where A006 = v_P002
            AND A002 = 11;

         commit;

     --ݱλȫ״̬λ
     open c_work;
     loop
         fetch c_work into v_EB003;
         if v_EB003 is not null then
             if v_EB003 = 'T_DB_04_001' then
                update t_db_04_001
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A011 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶʹƱ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002' then
                update t_db_04_002
                   set A004 = A007,
                       A005 = 0,
                       A006 = 0,
                       A007 = 0,
                       A008 = 0,
                       A009 = 0,
                       A010 = 0,
                       A012 = 0;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯͶծȯT_DB_04_002',1001101,sysdate);
            elsif v_EB003 = 'T_DB_B2_02' then
                update t_db_b2_02
                   set A004 = A006,
                       A005 = A007,
                       A100 = null;
                insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽֲ',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_004' then
                 update t_db_01_004
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0)*decode(p001,1001102,v_gb,1001103,v_my,1) + nvl(A004,0) end),
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ׻ܱT_DB_01_004',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_005' then
                 update t_db_01_005
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0)*decode(P001,1001,1,1002,v_my,1004,v_gb) + nvl(A003,0) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵϽױT_DB_01_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_01_007' then
                 update t_db_01_007  a
                    set a.A002 = (case when substr(v_P001,5,2)='01' then 0 else nvl(a.A002,0)+(select nvl(b.A002,0)*decode(b.a003,1001,1,1002,v_gb,1004,v_my) from t_db_01_007 b where b.P001=1001303 and b.A003=a.a003 and b.W100=a.W100) end)
                  where a.P001=1001304
                  and a.A003 in (1001,1002,1004)
                  and exists(select 1
                               from t_db_01_007 b
                               where b.P001=1001303
                                 and b.A003=a.a003
                                 and b.W100=a.W100);

                 update t_db_01_007
                    set A002 = 0
                  where P001 <> 1001304 and w100=v_bmid;

                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񲹳T_DB_01_007',1001101,sysdate);
             elsif v_EB003 = 'T_DB_08_001' then
                 update t_db_08_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + nvl(A005,0) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + nvl(A007,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A008 = null;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_08_001',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_001' then
                 update t_db_09_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعӪT_DB_09_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_09_002' then
                 update t_db_09_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعʲT_DB_09_002',1001101,sysdate);
              elsif v_EB003 = 'T_DB_09_003' then
                 update t_db_09_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽծȯعT_DB_09_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_11_001' then
                 update t_db_11_001
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪT_DB_11_001',1001101,sysdate);
               elsif v_EB003 = 'T_DB_11_002' then
                 update t_db_11_002
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعʲT_DB_11_002',1001101,sysdate);

               elsif v_EB003 = 'T_DB_11_003' then
                 update t_db_11_003
                    set A010 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A007,0) + nvl(A010,0) end),
                        A011 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A008,0) + nvl(A011,0) end),
                        A012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        A002 = 0,
                        A003 = 0,
                        A004 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ񣩡T_DB_11_003',1001101,sysdate);
              elsif v_EB003 = 'T_DB_12_001' then
                 update t_db_12_001
                    set A006 = 0,
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼмгT_DB_12_001',1001101,sysdate);
            /* elsif v_EB003 = 'T_DB_12_002' then
                 update t_db_12_002
                    set A006 =(case when substr(v_P001,5,2)='01' then 0 else nvl(A006,0) + nvl(A003,0)+nvl(A004,0) end),
                        A002 = nvl(A002,0) + (nvl(A003,0) - nvl(A004,0)),
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006\*,w100*\) VALUES(v_P001,v_P002,'ݱ','ʼмгȯ14002',1001101,sysdate\*,v_frid*\);
            */ elsif v_EB003 = 'T_DB_B4_03' then
                 update T_DB_B4_03
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004*v_my,0) + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005*v_gb,0) + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0,
                        a012 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A009,0) + nvl(A012,0) end),
                        a013 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A010*v_my,0) + nvl(A013,0) end),
                        a014 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A011*v_gb,0) + nvl(A014,0) end),
                        a009 = 0,
                        a010 = 0,
                        a011 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵֳױT_DB_B4_03',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_02' then
                 update t_db_b4_02
                    set a006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + nvl(A006,0) end),
                        a007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0)*v_gb + nvl(A007,0) end),
                        a008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A005,0)*v_my + nvl(A008,0) end),
                        a003 = 0,
                        a004 = 0,
                        a005 = 0;
                 insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵɷݽT_DB_B4_02',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_001' then
                 update t_db_03_001
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ״ηУT_DB_03_001',1001101,sysdate);
             elsif v_EB003 = 'T_DB_B4_04' then
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʡT_DB_B4_04',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_003' then
                 update t_db_03_003
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵɣT_DB_03_003',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_005' then
                 update t_db_03_005
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_005',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_007' then
                 update t_db_03_007
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯУT_DB_03_007',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_009' then
                 update t_db_03_009
                    set A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A006,0)) end),
                        A007 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A007,0)) end),
                        A008 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A004,0) + (nvl(A008,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0,
                        A004 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵT_DB_03_009',1001101,sysdate);
              elsif v_EB003 = 'T_DB_03_011' then
                 update t_db_03_011
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸״ηУT_DB_03_011',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_013' then
                 update t_db_03_013
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ɣT_DB_03_013',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_015' then
                 update t_db_03_015
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_015',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_017' then
                 update t_db_03_017
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸ծȯУT_DB_03_017',1001101,sysdate);
             elsif v_EB003 = 'T_DB_03_019' then
                 update t_db_03_019
                    set A004 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A001,0) + (nvl(A004,0)) end),
                        A005 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A005,0)) end),
                        A006 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A003,0) + (nvl(A006,0)) end),
                        A001 = 0,
                        A002 = 0,
                        A003 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ񣨸T_DB_03_019',1001101,sysdate);
             elsif v_EB003 = 'T_DB_04_002_02_01' then
                 update T_DB_04_002_02_01
                    set A003 = A006,
                        A004 = 0,
                        A005 = 0,
                        A006 = 0,
                        A007 = 0,
                        A008 = 0,
                        A009 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','֤ȯͶҵ(ծȯ,)--̶',1001101,sysdate);
             elsif v_EB003 = 'T_DA_01_004' then
                 update T_DA_01_004
                    set A002 = A003,
                        A003 = 0,
                        A005 = A006,
                        A006 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ׼',1001101,sysdate);


            elsif v_EB003 = 'T_DB_61_001' then
                 update T_DB_61_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_61_002' then
                 update t_db_03_019
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼѺʽۻعҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_001' then
                 update T_DB_62_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽ׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_62_002' then
                 update T_DB_62_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼԼʽҵģ',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_001' then
                 update T_DB_63_001
                    set A002 = A005,
                        A003 = 0,
                        A004 = 0,
                        A005 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽع׼',1001101,sysdate);

             elsif v_EB003 = 'T_DB_63_002' then
                 update T_DB_63_002
                    set A003 = (case when substr(v_P001,5,2)='01' then 0 else nvl(A002,0) + (nvl(A003,0)) end),
                        A002 = 0;
                 insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼƱѺʽعҵģ',1001101,sysdate);
             else
                 v_Ecmd := 'delete from '||v_EB003;
                 execute immediate v_Ecmd;
             end if;
         end if;

         exit when c_work%notfound;
     end loop;
     close c_work;

    --λӪҵݱ״̬
    update KRCS.T_SYS_T012
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 12;

    --λݱ״̬
    update KRCS.T_SYS_T022
       set A006 = 1015002,
           A007 = 1010002,
           A008 = 1016002,
           A009 = 1009002
     where A010 = v_P002
       AND P002 = 11;


     --ݱеǷ롢ûʱΪ
     --Ӫҵݱ
     update KRCS.T_SYS_T012
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 12;

     --ݱ
     update KRCS.T_SYS_T022
        set A011 = null,
            A012 = null,
            A013 = null
      where A010 = v_P002
        AND P002 = 11;

     --Ӫҵ˾״̬λȫ״̬
     update KRCS.T_SYS_T014
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002,
            A016 = 1009002
      where A006 = v_P002
        AND A002 IN(11,12);

     --ű״̬λȫ״̬
     update KRCS.T_SYS_T024
        set A009 = 1016002,
            A010 = 1015002,
            A011 = 1009002,
            A012 = 1020002
      where A006 = v_P002
        AND A002 = 11;

     --
     delete from T_SYS_T029 t where P001 IN(SELECT A005 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     --V10״̬
     delete from KRCS.t_sys_t066 where P003 IN(SELECT P001 FROM KRCS.T_SYS_T004 WHERE A006 = v_P002 AND A002 IN(11,12));

     if (v_P002=1013001) then  -- ±

        --ʱ
        select max(P001) INTO v_date from t_idx_f004 where P003=1001002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001102,sysdate);
        else
           insert into T_DA_01_001(p001,A002,A100,W100)
           select p002,v,(select t1.w100 from KRCS.T_CTL_T036 t1 where t1.p001=t.w100),W100
             from t_idx_f004 t
            where P003 = 1001002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʱ㱨',1001101,sysdate);
        end if ;

        --֤ȯ˾տָܱ
        select max(P001) INTO v_date from t_idx_f005 where P003=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001102,sysdate);
        else
           insert into T_DA_01_002(p001,A002,A100,W100)
           select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from t_idx_f005 t1
            where P003 = 1002002
              and p001 = v_date;
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾տָܱ',1001101,sysdate);
        end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001102,sysdate);
        else
         if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 < 501100                                      --ųϵ
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           else
           insert into T_DACT_001(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 < 501100                                      --ųϵ
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծܱ',1001101,sysdate);
           end if;
         end if ;

        --ʲծܱ
        select max(P001) INTO v_date from T_ACT_F001 where P003=1003002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003002
                and p002 >= 501100
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
           else
           insert into T_DACT_002(p001,A003,A100,W100)
             select p002,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F001 t1
              where P003 = 1003001
                and p002 >= 501100
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲծϱ',1001101,sysdate);
          end if;
        end if ;


        --ܱ
        select max(P001) INTO v_date from t_act_f002 where P002=1002002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾',1001102,sysdate);
        else
           insert into t_dact_003(p001,a003,a100,w100)
           select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),w100
           from t_act_f002 t1
           where p002 = 1002002
           and p001 = v_date;

          if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_dact_003 set A003=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾',1001101,sysdate);
        end if;

        --ʲֵ׼
        select max(P001) INTO v_date from T_ACT_F004 where P002=1001005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001102,sysdate);
        else
          if(substr(v_p001,5,2)='01')
           then
             insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001005
                and p001 = substr(to_char(v_date-13),0,4)||'12';
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         else
          insert into T_DACT_005(p001,A002,A100,W100)
             select p003,v,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
               from T_ACT_F004 t1
              where P002 = 1001001
                and p001 = v_date;
             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ֤ȯ˾ʲֵ׼',1001101,sysdate);
         end if;
        end if ;

        --ҵ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001102,sysdate);
        else
           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001404;

           insert into T_DB_01_008(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1001
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_008 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ',1001101,sysdate);
        end if;

        --ҵʲƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001102,sysdate);
        else
           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001404;

           insert into T_DB_01_009(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1002
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_009 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʲƷ',1001101,sysdate);
        end if;

        --ҵծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1003;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001102,sysdate);
        else
           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001404;

           insert into T_DB_01_010(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1003
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_010 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծ',1001101,sysdate);
        end if;

        --ҵծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001102,sysdate);
        else
           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001404;

           insert into T_DB_01_011(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1004
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_011 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵծȯ',1001101,sysdate);
        end if;

        --ҵҸծ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001102,sysdate);
        else
           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001404;

           insert into T_DB_01_012(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1005
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_012 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծ',1001101,sysdate);
        end if;

        --ҵҸծȯ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1006;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001102,sysdate);
        else
           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001404;

           insert into T_DB_01_013(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1006
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_013 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҸծȯ',1001101,sysdate);
        end if;

        --ҵͻʽ
        select max(P001) into v_date from T_B01_F003 where P002=1001 and P003=1001105;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001102,sysdate);
        else
           insert into T_DB_01_001(P001,P002,A003,A100,W100)
           select 1001101,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F003 t1
            where P003=1001105
              and p001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵͻʽ',1001101,sysdate);
        end if;

        --ҵʽʻ
        select max(P001) into v_date from T_B01_F002 where P002=1001 and P003=1001004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001102,sysdate);
        else
           insert into T_DB_01_002(P001,P002,A003,A100,W100)
           select 1001001,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F002 t1
            where p001 = v_date
              and P003=1001004
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵʽʻ',1001101,sysdate);
        end if;

        --ҵ˻
      select max(p001) into v_date from T_B01_F020 where p003 = 1004004;
       if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001102,sysdate);
        else
        insert into T_DB_01_020 (P001,A002,W100,A100)
        select p002,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
        from T_B01_F020 t1
        where p001 = v_date
        and p003 = 1004004;

         insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼ˻',1001101,sysdate);
        end if;

        --ҵ֤ȯʻ
        select max(P001) into v_date from T_B01_F001 where P002=1001 and P003=1001012;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001102,sysdate);
        else
           insert into T_DB_01_003(P001,P002,A003,A100,W100)
           select 1001007,P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F001 t1
            where p001 = v_date
              and P003=1001012
              and p002!=1004;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵ֤ȯʻ',1001101,sysdate);
        end if;

        --ҵƷ
        select max(p001) into v_date from T_B01_F005 where P004=1001404 and P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵƷ',1001102,sysdate);
        else
           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001404,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001404;

           insert into T_DB_01_014(P001,A002,A100,W100)
           select 1001406,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B01_F005 t1
            where P001=v_date
              and P002=1099
              and P004=1001406;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_01_014 SET A002=0; -- ꣬0;
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼҵҵ',1001101,sysdate);
        end if;

        --ʼܲC12-ڲƷͳƱ add by 2013-01-18
        select max(P001) INTO v_date from T_B50_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_50_001(p001,/*a004,*/a005,a009,a100,w100)
           select p002,
                 /*(select v
                  from T_B50_F001
                  where p003 = 1003
                  and p001 = a.p001
                  and p002 = a.p002
                  ) as a003,*/
                  (select v
                  from T_B50_F001
                  where p003 = 1004
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  ) as a005,
                  decode(a.p001,1240,0,1250,0,
                  (select v
                  from T_B50_F001
                  where p003 = 1008
                  and p001 = a.p001
                  and p002 = a.p002
                  and w100 = a.w100
                  )) as a009,
                  100000,
                  a.w100
             from (select distinct p001,p002,w100
                   from T_B50_F001
                   where p001 = v_date
                     and p002 not in (1230,1200,1090,1140)
                     and p003 in (1008,1004) )a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_50_001 set /*A004=0,*/a005=0,a009=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲ۽ڲƷͳƱ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵҵܣ
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001102,sysdate);
        else
           insert into T_DB_15_001(P001,A002,A100,W100)
           select A.P002,A.V,(select w100 from KRCS.T_CTL_T036 t where t.p001=a.w100),A.W100
             from T_B11_F003 A, T_B11_D001 B
            where A.P002(+)=B.P001
              and B.P001!=1099
              and A.P003=1011004
              and A.P001=v_date;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵҵܣ',1001101,sysdate);
        end if;

        --Ϊڻ˾ṩмҵӶ룩
        select max(P001) INTO v_date FROM T_B11_F003 WHERE P003=1011102 AND P002=1099;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001102,sysdate);
        else
           insert into T_DB_15_002(P001,A003,A100,W100)
           select P002,V,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100),W100
             from T_B11_F003 t1
            where P003=1011102
              and P002=1099
              and P001=v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_15_002 SET A003=0; -- ꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼΪڻ˾ṩмҵӶ룩',1001101,sysdate);
        end if;

        --ʽծȯعӪ ޸ĳɺT_DB_09_003һķʽ modified by wuzhao 2009/9/28
        /*select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1001 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001102,sysdate);
        else
           insert into T_DB_11_001(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1001
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_001 a
              set A011=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_001 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1001
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_001 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعӪ',1001101,sysdate);
        end if;

        --ʽծȯعҵ
        select max(P001) INTO v_date FROM T_B14_F003 WHERE P003=1003 AND P005=1014002 AND P004=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001102,sysdate);
        else
           insert into T_DB_11_003(P001,A100,A010,W100)
           select A.P002, v_A100, A.V, A.W100
             from T_B14_F003 A, t_b14_d001 B
            where A.P001=v_date
              and A.P003=1003
              and A.P005=1014002
              and A.P004=1001
              and A.P002(+)=B.P001;

           update T_DB_11_003 a
              SET A011=(SELECT V FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1002
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );
           update T_DB_11_003 a
              SET A012=(SELECT V
                          FROM T_B14_F003 b
                         WHERE P001=v_date
                           AND P003=1003
                           AND P005=1014002
                           AND P004=1003
                           AND b.P002=a.P001
                           AND b.W100=a.W100
                       );

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_11_003 SET A010=0, A011=0, A012=0; --꣬0
           end if;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʽծȯعҵ',1001101,sysdate);
        end if;*/

        --ʻչ
   /*     select max(p001) into v_date FROM T_B15_F001 where P002=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001102,sysdate);
        else
           insert into t_db1_01_001(P001,A002,A100,W100)
           select P002,V, (select w100 from KRCS.T_CTL_T036 t where t.p001=w100), W100
             from T_B15_F001
            where P001=v_date
              and P002 = 1001;

           insert into T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼʻչ',1001101,sysdate);
        end if;*/

        ----------------------ʲ-----------------------------


         --ʼC4-1ʲҵ
     select max(P001) INTO v_date from t_b04_f102 where P003=1004805;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_05_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f102
            where p001= v_date
              and p003 = 1004805;

           insert into T_DB_05_103(P001,A002,A100,W100)
           select p002,v,100000,w100
             from t_b04_f103
            where p001= v_date
              and p003 = 1004902;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

     --ʼC4-3ʲҵ
     select max(P001) INTO v_date from T_B07_F001 where P003=1005;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001102,sysdate);
        else
           insert into T_DB_07_101(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F001
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert into T_DB_07_102(P001,A002,A100,W100)
           select p002,v,100000,w100
             from T_B07_F002
            where p001= v_date
              and p003 = 1005
              and p002 <> 1300;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼܲʲҵ񱨱',1001101,sysdate);
        end if;

        ----------------------Ӫҵ-------------------------------
        --ʲծ״
        select max(P001) INTO v_date from t_b001_f001 where P004=1025001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʲծ״',1001102,sysdate);
        else
           if(substr(v_p001,5,2)='01')
              then
             insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025001
                and p001 = substr(to_char(v_P001-13),0,4)||'12';

             insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
             else
              insert into t_db_b1_01(p001,p002,A004)
             select p002,P003,v
               from t_b001_f001
              where P004=1025002
                and p001 = v_date;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʲծ״',1001101,sysdate);
           end if;
        end if ;

        --
        select max(P001) INTO v_date from t_b001_f002 where P004=1026002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ',1001102,sysdate);
        else
           insert into t_db_b1_02(p001,p002,A004)
           select p002,P003,v
             from t_b001_f002
            where P004=1026002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b1_02 set A004=0; -- 0;
           end if;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ',1001101,sysdate);
        end if;


        --ͻʲ
        select max(P001) INTO v_date from t_b002_f001 where P004=1027001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001102,sysdate);
        else
           insert into t_db_b2_01(p001,p002,A004)
           select p002,P003,v
             from t_b002_f001
            where P004=1027001
              and p001 = v_date;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵͻʲ',1001101,sysdate);
        end if;

        --ʽ˻
        select max(P001) INTO v_date from t_b003_f001 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵʽ˻',1001102,sysdate);
        else
           insert into t_db_b3_01(p001,p002,A003)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f001
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2007001) as v1
             from (select distinct p001, p004 from t_b003_f001 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵʽ˻',1001101,sysdate);
        end if;

        --֤ȯ˻
        select max(P001) INTO v_date from t_b003_f002 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001102,sysdate);
        else
           insert into t_db_b3_02(p001,p002,A003,A004)
           select a.p004,
                  1001,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008001) as v1,
                  (select v
                     from t_b003_f002
                    where p001 = a.p001
                      and p004 = a.p004
                      and p002 = 1004
                      and p003 = 2008002) as v1
             from (select distinct p001, p004 from t_b003_f002 where p001 = v_date and p002 = 1004) a;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ֤ȯ˻',1001101,sysdate);
        end if;

        --˻
        select max(P001) INTO v_date from t_b003_f003 where P002=1004;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ˻',1001102,sysdate);
        else
           insert into t_db_b3_03(p001,p002,A003)
           select p004,1001,v
             from t_b003_f003
            where P002=1004
              and p001 = v_date
              and p003 = 2009001;

           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ˻',1001101,sysdate);
        end if;

        --֤ȯ
        select max(P001) INTO v_date from t_b004_f001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001102,sysdate);
        else
           insert into t_db_b4_01(p001,p002,A004,A006)
           select a.p004,
                  decode(a.p002,1001,1001,
                              1005,1005,
                              1006,1006,
                              1007,1007,
                              1008,1008,
                              1009,1009,
                              1010,1010,
                              1014,1002,
                              1015,1003),
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005002) as v1,
                  (select v
                     from t_b004_f001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 2005004) as v1
             from (select distinct p001,p002, p004 from t_b004_f001 where p001 = v_date and p002 not in (1004,1011,1012,1013,1016)) a;

            if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_01 set A004=0,A006=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ֤ȯ',1001101,sysdate);
        end if;

        --ɷݽ
        /* select max(P001) INTO v_date from t_b004_f002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        else
           insert into t_db_b4_02(p001,p002,A004)
           select p004,P002,v
             from t_b004_f002
            where P003=2011002
              and p001 = v_date;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update t_db_b4_02 set A004=0; -- 0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼɷݽ',1001102,sysdate);
        end if;
        */

         --ʼȯҵ¶רͳ



        --֤ȯӪҵȯҵ¶רͳƱ
        select max(P001) INTO v_date from T_B01_DACT_B_R001 where P003=1001;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001102,sysdate);
        else
           insert into T_DACT_B_R001(p001,p002,A003)
           select p004,P002,v
             from T_B01_DACT_B_R001
            where P003=1001
              and p001 = v_date
              and p002 not in (1009,1010,1011,1012,1013,1014);

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DACT_B_R001 set A002=0,A003=0 where p002 = 1019; -- Сȯ0;
           end if;

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯӪҵȯҵ¶רͳƱ',1001101,sysdate);
        end if;


        --ʼC10-1update by 20120220 wull
      select max(P001) INTO v_date from t_b30_f001 ;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001102,sysdate);
        else
            --ʼ  ƽͺԴʼ,ʼΪ
            -- 1ڱ 2ڱ 3ڱڱ

            --1ڱkrcs_etl_rzrq_c10_1ݱת洢Уʱֱȡݱеı

            --2ڱ ʱֱȡݱеı
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10020,10100,10110,10120);

            --3ڱڱʱݱеıӱ
            insert into T_DB_30_001(p001,a002,A003,W100,A100)
            select p002,0,v,w100,(select w100 from KRCS.T_CTL_T036 t where t.p001=t1.w100)
             from t_b30_f001 t1
             where P003=1206002
              and p001 = v_date
              and p002 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);

            --ʼ ---


            --±ڡ
            --ʽ˻ڳ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10050)
            where t.p001 = 10020;

            --ڳȯ
            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10190)
            where t.p001 = 10100;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10200)
            where t.p001 = 10110;

            update T_DB_30_001 t
            set t.a002 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10210)
            where t.p001 = 10120;



            --겿Ŀ0ִ0
             if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_30_001 set A003=0
              where p001 in (10030,10040,10130,10140,10150,10160,10170,10180,10220,10230,10240,
                             10310,10320,10330,10340,10350,10360,10370,10380,10390,10420,10430);
            
            -- ڳʽ˻ձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10050)
            where t.p001 = 10020;
            commit;

            -- ڳȯձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10190)
            where t.p001 = 10100;
            commit;

             -- ڳʽձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10200)
            where t.p001 = 10110;
            commit;

             -- ڳȯձи
            update T_DB_30_001 t set t.a003 = (select v from t_b30_f001 where p003 = 1206001 and t.w100 = w100 and p001 = v_date and p002= 10210)
            where t.p001 = 10120;
            commit;
                             
           end if;

            --ڳʼ --

           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼ֤ȯC10-1ȯҵ',1001101,sysdate);
        end if;



        --ʼӪҵڲƷͳƱadd by 2013-01-18

        select max(P001) INTO v_date from T_B050_F001 where P003=1002;
        if (v_date=v_P001) then
           insert into T_SYS_T017(p001,P002,P003,A004,A005,A006) VALUES(v_p001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001102,sysdate);
        else
           insert into T_DB_B50_01(p001,p002,a006,a010)
           select p004,
                  p002,
                  (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1004) as v1,
                   decode(a.p002,1240,0,1250,0,
                    (select v
                     from T_B050_F001
                    where p001 = a.p001
                      and p002 = a.p002
                      and p004 = a.p004
                      and p003 = 1008) ) as v2
             from (select distinct p001,p002, p004 from T_B050_F001 where p001 = v_date and p002 not in (1230,1200,1090,1140)) a;

           if (trunc(v_date/100)!=trunc(v_P001/100)) then
              update T_DB_B50_01 set /*A004=0,*/a006=0,a010=0; -- 0;
           end if;

       ---C12-1B-A5-1гɽ add by zhenyj 20190220
        delete from kods.a_hs_his_secumdealinfo_temp2;
        delete from kods.a_hs_his_secumdealinfo_bn_t2;
        insert into kods.a_hs_his_secumdealinfo_temp2
          select * from kods.a_hs_his_secumdealinfo_temp;
        insert into kods.a_hs_his_secumdealinfo_bn_t2
          select * from kods.a_hs_his_secumdealinfo_bn_t1;
        commit;


   --CISP_INIT_REPORTDATE_AFTER(v_P002);
           insert INTO T_SYS_T017(P001,P002,P003,A004,A005,A006) VALUES(v_P001,v_P002,'ݱ','ʼӪҵ۽ڲƷͳƱ',1001101,sysdate);
        end if;

     end if;


     if (v_P002=1013002) then  -- 
        errcode := 1;
     end if;

     if (v_P002=1013003) then  -- 걨
        errcode := 1;
     end if;

     --ѳʼ־
     update T_B00_D004 set F100=1007001 where P001=v_P001 and A002=v_P002;

     commit;
     errcode := 1;
     errmsg  := 'ʼڳɹ';
/*
     EXCEPTION WHEN OTHERS THEN
        rollback;
        errcode := 0;
        errmsg  := 'ʼʧ'||sqlerrm;
        RETURN;*/
end;
/

prompt
prompt Creating procedure CISP_INS_B05T001
prompt ===================================
prompt
create or replace procedure cisp_ins_B05T001(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task  varchar2,
       v_p001 int,
       v_F002 int,
       v_F003 int,
       v_A003 varchar2,
       v_A004 varchar2,
       v_A005 varchar2,
       v_A006 number,
       v_A007 varchar2,
       v_A008 varchar2,
       v_A015 varchar2,
       v_A016 varchar2,
       v_A009 number,
       v_A010 int,
       v_A011 number,
       v_A012 number,
       v_A013 varchar2,
       v_A014 varchar2,
       v_A017 varchar2,
       v_B001 int
) is
orgid int;
v_live int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_b05_t001 where p001=v_p001 and A100=orgid;
  if(v_live=0) then
      insert into cisp.T_B05_t001(P001,F002,F003,A003,A004,A005,A006,A007,A008,A015,A016,A009,A010,A011,A012,A013,A014,A017,B001,a100)
      values(v_p001,v_F002,v_F003,v_A003,v_A004,v_A005,v_A006,v_A007,v_A008,to_date(v_A015,'yyyy-mm-dd'),to_date(v_A016,'yyyy-mm-dd'),
      v_A009,v_A010,v_A011,v_A012,v_A013,v_A014,v_A017,v_B001,orgid);
      insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'רʲϢ ID:['||v_p001||']',v_task);
      errcode := 1;
      errmsg := 'ɹ';
  else
      errcode := 0;
      errmsg := 'ĿIDѾڣ';
  end if;
end cisp_ins_B05T001;
/

prompt
prompt Creating procedure CISP_INS_B08_D002
prompt ====================================
prompt
create or replace procedure cisp_ins_b08_d002(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task   varchar2,
       v_p001   int,
       v_A002   varchar2
) is
orgid int;
v_live int;
begin
    select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
    select count(*) into v_live from cisp.t_b08_d002 where p001=v_p001;
    if(v_live = 0) then
         insert into cisp.t_b08_d002(p001,a002)values(v_p001,v_A002);
         insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ȯ ID['||v_p001||']',v_task);
         errcode := 1;
         errmsg := 'ɹ!';
    else
         errcode := 0;
         errmsg := 'IDѾڣ!';
    end if;
end cisp_ins_b08_d002;
/

prompt
prompt Creating procedure CISP_INS_B09_T002
prompt ====================================
prompt
create or replace procedure cisp_ins_b09_t002(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int,
       v_A002 varchar2,
       v_A003 varchar2,
       v_A004 int
) is
  orgid int;
  v_live int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_b09_t002 where p001=v_p001 and A100=orgid;

  if(v_live>0) then
      errcode := 0;
      errmsg := 'Ȩ֤IDѾڣ!';
      return;
  else
     insert into cisp.t_b09_t002(A002,a003,a004,p001,a100)values(v_A002,v_A003,v_A004,v_p001,orgid);
     insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'Ȩ֤Ϣ ID:['||v_p001||']',v_task);
     errcode := 1;
     errmsg := 'ɹ!';
  end if;

end cisp_ins_b09_t002;
/

prompt
prompt Creating procedure CISP_INS_B12_T002
prompt ====================================
prompt
create or replace procedure cisp_ins_b12_t002(errcode  out int,
                                              errmsg   out varchar2,
                                              kjaxuser varchar2,
                                              v_task   varchar2,
                                              v_p001   varchar2,
                                              v_p002   int,
                                              v_p003   varchar2,
                                              v_A004   number,
                                              v_A005   number,
                                              v_A006   varchar2) is
  orgid  int;
  v_live int;
begin
  select p002 into orgid from krcs.t_sys_user where p001 = kjaxuser;
  select count(*)
    into v_live
    from cisp.t_b12_t002
   where p001 = to_date(v_p001, 'yyyy-mm-dd')
     and p002 = v_p002
     and p003 = v_p003
     and A100 = orgid;
  if (v_live > 0) then
    errcode := 0;
    errmsg  := 'ѾڴĿ룡';
    return;
  else
    insert into cisp.t_b12_t002
      (p001, p002, p003, a005, a006, a004, a100)
    values
      (to_date(v_p001, 'yyyy-mm-dd'),
       v_p002,
       v_p003,
       v_A005,
       v_A006,
       v_A004,
       orgid);
    insert into krcs.t_sys_log
      (p001, p002, a003, a004)
    values
      (kjaxuser,
       sysdate,
       'ҵĿϸ :' || to_date(v_p001, 'yyyy-mm-dd') || '] ĿID[' ||
       v_p002 || '[]',
       v_task);
    errcode := 1;
    errmsg  := 'ɹ!';
  end if;
end cisp_ins_b12_t002;
/

prompt
prompt Creating procedure CISP_INS_BKST002
prompt ===================================
prompt
create or replace procedure cisp_INS_BKST002(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             v_p001   int,
                                             v_A003   varchar2,
                                             v_A004   varchar2,
                                             v_A005   int,
                                             v_A006   varchar2,
                                             v_A007   varchar2,
                                             v_A008   varchar2,
                                             v_A009   varchar2,
                                             v_A010   int,
                                             v_A011   int,
                                             v_A012   varchar2) is

  v_live int;
  v_A100 int;

begin
  select p002 into v_A100 from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_bks_t002 where p001=v_p001 and p002=v_A100;

  if(v_live=0) then
           insert into cisp.T_BKS_T002(P001,P002,A003,A004,A005,A006,A007,A008,A009,A010,A011,A012)
				          values( v_P001,v_A100,to_date(v_A003,'yyyy-mm-dd'),v_A004,v_A005,v_A006,v_A007,v_A008,to_date(v_A009,'yyyy-mm-dd'),v_A010,v_A011,v_A012);
           insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ý ID:['||v_p001||']',v_task);
  else
          errcode := 0;
          errmsg := 'ýIDѾڣ!';
          return ;

  end if;
  errcode := 1;
  errmsg := '';
end cisp_INS_BKST002;
/

prompt
prompt Creating procedure CISP_INS_BKST003
prompt ===================================
prompt
create or replace procedure cisp_INS_BKST003(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    integer,
                                             vA003    integer,
                                             vA004    integer,
                                             vA006    varchar) is
  v_count integer;
  v_orgid number;
  --  update by zhouly  20130826 ޸a010Ϊa100
begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  select count(*)
    into v_count
    from cisp.T_BKS_T003
   where p001 = vP001
     and a100 = v_orgid;
  if (v_count = 1) then
    update cisp.T_BKS_T003
       set p001 = vp001,
           A002 = VA002,
           A003 = VA003,
           A004 = VA004,
           A005 = VA002 + VA003 - VA004,
           a006 = vA006
     WHERE P001 = VP001
       and a100 = v_orgid;
  else
    insert into cisp.T_BKS_T003
      (P001, A002, A003, A004, A005, A006, a100)
    VALUES
      (vP001, vA002, vA003, vA004, vA002 + vA003 - vA004, vA006, v_orgid);
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ IDT003˻ڣ<font color=red>' || vP001 || '</font>',v_task);

end cisp_INS_BKST003;
/

prompt
prompt Creating procedure CISP_INS_BKST005
prompt ===================================
prompt
create or replace procedure cisp_ins_BKST005(error_code out int,
                                             errmsg     out varchar2,
                                             kjaxuser   varchar2,
                                             v_task     varchar2,
                                             v_p001     int,
                                             v_p002     int,
                                             v_p003     int,
                                             v_p004     int,
                                             v_p005     varchar2,
                                             v_p006     varchar2,
                                             v_A007     varchar2,
                                             v_A008     varchar2,
                                             v_A009     int,
                                             v_A010     int,
                                             v_A016     int,
                                             v_A017     int,
                                             v_A011     int,
                                             v_A018     int,
                                             v_A015     varchar2) is
  v_orgid int;
  v_live  int;
begin
  select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_bks_t005 where p001=v_p001 and A100=v_orgid;
           if(v_live>0) then
               error_code := 0;
               errmsg := 'ѾĿID!';
               return;
            else
        insert into cisp.T_BKS_T005
          (P001,
           P002,
           P003,
           P004,
           P005,
           P006,
           A007,
           A008,
           A009,
           A010,
           A016,
           A017,
           A011,
           A018,
           A015,
           users,
           a100)
        values
          (v_p001,
           v_p002,
           v_p003,
           v_p004,
           v_p005,
           v_p006,
           v_A007,
           to_date(v_A008,'yyyy-mm-dd'),
           v_A009,
           v_A010,
           v_A016,
           v_A017,
           v_A011,
           v_A018,
           v_A015,
           kjaxuser,
           v_orgid);

         insert into krcs.t_sys_log(p001,p002,a003,a004)
         values(kjaxuser,sysdate,'Ŀ ĿID['||v_p001||']ɹ!',v_task);

         end if;
         error_code := 1;
         errmsg := 'ɹ!';

end cisp_ins_BKST005;
/

prompt
prompt Creating procedure CISP_INS_BKST033
prompt ===================================
prompt
create or replace procedure cisp_ins_BKST033(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int,
       v_p002 varchar2,
       logP001 varchar2,
       logA002 varchar2
) is
  orgid int;

begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;

    insert into cisp.t_bks_t033(p001,p002,a100)values(v_p001,v_p002,orgid);
    insert into krcs.t_sys_log(P001,p002,a003,a004)values(kjaxuser,sysdate,'вƷй˾֤˻:ID['||v_p001||']',v_task);

  errcode := 1;
  errmsg := 'ɹ!';
end cisp_ins_BKST033;
/

prompt
prompt Creating procedure CISP_INS_BKST043
prompt ===================================
prompt
create or replace procedure cisp_ins_bkst043(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             v_p001   varchar2,
                                             v_p002   varchar2) is
  orgid  int;
  v_live int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_bks_t043 where p001=v_p001 and A100=orgid;

  if(v_live>0) then
      errcode := 0;
      errmsg := 'ѾڴID!';
      return;
  else
      insert into cisp.t_bks_t043(p001,a001,a100)values(v_p001,v_p002,orgid);
      insert into krcs.t_sys_log(P001,p002,a003,a004)values(kjaxuser,sysdate,'ʲƷϢ ID['||v_p001||']',v_task);
      errcode := 1;
      errmsg := 'ɹ!';
  end if;
end cisp_ins_bkst043;
/

prompt
prompt Creating procedure CISP_INS_BKST101
prompt ===================================
prompt
create or replace procedure CISP_INS_BKST101(
      errcode  out int,
          errmsg   out varchar2,
          kjaxuser varchar2,/*ûid*/
          v_task   varchar2,/**/

          V_P001  int,
          V_A001  varchar2,
          V_A002  varchar2,
          V_A003  varchar2,
          V_A004  varchar2,
          V_A005  varchar2,
          V_A006  varchar2,
          V_A007  varchar2,
          V_A008  varchar2,
          V_A009  varchar2,
          V_A010  varchar2,
          V_A011  varchar2,
          V_A012  varchar2,
          V_A013  varchar2,
          V_A014  varchar2
 ) is
          v_orgid number;
          market number;/* жӵǷڵı־*/

begin
       select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;/*û˻*/
       errcode := 1;
       errmsg  := 'ӳɹ';

       select count(1) into market from cisp.t_bks_t101 where p001=V_P001 and a100=v_orgid;
  if market !=0 then
       errcode := 0;
       errmsg  := 'Ѿ';
       return;
  else
       insert into  T_BKS_T101
       (P001,A001,A002,  A003,  A004,  A005,  A006,  A007,  A008,  A009, A010,  A011,  A012,  A013,  A014,A100)
       values
       (V_P001,V_A001,  V_A002,  V_A003,  V_A004,  V_A005,  V_A006,  V_A007,  V_A008,  V_A009,  V_A010,  V_A011,  V_A012,  V_A013,V_A014,v_orgid);
       insert into krcs.T_SYS_LOG
       (P001, P002, A003,A004)
       values
       (kjaxuser,sysdate, 'ҵ̨ˣӳɹ뽻ⲿϢϵͳ漰˻ ID'||V_P001||'',v_task);
  end if;
  commit;

end CISP_INS_BKST101;
/

prompt
prompt Creating procedure CISP_INS_BKST102
prompt ===================================
prompt
create or replace procedure CISP_INS_BKST102(
              errcode  out int,
              errmsg   out varchar2,
              kjaxuser varchar2,
              v_task   varchar2,

              V_P001  int,
              V_A001  varchar2,
              V_A002  varchar2,
              V_A003  varchar2,
              V_A004  varchar2,
              V_A005  varchar2,
              V_A006  varchar2,
              V_A007  varchar2,
              V_A008  varchar2,
              V_A009  varchar2,
              V_A011  int,
              V_A010  varchar2

) is
              v_orgid     int;
              market    int; /*жӵţǷ*/

begin
      select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
      errcode := 1;
      errmsg  := 'ӳɹ';

      select count(1) into market from cisp.t_bks_t102 where p001=V_P001 and a100=v_orgid;
  if market !=0 then
      errcode := 0;
      errmsg  := 'Ѿ';
      return;
  else
      insert into  T_BKS_T102
       (P001,A001,A002,  A003,  A004,  A005,  A006,  A007,  A008,  A009,  A010,A011, A100)
       values
       (V_P001,V_A001,  V_A002,  V_A003,  V_A004,  V_A005,  V_A006,  to_date(V_A007,'yyyy-mm-dd'),  to_date(V_A008,'yyyy-mm-dd'),  V_A009,  V_A010,V_A011, v_orgid);
       insert into krcs.T_SYS_LOG
       (P001, P002, A003,A004)
       values
      (kjaxuser, sysdate, 'ҵ̨ˣӳɹ뽻ⲿϢϵͳ漰˻ϸ ID'||V_P001||'',v_task);
  end  if;
  commit;

end CISP_INS_BKST102;
/

prompt
prompt Creating procedure CISP_INS_BKSZYRHHY
prompt =====================================
prompt
CREATE OR REPLACE PROCEDURE cisp_INS_BKSZYRHHY(
    ERRCODE OUT INT,
    ERRMSG OUT VARCHAR2,
    KJAXUSER VARCHAR2,
    V_TASK VARCHAR2,
    V_P001 VARCHAR2,
    V_JYRQ VARCHAR2,
    V_HTH VARCHAR2,
    V_GLHTH VARCHAR2,
    V_SBHTXH VARCHAR2,
    V_HTLX VARCHAR2,
  V_FZJG VARCHAR2,
  V_KHBH VARCHAR2,
  V_KHXM VARCHAR2,
  V_RCFMC VARCHAR2,
  V_RCFLX VARCHAR2,
  V_ZQDM VARCHAR2,
  V_ZQMC VARCHAR2,
  V_WTSL integer,
  V_HGSL integer,
  V_LJBFJYSL integer,
  V_LJWYMCSL integer,
  V_WTJE NUMBER,
  V_YHJE NUMBER,
  V_DQRQ VARCHAR2,
  V_SJGHRQ VARCHAR2,
  V_WTRQ integer,
  V_JYSC VARCHAR2,
  V_XSBS VARCHAR2,
  V_JGBS VARCHAR2,
  V_HGLL  NUMBER,
  V_SJGHJE  NUMBER,
  V_YJLX  NUMBER,
  V_SFWY  VARCHAR2
    ) IS

  v_live int;
  v_A100 int;

begin
  select p002 into v_A100 from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.T_BKS_ZYRHHY where p001=v_p001 and a100=v_A100;

  if(v_live=0) then
           insert into cisp.T_BKS_ZYRHHY(P001,JYRQ,HTH,GLHTH,SBHTXH,HTLX,FZJG,KHBH,KHXM,RCFMC,RCFLX,ZQDM,ZQMC,WTSL,HGSL,LJBFJYSL,LJWYMCSL,WTJE,YHJE,DQRQ,SJGHRQ,WTRQ,JYSC,XSBZ,JGBS,HGLL,SJGHJE,YJLX,SFWY,A100)
                  values(V_P001,V_JYRQ,V_HTH,V_GLHTH,V_SBHTXH,V_HTLX,V_FZJG,V_KHBH,V_KHXM,V_RCFMC,V_RCFLX,V_ZQDM,V_ZQMC,V_WTSL,V_HGSL,V_LJBFJYSL,V_LJWYMCSL,V_WTJE,V_YHJE,V_DQRQ,V_SJGHRQ,V_WTRQ,V_JYSC,V_XSBS,V_JGBS,V_HGLL,V_SJGHJE,V_YJLX,V_SFWY,v_A100);
           insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ڻԼ̨ ID:['||v_p001||']',v_task);
  else
          errcode := 0;
          errmsg := '̨IDѾڣ!';
          return ;

  end if;
  errcode := 1;
  errmsg := '';
end cisp_INS_BKSZYRHHY;
/

prompt
prompt Creating procedure CISP_INS_BKS_T016
prompt ====================================
prompt
create or replace procedure CISP_INS_BKS_T016(errcode    out int,
                                              errmsg     out varchar2,
                                              v_KJAXUSER varchar2,
                                              v_TASK     varchar2,
                                              VP001      varchar2,
                                              VA002      varchar2,
                                              VA003      numeric,
                                              VA004      numeric,
                                              VA005      numeric) is
  V_A003     numeric;
  V_A004     numeric;
  V_COUNT    integer;
  V_TYPENAME varchar2(1024);
  V_ORG      number;
begin
  V_COUNT := 0;
  errcode := 1;
  errmsg  := '';
  V_A003  := substr(VA003, 4, 7);
  V_A004  := substr(VA003, 1, 3);

  select p002 into V_ORG from krcs.t_sys_user where p001 = v_KJAXUSER;
  --ǰжϴǷѾ
  --1Ʊ 10121017⣬ͬʱ йҵͬʱ֤180һͨ
  if V_A004 = 100 then
    --ͨ
    if V_A003 = 1012 or V_A003 = 1017 then
      select count(P001)
        into V_COUNT
        from T_BKS_T016
       where A004 = 100
         and A003 in (1012, 1017)
         and P001 = VP001
         and A100 = V_ORG;
      if V_COUNT > 0 then
        errcode := 0;
        errmsg  := '֤ȯѾͨ͵ĹɱϢ';
        return;
      end if;
    end if;
    if V_A003 <> 1012 and V_A003 <> 1017 then
      select count(P001)
        into V_COUNT
        from T_BKS_T016
       where A004 = 100
         and A003 not in (1012, 1017)
         and P001 = VP001
         and A100 = V_ORG;
      if V_COUNT > 0 then
        errcode := 0;
        errmsg  := '֤ȯѾڷͨ͵ĹɱϢ';
        return;
      end if;
    end if;
  end if;

  --1, ծȯ ͬʱ 绪Ļͬʱǻгͷǻг
  if V_A004 <> 100 then
    if V_A004 = 200 then
      V_TYPENAME := '';
    end if;
    if V_A004 = 300 then
      V_TYPENAME := 'ծȯ';
    end if;
    if V_A004 = 400 then
      V_TYPENAME := '(Ȩ֤Ʊݵ)';
    end if;
    select count(P001)
      into V_COUNT
      from T_BKS_T016
     where A004 = V_A004
       and P001 = VP001
       and A100 = V_ORG;
    if V_COUNT > 0 then
      errcode := 0;
      errmsg  := '֤ȯѾ' || V_TYPENAME || '͵ĹɱϢ';
      return;
    end if;
  end if;

  --Ȳɱ
  insert into T_BKS_T016
    (P001, A002, A003, A004, A005, A006, A007 ,A100)
  values
    (VP001, VA002, V_A003, V_A004, VA004, v_KJAXUSER, sysdate , V_ORG);

  if VA003 = '1001012' or VA003 = '1001017' then
    delete from t_bks_t019 where P001 = VP001 and A100 = V_ORG;
    insert into T_BKS_T019 (P001, A002, A003 ,A100) values (VP001, VA002, VA005 ,V_ORG);
  end if;

  --ͬһµ֤ȯйɱϢΪܴͬһ֤ȯڲͬСࣨƺͷƣͬ¹ɱ
  update t_bks_t016
     set A005 = VA004,A002=VA002, A006 = v_KJAXUSER, A007 = sysdate
   where P001 = VP001
     and A004 = V_A004
     and A100 = V_ORG;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003 ,A004)
  values
    (v_KJAXUSER,
     sysdate,
     '֤ȯϢIDBKS_T016֤ȯϢ--ɱࣻ룺<font color=red>' ||
     VP001 || '</font>',
     v_TASK);
exception
  when others then
    errcode := 0;
    errmsg  := 'ʶļ¼Ѿڻ֤ȯδά';
    return;
end;
/

prompt
prompt Creating procedure CISP_INS_BKS_T019
prompt ====================================
prompt
create or replace procedure CISP_INS_BKS_T019(errcode    out int,
                                              errmsg     out varchar2,
                                              v_KJAXUSER varchar2,
                                              v_TASK     varchar2,
                                              VP001      varchar2,
                                              VA002      varchar2,
                                              VA003      numeric,
                                              VA004      numeric,
                                              VA005      numeric) is
  V_A003 numeric;
  V_A004 numeric;
  V_COUNT integer;
  V_ORG  number;
begin
  errcode := 1;
  errmsg  := '';

  select p002 into V_ORG from krcs.t_sys_user where p001 = v_KJAXUSER;
  --delete from T_BKS_T016   where P001 = VP001  AND A100 IN (SELECT P002 FROM T_SYS_USER WHERE P001 = v_KJAXUSER);
  V_A003 := substr(VA003, 4, 7);
  V_A004 := substr(VA003, 1, 3);
  select count(P001)
    into V_COUNT
    from T_BKS_T016
   where A004 = 100
     and A003 in (1012, 1017)
     and P001 = VP001
     and A100 = V_ORG;
  if V_COUNT > 0 then
    errcode := 0;
    errmsg  := '֤ȯѾͨ͵ĹɱϢ';
    return;
  end if;

  insert into T_BKS_T016
    (P001, A002, A003, A004, A005, A006, A007 ,A100)
  values
    (VP001, VA002, V_A003, V_A004, VA004, v_KJAXUSER, sysdate ,V_ORG);
  delete from t_bks_t019 where p001 = VP001 and A100 = V_ORG;
  insert into T_BKS_T019 (P001, A002, A003 ,A100) values (VP001, VA002, VA005 ,V_ORG);

  --ͬһµ֤ȯйɱϢΪܴͬһ֤ȯڲͬС࣬ͬ¹ɱ
  update t_bks_t016
     set A005 = VA004, A006 = v_KJAXUSER, A007 = sysdate
   where P001 = VP001
     and A004 = V_A004
     and A100 = V_ORG;

  insert into KRCS.T_SYS_LOG
    (P001, P002, A003 ,A004)
  values
    (v_KJAXUSER,
     sysdate,
     '֤ȯϢIDBKS_T016֤ȯϢ--ͨɹ룺<font color=red>' ||
     VP001 || '</font>',
     v_TASK);

exception
  when others then
    errcode := 0;
    errmsg  := 'ʶļ¼Ѿڻδά֤ȯ';
    return;
end;
/

prompt
prompt Creating procedure CISP_INS_DT_112007001
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_112007001(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_task     varchar2,
                                             v_p001     int,
                                             v_A002     int,
                                             v_A003     number,
                                             v_A004     number,
                                             v_A005     number,
                                             v_A006     number,
                                             v_A007     number,
                                             v_A008     number) is
v_live int;
begin

  select count(*) into v_live from cisp.t_db_04_007 where p001=v_p001 and w100=(select A012 from krcs.t_sys_user where p001=v_kjaxuser);
  if(v_live >0) then
       errcode := 0;
       errmsg := 'ѾڴID';
       return ;
  else
  insert into cisp.T_DB_04_007
    (P001, A002, A003, A004, A005, A006, A007, A008, A100, W100)
    SELECT v_P001,
           v_A002,
           v_A003,
           v_A004,
           v_A005,
           v_A006,
           v_A007,
           v_A008,
           P002,
           A012
      FROM krcs.T_SYS_USER
     WHERE P001 = v_kjaxuser;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112007001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,' ֤ȯͶҵ񣨹ָڻͶʣID: 112007001',v_task);
    errcode := 1;
    errmsg := 'ɹ!';
   end if;
end ;
/

prompt
prompt Creating procedure CISP_INS_DT_113002001
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113002001(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A011     numeric,
                                             V_A012     integer,
                                             V_A013     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;


begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  --жĴݱ(ͨ)Ƿ
  select count(*)
    into v_count
    from cisp.T_DB_04_001
   where A002 not in(1012,1017)
     and A010 = 100
     and P001 = V_P001
     and w100 = v_bmid;

  if v_count > 0 then
    errcode := 0;
    errmsg  := '֤ȯͨƱѾ';
    return;
  end if;

  --ݱ
  insert into cisp.T_DB_04_001
    (P001,
     A002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A100,
     w100)
    select V_P001,
           V_A002,
           V_A003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           V_A009,
           100,
           V_A011,
           P002,
           a012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;

  --´˴֤ͬȯйɱ(ͬһַ)
  update cisp.t_bks_t016
     set A005 = V_A013,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
   where P001 = V_P001
     and A004 = 100
     and a100 = v_orgid;

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and A004 = 100
     and a100 = v_orgid;

  --ɱ
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P001, V_A003, V_A002, 100, V_A013, v_orgid);
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002001֤ȯͶҵ-ͨɣ±֤ȯ룺<font color=red>' ||
     v_P001 || '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002001
     and a004 = v_bmid
     and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'krcs_ins_dt_6001ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113002002
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113002002(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A011     numeric,
                                             V_A012     integer,
                                             V_A013     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;

begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  select count(*)
    into v_count
    from cisp.T_DB_04_001
   where A002 in(1012,1017)
     and A010 = 100
     and P001 = V_P001
     and w100 = v_bmid;

  if v_count > 0 then
    errcode := 0;
    errmsg  := '֤ȯͨƱѾ';
    return;
  end if;

  --ݱ
  insert into cisp.T_DB_04_001
    (P001,
     A002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A100,
     w100)
    select V_P001,
           V_A002,
           V_A003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           V_A009,
           100,
           V_A011,
           P002,
           a012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;

  --´˴֤ͬȯйɱ(ͬһַ)
  update cisp.t_bks_t016
     set A005 = V_A013,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
   where P001 = V_P001
     and A004 = 100
     and a100 = v_orgid;

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and A004 = 100
     and a100 = v_orgid;

  --ɱ
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, a100)
    values
      (V_P001, V_A003, V_A002, 100, V_A013, v_orgid);
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002002֤ȯͶҵ-ͨɣ±֤ȯ룺<font color=red>' ||
     v_P001 || '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002002
     and a004 = v_bmid
     and p002= v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'krcs_ins_dt_6002ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113002003
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113002003(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A011     numeric,
                                             V_A012     integer,
                                             V_A013     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;


begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  select count(*)
    into v_count
    from cisp.T_DB_04_001
   where A010 = 200
     and A002 not in(1012,1017)
     and P001 = V_P001
     and w100 = v_bmid;

  if v_count > 0 then
    errcode := 0;
    errmsg  := '֤ȯڻѾ';
    return;
  end if;

  --ݱ
  insert into cisp.T_DB_04_001
    (P001,
     A002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A100,
     w100)
    select V_P001,
           V_A002,
           V_A003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           V_A009,
           200,
           V_A011,
           P002,
           a012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;

  --´˴֤ͬȯйɱ(ͬһַ)
  update cisp.t_bks_t016
     set A005 = V_A013,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
   where P001 = V_P001
     and A004 = 200
     and a100 = v_orgid;

  select count(*)
    into v_count
    from t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and A004 = 200
     and a100 = v_orgid;

  --ɱ
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P001, V_A003, V_A002, 200, V_A013, v_orgid);
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002003֤ȯͶҵ-𣩣±֤ȯ룺<font color=red>' ||
     v_P001 || '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002003
     and a004 = v_bmid
     and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'krcs_ins_dt_6003ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113002004
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113002004(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A010     numeric,
                                             V_A012     numeric,
                                             V_A013     integer,
                                             V_A014     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;


begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  select count(*)
    into v_count
    from cisp.T_DB_04_002
   where A011 = 300
     and P001 = V_P001
     and w100 = v_bmid;

  if v_count > 0 then
    errcode := 0;
    errmsg  := '֤ȯծȯѾ';
    return;
  end if;

  --ݱ
  insert into cisp.T_DB_04_002
    (P001,
     A002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A012,
     A100,
     w100)
    select V_P001,
           V_A002,
           V_A003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           V_A009,
           V_A010,
           300,
           V_A012,
           P002,
           a012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;

  --´˴֤ͬȯйɱ(ͬһַ)
  update cisp.t_bks_t016
    set A005 = V_A013,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
  where P001 = V_P001
    and A004 = 300
     and a100 = v_orgid;

  select count(*)
    into v_count
    from t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and A004 = 300
     and a100 = v_orgid;

  --ɱ
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P001, V_A003, V_A002, 300, V_A014, v_orgid);
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002004֤ȯͶҵ-ծȯ±֤ȯ룺<font color=red>' || v_P001 ||
     '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002004
     and a004 = v_bmid
     and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'krcs_ins_dt_6004ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113002005
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113002005(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A010     numeric,
                                             V_A012     numeric,
                                             V_A013     integer,
                                             V_A014     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;

begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  select count(*)
    into v_count
    from cisp.T_DB_04_002
   where A011 = 400
     and P001 = V_P001
     and w100 = v_bmid;

  if v_count > 0 then
    errcode := 0;
    errmsg  := '֤ȯѾ';
    return;
  end if;


  --ݱ
  insert into cisp.T_DB_04_002
    (P001,
     A002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A012,
     A100,
     w100)
    select V_P001,
           V_A002,
           V_A003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           V_A009,
           V_A010,
           400,
           V_A012,
           P002,
           a012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;


  --´˴֤ͬȯйɱ(ͬһַ)
  update cisp.t_bks_t016
     set A005 = V_A014,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
   where P001 = V_P001
     and A004 = 400
     and A100 = v_orgid;

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and A004 = 400
     and A100 = v_orgid;

  --ɱ
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, a100)
    values
      (V_P001, V_A003, V_A002, 400, V_A014, v_orgid);
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002005֤ȯͶҵ-±֤ȯ룺<font color=red>' || v_P001 ||
     '</font>',v_task);

update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002005
   and a004 = v_bmid
   and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_ins_dt_113002005ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113002008
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113002008(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P003     varchar2,
                                             V_A002     integer,
                                             V_A004     varchar2,
                                             V_CA005    numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;


begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  select count(*)
    into v_count
    from cisp.T_DB_04_002_02_02
   where P001 = 300
     and P003 = V_P003
     and W100 = v_bmid
     and A100 = v_orgid;

  if v_count > 0 then
    errcode := 0;
    errmsg  := '֤ȯծȯѾ';
    return;
  end if;


  --ݱ
  insert into cisp.T_DB_04_002_02_02
    (P001,
     P003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A100,
     W100)
    select 300,
           V_P003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           P002,
           A012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;

  --´˴֤ͬȯйɱ(ͬһַ)
  update cisp.t_bks_t016
     set A005 = V_CA005
   where P001 = V_P003
     and A004 = 300
     and a100 = v_orgid;

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P003
     and A003 = V_A002
     and A004 = 300
     and a100 = v_orgid;

  --ɱ
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P003, V_A004, V_A002, 300, V_CA005, v_orgid);
  end if;


  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002008֤ȯͶҵ-ծȯ̶沿бǰ5-±֤ȯ룺<font color=red>' || V_P003 ||
     '</font>',v_task);

 update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002008
   and a004 = v_bmid
   and p002 = v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_ins_dt_113002008ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113002009
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113002009(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P003     varchar2,
                                             V_A002     integer,
                                             V_A004     varchar2,
                                             V_CA005    numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;

begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  select count(*)
    into v_count
    from cisp.T_DB_04_002_02_02
   where P001 = 400
     and P003 = V_P003
     and W100 = v_bmid
     and a100 = v_orgid;

  if v_count > 0 then
    errcode := 0;
    errmsg  := '֤ȯѾ';
    return;
  end if;


  --ݱ
  insert into cisp.T_DB_04_002_02_02
    (P001,
     P003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A100,
     W100)
    select 400,
           V_P003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           P002,
           A012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P003
     and A004 = 400
     and a100 = v_orgid;

  --´˴֤ͬȯйɱ(ͬһַ)
  update cisp.t_bks_t016
     set A005 = V_CA005
   where P001 = V_P003
     and A004 = 400
     and a100 = v_orgid;

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P003
     and A003 = V_A002
     and A004 = 400
     and a100 = v_orgid;

  --ɱ
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P003, V_A004, V_A002, 400, V_CA005, v_orgid);
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002009֤ȯͶҵ-̶沿бǰ5-±֤ȯ룺<font color=red>' || V_P003 ||
     '</font>',v_task);

 update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002009
   and a004 = v_bmid
   and p002 = v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_ins_dt_113002009ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113014001
prompt ========================================
prompt
create or replace procedure cisp_ins_DT_113014001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    VP001 integer,
    VA002 varchar2,
    VA003 varchar2,
    VA004 varchar2,
    VA005 numeric,
    VA006 varchar2,
    VA007 varchar2,
    VA008 varchar2,
    VA009 numeric,
    VA010 varchar2,
    VA011 numeric,
    VA012 numeric,
    VA013 varchar2,
    VA014 numeric,
    VA015 varchar2
    )
is
  v_count integer;
begin
  errcode := 1;
  errmsg  := '';

  --жݱǷ
  select count(*)
    into v_count
    from cisp.T_DB_05_020
   where P001 = VP001
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER);

  if v_count > 0 then
    errcode := 0;
    errmsg  := 'Ѿ';
    return;
  end if;

  --ݱ
  insert into cisp.T_DB_05_020
    (P001,
     A002,
     A003,
     A004,
     A005,
     A006,
     A007,
     A008,
     A009,
     A010,
     A011,
     A012,
     A013,
     A014,
     A015,
     A100,
     w100)
    select VP001,
           to_date(VA002,'yyyy-mm-dd'),
           VA003,
           VA004,
           VA005,
           VA006,
           to_date(VA007,'yyyy-mm-dd'),
           to_date(VA008,'yyyy-mm-dd'),
           VA009,
           VA010,
           VA011,
           VA012,
           VA013,
           VA014,
           to_date(VA015,'yyyy-mm-dd'),
           P002,
           a012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;

  insert into krcs.T_SYS_LOG (P001, P002, A003,A004) values(v_KJAXUSER,sysdate,'ݱάID113014001֤ȯ˾ʻרܱ-ϸ,ţ<font color=red>' ||VP001 || '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113014001
     and a004 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
     and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_ins_DT_113014001ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_INS_DT_113015001
prompt ========================================
prompt
create or replace procedure CISP_INS_DT_113015001(errcode  out int,
                                                   errmsg   out varchar2,
                                                  kjaxuser varchar2,
                                                  v_task   varchar2,
                                                  V_P001    integer,
                                                  V_A001    varchar2,
                                                  V_A002   number,
                                                  V_A003   number,
                                                  V_A004   number,
                                                  V_A005   number,
                                                  V_A006   number,
                                                  V_A007   number,
                                                  V_A008   number,
                                                  V_A009   number,
                                                  V_A010   number,
                                                  V_A011   number,
                                                  V_A012   number,
                                                  V_A013   number,
                                                  V_A014   number,
                                                  V_A015   number,
                                                  V_A016   number,
                                                  V_A017   number,
                                                  V_A018   number
                                                  )
is
v_count number;
v_bmid number;
v_orgid number;
begin
  select a012 into v_bmid from krcs.t_sys_user where p001 =kjaxuser;
  select count(*) into v_count from  cisp.t_db_05_025
         where P001= V_P001 AND w100 =v_bmid and A100=(select p002 from krcs.t_sys_user where p001=kjaxuser);
  select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
  if v_count<>0 then
    errcode := 0;
    errmsg  :='IDѴ';
  else
         INSERT INTO cisp.t_db_05_025(P001, A001,A002,A003,A004,A005,A006,A007,A008,A009,A010,A011,A012,A013,A014,A015,A016,A017,A018,A100,W100)
                values(V_P001,V_A001,V_A002,V_A003,V_A004,V_A005,V_A006,V_A007,V_A008,V_A009,V_A010,V_A011,V_A012,V_A013,
                V_A014,V_A015,V_A016,V_A017,V_A018,v_orgid,v_bmid);
         insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'֤ȯ˾ʻרܱ ID:113015001',V_TASK);
    errcode := 1;
    errmsg  :=' ɹ';
  end if ;
end;
/

prompt
prompt Creating procedure CISP_INS_UPDRECORD
prompt =====================================
prompt
CREATE OR REPLACE PROCEDURE cisp_ins_updrecord (v_p001 varchar2,--ݱid
                                                v_rowid varchar2,--rowidڶλ
                                                v_KJAXUSER varchar2,
                                                v_flag varchar2,--ͣ1ݱ
                                                logP001  varchar2,
                                                logA002  varchar2
                                              ) is
  /*
       רݱ޸ļ¼ѯ
  */
  v_table  varchar2(255);
  err_msg   varchar2(4000);
  v_tempcol varchar2(4000);
  v_sql5 varchar2(4000);
  v_sql4 varchar2(4000);
  v_sql varchar2(4000);
  v_sql2 varchar2(4000);
  v_sql3 varchar2(4000);
  v_cols varchar2(4000);
  v_values varchar2(4000);--޸ǰֵ
  v_values2 varchar2(4000);--޸ĺֵ
  v_tablename varchar(4000);--ı
  v_strtmp varchar2(4000);
  v_strtmp2 varchar2(4000);
  v_strtmp3 varchar2(4000);
  v_col varchar2(4000);--
  v_msg varchar2(4000);--޸
  v_remark varchar2(4000);--ע
  v_updflag number;--Ƿ޸ı־ĬΪ0޸Ϊ1
   v_index1        int;
   v_index2        int;
   v_index11        int;
   v_index22        int;
    v_index111        int;
   v_index222        int;
   v_value varchar2(4000);--޸ǰֵ
   v_value2 varchar2(4000);--޸ĺֵ
begin
    select upper(t.b003) into v_table from krcs.t_sys_t011 t where t.p001=v_p001;
    v_sql5:='select  distinct p002   from  t_cisp_comments_config   where   upper(p001)= upper('''||v_p001||''')';
    EXECUTE IMMEDIATE v_sql5 into v_tablename;
    --ѯñֶ
    v_sql:='select to_char(WMSYS.WM_CONCAT(cname))   from sys.col where upper(tname)=upper('''||v_table||''')';
    EXECUTE IMMEDIATE v_sql into v_cols;

    --õѯֶθʽ p001||'|'||p002
    v_sql4:='select to_char(WMSYS.WM_CONCAT(cname||''||''''|''''||'')) from sys.col where upper(tname)=('''||v_table||''')';
    EXECUTE IMMEDIATE v_sql4 INTO v_tempcol;
    v_tempcol:=replace(v_tempcol,',','');
    v_tempcol:=substr(v_tempcol,0,length(v_tempcol)-2);

    --õ޸ĺı¼
    v_sql2:='select '||v_tempcol||' from '||v_table||' a where a.rowid='''||v_rowid||'''';
    EXECUTE IMMEDIATE v_sql2 INTO v_values2;

    --õ޸ǰı¼
    v_sql3:='select '||v_tempcol||' from '||v_table||'  VERSIONS BETWEEN TIMESTAMP MINVALUE AND MAXVALUE where rowid='''||v_rowid||''' and VERSIONS_ENDTIME is not null and rownum=1 order by VERSIONS_ENDTIME desc';
    EXECUTE IMMEDIATE v_sql3 into v_values;
     v_strtmp := v_cols || ',';
     v_index2        := 1;
     v_strtmp2 := v_values || '|';
     v_index22        := 1;
     v_strtmp3 := v_values2 || '|';
     v_index222        := 1;
     v_updflag:=0;
     v_msg:=logP001|| '<font color=red>' ||logA002 || '</font>:';

     loop
        v_index1  := instr(v_strtmp, ',', v_index2);
          exit when v_index1 <= 0;

        v_index11  := instr(v_strtmp2, '|', v_index22);
          exit when v_index11 <= 0;

        v_index111  := instr(v_strtmp3, '|', v_index222);
          exit when v_index111 <= 0;

        v_col    := substr(v_strtmp, v_index2, v_index1 - v_index2);
        v_index2        := v_index1 + 1;

        v_value    := substr(v_strtmp2, v_index22, v_index11 - v_index22);
        v_index22        := v_index11 + 1;

        v_value2    := substr(v_strtmp3, v_index222, v_index111 - v_index222);
        v_index222        := v_index111 + 1;



        if v_value2<>v_value then
          v_updflag:=1;
          v_remark:=f_getcomments(v_p001,v_col);
          v_msg:=v_msg||'['||v_remark||']<font color=blue>'||v_value||'</font>-><font color=red>'||v_value2||'</font>,';

        end if;
      end loop;

      if v_updflag =1 then
          v_msg:=substr(v_msg,0,length(v_msg)-1);
          insert into T_CISP_LOG(p001,a002,a003,a004,a005,a006,flag,w100)
             values(v_p001,v_tablename,v_rowid,v_msg,sysdate,v_KJAXUSER,v_flag,(select nvl(x.a012,x.p002) from krcs.t_sys_user x where x.p001=v_KJAXUSER));

      end if;
      commit;
return;

end ;
/

prompt
prompt Creating procedure CISP_INS_UPD_BKSB11T001
prompt ==========================================
prompt
create or replace procedure cisp_ins_upd_BKSB11T001(
       errcode            out int,
       errmsg             out varchar2,
       kjaxuser               varchar2,
       v_task                 varchar2,
       v_p001                 int,
       v_A002                 varchar2,
       v_B001                 int
) is

       v_orgid int;
       v_live int;
begin
       select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
       select count(*) into v_live from cisp.t_b11_t001 where p001=v_p001 and A100=v_orgid;

       if(v_live>0) then
            update cisp.t_b11_t001 set A002=v_A002,B001=v_B001 where p001=v_p001 and A100=v_orgid;
       else
            insert into cisp.t_b11_t001(P001,A002,B001,A100)values (v_p001,v_A002,v_B001,v_orgid);

       end if;

       insert into krcs.t_sys_log(P001,p002,a003,a004)values
       (kjaxuser,sysdate,'ڻмҵȫʻʵʣعڻ˾£:ID['||v_p001||'ɹ!',v_task);

       errcode := 1;
       errmsg := '';
end ;
/

prompt
prompt Creating procedure CISP_INS_UPD_BKSB11T003
prompt ==========================================
prompt
create or replace procedure cisp_ins_upd_BKSB11T003(
       errcode            out int,
       errmsg             out varchar2,
       kjaxuser               varchar2,
       v_task                 varchar2,
       v_p001                 int,
       v_A002                 varchar2,
       v_B001                 int
) is

       v_orgid int;
       v_live int;
begin
       select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
       select count(*) into v_live from cisp.t_b11_t003 where p001=v_p001 and A100=v_orgid;

       if(v_live>0) then
            update cisp.t_b11_t003 set A002=v_A002,B001=v_B001 where p001=v_p001 and A100=v_orgid;
       else
            insert into cisp.t_b11_t003(P001,A002,B001,A100)values (v_p001,v_A002,v_B001,v_orgid);

       end if;

       insert into krcs.t_sys_log(P001,p002,a003,a004)values
       (kjaxuser,sysdate,'޸ģṩмҵڻ˾:ID['||v_p001||'ɹ!',v_task);

       errcode := 1;
       errmsg := '';
end ;
/

prompt
prompt Creating procedure CISP_MAKEBALANCE_UNFI
prompt ========================================
prompt
CREATE OR REPLACE PROCEDURE CISP_MAKEBALANCE_UNFI
  /* =============================================
  * ҵ˵;ѲϵͳɿĿ
  *  P_OUT_FLAG           :ش룬1-ɹ 0-ʧ
  *  P_OUT_MSG            :
  *  P_OUT_RESULT         :ǰ˴
  * Ա[chenyong]
  * ϵʽ[:chen_yong@szkingdom.com]
  * ʱ䣺2019-11-19
  * 汾˵v1.0
  * ҵϸ˵
  ============================================*/
 AS
  v_bbq_begindate NUMBER; --ʼ
  v_bbq_enddate   NUMBER; --ֹ
  v_str           varchar2(1000);
  i int;
  v_year       varchar2(64);
  v_period     varchar2(64);
  type tb_map_cwxt_km_unfi is table of t_map_cwxt_km_unfi%rowtype;
  vt_cwxt_unfi tb_map_cwxt_km_unfi := tb_map_cwxt_km_unfi();

BEGIN

    select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_bbq_begindate, v_bbq_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

    select to_char(to_date(p001,'yyyy-mm'),'yyyy') into v_year from t_b00_d004 where a002 = 1013001 and c001=1001101;
    select to_char(to_date(p001,'yyyy-mm'),'mm') into v_period from t_b00_d004 where a002 = 1013001 and c001=1001101;



  delete from t_map_cwxt_km_unfi;
  --ĩԭң
  insert into t_map_cwxt_km_unfi
    (company,
     acctsubjcode,
     begin_balance_dr,
     begin_balance_cr,
     local_begin_balance_dr,
     local_begin_balance_cr,
     period_net_dr,
     period_net_cr,
     local_period_net_dr,
     local_period_net_cr,
     period_name,
     period_year,
     period_num,
     nc_balance_dr,
     nc_balance_cr,
     local_nc_balance_dr,
     local_nc_balance_cr,
     beginbalance,
     endbalance,
     ncbalance,
     periodbalance,
     local_beginbalance,
     local_endbalance,
     local_ncbalance,
     local_periodbalance,
     currency,
     enddrbalance,
     local_enddrbalance,
     endcrbalance,
     local_endcrbalance)
    select b.code         as company,
           d.code  as acctsubjcode,
           0,
           0,
           0,
           0,
           0,
           0,
           0,
           0,
           v_year || '-' || v_period as period_name,
           v_year                    as period_year,
           v_period                  as period_num,
           0,
           0,
           0,
           0,
           0,
           nvl(sum(decode(d.balanorient,0,a.debitamount - a.creditamount,
                                        1,a.creditamount - a.debitamount)),0)           as endbalance,
           0,
           0,
           0,
           nvl(sum(decode(d.balanorient,0,a.localdebitamount - a.localcreditamount,
                                        1,a.localcreditamount - a.localdebitamount)),0) as local_endbalance,
           0,
           0,
           c.code                   as currency,
           sum(a.debitamount)       as enddrbalance,
           sum(a.localdebitamount)  as local_enddrbalance,
           sum(a.creditamount)      as endcrbalance,
           sum(a.localcreditamount) as local_endcrbalance
      from kods.nc65_gl_detail   a,
           kods.nc65_org_accountingbook    b,
           kods.nc65_bd_currtype c,
           kods.nc65_bd_accasoa e,
           kods.nc65_bd_account d --ϼĿΪ׼
     where a.pk_accountingbook = b.pk_accountingbook
       and a.pk_currtype = c.pk_currtype
       and a.pk_accasoa = e.pk_accasoa
       and e.pk_account = d.pk_account
       and a.yearv = v_year
       and a.periodv <= v_period
       and a.dr = 0 --Ƿע
       --and a.discardflagv = 'N' --ǷΪϵ־
       --and b.code != '02' --޳ڻݺͶ޹˾
     group by b.code, c.code,d.code;

  --ڼ:ԭңҽ跽
  select b.code        as company,
         d.code as acctsubjcode,
         0,
         0,
         0,
         0,
         nvl(sum(a.debitamount), 0)       as period_net_dr,
         nvl(sum(a.creditamount), 0)      as period_net_cr,
         nvl(sum(a.localdebitamount), 0)  as local_period_net_dr,
         nvl(sum(a.localcreditamount), 0) as local_period_net_cr,
         v_year || '-' || v_period        as period_name,
         v_year                           as period_year,
         v_period                         as period_num,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         nvl(sum(decode(d.balanorient,0,a.debitamount - a.creditamount,
                                    1,a.creditamount - a.debitamount,
                                        a.debitamount - a.creditamount)),0)  as periodbalance,
         0,
         0,
         0,
         nvl(sum(decode(d.balanorient,0,a.localdebitamount - a.localcreditamount,
                                    1,a.localcreditamount - a.localdebitamount,
                                        a.localdebitamount - a.localcreditamount)),0) as local_periodbalance,
         c.code                   as currency,
         sum(a.debitamount)       as enddrbalance,
         sum(a.localdebitamount)  as local_enddrbalance,
         sum(a.creditamount)      as endcrbalance,
         sum(a.localcreditamount) as local_endcrbalance bulk collect
    into vt_cwxt_unfi
    from kods.nc65_gl_detail   a,
         kods.nc65_org_accountingbook    b,
         kods.nc65_bd_currtype c,
         kods.nc65_bd_accasoa e,
         kods.nc65_bd_account  d
   where a.pk_accountingbook = b.pk_accountingbook
     and a.pk_currtype = c.pk_currtype
     and a.yearv = v_year
     and a.pk_accasoa = e.pk_accasoa
     and e.pk_account = d.pk_account
     and a.periodv = v_period
     and a.dr = 0 --Ƿע
     --and a.discardflagv = 'N' --ǷΪϵ־
     --and a.direction = 'C' --ڼȡһ
     --and b.code != '02' --޳ڻݺͶ޹˾
   group by b.code,c.code,d.code;

  for i in 1 .. vt_cwxt_unfi.count loop
    update t_map_cwxt_km_unfi t
       set t.period_net_dr       = vt_cwxt_unfi(i).period_net_dr,
           t.period_net_cr       = vt_cwxt_unfi(i).period_net_cr,
           t.local_period_net_cr = vt_cwxt_unfi(i).local_period_net_cr,
           t.local_period_net_dr = vt_cwxt_unfi(i).local_period_net_dr,
           t.periodbalance       = vt_cwxt_unfi(i).periodbalance,
           t.local_periodbalance = vt_cwxt_unfi(i).local_periodbalance
     where t.company = vt_cwxt_unfi(i).company
       and t.acctsubjcode = vt_cwxt_unfi(i).acctsubjcode
       and t.currency = vt_cwxt_unfi(i).currency;
  end loop;
  vt_cwxt_unfi.delete;
  --ڳ
  select b.code,
         d.code,
         nvl(sum(a.debitamount), 0) beginbalancedr,
         nvl(sum(a.creditamount), 0) beginbalancecr,
         nvl(sum(a.localdebitamount), 0) localbeginbalancedr,
         nvl(sum(a.localcreditamount), 0) localbeginbalancecr,
         0,
         0,
         0,
         0,
         v_year || '-' || v_period,
         v_year,
         v_period,
         0,
         0,
         0,
         0,
         nvl(sum(decode(d.balanorient,0,a.debitamount - a.creditamount,
                                      1,a.creditamount - a.debitamount)),0) beginbalance,
         0,
         0,
         0,
         nvl(sum(decode(d.balanorient,0,a.localdebitamount - a.localcreditamount,
                                      1,a.localcreditamount - a.localdebitamount)),0) localbeginbalance,
         0,
         0,
         0,
         c.code,
         sum(a.debitamount),
         sum(a.localdebitamount),
         sum(a.creditamount),
         sum(a.localcreditamount) bulk collect
    into vt_cwxt_unfi
    from kods.nc65_gl_detail   a,
         kods.nc65_org_accountingbook    b,
         kods.nc65_bd_currtype c,
         kods.nc65_bd_accasoa e,
         kods.nc65_bd_account d
   where a.pk_accountingbook = b.pk_accountingbook
     and a.pk_currtype = c.pk_currtype
     and a.pk_accasoa = e.pk_accasoa
     and e.pk_account = d.pk_account
     and a.yearv = v_year
     and a.periodv < v_period
     and a.dr = 0 --Ƿע
     --and a.discardflagv = 'N' --ǷΪϵ־
     --and b.code != '02' --޳ڻݺͶ޹˾
   group by b.code, c.code,d.code;

  for i in 1 .. vt_cwxt_unfi.count loop
    update t_map_cwxt_km_unfi t
       set t.begin_balance_dr       = vt_cwxt_unfi(i).begin_balance_dr,
           t.begin_balance_cr       = vt_cwxt_unfi(i).begin_balance_cr,
           t.local_begin_balance_cr = vt_cwxt_unfi(i)
                                      .local_begin_balance_cr,
           t.local_begin_balance_dr = vt_cwxt_unfi(i)
                                      .local_begin_balance_dr,
           t.beginbalance           = vt_cwxt_unfi(i).beginbalance,
           t.local_beginbalance     = vt_cwxt_unfi(i).local_beginbalance
     where t.company = vt_cwxt_unfi(i).company
       and t.acctsubjcode = vt_cwxt_unfi(i).acctsubjcode
       and t.currency = vt_cwxt_unfi(i).currency;
  end loop;
  vt_cwxt_unfi.delete;
  --ԭң
  select b.code,
         d.code,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         v_year || '-' || v_period,
         v_year,
         v_period,
         nvl(sum(a.debitamount), 0) nc_balancedr,
         nvl(sum(a.creditamount), 0) nc_balancecr,
         nvl(sum(a.localdebitamount), 0) local_nc_balancedr,
         nvl(sum(a.localcreditamount), 0) local_nc_balancecr,
         0,
         0,
         nvl(sum(decode(d.balanorient,0,a.debitamount - a.creditamount,
                                      1,a.creditamount - a.debitamount)),0) ncbalance,
         0,
         0,
         0,
         nvl(sum(decode(d.balanorient,0,a.localdebitamount - a.localcreditamount,
                                      1,a.localcreditamount - a.localdebitamount)),0) localncbalance,
         0,
         c.code,
         sum(a.debitamount),
         sum(a.localdebitamount),
         sum(a.creditamount),
         sum(a.localcreditamount) bulk collect
    into vt_cwxt_unfi
    from kods.nc65_gl_detail   a,
         kods.nc65_org_accountingbook  b,
         kods.nc65_bd_currtype c,
         kods.nc65_bd_accasoa e,
         kods.nc65_bd_account  d
   where a.pk_accountingbook = b.pk_accountingbook
     and a.pk_currtype = c.pk_currtype
     and a.pk_accasoa = e.pk_accasoa
     and e.pk_account = d.pk_account
     and a.yearv = v_year
     and a.periodv = '00'
     and a.dr = 0 --Ƿע
     --and a.discardflagv = 'N' --ǷΪϵ־
     --and b.code != '02' --޳ڻݺͶ޹˾
   group by b.code, c.code,d.code;

  for i in 1 .. vt_cwxt_unfi.count loop
    update t_map_cwxt_km_unfi t
       set t.nc_balance_dr       = vt_cwxt_unfi(i).nc_balance_dr,
           t.nc_balance_cr       = vt_cwxt_unfi(i).nc_balance_cr,
           t.local_nc_balance_cr = vt_cwxt_unfi(i).local_nc_balance_cr,
           t.local_nc_balance_dr = vt_cwxt_unfi(i).local_nc_balance_dr,
           t.ncbalance           = vt_cwxt_unfi(i).ncbalance,
           t.local_ncbalance     = vt_cwxt_unfi(i).local_ncbalance
     where t.company = vt_cwxt_unfi(i).company
       and t.acctsubjcode = vt_cwxt_unfi(i).acctsubjcode
       and t.currency = vt_cwxt_unfi(i).currency;
  end loop;
  vt_cwxt_unfi.delete;
  commit;


 exception when others then
  v_str:=sqlerrm;
  rollback;
  return;
END;
/

prompt
prompt Creating procedure CISP_PROCESS_CWDATA_UNFI
prompt ===========================================
prompt
create or replace procedure cisp_process_cwdata_unfi
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:  Ѳϵͳݴ
  -- RETURN:
  -- AUTHOR:       rfvan
  -- CREATE DATE:  2009/9/2
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
(pi_reportid    varchar2,
 pi_etltable    varchar2,
 pi_fbcl        varchar2, --ֱҴ־0ֱַ𱣴棬ۺұ棬1ֱַ𱣴棬ͬʱҲۺ
 pi_companytype varchar2) --:0:Ӫҵ,1ܲ,2:ױĿ
 is
  type tb_cwcj_config is table of t_krcs_cwcj_config%rowtype;
  v_cwcj_config tb_cwcj_config := tb_cwcj_config();
  type tb_cw_hl is table of t_krcs_cw_hl%rowtype;
  v_cw_hl tb_cw_hl := tb_cw_hl();
  type tb_ctl_036 is table of krcs.t_ctl_t036%rowtype;
  v_ctl_036 tb_ctl_036 := tb_ctl_036();
  type tb_cwxt_km is table of t_map_cwxt_km_unfi.company%type;
  v_cwxt_km        tb_cwxt_km := tb_cwxt_km();
  i                int;
  j                int;
  k                int;
  v_je             number;
  v_hlje           number;
  v_result         number; --ĩ
  v_hlresult       number; --ۺĩ(RMB+HKD+USD)
  v_ncresult       number; --
  v_hlncresult     number; --ۺ(RMB+HKD+USD)
  v_periodresult   number; --
  v_hlperiodresult number; --ۺ(RMB+HKD+USD)
  v_beginresult    number; --ڳ
  v_hlbeginresult  number; --ۺڳ(RMB+HKD+USD)
  v_period_dr      number; --ڴ
  v_hlperiod_dr    number; --ۺڽ跽
  v_period_cr      number; --ڴ
  v_hlperiod_cr    number; --ۺڴ
  v_begin_dr       number; --ڳ
  v_begin_cr       number; --ڳ跽
  v_end_dr         number; --ĩ
  v_end_cr         number; --ĩ跽
  v_hlbegin_dr     number; --ۺڳ
  v_hlbegin_cr     number; --ۺڳ跽
  v_hlend_dr       number; --ۺĩ
  v_hlend_cr       number; --ۺĩ跽
  v_sql            varchar2(3000);
  cursor the_cur is
    select distinct proid, protype
      from t_krcs_cwcj_config
     where reportid = pi_reportid
       and protype <> 'N'
     order by proid, protype;
begin

  delete from t_etl_biz_data where reportid = pi_reportid;
  --رּ
  select * BULK COLLECT
    into v_cw_hl
    from t_krcs_cw_hl
   where from_currency in ('CNY', 'USD', 'HKD')
   order by from_currency;
  --ÿĿ
  for my_cur in the_cur loop
    select * BULK COLLECT
      into v_cwcj_config
      from t_krcs_cwcj_config t
     where t.reportid = pi_reportid
       and t.protype <> 'N'
       and t.proid = my_cur.proid
       and t.protype = my_cur.protype
     order by t.proid, t.formular;

    v_je             := 0;
    v_result         := 0;
    v_hlje           := 0;
    v_hlresult       := 0;
    v_hlncresult     := 0;
    v_hlperiodresult := 0;
    v_hlbeginresult  := 0;
    v_hlperiod_dr    := 0;
    v_hlperiod_cr    := 0;
    v_hlbegin_dr     := 0;
    v_hlbegin_cr     := 0;
    v_hlend_dr       := 0;
    v_hlend_cr       := 0;

    if (pi_companytype = '1') then
      --ܲ
      --ֱͳ
      for j in 1 .. v_cw_hl.count loop
        --ͳÿĿ
        v_result       := 0;
        v_beginresult  := 0;
        v_ncresult     := 0;
        v_periodresult := 0;
        v_period_cr    := 0;
        v_period_dr    := 0;
        v_begin_dr     := 0;
        v_begin_cr     := 0;
        v_end_dr       := 0;
        v_end_cr       := 0;

        for i in 1 .. v_cwcj_config.count loop
          if (v_cwcj_config(i).colname = 'ENDBALANCE') then--ĩ
            v_sql := 'select nvl(sum(t1.endbalance),0),nvl(sum(t1.local_endbalance),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''' ;
          elsif (v_cwcj_config(i).colname = 'NCBALANCE') then--
            v_sql := 'select nvl(sum(t1.ncbalance),0),nvl(sum(t1.local_ncbalance),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then--
            v_sql := 'select nvl(sum(t1.periodbalance),0),nvl(sum(t1.local_periodbalance),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then--ڳ
            v_sql := 'select nvl(sum(t1.beginbalance),0),nvl(sum(t1.local_beginbalance),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
            --ڽ跽
            v_sql := 'select nvl(sum(t1.period_net_dr),0),nvl(sum(t1.local_period_net_dr),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
            --ڴ
            v_sql := 'select nvl(sum(t1.period_net_cr),0),nvl(sum(t1.local_period_net_cr),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
            --ڳ跽
            v_sql := 'select nvl(sum(t1.begin_balance_dr),0),nvl(sum(t1.local_begin_balance_dr),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
            --ڳ
            v_sql := 'select nvl(sum(t1.begin_balance_cr),0),nvl(sum(t1.local_begin_balance_cr),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
            v_sql := 'select nvl(sum(t1.enddrbalance),0),nvl(sum(t1.local_enddrbalance),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
            v_sql := 'select nvl(sum(t1.endcrbalance),0),nvl(sum(t1.local_endcrbalance),0)
                       from t_map_cwxt_km_unfi t1
                       where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
          end if;

          if (v_cwcj_config(i).orgid <> 'N') then
              v_sql := v_sql ||
                       ' and t1.company  in (select a023  from krcs.t_ctl_t036 s where s.a002 is not null and s.a002 <> '||'719077033'||')';
            end if;

          v_sql := v_sql || ' and t1.currency=''' || v_cw_hl(j)
                  .from_currency || '''';
          execute immediate v_sql
            into v_je, v_hlje;
          if (v_cwcj_config(i).formular = '+') then
            if (v_cwcj_config(i).colname = 'ENDBALANCE') then
              v_result   := v_result + v_je;
              v_hlresult := v_hlresult + v_hlje;
            elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
              v_ncresult   := v_ncresult + v_je;
              v_hlncresult := v_hlncresult + v_hlje;
            elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
              v_periodresult   := v_periodresult + v_je;
              v_hlperiodresult := v_hlperiodresult + v_hlje;
            elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
              v_beginresult   := v_beginresult + v_je;
              v_hlbeginresult := v_hlbeginresult + v_hlje;
            elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
              v_period_dr   := v_period_dr + v_je;
              v_hlperiod_dr := v_hlperiod_dr + v_hlje;
            elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
              v_period_cr   := v_period_cr + v_je;
              v_hlperiod_cr := v_hlperiod_cr + v_hlje;
            elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
              v_begin_dr   := v_begin_dr + v_je;
              v_hlbegin_dr := v_hlbegin_dr + v_hlje;
            elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
              v_begin_cr   := v_begin_cr + v_je;
              v_hlbegin_cr := v_hlbegin_cr + v_hlje;
            elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
              v_end_dr   := v_end_dr + v_je;
              v_hlend_dr := v_hlend_dr + v_hlje;
            elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
              v_end_cr   := v_end_cr + v_je;
              v_hlend_cr := v_hlend_cr + v_hlje;
            end if;
          elsif (v_cwcj_config(i).formular = '-') then
            if (v_cwcj_config(i).colname = 'ENDBALANCE') then
              v_result   := v_result - v_je;
              v_hlresult := v_hlresult - v_hlje;
            elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
              v_ncresult   := v_ncresult - v_je;
              v_hlncresult := v_hlncresult - v_hlje;
            elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
              v_periodresult   := v_periodresult - v_je;
              v_hlperiodresult := v_hlperiodresult - v_hlje;
            elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
              v_beginresult   := v_beginresult - v_je;
              v_hlbeginresult := v_hlbeginresult - v_hlje;
            elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
              v_period_dr   := v_period_dr - v_je;
              v_hlperiod_dr := v_hlperiod_dr - v_hlje;
            elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
              v_period_cr   := v_period_cr - v_je;
              v_hlperiod_cr := v_hlperiod_cr - v_hlje;
            elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
              v_begin_dr   := v_begin_dr - v_je;
              v_hlbegin_dr := v_hlbegin_dr - v_hlje;
            elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
              v_begin_cr   := v_begin_cr - v_je;
              v_hlbegin_cr := v_hlbegin_cr - v_hlje;
            elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
              v_end_dr   := v_end_dr - v_je;
              v_hlend_dr := v_hlend_dr - v_hlje;
            elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
              v_end_cr   := v_end_cr - v_je;
              v_hlend_cr := v_hlend_cr - v_hlje;
            end if;
          end if;
        end loop;
        if (pi_fbcl = '1') then
          v_sql := 'insert into t_etl_biz_data (reportid,proid,protype,currency,endbalance,beginbalance,ncbalance,periodbalance,
                                perioddrbalance,periodcrbalance,begindrbalance,begincrbalance,enddrbalance,endcrbalance)' ||
                   ' select ''' || pi_reportid || ''',' || my_cur.proid ||
                   ',''' || my_cur.protype || ''',decode(''' || v_cw_hl(j)
                  .from_currency ||
                   ''',''CNY'',''0'',''HKD'',''1'',''USD'',''2''),' ||
                   v_result || ',' || v_beginresult || ',' || v_ncresult || ',' ||
                   v_periodresult || ',' || v_period_dr || ',' ||
                   v_period_cr || ',' || v_begin_dr || ',' || v_begin_cr || ',' ||
                   v_end_dr || ',' || v_end_cr || ' from dual';
          execute immediate v_sql;
        end if;
      end loop;
       commit;
      --ۺҽ
      v_sql := ' insert into t_etl_biz_data (reportid,proid,protype,currency,endbalance,beginbalance,ncbalance,periodbalance,
                                perioddrbalance,periodcrbalance,begindrbalance,begincrbalance,enddrbalance,endcrbalance)' ||
               ' select ''' || pi_reportid || ''',' || my_cur.proid ||
               ',''' || my_cur.protype || ''',''3'',' || v_hlresult || ',' ||
               v_hlbeginresult || ',' || v_hlncresult || ',' ||
               v_hlperiodresult || ',' || v_hlperiod_dr || ',' ||
               v_hlperiod_cr || ',' || v_hlbegin_dr || ',' || v_hlbegin_cr || ',' ||
               v_hlend_dr || ',' || v_hlend_cr || ' from dual';
      execute immediate v_sql;
       commit;
    elsif (pi_companytype = '0') then
      --Ӫҵ
      select distinct * BULK COLLECT
        into v_ctl_036
        from krcs.T_CTL_T036
       where a023 is not null;
      --Ӫҵͳ
      for k in 1 .. v_ctl_036.count loop
        v_hlresult       := 0;
        v_hlncresult     := 0;
        v_hlperiodresult := 0;
        v_hlperiod_dr    := 0;
        v_hlperiod_cr    := 0;
        v_hlbegin_dr     := 0;
        v_hlbegin_cr     := 0;
        v_hlend_dr       := 0;
        v_hlend_cr       := 0;
        for j in 1 .. v_cw_hl.count loop
          --ͳÿĿ
          v_result       := 0;
          v_beginresult  := 0;
          v_ncresult     := 0;
          v_periodresult := 0;
          v_period_cr    := 0;
          v_period_dr    := 0;

          v_begin_dr := 0;
          v_begin_cr := 0;
          v_end_dr   := 0;
          v_end_cr   := 0;

          for i in 1 .. v_cwcj_config.count loop
            if (v_cwcj_config(i).colname = 'ENDBALANCE') then
              v_sql := 'select nvl(sum(t1.endbalance),0),nvl(sum(t1.local_endbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
              v_sql := 'select nvl(sum(t1.ncbalance),0),nvl(sum(t1.local_ncbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
              v_sql := 'select nvl(sum(t1.periodbalance),0),nvl(sum(t1.local_periodbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
              v_sql := 'select nvl(sum(t1.beginbalance),0),nvl(sum(t1.local_beginbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
              v_sql := 'select nvl(sum(t1.period_net_dr),0),nvl(sum(t1.local_period_net_dr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
              v_sql := 'select nvl(sum(t1.period_net_cr),0),nvl(sum(t1.local_period_net_cr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
              v_sql := 'select nvl(sum(t1.begin_balance_dr),0),nvl(sum(t1.local_begin_balance_dr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
              v_sql := 'select nvl(sum(t1.begin_balance_cr),0),nvl(sum(t1.local_begin_balance_cr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
              v_sql := 'select nvl(sum(t1.enddrbalance),0),nvl(sum(t1.local_enddrbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
              v_sql := 'select nvl(sum(t1.endcrbalance),0),nvl(sum(t1.local_endcrbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';

            end if;
            --Ӫҵ
            v_sql := v_sql || ' and t1.company=''' || v_ctl_036(k)
                    .a023 || '''';

            v_sql := v_sql || ' and t1.currency=''' || v_cw_hl(j)
                    .from_currency || '''';
            execute immediate v_sql
              into v_je, v_hlje;
            if (v_cwcj_config(i).formular = '+') then
              if (v_cwcj_config(i).colname = 'ENDBALANCE') then
                v_result   := v_result + v_je;
                v_hlresult := v_hlresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
                v_ncresult   := v_ncresult + v_je;
                v_hlncresult := v_hlncresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
                v_periodresult   := v_periodresult + v_je;
                v_hlperiodresult := v_hlperiodresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
                v_beginresult   := v_beginresult + v_je;
                v_hlbeginresult := v_hlbeginresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
                v_period_dr   := v_period_dr + v_je;
                v_hlperiod_dr := v_hlperiod_dr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
                v_period_cr   := v_period_cr + v_je;
                v_hlperiod_cr := v_hlperiod_cr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
                v_begin_dr   := v_begin_dr + v_je;
                v_hlbegin_dr := v_hlbegin_dr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
                v_begin_cr   := v_begin_cr + v_je;
                v_hlbegin_cr := v_hlbegin_cr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
                v_end_dr   := v_end_dr + v_je;
                v_hlend_dr := v_hlend_dr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
                v_end_cr   := v_end_cr + v_je;
                v_hlend_cr := v_hlend_cr + v_hlje;
              end if;
            elsif (v_cwcj_config(i).formular = '-') then
              if (v_cwcj_config(i).colname = 'ENDBALANCE') then
                v_result   := v_result - v_je;
                v_hlresult := v_hlresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
                v_ncresult   := v_ncresult - v_je;
                v_hlncresult := v_hlncresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
                v_periodresult   := v_periodresult - v_je;
                v_hlperiodresult := v_hlperiodresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
                v_beginresult   := v_beginresult - v_je;
                v_hlbeginresult := v_hlbeginresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
                v_period_dr   := v_period_dr - v_je;
                v_hlperiod_dr := v_hlperiod_dr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
                v_period_cr   := v_period_cr - v_je;
                v_hlperiod_cr := v_hlperiod_cr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
                v_begin_dr   := v_begin_dr - v_je;
                v_hlbegin_dr := v_hlbegin_dr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
                v_begin_cr   := v_begin_cr - v_je;
                v_hlbegin_cr := v_hlbegin_cr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
                v_end_dr   := v_end_dr - v_je;
                v_hlend_dr := v_hlend_dr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
                v_end_cr   := v_end_cr - v_je;
                v_hlend_cr := v_hlend_cr - v_hlje;
              end if;
            end if;
          end loop;
          if (pi_fbcl = '1') then
            v_sql := 'insert into t_etl_biz_data (reportid,proid,protype,currency,endbalance,beginbalance,ncbalance,periodbalance,
                                perioddrbalance,periodcrbalance,company,begindrbalance,begincrbalance,enddrbalance,endcrbalance)' ||
                     ' select ''' || pi_reportid || ''',' || my_cur.proid ||
                     ',''' || my_cur.protype || ''',decode(''' ||
                     v_cw_hl(j)
                    .from_currency ||
                     ''',''CNY'',''0'',''HKD'',''1'',''USD'',''2''),' ||
                     v_result || ',' || v_beginresult || ',' || v_ncresult || ',' ||
                     v_periodresult || ',' || v_period_dr || ',' ||
                     v_period_cr || ',''' || v_ctl_036(k)
                    .a023 || ''',' || v_begin_dr || ',' || v_begin_cr || ',' ||
                     v_end_dr || ',' || v_end_cr || ' from dual';
            execute immediate v_sql;

          end if;
          commit;
        end loop;
        --ۺҽ
        v_sql := ' insert into t_etl_biz_data (reportid,proid,protype,currency,endbalance,beginbalance,ncbalance,periodbalance,
                         perioddrbalance,periodcrbalance,company,begindrbalance,begincrbalance,enddrbalance,endcrbalance)' ||
                 ' select ''' || pi_reportid || ''',' || my_cur.proid ||
                 ',''' || my_cur.protype || ''',''3'',' || v_hlresult || ',' ||
                 v_hlbeginresult || ',' || v_hlncresult || ',' ||
                 v_hlperiodresult || ',' || v_hlperiod_dr || ',' ||
                 v_hlperiod_cr || ',''' || v_ctl_036(k)
                .a023 || ''',' || v_hlbegin_dr || ',' || v_hlbegin_cr || ',' ||
                 v_hlend_dr || ',' || v_hlend_cr || ' from dual';
        execute immediate v_sql;

      end loop;
       commit;
    elsif (pi_companytype = '2') then
      --ױĿϢ
      select distinct company BULK COLLECT
        into v_cwxt_km
        from t_map_cwxt_km_unfi
       where company is not null;
      --Ӫҵͳ
      for k in 1 .. v_cwxt_km.count loop
        v_hlresult       := 0;
        v_hlncresult     := 0;
        v_hlperiodresult := 0;
        v_hlperiod_dr    := 0;
        v_hlperiod_cr    := 0;
        v_hlbegin_dr     := 0;
        v_hlbegin_cr     := 0;
        v_hlend_dr       := 0;
        v_hlend_cr       := 0;
        for j in 1 .. v_cw_hl.count loop
          --ͳÿĿ
          v_result       := 0;
          v_beginresult  := 0;
          v_ncresult     := 0;
          v_periodresult := 0;
          v_period_cr    := 0;
          v_period_dr    := 0;

          v_begin_dr := 0;
          v_begin_cr := 0;
          v_end_dr   := 0;
          v_end_cr   := 0;

          for i in 1 .. v_cwcj_config.count loop
            if (v_cwcj_config(i).colname = 'ENDBALANCE') then
              v_sql := 'select nvl(sum(t1.endbalance),0),nvl(sum(t1.local_endbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
              v_sql := 'select nvl(sum(t1.ncbalance),0),nvl(sum(t1.local_ncbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
              v_sql := 'select nvl(sum(t1.periodbalance),0),nvl(sum(t1.local_periodbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
              v_sql := 'select nvl(sum(t1.beginbalance),0),nvl(sum(t1.local_beginbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
              v_sql := 'select nvl(sum(t1.period_net_dr),0),nvl(sum(t1.local_period_net_dr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
              v_sql := 'select nvl(sum(t1.period_net_cr),0),nvl(sum(t1.local_period_net_cr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
              v_sql := 'select nvl(sum(t1.begin_balance_dr),0),nvl(sum(t1.local_begin_balance_dr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
              v_sql := 'select nvl(sum(t1.begin_balance_cr),0),nvl(sum(t1.local_begin_balance_cr),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
              v_sql := 'select nvl(sum(t1.enddrbalance),0),nvl(sum(t1.local_enddrbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';
            elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
              v_sql := 'select nvl(sum(t1.endcrbalance),0),nvl(sum(t1.local_endcrbalance),0)
                           from t_map_cwxt_km_unfi t1
                           where t1.acctsubjcode like ''' ||
                     v_cwcj_config(i)
                    .subjcode || '%''';

            end if;
            --״
            v_sql := v_sql || ' and t1.company=''' || v_cwxt_km(k) || '''';

            v_sql := v_sql || ' and t1.currency=''' || v_cw_hl(j)
                    .from_currency || '''';
            execute immediate v_sql
              into v_je, v_hlje;
            if (v_cwcj_config(i).formular = '+') then
              if (v_cwcj_config(i).colname = 'ENDBALANCE') then
                v_result   := v_result + v_je;
                v_hlresult := v_hlresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
                v_ncresult   := v_ncresult + v_je;
                v_hlncresult := v_hlncresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
                v_periodresult   := v_periodresult + v_je;
                v_hlperiodresult := v_hlperiodresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
                v_beginresult   := v_beginresult + v_je;
                v_hlbeginresult := v_hlbeginresult + v_hlje;
              elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
                v_period_dr   := v_period_dr + v_je;
                v_hlperiod_dr := v_hlperiod_dr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
                v_period_cr   := v_period_cr + v_je;
                v_hlperiod_cr := v_hlperiod_cr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
                v_begin_dr   := v_begin_dr + v_je;
                v_hlbegin_dr := v_hlbegin_dr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
                v_begin_cr   := v_begin_cr + v_je;
                v_hlbegin_cr := v_hlbegin_cr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
                v_end_dr   := v_end_dr + v_je;
                v_hlend_dr := v_hlend_dr + v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
                v_end_cr   := v_end_cr + v_je;
                v_hlend_cr := v_hlend_cr + v_hlje;
              end if;
            elsif (v_cwcj_config(i).formular = '-') then
              if (v_cwcj_config(i).colname = 'ENDBALANCE') then
                v_result   := v_result - v_je;
                v_hlresult := v_hlresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'NCBALANCE') then
                v_ncresult   := v_ncresult - v_je;
                v_hlncresult := v_hlncresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'PERIODBALANCE') then
                v_periodresult   := v_periodresult - v_je;
                v_hlperiodresult := v_hlperiodresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINBALANCE') then
                v_beginresult   := v_beginresult - v_je;
                v_hlbeginresult := v_hlbeginresult - v_hlje;
              elsif (v_cwcj_config(i).colname = 'DRBALANCE') then
                v_period_dr   := v_period_dr - v_je;
                v_hlperiod_dr := v_hlperiod_dr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'CRBALANCE') then
                v_period_cr   := v_period_cr - v_je;
                v_hlperiod_cr := v_hlperiod_cr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINDRBALANCE') then
                v_begin_dr   := v_begin_dr - v_je;
                v_hlbegin_dr := v_hlbegin_dr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'BEGINCRBALANCE') then
                v_begin_cr   := v_begin_cr - v_je;
                v_hlbegin_cr := v_hlbegin_cr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDDRBALANCE') then
                v_end_dr   := v_end_dr - v_je;
                v_hlend_dr := v_hlend_dr - v_hlje;
              elsif (v_cwcj_config(i).colname = 'ENDCRBALANCE') then
                v_end_cr   := v_end_cr - v_je;
                v_hlend_cr := v_hlend_cr - v_hlje;
              end if;
            end if;
          end loop;
          if (pi_fbcl = '1') then
            v_sql := 'insert into t_etl_biz_data (reportid,proid,protype,currency,endbalance,beginbalance,ncbalance,periodbalance,
                                perioddrbalance,periodcrbalance,company,begindrbalance,begincrbalance,enddrbalance,endcrbalance)' ||
                     ' select ''' || pi_reportid || ''',' || my_cur.proid ||
                     ',''' || my_cur.protype || ''',decode(''' ||
                     v_cw_hl(j)
                    .from_currency ||
                     ''',''CNY'',''0'',''HKD'',''1'',''USD'',''2''),' ||
                     v_result || ',' || v_beginresult || ',' || v_ncresult || ',' ||
                     v_periodresult || ',' || v_period_dr || ',' ||
                     v_period_cr || ',''' || v_cwxt_km(k) || ''',' ||
                     v_begin_dr || ',' || v_begin_cr || ',' || v_end_dr || ',' ||
                     v_end_cr || ' from dual';
            execute immediate v_sql;
          end if;
        end loop;
         commit;
        --ۺҽ
        v_sql := ' insert into t_etl_biz_data (reportid,proid,protype,currency,endbalance,beginbalance,ncbalance,periodbalance,
                         perioddrbalance,periodcrbalance,company,begindrbalance,begincrbalance,enddrbalance,endcrbalance)' ||
                 ' select ''' || pi_reportid || ''',' || my_cur.proid ||
                 ',''' || my_cur.protype || ''',''3'',' || v_hlresult || ',' ||
                 v_hlbeginresult || ',' || v_hlncresult || ',' ||
                 v_hlperiodresult || ',' || v_hlperiod_dr || ',' ||
                 v_hlperiod_cr || ',''' || v_cwxt_km(k) || ''',' ||
                 v_hlbegin_dr || ',' || v_hlbegin_cr || ',' || v_hlend_dr || ',' ||
                 v_hlend_cr || ' from dual';
        execute immediate v_sql;
      end loop;

    end if;
  end loop;

  commit;
exception
  when others then
    rollback;
    return;
end;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_1
prompt ========================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_1 is
  v_begintime_date varchar(16);
  v_begintime_date int;
  /********************************************************************
  *ܣɴԴݵETLݱݻܹ̣
   *
  *********************************************************************/
  v_begindate varchar2(8);
  v_enddate   varchar2(8);

begin
  --ȡڵڼʱ
      select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

-----------------------------------------------------------------------------------------------
  delete from t_etl_khjyjszj;
  commit;
  ------------------------------------------------------------------------------------------------------------------------------------------
  --ͻ׽ʽ
  --ܣͳC1-1 --ͻڴ,ȡ,ĩ
   insert into t_etl_khjyjszj
    (khlx, jylx, bz, je)
     select 0 khlx, 1 jylx, bz, sum(je) as je
      from (
            select decode(a.money_type, 0, 0, 2, 1, 1, 2) as bz,
                   abs(a.occur_balance) as je --
              from KODS.V_A_HS08_HIS_OPERATIONTOTAL a
             where a.business_flag in (2001,2003,2005,2020,2041,2064,2089,2405) --
            ) t1
     group by  t1.bz
    union
    --ȡ

  select 0 khlx, 2 jylx, bz, sum(je) as je
      from (
            select decode(a.money_type, 0, 0, 2, 1, 1, 2) as bz,
                   abs(a.occur_balance) as je --
              from KODS.V_A_HS08_HIS_OPERATIONTOTAL a
             where a.business_flag in (2002,2004,2006,2021,2022,2040,2042,2063,2090,2404)  --ȡ
            ) t1
     group by  t1.bz;

    commit;

    -- ĩ
    ------------------------

    ------------------------
  cisp_process_cwdata_unfi('C1-1','t_etl_khjyjszj','1','1');
    COMMIT;
 insert into t_etl_khjyjszj
    (khlx, jylx, bz, je)
   select 1 as khlx , 3 jylx,
         decode(s.money_type, 0, 0, 2, 1, 1, 2) as bz,
         sum(s.current_balance)
      from KODS.V_RZRQ_HS_FUND_FUND s, kods.rzrq_hs_client a,kods.rzrq_hs_fund_fundaccount b
     where s.client_id=b.client_id
       and s.fund_account=b.fund_account
       and a.organ_flag in ('1','3')
       and a.client_id = s.client_id
       and a.client_status != '3'
     group by decode(s.money_type, 0, 0, 2, 1, 1, 2);
       commit;    
  insert into t_etl_khjyjszj   --ȡĿ
    (khlx, jylx, bz, je)
select 0,3,0, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency=0)
 -(select je from t_etl_khjyjszj where bz=0 and jylx=3 and khlx=1) from dual
 union all
select 0,3,1, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency='1')
 -(select je from t_etl_khjyjszj where bz=1 and jylx=3 and khlx=1) from dual
 union all
select 0,3,2, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency='2')
 -(select je from t_etl_khjyjszj where bz=2 and jylx=3 and khlx=1) from dual ;
commit;
   ------------------------------------------------------------------------------------------------------------------------------------------
  --ʽʻ
  --ܣͳC1-1ʽ˻
  ------------------------------------------------------------------------------------------------------------------------------------------
  delete from t_etl_zjzh;
  --ʽʻ
  --   ʲ˻ˮѡ1001ʽ˻
insert into t_etl_zjzh
  (khlx, jylx, bz, sl)
  select 0 khlx, 1 jylx, 0 as bz, count(a.fund_account) as sl
    from kods.rzrq_hs_his_fundaccountjour a
   where a.init_date between v_begindate and v_enddate
     and a.business_flag = '1001'
     and a.fundacct_status <> '3'
     and a.asset_prop = '0';

insert into t_etl_zjzh
  (khlx, jylx, bz, sl)
  select 0 khlx, 1 jylx, bz, sl
    from (select decode(s.exchange_type, 'H', 1, 'D', 2) as bz,
                 count(s.stock_account) sl
            from kods.a_hs08_his_stockholderjour s
           where s.init_date between v_begindate and v_enddate
             and s.asset_prop in ('0')
             and s.business_flag = '1104'
             and s.exchange_type in ('H', 'D')
           group by decode(s.exchange_type, 'H', 1, 'D', 2));
--Ͽ
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,12 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a --,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.init_date between v_begindate  and  v_enddate
             and a.fundacct_status<>'3'
             and a.asset_prop = '0'
             and a.business_flag = '1001'
             and a.open_type = '2';
            --group by   decode(b.money_type, '0', 0, '2', 1, '1', 2);
            commit;

--֤
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,13 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a --,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.init_date between v_begindate  and  v_enddate
             and a.fundacct_status<>'3'
             and a.asset_prop = '0'
             and a.open_type = '1'; 
            commit;      
--
insert into t_etl_zjzh
  (khlx, jylx, bz, sl)
  select 0 khlx, 2 jylx, 0 as bz, count(a.fund_account) as sl
    from kods.rzrq_hs_his_fundaccountjour a
   where a.init_date between v_begindate and v_enddate
     and a.business_flag = '1002'
     and a.asset_prop = '0';
commit;

insert into t_etl_zjzh
  (khlx, jylx, bz, sl)
  select 0 khlx, 2 jylx, bz, sl
    from (select decode(s.exchange_type, 'H', 1, 'D', 2) as bz,
                 count(s.stock_account) sl
            from kods.a_hs08_his_stockholderjour s
           where s.init_date between v_begindate and v_enddate
             and s.asset_prop in ('0')
             and s.business_flag = '1102'
             and s.exchange_type in ('H', 'D')
           group by decode(s.exchange_type, 'H', 1, 'D', 2));
commit;
 --ת˻
 

--ĩ
insert into t_etl_zjzh
  (khlx, jylx, bz, sl)
  select decode(c.organ_flag, '1', 1, '3', 1, 0) as khlx,
         3 jylx, /*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/
         0 as bz,
         count(distinct a.client_id) as sl
    from kods.rzrq_hs_fund_fundaccount a,
         kods.rzrq_hs_fund_fund        b,
         kods.rzrq_hs_client           c
   where a.client_id = c.client_id
     and a.client_id = b.client_id
     and a.fundacct_status = '0'
     and c.organ_flag in ('1', '0', '3')
     and a.main_flag = '1'
     and b.money_type = 0
     and a.open_date <= v_enddate
     and a.asset_prop = '0'
   group by decode(c.organ_flag, '1', 1, '3', 1, 0);
commit;
insert into t_etl_zjzh (khlx, jylx, bz, sl)
select decode(b.organ_flag,'1',1,'3',1,0) as khlx,3 jylx, decode(s.exchange_type,'D',2,'H',1) bz,
            count( s.stock_account) sl
            from kods.rzrq_hs_stockholder s,kods.rzrq_hs_client b
            where s.client_id = b.client_id
            and s.asset_prop in ('0')
            and s.holder_status='0'
            and b.organ_flag in ('1','0','3')
            and s.exchange_type in ('D','H')
            group by decode(b.organ_flag,'1',1,'3',1,0),decode(s.exchange_type,'D',2,'H',1);
   commit;   
   

--Сת
/*insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select 0 as khlx,4 jylx,0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a --,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.init_date between v_begindate and v_enddate
             and a.business_flag = '1012'
             and a.asset_prop = '0';
    commit;*/

--ϸת
--ϸת
/*insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select decode(c.organ_flag,'1',1,0) as khlx,5 jylx,decode(b.money_type, '0', 0, '2', 1, '1', 2) as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.client_id=b.client_id
             and a.fund_account=b.fund_account
             and a.client_id=c.client_id and a.branch_no=c.branch_no
             and a.fundacct_status<>'3'
             and c.organ_flag in ('1','0')
             and a.asset_prop = '0'
            group by   decode(c.organ_flag,'1',1,0),decode(b.money_type, '0', 0, '2', 1, '1', 2);
            commit;*/

  ----------------------------------------------------------------------------------------------------------------------------------------
  --֤ȯʻ
  ------------------------------------------------------------------------------------------------------------------------------------------
  delete from t_etl_zqzh;
    -- ĩ
 insert into t_etl_zqzh
   (khlx, jylx, sc, bz, sl)
   select decode(b.organ_flag, '1', 1, '3', 1, 0) as khlx,
          7 jylx,
          decode(s.exchange_type, '1', 1, 'D', 1, '2', 0, 'H', 0) sc,
          decode(s.exchange_type, '1', 0, 'D', 2, '2', 0, 'H', 1) bz,
          count(s.stock_account) sl
     from kods.rzrq_hs_stockholder s, kods.rzrq_hs_client b
    where s.client_id = b.client_id
      and s.asset_prop in ('0')
      and s.holder_status = '0'
      and s.open_date <= v_enddate
      and b.organ_flag in ('1', '0', '3')
      and s.exchange_type in ('1', '2', 'D', 'H')
    group by decode(b.organ_flag, '1', 1, '3', 1, 0),
             decode(s.exchange_type, '1', 0, 'D', 2, '2', 0, 'H', 1),
             decode(s.exchange_type, '1', 1, 'D', 1, '2', 0, 'H', 0);
     commit;
--0----0----0----0----0----0----0----0----0----0----0----0----0----0--
  delete from t_etl_dlkxh;
  insert into t_etl_dlkxh--ת
     select 3, decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2) as bz,count( s.stock_account)
         from kods.a_hs08_his_stockholderjour s
      where s.business_flag in (1101)
        and s.asset_prop in ('0')
        and s.exchange_type in ('1','2','H','D')
        and s.init_date between v_begindate and v_enddate
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2);
        commit;
   insert into t_etl_dlkxh--ת
        select 4 ,decode(s.money_type, '0', 0, '2', 1, '1', 2) as bz,count(distinct s.stock_account)
        from kods.rzrq_hs_his_hisdeliver s
      where s.business_flag in (4008)
        and s.asset_prop in ('0')
        and s.exchange_type in ('1','2')
        and s.init_date between v_begindate and v_enddate
        group by decode(s.money_type, '0', 0, '2', 1, '1', 2) ;
        commit;
      --ڴ  
 insert into t_etl_dlkxh
   select 5, bz, sum(sl)
     from (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2) as bz,
                  count(s.stock_account) sl
             from kods.a_hs08_his_stockholderjour s
            where s.init_date between v_begindate and v_enddate
              and s.asset_prop in ('0')
              and s.business_flag in ('1104','1101')
              and s.exchange_type in ('1', '2', 'H', 'D')
            group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2))
    group by bz;
--Ͽ
 insert into t_etl_dlkxh
   select 11,bz, sum(sl) from
      (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,
      count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag in ('1104','1101')
      and s.op_entrust_way = '7'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
       )
    group by bz;

--֤
 insert into t_etl_dlkxh
  select 12,bz, sum(sl) from
      (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,
      count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag in ('1104','1101')
      and s.op_entrust_way ='O'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
       )
    group by bz;
 commit;
 --
 insert into t_etl_dlkxh
 select 20 ,bz,sum(sl) from 
 (
   select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 )
 group by bz;
 commit;
 
  --֤
 insert into t_etl_dlkxh
 select 22,bz, sl
        from (
   select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
      and s.open_type='1'
      and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 );
  commit;
  --
 insert into t_etl_dlkxh
 select 21, bz, sl
 from (
    select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
      --and s.open_type='2'
      and s.op_entrust_way = '7' -- modify by  zhenyj  20190418
      and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 );
 commit;
-----------------------------------------------------------------------------------
  --    ʽ˻
-----------------------------------------------------------------------------------
 delete from t_etl_fzcjy_zjzh;
  commit;
 insert into t_etl_fzcjy_zjzh
     select 1,3 ,count(distinct a.fund_account)
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
        where c.client_id = a.client_id
          and a.fund_account = b.fund_account
          and b.money_type in (0)
          and c.risk_info like '%2%';
commit;
 insert into t_etl_fzcjy_zjzh
 select 2,3, count(distinct s.fund_account)  from
  kods.rzrq_hs_fund_fundaccount s, kods.a_hs08_clientinfo c
   where --s.client_group='902'
   s.client_id=c.client_id
   and exists (select 1
              from kods.rzrq_hs_stockholder d,kods.rzrq_hs_nonstdholder e
              where d.stock_account = e.stock_account
              and d.fund_account = s.fund_account
              and d.client_id = s.client_id);

  commit;

   insert into t_etl_fzcjy_zjzh
 select 3,3,sum(sl) from(
select 3,3 ,count(distinct a.fund_account) as sl
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
        where c.client_id = a.client_id
          and a.fund_account = b.fund_account
          and b.money_type in (0)
          and c.risk_info like '%6%'
  union all        
select 3,3, count(distinct s.fund_account) as sl  from
  kods.rzrq_hs_fund_fundaccount s, kods.a_hs08_clientinfo c
   where s.fundacct_status='1'
       and s.client_id=c.client_id ) ;
   commit;

---------------------------------------------------------------------------------------------------
  -- -  ֤ȯ˻
---------------------------------------------------------------------------------------------------
delete from t_etl_fzcjy_zqzh;
commit;
  insert into t_etl_fzcjy_zqzh
 select 1 zhlx ,3 jylx ,sum(sl) from
    (select count(distinct a.stock_account) sl
            from kods.rzrq_hs_stockholder a where a.holder_status = 'C' 
            and a.asset_prop = '0'
            and a.exchange_type in ('1','2')
       );
/*
  insert into t_etl_fzcjy_zqzh
  --ɶ(HOLDER_ACC) ˻ 1-˻ 2-ϸ˻ 3-˻ 4-˻
  -- еȡ
  select 2 zhlx ,3 jylx ,count(zqzh) from  a_bhg_djhb;
   commit;
*/
  insert into t_etl_fzcjy_zqzh
 select 3 zhlx ,3 jylx ,sum(sl) from
    (select count(distinct a.stock_account) sl
            from kods.rzrq_hs_stockholder a where a.holder_status = '1' 
            and a.asset_prop = '0'
            and a.exchange_type in ('1','2')
       );

 insert into t_etl_fzcjy_zqzh
  select 2,3,sum(sl) from
  (select count(a.stock_account) sl
        from kods.rzrq_hs_nonstdholder a);
  commit;
  /*-------------------------------------------------------------------------------------------------------------------------
  --ִݻܵݱ
  ------------------------------------------------------------------------------------------------------------------------*/
--ִ˳  etl_zjzhҪõֳ׵DB
  cisp_etl_fzcjy_zjzh;
   commit;
  cisp_etl_zjzh;
  commit;
  cisp_etl_khjyjszjzl;
   commit;
  cisp_etl_zqzh;
   commit;
  cisp_etl_fzcjy_zqzh;
  commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_RZRQ_ZB
prompt ===================================
prompt
create or replace procedure cisp_map_rzrq_zb
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:        hucc
  -- CREATE DATE:   20120619
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate    number; --ʼ
  v_bbq_enddate      number; --ֹ
  v_bmid             varchar(80); --ID
  v_date             number;
  v_bbq_lastendmonth number; --һֹ
  /*20120618 by hucc in ֤ȯ*/
begin

  --ɾȯETL
  delete from T_ETL_RZRQ_C10; -- a -- where a.xm not in('37','38','36','39'/*,'40','41','44'*/); --ȯC10-1
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select max(s.phydate)
    into v_bbq_lastendmonth
    from krcs.t_krcs_trdcalendar s
   where s.businessflag = 1
     and s.phydate <=
         to_number(to_char(add_months(to_date(v_bbq_enddate, 'yyyymmdd'),
                                      -1),
                           'yyyymmdd'));

  v_bmid := '50008'; --ýײID

  select max(p001)
    into v_date
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001102;
  --C10-1ܲȯ
  /*************   ˻    ***********/
  cisp_process_cwdata_unfi('C10-1', 't_etl_rzrq_c10', '1', '1');
  commit;

  --1 ˾չȯҵ֤ȯӪҵ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 1 as id, count(distinct a.branch_no) s1
      from kods.rzrq_hs_his_hisassetdebit a
     where a.branch_no not in ('7777'); /*,krcs.t_ctl_t036 b*/
  --where a.branch_no=b.p001
  --and b.a008='1023008';

  --2 ڳʽ˻  ʼ

  --3 ʽ˻
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 3 as id, count(*)
      from kods.rzrq_hs_fund_fundaccount
     where asset_prop = '7'
          --and business_flag in (1001, 1020)
       and branch_no not in ('7777')
       and open_date between v_bbq_begindate and v_bbq_enddate;
  --4 ڼʽ˻ 
  insert into T_ETL_RZRQ_C10
    (XM, JE)
    select 4, nvl(count(*), 0)
      from kods.rzrq_hs_fund_fundaccount t
     where t.fundacct_status = '3' --˻
       and t.asset_prop = '7' --˻
       and t.cancel_date between v_bbq_begindate and v_bbq_enddate
       and t.branch_no not in ('7777');

  --5 ĩʽ˻
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 5, count(distinct a.fund_account)
      from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_client b
     where a.client_id = b.client_id
       and a.fundacct_status <> '3' --Ϊ˻
       and a.asset_prop = '7' --˻
       and b.organ_flag in ('0', '1', '3') --0Ϊ 1Ϊ;
       and a.branch_no not in ('7777')
       and a.open_date <= v_bbq_enddate;

  --6 Уͻ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 6, nvl(count(distinct a.fund_account), 0)
      from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_client b
     where a.client_id = b.client_id
       and a.fundacct_status <> '3' --Ϊ˻
       and a.asset_prop = '7' --˻
       and b.organ_flag in ('1', '3')
       and a.branch_no not in ('7777')
       and a.open_date <= v_bbq_enddate;

  --7 Уδ˽ծȨծϵĿͻ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 7, nvl(count(fund_account), 0) s1
      from kods.rzrq_hs_his_hisassetdebit a
     where (a.fin_close_balance + a.slo_close_balance + --ʸծ+ȯծ
           a.fare_close_debit + a.other_close_debit + --зøծծ
           a.fin_close_interest + a.slo_close_interest + --ʸծϢȯծϢ
           a.fare_close_interest + a.other_close_interest +
           a.refcost_close_fare > 0) --зøծϢծϢ תͨɱ
       and a.init_date =
           (select max(init_date)
              from kods.rzrq_hs_his_hisassetdebit t
             where t.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  /*************   ȯ    ***********/

  --8 ĩ»ȷȯҵܹģ˾ܶȣ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 8, sum(t.crdt_total_quota) as s1
      from kods.RZRQ_HS_CASHQUOTA t
     where t.cashgroup_no = '1'
       and t.cashquota_type in ('3');

  --9 УͻѻʹõŶ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 9, nvl(s1, 0) as balance
      from (select /*case
                                                     when sum(nvl(m.total_max_quota, 0)) = 0 then --ܶ
                                                      sum(nvl(m.finance_max_quota, 0)) +--ʶ
                                                      sum(nvl(shortsell_max_quota, 0)) --ȯֵ
                                                     else
                                                      sum(nvl(m.total_max_quota, 0))
                                                   end s1*/
             sum(nvl(m.total_max_quota, 0)) as s1
              from kods.rzrq_hs_crdtcontract m
             where m.branch_no not in ('7777')) a;

  --ʼ 10 ڳȯ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 10, v
      from t_b30_f001
     where p003 = 1206001
       and p001 = v_date
       and p002 = 10190;

  --       11    Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 11, v
      from t_b30_f001
     where p003 = 1206001
       and p001 = v_date
       and p002 = 10200;
  --       12  ȯֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 12, v
      from t_b30_f001
     where p003 = 1206001
       and p001 = v_date
       and p002 = 10210;
  --13·ȯ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 13, nvl(sum(business_balance), 0) balance
      from (select nvl(sum(abs(clear_balance)), 0) business_balance
              from kods.rzrq_hs_his_hisdeliver
             where init_date <= v_bbq_enddate
               and init_date >= v_bbq_begindate
               and business_flag = 4702
            union all
            select nvl(sum(business_balance), 0) business_balance
              from kods.rzrq_hs_his_hisdeliver
             where init_date <= v_bbq_enddate
               and init_date >= v_bbq_begindate
               and business_flag = 4703) a;

  --14    Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 14, nvl(sum(abs(clear_balance)), 0) business_balance
      from kods.rzrq_hs_his_hisdeliver
     where init_date <= v_bbq_enddate
       and init_date >= v_bbq_begindate
       and business_flag = 4702;

  --15 ȯȯʱֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 15, nvl(sum(business_balance), 0) business_balance
      from kods.rzrq_hs_his_hisdeliver
     where init_date <= v_bbq_enddate
       and init_date >= v_bbq_begindate
       and business_flag = 4703;

  --18         ȯȯʱֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 18, sum(business_balance + slo_stockret_balance) as s1
      from (select sum(abs(business_balance)) as business_balance
              from kods.RZRQ_HS_HIS_BUSINESSTOTAL
             where init_date between v_bbq_begindate and v_bbq_enddate
               and business_flag in (4704, 4706, 4724, 4727, 4728)),
           
           (select nvl(sum(a.slo_stockret_amount * b.asset_price), 0) as slo_stockret_balance
              from kods.RZRQ_HS_HIS_SECRDTMTSL a,
                   kods.RZRQ_HS_HIS_HISPRICE   b
             where a.stock_code = b.stock_code
               and a.exchange_type = b.exchange_type
               and a.init_date = b.init_date
               and a.init_date between v_bbq_begindate and v_bbq_enddate);
  --19 ĩȯ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 19,
           sum(a.fin_close_balance + a.fare_close_debit +
               a.other_close_debit + a.slo_close_balance) as s1 --ʸծ+ȯծ
      from kods.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(a.init_date)
                          from kods.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');
  --20 Уʽ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 20,
           sum(fin_close_balance + a.fare_close_debit + a.other_close_debit) as s1 --ʸծ
      from kods.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(a.init_date)
                          from kods.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --21 Уȯֵ
  insert into T_ETL_RZRQ_C10
    select 21, sum(slo_close_balance) as s1 --ȯծ
      from kods.rzrq_hs_his_hisassetdebit a
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --17  Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 17 as id, COALESCE(a.je - b.je, 0)
      from (select COALESCE(sum(a.je), 0) as je
              from T_ETL_RZRQ_C10 a
             where a.xm in ('11', '14')) a,
           (select COALESCE(sum(a.je), 0) as je
              from T_ETL_RZRQ_C10 a
             where a.xm in ('20')) b;

  --16   ڹ黹ȯ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 16 as id, COALESCE(a.je, 0)
      from (select COALESCE(sum(a.je), 0) as je
              from T_ETL_RZRQ_C10 a
             where a.xm in ('17', '18')) a;

  --22 ˾ۼƶԿͻʡȯʣ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 22, nvl(count(*), 0) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702, 4703) --4702,4702ȯ
       and init_date between v_bbq_begindate and v_bbq_enddate
       and branch_no not in ('7777');

  --23 Уʱʣ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 23, nvl(count(*), 0) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702) --4702
       and init_date between v_bbq_begindate and v_bbq_enddate
       and branch_no not in ('7777');

  --24 ȯʣ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 24, nvl(count(*), 0) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4703) --4214ȯ
       and init_date between v_bbq_begindate and v_bbq_enddate
       and branch_no not in ('7777');

  /*************       ***********/

  --25 ĩͻֵ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 25,
           nvl(sum(a.current_balance), 0) + nvl(sum(market_close_value), 0) +
           nvl(sum(correct_balance), 0) as s1 --ǰ
      from kods.rzrq_hs_his_hisassetdebit a
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --26 Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 26, nvl(sum(current_balance), 0) as s1 --ǰ
      from kods.rzrq_hs_his_hisassetdebit a
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --27 ֤ȯֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 27, nvl(sum(market_close_value), 0) as s1
      from kods.rzrq_hs_his_hisassetdebit
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and branch_no not in ('7777');
  --28  ޣ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 28, nvl(sum(correct_balance), 0) as s1 --ʽ
      from kods.rzrq_hs_his_hisassetdebit
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and branch_no not in ('7777');
  --29 ĩάֵ%
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 29, /*case
                                          when sum(a.fin_close_balance + a.slo_close_balance +
                                                         a.fin_close_interest + a.slo_close_interest +
                                                         a.fare_close_interest + a.other_close_interest +
                                                         a.fare_close_debit + a.other_close_debit) = 0 then
                                           -1
                                          else*/
           round(sum(assure_close_balance) * 100 /
                  /*sum(a.fin_close_balance + a.slo_close_balance +
                  a.fin_close_interest + a.slo_close_interest +
                  a.fare_close_interest + a.other_close_interest +
                  a.fare_close_debit + a.other_close_debit)*/
                  sum(a.fin_close_balance + a.slo_close_balance +
                      a.fare_close_debit + a.fin_pre_interest +
                      a.other_close_debit + a.refcost_close_fare),
                  2)
           /*end*/ s1
      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(a.init_date)
                          from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and ( /*a.fin_close_balance + a.slo_close_balance +
                                                         a.fin_close_interest + a.slo_close_interest +
                                                         a.fare_close_interest + a.other_close_interest +
                                                         a.fare_close_debit + a.other_close_debit*/
            a.fin_close_balance + a.slo_close_balance + a.fare_close_debit +
            a.fin_pre_interest + a.other_close_debit + a.refcost_close_fare) > 0
       and a.branch_no not in ('7777');

  --30 ĩ͵Ŀͻ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 30, nvl(count(*), 0) s1
      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
     where a.close_rate < '1.3'
       and a.close_rate <> -1.00
       and init_date = (select max(a.init_date)
                          from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777'); --άֵ130

  /*************   ǿƽ    ***********/

  --31 ۼƱǿƽֵĿͻ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 31, nvl(s1, 0)
      from (select count(distinct fund_account) s1
              from kods.rzrq_hs_his_hisdeliver
             where business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;

  --32 ۼǿƽִ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 32, nvl(s1, 0)
      from (select count(*) s1
              from kods.rzrq_hs_his_hisdeliver
             where business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;

  --33 ۼǿƽֽ׽

  insert into T_ETL_RZRQ_C10
    select 33, nvl(s1, 0)
      from (select sum(business_balance) s1
              from kods.rzrq_hs_his_hisdeliver
             where business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;

  --34 ۼƾǿƽδʵֵծȨ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 34, nvl(s1, 0)
      from (select sum(nvl(fin_close_balance, 0) + nvl(slo_close_balance, 0) +
                       nvl(fare_close_debit, 0) + nvl(other_close_debit, 0) +
                       nvl(fare_close_interest, 0) +
                       nvl(other_close_interest, 0) +
                       nvl(fin_close_interest, 0) +
                       nvl(slo_close_interest, 0) +
                       nvl(fin_close_fine_interest, 0) +
                       nvl(slo_close_fine_interest, 0) +
                       nvl(other_close_fine_interest, 0) +
                       nvl(refcost_close_fare, 0)) as s1 --refcost_close_fare תͨɱ
              from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
             where a.close_rate >= 0
               and a.close_rate < 1
               and init_date =
                   (select max(a.init_date)
                      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                     where a.init_date <= v_bbq_enddate)
               and branch_no not in ('7777')) a;

  --35 УĩջծȨ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 35,
           nvl(a.occur_balance, 0) + nvl(c.occur_balance, 0) as occur_balance
    
      from (select nvl(sum(abs(occur_balance)), 0) occur_balance
              from KODS.RZRQ_HS_HIS_HISFUNDJOUR
             where business_flag in (4217, 4218, 4220) --Ϣ֧,ȯϢ֧,Ϣ֧
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a,
           (select nvl(sum(abs(fare0)), 0) occur_balance
              from KODS.RZRQ_HS_HIS_HISDELIVER
             where business_flag in (4702, 4212, 4216) --4702,4212,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) c;
  commit;

  /*--ҵ  
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
       select 37,
             nvl(a.occur_balance, 0) + nvl(c.occur_balance, 0) -
         nvl(d.occur_balance, 0) - nvl(a1.occur_balance, 0) as occur_balance
    from (select nvl(sum(abs(occur_balance)), 0) occur_balance
            from kods.rzrq_hs_his_hisfundjour a
           where (business_flag in (2712,2715,2718,2721,2724,2795,2732,2735,2738,2741,2744,2778)  or
                 (a.business_flag = 2779 and exists
                (select compact_id
                 from kods.rzrq_hs_his_compact
                 where compact_type in('0','2') 
                   and compact_id = substr(a.remark, 6, 23))))
             and init_date <= v_bbq_enddate) a,
       (select nvl(sum(abs(occur_balance)), 0) occur_balance
          from kods.rzrq_hs_his_hisfundjour a
         where (business_flag in (2712,2715,2718,2721,2724,2795,2732,2735,2738,2741,2744,2778)  or
                 (a.business_flag in(2779,2769) and exists
                (select compact_id
                 from kods.rzrq_hs_his_compact
                 where compact_type in('0','2') 
                   and compact_id = substr(a.remark, 6, 23))))
             and init_date <= (select MAX(init_date)
                        from  kods.a_hs08_exchangedate t
                        where  t.init_date  < =v_bbq_enddate)) a1,
      (select nvl(sum(fin_close_interest + fare_close_interest +other_close_interest),0) occur_balance
        from kods.rzrq_hs_his_hisassetdebit 
       where init_date = (select max(init_date)
                          from kods.rzrq_hs_his_hisassetdebit
                          where init_date <= v_bbq_enddate)) c,
      (select nvl(sum(fin_close_interest + fare_close_interest +other_close_interest),0) occur_balance
        from kods.rzrq_hs_his_hisassetdebit
       where init_date = (select MAX(init_date)
                        from  kods.a_hs08_exchangedate t
                        where  t.init_date  < = v_bbq_begindate)) d;
  */

  --38        ȯҵ  

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 38,
           nvl(a.occur_balance, 0) + nvl(b.occur_balance, 0) -
           nvl(c.occur_balance, 0) as occur_balance
      from (select nvl(sum(abs(occur_balance)), 0) occur_balance
              from (select occur_balance, init_date
                      from kods.rzrq_hs_his_hisfundjour a
                     where business_flag in (2701, 2776, 31208))
             where init_date <= v_bbq_enddate) a,
           (select nvl(sum(slo_close_interest + refcost_close_fare), 0) occur_balance
              from kods.rzrq_hs_his_hisassetdebit
             where init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisassetdebit
                     where init_date <= v_bbq_enddate)) b,
           (select nvl(sum(slo_close_interest + refcost_close_fare), 0) occur_balance
              from kods.rzrq_hs_his_hisassetdebit
             where init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisassetdebit
                     where init_date <= v_bbq_lastendmonth)) c;
  commit;
  --36 ȯҵ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 36, nvl(sum(abs(t.periodcrbalance)), 0)
      from t_etl_biz_data t
     where t.reportid = 'C10-1'
       and t.proid = 1
       and t.currency = 3;
  commit;
  insert into t_etl_rzrq_c10
    (xm, je)
    select 37, sum(decode(xm, 36, je, -je))
      from t_etl_rzrq_c10 t
     where t.xm in (36, 38);
  commit;

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 40, round(nvl(a.rate, 0), 4)
      from (select case
                     when sum(nvl(a.compact_balance, 0)) <> 0 then
                      round(sum(nvl(a.compact_balance, 0) *
                                nvl(a.year_rate, 0)) /
                            sum(nvl(a.compact_balance, 0)) / 360 * 1000,
                            6)
                     else
                      round(avg(nvl(a.year_rate, 0)) / 360 * 1000, 6)
                   end rate
              from kods.rzrq_hs_his_compact a
             where init_date >= v_bbq_begindate
               and init_date <= v_bbq_enddate
               and compact_type = '0'
               and compact_status <> '3'
               and nvl(a.compact_balance, 0) <> 0) a;

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 41, nvl(a.rate, 0)
      from (select case
                     when sum(nvl(a.compact_balance, 0)) <> 0 then
                      round(sum(nvl(a.compact_balance, 0) *
                                nvl(a.year_rate, 0)) /
                            sum(nvl(a.compact_balance, 0)) / 360 * 1000,
                            6)
                     else
                      round(avg(nvl(a.year_rate, 0)) / 360 * 1000, 6)
                   end rate
              from kods.rzrq_hs_his_compact a
             where init_date >= v_bbq_begindate
               and init_date <= v_bbq_enddate
               and compact_type = '1'
               and compact_status <> '3'
               and nvl(a.compact_balance, 0) <> 0) a;
  /*************   ע    ***********/
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 42, business_balance --+ c.occur_balance
      from (select nvl(sum(abs(b.business_balance)), 0) as business_balance /*,
                                                   nvl(sum(b.fare0), 0) as total_income*/
              from kods.rzrq_hs_his_businesstotal b
             where b.init_date >= v_bbq_begindate
               and b.init_date <= v_bbq_enddate
               and b.asset_prop = '7'
               and b.business_flag in (4701, 4702, 4703, 4704, 4705, 4706));

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 43,
           nvl(a.occur_balance, 0) /*+ nvl(c.occur_balance, 0)*/ as occur_balance
      from (select nvl(sum(FARE0 - EXCHANGE_FARE0 + FARE3 + FAREX -
                           EXCHANGE_FARE3 - EXCHANGE_FARE4 - EXCHANGE_FARE5 -
                           EXCHANGE_FARE6 - EXCHANGE_FAREX),
                       0) occur_balance
              from kods.rzrq_hs_his_hisdeliver a
            --4211  ,4212  
            -- 4213  ȯ,4214  ȯ,
            --4215  ƽ,4216  ƽ
             where business_flag in (4701, 4702, 4703, 4704, 4705, 4706)
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;
  commit;
  --44 ȯͻ֤ȯ׵ƽӶ()
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 44 as id,
           round(COALESCE(nvl(a.sxf, 1) / nvl(b.jsr, 0), 0) * 1000, 4)
      from (select b.je as sxf from T_ETL_RZRQ_C10 b where b.xm in ('43')) a,
           (select b.je as jsr from T_ETL_RZRQ_C10 b where b.xm in ('42')) b;
  commit;
  cisp_etl_rzrq_c10_1;
  commit;

  -- E1-7-1
  -- add by hucc 20120517
  --һĩȯߵǰ10ͻϸ

  delete from t_B40_A001;
  commit;
  insert into t_B40_A001
    (P001, A002, A003, A004, A005, A006, A100, W100)
    select b.client_name,
           a.total_balance,
           a.fin_close_balance,
           a.slo_close_balance,
           a.assure_close_balance,
           case
             when a.close_rate * 100 = 9999999999999 then
              -1
             else
              close_rate * 100
           end close_rate,
           '100000',
           v_bmid
      from (select rownum id,
                   client_id,
                   total_balance,
                   fin_close_balance,
                   slo_close_balance,
                   assure_close_balance,
                   close_rate
              from (select fund_account,
                           client_id,
                           fin_close_balance,
                           slo_close_balance,
                           fin_close_balance + slo_close_balance as total_balance,
                           assure_close_balance,
                           close_rate
                      from kods.RZRQ_HS_HIS_HISASSETDEBIT a
                     where init_date =
                           (select max(init_date)
                              from kods.RZRQ_HS_HIS_HISASSETDEBIT
                             where init_date <= v_bbq_enddate)
                       and close_rate <> '99999999999.99'
                       and branch_no not in ('7777')
                     order by fin_close_balance + slo_close_balance desc) a
             where rownum <= 10) a,
           kods.RZRQ_HS_CLIENT b
     where a.client_id = b.client_id
     order by a.id;
  commit;

  --ĩάֵ͵10ͻϸάֵĿͻϸͳƣ
  delete from t_B40_A002;
  commit;
  insert into t_B40_A002
    (P001, A002, A003, A004, A005, A006, A100, W100)
    select b.client_name,
           total_balance,
           fin_close_balance,
           slo_close_balance,
           assure_close_balance,
           close_rate,
           '100000',
           v_bmid
      from (select rownum id,
                   client_id,
                   total_balance,
                   fin_close_balance,
                   slo_close_balance,
                   assure_close_balance,
                   case
                     when close_rate * 100 = 9999999999999 then
                      -1
                     else
                      close_rate * 100
                   end close_rate
              from (select fund_account,
                           client_id,
                           fin_close_balance,
                           slo_close_balance,
                           fin_close_balance + slo_close_balance as total_balance,
                           assure_close_balance,
                           close_rate
                      from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                             where init_date <= v_bbq_enddate)
                       and close_rate >= 1.3
                       and close_rate <> '99999999999.99'
                       and branch_no not in ('7777')
                     order by close_rate asc) a
             where rownum <= 10) a,
           KODS.RZRQ_HS_CLIENT b
     where a.client_id = b.client_id
     order by to_number(id);
  commit;

  --ġĩ֤ȯֵǰ10֤ȯ
  delete from t_B40_A003;
  commit;
  insert into t_B40_A003
    (P001, A002, A003, A004, A005, A100, W100)
    select stock_name,
           stock_code,
           capital_amount,
           compact_amount,
           business_balance,
           '100000',
           v_bmid
      from (select stock_name,
                   stock_code,
                   capital_amount,
                   compact_amount,
                   business_balance
              from (select a.stock_name,
                           a.stock_code,
                           nvl(c.capital_amount, 0) as capital_amount,
                           nvl(a.compact_amount, 0) as compact_amount,
                           nvl(a.compact_amount, 0) * nvl(b.asset_price, 0) as business_balance
                      from (select stock_code,
                                   stock_name,
                                   exchange_type,
                                   sum(abs(a.compact_amount)) compact_amount
                              from KODS.RZRQ_HS_HIS_COMPACT a
                             where init_date =
                                   (select max(init_date)
                                      from KODS.RZRQ_HS_HIS_COMPACT a
                                     where a.init_date <= v_bbq_enddate)
                               and a.compact_type = '0'
                            --and a.debit_status <> '2'
                             group by stock_code, stock_name, exchange_type) a
                      left join (select stock_code, exchange_type, asset_price
                                  from KODS.RZRQ_HS_HIS_HISPRICE
                                 where init_date =
                                       (select max(init_date)
                                          from KODS.RZRQ_HS_HIS_HISPRICE a
                                         where a.init_date <= v_bbq_enddate)) b
                        on a.stock_code = b.stock_code
                       and a.exchange_type = b.exchange_type
                      left join (select stock_code,
                                       exchange_type,
                                       capital_amount
                                  from KODS.RZRQ_HS_HIS_HISASSURECODE
                                 where init_date =
                                       (select max(init_date)
                                          from KODS.RZRQ_HS_HIS_HISASSURECODE a
                                         where a.init_date <= v_bbq_enddate)) c
                        on a.stock_code = c.stock_code
                       and a.exchange_type = c.exchange_type) a
             order by business_balance desc --159937
            ) a
     where rownum <= 10;
  commit;
  --塢ĩȯ֤ȯֵǰ10֤ȯ
  delete from t_B40_A004;
  commit;
  insert into t_B40_A004
    (P001, A002, A003, A004, A005, A100, W100)
    select stock_name,
           stock_code,
           capital_amount,
           compact_amount,
           business_balance,
           '100000',
           v_bmid
      from (select stock_name,
                   stock_code,
                   capital_amount,
                   compact_amount,
                   business_balance
              from (select a.stock_name,
                           a.stock_code,
                           nvl(c.capital_amount, 0) as capital_amount,
                           nvl(a.compact_amount, 0) as compact_amount,
                           nvl(a.compact_amount, 0) * nvl(b.asset_price, 0) as business_balance
                      from (select stock_code,
                                   stock_name,
                                   sum(abs(a.compact_amount)) compact_amount
                              from KODS.RZRQ_HS_HIS_COMPACT a
                             where init_date =
                                   (select max(init_date)
                                      from KODS.RZRQ_HS_HIS_COMPACT a
                                     where a.init_date <= v_bbq_enddate)
                               and a.compact_type = '1'
                               and abs(a.compact_amount) <> 0
                            --and a.debit_status <> '2'
                             group by stock_code, stock_name) a
                      left join (select stock_code, asset_price
                                  from KODS.RZRQ_HS_HIS_HISPRICE
                                 where init_date =
                                       (select max(init_date)
                                          from KODS.RZRQ_HS_HIS_HISPRICE a
                                         where a.init_date <= v_bbq_enddate)) b
                        on a.stock_code = b.stock_code
                      left join (select stock_code, capital_amount
                                  from KODS.RZRQ_HS_HIS_HISASSURECODE
                                 where init_date =
                                       (select max(init_date)
                                          from KODS.RZRQ_HS_HIS_HISASSURECODE a
                                         where a.init_date <= v_bbq_enddate)) c
                        on a.stock_code = c.stock_code) a
             order by business_balance desc) a
     where rownum <= 10;
  commit;
  --ĩֵǰ10֤ȯ

  delete from t_B40_A005;
  commit;
  insert into t_B40_A005
    (P001, A002, A003, A004, A100, W100)
    select stock_name, stock_code, balance, rate, '100000', v_bmid
      from (select rownum pm, stock_name, stock_code, balance, rate
              from (select stock_name,
                           stock_code,
                           round(balance, 2) balance,
                           round(balance * 100 /
                                 (select sum(assure_close_balance)
                                    from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                                   where init_date =
                                         (select max(init_date)
                                            from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                                           where a.init_date <= v_bbq_enddate)),
                                 4) as rate
                      from (select a.stock_code,
                                   d.stock_name,
                                   a.current_amount * nvl(c.asset_price, 0) as balance
                              from (select stock_code,
                                           stock_type,
                                           EXCHANGE_TYPE,
                                           sum(current_amount) current_amount
                                      from KODS.RZRQ_HS_STOCK            a,
                                           kods.rzrq_hs_fund_fundaccount b
                                     where a.fund_account = b.fund_account
                                       and exists
                                     (select *
                                              from KODS.RZRQ_HS_HIS_HISASSURECODE c
                                             where a.stock_code = c.stock_code)
                                       and a.branch_no not in ('7777')
                                       and b.asset_prop = '7'
                                     group by stock_code,
                                              stock_type,
                                              EXCHANGE_TYPE) a,
                                   (select stock_code,
                                           EXCHANGE_TYPE,
                                           asset_price
                                      from KODS.RZRQ_HS_HIS_HISPRICE t
                                     where init_date =
                                           (select max(init_date)
                                              from KODS.RZRQ_HS_HIS_HISPRICE
                                             where init_date <= v_bbq_enddate)
                                    /*and t.exchange_type='2'*/
                                    ) c,
                                   (select stock_code, stock_name, stock_type
                                      from KODS.rzrq_hs_stkcode) d
                             where a.stock_code = c.stock_code
                               and a.EXCHANGE_TYPE = c.EXCHANGE_TYPE
                               and a.stock_code = d.stock_code
                               and a.stock_type = d.stock_type) a
                     order by balance desc) a
             where rownum <= 10) t;
  commit;
  --ߡ10ǿƽֽϸ

  delete from t_B40_A006;
  commit;
  insert into t_B40_A006
    (P001, A002, A003, A004, A100, W100)
    select client_name,
           to_date(init_date, 'yyyy-mm-dd'),
           business_balance,
           0,
           '100000',
           v_bmid
      from (select rownum pm,
                   fund_account,
                   client_id,
                   client_name,
                   init_date,
                   business_balance,
                   0
              from (select fund_account,
                           client_id,
                           client_name,
                           init_date,
                           abs(business_balance) as business_balance
                      from kods.Rzrq_Hs_His_Hisdeliver T
                     where init_date between v_bbq_begindate and
                           v_bbq_enddate
                       and business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
                     order by business_balance desc) a)
     where pm <= 10;
  commit;
  -- E1_7_3 ȯҵϸܱ

  --ĩάֵͻϸ

  delete from t_B50_A001;
  commit;
  insert into t_B50_A001
    (P001, A002, A003, A004, a005, A006, A100, W100)
    select b.client_name,
           total_balance,
           fin_close_balance,
           slo_close_balance,
           assure_close_balance,
           close_rate,
           '100000',
           v_bmid
      from (select rownum id,
                   client_id,
                   total_balance,
                   fin_close_balance,
                   slo_close_balance,
                   assure_close_balance,
                   case
                     when close_rate * 100 = 9999999999999 then
                      -1
                     else
                      close_rate * 100
                   end close_rate
              from (select fund_account,
                           client_id,
                           fin_close_balance,
                           slo_close_balance,
                           fin_close_balance + slo_close_balance as total_balance,
                           assure_close_balance,
                           close_rate
                      from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                             where init_date <= v_bbq_enddate)
                       and close_rate < 1.3 --άֵ1.3
                       and close_rate <> -1.00
                       and branch_no not in ('7777')
                     order by close_rate asc) a) a,
           KODS.RZRQ_HS_CLIENT b
     where a.client_id = b.client_id
     order by to_number(id);
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A2_1
prompt ====================================
prompt
create or replace procedure cisp_map_yyb_a2_1 is
  /********************************************************************
  *ܣɴԴݵETLݱݻܹ̣A2-1ͻʲ״
  *  
  *********************************************************************/
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
  --ȡڵڼʱ
  select to_char(t.A005, 'yyyymmdd')
    into v_begindate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.A006, 'yyyymmdd')
    into v_enddate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  delete from t_etl_yyb_khjyjszj;
  commit;

  cisp_process_cwdata_unfi('B-A2-1', 't_etl_yyb_khjyjszj', '1', '0');
  commit;
  insert into t_etl_yyb_khjyjszj
    select t1.p001, t.proid, t.endbalance
      from t_etl_biz_data t, krcs.t_ctl_t036 t1
     where t.reportid = 'B-A2-1'
       and t.company = t1.a023
       and t.currency = 0;
  commit;
  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je)
    select a.branch_no, 5 jylx, sum(b.current_balance)
      from kods.rzrq_hs_fund_fundaccount a,
           kods.v_rzrq_hs_fund_fund      b, --ϲ̨ 20200331 zhenyj
           kods.a_hs08_clientinfo        c
     where a.client_id = c.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%2%'
     group by a.branch_no;
  commit;
  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je) --ϸ
    select to_number(trim(b.branch_no)) yyb,
           6 jylx,
           sum(b.current_balance) je
      from kods.rzrq_hs_fund_fundaccount a, kods.v_rzrq_hs_fund_fund b --ϲ̨ 20200331 zhenyj
     where a.client_id = b.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
          --and a.client_group='902'
       and a.asset_prop in ('0') --ֻȡ̨
       and exists
     (select 1
              from kods.rzrq_hs_stockholder d, kods.rzrq_hs_nonstdholder e
             where d.stock_account = e.stock_account
               and d.fund_account = b.fund_account
               and d.client_id = b.client_id)
     group by b.branch_no;
  commit;

  --ָй֤ȯֵȥ߹ܶ
  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je)
    select yyb, 9 zqlx, sum(zqsz)
      from (select t1.branch_no as yyb,
                   9 zqlx,
                   sum((t1.current_amount + abs(t1.correct_amount)) *
                       b.asset_price) zqsz
              from kods.v_rzrq_hs_stock t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('0',
                                     'c',
                                     '6',
                                     'L',
                                     'T',
                                     'j',
                                     'l',
                                     '9',
                                     'X',
                                     'Y',
                                     'U',
                                     'u',
                                     'a',
                                     'Z',
                                     'e'  --e ƴ
                                     'p', --pעƴҵ
                                     'r' -- r ʩ 20210705
                                     )
               and t3.fundacct_status != '3'
               and t1.exchange_type in ('1', '2')
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.client_id = t3.client_id
               and t1.money_type = '0'
               and t1.current_amount >= 0
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code = t1.stock_code
             group by t1.branch_no
            union all
            select t1.branch_no as yyb,
                   9 zqlx,
                   sum((t1.current_amount + abs(t1.correct_amount)) *
                       b.asset_price) zqsz
              from kods.v_rzrq_hs_stock t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('q', --qҵƾ֤
                                     'g') --gƴƾ֤ 
               and t3.fundacct_status != '3'
               and t1.exchange_type in ('1', '2')
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.client_id = t3.client_id
               and t1.money_type = '0'
               and t1.current_amount >= 0
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code = t1.stock_code
             group by t1.branch_no
            union all
            select a.branch_no as yyb,
                   9 zqlx,
                   -sum(greatest(nvl(b.current_amount, 0) -
                                 nvl(a.available_amount, 0),
                                 0) * c.asset_price) as zqsz --
              from --kods.A_HS08_EXTSTOCKREAL a,
                   --kods.rzrq_hs_stockreal b,
                   --ͼϲ̨ 20200331
                    kods.v_a_hs08_extstockreal a,
                   kods.v_rzrq_hs_stockreal b,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) c
             where a.client_id = b.client_id
               and a.stock_code = b.stock_code
               and a.exchange_type = b.exchange_type
               and trim(c.stock_code) = trim(a.stock_code)
               and b.stock_flag = '1'
             group by a.branch_no
            
            union all --۹ͨ
            select t1.branch_no,
                   9 zqlx,
                   sum((t1.current_amount + t1.correct_amount) *
                       b.asset_price) zqsz
              from --kods.rzrq_hs_stock t1,
                   kods.v_rzrq_hs_stock t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('0')
               and t3.fundacct_status != '3'
               and t1.exchange_type in ('G', 'S')
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.client_id = t3.client_id
               and t1.money_type = '0'
               and t1.current_amount >= 0
               and t1.fund_account = t3.fund_account
               and t1.branch_no not in
                   (select p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004002))
                  --and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004014,1004001,1004005,1004008))--һЩӪҵ
               and b.stock_code = t1.stock_code
             group by t1.branch_no
            union all
            select s.yyb, 9 as zqlx, sum(s.je) as zqsz --϶ʽ
              from (select sum(abs(t.occur_balance)) je, t.branch_no yyb
                      from /*a_hs_contstk*/ kods.v_rzrq_hs_his_hisfundjour t --kods.rzrq_hs_his_hisfundjour t
                     where t.business_flag in ('44170')
                       and t.init_date =
                           (select max(init_date)
                              from kods.v_rzrq_hs_his_hisfundjour
                             where init_date <= v_enddate)
                     group by t.branch_no) s
             group by yyb)
     group by yyb;
  commit;

  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je)
  --ָй֤ͨȯֵ
    select to_number(yyb), 10, sum(zqsz)
      from (select trim(t.open_brh) as yyb, 10 as jylx, sum(t.zqsz) as zqsz
              from (select b.branch_no as open_brh,
                           sum((m.yest_sec_bal + m.settle_sec_net +
                               m.post_sec_net) * c.asset_price) as zqsz
                      from kods.xy60_inv_sec_balance m,
                           kods.xy60_sys_sec_custody n,
                           kods.rzrq_hs_stockholder b,
                           (select stock_code, asset_price
                              from kods.rzrq_hs_his_hisprice
                             where init_date =
                                   (select max(init_date)
                                      from kods.rzrq_hs_his_hisprice)) c
                     where m.sec_id = n.sec_id
                       and m.inv_acc = b.stock_account
                       and m.mkt_code = '01'
                       and n.mkt_code = '01'
                       and n.sec_class = 'XL'
                       and trim(c.stock_code) = trim(m.sec_code)
                       and trim(m.inv_acc) = trim(b.stock_account)
                       and b.exchange_type = '1'
                     group by b.branch_no
                    union all
                    select b.branch_no as open_brh,
                           sum(nvl(a.stock_mkt, 0)) as zqsz
                      from kods.xy60_sec_vou_limited_sale /*xy60_SA_SJSFW_CL*/ a,
                           kods.rzrq_hs_stockholder       b
                     where trim(b.stock_account) = trim(a.inv_acc)
                       and a.mkt_code = '02' --A
                       and b.exchange_type = '2'
                    --and a.Seat_Code='054900'
                     group by b.branch_no
                    union all --
                    select b.branch_no as open_brh,
                           sum(nvl(a.stock_mkt, 0)) as zqsz
                      from kods.xy60_sec_vou_limited_sale /*xy60_SA_SJSFW_CL*/ a,
                           kods.rzrq_hs_stockholder       b
                     where trim(b.stock_account) = trim(a.inv_acc)
                       and a.mkt_code = '13' --
                       and b.exchange_type = '2'
                     group by b.branch_no
                    union all
                    select a.branch_no as open_brh,
                           sum(greatest(nvl(b.current_amount, 0) -
                                        nvl(a.available_amount, 0),
                                        0) * c.asset_price) as zqsz --
                      from --kods.A_HS08_EXTSTOCKREAL a,
                           --kods.rzrq_hs_stockreal b,
                            kods.v_a_hs08_extstockreal a,
                           kods.v_rzrq_hs_stockreal b,
                           (select *
                              from kods.rzrq_hs_his_hisprice
                             where init_date =
                                   (select max(init_date)
                                      from kods.rzrq_hs_his_hisprice)) c
                     where a.client_id = b.client_id
                       and a.stock_code = b.stock_code
                       and a.exchange_type = b.exchange_type
                       and trim(c.stock_code) = trim(a.stock_code)
                       and b.stock_flag = '1'
                     group by a.branch_no) t
             group by t.open_brh)
     group by yyb;
  commit;
  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je)
  --ɷתϵͳ֤ȯֵ
    select a.branch_no,
           11,
           sum((a.current_amount + abs(a.correct_amount)) * asset_price) as gpsz
      from --kods.rzrq_hs_stock a,
           kods.v_rzrq_hs_stock a,
           kods.rzrq_hs_fund_fundaccount c,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) b
     where a.exchange_type = b.exchange_type
       and a.fund_account = c.fund_account
       and c.asset_prop = '0'
       and a.stock_code = b.stock_code
       and a.money_type = 0
       and a.current_amount >= 0
       and a.stock_type in ('0', 'z')
       and a.exchange_type in ('9', 'A')
     group by a.branch_no
    
    union all
    
    --̨ͻ׽ʽ
    select s.branch_no, 14, sum(s.current_balance)
      from kods.v_rzrq_hs_fund_fund      s,
           kods.rzrq_hs_client           a,
           kods.rzrq_hs_fund_fundaccount b
     where s.fund_account = b.fund_account
       and b.asset_prop = '0'
       and s.money_type = 0
       and a.organ_flag in ('1', '0', '3', '5', '6')
       and a.client_id = s.client_id
       and a.client_status != '3'
     group by s.branch_no
    
    union all
    
    --Уĩϡ깺ʽ
    select s.yyb, 13 as jylx, sum(s.je) as je
      from (select sum(abs(t.occur_balance)) je, t.branch_no yyb
              from /*a_hs_contstk*/ kods.v_rzrq_hs_his_hisfundjour t --kods.rzrq_hs_his_hisfundjour t
             where t.business_flag in ('44170')
               and t.init_date =
                   (select max(init_date)
                      from kods.v_rzrq_hs_his_hisfundjour
                     where init_date <= v_enddate)
             group by t.branch_no) s
     group by yyb;
  commit;
  update t_etl_yyb_khjyjszj t --ڲ-=23110102+231102-С-ϸ
     set t.je =
         (select sum(decode(jylx, 3, je, 5, -je, 6, -je))
            from t_etl_yyb_khjyjszj
           where yyb = t.yyb)
   where t.jylx = 3;
  commit;
  ------------------------------------------------------------------------------------------------------------------------------------------
  --ͻʽֲ
  ------------------------------------------------------------------------------------------------------------------------------------------
  delete from t_etl_yyb_khzjfb;
  insert into t_etl_yyb_khzjfb
    (yyb, yhdm, yhmc, khsl, zjye)
    select to_char(a.branch_no), a.bank_no, b.a003, a.sl, a.ye
      from (select t1.branch_no,
                   coalesce(t3.bank_no, '9999') bank_no,
                   count(*) sl,
                   sum(t1.current_balance) ye
              from --kods.rzrq_hs_fund_fund        t1,
                   kods.v_rzrq_hs_fund_fund      t1,
                   kods.rzrq_hs_fund_fundaccount t2,
                   kods.rzrq_hs_bankarg          t3
             where t1.bank_no = t3.bank_no
               and t1.fund_account = t2.fund_account
               and t3.bank_type = '2'
               and t1.money_type = '0'
               and t2.fundacct_status <> '3'
               and t2.asset_prop = '0'
               and t2.open_date <= v_enddate
             group by t1.branch_no, coalesce(t3.bank_no, '9999')) a,
           (select p002, a003 from t_bks_t031 where p001 = 101) b
     where a.bank_no = b.p002;
  commit;
  cisp_etl_yyb_khjyjszj;
  cisp_etl_yyb_khzjfb;
  commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_SY
prompt ==================================
prompt
create or replace procedure cisp_map_yyb_sy
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  Ӫҵ״
-- RETURN:
-- AUTHOR:       gaoj
-- CREATE DATE:  2014/8/12
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
   v_year          varchar2(64);
   v_period        varchar2(64);
   v_usd number(17,5);
   v_hkd number(17,5);
begin
    select a002 into v_usd from t_bks_t007 ;
    select a003 into v_hkd from t_bks_t007 ;

    select to_char(to_date(p001,'yyyy-mm'),'yyyy') into v_year from t_b00_d004 where a002 = 1013001 and c001=1001101;
    select to_char(to_date(p001,'yyyy-mm'),'mm') into v_period from t_b00_d004 where a002 = 1013001 and c001=1001101;

    cisp_process_cwdata_unfi('B-A1-1-2','t_etl_yyb_zcfz','0','0');
    delete from T_ETL_YYB_SY;

    --ȡ跽
 insert into T_ETL_YYB_SY
   (yyb, xm, bqje)
   select t1.p001,
          t.proid,sum(t.periodcrbalance)
     from t_etl_biz_data t,
          (select * from krcs.t_ctl_t036 where a008 = 1023008) t1
    where t.reportid = 'B-A1-1-2'
      and t.company = t1.a023
      and t.currency = 3
    group by t1.p001, t.proid
    order by t1.p001, t.proid
    ;


   --Ӫҵ = Ӫҵ - Ӫҵ֧
    insert into T_ETL_YYB_SY(yyb,xm,bqje)
    select yyb,
           14 as xm,
           sum(decode(xm,1,bqje,4,-bqje)) as bqje
    from T_ETL_YYB_SY
    where xm in (1,4)--97 ʱĿҵ
    group by yyb;
    commit;
   --ܶ = Ӫҵ - 6711 +6301
   insert into T_ETL_YYB_SY(yyb,xm,bqje)
    select yyb,
           15 as xm,
           sum(bqje) as bqje
    from T_ETL_YYB_SY
    where xm in (14,25)--25 ʱĿҵ
    group by yyb;
    commit;
    -- = ܶ - ˰
    insert into T_ETL_YYB_SY(yyb,xm,bqje)
    select yyb,
           17 as xm,
           sum(decode(xm,15,bqje,16,-bqje)) as bqje
    from T_ETL_YYB_SY
    where xm in (15,16)
    group by yyb;


    commit;
    delete T_ETL_YYB_SY where xm=25;

    cisp_etl_yyb_sy;
    commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_ZCFZ
prompt ====================================
prompt
create or replace procedure cisp_map_yyb_zcfz
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  Ӫҵʲծ״
-- RETURN:
-- AUTHOR:       wxg
-- CREATE DATE:  2015/8/31
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
begin
    cisp_process_cwdata_unfi('B-A1-1-1','t_etl_yyb_zcfz','1','0');
    delete from t_etl_yyb_zcfz;


    insert into t_etl_yyb_zcfz(yyb,xm,qmye)
    select t1.p001,t.proid,sum(t.endbalance)
    from t_etl_biz_data t,(select * from krcs.t_ctl_t036 where a008 = 1023008) t1
    where t.reportid='B-A1-1-1'
    and t.company = t1.a023 and t.currency = 3
    and t.proid<>'9'
    group by t1.p001,t.proid;

    commit;
    
     insert into t_etl_yyb_zcfz(yyb,xm,qmye)
    select t1.p001,t.proid,sum(t.endbalance)
    from t_etl_biz_data t,(select * from krcs.t_ctl_t036 where a008 = 1023008) t1
    where t.reportid='B-A1-1-1'
    and t.company = t1.a023 and t.currency = 0
    and t.proid='9'
    group by t1.p001,t.proid;
    commit;

    --ʲܶ
     
      insert into t_etl_yyb_zcfz(yyb,xm,qmye)
    select yyb,7 as xm,sum(decode(xm,1,qmye,12,-qmye))
    from t_etl_yyb_zcfz
    where xm in(  1,  --ʲܶ
     -- 9,  --У֤ȯ-
     -- 10,  --Ӧڲ
      12  --ڲ
     ) group by yyb;
     commit;

    cisp_etl_yyb_zcfz;
    commit;

end;
/

prompt
prompt Creating procedure CISP_INTERFACE_CW
prompt ====================================
prompt
create or replace procedure cisp_interface_cw
is
begin
  cisp_makebalance_unfi;
   --Ӫҵ
   cisp_map_yyb_sy;
   cisp_map_yyb_zcfz;
   cisp_map_yyb_a2_1;
   --ܲ
   cisp_map_hs_jjyw_c1_1;
   cisp_map_rzrq_zb;
   --cisp_map_hg_c13_3;
   commit;

end cisp_interface_cw;
/

prompt
prompt Creating procedure CISP_MAP_F2_1
prompt ================================
prompt
create or replace procedure cisp_map_f2_1 is
  /********************************************************************
  *ܣɴԴݵETLݱݻܹ̣A2-1ͻʲ״
  *  
  *********************************************************************/
   v_begindate varchar2(8);
  v_enddate   varchar2(8);
  v_bmid number;
begin
  --ȡڵڼʱ
  select to_char(t.A005,'yyyymmdd')
    into v_begindate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.A006,'yyyymmdd')
     into v_enddate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
     v_bmid:=50005;
 delete from  T_DB_31_03;   
 commit;
insert into T_DB_31_03
select t.a001,nvl(t1.balance,0),nvl(t2.balance,0)+nvl(t1.balance,0),nvl(t3.business_balance,0),v_bmid from T_BKS_T101 t
 left join (select t.fund_account,
       nvl(round(sum(t.current_balance + t.correct_balance) / 10000, 2), 0) balance --ͻʲ
  from T_BKS_T101 a, kods.rzrq_hs_fund_fund t
 where trim(a.a001) = t.fund_account
 group by t.fund_account)t1 on trim(t.a001)=t1.fund_account 
 left join (
 select fund_accout,sum(balance) as balance from (select   b.fund_account as fund_accout,b.exchange_type,nvl(round((case when b.exchange_type ='G' THEN
sum((b.current_amount+b.correct_amount)*c.asset_price)*(select A003 from t_bks_t007)/10000 
WHEN b.exchange_type ='S' then sum((b.current_amount+b.correct_amount)*c.asset_price)*(select A002 from t_bks_t007)/10000
 else sum((b.current_amount+b.correct_amount)*c.asset_price)/10000   end),2),0) balance
  from T_BKS_T101 a,kods.rzrq_hs_stock b,(select distinct STOCK_CODE,asset_price from kods.rzrq_hs_his_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_his_hisprice where init_date <=v_enddate)) c
  where trim(a.a001)=b.fund_account
  and b.stock_code=c.stock_code
  and b.stock_code not in ('888880','131990')
  group by b.fund_account,b.exchange_type)
  group by fund_accout
 )t2 on trim(t.a001) =t2.fund_accout left join (

 select  b.fund_account,nvl(round(sum(b.business_balance)/10000,2),0) as  business_balance
 from T_BKS_T101 a,kods.rzrq_hs_his_hisdeliver b 
 where trim(a.a001)=b.fund_account
 and b.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a')
 and b.asset_prop ='0'
 and b.init_date between v_begindate and v_enddate
 and b.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
 group by b.fund_account )t3 on trim(t.a001)=t3.fund_account;
 commit;



end;
/

prompt
prompt Creating procedure CISP_MAP_F2_2
prompt ================================
prompt
create or replace procedure cisp_map_f2_2 is
  /********************************************************************
  *ܣɴԴݵETLݱݻܹ̣A2-1ͻʲ״
  *  
  *********************************************************************/
   v_begindate varchar2(8);
  v_enddate   varchar2(8);
  v_bmid number;
begin
  --ȡڵڼʱ
  select to_char(t.A005,'yyyymmdd')
    into v_begindate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.A006,'yyyymmdd')
     into v_enddate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
     v_bmid:=50005;
 delete from  T_DB_31_04;
 commit;
insert into T_DB_31_04(P001,A002,W100)
select  t.a003,nvl(t1.zqsz,0),v_bmid from T_BKS_T102 t
left join (select a003, sum(zqsz) as zqsz from (select a.a003,nvl(round((case when b.exchange_type ='G' THEN
sum((b.current_amount+b.correct_amount)*c.asset_price)*(select A003 from t_bks_t007)/10000 
WHEN b.exchange_type ='S' then sum((b.current_amount+b.correct_amount)*c.asset_price)*(select A002 from t_bks_t007)/10000
 else sum((b.current_amount+b.correct_amount)*c.asset_price)/10000   end),2),0) as zqsz
from T_BKS_T102 a,kods.rzrq_hs_stock b,
(select distinct stock_code,asset_price from kods.rzrq_hs_his_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_his_hisprice))c
where trim(a.a001)=b.fund_account
and b.stock_code=c.stock_code
and b.stock_code not in ('888880','131990')
and trim(a.a003) = b.stock_account
group by a.a003,b.exchange_type)
group by a003)t1 on t.a003=t1.a003
left join (select a.a001
from T_BKS_T102 a, kods.rzrq_hs_his_hisdeliver b
where trim(a.a001)=b.fund_account
and  b.init_date between v_begindate and v_enddate
group by a.a001 ) t2 on trim(t.a001)=trim(t2.a001);
commit;


end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3
prompt ====================================
prompt
create or replace procedure cisp_map_hg_c13_3
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  lastbbq                 number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
     
  
  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;

 select to_char(to_date(v_bbq_begindate, 'yyyymmdd') -1, 'yyyymm') into lastbbq from dual;

  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  /*--modify zhenyj 20200601 ͻҪɾ8Լ
  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',
                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
  --ͻҪ޸
  update kods.A_HS08_SRPCONTRACT t set t.repaid_balance = decode(t.contract_id,'2017012000000005',134500000.00,124450000.00)
  where t.contract_id in ('2017012000000005','2017052300000001');
  commit;*/

  delete from t_etl_c13_3_sl;
  delete from t_etl_c13_3_je;
  delete from t_etl_c13_3_ywmx1;
  delete from t_etl_c13_3_ywmx2;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl
     select case
             when t.jgbs='' then 5
              else 6 end,
           1,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
      where t.khbh in (select distinct t.khbh from T_BKS_ZYRHHY t
                     minus
                     select distinct t.khbh from t_zyrhhy_khxx t where t.bbg=lastbbq)
     group by t.jgbs;
  commit;

  --ĩ
  insert into t_etl_c13_3_sl
    select case
             when t.jgbs='' then 5
              else 6 end,
           3,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_sl
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

    --ؽ׽Ԫ 
  insert into t_etl_c13_3_je
    select case
             when t.jysc = 'Ϻ' then
              8
             else
              9
           end,
           1,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
     group by t.jysc;
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je
    select case
             when t.jysc = 'Ϻ' then
              8
             else
              9
           end,
           3,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     group by t.jysc;
  commit;

  insert into t_etl_c13_3_je
    select 7, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je
   select 10, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 30
    ;
  commit;

  -- عʣ1ڣ
  insert into t_etl_c13_3_je
    select 11, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 30
       and to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 365
       ;
  commit;

  -- عʣ1
  insert into t_etl_c13_3_je
    select 12, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 365
     ;
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je
    select case
             when t.jgbs='' then 13
              else 14 end,
           1,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
     group by t.jgbs;
  commit;

  --/
  insert into t_etl_c13_3_je
    select case
             when t.jgbs='' then 13
              else 14 end,
           3,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     group by t.jgbs;
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je
    select decode(t.jysc, 'Ϻ', '16', 18),
           3,
           sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
     group by t.jysc;
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je
    select 17,
           3,
           nvl(sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price),0)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.jysc='Ϻ'
       and t.xsbz='';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je
     select 19,
           3,
           nvl(sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price),0)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.jysc=''
       and t.xsbz=''
       ;
  commit;

  insert into t_etl_c13_3_je
    select 15, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je
    select decode(t.jgbs, '',21, 22),
           3,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
     where t.sfwy=''
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_je
    select 20, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je
    select decode(t.jgbs, '',24, 25),
           3,
           sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where t.sfwy=''
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_je
    select 23, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
   select 28 xh,3,
           sum(case
                 when to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') <= 30 then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  --29 ֤ȯ˾ΪڳۼҵģԪ           
  insert into t_etl_c13_3_je
    select 29 xh,3,
           sum(case
                 when (to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') > 30) and 
                      (to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') <= 365)then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate;

  --30 ֤ȯ˾ΪڳۼҵģԪ         
  insert into t_etl_c13_3_je
    select 30 xh,3,
           sum(case
                 when to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') > 365 then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate;

  insert into t_etl_c13_3_je
    select 27, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
   insert into t_etl_c13_3_je
    select 31,
           0,
           sum(REAL_BACK_BALANCE-ENTRUST_BALANCE+REPAID_BALANCE+SETTLE_INTEREST)
      from (select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status in ('4')
      ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 33, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.sjghrq < v_bbq_next_enddate
       and t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
  select 34, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.sjghrq > v_bbq_enddate
       and t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.sjghrq between v_bbq_enddate and v_bbq_next_year_enddate
        and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
     select 35, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.sjghrq > v_bbq_next_year_enddate
       and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  insert into t_etl_c13_3_je
    select 32, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 1, nvl(max(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 30
     ;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 2, nvl(min(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 30
       ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 1, nvl(max(t.hgll*100),0)
      from T_BKS_ZYRHHY t
     where (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 30) and
                      (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 365)
     ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 2, nvl(min(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 30) and
                      (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 365)
      ;
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je
    select 38, 1, nvl(max(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 365
     ;
  commit;

  insert into t_etl_c13_3_je
    select 38, 2, nvl(min(t.hgll*100),0)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 365
    ;
  commit;

  insert into t_etl_c13_3_ywmx1
   select y.client_id,
           y.client_name,
           sum(x.wtje-x.yhje),
           sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price),
           round(sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price)
                  / sum(x.wtje-x.yhje) * 100,2),
           0
      from T_BKS_ZYRHHY x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.khbh = y.client_id
       and x.zqdm = z.stock_code
       and decode(x.jysc,'Ϻ','1',2) = z.exchange_type
       and x.wtrq <= v_bbq_enddate
       and x.sfwy=''
     group by y.client_id, y.client_name having sum(x.wtje-x.yhje)>0
     order by sum(x.wtje-x.yhje) desc;
  commit;

  insert into t_etl_c13_3_ywmx2
  select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.zqdm as stock_code,
                   sum(x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) as entrust_amount,
                   sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price) as sz,
                   sum(x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from T_BKS_ZYRHHY x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.zqdm = z.stock_code
               and x.zqdm = n.stock_code
               and decode(x.jysc,'Ϻ','1','2') = z.exchange_type
               and x.wtrq <= v_bbq_enddate
               and x.sfwy=''
               and x.zqdm = y.stock_code
             group by x.zqdm, y.stock_name, n.capital_amount
             order by sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price) desc
             
             ) a
     where rownum < 6;
  commit;
  update t_etl_c13_3_je t set t.je=0 where t.je is null;
  commit;
  cisp_etl_gpzy_jyb;
  commit;
  cisp_etl_gpzy_jyb_ljywgm; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_RH
prompt =======================================
prompt
create or replace procedure cisp_map_hg_c13_3_rh
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  lastbbq                 number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;
  
  select to_char(to_date(v_bbq_begindate, 'yyyymmdd') -1, 'yyyymm') into lastbbq from dual;


  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  --modify zhenyj 20200601 ͻҪɾ8Լ
/*  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',
                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
*/

  delete from t_etl_c13_3_sl_rh;
  delete from t_etl_c13_3_je_rh;
  delete from t_etl_c13_3_ywmx1_rh;
  delete from t_etl_c13_3_ywmx2_rh;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl_rh
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
       --and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.rcflx='ʹӹ˾ʹܿͻ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl_rh
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
       --and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.rcflx='ʹӹ˾ʹܿͻ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl_rh
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl_rh t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl_rh
    select case
             when t.jgbs='' then 5
              else 6 end,
           1,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
      where t.rcflx='ʹӹ˾ʹܿͻ'
      and t.khbh in (select distinct t.khbh from T_BKS_ZYRHHY t
                     minus
                     select distinct t.khbh from t_zyrhhy_khxx t where t.bbg=lastbbq)
     group by t.jgbs;
  commit;

  --ĩ
  insert into t_etl_c13_3_sl_rh
    select case
             when t.jgbs='' then 5
              else 6 end,
           3,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
      where t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_sl_rh
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl_rh t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

     --ؽ׽Ԫ 
  insert into t_etl_c13_3_je_rh
    select case
             when t.jysc = 'Ϻ' then
              8
             else
              9
           end,
           1,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
     and t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jysc;
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je_rh
    select case
             when t.jysc = 'Ϻ' then
              8
             else
              9
           end,
           3,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
      where t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jysc;
  commit;

  insert into t_etl_c13_3_je_rh
    select 7, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je_rh
   select 10, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 30
     and t.rcflx='ʹӹ˾ʹܿͻ'
    ;
  commit;

  -- عʣ1ڣ
  insert into t_etl_c13_3_je_rh
    select 11, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 30
       and to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 365
       and t.rcflx='ʹӹ˾ʹܿͻ'
       ;
  commit;

  -- عʣ1
  insert into t_etl_c13_3_je_rh
    select 12, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 365
     and t.rcflx='ʹӹ˾ʹܿͻ'
     ;
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je_rh t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je_rh
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je_rh
    select case
             when t.jgbs='' then 13
              else 14 end,
           1,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
     and t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jgbs;
  commit;

  --/
  insert into t_etl_c13_3_je_rh
    select case
             when t.jgbs='' then 13
              else 14 end,
           3,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
      where t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jgbs;
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je_rh
    select decode(t.jysc, 'Ϻ', '16', 18),
           3,
           sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jysc;
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je_rh
    select 17,
           3,
           nvl(sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price),0)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.jysc='Ϻ'
       and t.xsbz=''
       and t.rcflx='ʹӹ˾ʹܿͻ';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je_rh
     select 19,
           3,
           nvl(sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price),0)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.jysc=''
       and t.xsbz=''
       and t.rcflx='ʹӹ˾ʹܿͻ'
       ;
  commit;

  insert into t_etl_c13_3_je_rh
    select 15, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je_rh
    select decode(t.jgbs, '',21, 22),
           3,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
     where t.sfwy=''
     and t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_je_rh
    select 20, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je_rh
    select decode(t.jgbs, '',24, 25),
           3,
           sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where t.sfwy=''
     and t.rcflx='ʹӹ˾ʹܿͻ'
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_je_rh
    select 23, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je_rh
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je_rh
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je_rh
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
   select 28 xh,3,
           sum(case
                 when to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') <= 30 then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate and s.rcflx='ʹӹ˾ʹܿͻ';

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  --29 ֤ȯ˾ΪڳۼҵģԪ           
  insert into t_etl_c13_3_je_rh
    select 29 xh,3,
           sum(case
                 when (to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') > 30) and 
                      (to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') <= 365)then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate and s.rcflx='ʹӹ˾ʹܿͻ';

  --30 ֤ȯ˾ΪڳۼҵģԪ         
  insert into t_etl_c13_3_je_rh
    select 30 xh,3,
           sum(case
                 when to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') > 365 then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate and s.rcflx='ʹӹ˾ʹܿͻ';

  insert into t_etl_c13_3_je_rh
    select 27, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_3_je_rh
    select 31,
           0,
           sum(REAL_BACK_BALANCE-ENTRUST_BALANCE+REPAID_BALANCE+SETTLE_INTEREST)
      from (select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status in ('4')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
    select 33, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.sjghrq < v_bbq_next_enddate
       and t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.rcflx='ʹӹ˾ʹܿͻ'
       and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
  select 34, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.sjghrq > v_bbq_enddate
       and t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.sjghrq between v_bbq_enddate and v_bbq_next_year_enddate
       and t.rcflx='ʹӹ˾ʹܿͻ'
       and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
     select 35, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.sjghrq > v_bbq_next_year_enddate
       and t.rcflx='ʹӹ˾ʹܿͻ'
       and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  insert into t_etl_c13_3_je_rh
    select 32, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je_rh
    select 36, 1, nvl(max(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 30
                      and t.rcflx='ʹӹ˾ʹܿͻ'
     ;
  commit;

  --ع     У
  insert into t_etl_c13_3_je_rh
    select 36, 2, nvl(min(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 30
                      and t.rcflx='ʹӹ˾ʹܿͻ'
       ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_rh
    select 37, 1, nvl(max(t.hgll*100),0)
      from T_BKS_ZYRHHY t
     where (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 30) and
                      (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 365)
                      and t.rcflx='ʹӹ˾ʹܿͻ'
     ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_rh
    select 37, 2, nvl(min(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 30) and
                      (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 365)
                      and t.rcflx='ʹӹ˾ʹܿͻ'
      ;
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je_rh
    select 38, 1, nvl(max(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 365
                      and t.rcflx='ʹӹ˾ʹܿͻ'
     ;
  commit;

  insert into t_etl_c13_3_je_rh
    select 38, 2, nvl(min(t.hgll*100),0)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 365
                      and t.rcflx='ʹӹ˾ʹܿͻ'
    ;
  commit;

  insert into t_etl_c13_3_ywmx1_rh
   select y.client_id,
           y.client_name,
           sum(x.wtje-x.yhje),
           sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price),
           round(sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price),
                 2) / round(sum(x.wtje-x.yhje), 2) * 100,
           0
      from T_BKS_ZYRHHY x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.khbh = y.client_id
       and x.zqdm = z.stock_code
       and decode(x.jysc,'Ϻ','1',2) = z.exchange_type
       and x.wtrq <= v_bbq_enddate
       and x.sfwy=''
       and x.rcflx='ʹӹ˾ʹܿͻ'
     group by y.client_id, y.client_name having sum(x.wtje-x.yhje)>0
     order by sum(x.wtje-x.yhje) desc;
  commit;

  insert into t_etl_c13_3_ywmx2_rh
  select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.zqdm as stock_code,
                   sum(x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) as entrust_amount,
                   sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price) as sz,
                   sum(x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from T_BKS_ZYRHHY x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.zqdm = z.stock_code
               and x.zqdm = n.stock_code
               and decode(x.jysc,'Ϻ','1','2') = z.exchange_type
               and x.wtrq <= v_bbq_enddate
               and x.sfwy=''
               and x.rcflx='ʹӹ˾ʹܿͻ'
               and x.zqdm = y.stock_code
             group by x.zqdm, y.stock_name, n.capital_amount
             order by sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price) desc
             
             ) a
     where rownum < 6;
  commit;
  update t_etl_c13_3_je_rh t set t.je=0 where t.je is null;
  commit;
  cisp_etl_gpzy_jyb_rh;
  commit;
  cisp_etl_gpzy_jyb_ljywgm_rh; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll_rh; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1_rh; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2_rh; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_YCL
prompt ========================================
prompt
create or replace procedure cisp_map_hg_c13_3_ycl
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  delete from t_etl_c13_3_ycl t;
  delete from T_BKS_ZYRHHY t
   where not exists (select 1 from t_c13_3_bchy t1 where t1.hth = t.hth);
  commit;

  /*select jyrq,hth,glhth,sbhtxh,htlx,fzjg,khbh,khxm,rcfmc,rcflx,zqdm,zqmc,wtsl,hgsl,ljbfjysl,ljwymcsl,wtje,yhje,dqrq,sjghrq,wtrq,jysc,xsbz,jgbs,hgll,sjghje,yjlx,sfwy
  from T_BKS_ZYRHHY t where where exists (select 1 from t_c13_3_bchy t1 where t1.hth=t.hth);
  
  select * from */

  --ڻ㼰ʽ
  insert into T_ETL_C13_3_YCL
    select t.init_date,
           t.contract_id,
           t.join_contract_id,
           t.REPORT_ID,
           decode(t.SRP_CONTRACT_TYPE, '0', 'ʼͬ', 'ͬ'),
           t2.branch_name,
           t.client_id,
           t4.client_name,
           t3.funder_name,
           decode(t3.FUNDER_TYPE,
                  '01',
                  '֤ȯ˾Ӫ',
                  'ʹӹ˾ʹܿͻ'),
           t1.stock_code,
           t1.stock_name,
           t.ENTRUST_AMOUNT,
           t.BONUS_AMOUNT,
           t.SUM_BACK_AMOUNT,
           t.SUM_SPB_AMOUNT,
           t.ENTRUST_BALANCE,
           t.repaid_balance,
           
           t.date_back,
           t.REAL_DATE_BACK,
           t.entrust_date,
           (case
             when t.exchange_type = 1 then
              'Ϻ'
             when t.exchange_type = 2 then
              ''
           end) as jysc,
           (case
             when t.report_id like '%XL%' or t.stock_property <> '00' then
              ''
             else
              ''
           end) as xsbz,
           (case
             when t4.organ_flag in (1, 3) then
              ''
             else
              ''
           end) as jgbs,
           t.real_year_rate,
           t.real_back_balance,
           t.SETTLE_INTEREST,
           ''
    
      from KODS.A_HS08_SRPCONTRACT t
      left join kods.RZRQ_HS_CLIENT t4
        on t.client_id = t4.client_id
      left join kods.RZRQ_HS_STKCODE t1
        on t.stock_code = t1.stock_code
      left join kods.RZRQ_HS_USER_ALLBRANCH t2
        on t.branch_no = t2.branch_no
      left join kods.A_HS08_GPZY_SRPFUNDER t3
        on t.funder_no = t3.funder_no
     where t3.funder_type in ('01', '05')
       and t.srp_contract_status not in ('4', '5')
       and t.contract_id not in ('2015043000000018',
                                 '2015043000000020',
                                 '2015043000000022',
                                 '2015051100000018',
                                 '2015051100000024',
                                 '2015051100000026',
                                 '2014090300000007',
                                 '2015061100000005',
                                 '2016102500000009',
                                 '2016103100000009',
                                 '2016103100000011',
                                 '2016103100000013',
                                 '2016111000000009',
                                 '2018012400000005',
                                '2018012400000006',
                                '2018022200000001',
                                '2018022200000002',
                                '2018071300000001',
                                '2018071300000002',
                                '2017092100000005',
                                '2017100900000005'
                                 )
     order by t.contract_id;
  commit;

  update t_etl_c13_3_ycl t
     set t.sfwy =
         (select wybs from t_cisp_htwybs t1 where t1.contract_id = t.hth)
   where exists
   (select 1 from t_cisp_htwybs t1 where t1.contract_id = t.hth);
  commit;

  insert into T_BKS_ZYRHHY
    select rownum, t.*, 100000 from T_ETL_C13_3_YCL t order by t.hth;
  commit;

  --
  update T_BKS_ZYRHHY t
     set t.p001 =
         (select tt.xh
            from (select t1.hth, rownum as xh
                    from T_BKS_ZYRHHY t1
                   order by t1.hth) tt
           where tt.hth = t.hth);
  commit;

  if substr(v_bbq_begindate, 5, 6) = '02' then
    delete from t_zyrhhy_khxx t
     where substr(t.bbg, 1, 4) < substr(v_bbq_begindate, 1, 4);
    commit;
  else
    insert into t_zyrhhy_khxx
      (khbh, rcflx, jgbs, bbg)
      select t.khbh, t.rcflx, t.jgbs, substr(v_bbq_begindate, 1, 6)
        from t_bks_zyrhhy t;
    commit;
  end if;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_ZYZJ
prompt =========================================
prompt
create or replace procedure cisp_map_hg_c13_3_zyzj
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  lastbbq                 number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;
    
  select to_char(to_date(v_bbq_begindate, 'yyyymmdd') -1, 'yyyymm') into lastbbq from dual;

  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  --modify zhenyj 20200601 ͻҪɾ8Լ
/*  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',
                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
  --ͻҪ޸
  update kods.A_HS08_SRPCONTRACT t set t.repaid_balance = decode(t.contract_id,'2017012000000005',134500000.00,124450000.00)
  where t.contract_id in ('2017012000000005','2017052300000001');
  commit;*/

  delete from t_etl_c13_3_sl_zyzj;
  delete from t_etl_c13_3_je_zyzj;
  delete from t_etl_c13_3_ywmx1_zyzj;
  delete from t_etl_c13_3_ywmx2_zyzj;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl_zyzj
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
       --and exists (select 1 from t_etl_c13_3_ycl tt where tt.khbm=t.client_id and tt.rcflx='֤ȯ˾Ӫ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl_zyzj
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
       --and exists (select 1 from t_etl_c13_3_ycl tt where tt.khbm=t.client_id and tt.rcflx='֤ȯ˾Ӫ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl_zyzj
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl_zyzj t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl_zyzj
    select case
             when t.jgbs='' then 5
              else 6 end,
           1,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
      where t.rcflx='֤ȯ˾Ӫ'
      and t.khbh in (select distinct t.khbh from T_BKS_ZYRHHY t
                     minus
                     select distinct t.khbh from t_zyrhhy_khxx t where t.bbg=lastbbq)
     group by t.jgbs;
  commit;

  --ĩ
  insert into t_etl_c13_3_sl_zyzj
     select case
             when t.jgbs='' then 5
              else 6 end,
           3,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
      where t.rcflx='֤ȯ˾Ӫ'
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_sl_zyzj
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl_zyzj t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

     --ؽ׽Ԫ 
  insert into t_etl_c13_3_je_zyzj
    select case
             when t.jysc = 'Ϻ' then
              8
             else
              9
           end,
           1,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
     and t.rcflx='֤ȯ˾Ӫ'
     group by t.jysc;
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je_zyzj
    select case
             when t.jysc = 'Ϻ' then
              8
             else
              9
           end,
           3,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
      where t.rcflx='֤ȯ˾Ӫ'
     group by t.jysc;
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 7, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je_zyzj
   select 10, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 30
     and t.rcflx='֤ȯ˾Ӫ'
    ;
  commit;

  -- عʣ1ڣ
  insert into t_etl_c13_3_je_zyzj
    select 11, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 30
       and to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 365
       and t.rcflx='֤ȯ˾Ӫ'
       ;
  commit;

  -- عʣ1
  insert into t_etl_c13_3_je_zyzj
    select 12, 3, sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 365
     and t.rcflx='֤ȯ˾Ӫ'
     ;
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je_zyzj t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je_zyzj
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je_zyzj
    select case
             when t.jgbs='' then 13
              else 14 end,
           1,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
     and t.rcflx='֤ȯ˾Ӫ'
     group by t.jgbs;
  commit;

  --/
  insert into t_etl_c13_3_je_zyzj
    select case
             when t.jgbs='' then 13
              else 14 end,
           3,
           sum(t.wtje - t.yhje)
      from T_BKS_ZYRHHY t
      where t.rcflx='֤ȯ˾Ӫ'
     group by t.jgbs;
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je_zyzj
    select decode(t.jysc, 'Ϻ', '16', 18),
           3,
           sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.rcflx='֤ȯ˾Ӫ'
     group by t.jysc;
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je_zyzj
    select 17,
           3,
           nvl(sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price),0)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.jysc='Ϻ'
       and t.xsbz=''
       and t.rcflx='֤ȯ˾Ӫ';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je_zyzj
     select 19,
           3,
           nvl(sum((t.wtsl + t.hgsl - t.ljbfjysl-t.ljwymcsl) *
               t1.asset_price),0)
      from T_BKS_ZYRHHY t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.zqdm = t1.stock_code
       and decode(t.jysc,'Ϻ','1','2') = t1.exchange_type
       and t.jysc=''
       and t.xsbz=''
       and t.rcflx='֤ȯ˾Ӫ'
       ;
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 15, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je_zyzj
    select decode(t.jgbs, '',21, 22),
           3,
           count(distinct t.khbh)
      from T_BKS_ZYRHHY t
     where t.sfwy=''
     and t.rcflx='֤ȯ˾Ӫ'
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 20, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je_zyzj
    select decode(t.jgbs, '',24, 25),
           3,
           sum(t.wtje-t.yhje)
      from T_BKS_ZYRHHY t
     where t.sfwy=''
     and t.rcflx='֤ȯ˾Ӫ'
     group by t.jgbs;
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 23, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je_zyzj
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je_zyzj
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je_zyzj
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
   select 28 xh,3,
           sum(case
                 when to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') <= 30 then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate and s.rcflx='֤ȯ˾Ӫ';

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  --29 ֤ȯ˾ΪڳۼҵģԪ           
  insert into t_etl_c13_3_je_zyzj
    select 29 xh,3,
           sum(case
                 when (to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') > 30) and 
                      (to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') <= 365)then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate and s.rcflx='֤ȯ˾Ӫ';

  --30 ֤ȯ˾ΪڳۼҵģԪ         
  insert into t_etl_c13_3_je_zyzj
    select 30 xh,3,
           sum(case
                 when to_date(s.dqrq, 'yyyymmdd') -
                      to_date(s.wtrq, 'yyyymmdd') > 365 then --
                  s.wtje
                 else
                  0.0
               end) c
      from T_BKS_ZYRHHY s where s.wtrq between v_bbq_begindate and v_bbq_enddate and s.rcflx='֤ȯ˾Ӫ';

  insert into t_etl_c13_3_je_zyzj
    select 27, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_3_je_zyzj
    select 31,
           0,
           sum(REAL_BACK_BALANCE-ENTRUST_BALANCE+REPAID_BALANCE+SETTLE_INTEREST)
      from (select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status  in ('4')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
    select 33, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.sjghrq < v_bbq_next_enddate
       and t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.rcflx='֤ȯ˾Ӫ'
       and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
  select 34, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.sjghrq > v_bbq_enddate
       and t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.sjghrq between v_bbq_enddate and v_bbq_next_year_enddate
       and t.rcflx='֤ȯ˾Ӫ'
       and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
     select 35, 3, nvl(sum(t.wtje),0)
      from T_BKS_ZYRHHY t
     where t.jyrq between v_bbq_begindate and v_bbq_enddate
       and t.sjghrq > v_bbq_next_year_enddate
       and t.rcflx='֤ȯ˾Ӫ'
        and t.hth in (select t.contract_id from kods.a_hs08_srpcontract t where funder_no not in (1, 71, 81, 91)
                     union
                     select t.contract_id from kods.a_hs08_his_srpcontract t where funder_no not in (1, 71, 81, 91))
       ;
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 32, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je_zyzj
    select 36, 1, nvl(max(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 30
                      and t.rcflx='֤ȯ˾Ӫ'
     ;
  commit;

  --ع     У
  insert into t_etl_c13_3_je_zyzj
    select 36, 2, nvl(min(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 30
                      and t.rcflx='֤ȯ˾Ӫ'
       ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_zyzj
    select 37, 1, nvl(max(t.hgll*100),0)
      from T_BKS_ZYRHHY t
     where (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 30) and
                      (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 365)
                      and t.rcflx='֤ȯ˾Ӫ'
     ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_zyzj
    select 37, 2, nvl(min(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 30) and
                      (to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') <= 365)
                      and t.rcflx='֤ȯ˾Ӫ'
      ;
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je_zyzj
    select 38, 1, nvl(max(t.hgll*100),0)
      from  T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 365
                      and t.rcflx='֤ȯ˾Ӫ'
     ;
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 38, 2, nvl(min(t.hgll*100),0)
      from T_BKS_ZYRHHY t
     where to_date(t.sjghrq, 'yyyymmdd') -
                      to_date(t.wtrq, 'yyyymmdd') > 365
                      and t.rcflx='֤ȯ˾Ӫ'
    ;
  commit;

  insert into t_etl_c13_3_ywmx1_zyzj
   select y.client_id,
           y.client_name,
           sum(x.wtje-x.yhje),
           sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price),
           round(sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price),
                 2) / round(sum(x.wtje-x.yhje), 2) * 100,
           0
      from T_BKS_ZYRHHY x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.khbh = y.client_id
       and x.zqdm = z.stock_code
       and decode(x.jysc,'Ϻ','1',2) = z.exchange_type
       and x.wtrq <= v_bbq_enddate
       and x.sfwy=''
       and x.rcflx='֤ȯ˾Ӫ'
     group by y.client_id, y.client_name having sum(x.wtje-x.yhje)>0
     order by sum(x.wtje-x.yhje) desc;
  commit;

  insert into t_etl_c13_3_ywmx2_zyzj
  select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.zqdm as stock_code,
                   sum(x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) as entrust_amount,
                   sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price) as sz,
                   sum(x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from T_BKS_ZYRHHY x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.zqdm = z.stock_code
               and x.zqdm = n.stock_code
               and decode(x.jysc,'Ϻ','1','2') = z.exchange_type
               and x.wtrq <= v_bbq_enddate
               and x.sfwy=''
               and x.rcflx='֤ȯ˾Ӫ'
               and x.zqdm = y.stock_code
             group by x.zqdm, y.stock_name, n.capital_amount
             order by sum((x.wtsl + x.hgsl-x.ljbfjysl-nvl(x.ljwymcsl,0)) * z.asset_price) desc
             
             ) a
     where rownum < 6;
  commit;
  update t_etl_c13_3_je_zyzj t set t.je=0 where t.je is null;
  commit;
  cisp_etl_gpzy_jyb_zyzj;
  commit;
  cisp_etl_gpzy_jyb_ljywgm_zyzj; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll_zyzj; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1_zyzj; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2_zyzj; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_2
prompt ========================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_2 is
  /***************************************
  *ܣҵ״ԴETL  
  ֱ   3500 20150708
  ***************************************/
  --v_date integer;
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
 -- select max(t1.busi_date) into v_date from a_ksd_his_done t1;
  --ȡڵڼʱ
  /*select to_char(t.p001) || '01'into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.p001) || '31' into v_enddate  from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;*/
 select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;    
-----------------------------------------------------------------------------------------------------
--   ½
-----------------------------------------------------------------------------------------------------
  delete from t_etl_jy;
  commit;
  --A
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,1 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('0','c','e','p')            --֤ͣƱ eƴ p עƴҵ 
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;
  --B
  insert into t_etl_jy
    select decode(t3.organ_flag, '1', 1, '3', 1, '5', 1, '6', 1, 0) as khlx,
           decode(t1.exchange_type, 'H', '2', 'D', '3') zqlx,
           1 jylx,
           sum(t1.business_balance) je
      from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,
           KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,
           KODS.RZRQ_HS_CLIENT           t3
     where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
       and t1.stock_type in ('0') --֤ͣƱ
       and t1.money_type != '0'
       and t3.organ_flag in ('1', '0', '3', '5', '6') ---5 ,6 ̨2020218
       and t1.fund_account = t2.fund_account
       and t1.client_id = t2.client_id
       and t1.client_id = t3.client_id
       and t1.exchange_type in ('H', 'D')
       and t2.asset_prop = '0'
     group by decode(t1.exchange_type, 'H', '2', 'D', '3'),
              decode(t3.organ_flag, '1', 1, '3', 1, '5', 1, '6', 1, 0);
  commit;
--
  insert into t_etl_jy
       select   decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,4 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('6','L','T','j','l','r')--T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF r ʩ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;
  --ETF
  insert into t_etl_jy
    select  0 as khlx,5 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('T')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t2.asset_prop = '0'
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               ;
  commit;
  --LOF
  insert into t_etl_jy
      select  0 as khlx,6 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('L','r') -- r ʩ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
              ;
    commit;

  --ծȯ
  insert into t_etl_jy
    select decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,7 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4050','4151','4152')  --֤ȯ ֤ȯ
               and t1.stock_type in ('9','X','Y','U','u','a')--9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
           group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;
  --Ȩ֤
  insert into t_etl_jy
    select   decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,8 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('D')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;
  

  --۹
  --06۹ȯUF2.0ԴRZRQ_HS_HIS_HISDELIVERȡ
  --add by jiangbt 20150202
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER  t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','c','3')            --֤ͣƱ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('G','S')         ---۹
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;
    --ƾ֤ҵ塢ƴ壩
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('g','q')            --֤ͣqҵƾ֤gƴƾ֤ 
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;

  --ʻع
  insert into t_etl_jy
     select   decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,10 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4003','4089','4103','4149')
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;
  --ȯع
  insert into t_etl_jy
  select   decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx,11 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4004','4090','4104'/*,4140*/) --modify by zhenyj 20190508 4140 ۻع
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,'5',1,'6',1,0);
  commit;
  --Ͻ 
  insert into t_etl_jy
     select   0 as khlx,12 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z','e','g','p','q','r') --r ʩ
               and t1.money_type ='0'
               and t1.op_entrust_way  in ('7','8','9')
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2','G','S')         ---1.Ϻ 2.
               and t2.asset_prop = '0';
  commit;

  --ϽסB
  insert into t_etl_jy
   select   0 as khlx, decode(t1.exchange_type, 'H', '13', 'D', '14') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')
               and t1.money_type !='0'
               and t1.op_entrust_way in ('7','8','9')
               and t3.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')      ---D.Ϻ H.
               and t2.asset_prop ='0'
               group by decode(t1.exchange_type, 'H', '13', 'D', '14');
  commit;

---------------------------------------------------------------------------------------------------------------
--    йֵ
---------------------------------------------------------------------------------------------------------------
  --A-ֵ
  insert into t_etl_jy
    select  khlx, 1 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('0','c','e','p') --e ƴ壬pעƴҵ qҵƾ֤
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0)
          ) t
     group by khlx;
  commit;
  --B-ֵ
  insert into t_etl_jy
   select  khlx,  zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx, 3 zqlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('0') --֤ͣƱ(0)
               and t1.exchange_type in ('D','H')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='1'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0)
          ) t
     group by khlx,zqlx;
  commit;
  ---ֵ
  insert into t_etl_jy
     select  khlx, 4 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('6','L','T','j','l','r')-- r ʩ
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0)
          ) t
     group by khlx;
  commit;
  --ETF-ֵ
  insert into t_etl_jy
    select  0 khlx, 5 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('T'/*,'j','l'*/)
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --LOF
 insert into t_etl_jy
    select  0 khlx, 6 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('L','r') --r ʩ
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --ծȯ
  insert into t_etl_jy
     select  khlx, 7 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('9','X','Y','U','u','a','Z') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0)
          ) t
     group by khlx;
  commit;
  --Ȩ֤
  insert into t_etl_jy
     select  khlx, 8 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
              decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('D')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0)
          ) t
     group by khlx;

  insert into t_etl_jy
     select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t1.exchange_type in ('G','S') --ͨ
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0)
          ) t
     group by khlx;
     
  commit;
  --ƴƾ֤-ֵ
  insert into t_etl_jy
    select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('g','q') --qҵƾ֤ gƴƾ֤
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3','5','6')---5 ,6 ̨2020218
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and t1.CURRENT_AMOUNT>0
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,'5',1,'6',1,0)
          ) t
     group by khlx;
     commit;
-------------------------------------------------------------------------------------------
--  
-------------------------------------------------------------------------------------------
delete from t_etl_bczl where jylx=1;
commit;


--ڴɷתý׽
insert into t_etl_bczl(jylx,je,bz)
   select 1 jylx, sum(je) je, 0 bz  from (
      select   decode(t1.money_type, '1', t1.business_balance*s.a002,
                '2',t1.business_balance*s.a003,t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1, t_bks_t007 s
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','z')           --֤ͣƱ۹ɷ
               and t1.exchange_type in ('9','A')
            ) t;
commit;

  cisp_etl_zqjy;
  commit;
  cisp_etl_bczl;
  commit;
end ;
/

prompt
prompt Creating procedure CISP_MAP_JJYW_C1_3
prompt =====================================
prompt
create or replace procedure cisp_map_jjyw_c1_3 is
  /***************************************
  *ܣҵ-̨ҵԴETL
  ***************************************/

   v_begindate varchar2(8);
   v_enddate   varchar2(8);

begin
 --ȡڵڼʱ
  select to_char(a005,'YYYYMMDD') into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(a006,'YYYYMMDD') into v_enddate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  -------------------------------------------------------------------------
  --  ۻ
  -------------------------------------------------------------------------
  delete from t_etl_dxjj;
  commit;
  -- ׽
insert into t_etl_dxjj
   select dljy, yjsr
      from  (select a.dljy as dljy,b.yjsr as yjsr from (select sum(BUSINESS_BALANCE) dljy  from kods.a_hs_his_secumdealinfo a
    where business_flag in ('44122','44139','44130')
      and prod_code in  (select jjdm from t_bks_t100 where fxzl=11)
       )a,
       (select sum(yjsr) as yjsr from( select  sum(fare_sx) yjsr from kods.a_hs_his_secumdealinfo
       where business_flag in ('44122','44139','44130')
       and prod_code in  (select jjdm from t_bks_t100 where fxzl=11)
      )
     )b
     ) x;
  commit;

  ----------------------------------------------------------------------------
  -- ʲҵƷ
  ----------------------------------------------------------------------------
  delete from t_etl_dxzcgl;
  commit;
  --׽
  insert into t_etl_dxzcgl
     select dljy, yjsr
      from  (select a.dljy as dljy,b.yjsr as yjsr from (
     select sum(dljy) as dljy from (/*select sum(balance) dljy  from kods.a_hs08_his_ofdeliver a
    where business_flag in ('122','139','130')
      and fund_code in  (select jjdm from t_bks_t100 where fxzl=13)
      union all*/
      select sum(abs(a.BUSINESS_BALANCE)) dljy  from kods.a_hs_his_secumdealinfo a
    where business_flag in ('44122','44130','44139')
      and prod_code in  (select jjdm from t_bks_t100 where fxzl=13) )
       )a,
       (select sum(yjsr) as yjsr from( 
       /*select  sum(fare_sx) yjsr from kods.a_hs08_his_ofdeliver 
       where business_flag in ('122','139','130'\*,'124','142','150'*\)
       and fund_code in  (select jjdm from t_bks_t100 where fxzl=13)
       union all*/
       select sum(fare_sx) yjsr from kods.a_hs_his_secumdeliver a
      where business_flag in ('44122','44130','44139'/*,'44124','44150','44142'*/)
        and prod_code in  (select jjdm from t_bks_t100 where fxzl=13) 
        and a.business_balance<>0)
     )b
     ) x;
  commit;
  -------------------------------------------------------------------------
  --  ۻ
  -------------------------------------------------------------------------
  delete from t_etl_qtjj;
  commit;
  -- ׽
insert into t_etl_qtjj
    select a.dljy,b.yjsr from(select sum(dljy) as dljy from 
      (/*select sum(balance) dljy  from kods.a_hs08_his_ofdeliver 
    where business_flag in ('122','139','130')
      and fund_code in  (select jjdm from t_bks_t100 where fxzl in (15,16,17)and fsfl=42)
      union all*/
      select sum(abs(BUSINESS_BALANCE)) dljy  from kods.a_hs_his_secumdealinfo
    where business_flag in ('44122','44130','44139')
      and prod_code in  (select jjdm from t_bks_t100 where fxzl in (15,16,17) and fsfl=42)
      union all
      select sum(abs(entrust_amount)) dljy  from kods.a_hs_his_bankmdeliver 
    where business_flag in ('43130')
      and prod_code in  (select jjdm from t_bks_t100 where fxzl in (14) and fsfl=42 )))a,
       (select sum(yjsr) as yjsr from (
       /*select  sum(fare_sx) yjsr from kods.a_hs08_his_ofdeliver 
       where business_flag in ('122','139','130'\*,'124','150'*\)
       and fund_code in  (select jjdm from t_bks_t100 where fxzl in (14,15,16,17) and fsfl=42)
       union all*/
       select sum(fare_sx) yjsr from kods.a_hs_his_secumdeliver a
      where business_flag in ('44122','44130','44139')
        and prod_code in  (select jjdm from t_bks_t100 where fxzl in (14,15,16,17) and fsfl=42) 
        and a.business_balance<>0
     ))b;
     
  commit;

  cisp_etl_dxjj;
  commit;
  cisp_etl_dxzcgl;
  commit;
  cisp_etl_dxgz;
  commit;
  cisp_etl_dxqtz;
  commit;
  cisp_etl_dldfgz;
  commit;
  cisp_etl_dldfqtz;
  commit;
  cisp_etl_qtjj;
  commit;
end;
/

prompt
prompt Creating procedure T_ETL_WDQ
prompt ============================
prompt
create or replace procedure t_etl_wdq is

    v_bmid number;  --ID
    v_count number;
begin
   ----------------------Ѻʽծȯعʲ
  delete from T_DB_09_001 where w100 = 50004; --ֻɾŵ
  commit;

--δ Ӫ
  insert into T_DB_09_001
              (P001  ,--  Ŀ
              A002  ,--  Ͻĩδڽ
              A003  ,--  ĩδڽ
              A004  ,--  мгĩδڽ
              A007  ,--  Ͻ·ܶ
              A008  ,--  ·ܶ
              A009  ,--  мг·ܶ
              A010  ,--  ϽۼƱ귢ܶ
              A011  ,--  ۼƱ귢ܶ
              A012  ,--  мۼƱ귢ܶ
              A100  ,--  
              W100   --  ܲID
              )
  select case when t.xm=1  then 1001 --ծʻع
              when t.xm=3  then 1002 --ծȯع
         end as P001
        ,abs(t.shajswdq)  as A002
        ,abs(t.shejswdq)  as A003
        ,abs(t.yhjwdq)  as A004
        ,abs(t.byshajsfse)  as A007
        ,abs(t.byshejsfse)  as A008
        ,abs(t.byyhjfse)  as A009
        ,abs(t.bnshajsfse-t.byshajsfse) as A010
        ,abs(t.bnshejsfse-t.byshejsfse) as A011
        ,abs(t.bnyhjfse-t.byyhjfse) as A012
        ,100000 as A100
        ,50004 as W100
    from t_etl_c7_1_ymwdqje t
   where t.xm in (1,3)
   ;
   commit;

 delete from T_DB_09_003 where w100 = 50004; --ֻɾŵ
  commit;
--δ ҵ
 insert into T_DB_09_003
              (P001  ,--  Ŀ
              A002  ,--  Ͻĩδڽ
              A003  ,--  ĩδڽ
              A004  ,--  мгĩδڽ
              A007  ,--  Ͻ·ܶ
              A008  ,--  ·ܶ
              A009  ,--  мг·ܶ
              A010  ,--  ϽۼƱ귢ܶ
              A011  ,--  ۼƱ귢ܶ
              A012  ,--  мۼƱ귢ܶ
              A100  ,--  
              W100   --  ܲID
              )
  select case when t.xm=2  then 1001 --ծʻع  
              when t.xm=4  then 1002 --ծȯع  
         end as P001
        ,abs(t.shajswdq)  as A002
        ,abs(t.shejswdq)  as A003
        ,abs(t.yhjwdq)  as A004
        ,abs(t.byshajsfse)  as A007
        ,abs(t.byshejsfse)  as A008
        ,abs(t.byyhjfse)  as A009
        ,abs(t.bnshajsfse-t.byshajsfse) as A010
        ,abs(t.bnshejsfse-t.byshejsfse) as A011
        ,abs(t.bnyhjfse-t.byyhjfse) as A012
        ,100000 as A100
        ,50004 as W100
    from t_etl_c7_1_ymwdqje t
   where t.xm in (2,4)
   ;
   commit;



  --
  --Ӫ
 /* delete from T_DB_10_001 where w100 = 50004; --ֻɾŵ;
  insert into T_DB_10_001
              (P001,--Ŀ
              A002,--ܶ
              A003,--Ͻ
              A004,--
              A005,--мг
              A100,--
              W100--ܲID
              )
  select case when t.xm=1 then 1001  --ծйܽֵ
              when t.xm=2 then 1003  --ծ׼ȯйܽ
              when t.xm=3 then 1004  --ҵծйܽֵ
              when t.xm=4 then 1006  --ҵծ׼ȯйܽ
         end as P001
        ,sum(tgjeze ) as A002
        ,sum(shajstgje )as A003
        ,sum(shejstgje )as A004
        ,sum(yhjtgje )as A005
        ,100000 as A100
        ,50004 as W100
    from T_ETL_C7_1_bczl t
   group by t.xm
   ;
   commit;*/
/*
1001  ծйܽֵ
1002  ծعǼǽֵ
1003  ծ׼ȯйܽ
1004  ҵծйܽֵ
1005  ҵծعǼǽֵ
1006  ҵծ׼ȯй
1099  */

 --ҵ
  delete from T_DB_10_003 where w100 = 50004; --ֻɾŵ;
  insert into T_DB_10_003
              (P001,--Ŀ
              A002,--ܶ
              A003,--Ͻ
              A004,--
              A005,--мг
              A100,--
              W100--ܲID
              )
  select case when t.xm=1 then 1001  --ծйܽֵ
              when t.xm=2 then 1003  --ծ׼ȯйܽ
              when t.xm=3 then 1004  --ҵծйܽֵ
              when t.xm=4 then 1006  --ҵծ׼ȯйܽ
         end as P001
        ,sum(nvl(tgjeze,0)) as A002
        ,sum(nvl(shajstgje,0) )as A003
        ,sum(nvl(shejstgje,0) )as A004
        ,sum(nvl(yhjtgje,0) )as A005
        ,100000 as A100
        ,50004 as W100
    from T_ETL_C7_1_bczl t
   group by t.xm
   ;
   commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_JJYW_C7_1
prompt =====================================
prompt
create or replace procedure cisp_map_jjyw_c7_1
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION: C7-1ծȯعҵܱ-Ѻʽծȯع   ͶӰetl
  -- RETURN:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
 is
  v_bbq           varchar2(6);--
  v_bbq_begindate varchar2(8);
  v_bbq_enddate   varchar2(8);
  v_bbqqsrq         number; --ȡһ
  v_endbusinessdate number; --ȡڵһ
  v_bnfirstdate     number; --ȡ
  V_bmid          varchar2(32);--id

begin
   --ȡڵڼʱ
      select
          to_number(to_char(a005, 'yyyy'))||'0101', 
          to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_bnfirstdate,v_bbq_begindate, v_bbq_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;
   select max(clear_date) into v_bbqqsrq from kods.xy_hs08_std_bond_balance;

delete from t_etl_c7_1_ymwdqje;
delete from T_ETL_C7_1_bczl;
delete from t_etl_zyszqhg_zy_gs;
commit;



--ʻع Ӫ
   insert into t_etl_c7_1_ymwdqje(xm,shajswdq,shejswdq,yhjwdq,byshajsfse,byshejsfse,byyhjfse,bnshajsfse,bnshejsfse,bnyhjfse,khlb,zqlb)
    SELECT 
               case when A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '01' /*and NVL(E.INV_PROP, '0')='1' */then 1  --ծ Ӫ 
                    --when A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '01' and NVL(E.INV_PROP, '0')='0' then 2  --ծ 
                    when A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '01' /*and NVL(E.INV_PROP, '0')='1' */then 3  --ծȯ Ӫ 
                   -- when A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '01' and NVL(E.INV_PROP, '0')='0' then 4  --ծȯ 
                else null
                end as xm,
               sum(CASE
                   WHEN A.MKT_CODE = '01' AND EXCH_DATE <= v_bbq_enddate AND
                        BACK_BUY_DATE > v_bbq_enddate THEN
                    A.EXCH_QTY
                   ELSE
                    0
               END) AS "ĩδڽ(Ϻ)",
               sum(CASE
                   WHEN A.MKT_CODE = '02' AND EXCH_DATE <= v_bbq_enddate AND
                        BACK_BUY_DATE > v_bbq_enddate THEN
                    DECODE(A.BUY_BACK_MODE, 'S', A.EXCH_QTY * 100, A.EXCH_QTY)
                   ELSE
                    0
               END) AS "ĩδڽ()",
                0 , --ĩδڽм䣩
               sum(CASE
                   WHEN A.MKT_CODE = '01' AND EXCH_DATE BETWEEN v_bbq_begindate AND
                        v_bbq_enddate THEN
                    A.EXCH_QTY
                   ELSE
                    0
               END) AS "·ۼ(Ϻ)",

               sum(CASE
                   WHEN A.MKT_CODE = '02' AND EXCH_DATE BETWEEN v_bbq_begindate AND
                        v_bbq_enddate THEN
                    DECODE(A.BUY_BACK_MODE, 'S', A.EXCH_QTY * 100, A.EXCH_QTY*100)
                   ELSE
                    0
               END) AS "·ۼ()",
                0 , --·ۼƣм䣩
               sum(CASE
                   WHEN A.MKT_CODE = '01' AND EXCH_DATE BETWEEN v_bnfirstdate AND
                        v_bbq_enddate THEN
                    A.EXCH_QTY
                   ELSE
                    0
               END) AS "귢ۼ(Ϻ)",

               sum(CASE
                   WHEN A.MKT_CODE = '02' AND EXCH_DATE BETWEEN v_bnfirstdate AND
                        v_bbq_enddate THEN
                    DECODE(A.BUY_BACK_MODE, 'S', A.EXCH_QTY * 100, A.EXCH_QTY*100)
                   ELSE
                    0
               END) AS "귢ۼ()",
               0 , --귢ۼƣм䣩
              /* DECODE(NVL(E.INV_PROP, '0'),
                      '0',
                      'Ϳͻ',
                      '1',
                      'Ӫ',
                      '2',
                      'Ͷʹͻ') AS INV_PROP_NAME*/
                'Ӫ',
              -- A.BUY_BACK_MODE,
               (CASE
                   WHEN A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '01' THEN
                    'ծʻع'
                   WHEN A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '02' THEN
                    'ҵծʻع'
                   WHEN A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE NOT IN ('01', '02') THEN
                    'ծȯʻع'
                   WHEN A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '01' THEN
                    'ծȯع'
                   WHEN A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '02' THEN
                    'ҵծȯع'
                   WHEN A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE NOT IN ('01', '02') THEN
                    'ծȯȯع'
                   ELSE
                    ''
               END) AS "Ŀ"
          FROM (SELECT *
                  FROM KODS.XY_HS08_NAT_BOND_BUY_BACK
                 WHERE SETTLE_ENTITY_ID = '1'
                   AND (BUY_BACK_TYPE in ('001','002','003','004'))
                UNION ALL
                SELECT *
                  FROM KODS.XY_HS08_NAT_BOND_BUY_BACK_H
                 WHERE SETTLE_ENTITY_ID = '1'
                   AND ( BUY_BACK_TYPE in ('001','002','003','004'))) A,
               KODS.XY_HS08_BR_SEC_TYPE_RULE B,
               KODS.XY_HS08_INV_ACC E
         WHERE A.MKT_CODE = B.MKT_CODE
           AND (/*A.SETTLE_DEPT_CODE not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22') 
               or*/ A.SETTLE_DEPT_CODE in ('DBZQZY0888','DBZQZY0889','DBZQZY0890') 
               )
           AND A.SEC_CODE BETWEEN SEC_CODE_BEG AND SEC_CODE_END
           AND A.MKT_CODE = E.MKT_CODE(+)
           AND A.INV_ACC = E.INV_ACC(+)
           AND A.BUY_BACK_MODE in ('B','S')
           AND A.BOND_TYPE in ('01','02')
           AND (A.EXCH_DATE BETWEEN LEAST(v_bbq_begindate, v_bnfirstdate) AND
               GREATEST(v_bbq_enddate, v_bbq_enddate) OR
               (A.EXCH_DATE <= v_bbq_enddate AND A.BACK_BUY_DATE > v_bbq_enddate))
           AND NVL(E.INV_PROP, '0') IN ('0', '1', '2')
         group by /*NVL(E.INV_PROP, '0'),*/A.BUY_BACK_MODE,A.BOND_TYPE
         union all
         --ҵ
         SELECT 
               case --when A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '01' and NVL(E.INV_PROP, '0')='1' then 1  --ծ Ӫ 
                    when A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '01' /*and NVL(E.INV_PROP, '0')='0'*/ then 2  --ծ 
                    --when A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '01' and NVL(E.INV_PROP, '0')='1' then 3  --ծȯ Ӫ 
                   when A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '01' /*and NVL(E.INV_PROP, '0')='0'*/ then 4  --ծȯ 
                else null
                end as xm,
               sum(CASE
                   WHEN A.MKT_CODE = '01' AND EXCH_DATE <= v_bbq_enddate AND
                        BACK_BUY_DATE > v_bbq_enddate THEN
                    A.EXCH_QTY
                   ELSE
                    0
               END) AS "ĩδڽ(Ϻ)",
               sum(CASE
                   WHEN A.MKT_CODE = '02' AND EXCH_DATE <= v_bbq_enddate AND
                        BACK_BUY_DATE > v_bbq_enddate THEN
                    DECODE(A.BUY_BACK_MODE, 'S', A.EXCH_QTY * 100, A.EXCH_QTY)
                   ELSE
                    0
               END) AS "ĩδڽ()",
                0 , --ĩδڽм䣩
               sum(CASE
                   WHEN A.MKT_CODE = '01' AND EXCH_DATE BETWEEN v_bbq_begindate AND
                        v_bbq_enddate THEN
                    A.EXCH_QTY
                   ELSE
                    0
               END) AS "·ۼ(Ϻ)",

               sum(CASE
                   WHEN A.MKT_CODE = '02' AND EXCH_DATE BETWEEN v_bbq_begindate AND
                        v_bbq_enddate THEN
                    DECODE(A.BUY_BACK_MODE, 'S', A.EXCH_QTY * 100, A.EXCH_QTY*100)
                   ELSE
                    0
               END) AS "·ۼ()",
                0 , --·ۼƣм䣩
               sum(CASE
                   WHEN A.MKT_CODE = '01' AND EXCH_DATE BETWEEN v_bnfirstdate AND
                        v_bbq_enddate THEN
                    A.EXCH_QTY
                   ELSE
                    0
               END) AS "귢ۼ(Ϻ)",

               sum(CASE
                   WHEN A.MKT_CODE = '02' AND EXCH_DATE BETWEEN v_bnfirstdate AND
                        v_bbq_enddate THEN
                    DECODE(A.BUY_BACK_MODE, 'S', A.EXCH_QTY * 100, A.EXCH_QTY*100)
                   ELSE
                    0
               END) AS "귢ۼ()",
               0 , --귢ۼƣм䣩
              /* DECODE(NVL(E.INV_PROP, '0'),
                      '0',
                      'Ϳͻ',
                      '1',
                      'Ӫ',
                      '2',
                      'Ͷʹͻ') AS INV_PROP_NAME*/
                '',
              -- A.BUY_BACK_MODE,
               (CASE
                   WHEN A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '01' THEN
                    'ծʻع'
                   WHEN A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE = '02' THEN
                    'ҵծʻع'
                   WHEN A.BUY_BACK_MODE = 'B' AND A.BOND_TYPE NOT IN ('01', '02') THEN
                    'ծȯʻع'
                   WHEN A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '01' THEN
                    'ծȯع'
                   WHEN A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE = '02' THEN
                    'ҵծȯع'
                   WHEN A.BUY_BACK_MODE = 'S' AND A.BOND_TYPE NOT IN ('01', '02') THEN
                    'ծȯȯع'
                   ELSE
                    ''
               END) AS "Ŀ"
          FROM (SELECT *
                  FROM KODS.XY_HS08_NAT_BOND_BUY_BACK
                 WHERE SETTLE_ENTITY_ID = '1'
                   AND (BUY_BACK_TYPE in ('001','002','003','004'))
                UNION ALL
                SELECT *
                  FROM KODS.XY_HS08_NAT_BOND_BUY_BACK_H
                 WHERE SETTLE_ENTITY_ID = '1'
                   AND ( BUY_BACK_TYPE in ('001','002','003','004'))) A,
               KODS.XY_HS08_BR_SEC_TYPE_RULE B,
               KODS.XY_HS08_INV_ACC E
         WHERE A.MKT_CODE = B.MKT_CODE
           AND (A.SETTLE_DEPT_CODE not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22') 
               /*or A.SETTLE_DEPT_CODE in ('DBZQZY0888','DBZQZY0889','DBZQZY0890') */
                )
           AND A.SEC_CODE BETWEEN SEC_CODE_BEG AND SEC_CODE_END
           AND A.MKT_CODE = E.MKT_CODE(+)
           AND A.INV_ACC = E.INV_ACC(+)
           AND A.BUY_BACK_MODE in ('B','S')
           AND A.BOND_TYPE in ('01','02')
           AND (A.EXCH_DATE BETWEEN LEAST(v_bbq_begindate, v_bnfirstdate) AND
               GREATEST(v_bbq_enddate, v_bbq_enddate) OR
               (A.EXCH_DATE <= v_bbq_enddate AND A.BACK_BUY_DATE > v_bbq_enddate))
           AND NVL(E.INV_PROP, '0') IN ('0', '1', '2')
         group by /*NVL(E.INV_PROP, '0'),*/A.BUY_BACK_MODE,A.BOND_TYPE
         
         ;
       commit;



--

--ծйܽ(ֵ)

 insert into T_ETL_C7_1_bczl     
   SELECT 1 xm,
       sum(case when t.mkt_code ='01' then nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)
                when t.mkt_code ='02' then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100
           else 0 end) as tgjeze,
       nvl(sum(case when t.mkt_code  = '01'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100 end),0) as shejystgje,
       0 yhj
   FROM kods.xy_hs08_inv_bond_balance t
  WHERE t.mkt_code in('02','01')--Ϻ
    and t.inv_prop='0'
    and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
    --and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
    --AND CLEAR_DATE = v_bbqqsrq
    ;
  commit;

--ծ׼ȯйܽ
 insert into T_ETL_C7_1_bczl
   SELECT 2 xm,
       sum(case when t.mkt_code ='01' then t.std_bond_bal
                when t.mkt_code ='02' then t.std_bond_bal*100
           else 0 end) as tgjeze,
       nvl(sum(case when t.mkt_code  = '01'    then nvl(t.std_bond_bal,0) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then nvl(t.std_bond_bal,0)*100 end),0) as shejystgje,
       0 yhj
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       and t.inv_prop='0'
       AND buy_back_type  in ( '001','002','003','004') --δ
       and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       --and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
       --and t.clear_date=v_bbqqsrq
       ;
       commit;

--ծйܽ(ֵ)
insert into T_ETL_C7_1_bczl
  SELECT 3 xm,
       sum(case when t.mkt_code ='01' then nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)
                when t.mkt_code ='02' then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100
           else 0 end) as tgjeze,
       nvl(sum(case when t.mkt_code  = '01'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100 end),0) as shejystgje,
       0 yhj
   FROM kods.xy_hs08_inv_bond_balance t
  WHERE t.mkt_code in('02','01')--Ϻ
    and t.inv_prop='0'
    and t.bond_type in (/*'01',*/'02'/*,'03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
    --and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
    --AND CLEAR_DATE = v_bbqqsrq
    ;
  commit;


--ծ׼ȯйܽ
 insert into T_ETL_C7_1_bczl
SELECT 4 xm,
       sum(case when t.mkt_code ='01' then t.std_bond_bal
                when t.mkt_code ='02' then t.std_bond_bal*100
           else 0 end) as tgjeze,  --׼ȯֶSTD_BOND_BALֶλܼȥ׼ȯֶSTD_BOND_AVA_BAL
       nvl(sum(case when t.mkt_code  = '01'    then nvl(t.std_bond_bal,0) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then nvl(t.std_bond_bal,0)*100 end),0) as shejystgje,
       0 yhj
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       AND (buy_back_type  in ( '001','002','003','004') or  buy_back_type is null)--δ
       and t.inv_prop ='0'
       and t.bond_type in (/*'01'*/'02'/*,'03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       --and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
       --and t.clear_date=v_bbqqsrq
       ;
       commit;

--ʻع 
insert into t_etl_zyszqhg_zy_gs
     select item,
           p_class,
           sum(ordamount_wdq) as ordamount_wdq,
           sum(ordamount_wdq_shg) as ordamount_wdq_shg,
           sum(ordamount_wdq_she) as ordamount_wdq_she,
           sum(ordamount_wdq_cnbd) as ordamount_wdq_cnbd,
           sum(ordamount_y) as ordamount_y,
           sum(ordamount_y_shg) as ordamount_y_shg,
           sum(ordamount_y_she) as ordamount_y_she,
           sum(ordamount_y_cnbd) as ordamount_y_cnbd
      from (select decode(a.trdtype, '40', '1', '2') as item, --1ʻعȯع
                   case
                     when d.p_class = 'ծ' then
                      '1'
                     when d.p_class = 'ծ' or d.p_class is null then
                      '2'
                     else
                      '3'
                   end as p_class, --1 ծ 2ծ 3ծȯ
                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') then
                      case
                        when a.m_type = 'X_CNBD' then
                         c.disamount
                        else
                         b.amount
                      end
                     else
                      0
                   end ordamount_wdq, --δ:ܶ
                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') and a.m_type = 'XSHG' then
                      b.amount
                     else
                      0
                   end ordamount_wdq_shg, --δ:Ͻ
                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') and a.m_type = 'XSHE' then
                      b.amount
                     else
                      0
                   end ordamount_wdq_she, --δ:

                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') and a.m_type = 'X_CNBD' then
                      c.disamount
                     else
                      0
                   end ordamount_wdq_cnbd, --δ:м

                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate then
                      case
                        when a.m_type = 'X_CNBD' then
                         c.disamount
                        else
                         b.amount
                      end
                     else
                      0
                   end ordamount_y, --귢ۼ:ܶ
                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate and a.m_type = 'XSHG' then
                      b.amount
                     else
                      0
                   end ordamount_y_shg, --귢ۼ:Ͻ
                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate and a.m_type = 'XSHE' then
                      b.amount
                     else
                      0
                   end ordamount_y_she, --귢ۼ:

                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate and a.m_type = 'X_CNBD' then
                      c.disamount
                     else
                      0
                   end ordamount_y_cnbd --귢ۼ:м

              from kods.ht_ttrd_otc_trade a
             inner join kods.ht_ttrd_otc_iblb b
                on a.i_code = b.i_code
              left join kods.ht_ttrd_otc_pledgebond c
                on a.i_code = c.i_code
              left join kods.ht_vbond_include_issue d
                on c.p_i_code = d.i_code
               and c.p_a_type = d.a_type
               and c.p_m_type = d.m_type
             where a.trdtype in ('40', '41')
               and a.ordstatus = 7
               and b.p_class='Ѻʽع'
               and a.sysordid != a.union_sysordid
               and ((replace(b.fstsetdate,'-','') between
                   substr(v_bbq_enddate, 1, 4) || '0101' and v_bbq_enddate) or
                   (replace(b.fstsetdate,'-','') < substr(v_bbq_enddate, 1, 4) || '0101' and
                   replace(b.endsetdate,'-','') >= substr(v_bbq_enddate, 1, 4) || '0101'))
                   ) t
     group by item, p_class;
     
commit;

 t_etl_wdq;
 commit;


END ;
/

prompt
prompt Creating procedure CISP_MAP_JJYW_SFCG
prompt =====================================
prompt
create or replace procedure cisp_map_jjyw_sfcg is
  v_bbq_begindate int;
  v_bbq_enddate   int;
  v_bbq           varchar2(8);
  v_sqsl          int;
  v_bmid          varchar2(12);
begin


  select to_number(to_char(a005, 'YYYYMMDD')),
         to_number(to_char(a006, 'YYYYMMDD')),
         to_char(a005, 'YYYYMM') || '--'
    into v_bbq_begindate, v_bbq_enddate, v_bbq
    from t_b00_d004
   where c001 = 1001101
     and d100 = 1006002
     and a002 = 1013001;
     v_bmid:=50001;

  select nvl(b4,0)
    into v_sqsl
    from t_csrc0710_0_6
   where userid = v_bmid
     and bbq = (select max(substr(bbq, 1, 6) || '--')
                  from t_csrc0710_0_6
                 where substr(bbq, 1, 6) < substr(v_bbq, 1, 6));

  delete from t_etl_sfcg;
  commit;

  insert into t_etl_sfcg t
    (moneytype, fundbal)
    SELECT 1 as moneytype, count(distinct a.fund_account) as sl
      FROM KODS.RZRQ_HS_BANKEXCHACCOUNT a, KODS.RZRQ_HS_BANKARG b,KODS.RZRQ_HS_FUND_FUNDACCOUNT c
     WHERE a.money_type = '0'
       and a.bank_no = b.bank_no
       and bank_type = '2'
       and a.fund_account = c.fund_account
       and c.fundacct_status='0'
       and c.main_flag='1'
       --and a.branch_no not in (88, 99)
  union all
    select 2 as moneytype, count(a.fund_account) - v_sqsl as sl
      FROM KODS.RZRQ_HS_BANKEXCHACCOUNT a, KODS.RZRQ_HS_BANKARG b,KODS.RZRQ_HS_FUND_FUNDACCOUNT c
     WHERE money_type = '0'
       and a.bank_no = b.bank_no
       and bank_type = '2'
       and a.fund_account = c.fund_account
       and c.fundacct_status='0'
       and c.main_flag = '1'
       --and a.branch_no not in (88, 99)
    union all
    SELECT 3 as moneytype, sum(a.occur_balance) as je
      FROM kods.A_HS08_HIS_OPERATIONTOTAL a, KODS.RZRQ_HS_BANKARG b
     where a.init_date = (select max(init_date)
                            from kods.A_HS08_HIS_OPERATIONTOTAL
                           where init_date <= v_bbq_enddate and op_branch_no <>'8888')
       --and a.branch_no not in (88, 99)
       AND money_type = '0'
       and BUSINess_flag = 5201
       and a.bank_no = b.bank_no
       and bank_type = '2';

  commit;

  cisp_etl_sfcg;
  commit;
end cisp_map_jjyw_sfcg;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A3_1
prompt ====================================
prompt
create or replace procedure cisp_map_yyb_a3_1 is
  /********************************************************************
  *ܣӪҵʻԴETL
  *ʱ䣺2015-09-08
  *
  *********************************************************************/

  v_begindate varchar2(8);
  v_enddate   varchar2(8);
  v_last_month_workday number;  

begin

  --ȡڵڼʱ
     select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

  --ȡһ
  select max(phydate)
    into v_last_month_workday
    from krcs.t_krcs_trdcalendar
   where phydate < v_begindate
     and businessflag = 1;

   --˻
  delete from t_etl_yyb_zjzh;
  commit;
  --ͳʽ˻
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 1 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;

--ʽ˻Ͽ
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 12 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             --and a.open_type = '2'
             and a.op_entrust_way = '7'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;
--ʽ˻֤
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 13 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('0')
             --and a.open_type = '1'
             and a.op_entrust_way = 'O'
             group by a.branch_no;
  commit;
  
  --ʽ˻
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 22 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1002'
             and a.op_entrust_way = '7'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;


--ͳʽ˻ĩ
  insert into t_etl_yyb_zjzh
   select a.branch_no as yyb, decode(b.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx , 3 jylx ,9 as bz,
  count(distinct a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,
             kods.rzrq_hs_client b,
             --kods.rzrq_hs_fund_fund c
             kods.v_rzrq_hs_fund_fund c --ӻ̨ 20200331 zhenyj
             where   a.client_id=b.client_id
             and a.client_id = c.client_id
             and a.branch_no=b.branch_no
             and a.fundacct_status<>'3'
             --and c.money_type = '0'
             and a.open_date < = v_enddate
             and b.organ_flag in ('1','0','3','5','6')
             and a.asset_prop in ('0'/*,'7'*/)
             group by a.branch_no,decode(b.organ_flag,'1',1,'3',1,'5',1,'6',1,0) ;
  commit;

  delete from t_etl_yyb_zqzh;
  commit;

   --ͳ֤ȯ˻
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           1 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a,
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.init_date  between  v_begindate  and  v_enddate
               and a.business_flag in ('1104','1101')
               and a.exchange_type in ('1','2','D','H')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and c.organ_flag in ('1','0','3','5','6')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0),t.bz;
  commit;


     --ͳ֤ȯ˻Ͽ
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           12 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, 
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.Init_Date  between  v_begindate  and  v_enddate
               and a.exchange_type in ('1','2','D','H')
               and a.business_flag in ('1104','1101')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.op_entrust_way = '7') t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0),t.bz;
     commit;

     --ͳ֤ȯ˻Ӽ֤
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           13 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, 
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.init_date  between  v_begindate  and  v_enddate
               and a.business_flag in ('1104','1101')
               and a.exchange_type in ('1','2','D','H')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.op_entrust_way ='O') t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0),t.bz;

     --ͳ֤ȯ˻ڼ
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           22 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, 
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.Init_Date  between  v_begindate  and  v_enddate
               and a.exchange_type in ('1','2','D','H')
               and a.business_flag in ('1102')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.op_entrust_way = '7') t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0),t.bz;
     commit;

   --ͳ֤ȯ˻ĩ
  insert into t_etl_yyb_zqzh
   select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           3 as jylx,
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a,  --ӻ̨ 20200331 zhenyj
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and (a.exchange_type in ('1','2') and b.fundacct_status<>'3'
               -- or a.exchange_type in ('D','H') and b.fundacct_status='0')
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and b.open_date < =v_enddate
               and c.organ_flag in ('1','0','3','5','6')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0),t.bz;
     commit;

 --ͳƻʻ
 delete t_etl_yyb_jjzh ;
 commit;
 insert into t_etl_yyb_jjzh
    select yyb,0,1,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a 
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' or substr(a.stock_account,1,3)='001' 
               or a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;


    --ͳƻʻϿ
  insert into t_etl_yyb_jjzh
    select yyb,0,12,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               OR substr(a.stock_account,1,3)='001' 
               OR a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.op_entrust_way = '7'
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and  a.op_entrust_way in ('7','8')
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;

     --ͳƻʻ֤
  insert into t_etl_yyb_jjzh
    select yyb,0,13,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               or substr(a.stock_account,1,3)='001' 
               or a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.op_entrust_way = 'O'
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and a.prodta_no  in ('98','99')
               and a.op_entrust_way='4'
               )t
     group by t.yyb) group by yyb;
     commit;
     
 --˻  
insert into t_etl_yyb_jjzh  
 select yyb,0,22,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               OR substr(a.stock_account,1,3)='001' 
               OR a.stock_account  like '05%')
               and a.business_flag in ('1102')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.op_entrust_way = '7' --
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44102'
               and  a.asset_prop in ('0')
               and  a.op_entrust_way in ('7') --
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;
     
--ͳƻʻĩ
 insert into t_etl_yyb_jjzh
   select yyb,khlx,3,sum(sl) from
      (select t.yyb yyb, decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.stock_account like 'F%' 
               --and substr(a.stock_account,1,3)='001' 
               --and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0','7')
               and b.open_date <=v_enddate
               and c.organ_flag in('1','0','3','5','6')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0)
      union all
      select t.yyb yyb, decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and a.stock_account like 'F%' 
               and substr(a.stock_account,1,3)='001' 
               --and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3','5','6')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0)
      union all
      select t.yyb yyb, decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and a.stock_account like 'F%' 
               --and substr(a.stock_account,1,3)='001' 
               and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3','5','6')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0)
      union all
     select t.yyb yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0) as khlx,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,c.organ_flag,
                   /*a.stock_account*/a.secum_account
              from /*kods.a_hs08_ofstockholder*/
                   kods.a_hs_secumholder a, 
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_client c  ---˱ֻ98 99ͷ
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and c.organ_flag in ('1','0','3','5','6')
               and substr(a.secum_account,0,2)  in ('98', '99')
               and b.open_date < =v_enddate
               )t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 ,'5',1,'6',1,0)) group by yyb,khlx;
     commit;

----------------------------------------------------------------------------------------------
  --˻淶
----------------------------------------------------------------------------------------------

  delete from t_etl_yyb_zhgf_zjzh;
  commit;

 --RMB˻ʽ˻
  insert into t_etl_yyb_zhgf_zjzh
    select s.branch_no,55 jylx,count(s.fund_account),sum(a.current_balance)
        from kods.RZRQ_hs_FUND_fundaccount s, 
             --kods.Rzrq_Hs_Fund_Fund a,
             kods.v_rzrq_hs_fund_fund a,
             kods.RZRQ_HS_CLIENT B
        where a.money_type='0' and a.fund_account=s.fund_account
         and a.client_id=s.client_id
         AND S.CLIENT_ID = B.CLIENT_ID
         AND A.CLIENT_ID = B.CLIENT_ID
         and B.organ_flag in ('1','0','3','5','6')
         AND S.ASSET_PROP in ('0'/*,'7'*/)
         and s.fundacct_status<>'3'
        group by s.branch_no   
 union all --˻ʽ˻
 select t1.branch_no,1 jylx,count(t2.fund_account)sl,sum(t1.current_balance)  je
          from kods.v_rzrq_hs_fund_fund t1 , 
               kods.rzrq_hs_fund_fundaccount t2,
               kods.rzrq_hs_bankarg t3
          where t1.bank_no = t3.bank_no
            and t1.fund_account = t2.fund_account
            and t3.bank_type in ('2','4')
            and t1.money_type = '0'
            and t2.fundacct_status <> '3'
            and t2.asset_prop in ('0'/*,'7'*/)
            and t2.main_flag = '1'
            and t2.open_date<=v_enddate
          group by t1.branch_no      

  --ϸ˻ʽ˻
 union all
   select a.branch_no,2 jylx,count(a.fund_account),sum(b.current_balance)
         from kods.rzrq_hs_fund_fundaccount a, 
              kods.v_rzrq_hs_fund_fund b
     where a.client_id = b.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
      -- and a.client_group='902'
       and a.ASSET_PROP in ('0'/*,'7'*/)
       and exists (select 1
              from kods.rzrq_hs_stockholder d,kods.rzrq_hs_nonstdholder e
              where d.stock_account = e.stock_account
              and d.fund_account = b.fund_account
              and d.client_id = b.client_id)
     group by a.branch_no

  union all
  --С˻ʽ˻
 select a.branch_no,3 jylx,count(a.fund_account),sum(b.current_balance)
        from kods.rzrq_hs_fund_fundaccount a, 
             kods.v_rzrq_hs_fund_fund b,
             kods.a_hs08_clientinfo c
     where c.client_id = a.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%2%'
     group by a.branch_no

 /*union all
  --˻ʽ˻
       select a.branch_no,4 jylx,count(a.fund_account),sum(b.current_balance)
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
     where c.client_id = a.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%6%'
     group by a.branch_no*/
 union all
  --ʽ˻
   select s.branch_no,5 jylx,count(distinct a.fund_account),sum(a.current_balance)
        from kods.rzrq_hs_fund_fundaccount s, 
             kods.v_rzrq_hs_fund_fund a,
             kods.rzrq_hs_bankarg c
        where a.money_type='0' 
        and a.fund_account=s.fund_account 
        and s.fundacct_status<>'3'
        and a.bank_no=c.bank_no 
        and c.bank_type in ('2','4')
        and a.client_id=s.client_id
        and s.main_flag='0'
        AND S.ASSET_PROP in ('0'/*,'7'*/)
        group by s.branch_no;
        commit;
   ---˺żʽ
  /* delete from t_etl_yyb_zhgf_zjzh where jylx=1;
   commit;*/
   --update t_etl_yyb_zhgf_zjzh t set t.zjye =(select sum(decode(jylx,55,zjye,-zjye))
    --from (select * from t_etl_yyb_zhgf_zjzh union all select * from t_etl_yyb_zhgf_zjzh_rzrq) where yyb=t.yyb)
    --where t.jylx=1; 
  /* insert into t_etl_yyb_zhgf_zjzh
    select yyb,1,sum(decode(jylx,55,sl,-sl)),sum(decode(jylx,55,zjye,-zjye))
    from (select * from t_etl_yyb_zhgf_zjzh union all select * from t_etl_yyb_zhgf_zjzh_rzrq)
    group by yyb;*/
    ---˺żʽ
   delete from t_etl_yyb_zhgf_zjzh where jylx=4;
   commit;
   insert into t_etl_yyb_zhgf_zjzh
    select yyb,4,sum(decode(jylx,55,sl,-sl)),sum(decode(jylx,55,zjye,-zjye))
    from t_etl_yyb_zhgf_zjzh
    group by yyb;
  commit; 
    
    
  commit;

--------------------------------------------------------------------------------------------------
-- ˻淶   ֤ȯֵ
---------------------------------------------------------------------------------------------------
  delete from t_etl_yyb_zhgf_zqzh;
  commit;
  --ϸ˻֤ȯ˻
    insert into t_etl_yyb_zhgf_zqzh
select yyb,2,sum(sl),sum(sz)je from
   (select c.branch_no yyb,count(distinct c.fund_account) sl,sum((c.current_amount+abs(c.correct_amount))*d.asset_price) sz
    from kods.v_rzrq_hs_stock c ,
         kods.rzrq_hs_nonstdholder a,
        (select * from kods.RZRQ_hs_HIS_hisprice where init_date=(select max(init_date) from kods.RZRQ_hs_HIS_hisprice)) d
           where   a.exchange_type IN ('1','2')
               and c.stock_code=d.stock_code
               AND A.STOCK_ACCOUNT = C.STOCK_ACCOUNT
               and c.CURRENT_AMOUNT>=0
     group by c.branch_no) 
     group by yyb;


  commit;
  --С˻֤ȯ˻
  insert into t_etl_yyb_zhgf_zqzh
    select yyb, 3, sum(sl), 0 zqsz
      from (select a.branch_no yyb, count(distinct a.stock_account) as sl
              from kods.rzrq_hs_stockholder a
             where holder_status = 'C'
               and a.exchange_type in ('1', '2')
               and a.asset_prop = '0'
             group by a.branch_no)
     group by yyb;
  commit;

 --˻֤ȯ˻

insert into t_etl_yyb_zhgf_zqzh
select a.branch_no yyb,4,count(a.stock_account) sl, sum((b.current_amount+abs(b.correct_amount))*c.asset_price)sz
        from kods.RZRQ_hs_stockholder a,
             kods.v_rzrq_hs_stock b,
        (select * from kods.RZRQ_hs_HIS_hisprice where init_date=(select max(init_date) from kods.RZRQ_hs_HIS_hisprice))c
      where a.stock_account=b.stock_account
         and b.stock_code=c.stock_code
         and a.exchange_type IN ('1','2')
         and a.asset_prop = '0'
         and b.CURRENT_AMOUNT >=0
         and a.holder_status = '1'
        group by a.branch_no;
commit;


     delete from t_etl_yyb_zhgf_zqzh where jylx=1;
    commit;
   ---ϸ֤ȯ
   insert into t_etl_yyb_zhgf_zqzh s
     select c.yyb,
            1,
            sum(c.sl) - nvl(sum(b.sl), 0),
            nvl(sum(s.je) - nvl(sum(b.sz), 0), 0)
       from (select yyb, sum(sl) sl, sum(zqsz) sz
               from t_etl_yyb_zhgf_zqzh
              where jylx in (2, 3, 4)
              group by yyb) b
      right join (select yyb, sum(sl) sl
                    from (select *
                            from t_etl_yyb_zqzh
                          union all
                          select *
                            from t_etl_yyb_zqzh_rzrq)
                   where jylx = 3
                     and bz = 0
                   group by yyb) c
         on b.yyb = c.yyb
       left join (select yyb, sum(je) je
                    from (select yyb, je
                            from t_etl_yyb_khjyjszj
                           where jylx = 9
                          union all
                          select yyb, je
                            from t_etl_yyb_khjyjszj_rzrq
                           where jylx = 9
                             and yyb not in
                                 (select p001
                                    from krcs.t_ctl_t036 t
                                   where t.a006 = '1004028'))
                   group by yyb) s
         on c.yyb = s.yyb
      group by c.yyb;
   commit;

-----     -------------------------------------------------------------------------------------
  --˻䶯
-------------------------------------------------------------------------------------
  delete from t_etl_yyb_zhbd_zjzh;
  commit;


  cisp_etl_yyb_zjzh;
  commit;
  cisp_etl_yyb_zqzh;
  commit;
  cisp_etl_yyb_jjzh;
  commit;
  cisp_etl_yyb_zhgf_zjzh;
  commit;
  cisp_etl_yyb_zhgf_zqzh;
  commit;
  cisp_etl_yyb_zhbd_zjzh;
  commit;
  cisp_etl_yyb_zhbd_zqzh;
  commit;

end ;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A4_1
prompt ====================================
prompt
create or replace procedure cisp_map_yyb_a4_1 is
  /********************************************************************
  *ܣӪҵ֤ȯԴETL
  *ʱ䣺
   
  *********************************************************************/
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin

  --ȡڵڼʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  --׽
  delete from t_etl_yyb_zqjy;
  commit;
  --- select * from a_hs_sysdictionary d where  d.dict_entry=1206-- ע
  --A
  insert into t_etl_yyb_zqjy
    select trim(yyb), 1 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002',
                                        '4001',
                                        '4003',
                                        '4004',
                                        '4050',
                                        '4103',
                                        '4104',
                                        '4123',
                                        '4137',
                                        '4138',
                                        '4140',
                                        '4149',
                                        '4150',
                                        '4151',
                                        '4152') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0', 'c', 'e', 'p') --֤ͣƱ e  ƴ pעƴҵ
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;

  --B
  insert into t_etl_yyb_zqjy
    select trim(yyb), zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,
                   t1.exchange_type,
                   decode(trim(t1.exchange_type), 'H', '2', 'D', '3') zqlx,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0') --֤ͣƱ
               and trim(t1.money_type) != '0'
               and t1.asset_prop in ('0')
               and trim(t1.exchange_type) in ('H', 'D') ---D.Ϻ H.
            ) t
     group by yyb, zqlx
    union all --Ϻ֤ҪѻͨеB
    select trim(yyb), zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,
                   t1.exchange_type,
                   /*decode(trim(t1.exchange_type), 'G',*/
                   '3' /*)*/ zqlx,
                   round(sum(t1.business_balance) /
                         (select nvl(sum(a002), 0) from t_bks_t007),
                         2) jyje,
                   round(sum(t1.fare0) /
                         (select nvl(sum(a002), 0) from t_bks_t007),
                         2) fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0') --֤ͣƱ
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('G', 'S') ---D.Ϻ H.
               and t1.branch_no in
                   (select p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004002))
             group by t1.branch_no, t1.exchange_type) t
     group by yyb, zqlx;
  commit;
  --('6', 'L', 'T','1','N')
  insert into t_etl_yyb_zqjy
    select trim(yyb), 4 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from /*a_hs_hisdeliver*/ kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4001', '4002') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('6', 'L', 'T', 'j', 'l','r') --T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF r ʩ
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;
  --ծȯ ('9', 'X', 'Y', 'U', 'u','I')
  insert into t_etl_yyb_zqjy
    select yyb, 5 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001', '4050') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('9', 'X', 'Y', 'U', 'u', 'a') ----9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  --Ȩ֤
  insert into t_etl_yyb_zqjy
    select yyb, 6 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from /*a_hs_hisdeliver*/ kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) = 'D'
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;

  --֤ȯ ͨ
  insert into t_etl_yyb_zqjy
    select yyb, 7 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0') --Ʊ
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('G', 'S') ---ͨ
               and t1.branch_no not in
                   (select p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004002)) --(select p001 from krcs.t_ctl_t036 t where t.a006 in(1004014,1004001,1004005,1004008))
            ) t
     group by yyb;
  --֤ȯ ƾ֤
  insert into t_etl_yyb_zqjy
    select trim(yyb), 7 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4001', '4002') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('q', 'g') --qҵƾ֤ gƴƾ֤
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;
  --ʻع
  insert into t_etl_yyb_zqjy
    select yyb, 8 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb, t1.business_balance jyje, t1.fare0 fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4003', '4103') --('4003','4089','4103')
               and trim(t1.stock_type) in ('Q', 'Z')
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;

  --ȯع
  insert into t_etl_yyb_zqjy
    select yyb, 9 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb, t1.business_balance jyje, t1.fare0 fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4004', '4090', '4104', '4140') --4090-ʽع 4140 ۻع
               and trim(t1.stock_type) in ('Q', 'Z')
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;
  --Ͻ 
  insert into t_etl_yyb_zqjy
    select yyb, 10 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,
                   t1.business_balance jyje,
                   (fare0 /*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                                       -exchange_fare5-exchange_fare6-exchange_farex*/
                   ) fee
              from kods.v_rzrq_hs_his_hisdeliver t1,
                   kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account
               and t2.asset_prop = '0'
               and t1.business_flag in ('4002',
                                        '4001',
                                        '4003',
                                        '4004',
                                        '4050',
                                        '4103',
                                        '4104',
                                        '4123',
                                        '4137',
                                        '4138',
                                        '4140',
                                        '4149',
                                        '4150',
                                        '4151',
                                        '4152')
               and t1.stock_type in ('0',
                                     'c',
                                     '6',
                                     'L',
                                     'T',
                                     'j',
                                     'l',
                                     '9',
                                     'X',
                                     'Y',
                                     'U',
                                     'u',
                                     'a',
                                     'Q',
                                     'Z',
                                     'e',
                                     'p',
                                     'q',
                                     'g',
                                     'r') --e ƴ pעƴҵ qҵƾ֤ gƴƾ֤ r ʩ
               and t1.money_type = '0'
                  --and t1.op_entrust_way ='7' --not in ('0','2','4')
               and t1.op_entrust_way in ('7', '8', '9') --7ί  8ֻί
               and t1.exchange_type in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb
    union all
    select yyb, 10 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf --Ϻּϸ۹ͨ
      from (select t1.branch_no yyb,
                   t1.business_balance jyje,
                   (fare0 /*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                                       -exchange_fare5-exchange_fare6-exchange_farex*/
                   ) fee
              from kods.v_rzrq_hs_his_hisdeliver t1,
                   kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account
               and t2.asset_prop = '0'
               and t1.business_flag in ('4002',
                                        '4001',
                                        '4003',
                                        '4004',
                                        '4050',
                                        '4103',
                                        '4104',
                                        '4123',
                                        '4137',
                                        '4138',
                                        '4140',
                                        '4149',
                                        '4150',
                                        '4151',
                                        '4152')
               and t1.stock_type in ('0',
                                     'c',
                                     '6',
                                     'L',
                                     'T',
                                     'j',
                                     'l',
                                     '9',
                                     'X',
                                     'Y',
                                     'U',
                                     'u',
                                     'a',
                                     'Q',
                                     'Z',
                                     'e',
                                     'p',
                                     'q',
                                     'g',
                                     'r') --e ƴ pעƴҵ qҵƾ֤ gƴƾ֤ r ʩ
               and t1.money_type = '0'
                  --and t1.op_entrust_way ='7' --not in ('0','2','4')
               and t1.op_entrust_way in ('7', '8', '9') --7ί  8ֻί
               and t1.exchange_type in ('G', 'S') ---۹ͨ ϺҪ
            --and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))
            ) t
     group by yyb;
  commit;
  --ϽסB
  insert into t_etl_yyb_zqjy
    select yyb, zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,
                   decode(t1.exchange_type, 'H', '11', 'D', '12') zqlx,
                   t1.business_balance jyje,
                   (fare0 /*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                                       -exchange_fare5-exchange_fare6-exchange_farex*/
                   ) fee
              from kods.v_rzrq_hs_his_hisdeliver t1,
                   kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account
               and t2.asset_prop = '0'
               and t1.business_flag in ('4002',
                                        '4001',
                                        '4003',
                                        '4004',
                                        '4050',
                                        '4103',
                                        '4104',
                                        '4123',
                                        '4137',
                                        '4138',
                                        '4140',
                                        '4149',
                                        '4150',
                                        '4151',
                                        '4152') --֤ȯ ֤ȯ
               and t1.stock_type in ('0') --֤ͣƱ
               and t1.money_type != '0'
                  --and t1.op_entrust_way ='7' --not in ('0','2','4')
               and t1.op_entrust_way in ('7', '8', '9') --7ί  8ֻί
               and t1.exchange_type in ('H', 'D') ---D.Ϻ H.
            ) t
     group by yyb, zqlx;

  commit;
  --ֳ 
  insert into t_etl_yyb_zqjy
    select yyb, 20 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,
                   t1.business_balance jyje,
                   (fare0 /*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                                       -exchange_fare5-exchange_fare6-exchange_farex*/
                   ) fee
              from kods.v_rzrq_hs_his_hisdeliver t1,
                   kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account
               and t2.asset_prop = '0'
               and t1.business_flag in ('4002',
                                        '4001',
                                        '4003',
                                        '4004',
                                        '4050',
                                        '4103',
                                        '4104',
                                        '4123',
                                        '4137',
                                        '4138',
                                        '4140',
                                        '4149',
                                        '4150',
                                        '4151',
                                        '4152')
               and t1.stock_type in ('0',
                                     'c',
                                     '6',
                                     'L',
                                     'T',
                                     'j',
                                     'l',
                                     '9',
                                     'X',
                                     'Y',
                                     'U',
                                     'u',
                                     'a',
                                     'Q',
                                     'Z',
                                     'e',
                                     'p',
                                     'q',
                                     'g',
                                     'r') --e ƴ pעƴҵ qҵƾ֤ gƴƾ֤ r ʩ
               and t1.money_type = '0'
               and t1.op_entrust_way in ('1', '7', '8', '5', '9')
               and t1.exchange_type in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb
    union all
    select yyb, 20 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,
                   t1.business_balance jyje,
                   (fare0 /*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                                       -exchange_fare5-exchange_fare6-exchange_farex*/
                   ) fee
              from kods.v_rzrq_hs_his_hisdeliver t1,
                   kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account
               and t2.asset_prop = '0'
               and t1.business_flag in ('4002',
                                        '4001',
                                        '4003',
                                        '4004',
                                        '4050',
                                        '4103',
                                        '4104',
                                        '4123',
                                        '4137',
                                        '4138',
                                        '4140',
                                        '4149',
                                        '4150',
                                        '4151',
                                        '4152')
               and t1.stock_type in ('0',
                                     'c',
                                     '6',
                                     'L',
                                     'T',
                                     'j',
                                     'l',
                                     '9',
                                     'X',
                                     'Y',
                                     'U',
                                     'u',
                                     'a',
                                     'Q',
                                     'Z',
                                     'e',
                                     'p',
                                     'q',
                                     'g',
                                     'r') --e ƴ pעƴҵ qҵƾ֤ gƴƾ֤ r ʩ
               and t1.money_type = '0'
               and t1.op_entrust_way in ('1', '7', '8', '5', '9')
               and t1.exchange_type in ('G', 'S') ---1.Ϻ 2.  Ϻּϸ۹ͨ
            --and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))
            ) t
     group by yyb;
  commit;
  --ֳסB
  insert into t_etl_yyb_zqjy
    select yyb, zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,
                   decode(t1.exchange_type, 'H', '21', 'D', '22') zqlx,
                   t1.business_balance jyje,
                   (fare0 /*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                                       -exchange_fare5-exchange_fare6-exchange_farex*/
                   ) fee
              from kods.v_rzrq_hs_his_hisdeliver t1,
                   kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account
               and t2.asset_prop = '0'
               and t1.business_flag in ('4002',
                                        '4001',
                                        '4003',
                                        '4004',
                                        '4050',
                                        '4103',
                                        '4104',
                                        '4123',
                                        '4137',
                                        '4138',
                                        '4140',
                                        '4149',
                                        '4150',
                                        '4151',
                                        '4152') --֤ȯ ֤ȯ
               and t1.stock_type in ('0') --֤ͣƱ
               and t1.money_type != '0'
               and t1.op_entrust_way in ('1', '7', '8', '5', '9')
               and t1.exchange_type in ('H', 'D') ---D.Ϻ H.
            ) t
     group by yyb, zqlx;

  commit;
  -------------------------------------------------------------------------------------------------------
  --   ֤ȯֵ
  -------------------------------------------------------------------------------------------------------
  delete from t_etl_yyb_zqsz;
  commit;
  --A-ֵ
  insert into t_etl_yyb_zqsz
    select yyb, 1 zqlx, sum(zqsz)
      from (select t1.branch_no as yyb,
                   sum((t1.current_amount + abs(t1.correct_amount)) *
                       b.asset_price) zqsz
              from kods.v_rzrq_hs_stock t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('0', 'c', 'e', 'p') --0 Ʊcҵ e ƴ  pעƴҵ
               and t1.exchange_type in ('1', '2')
               and t3.fundacct_status != '3'
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.CURRENT_AMOUNT >= 0
               and t1.client_id = t3.client_id
               and t1.money_type = '0'
               and t1.fund_account = t3.fund_account
               and b.stock_code = t1.stock_code
               and t3.asset_prop = '0'
             group by t1.branch_no
            union all
            select a.branch_no as yyb,
                   -sum(greatest(nvl(b.current_amount, 0) -
                                 nvl(a.available_amount, 0),
                                 0) * c.asset_price) as zqsz --  
              from kods.v_A_HS08_EXTSTOCKREAL a,
                   kods.v_rzrq_hs_stockreal b,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) c
             where a.client_id = b.client_id
               and a.stock_code = b.stock_code
               and a.exchange_type = b.exchange_type
               and trim(c.stock_code) = trim(a.stock_code)
               and b.stock_flag = '1'
             group by a.branch_no)
     group by yyb;
  commit;

  --B-ֵ
  insert into t_etl_yyb_zqsz
    select t1.branch_no yyb,
           decode(t1.exchange_type, 'D', 3, 'H', 2),
           sum((t1.current_amount + abs(t1.correct_amount)) * b.asset_price) zqsz
      from kods.v_rzrq_hs_stock t1,
           kods.rzrq_hs_fund_fundaccount t3,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) b
     where t1.stock_type in ('0') --֤ͣƱ(0)
       and t3.fundacct_status != '3'
       and t1.exchange_type in ('D', 'H')
       and t1.exchange_type = b.exchange_type
       and t1.branch_no = t3.branch_no
       and t1.client_id = t3.client_id
       and t1.money_type in (1, 2)
       and t1.CURRENT_AMOUNT >= 0
       and t1.fund_account = t3.fund_account
       and t3.asset_prop = '0'
       and b.stock_code = t1.stock_code
     group by t1.branch_no, decode(t1.exchange_type, 'D', 3, 'H', 2)
    union all --Ϻ֤ҪBֱͨ
    select yyb, 2 zqlx, sum(t.zqsz) zqsz
      from (select round(sum((t1.current_amount + t1.correct_amount) *
                             b.asset_price) /
                         (select nvl(sum(a002), 0) from t_bks_t007),
                         2) zqsz,
                   t1.branch_no yyb
              from kods.v_RZRQ_HS_STOCK t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.RZRQ_HS_HIS_HISPRICE
                     where init_date =
                           (select max(init_date)
                              from kods.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t3.fundacct_status != '3'
               and t1.exchange_type in ('G', 'S')
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.money_type = '0'
               and t1.CURRENT_AMOUNT >= 0
               and t1.fund_account = t3.fund_account
               and b.stock_code = t1.stock_code
               and t1.branch_no in
                   (select p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004002))
             group by t1.branch_no) t
     group by yyb;

  commit;
  ---ֵ
  insert into t_etl_yyb_zqsz
    select t1.branch_no,
           4 zqlx,
           sum((t1.current_amount + abs(t1.correct_amount)) * b.asset_price) zqsz
      from kods.v_rzrq_hs_stock t1,
           kods.rzrq_hs_fund_fundaccount t3,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) b
     where t1.stock_type in ('6', 'L', 'T', 'j', 'l','r') -- r ʩ 20210705
       and t3.fundacct_status != '3'
       and t1.exchange_type in ('1', '2')
       and t1.exchange_type = b.exchange_type
       and t1.branch_no = t3.branch_no
       and t1.client_id = t3.client_id
       and t1.money_type = '0'
       and t1.fund_account = t3.fund_account
       and t3.asset_prop = '0'
       and t1.CURRENT_AMOUNT >= 0
       and b.stock_code = t1.stock_code
     group by t1.branch_no
    union all
    select s.yyb, 4 as zqlx, sum(s.je) as zqsz --ʽ㵽ֵ
      from (select sum(abs(t.occur_balance)) je, t.branch_no yyb
              from /*a_hs_contstk*/ kods.v_rzrq_hs_his_hisfundjour t
             where t.business_flag in ('44170')
               and t.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisfundjour
                     where init_date <= v_enddate)
             group by t.branch_no) s
     group by yyb;
  commit;
  --ծȯ-ֵ
  insert into t_etl_yyb_zqsz
    select t1.branch_no,
           5 zqlx,
           sum((t1.current_amount + abs(t1.correct_amount)) * b.asset_price) zqsz
      from kods.v_rzrq_hs_stock t1,
           kods.rzrq_hs_fund_fundaccount t3,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) b
     where t1.stock_type in ('9', 'X', 'Y', 'U', 'u', 'a', 'Z')
       and t3.fundacct_status != '3'
       and t1.exchange_type in ('1', '2')
       and t1.exchange_type = b.exchange_type
       and t1.branch_no = t3.branch_no
       and t1.client_id = t3.client_id
       and t1.money_type = '0'
       and t1.fund_account = t3.fund_account
       and t3.asset_prop = '0'
       and t1.CURRENT_AMOUNT >= 0
       and b.stock_code = t1.stock_code
     group by t1.branch_no;

  commit;
  --Ȩ֤-ֵ
  insert into t_etl_yyb_zqsz
    select t1.branch_no,
           6 zqlx,
           sum((t1.current_amount + abs(t1.correct_amount)) * b.asset_price) zqsz
      from kods.v_rzrq_hs_stock t1,
           kods.rzrq_hs_fund_fundaccount t3,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) b
     where t1.stock_type in ('D')
       and t3.fundacct_status != '3'
       and t1.exchange_type in ('1', '2')
       and t1.exchange_type = b.exchange_type
       and t1.branch_no = t3.branch_no
       and t1.client_id = t3.client_id
       and t1.money_type = '0'
       and t1.fund_account = t3.fund_account
       and t3.asset_prop = '0'
       and t1.CURRENT_AMOUNT >= 0
       and b.stock_code = t1.stock_code
     group by t1.branch_no;
  commit;

  --֤ȯ-۹,ƾ֤ ֻвӪҵȡͨ ĳɳϺּBУӪҵ֤ȯ
  insert into t_etl_yyb_zqsz
    select yyb, 7 zqlx, sum(t.zqsz) zqsz
      from (select t1.branch_no yyb,sum((t1.current_amount + t1.correct_amount) *
                       b.asset_price) zqsz
              from kods.v_RZRQ_HS_STOCK t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.RZRQ_HS_HIS_HISPRICE
                     where init_date =
                           (select max(init_date)
                              from kods.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t3.fundacct_status != '3'
               and t1.exchange_type in ('G', 'S')
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.money_type = '0'
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and t1.CURRENT_AMOUNT >= 0
               and b.stock_code = t1.stock_code
               and t1.branch_no not in
                   (select p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004002))
             group by t1.branch_no
            union all
            select t1.branch_no as yyb,
                   sum((t1.current_amount + abs(t1.correct_amount)) *
                       b.asset_price) zqsz
              from kods.v_rzrq_hs_stock t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('q', 'g') ----qҵƾ֤ gƴƾ֤
               and t1.exchange_type in ('1', '2')
               and t3.fundacct_status != '3'
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.CURRENT_AMOUNT >= 0
               and t1.client_id = t3.client_id
               and t1.money_type = '0'
               and t1.fund_account = t3.fund_account
               and b.stock_code = t1.stock_code
               and t3.asset_prop = '0'
               /*and t1.branch_no not in
                   (select p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004002))*/
             group by t1.branch_no) t
     group by yyb;
  commit;

  ----------------------------------------
  --ڴɷתý׽
  ----------------------------------------
  delete from t_etl_yyb_dbzz;
  commit;
  insert into t_etl_yyb_dbzz --У 0- 1-۱ 2-Ԫ
    select yyb, 0 bz, sum(t.je) je
      from (select t1.branch_no yyb,
                   decode(t1.money_type,
                          '1',
                          t1.business_balance * s.a002,
                          '2',
                          t1.business_balance * s.a003,
                          t1.business_balance) je
              from kods.v_rzrq_hs_his_hisdeliver t1, t_bks_t007 s
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and t1.stock_type in ('0', 'z') --֤ͣƱ۹ɷ
               and t1.exchange_type in ('9', 'A')) t
     group by yyb;
  commit;
  -------Ӷ
  delete from t_etl_yyb_yjl;
  commit;
  delete t_db_b4_04;
  commit;
  insert into t_db_b4_04
    select yyb, 3002, to_char(maxsl, 'fm990.0999') from t_etl_yyb_yjl;
  insert into t_db_b4_04
    select yyb, 3003, to_char(minsl, 'fm990.0999') from t_etl_yyb_yjl;
  commit;

  ---------------END----------------

  cisp_etl_yyb_zqjy;
  commit;
  cisp_etl_yyb_zqjy_gtsxf;
  commit;
  CISP_ETL_YYB_ZQJY_FXC;
  commit;
  cisp_etl_yyb_dbzz;
  commit;

end;
/

prompt
prompt Creating procedure CISP_INTERFACE_JJJY
prompt ======================================
prompt
create or replace procedure cisp_interface_jjjy is
begin
  cisp_map_hs_jjyw_c1_1;
  cisp_map_hs_jjyw_c1_2;
  cisp_map_jjyw_c1_3;
  cisp_map_jjyw_sfcg;
  cisp_map_f2_1;
  cisp_map_f2_2;
  cisp_map_jjyw_c7_1;

  --cisp_map_c12_1;
  --ִеӪҵA1-1A2-1A3-1, A4-1 , A5-1
  cisp_map_yyb_a2_1;
  cisp_map_yyb_a3_1;
  cisp_map_yyb_a4_1;
  --cisp_map_yyb_a5_1;

  commit;
  cisp_map_hg_c13_3_ycl;
  cisp_map_hg_c13_3;
  cisp_map_hg_c13_3_rh;
  cisp_map_hg_c13_3_zyzj;

end cisp_interface_jjjy;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_2
prompt ====================================
prompt
create or replace procedure cisp_map_hg_c13_2
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate    number; --ʼ
  v_bbq_enddate      number; --ֹ
  v_bbq_next_enddate number;
  v_dhgje            number(19, 2);
  v_dhgsz            number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select to_char(to_date(v_bbq_enddate,'yyyymmdd')+31,'yyyymmdd')
    into v_bbq_next_enddate
    from dual;
  delete from t_etl_c13_2_sl;
  delete from t_etl_c13_2_je;
  delete from t_etl_c13_2_ywmx1;
  delete from t_etl_c13_2_ywmx2;

  --ǩԼͻ  
  insert into t_etl_c13_2_sl
     select decode(t1.organ_flag, '1', 2,'3',2, 3), 1, count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id,
                   a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1','3')
       and t.business_flag in ('1444', '1448') -- 1444ԼعȨ  1448 ԼعȨֹ
     group by t1.organ_flag;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_2_sl
    select decode(t1.organ_flag, '1', 2,'3' ,2 , 3), 3, count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id,
                   a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%l%'
       and t1.organ_flag in ('0', '1' ,'3')
       and t.asset_prop = '0'
     group by t1.organ_flag;

  commit;
  insert into t_etl_c13_2_sl
    select 1, jylx, sum(sl)
      from t_etl_c13_2_sl t
     where t.xm in (2, 3)
     group by t.jylx;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_2_sl
 select decode(t1.organ_flag, '1', 5,'3',5, 6), 1, count(distinct fund_account)
  from (select init_date,client_id,fund_account,real_date_back,arp_contract_status
          from kods.a_hs08_arpcontract
        union all
        select init_date,client_id,fund_account,real_date_back,arp_contract_status from kods.a_hs08_his_arpcontract) t,
       (select a.client_id,
               a.organ_flag as organ_flag
          from kods.rzrq_hs_client a) t1
 where init_date between v_bbq_begindate and v_bbq_enddate
   and fund_account not in
       (select fund_account
          from (select init_date,client_id,fund_account,real_date_back,arp_contract_status
                  from kods.a_hs08_arpcontract
                union all
                select init_date,client_id,fund_account,real_date_back,arp_contract_status from kods.a_hs08_his_arpcontract)
         where init_date < v_bbq_begindate
           and real_date_back >= v_bbq_begindate)
   and arp_contract_status <> 'b' and t.client_id = t1.client_id
 group by t1.organ_flag;


  --ڴؽ׿ͻ  ĩ
  insert into t_etl_c13_2_sl
     select decode(t1.organ_flag, '1', 5 ,'3' ,5 , 6), 3, count(distinct t.client_id)
      from kods.a_hs08_arpcontract t,
           (select a.client_id,
                   a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back > v_bbq_enddate
       and t1.organ_flag in ('0', '1','3')
     group by t1.organ_flag;
  commit;

  insert into t_etl_c13_2_sl
    select 4, jylx, sum(sl)
      from t_etl_c13_2_sl t
     where t.xm in (5, 6)
     group by t.jylx;

  --ؽ׽Ԫ 
  insert into t_etl_c13_2_je
    select decode(t.exchange_type, '1', 8, 9), 1, sum(t.entrust_balance)
      from kods.a_hs08_arpcontract t
     where t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.real_date_back > v_bbq_enddate
       and t.arp_contract_status <> 'b'
     group by t.exchange_type;

  /*  --ؽ׽Ԫ ڼ
  insert into t_etl_c13_2_je
    select decode(t.exchange_type, '1', 8, 9), 2, sum(t.entrust_balance)
      from a_hs_hisarpcontract t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and arp_contract_status <> 'b'
     group by t.exchange_type;*/

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_2_je
     select decode(t.exchange_type, '1', 8, 9), 3, sum(t.entrust_balance)
      from kods.a_hs08_arpcontract t
     where t.real_date_back > v_bbq_enddate
     group by t.exchange_type;
  commit;

  insert into t_etl_c13_2_je
    select 7, jylx, sum(je)
      from t_etl_c13_2_je t
     where t.xm in (8, 9)
     group by t.jylx;

  --ʣ1
  insert into t_etl_c13_2_je
    select 10, 3, sum(t.entrust_balance)
      from kods.a_hs08_arpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') <=
           to_date(v_bbq_enddate, 'yyyymmdd') + 31
       and t.real_date_back > v_bbq_enddate;

  --ʣ1
  insert into t_etl_c13_2_je
    select 11, 3, sum(t.entrust_balance)
      from kods.a_hs08_arpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') >
           to_date(v_bbq_enddate, 'yyyymmdd') + 31
       and t.real_date_back > v_bbq_enddate;


  --/
  insert into t_etl_c13_2_je
    select decode(t1.organ_flag, '1', 12,'3' ,12, 13), 1, sum(t.entrust_balance)
      from kods.a_hs08_arpcontract t,
           (select a.client_id,
                   a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.real_date_back > v_bbq_enddate
     group by t1.organ_flag;

  --/
  insert into t_etl_c13_2_je
    select decode(t1.organ_flag, '1', 12,'3',12, 13), 3, sum(t.entrust_balance)
      from kods.a_hs08_arpcontract t,
           (select a.client_id,
                   organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back > v_bbq_enddate
     group by t1.organ_flag;

  --ر֤ȯֵԪ
  insert into t_etl_c13_2_je
    select decode(t.exchange_type, '1', 15, 16),
           3,
           sum((t.entrust_amount + t.bonus_amount) * t1.asset_price)
      from kods.a_hs08_arpcontract t,
      (select *from kods.rzrq_hs_his_hisprice where init_date = (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.real_date_back > v_bbq_enddate
     group by t.exchange_type;

  insert into t_etl_c13_2_je
    select 14, jylx, sum(je)
      from t_etl_c13_2_je t
     where t.xm in (15, 16)
     group by t.jylx;

  commit;

  --Լϱ
  select nvl(sum(je), 0)
    into v_dhgsz
    from t_etl_c13_2_je
   where xm = 14
     and jylx = 3;
  select nvl(sum(je), 0)
    into v_dhgje
    from t_etl_c13_2_je
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_2_je
    select 23, 3, (case when v_dhgje<>0 then v_dhgsz / v_dhgje*100 else 0 end) from dual;

  --ۼҵģԪ
  insert into t_etl_c13_2_je
     select 25, 3, sum(t.entrust_balance)
      from (select entrust_balance, real_date_back, entrust_date
              from kods.a_hs08_arpcontract
            union all
            select entrust_balance, real_date_back, entrust_date
              from kods.a_hs08_his_arpcontract) t
     where t.real_date_back between v_bbq_enddate and v_bbq_next_enddate
       and t.entrust_date between v_bbq_begindate and v_bbq_enddate;

  insert into t_etl_c13_2_je
    select 26, 3, sum(t.entrust_balance)
      from (select entrust_balance, real_date_back, entrust_date
              from kods.a_hs08_arpcontract
            union all
            select entrust_balance, real_date_back, entrust_date
              from kods.a_hs08_his_arpcontract) t
     where t.real_date_back > v_bbq_next_enddate
       and t.entrust_date between v_bbq_begindate and v_bbq_enddate;


  commit;

  insert into t_etl_c13_2_je
    select 24, jylx, sum(je)
      from t_etl_c13_2_je t
     where t.xm in (25, 26)
     group by t.jylx;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_2_je
    select 27,0,sum(round(entrust_balance * real_year_rate *
                 (to_date(real_date_back, 'yyyymmdd') -
                 to_date(init_date, 'yyyymmdd')) / 360,
                 2))
  from (select init_date,entrust_balance,real_year_rate,real_date_back,arp_contract_status
          from kods.a_hs08_arpcontract
        union all
        select init_date,entrust_balance,real_year_rate,real_date_back,arp_contract_status from kods.a_hs08_his_arpcontract)
 where real_date_back between v_bbq_begindate and v_bbq_enddate
   and arp_contract_status <> 'b';

  --ع
  insert into t_etl_c13_2_je
     select 28, 1, max(t.expire_year_rate*100)
      from (select t1.expire_year_rate, t1.real_date_back, t1.init_date,t1.entrust_date
              from kods.a_hs08_arpcontract t1
              where t1.arp_contract_status=3
            union all
            select t2.expire_year_rate, t2.real_date_back, t2.init_date,t2.entrust_date
              from kods.a_hs08_his_arpcontract t2 where t2.arp_contract_status=3) t
     where ceil(to_date(t.real_date_back,'yyyymmdd')-to_date(t.entrust_date,'yyyymmdd'))<=31
     and t.real_date_back >= v_bbq_enddate;   --ʵʹ-ίһǶڣʵʹڴڵ ״̬Ч3
     
       --and t.init_date between v_bbq_begindate and v_bbq_enddate;

  insert into t_etl_c13_2_je
    select 28, 2, min(t.expire_year_rate*100)
      from (select t1.expire_year_rate, t1.real_date_back, t1.init_date,t1.entrust_date
              from kods.a_hs08_arpcontract t1 where t1.arp_contract_status=3
            union all
            select t2.expire_year_rate, t2.real_date_back, t2.init_date,t2.entrust_date
              from kods.a_hs08_his_arpcontract t2 where t2.arp_contract_status=3) t
     where ceil(to_date(t.real_date_back,'yyyymmdd')-to_date(t.entrust_date,'yyyymmdd'))<=31
      and t.real_date_back >= v_bbq_enddate ;
       --and t.init_date between v_bbq_begindate and v_bbq_enddate;

  insert into t_etl_c13_2_je
    select 29, 1, max(t.expire_year_rate*100)
      from (select t1.expire_year_rate, t1.real_date_back, t1.init_date,t1.entrust_date
              from kods.a_hs08_arpcontract t1 where t1.arp_contract_status=3
            union all
            select t2.expire_year_rate, t2.real_date_back, t2.init_date,t2.entrust_date
              from kods.a_hs08_his_arpcontract t2 where t2.arp_contract_status=3) t
     where ceil(to_date(t.real_date_back,'yyyymmdd')-to_date(t.entrust_date,'yyyymmdd'))>31
     and t.real_date_back >= v_bbq_enddate;
       --and t.init_date between v_bbq_begindate and v_bbq_enddate;

  insert into t_etl_c13_2_je
    select 29, 2, min(t.expire_year_rate*100)
      from (select t1.expire_year_rate, t1.real_date_back, t1.init_date,t1.entrust_date
              from kods.a_hs08_arpcontract t1 where t1.arp_contract_status=3
            union all
            select t2.expire_year_rate, t2.real_date_back, t2.init_date,t2.entrust_date
              from kods.a_hs08_his_arpcontract t2 where t2.arp_contract_status=3) t
     where  ceil(to_date(t.real_date_back,'yyyymmdd')-to_date(t.entrust_date,'yyyymmdd'))>31
      and t.real_date_back > v_bbq_enddate;
       --and t.init_date between v_bbq_begindate and v_bbq_enddate;

  insert into t_etl_c13_2_ywmx1
   select y.client_id,
           y.client_name,
           sum(x.entrust_balance),
           sum((x.entrust_amount + x.bonus_amount) * z.asset_price),
           sum(x.entrust_amount * z.asset_price) / sum(x.entrust_balance)*100,
           0
      from (select t1.client_id,
                   t1.real_date_back,
                   t1.entrust_date,
                   t1.entrust_balance,
                   t1.real_back_balance,
                   t1.stock_code,
                   t1.entrust_amount,
                   t1.exchange_type,
                   t1.bonus_amount
              from kods.a_hs08_arpcontract t1) x,
           kods.rzrq_hs_client y,
           (select * from kods.rzrq_hs_his_hisprice where init_date = (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.client_id = y.client_id
       and x.stock_code = z.stock_code
       and x.exchange_type = z.exchange_type
       and x.real_date_back > v_bbq_enddate
       and x.entrust_date <= v_bbq_enddate
     group by y.client_id, y.client_name
     order by sum(x.entrust_balance) desc;


  insert into t_etl_c13_2_ywmx2
    select x.stock_code,
           sum(x.entrust_amount + x.bonus_amount),
           sum((x.entrust_amount + x.bonus_amount) * z.asset_price),
           sum(x.entrust_amount + x.bonus_amount)/n.capital_amount*100 ,
           0,
           y.stock_name
      from (select t1.client_id,
                   t1.real_date_back,
                   t1.entrust_date,
                   t1.entrust_balance,
                   t1.real_back_balance,
                   t1.stock_code,
                   t1.entrust_amount,
                   t1.exchange_type,
                   t1.bonus_amount
              from kods.a_hs08_arpcontract t1
            ) x,
           (select * from kods.rzrq_hs_his_hisprice where init_date = (select max(init_date) from kods.rzrq_hs_his_hisprice)) z,
           kods.rzrq_hs_stkcode y,
           (select stock_code,capital_amount
                              from KODS.RZRQ_HS_HIS_HISASSURECODE
                             where init_date =(select max(init_date) from
                          KODS.RZRQ_HS_HIS_HISASSURECODE a
                           where a.init_date<=v_bbq_enddate)) n
     where x.stock_code = z.stock_code
       and x.stock_code = n.stock_code
       and x.exchange_type = z.exchange_type
       and x.real_date_back > v_bbq_enddate
       and x.entrust_date <= v_bbq_enddate
       and x.stock_code = y.stock_code
     group by x.stock_code, y.stock_name,n.capital_amount
     order by sum((x.entrust_amount + x.bonus_amount) * z.asset_price) desc;


  commit;

  cisp_etl_ydgh_jyb;
  commit;
  cisp_etl_ydgh_jyb_ljywgm; --ۼҵģ
  commit;
  cisp_etl_ydgh_jyb_hgll; --ع
  commit;
  cisp_etl_ydgh_jyb_ywmx1; --ؽ׽ǰ5
  commit;
  cisp_etl_ydgh_jyb_ywmx2; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_JY_RZRQ
prompt ===================================
prompt
create or replace procedure cisp_map_jy_rzrq
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:  C1-2:ױ(ͶӰetl:t_etl_jy)
  -- RETURN:
  -- AUTHOR:       wuxg
  -- CREATE DATE:  2015/07/08
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
 is
  v_bbq_begindate number;
  v_bbq_enddate   number;
begin
  delete from t_etl_jy_rzrq;

  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           1 zqlx, --A
           1 jylx, --
           sum(abs(je)) je
      from (select decode(b.organ_flag, '1', 1, '3', 1, '0') khlx,
                   business_balance je --ɽ
              from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
             where a.client_id = b.client_id
               and business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  --4001֤ȯ ,4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and a.stock_type in ('0', '3', 'c', 'e', 'p') -- p עƴҵ 
               and trim(a.exchange_type) in ('1', '2')
               and a.asset_prop = '7'
               and init_date between v_bbq_begindate and v_bbq_enddate) t
     group by t.khlx;
  commit;
  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           4 zqlx, --
           1 jylx, --
           sum(abs(je)) je
      from (select decode(b.organ_flag, '1', 1, '3', 1, '0') khlx,
                   business_balance je --ɽ
              from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
             where a.client_id = b.client_id
               and business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  --4001֤ȯ ,4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and a.stock_type in ('6', 'L', 'T', 'j', 'l','r')
               and trim(a.exchange_type) in ('1', '2')
               and a.asset_prop = '7'
                  -- T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF  r ʩ
               and init_date between v_bbq_begindate and v_bbq_enddate) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           5 zqlx, --ETF
           1 jylx, --
           sum(abs(je)) je
      from (select decode(b.organ_flag, '1', 1, '3', 1, '0') khlx,
                   business_balance je --ɽ
              from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
             where a.client_id = b.client_id
               and business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  --4001֤ȯ ,4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and a.stock_type in ('T' /*,'j','l'*/) --   T ETL
               and trim(a.exchange_type) in ('1', '2')
               and a.asset_prop = '7'
               and init_date between v_bbq_begindate and v_bbq_enddate) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           6 zqlx, --LOF
           1 jylx, --
           sum(abs(je)) je
      from (select decode(b.organ_flag, '1', 1, '3', 1, '0') khlx,
                   business_balance je --ɽ
              from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
             where a.client_id = b.client_id
               and business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  --4001֤ȯ ,4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and a.stock_type in ('L','r') --  L LOF r ʩ
               and trim(a.exchange_type) in ('1', '2') 
               and a.asset_prop = '7'
               and init_date between v_bbq_begindate and v_bbq_enddate) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           7 zqlx, --ծȯ
           1 jylx, --
           sum(abs(je)) je
      from (select decode(b.organ_flag, '1', 1, '3', 1, '0') khlx,
                   business_balance je --ɽ
              from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
             where a.client_id = b.client_id
               and business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  --4001֤ȯ ,4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and a.stock_type in ('9', 'X', 'Y', 'U', 'u', 'a') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and trim(a.exchange_type) in ('1', '2')
               and a.asset_prop = '7'
               and init_date between v_bbq_begindate and v_bbq_enddate) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           9 zqlx,--
           1 jylx, --
           sum(abs(je)) je
      from (select decode(b.organ_flag, '1', 1, '3', 1, '0') khlx,
                   business_balance je --ɽ
              from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
             where a.client_id = b.client_id
               and business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  --4001֤ȯ ,4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and a.stock_type in ('q', 'g') --qҵƾ֤  g ƴƾ֤
               and trim(a.exchange_type) in ('1', '2')
               and a.asset_prop = '7'
               and init_date between v_bbq_begindate and v_bbq_enddate) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           12 zqlx, --Ͻ
           1 jylx, --
           sum(je) je
      from (select decode(b.organ_flag, '1', 1, '3', 1, '0') khlx,
                   business_balance je --ɽ
              from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
             where a.client_id = b.client_id
               and business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  --4001֤ȯ ,4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and a.op_entrust_way in ('7') --ίзʽί7 
               and trim(a.exchange_type) in ('1', '2')
               and a.asset_prop = '7'
               and init_date between v_bbq_begindate and v_bbq_enddate) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           1 zqlx, --AƱ
           2 jylx, --ָй
           sum(je) je
      from (select decode(c.organ_flag, '1', 1, '3', 1, '0') khlx,
                   a.current_amount * b.ASSET_PRICE je
              from kods.rzrq_hs_stock            a,
                   kods.rzrq_hs_his_hisprice     b,
                   kods.rzrq_hs_client           c,
                   kods.rzrq_hs_fund_fundaccount d
             where b.stock_code = a.stock_code
               and a.client_id = c.client_id
               and a.fund_account = d.fund_account
               and a.stock_type in ('0', 'c', 'e', 'p', 'q') --A,ҵ,ƴ
               and trim(a.exchange_type) in ('1', '2')
               and d.asset_prop = '7'
               and b.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisprice
                     where init_date <= v_bbq_enddate)) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           4 zqlx, --
           2 jylx, --ָй
           sum(je) je
      from (select decode(c.organ_flag, '1', 1, '3', 1, '0') khlx,
                   a.current_amount * b.asset_price je
              from kods.rzrq_hs_stock            a,
                   kods.rzrq_hs_his_hisprice     b,
                   kods.rzrq_hs_client           c,
                   kods.rzrq_hs_fund_fundaccount d
             where b.stock_code = a.stock_code
               and a.client_id = c.client_id
               and a.stock_type in ('T', 'L', '6', 'j', 'l','r') -- T ETLL LOF6 Ͷʻ r ʩ
               and trim(a.exchange_type) in ('1', '2')
               and a.fund_account = d.fund_account
               and d.asset_prop = '7'
               and b.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisprice
                     where init_date <= v_bbq_enddate)) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           5 zqlx, --ETF
           2 jylx, --ָй
           sum(je) je
      from (select decode(c.organ_flag, '1', 1, '3', 1, '0') khlx,
                   a.current_amount * b.last_price je
              from kods.rzrq_hs_stock            a,
                   kods.rzrq_hs_his_hisprice     b,
                   kods.rzrq_hs_client           c,
                   kods.rzrq_hs_fund_fundaccount d
             where b.stock_code = a.stock_code
               and a.client_id = c.client_id
               and a.fund_account = d.fund_account
               and a.stock_type in ('T' /*,'j','l'*/) -- T ETL
               and trim(a.exchange_type) in ('1', '2')
               and d.asset_prop = '7'
               and b.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisprice
                     where init_date <= v_bbq_enddate)) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           6 zqlx, --LOF
           2 jylx, --ָй
           sum(je) je
      from (select decode(c.organ_flag, '1', 1, '3', 1, '0') khlx,
                   a.current_amount * b.last_price je
              from kods.rzrq_hs_stock            a,
                   kods.rzrq_hs_his_hisprice     b,
                   kods.rzrq_hs_client           c,
                   kods.rzrq_hs_fund_fundaccount d
             where b.stock_code = a.stock_code
               and a.client_id = c.client_id
               and a.fund_account = d.fund_account
               and a.stock_type in ('L','r') -- T L LOF r ʩ
               and trim(a.exchange_type) in ('1', '2')
               and d.asset_prop = '7'
               and b.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisprice
                     where init_date <= v_bbq_enddate)) t
     group by t.khlx;
  commit;

  insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           7 zqlx, --ծȯ
           2 jylx, --ָй
           sum(je) je
      from (select decode(c.organ_flag, '1', 1, '3', 1, '0') khlx,
                   a.current_amount * b.last_price je
              from kods.rzrq_hs_stock            a,
                   kods.rzrq_hs_his_hisprice     b,
                   kods.rzrq_hs_client           c,
                   kods.rzrq_hs_fund_fundaccount d
             where b.stock_code = a.stock_code
               and a.client_id = c.client_id
               and a.fund_account = d.fund_account
               and a.stock_type in ('9', 'X', 'Y', 'U', 'u', 'a', 'Z') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and trim(a.exchange_type) in ('1', '2')
               and d.asset_prop = '7'
               and b.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisprice
                     where init_date <= v_bbq_enddate)) t
     group by t.khlx;
  commit;
   --
    insert into t_etl_jy_rzrq
    (khlx, zqlx, jylx, je)
    select t.khlx,
           9 zqlx, --A֤ȯ
           2 jylx, --ָй
           sum(je) je
      from (select decode(c.organ_flag, '1', 1, '3', 1, '0') khlx,
                   a.current_amount * b.ASSET_PRICE je
              from kods.rzrq_hs_stock            a,
                   kods.rzrq_hs_his_hisprice     b,
                   kods.rzrq_hs_client           c,
                   kods.rzrq_hs_fund_fundaccount d
             where b.stock_code = a.stock_code
               and a.client_id = c.client_id
               and a.fund_account = d.fund_account
               and a.stock_type in ('q','g') ----qҵƾ֤  g ƴƾ֤
               and trim(a.exchange_type) in ('1', '2')
               and d.asset_prop = '7'
               and b.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisprice
                     where init_date <= v_bbq_enddate)) t
     group by t.khlx;
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_RZRQ_YYB
prompt ====================================
prompt
create or replace procedure cisp_map_rzrq_yyb
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:        wuxg
  -- CREATE DATE:   20150831
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate number; --ʼ
  v_bbq_enddate   number; --ֹ
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  delete from T_ETL_YYB_RZRQ_TJB;

  --1 ʽ˻

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select t.branch_no, 1, nvl(count(*), 0)
      from kods.rzrq_hs_fund_fundaccount t, kods.rzrq_hs_client s
     where t.client_id = s.client_id
       and s.organ_flag in ('1', '0', '3')
       and t.asset_prop = '7' --˻
       and t.fundacct_status <> '3'
       and t.open_date <= v_bbq_enddate
     group by t.branch_no;
  --2 --Уͻ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select t.branch_no, 2, nvl(count(*), 0)
      from kods.rzrq_hs_fund_fundaccount t, kods.rzrq_hs_client s
     where t.client_id = s.client_id
       and s.organ_flag in ('1', '3') --1
       and t.asset_prop = '7' --˻
       and t.fundacct_status <> '3'
       and t.open_date <= v_bbq_enddate
     group by t.branch_no;
  --3 --˿ͻ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select t.branch_no, 3, nvl(count(*), 0)
      from kods.rzrq_hs_fund_fundaccount t, kods.rzrq_hs_client s
     where t.client_id = s.client_id
       and s.organ_flag = '0' --0
       and t.asset_prop = '7' --˻
       and t.fundacct_status <> '3'
       and t.open_date <= v_bbq_enddate
     group by t.branch_no;
  --4 ֤ȯ˻

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select t.branch_no, 4, sum(ls)
      from (select a.branch_no, count(stock_account) ls
              from KODS.RZRQ_HS_STOCKHOLDER a
             where open_date <= v_bbq_enddate
               and a.holder_status <> '3'
               and a.asset_prop = '7'
             group by a.branch_no) t
     group by t.branch_no;
  --5 ֤ȯӪҵпͻѻʹõŶȣԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select b.branch_no, 5, nvl(b.s1, 0) balance
      from (select m.branch_no, sum(m.total_max_quota) as s1
              from KODS.RZRQ_HS_CRDTCONTRACT m
             group by m.branch_no) b;

  --6 УͻʵʹõŶȣԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select b.branch_no, 6, nvl(b.s1, 0) balance
      from (select a.branch_no,
                   sum(a.slo_close_balance + fin_close_balance +
                       fare_close_debit + other_close_debit --ʸծ
                       /*a.fin_close_balance+ a.slo_close_balance*/) as s1 --ȯծ
              from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
             where a.init_date =
                   (select max(t.init_date)
                      from KODS.RZRQ_HS_HIS_HISASSETDEBIT t
                     where t.init_date <= v_bbq_enddate)
             group by a.branch_no) b;
  --7 УʽԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no,
           7,
           sum(fin_close_balance + fare_close_debit + other_close_debit) --ʸծ
      from kods.rzrq_hs_his_hisassetdebit
     where init_date = (select max(t.init_date)
                          from kods.rzrq_hs_his_hisassetdebit t
                         where t.init_date <= v_bbq_enddate)
     group by branch_no;

  --8 ȯԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no, 8, sum(slo_close_balance) --ȯծ
      from kods.rzrq_hs_his_hisassetdebit
     where init_date = (select max(t.init_date)
                          from kods.rzrq_hs_his_hisassetdebit t
                         where t.init_date <= v_bbq_enddate)
     group by branch_no;

  --9 ¹˾ۼƶ֤ȯӪҵͻűʣ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no, 9, count(*) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702, 4703) -- 4702ȯ 4703
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by branch_no;

  --10 Уűʣ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no, 10, count(*) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702) -- 4702
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by branch_no;

  --11 Уűʣ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no, 11, count(*) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4703) --ȯ 4703
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by branch_no;

  --12 ¹˾ۼƶ֤ȯӪҵͻŽԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no, 12, sum(business_balance)
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702, 4703) -- 4702  ȯ 4703
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by branch_no;

  --13  УŽԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no, 13, sum(business_balance)
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702) -- 4702
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by branch_no;

  --14  ȯŽԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no, 14, sum(business_balance)
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4703) --ȯ 4703
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by branch_no;

  --
  -- add by hucc 20120524
  -- Ŀ15  26

  delete from T_ETL_YYB_RZRQ_JYQK_UNION;
  --
  insert into T_ETL_YYB_RZRQ_JYQK_UNION
    (LX, BRANCH, SECU_NAME, SZ)
    select 1 as LX, a.branch_no, b.stock_name, sum(a.business_balance)
      from KODS.RZRQ_HS_HIS_HISDELIVER a, kods.Rzrq_Hs_Stkcode b
     where a.business_flag = '4702' -- 4702
       and a.init_date between v_bbq_begindate and v_bbq_enddate
       and a.stock_type = b.stock_type
       and a.stock_code = b.stock_code
     group by a.branch_no, b.stock_name;

  -- ȯ
  insert into T_ETL_YYB_RZRQ_JYQK_UNION
    (LX, BRANCH, SECU_NAME, SZ)
    select 2 as LX, a.branch_no, b.stock_name, sum(a.business_balance)
      from KODS.RZRQ_HS_HIS_HISDELIVER a, kods.Rzrq_Hs_Stkcode b
     where a.business_flag = '4703' --ȯ 4703
       and init_date between v_bbq_begindate and v_bbq_enddate
       and a.stock_type = b.stock_type
       and a.stock_code = b.stock_code
     group by a.branch_no, b.stock_name;
  --27 ֵԪ
  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select a.branch_no,
           27, /*sum(a.assure_close_balance)*/
           sum(current_balance) + sum(a.market_close_value) as s1
      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(t.init_date)
                          from KODS.RZRQ_HS_HIS_HISASSETDEBIT t
                         where t.init_date <= v_bbq_enddate)
     group by a.branch_no;
  --28  УֽԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select a.branch_no, 28, sum(current_balance) as s1
      from kods.rzrq_hs_his_hisassetdebit a
     where init_date = (select max(t.init_date)
                          from kods.rzrq_hs_his_hisassetdebit t
                         where t.init_date <= v_bbq_enddate)
     group by a.branch_no;

  --29 ֤ȯֵԪ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select a.branch_no, 29, sum(market_close_value) as s1
      from kods.rzrq_hs_his_hisassetdebit a
     where a.init_date =
           (select max(t.init_date)
              from kods.rzrq_hs_his_hisassetdebit t
             where t.init_date <= v_bbq_enddate)
     group by a.branch_no;

  --30 ֤ȯӪҵάֵ

  insert into T_ETL_YYB_RZRQ_TJB
    (YYB, XM, JE)
    select branch_no,
           30,
           case
             when sum(a.fin_close_balance + a.slo_close_balance +
                      a.fin_close_interest + a.slo_close_interest +
                      a.fare_close_interest + a.other_close_interest +
                      a.fare_close_debit + a.other_close_debit) = 0 then
              -1
             else
              round(sum(assure_close_balance) * 100 /
                    sum(a.fin_close_balance + a.slo_close_balance +
                        a.fin_close_interest + a.slo_close_interest +
                        a.fare_close_interest + a.other_close_interest +
                        a.fare_close_debit + a.other_close_debit),
                    2)
           end s1
      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(t.init_date)
                          from KODS.RZRQ_HS_HIS_HISASSETDEBIT t
                         where t.init_date <= v_bbq_enddate)
       and (a.fin_close_balance + a.slo_close_balance +
           a.fin_close_interest + a.slo_close_interest +
           a.fare_close_interest + a.other_close_interest +
           a.fare_close_debit + a.other_close_debit) > 0
     group by branch_no;

  --
  delete from T_ETL_YYB_RZRQ_SRQK
   WHERE YYB NOT IN
         (select p001 from krcs.t_ctl_t036 where a006 = '1004015');
  insert into T_ETL_YYB_RZRQ_SRQK
    (YYB, JE)
    select yyb, sum(occur_balance)
      from (select branch_no as yyb,
                   nvl(abs(sum(a.occur_balance)), 0) as occur_balance
              from kods.rzrq_hs_his_hisfundjour_q a
             where a.init_date between
                   (select substr(v_bbq_enddate, 1, 4) || '0101' from dual) and
                   v_bbq_enddate
               and a.business_flag in (2701,
                                       2712,
                                       2715,
                                       2718,
                                       2721,
                                       2724,
                                       2731,
                                       2732,
                                       2734,
                                       2735,
                                       2737,
                                       2738,
                                       2740,
                                       2741,
                                       2744,
                                       2776,
                                       2778,
                                       2779,
                                       2794,
                                       2795,
                                       2773)
               and a.asset_prop = '7'
               and a.branch_no not in
                   (select p001 from krcs.t_ctl_t036 where a006 = '1004015') --ɽӪҵ
             group by branch_no
            union all
            select branch_no as yyb,
                   nvl(abs(sum(a.FARE0)), 0) as occur_balance
              from kods.rzrq_hs_his_hisdeliver_q a
             where a.init_date between
                   (select substr(v_bbq_enddate, 1, 4) || '0101' from dual) and
                   v_bbq_enddate
               and a.business_flag in (4001,
                                       4002,
                                       4701,
                                       4702,
                                       4703,
                                       4704,
                                       4705,
                                       4706,
                                       4721,
                                       4722,
                                       4725,
                                       4726)
               and a.asset_prop = '7'
               and a.branch_no not in
                   (select p001 from krcs.t_ctl_t036 where a006 = '1004015') --ɽӪҵ
             group by branch_no)
     group by yyb;
  commit;

  -- ɽֵĩȡ
  delete from T_ETL_YYB_RZRQ_SRQK
   WHERE YYB IN (select p001 from krcs.t_ctl_t036 where a006 = '1004015');
  insert into T_ETL_YYB_RZRQ_SRQK
    (YYB, JE)
    select yyb, sum(occur_balance)
      from (select branch_no as yyb,
                   nvl(abs(sum(a.occur_balance)), 0) as occur_balance
              from kods.rzrq_hs_his_hisfundjour a
             where a.init_date between v_bbq_begindate and v_bbq_enddate
               and a.business_flag in (2701,
                                       2712,
                                       2715,
                                       2718,
                                       2721,
                                       2724,
                                       2732,
                                       2735,
                                       2738,
                                       2741,
                                       2744,
                                       2776,
                                       2778,
                                       2779,
                                       2794,
                                       2795,
                                       2773)
               and a.asset_prop = '7'
               and a.branch_no in
                   (select p001 from krcs.t_ctl_t036 where a006 = '1004015') --ɽӪҵ
             group by branch_no
            union all
            select branch_no as yyb,
                   nvl(abs(sum(a.FARE0)), 0) as occur_balance
              from kods.rzrq_hs_his_hisdeliver a
             where a.init_date between v_bbq_begindate and v_bbq_enddate
               and a.business_flag in (4001,
                                       4002,
                                       4701,
                                       4702,
                                       4703,
                                       4704,
                                       4705,
                                       4706,
                                       4721,
                                       4722,
                                       4725,
                                       4726)
               and a.asset_prop = '7'
               and a.branch_no in
                   (select p001 from krcs.t_ctl_t036 where a006 = '1004015') --ɽӪҵ
             group by branch_no)
     group by yyb;
  commit;

  cisp_etl_rzrq_yyb_zxtj_jyqk;
  cisp_etl_rzrq_yyb_zxtj_tjb;
  cisp_etl_rzrq_yyb_zxtj_srqk;
  commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_JY_RZRQ
prompt =======================================
prompt
create or replace procedure cisp_map_yyb_jy_rzrq
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:  A4-1:ױ(ͶӰetl:t_etl_jy)
  -- RETURN:
  -- AUTHOR:       hucc
  -- CREATE DATE:  2012/05/26
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
 is
  v_bbq_begindate number;
  v_bbq_enddate   number;
begin

  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  --֤ȯ
  delete from t_etl_yyb_zqjy_rzrq;

  --A
  insert into t_etl_yyb_zqjy_rzrq
    (yyb, zqlx, jyje, sxf)
    select a.branch_no yyb,
           1 zqlx, --A
           sum(business_balance) cjje, --ɽ
           sum(fare0) s1 --Ӷ
      from kods.v_rzrq_hs_his_hisdeliver a
     where business_flag in
           (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
          --4001֤ȯ ,4002֤ȯ
          --4211  ,4212  
          -- 4213ȯ,4214  ȯ,
          --4215 ƽ,4216  ƽ
       and trim(a.exchange_type) in ('1', '2')
       and a.stock_type in ('0', 'c', 'e', 'p') --A,ҵ
       and init_date between v_bbq_begindate and v_bbq_enddate
       and a.ASSET_PROP = '7'
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
     group by a.branch_no;
  --
  insert into t_etl_yyb_zqjy_rzrq
    (yyb, zqlx, jyje, sxf)
    select a.branch_no yyb,
           4 zqlx, --
           sum(business_balance) cjje, --ɽ
           sum(fare0) s1 --Ӷ
      from kods.v_rzrq_hs_his_hisdeliver a
     where business_flag in
           (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
          --4001֤ȯ  4002֤ȯ
          --4211  ,4212  
          -- 4213ȯ,4214  ȯ,
          --4215 ƽ,4216  ƽ
       and a.stock_type in ('6', 'L', 'T', 'j', 'l''r') -- T ETLL LOF6 Ͷʻ r ʩ
       and trim(a.exchange_type) in ('1', '2')
       and a.ASSET_PROP = '7'
       and init_date between v_bbq_begindate and v_bbq_enddate
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
     group by a.branch_no;
  --ծȯ
  insert into t_etl_yyb_zqjy_rzrq
    select yyb, 5 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb, t1.business_balance jyje, (fare0) fee
              from kods.v_rzrq_hs_his_hisdeliver t1
             where t1.business_flag in
                   (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
                  ----4001֤ȯ  4002֤ȯ
                  --4211  ,4212  
                  -- 4213ȯ,4214  ȯ,
                  --4215 ƽ,4216  ƽ
               and t1.stock_type in ('9', 'X', 'Y', 'U', 'u', 'a') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.ASSET_PROP = '7'
               and trim(t1.exchange_type) in ('1', '2')
               and t1.branch_no not in
                   (select t.p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004013, 1004011))
               and t1.init_date between v_bbq_begindate and v_bbq_enddate) t
     group by yyb;

  --֤ȯ
  insert into t_etl_yyb_zqjy_rzrq
    (yyb, zqlx, jyje, sxf)
    select a.branch_no yyb,
           7 zqlx, --֤ȯ
           sum(business_balance) cjje, --ɽ
           sum(fare0) s1 --Ӷ
      from kods.v_rzrq_hs_his_hisdeliver a
     where business_flag in
           (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
          --4001֤ȯ ,4002֤ȯ
          --4211  ,4212  
          -- 4213ȯ,4214  ȯ,
          --4215 ƽ,4216  ƽ
       and trim(a.exchange_type) in ('1', '2')
       and a.stock_type in ('q', 'g') --qҵƾ֤ gƴƾ֤
       and init_date between v_bbq_begindate and v_bbq_enddate
       and a.ASSET_PROP = '7'
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
     group by a.branch_no;

  --Ͻ
  insert into t_etl_yyb_zqjy_rzrq
    (yyb, zqlx, jyje, sxf)
    select a.branch_no yyb,
           10 zqlx, --Ͻ
           sum(business_balance) cjje, --ɽ
           sum(fare0) s1 --Ӷ
      from kods.v_rzrq_hs_his_hisdeliver a
     where business_flag in
           (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
          --4001֤ȯ  4002֤ȯ
          --4211  ,4212  
          -- 4213ȯ,4214  ȯ,
          --4215 ƽ,4216  ƽ
       and a.op_entrust_way in ('7', '8', '9') --ίзʽί7 ֻί8
       and trim(a.exchange_type) in ('1', '2')
       and a.stock_type in ('0',
                            'c',
                            '6',
                            'L',
                            'T',
                            'j',
                            'l',
                            '9',
                            'X',
                            'Y',
                            'U',
                            'u',
                            'a',
                            'e',
                            'p',
                            'q',
                            'g',
                            'r') --qҵƾ֤ gƴƾ֤ r ʩ
       and a.ASSET_PROP = '7'
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by a.branch_no;

  --ֳ
  insert into t_etl_yyb_zqjy_rzrq
    (yyb, zqlx, jyje, sxf)
    select a.branch_no yyb,
           20 zqlx, --ֳ
           sum(business_balance) cjje, --ɽ
           sum(fare0) s1 --Ӷ
      from kods.v_rzrq_hs_his_hisdeliver a
     where business_flag in
           (4001, 4002, 4701, 4702, 4703, 4704, 4705, 4706)
          --4001֤ȯ ,4002֤ȯ
          --4211  ,4212  
          --4213ȯ,4214  ȯ,
          --4215 ƽ,4216  ƽ
       and a.op_entrust_way in ('1', '7', '8', '9') --绰ֻ
          --ίзʽ0ίУ2פίУ4̨ί
       and trim(a.exchange_type) in ('1', '2')
       and a.stock_type in ('0',
                            'c',
                            '6',
                            'L',
                            'T',
                            'j',
                            'l',
                            '9',
                            'X',
                            'Y',
                            'U',
                            'u',
                            'a',
                            'e',
                            'p',
                            'q',
                            'g',
                            'r') --qҵƾ֤ gƴƾ֤ r ʩ
       and a.ASSET_PROP = '7'
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
       and init_date between v_bbq_begindate and v_bbq_enddate
     group by a.branch_no;

  --֤ȯֵ
  delete from t_etl_yyb_zqsz_rzrq;
  --A
  insert into t_etl_yyb_zqsz_rzrq
    (yyb, zqlx, zqsz)
    select a.branch_no,
           1 zqlx, --A
           sum((a.current_amount + abs(a.correct_amount)) * b.last_price) zqsz
      from kods.v_rzrq_hs_stock          a,
           kods.rzrq_hs_his_hisprice     b,
           kods.rzrq_hs_fund_fundaccount c
     where b.stock_code = a.stock_code
       and b.exchange_type = a.EXCHANGE_TYPE
       and a.fund_account = c.fund_account
       and a.stock_type in ('0', 'c', 'e', 'p') --A,ҵ
       and trim(a.exchange_type) in ('1', '2')
       and c.asset_prop = '7'
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
       and b.init_date = (select max(init_date)
                            from kods.rzrq_hs_his_hisprice
                           where init_date <= v_bbq_enddate)
     group by a.branch_no;
  --
  insert into t_etl_yyb_zqsz_rzrq
    (yyb, zqlx, zqsz)
    select a.branch_no,
           4 zqlx, --
           sum((a.current_amount + abs(a.correct_amount)) * b.last_price) zqsz
      from kods.v_rzrq_hs_stock          a,
           kods.rzrq_hs_his_hisprice     b,
           kods.rzrq_hs_fund_fundaccount c
     where b.stock_code = a.stock_code
       and b.exchange_type = a.exchange_type
       and a.fund_account = c.fund_account
       and c.asset_prop = '7'
       and a.stock_type in ('6', 'L', 'T', 'j', 'l','r')
          -- T ETLL LOF6 Ͷʻ, 
       and trim(a.exchange_type) in ('1', '2')
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
       and b.init_date = (select max(init_date)
                            from kods.rzrq_hs_his_hisprice
                           where init_date <= v_bbq_enddate)
     group by a.branch_no;

  --ծȯ
  insert into t_etl_yyb_zqsz_rzrq
    (yyb, zqlx, zqsz)
    select a.branch_no,
           5 zqlx, --ծȯ
           sum((a.current_amount + abs(a.correct_amount)) * b.last_price) zqsz
      from kods.v_rzrq_hs_stock          a,
           kods.rzrq_hs_his_hisprice     b,
           kods.rzrq_hs_fund_fundaccount c
     where b.stock_code = a.stock_code
       and b.exchange_type = a.exchange_type
       and a.fund_account = c.fund_account
       and c.asset_prop = '7'
       and a.stock_type in ('9', 'X', 'Y', 'U', 'u', 'a')
          -- u˾ծ Uҵծȯ Yҵתծ Xƾ֤ծ 9ʹծ a ˽ļծ
       and trim(a.exchange_type) in ('1', '2')
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
       and b.init_date = (select max(init_date)
                            from kods.rzrq_hs_his_hisprice
                           where init_date <= v_bbq_enddate)
     group by a.branch_no;

  --֤ȯ
  insert into t_etl_yyb_zqsz_rzrq
    (yyb, zqlx, zqsz)
    select a.branch_no,
           7 zqlx, --A
           sum((a.current_amount + abs(a.correct_amount)) * b.last_price) zqsz
      from kods.v_rzrq_hs_stock          a,
           kods.rzrq_hs_his_hisprice     b,
           kods.rzrq_hs_fund_fundaccount c
     where b.stock_code = a.stock_code
       and b.exchange_type = a.EXCHANGE_TYPE
       and a.fund_account = c.fund_account
       and a.stock_type in ('q', 'g') ----qҵƾ֤ gƴƾ֤
       and trim(a.exchange_type) in ('1', '2')
       and c.asset_prop = '7'
       and a.branch_no not in
           (select t.p001
              from krcs.t_ctl_t036 t
             where t.a006 in (1004013, 1004011))
       and b.init_date = (select max(init_date)
                            from kods.rzrq_hs_his_hisprice
                           where init_date <= v_bbq_enddate)
     group by a.branch_no;

  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_KHJYJSZJ_RZRQ
prompt =============================================
prompt
create or replace procedure cisp_map_yyb_khjyjszj_rzrq
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  a2-1:ͻʲ
-- RETURN:
-- AUTHOR:       wuxg
-- CREATE DATE:  2015/07/26
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
  v_bbq_begindate    number;
  v_bbq_enddate      number;

begin
   delete from  t_etl_yyb_khjyjszj_rzrq;

   select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_bbq_begindate, v_bbq_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

insert into t_etl_yyb_khjyjszj_rzrq(
          yyb,
          jylx,
          je
   )

   --ָй֤ȯֵ֤ͨȯֵ
   --עһӦõA4-1G11-G4
   select yyb, 9 jylx, sum(zxsz) zqsz
     from (select a.branch_no yyb, sum((a.current_amount+abs(a.correct_amount)) * b.last_price) zxsz
             from kods.v_rzrq_hs_stock a, 
                  kods.rzrq_hs_his_hisprice b,
                  kods.rzrq_hs_fund_fundaccount c
            where b.stock_code = a.stock_code
              -- add by zhouly 20200508 г
              and b.exchange_type = a.exchange_type
              and a.fund_account=c.fund_account
              and c.asset_prop='7'
              and a.stock_type in ('0','c','6','L','T','9','X','Y','U','u','a','j','l','e','p','q','g','r') --A,ҵ,T ETLL LOF6 Ͷʻ r ʩ
              and b.init_date = (select max(init_date)
             from kods.rzrq_hs_his_hisprice where init_date<=v_bbq_enddate)
             and trim(b.exchange_type) in('1','2')
             and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011))
            group by a.branch_no

           ) t
    group by yyb;
    commit;
    insert into t_etl_yyb_khjyjszj_rzrq  --̨ͻ׽ʽ
    (yyb,jylx,je)
     select yyb,14 jylx,sum(zhye) je
     from (
            select a.branch_no yyb,sum(/*a.BEGIN_BALANCE*/a.current_balance) zhye from
                   kods.v_rzrq_hs_fund_fund a,
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_bankarg c
            where a.fund_account=b.fund_account
            and b.fundacct_status!='3'--
            and a.branch_no=b.branch_no
            and a.bank_no=c.bank_no
            and b.asset_prop='7'
            and c.bank_type='4'
            and b.open_date<=v_bbq_enddate
            and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011))
            group by a.branch_no
          ) t1
    group by yyb;
commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_KHZJFB_RZRQ
prompt ===========================================
prompt
create or replace procedure cisp_map_yyb_khzjfb_rzrq
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  a2-1:ͻʽֲ
-- RETURN:
-- AUTHOR:       hucc
-- CREATE DATE:  2012/05/26
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
  v_bbq_begindate    number;
  v_bbq_enddate      number;

begin
   delete from  t_etl_yyb_khzjfb_rzrq;


  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  --ͻʽֲ
    insert into t_etl_yyb_khzjfb_rzrq
    (yyb,yhdm,yhmc,khsl,zjye,zzjzh)
   select yyb,yhdm,yhmc,sum(khsl) khsl,sum(zhye) zjye,sum(zzjzh) zzjzh
     from (
            select a.branch_no yyb,
            a.bank_no yhdm,
            c.bank_name yhmc,
            count(distinct a.fund_account) khsl,
            sum(a.current_balance) zhye,
            0 zzjzh
             from
            kods.v_rzrq_hs_fund_fund a,
            kods.rzrq_hs_bankarg c,
            kods.rzrq_hs_fund_fundaccount d
            where a.bank_no=c.bank_no
            and a.fund_account=d.fund_account
            and a.money_type='0'
            and c.bank_type='4'
            and d.asset_prop='7'
            and d.fundacct_status!='3'
            and d.open_date<=v_bbq_enddate
            and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011))
            group by a.branch_no,a.bank_no,c.bank_name
          ) t1
    group by yyb,yhdm,yhmc;

    --ɼ̨д
    declare
    v_yyb  number;
    v_jgdm varchar2(20);
    v_jgmc varchar2(40);
    v_count number;

    cursor yhdm is
      select b.p001,
             c.hs_bank_code,
           a.bank_name
      from kods.rzrq_hs_bankarg a ,(select p001 from krcs.t_ctl_t036 where a008 = 1023008) b
      , rzrq_bank c
      where a.bank_type in ('2','4')
      and a.bank_no=c.rzrq_bank_code;

  begin
    --α
    open yhdm;
    fetch yhdm
      into  v_yyb,v_jgdm,v_jgmc;

    while yhdm%found loop
      select count(*)
        into v_count
        from t_bks_t031
       where p001 = v_yyb and p002 = v_jgdm;
    if v_count = 0 then
       insert into t_bks_t031(P001,P002,A003,a004,a100) values (v_yyb,v_jgdm,v_jgmc,1,100000);

    end if;
    fetch yhdm
    into v_yyb,v_jgdm,v_jgmc;
    end loop;
    close yhdm;
     end;
    commit;


end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_ZHGF_ZJZH_RZRQ
prompt ==============================================
prompt
create or replace procedure cisp_map_yyb_zhgf_zjzh_rzrq
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:  a3-1:ʽ˻(ʻ淶)(ͶӰetl:t_etl_zqzh')
  -- RETURN:
  -- AUTHOR:       hucc
  -- CREATE DATE:  2012/05/26
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
 is
  v_bbq_begindate number;
  v_enddate       number;
begin
  delete from t_etl_yyb_zhgf_zjzh_rzrq;

  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  insert into t_etl_yyb_zhgf_zjzh_rzrq
    (yyb, jylx, sl, zjye)
    select s.branch_no,
           55 jylx,
           count(s.fund_account),
           sum(a.current_balance)
      from kods.rzrq_hs_fund_fundaccount s,
           kods.v_rzrq_hs_fund_fund      a,
           kods.rzrq_hs_client           b
     where a.money_type = '0'
       and a.fund_account = s.fund_account
       and a.client_id = s.client_id
       AND S.CLIENT_ID = B.CLIENT_ID
       AND A.CLIENT_ID = B.CLIENT_ID
       and B.organ_flag in ('1', '0', '3', '5', '6')
       AND S.ASSET_PROP in ( /*'0',*/ '7')
          --and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
       and s.fundacct_status <> '3'
     group by s.branch_no
    union all --˻ʽ˻
    select t1.branch_no,
           1 jylx,
           count(t2.fund_account) sl,
           sum(t1.current_balance) je
      from kods.v_rzrq_hs_fund_fund      t1,
           kods.rzrq_hs_fund_fundaccount t2,
           kods.rzrq_hs_bankarg          t3
     where t1.bank_no = t3.bank_no
       and t1.fund_account = t2.fund_account
       and t3.bank_type in ('2', '4')
       and t1.money_type = '0'
       and t2.fundacct_status <> '3'
       and t2.asset_prop in ( /*'0',*/ '7')
       and t2.main_flag = '1'
       and t2.open_date <= v_enddate
    --and t1.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
     group by t1.branch_no;
  commit;
  delete from t_etl_yyb_zhgf_zjzh_rzrq t
   where t.yyb in
         (select t.p001
            from krcs.t_ctl_t036 t
           where t.a006 in (1004013, 1004011, 1004015, 1004005, 1004028));
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_ZJZH_RZRQ
prompt =========================================
prompt
create or replace procedure cisp_map_yyb_zjzh_rzrq
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  a3-1:ʽ˻(ʻ)(ͶӰetl:T_ETL_ZJZH)
-- RETURN:
-- AUTHOR:       hucc
-- CREATE DATE:  2012/05/26
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
  v_begindate    number;
  v_enddate      number;
begin
   delete from  t_etl_yyb_zjzh_rzrq;

   select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;
   --ʽ˻
   insert into t_etl_yyb_zjzh_rzrq( yyb, khlx, jylx, bz, sl)
     select a.branch_no as yyb,0 as khlx , 1 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('7')
             and a.branch_no not in(select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005,1004028))
             group by a.branch_no;
             
 --ʽ˻Ͽ    
   insert into t_etl_yyb_zjzh_rzrq
  select a.branch_no as yyb,0 as khlx , 12 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             --and a.open_type = '2'
             and a.op_entrust_way = '7'
             and a.asset_prop in ('7')
             and a.branch_no not in(select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005,1004028))
             group by a.branch_no;
  commit;
--ʽ˻֤
  insert into t_etl_yyb_zjzh_rzrq
  select a.branch_no as yyb,0 as khlx , 13 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('7')
             and a.branch_no not in(select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005,1004028))
             --and a.open_type = '1'
             and a.op_entrust_way = 'O'
             group by a.branch_no;
  commit;        
  
   insert into t_etl_yyb_zjzh_rzrq( yyb, khlx, jylx, bz, sl)
   --ĩʽ˻
      select a.branch_no as yyb, decode(b.organ_flag,'1',1,'3',1,'5',1,'6',1,0) as khlx , 3 jylx ,9 as bz,
  count(distinct a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,kods.rzrq_hs_client b,kods.v_rzrq_hs_fund_fund c
             where   a.client_id=b.client_id
             and a.client_id = c.client_id
             and b.branch_no=b.branch_no
             and a.fundacct_status<>'3'
             and c.money_type = '0'
             and a.open_date < = v_enddate
             and b.organ_flag in ('1','0','3','5','6')
             and a.asset_prop in ('7')
             and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005,1004028))
             group by a.branch_no,decode(b.organ_flag,'1',1,'3',1,'5',1,'6',1,0) ;--Ϊ

    commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_ZQZH_RZRQ
prompt =========================================
prompt
create or replace procedure cisp_map_yyb_zqzh_rzrq
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:  a3-1:֤ȯ˻(ʻ)(ͶӰetl:t_etl_zqzh')
  -- RETURN:
  -- AUTHOR:       hucc
  -- CREATE DATE:  2012/05/26
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
 is
  v_begindate number;
  v_enddate   number;
begin
  delete from t_etl_yyb_zqzh_rzrq;
  commit;

  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  insert into t_etl_yyb_zqzh_rzrq
    (yyb, khlx, jylx, bz, sl)
    select t.yyb yyb,
           decode(t.organ_flag, '1', 1, '3', 1, '5', 1, '6', 1, 0) as khlx,
           1 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type, '1', 0, 'D', 2, '2', 0, 'H', 1) as bz,
                   c.organ_flag,
                   a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a,
                   kods.rzrq_hs_fund_fundaccount   b,
                   kods.rzrq_hs_client             c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account = b.fund_account
               and a.init_date between v_begindate and v_enddate
               and a.business_flag in ('1104', '1101')
               and a.exchange_type in ('1', '2', 'D', 'H')
               and b.asset_prop in ( /*'0',*/ '7')
                  --and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
               and c.organ_flag in ('1', '0', '3', '5', '6')) t
     group by t.yyb,
              decode(t.organ_flag, '1', 1, '3', 1, '5', 1, '6', 1, 0),
              t.bz;
  commit;

  --ĩ
  insert into t_etl_yyb_zqzh_rzrq
    (yyb, khlx, jylx, bz, sl)
    select t.yyb yyb,
           decode(t.organ_flag, '1', 1, '3', 1, '5', 1, '6', 1, 0) as khlx,
           3 as jylx,
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type, '1', 0, 'D', 2, '2', 0, 'H', 1) as bz,
                   c.organ_flag,
                   a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder      a,
                   kods.rzrq_hs_fund_fundaccount b,
                   kods.rzrq_hs_client           c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account = b.fund_account
               and b.fundacct_status <> '3'
               and a.asset_prop in ( /*'0',*/ '7')
               and a.stock_account not like 'F%'
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and b.open_date < = v_enddate
                  --and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
               and c.organ_flag in ('1', '0', '3', '5', '6')) t
     group by t.yyb,
              decode(t.organ_flag, '1', 1, '3', 1, '5', 1, '6', 1, 0),
              t.bz;
  commit;
  delete from t_etl_yyb_zqzh_rzrq t
   where t.yyb in
         (select t.p001
            from krcs.t_ctl_t036 t
           where t.a006 in (1004013, 1004011, 1004015, 1004005, 1004028));
  commit;

end;
/

prompt
prompt Creating procedure CISP_INTERFACE_RZRQ
prompt ======================================
prompt
create or replace procedure cisp_interface_rzrq
is
begin
   --ܲȯ C10-1
   cisp_map_rzrq_zb;
   --Ӫҵȯ
   cisp_map_rzrq_yyb;
   --ִеܲC1-2
   cisp_map_jy_rzrq;
   --ִеӪҵA2-1A3-1A4-1
   cisp_map_yyb_khjyjszj_rzrq;
   cisp_map_yyb_khzjfb_rzrq;
   cisp_map_yyb_zjzh_rzrq;
   cisp_map_yyb_zqzh_rzrq;
   cisp_map_yyb_zhgf_zjzh_rzrq;
   
   cisp_map_yyb_jy_rzrq;
   cisp_map_hg_c13_2;
  -- cisp_map_hg_c13_3;
   commit;

end cisp_interface_rzrq;
/

prompt
prompt Creating procedure CISP_INTERFACE_XSJRCP_YCL
prompt ============================================
prompt
create or replace procedure cisp_interface_xsjrcp_ycl is
  v_begindate   varchar2(8);
  v_enddate     varchar2(8);
  v_endworddate varchar2(8);
begin
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select max(t.phydate)
    into v_endworddate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_enddate;

  --add by zhenyj 20190220 C12-1B-A5-1⣬Ȱݲ뵽мȻɾִֻһ
  delete kods.a_hs_his_secumdealinfo_temp;
  delete kods.a_hs_his_secumdealinfo_bn_t1;
  -- ȷT+1һԤȷˮ¸
  insert into kods.a_hs_his_secumdealinfo_temp
    select *
      from kods.a_hs_his_secumdealinfo t
     where t.business_amount = 0
       and t.business_flag = '44122'
       and t.init_date = v_endworddate;

  delete from kods.a_hs_his_secumdealinfo t
   where t.business_amount = 0
     and t.business_flag = '44122';

  insert into kods.a_hs_his_secumdealinfo_bn_t1
    select * from kods.a_hs_his_secumdealinfo_bnlj t
     where t.business_amount = 0
       and t.business_flag = '44122'
       and t.init_date = v_endworddate;

  delete from kods.a_hs_his_secumdealinfo_bnlj t
   where t.business_amount = 0
     and t.business_flag = '44122';

  insert into kods.a_hs_his_secumdealinfo
    select * from kods.a_hs_his_secumdealinfo_temp2 t;

  insert into kods.a_hs_his_secumdealinfo_bnlj
    select * from kods.a_hs_his_secumdealinfo_bn_t2;
  commit;

end;
/

prompt
prompt Creating procedure CISP_INTERFACE_SJHB
prompt ======================================
prompt
create or replace procedure cisp_interface_sjhb is
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  --C12-1ƷѯƷϸԺ󵼳excelͻ
  /*  
  insert into t_bks_t100
    select distinct t.fund_code, t.stock_name, 11, 22, 30, 42
      from kods.a_hs08_his_ofdeliver t
     where t.fund_code not in (select jjdm from t_bks_t100)
       and t.fund_code <> ' '
    union all
    select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
      from kods.a_hs_his_bankmdeliver t
     where t.prod_code not in (select jjdm from t_bks_t100)
    union all
    select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
      from kods.a_hs_his_secumdeliver t
     where t.prod_code not in (select jjdm from t_bks_t100);
  commit;
  */


  --add by zhenyj 20190220 C12-1B-A5-1⣬ִֻһ
  cisp_interface_xsjrcp_ycl;
  
  
  --ݲ뱾 
  --modify by zhenyj 20190301 ݲɼɼȫݣҪڴ
/*  delete from kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
   where init_date between v_begindate and v_enddate;
  commit;
  delete from kods.RZRQ_HS_HIS_HISDELIVER_Q
   where init_date between v_begindate and v_enddate;
  commit;

  insert into kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
    select *
      from kods.RZRQ_HS_HIS_HISFUNDJOUR
     where init_date between v_begindate and v_enddate;

  insert into kods.RZRQ_HS_HIS_HISDELIVER_Q
    select *
      from kods.RZRQ_HS_HIS_HISDELIVER
     where init_date between v_begindate and v_enddate;
  commit;*/

end;
/

prompt
prompt Creating procedure CISP_MAP_C12_1
prompt =================================
prompt
create or replace procedure cisp_map_C12_1 is

  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin

  --ȡڵڼʱ
  select to_char(a005,'YYYYMMDD') into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(a006,'YYYYMMDD') into v_enddate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;

  delete from T_ETL_XSJRCP_FSE /*where xm not in(24,25)*/;
   /******************************Ӷ***********************************/
   --1.֤ȯͶʻ
  insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 1,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
      )a
      ,
      (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag  in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;

  --3.˾ʲƻ
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 3,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       )
      ) a
      ,
      ( select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
       )
       
      )B
      ,
      (select sum(BNZJSL) as BNZJSL from (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )
      ) C
      ,
      (select sum(BNJSSL) as BNJSSL from (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )
      )D;
    commit;
    
    --5.˾ʲƻ
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 4,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       )
      ) a
      ,
      ( select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
       )
       
      )B
      ,
      (select count(distinct BNZJSL) as BNZJSL from (
      select prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all 
      select  prod_code BNZJSL from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44122','44130','44139')
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      ) C
      ,
      (select count(distinct BNJSSL) as BNJSSL from (
      select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
      select  t.prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)      
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      )D;
    commit;
    -- ҵƲƷ
     insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 5,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(abs(entrust_amount)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43130') and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
      ) a
      ,
      (
      select sum(abs(entrust_amount)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43142','43150') and prod_code in (select jjdm from t_bks_t100 where fxzl=14)      
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43130') 
       and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      ) C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43142','43150') 
       and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;
    commit;
    
    --
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select 6,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
      )a
      ,
      (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag  in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;
      commit;
    
    --ڲƷ
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 8,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (select sum(BQZJJE) BQZJJE,sum(BQZJSL) BQZJSL from (
       select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
       and business_balance<>0)       
      ) a
      ,
      (
      select sum(BQJSJE) BQJSJE,sum(BQJSSL) BQJSSL from (
       select sum(abs(business_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
       and entrust_balance<>0)      
      )B
      ,
      (
      select count(distinct BNZJSL) BNZJSL from (
       select  prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=17)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       /*union all
       select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate*/
       )
      ) C
      ,
      (
      select count(distinct BNJSSL) BNJSSL from (
      /* select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=17)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
       select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate) 
      )D;
    commit;
    --֤ȯ˾ʲƻ
    insert into T_ETL_XSJRCP_FSE
    select 2,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL),sum(T.BQJSSL),sum(T.BQJSJE),sum(T.BNJSSL) from T_ETL_XSJRCP_FSE t where t.xm in (3,4) ;

    commit;
    --˷ϼ
    insert into T_ETL_XSJRCP_FSE
    select 101,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL) ,SUM(T.BQJSSL),SUM(T.BQJSJE),SUM(T.BNJSSL)
           from T_ETL_XSJRCP_FSE t
                where t.xm in(1,2,5,6,7,8);

    commit;
    /*******************************************************************/
    --10.̶ڲƷ
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   --select 10,t.BQZJSL,t.BQZJJE,t.BNZJSL,t.BQJSSL,t.BQJSJE,t.BNJSSL from T_ETL_XSJRCP_FSE t where t.xm = 5;
   select 10,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(abs(entrust_amount)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43130') and prod_code in (select jjdm from t_bks_t100 where syzl=21)
      ) a
      ,
      (
      select sum(abs(entrust_amount)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43142','43150') and prod_code in (select jjdm from t_bks_t100 where syzl=21)      
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43130') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=21)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      ) C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43142','43150') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=21)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;
   
    --11.ڲƷ
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
  select 11,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from(
      select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and business_balance<>0
       union
       select sum(abs(entrust_amount)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43130') and prod_code in (select jjdm from t_bks_t100 where syzl=22))  
      ) a
      ,
      (
      select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
      select sum(abs(entrust_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and entrust_balance<>0
       union
       select sum(abs(entrust_amount)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43142','43150') and prod_code in (select jjdm from t_bks_t100 where syzl=22) )  
      ) B
      ,
      (
      select count(distinct BNZJSL) as BNZJSL from (
      /*select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date  between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
      select  prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        union all 
        select  prod_code as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43130') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      ) C
      ,
      (
      select count(distinct BNJSSL) as BNJSSL from (
      /*select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
      select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select  prod_code as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43142','43150') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate )
      ) D;
      commit;
     --13ڲƷ    
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 13,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
       select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)  
       and business_balance<>0   
      ) a
      ,
      (
      select sum(abs(entrust_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and entrust_balance<>0
      )B
      ,
      (select count(distinct BNZJSL) as BNZJSL from (
       select prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        /*union all
        select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate*/)) C
      ,
      (
      select count(distinct BNJSSL) as BNJSSL from(
       select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       /*union all
       select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate*/)
      )D;
    commit;

     --12.ڲƷ
   

      --15.ṹڲƷ
     insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 15,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) BQZJJE,sum(BQZJSL) BQZJSL from (
      select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and business_balance<>0) 
      ) a
      ,
      (
      select sum(BQJSJE) BQJSJE,sum(BQJSSL) BQJSSL from (
      select sum(abs(entrust_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and entrust_balance<>0)
      ) B
      ,
      (
      select count(distinct BNZJSL) BNZJSL from(
     /* select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
      select prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)       
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate) 
      ) C
      ,
      (
      select count(distinct BNJSSL) BNJSSL from (
      /*select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where syfl=31)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
      select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code  in (select jjdm from t_bks_t100 where syfl=31)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate) 
      ) D;
    /******************************۷ʽ*************************************/
    commit;
    --(˾)
    insert into T_ETL_XSJRCP_FSE
     select 17,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from (
       select sum(abs(t.business_balance)) BQZJJE,count (distinct t.prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo t
       where business_flag in('44122','44130','44139')
       and  t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and t.business_balance<>0)
      ) a
      ,
      ( select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
       select sum(abs(t.business_balance)) BQJSJE,count (distinct t.prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and t.entrust_balance<>0)
       
      )B
      ,
      (select count(distinct BNZJSL) as BNZJSL from (
      /*select prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fsfl=41)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all */
      select prod_code BNZJSL from kods.a_hs_his_secumdealinfo_bnlj t
       where business_flag in('44122','44130','44139')
       and  t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      ) C
      ,
      (select count(distinct BNJSSL) as BNJSSL from (
      /*select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
      select  t.prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      )D;
    commit;
    --
    insert into T_ETL_XSJRCP_FSE
    select       18,sum(decode(xm,101,t.BQZJSL,-t.BQZJSL)),
                    sum(decode(xm,101,t.BQZJJE,-t.BQZJJE)),
                    sum(decode(xm,101,t.BNZJSL,-t.BNZJSL)),
                    sum(decode(xm,101,t.BQJSSL,-t.BQJSSL)),
                    sum(decode(xm,101,t.BQJSJE,-t.BQJSJE)),
                    sum(decode(xm,101,t.BNJSSL,-t.BNJSSL))
                    from T_ETL_XSJRCP_FSE t
                         where t.xm in( 101,17);

     commit;
    /******************************ͷ*************************************/
    --21.
   insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 21,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
       select sum(BQZJJE) BQZJJE,count(distinct BQZJSL) BQZJSL from (  
       select sum(a.business_balance) BQZJJE, a.client_id as BQZJSL  from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44122','44139','44130')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQZJJE,a.client_id as BQZJSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       group by a.client_id)
      )a
      ,
      (
       select sum(BQJSJE) BQJSJE,count(distinct BQJSSL) BQJSSL from(
       select sum(abs(a.BUSINESS_BALANCE)) BQJSJE, a.client_id as BQJSSL from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       and a.entrust_balance<>0
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQJSJE, a.client_id as BQJSSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c 
       where business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       group by a.client_id )
      )B
      ,
      (
       select count(distinct BNZJSL) BNZJSL  from (
       /*select a.client_id as BNZJSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44122','44139','44130')
       and a.client_id = c.client_id
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and c.organ_flag in ('1','3') 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all*/
       select  a.client_id BNZJSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44122','44130','44139')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all
       select a.client_id as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id)
      )C
      ,
      (
       select count(distinct BNJSSL) BNJSSL from (
      /* select a.client_id as BNJSSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44124','44142','44150')
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all */
       select  a.client_id as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all
       select  a.client_id as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id)
      )D;

     commit;
     --22.
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 22,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
       select sum(BQZJJE) BQZJJE,count(distinct BQZJSL) BQZJSL from ( 
       select sum(abs(business_balance)) BQZJJE,a.client_id as BQZJSL from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
      where business_flag in ('44122','44130','44139')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and a.business_balance<>0
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQZJJE, a.client_id as BQZJSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       group by a.client_id)
      )a
      ,
      (
       select sum(BQJSJE) BQJSJE,count(distinct BQJSSL) BQJSSL from(
       select sum(abs(a.entrust_balance)) BQJSJE,a.client_id as BQJSSL from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and a.entrust_balance<>0
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQJSJE,a.client_id as BQJSSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c 
       where business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and c.organ_flag ='0' 
       group by a.client_id)
      )B
      ,
      (
       select count(distinct BNZJSL) BNZJSL  from (
      /* select a.client_id as BNZJSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44122','44139','44130')
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
       select a.client_id BNZJSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44122','44130','44139')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select a.client_id as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       and c.organ_flag ='0')
      )C
      ,
      (
       select count(distinct BNJSSL) BNJSSL from (
      /* select a.client_id as BNJSSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44124','44142','44150')
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all */
       select  a.client_id as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       and c.organ_flag ='0'
       group by a.client_id
       union all
       select a.client_id as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       and c.organ_flag ='0'
       group by a.client_id)
      )D;
     commit;

    update T_ETL_XSJRCP_FSE t set t.BQZJJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQZJJE,0),-nvl(t1.BQZJJE,0))) from T_ETL_XSJRCP_FSE t1
                    where t1.xm in(101,21) ),
                    t.BQJSJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQJSJE,0),-nvl(t1.BQJSJE,0))) from T_ETL_XSJRCP_FSE t1
                    where t1.xm in(101,21) )
                    where t.xm=22;

  delete from T_ETL_XSJRCP_QMYE;
  commit;
    /******************************ĩ***********************************/
      --1.֤ȯͶʻ
  insert into T_ETL_XSJRCP_QMYE
    (XM, QMSL, QMJE)
    select 1, a.qmsl, a.qmje
      from (select count(distinct a.prod_code) as qmsl,
                   round(sum(a.current_amount * b.net_value), 2) as qmje
              from kods.a_hs08_secumshare a, kods.a_hs_his_prodprice b
             where a.prod_code = b.prod_code
               and a.prod_code in
                   (select jjdm from t_bks_t100 where fxzl = 11)
               and a.current_amount<>0
               and b.init_date =
                   (select max(init_date)
                      from kods.a_hs_his_prodprice
                     where init_date <= v_enddate)
               and exists (select *
                      from kods.a_hs_secumholder s
                     where a.client_id = s.client_id)) a;
    commit;

  --3.˾ʲƻ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 3, a.qmsl, a.qmje
       from (select sum(qmsl) as qmsl, sum(qmje) as qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                      and t.current_amount <>0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 12)
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id))) a;
   commit;
    
  --4.˾ʲƻ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 4, a.qmsl, a.qmje
       from (select sum(qmsl) as qmsl, sum(qmje) as qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and t.current_amount <>0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 13)
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id))) a;
   commit;

    --֤ȯ˾ʲƻ
    insert into T_ETL_XSJRCP_QMYE
    select 2,sum(t.qmsl),sum(t.qmje) from T_ETL_XSJRCP_QMYE t where t.xm in (3,4) ;

    commit;
    --
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 5, a.qmsl, a.qmje
       from (select count(distinct prod_code) as qmsl,
                    sum(current_amount) as qmje
               from kods.a_hs08_bankmshare
              where prod_code in
                    (select jjdm from t_bks_t100 where fxzl = 14)
                and current_amount <> 0) a;
   commit;
   --ڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 8, a.qmsl, a.qmje
       from (select sum(qmsl) qmsl, sum(qmje) qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and t.current_amount <>0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 17)
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id))) a;
   commit;

    --˷ϼ
    insert into T_ETL_XSJRCP_QMYE
    select 101,sum(t.qmsl),sum(t.qmje)
           from T_ETL_XSJRCP_QMYE t
                where t.xm in(1,2,5,6,7,8);

    commit;

     --10.̶ڲƷ
      insert into T_ETL_XSJRCP_QMYE(XM,QMSL,QMJE)
   --select 10,a.qmsl,a.qmje from T_ETL_XSJRCP_QMYE a where xm=5;
       select 10, a.qmsl, nvl(a.qmje, 0)
      from (select count(distinct prod_code) as qmsl,
                   sum(current_amount) as qmje
              from kods.a_hs08_bankmshare
             where prod_code in
                   (select jjdm from t_bks_t100 where syzl = 21)
               and current_amount<>0 ) a;


    --11.ڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 11, a.qmsl, a.qmje
       from (select sum(qmsl) qmsl, sum(qmje) qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where syzl = 22)
                        and current_amount <> 0
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id)
                     union all
                     select count(distinct prod_code) as qmsl,
                            sum(current_amount) as qmje
                       from kods.a_hs08_bankmshare
                      where prod_code in
                            (select jjdm from t_bks_t100 where syzl = 22)
                        and current_amount <> 0)) a;
      commit;
     -- ڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 13, a.qmsl, a.qmje
       from (select count(distinct t.prod_code) as qmsl,
                    round(sum(t.current_amount * b.net_value), 2) as qmje
               from kods.a_hs08_secumshare t, kods.a_hs_his_prodprice b
              where t.prod_code = b.prod_code
                and t.current_amount <>0
                and b.init_date =
                    (select max(init_date)
                       from kods.a_hs_his_prodprice
                      where init_date <= v_enddate)
                and t.prod_code in
                    (select jjdm from t_bks_t100 where syzl = 24)
                and exists (select *
                       from kods.a_hs_secumholder s
                      where t.client_id = s.client_id)) a;
   commit;

 
   --15.ṹڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 15, a.qmsl, a.qmje
       from (select sum(qmsl) qmsl, sum(qmje) qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                       and t.current_amount <>0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where syfl = 31)
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id))) a;
   /******************************۷ʽ*************************************/
    commit;
    --(˾)
    insert into T_ETL_XSJRCP_QMYE
      select 17, a.qmsl, a.qmje
        from (select sum(qmsl) as qmsl, sum(qmje) as qmje
                from (select count(distinct t.prod_code) as qmsl,
                             round(sum(t.current_amount * b.net_value), 2) as qmje
                        from kods.a_hs08_secumshare  t,
                             kods.a_hs_his_prodprice b
                       where t.prod_code = b.prod_code
                        and t.current_amount <>0
                         and b.init_date =
                             (select max(init_date)
                                from kods.a_hs_his_prodprice
                               where init_date <= v_enddate)
                         and t.prod_code in
                             (select jjdm from t_bks_t100 where fsfl = 41)
                         and exists
                       (select *
                                from kods.a_hs_secumholder s
                               where t.client_id = s.client_id))) a;
    commit;

    commit;
    --
    insert into T_ETL_XSJRCP_QMYE
    select 18,sum(decode(xm,101,t.qmsl,-t.qmsl)),
                    sum(decode(xm,101,t.qmje,-t.qmje))
                    from T_ETL_XSJRCP_QMYE t
                         where t.xm in( 101,17);


    /******************************ͷ*************************************/
   --21.
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 21, a.qmsl, a.qmje
       from (select count(distinct qmsl) qmsl, sum(qmje) qmje
               from (select a.client_id as qmsl,
                            sum(a.current_amount) as qmje
                       from kods.a_hs08_bankmshare a, kods.rzrq_hs_client c
                      where a.client_id = c.client_id
                        and c.organ_flag in ('1', '3')
                      group by a.client_id
                     union all
                     select a.client_id as qmsl,
                            sum(a.current_amount * b.net_value) as qmje
                       from kods.a_hs08_secumshare  a,
                            kods.rzrq_hs_client     c,
                            kods.a_hs_his_prodprice b
                      where a.client_id = c.client_id
                        and a.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and c.organ_flag in ('1', '3')
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where a.client_id = s.client_id)
                      group by a.client_id)
              where qmje <> 0) a;
   
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 22, a.qmsl, a.qmje
       from (select count(distinct qmsl) qmsl, sum(qmje) qmje
               from (select a.client_id as qmsl,
                            sum(a.current_amount) as qmje
                       from kods.a_hs08_bankmshare a, kods.rzrq_hs_client c
                      where a.client_id = c.client_id
                        and c.organ_flag = '0'
                      group by a.client_id
                     union all
                     select a.client_id as qmsl,
                            round(sum(a.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  a,
                            kods.rzrq_hs_client     c,
                            kods.a_hs_his_prodprice b
                      where a.client_id = c.client_id
                        and a.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and c.organ_flag = '0'
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where a.client_id = s.client_id)
                      group by a.client_id)
              where qmje <> 0) a;
   commit;
   
   update T_ETL_XSJRCP_QMYE t
      set t.qmje = (select sum(decode(t1.xm,
                                      101,
                                      nvl(t1.qmje, 0),
                                      -nvl(t1.qmje, 0)))
                      from T_ETL_XSJRCP_QMYE t1
                     where t1.xm in (101, 21))
    where t.xm = 22;
   /*  --22.
        insert into T_ETL_XSJRCP_QMYE(XM,QMSL,QMJE)
       select 22,sum(decode(xm,101,qmsl,-qmsl)),
                       sum(decode(xm,101,qmje,-qmje))
              from T_ETL_XSJRCP_QMYE t
                   where xm in (101,21);*/

    commit;
   --
   insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select 24,0,NVL(a.BQZJJE,0),0,0,0,0
    from (
       select sum(BQZJJE) BQZJJE from (  
       /*select sum(a.fare_sx) BQZJJE  from kods.a_hs08_his_ofdeliver a
       where a.business_flag in ('122','139','130'\*,'124','142','150'*\)
       union all*/
       select sum(fare_sx) BQZJJE from kods.a_hs_his_secumdealinfo a
      where business_flag in ('44122','44130','44139') 
       and a.business_balance<>0 
       union all
       select sum(RATIO_SX) BQZJJE from kods.a_hs_his_bankmdeliver a
       where  business_flag in ('43130')
      ) )a;
      --
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select 25,0,NVL(a.BQZJJE,0),0,0,0,0
    from (
       select sum(BQZJJE) BQZJJE from (  
       /*select sum(a.fare_sx) BQZJJE  from kods.a_hs08_his_ofdeliver a
       where a.business_flag in ('122','139','130'\*,'124','142','150'*\)
       and fund_code in  (select jjdm from t_bks_t100 where fsfl=42)
       union  all*/
        select sum(fare_sx) BQZJJE from kods.a_hs_his_secumdealinfo a
      where business_flag in ('44122','44130','44139')
        and prod_code in  (select jjdm from t_bks_t100 where fsfl=42)
         and a.business_balance<>0 
      ) )a;

  cisp_etl_XSJRCP;
  /**
     ҵĿǰû
  **/
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A5_1
prompt ====================================
prompt
create or replace procedure cisp_map_YYB_A5_1 is

  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin

  --ȡڵڼʱ
  select to_char(a005,'YYYYMMDD') into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(a006,'YYYYMMDD') into v_enddate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;

  delete from T_ETL_YYB_XSJRCP_FSE /*where xm not in(24,25)*/;
   /******************************Ӷ***********************************/
   --1.֤ȯͶʻ
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
      SELECT yyb,1,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT PROD_CODE) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG in ('44124','44142','44150')
            and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
            and init_date between substr(v_enddate,1,4)||0101 and v_enddate
            GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(BUSINESS_BALANCE) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_secumdealinfo
             WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
             and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
             GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(BUSINESS_BALANCE) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo
                WHERE BUSINESS_FLAG in ('44124','44142','44150')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
                GROUP BY BRANCH_NO) group by yyb;
     commit;
  --3.˾ʲƻ
      insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select yyb,3,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
    from
      (
      select branch_no yyb,0 bqzjsl,0 bqzjje,count(distinct prod_code) as BNZJSL ,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44122','44139','44130')
      and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        group by branch_no
     /*union all
     select branch_no yyb,0 bqzjsl,0 bqzjje,count(distinct prod_code)as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by branch_no  */
     union all
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,count(distinct prod_code) as BNJSSL
      from kods.a_hs_his_secumdealinfo_bnlj where   business_flag in ('44124','44142','44150')
      and prod_code in (select jjdm from t_bks_t100 where fxzl=12)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        group by branch_no
     /* union all  
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,count(distinct t.prod_code) as BNJSSL 
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by branch_no */
     /*union all
      select branch_no yyb,count(distinct fund_code) as BQZJSL,sum(balance) BQZJJE,0 BNZJSL ,0 bqjssl,0 bqjsje,0 BNJSSL
      from kods.a_hs08_his_ofdeliver where  business_flag in ('122','139','130')
      and fund_code in (select jjdm from t_bks_t100 where fxzl=12)
        group by branch_no*/
     union all
      select branch_no yyb,count (distinct t.prod_code) as BQZJSL,sum(abs(t.business_balance)) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL 
      from kods.a_hs_his_secumdealinfo t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and t.business_balance<>0
       group by branch_no
     /*union all
      select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count(distinct fund_code) as BQJSSL,sum(balance) BQJSJE,0 BNJSSL
        from kods.a_hs08_his_ofdeliver where  business_flag in ('124','142','150')
        and fund_code in (select jjdm from t_bks_t100 where fxzl=12)
        group by branch_no*/
      union all
       select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count (distinct t.prod_code) as BQJSSL,sum(t.business_balance) BQJSJE,0 BNJSSL
       from kods.a_hs_his_secumdealinfo t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and t.entrust_balance<>0
       group by branch_no 
      )group by yyb;
    commit;
    
    
    --3.˾ʲƻ
      insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select yyb,4,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
    from
      (
      select yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from (
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL ,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44122','44139','44130')
      and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
     /*union all
     select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      */)  group by yyb 
     union all
     select  yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,count(distinct BNJSSL) as BNJSSL from (
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,prod_code as BNJSSL
      from kods.a_hs_his_secumdealinfo_bnlj where   business_flag in ('44124','44142','44150')
      and prod_code in (select jjdm from t_bks_t100 where fxzl=13)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate      
     /* union all  
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje, t.prod_code as BNJSSL 
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        */)group by yyb   
     union all
     /* select branch_no yyb,count(distinct fund_code) as BQZJSL,sum(balance) BQZJJE,0 BNZJSL ,0 bqjssl,0 bqjsje,0 BNJSSL
      from kods.a_hs08_his_ofdeliver where  business_flag in ('122','139','130')
      and fund_code in (select jjdm from t_bks_t100 where fxzl=13)
        group by branch_no
     union all*/
      select branch_no yyb,count (distinct t.prod_code) as BQZJSL,sum(t.business_balance) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL 
      from kods.a_hs_his_secumdealinfo t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and t.business_balance<>0
       group by branch_no
    /* union all
      select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count(distinct fund_code) as BQJSSL,sum(balance) BQJSJE,0 BNJSSL
        from kods.a_hs08_his_ofdeliver where  business_flag in ('124','142','150')
        and fund_code in (select jjdm from t_bks_t100 where fxzl=13)
        group by branch_no*/
      union all
       select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count (distinct t.prod_code) as BQJSSL,sum(t.business_balance) BQJSJE,0 BNJSSL
       from kods.a_hs_his_secumdealinfo t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and t.entrust_balance<>0
       group by branch_no 
      )group by yyb;
    commit;
    
    --֤ȯ˾ʲƻ
    insert into T_ETL_YYB_XSJRCP_FSE
    select t.yyb,2,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL),sum(T.BQJSSL),sum(T.BQJSJE),sum(T.BNJSSL) from T_ETL_YYB_XSJRCP_FSE t where t.xm in (3,4) group by t.yyb ;
    commit;
    --
    insert into T_ETL_YYB_XSJRCP_FSE
     SELECT yyb,5,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT prod_code) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('43130') 
           and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG in('43142','43150')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(abs(entrust_amount)) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_bankmdeliver
             WHERE BUSINESS_FLAG IN ('43130')  
             and prod_code in (select jjdm from t_bks_t100 where fxzl=14)           
                GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(abs(entrust_amount)) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver
                WHERE BUSINESS_FLAG in('43142','43150')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
                GROUP BY BRANCH_NO) group by yyb;
    commit;
    --6.
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
      SELECT yyb,6,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT PROD_CODE) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG in ('44124','44142','44150')
            and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
            and init_date between substr(v_enddate,1,4)||0101 and v_enddate
            GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(BUSINESS_BALANCE) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_secumdealinfo
             WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
             and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
             GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(BUSINESS_BALANCE) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo
                WHERE BUSINESS_FLAG in ('44124','44142','44150')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
                GROUP BY BRANCH_NO) group by yyb;
     commit;
    --ڲƷ
    insert into T_ETL_YYB_XSJRCP_FSE
     SELECT yyb,8,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0) FROM 
     (
     SELECT  YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT BNZJSL) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl FROM (
     SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,prod_code AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG IN ('44122','44139','44130')
           and prod_code  in (select jjdm from t_bks_t100 where fxzl=17)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       /*union all
       SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje, prod_code AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('44122','44130','44139')
          and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
          and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
          and init_date between substr(v_enddate,1,4)||0101 and v_enddate
          */) GROUP BY YYB      
       union all 
       SELECT  YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT BNJSSL) AS BNJSSL FROM (
       SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje,PROD_code AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG in ('44124','44142','44150')
            and PROD_code  in (select jjdm from t_bks_t100 where fxzl=17)
            and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       /* union all           
       SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje,  prod_code AS BNJSSL
                 FROM KODS.a_hs_his_secumdeliver_bnlj
           WHERE BUSINESS_FLAG in('44124','44150','44142')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           */)group by yyb
       /*union all
       SELECT BRANCH_NO YYB,COUNT(DISTINCT fund_code) AS BQZJSL, SUM(balance) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs08_his_ofdeliver
             WHERE BUSINESS_FLAG IN ('122','139','130') 
             and fund_code  in (select jjdm from t_bks_t100 where fxzl=17)           
                GROUP BY BRANCH_NO*/
      union all        
        SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(business_balance) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_secumdealinfo
             WHERE BUSINESS_FLAG IN ('44122','44130','44139')  
             and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
             and business_balance<>0         
                GROUP BY BRANCH_NO  
       /*union all
       SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT fund_code) AS BQJSSL, SUM(balance) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs08_his_ofdeliver
                WHERE BUSINESS_FLAG in('44124','44142','44150')
                and fund_code  in (select jjdm from t_bks_t100 where fxzl=17)
                GROUP BY BRANCH_NO      */     
       union all
       SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(business_balance) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo
                WHERE BUSINESS_FLAG in('44124','44150','44142')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
                and entrust_balance<>0
                GROUP BY BRANCH_NO         
     ) group by yyb;
     commit;
    --˷ϼ
    insert into T_ETL_YYB_XSJRCP_FSE
    select t.yyb,101,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL) ,SUM(T.BQJSSL),SUM(T.BQJSJE),SUM(T.BNJSSL)
           from T_ETL_YYB_XSJRCP_FSE t where t.xm in(1,2,5,6,7,8)
                group by t.yyb;
    commit;
     /*******************************************************************/
    --10.̶ڲƷ
      insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    -- select t.yyb,10,t.BQZJSL,t.BQZJJE,t.BNZJSL,T.BQJSSL,T.BQJSJE,T.BNJSSL from T_ETL_YYB_XSJRCP_FSE t where t.xm = 5 ;
    SELECT yyb,10,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT prod_code) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('43130') 
           and prod_code in (select jjdm from t_bks_t100 where syzl=21)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG in('43142','43150')
           and prod_code in (select jjdm from t_bks_t100 where syzl=21)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(abs(entrust_amount)) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_bankmdeliver
             WHERE BUSINESS_FLAG IN ('43130')  
             and prod_code in (select jjdm from t_bks_t100 where syzl=21)           
                GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(abs(entrust_amount)) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver
                WHERE BUSINESS_FLAG in('43142','43150')
                and prod_code in (select jjdm from t_bks_t100 where syzl=21)
                GROUP BY BRANCH_NO) group by yyb;
    --11.ڲƷ
     insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
  select yyb,11,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
  from(
  select yyb,0 bqzjsl,0 bqzjje, count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from(
  select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
  from kods.a_hs_his_secumdealinfo_bnlj 
    where   business_flag in ('44122','44139','44130')
      and prod_code in (select jjdm from t_bks_t100 where syzl=22)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
     /*union all
     select branch_no yyb,0 bqzjsl,0 bqzjje,prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
    from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate*/
      union all 
     SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje, prod_code AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('43130') 
           and prod_code in (select jjdm from t_bks_t100 where syzl=22)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )group by yyb
     union all
     select  yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, count(distinct BNJSSL) as BNJSSL  from (
      select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      /*union all
      select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdeliver_bnlj 
       where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate*/
      union all
      SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje,  prod_code AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG in('43142','43150')
           and prod_code in (select jjdm from t_bks_t100 where syzl=22)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       ) group  by yyb
      union all
      select  branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(entrust_amount)) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL
       from kods.a_hs_his_bankmdeliver 
       where   business_flag in ('43130')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        group by branch_no
      union all
      select  branch_no yyb,count(distinct prod_code) bqzjsl,sum(business_balance) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo
       where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and business_balance<>0
        group by branch_no  
      union all
      select  branch_no yyb,0 bqzjsl,0 BQZJJE,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(entrust_amount)) bqjsje,0 BNJSSL
       from kods.a_hs_his_bankmdeliver 
       where  business_flag in ('43142','43150')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        group by branch_no
      union all
      select  branch_no yyb,0 bqzjsl,0 BQZJJE,0 BNZJSL,count(distinct prod_code) bqjssl,sum(business_balance) bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo 
       where  business_flag in ('44124','44150','44142')
        and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        and entrust_balance<>0
        group by branch_no  
      ) group by YYB;
      commit;
  --ڲƷ    
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)    
  select yyb,13,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
  from(
     select  yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from (
     select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
    from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        union all
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
    from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
        )group by yyb
      union all
      select yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,count(distinct BNJSSL) as BNJSSL from (
      /*select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdeliver_bnlj 
       where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)  
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all*/
       select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdealinfo_bnlj
       where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)  
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )group by yyb
      union all
      select  branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(business_balance)) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo
       where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and business_balance<>0
        group by branch_no  
      union all
      select  branch_no yyb,0 bqzjsl,0 BQZJJE,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(business_balance)) bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo
       where  business_flag in ('44124','44150','44142')
        and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
        and entrust_balance<>0
        group by branch_no  
      ) group by YYB;     
     commit;
     --15.ṹڲƷ
     insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select yyb,15,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
 from(
 select yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl  from (
 select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44122','44139','44130')
        and prod_code  in (select jjdm from t_bks_t100 where syfl=31)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
      /*union all
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdeliver_bnlj where  business_flag in ('44122','44130','44139')
        and  prod_code in (select jjdm from t_bks_t100 where syfl=31)
        and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        */)group by yyb 
      union all
      select yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,count(distinct bnjssl) bnjssl from (
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,prod_code bnjssl
       from kods.a_hs_his_secumdealinfo_bnlj
       where  business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where syfl=31) 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      /*union all 
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code bnjssl
       from kods.a_hs_his_secumdeliver_bnlj where  business_flag in('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       */) group by yyb
       union all
      /*select branch_no yyb,count(distinct fund_code) bqzjsl,sum(balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where  business_flag in ('122','139','130')
       and fund_code  in (select jjdm from t_bks_t100 where syfl=31) 
        group by branch_no
        union all*/
        select branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo 
       where  business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and business_balance<>0 
        group by branch_no
            /*union all
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct fund_code) bqjssl,sum(balance) bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where   business_flag in ('124','142','150')
        and fund_code  in (select jjdm from t_bks_t100 where syfl=31) 
        group by branch_no*/
        union all
       select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(entrust_balance)) bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo
       where   business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and entrust_balance<>0 
        group by branch_no 
      ) group by YYB;
    /******************************۷ʽ*************************************/
    commit;
    --(˾)
    insert into T_ETL_YYB_XSJRCP_FSE
      select yyb,17,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
     from(
     select yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from (
     select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdealinfo_bnlj
        where  business_flag in ('44122','44139','44130')
        and prod_code  in (select jjdm from t_bks_t100 where fsfl=41)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
      /*union all
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdeliver_bnlj 
        where  business_flag in ('44122','44130','44139')
        and  prod_code in (select jjdm from t_bks_t100 where fsfl=41)
        and  prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
        */) group by yyb  
      union all
      select yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,count(distinct bnjssl) as BNJSSL from (
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code bnjssl
       from kods.a_hs_his_secumdealinfo_bnlj
       where  business_flag  in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fsfl=41) 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      /*union all 
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code bnjssl
       from kods.a_hs_his_secumdeliver_bnlj where  business_flag in('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       */)group  by  yyb
       /*union all
      select branch_no yyb,count(distinct fund_code) bqzjsl,sum(balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where  business_flag in ('44122','44139','44130')
       and fund_code  in (select jjdm from t_bks_t100 where fsfl=41) 
        group by branch_no*/
        union all
        select branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo where  business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41) 
       and business_balance<>0
        group by branch_no
            /*union all
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct fund_code) bqjssl,sum(balance) bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where   business_flag in ('124','142','150')
        and fund_code  in (select jjdm from t_bks_t100 where fsfl=41) 
        group by branch_no*/
        union all
       select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(business_balance)) bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo where   business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and entrust_balance<>0 
        group by branch_no 
      ) group by YYB;
    commit;
    
    insert into T_ETL_YYB_XSJRCP_FSE
    select t.yyb,18,sum(decode(xm,101,t.BQZJSL,-t.BQZJSL)),
                    sum(decode(xm,101,t.BQZJJE,-t.BQZJJE)),
                    sum(decode(xm,101,t.BNZJSL,-t.BNZJSL)),
                    sum(decode(xm,101,t.BQJSSL,-t.BQJSSL)),
                    sum(decode(xm,101,t.BQJSJE,-t.BQJSJE)),
                    sum(decode(xm,101,t.BNJSSL,-t.BNJSSL))
                    from T_ETL_YYB_XSJRCP_FSE t
                    where t.xm in( 101,17)
                    group by t.yyb;
     commit;
  
    /******************************ͷ*************************************/
   --21.
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select nvl(a.yyb,b.yyb),21,NVL(sum(c.BQZJSL), 0),NVL(sum(c.BQZJJE), 0),NVL(sum(a.BNZJSL), 0),NVL(sum(d.BQJSSL), 0),NVL(sum(d.BQJSJE), 0),NVL(sum(b.BNJSSL), 0)
  from (
    select yyb,count(distinct BNZJSL) BNZJSL from(
    select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44122', '44139', '44130')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
        /*union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id */
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb) a
          full join 
        (select yyb,count(distinct bnjssl) bnjssl from (
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44142','44150')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
        /*union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id*/
         union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb)b on a.yyb=b.yyb
         full join
        (select yyb,count(distinct bqzjsl) bqzjsl,sum(bqzjje) bqzjje from(
        /*select a.branch_no yyb, a.client_id bqzjsl,sum(a.balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('122', '139', '130')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver a, kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and a.business_balance<>0
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(entrust_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a, kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
         group by a.branch_no,a.client_id )
         group by yyb)c on nvl(a.yyb,b.yyb)=c.yyb
         full join 
        (select yyb,count(distinct bqjssl) bqjssl,sum(bqjsje) bqjsje  from (
        /*select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(a.balance) bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('124','142','150')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and a.entrust_balance<>0
         group by a.branch_no,a.client_id
         union all
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a, kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
         group by a.branch_no,a.client_id)
         group by yyb)d  on nvl(b.yyb,c.yyb)=d.yyb 
         --where a.yyb=b.yyb and a.yyb=c.yyb and a.yyb=d.yyb
         group by a.yyb,b.yyb,c.yyb,d.yyb;
     commit;
     
        --22.
     insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
  select nvl(a.yyb,b.yyb),22,NVL(sum(c.BQZJSL), 0),NVL(sum(c.BQZJJE), 0),NVL(sum(a.BNZJSL), 0),NVL(sum(d.BQJSSL), 0),NVL(sum(d.BQJSJE), 0),NVL(sum(b.BNJSSL), 0)
  from (
    select yyb,count(distinct BNZJSL) BNZJSL from(
    select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44122', '44139', '44130')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
        /*union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a, kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id */
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb) a
          full join 
        (select yyb,count(distinct bnjssl) bnjssl from (
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a ,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44142','44150')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
       /* union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id*/
         union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb)b on a.yyb=b.yyb
         full join
        (select yyb,count(distinct bqzjsl) bqzjsl,sum(bqzjje) bqzjje from(
        /*select a.branch_no yyb, a.client_id bqzjsl,sum(a.balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('122', '139', '130')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver a,kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and a.business_balance<>0
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(entrust_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a,kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
         group by a.branch_no,a.client_id )
         group by yyb)c on nvl(a.yyb,b.yyb)=c.yyb
         full join 
        (select yyb,count(distinct bqjssl) bqjssl,sum(bqjsje) bqjsje  from (
        /*select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(a.balance) bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('124','142','150')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and a.entrust_balance<>0
         group by a.branch_no,a.client_id
         union all
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a,kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
         group by a.branch_no,a.client_id)
         group by yyb)d  on nvl(b.yyb,c.yyb)=d.yyb 
         --where a.yyb=b.yyb and a.yyb=c.yyb and a.yyb=d.yyb
         group by a.yyb,b.yyb,c.yyb,d.yyb;
     commit;


    update T_ETL_YYB_XSJRCP_FSE t set t.BQZJJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQZJJE,0),-nvl(t1.BQZJJE,0))) from T_ETL_YYB_XSJRCP_FSE t1
                    where t1.xm in(101,21) and t.yyb = t1.yyb ),
                    t.BQJSJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQJSJE,0),-nvl(t1.BQJSJE,0))) from T_ETL_YYB_XSJRCP_FSE t1
                    where t1.xm in(101,21) and t.yyb = t1.yyb )
                    where t.xm=22;
                commit;

   delete T_ETL_YYB_XSJRCP_QMYE;
    /******************************ĩ***********************************/
      --1.֤ȯͶʻ
  insert into T_ETL_YYB_XSJRCP_QMYE
    (YYB, XM, QMSL, QMJE)
    select a.yyb, 1, nvl(a.qmsl, 0), nvl(a.qmje, 0)
      from (select t.branch_no yyb,
                   nvl(count(distinct t.prod_code), 0) as qmsl,
                   round(sum(t.current_amount * b.net_value), 2) as qmje
              from kods.a_hs08_secumshare t, kods.a_hs_his_prodprice b
             where t.prod_code = b.prod_code
               and t.current_amount <> 0
               and b.init_date =
                   (select max(init_date)
                      from kods.a_hs_his_prodprice
                     where init_date <= v_enddate)
               and t.prod_code in
                   (select jjdm from t_bks_t100 where fxzl = 11)
               and t.current_amount <> 0
               and exists (select *
                      from kods.a_hs_secumholder s
                     where t.client_id = s.client_id)
             group by t.branch_no) a;
  commit;

  --3.˾ʲƻ
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
     select a.yyb, 3, a.qmsl, a.qmje
       from (select yyb,
                    nvl(sum(qmsl), 0) as qmsl,
                    nvl(sum(qmje), 0) as qmje
               from (select t.branch_no yyb,
                            nvl(count(distinct t.prod_code), 0) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                      and t.current_amount <> 0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 12)
                        and t.current_amount <> 0
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id)
                      group by t.branch_no)
              group by yyb) a;

    commit;
    
  --4.˾ʲƻ
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
     select a.yyb, 4, a.qmsl, a.qmje
       from (select yyb,
                    nvl(sum(qmsl), 0) as qmsl,
                    nvl(sum(qmje), 0) as qmje
               from (select t.branch_no yyb,
                            nvl(count(distinct t.prod_code), 0) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                      and t.current_amount <> 0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 13)
                        and t.current_amount <> 0
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id)
                      group by t.branch_no)
              group by yyb) a;

    commit;  
    
    
   --֤ȯ˾ʲƻ
   insert into T_ETL_YYB_XSJRCP_QMYE
     select t.yyb, 2, sum(t.qmsl), sum(t.qmje)
       from T_ETL_YYB_XSJRCP_QMYE t
      where t.xm in (3, 4)
      group by t.yyb;
   
   commit;
   
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
     select a.yyb, 5, nvl(a.qmsl, 0), nvl(a.qmje, 0)
       from (select branch_no yyb,
                    count(distinct prod_code) as qmsl,
                    sum(current_amount) as qmje
               from kods.a_hs08_bankmshare
              where prod_code in
                    (select jjdm from t_bks_t100 where fxzl = 14)
                and current_amount <> 0
              group by branch_no) a;
   commit;
      
      
      
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
     select a.yyb, 8, nvl(a.qmsl, 0), nvl(a.qmje, 0)
       from (select yyb, sum(qmsl) qmsl, sum(qmje) qmje
               from (select t.branch_no as yyb,
                            count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and t.current_amount <> 0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 17)
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id)
                      group by t.branch_no)
              group by yyb) a;
      commit; 
       
    --˷ϼ
    insert into T_ETL_YYB_XSJRCP_QMYE
      select t.yyb, 101, sum(t.qmsl), sum(t.qmje)
        from T_ETL_YYB_XSJRCP_QMYE t
       where t.xm in (1, 2, 5, 6, 7, 8)
       group by t.yyb;

    commit;
   
   --10.̶ڲƷ
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
   --select a.yyb,10,a.qmsl,a.qmje from T_ETL_YYB_XSJRCP_QMYE a where xm=5;
     select a.yyb, 5, nvl(a.qmsl, 0), nvl(a.qmje, 0)
       from (select branch_no yyb,
                    count(distinct prod_code) as qmsl,
                    sum(current_amount) as qmje
               from kods.a_hs08_bankmshare
              where prod_code in
                    (select jjdm from t_bks_t100 where syzl = 21)
                and current_amount <> 0
              group by branch_no) a;

     --11.ڲƷ
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
     select a.yyb, 11, nvl(a.qmsl, 0), nvl(a.qmje, 0)
       from (select yyb, sum(qmsl) qmsl, sum(qmje) qmje
               from (select branch_no as yyb,
                            count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and t.current_amount <> 0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where syzl = 22)
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id)
                      group by branch_no
                     union all
                     select branch_no yyb,
                            count(distinct prod_code) as qmsl,
                            sum(current_amount) as qmje
                       from kods.a_hs08_bankmshare
                      where prod_code in
                            (select jjdm from t_bks_t100 where syzl = 22)
                        and current_amount <> 0
                      group by branch_no)
              group by yyb) a;
   commit;
   
   
    --ڲƷ
    insert into T_ETL_YYB_XSJRCP_QMYE
      (YYB, XM, QMSL, QMJE)
      select a.yyb, 13, nvl(a.qmsl, 0), nvl(a.qmje, 0)
        from (select t.branch_no as yyb,
                     count(distinct t.prod_code) as qmsl,
                     round(sum(t.current_amount * b.net_value), 2) as qmje
                from kods.a_hs08_secumshare t, kods.a_hs_his_prodprice b
               where t.prod_code = b.prod_code
                 and t.current_amount <> 0
                 and b.init_date =
                     (select max(init_date)
                        from kods.a_hs_his_prodprice
                       where init_date <= v_enddate)
                 and t.prod_code in
                     (select jjdm from t_bks_t100 where syzl = 24)
                  and exists
                      (select *from kods.a_hs_secumholder s
                              where t.client_id = s.client_id)
               group by t.branch_no
              union all
              select branch_no as yyb,
                     count(distinct t.prod_code) as qmsl,
                     round(sum(current_amount), 2) as qmje
                from kods.a_hs08_bankmshare t
               where t.current_amount <> 0
                 and t.prod_code in
                     (select jjdm from t_bks_t100 where syzl = 24)
               group by branch_no) a;
    commit;
  
    --15.ṹڲƷ
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
     select a.yyb, 15, nvl(a.qmsl, 0), nvl(a.qmje, 0)
       from (select yyb, sum(qmsl) qmsl, sum(qmje) qmje
               from (select branch_no as yyb,
                            count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_bankmshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.current_amount <> 0
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where syfl = 31)
                      group by branch_no
                     union all
                     select t.branch_no as yyb,
                            count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and t.current_amount <> 0
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where syfl = 31)
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where t.client_id = s.client_id)
                      group by t.branch_no)
              group by yyb) a;
   /******************************۷ʽ*************************************/
    commit;
    --(qita˾)
    insert into T_ETL_YYB_XSJRCP_QMYE
      select a.yyb, 17, nvl(a.qmsl, 0), nvl(a.qmje, 0)
        from (select yyb, sum(qmsl) qmsl, sum(qmje) qmje
                from (select branch_no as yyb,
                             count(distinct prod_code) as qmsl,
                             sum(current_amount) as qmje
                        from kods.a_hs08_bankmshare
                       where prod_code in
                             (select jjdm from t_bks_t100 where fsfl = 41)
                         and current_amount <> 0
                       group by branch_no
                      union all
                      select t.branch_no as yyb,
                             count(distinct t.prod_code) as qmsl,
                             round(sum(t.current_amount * b.net_value), 2) as qmje
                        from kods.a_hs08_secumshare  t,
                             kods.a_hs_his_prodprice b
                       where t.prod_code = b.prod_code
                         and t.current_amount <> 0
                         and b.init_date =
                             (select max(init_date)
                                from kods.a_hs_his_prodprice
                               where init_date <= v_enddate)
                         and t.prod_code in
                             (select jjdm from t_bks_t100 where fsfl = 41)
                         and exists
                       (select *
                                from kods.a_hs_secumholder s
                               where t.client_id = s.client_id)
                       group by t.branch_no)
               group by yyb) a;

    commit;
    --
    insert into T_ETL_YYB_XSJRCP_QMYE
    select t.yyb,18,sum(decode(xm,101,t.qmsl,-t.qmsl)),
                    sum(decode(xm,101,t.qmje,-t.qmje))
                    from T_ETL_YYB_XSJRCP_QMYE t
                         where t.xm in( 101,17)
                         group by t.yyb;


    /******************************ͷ*************************************/
  --21.
   insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb, 21, nvl(a.qmsl, 0), nvl(a.qmje, 0)
     from (select yyb, count(distinct qmsl) qmsl, sum(qmje) qmje
             from (select a.branch_no yyb,
                          a.client_id as qmsl,
                          round(sum(a.current_amount * d.net_value), 2) as qmje
                     from kods.a_hs08_secumshare  a,
                          kods.rzrq_hs_client     c,
                          kods.a_hs_his_prodprice d
                    where a.client_id = c.client_id
                      and a.prod_code = d.prod_code
                      and a.current_amount <> 0
                      and d.init_date =
                          (select max(init_date)
                             from kods.a_hs_his_prodprice
                            where init_date <= v_enddate)
                      and c.organ_flag in ('1', '3')
                      and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where a.client_id = s.client_id)
                    group by a.branch_no, a.client_id
                   union all
                   select a.branch_no yyb,
                          a.client_id as qmsl,
                          sum(a.current_amount) as qmje
                     from kods.a_hs08_bankmshare a, kods.rzrq_hs_client c
                    where a.client_id = c.client_id
                      and a.current_amount <> 0
                      and c.organ_flag in ('1', '3')
                    group by a.branch_no, a.client_id)
            group by yyb) a;
   commit;
   --
   insert into T_ETL_YYB_XSJRCP_QMYE
     (YYB, XM, QMSL, QMJE)
     select a.yyb, 22, nvl(a.qmsl, 0), nvl(a.qmje, 0)
       from (select yyb, count(distinct qmsl) qmsl, sum(qmje) qmje
               from (select a.branch_no yyb,
                            a.client_id as qmsl,
                            round(sum(a.current_amount * d.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  a,
                            kods.rzrq_hs_client     c,
                            kods.a_hs_his_prodprice d
                      where a.client_id = c.client_id
                        and a.prod_code = d.prod_code
                        and a.current_amount <> 0
                        and d.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and c.organ_flag = '0'
                        and exists
                      (select *
                               from kods.a_hs_secumholder s
                              where a.client_id = s.client_id)
                      group by a.branch_no, a.client_id
                     union all
                     select a.branch_no yyb,
                            a.client_id as qmsl,
                            sum(a.current_amount) as qmje
                       from kods.a_hs08_bankmshare a, kods.rzrq_hs_client c
                      where a.client_id = c.client_id
                        and c.organ_flag = '0'
                        and a.current_amount <> 0
                      group by a.branch_no, a.client_id)
              group by yyb) a;
   commit;
      
        
    update T_ETL_YYB_XSJRCP_QMYE t
       set t.qmje = (select sum(decode(t1.xm,
                                       101,
                                       nvl(t1.qmje, 0),
                                       -nvl(t1.qmje, 0)))
                       from T_ETL_YYB_XSJRCP_QMYE t1
                      where t1.xm in (101, 21)
                        and t.yyb = t1.yyb)
     where t.xm = 22;
                    
   delete T_ETL_YYB_XSJRCP_QMYE where xm = 101;
   commit;
    
   --
   insert into T_ETL_YYB_XSJRCP_FSE
     (YYB, XM, BQZJSL, BQZJJE, BNZJSL, BQJSSL, BQJSJE, BNJSSL)
     select yyb, 24, 0, NVL(sum(a.BQZJJE), 0), 0, 0, 0, 0
       from (
             select a.branch_no yyb, sum(a.fare_sx) BQZJJE
               from kods.a_hs_his_secumdealinfo a
              where a.business_flag in ('44122', '44130', '44139' /*,'44124','44150','44142'*/
                    )
                and a.business_balance <> 0
              group by a.branch_no
             union all
             select a.branch_no yyb, sum(a.RATIO_SX) BQZJJE
               from kods.a_hs_his_bankmdeliver a
              where a.business_flag in ('43130' /*,'43142'*/
                    )
              group by a.branch_no) a
      group by yyb;
   --
   insert into T_ETL_YYB_XSJRCP_FSE
     (YYB, XM, BQZJSL, BQZJJE, BNZJSL, BQJSSL, BQJSJE, BNJSSL)
     select yyb, 25, 0, NVL(sum(a.BQZJJE), 0), 0, 0, 0, 0
       from (select a.branch_no yyb, sum(a.fare_sx) BQZJJE
               from kods.a_hs_his_secumdealinfo a
              where a.business_flag in ('44122', '44139', '44130' /*,'124','142','150'*/
                    )
                and prod_code in
                    (select jjdm from t_bks_t100 where fsfl = 42)
              group by a.branch_no
   
             ) a
      group by yyb;
   commit;

  cisp_etl_yyb_XSJRCP;
  /**
     ҵĿǰû
  **/

 -- krcs_etl_yyb_dlxs;
 -- krcs_etl_yyb_dlxs_cwsr;
  commit;

end;
/

prompt
prompt Creating procedure CISP_INTERFACE_XSJRCP
prompt ========================================
prompt
create or replace procedure cisp_interface_xsjrcp
is
begin

   cisp_map_jjyw_c1_3;
   cisp_map_c12_1;
   cisp_map_yyb_a5_1;

   commit;

end ;
/

prompt
prompt Creating procedure CISP_INTERFACE_ALL
prompt =====================================
prompt
create or replace procedure cisp_interface_all is

begin
  cisp_interface_sjhb;
  cisp_interface_rzrq;
  cisp_interface_jjjy;
  cisp_interface_cw;
  cisp_interface_xsjrcp;

end;
/

prompt
prompt Creating procedure CISP_INTERFACE_SJHB_20190201
prompt ===============================================
prompt
create or replace procedure cisp_interface_sjhb_20190201 is
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  
  --C12-1ƷѯƷϸԺ󵼳excelͻ
  /*  
 insert into t_bks_t100
   select distinct t.fund_code, t.stock_name, 11, 22, 30, 42
     from kods.a_hs08_his_ofdeliver t
    where t.fund_code not in (select jjdm from t_bks_t100)
      and t.fund_code <> ' '
   union all
   select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
     from kods.a_hs_his_bankmdeliver t
    where t.prod_code not in (select jjdm from t_bks_t100)
   union all
   select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
     from kods.a_hs_his_secumdeliver t
    where t.prod_code not in (select jjdm from t_bks_t100);
 commit;
 */

  --ÿ걨Ϊ 1·ݵʱݣգ
  if substr(v_begindate, 5, 2) = '01' then
    delete from kods.RZRQ_HS_HIS_HISFUNDJOUR_Q;
    delete from kods.RZRQ_HS_HIS_HISDELIVER_Q;
    commit;
  end if;

  --ݲ뱾 
  delete from kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
   where init_date between v_begindate and v_enddate;
  commit;
  delete from kods.RZRQ_HS_HIS_HISDELIVER_Q
   where init_date between v_begindate and v_enddate;
  commit;

  insert into kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
    select *
      from kods.RZRQ_HS_HIS_HISFUNDJOUR
     where init_date between v_begindate and v_enddate;

  insert into kods.RZRQ_HS_HIS_HISDELIVER_Q
    select *
      from kods.RZRQ_HS_HIS_HISDELIVER
     where init_date between v_begindate and v_enddate;
  commit;

end ;
/

prompt
prompt Creating procedure CISP_INTERFACE_SJHB_20190220
prompt ===============================================
prompt
create or replace procedure cisp_interface_sjhb_20190220 is
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  
  --C12-1ƷѯƷϸԺ󵼳excelͻ
  /*  
 insert into t_bks_t100
   select distinct t.fund_code, t.stock_name, 11, 22, 30, 42
     from kods.a_hs08_his_ofdeliver t
    where t.fund_code not in (select jjdm from t_bks_t100)
      and t.fund_code <> ' '
   union all
   select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
     from kods.a_hs_his_bankmdeliver t
    where t.prod_code not in (select jjdm from t_bks_t100)
   union all
   select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
     from kods.a_hs_his_secumdeliver t
    where t.prod_code not in (select jjdm from t_bks_t100);
 commit;
 */

  --ÿ걨Ϊ 1·ݵʱݣգ
  if substr(v_begindate, 5, 2) = '01' then
    delete from  kods.RZRQ_HS_HIS_HISFUNDJOUR_Q;
    delete from  kods.RZRQ_HS_HIS_HISDELIVER_Q;
    commit;
  end if;

  --ݲ뱾 
  delete from kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
   where init_date between v_begindate and v_enddate;
  commit;
  delete from kods.RZRQ_HS_HIS_HISDELIVER_Q
   where init_date between v_begindate and v_enddate;
  commit;

  insert into kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
    select *
      from kods.RZRQ_HS_HIS_HISFUNDJOUR
     where init_date between v_begindate and v_enddate;

  insert into kods.RZRQ_HS_HIS_HISDELIVER_Q
    select *
      from kods.RZRQ_HS_HIS_HISDELIVER
     where init_date between v_begindate and v_enddate;
  commit;

end ;
/

prompt
prompt Creating procedure CISP_INTERFACE_SJHB_20190301
prompt ===============================================
prompt
create or replace procedure cisp_interface_sjhb_20190301 is
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  --C12-1ƷѯƷϸԺ󵼳excelͻ
  /*  
  insert into t_bks_t100
    select distinct t.fund_code, t.stock_name, 11, 22, 30, 42
      from kods.a_hs08_his_ofdeliver t
     where t.fund_code not in (select jjdm from t_bks_t100)
       and t.fund_code <> ' '
    union all
    select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
      from kods.a_hs_his_bankmdeliver t
     where t.prod_code not in (select jjdm from t_bks_t100)
    union all
    select distinct t.prod_code, t.prod_name, 11, 22, 30, 42
      from kods.a_hs_his_secumdeliver t
     where t.prod_code not in (select jjdm from t_bks_t100);
  commit;
  */


  --add by zhenyj 20190220 C12-1B-A5-1⣬ִֻһ
  cisp_interface_xsjrcp_ycl;
  
  --ݲ뱾 
  delete from kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
   where init_date between v_begindate and v_enddate;
  commit;
  delete from kods.RZRQ_HS_HIS_HISDELIVER_Q
   where init_date between v_begindate and v_enddate;
  commit;

  insert into kods.RZRQ_HS_HIS_HISFUNDJOUR_Q
    select *
      from kods.RZRQ_HS_HIS_HISFUNDJOUR
     where init_date between v_begindate and v_enddate;

  insert into kods.RZRQ_HS_HIS_HISDELIVER_Q
    select *
      from kods.RZRQ_HS_HIS_HISDELIVER
     where init_date between v_begindate and v_enddate;
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAKEBALANCE_UNFI_20200616
prompt =================================================
prompt
create or replace procedure cisp_makebalance_unfi_20200616
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  ѲϵͳɿĿ
-- RETURN:
-- AUTHOR:       rfvan
-- CREATE DATE:  2009/11/6
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
  v_year          varchar2(64);
  v_period        varchar2(64);

  i               int;
  type tb_map_cwxt_km_unfi is table of t_map_cwxt_km_unfi%rowtype;
  vt_cwxt_unfi   tb_map_cwxt_km_unfi:=tb_map_cwxt_km_unfi();
  v_str           varchar2(1000);
begin

    select to_char(to_date(p001,'yyyy-mm'),'yyyy') into v_year from t_b00_d004 where a002 = 1013001 and c001=1001101;
    select to_char(to_date(p001,'yyyy-mm'),'mm') into v_period from t_b00_d004 where a002 = 1013001 and c001=1001101;

   delete from t_map_cwxt_km_unfi;
    --ĩԭң
    insert into t_map_cwxt_km_unfi (company ,acctsubjcode ,begin_balance_dr,begin_balance_cr,local_begin_balance_dr ,
    local_begin_balance_cr ,period_net_dr,period_net_cr,local_period_net_dr,
    local_period_net_cr,period_name,period_year,period_num,nc_balance_dr,
    nc_balance_cr,local_nc_balance_dr,local_nc_balance_cr,beginbalance,
    endbalance,ncbalance,periodbalance,local_beginbalance,local_endbalance,
    local_ncbalance,local_periodbalance,currency,enddrbalance,local_enddrbalance,endcrbalance,local_endcrbalance)
    select --gl.year,
           --gl.period,
           --gl.pk_corp,
           --gl.pk_glorgbook,
           gg.glorgbookcode,
           --min(gg.glorgbookname),
           ac.subjcode,
           --min(ac.subjname),
           --ac.balanorient,
           0,0,0,0,0,0,0,0,v_year||'-'||v_period,
           v_year,v_period,
           0,0,0,0,0,
           --sum(gl.debitamount)  dramount,
           --sum(gl.creditamount) cramount,
           --sum(gl.localdebitamount) localdramount,
           --sum(gl.localcreditamount) localcramount,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.debitamount - gl.creditamount,
                  2,
                  gl.creditamount - gl.debitamount,
                  gl.debitamount - gl.creditamount)),0) amount,
                  0,0,0,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.localdebitamount - gl.localcreditamount,
                  2,
                  gl.localcreditamount - gl.localdebitamount,
                  gl.localdebitamount - gl.localcreditamount)),0) localamount,
                  0,0,cr.currtypecode,
           sum(gl.debitamount),sum(gl.localdebitamount),sum(gl.creditamount),sum(gl.localcreditamount)
      from kods.nc5_bd_accsubj ac, kods.nc5_gl_detail gl, kods.nc5_bd_glorgbook gg,kods.nc5_bd_currtype cr
     where ac.pk_accsubj = gl.pk_accsubj
       and gl.pk_glorgbook=gg.pk_glorgbook
       and gl.pk_currtype=cr.pk_currtype
       and gl.yearv = v_year
       and gl.periodv <=v_period
       and gl.dr = 0 --Ƿע
       and gl.discardflagv = 'N' --ǷΪϵ־
       --and gg.glorgbookcode not in('1011-0002')--,'4000-0003','4001-0003','4002-0003','4003-0003',
       --'4004-0003','4005-0003','4006-0003','4007-0003','4008-0003') --
     group by gl.pk_glorgbook,gg.glorgbookcode,ac.subjcode,cr.currtypecode
     order by gl.pk_glorgbook,ac.subjcode;

    --ڼ:ԭңҽ跽
    select gg.glorgbookcode,
           ac.subjcode,
           0,0,0,0,
           nvl(sum(gl.debitamount),0) perioddr,
           nvl(sum(gl.creditamount),0) periodcr,
           nvl(sum(gl.localdebitamount),0) localperioddr,
           nvl(sum(gl.localcreditamount),0) localperiodcr,
           v_year||'-'||v_period,
           v_year,v_period,
           0,0,0,0,0,0,0,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.debitamount - gl.creditamount,
                  2,
                  gl.creditamount - gl.debitamount,
                  gl.debitamount - gl.creditamount)),0) periodbalance,
                  0,0,0,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.localdebitamount - gl.localcreditamount,
                  2,
                  gl.localcreditamount - gl.localdebitamount,
                  gl.localdebitamount - gl.localcreditamount)),0) localperiodbalance,
                  cr.currtypecode,sum(gl.debitamount),sum(gl.localdebitamount),sum(gl.creditamount),sum(gl.localcreditamount)
               bulk collect into vt_cwxt_unfi
      from kods.nc5_bd_accsubj ac, kods.nc5_gl_detail gl, kods.nc5_bd_glorgbook gg,kods.nc5_bd_currtype cr
     where ac.pk_accsubj = gl.pk_accsubj
       and gl.pk_glorgbook=gg.pk_glorgbook
       and gl.pk_currtype=cr.pk_currtype
       and gl.yearv = v_year
       and gl.periodv =v_period
       and gl.dr = 0 --Ƿע
       and gl.discardflagv = 'N' --ǷΪϵ־
       --and gg.glorgbookcode not in('1011-0002')--and gg.glorgbookcode not in('5000-0001','4000-0003','4001-0003','4002-0003','4003-0003',
       --'4004-0003','4005-0003','4006-0003','4007-0003','4008-0003') --
     group by gl.pk_glorgbook,gg.glorgbookcode,ac.subjcode,cr.currtypecode
     order by gl.pk_glorgbook,ac.subjcode ;

    for i in 1..vt_cwxt_unfi.count loop
        update t_map_cwxt_km_unfi t set t.period_net_dr=vt_cwxt_unfi(i).period_net_dr,
                                        t.period_net_cr=vt_cwxt_unfi(i).period_net_cr,
                                        t.local_period_net_cr=vt_cwxt_unfi(i).local_period_net_cr,
                                        t.local_period_net_dr=vt_cwxt_unfi(i).local_period_net_dr,
                                        t.periodbalance=vt_cwxt_unfi(i).periodbalance,
                                        t.local_periodbalance=vt_cwxt_unfi(i).local_periodbalance
                                  where t.company=vt_cwxt_unfi(i).company
                                   and  t.acctsubjcode=vt_cwxt_unfi(i).acctsubjcode
                                   and  t.currency=vt_cwxt_unfi(i).currency;
    end loop;
    vt_cwxt_unfi.delete;

    --ڳ
    select gg.glorgbookcode,
           ac.subjcode,
           nvl(sum(gl.debitamount),0) beginbalancedr,
           nvl(sum(gl.creditamount),0) beginbalancecr,
           nvl(sum(gl.localdebitamount),0) localbeginbalancedr,
           nvl(sum(gl.localcreditamount),0) localbeginbalancecr,
           0,0,0,0,
           v_year||'-'||v_period,
           v_year,v_period,
           0,0,0,0,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.debitamount - gl.creditamount,
                  2,
                  gl.creditamount - gl.debitamount,
                  gl.debitamount - gl.creditamount)),0) beginbalance,
                  0,0,0,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.localdebitamount - gl.localcreditamount,
                  2,
                  gl.localcreditamount - gl.localdebitamount,
                  gl.localdebitamount - gl.localcreditamount)),0) localbeginbalance,
                  0,0,0,
                  cr.currtypecode,sum(gl.debitamount),sum(gl.localdebitamount),sum(gl.creditamount),sum(gl.localcreditamount)
               bulk collect into vt_cwxt_unfi
      from kods.nc5_bd_accsubj ac, kods.nc5_gl_detail gl, kods.nc5_bd_glorgbook gg,kods.nc5_bd_currtype cr
     where ac.pk_accsubj = gl.pk_accsubj
       and gl.pk_glorgbook=gg.pk_glorgbook
       and gl.pk_currtype=cr.pk_currtype
       and gl.yearv = v_year
       and gl.periodv < v_period
       and gl.dr = 0 --Ƿע
       and gl.discardflagv = 'N' --ǷΪϵ־
       --and gg.glorgbookcode not in('1011-0002')--and gg.glorgbookcode not in('5000-0001','4000-0003','4001-0003','4002-0003','4003-0003',
       --'4004-0003','4005-0003','4006-0003','4007-0003','4008-0003') --
     group by gl.pk_glorgbook,gg.glorgbookcode,ac.subjcode,cr.currtypecode
     order by gl.pk_glorgbook,ac.subjcode ;

    for i in 1..vt_cwxt_unfi.count loop
        update t_map_cwxt_km_unfi t set t.begin_balance_dr=vt_cwxt_unfi(i).begin_balance_dr,
                                        t.begin_balance_cr=vt_cwxt_unfi(i).begin_balance_cr,
                                        t.local_begin_balance_cr=vt_cwxt_unfi(i).local_begin_balance_cr,
                                        t.local_begin_balance_dr=vt_cwxt_unfi(i).local_begin_balance_dr,
                                        t.beginbalance=vt_cwxt_unfi(i).beginbalance,
                                        t.local_beginbalance=vt_cwxt_unfi(i).local_beginbalance
                                  where t.company=vt_cwxt_unfi(i).company
                                   and  t.acctsubjcode=vt_cwxt_unfi(i).acctsubjcode
                                   and  t.currency=vt_cwxt_unfi(i).currency;
    end loop;
    vt_cwxt_unfi.delete;

    --ԭң
    select gg.glorgbookcode,
           ac.subjcode,
           0,0,0,0,0,0,0,0,
           v_year||'-'||v_period,
           v_year,v_period,
           nvl(sum(gl.debitamount),0) nc_balancedr,
           nvl(sum(gl.creditamount),0) nc_balancecr,
           nvl(sum(gl.localdebitamount),0) local_nc_balancedr,
           nvl(sum(gl.localcreditamount),0) local_nc_balancecr,
           0,0,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.debitamount - gl.creditamount,
                  2,
                  gl.creditamount - gl.debitamount,
                  gl.debitamount - gl.creditamount)),0) ncbalance,
                  0,0,0,
           nvl(sum(decode(ac.balanorient,
                  1,
                  gl.localdebitamount - gl.localcreditamount,
                  2,
                  gl.localcreditamount - gl.localdebitamount,
                  gl.localdebitamount - gl.localcreditamount)),0) localncbalance,
                  0,
                  cr.currtypecode,sum(gl.debitamount),sum(gl.localdebitamount),sum(gl.creditamount),sum(gl.localcreditamount)
               bulk collect into vt_cwxt_unfi
      from kods.nc5_bd_accsubj ac, kods.nc5_gl_detail gl, kods.nc5_bd_glorgbook gg,kods.nc5_bd_currtype cr
     where ac.pk_accsubj = gl.pk_accsubj
       and gl.pk_glorgbook=gg.pk_glorgbook
       and gl.pk_currtype=cr.pk_currtype
       and gl.yearv = v_year
       and gl.periodv ='01'
       and gl.dr = 0 --Ƿע
       and gl.discardflagv = 'N' --ǷΪϵ־
       --and gg.glorgbookcode not in('1011-0002')--and gg.glorgbookcode not in('5000-0001','4000-0003','4001-0003','4002-0003','4003-0003',
       --'4004-0003','4005-0003','4006-0003','4007-0003','4008-0003') --
     group by gl.pk_glorgbook,gg.glorgbookcode,ac.subjcode,cr.currtypecode
     order by gl.pk_glorgbook,ac.subjcode ;

    for i in 1..vt_cwxt_unfi.count loop
        update t_map_cwxt_km_unfi t set t.nc_balance_dr=vt_cwxt_unfi(i).nc_balance_dr,
                                        t.nc_balance_cr=vt_cwxt_unfi(i).nc_balance_cr,
                                        t.local_nc_balance_cr=vt_cwxt_unfi(i).local_nc_balance_cr,
                                        t.local_nc_balance_dr=vt_cwxt_unfi(i).local_nc_balance_dr,
                                        t.ncbalance=vt_cwxt_unfi(i).ncbalance,
                                        t.local_ncbalance=vt_cwxt_unfi(i).local_ncbalance
                                  where t.company=vt_cwxt_unfi(i).company
                                   and  t.acctsubjcode=vt_cwxt_unfi(i).acctsubjcode
                                   and  t.currency=vt_cwxt_unfi(i).currency;
    end loop;
    vt_cwxt_unfi.delete;
    commit;
exception when others then
  v_str:=sqlerrm;
  rollback;
  return;
end;
/

prompt
prompt Creating procedure CISP_MAKEBALANCE_UNFI_20200903
prompt =================================================
prompt
CREATE OR REPLACE PROCEDURE CISP_MAKEBALANCE_UNFI_20200903
  /* =============================================
  * ҵ˵;ѲϵͳɿĿ
  *  P_OUT_FLAG           :ش룬1-ɹ 0-ʧ
  *  P_OUT_MSG            :
  *  P_OUT_RESULT         :ǰ˴
  * Ա[chenyong]
  * ϵʽ[:chen_yong@szkingdom.com]
  * ʱ䣺2019-11-19
  * 汾˵v1.0
  * ҵϸ˵
  ============================================*/
 AS
  v_bbq           varchar2(6); --
  v_bbq_begindate NUMBER; --ʼ
  v_bbq_enddate   NUMBER; --ֹ
  v_str           varchar2(1000);
  i int;
  v_year       varchar2(64);
  v_period     varchar2(64);
  type tb_map_cwxt_km_unfi is table of t_map_cwxt_km_unfi%rowtype;
  vt_cwxt_unfi tb_map_cwxt_km_unfi := tb_map_cwxt_km_unfi();

BEGIN

    select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_bbq_begindate, v_bbq_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

    select to_char(to_date(p001,'yyyy-mm'),'yyyy') into v_year from t_b00_d004 where a002 = 1013001 and c001=1001101;
    select to_char(to_date(p001,'yyyy-mm'),'mm') into v_period from t_b00_d004 where a002 = 1013001 and c001=1001101;



  delete from t_map_cwxt_km_unfi;
  --ĩԭң
  insert into t_map_cwxt_km_unfi
    (company,
     acctsubjcode,
     begin_balance_dr,
     begin_balance_cr,
     local_begin_balance_dr,
     local_begin_balance_cr,
     period_net_dr,
     period_net_cr,
     local_period_net_dr,
     local_period_net_cr,
     period_name,
     period_year,
     period_num,
     nc_balance_dr,
     nc_balance_cr,
     local_nc_balance_dr,
     local_nc_balance_cr,
     beginbalance,
     endbalance,
     ncbalance,
     periodbalance,
     local_beginbalance,
     local_endbalance,
     local_ncbalance,
     local_periodbalance,
     currency,
     enddrbalance,
     local_enddrbalance,
     endcrbalance,
     local_endcrbalance)
    select b.code         as company,
           d.code  as acctsubjcode,
           0,
           0,
           0,
           0,
           0,
           0,
           0,
           0,
           v_year || '-' || v_period as period_name,
           v_year                    as period_year,
           v_period                  as period_num,
           0,
           0,
           0,
           0,
           0,
           nvl(sum(decode(d.pid_balanorient,0,a.debitamount - a.creditamount,
                                        1,a.creditamount - a.debitamount)),0)           as endbalance,
           0,
           0,
           0,
           nvl(sum(decode(d.pid_balanorient,0,a.localdebitamount - a.localcreditamount,
                                        1,a.localcreditamount - a.localdebitamount)),0) as local_endbalance,
           0,
           0,
           c.code                   as currency,
           sum(a.debitamount)       as enddrbalance,
           sum(a.localdebitamount)  as local_enddrbalance,
           sum(a.creditamount)      as endcrbalance,
           sum(a.localcreditamount) as local_endcrbalance
      from kods.nc65_gl_detail   a,
           kods.nc65_org_accountingbook    b,
           kods.nc65_bd_currtype c,
           kods.nc65_bd_accasoa e,
           (select nvl(t2.balanorient,t1.balanorient) pid_balanorient,t1.* from kods.nc65_bd_account t1
            left join kods.nc65_bd_account t2 on substr(t1.code,0,4) = t2.code
                                            and t2.dataoriginflag = 0)  d --ϼĿΪ׼
     where a.pk_accountingbook = b.pk_accountingbook
       and a.pk_currtype = c.pk_currtype
       and a.pk_accasoa = e.pk_accasoa
       and e.pk_account = d.pk_account
       and a.yearv = v_year
       and a.periodv <= v_period
       and a.dr = 0 --Ƿע
       --and a.discardflagv = 'N' --ǷΪϵ־
       --and b.code != '02' --޳ڻݺͶ޹˾
     group by b.code, c.code,d.code;

  --ڼ:ԭңҽ跽
  select b.code        as company,
         d.code as acctsubjcode,
         0,
         0,
         0,
         0,
         nvl(sum(a.debitamount), 0)       as period_net_dr,
         nvl(sum(a.creditamount), 0)      as period_net_cr,
         nvl(sum(a.localdebitamount), 0)  as local_period_net_dr,
         nvl(sum(a.localcreditamount), 0) as local_period_net_cr,
         v_year || '-' || v_period        as period_name,
         v_year                           as period_year,
         v_period                         as period_num,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         nvl(sum(decode(d.pid_balanorient,0,a.debitamount - a.creditamount,
                                    1,a.creditamount - a.debitamount,
                                        a.debitamount - a.creditamount)),0)  as periodbalance,
         0,
         0,
         0,
         nvl(sum(decode(d.pid_balanorient,0,a.localdebitamount - a.localcreditamount,
                                    1,a.localcreditamount - a.localdebitamount,
                                        a.localdebitamount - a.localcreditamount)),0) as local_periodbalance,
         c.code                   as currency,
         sum(a.debitamount)       as enddrbalance,
         sum(a.localdebitamount)  as local_enddrbalance,
         sum(a.creditamount)      as endcrbalance,
         sum(a.localcreditamount) as local_endcrbalance bulk collect
    into vt_cwxt_unfi
    from kods.nc65_gl_detail   a,
         kods.nc65_org_accountingbook    b,
         kods.nc65_bd_currtype c,
         kods.nc65_bd_accasoa e,
         (select nvl(t2.balanorient,t1.balanorient) pid_balanorient,t1.* from kods.nc65_bd_account t1
          left join kods.nc65_bd_account t2 on substr(t1.code,0,4) = t2.code
                                            and t2.dataoriginflag = 0)  d
   where a.pk_accountingbook = b.pk_accountingbook
     and a.pk_currtype = c.pk_currtype
     and a.yearv = v_year
     and a.pk_accasoa = e.pk_accasoa
     and e.pk_account = d.pk_account
     and a.periodv = v_period
     and a.dr = 0 --Ƿע
     --and a.discardflagv = 'N' --ǷΪϵ־
     --and a.direction = 'C' --ڼȡһ
     --and b.code != '02' --޳ڻݺͶ޹˾
   group by b.code,c.code,d.code;

  for i in 1 .. vt_cwxt_unfi.count loop
    update t_map_cwxt_km_unfi t
       set t.period_net_dr       = vt_cwxt_unfi(i).period_net_dr,
           t.period_net_cr       = vt_cwxt_unfi(i).period_net_cr,
           t.local_period_net_cr = vt_cwxt_unfi(i).local_period_net_cr,
           t.local_period_net_dr = vt_cwxt_unfi(i).local_period_net_dr,
           t.periodbalance       = vt_cwxt_unfi(i).periodbalance,
           t.local_periodbalance = vt_cwxt_unfi(i).local_periodbalance
     where t.company = vt_cwxt_unfi(i).company
       and t.acctsubjcode = vt_cwxt_unfi(i).acctsubjcode
       and t.currency = vt_cwxt_unfi(i).currency;
  end loop;
  vt_cwxt_unfi.delete;
  --ڳ
  select b.code,
         d.code,
         nvl(sum(a.debitamount), 0) beginbalancedr,
         nvl(sum(a.creditamount), 0) beginbalancecr,
         nvl(sum(a.localdebitamount), 0) localbeginbalancedr,
         nvl(sum(a.localcreditamount), 0) localbeginbalancecr,
         0,
         0,
         0,
         0,
         v_year || '-' || v_period,
         v_year,
         v_period,
         0,
         0,
         0,
         0,
         nvl(sum(decode(d.pid_balanorient,0,a.debitamount - a.creditamount,
                                      1,a.creditamount - a.debitamount)),0) beginbalance,
         0,
         0,
         0,
         nvl(sum(decode(d.pid_balanorient,0,a.localdebitamount - a.localcreditamount,
                                      1,a.localcreditamount - a.localdebitamount)),0) localbeginbalance,
         0,
         0,
         0,
         c.code,
         sum(a.debitamount),
         sum(a.localdebitamount),
         sum(a.creditamount),
         sum(a.localcreditamount) bulk collect
    into vt_cwxt_unfi
    from kods.nc65_gl_detail   a,
         kods.nc65_org_accountingbook    b,
         kods.nc65_bd_currtype c,
         kods.nc65_bd_accasoa e,
         (select nvl(t2.balanorient,t1.balanorient) pid_balanorient,t1.* from kods.nc65_bd_account t1
          left join kods.nc65_bd_account t2 on substr(t1.code,0,4) = t2.code
                                            and t2.dataoriginflag = 0) d
   where a.pk_accountingbook = b.pk_accountingbook
     and a.pk_currtype = c.pk_currtype
     and a.pk_accasoa = e.pk_accasoa
     and e.pk_account = d.pk_account
     and a.yearv = v_year
     and a.periodv < v_period
     and a.dr = 0 --Ƿע
     --and a.discardflagv = 'N' --ǷΪϵ־
     --and b.code != '02' --޳ڻݺͶ޹˾
   group by b.code, c.code,d.code;

  for i in 1 .. vt_cwxt_unfi.count loop
    update t_map_cwxt_km_unfi t
       set t.begin_balance_dr       = vt_cwxt_unfi(i).begin_balance_dr,
           t.begin_balance_cr       = vt_cwxt_unfi(i).begin_balance_cr,
           t.local_begin_balance_cr = vt_cwxt_unfi(i)
                                      .local_begin_balance_cr,
           t.local_begin_balance_dr = vt_cwxt_unfi(i)
                                      .local_begin_balance_dr,
           t.beginbalance           = vt_cwxt_unfi(i).beginbalance,
           t.local_beginbalance     = vt_cwxt_unfi(i).local_beginbalance
     where t.company = vt_cwxt_unfi(i).company
       and t.acctsubjcode = vt_cwxt_unfi(i).acctsubjcode
       and t.currency = vt_cwxt_unfi(i).currency;
  end loop;
  vt_cwxt_unfi.delete;
  --ԭң
  select b.code,
         d.code,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         0,
         v_year || '-' || v_period,
         v_year,
         v_period,
         nvl(sum(a.debitamount), 0) nc_balancedr,
         nvl(sum(a.creditamount), 0) nc_balancecr,
         nvl(sum(a.localdebitamount), 0) local_nc_balancedr,
         nvl(sum(a.localcreditamount), 0) local_nc_balancecr,
         0,
         0,
         nvl(sum(decode(d.pid_balanorient,0,a.debitamount - a.creditamount,
                                      1,a.creditamount - a.debitamount)),0) ncbalance,
         0,
         0,
         0,
         nvl(sum(decode(d.pid_balanorient,0,a.localdebitamount - a.localcreditamount,
                                      1,a.localcreditamount - a.localdebitamount)),0) localncbalance,
         0,
         c.code,
         sum(a.debitamount),
         sum(a.localdebitamount),
         sum(a.creditamount),
         sum(a.localcreditamount) bulk collect
    into vt_cwxt_unfi
    from kods.nc65_gl_detail   a,
         kods.nc65_org_accountingbook  b,
         kods.nc65_bd_currtype c,
         kods.nc65_bd_accasoa e,
         (select nvl(t2.balanorient,t1.balanorient) pid_balanorient,t1.* from kods.nc65_bd_account t1
          left join kods.nc65_bd_account t2 on substr(t1.code,0,4) = t2.code
                                            and t2.dataoriginflag = 0)  d
   where a.pk_accountingbook = b.pk_accountingbook
     and a.pk_currtype = c.pk_currtype
     and a.pk_accasoa = e.pk_accasoa
     and e.pk_account = d.pk_account
     and a.yearv = v_year
     and a.periodv = '00'
     and a.dr = 0 --Ƿע
     --and a.discardflagv = 'N' --ǷΪϵ־
     --and b.code != '02' --޳ڻݺͶ޹˾
   group by b.code, c.code,d.code;

  for i in 1 .. vt_cwxt_unfi.count loop
    update t_map_cwxt_km_unfi t
       set t.nc_balance_dr       = vt_cwxt_unfi(i).nc_balance_dr,
           t.nc_balance_cr       = vt_cwxt_unfi(i).nc_balance_cr,
           t.local_nc_balance_cr = vt_cwxt_unfi(i).local_nc_balance_cr,
           t.local_nc_balance_dr = vt_cwxt_unfi(i).local_nc_balance_dr,
           t.ncbalance           = vt_cwxt_unfi(i).ncbalance,
           t.local_ncbalance     = vt_cwxt_unfi(i).local_ncbalance
     where t.company = vt_cwxt_unfi(i).company
       and t.acctsubjcode = vt_cwxt_unfi(i).acctsubjcode
       and t.currency = vt_cwxt_unfi(i).currency;
  end loop;
  vt_cwxt_unfi.delete;
  commit;


 exception when others then
  v_str:=sqlerrm;
  rollback;
  return;
END;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1100060
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1100060(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid  integer;
    v_orgid  integer;
    v_rmb  number;
    v_gb  number;
    v_my  number;
    v_myrate  number;
    v_gbrate  number;

    v_count number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select a.a012,a.p002  into v_userid,v_orgid from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b where a.P001 = v_KJAXUSER and a.P002 = b.P001;

    delete from T_CSRC0710_0_6 WHERE BBQ=v_P001 and userid = v_userid; /* ɾͬһڵ */

    insert into T_CSRC0710_0_6(BBQ,USERID,BTYPE,OPTION1,SHTAG,a4,b4)
      select v_P001,v_userid,0,null,1,(select count(*) from  krcs.t_ctl_t036 where a008=1023008 and w100 = v_orgid),v
      from t_b15_f001
      where p002=1001 and p001=substr(v_P001,1,6);

    update T_CSRC0710_0_6 set c4=(select v
                                 from t_b15_f001
                                 where p002=1002 and p001=substr(v_P001,1,6))  where bbq = v_P001 and userid = v_userid;
    v_count := 0;
    v_rmb := 0;
    select count(*) into v_count
    from t_b15_f001 where p002=1003 and p001=substr(v_P001,1,6) and w100 = v_userid;
    if v_count > 0 then
       select nvl(v,0) into v_rmb from t_b15_f001 where p002=1003 and p001=substr(v_P001,1,6) and w100 = v_userid;
    end if;

    v_count := 0;
    v_gb := 0;
    select count(*) into v_count
    from t_b15_f001 where p002=1004 and p001=substr(v_P001,1,6) and w100 = v_userid;
    if v_count > 0 then
       select nvl(v,0) into v_gb  from t_b15_f001 where p002=1004 and p001=substr(v_P001,1,6) and w100 = v_userid;
    end if;

    v_count := 0;
    v_my := 0;
    select count(*) into v_count
    from t_b15_f001 where p002=1005 and p001=substr(v_P001,1,6) and w100 = v_userid;
    if v_count > 0 then
       select nvl(v,0) into v_my  from t_b15_f001 where p002=1005 and p001=substr(v_P001,1,6) and w100 = v_userid;
    end if;

    select a002 into v_myrate from t_bks_t007;
    select a003 into v_gbrate from t_bks_t007;
    update T_CSRC0710_0_6 set d4=(v_rmb+v_gb*v_gbrate+v_my*v_myrate) where BBQ=v_P001 and USERID = v_userid;


    update T_CSRC0710_0_6 set e4=(select decode(a005,1001101,'T',1001102,'F')
                                 from t_b15_t001 where a100 = v_orgid) where BBQ=v_P001 and USERID= v_userid;

    update T_CSRC0710_0_6 set f4=(select a099
                                 from t_b15_t001 where a100 = v_orgid) where BBQ=v_P001 and USERID= v_userid;


    update krcs.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1100060;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>0-6'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1100060;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1100060;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_1100060!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1105010
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1105010(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    V_ORGNAME VARCHAR(51);
    V_C11 VARCHAR2(25);
    V_g11 VARCHAR2(25);
    V_K11 VARCHAR2(25);
    V_C13 VARCHAR2(21);
    V_g13 VARCHAR2(25);
    V_c15 VARCHAR2(21);
    V_f15 VARCHAR2(25);
    V_i15 VARCHAR2(25);
    V_L15 VARCHAR2(25);
    V_c17 VARCHAR2(21);
    V_f17 VARCHAR2(25);
    V_i17 VARCHAR2(25);
    V_L17 VARCHAR2(25);
    V_d21 VARCHAR2(25);
    V_C19 integer;
    V_I19 integer;
    v_status number;
    v_count       number;
    /*Ϣ*/
    --  update by zhouly  20130822  ˻ͲID
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_B0 WHERE BBQ=v_P001 and userid = v_userid; /* ɾͬһڵ */
    SELECT T2.A003 into V_ORGNAME FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;
    SELECT nvl(A002,0) INTO V_C11 FROM t_bks_t012 WHERE P001=1031001 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    SELECT nvl(A002,0) INTO V_G11 FROM t_bks_t012 WHERE P001=1031002 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    SELECT nvl(A002,0) INTO V_K11 FROM t_bks_t012 WHERE P001=1031003 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    SELECT nvl(A002,0) INTO V_C13 FROM t_bks_t012 WHERE P001=1031004 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    SELECT nvl(A002,0) INTO V_G13 FROM t_bks_t012 WHERE P001=1031005 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    SELECT A002,A003,A004,substr(A005,1,24) INTO V_C15,V_f15,V_i15,V_L15 FROM t_bks_t012 WHERE P001=1031006 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    SELECT A002,A003,A004,substr(A005,1,24) INTO V_C17,V_f17,V_i17,V_L17 FROM t_bks_t012 WHERE P001=1031007 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);

    select count(*) into v_count FROM T_BKS_T040 WHERE P001 =1060001 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    if(v_count =1) then
         SELECT A002,A003 INTO V_C19,V_I19 FROM T_BKS_T040 WHERE P001 =1060001 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    end if;

    insert into t_csrc0707_b0(bbq,userid,btype,option1,shtag,UPID,username,g8,c11,g11,K11,C13,g13,c15,f15,i15,L15,c17,f17,i17,L17,d21,C19,I19)
           VALUES( v_p001,v_userid,'0','0','0','--',V_ORGNAME,SYSDATE,V_C11,V_g11,V_K11,V_C13,V_g13,V_c15,V_f15,V_i15,V_L15,V_c17,V_f17,V_i17,V_L17,V_d21,V_C19,V_I19);


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1105010 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 =1105010;
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1105010 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1105010!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1105020
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1105020(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp     varchar(2000);
  v_sql      varchar(2000);
  v_logic    varchar(1);
  v_row      integer;
  v_colname1 varchar(256);
  v_colname2 varchar(256);
  v_EP001    integer;
  v_EA002    integer;
  v_USER     integer;
  v_EA003    varchar(256);
  v_status   number;
  cursor cur_work is
    select a.p001, a.a002, a.a003
      from T_BKS_T009 a, t_b00_d099 b
     where a.p001 = b.p001
       and b.a002 = 1015
       and a.a100 in
           (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
     order by p001;
  /*֤ȯ˾ʾ */
begin
  errcode := 1;
  errmsg  := 'ɱɹ';

  select a.a012
    into v_USER
    from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
   where a.P001 = v_KJAXUSER
     and a.P002 = b.P001;

  delete from T_CSRC0707_B1
   WHERE BBQ = v_P001
     and userid = v_USER;
  insert into T_CSRC0707_B1
    (Userid, Bbq, Btype, Option1, Shtag)
  values
    (v_USER, v_P001, '0', '', '0');

  v_row := 6;
  open cur_work;
  fetch cur_work
    into v_EP001, v_EA002, v_EA003;
  while cur_work%found loop
    ---
    v_logic := '';
    if v_EA002 = 1001101 then
      v_logic := 'T';
    end if;
    if v_EA002 = 1001102 then
      v_logic := 'F';
    end if;
  
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0707_B1'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname1;
    v_row := v_row + 1;
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0707_B1'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname2;
  
    v_sql := 'update T_CSRC0707_B1 set ' || v_colname1 || '=''' || v_logic ||
             ''',' || v_colname2 || '=''' || v_EA003 || '''' ||
             ' where userid=''' || v_USER || ''' and BBQ=''' || v_P001 || '''';
    execute immediate v_sql;
  
    fetch cur_work
      into v_EP001, v_EA002, v_EA003;
    v_row := v_row + 1;
  end loop;
  close cur_work;

  update KRCS.T_SYS_T024
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = 1105020
     and a008 = v_USER;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1105020;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;
exception
  when others then
    rollback;
  
    update KRCS.T_SYS_T024
       SET A010 = 1015002
     WHERE P001 = 1105020
       and a008 = v_USER; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1105020!';
    return;
  
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1105030
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1105030(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp     varchar(2000);
  v_sql      varchar(2000);
  v_row      integer;
  v_colname1 varchar(256);
  v_colname2 varchar(256);
  v_colname3 varchar(256);
  v_colname4 varchar(256);
  v_EP001    integer;
  v_EA002    varchar(256);
  v_EA003    varchar(256);
  v_EA004    varchar(256);
  v_EA005    varchar(256);
  v_USER     integer;
  v_status   number;

  cursor cur_work is
  /* select a.p001,b.a003,b.a011,c.a002,b.a100
               from T_BKS_T008 a,
                    KRCS.T_CTL_T036 b,
                    (select 3||p001 as p001,a002 from t_ctl_t008) c
               where a.a002(+)=b.p001
                 and b.a015(+)=c.p001
                 and b.a008=1023002
                 and b.B001=1002001
               order by a.p001;*/
  
    select d.p001, b.a003, b.a011, c.a002, b.a100
      from T_BKS_D006 d,
           T_BKS_T008 a,
           (select *
              from KRCS.T_CTL_T036
             where a008 = 1023002
               and b001 = 1001101
               and w100 =
                   (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)) b,
           (select 3 || p001 as p001, a002
              from t_ctl_t008
             where a100 =
                   (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)) c
     where d.p001 = a.p001(+)
       and a.a002 = b.p001(+)
       and b.a015 = c.p001(+)
       and a.a100 in
           (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
     order by d.p001;
  /*˾ҵ */
begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  select a.a012
    into v_USER
    from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
   where a.P001 = v_KJAXUSER
     and a.P002 = b.P001;

  delete from T_CSRC0707_B2
   WHERE BBQ = v_P001
     and userid = v_USER;
  insert into T_CSRC0707_B2
    (Userid, Bbq, Btype, Option1, Shtag)
  values
    (v_USER, v_P001, '0', '', '0');

  v_row := 6;
  open cur_work;
  fetch cur_work
    into v_EP001, v_EA002, v_EA003, v_EA004, v_EA005;
  while cur_work%found loop
  
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0707_B2'' and COLNO=' || v_row;
    dbms_output.put_line(v_sql);
  
    execute immediate v_sql
      into v_colname1;
  
    v_row := v_row + 1;
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0707_B2'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname2;
  
    v_row := v_row + 1;
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0707_B2'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname3;
  
    v_row := v_row + 1;
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0707_B2'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname4;
  
    v_sql := 'update T_CSRC0707_B2 set ' || v_colname1 || '=''' || v_EA002 ||
             ''',' || v_colname2 || '=''' || v_EA003 || ''',' || v_colname3 ||
             '=''' || v_ea004 || ''',' || v_colname4 || '=''' || v_ea005 || '''' ||
             ' where userid=''' || v_USER || ''' and BBQ=''' || v_P001 || '''';
    execute immediate v_sql;
  
    fetch cur_work
      into v_EP001, v_EA002, v_EA003, v_EA004, v_EA005;
    v_row := v_row + 1;
  end loop;
  close cur_work;

  update KRCS.T_SYS_T024
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = 1105030
     and a008 = v_USER;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1105030;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;
exception
  when others then
    rollback;
    update KRCS.T_SYS_T024
       SET A010 = 1015002
     WHERE P001 = 1105030
       and a008 = v_USER; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1105030!';
    return;
  
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1110010
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1110010(errcode    out int,
                                                 errmsg     out varchar2,
                                                 v_KJAXUSER varchar2,
						 v_TASK varchar2,
                                                 v_P001     varchar2,
                                                 v_P002     varchar2,
                                                 v_P003     varchar2)
       is
       v_bmid number;
        v_date int;
       v_temp varchar(256);
begin


     errcode:=1;
     errmsg := 'ɱɹ';
     select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;
     select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID


     update T_CSRC1226_A1_1 set O33=(select nvl(a003,0) from t_idx_d002 t where t.p001=14300)
     where BBQ=v_date||'--' and USERID=v_bmid;

     update T_CSRC1226_A1_1 set O49=(select nvl(a003,0) from t_idx_d002 t  where t.p001=15604)
     where BBQ=v_date||'--' and USERID=v_bmid;

     update T_CSRC1226_A1_1 set O82=(select nvl(a003,0) from t_idx_d002 t where t.p001=19200)
     where BBQ=v_date||'--' and USERID=v_bmid;

     update T_CSRC1226_A1_1 set O85=(select nvl(a003,0) from t_idx_d002 t where t.p001=20200)
     where BBQ=v_date||'--' and USERID=v_bmid;

      update T_CSRC1226_A1_1 set O87=(select nvl(a003,0) from t_idx_d002 t where t.p001=21100)
     where BBQ=v_date||'--' and USERID=v_bmid;

      update T_CSRC1226_A1_1 set O88=(select nvl(a003,0) from t_idx_d002 t where t.p001=21101)
     where BBQ=v_date||'--' and USERID=v_bmid;

     update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1110010 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>'||A004||'' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1110010;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1110020
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1110020(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_EP001 varchar(64);
    v_EP002 number(19,2);
    v_EP003 number(19,2);
    v_EP004 varchar(64);
    v_bmid number;
    v_org  number;
    --v_USER  integer;
    v_count integer;
    v_yjbz varchar(19);
    v_jgbz varchar(19);
    /*ָ걨ˡݱ*/


  /*  cursor c_work7 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1013
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work8 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1014
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work9 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1015
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work10 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1016
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work11 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1017
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;*/
    --added by  wujinyu on 2010-8-12 (end)

    cursor c_work1 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1009
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work2 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1010
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
     cursor c_work3 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1012--ݱӦķࣨݱID
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work4 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1006
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work5 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1007
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
    cursor c_work6 is
           select p001,a002,a003,a006 from t_da_02_001
            where a004=1008
            and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER)
            order by a005;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select a012,p002 into v_bmid,v_org from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID

    /*select T2.A002 into v_bmid
      from KRCS.T_SYS_USER T1, T_CTL_T036 T2
      where T1.P001 = v_KJAXUSER
      and T1.P002 = T2.P001;*/

    update T_CSRC1226_A2_1 set e2=(select a002 from t_bks_t017 where p001=1001 and a100 = v_org),
                               f2=(select a003 from t_bks_t017 where p001=1001 and a100 = v_org),
                               g2=(select a006 from t_da_01_002 where p001=1001 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e3=(select a002 from t_bks_t017 where p001=1002 and a100 = v_org),
                               f3=(select a003 from t_bks_t017 where p001=1002 and a100 = v_org),
                               g3=(select a006 from t_da_01_002 where p001=1002 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    /*֤İ󣬶Ԥָͼָꡱθҳд;
    update T_CSRC1226_A2_1 set e4=(select a002 from t_bks_t017 where p001=1003),
                               f4=(select a003 from t_bks_t017 where p001=1003),
                               g4=(select a006 from t_da_01_002 where p001=1003 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e5=(select a002 from t_bks_t017 where p001=1004),
                               f5=(select a003 from t_bks_t017 where p001=1004),
                               g5=(select a006 from t_da_01_002 where p001=1004 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e6=(select a002 from t_bks_t017 where p001=1005),
                               f6=(select a003 from t_bks_t017 where p001=1005),
                               g6=(select a006 from t_da_01_002 where p001=1005 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e7=(select a002 from t_bks_t017 where p001=1006),
                               f7=(select a003 from t_bks_t017 where p001=1006),
                               g7=(select a006 from t_da_01_002 where p001=1006 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e8=(select a002 from t_bks_t017 where p001=1023),
                               f8=(select a003 from t_bks_t017 where p001=1023),
                               g8=(select a006 from t_da_01_002 where p001=1023 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e9=(select a002 from t_bks_t017 where p001=1024),
                               f9=(select a003 from t_bks_t017 where p001=1024),
                               g9=(select a006 from t_da_01_002 where p001=1024 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e10=(select a002 from t_bks_t017 where p001=1025),
                               f10=(select a003 from t_bks_t017 where p001=1025),
                               g10=(select a006 from t_da_01_002 where p001=1025 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e17=(select a002 from t_bks_t017 where p001=1026),
                               f24=(select a003 from t_bks_t017 where p001=1026),
                               g24=(select a006 from t_da_01_002 where p001=1026 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e24=(select a002 from t_bks_t017 where p001=1028),
                               f24=(select a003 from t_bks_t017 where p001=1028),
                               g24=(select a006 from t_da_01_002 where p001=1028 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;
    update T_CSRC1226_A2_1 set e31=(select a002 from t_bks_t017 where p001=1034),
                               f31=(select a003 from t_bks_t017 where p001=1034),
                               g31=(select a006 from t_da_01_002 where p001=1034 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;

    update T_CSRC1226_A2_1 set e38=(select a002 from t_bks_t017 where p001=1040),
                               f38=(select a003 from t_bks_t017 where p001=1040),
                               g38=(select a006 from t_da_01_002 where p001=1040 and w100=v_bmid)
                               where BBQ=v_P001 and USERID=v_bmid;*/
    open c_work1;
    v_count:=1;
    fetch c_work1 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work1%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a12=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c12=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d12=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g12=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a13=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c13=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d13=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g13=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a14=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c14=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d14=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g14=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a15=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c15=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d15=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g15=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a16=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c16=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d16=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g16=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work1 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work1;

    open c_work2;
    v_count:=1;
    fetch c_work2 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work2%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a19=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c19=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d19=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g19=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a20=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c20=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d20=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g20=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a21=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c21=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d21=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g21=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a22=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c22=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d22=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g22=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a23=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c23=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d23=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g23=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work2 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work2;

    open c_work3;
    fetch c_work3 into v_EP001,v_EP002,v_EP003,v_EP004;
    v_count:=1;
    while c_work3%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a26=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c26=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d26=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g26=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a27=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c27=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d27=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g27=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a28=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c28=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d28=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g28=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a29=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c29=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d29=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g29=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a30=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c30=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d30=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g30=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work3 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work3;

    open c_work4;
    v_count:=1;
    fetch c_work4 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work4%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a33=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c33=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d33=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g33=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a34=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c34=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d34=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g34=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a35=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c35=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d35=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g35=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a36=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c36=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d36=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g36=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a37=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c37=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d37=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g37=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work4 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work4;

    open c_work5;
    v_count:=1;
    fetch c_work5 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work5%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a40=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c40=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d40=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g40=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a41=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c41=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d41=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g41=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a42=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c42=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d42=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g42=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a43=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c43=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d43=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g43=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a44=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c44=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d44=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g44=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work5 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work5;
    -- added by wujinyu on 2010-8-13 .[hongyuan limited].  begin
    open c_work6;
    v_count:=1;
    fetch c_work6 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work6%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a47=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c47=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d47=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g47=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a48=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c48=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d48=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g48=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a49=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c49=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d49=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g49=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a50=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c50=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d50=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g50=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a51=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c51=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d51=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g51=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work6 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work6;

    /*open c_work7;
    v_count:=1;
    fetch c_work7 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work7%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a54=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c54=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d54=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g54=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a55=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c55=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d55=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g55=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a56=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c56=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d56=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g56=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a57=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c57=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d57=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g57=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a58=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c58=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d58=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g58=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work7 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work7;

    open c_work8;
    v_count:=1;
    fetch c_work8 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work8%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a61=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c61=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d61=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g61=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a62=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c62=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d62=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g62=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a63=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c63=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d63=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g63=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a64=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c64=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d64=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g64=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a65=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c65=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d65=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g65=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work8 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work8;

    open c_work9;
    v_count:=1;
    fetch c_work9 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work9%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a68=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c68=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d68=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g68=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a69=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c69=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d69=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g69=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a70=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c70=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d70=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g70=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a71=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c71=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d71=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g71=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a72=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c72=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d72=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g72=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work9 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work9;

    open c_work10;
    v_count:=1;
    fetch c_work10 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work10%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a75=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c75=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d75=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g75=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a76=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c76=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d76=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g76=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a77=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c77=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d77=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g77=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a78=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c78=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d78=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g78=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a79=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c79=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d79=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g79=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work10 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work10;


    open c_work11;
    v_count:=1;
    fetch c_work11 into v_EP001,v_EP002,v_EP003,v_EP004;
    while c_work11%found
    loop
        if( v_count=1)  then
             update T_CSRC1226_A2_1 set a82=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c82=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d82=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g82=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=2)  then
             update T_CSRC1226_A2_1 set a83=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c83=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d83=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g83=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=3)  then
             update T_CSRC1226_A2_1 set a84=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c84=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d84=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g84=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=4)  then
             update T_CSRC1226_A2_1 set a85=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c85=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d85=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g85=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        if( v_count=5)  then
             update T_CSRC1226_A2_1 set a86=v_EP001 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set c86=v_EP002 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set d86=v_EP003 where BBQ=v_P001 and USERID=v_bmid;
             update T_CSRC1226_A2_1 set g86=v_EP004 where BBQ=v_P001 and USERID=v_bmid;
        end if;
        v_count := v_count +1;
        fetch c_work11 into v_EP001,v_EP002,v_EP003,v_EP004;
    end loop;
    close c_work11;*/
    -- added by wujinyu on 2010-8-13 .[hongyuan limited].  end
    select a002 into v_yjbz from T_bks_t017 where p001=1025 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1025 and a100 = v_org;
    update T_CSRC1226_A2_1 set e12=v_yjbz,f12=v_jgbz,
                               e13=v_yjbz,f13=v_jgbz,
                               e14=v_yjbz,f14=v_jgbz,
                               e15=v_yjbz,f15=v_jgbz,
                               e16=v_yjbz,f16=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;

    select a002 into v_yjbz from T_bks_t017 where p001=1026 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1026 and a100 = v_org;
    update T_CSRC1226_A2_1 set e19=v_yjbz,f19=v_jgbz,
                               e20=v_yjbz,f20=v_jgbz,
                               e21=v_yjbz,f21=v_jgbz,
                               e22=v_yjbz,f22=v_jgbz,
                               e23=v_yjbz,f23=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;

    select a002 into v_yjbz from T_bks_t017 where p001=1027 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1027 and a100 = v_org;
    update T_CSRC1226_A2_1 set e26=v_yjbz,f26=v_jgbz,
                               e27=v_yjbz,f27=v_jgbz,
                               e28=v_yjbz,f28=v_jgbz,
                               e29=v_yjbz,f29=v_jgbz,
                               e30=v_yjbz,f30=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;
    select a002 into v_yjbz from T_bks_t017 where p001=1028 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1028 and a100 = v_org;
    update T_CSRC1226_A2_1 set e33=v_yjbz,f33=v_jgbz,
                               e34=v_yjbz,f34=v_jgbz,
                               e35=v_yjbz,f35=v_jgbz,
                               e36=v_yjbz,f36=v_jgbz,
                               e37=v_yjbz,f37=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;
    select a002 into v_yjbz from T_bks_t017 where p001=1034 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1034 and a100 = v_org;
    update T_CSRC1226_A2_1 set e40=v_yjbz,f40=v_jgbz,
                               e41=v_yjbz,f41=v_jgbz,
                               e42=v_yjbz,f42=v_jgbz,
                               e43=v_yjbz,f43=v_jgbz,
                               e44=v_yjbz,f44=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;
     --added by wujinyu on hongyuan  on 2010-08-13  begin
    select a002 into v_yjbz from T_bks_t017 where p001=1040 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1040 and a100 = v_org;
    update T_CSRC1226_A2_1 set e47=v_yjbz,f47=v_jgbz,
                               e48=v_yjbz,f48=v_jgbz,
                               e49=v_yjbz,f49=v_jgbz,
                               e50=v_yjbz,f50=v_jgbz,
                               e51=v_yjbz,f51=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;

    /*select a002 into v_yjbz from T_bks_t017 where p001=1060 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1060 and a100 = v_org;
    update T_CSRC1226_A2_1 set e54=v_yjbz,f54=v_jgbz,
                               e55=v_yjbz,f55=v_jgbz,
                               e56=v_yjbz,f56=v_jgbz,
                               e57=v_yjbz,f57=v_jgbz,
                               e58=v_yjbz,f58=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;

    select a002 into v_yjbz from T_bks_t017 where p001=1070 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1070 and a100 = v_org;
    update T_CSRC1226_A2_1 set e61=v_yjbz,f61=v_jgbz,
                               e62=v_yjbz,f62=v_jgbz,
                               e63=v_yjbz,f63=v_jgbz,
                               e64=v_yjbz,f64=v_jgbz,
                               e65=v_yjbz,f65=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;

    select a002 into v_yjbz from T_bks_t017 where p001=1080 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1080 and a100 = v_org;
    update T_CSRC1226_A2_1 set e68=v_yjbz,f68=v_jgbz,
                               e69=v_yjbz,f69=v_jgbz,
                               e70=v_yjbz,f70=v_jgbz,
                               e71=v_yjbz,f71=v_jgbz,
                               e72=v_yjbz,f72=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;

    select a002 into v_yjbz from T_bks_t017 where p001=1090 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1090 and a100 = v_org;
    update T_CSRC1226_A2_1 set e75=v_yjbz,f75=v_jgbz,
                               e76=v_yjbz,f76=v_jgbz,
                               e77=v_yjbz,f77=v_jgbz,
                               e78=v_yjbz,f78=v_jgbz,
                               e79=v_yjbz,f79=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;

    select a002 into v_yjbz from T_bks_t017 where p001=1100 and a100 = v_org;
    select a003 into v_jgbz from t_bks_t017 where p001=1100 and a100 = v_org;
    update T_CSRC1226_A2_1 set e82=v_yjbz,f82=v_jgbz,
                               e83=v_yjbz,f83=v_jgbz,
                               e84=v_yjbz,f84=v_jgbz,
                               e85=v_yjbz,f85=v_jgbz,
                               e86=v_yjbz,f86=v_jgbz
                               where BBQ=v_P001 and USERID=v_bmid;*/




    --added by wujinyu on hongyuan  on 2010-08-13  end

    update KRCS.T_SYS_T024 SET A010=1015001 WHERE P001=1110020 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>'||A004||'' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1110020;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1110020 and a008=v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_1110020!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1110030
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1110030(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_name varchar(19);
    --v_USER  integer;
    v_bmid number;
begin
   /* select T2.A002 into v_USER
      from KRCS.T_SYS_USER T1, T_CTL_T036 T2
      where T1.P001 = v_KJAXUSER
      and T1.P002 = T2.P001;*/
    errcode:=1;
    errmsg := 'ɱɹ';
    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID

    select a022 into v_name from KRCS.t_ctl_t036
    where p001 in (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);

    update T_CSRC1226_A2_2 set d1=v_name  where BBQ=v_P001 and USERID=v_bmid;

    update KRCS.T_SYS_T024 SET A010=1015001 WHERE P001=1110030 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>'||A004||'' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1110030;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1110030 and a008=v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_1110030!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1110040
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1110040( errcode out int, errmsg out varchar2,v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2 ,v_P002 varchar2, v_P003 varchar2)
is

     v_temp varchar(256);
     --v_USER  integer;
     v_count int;
     v_bmid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

      select a012 into v_bmid from KRCS.t_sys_user where p001 =v_KJAXUSER;--ȡID

      select count(*) into v_count from t_da_01_003 where p001=1100 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g4=(select a006 from t_da_01_003 where p001=1100 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1200 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g5=(select a006 from t_da_01_003 where p001=1200 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1300 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g6=(select a006 from t_da_01_003 where p001=1300 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1400 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g9=(select a006 from t_da_01_003 where p001=1400 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1500 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g10=(select a006 from t_da_01_003 where p001=1500 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1600 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g11=(select a006 from t_da_01_003 where p001=1600 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1700 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g12=(select a006 from t_da_01_003 where p001=1700 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1800 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g13=(select a006 from t_da_01_003 where p001=1800 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=1900 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g16=(select a006 from t_da_01_003 where p001=1900 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2000 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g17=(select a006 from t_da_01_003 where p001=2000 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2100 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g18=(select a006 from t_da_01_003 where p001=2100 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2200 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g19=(select a006 from t_da_01_003 where p001=2200 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2300 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g22=(select a006 from t_da_01_003 where p001=2300 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2400 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g23=(select a006 from t_da_01_003 where p001=2400 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2500 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g24=(select a006 from t_da_01_003 where p001=2500 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2600 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g25=(select a006 from t_da_01_003 where p001=2600 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2601 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g26=(select a006 from t_da_01_003 where p001=2601 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2602 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g27=(select a006 from t_da_01_003 where p001=2602 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2700 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g28=(select a006 from t_da_01_003 where p001=2700 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2800 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g29=(select a006 from t_da_01_003 where p001=2800 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=2900 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g31=(select a006 from t_da_01_003 where p001=2900 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=3000 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g34=(select a006 from t_da_01_003 where p001=3000 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=3100 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g35=(select a006 from t_da_01_003 where p001=3100 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=3200 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g36=(select a006 from t_da_01_003 where p001=3200 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=3300 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g37=(select a006 from t_da_01_003 where p001=3300 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from t_da_01_003 where p001=3400 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC0707_A3_1 set g38=(select a006 from t_da_01_003 where p001=3400 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1110040 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>'||A004||'' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1110040;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1110040 and a008=v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢krcs_makereport_1110040!';
                return;

end ;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120010
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1120010(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)

   is
    v_temp        varchar(256);
    v_content1    number;
    v_content2    varchar(256);
    v_count       number;
    v_bmid number;

begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select a012 into v_bmid from krcs.t_sys_user where p001 =v_KJAXUSER;--ȡID

    v_content1 := '';
    v_content2 := '';

    select count(*) into v_count from T_BKS_T041 where P001=1070001 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    if(v_count =1) then
         select A002,A008 into v_content1,v_content2 from T_BKS_T041 where P001=1070001 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    end if;
    update T_CSRC0707_C1_1 set E52 = v_content1,K52=v_content2
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_BKS_T041 where P001=1070002 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    if(v_count =1) then
         select A002,A008 into v_content1,v_content2 from T_BKS_T041 where P001=1070002 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    end if;
    update T_CSRC0707_C1_1 set E53 = v_content1,K53=v_content2
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_BKS_T041 where P001=1070003 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    if(v_count =1) then
         select A002,A008 into v_content1,v_content2 from T_BKS_T041 where P001=1070003 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    end if;
    update T_CSRC0707_C1_1 set E54 = v_content1,K54=v_content2
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_BKS_T041 where P001=1070004 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    if(v_count =1) then
         select A002,A008 into v_content1,v_content2 from T_BKS_T041 where P001=1070004 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    end if;
    update T_CSRC0707_C1_1 set E55 = v_content1,K55=v_content2
     where userid=v_bmid and bbq=v_P001;


    update T_CSRC0707_C1_1 set E56 = nvl(E52,0)+nvl(E53,0)+nvl(E54,0)+nvl(E55,0)
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_BKS_T042 where P001=1080001 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    if(v_count =1) then
         select A002,A008 into v_content1,v_content2 from T_BKS_T042 where P001=1080001 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    end if;
    update T_CSRC0707_C1_1 set E58 = v_content1,K58=v_content2
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_BKS_T042 where P001=1080002 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    if(v_count =1) then
         select A002,A008 into v_content1,v_content2 from T_BKS_T042 where P001=1080002 and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);
    end if;
    update T_CSRC0707_C1_1 set E59 = v_content1,K59=v_content2
     where userid=v_bmid and bbq=v_P001;

    update T_CSRC0707_C1_1 set E60 = nvl(E58,0)+nvl(E59,0)
     where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K42 = (select A099 from t_db_01_020 where p001=10001000
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER))
       where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K43 = (select A099 from t_db_01_020 where p001=10001005
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER))
       where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K44 = (select A099 from t_db_01_020 where p001=10001010
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER))
       where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K45 = (select A099 from t_db_01_020 where p001=10001015
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER))
       where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K46 = (select A099 from t_db_01_020 where p001=10001020
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER))
       where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K47 = (select A099 from t_db_01_020 where p001=10001025
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER) )
       where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K48 = (select A099 from t_db_01_020 where p001=10001030
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER))
       where userid=v_bmid and bbq=v_P001;

     update T_CSRC0707_C1_1 set K49 = (select A099 from t_db_01_020 where p001=10001035
            and a100 in (select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
            and w100 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER))
       where userid=v_bmid and bbq=v_P001;

     commit;
    exception when others then
              errcode := 0;
              errmsg :='ڴ洢krcs_makereport_1120010!';
              update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120010 and a008=v_bmid;
              return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120040
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1120040(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2, v_TASK varchar2,v_P001 varchar2, v_P002 varchar2, v_P003 varchar2,v_type varchar2)
is
    V_temp varchar(256);
    V_USERID VARCHAR2(19);
    V_C2  NUMBER ;
    V_C3  NUMBER ;
    V_C4  NUMBER ;
    V_C5  NUMBER ;
    V_C6  VARCHAR2(256) ;
    V_C7  VARCHAR2(256) ;
    V_C8  VARCHAR2(101);
    V_C9  VARCHAR2(101);
    V_C10 VARCHAR2(101);
    V_C13 NUMBER;
    V_D13  NUMBER;
    V_E13  NUMBER;
    V_C14  NUMBER;
    V_D14  NUMBER;
    V_E14  NUMBER;
    V_C15  NUMBER;
    V_D15  NUMBER;
    V_E15  NUMBER;
    V_C16  NUMBER;
    V_D16  NUMBER;
    V_E16  NUMBER;
    V_C17  NUMBER;
    V_D17  NUMBER;
    V_E17  NUMBER;
    v_count number;
    v_status number;
    v_orgid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from krcs.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    select p002 into v_orgid from krcs.T_SYS_USER where p001 = v_KJAXUSER;
    delete from T_CSRC0707_C2_1 where BBQ=v_P001 and USERID=V_USERID;

    SELECT count(*) into v_count FROM T_BKS_T003 WHERE P001=substr(v_P001,1,6) and a100 = v_orgid;
    if v_count > 0 then
       SELECT A002,A003,A004,A005 INTO V_C2,V_C3, V_C4, V_C5 FROM T_BKS_T003 WHERE P001=substr(v_P001,1,6) and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T006 where p001=1006110 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A003 INTO V_C6 FROM T_BKS_T006 WHERE  P001 =1006110 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T006 where p001=1006111 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A003 INTO V_C7 FROM T_BKS_T006 WHERE  P001 =1006111 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T006 where p001=1006112 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A003 INTO V_C8 FROM T_BKS_T006 WHERE  P001 =1006112 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T006 where p001=1006113 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A003 INTO V_C9 FROM T_BKS_T006 WHERE  P001 =1006113 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T006 where p001=1006114 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A003 INTO V_C10 FROM T_BKS_T006 WHERE  P001 =1006114 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T013 where p001=1001120210 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A002,A003,A004 INTO  V_C13,V_D13,V_E13 FROM T_BKS_T013 WHERE P001=1001120210 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T013 where p001=1006202 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A002,A003,A004 INTO  V_C14,V_D14,V_E14 FROM T_BKS_T013 WHERE P001=1006202 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T013 where p001=1006203 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A002,A003,A004 INTO  V_C15,V_D15,V_E15 FROM T_BKS_T013 WHERE P001=1006203 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T013 where p001=1006204 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A002,A003,A004 INTO  V_C16,V_D16,V_E16 FROM T_BKS_T013 WHERE P001=1006204 and a100 = v_orgid;
    end if;

    select count(*) into v_count from T_BKS_T013 where p001=1006205 and a100 = v_orgid;
    if v_count > 0  then
       SELECT A002,A003,A004 INTO  V_C17,V_D17,V_E17 FROM T_BKS_T013 WHERE P001=1006205 and a100 = v_orgid;
    end if;
    insert into T_CSRC0707_C2_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,C3,C4,C5,C6,C7,C8,C9,C10,C13,D13,E13,C14,D14,E14,C15,D15,E15,C16,D16,E16,C17,D17,E17)
    VALUES(v_P001,V_USERID,0,'',1,V_C2, V_C3, V_C4, V_C5,TO_NUMBER(V_C6),TO_NUMBER(V_C7),V_C8,V_C9,V_C10,V_C13,V_D13,V_E13,V_C14,V_D14,V_E14,V_C15,V_D15,V_E15,V_C16,V_D16,V_E16,V_C17,V_D17,V_E17);

    if v_type = 'corp' then
       update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1015002 and a008 = v_orgid;
    else
       update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1015002 and a008=V_USERID;
    end if;

    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1015002;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                if v_type = 'corp' then
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1120040 and a008 = v_orgid;/*޸ת״̬ */
                else
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120040 and a008=V_USERID;/*޸ת״̬ */
                end if;
                errcode := 0;
                errmsg := 'ڴ洢krcs_makereport_1120040!Ϊͣҵ̨ʣ';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120060
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120060(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
       v_cflqksm1 varchar(800);     --ط˵
       v_bz1 varchar(800);          --ע
       v_count integer;
       --v_temp varchar(256);
       v_bmid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';
    v_cflqksm1 := '';
    v_bz1 := '';

    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    select count(*) into v_count from t_db_04_006 where p001=1019001 and w100=v_bmid;
    if v_count > 0 then
       select A002 into v_cflqksm1 from t_db_04_006 where p001=1019001 and w100=v_bmid;
    end if;
    select count(*) into v_count from t_db_04_006 where p001=1019002 and w100=v_bmid;
    if v_count > 0 then
       select A002 into v_bz1 from t_db_04_006 where p001=1019002 and w100=v_bmid;
    end if;

    update t_csrc0707_c3_1 set d46 = v_cflqksm1,
                               d47=v_bz1
                           where bbq=v_p001 and USERID=v_bmid;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120060 and a008=v_bmid;
   commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120060 and a008=v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120060!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120070
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120070(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_EP003 number;
    v_EP004 number;
    v_EP005 number;
    v_EP006 number;
    v_EP007 number;
    v_EP008 number;
    v_bmid number;
    v_userid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select a012 into v_bmid from KRCS.T_SYS_USER where p001= v_KJAXUSER;
    delete from T_CSRC0707_C3_2 where BBQ=v_P001 and userid=v_bmid;
    select sum(a003),sum(a004),sum(a005),sum(a006),sum(a007),sum(a008)
           into v_EP003,v_EP004,v_EP005,v_EP006,v_EP007,v_EP008 from t_db_04_007 where w100=v_bmid;
    insert into t_csrc0707_c3_2(bbq,userid,btype,option1,shtag,ishj,a3,b3,c3,d3,e3,f3,g3,h3,i3)
           select v_p001,v_bmid,0,null,1,0,rownum,p001,a002,a003,a004,a005,a006,a007,a008 from t_db_04_007 where w100=v_bmid;
    insert into t_csrc0707_c3_2(bbq,userid,btype,option1,shtag,ishj,a3,d3,e3,f3,g3,h3,i3)
           values (v_p001,v_bmid,0,null,null,1,null,v_EP003,v_EP004,v_EP005,v_EP006,v_EP007,v_EP008);

/*    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120070;*/
    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120070 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1120070;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1120070;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120070!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120080
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120080(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_counter integer;
    v_count  number(19,2);        --
    v_planid varchar(26);        --ƻid
    v_planname varchar(256);--ƻ
    v_bmid number;

    ---Ʒ---
    v_xh     number;         --
    v_xm_1   number;         --Ŀתǰid
    v_xm_11  varchar(30);    --Ŀתid
    v_xm_2   number;         --Ŀתǰid
    v_xm_22  varchar(30);    --Ŀתid
    v_slrq   date;           --
    v_tzzbr  varchar(100);   --Ͷ
    v_tgr    varchar(100);   --й
    v_fedjjg varchar(100);   --ݶǼǻ
    v_dltgjg varchar(100);   --ƹ
    v_zdcyje number(18,2);   --Ͳ
    v_glfl   number(18,2);   --
    v_tgfl   number(18,2);   --йܷ
    v_qmzyzjje number(18,2);  --ĩʽʽͶ
    v_cdzyzjje number(18,2);  --ʽгеεʽ

    ---ĩͻ---
    v_qrkh   number(18,2);    --˿ͻ
    v_jgkh   number(18,2);    --ͻ
    v_khhj   number(18,2);    --ϼ

    ---ʽ---
    v_qcje   number(18,2);    --ڳ
    v_bqzj   number(18,2);    --
    v_bqjs   number(18,2);    --ڼ
    --v_bnlj   number(18,2);    --ۼ
    v_qmje   number(18,2);    --ĩ
    v_grkhje number(18,2);    --и˿ͻ
    v_jgkhje number(18,2);    --лͻ

    --ֵ
    v_qcdwjz   number(18,4);  --ڳλֵ
    v_qmdwjz   number(18,4);  --ĩλֵ
    v_ljdwpxe  number(18,4);  --ۼƵλֶ
    v_ljdwjz   number(18,4);  --ۼƵλֵ
    v_orgid number;

    /*ʲҵ,ƻα*/
    cursor c_work_plan is
      select t.a002 From t_b04_t011 t where t.b001=1002001 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
      order by t.p001;

begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    select p002 into v_orgid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    v_xh :=0;--ʼֵ

    delete from T_CSRC0128_C4_1 where BBQ=v_P001 and USERID=v_bmid;

    open c_work_plan;
      fetch c_work_plan into v_planid;
      while c_work_plan%found
      loop
           ---õƷϢ---
           select a.a003,a.f004,b.a003,a.f005,c.a003,a.a004,a.a005,a.a006,a.a007,a.a008,a.a009,a.a010,a.a011,a.a012,a.a013
             into v_planname,v_xm_1,v_xm_11,v_xm_2,v_xm_22,v_slrq,v_tzzbr,v_tgr,v_fedjjg,v_dltgjg,v_zdcyje,v_glfl,v_tgfl,v_qmzyzjje,v_cdzyzjje
           from t_b04_t011 a,
           (select * from T_B04_D011 where b099='LX1')b,
           (select * from T_B04_D011 where b099='LX2')c
           where a.f004=b.p001 and a.f005=c.p001
           and a.a100 = v_orgid
           and a.A002 = v_planid;

           ---ĩͻ----
           --˿ͻ
           select count(v) into v_count
           from T_B04_F101
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004701
                 and w100 = v_bmid;
           v_qrkh := 0;
           if v_count > 0 then
             select v into v_qrkh
             from T_B04_F101
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004701
                   and w100 = v_bmid;
           end if;
           --ͻ
           select count(v) into v_count
           from T_B04_F101
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004702
                 and w100 = v_bmid;
           v_jgkh := 0;
           if v_count > 0 then
             select v into v_jgkh
             from T_B04_F101
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004702
                   and w100 = v_bmid;
           end if;
           --ϼ
           select count(v) into v_count
           from T_B04_F101
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004703
                 and w100 = v_bmid;
           v_khhj := 0;
           if v_count > 0 then
             select v into v_khhj
             from T_B04_F101
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004703
                   and w100 = v_bmid;
           end if;

           ---ʽ----
           --ڳ
           select count(v) into v_count
           from T_B04_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004801
                 and w100 = v_bmid;
           v_qcje := 0;
           if v_count > 0 then
             select v into v_qcje
             from T_B04_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004801
                   and w100 = v_bmid;
           end if;
           --
           select count(v) into v_count
           from T_B04_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004802
                 and w100 = v_bmid;
           v_bqzj := 0;
           if v_count > 0 then
             select v into v_bqzj
             from T_B04_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004802
                   and w100 = v_bmid;
           end if;
           --ڼ
           select count(v) into v_count
           from T_B04_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004803
                 and w100 = v_bmid;
           v_bqjs := 0;
           if v_count > 0 then
             select v into v_bqjs
             from T_B04_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004803
                   and w100 = v_bmid;
           end if;
           /*--ۼ
           select count(v) into v_count
           from T_B04_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004804
                 and w100 = v_bmid;
           v_bnlj := 0;
           if v_count > 0 then
             select v into v_bnlj
             from T_B04_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004804
                   and w100 = v_bmid;
           end if;*/

           /*select count(*) into v_count
           from T_DB_05_102
           where p001 = v_planid
           and w100 = v_bmid;
           v_bnlj := 0;
           if v_count > 0 then
           select nvl(a003,0)+nvl(a004,0) into v_bnlj
           from T_DB_05_102
           where p001 = v_planid
            and w100 = v_bmid;
           end if;*/
           --ĩ
           select count(v) into v_count
           from T_B04_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004805
                 and w100 = v_bmid;
           v_qmje := 0;
           if v_count > 0 then
             select v into v_qmje
             from T_B04_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004805
                   and w100 = v_bmid;
           end if;
           --и˿ͻ
           select count(v) into v_count
           from T_B04_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004806
                 and w100 = v_bmid;
           v_grkhje := 0;
           if v_count > 0 then
             select v into v_grkhje
             from T_B04_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004806
                   and w100 = v_bmid;
           end if;
           --лͻ
           select count(v) into v_count
           from T_B04_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004807
                 and w100 = v_bmid;
           v_jgkhje := 0;
           if v_count > 0 then
             select v into v_jgkhje
             from T_B04_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004807
                   and w100 = v_bmid;
           end if;

           ----- ֵ -----
           --ڳλֵ
           select count(v) into v_count
           from T_B04_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004901
                 and w100 = v_bmid;
           v_qcdwjz := 0;
           if v_count > 0 then
             select v into v_qcdwjz
             from T_B04_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004901
                   and w100 = v_bmid;
           end if;
           --ĩλֵ
           select count(v) into v_count
           from T_B04_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004902
                 and w100 = v_bmid;
           v_qmdwjz := 0;
           if v_count > 0 then
             select v into v_qmdwjz
             from T_B04_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004902
                   and w100 = v_bmid;
           end if;
           --ۼƵλֶ
           select count(v) into v_count
           from T_B04_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004903
                 and w100 = v_bmid;
           v_ljdwpxe := 0;
           if v_count > 0 then
             select v into v_ljdwpxe
             from T_B04_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004903
                   and w100 = v_bmid;
           end if;
           --ۼƵλֵ
           select count(v) into v_count
           from T_B04_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004904
                 and w100 = v_bmid;
           v_ljdwjz := 0;
           if v_count > 0 then
             select v into v_ljdwjz
             from T_B04_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004904
                   and w100 = v_bmid;
           end if;
        v_xh :=v_xh+1;
        --вֵ
        insert into T_CSRC0128_C4_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,
           O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3)
        values(v_P001,v_bmid,0,null,1,0,
           v_xh,v_planname,v_xm_11,v_xm_22,v_slrq,v_tzzbr,v_tgr,v_fedjjg,v_dltgjg,v_zdcyje,v_glfl,v_tgfl,
           v_qrkh,v_jgkh,v_khhj,
           v_qcje,v_bqzj,v_bqjs,v_qmje,v_grkhje,v_jgkhje,v_qmzyzjje,v_cdzyzjje,
           v_qcdwjz,v_qmdwjz,v_ljdwpxe,v_ljdwjz
           );

           fetch c_work_plan into v_planid;

      end loop;
    close c_work_plan;

    --ϼֵ
    insert into T_CSRC0128_C4_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3)
    select v_P001,v_bmid,0,null,null,1,
    sum(J3),sum(K3),sum(L3),sum(M3),sum(N3),sum(O3),sum(P3),sum(Q3),
    sum(R3),sum(S3),sum(T3),sum(U3),sum(V3),sum(W3),sum(X3),sum(Y3),sum(Z3),sum(AA3)
      from T_CSRC0128_C4_1
     where BBQ=v_P001 and USERID=v_bmid and ISHJ=0;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120080 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1120080;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120080 and a008=v_bmid; -- \*޸ת״̬ *\
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120080!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120090
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120090(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_counter integer;
    v_count  number(19,2);       --
    v_planid varchar(26);        --ƻid
    v_planname varchar(256);     --ƻ
    v_bmid number;

    ---Ʒ---
    v_xh     number;         --
    v_xm_1   number;         --Ŀתǰid
    v_xm_11  varchar(30);    --Ŀתid

    v_hzje   number(18,2);           --׼
    v_xmzbr  varchar(100);   --Ŀ
    v_llr    varchar(100);   --
    v_slrq date;     --
    v_dqr date;      --
    v_sypz number(18,2);     --ƾ֤Ԥ
    v_cszxdj  varchar(100);                       --ʼŵȼ
    v_bgqmzxdj  varchar(100);    --ĩŵȼ
    v_dbjg   varchar(100);   --
    v_dbxs varchar(100);  --ʽ
    v_zyzjje number(18,2);  --УƷʱʽͶ
    v_bz    varchar(255);   --ע

    ---ĩͻ---
    v_grkh   number(18,2);    --˿ͻ
    v_jgkh   number(18,2);    --ͻ
    v_khhj   number(18,2);    --ϼ

    ---ʵʷйģԪ---
    v_fe   number(18,2);    --ݶ
    v_grkhje   number(18,2);    --˿ͻ
    v_jgkhje   number(18,2);    --ͻ
    v_zje   number(18,2);    --ܽ
    v_zyzjbgqmye number(18,2);    --ʽ𱨸ĩ


    --Ʒֽռ֧
    v_bqssje   number(18,2);  --ʵս
    v_bqysje   number(18,2);  --Ӧս
    v_ljssje  number(18,2);  --ۼʵս
    v_ljysje   number(18,2);  --ۼӦս
    v_ljyfzje   number(18,2);  --ƷۼӦܽ
    v_bj  number(18,2);  --У
    v_cjsypz   number(18,2);  --Уμƾ֤ӦӦ

    v_orgid number;
    --  update by zhouly  20130828  ˺ͲID

    /*ʲҵ,ƻα*/
    cursor c_work_plan is
      select t.p002 From t_b05_t011 t where t.b001=1002001
            and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
      order by t.p001;

begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    select p002 into v_orgid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    v_xh :=0;--ʼֵ

    delete from T_CSRC0128_C4_2 where BBQ=v_P001 and USERID=v_bmid;

    open c_work_plan;
      fetch c_work_plan into v_planid;
      while c_work_plan%found
      loop
           ---õƷϢ---
           select a.a003,a.a002,b.a003,a.a004,a.a005,a.a006,a.a007,a.a008,a.a009,a.a010,a.a011,a.a012,a.a013,a.a014,a.a099
             into v_planname,v_xm_1,v_xm_11,v_hzje,v_xmzbr,v_llr,v_slrq,v_dqr,v_sypz,v_cszxdj,v_bgqmzxdj,v_dbjg,v_dbxs,v_zyzjje,v_bz
           from t_b05_t011 a,
           (select * from T_B05_D001 ) b
           where a.a002=b.p001
           and a.p002=v_planid
           and a.a100 = v_orgid;

           ---ĩͻ----
           --˿ͻ
           select count(v) into v_count
           from T_B05_F101
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1001
                 and w100 = v_bmid;
           v_grkh := 0;
           if v_count > 0 then
             select v into v_grkh
             from T_B05_F101
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1001
                   and w100 = v_bmid;
           end if;
           --ͻ
           select count(v) into v_count
           from T_B05_F101
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1002
                 and w100 = v_bmid;
           v_jgkh := 0;
           if v_count > 0 then
             select v into v_jgkh
             from T_B05_F101
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1002
                   and w100 = v_bmid;
           end if;
           --ϼ
           select count(v) into v_count
           from T_B05_F101
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1003
                 and w100 = v_bmid;
           v_khhj := 0;
           if v_count > 0 then
             select v into v_khhj
             from T_B05_F101
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1003
                   and w100 = v_bmid;
           end if;

           ---ʽ----
           --ݶ
           select count(v) into v_count
           from T_B05_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1001
                 and w100 = v_bmid;
           v_fe := 0;
           if v_count > 0 then
             select v into v_fe
             from T_B05_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1001
                   and w100 = v_bmid;
           end if;
           --˿ͻ
           select count(v) into v_count
           from T_B05_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1002
                 and w100 = v_bmid;
           v_grkhje := 0;
           if v_count > 0 then
             select v into v_grkhje
             from T_B05_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1002
                   and w100 = v_bmid;
           end if;
           --ͻ
           select count(v) into v_count
           from T_B05_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1003
                 and w100 = v_bmid;
           v_jgkhje := 0;
           if v_count > 0 then
             select v into v_jgkhje
             from T_B05_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1003
                   and w100 = v_bmid;
           end if;

           --ܽ
           select count(v) into v_count
           from T_B05_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004
                 and w100 = v_bmid;
           v_zje := 0;
           if v_count > 0 then
             select v into v_zje
             from T_B05_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004
                   and w100 = v_bmid;
           end if;
           --ʽ𱨸ĩ
           select count(v) into v_count
           from T_B05_F102
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005
                 and w100 = v_bmid;
           v_zyzjbgqmye := 0;
           if v_count > 0 then
             select v into v_zyzjbgqmye
             from T_B05_F102
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005
                   and w100 = v_bmid;
           end if;



           ----- Ʒֽռ֧ -----
           --ʵս
           select count(v) into v_count
           from T_B05_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1001
                 and w100 = v_bmid;
           v_bqssje := 0;
           if v_count > 0 then
             select v into v_bqssje
             from T_B05_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1001
                   and w100 = v_bmid;
           end if;
           --Ӧս
           select count(v) into v_count
           from T_B05_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1002
                 and w100 = v_bmid;
           v_bqysje := 0;
           if v_count > 0 then
             select v into v_bqysje
             from T_B05_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1002
                   and w100 = v_bmid;
           end if;
           --ۼʵս
           select count(v) into v_count
           from T_B05_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1003
                 and w100 = v_bmid;
           v_ljssje := 0;
           if v_count > 0 then
             select v into v_ljssje
             from T_B05_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1003
                   and w100 = v_bmid;
           end if;
           --ۼӦս
           select count(v) into v_count
           from T_B05_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1004
                 and w100 = v_bmid;
           v_ljysje := 0;
           if v_count > 0 then
             select v into v_ljysje
             from T_B05_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1004
                   and w100 = v_bmid;
           end if;
           --ƷۼӦܽ
           select count(v) into v_count
           from T_B05_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005
                 and w100 = v_bmid;
           v_ljyfzje := 0;
           if v_count > 0 then
             select v into v_ljyfzje
             from T_B05_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005
                   and w100 = v_bmid;
           end if;
           --У
           select count(v) into v_count
           from T_B05_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1006
                 and w100 = v_bmid;
           v_bj := 0;
           if v_count > 0 then
             select v into v_bj
             from T_B05_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1006
                   and w100 = v_bmid;
           end if;
           --Уμƾ֤ӦӦ
           select count(v) into v_count
           from T_B05_F103
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1007
                 and w100 = v_bmid;
           v_cjsypz := 0;
           if v_count > 0 then
             select v into v_cjsypz
             from T_B05_F103
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1007
                   and w100 = v_bmid;
           end if;
        v_xh :=v_xh+1;



        --вֵ
        insert into T_CSRC0128_C4_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,
           O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3,AB3,AC3)
        values(v_P001,v_bmid,0,null,1,0,
           v_xm_11,v_planname,v_hzje,v_xmzbr,v_llr,v_slrq,v_dqr,v_sypz,v_grkh,v_jgkh,v_khhj,v_cszxdj,v_bgqmzxdj,v_dbjg,v_dbxs,
           v_fe,v_grkhje,v_jgkhje,v_zje,v_zyzjje,v_zyzjbgqmye,v_bqssje,v_bqysje,v_ljssje,v_ljysje,v_ljyfzje,v_bj,v_cjsypz,v_bz
           );

           fetch c_work_plan into v_planid;

      end loop;
    close c_work_plan;

    --ϼֵ
    insert into T_CSRC0128_C4_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           c3,i3,j3,k3,p3,q3,r3,s3,t3,U3,V3,W3,X3,Y3,z3,Aa3,Ab3)
    select v_P001,v_bmid,0,null,null,1,
      sum(c3),sum(i3),sum(j3),sum(k3),sum(p3),sum(q3),sum(r3),sum(s3),sum(t3),sum(U3),sum(V3),sum(W3),sum(X3),sum(Y3),sum(z3),sum(Aa3),sum(Ab3)
      from T_CSRC0128_C4_2
     where BBQ=v_P001 and USERID=v_bmid and ISHJ=0;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120090 and a008 = v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp
    FROM KRCS.T_SYS_T004 WHERE P001 = 1120090;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120090 and a008 = v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120090!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120100
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120100(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)

   is
    v_temp        varchar(256);
    v_content1    varchar(256);
    v_content2    varchar(256);
    v_content3    varchar(256);
    v_count       number;
    v_bmid number;
      v_orgid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';
      select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
      select p002 into v_orgid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID



    v_content1 := '';
    v_content2 := '';
    v_content3 := '';
    select count(*) into v_count from T_B06_T012 where P001=10 and a100 = v_orgid;
    if(v_count =1) then
         select A002,A003,A004 into v_content1,v_content2,v_content3 from T_B06_T012 where P001 =10 and a100 = v_orgid;
    end if;
    update T_CSRC0128_C4_3 set B14 = v_content1,E14=v_content2,H14=v_content3
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    v_content3 := '';
    select count(*) into v_count from T_B06_T012 where P001=20 and a100 = v_orgid;
    if(v_count =1) then
         select A002,A003,A004 into v_content1,v_content2,v_content3 from T_B06_T012 where P001 =20 and a100 = v_orgid;
    end if;
    update T_CSRC0128_C4_3 set B15 = v_content1,E15=v_content2,H15=v_content3
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    v_content3 := '';
    select count(*) into v_count from T_B06_T012 where P001=30 and a100 = v_orgid;
    if(v_count =1) then
         select A002,A003,A004 into v_content1,v_content2,v_content3 from T_B06_T012 where P001 =30 and a100 = v_orgid;
    end if;
    update T_CSRC0128_C4_3 set B16 = v_content1,E16=v_content2,H16=v_content3
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    v_content3 := '';
    select count(*) into v_count from T_B06_T012 where P001=40 and a100 = v_orgid;
    if(v_count =1) then
         select A002,A003,A004 into v_content1,v_content2,v_content3 from T_B06_T012 where P001 =40 and a100 = v_orgid;
    end if;
    update T_CSRC0128_C4_3 set B17 = v_content1,E17=v_content2,H17=v_content3
    where userid=v_bmid and bbq=v_P001;

     commit;
    exception when others then
              errcode := 0;
              errmsg :='ڴ洢CISP_MAKEREPORT_1120100!';
              update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120100 and a008=v_bmid;
              return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120110
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120110(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp        varchar(256);
    v_content1    varchar(128);
    v_count       number;
    --v_userid      integer;
    v_bmid number;
    /**
         ҵ
           ϢҪݱȡ,Ҫڴ洢д
    **/
begin
    errcode:=1;
    errmsg := 'ɱɹ';
    v_content1 := '';

    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID

    /*
    SELECT T2.A002 into v_userid
    FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
    WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;
    */
    v_content1 := '';
    select count(*) into v_count from T_DB_08_001 where P001=1001 and w100=v_bmid;
    if(v_count =1) then
         select A008 into v_content1 from T_DB_08_001 where P001=1001 and w100=v_bmid;
    end if;
    update T_CSRC0707_C5_1 set J3 = v_content1
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    select count(*) into v_count from T_DB_08_001 where P001=1002 and w100=v_bmid;
    if(v_count =1) then
         select A008 into v_content1 from T_DB_08_001 where P001=1002 and w100=v_bmid;
    end if;
    update T_CSRC0707_C5_1 set J4 = v_content1
     where userid=v_bmid and bbq=v_P001;


    v_content1 := '';
    select count(*) into v_count from T_DB_08_001 where P001=1003 and w100=v_bmid;
    if(v_count =1) then
         select A008 into v_content1 from T_DB_08_001 where P001=1003 and w100=v_bmid;
    end if;
    update T_CSRC0707_C5_1 set J5 = v_content1
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    select count(*) into v_count from T_DB_08_001 where P001=1004 and w100=v_bmid;
    if(v_count =1) then
         select A008 into v_content1 from T_DB_08_001 where P001=1004 and w100=v_bmid;
    end if;

    update T_CSRC0707_C5_1 set J6 = v_content1
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    select count(*) into v_count from T_DB_08_001 where P001=1005 and w100=v_bmid;
    if(v_count =1) then
         select A008 into v_content1 from T_DB_08_001 where P001=1005 and w100=v_bmid;
    end if;
    update T_CSRC0707_C5_1 set J7 = v_content1
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    select count(*) into v_count from T_DB_08_001 where P001=1006 and w100=v_bmid;
    if(v_count =1) then
         select A008 into v_content1 from T_DB_08_001 where P001=1006 and w100=v_bmid;
    end if;
    update T_CSRC0707_C5_1 set J8 = v_content1
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    select count(*) into v_count from T_DB_08_001 where P001=1007 and w100=v_bmid;
    if(v_count =1) then
         select A008 into v_content1 from T_DB_08_001 where P001=1007 and w100=v_bmid;
    end if;
    update T_CSRC0707_C5_1 set J9 = v_content1
     where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    select count(*) into v_count from T_DB_08_002 where w100=v_bmid;
    if(v_count = 1) then
        select a002 into v_content1 from T_DB_08_002 where w100=v_bmid;
    end if;

    update T_CSRC0707_C5_1
    set D11 = v_content1
    where userid=v_bmid and bbq=v_P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120110 and a008=v_bmid;
    commit;
    exception when others then
              errcode := 0;
              errmsg :='ڴ洢CISP_MAKEREPORT_1120110!';
              update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120110 and a008=v_bmid;
              return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120120
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120120(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_A2 number; v_A3 number; v_A4 number; v_A5 number;
    v_B2 number; v_B3 number; v_B4 number; v_B5 number;
    v_C2 number; v_C3 number; v_C4 number; v_C5 number;
    v_D2 number; v_D3 number; v_D4 number; v_D5 number;
    v_E1 number; v_E2 number; v_E3 number; v_E4 number;
    v_E5 number; v_E6 number; v_E7 number; v_E8 number;
    v_E9 number; v_E10 number; v_E11 number; v_E12 number;
    v_status number;
    v_orgid number;
begin
   errcode:=1;
    errmsg := 'ɱɹ';

    select to_char(a.a012) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    select p002 into v_orgid from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    delete from T_CSRC0707_C6_1 where BBQ=v_P001 and userid = v_userid;
    /*SELECT T2.A002 into v_userid FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;*/

    select sum(a002),sum(a003),sum(a004),sum(a005) into v_A2,v_A3,v_A4,v_A5 from t_bks_t004 where p001=1028001 and a100 = v_orgid;
    select sum(a002),sum(a003),sum(a004),sum(a005) into v_B2,v_B3,v_B4,v_B5 from t_bks_t004 where p001=1028002 and a100 = v_orgid;
    select sum(a002),sum(a003),sum(a004),sum(a005) into v_C2,v_C3,v_C4,v_C5 from t_bks_t004 where p001=1028003 and a100 = v_orgid;
    select sum(a002),sum(a003),sum(a004),sum(a005) into v_D2,v_D3,v_D4,v_D5 from t_bks_t004 where p001=1028004 and a100 = v_orgid;
    select sum(a006) into v_E1 from t_bks_t001 where a004=1001 and a005=1013100 and a100 = v_orgid;
    select sum(a006) into v_E2 from t_bks_t001 where a004=1001 and a005=1013101 and a100 = v_orgid;
    select sum(a006) into v_E3 from t_bks_t001 where a004=1001 and a005=1013102 and a100 = v_orgid;
    select sum(a006) into v_E4 from t_bks_t001 where a004=1001 and a005=1013199 and a100 = v_orgid;
    select sum(a006) into v_E5 from t_bks_t001 where a004=1002 and a005=1013100 and a100 = v_orgid;
    select sum(a006) into v_E6 from t_bks_t001 where a004=1002 and a005=1013101 and a100 = v_orgid;
    select sum(a006) into v_E7 from t_bks_t001 where a004=1002 and a005=1013102 and a100 = v_orgid;
    select sum(a006) into v_E8 from t_bks_t001 where a004=1002 and a005=1013199 and a100 = v_orgid;
    select sum(a006) into v_E9 from t_bks_t001 where a004=1003 and a005=1013100 and a100 = v_orgid;
    select sum(a006) into v_E10 from t_bks_t001 where a004=1003 and a005=1013101 and a100 = v_orgid;
    select sum(a006) into v_E11 from t_bks_t001 where a004=1003 and a005=1013102 and a100 = v_orgid;
    select sum(a006) into v_E12 from t_bks_t001 where a004=1003 and a005=1013199 and a100 = v_orgid;

    insert into t_csrc0707_c6_1(bbq,userid,btype,option1,shtag,c2,d2,e2,f2,g2,c3,d3,e3,f3,g3,c4,d4,e4,f4,g4,
       c5,d5,e5,f5,g5,c7,d7,e7,f7,c8,d8,e8,f8,c9,d9,e9,f9)
       values(v_P001,v_userid,'0','','0',v_A2,v_B2,v_C2,v_D2,'',v_A3,v_B3,v_C3,v_D3,'',v_A4,v_B4,v_C4,v_D4,'',v_A5,v_B5,v_C5,v_D5,'',
              v_E1,v_E2,v_E3,v_E4,v_E5,v_E6,v_E7,v_E8,v_E9,v_E10,v_E11,v_E12);


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120120 and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C6-1'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1120120;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120120 and a008=V_USERID;/*޸ת״̬ */

                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120120!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120130
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120130(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2,v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    begintime varchar2(8);
    endtime varchar2(8);
    v_status number;
    v_orgid number;
begin
   errcode:=1;
    errmsg := 'ɱɹ';

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    select p002 into v_orgid from KRCS.T_SYS_USER where p001 = v_KJAXUSER;
    delete from T_CSRC0707_C6_1_1 where BBQ=v_P001 and userid = v_userid;


    select TO_CHAR(a005,'YYYYMMDD'),TO_CHAR(a006,'YYYYMMDD') into begintime,endtime
    from t_b00_d004
    where a002=1013001 and c001=1001101 and d100=1006002;

    insert into t_csrc0707_c6_1_1(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2)
           select v_p001,v_userid,'0','','0','0',rownum,a006,a007||'-'||a008,a011,a012
           from t_bks_t002
           where a010=1001 and TO_CHAR(a003,'YYYYMMDD') between begintime and endtime and p002 = v_orgid;

    if v_type = 'corp' then
     update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120130 and a008 = v_orgid;
    else
    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120130 and a008=V_USERID;
    end if;

    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C6-1-1'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1120130;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                if v_type = 'corp' then
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1120130;/*޸ת״̬ */
                else
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120130 and a008=V_USERID;/*޸ת״̬ */
                end if;
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120130!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120170
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120170(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    --v_USER integer;
    v_bmid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    delete from T_CSRC0707_C8_1_1 where BBQ=v_P001 and userid=v_bmid;

    /*SELECT T2.A002 into v_USER
    FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
    WHERE T1.P001 = v_KJAXUSER
      AND T1.P002 = T2.P001;*/

    insert into t_csrc0707_c8_1_1(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2)
      select v_p001,v_bmid,0,NULL,1,0,t1.xm,t1.qc,t1.bqzj,t1.bqjs,t1.qmye,t1.bnlj
      from (select a.p002 as xm,
                     sum(case  when a.p003=1008001 then a.v else 0 end) qc,
                     sum(case  when a.p003=1008002 then a.v else 0 end) bqzj,
                     sum(case  when a.p003=1008003 then a.v else 0 end) bqjs,
                     sum(case  when a.p003=1008004 then a.v else 0 end) qmye,
                     sum(case  when a.p003=1008005 then a.v else 0 end) bnlj
              from t_b08_f002 a/*,t_b08_d002 b*/
              where /*a.p002=b.p001 and */a.p001=substr(v_p001,0,6)
              and a.w100=v_bmid
              group by a.p001,a.p002) t1;

    insert into t_csrc0707_c8_1_1(bbq,userid,btype,option1,shtag,ishj,b2,c2,d2,e2,f2)
      select v_p001,v_bmid,0,NULL,NULL,1,sum(b2),sum(c2),sum(d2),sum(e2),sum(f2)
      from t_csrc0707_c8_1_1 where BBQ = v_p001 and userid=v_bmid;
    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120170 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1120170;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120170 and a008=v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120170!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120180
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120180(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
   --v_userid number;
   v_EP001  number;
   v_count number;
   v_id     number;--Ȩ֤ID
   v_lx     number;--Ȩ֤
   v_lx1    number;--Ȩ֤(Ϲ)
   v_dm     varchar(32);--Ȩ֤
   v_jc     varchar(128);--Ȩ֤
   v_ljzl   number(19,2);--ۼȨ֤
   v_ljzxzl number(19,2);--ۼȨ֤ע
   v_bqzxl  number(19,2);--Ȩ֤ע
   v_ljdqzl number(19,2);--ۼȨ֤
   v_qmsyl  number(19,2);--ĩȨ֤ʣ
   v_qmssz  number(19,2);--ĩʣȨֵ֤
   v_dsx    number(19,2);--ĩʣȨ֤루ʵ֣
   v_zgcyl  number(19,2);--ĩɳ
   v_spzsc  number(19,2);--ĩֵ
   v_zcb    number(19,2);--ĩܳɱ
   v_zyzj   number(19,2);--ĩϹȨ֤ռʽ
   v_fdyk   number(19,2);--ĩɸӯ
   v_qzfdyk number(19,2);--Ȩ֤ӯ(̼ע)
   v_zfdyk  number(19,2);--ܸӯ
   v_sxsy   number(19,2);--Ȩ֤ۼʵ
   v_bnlj_sxsy number(19,2);--УȨ֤ۼʵ
   v_num number;
   v_bmid number;


    cursor c_work is
       select distinct p002 from t_b09_f001 where p001 = substr(v_P001,0,6)
       and w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER);
begin
   errcode:=1;
    errmsg := 'ɱɹ';
    v_num:=0;
     select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
     delete from T_CSRC0707_C9_1 where BBQ=v_P001 and userid=v_bmid;
    /* SELECT T2.A002 into v_userid FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;*/
      open c_work;
      fetch c_work into v_EP001;
      while c_work%found
      loop
  --ǫ̃лϢ
       select p001,a004,(case a004 when 1001 then '1' else '2' end),a002,a003 into v_id,v_lx,v_lx1,v_dm,v_jc
         from t_b09_t002
        where p001=v_EP001 and a100 =(select p002 from KRCS.T_SYS_USER where p001 =v_KJAXUSER);
  --ۼȨ֤
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009001
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_ljzl
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009001
          and w100 = v_bmid;
       end if;
 --ۼȨ֤ע
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009002
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_ljzxzl
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009002
          and w100 = v_bmid;
       end if;
  --УȨ֤ע
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009003
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_bqzxl
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009003
          and w100 = v_bmid;
       end if;
  --ۼȨ֤
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009004
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_ljdqzl
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009004
          and w100 = v_bmid;
       end if;
  --ĩȨ֤ʣ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009005
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_qmsyl
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009005
          and w100 = v_bmid;
       end if;
  --ĩʣȨֵ֤
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009006
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_qmssz
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009006
          and w100 = v_bmid;
       end if;
  --ĩʣȨ֤루ʵ֣
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009007
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_dsx
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009007
          and w100 = v_bmid;
       end if;
   --ĩɳ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009008
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_zgcyl
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009008
          and w100 = v_bmid;
       end if;
    --ĩֵ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009009
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_spzsc
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009009
          and w100 = v_bmid;
       end if;
     --ĩܳɱ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009010
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_zcb
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009010
          and w100 = v_bmid;
       end if;
     --ĩϹȨ֤ռʽ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009011
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_zyzj
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009011
          and w100 = v_bmid;
       end if;
     --ĩɸӯ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009012
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_fdyk
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009012
          and w100 = v_bmid;
       end if;
     --Ȩ֤ӯ(̼ע)
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009013
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_qzfdyk
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009013
          and w100 = v_bmid;
       end if;
    --ܸӯ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009014
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_zfdyk
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009014
          and w100 = v_bmid;
       end if;
    --Ȩ֤ۼʵ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009015
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_sxsy
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009015
          and w100 = v_bmid;
       end if;
     --УȨ֤ۼʵ
       select count(v) into v_count
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009016
          and w100 = v_bmid;

       if v_count > 0 then
       select v into v_bnlj_sxsy
         from T_B09_F001
        where p001 = substr(v_P001,0,6)
          and p002 = v_id
          and p003 = 1009016
          and w100 = v_bmid;
       end if;
       v_num:=v_num+1;
     insert into T_CSRC0707_C9_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A4,B4,C4,D4,
          E4,F4,G4,H4,I4,J4,K4,L4,M4,N4,O4,P4,Q4,R4,S4,T4)
     values(v_P001,v_bmid,0,null,0,0,v_lx1,v_num,v_dm,v_jc,v_ljzl,v_ljzxzl,v_bqzxl,
     v_ljdqzl,v_qmsyl,v_qmssz,v_dsx,v_zgcyl,v_spzsc,v_zcb,v_zyzj,v_fdyk,v_qzfdyk,v_zfdyk,
     v_sxsy,v_bnlj_sxsy);
      fetch c_work into v_EP001;
      end loop;
    close c_work;
--ϼ
 insert into T_CSRC0707_C9_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    E4,F4,G4,H4,I4,J4,K4,L4,M4,N4,O4,P4,Q4,R4,T4)
    select v_P001,v_bmid,0,null,null,1,
    sum(E4),sum(F4),sum(G4),sum(H4),sum(I4),sum(J4),sum(K4),sum(L4),sum(M4),
    sum(N4),sum(O4) ,sum(P4),sum(Q4),sum(R4),sum(T4)
 from T_CSRC0707_C9_1 where BBQ=v_P001 and USERID=v_bmid and ISHJ=0;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120180 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1120180;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120180 and a008=v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120180!';
                return;
 end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120190
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120190(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);

  v_date number;
  --v_EP004 varchar(64);
  v_USER  integer;
  v_bmid  number;

begin
  errcode := 1;
  errmsg  := 'ɱɹ';


  select a012 into v_bmid from KRCS.T_SYS_USER where p001 = v_KJAXUSER; --ȡID
   select P001 into v_date FROM T_B00_D004 WHERE C001=1001101 and A002=1013001;


   select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --뱸ע
  update t_Csrc1212_C10_1 t set t.B46=(select a001 from t_db_30_002 t1 where w100 in (select a012 from KRCS.T_SYS_USER where p001 =v_KJAXUSER))
  where t.bbq=v_date||'--' and t.userid=v_bmid;
  commit;

  update KRCS.T_SYS_T024
     SET A010 = 1015001
   WHERE P001 = 1120190
     and a008 = v_bmid;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>' || A004 || ''
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1120190;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;
exception
  when others then
    rollback;
    update KRCS.T_SYS_T024
       SET A010 = 1015002
     WHERE P001 = 1120190
       and a008 = v_bmid; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1120190!';
    return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120200
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120200(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_comp1 varchar(101);           --ȫʱʵʣعڻ˾
    v_comp2 varchar(101);           --мܵڻ˾
    v_comp1_ varchar(101);          --ȫʱʵʣعڻ˾
    v_comp2_ varchar(101);          --мܵڻ˾
    v_status number;
    v_userid number;
     v_orgid number;
     --v_bmid number;

    --̨ʱ
    --ֱȫʱʵʣعڻ˾ t_b11_t001  ṩмܵڻ˾ t_b11_t003Ч
    cursor cur_work1 is
         select A002
           from t_b11_t001
          where B001 = '1002001'
            and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
    cursor cur_work2 is
         select A002
           from t_b11_t003
          where B001 = '1002001'
            and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER);
/*Ϊڻ˾ṩмҵܱ update by liangns 2008-01-18*/
begin

    --ִд洢ǰѾиxmlCSRCв¼ڴ洢ֻ¼¼
    SELECT P002 into v_orgid FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER;  --  ˻ID

    errcode:=1;
    errmsg := 'ɱɹ';
    v_comp1_ := '';
    v_comp2_ := '';


    select to_char(a.a012) into v_userid
    from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    --Ȼȡ˾¼CSRC
    open cur_work1;
    fetch cur_work1 into v_comp1;
    while cur_work1%found
    loop
          v_comp1_ := v_comp1_ || v_comp1 || '  ';
          fetch cur_work1 into v_comp1;
    end loop;
    close cur_work1;

    open cur_work2;
    fetch cur_work2 into v_comp2;
    while cur_work2%found
    loop
          v_comp2_ := v_comp2_ || v_comp2 || '  ';
          fetch cur_work2 into v_comp2;
    end loop;
    close cur_work2;



    --Ӧգֵ
    update T_CSRC0707_C11_1 set C2 = v_comp1_,C3 = v_comp2_ where BBQ = v_P001 and userid = v_userid;


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120200 and a008=V_USERID;

    commit;
    exception when others then
              rollback;
              update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120200 and a008=V_USERID;/*޸ת״̬ */

              errcode:=0;
              errmsg :='ɱʧܣŴ洢CISP_MAKEREPORT_1120200У';

              return;

end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120210
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120210( errcode out int, errmsg out varchar2,v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2 ,v_P002 varchar2, v_P003 varchar2)
is

     v_temp varchar(256);
     --v_USER  integer;
     v_count int;
     v_bmid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';
    /*select T2.A002 into v_USER
      from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
      where T1.P001 = v_KJAXUSER
      and T1.P002 = T2.P001;
      */
      select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID

      select count(*) into v_count from T_DB_50_001 where p001=1010 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M5=(select a099 from T_DB_50_001 where p001=1010 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1020 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M6=(select a099 from T_DB_50_001 where p001=1020 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1030 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M7=(select a099 from T_DB_50_001 where p001=1030 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1040 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M8=(select a099 from T_DB_50_001 where p001=1040 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1050 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M9=(select a099 from T_DB_50_001 where p001=1050 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1060 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M10=(select a099 from T_DB_50_001 where p001=1060 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1070 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M11=(select a099 from T_DB_50_001 where p001=1070 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1080 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M12=(select a099 from T_DB_50_001 where p001=1080 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1090 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M13=(select a099 from T_DB_50_001 where p001=1090 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1100 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M15=(select a099 from T_DB_50_001 where p001=1100 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1110 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M16=(select a099 from T_DB_50_001 where p001=1110 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1120 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M17=(select a099 from T_DB_50_001 where p001=1120 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1130 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M18=(select a099 from T_DB_50_001 where p001=1130 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1140 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M19=(select a099 from T_DB_50_001 where p001=1140 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1150 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M20=(select a099 from T_DB_50_001 where p001=1150 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1160 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M21=(select a099 from T_DB_50_001 where p001=1160 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1170 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M23=(select a099 from T_DB_50_001 where p001=1170 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1180 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M24=(select a099 from T_DB_50_001 where p001=1180 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1190 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M25=(select a099 from T_DB_50_001 where p001=1190 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1200 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M26=(select a099 from T_DB_50_001 where p001=1200 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1210 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M28=(select a099 from T_DB_50_001 where p001=1210 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1220 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M29=(select a099 from T_DB_50_001 where p001=1220 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1230 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M30=(select a099 from T_DB_50_001 where p001=1230 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1240 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M32=(select a099 from T_DB_50_001 where p001=1240 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;

      select count(*) into v_count from T_DB_50_001 where p001=1250 and w100=v_bmid;
      if(v_count>0) then
      update T_CSRC1227_C12_1 set M33=(select a099 from T_DB_50_001 where p001=1250 and w100=v_bmid)
                             where BBQ=v_P001 and USERID=v_bmid;
      end if;



    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120210 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>'||A004||'' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1120210;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120210 and a008=v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120210!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120220
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120220(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
     v_temp varchar(256);
     v_bmid number;
     v_orgid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    select p002 into v_orgid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1120220 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp
    FROM KRCS.T_SYS_T004 WHERE P001 = 1120220;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120220 and a008 = v_bmid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1120220!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120230
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120230(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp varchar(2000);
  v_bmid number;
  v_row  integer; --Ϲ
  v_sql  varchar(2000); --SQL

  v_mc   varchar(256);
  v_js   number;
  v_zqsz number;
  v_bzbl number;
  v_zbbl number;

  cursor cur_money_cust is -- ؿͻ ͻơؽ֤ȯֵԼϱСռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_62_004
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a003 desc) a
     where rownum <= 5;

  cursor cur_stkasset_stock is -- ֤ȯ ֤ȯơ֤ȯ֤ȯֵռܹɱռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_62_005
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a004 desc) a
     where rownum <= 5;
begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  select a012 into v_bmid from KRCS.T_SYS_USER where p001 = v_KJAXUSER; --ȡID

  v_js   := 0;
  v_zqsz := 0;
  v_bzbl := 0;
  v_zbbl := 0;

  v_row := 38;
  open cur_money_cust;
  fetch cur_money_cust
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_money_cust%found) loop
    v_sql := 'update t_csrc0822_c13_2 set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_money_cust
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_money_cust;

  v_row := 44;
  open cur_stkasset_stock;
  fetch cur_stkasset_stock
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_stkasset_stock%found) loop
    v_sql := 'update t_csrc0822_c13_2 set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_stkasset_stock
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_stkasset_stock;

  update KRCS.T_SYS_T024
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = 1120230
     and a008 = v_bmid;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1120230;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;
  /*    exception when others then
  rollback;
  update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1120230 and a008=v_bmid;\*޸ת״̬ *\
  errcode := 0;
  errmsg := 'ڴ洢CISP_MAKEREPORT_1120230!';
  return;*/
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120240
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120240(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp varchar(256);
  v_bmid number;
  v_row  integer; --Ϲ
  v_sql  varchar(2000); --SQL

  v_mc   varchar(256);
  v_js   number;
  v_zqsz number;
  v_bzbl number;
  v_zbbl number;

  cursor cur_money_cust is -- ؿͻ ͻơؽ֤ȯֵԼϱСռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_63_004
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a003 desc) a
     where rownum <= 5;

  cursor cur_stkasset_stock is -- ֤ȯ ֤ȯơ֤ȯ֤ȯֵռܹɱռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_63_005
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a004 desc) a
     where rownum <= 5;
begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  select a012 into v_bmid from KRCS.T_SYS_USER where p001 = v_KJAXUSER; --ȡID

  v_row := 47;
  open cur_money_cust;
  fetch cur_money_cust
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_money_cust%found) loop
    v_sql := 'update t_csrc0822_c13_3 set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_money_cust
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_money_cust;

  v_row := 53;
  open cur_stkasset_stock;
  fetch cur_stkasset_stock
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_stkasset_stock%found) loop
    v_sql := 'update t_csrc0822_c13_3 set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_stkasset_stock
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_stkasset_stock;

  update KRCS.T_SYS_T024
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = 1120240
     and a008 = v_bmid;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1120240;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;
exception
  when others then
    rollback;
    update KRCS.T_SYS_T024
       SET A010 = 1015002
     WHERE P001 = 1120240
       and a008 = v_bmid; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1120240!';
    return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120241
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120241(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp varchar(256);
  v_bmid number;
  v_row  integer; --Ϲ
  v_sql  varchar(2000); --SQL

  v_mc   varchar(256);
  v_js   number;
  v_zqsz number;
  v_bzbl number;
  v_zbbl number;

  cursor cur_money_cust is -- ؿͻ ͻơؽ֤ȯֵԼϱСռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_63_004_RH
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a003 desc) a
     where rownum <= 5;

  cursor cur_stkasset_stock is -- ֤ȯ ֤ȯơ֤ȯ֤ȯֵռܹɱռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_63_005_RH
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a004 desc) a
     where rownum <= 5;
begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  select a012 into v_bmid from KRCS.T_SYS_USER where p001 = v_KJAXUSER; --ȡID

  v_row := 47;
  open cur_money_cust;
  fetch cur_money_cust
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_money_cust%found) loop
    v_sql := 'update t_csrc0822_c13_3_rh set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_money_cust
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_money_cust;

  v_row := 53;
  open cur_stkasset_stock;
  fetch cur_stkasset_stock
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_stkasset_stock%found) loop
    v_sql := 'update t_csrc0822_c13_3_rh set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_stkasset_stock
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_stkasset_stock;

  update KRCS.T_SYS_T024
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = 1120241
     and a008 = v_bmid;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1120241;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;
exception
  when others then
    rollback;
    update KRCS.T_SYS_T024
       SET A010 = 1015002
     WHERE P001 = 1120241
       and a008 = v_bmid; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1120241!';
    return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1120242
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1120242(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp varchar(256);
  v_bmid number;
  v_row  integer; --Ϲ
  v_sql  varchar(2000); --SQL

  v_mc   varchar(256);
  v_js   number;
  v_zqsz number;
  v_bzbl number;
  v_zbbl number;

  cursor cur_money_cust is -- ؿͻ ͻơؽ֤ȯֵԼϱСռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_63_004_ZYZJ
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a003 desc) a
     where rownum <= 5;

  cursor cur_stkasset_stock is -- ֤ȯ ֤ȯơ֤ȯ֤ȯֵռܹɱռʱ
    select a.a002,
           nvl(a.a003, 0),
           nvl(a.a004, 0),
           nvl(a.a005, 0),
           nvl(a.a006, 0)
      from (select *
              from T_DB_63_005_ZYZJ
             where w100 in
                   (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
               and a002 is not null
             order by a004 desc) a
     where rownum <= 5;
begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  select a012 into v_bmid from KRCS.T_SYS_USER where p001 = v_KJAXUSER; --ȡID

  v_row := 47;
  open cur_money_cust;
  fetch cur_money_cust
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_money_cust%found) loop
    v_sql := 'update t_csrc0822_c13_3_zyzj set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_money_cust
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_money_cust;

  v_row := 53;
  open cur_stkasset_stock;
  fetch cur_stkasset_stock
    into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  while (cur_stkasset_stock%found) loop
    v_sql := 'update t_csrc0822_c13_3_zyzj set ' || 'A' || v_row || '=''' || v_mc ||
             ''',' || 'C' || v_row || '=''' || v_js || ''',' || 'D' ||
             v_row || '=' || v_zqsz || ',' || 'E' || v_row || '=' || v_bzbl || ',' || 'F' ||
             v_row || '=' || v_zbbl || ' ' || 'where BBQ=''' || v_P001 ||
             ''' and USERID=' || v_bmid;
  
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch cur_stkasset_stock
      into v_mc, v_js, v_zqsz, v_bzbl, v_zbbl;
  end loop;
  close cur_stkasset_stock;

  update KRCS.T_SYS_T024
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = 1120242
     and a008 = v_bmid;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1120242;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;
exception
  when others then
    rollback;
    update KRCS.T_SYS_T024
       SET A010 = 1015002
     WHERE P001 = 1120242
       and a008 = v_bmid; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1120242!';
    return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125010
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125010(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_status number;
    v_a100   number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
    from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D1_1_1 where BBQ=v_P001 AND USERID = v_userid;

    insert into t_csrc0707_d1_1_1(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2,g2,h2,i2,j2)
           select v_P001,v_userid,'0','','0','0',a.a002,decode(a.a003,1001101,'T',1001102,'F'),b.a002,a.a004,a.a005,a.a006,a.a007,a.a008,decode(a.a009,1001101,'T',1001102,'F'),a.a010
           from t_ctl_t001 a,t_ctl_d001 b
           where a.f004=b.p001 and a.b001=1002001 and a.a100 = v_a100;

     --ϼ
     insert into t_csrc0707_d1_1_1(bbq,userid,btype,option1,shtag,ishj,d2,e2,f2,g2,h2)
            select v_P001,v_userid,'0','','0','1',sum(d2),sum(e2),sum(f2),sum(g2),sum(h2)
            from t_csrc0707_d1_1_1 where bbq=v_P001 and userid = v_userid;


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125010 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125010;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125010 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125010!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125020
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125020(
         errcode out int, errmsg out varchar2, v_KJAXUSER varchar2,v_TASK varchar2,
         v_P001 varchar2, v_P002 varchar2, v_P003 varchar2) is
     v_temp varchar(256);
     v_userid integer;
     v_status number;
     v_a100   number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D1_1_2 where BBQ=v_P001 and userid = v_userid;


     insert into t_csrc0707_d1_1_2(bbq,userid,btype,option1,shtag,ishj,a3,b3,c3,d3,e3,f3,g3,h3,i3,j3)
           select v_p001,v_userid,'0','','0','0',T.A3,
           (case T.B3 WHEN 1001 THEN 1 WHEN 1002 THEN 2 WHEN 1003 THEN 3 WHEN 1004 THEN 4 END),
           T.C3,T.D3,T.E3,T.F3,G3,T.H3,T.I3,T.J3
           from (select T5.A002 AS A3,
                        T5.F004 AS B3,
                        T1.A002 AS C3,
                        T1.A003 AS D3,
                        T1.A004 AS E3,
                        T1.A005 AS F3,
                        T1.A002+T1.A003+T1.A004+T1.A005 AS G3,
                        T2.A002 AS H3,
                        T6.A003 AS I3,
                        T2.A010 AS J3
                 FROM t_ctl_t002 T1,t_ctl_t006 T2 ,t_ctl_t001 T5 ,t_ctl_d003 T6 WHERE T2.F008=1002 AND T1.B001=1002001 AND T5.B001=1002001 AND T6.P001= T2.F003 AND T1.P001= T5.P001 AND T1.A100 = T2.A100 AND T1.A100 =T5.A100 and T1.A100 = v_a100
                 UNION
                 select T5.A002 AS A3,
                        T5.F004 AS B3,
                        T1.A002 AS C3,
                        T1.A003 AS D3,
                        T1.A004 AS E3,
                        T1.A005 AS F3,
                        T1.A002+T1.A003+T1.A004+T1.A005 AS G3,
                        T3.A002 AS H3,
                        T6.A003 AS I3,
                        T3.A010 AS J3
                 FROM t_ctl_t002 T1,t_ctl_t023 T3 ,t_ctl_t001 T5, t_ctl_d003 T6 WHERE T3.F008=1002 AND T1.B001=1002001 AND T5.B001=1002001 AND T6.P001= T3.F003 AND T1.P001= T5.P001 AND T1.A100 = T3.A100 AND T1.A100 =T5.A100 and T1.A100 = v_a100
                 UNION
                 select T5.A002 AS A3,
                        T5.F004 AS B3,
                        T1.A002 AS C3,
                        T1.A003 AS D3,
                        T1.A004 AS E3,
                        T1.A005 AS F3,
                        T1.A002+T1.A003+T1.A004+T1.A005 AS G3,
                        T4.A002 AS H3,
                        T6.A003 AS I3,
                        T4.A010 AS J3
                 FROM t_ctl_t002 T1,t_ctl_t008 T4 ,t_ctl_t001 T5 ,t_ctl_d003 T6 WHERE T4.A003=1001101 AND T1.B001=1002001 AND T5.B001=1002001 AND T6.P001= T4.F004 AND T1.P001= T5.P001 AND T1.A100 = T4.A100 AND T1.A100 =T5.A100 and T1.A100 = v_a100
                 )T;


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125020 and a008=V_USERID;

    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125020;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125020 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125020!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125030
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125030(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D1_1_3 where BBQ=v_P001 and userid = v_userid;

    insert into t_csrc0707_d1_1_3(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2)
           select v_p001,v_userid,'0','','0','0',p001,a002,a003,decode(a004,1001101,'T',1001102,'F'),a005
           from t_ctl_t004
           where a006='ɶ' and b001=1002001 and a100 =v_a100
	  order by a002;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125030 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125030;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125030 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125030!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125040
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125040(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid varchar(32);
    v_status number;
    v_a100 number;
    v_date_first date;
    v_date_last date;

begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

     select a005 into v_date_first from T_B00_d004 WHERE C001=1001101 and A002=1013002 ;
     select a006 into v_date_last from T_B00_d004 WHERE C001=1001101  and A002=1013002;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D2_1_1 where BBQ=v_P001 and userid = v_userid;



    insert into t_csrc0707_d2_1_1(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2,g2)
           select v_p001,v_userid,'0','','0','0',a.a002,a.a004,decode(d.A003,null,'F',0,'F','T'),b.a002||b.a003,c.a002,a.a009,a.a010
           from (select * from t_ctl_t006 where a100 = v_a100) a,
	        (select * from t_ctl_t005 where a100 = v_a100) b,
		 t_ctl_d002 c ,
		(select distinct p001,100 as A003 from T_CTL_T028 where p002 between v_date_first and v_date_last and a100 = v_a100) d
           where
                 a.f008=c.p001(+)
             and a.p001=b.p001(+) and a.p001=d.p001(+)
             and a.b001=1005001
	   order by a.p001;


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125040 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125040 ;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125040 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125040!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125050
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125050(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid varchar(32);
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D2_1_2 where BBQ=v_P001 and userid = v_userid;

    insert into t_csrc0707_d2_1_2(bbq,userid,btype,OPTION1,shtag,ishj,a2,b2,c2,d2,e2)
           select v_p001, v_userid, '0', '', '0', '0',
                  p001,a002, a003, decode(a004, 1001101, 'T', 1001102,'F'), a005
           from t_ctl_t004
           where a006='»' and b001=1002001 and a100 = v_a100;


    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125050 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125050;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125050 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125050!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125060
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125060(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D2_1_3 where BBQ=v_P001 and userid = v_userid;

     insert into t_csrc0707_d2_1_3(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2)
           select v_p001,v_userid,'0','','0','0', a003,a005,a007,a008
           from t_ctl_t037
           where a002=1023011 and b001=1002001 and a100 = v_a100;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125060 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125060 ;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125060 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125060!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125070
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125070(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;
    delete from T_CSRC0707_D2_1_4 where BBQ=v_P001 and userid = v_userid;

     insert into t_csrc0707_d2_1_4(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2)
           select v_p001,v_userid,'0','','0','0',a.a002,a.a004,decode(b.a003,null,'F',0,'F','T'),c.a002,a.a009,a.a010
           from (select * from t_ctl_t023 where a100 = v_a100) a,
	        (select * from t_ctl_t026 where a100 = v_a100) b,
		t_ctl_d002 c
           where a.b001=1005001 and c.p001=a.f008 and a.p001=b.p001(+)
	   order by a.p001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125070 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125070 ;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125070 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125070!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125080
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125080(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D2_1_5 where BBQ=v_P001 and userid = v_userid;

     insert into t_csrc0707_d2_1_5(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2)
           select v_p001,v_userid,'0','','0','0',p001,a002,a003,decode(a004,1001101,'T',1001102,'F'),a005
           from t_ctl_t004
           where a006='»' and b001=1002001 and a100 = v_a100;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125080 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125080;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125080 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125080!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125090
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125090(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_EEP001 varchar(256);
    v_EP001 number;
    v_EP002 varchar(256);
    v_EP003 varchar(256);
    v_EP004 date;
    v_EP005 varchar(256);
    v_EP006 varchar(256);
    v_EP007 varchar(256);
    v_status number;
    v_a100 number;
     cursor c_work is
       select v_p001,a.a002,c.a003,a.a005,a.a009,a.a010,a.p001
       from (select * from t_ctl_t008 where b001 = 1005001 and a100 = (select p002 from KRCS.T_SYS_USER WHERE P001 =v_KJAXUSER)) a, KRCS.T_B00_D098 b, T_CTL_D003 c,KRCS.T_B00_D098 e
     	WHERE a.A003=b.P002 AND a.F004=c.P001 AND a.B001=e.P002
      order by a.p001;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D2_1_6 where BBQ=v_P001 and userid = v_userid;

    open c_work;
    fetch c_work into v_EEP001,v_EP002,v_EP003,v_EP004,v_EP005,v_EP006,v_EP001;
    while c_work%found
    loop
       v_EP007:='';
       declare
          v_CP001 varchar(256);
          cursor c_work1 is
           select a.a003
           from KRCS.T_CTL_T036 a,(select * from t_ctl_t008 where b001 = 1005001) b
           where a.a015=3||b.p001
              and a.a015=3||v_EP001
	      and a.w100 = b.a100
	      and a.w100 = v_a100;
        begin
           open c_work1;
           fetch c_work1 into v_CP001;
           while c_work1%found
           loop
               v_EP007 := v_EP007 || v_CP001||'';
               fetch c_work1 into v_CP001;
           end loop;
           close c_work1;
           if(length(v_EP007)>0) then
                    v_EP007 := substr(v_EP007,0,length(v_EP007)-1);
           end if;
        insert into t_csrc0707_d2_1_6(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2)
         values(v_EEP001,v_userid,'0','','0','0',v_EP002,v_EP003,v_EP007,v_EP004,v_EP005,v_EP006);
         end;
         fetch c_work into v_EEP001,v_EP002,v_EP003,v_EP004,v_EP005,v_EP006,v_EP001;
    end loop;
    close c_work;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125090 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<fontcolor=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp
    FROM KRCS.T_SYS_T004 WHERE P001 = 1125090;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125090 and a008=V_USERID;/*޸ת״̬ */

                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125090!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125100
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125100(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_date_first date;
    v_date_last date;
    v_date_year varchar(4);
    B2 number;
    C2 number(10,2);
    D2 number(10,2);
    E2 number(10,2);
    F2 number(10,2);
    B3 number;
    C3 number(10,2);
    D3 number(10,2);
    E3 number(10,2);
    F3 number(10,2);
    B4 number;
    C4 number(10,2);
    D4 number(10,2);
    E4 number(10,2);
    F4 number(10,2);
    B5 number;
    C5 number(10,2);
    D5 number(10,2);
    E5 number(10,2);
    F5 number(10,2);
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

     select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

     select a005 into v_date_first from T_B00_d004 WHERE C001=1001101 and A002=1013002 ;
     select a006 into v_date_last from T_B00_d004 WHERE C001=1001101  and A002=1013002;
     select to_char(a005,'yyyy') into v_date_year from T_B00_d004 WHERE C001=1001101 and A002=1013002;


    delete from T_CSRC0707_D2_2 where BBQ=v_P001 and userid = v_userid;


    SELECT COUNT(DISTINCT T1.P001) into B2 FROM T_CTL_T006 T1, T_CTL_T028 T2 WHERE T1.P001 = T2.P001 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.a100 = v_a100;

    SELECT sum(T2.A003) into C2 FROM T_CTL_T006 T1, T_CTL_T028 T2 WHERE T1.P001 = T2.P001 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.A100 = v_a100;
    SELECT sum(T2.A003) into D2 FROM T_CTL_T006 T1, T_CTL_T028 T2 WHERE T1.P001 = T2.P001 AND to_char(T2.P002,'yyyy')=v_date_year AND T1.A100 = T2.A100 and T1.A100 = v_a100;
    SELECT sum(T1.A006) into E2 FROM T_CTL_T006 T1 WHERE T1.P001 IN( SELECT T2.P001 FROM T_CTL_T028 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;
    SELECT sum(T1.A007) into F2 FROM T_CTL_T006 T1 WHERE T1.P001 IN( SELECT T2.P001 FROM T_CTL_T028 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;

    SELECT COUNT(DISTINCT T1.P001) into B3 FROM T_CTL_T006 T1, T_CTL_T028 T2 WHERE T1.P001 = T2.P001 AND T1.F003=1004 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.a100 = v_a100;

    SELECT sum(T2.A003) into C3 FROM T_CTL_T006 T1, T_CTL_T028 T2 WHERE T1.P001 = T2.P001 AND T1.F003=1004 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.a100 = v_a100;
    SELECT sum(T2.A003) into D3 FROM T_CTL_T006 T1, T_CTL_T028 T2 WHERE T1.P001 = T2.P001 AND T1.F003=1004 AND to_char(T2.P002,'yyyy')=v_date_year AND T1.A100 = T2.A100 and T1.a100 = v_a100;
    SELECT sum(T1.A006) into E3 FROM T_CTL_T006 T1 WHERE T1.F003=1004 AND T1.P001 IN( SELECT T2.P001 FROM T_CTL_T028 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;
    SELECT sum(T1.A007) into F3 FROM T_CTL_T006 T1 WHERE T1.F003=1004 AND T1.P001 IN( SELECT T2.P001 FROM T_CTL_T028 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;

    SELECT COUNT(DISTINCT T1.P001) into B4 FROM T_CTL_T023 T1, T_CTL_T026 T2 WHERE T1.P001 = T2.P001 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.a100 = v_a100;

    SELECT sum(T2.A003) into C4 FROM T_CTL_T023 T1, T_CTL_T026 T2 WHERE T1.P001 = T2.P001 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.a100 = v_a100;
    SELECT sum(T2.A003) into D4 FROM T_CTL_T023 T1, T_CTL_T026 T2 WHERE T1.P001 = T2.P001 AND to_char(T2.P002,'yyyy')=v_date_year AND T1.A100 = T2.A100 and T1.a100 = v_a100;
    SELECT sum(T1.A006) into E4 FROM T_CTL_T023 T1 WHERE T1.P001 IN( SELECT T2.P001 FROM T_CTL_T026 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;
    SELECT sum(T1.A007) into F4 FROM T_CTL_T023 T1 WHERE T1.P001 IN( SELECT T2.P001 FROM T_CTL_T026 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;

    SELECT COUNT(DISTINCT T1.P001) into B5 FROM T_CTL_T008 T1, T_CTL_T007 T2 WHERE T1.P001 = T2.P001 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.a100 = v_a100;

    SELECT sum(T2.A003) into C5 FROM T_CTL_T008 T1, T_CTL_T007 T2 WHERE T1.P001 = T2.P001 AND T2.P002 BETWEEN v_date_first and v_date_last AND T1.A100 = T2.A100 and T1.a100 = v_a100;
    SELECT sum(T2.A003) into D5 FROM T_CTL_T008 T1, T_CTL_T007 T2 WHERE T1.P001 = T2.P001 AND to_char(T2.P002,'yyyy')=v_date_year AND T1.A100 = T2.A100 and T1.a100 = v_a100;
    SELECT sum(T1.A006) into E5 FROM T_CTL_T008 T1 WHERE T1.P001 IN( SELECT T2.P001 FROM T_CTL_T007 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;
    SELECT sum(T1.A007) into F5 FROM T_CTL_T008 T1 WHERE T1.P001 IN( SELECT T2.P001 FROM T_CTL_T007 T2 WHERE T2.P002 BETWEEN v_date_first and v_date_last and T2.a100 = v_a100) and T1.a100 = v_a100;


    insert into t_csrc0707_d2_2(bbq,userid,btype,option1,shtag,B2,C2,D2,E2,F2,B3,C3,D3,E3,F3,B4,C4,D4,E4,F4,B5,C5,d5,e5,f5,B6,C6,D6,E6,F6)
           values(v_P001,v_userid,'0','','1',B2,C2,D2,E2,F2,B3,C3,D3,E3,F3,B4,C4,D4,E4,F4,B5,C5,d5,e5,f5,B2+B4+B5,C2+C4+C5,D2+D4+D5,E2+E4+E5,F2+F4+F5);

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125100 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125100;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125100 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125100!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125110
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125110(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D3_1_1 where BBQ=v_P001 and userid = v_userid;

    insert into t_csrc0707_d3_1_1(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2)
           select v_p001,v_userid,'0','','0','0',a003,decode(a004,1001101,'T',1001102,'F'),a005,a006,a007,a008
           from t_ctl_t037
           where a002=1023003 and b001=1002001 and a100 = v_a100;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125110 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125110;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125110 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125110!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125120
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125120(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;
    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D3_1_2 where BBQ=v_P001 and userid = v_userid;

    insert into t_csrc0707_d3_1_2(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2)
           select v_p001,v_userid,'0','','0','0',a.a003,a.a011,a.a009,a.a016,a.a012,a.a100
           from KRCS.T_CTL_T036 a,KRCS.T_B00_D098 c
           where c.p002=1022001 and a.a013=c.p002 and w100 =v_a100
	   order by a.p001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125120 and a008=V_USERID;

    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125120;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125120 and a008=V_USERID;/*޸ת״̬ */

                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125120!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125130
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125130(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D3_1_3 where BBQ=v_P001 and userid = v_userid;

     insert into t_csrc0707_d3_1_3(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2)
           select v_p001,v_userid,'0','','0','0',a.a003,a.a011,a.a009,a.a016,a.a012,a.a100
           from KRCS.T_CTL_T036 a,KRCS.T_B00_D098 c
           where
               (c.p002=1022002 or c.p002=1022004 or c.p002=1022007 or c.p002=1022006)
                and a.a013=c.p002 and a.w100 =v_a100;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125130 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125130;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125130 and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125130!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125140
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125140(errcode out int, errmsg out varchar2,
          v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;
    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D3_1_4 where BBQ=v_P001 and userid = v_userid;

    insert into t_csrc0707_d3_1_4(bbq,userid,btype,option1,shtag,ishj,a2,b2,c2,d2,e2,f2,g2)
           select v_p001,v_userid,'0','','0','0',a.a003,a.a011,a.a009,a.a016,a.a014,a.a012,a.a100
           from KRCS.T_CTL_T036 a,KRCS.T_B00_D098 c
           where
                 (c.p002=1022003 or c.p002=1022005 )
                and a.a013=c.p002 and w100 =v_a100;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125140 and a008=V_USERID;

    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125140;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125140 and a008=V_USERID;/*޸ת״̬ */

                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125140!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125150
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125150(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(255);
    v_ROWNUM integer;
    v_EEP001 varchar(255);
    v_EP001 integer;
    v_EP002 varchar(128);
    v_EP004 varchar(128);
    v_EP005 number;
    v_EP006 varchar(128);
    v_EP007 varchar(128);
    v_EP008 varchar(255);
    v_EP009 varchar(255);
    v_count1 integer;
    v_count2 integer;
    v_userid integer;
    v_a100 number;
    cursor c_work is
       select v_p001,rownum,a003,a011,a010,a009,a007,a100,p001
         from KRCS.T_CTL_T036
        where a008=1023004 and w100 =(select p002 from KRCS.T_SYS_USER WHERE P001=v_KJAXUSER);
 /*ֹ˾ܲ  - ֹ˾  */
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;
    v_EP009 :='';

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D4_1_1 where BBQ=v_P001 and userid = v_userid;


    open c_work;
    fetch c_work into v_EEP001,v_ROWNUM,v_EP002,v_EP004,v_EP005,v_EP006,v_EP007,v_EP008,v_EP001;
    while c_work%found
    loop
       v_EP009 := '';
        select count(*) into v_count1
          from KRCS.T_CTL_T036
         where A017=v_EP001
           and a008=1023008 AND W100=v_a100;
        select count(*) into v_count2
          from KRCS.T_CTL_T036
         where A017=v_EP001 and a008=1023010 AND W100=v_a100;

        declare
           v_CP001 varchar(256);
             cursor c_work1 is
             select distinct b.a003
               from KRCS.T_CTL_T036 a,
                    KRCS.T_B00_D098 b
              where a.a006 = b.p002
                and a008=1023008
                and a.a017=v_EP001
		AND A.W100=v_a100;
        begin
          open c_work1;
           fetch c_work1 into v_CP001;
           while c_work1%found
           loop
                 v_EP009 := v_EP009 || v_CP001||'';
                 fetch c_work1 into v_CP001;
           end loop;
           close c_work1;
           if(length(v_EP009)>0) then
                    v_EP009 := substr(v_EP009,0,length(v_EP009)-1);
           end if;
           insert into t_csrc0707_d4_1_1(bbq,userid,btype,option1,shtag,ishj,a3,b3,c3,d3,e3,f3,g3,h3,i3,j3)
           values (v_EEP001,v_userid,'0','','0','0',v_ROWNUM,v_EP002,v_EP004,decode(v_EP005,1001101,'T',1001102,'F'),
           v_EP006,v_EP007,v_EP009,v_count1,v_count2,v_EP008);
         end;
         fetch c_work into v_EEP001,v_ROWNUM,v_EP002,v_EP004,v_EP005,v_EP006,v_EP007,v_EP008,v_EP001;
    end loop;
    close c_work;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125150 and a008=V_USERID;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125150;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125150 and a008=V_USERID;/*޸ת״̬ */

                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125150!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125160
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125160(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_ROWNUM integer;
    v_EEP001 varchar(256);
    v_EP001 integer;
    v_EP002 varchar(128);
    v_EP004 varchar(128);
    v_EP005 number;
    v_EP006 varchar(128);
    v_EP007 varchar(128);
    v_EP008 varchar(512);
    v_EP109 varchar(256);
    v_count1 integer;
    v_count2 integer;
    v_userid integer;
    v_a100 number;
    cursor c_work is
       select v_p001,rownum,a003,a011,a010,a009,a007,a100,p001
         from KRCS.T_CTL_T036
        where a008=1023006 and w100 =(select p002 from KRCS.T_SYS_USER WHERE P001=v_KJAXUSER);
 /*ֹ˾ܲ - ܲ  */
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D4_1_2 where BBQ=v_P001 and userid = v_userid;


    open c_work;
    fetch c_work into v_EEP001,v_ROWNUM,v_EP002,v_EP004,v_EP005,v_EP006,v_EP007,v_EP008,v_EP001;
    while c_work%found
    loop
        v_EP109 := '';
        select count(*) into v_count1
          from KRCS.T_CTL_T036
         where A018=v_EP001
           and a008=1023008 and w100 =v_a100;
        select count(*) into v_count2
          from KRCS.T_CTL_T036
         where A018=v_EP001 and a008=1023010  and w100 =v_a100;

        declare
           v_CP001 varchar(256);
             cursor c_work1 is
             select distinct b.a003
               from KRCS.T_CTL_T036 a,
                    KRCS.T_B00_D098 b
              where a.a006 = b.p002
                and a.A018 = v_EP001
                and a.a008 = 1023008
		and a.w100 =v_a100;
        begin
          open c_work1;
           fetch c_work1 into v_CP001;
           while c_work1%found
           loop
                 v_EP109 := v_EP109 || v_CP001||'';
                 fetch c_work1 into v_CP001;
           end loop;
           close c_work1;
           if(length(v_EP109)>0) then
                    v_EP109 := substr(v_EP109,0,length(v_EP109)-1);
           end if;
           insert into t_csrc0707_d4_1_2(bbq,userid,btype,option1,shtag,ishj,a3,b3,c3,d3,e3,f3,g3,h3,i3,j3)
           values (v_EEP001,v_userid,'0','','0','0',v_ROWNUM,v_EP002,v_EP004,decode(v_EP005,1001101,'T',1001102,'F'),
           v_EP006,v_EP007,v_EP109,v_count1,v_count2,v_EP008);
         end;
         fetch c_work into v_EEP001,v_ROWNUM,v_EP002,v_EP004,v_EP005,v_EP006,v_EP007,v_EP008,v_EP001;
    end loop;
    close c_work;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125160 and a008=V_USERID;

    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125160;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125160 and a008=V_USERID;/*޸ת״̬ */

                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125160!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125170
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125170(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);


    v_USER integer;
    v_status number;
    v_a100 number;


begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D5_1_1 where BBQ=v_P001 and userid= v_USER;

  insert into T_CSRC0707_D5_1_1 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A3,B3,C3,D3,E3,F3,G3)
     select v_P001,v_USER,'0','','0','0',rownum,a.A003, a.A004,a.A005,a.A006,a.A008,a.A007
     FROM T_CTL_T011 a,
          T_CTL_D009 b,
          KRCS.T_B00_D098 c
     WHERE a.A002=b.P001
       AND a.B001=c.P002
       AND a.B001=1002001
       AND a.A002=1001
       AND A.A100=v_a100
     ORDER BY a.P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125170 and a008=v_USER;

    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125170 ;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;

                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125170 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125170!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125180
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125180(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D5_1_2 where BBQ=v_P001 and userid =v_USER;

    insert into T_CSRC0707_D5_1_2 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A3,B3,C3,D3,E3,F3,G3)
    select v_P001,v_USER,'0','','0','0',rownum,a.A003, a.A004,a.A005,a.A006,a.A008,a.A007
    FROM T_CTL_T011 a,
         T_CTL_D009 b,
         KRCS.T_B00_D098 c
    WHERE a.A002=b.P001
      AND a.B001=c.P002
      AND (a.A002=1002 or a.A002=1003)
      AND a.B001=1002001
      and a.a100 =v_a100
    ORDER BY a.P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125180 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125180;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125180 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125180!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125190
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125190(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER  integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D5_1_3 where BBQ=v_P001 and userid = v_user;

    insert into T_CSRC0707_D5_1_3 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2)
      select v_P001,v_USER,0,NULL,1,0,rownum,a002,a003,a006,a007 from t_ctl_t012 where b001=1002001 and a100 = v_a100;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125190 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125190;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125190 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125190!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125200
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125200(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER  integer;
    v_status number;
    v_a100 number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100  from KRCS.T_SYS_USER where p001 = v_KJAXUSER;

    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_D6_1 where BBQ=v_P001 and userid =v_USER;

    --'רҵ'
    insert into T_CSRC0707_D6_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,2,b.a002 as cp002,c.a002 as cap003,d.a002 as cp004,a.a006,a.a005
      FROM (select * from T_CTL_T017  where B001=1002001 and a100 = v_a100) a,T_B00_D001 b,T_CTL_D005 c,T_CTL_D006 d
      WHERE a.p002=b.p001 and a.P003=c.P001 AND a.p004=d.P001;
    --'ܲ'
    insert into T_CSRC0707_D6_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,1,b.a003 as cap002,c.a002 as cap003,d.a002 as cp004,a.a006,a.a005
      FROM (select * from T_CTL_T018  where B001=1002001 and a100 = v_a100) a,
           (select * from KRCS.T_CTL_T036  where B001=1002001 AND A008=1023002  and w100 = v_a100) b,
           T_CTL_D005 c,T_CTL_D006 d
      WHERE a.p002=b.p001 and a.P003=c.P001 and a.p004=d.P001;
    --'ֹ˾ܲ'
    insert into T_CSRC0707_D6_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,4,b.a003 as cap002,c.a002 as cap003,d.a002 as cp004,a.a006,a.a005
      FROM (select * from T_CTL_T019  where B001=1002001 and a100 = v_a100) a,
           (select * from KRCS.T_CTL_T036  where B001=1002001 AND (A008=1023006 OR A008=1023004)  and w100 = v_a100) b,
            T_CTL_D005 c,T_CTL_D006 d
      WHERE a.p002=b.p001(+) and a.P003=c.P001 AND a.p004=d.P001;
    --'Ӫҵ'
    insert into T_CSRC0707_D6_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,5,b.a003 as cap002,c.a002 as cap003,d.a002 as cp004,a.a006,a.a005
      FROM (select * from T_CTL_T020 where B001=1002001 and a100 = v_a100) a,
           (SELECT * FROM KRCS.T_CTL_T036 WHERE B001=1002001 and A008=1023008 and w100 = v_a100) b,
           T_CTL_D005 c,T_CTL_D006 d
      WHERE a.p002=b.p001(+) and a.P003=c.P001 AND a.p004=d.P001;
    --''
    insert into T_CSRC0707_D6_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,6,b.a003 as cap002,c.a002 as cap003,d.a002 as cp004,a.a006,a.a005
    FROM (select * from T_CTL_T021  where B001=1002001 and a100 = v_a100) a,
           (SELECT P001, A003 FROM KRCS.T_CTL_T036 WHERE A008=1023010 AND B001=1002001 and w100 = v_a100) b,
           T_CTL_D005 c,T_CTL_D006 d
      WHERE a.p002=b.p001(+) and a.P003=c.P001 AND a.p004=d.P001;
    --'ؼλԱ'
    insert into T_CSRC0707_D6_1(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,3,p002,c.a002 as cap003,d.a002 as cp004,a.a006,a.a005
    FROM (select * from T_CTL_T022  where B001=1002001 and a100 = v_a100) a,
           T_CTL_D005 c,T_CTL_D006 d
      WHERE a.P003=c.P001 AND a.p004=d.P001;
    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125200 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125200 ;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125200 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125200!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1125210
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1125210(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_EFP001  varchar(256);
    v_EP001 integer;
    v_EP002 varchar(256);
    v_EP003 varchar(256);
    v_EP004 varchar(256);
    v_EP005 varchar(256);
    v_EP006 varchar(256);
    v_USER  integer;
    v_counter integer;
    v_status number;
    v_num integer;
    v_cou integer;
    v_orgid number;
    cursor c_work is
        select 2007,a.p001,a.a002,a.a003,a.a004,a.a005,a.a006
        from (select * from T_BKS_T011
              where p001 <=(substr(v_P001,0,length(p001)))
                         and P001>=((substr(v_P001,0,length(p001))) -5) and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
              order by p001 desc
              ) a
        order by a.p001 desc;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    SELECT P002 into v_orgid FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER;  --  ˻ID

    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;
    delete from T_CSRC0707_D7_1 where BBQ=v_P001 AND USERID = v_USER;

    open c_work;
    v_counter:=0;
    v_cou:=0;
    select count(*) into v_num
        from (select * from T_BKS_T011
              where p001 <=(substr(v_P001,0,length(p001)))
                         and P001>=((substr(v_P001,0,length(p001))) -5) and a100 = v_orgid
              order by p001 desc
              ) a
        order by a.p001 desc;
    loop
         fetch c_work into v_EFP001,v_EP001,v_EP002,v_EP003,v_EP004,v_EP005,v_EP006;
     if(v_cou<v_num) then
         if (v_counter=0) then
            insert into T_CSRC0707_D7_1 (BBQ,USERID,BTYPE,OPTION1,SHTAG,B2,C2,D2,E2,F2,G2)
                   values(v_P001,v_USER,0,null,1,v_EP001,v_EP002,v_EP003,v_EP004,v_EP005,v_EP006);
         end if;
         if (v_counter=1) then
            update T_CSRC0707_D7_1 set BBQ=v_P001,B3=v_EP001,C3=v_EP002,
                  D3=v_EP003,E3=v_EP004,F3=v_EP005,G3=v_EP006 where BBQ=v_P001 and USERID=v_USER;
         end if;
         if (v_counter=2) then
            update T_CSRC0707_D7_1 set BBQ=v_P001,B4=v_EP001,C4=v_EP002,
                  D4=v_EP003,E4=v_EP004,F4=v_EP005,G4=v_EP006 where BBQ=v_P001 and USERID=v_USER;
         end if;
         if (v_counter=3) then
            update T_CSRC0707_D7_1 set BBQ=v_P001,B5=v_EP001,C5=v_EP002,
                  D5=v_EP003,E5=v_EP004,F5=v_EP005,G5=v_EP006 where BBQ=v_P001 and USERID=v_USER;
         end if;
         if (v_counter=4) then
            update T_CSRC0707_D7_1 set BBQ=v_P001,B6=v_EP001,C6=v_EP002,
                  D6=v_EP003,E6=v_EP004,F6=v_EP005,G6=v_EP006 where BBQ=v_P001 and USERID=v_USER;
         end if;
     end if;
         v_counter := v_counter +1;
         v_cou := v_cou +1;
    exit when c_work%notfound;
    end loop;
    close c_work;
    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1125210 and a008 = v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1125210;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1125210 and a008 = v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1125210!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130010
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130010(errcode out int, errmsg out varchar2,
          v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER integer;
    v_count integer;
    v_P004 varchar(8);
    v_status number;

begin
    errcode:=1;
    errmsg := 'ɱɹ';

     select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_E1_1 where BBQ=v_P001 and USERID=v_USER;


    v_P004:=substr(v_P001,0,4)||01;
    insert into T_CSRC0707_E1_1 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2,G2,H2,I2,J2)
      select v_P001,v_USER,0,NULL,1,0,rownum,b.a002,a.p005,a.p006,a.a007,a.a009,a.a010,c.a002,a.a011,a.a015
      from T_BKS_T005 a,T_B06_D001 b,T_B06_D002 c
      where a.p002=b.p001 and a.p004=c.p001 and a.a018=1035002 and a.users=v_KJAXUSER;
      --and substr(to_char(a.a008,'yyyymm'),0,6) between v_P004 and substr(v_P001,0,6) ;
    --ϼ

    insert into T_CSRC0707_E1_1 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,F2,G2,I2)
      select v_P001,v_USER,0,NULL,null,1,sum(F2),sum(G2),sum(I2)
      from T_CSRC0707_E1_1 where bbq=v_P001 and userid= v_USER;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130010 and a008=V_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-1'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130010;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130010 and a008=V_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130010!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130020
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130020(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp varchar(256);
  --v_userid        integer;

  v_sql           varchar(2000); --SQL
  v_qmcys_hj      number(19, 2); --ĩϼ
  v_qmzmcb_hj     number(19, 2); --ĩɱϼ
  v_qmzmgyjz_hj   number(19, 2); --ĩ湫ʼֵϼ
  v_qmsc_hj       number(19, 2); ---ĩֵϼ
  v_qtgp_qmzmcb   number(19, 2); --Ʊĩɱ
  v_qtgp_qmzmgyjz number(19, 2); --Ʊĩ湫ʼֵ
  v_qtgp_qmsc     number(19, 2); --Ʊĩֵ
  v_count         number;
  v_zqdm          varchar(16);
  v_zqmc          varchar(256);
  v_row           number;
  v_num           number;
  v_EP001         number(19, 2);
  v_EP002         number(19, 2);
  v_EP003         number(19, 2);
  v_EP004         number(19, 2);
  v_EP005         number(19, 2);
  v_orgid         number;
  v_bmid          number;

  cursor c_work_gp is
    select a.p003, b.a002
      from t_b02_f008 a,
           (select distinct p001, a002, a004
              from t_bks_t016
             where a100 in
                   (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)) b
     where a.p003 = b.p001
       and b.a004 = 100
       and a.p001 = substr(v_p001, 0, 6)
       and a.p002 = 1001
       and a.p004 = 1002000
       and a.w100 in
           (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
     order by v desc; ----Ʊα
  cursor c_work_jj is
    select a.p003, b.a002
      from t_b02_f008 a,
           (select distinct p001, a002, a004
              from t_bks_t016
             where a100 in
                   (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)) b
     where a.p003 = b.p001
       and b.a004 = 200
       and a.p001 = substr(v_p001, 0, 6)
       and a.p002 = 1002
       and a.p004 = 1002000
       and a.w100 in
           (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
     order by v desc; ----α
  cursor c_work_zq is
    select a.p003, b.a002
      from t_b02_f008 a,
           (select distinct p001, a002, a004
              from t_bks_t016
             where a100 in
                   (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)) b
     where a.p003 = b.p001
       and b.a004 = 300
       and a.p001 = substr(v_p001, 0, 6)
       and a.p002 = 1003
       and a.p004 = 1002004
       and a.w100 in
           (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
     order by v desc; ----ծȯα
  cursor c_work_qz is
    select a.p003, b.a002
      from t_b02_f008 a,
           (select *
              from t_bks_t016
             where a100 in
                   (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)) b
     where a.p003 = b.p001
       and b.a004 = 400
       and a.p001 = substr(v_p001, 0, 6)
       and a.p002 = 1004
       and a.p004 = 1002000
       and a.w100 in
           (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
     order by v desc; ----Ȩ֤α
  cursor c_work_qt is
    select a.p003, b.a002
      from t_b02_f008 a,
           (select distinct p001, a002, a004
              from t_bks_t016
             where a100 in
                   (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)) b
     where a.p003 = b.p001
       and b.a004 <> 300
       and a.p001 = substr(v_p001, 0, 6)
       and a.w100 in
           (select a012 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)
       and a.p002 = 1005
       and a.p004 = 1002000
     order by v desc; ----һַծȯ֤ȯĳɱǰ֤ȯα

begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  select a012 into v_bmid from KRCS.T_SYS_USER where p001 = v_KJAXUSER; --ȡID
  SELECT P002 into v_orgid FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER; --  ˻ID
  delete from T_CSRC0707_E1_2
   where BBQ = v_P001
     and userid = v_bmid;

  /*  SELECT T2.A002 into v_userid FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
       WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;
  */
  ----Ȳһؼּ¼
  insert into t_csrc0707_e1_2
    (BBQ, userid, btype, option1, shtag)
  values
    (v_P001, v_bmid, 0, null, null);

  --̶Ϣ
  --Ʊ

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1001
     and p003 = 1002009
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmcys_hj
      from t_b02_f009 --ĩݣϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = 1002009
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set d3 = v_qmcys_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1001
     and p003 = 1002004
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmzmcb_hj
      from t_b02_f009 --ĩɱϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f3 = v_qmzmcb_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1001
     and p003 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmzmgyjz_hj
      from t_b02_f009 --ĩ湫ʼֵϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g3 = v_qmzmgyjz_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1001
     and p003 = 1002006
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmsc_hj
      from t_b02_f009 --ĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h3 = v_qmsc_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1001
     and p003 = 'qtgp'
     and p004 = 1002004
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmcb
      from t_b02_f008 --Ʊĩɱ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = 'qtgp'
       and p004 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f9 = v_qtgp_qmzmcb
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1001
     and p003 = 'qtgp'
     and p004 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmgyjz
      from t_b02_f008 --Ʊĩ湫ʼֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = 'qtgp'
       and p004 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g9 = v_qtgp_qmzmgyjz
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1001
     and p003 = 'qtgp'
     and p004 = 1002006
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qtgp_qmsc
      from t_b02_f008 --Ʊĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = 'qtgp'
       and p004 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h9 = v_qtgp_qmsc
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  ---------------------------------ʽϢ---------------------------------------------------------------------
  v_row := 4;
  open c_work_gp;
  fetch c_work_gp
    into v_zqdm, v_zqmc;
  while c_work_gp%found loop
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = v_zqdm
       and p004 = 1002009
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP001
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1001
         and p003 = v_zqdm
         and p004 = 1002009
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = v_zqdm
       and p004 = 1002000
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP002
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1001
         and p003 = v_zqdm
         and p004 = 1002000
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = v_zqdm
       and p004 = 1002004
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP003
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1001
         and p003 = v_zqdm
         and p004 = 1002004
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = v_zqdm
       and p004 = 1002005
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP004
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1001
         and p003 = v_zqdm
         and p004 = 1002005
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1001
       and p003 = v_zqdm
       and p004 = 1002006
       and w100 = v_bmid;
    if v_num > 0 then
      select nvl(v, 0)
        into v_EP005
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1001
         and p003 = v_zqdm
         and p004 = 1002006
         and w100 = v_bmid;
    else
      v_EP005 := 0;
    end if;
  
    --ȥƱ'sh''sz'
    if substr(v_zqdm, 1, 2) = 'sh' or substr(v_zqdm, 1, 2) = 'sz' then
      v_zqdm := substr(v_zqdm, 3);
    else
      v_zqdm := v_zqdm;
    end if;
  
    v_sql := 'update T_CSRC0707_E1_2 set ' || 'B' || v_row || '=''' ||
             v_zqmc || ''',' || 'C' || v_row || '=''' || v_zqdm || ''',' || 'D' ||
             v_row || '=' || v_EP001 || ',' || 'E' || v_row || '=' ||
             v_EP002 || ',' || 'F' || v_row || '=' || v_EP003 || ',' || 'G' ||
             v_row || '=' || v_EP004 || ',' || 'H' || v_row || '=' ||
             v_EP005 || ' ' || 'where BBQ=''' || v_P001 || ''' and USERID=' ||
             v_bmid;
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch c_work_gp
      into v_zqdm, v_zqmc;
  end loop;
  close c_work_gp;

  --

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1002
     and p003 = 1002009
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmcys_hj
      from t_b02_f009 --ĩݣϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = 1002009
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set d10 = v_qmcys_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1002
     and p003 = 1002004
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmzmcb_hj
      from t_b02_f009 --ĩɱϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f10 = v_qmzmcb_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1002
     and p003 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmzmgyjz_hj
      from t_b02_f009 --ĩ湫ʼֵϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g10 = v_qmzmgyjz_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1002
     and p003 = 1002006
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmsc_hj
      from t_b02_f009 --ĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h10 = v_qmsc_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1002
     and p003 = 'qtjj'
     and p004 = 1002004
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmcb
      from t_b02_f008 --Ʊĩɱ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = 'qtjj'
       and p004 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f16 = v_qtgp_qmzmcb
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1002
     and p003 = 'qtjj'
     and p004 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmgyjz
      from t_b02_f008 --Ʊĩ湫ʼֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = 'qtjj'
       and p004 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g16 = v_qtgp_qmzmgyjz
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1002
     and p003 = 'qtjj'
     and p004 = 1002006
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qtgp_qmsc
      from t_b02_f008 --Ʊĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = 'qtjj'
       and p004 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h16 = v_qtgp_qmsc
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  ------------------------------ʽϢ----------------------------------------------------------------------------

  v_row := 11;
  open c_work_jj;
  fetch c_work_jj
    into v_zqdm, v_zqmc;
  while c_work_jj%found loop
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = v_zqdm
       and p004 = 1002009
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP001
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1002
         and p003 = v_zqdm
         and p004 = 1002009
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = v_zqdm
       and p004 = 1002000
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP002
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1002
         and p003 = v_zqdm
         and p004 = 1002000
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = v_zqdm
       and p004 = 1002004
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP003
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1002
         and p003 = v_zqdm
         and p004 = 1002004
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = v_zqdm
       and p004 = 1002005
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP004
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1002
         and p003 = v_zqdm
         and p004 = 1002005
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1002
       and p003 = v_zqdm
       and p004 = 1002006
       and w100 = v_bmid;
    if v_num > 0 then
      select nvl(v, 0)
        into v_EP005
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1002
         and p003 = v_zqdm
         and p004 = 1002006
         and w100 = v_bmid;
    else
      v_EP005 := 0;
    end if;
  
    v_sql := 'update T_CSRC0707_E1_2 set ' || 'B' || v_row || '=''' ||
             v_zqmc || ''',' || 'C' || v_row || '=''' || v_zqdm || ''',' || 'D' ||
             v_row || '=' || v_EP001 || ',' || 'E' || v_row || '=' ||
             v_EP002 || ',' || 'F' || v_row || '=' || v_EP003 || ',' || 'G' ||
             v_row || '=' || v_EP004 || ',' || 'H' || v_row || '=' ||
             v_EP005 || ' ' || 'where BBQ=''' || v_P001 || ''' and USERID=' ||
             v_bmid;
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch c_work_jj
      into v_zqdm, v_zqmc;
  end loop;
  close c_work_jj;

  --ծȯ

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1003
     and p003 = 1002009
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmcys_hj
      from t_b02_f009 --ĩݣϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = 1002009
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set d17 = v_qmcys_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1003
     and p003 = 1002004
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmzmcb_hj
      from t_b02_f009 --ĩɱϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f17 = v_qmzmcb_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1003
     and p003 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmzmgyjz_hj
      from t_b02_f009 --ĩ湫ʼֵϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g17 = v_qmzmgyjz_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1003
     and p003 = 1002006
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmsc_hj
      from t_b02_f009 --ĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h17 = v_qmsc_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1003
     and p003 = 'qtzq'
     and p004 = 1002004
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmcb
      from t_b02_f008 --Ʊĩɱ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = 'qtzq'
       and p004 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f23 = v_qtgp_qmzmcb
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1003
     and p003 = 'qtzq'
     and p004 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmgyjz
      from t_b02_f008 --Ʊĩ湫ʼֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = 'qtzq'
       and p004 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g23 = v_qtgp_qmzmgyjz
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1003
     and p003 = 'qtzq'
     and p004 = 1002006
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qtgp_qmsc
      from t_b02_f008 --Ʊĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = 'qtzq'
       and p004 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h23 = v_qtgp_qmsc
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;
  ------------------------------ʽϢ----------------------------------------------------------------------------

  v_row := 18;
  open c_work_zq;
  fetch c_work_zq
    into v_zqdm, v_zqmc;
  while c_work_zq%found loop
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = v_zqdm
       and p004 = 1002009
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP001
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1003
         and p003 = v_zqdm
         and p004 = 1002009
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = v_zqdm
       and p004 = 1002000
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP002
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1003
         and p003 = v_zqdm
         and p004 = 1002000
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = v_zqdm
       and p004 = 1002004
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP003
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1003
         and p003 = v_zqdm
         and p004 = 1002004
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = v_zqdm
       and p004 = 1002005
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP004
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1003
         and p003 = v_zqdm
         and p004 = 1002005
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1003
       and p003 = v_zqdm
       and p004 = 1002006
       and w100 = v_bmid;
    if v_num > 0 then
      select nvl(v, 0)
        into v_EP005
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1003
         and p003 = v_zqdm
         and p004 = 1002006
         and w100 = v_bmid;
    else
      v_EP005 := 0;
    end if;
  
    v_sql := 'update T_CSRC0707_E1_2 set ' || 'B' || v_row || '=''' ||
             v_zqmc || ''',' || 'C' || v_row || '=''' || v_zqdm || ''',' || 'D' ||
             v_row || '=' || v_EP001 || ',' || 'E' || v_row || '=' ||
             v_EP002 || ',' || 'F' || v_row || '=' || v_EP003 || ',' || 'G' ||
             v_row || '=' || v_EP004 || ',' || 'H' || v_row || '=' ||
             v_EP005 || ' ' || 'where BBQ=''' || v_P001 || ''' and USERID=' ||
             v_bmid;
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch c_work_zq
      into v_zqdm, v_zqmc;
  end loop;
  close c_work_zq;

  --Ȩ֤

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1004
     and p003 = 1002009
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmcys_hj
      from t_b02_f009 --ĩݣϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = 1002009
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set d24 = v_qmcys_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1004
     and p003 = 1002004
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmzmcb_hj
      from t_b02_f009 --ĩɱϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f24 = v_qmzmcb_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1004
     and p003 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmzmgyjz_hj
      from t_b02_f009 --ĩ湫ʼֵϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g24 = v_qmzmgyjz_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1004
     and p003 = 1002006
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmsc_hj
      from t_b02_f009 --ĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h24 = v_qmsc_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1004
     and p003 = 'qtqz'
     and p004 = 1002004
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmcb
      from t_b02_f008 --Ʊĩɱ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = 'qtqz'
       and p004 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f30 = v_qtgp_qmzmcb
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1004
     and p003 = 'qtqz'
     and p004 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qtgp_qmzmgyjz
      from t_b02_f008 --Ʊĩ湫ʼֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = 'qtqz'
       and p004 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g30 = v_qtgp_qmzmgyjz
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f008
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1004
     and p003 = 'qtqz'
     and p004 = 1002006
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qtgp_qmsc
      from t_b02_f008 --Ʊĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = 'qtqz'
       and p004 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h30 = v_qtgp_qmsc
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  ------------------------------ʽϢ----------------------------------------------------------------------------

  v_row := 25;
  open c_work_qz;
  fetch c_work_qz
    into v_zqdm, v_zqmc;
  while c_work_qz%found loop
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = v_zqdm
       and p004 = 1002009
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP001
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1004
         and p003 = v_zqdm
         and p004 = 1002009
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = v_zqdm
       and p004 = 1002000
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP002
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1004
         and p003 = v_zqdm
         and p004 = 1002000
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = v_zqdm
       and p004 = 1002004
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP003
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1004
         and p003 = v_zqdm
         and p004 = 1002004
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = v_zqdm
       and p004 = 1002005
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP004
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1004
         and p003 = v_zqdm
         and p004 = 1002005
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1004
       and p003 = v_zqdm
       and p004 = 1002006
       and w100 = v_bmid;
    if v_num > 0 then
      select nvl(v, 0)
        into v_EP005
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1004
         and p003 = v_zqdm
         and p004 = 1002006
         and w100 = v_bmid;
    else
      v_EP005 := 0;
    end if;
  
    v_sql := 'update T_CSRC0707_E1_2 set ' || 'B' || v_row || '=''' ||
             v_zqmc || ''',' || 'C' || v_row || '=''' || v_zqdm || ''',' || 'D' ||
             v_row || '=' || v_EP001 || ',' || 'E' || v_row || '=''' ||
             v_EP002 || ''',' || 'F' || v_row || '=' || v_EP003 || ',' || 'G' ||
             v_row || '=' || v_EP004 || ',' || 'H' || v_row || '=' ||
             v_EP005 || ' ' || 'where BBQ=''' || v_P001 || ''' and USERID=' ||
             v_bmid;
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch c_work_qz
      into v_zqdm, v_zqmc;
  end loop;
  close c_work_qz;

  --һַծȯ֤ȯĳɱǰ֤ȯ(ϼƣ

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1005
     and p003 = 1002009
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmcys_hj
      from t_b02_f009 --ĩݣϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = 1002009
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set d31 = v_qmcys_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1005
     and p003 = 1002004
     and w100 = v_bmid;

  if v_count > 0 then
    select v
      into v_qmzmcb_hj
      from t_b02_f009 --ĩɱϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = 1002004
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set f31 = v_qmzmcb_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1005
     and p003 = 1002005
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmzmgyjz_hj
      from t_b02_f009 --ĩ湫ʼֵϼ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = 1002005
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set g31 = v_qmzmgyjz_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  select count(v)
    into v_count
    from t_b02_f009
   where p001 = substr(v_P001, 0, 6)
     and p002 = 1005
     and p003 = 1002006
     and w100 = v_bmid;
  if v_count > 0 then
    select v
      into v_qmsc_hj
      from t_b02_f009 --ĩֵ
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = 1002006
       and w100 = v_bmid;
    update t_csrc0707_e1_2
       set h31 = v_qmsc_hj
     where BBQ = v_p001
       and userid = v_bmid;
  
  end if;

  ------------------------------ʽϢ----------------------------------------------------------------------------

  v_row := 32;
  open c_work_qt;
  fetch c_work_qt
    into v_zqdm, v_zqmc;
  while c_work_qt%found loop
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = v_zqdm
       and p004 = 1002009
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP001
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1005
         and p003 = v_zqdm
         and p004 = 1002009
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = v_zqdm
       and p004 = 1002000
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP002
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1005
         and p003 = v_zqdm
         and p004 = 1002000
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = v_zqdm
       and p004 = 1002004
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP003
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1005
         and p003 = v_zqdm
         and p004 = 1002004
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = v_zqdm
       and p004 = 1002005
       and w100 = v_bmid;
    if v_num > 0 then
      select v
        into v_EP004
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1005
         and p003 = v_zqdm
         and p004 = 1002005
         and w100 = v_bmid;
    end if;
  
    select count(*)
      into v_num
      from t_b02_f008
     where p001 = substr(v_P001, 0, 6)
       and p002 = 1005
       and p003 = v_zqdm
       and p004 = 1002006
       and w100 = v_bmid;
    if v_num > 0 then
      select nvl(v, 0)
        into v_EP005
        from t_b02_f008
       where p001 = substr(v_P001, 0, 6)
         and p002 = 1005
         and p003 = v_zqdm
         and p004 = 1002006
         and w100 = v_bmid;
    else
      v_EP005 := 0;
    end if;
    --ȥƱ'sh''sz'
    if substr(v_zqdm, 1, 2) = 'sh' or substr(v_zqdm, 1, 2) = 'sz' then
      v_zqdm := substr(v_zqdm, 3);
    else
      v_zqdm := v_zqdm;
    end if;
  
    v_sql := 'update T_CSRC0707_E1_2 set ' || 'B' || v_row || '=''' ||
             v_zqmc || ''',' || 'C' || v_row || '=''' || v_zqdm || ''',' || 'D' ||
             v_row || '=' || v_EP001 || ',' || 'E' || v_row || '=''' ||
             v_EP002 || ''',' || 'F' || v_row || '=' || v_EP003 || ',' || 'G' ||
             v_row || '=' || v_EP004 || ',' || 'H' || v_row || '=' ||
             v_EP005 || ' ' || 'where BBQ=''' || v_P001 || ''' and USERID=' ||
             v_bmid;
    execute immediate v_sql;
    v_row := v_row + 1;
    fetch c_work_qt
      into v_zqdm, v_zqmc;
  end loop;
  close c_work_qt;

  update KRCS.T_SYS_T024
     SET A010 = 1015001
   WHERE P001 = 1130020
     and a008 = v_bmid;
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1130020;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;
exception
  when others then
    rollback;
    update KRCS.T_SYS_T024
       SET A010 = 1015002
     WHERE P001 = 1130020
       and a008 = v_bmid;
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1130020!';
    return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130030
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130030(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)

   is
    v_temp        varchar(256);
    v_content1    varchar(256);
    v_content2    varchar(256);
    v_count       number;
    v_bmid number;
    v_orgid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    SELECT P002 into v_orgid FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER;  --  ˻ID


    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1100 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1100 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y6 = v_content1,AC6=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1200 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1200 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y7 = v_content1,AC7=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1210 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1210 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y8 = v_content1,AC8=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1220 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1220 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y9 = v_content1,AC9=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1230 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1230 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y10 = v_content1,AC10=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1240 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1240 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y11 = v_content1,AC11=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1250 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1250 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y12 = v_content1,AC12=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1260 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1260 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y13 = v_content1,AC13=v_content2
    where userid=v_bmid and bbq=v_P001;

    v_content1 := '';
    v_content2 := '';
    select count(*) into v_count from T_DB_07_103 where P001=1270 and w100 = v_bmid and a100=v_orgid;
    if(v_count =1) then
         select A024,A028 into v_content1,v_content2 from T_DB_07_103 where P001 =1270 and w100 = v_bmid;
    end if;
    update T_CSRC0128_E1_3_1 set Y14 = v_content1,AC14=v_content2
    where userid=v_bmid and bbq=v_P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130030 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130030;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
     commit;
    exception when others then
              errcode := 0;
              errmsg :='ڴ洢CISP_MAKEREPORT_1130030!';
              update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130030 and a008=v_bmid;
              return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130040
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130040(
         errcode out int, errmsg out varchar2,
         v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
   is
         v_temp varchar(256);
         --v_userid number;
         v_bmid number;
         v_count number;
         v_sum number;
          v_planid varchar(26);        --ƻid
          v_planname varchar(256);--ƻ

         v_xh number;--ĿID
          v_xm_1   number;         --Ŀתǰid
          v_xm_11  varchar(30);    --Ŀתid
          v_xm_2   number;         --Ŀתǰid
          v_xm_22  varchar(30);    --Ŀתid
         v_qmstje number;--ĩн
         --Ʊ
         v_gp_cycb number;--гɱ
         v_gp_gyjz number;--ʼֵ
         --
         v_jj_cycb number;--гɱ
         v_jj_gyjz number;--ʼֵ
         -- ծȯ
         v_zq_cycb number;--гɱ
         v_zq_gyjz number;--ʼֵ
         --ʲ֧֤ȯ
         v_zczczq_cycb number;--гɱ
         v_zczczq_gyjz number;--ʼֵ
         --ڻ
         v_qh_qmbzjje number;--ĩ֤

         --Ƽƻ
         v_yhlcjh_cycb number;--гɱ
         v_yhlcjh_gyjz number;--ʼֵ

         --мƻ
         v_xtjh_cycb number;--гɱ
         v_xtjh_gyjz number;--ʼֵ

         --רʲƻ
         v_zxzcgljh_cycb number;--гɱ
         v_zxzcgljh_gyjz number;--ʼֵ
         --Эڴ
         v_qmye number;


         --
         v_qt_cycb number;--гɱ
         v_qt_gyjz number;--ʼֵ

         --ϼ

         v_hj_cycb number;--гɱ
         v_hj_gyjz number;--ʼֵ


         v_sykyzj number;--ʣʽ

         --v_zj number;--ܼ

         v_zhg number; -- ع
         v_nhg number; -- ع
         v_rzgm number;-- ʹģ
         v_rqgm number;-- ȯģ
         v_wcdbbl number;--ά
         v_cjzqye number; --֤ȯ

         v_qmzcjz number ;--ĩʲֵ
         v_orgid number; --˻id

     cursor c_work_plan is
      select t.a002 From t_b04_t011 t where t.b001=1002001 AND A100=(SELECT p002 FROM KRCS.T_SYS_USER WHERE P001=v_KJAXUSER)
      order by t.p001;

begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
     select p002 into v_orgid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡ˻ID
    v_xh :=0;--ʼֵ

    delete from T_CSRC0128_E1_3_2 where BBQ=v_P001 and USERID=v_bmid;

    open c_work_plan;
      fetch c_work_plan into v_planid;
      while c_work_plan%found
      loop
          --̨ȡϢ
          select a.a003,a.f004,b.a003,a.f005,c.a003
             into v_planname,v_xm_1,v_xm_11,v_xm_2,v_xm_22
           from t_b04_t011 a ,
           (select * from T_B04_D011 where b099='LX1')b,
           (select * from T_B04_D011 where b099='LX2')c
           where a.f004=b.p001 and a.f005=c.p001
           and a.A002=v_planid
           and a.a100=v_orgid;


           --ع
           select count(v) into v_count
           from T_B04_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005701
                 and w100 = v_bmid;
           v_zhg := 0;
           if v_count > 0 then
             select v into v_zhg
             from T_B04_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005701
                   and w100 = v_bmid;
           end if;
           --ع
           select count(v) into v_count
           from T_B04_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005702
                 and w100 = v_bmid;
           v_nhg := 0;
           if v_count > 0 then
             select v into v_nhg
             from T_B04_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005702
                   and w100 = v_bmid;
           end if;
           --ʹģ
           select count(v) into v_count
           from T_B04_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005703
                 and w100 = v_bmid;
           v_rzgm := 0;
           if v_count > 0 then
             select v into v_rzgm
             from T_B04_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005703
                   and w100 = v_bmid;
           end if;
             --ȯģ
           select count(v) into v_count
           from T_B04_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005704
                 and w100 = v_bmid;
           v_rqgm := 0;
           if v_count > 0 then
             select v into v_rqgm
             from T_B04_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005704
                   and w100 = v_bmid;
           end if;
           --άֵ
           select count(v) into v_count
           from T_B04_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005705
                 and w100 = v_bmid;
           v_wcdbbl := 0;
           if v_count > 0 then
             select v into v_wcdbbl
             from T_B04_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005705
                   and w100 = v_bmid;
           end if;
           --֤ȯ
           select count(v) into v_count
           from T_B04_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005706
                 and w100 = v_bmid;
           v_cjzqye := 0;
           if v_count > 0 then
             select v into v_cjzqye
             from T_B04_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005706
                   and w100 = v_bmid;
           end if;

           ---Ͷ----
           --ĩн
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005801
                 and w100 = v_bmid;
           v_qmstje := 0;
           if v_count > 0 then
             select v into v_qmstje
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005801
                   and w100 = v_bmid;
           end if;
           --гɱ(Ʊ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005802
                 and w100 = v_bmid;
           v_gp_cycb := 0;
           if v_count > 0 then
             select v into v_gp_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005802
                   and w100 = v_bmid;
           end if;
           --ʼֵ(Ʊ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005803
                 and w100 = v_bmid;
           v_gp_gyjz := 0;
           if v_count > 0 then
             select v into v_gp_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005803
                   and w100 = v_bmid;
           end if;
           --гɱ()
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005804
                 and w100 = v_bmid;
           v_jj_cycb := 0;
           if v_count > 0 then
             select v into v_jj_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005804
                   and w100 = v_bmid;
           end if;
           --ʼֵ()
            select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005805
                 and w100 = v_bmid;
           v_jj_gyjz := 0;

           if v_count > 0 then
             select v into v_jj_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005805
                   and w100 = v_bmid;
           end if;
           --гɱ(ծȯ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005806
                 and w100 = v_bmid;
           v_zq_cycb := 0;
           if v_count > 0 then
             select v into v_zq_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005806
                   and w100 = v_bmid;
           end if;
           --ʼֵ(ծȯ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005807
                 and w100 = v_bmid;
           v_zq_gyjz := 0;
           if v_count > 0 then
             select v into v_zq_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005807
                   and w100 = v_bmid;
           end if;
           --гɱ(ʲ֧֤ȯ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005808
                 and w100 = v_bmid;
           v_zczczq_cycb := 0;
           if v_count > 0 then
             select v into v_zczczq_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005808
                   and w100 = v_bmid;
           end if;
            --ʼֵ(ʲ֧֤ȯ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005809
                 and w100 = v_bmid;
           v_zczczq_gyjz := 0;
           if v_count > 0 then
             select v into v_zczczq_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005809
                   and w100 = v_bmid;
           end if;

           -----------
           --ĩ֤
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005810
                 and w100 = v_bmid;
           v_qh_qmbzjje := 0;
           if v_count > 0 then
             select v into v_qh_qmbzjje
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005810
                   and w100 = v_bmid;
           end if;
            --гɱ(Ƽƻ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005811
                 and w100 = v_bmid;
           v_yhlcjh_cycb := 0;
           if v_count > 0 then
             select v into v_yhlcjh_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005811
                   and w100 = v_bmid;
           end if;
--ʼֵ(Ƽƻ

           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005812
                 and w100 = v_bmid;
           v_yhlcjh_gyjz := 0;
           if v_count > 0 then
             select v into v_yhlcjh_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005812
                   and w100 = v_bmid;
           end if;
            --гɱ(мƻ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005813
                 and w100 = v_bmid;
           v_xtjh_cycb := 0;
           if v_count > 0 then
             select v into v_xtjh_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005813
                   and w100 = v_bmid;
           end if;
           --ʼֵ(мƻ

           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005814
                 and w100 = v_bmid;
           v_xtjh_gyjz := 0;
           if v_count > 0 then
             select v into v_xtjh_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005814
                   and w100 = v_bmid;
           end if;
            --гɱ(רʲƻ)
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005815
                 and w100 = v_bmid;
           v_zxzcgljh_cycb := 0;
           if v_count > 0 then
             select v into v_zxzcgljh_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005815
                   and w100 = v_bmid;
           end if;
           --ʼֵ(רʲƻ

           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005816
                 and w100 = v_bmid;
           v_zxzcgljh_gyjz := 0;
           if v_count > 0 then
             select v into v_zxzcgljh_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005816
                   and w100 = v_bmid;
           end if;
            --ĩ
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005817
                 and w100 = v_bmid;
           v_qmye := 0;
           if v_count > 0 then
             select v into v_qmye
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005817
                   and w100 = v_bmid;
           end if;
           --гɱ(
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005818
                 and w100 = v_bmid;
           v_qt_cycb := 0;
           if v_count > 0 then
             select v into v_qt_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005818
                   and w100 = v_bmid;
           end if;
            --ʼֵ(

           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005819
                 and w100 = v_bmid;
           v_qt_gyjz := 0;
           if v_count > 0 then
             select v into v_qt_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005819
                   and w100 = v_bmid;
           end if;
           --гɱ(ϼƣ
           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005820
                 and w100 = v_bmid;
           v_hj_cycb := 0;
           if v_count > 0 then
             select v into v_hj_cycb
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005820
                   and w100 = v_bmid;
           end if;
            --ĩʲֵ(ϼƣ

           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005821
                 and w100 = v_bmid;
           v_hj_gyjz := 0;
           if v_count > 0 then
             select v into v_hj_gyjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005821
                   and w100 = v_bmid;
           end if;
            --ʣʽ

           select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005822
                 and w100 = v_bmid;
           v_sykyzj := 0;
           if v_count > 0 then
             select v into v_sykyzj
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005822
                   and w100 = v_bmid;
           end if;
           --ĩʲֵ
            select count(v) into v_count
           from T_B04_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005823
                 and w100 = v_bmid;
           v_qmzcjz := 0;
           if v_count > 0 then
             select v into v_qmzcjz
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005823
                   and w100 = v_bmid;
           end if;
         /*--ܼ
             select sum(v) into v_sykyzj
             from T_B04_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 in (1005821,1005822)
                   and w100 = v_bmid;
          */

        v_xh :=v_xh+1;
        --вֵ
        insert into T_CSRC0128_E1_3_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           A5,B5,C5,D5,E5,F5,G5,H5,I5,J5,K5,L5,M5,N5,
           O5,P5,Q5,R5,S5,T5,U5,V5,W5,X5,Y5,Z5,AA5,AB5,AC5,AD5,AE5,AF5,AG5,AH5)
        values(v_P001,v_bmid,0,null,1,0,
           v_xh,v_planname,v_xm_11,v_xm_22,v_qmstje,v_gp_cycb,v_gp_gyjz,v_jj_cycb,v_jj_gyjz,v_zq_cycb,v_zq_gyjz,v_zczczq_cycb,
           v_zczczq_gyjz,v_qh_qmbzjje,v_yhlcjh_cycb,v_yhlcjh_gyjz,v_xtjh_cycb,v_xtjh_gyjz,v_zxzcgljh_cycb,v_zxzcgljh_gyjz, v_qmye,v_qt_cycb,v_qt_gyjz,
           null,v_hj_cycb,v_hj_gyjz,v_sykyzj,v_zhg,v_nhg,v_rzgm,v_rqgm,v_wcdbbl,v_cjzqye,v_qmzcjz
           );

           fetch c_work_plan into v_planid;

      end loop;
    close c_work_plan;

    --ϼֵ
    insert into T_CSRC0128_E1_3_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           E5,F5,G5,H5,I5,J5,K5,L5,M5,N5,
           O5,P5,Q5,R5,S5,T5,U5,V5,W5,Y5,Z5,AA5,AB5,AC5,AD5,AE5,AF5,AG5,AH5)
    select v_P001,v_bmid,0,null,null,1,
    sum(E5),sum(F5),sum(G5),sum(H5),sum(I5),sum(J5),sum(K5),sum(L5),
    sum(M5),sum(N5),sum(O5),sum(P5),sum(Q5),sum(R5),sum(S5),sum(T5),sum(U5),sum(V5),sum(W5),sum(Y5),sum(Z5),sum(AA5),sum(AB5),sum(AC5),
    sum(AD5),sum(AE5),sum(AF5),sum(AG5),sum(AH5)
      from T_CSRC0128_E1_3_2
     where BBQ=v_P001 and USERID=v_bmid and ISHJ=0;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130040 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130040;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130040 and a008=v_bmid;
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130040!';
                --errmsg:=sqlerrm;
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130050
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130050(
         errcode out int, errmsg out varchar2,
         v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
   is
         v_temp varchar(256);
         --v_userid number;
         v_bmid number;
         v_count number;
         v_sum number;
          v_planid varchar(26);        --ƻid
          v_planname varchar(256);--ƻ

         v_xh number;--ĿID
          v_xm_1   number;         --Ŀתǰid
          v_xm_11  varchar(30);    --Ŀתid

         v_qmstje number;--ĩн
         --Ʊ
         v_gp_cycb number;--гɱ
         v_gp_gyjz number;--ʼֵ
         --
         v_jj_cycb number;--гɱ
         v_jj_gyjz number;--ʼֵ
         -- ծȯ
         v_zq_cycb number;--гɱ
         v_zq_gyjz number;--ʼֵ
         --ʲ֧֤ȯ
         v_zczczq_cycb number;--гɱ
         v_zczczq_gyjz number;--ʼֵ
         --ڻ
         v_qh_qmbzjje number;--ĩ֤

         --Ƽƻ
         v_yhlcjh_cycb number;--гɱ
         v_yhlcjh_gyjz number;--ʼֵ

         --мƻ
         v_xtjh_cycb number;--гɱ
         v_xtjh_gyjz number;--ʼֵ

         --רʲƻ
         v_zxzcgljh_cycb number;--гɱ
         v_zxzcgljh_gyjz number;--ʼֵ

         --ʲȨ
         v_zcsyq_cycb number;
         v_zcsyq_gyjz number;
         v_zcsyq_bz varchar(255);

         --Эڴ
         v_qmye number;


         --
         v_qt_cycb number;--гɱ
         v_qt_gyjz number;--ʼֵ
         v_qt_bz varchar(255);

         --ϼ

         v_hj_cycb number;--гɱ
         v_hj_gyjz number;--ʼֵ


         v_sykyzj number;--ʣʽ

         --v_zj number;--ܼ

         v_zhg number; -- ع
         v_nhg number; -- ع
         v_rzgm number;-- ʹģ
         v_rqgm number;-- ȯģ
         v_wcdbbl number;--ά
         v_cjzqye number; --֤ȯ
         v_qmzcjz number ;--ĩʲֵ
      /*רʲҪֲ  */

     cursor c_work_plan is
      select t.p002 From t_b05_t011 t where t.b001=1002001 and t.a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER)
      order by t.p001;

begin
    errcode:=1;
    errmsg := 'ɱɹ';
    select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;--ȡID
    v_xh :=0;--ʼֵ

    delete from T_CSRC0128_E1_3_3 where BBQ=v_P001 and USERID=v_bmid;

    open c_work_plan;
      fetch c_work_plan into v_planid;
      while c_work_plan%found
      loop
          --̨ȡϢ
          select a.a003,a.p002
             into v_planname,v_xm_11
           from t_b05_t011 a
           where a.p002=v_planid and a.a100 =(select p002 from krcs.t_sys_user where p001 = v_KJAXUSER);


           --ع
           select count(v) into v_count
           from T_B06_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005701
                 and w100 = v_bmid;
           v_zhg := 0;
           if v_count > 0 then
             select v into v_zhg
             from T_B06_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005701
                   and w100 = v_bmid;
           end if;
           --ع
           select count(v) into v_count
           from T_B06_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005702
                 and w100 = v_bmid;
           v_nhg := 0;
           if v_count > 0 then
             select v into v_nhg
             from T_B06_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005702
                   and w100 = v_bmid;
           end if;
           --ʹģ
           select count(v) into v_count
           from T_B06_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005703
                 and w100 = v_bmid;
           v_rzgm := 0;
           if v_count > 0 then
             select v into v_rzgm
             from T_B06_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005703
                   and w100 = v_bmid;
           end if;
             --ȯģ
           select count(v) into v_count
           from T_B06_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005704
                 and w100 = v_bmid;
           v_rqgm := 0;
           if v_count > 0 then
             select v into v_rqgm
             from T_B06_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005704
                   and w100 = v_bmid;
           end if;
           --άֵ
           select count(v) into v_count
           from T_B06_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005705
                 and w100 = v_bmid;
           v_wcdbbl := 0;
           if v_count > 0 then
             select v into v_wcdbbl
             from T_B06_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005705
                   and w100 = v_bmid;
           end if;
           --֤ȯ
           select count(v) into v_count
           from T_B06_F105
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005706
                 and w100 = v_bmid;
           v_cjzqye := 0;
           if v_count > 0 then
             select v into v_cjzqye
             from T_B06_F105
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005706
                   and w100 = v_bmid;
           end if;

           ---Ͷ----
           --ĩн
           select count(v) into v_count
           from T_B06_F104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005801
                 and w100 = v_bmid;
           v_qmstje := 0;
           if v_count > 0 then
             select v into v_qmstje
             from T_B06_F104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005801
                   and w100 = v_bmid;
           end if;
           --гɱ(Ʊ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005802
                 and w100 = v_bmid;
           v_gp_cycb := 0;
           if v_count > 0 then
             select v into v_gp_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005802
                   and w100 = v_bmid;
           end if;
           --ʼֵ(Ʊ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005803
                 and w100 = v_bmid;
           v_gp_gyjz := 0;
           if v_count > 0 then
             select v into v_gp_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005803
                   and w100 = v_bmid;
           end if;
           --гɱ()
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005804
                 and w100 = v_bmid;
           v_jj_cycb := 0;
           if v_count > 0 then
             select v into v_jj_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005804
                   and w100 = v_bmid;
           end if;
           --ʼֵ()
            select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005805
                 and w100 = v_bmid;
           v_jj_gyjz := 0;

           if v_count > 0 then
             select v into v_jj_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005805
                   and w100 = v_bmid;
           end if;
           --гɱ(ծȯ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005806
                 and w100 = v_bmid;
           v_zq_cycb := 0;
           if v_count > 0 then
             select v into v_zq_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005806
                   and w100 = v_bmid;
           end if;
           --ʼֵ(ծȯ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005807
                 and w100 = v_bmid;
           v_zq_gyjz := 0;
           if v_count > 0 then
             select v into v_zq_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005807
                   and w100 = v_bmid;
           end if;
           --гɱ(ʲ֧֤ȯ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005808
                 and w100 = v_bmid;
           v_zczczq_cycb := 0;
           if v_count > 0 then
             select v into v_zczczq_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005808
                   and w100 = v_bmid;
           end if;
            --ʼֵ(ʲ֧֤ȯ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005809
                 and w100 = v_bmid;
           v_zczczq_gyjz := 0;
           if v_count > 0 then
             select v into v_zczczq_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005809
                   and w100 = v_bmid;
           end if;

           -----------
           --ĩ֤
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005810
                 and w100 = v_bmid;
           v_qh_qmbzjje := 0;
           if v_count > 0 then
             select v into v_qh_qmbzjje
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005810
                   and w100 = v_bmid;
           end if;
            --гɱ(Ƽƻ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005811
                 and w100 = v_bmid;
           v_yhlcjh_cycb := 0;
           if v_count > 0 then
             select v into v_yhlcjh_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005811
                   and w100 = v_bmid;
           end if;
--ʼֵ(Ƽƻ

           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005812
                 and w100 = v_bmid;
           v_yhlcjh_gyjz := 0;
           if v_count > 0 then
             select v into v_yhlcjh_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005812
                   and w100 = v_bmid;
           end if;
            --гɱ(мƻ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005813
                 and w100 = v_bmid;
           v_xtjh_cycb := 0;
           if v_count > 0 then
             select v into v_xtjh_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005813
                   and w100 = v_bmid;
           end if;
           --ʼֵ(мƻ

           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005814
                 and w100 = v_bmid;
           v_xtjh_gyjz := 0;
           if v_count > 0 then
             select v into v_xtjh_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005814
                   and w100 = v_bmid;
           end if;
            --гɱ(רʲƻ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005815
                 and w100 = v_bmid;
           v_zxzcgljh_cycb := 0;
           if v_count > 0 then
             select v into v_zxzcgljh_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005815
                   and w100 = v_bmid;
           end if;
           --ʼֵ(רʲƻ

           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005816
                 and w100 = v_bmid;
           v_zxzcgljh_gyjz := 0;
           if v_count > 0 then
             select v into v_zxzcgljh_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005816
                   and w100 = v_bmid;
           end if;

           --гɱ(ʲȨ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005817
                 and w100 = v_bmid;
           v_zcsyq_cycb := 0;
           if v_count > 0 then
             select v into v_zcsyq_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005817
                   and w100 = v_bmid;
           end if;

           --ʼֵ(ʲȨ)
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005818
                 and w100 = v_bmid;
           v_zcsyq_gyjz := 0;
           if v_count > 0 then
             select v into v_zcsyq_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005818
                   and w100 = v_bmid;
           end if;


           --ע(ʲȨ)
           select count(*) into v_count
           from T_DB_06_104
           where /*p001 = substr(v_P001,0,6)
                 and */p001 = v_planid
                 /*and p003 = 1005819*/
                 and w100 = v_bmid;
           v_zcsyq_bz := 0;
           if v_count > 0 then
             select a024 into v_zcsyq_bz
             from T_DB_06_104
             where /*p001 = substr(v_P001,0,6)
                   and*/ p001 = v_planid
                  /* and p003 = 1005819*/
                   and w100 = v_bmid;
           end if;

            --ĩ
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005820
                 and w100 = v_bmid;
           v_qmye := 0;
           if v_count > 0 then
             select v into v_qmye
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005820
                   and w100 = v_bmid;
           end if;
           --гɱ(
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005821
                 and w100 = v_bmid;
           v_qt_cycb := 0;
           if v_count > 0 then
             select v into v_qt_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005821
                   and w100 = v_bmid;
           end if;
            --ʼֵ(

           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005822
                 and w100 = v_bmid;
           v_qt_gyjz := 0;
           if v_count > 0 then
             select v into v_qt_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005822
                   and w100 = v_bmid;
           end if;

           --ע(ʲȨ)
           select count(*) into v_count
           from T_DB_06_104
           where /*p001 = substr(v_P001,0,6)
                 and */p001 = v_planid
                 /*and p003 = 1005819*/
                 and w100 = v_bmid;
           v_qt_bz := 0;
           if v_count > 0 then
             select a028 into v_qt_bz
             from T_DB_06_104
             where /*p001 = substr(v_P001,0,6)
                   and*/ p001 = v_planid
                  /* and p003 = 1005819*/
                   and w100 = v_bmid;
           end if;

           --гɱ(ϼƣ
           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005824
                 and w100 = v_bmid;
           v_hj_cycb := 0;
           if v_count > 0 then
             select v into v_hj_cycb
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005824
                   and w100 = v_bmid;
           end if;
            --ĩʲֵ(ϼƣ

           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005825
                 and w100 = v_bmid;
           v_hj_gyjz := 0;
           if v_count > 0 then
             select v into v_hj_gyjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005825
                   and w100 = v_bmid;
           end if;
            --ʣʽ

           select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005826
                 and w100 = v_bmid;
           v_sykyzj := 0;
           if v_count > 0 then
             select v into v_sykyzj
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005826
                   and w100 = v_bmid;
           end if;
           --ĩʲֵ
            select count(v) into v_count
           from T_B06_f104
           where p001 = substr(v_P001,0,6)
                 and p002 = v_planid
                 and p003 = 1005827
                 and w100 = v_bmid;
           v_qmzcjz := 0;
           if v_count > 0 then
             select v into v_qmzcjz
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 = 1005827
                   and w100 = v_bmid;
           end if;
         /*--ܼ
             select sum(v) into v_sykyzj
             from T_B06_f104
             where p001 = substr(v_P001,0,6)
                   and p002 = v_planid
                   and p003 in (1005821,1005822)
                   and w100 = v_bmid;
          */

        v_xh :=v_xh+1;
        --вֵ
        insert into T_CSRC0128_E1_3_3(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           A5,B5,C5,D5,E5,F5,G5,H5,I5,J5,K5,L5,M5,N5,
           O5,P5,Q5,R5,S5,T5,U5,V5,W5,X5,Y5,Z5,AA5,AB5,AC5,AD5,AE5,AF5,AG5,AH5,AI5)
        values(v_P001,v_bmid,0,null,1,0,
           v_xh,v_planname,v_qmstje,v_gp_cycb,v_gp_gyjz,v_jj_cycb,v_jj_gyjz,v_zq_cycb,v_zq_gyjz,v_zczczq_cycb,
           v_zczczq_gyjz,
           v_qh_qmbzjje,
           v_yhlcjh_cycb,v_yhlcjh_gyjz,v_xtjh_cycb,v_xtjh_gyjz,v_zxzcgljh_cycb,v_zxzcgljh_gyjz,
           v_zcsyq_cycb,v_zcsyq_gyjz,v_zcsyq_bz,
           v_qmye,v_qt_cycb,v_qt_gyjz,
           v_qt_bz,v_hj_cycb,v_hj_gyjz,v_sykyzj,v_zhg,v_nhg,v_rzgm,v_rqgm,v_wcdbbl,v_cjzqye,v_qmzcjz
           );

           fetch c_work_plan into v_planid;

      end loop;
    close c_work_plan;

    --ϼֵ
    insert into T_CSRC0128_E1_3_3(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           C5,D5,E5,F5,G5,H5,I5,J5,K5,L5,M5,N5,
           O5,P5,Q5,R5,S5,T5,V5,W5,Z5,AA5,AB5,AC5,AD5,AE5,AF5,AG5,AH5,AI5)
    select v_P001,v_bmid,0,null,null,1,
    sum(c5),sum(d5),sum(E5),sum(F5),sum(G5),sum(H5),sum(I5),sum(J5),sum(K5),sum(L5),
    sum(M5),sum(N5),sum(O5),sum(P5),sum(Q5),sum(R5),sum(S5),sum(T5),sum(V5),sum(W5),sum(Z5),sum(AA5),sum(AB5),sum(AC5),
    sum(AD5),sum(AE5),sum(AF5),sum(AG5),sum(AH5),sum(aI5)
      from T_CSRC0128_E1_3_3
     where BBQ=v_P001 and USERID=v_bmid and ISHJ=0;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130050 and a008=v_bmid;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130050;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130050 and a008=v_bmid;
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130050!';
                --errmsg:=sqlerrm;
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130060
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130060(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER integer;
    v_count integer;
    v_status number;
    v_a100  number;
    /*begintime varchar2(8);
    endtime varchar2(8);*/
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100 from krcs.t_sys_user where p001 =v_KJAXUSER;
    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_E1_4 where BBQ=v_P001 and USERID=v_USER;

   /* select TO_CHAR(a005,'YYYYMMDD'),TO_CHAR(a006,'YYYYMMDD') into begintime,endtime
    from t_b00_d004
    where a002=1013001 and c001=1001101 and d100=1006002;
    */


    insert into T_CSRC0707_E1_4 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,rownum,b.a002,a.p003,a.a004,a.a005,a.a006
      from t_b12_t002 a,t_b12_d002 b
      where a.p002=b.p001 and a.a100=v_a100 ;
    --ϼ
    select count(*) into v_count
      from t_b12_t002 a,t_b12_d002 b
      where a.p002=b.p001 and a.a100=v_a100 ;
    insert into T_CSRC0707_E1_4 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,D2,E2)
      select v_P001,v_USER,0,NULL,null,1,v_count,sum(a.a004),sum(a.a005)
      from t_b12_t002 a,t_b12_d002 b
      where a.p002=b.p001 and a.a100=v_a100  ;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130060 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-4'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130060;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130060 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130060!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130070
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130070(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER integer;
    v_status number;
     /*ضƷϯλϢרܱ  */
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_E1_5 where BBQ=v_P001 and userid = v_USER;

    insert into T_CSRC0707_E1_5 (BBQ,USERID,BTYPE,OPTION1,SHTAG,D2,E3,F3,C4,C5,D5,E5,F5)
      values(v_P001,v_USER,0,NULL,1,
      (select A002 from t_bks_t010 where p001=1001 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)),
      (select A002 from t_bks_t010 where p001=1002 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)),
      (select A002 from t_bks_t010 where p001=1003 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)),
      (select A002 from t_bks_t010 where p001=1004 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)),
      (select A002 from t_bks_t010 where p001=1005 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)),
      (select A002 from t_bks_t010 where p001=1006 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)),
      (select A002 from t_bks_t010 where p001=1007 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)),
      (select A002 from t_bks_t010 where p001=1008 and a100 in (select p002 from KRCS.T_SYS_USER where p001 = v_KJAXUSER)));
    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130070 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-5'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130070;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130070 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130070!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130080
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130080(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER integer;
    v_status number;
     /*ʹϵͳ*/
begin
    errcode:=1;
    errmsg := 'ɱɹ';

      select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_E1_6_1 where BBQ=v_P001 and userid =v_USER;

    insert into T_CSRC0707_E1_6_1 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2,G2)
      select v_P001,v_USER,0,NULL,1,0,rownum,b.a002,a.P002,a.A003,a.A004,a.A005,a.A007
      from (select * from T_B99_T002 where b001=1002001 and a100 = (select p002 from KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER)) a,T_CTL_D010 b
      WHERE a.P001=b.P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130080 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130080;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130080 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130080!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130090
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130090(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER integer;
    v_status number;
     /*Ӳ */
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_E1_6_2 where BBQ=v_P001 and userid = v_USER;

    insert into T_CSRC0707_E1_6_2(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2)
      select v_P001,v_USER,0,NULL,1,0,rownum,a002,a003,a005,a004,a006 from t_b99_t003 where b001=1002001 and a100 = (select p002 from KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER);
    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130090 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130090;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130090 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130090!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130100
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130100(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER integer;
    v_status number;
    /*¹ʱ*/
begin
    errcode:=1;
    errmsg := 'ɱɹ';

      select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_E1_6_3 WHERE BBQ=v_P001 and userid = v_USER;

    insert into T_CSRC0707_E1_6_3(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2,G2,H2,I2)
      select v_P001,v_USER,0,NULL,1,0,rownum,a.p001,a.P002,a.P003,a.P004,a.P005,a.P006,a.P007,a.P008
      from T_B99_T004 a
      where a.b001=1002001 and a100 = (select p002 from KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER);

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130100 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130100 ;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130100 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130100!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130110
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130110(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER  integer;
    v_status number;
    v_a100 number;
    /*Ӫҵ*/
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    select p002 into v_a100 from KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER;
    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0707_E1_6_4 WHERE BBQ=v_P001 and userid = v_USER;

    insert into T_CSRC0707_E1_6_4 (BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2,G2)
      select v_P001,v_USER,0,NULL,1,0,rownum,decode(b.p002,1001101,'T',1001102,'F'),
             (select count(*) from KRCS.T_CTL_T036 where a008=1023008 AND  w100 = v_a100),
             (select count(*) from KRCS.T_CTL_T036 where a008=1023010 AND  w100 = v_a100),
            /* decode(b.p002,
                    1001101,
                   (select count(*) from KRCS.T_CTL_T036 where a008=1023008 and a019=1001101),
                   1001102,
                   (select count(*) from KRCS.T_CTL_T036 where a008=1023008 and a019=1001102)
                  ),*/
                (select count(*) from KRCS.T_CTL_T036 where a008=1023008 and a019=1001101 AND  w100 = v_a100),
             c.a003,a.a007
      from t_b99_t005 a,KRCS.t_b00_d098 b,KRCS.t_b00_d098 c
      WHERE a.a002 = b.p002 and a.a006 = c.p002 and a.a100 = v_a100;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130110 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130110;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130110 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130110!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130120
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130120(errcode    out int,
                                                 errmsg     out varchar2,
                                                 v_KJAXUSER varchar2,v_TASK varchar2,
                                                 v_P001     varchar2,
                                                 v_P002     varchar2,
                                                 v_P003     varchar2)
is
           v_bmid number;
           v_temp varchar(256);
begin
        errcode:=1;
        errmsg := 'ɱɹ';

        select a012 into v_bmid from KRCS.T_SYS_USER where p001 =v_KJAXUSER;

        update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130120 and a008=v_bmid;
        SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>'||A004||'' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130120;
        INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
         commit;
        exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130120 and a008=v_bmid;
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130120!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130130
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130130(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER  integer;
    v_status number;
    /*Ӫҵ*/
begin
    errcode:=1;
    errmsg := 'ɱɹ';


    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130130 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130130;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130130 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130130!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130140
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130140(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER  integer;
    v_status number;
    /*Ӫҵ*/
begin
    errcode:=1;
    errmsg := 'ɱɹ';


    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130140 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130140;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130140 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130140!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1130150
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1130150(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_USER  integer;
    v_status number;
    /*Ӫҵ */
begin
    errcode:=1;
    errmsg := 'ɱɹ';


    select a.a012 into v_USER
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1130150 and a008=v_USER;
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1130150;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=1130150 and a008=v_USER;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1130150!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1131010
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1131010(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1131010;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0619_F_XXB where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1131020
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1131020(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1131020;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0619_F1_1 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1131030
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1131030(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1131030;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0619_F1_2 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1131040
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1131040(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_count number;
    v_reportid number;
    v_planid number; --ʽ˻
    v_planname varchar2(255);
    
    v_xh number;--ĿID
    v_xm_1  varchar2(20);    
    v_xm_11 varchar2(30);  
    v_xm_2   varchar2(255);  
    v_xm_22  varchar2(255);  
    v_xm_3  varchar(10); 
    v_xm_33  varchar(10); 
    v_xm_4  varchar(10); 
    v_xm_44  varchar(10);
    v_xm_5  varchar(10); 
    v_xm_55  varchar(10);  
    v_xm_6  varchar2(255); 
    v_xm_66  varchar2(255); 
    v_zhye number(18,2);--˻
    v_zhzc number(18,2);--ͻʲ
    v_zhsl number(18,2);--˻
    
    cursor c_work_plan is
      select t.a001 From T_BKS_T101 t 
      order by t.p001;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1131040;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;
      v_xh :=0;--ʼֵ

    delete from T_CSRC0619_F2_1 where BBQ=v_P001 and userid = v_userid;

   open c_work_plan;
      fetch c_work_plan into v_planid;
      while c_work_plan%found
      loop
          --̨ȡϢ
          select a.a002,b.a003,a.a004,a.a005,a.a006,a.a007,a.a008,a.a009,
          a.a010,a.a011,a.a012,a.a013,a.a014
             into v_planname,v_xm_1,v_xm_11,v_xm_2,v_xm_22,v_xm_3,v_xm_33,v_xm_4,
             v_xm_44,v_xm_5,v_xm_55,v_xm_6,v_xm_66
           from t_bks_t101 a,
           (select * from krcs.t_b00_d098 where p001='4105')b
           where a.a003=b.p002 
           and a.A001=v_planid;


           --˻
           select count(a002) into v_count
           from T_DB_31_03
           where p001 = v_planid
                and w100 = v_userid;
           v_zhye := 0;
           if v_count > 0 then
             select a002 into v_zhye
             from T_DB_31_03
             where p001  = v_planid
                   and w100 = v_userid;
           end if;
           --ͻʲ
           select count(a003) into v_count
           from T_DB_31_03
           where p001 = v_planid
                 and w100 = v_userid;
           v_zhzc := 0;
           if v_count > 0 then
             select a003 into v_zhzc
             from T_DB_31_03
             where p001 = v_planid
                   and w100 = v_userid;
           end if;
           --
           select count(a004) into v_count
           from T_DB_31_03
           where p001 = v_planid
                 and w100 = v_userid;
           v_zhsl := 0;
           if v_count > 0 then
             select a004 into v_zhsl
             from T_DB_31_03
             where p001  = v_planid
                   and w100 = v_userid;
           end if;
        v_xh :=v_xh+1;
        --вֵ
        insert into T_CSRC0619_F2_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,
           O3,P3,Q3,R3)
        values(v_P001,v_userid,0,null,1,0,
           v_xh,v_planid,v_planname,v_xm_1,v_xm_11,v_xm_2,v_xm_22,v_xm_3,v_xm_33,v_xm_4,v_xm_44,v_xm_5,v_xm_55,
           v_xm_6,v_zhye,v_zhzc,v_zhsl,v_xm_66
           );

           fetch c_work_plan into v_planid;
      end loop;
    close c_work_plan; 
    insert into T_CSRC0619_F2_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,O3,P3,Q3)
    select v_P001,v_userid,0,null,null,1,
    sum(O3),sum(P3),sum(Q3)
      from T_CSRC0619_F2_1
     where BBQ=v_P001 and USERID=v_userid and ISHJ=0;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
 /*   exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;\*޸ת״̬ *\
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;*/
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1131050
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1131050(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
    v_planid varchar2(100); --֤ȯ˻˺
    v_planname varchar2(255);
    v_count  number; 
    
    v_xh number;--ĿID
    v_xm_1  varchar2(100);
    v_xm_11 varchar2(255);
    v_xm_2  varchar2(50);
    v_xm_22 varchar2(12);
    v_xm_3  date;
    v_xm_33 date;
    v_xm_4  varchar2(200);
    v_xm_44 varchar2(255);
    v_xm_5  number(18,2);
    v_zhsz  number(18,2);
    v_yjl  number(18,2);
    cursor c_work_plan is
      select t.a003 From T_BKS_T102 t 
      order by t.p001;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1131050;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;
      v_xh :=0;--ʼֵ

    delete from T_CSRC0619_F2_2 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/
    open c_work_plan;
      fetch c_work_plan into v_planid;
      while c_work_plan%found
      loop
          --̨ȡϢ
          select a.a001,a.a002,a.a004,a.a005,a.a006,a.a007,a.a008,a.a009,
          a.a010,a.a011
             into v_xm_1,v_planname,v_xm_11,v_xm_2,v_xm_22,v_xm_3,v_xm_33,v_xm_4,
             v_xm_44,v_xm_5
           from t_bks_t102 a
           where a.A003=v_planid;


           --ĩֵ
           select count(a002) into v_count
           from T_DB_31_04
           where p001 = v_planid
                and w100 = v_userid;
           v_zhsz := 0;
           if v_count > 0 then
             select a002 into v_zhsz
             from T_DB_31_04
             where p001  = v_planid
                   and w100 = v_userid;
           end if;
         /*  --Ӷ
           select count(a003) into v_count
           from T_DB_31_04
           where a001 = v_planid
                 and w100 = v_userid;
           v_yjl := 0;
           if v_count > 0 then
             select a003 into v_yjl
             from T_DB_31_04
             where a001 = v_planid
                   and w100 = v_userid;
           end if;*/
          
        v_xh :=v_xh+1;
        --вֵ
        insert into T_CSRC0619_F2_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
           A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2)
        values(v_P001,v_userid,0,null,1,0,
           v_xh,v_xm_1,v_planname,v_planid,v_xm_11,v_xm_2,v_xm_22,v_xm_3,v_xm_33,v_xm_4,v_zhsz,v_xm_5,v_xm_44
           );

           fetch c_work_plan into v_planid;
      end loop;
    close c_work_plan; 
     insert into T_CSRC0619_F2_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,K2)
    select v_P001,v_userid,0,null,null,1,
    sum(K2)
      from T_CSRC0619_F2_2
     where BBQ=v_P001 and USERID=v_userid and ISHJ=0;

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
   /* exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;\*޸ת״̬ *\
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;*/
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132010
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132010(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132010;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_XXB where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132020
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132020(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132020;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_1 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132030
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132030(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132030;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_2_1 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132040
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132040(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132040;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_2_2 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132050
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132050(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132050;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_2_3 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132060
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132060(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132060;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_2_4 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132070
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132070(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132070;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_3 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132080
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132080(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132080;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_3_1 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132090
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132090(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132090;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_3_2 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132100
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132100(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132100;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_4 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132110
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132110(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132110;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_5 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132120
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132120(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132120;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_6 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1132130
prompt ==========================================
prompt
create or replace procedure cisp_makereport_1132130(errcode out int,
                                                 errmsg out varchar2,
                                                 v_KJAXUSER varchar2,
                                                 v_TASK varchar2,
                                                 v_P001 varchar2,
                                                 v_P002 varchar2,
                                                 v_P003 varchar2,
                                                 v_type varchar2)
is
    v_temp varchar(256);
    v_userid number;
    v_reportid number;
begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --IDֵ
    v_reportid := 1132130;

    select decode(v_type,'corp',b.A002, to_char(a.a012)) into v_userid
     from KRCS.T_SYS_USER a, KRCS.T_CTL_T036 b
    where a.P001 = v_KJAXUSER
      and a.P002 = b.P001;

    delete from T_CSRC0811_ZQGS_7 where BBQ=v_P001 and userid = v_userid;

    /**ҵ߼**/

    update KRCS.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=v_reportid and a008=V_USERID;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T024 SET A010=1015002 WHERE P001=v_reportid and a008=V_USERID;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_makereport_'||v_reportid||'!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1205010
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1205010(errcode    out int,
                                                errmsg     out varchar2,
                                                v_KJAXUSER varchar2,
						v_TASK varchar2,
                                                v_P001     varchar2,
                                                v_P002     varchar2,
                                                v_P003     varchar2) is
  v_temp    varchar(256);
  v_userid    varchar2(18);
  V_ORGNAME VARCHAR(51);
  V_ADDRESS VARCHAR(255);
  V_NUM     NUMBER;
  V_SALES   NUMBER;
  --add hucc
  A026   NUMBER;
  A027   NUMBER;
  A028   NUMBER;
  A029   NUMBER;
  A030   NUMBER;
  --end by
  V_EP002   VARCHAR(24);
  V_EP003   VARCHAR(24);
  V_EP004   VARCHAR(24);
  V_EP012   VARCHAR(24);
  V_EP013   VARCHAR(24);
  V_EP014   VARCHAR(24);
  V_EP015   VARCHAR(24);
  v_count   integer;
  v_count1  integer;
  /*Ϣ  */
begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  --ȡػ,Ӫҵ,ַ..
  SELECT T2.A002, T2.A003, T2.A005, T2.A009, T2.A021, T2.A026, T2.A027, T2.A028, T2.A029, T2.A030
    into v_userid, V_ORGNAME, V_ADDRESS, V_NUM, V_SALES,A026,A027,A028,A029,A030
    FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   WHERE T1.P001 = v_KJAXUSER
     AND T1.P002 = T2.P001;

     /* ɾͬһڵ */
  delete from T_CSRC0328_B_B00
   WHERE BBQ = v_P001
     and USERID = v_userid;

select count(*) into v_count   from t_bks_t032 where p001=1033001  AND P002 IN (SELECT P002 FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER);
select count(*) into v_count1   from t_bks_t032 where p001=1033002  AND P002 IN (SELECT P002 FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER);
if v_count=1 then
  SELECT A002, A003, A004
    INTO V_EP002, V_EP003, V_EP004
    FROM T_BKS_T032
   WHERE P001 = 1033001
     AND P002 IN (SELECT P002 FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER);
 end if;
 if v_count1=1 then
  SELECT A002, A003, A004, A005
    INTO V_EP012, V_EP013, V_EP014, V_EP015
    FROM T_BKS_T032
   WHERE P001 = 1033002
     AND P002 IN (SELECT P002 FROM KRCS.T_SYS_USER WHERE P001 = v_KJAXUSER);
 end if;
  INSERT INTO T_CSRC0328_B_B00
    (BBQ,
     USERID,
     BTYPE,
     OPTION1,
     SHTAG,
     UPID,
     G6,
     USERNAME,
     I9,
     C10,
     --add by
     C11,
     C13,
     I11,
     I12,
     I13,
     I14,
     --end by
     --C14,
     C18,
     --F14,
     F18,
     --I14,
     I18,
     --C15,
     C19,
     --F15,
     F19,
     --I15,
     I19,
     --L15
     l19
    )
  VALUES
    (v_P001,
     v_userid,
     '0',
     '0',
     '0',
     '--',
     SYSDATE,
     V_ORGNAME,
     V_NUM,
     V_ADDRESS,
     A028,
     V_SALES,
     A029,
     A030,
     A026,
     A027,
     V_EP002,
     V_EP003,
     V_EP004,
     V_EP012,
     V_EP013,
     V_EP014,
     V_EP015);
  update KRCS.T_SYS_T014 SET A010 = 1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001 = 1205010 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
  SELECT 'ɱ100' || A002
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1205010;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;
  exception when others then
  rollback;
  update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1205010 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
  errcode := 1;
  errmsg := 'ڴ洢CISP_MAKEREPORT_1205010!';
  return;

end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1205020
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1205020(errcode    out int,
                                                    errmsg     out varchar2,
                                                    v_KJAXUSER varchar2,
                                                    v_TASK     varchar2,
                                                    v_P001     varchar2,
                                                    v_P002     varchar2,
                                                    v_P003     varchar2) is
  v_temp     varchar(2000);
  v_sql      varchar(2000);
  v_logic    varchar(1);
  v_row      integer;
  v_colname1 varchar(256);
  v_colname2 varchar(256);
  v_colname3 varchar(256);
  v_EP001    integer;
  v_EA002    integer;
  v_USER     varchar2(18);
  v_EA003    number(19, 2);
  v_EA004    varchar(256);
  cursor cur_work is
  --ʾ
    select a.a001, a.a002, a.a003, a.a004
      from t_bks_t027 a
     where a.p001 =
           (select P002 from KRCS.T_SYS_USER where P001 = V_KJAXUSER)
    union
    select a.a001, a.a002, a.a003, a.a004
      from t_bks_t028 a
     where a.p001 =
           (select P002 from KRCS.T_SYS_USER where P001 = V_KJAXUSER)
    union
    select a.a001, a.a002, a.a003, a.a004
      from t_bks_t029 a
     where a.p001 =
           (select P002 from KRCS.T_SYS_USER where P001 = V_KJAXUSER)
    union
    select a.a001, a.a002, a.a003, a.a004
      from t_bks_t030 a
     where a.p001 =
           (select P002 from KRCS.T_SYS_USER where P001 = V_KJAXUSER);

begin
  errcode := 1;
  errmsg  := 'ɱɹ';
  --ѯ
  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
  --ɾͬһͬһ
  delete from T_CSRC0328_B_A0
   where BBQ = v_P001
     and userid = v_USER;
  --̶
  insert into T_CSRC0328_B_A0
    (BBQ, Userid, Btype, Option1, Shtag)
  values
    (v_P001, v_USER, '0', '', '0');

  v_row := 6;
  open cur_work;
  fetch cur_work
    into v_EP001, v_EA002, v_EA003, v_EA004;
  while cur_work%found loop
    v_logic := '';
    if v_EA002 = 1001101 then
      v_logic := 'T';
    end if;
    if v_EA002 = 1001102 then
      v_logic := 'F';
    end if;
    --ǻ
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0328_B_A0'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname1;
    --
    v_row := v_row + 1;
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0328_B_A0'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname2;
  
    --ע
    v_row := v_row + 1;
    v_sql := 'select CNAME ' || 'from SYS.Col' ||
             ' where TNAME=''T_CSRC0328_B_A0'' and COLNO=' || v_row;
  
    execute immediate v_sql
      into v_colname3;
  
    v_sql := 'update T_CSRC0328_B_A0 set ' || v_colname1 || '=''' ||
             v_logic || ''',' || v_colname3 || '=''' || v_EA004 || ''',' ||
             v_colname2 || '=''' || v_EA003 || '''' || ' where userid=''' ||
             v_USER || ''' and BBQ=''' || v_P001 || '''';
    execute immediate v_sql;
  
    fetch cur_work
      into v_EP001, v_EA002, v_EA003, v_EA004;
    v_row := v_row + 1;
    dbms_output.put_line(v_sql);
  end loop;
  close cur_work;

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = 1205020
     and a008 = (select P002 from KRCS.T_SYS_USER where P001 = v_KJAXUSER);
  SELECT 'ɣ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>B0' || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1205020;

  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);

  commit;
exception
  when others then
    rollback;
    update KRCS.T_SYS_T014
       SET A010 = 1015002
     WHERE P001 = 1205020
       and a008 =
           (select P002 from KRCS.T_SYS_USER where P001 = v_KJAXUSER);
    errcode := 0;
    errmsg  := 'ڴ洢CISP_MAKEREPORT_1205020!';
    return;
  
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1205030
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1205030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2
      )
is

       v_temp varchar(256);
       v_USER    varchar2(18);
       v_ORGANID  integer;
       v_data1 varchar2(255);
       v_count integer;

begin
       errcode:=1;
       errmsg := 'ɱɹ';

      --ȡ--
       SELECT T2.A002 into v_USER
       FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
       WHERE T1.P001 = v_KJAXUSER
         AND T1.P002 = T2.P001;

       --ȡӪҵID--
       select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;

       select count(*) into v_count from T_DB_B1_03 where p002 = 3001 and p001 = V_ORGANID;
       if(v_count>0) then
           select A003 into v_data1
           from  T_DB_B1_03
           where P002 = 3001 and p001=v_ORGANID;
       update T_CSRC0328_B_A1_1 set B32 = v_data1 where BBQ = v_p001 and USERID=v_USER;

       end if;

       update KRCS.T_SYS_T014 SET A010=1015001 WHERE P001=1205030 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
       SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1205030;
       INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;
       exception when others then
                  rollback;
                  update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1205030 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);--޸ת״̬ --
                  errcode := 0;
                  errmsg := 'ڴ洢CISP_MAKEREPORT_1205030!';
                  return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1205040
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1205040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2)
is
       v_temp varchar(256);
       v_USER  varchar2(18);
       v_ORGANID  integer;
       v_data1 varchar2(255);
       v_data2 varchar2(255);
       v_data3 varchar2(255);
       v_data4 varchar2(255);
       v_data5 varchar2(255);
       v_data6 varchar2(255);
       v_data7 varchar2(255);
       v_data8 varchar2(255);
       v_data9 varchar2(255);
       v_data10 varchar2(255);
       v_data11 varchar2(255);
       v_data12 varchar2(255);
       v_data13 varchar2(255);
       v_data14 varchar2(255);
       v_data15 varchar2(255);
       v_data16 varchar2(255);
       v_data17 varchar2(255);
       v_data18 varchar2(255);
       v_data19 varchar2(255);
       v_data20 varchar2(255);
       v_data21 varchar2(255);
       v_data22 varchar2(255);
       v_data23 varchar2(255);
       v_data24 varchar2(255);
       v_data25 varchar2(255);
       v_data26 varchar2(255);
       v_data27 varchar2(255);
       v_data28 varchar2(255);
       v_data29 varchar2(255);
       v_data30 varchar2(255);
       v_data31 varchar2(255);
       v_count integer;
       v_count1 integer;

begin
       errcode:=1;
       errmsg := 'ɱɹ';

       --ȡ--
       SELECT T2.A002 into v_USER
       FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
       WHERE T1.P001 = v_KJAXUSER
         AND T1.P002 = T2.P001;

       --ȡӪҵID--
       select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;

       select count(*) into v_count from T_DB_B2_01 where p002 = 1001 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data1
           from  T_DB_B2_01
           where P002 = 1001 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F3 = v_data1 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1002 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data2
           from  T_DB_B2_01
           where P002 = 1002 and p001=v_ORGANID;
            update T_CSRC0328_B_A2_1 set F4 = v_data2 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1003 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data3
           from  T_DB_B2_01
           where P002 = 1003 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F5 = v_data3 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1004 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data4
           from  T_DB_B2_01
           where P002 = 1004 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F6 = v_data4 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1005 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data5
           from  T_DB_B2_01
           where P002 = 1005 and p001=v_ORGANID;
            update T_CSRC0328_B_A2_1 set F7 = v_data5 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1006 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data6
           from  T_DB_B2_01
           where P002 = 1006 and p001=v_ORGANID;
            update T_CSRC0328_B_A2_1 set F8 = v_data6 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1007 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data7
           from  T_DB_B2_01
           where P002 = 1007 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F9 = v_data7 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1008 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data8
           from  T_DB_B2_01
           where P002 = 1008 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F10 = v_data8 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1009 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data9
           from  T_DB_B2_01
           where P002 = 1009 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F11 = v_data9 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1010 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data10
           from  T_DB_B2_01
           where P002 = 1010 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F12 = v_data10 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1011 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data11
           from  T_DB_B2_01
           where P002 = 1011 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F13 = v_data11 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1012 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data12
           from  T_DB_B2_01
           where P002 = 1012 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F14 = v_data12 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 1013 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data13
           from  T_DB_B2_01
           where P002 = 1013 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F15 = v_data13 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B2_01 where p002 = 2001 and p001 = V_ORGANID;
       if(v_count>0) then
           select A005 into v_data14
           from  T_DB_B2_01
           where P002 = 2001 and p001=v_ORGANID;
           update T_CSRC0328_B_A2_1 set F17 = v_data14 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1010;
       if(v_count1>0) then
       select a.a100 into v_data15
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1010;
       update T_CSRC0328_B_A2_1 set F20 = v_data15 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1020;
       if(v_count1>0) then
       select a.a100 into v_data16
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1020;
        update T_CSRC0328_B_A2_1 set F21 = v_data16 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1030;
       if(v_count1>0) then
       select a.a100 into v_data17
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1030;
       update T_CSRC0328_B_A2_1 set F22 = v_data17 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1040;
       if(v_count1>0) then
       select a.a100 into v_data18
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1040;
       update T_CSRC0328_B_A2_1 set F23 = v_data18 where BBQ = v_p001 and USERID=v_USER;
       end if;


       /*select a.a100 into v_data19
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1050;*/
       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1050;
       if(v_count1>0) then
       select a.a100 into v_data19
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1050;
       update T_CSRC0328_B_A2_1 set F24 = v_data19 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1060;
       if(v_count1>0) then
       select a.a100 into v_data20
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1060;
       update T_CSRC0328_B_A2_1 set F25 = v_data20 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1070;
       if(v_count1>0) then
       select a.a100 into v_data21
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1070;
       update T_CSRC0328_B_A2_1 set F26 = v_data21 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1080;
       if(v_count1>0) then
       select a.a100 into v_data22
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1080;
       update T_CSRC0328_B_A2_1 set F27 = v_data22 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1090;
       if(v_count1>0) then
       select a.a100 into v_data23
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1090;
       update T_CSRC0328_B_A2_1 set F28 = v_data23 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1100;
       if(v_count1>0) then
       select a.a100 into v_data24
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1100;
       update T_CSRC0328_B_A2_1 set F29 = v_data24 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1110;
       if(v_count1>0) then
       select a.a100 into v_data25
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1110;
        update T_CSRC0328_B_A2_1 set F30 = v_data25 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1120;
       if(v_count1>0) then
       select a.a100 into v_data26
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1120;
       update T_CSRC0328_B_A2_1 set F31 = v_data26 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1130;
       if(v_count1>0) then
       select a.a100 into v_data27
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1130;
       update T_CSRC0328_B_A2_1 set F32 = v_data27 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1140;
       if(v_count1>0) then
       select a.a100 into v_data28
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1140;
       update T_CSRC0328_B_A2_1 set F33 = v_data28 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1150;
       if(v_count1>0) then
       select a.a100 into v_data29
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1150;
       update T_CSRC0328_B_A2_1 set F34 = v_data29 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1160;
       if(v_count1>0) then
       select a.a100 into v_data30
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1160;
       update T_CSRC0328_B_A2_1 set F35 = v_data30 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count1
       from T_DB_B2_02 a ,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1170;
       if(v_count1>0) then
       select substrb(catstr(a.a100),1,255) into v_data31
       from T_DB_B2_02 a,T_BKS_T031 b
       where a.p001=b.p001 and a.p001=v_ORGANID and a.p002=b.p002 and b.a004=1170;
       update T_CSRC0328_B_A2_1 set F36 = v_data31 where BBQ = v_p001 and USERID=v_USER;
       end if;



       update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1205040 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
       SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1205040;
       INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;
   /* exception when others then
                  rollback;
                  update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1205040 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);--޸ת״̬ --
                  errcode := 0;
                  errmsg := 'ڴ洢CISP_MAKEREPORT_1205040!';
                  return;*/
end CISP_MAKEREPORT_1205040;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1205050
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1205050(
        errcode out int,        ---ش
        errmsg out varchar2,    ---Ϣ
        v_KJAXUSER varchar2,v_TASK varchar2,    ---û
        v_P001 varchar2,         ---
        v_P002 varchar2,
        v_P003 varchar2) is
         v_temp varchar(256);
         v_userid varchar2(18);
         v_data1 varchar2(255);
         v_data2 varchar2(255);
         v_data3 varchar2(255);
         v_data4 varchar2(255);
         v_data5 varchar2(255);
         v_data6 varchar2(255);
         v_data7 varchar2(255);
         v_data8 varchar2(255);
         v_data9 varchar2(255);
         v_data10 varchar2(255);
         v_data11 varchar2(255);

         v_data100 varchar2(255);
         v_data200 varchar2(255);
         v_data300 varchar2(255);
         v_data400 varchar2(255);
         v_data500 varchar2(255);
         v_data600 varchar2(255);
         v_data700 varchar2(255);
         v_data800 varchar2(255);
         v_data900 varchar2(255);
         v_data1000 varchar2(255);
         v_data1100 varchar2(255);

         v_data10000 varchar2(255);
         v_data20000 varchar2(255);
         v_data30000 varchar2(255);
         v_data40000 varchar2(255);
         v_data50000 varchar2(255);
         v_data60000 varchar2(255);
         v_data70000 varchar2(255);
         v_data80000 varchar2(255);
         v_data90000 varchar2(255);
         v_data100000 varchar2(255);
         v_data110000 varchar2(255);

         v_data1310 varchar2(255);
         v_data1320 varchar2(255);
         v_data1330 varchar2(255);
         v_data1340 varchar2(255);
         v_data1350 varchar2(255);
         v_data1360 varchar2(255);
         v_data1370 varchar2(255);
         v_data1380 varchar2(255);
         v_data1390 varchar2(255);
         v_data1400 varchar2(255);
         v_data1410 varchar2(255);

          v_data40 varchar2(255);
          v_data41 varchar2(255);
          v_data42 varchar2(255);
          v_data43 varchar2(255);
          v_data44 varchar2(255);
          v_data45 varchar2(255);
          v_data46 varchar2(255);
          v_data47 varchar2(255);
          v_data48 varchar2(255);



         v_data51 varchar2(255);
         v_data52 varchar2(255);
         v_data53 varchar2(255);
         v_data54 varchar2(255);


begin
    errcode:=1;
    errmsg := 'ɱɹ';
    /**
    *dsp:104Ӫҵ˻ע
  ***/
       --ȡ--
     select T2.A002 into v_userid
      from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
      where T1.P001 = v_KJAXUSER
        and T1.P002 = T2.P001;
     ----ʽ˻---
    select a005 into v_data1
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1001;

     select a005 into v_data2
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1002;

      select a005 into v_data3
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1003;

     select a005 into v_data4
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
     where P002=1004;

     select a005 into v_data5
      from (select b.P001 as P002, a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
     where P002=1005;


     select a005 into v_data6
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1006;

     select a005 into v_data7
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1007;

      select a005 into v_data8
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1008;

     select a005 into v_data9
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
     where P002=1009;

     select a005 into v_data10
      from (select b.P001 as P002, a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
     where P002=1010;

     select a005 into v_data11
      from (select b.P001 as P002, a005 as a005
          from (select * from  T_DB_B3_01 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
     where P002=1011;

     ---֤ȯ˻----
    select a005 into v_data100
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1001;

     select a005 into v_data200
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
     where P002=1002;

      select a005 into v_data300
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
       where P002=1003;

     select a005 into v_data400
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1004;

     select a005 into v_data500
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1005;

     select a005 into v_data600
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1006;

     select a005 into v_data700
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
     where P002=1007;

      select a005 into v_data800
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001 )
       where P002=1008;

     select a005 into v_data900
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1009;

     select a005 into v_data1000
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1010;

     select a005 into v_data1100
      from (select b.P001 as P002, a.a005 as a005
          from (select * from  T_DB_B3_02 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1011;

    ---˻----
    select a005 into v_data10000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1001;

     select a005 into v_data20000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1002;

      select a005 into v_data30000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1003;

     select a005 into v_data40000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1004;

     select a005 into v_data50000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1005;

     select a005 into v_data60000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1006;

     select a005 into v_data70000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1007;

      select a005 into v_data80000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1008;

     select a005 into v_data90000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1009;

     select a005 into v_data100000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1010;

      select a005 into v_data110000
      from (select b.P001 as P002, a.a004 as a005
          from (select * from  T_DB_B3_03 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=1011;

     v_data1310 :=v_data1||v_data100||v_data10000; --1001  h2
     v_data1320 :=v_data2||v_data200||v_data20000; --1002  h3
     v_data1330 :=v_data3||v_data300||v_data30000; --1003  h7
     v_data1340 :=v_data4||v_data400||v_data40000; --1004  h11
     v_data1350 :=v_data5||v_data500||v_data50000; --1005  h12

     v_data1360 :=v_data6||v_data600||v_data60000; --1006  h4
     v_data1370 :=v_data7||v_data700||v_data70000; --1007  h5
     v_data1380 :=v_data8||v_data800||v_data80000; --1008  h6
     v_data1390 :=v_data9||v_data900||v_data90000; --1009  h8
     v_data1400 :=v_data10||v_data1000||v_data100000; --1010 h9
     v_data1410 :=v_data11||v_data1100||v_data110000; --1011 h10

     update T_CSRC0328_B_A3_1 set H2 = v_data1310 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H3 = v_data1320 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H7 = v_data1330 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H11 = v_data1340 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H12 = v_data1350 where BBQ = v_p001 and USERID=v_userid;

     update T_CSRC0328_B_A3_1 set H4 = v_data1360 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H5 = v_data1370 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H6 = v_data1380 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H8 = v_data1390 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H9 = v_data1400 where BBQ = v_p001 and USERID=v_userid;
     update T_CSRC0328_B_A3_1 set H10 = v_data1410 where BBQ = v_p001 and USERID=v_userid;



     ----˻淶---
     select a005 into v_data40
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2001;
     update T_CSRC0328_B_A3_1 set H14 = v_data40 where BBQ = v_p001 and USERID=v_userid;

     select a005 into v_data41
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2009;
     update T_CSRC0328_B_A3_1 set H15 = v_data41 where BBQ = v_p001 and USERID=v_userid;

     select a005 into v_data42
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2002;
     update T_CSRC0328_B_A3_1 set H16 = v_data42 where BBQ = v_p001 and USERID=v_userid;

     select a005 into v_data43
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2003;
     update T_CSRC0328_B_A3_1 set H17 = v_data43 where BBQ = v_p001 and USERID=v_userid;

     select a005 into v_data44
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2004;
     update T_CSRC0328_B_A3_1 set H18 = v_data44 where BBQ = v_p001 and USERID=v_userid;


      select a005 into v_data45
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2005;
     update T_CSRC0328_B_A3_1 set H19 = v_data45 where BBQ = v_p001 and USERID=v_userid;


     select a005 into v_data46
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2006;
     update T_CSRC0328_B_A3_1 set H20 = v_data46 where BBQ = v_p001 and USERID=v_userid;

     select a005 into v_data47
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2007;
     update T_CSRC0328_B_A3_1 set H21 = v_data47 where BBQ = v_p001 and USERID=v_userid;

     select a005 into v_data48
      from (select b.P001 as P002, a.a006 as a005
          from (select * from  T_DB_B3_04 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2008;
     update T_CSRC0328_B_A3_1 set H21 = v_data48 where BBQ = v_p001 and USERID=v_userid;

     --˻䶯
      select a007 into v_data51
      from (select b.P001 as P002, a.a007 as a007
          from (select * from  T_DB_B3_05 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2005;
     update T_CSRC0328_B_A3_1 set H24 = v_data51 where BBQ = v_p001 and USERID=v_userid;


      select a007 into v_data52
      from (select b.P001 as P002, a.a007 as a007
          from (select * from  T_DB_B3_05 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2006;
     update T_CSRC0328_B_A3_1 set H25 = v_data52 where BBQ = v_p001 and USERID=v_userid;


     select a007 into v_data53
      from (select b.P001 as P002, a.a007 as a007
          from (select * from  T_DB_B3_05 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2003;
     update T_CSRC0328_B_A3_1 set H26 = v_data53 where BBQ = v_p001 and USERID=v_userid;


      select a007 into v_data54
      from (select b.P001 as P002, a.a007 as a007
          from (select * from  T_DB_B3_05 where P001 = (select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER)) a,T_DB_B3_D001 b
             where a.P002(+)=b.P001)
     where P002=2004;
     update T_CSRC0328_B_A3_1 set H27 = v_data54 where BBQ = v_p001 and USERID=v_userid;







    update KRCS.T_SYS_T014 set A010=1015001 where P001=1205050 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
    select 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1205050;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T014 set A010=1015002 where P001=1205050 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1205050!';
                return;
end CISP_MAKEREPORT_1205050;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1205060
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1205060(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2
       )
is

       v_temp varchar(256);
       v_USER  varchar2(18);
       v_ORGANID  integer;
       v_data1 varchar2(255);
       v_data2 number(19,2);
       v_data3 number(19,2);
       v_count integer;

begin
       errcode:=1;
       errmsg := 'ɱɹ';

      --ȡ--
       SELECT T2.A002 into v_USER
       FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
       WHERE T1.P001 = v_KJAXUSER
         AND T1.P002 = T2.P001;

       --ȡӪҵID--
       select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;

       select count(*) into v_count from T_DB_B4_04 where (p002 = 3001 or p002='3002' or p002='3003') and p001 = V_ORGANID;
       if(v_count>0) then
          /* select A003 into v_data1
           from  T_DB_B4_04
           where P002 = 3001 and p001=v_ORGANID;
           update T_CSRC0328_B_A4_1 set C16 = v_data1 where BBQ = v_p001 and USERID=v_USER;*/
           -- ֤ȯײ
           update T_CSRC0328_B_A4_1 t set
           c16=(select A003 from T_DB_B4_04 a where a.p002='3001' and a.p001=v_ORGANID ),
           C18=(select A003 from T_DB_B4_04 a where a.p002='3002' and a.p001=v_ORGANID ),
           C19=(select A003 from T_DB_B4_04 a where a.p002='3003' and a.p001=v_ORGANID )
           where BBQ = v_p001 and USERID=v_USER;
       end if;


        update KRCS.T_SYS_T014 SET A010=1015001 WHERE P001=1205060 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
       SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1205060;
       INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;
    exception when others then
                  rollback;
                  update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1205060 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);--޸ת״̬ --
                  errcode := 0;
                  errmsg := 'ڴ洢CISP_MAKEREPORT_1205060!';
                  return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1205070
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1205070(
       /**dsp:۲Ʒɱע
        **/
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2)
is
       v_temp varchar(256);
       v_USER  varchar2(18);
       v_ORGANID  integer;
       v_data1 varchar2(255);
       v_data2 varchar2(255);
       v_data4 varchar2(255);
       v_data5 varchar2(255);
       v_data6 varchar2(255);
       v_data7 varchar2(255);
       v_data8 varchar2(255);
       v_data9 varchar2(255);
       v_data10 varchar2(255);
       v_data11 varchar2(255);
       v_data12 varchar2(255);
       v_data13 varchar2(255);
       v_data14 varchar2(255);
       v_data15 varchar2(255);
       v_data16 varchar2(255);
       v_data17 varchar2(255);
       v_data18 varchar2(255);
       v_data19 varchar2(255);
       v_data20 varchar2(255);
       v_data21 varchar2(255);
       v_data22 varchar2(255);
       v_count integer;

begin
       errcode:=1;
       errmsg := 'ɱɹ';

      --ȡ--
       SELECT T2.A002 into v_USER
       FROM KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
       WHERE T1.P001 = v_KJAXUSER
         AND T1.P002 = T2.P001;

       select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1010 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data1
           from  T_DB_B50_01
           where P002 = 1010 and p001=v_ORGANID;
       update T_CSRC1228_B_A5_1 set M5 = v_data1 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1020 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data2
           from  T_DB_B50_01
           where P002 = 1020 and p001=v_ORGANID;
           update T_CSRC1228_B_A5_1 set M6 = v_data2 where BBQ = v_p001 and USERID=v_USER;
       end if;


      /* select count(*) into v_count from T_DB_B5_01 where p002 = 1003 and p001 = V_ORGANID;
       if(v_count>0) then
           select A007 into v_data3
           from  T_DB_B5_01
           where P002 = 1003 and p001=v_ORGANID;
       end if;
       update T_CSRC0328_B_A5_1 set J5 = v_data3 where BBQ = v_p001 and USERID=v_USER;
      */
       select count(*) into v_count from T_DB_B50_01 where p002 = 1030 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data4
           from  T_DB_B50_01
           where P002 = 1030 and p001=v_ORGANID;
       update T_CSRC1228_B_A5_1 set M7 = v_data4 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1040 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data5
           from  T_DB_B50_01
           where P002 = 1040 and p001=v_ORGANID;
           update T_CSRC1228_B_A5_1 set M8 = v_data5 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1050 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data6
           from  T_DB_B50_01
           where P002 = 1050 and p001=v_ORGANID;
           update T_CSRC1228_B_A5_1 set M9 = v_data6 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1060 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data7
           from  T_DB_B50_01
           where P002 = 1060 and p001=v_ORGANID;
           update T_CSRC1228_B_A5_1 set M10 = v_data7 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1070 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data8
           from  T_DB_B50_01
           where P002 = 1070 and p001=v_ORGANID;
           update T_CSRC1228_B_A5_1 set M11 = v_data8 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1080 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data9
           from  T_DB_B50_01
           where P002 = 1080 and p001=v_ORGANID;
           update T_CSRC1228_B_A5_1 set M12 = v_data9 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1100 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data10
           from  T_DB_B50_01
           where P002 = 1100 and p001=v_ORGANID;
           update T_CSRC1228_B_A5_1 set M15 = v_data10 where BBQ = v_p001 and USERID=v_USER;
       end if;


       select count(*) into v_count from T_DB_B50_01 where p002 = 1110 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data11
           from  T_DB_B50_01
           where P002 = 1110 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M16 = v_data11 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1120 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data12
           from  T_DB_B50_01
           where P002 = 1120 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M17 = v_data12 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1130 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data13
           from  T_DB_B50_01
           where P002 = 1130 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M18 = v_data13 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1150 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data14
           from  T_DB_B50_01
           where P002 = 1150 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M20 = v_data14 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1160 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data15
           from  T_DB_B50_01
           where P002 = 1160 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M21 = v_data15 where BBQ = v_p001 and USERID=v_USER;
       end if;

        select count(*) into v_count from T_DB_B50_01 where p002 = 1170 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data16
           from  T_DB_B50_01
           where P002 = 1170 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M23 = v_data16 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1180 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data17
           from  T_DB_B50_01
           where P002 = 1180 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M24 = v_data17 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1190 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data18
           from  T_DB_B50_01
           where P002 = 1190 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M25 = v_data18 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1210 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data19
           from  T_DB_B50_01
           where P002 = 1210 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M28 = v_data19 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1220 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data20
           from  T_DB_B50_01
           where P002 = 1220 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M29 = v_data20 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1240 and p001 = V_ORGANID;
       if(v_count>0) then
           select A004 into v_data21
           from  T_DB_B50_01
           where P002 = 1240 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set D32 = v_data21 where BBQ = v_p001 and USERID=v_USER;
       end if;

       select count(*) into v_count from T_DB_B50_01 where p002 = 1250 and p001 = V_ORGANID;
       if(v_count>0) then
           select A099 into v_data22
           from  T_DB_B50_01
           where P002 = 1250 and p001=v_ORGANID;
            update T_CSRC1228_B_A5_1 set M33 = v_data22 where BBQ = v_p001 and USERID=v_USER;
       end if;




       update KRCS.T_SYS_T014 SET A010=1015001 WHERE P001=1205070 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
       SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1205070;
       INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
       commit;
       exception when others then
                  rollback;
                  update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1205070 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);--޸ת״̬ --
                  errcode := 0;
                  errmsg := 'ڴ洢CISP_MAKEREPORT_1205070!';
                  return;
end ;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1210010
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1210010(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2, v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid integer;

begin
    errcode:=1;
    errmsg := 'ɱɹ';

    --ѯ
    select T2.A002 into v_userid
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
    where T1.P001 = v_KJAXUSER
      and T1.P002 = T2.P001;

    delete from t_csrc0623_b_r_xxb WHERE BBQ=v_P001 and userid = v_userid; /* ɾͬһڵ */


    insert into t_csrc0623_b_r_xxb (bbq,userid,btype,option1,shtag,UPID,username,D3,B5,D5)


    select v_p001,v_userid,'0','1','1','--',b.a003,a.a002,a.a003,a.a004
    from t_bks_t064 a,(select * from KRCS.T_CTL_T036 where a008 = 1023008 ) b
    where b.p001 = a.p001(+)
    and b.a002 = v_userid;


   /* update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1210010;*/
    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1210010
    and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1210010;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1210010;
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1210010!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1210020
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1210020(errcode    out int,
                                                 errmsg     out varchar2,
                                                 v_KJAXUSER varchar2,
						 v_TASK varchar2,
                                                 v_P001     varchar2,
                                                 v_P002     varchar2,
                                                 v_P003     varchar2)
                                                  is
           v_temp varchar(256);
           v_userid varchar2(18);
           v_jgid number;
begin
        errcode:=1;
        errmsg := 'ɱɹ';

        select T2.A002 into v_userid from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
         where T1.P001 = v_KJAXUSER
           and T1.P002 = T2.P001;

        select T2.p001 into v_jgid from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
         where T1.P001 = v_KJAXUSER
           and T1.P002 = T2.P001;

       update T_CSRC0623_B_R_R1
          set F16 = (select ppp(2001,v_jgid) as A002 from dual),
              F17 = (select A003 from T_DACT_B_R002 where p002 = 2001 and p001 = v_jgid)
        where userid = v_userid
          and bbq = v_P001;

        update T_CSRC0623_B_R_R1
          set F18 = (select ppp(2002,v_jgid) as A002 from dual),
              F19 = (select A003 from T_DACT_B_R002 where p002 = 2002 and p001 = v_jgid)
        where userid = v_userid
          and bbq = v_P001;

        update T_CSRC0623_B_R_R1
          set F20 = (select ppp(2003,v_jgid) as A002 from dual),
              F21 = (select A003 from T_DACT_B_R002 where p002 = 2003 and p001 = v_jgid)
        where userid = v_userid
          and bbq = v_P001;

        update T_CSRC0623_B_R_R1
          set F22 = (select ppp(2004,v_jgid) as A002 from dual),
              F23 = (select A003 from T_DACT_B_R002 where p002 = 2004 and p001 = v_jgid)
        where userid = v_userid
          and bbq = v_P001;

         update T_CSRC0623_B_R_R1
          set F24 = (select ppp(2005,v_jgid) as A002 from dual),
              F25 = (select A003 from T_DACT_B_R002 where p002 = 2005 and p001 = v_jgid)
        where userid = v_userid
          and bbq = v_P001;


        update T_CSRC0623_B_R_R1
          set F26 = (select ppp(2006,v_jgid) as A002 from dual),
              F27 = (select A003 from T_DACT_B_R002 where p002 = 2006 and p001 = v_jgid)
        where userid = v_userid
          and bbq = v_P001;
        update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1210020 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
        select 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1210020;
        INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
         commit;
        exception when others then
                rollback;
                update KRCS.T_SYS_T014 set A010=1015002 where P001=1210020 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1210020!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1215010
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1215010(
        errcode out int,
        errmsg out varchar2,
        v_KJAXUSER varchar2,
	v_TASK varchar2,
        v_P001 varchar2,
        v_P002 varchar2,
        v_P003 varchar2)
is
    v_count integer;
    v_temp    varchar(256);
    v_USER   varchar2(18);
    V_ORGNAME   varchar2(128);
    V_ORGANID  NUMERIC;

begin
    errcode:=1;
    errmsg := 'ɱɹ';
    --ѯ
    select T2.A002,T2.A003 into v_USER,V_ORGNAME
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
    where T1.P001 = v_KJAXUSER
      and T1.P002 = T2.P001;
     --ɾͬһͬһ
    delete from T_CSRC1110_B_XXB where BBQ=v_P001 and userid=v_USER;

  --̶
    insert into T_CSRC1110_B_XXB(BBQ,Userid,Btype,Option1,Shtag)values(v_P001,v_USER,'0','0','0');
    commit;
    select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;
    update T_CSRC1110_B_XXB set
          C11=(select t.a002 from t_bks_t052 t where t.p001=V_ORGANID and t.a001=1),
          F11=(select t.a002 from t_bks_t052 t where t.p001=V_ORGANID and t.a001=2),
          C13=(select t.a002 from t_bks_t052 t where t.p001=V_ORGANID and t.a001=3),
          F13=(select t.a002 from t_bks_t052 t where t.p001=V_ORGANID and t.a001=4)
    where bbq=v_P001 and userid=v_USER;
    update T_CSRC1110_B_XXB set username=(select a003 from KRCS.T_CTL_T036 where p001=V_ORGANID)
    where bbq=v_P001 and userid=v_USER;
   commit;

  update KRCS.T_SYS_T014 SET A010 = 1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001 = 1215010 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
  SELECT 'ɱ100' || A002
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = 1215010;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003 ,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;
 exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1215010 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
                errcode := 0;
                errmsg := 'ڴ洢CISP_MAKEREPORT_1215010!';
                return;
end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1215020
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1215020(
        errcode out int,
        errmsg out varchar2,
        v_KJAXUSER varchar2,v_TASK varchar2,
        v_P001 varchar2,
        v_P002 varchar2,
        v_P003 varchar2)
is
    v_temp varchar(256);
    v_sql  varchar(2000);
    v_logic varchar(10);
    v_row  integer;
    v_colname1 varchar(256);
    v_colname2 varchar(256);
    v_colname3 varchar(256);
    v_EP001  integer;
    v_EA002  varchar(10);
    v_USER     varchar2(18);
    v_EA003  number(19,2);
    v_EA004  varchar(256);
    V_ORGANID  NUMERIC;
    cursor cur_work is
    --ʾ
        select a.a001, a.a002
          from t_bks_t054 a where a.p001=(select P002 from KRCS.T_SYS_USER  where P001 = v_KJAXUSER);

begin
    errcode:=1;
    errmsg := 'ɱɹ';
    --ѯ
    select T2.A002 into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
    where T1.P001 = v_KJAXUSER
      and T1.P002 = T2.P001;
     --ɾͬһͬһ
    delete from T_CSRC1110_B_B0 where BBQ=v_P001 and userid=v_USER;
    --̶
    insert into T_CSRC1110_B_B0(BBQ,Userid,Btype,Option1,Shtag)values(v_P001,v_USER,'0','','0');

    --v_row := 6;
    open cur_work;
    fetch cur_work into v_EP001,v_EA002;
    while cur_work%found
    loop
          v_logic := '';
          if v_EA002 = '1001101' then
             v_logic := 'T';
          elsif v_EA002 = '1001102' then
             v_logic := 'F';
          else
             v_logic := v_EA002;
          end if;

    v_EP001 := v_EP001+5;

   --ǻ
          v_sql := 'select CNAME '
                   ||'from SYS.Col'
                   ||' where TNAME=''T_CSRC1110_B_B0'' and COLNO='||v_EP001;

          execute immediate v_sql into v_colname1;


          v_sql := 'update T_CSRC1110_B_B0 set '||v_colname1||'='''||v_logic||''' where userid='''||v_USER||''' and BBQ='''||v_P001||'''';
          execute immediate v_sql;

          fetch cur_work into v_EP001,v_EA002;
          --v_row := v_row + 1;
          --dbms_output.put_line( v_sql );
    end loop;
    close cur_work;

    select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;
    update T_CSRC1110_B_B0 t set t.e139=(select a002 from t_bks_t053 where p001=V_ORGANID) where BBQ=v_P001 and userid=v_USER;
    commit;

    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1215020 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B1'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1215020;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

    commit;
 exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1215020 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
                errcode := 0;
                errmsg := sqlerrm||'ڴ洢CISP_MAKEREPORT_1215020!';
                return;


end;
/

prompt
prompt Creating procedure CISP_MAKEREPORT_1215030
prompt ==========================================
prompt
create or replace procedure CISP_MAKEREPORT_1215030(
        errcode out int,
        errmsg out varchar2,
        v_KJAXUSER varchar2,v_TASK varchar2,
        v_P001 varchar2,
        v_P002 varchar2,
        v_P003 varchar2)
is
    v_temp varchar(256);
    v_sql  varchar(1024);
    v_logic varchar(10);
    v_row  integer;
    v_colname1 varchar(256);
    v_colname2 varchar(256);
    v_colname3 varchar(256);
    v_EP001  integer;
    v_EA002  varchar(128);
    v_USER     varchar2(18);
    v_EA003  number(19,2);
    v_EA004  varchar(256);
    V_ORGANID  NUMERIC;
    cursor cur_work is
    --ʾ
        select a.a001, a.a002
          from t_bks_t051 a where a.p001=(select P002 from KRCS.T_SYS_USER  where P001 = v_KJAXUSER);

begin
    errcode:=1;
    errmsg := 'ɱɹ';
    --ѯ
    select T2.A002 into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
    where T1.P001 = v_KJAXUSER
      and T1.P002 = T2.P001;
     --ɾͬһͬһ
    delete from T_CSRC1110_B_B1 where BBQ=v_P001 and userid=v_USER;
    --̶
    insert into T_CSRC1110_B_B1(BBQ,Userid,Btype,Option1,Shtag)values(v_P001,v_USER,'0','','0');

    --v_row := 6;
    open cur_work;
    fetch cur_work into v_EP001,v_EA002;
    while cur_work%found
    loop
    v_EP001 := v_EP001+5;

   --ǻ
          v_sql := 'select CNAME '
                   ||'from SYS.Col'
                   ||' where TNAME=''T_CSRC1110_B_B1'' and COLNO='||v_EP001;

          execute immediate v_sql into v_colname1;


          v_sql := 'update T_CSRC1110_B_B1 set '||v_colname1||'='''||v_EA002||''' where userid='''||v_USER||''' and BBQ='''||v_P001||'''';
          execute immediate v_sql;

          fetch cur_work into v_EP001,v_EA002;
          --v_row := v_row + 1;
          --dbms_output.put_line( v_sql );
    end loop;
    close cur_work;

    /*select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;
    update T_CSRC1110_B_B1 t set t.e139=(select a002 from t_bks_t051 where p001=V_ORGANID) where BBQ=v_P001 and userid=v_USER;
    commit;*/

    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1215030 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B1'||A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = 1215030;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);

    commit;
exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1215030 and a008=(select P002 from KRCS.T_SYS_USER where P001=v_KJAXUSER);
                errcode := 0;
                errmsg := sqlerrm||'ڴ洢CISP_MAKEREPORT_1215030!';
                return;


end;
/

prompt
prompt Creating procedure CISP_MAP_C12_1_20190401
prompt ==========================================
prompt
create or replace procedure cisp_map_C12_1_20190401 is

  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin

  --ȡڵڼʱ
  select to_char(a005,'YYYYMMDD') into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(a006,'YYYYMMDD') into v_enddate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;

  delete from T_ETL_XSJRCP_FSE /*where xm not in(24,25)*/;
   /******************************Ӷ***********************************/
   --1.֤ȯͶʻ
  insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 1,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
      )a
      ,
      (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag  in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;

  --3.˾ʲƻ
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 3,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       )
      ) a
      ,
      ( select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
       )
       
      )B
      ,
      (select sum(BNZJSL) as BNZJSL from (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )
      ) C
      ,
      (select sum(BNJSSL) as BNJSSL from (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )
      )D;
    commit;
    
    --5.˾ʲƻ
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 4,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       )
      ) a
      ,
      ( select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
       )
       
      )B
      ,
      (select count(distinct BNZJSL) as BNZJSL from (
      select prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all 
      select  prod_code BNZJSL from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44122','44130','44139')
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      ) C
      ,
      (select count(distinct BNJSSL) as BNJSSL from (
      select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
      select  t.prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)      
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      )D;
    commit;
    -- ҵƲƷ
     insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 5,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(abs(entrust_amount)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43130') and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
      ) a
      ,
      (
      select sum(abs(entrust_amount)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43142','43150') and prod_code in (select jjdm from t_bks_t100 where fxzl=14)      
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43130') 
       and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      ) C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43142','43150') 
       and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;
    commit;
    
    --
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select 6,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BUSINESS_BALANCE) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
      )a
      ,
      (
      select sum(BUSINESS_BALANCE) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag  in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;
      commit;
    
    --ڲƷ
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 8,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (select sum(BQZJJE) BQZJJE,sum(BQZJSL) BQZJSL from (
       select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
       and business_balance<>0)       
      ) a
      ,
      (
      select sum(BQJSJE) BQJSJE,sum(BQJSSL) BQJSSL from (
       select sum(abs(business_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
       and entrust_balance<>0)      
      )B
      ,
      (
      select count(distinct BNZJSL) BNZJSL from (
       select  prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=17)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      ) C
      ,
      (
      select count(distinct BNJSSL) BNJSSL from (
       select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fxzl=17)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate) 
      )D;
    commit;
    --֤ȯ˾ʲƻ
    insert into T_ETL_XSJRCP_FSE
    select 2,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL),sum(T.BQJSSL),sum(T.BQJSJE),sum(T.BNJSSL) from T_ETL_XSJRCP_FSE t where t.xm in (3,4) ;

    commit;
    --˷ϼ
    insert into T_ETL_XSJRCP_FSE
    select 101,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL) ,SUM(T.BQJSSL),SUM(T.BQJSJE),SUM(T.BNJSSL)
           from T_ETL_XSJRCP_FSE t
                where t.xm in(1,2,5,6,7,8);

    commit;
    /*******************************************************************/
    --10.̶ڲƷ
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   --select 10,t.BQZJSL,t.BQZJJE,t.BNZJSL,t.BQJSSL,t.BQJSJE,t.BNJSSL from T_ETL_XSJRCP_FSE t where t.xm = 5;
   select 10,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(abs(entrust_amount)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43130') and prod_code in (select jjdm from t_bks_t100 where syzl=21)
      ) a
      ,
      (
      select sum(abs(entrust_amount)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43142','43150') and prod_code in (select jjdm from t_bks_t100 where syzl=21)      
      )B
      ,
      (
      select count(distinct prod_code) as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43130') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=21)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      ) C
      ,
      (
      select count(distinct prod_code) as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43142','43150') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=21)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )D;
   
    --11.ڲƷ
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
  select 11,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from(
      select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and business_balance<>0
       union
       select sum(abs(entrust_amount)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43130') and prod_code in (select jjdm from t_bks_t100 where syzl=22))  
      ) a
      ,
      (
      select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
      select sum(abs(entrust_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and entrust_balance<>0
       union
       select sum(abs(entrust_amount)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_bankmdeliver where
       business_flag in ('43142','43150') and prod_code in (select jjdm from t_bks_t100 where syzl=22) )  
      ) B
      ,
      (
      select count(distinct BNZJSL) as BNZJSL from (
      select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date  between substr(v_enddate,1,4)||0101 and v_enddate
       union all
      select  prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        union all 
        select  prod_code as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43130') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      ) C
      ,
      (
      select count(distinct BNJSSL) as BNJSSL from (
      select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
      select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select  prod_code as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj where
       business_flag in ('43142','43150') 
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate )
      ) D;
      commit;
     --13ڲƷ    
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 13,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
       select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)  
       and business_balance<>0   
      ) a
      ,
      (
      select sum(abs(entrust_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and entrust_balance<>0
      )B
      ,
      (select count(distinct BNZJSL) as BNZJSL from (
       select prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        union all
        select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)) C
      ,
      (
      select count(distinct BNJSSL) as BNJSSL from(
       select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      )D;
    commit;

     --12.ڲƷ
   

      --15.ṹڲƷ
     insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 15,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) BQZJJE,sum(BQZJSL) BQZJSL from (
      select sum(abs(business_balance)) BQZJJE,count(distinct prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and business_balance<>0) 
      ) a
      ,
      (
      select sum(BQJSJE) BQJSJE,sum(BQJSSL) BQJSSL from (
      select sum(abs(entrust_balance)) BQJSJE,count(distinct prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo
      where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and entrust_balance<>0)
      ) B
      ,
      (
      select count(distinct BNZJSL) BNZJSL from(
      select  prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
      select prod_code as BNZJSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)       
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate) 
      ) C
      ,
      (
      select count(distinct BNJSSL) BNJSSL from (
      select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where syfl=31)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
      select  prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj
      where business_flag in ('44124','44150','44142')
       and prod_code  in (select jjdm from t_bks_t100 where syfl=31)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate) 
      ) D;
    /******************************۷ʽ*************************************/
    commit;
    --(˾)
    insert into T_ETL_XSJRCP_FSE
     select 17,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
      select sum(BQZJJE) as BQZJJE,sum(BQZJSL) as BQZJSL from (
       select sum(abs(t.business_balance)) BQZJJE,count (distinct t.prod_code) as BQZJSL from kods.a_hs_his_secumdealinfo t
       where business_flag in('44122','44130','44139')
       and  t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and t.business_balance<>0)
      ) a
      ,
      ( select sum(BQJSJE) as BQJSJE,sum(BQJSSL) as BQJSSL from (
       select sum(abs(t.business_balance)) BQJSJE,count (distinct t.prod_code) as BQJSSL from kods.a_hs_his_secumdealinfo t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and t.entrust_balance<>0)
       
      )B
      ,
      (select count(distinct BNZJSL) as BNZJSL from (
      select prod_code as BNZJSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44139','44130')
       and prod_code  in (select jjdm from t_bks_t100 where fsfl=41)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all 
      select prod_code BNZJSL from kods.a_hs_his_secumdealinfo_bnlj t
       where business_flag in('44122','44130','44139')
       and  t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      ) C
      ,
      (select count(distinct BNJSSL) as BNJSSL from (
      select  prod_code as BNJSSL from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
      select  t.prod_code as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate)
      )D;
    commit;
    --
    insert into T_ETL_XSJRCP_FSE
    select       18,sum(decode(xm,101,t.BQZJSL,-t.BQZJSL)),
                    sum(decode(xm,101,t.BQZJJE,-t.BQZJJE)),
                    sum(decode(xm,101,t.BNZJSL,-t.BNZJSL)),
                    sum(decode(xm,101,t.BQJSSL,-t.BQJSSL)),
                    sum(decode(xm,101,t.BQJSJE,-t.BQJSJE)),
                    sum(decode(xm,101,t.BNJSSL,-t.BNJSSL))
                    from T_ETL_XSJRCP_FSE t
                         where t.xm in( 101,17);

     commit;
    /******************************ͷ*************************************/
    --21.
   insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 21,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
       select sum(BQZJJE) BQZJJE,count(distinct BQZJSL) BQZJSL from (  
       select sum(a.business_balance) BQZJJE, a.client_id as BQZJSL  from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44122','44139','44130')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQZJJE,a.client_id as BQZJSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       group by a.client_id)
      )a
      ,
      (
       select sum(BQJSJE) BQJSJE,count(distinct BQJSSL) BQJSSL from(
       select sum(abs(a.BUSINESS_BALANCE)) BQJSJE, a.client_id as BQJSSL from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       and a.entrust_balance<>0
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQJSJE, a.client_id as BQJSSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c 
       where business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       group by a.client_id )
      )B
      ,
      (
       select count(distinct BNZJSL) BNZJSL  from (
       select a.client_id as BNZJSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44122','44139','44130')
       and a.client_id = c.client_id
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and c.organ_flag in ('1','3') 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all
       select  a.client_id BNZJSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44122','44130','44139')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3') 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all
       select a.client_id as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id)
      )C
      ,
      (
       select count(distinct BNJSSL) BNJSSL from (
       select a.client_id as BNJSSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44124','44142','44150')
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all 
       select  a.client_id as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all
       select  a.client_id as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and c.organ_flag in ('1','3')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id)
      )D;

     commit;
     --22.
    insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select 22,NVL(a.BQZJSL,0),NVL(a.BQZJJE,0),NVL(C.BNZJSL,0),NVL(B.BQJSSL,0),NVL(B.BQJSJE,0),NVL(D.BNJSSL,0)
    from (
       select sum(BQZJJE) BQZJJE,count(distinct BQZJSL) BQZJSL from ( 
       select sum(abs(business_balance)) BQZJJE,a.client_id as BQZJSL from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
      where business_flag in ('44122','44130','44139')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and a.business_balance<>0
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQZJJE, a.client_id as BQZJSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       group by a.client_id)
      )a
      ,
      (
       select sum(BQJSJE) BQJSJE,count(distinct BQJSSL) BQJSSL from(
       select sum(abs(a.entrust_balance)) BQJSJE,a.client_id as BQJSSL from kods.a_hs_his_secumdealinfo a,
       kods.rzrq_hs_client c 
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and a.entrust_balance<>0
       group by a.client_id
       union all
       select sum(abs(entrust_amount)) BQJSJE,a.client_id as BQJSSL from kods.a_hs_his_bankmdeliver a,
       kods.rzrq_hs_client c 
       where business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and c.organ_flag ='0' 
       group by a.client_id)
      )B
      ,
      (
       select count(distinct BNZJSL) BNZJSL  from (
       select a.client_id as BNZJSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44122','44139','44130')
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select a.client_id BNZJSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44122','44130','44139')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select a.client_id as BNZJSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43130')
       and a.client_id = c.client_id
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       and c.organ_flag ='0')
      )C
      ,
      (
       select count(distinct BNJSSL) BNJSSL from (
       select a.client_id as BNJSSL  from kods.a_hs_his_secumdeliver_bnlj a,
       kods.rzrq_hs_client c 
       where a.business_flag in ('44124','44142','44150')
       and a.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and a.client_id = c.client_id
       and c.organ_flag ='0'
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by a.client_id
       union all 
       select  a.client_id as BNJSSL from kods.a_hs_his_secumdealinfo_bnlj a,
       kods.rzrq_hs_client c
       where business_flag in('44124','44150','44142')
       and a.client_id = c.client_id
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       and c.organ_flag ='0'
       group by a.client_id
       union all
       select a.client_id as BNJSSL from kods.a_hs_his_bankmdeliver_bnlj a,
       kods.rzrq_hs_client c
       where  business_flag in ('43142','43150')
       and a.client_id = c.client_id
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       and c.organ_flag ='0'
       group by a.client_id)
      )D;
     commit;

    update T_ETL_XSJRCP_FSE t set t.BQZJJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQZJJE,0),-nvl(t1.BQZJJE,0))) from T_ETL_XSJRCP_FSE t1
                    where t1.xm in(101,21) ),
                    t.BQJSJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQJSJE,0),-nvl(t1.BQJSJE,0))) from T_ETL_XSJRCP_FSE t1
                    where t1.xm in(101,21) )
                    where t.xm=22;

  delete from T_ETL_XSJRCP_QMYE;
  commit;
    /******************************ĩ***********************************/
      --1.֤ȯͶʻ
  insert into T_ETL_XSJRCP_QMYE
    (XM, QMSL, QMJE)
    select 1, a.qmsl, a.qmje
      from (select count(distinct a.prod_code) as qmsl,
                   round(sum(a.current_amount * b.net_value), 2) as qmje
              from kods.a_hs08_secumshare a, kods.a_hs_his_prodprice b
             where a.prod_code = b.prod_code
               and a.prod_code in
                   (select jjdm from t_bks_t100 where fxzl = 11)
               and b.init_date =
                   (select max(init_date)
                      from kods.a_hs_his_prodprice
                     where init_date <= v_enddate)) a;
      commit;

  --3.˾ʲƻ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 3, a.qmsl, a.qmje
       from (select sum(qmsl) as qmsl, sum(qmje) as qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 12))) a;
    commit;
    
  --4.˾ʲƻ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 4, a.qmsl, a.qmje
       from (select sum(qmsl) as qmsl, sum(qmje) as qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 13))) a;
    commit;  

    --֤ȯ˾ʲƻ
    insert into T_ETL_XSJRCP_QMYE
    select 2,sum(t.qmsl),sum(t.qmje) from T_ETL_XSJRCP_QMYE t where t.xm in (3,4) ;

    commit;
    --
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 5, a.qmsl, a.qmje
       from (select count(distinct prod_code) as qmsl,
                    sum(current_amount) as qmje
               from kods.a_hs08_bankmshare
              where prod_code in
                    (select jjdm from t_bks_t100 where fxzl = 14)
                and current_amount <> 0) a;
   commit;
   --ڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 8, a.qmsl, a.qmje
       from (select sum(qmsl) qmsl, sum(qmje) qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where fxzl = 17))) a;
   commit;

    --˷ϼ
    insert into T_ETL_XSJRCP_QMYE
    select 101,sum(t.qmsl),sum(t.qmje)
           from T_ETL_XSJRCP_QMYE t
                where t.xm in(1,2,5,6,7,8);

    commit;

     --10.̶ڲƷ
      insert into T_ETL_XSJRCP_QMYE(XM,QMSL,QMJE)
   --select 10,a.qmsl,a.qmje from T_ETL_XSJRCP_QMYE a where xm=5;
       select 10, a.qmsl, nvl(a.qmje, 0)
      from (select count(distinct prod_code) as qmsl,
                   sum(current_amount) as qmje
              from kods.a_hs08_bankmshare
             where prod_code in
                   (select jjdm from t_bks_t100 where syzl = 21)
               and current_amount<>0    ) a;


    --11.ڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 11, a.qmsl, a.qmje
       from (select sum(qmsl) qmsl, sum(qmje) qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where syzl = 22)
                        and current_amount <> 0
                     union all
                     select count(distinct prod_code) as qmsl,
                            sum(current_amount) as qmje
                       from kods.a_hs08_bankmshare
                      where prod_code in
                            (select jjdm from t_bks_t100 where syzl = 22)
                        and current_amount <> 0)) a;
      commit;
     -- ڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 13, a.qmsl, a.qmje
       from (select count(distinct t.prod_code) as qmsl,
                    round(sum(t.current_amount * b.net_value), 2) as qmje
               from kods.a_hs08_secumshare t, kods.a_hs_his_prodprice b
              where t.prod_code = b.prod_code
                and b.init_date =
                    (select max(init_date)
                       from kods.a_hs_his_prodprice
                      where init_date <= v_enddate)
                and t.prod_code in
                    (select jjdm from t_bks_t100 where syzl = 24)) a;
   commit;

 
   --15.ṹڲƷ
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 15, a.qmsl, a.qmje
       from (select sum(qmsl) qmsl, sum(qmje) qmje
               from (select count(distinct t.prod_code) as qmsl,
                            round(sum(t.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  t,
                            kods.a_hs_his_prodprice b
                      where t.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and t.prod_code in
                            (select jjdm from t_bks_t100 where syfl = 31))) a;
   /******************************۷ʽ*************************************/
    commit;
    --(˾)
    insert into T_ETL_XSJRCP_QMYE
      select 17, a.qmsl, a.qmje
        from (select sum(qmsl) as qmsl, sum(qmje) as qmje
                from (select count(distinct t.prod_code) as qmsl,
                             round(sum(t.current_amount * b.net_value), 2) as qmje
                        from kods.a_hs08_secumshare  t,
                             kods.a_hs_his_prodprice b
                       where t.prod_code = b.prod_code
                         and b.init_date =
                             (select max(init_date)
                                from kods.a_hs_his_prodprice
                               where init_date <= v_enddate)
                         and t.prod_code in
                             (select jjdm from t_bks_t100 where fsfl = 41))) a;
    commit;

    commit;
    --
    insert into T_ETL_XSJRCP_QMYE
    select 18,sum(decode(xm,101,t.qmsl,-t.qmsl)),
                    sum(decode(xm,101,t.qmje,-t.qmje))
                    from T_ETL_XSJRCP_QMYE t
                         where t.xm in( 101,17);


    /******************************ͷ*************************************/
   --21.
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 21, a.qmsl, a.qmje
       from (select count(distinct qmsl) qmsl, sum(qmje) qmje
               from (select a.client_id as qmsl,
                            sum(a.current_amount) as qmje
                       from kods.a_hs08_bankmshare a, kods.rzrq_hs_client c
                      where a.client_id = c.client_id
                        and c.organ_flag in ('1', '3')
                      group by a.client_id
                     union all
                     select a.client_id as qmsl,
                            sum(a.current_amount * b.net_value) as qmje
                       from kods.a_hs08_secumshare  a,
                            kods.rzrq_hs_client     c,
                            kods.a_hs_his_prodprice b
                      where a.client_id = c.client_id
                        and a.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and c.organ_flag in ('1', '3')
                      group by a.client_id)
              where qmje <> 0) a;
   
   insert into T_ETL_XSJRCP_QMYE
     (XM, QMSL, QMJE)
     select 22, a.qmsl, a.qmje
       from (select count(distinct qmsl) qmsl, sum(qmje) qmje
               from (select a.client_id as qmsl,
                            sum(a.current_amount) as qmje
                       from kods.a_hs08_bankmshare a, kods.rzrq_hs_client c
                      where a.client_id = c.client_id
                        and c.organ_flag = '0'
                      group by a.client_id
                     union all
                     select a.client_id as qmsl,
                            round(sum(a.current_amount * b.net_value), 2) as qmje
                       from kods.a_hs08_secumshare  a,
                            kods.rzrq_hs_client     c,
                            kods.a_hs_his_prodprice b
                      where a.client_id = c.client_id
                        and a.prod_code = b.prod_code
                        and b.init_date =
                            (select max(init_date)
                               from kods.a_hs_his_prodprice
                              where init_date <= v_enddate)
                        and c.organ_flag = '0'
                      group by a.client_id)
              where qmje <> 0) a;
   commit;
   
   update T_ETL_XSJRCP_QMYE t
      set t.qmje = (select sum(decode(t1.xm,
                                      101,
                                      nvl(t1.qmje, 0),
                                      -nvl(t1.qmje, 0)))
                      from T_ETL_XSJRCP_QMYE t1
                     where t1.xm in (101, 21))
    where t.xm = 22;
   /*  --22.
        insert into T_ETL_XSJRCP_QMYE(XM,QMSL,QMJE)
       select 22,sum(decode(xm,101,qmsl,-qmsl)),
                       sum(decode(xm,101,qmje,-qmje))
              from T_ETL_XSJRCP_QMYE t
                   where xm in (101,21);*/

    commit;
   --
   insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select 24,0,NVL(a.BQZJJE,0),0,0,0,0
    from (
       select sum(BQZJJE) BQZJJE from (  
       /*select sum(a.fare_sx) BQZJJE  from kods.a_hs08_his_ofdeliver a
       where a.business_flag in ('122','139','130'\*,'124','142','150'*\)
       union all*/
       select sum(fare_sx) BQZJJE from kods.a_hs_his_secumdealinfo a
      where business_flag in ('44122','44130','44139') 
       and a.business_balance<>0 
       union all
       select sum(RATIO_SX) BQZJJE from kods.a_hs_his_bankmdeliver a
       where  business_flag in ('43130')
      ) )a;
      --
      insert into T_ETL_XSJRCP_FSE(XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select 25,0,NVL(a.BQZJJE,0),0,0,0,0
    from (
       select sum(BQZJJE) BQZJJE from (  
       /*select sum(a.fare_sx) BQZJJE  from kods.a_hs08_his_ofdeliver a
       where a.business_flag in ('122','139','130'\*,'124','142','150'*\)
       and fund_code in  (select jjdm from t_bks_t100 where fsfl=42)
       union  all*/
        select sum(fare_sx) BQZJJE from kods.a_hs_his_secumdealinfo a
      where business_flag in ('44122','44130','44139')
        and prod_code in  (select jjdm from t_bks_t100 where fsfl=42)
         and a.business_balance<>0 
      ) )a;

  cisp_etl_XSJRCP;
  /**
     ҵĿǰû
  **/
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_1
prompt ====================================
prompt
create or replace procedure cisp_map_hg_c13_1
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  lastbbq                 number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;


  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;

 select to_char(to_date(v_bbq_begindate, 'yyyymmdd') -1, 'yyyymm') into lastbbq from dual;

  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  /*--modify zhenyj 20200601 ͻҪɾ8Լ
  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',  update kods.A_HS08_SRPCONTRACT t set t.repaid_balance = decode(t.contract_id,'2017012000000005',134500000.00,124450000.00)

                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
  --ͻҪ޸
  where t.contract_id in ('2017012000000005','2017052300000001');
  commit;*/

  delete from t_etl_c13_1_sl;
  delete from t_etl_c13_1_je;
  delete from T_ETL_C13_1_YWGM;
  commit;

--ǩԼͻ    
insert into t_etl_c13_1_sl
select  2,1,nvl(sum(case when a.business_flag in (1443, 1447) then 1 else 0 end),0) as account_organ_inc
from kods.A_HS08_HIS_STOCKHOLDERJOUR a
where a.init_date between v_bbq_begindate and v_bbq_enddate
   and a.business_flag in (1443, 1445, 1447, 1449)
   and exists (select 1 from kods.RZRQ_HS_CLIENT b
                where b.client_id = a.client_id
                  and b.organ_flag <> '0')
                  and ((a.regflag = '1' and a.exchange_type = '1') or a.exchange_type = '2');
--ǩԼͻ  ڼ
insert into t_etl_c13_1_sl
select  2,2,nvl(sum(case when a.business_flag in (1445, 1449) then 1 else 0 end),0) as account_organ_dec
from kods.A_HS08_HIS_STOCKHOLDERJOUR a
where a.init_date between v_bbq_begindate and v_bbq_enddate
   and a.business_flag in (1443, 1445, 1447, 1449)
   and exists (select 1 from kods.RZRQ_HS_CLIENT b
                where b.client_id = a.client_id
                  and b.organ_flag <> '0')
                  and ((a.regflag = '1' and a.exchange_type = '1') or a.exchange_type = '2');
                  
                  
--ǩԼͻ    
insert into t_etl_c13_1_sl
select  3,1,nvl(sum(case when a.business_flag in (1443, 1447) then 1 else 0 end),0) as account_organ_inc
from kods.A_HS08_HIS_STOCKHOLDERJOUR a
where a.init_date between v_bbq_begindate and v_bbq_enddate
   and a.business_flag in (1443, 1445, 1447, 1449)
   and exists (select 1 from kods.RZRQ_HS_CLIENT b
                where b.client_id = a.client_id
                  and b.organ_flag = '0')
                  and ((a.regflag = '1' and a.exchange_type = '1') or a.exchange_type = '2');
--ǩԼͻ  ڼ
insert into t_etl_c13_1_sl
select  3,2,nvl(sum(case when a.business_flag in (1445, 1449) then 1 else 0 end),0) as account_organ_dec
from kods.A_HS08_HIS_STOCKHOLDERJOUR a
where a.init_date between v_bbq_begindate and v_bbq_enddate
   and a.business_flag in (1443, 1445, 1447, 1449)
   and exists (select 1 from kods.RZRQ_HS_CLIENT b
                where b.client_id = a.client_id
                  and b.organ_flag = '0')
                  and ((a.regflag = '1' and a.exchange_type = '1') or a.exchange_type = '2');
commit;

insert into t_etl_c13_1_sl  
 select 1,1, sum(t.sl) from  t_etl_c13_1_sl t where t.xm in (2,3) and t.jylx='1';

insert into t_etl_c13_1_sl                   
  select 1,2, sum(t.sl) from  t_etl_c13_1_sl t where t.xm in (2,3) and t.jylx='2';

commit;

--δڻعĿͻ  
insert into t_etl_c13_1_sl
select 
        case when t1.organ_flag=1 then 5 else 6  end as xm,  --5  6
        1,
        count(distinct t1.client_id) 
from (select  a.client_id, min(b.organ_flag) as organ_flag
       from kods.RZRQ_HS_CLIENT b, kods.t_hs08_ASSETUNFINISHED a
        where a.init_date between v_bbq_begindate and v_bbq_enddate
           and a.unfinished_type = 'E'
           and a.deli_status = '0'
           and a.client_id = b.client_id
           and not exists(select * from kods.t_hs08_ASSETUNFINISHED c
                          where a.client_id = c.client_id
                             and a.branch_no = c.branch_no
                             and c.unfinished_type = 'E'
                             and c.init_date < v_bbq_begindate)
           and not exists(select * from kods.t_hs08_HIS_ASSETUNFINISHED d
                          where a.client_id = d.client_id
                             and a.branch_no = d.branch_no
                             and d.unfinished_type = 'E'
                             and d.init_date < v_bbq_begindate
                             and d.date_clear >= v_bbq_begindate)
      group by a.client_id
    union
    select  a.client_id, min(b.organ_flag) as organ_flag
       from kods.RZRQ_HS_CLIENT b, kods.t_hs08_HIS_ASSETUNFINISHED a
        where a.init_date between v_bbq_begindate and v_bbq_enddate
           and a.unfinished_type = 'E'
           and a.client_id = b.client_id
           and not exists(select * from kods.t_hs08_ASSETUNFINISHED c
                          where a.client_id = c.client_id
                             and a.branch_no = c.branch_no
                             and c.unfinished_type = 'E'
                             and c.init_date < v_bbq_begindate)
           and not exists(select * from kods.t_hs08_HIS_ASSETUNFINISHED d
                          where a.client_id = d.client_id
                             and a.branch_no = d.branch_no
                             and d.unfinished_type = 'E'
                             and d.init_date < v_bbq_begindate
                             and d.date_clear >= v_bbq_begindate)
      group by a.client_id) t1 group by t1.organ_flag;

commit;

--δڻعĿͻ ڼ
insert into t_etl_c13_1_sl
select case when t1.organ_flag=1 then 5 else 6  end as xm,  --5  6
        1,
        count(distinct t1.client_id) 
from (select  a.client_id, min(b.organ_flag) as organ_flag
       from kods.RZRQ_HS_CLIENT b, kods.t_hs08_HIS_ASSETUNFINISHED a
        where a.date_clear between v_bbq_begindate and v_bbq_enddate
           and a.unfinished_type = 'E'
           and a.deli_status = '1'
           and a.client_id = b.client_id
           and not exists(select * from kods.t_hs08_ASSETUNFINISHED c
                          where a.client_id = c.client_id
                             and a.branch_no = c.branch_no
                             and c.unfinished_type = 'E'
                             and c.init_date <= v_bbq_enddate)
           and not exists(select * from kods.t_hs08_HIS_ASSETUNFINISHED d
                          where a.client_id = d.client_id
                             and a.branch_no = d.branch_no
                             and d.unfinished_type = 'E'
                             and d.init_date <= v_bbq_enddate
                             and d.date_clear > v_bbq_enddate)
      group by a.client_id) t1 group by t1.organ_flag ;
 commit;
 
 
insert into t_etl_c13_1_sl  
 select 4,1, sum(t.sl) from  t_etl_c13_1_sl t where t.xm in (5,6) and t.jylx='1';

insert into t_etl_c13_1_sl                   
  select 4,2, sum(t.sl) from  t_etl_c13_1_sl t where t.xm in (5,6) and t.jylx='2';

commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_1_sl
    select
  1,3,nvl(sum(a.acount_person_count + a.acount_organ_count),0) as signed_count --ǩԼͻ
   from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union all
  select
  2,3,nvl(sum(a.acount_organ_count),0) as account_organ_count  --ǩԼͻ 
   from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
   union all
  select
  3,3,nvl(sum(a.acount_person_count),0) as account_person_count --ǩԼͻ 
   from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
   union all
  select
  4,3,nvl(sum(a.acount_perback_count + a.acount_organback_count),0) as back_count --δڽعĿͻ
   from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union all
  select
  5,3,nvl(sum(a.acount_organback_count),0) as account_organback_count --δڽعĿͻ   
   from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union all
  select
  6,3,nvl(sum(a.acount_perback_count),0) as account_perback_count --δڽعĿͻ   
   from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate;
  
  commit;
  
  --Ѻרֵ仯 
  insert into T_ETL_C13_1_JE
  select
  8,1,nvl(sum((case a.exchange_type when '1' then a.entrust_amount else 0 end)*b.asset_price), 0) as sh_market_value_inc  --Ϻ
from kods.t_hs08_HIS_CBPENTRUST a, kods.RZRQ_HS_HIS_HISPRICE b
where a.exchange_type= b.exchange_type
  and a.stock_code = b.stock_code
  and a.init_date = b.init_date
  and a.entrust_prop = 'QBD'
  and a.entrust_type = '0'
  and a.entrust_status = '8'
  and a.init_date >= v_bbq_begindate
  and a.init_date <= v_bbq_enddate;
  
  
  insert into T_ETL_C13_1_JE  
  select
  9,1,nvl(sum((case a.exchange_type when '2' then a.entrust_amount else 0 end)*b.asset_price), 0) as sz_market_value_inc --
from kods.t_hs08_HIS_SOPTENTRUST a, kods.RZRQ_HS_HIS_HISPRICE b
where a.exchange_type= b.exchange_type
  and a.stock_code = b.stock_code
  and a.init_date = b.init_date
  and a.entrust_prop = 'QBD'
  and a.entrust_type = '0'
  and a.entrust_status = '8'
  and a.init_date >= v_bbq_begindate
  and a.init_date <= v_bbq_enddate;
  
  --Ѻרֵ仯 
  insert into T_ETL_C13_1_JE
  select
  8,2,nvl(sum((case a.exchange_type when '1' then a.entrust_amount else 0 end)*b.asset_price), 0) as sh_market_value_dec  --Ϻ
from kods.t_hs08_HIS_CBPENTRUST a, kods.RZRQ_HS_HIS_HISPRICE b
where a.exchange_type= b.exchange_type
  and a.stock_code = b.stock_code
  and a.init_date = b.init_date
  and a.entrust_prop = 'QBW'
  and a.entrust_type = '0'
  and a.entrust_status = '8'
  and a.init_date >= v_bbq_begindate
  and a.init_date <= v_bbq_enddate;
  commit;
  
  insert into T_ETL_C13_1_JE
  select
  9,2,nvl(sum((case a.exchange_type when '2' then a.entrust_amount else 0 end)*b.asset_price), 0) as sz_market_value_dec --ڼ
from kods.t_hs08_HIS_SOPTENTRUST a, kods.RZRQ_HS_HIS_HISPRICE b
where a.exchange_type= b.exchange_type
  and a.stock_code = b.stock_code
  and a.init_date = b.init_date
  and a.entrust_prop = 'QBW'
  and a.entrust_type = '0'
  and a.entrust_status = '8'
  and a.init_date >= v_bbq_begindate
  and a.init_date <= v_bbq_enddate;
  commit;
  
  insert into t_etl_c13_1_sl  
 select 7,1, sum(t.sl) from  t_etl_c13_1_sl t where t.xm in (8,9) and t.jylx='1';

 insert into t_etl_c13_1_sl                   
  select 7,2, sum(t.sl) from  t_etl_c13_1_sl t where t.xm in (8,9) and t.jylx='2';

 commit; 
  
  
  --ĩ
  insert into T_ETL_C13_1_JE
  select 7,3,nvl(sum(a.market_value),0) as market_value --Ѻרֵ
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 8,3,nvl(sum(case a.exchange_type when '1' then a.market_value else 0 end),0) as market_value_sh  --Ѻרֵ  Ϻ
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 9,3,nvl(sum(case a.exchange_type when '2' then a.market_value else 0 end),0) as market_value_sz  --Ѻרֵ  
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 10,3,nvl(sum(a.uncome_balance_short_term+a.uncome_balance_medium_term+a.uncome_balance_long_term),0) as uncome_balance  --δڻعԪ
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 11,3,nvl(sum(a.uncome_balance_short_term),0) as uncome_balance_short_term  --   Уعʣ1
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 12,3,nvl(sum(a.uncome_balance_medium_term),0) as uncome_balance_medium_term  --         عʣ30ڣ
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 13,3,nvl(sum(a.uncome_balance_long_term),0) as uncome_balance_long_term   --         عʣ30
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 14,3,nvl(sum(a.uncome_balance_organ),0) as uncome_balance_organ  --   Уͻ
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate
  union 
  select 15,3,nvl(sum(a.uncome_balance_person),0) as uncome_balance_person --         ˿ͻ
  from  kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date = v_bbq_endworkdate;
  commit;
  --վδڻعԪ
  insert into T_ETL_C13_1_JE
  select 16,3,round(nvl(sum(uncome_balance), 0) /
             greatest(to_number(to_date(v_bbq_enddate, 'yyyymmdd') -
                       to_date(v_bbq_begindate, 'yyyymmdd') + 1),1),--20190610 panxk mod ʼͽ ޸ĵ:M201906051759
             2) as av_uncome_balance
  from kods.t_hs08_his_QRPBASETOTAL
 where init_date between
       v_bbq_begindate and v_bbq_enddate;
  commit;
  
  --Ѻ
   insert into T_ETL_C13_1_JE
  select 17,3 ,to_char(round(nvl(sum(market_value),0) / nvl(decode(sum(uncome_balance),0,1,sum(uncome_balance)),1),4)) as av_impawn_ratio
    from kods.t_hs08_his_QRPBASETOTAL
   where init_date = v_bbq_endworkdate
    ;
  commit;
  
  
  --ۼҵģԪ
  insert into T_ETL_C13_1_JE
  select
     18,3,
     nvl(sum(repaid_interest),0) as repaid_interest_term
   from kods.t_hs08_his_QRPBASETOTAL a
   where a.init_date between v_bbq_begindate and v_bbq_enddate;
      
       --У
   insert into T_ETL_C13_1_JE
   select
     19,3,
     nvl(sum(trade_balance_short_term),0) as balance_short_term
   from kods.t_hs08_his_QRPBASETOTAL a
   where a.init_date between v_bbq_begindate and v_bbq_enddate;

        -- 
   insert into T_ETL_C13_1_JE
   select
     20,3,
     nvl(sum(trade_balance_medium_term),0) as balance_medium_term
   from kods.t_hs08_his_QRPBASETOTAL a
   where a.init_date between v_bbq_begindate and v_bbq_enddate;
        -- 
   insert into T_ETL_C13_1_JE
   select
     21,3,
     nvl(sum(trade_balance_long_term),0) as balance_long_term
   from kods.t_hs08_his_QRPBASETOTAL a
   where a.init_date between v_bbq_begindate and v_bbq_enddate;
  
  commit;
  
  --ع
  --У
   insert into T_ETL_C13_1_YWGM
  select 23,nvl(max(short_year_rate_high), 0)*100 as short_year_rate_high,nvl(min(short_year_rate_low), 0)*100 as short_year_rate_low
   from kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date between v_bbq_begindate and v_bbq_enddate; 
   
   --
   insert into T_ETL_C13_1_YWGM
  select 24, nvl(max(medium_year_rate_high), 0)*100 as medium_year_rate_high,nvl(min(medium_year_rate_low), 0)*100 as medium_year_rate_low
   from kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date between v_bbq_begindate and v_bbq_enddate;
   
  --
  insert into T_ETL_C13_1_YWGM
  select 25,nvl(max(long_year_rate_high), 0)*100 as long_year_rate_high,nvl(min(long_year_rate_low), 0)*100 as long_year_rate_low
   from kods.t_hs08_his_QRPBASETOTAL a
  where a.init_date between v_bbq_begindate and v_bbq_enddate; 
  commit;


 
  update t_etl_c13_3_je t set t.je=0 where t.je is null;
  commit;
  
  cisp_etl_bjhg_jyb;
  cisp_etl_bjhg_jyb_ljywgm;
  
  commit;
  

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_301
prompt ======================================
prompt
create or replace procedure cisp_map_hg_c13_301
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
     
  
  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;

  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  /*--modify zhenyj 20200601 ͻҪɾ8Լ
  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',
                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
  --ͻҪ޸
  update kods.A_HS08_SRPCONTRACT t set t.repaid_balance = decode(t.contract_id,'2017012000000005',134500000.00,124450000.00)
  where t.contract_id in ('2017012000000005','2017052300000001');
  commit;*/

  delete from t_etl_c13_3_sl;
  delete from t_etl_c13_3_je;
  delete from t_etl_c13_3_ywmx1;
  delete from t_etl_c13_3_ywmx2;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           1,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.sign_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  --ĩ
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  insert into t_etl_c13_3_sl
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

  --ؽ׽Ԫ 
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 8, 9), 1, sum(t.entrust_balance- t.repaid_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   exchange_type,
                   entrust_balance,
                   repaid_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   exchange_type,
                   entrust_balance,
                    repaid_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 8, 9),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where t.srp_contract_status = 1
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  insert into t_etl_c13_3_je
    select 7, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je
   select 10, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 30
     and t.srp_contract_status = 1
    ;
  commit;

  -- عʣ1ڣ
  insert into t_etl_c13_3_je
    select 11, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 30
       and to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 365
       and t.srp_contract_status = 1
       ;
  commit;

  -- عʣ1
  insert into t_etl_c13_3_je
    select 12, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 365
     ;
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           1,
           sum(t.entrust_balance - t.repaid_balance)
      from (select init_date,
                   client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select init_date,
                   client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
    --and t.real_date_back > v_bbq_enddate
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --/
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.srp_contract_status = 1
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 16, 18),
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
     group by decode(t.exchange_type, '1', 16, 18);
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je
    select 17,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.report_id like '%XL%';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je
    select 19,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.exchange_type = 2
       and t.stock_property <> '00'
       ;
  commit;

  insert into t_etl_c13_3_je
    select 15, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 21, '3', 21, 22),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.hth=t.contract_id and tt.sfwy='')
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 21, '3', 21, 22);
  commit;

  insert into t_etl_c13_3_je
    select 20, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 24, '3', 24, 25),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
        and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.hth=t.contract_id and tt.sfwy='')
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 24, '3', 24, 25);
  commit;

  insert into t_etl_c13_3_je
    select 23, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 28 xh,3,
           sum(case
                 when to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') <= 30 then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from  kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
              ) s;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  --29 ֤ȯ˾ΪڳۼҵģԪ           
  insert into t_etl_c13_3_je
    select 29 xh,3,
           sum(case
                 when (to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') <= 365) then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
            --and c.srp_contract_status = '1'
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
              ) s
   ;

  --30 ֤ȯ˾ΪڳۼҵģԪ         
  insert into t_etl_c13_3_je
    select 30 xh,3,
           sum(case
                 when to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') > 365 then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
            --and c.srp_contract_status = '1'
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
               ) s;

  insert into t_etl_c13_3_je
    select 27, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_3_je
    select 31,
           0,
           sum(REAL_BACK_BALANCE-ENTRUST_BALANCE+REPAID_BALANCE+SETTLE_INTEREST)
      from (select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status in ('4')
      ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 33, 3, nvl(sum(t.entrust_balance),0)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back < v_bbq_next_enddate
          --and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 34, 3, nvl(sum(t.entrust_balance),0)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back between v_bbq_enddate and
           v_bbq_next_year_enddate
       and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 35, 3, nvl(sum(t.entrust_balance),0)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back > v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
      ;
  commit;

  insert into t_etl_c13_3_je
    select 32, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 1, nvl(max(t.real_year_rate*100),0)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 30
     ;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 2, nvl(min(t.real_year_rate*100),0)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 30
       ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 1, max(t.real_year_rate*100)
      from kods.a_hs08_srpcontract t
     where (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 365)
     ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 2, min(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 365)
      ;
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je
    select 38, 1, max(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 365
     ;
  commit;

  insert into t_etl_c13_3_je
    select 38, 2, min(t.real_year_rate*100)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 365
    ;
  commit;

  insert into t_etl_c13_3_ywmx1
   select y.client_id,
           y.client_name,
           sum(x.entrust_balance-x.repaid_balance),
           sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price),
           round(sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price),
                 2) / round(sum(x.entrust_balance-x.repaid_balance), 2) * 100,
           0
      from (select t1.client_id,
                   t1.real_date_back,
                   t1.entrust_date,
                   t1.entrust_balance,
                   t1.repaid_balance,
                   t1.real_back_balance,
                   t1.stock_code,
                   t1.entrust_amount,
                   t1.exchange_type,
                   t1.bonus_amount,
                   t1.sum_back_amount,
                   t1.sum_spb_amount
              from kods.a_hs08_srpcontract t1 where not exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t1.client_id and tt.hth=t1.contract_id and tt.sfwy='')
             ) x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.client_id = y.client_id
       and x.stock_code = z.stock_code
       and x.exchange_type = z.exchange_type
       --and x.real_date_back > v_bbq_endworkdate
       and x.entrust_date <= v_bbq_enddate
       --and x.entrust_balance-x.repaid_balance > 0
     group by y.client_id, y.client_name having sum(x.entrust_balance-x.repaid_balance)>0
     order by sum(x.entrust_balance-x.repaid_balance) desc;
  commit;

  insert into t_etl_c13_3_ywmx2
  select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.stock_code as stock_code,
                   sum(x.entrust_amount + x.bonus_amount-x.sum_back_amount-x.sum_spb_amount) as entrust_amount,
                   sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-x.sum_spb_amount) * z.asset_price) as sz,
                   sum(x.entrust_amount + x.bonus_amount-x.sum_back_amount-x.sum_spb_amount) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from (select t1.client_id,
                           t1.real_date_back,
                           t1.entrust_date,
                           t1.entrust_balance,
                           t1.real_back_balance,
                           t1.stock_code,
                           t1.entrust_amount,
                           t1.exchange_type,
                           t1.bonus_amount,
                           t1.sum_back_amount,
                           t1.sum_spb_amount
                      from kods.a_hs08_srpcontract t1
                      where not exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t1.client_id and tt.hth=t1.contract_id and tt.sfwy='')
                      ) x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.stock_code = z.stock_code
               and x.stock_code = n.stock_code
               and x.exchange_type = z.exchange_type
               --and x.real_date_back > v_bbq_endworkdate
               and x.entrust_date <= v_bbq_enddate
               and x.stock_code = y.stock_code
             group by x.stock_code, y.stock_name, n.capital_amount
             order by sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price) desc) a
     where rownum < 6;
  commit;
  update t_etl_c13_3_je t set t.je=0 where t.je is null;
  commit;
  cisp_etl_gpzy_jyb;
  commit;
  cisp_etl_gpzy_jyb_ljywgm; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_20200214
prompt =============================================
prompt
create or replace procedure cisp_map_hg_c13_3_20200214
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;

  select max(t.phydate) into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;
  
  delete from t_etl_c13_3_sl;
  delete from t_etl_c13_3_je;
  delete from t_etl_c13_3_ywmx1;
  delete from t_etl_c13_3_ywmx2;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           1,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.sign_date between v_bbq_begindate and v_bbq_enddate
       and t.real_date_back > v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  --ĩ
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back > v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  insert into t_etl_c13_3_sl
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

  --ؽ׽Ԫ 
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 8, 9), 1, sum(t.entrust_balance)
      from (select exchange_type,
                   entrust_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select exchange_type,
                   entrust_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 8, 9),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where t.srp_contract_status = 1 --t.real_date_back > v_bbq_enddate
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  insert into t_etl_c13_3_je
    select 7, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je
    select 10, 3, sum(t.entrust_balance)
      from kods.a_hs08_srpcontract t
     where t.real_date_back between v_bbq_enddate and v_bbq_next_enddate;
  commit;

  --         عʣ1ڣ
  insert into t_etl_c13_3_je
    select 11, 3, sum(t.entrust_balance)
      from kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_enddate
       and t.real_date_back <= v_bbq_next_year_enddate;
  commit;

  --                  عʣ1
  insert into t_etl_c13_3_je
    select 12, 3, sum(t.entrust_balance)
      from kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_year_enddate;
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           1,
           sum(t.entrust_balance - t.repaid_balance)
      from (select init_date,
                   client_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select init_date,
                   client_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
    --and t.real_date_back > v_bbq_enddate
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --/
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
          --and t.real_date_back > v_bbq_enddate
       and t.srp_contract_status = 1
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 16, 18),
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.real_date_back > v_bbq_enddate
     group by decode(t.exchange_type, '1', 16, 18);
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je
    select 17,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.real_date_back > v_bbq_enddate
       and t.report_id like '%XL%';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je
    select 19,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.real_date_back > v_bbq_enddate
       and t.exchange_type = 2
       and t.stock_property <> '00';
  commit;

  insert into t_etl_c13_3_je
    select 15, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 21, '3', 21, 22),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back <= v_bbq_enddate
          --and t.date_back <= v_bbq_enddate  modify by zhenyj 20191205 δؾΥԼ
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 21, '3', 21, 22);
  commit;

  insert into t_etl_c13_3_je
    select 20, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 24, '3', 24, 25),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back <= v_bbq_enddate
          --and t.date_back <= v_bbq_enddate  modify by zhenyj 20191205 δؾΥԼ
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 24, '3', 24, 25);
  commit;
  insert into t_etl_c13_3_je
    select 23, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 28, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no in (1, 71, 81, 91)) t
     where to_date(t.real_date_back, 'yyyymmdd') -
           to_date(t.init_date, 'yyyymmdd') < 31
          --t.real_date_back < v_bbq_next_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 29, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no in (1, 71, 81, 91)) t
     where to_date(t.real_date_back, 'yyyymmdd') -
           to_date(t.init_date, 'yyyymmdd') between 31 and 366
          --t.real_date_back between v_bbq_next_enddate and v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 30, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no in (1, 71, 81, 91)) t
     where to_date(t.real_date_back, 'yyyymmdd') -
           to_date(t.init_date, 'yyyymmdd') > 366
          --t.real_date_back > v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  insert into t_etl_c13_3_je
    select 27, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_3_je
    select 31,
           0,
           sum(round(entrust_balance * real_year_rate *
                     (to_date(real_date_back, 'yyyymmdd') -
                     to_date(init_date, 'yyyymmdd')) / 365,
                     2))
      from (select init_date,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select init_date,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 33, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back < v_bbq_next_enddate
          --and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 34, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back between v_bbq_enddate and
           v_bbq_next_year_enddate
       and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 35, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back > v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  insert into t_etl_c13_3_je
    select 32, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 1, max(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back between v_bbq_enddate and v_bbq_next_enddate
          --and t.entrust_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 2, min(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           ) */ kods.a_hs08_srpcontract t
     where t.real_date_back between v_bbq_enddate and v_bbq_next_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 1, max(t.real_year_rate) * 100 --expire_year_rate
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_enddate
       and t.real_date_back < = v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 2, min(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_enddate
       and t.real_date_back < = v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je
    select 38, 1, max(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  insert into t_etl_c13_3_je
    select 38, 2, min(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status /*srp_contract_type*/
           = 1;
  commit;

  insert into t_etl_c13_3_ywmx1
    select y.client_id,
           y.client_name,
           sum(x.entrust_balance),
           sum((x.entrust_amount + x.bonus_amount) * z.asset_price),
           round(sum((x.entrust_amount + x.bonus_amount) * z.asset_price),
                 2) / round(sum(x.entrust_balance), 2) * 100,
           0
      from (select t1.client_id,
                   t1.real_date_back,
                   t1.entrust_date,
                   t1.entrust_balance,
                   t1.real_back_balance,
                   t1.stock_code,
                   t1.entrust_amount,
                   t1.exchange_type,
                   t1.bonus_amount
              from kods.a_hs08_srpcontract t1) x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.client_id = y.client_id
       and x.stock_code = z.stock_code
       and x.exchange_type = z.exchange_type
       and x.real_date_back > v_bbq_enddate
       and x.entrust_date <= v_bbq_enddate
       and x.entrust_balance > 0
     group by y.client_id, y.client_name
     order by sum(x.entrust_balance) desc;
  commit;

  insert into t_etl_c13_3_ywmx2
    select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.stock_code as stock_code,
                   sum(x.entrust_amount) as entrust_amount,
                   sum((x.entrust_amount) * z.asset_price) as sz,
                   sum(x.entrust_amount) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from (select t1.client_id,
                           t1.real_date_back,
                           t1.entrust_date,
                           t1.entrust_balance,
                           t1.real_back_balance,
                           t1.stock_code,
                           t1.entrust_amount,
                           t1.exchange_type,
                           t1.bonus_amount
                      from kods.a_hs08_srpcontract t1) x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.stock_code = z.stock_code
               and x.stock_code = n.stock_code
               and x.exchange_type = z.exchange_type
               and x.real_date_back > v_bbq_enddate
               and x.entrust_date <= v_bbq_enddate
               and x.stock_code = y.stock_code
             group by x.stock_code, y.stock_name, n.capital_amount
             order by sum(x.entrust_amount * z.asset_price) desc) a
     where rownum < 6;
  commit;

  cisp_etl_gpzy_jyb;
  commit;
  cisp_etl_gpzy_jyb_ljywgm; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_20200916
prompt =============================================
prompt
create or replace procedure cisp_map_hg_c13_3_20200916
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;

  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  --modify zhenyj 20200601 ͻҪɾ8Լ
  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',
                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
  --ͻҪ޸
  update kods.A_HS08_SRPCONTRACT t set t.repaid_balance = decode(t.contract_id,'2017012000000005',134500000.00,124450000.00)
  where t.contract_id in ('2017012000000005','2017052300000001');
  commit;
  
  delete from t_etl_c13_3_sl;
  delete from t_etl_c13_3_je;
  delete from t_etl_c13_3_ywmx1;
  delete from t_etl_c13_3_ywmx2;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           1,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.sign_date between v_bbq_begindate and v_bbq_enddate
       and t.real_date_back > v_bbq_endworkdate
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  --ĩ
  insert into t_etl_c13_3_sl
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back > v_bbq_endworkdate
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  insert into t_etl_c13_3_sl
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

  --ؽ׽Ԫ 
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 8, 9), 1, sum(t.entrust_balance)
      from (select exchange_type,
                   entrust_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select exchange_type,
                   entrust_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 8, 9),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where t.srp_contract_status = 1 --t.real_date_back > v_bbq_enddate
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  insert into t_etl_c13_3_je
    select 7, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je
    select 10, 3, sum(t.entrust_balance)
      from kods.a_hs08_srpcontract t
     where t.real_date_back between v_bbq_enddate and v_bbq_next_enddate;
  commit;

  --         عʣ1ڣ
  insert into t_etl_c13_3_je
    select 11, 3, sum(t.entrust_balance)
      from kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_enddate
       and t.real_date_back <= v_bbq_next_year_enddate;
  commit;

  --                  عʣ1
  insert into t_etl_c13_3_je
    select 12, 3, sum(t.entrust_balance)
      from kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_year_enddate;
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           1,
           sum(t.entrust_balance - t.repaid_balance)
      from (select init_date,
                   client_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select init_date,
                   client_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
    --and t.real_date_back > v_bbq_enddate
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --/
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
          --and t.real_date_back > v_bbq_enddate
       and t.srp_contract_status = 1
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je
    select decode(t.exchange_type, '1', 16, 18),
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.real_date_back > v_bbq_endworkdate
     group by decode(t.exchange_type, '1', 16, 18);
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je
    select 17,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.real_date_back > v_bbq_endworkdate
       and t.report_id like '%XL%';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je
    select 19,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.real_date_back > v_bbq_endworkdate
       and t.exchange_type = 2
       and t.stock_property <> '00';
  commit;

  insert into t_etl_c13_3_je
    select 15, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 21, '3', 21, 22),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back <= v_bbq_endworkdate
          --and t.date_back <= v_bbq_enddate  modify by zhenyj 20191205 δؾΥԼ
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 21, '3', 21, 22);
  commit;

  insert into t_etl_c13_3_je
    select 20, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je
    select decode(t1.organ_flag, '1', 24, '3', 24, 25),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.real_date_back <= v_bbq_endworkdate
          --and t.date_back <= v_bbq_enddate  modify by zhenyj 20191205 δؾΥԼ
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 24, '3', 24, 25);
  commit;
  insert into t_etl_c13_3_je
    select 23, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 28, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no in (1, 71, 81, 91)) t
     where to_date(t.real_date_back, 'yyyymmdd') -
           to_date(t.init_date, 'yyyymmdd') < 31
          --t.real_date_back < v_bbq_next_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 29, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no in (1, 71, 81, 91)) t
     where to_date(t.real_date_back, 'yyyymmdd') -
           to_date(t.init_date, 'yyyymmdd') between 31 and 366
          --t.real_date_back between v_bbq_next_enddate and v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 30, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no in (1, 71, 81, 91)) t
     where to_date(t.real_date_back, 'yyyymmdd') -
           to_date(t.init_date, 'yyyymmdd') > 366
          --t.real_date_back > v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  insert into t_etl_c13_3_je
    select 27, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_3_je
    select 31,
           0,
           sum(round(entrust_balance * real_year_rate *
                     (to_date(real_date_back, 'yyyymmdd') -
                     to_date(init_date, 'yyyymmdd')) / 365,
                     2))
      from (select init_date,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select init_date,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 33, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back < v_bbq_next_enddate
          --and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 34, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back between v_bbq_enddate and
           v_bbq_next_year_enddate
       and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je
    select 35, 3, sum(t.entrust_balance)
      from (select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back > v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5');
  commit;

  insert into t_etl_c13_3_je
    select 32, jylx, sum(je)
      from t_etl_c13_3_je t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 1, max(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back between v_bbq_enddate and v_bbq_next_enddate
          --and t.entrust_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У
  insert into t_etl_c13_3_je
    select 36, 2, min(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           ) */ kods.a_hs08_srpcontract t
     where t.real_date_back between v_bbq_enddate and v_bbq_next_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 1, max(t.real_year_rate) * 100 --expire_year_rate
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_enddate
       and t.real_date_back < = v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je
    select 37, 2, min(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_enddate
       and t.real_date_back < = v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je
    select 38, 1, max(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status = 1;
  commit;

  insert into t_etl_c13_3_je
    select 38, 2, min(t.real_year_rate) * 100
      from /*(
           select t1.expire_year_rate,t1.real_date_back,t1.entrust_date,t1.init_date,t1.srp_contract_type from kods.a_hs08_srpcontract t1
           union all
           select t2.expire_year_rate,t2.real_date_back,t2.entrust_date,t2.init_date,t2.srp_contract_type from kods.a_hs08_his_srpcontract t2
           )*/ kods.a_hs08_srpcontract t
     where t.real_date_back > v_bbq_next_year_enddate
          --and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status /*srp_contract_type*/
           = 1;
  commit;

  insert into t_etl_c13_3_ywmx1
    select y.client_id,
           y.client_name,
           sum(x.entrust_balance),
           sum((x.entrust_amount + x.bonus_amount) * z.asset_price),
           round(sum((x.entrust_amount + x.bonus_amount) * z.asset_price),
                 2) / round(sum(x.entrust_balance), 2) * 100,
           0
      from (select t1.client_id,
                   t1.real_date_back,
                   t1.entrust_date,
                   t1.entrust_balance,
                   t1.real_back_balance,
                   t1.stock_code,
                   t1.entrust_amount,
                   t1.exchange_type,
                   t1.bonus_amount
              from kods.a_hs08_srpcontract t1) x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.client_id = y.client_id
       and x.stock_code = z.stock_code
       and x.exchange_type = z.exchange_type
       and x.real_date_back > v_bbq_endworkdate
       and x.entrust_date <= v_bbq_enddate
       and x.entrust_balance > 0
     group by y.client_id, y.client_name
     order by sum(x.entrust_balance) desc;
  commit;

  insert into t_etl_c13_3_ywmx2
    select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.stock_code as stock_code,
                   sum(x.entrust_amount) as entrust_amount,
                   sum((x.entrust_amount) * z.asset_price) as sz,
                   sum(x.entrust_amount) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from (select t1.client_id,
                           t1.real_date_back,
                           t1.entrust_date,
                           t1.entrust_balance,
                           t1.real_back_balance,
                           t1.stock_code,
                           t1.entrust_amount,
                           t1.exchange_type,
                           t1.bonus_amount
                      from kods.a_hs08_srpcontract t1) x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.stock_code = z.stock_code
               and x.stock_code = n.stock_code
               and x.exchange_type = z.exchange_type
               and x.real_date_back > v_bbq_endworkdate
               and x.entrust_date <= v_bbq_enddate
               and x.stock_code = y.stock_code
             group by x.stock_code, y.stock_name, n.capital_amount
             order by sum(x.entrust_amount * z.asset_price) desc) a
     where rownum < 6;
  commit;

  cisp_etl_gpzy_jyb;
  commit;
  cisp_etl_gpzy_jyb_ljywgm; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_RH01
prompt =========================================
prompt
create or replace procedure cisp_map_hg_c13_3_rh01
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;

  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  --modify zhenyj 20200601 ͻҪɾ8Լ
/*  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',
                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
*/

  delete from t_etl_c13_3_sl_rh;
  delete from t_etl_c13_3_je_rh;
  delete from t_etl_c13_3_ywmx1_rh;
  delete from t_etl_c13_3_ywmx2_rh;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl_rh
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
       --and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.rcflx='ʹӹ˾ʹܿͻ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl_rh
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
       --and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.rcflx='ʹӹ˾ʹܿͻ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl_rh
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl_rh t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl_rh
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           1,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.sign_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  --ĩ
  insert into t_etl_c13_3_sl_rh
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t1.organ_flag in ('0', '1', '3')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  insert into t_etl_c13_3_sl_rh
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl_rh t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

  --ؽ׽Ԫ 
  insert into t_etl_c13_3_je_rh
    select decode(t.exchange_type, '1', 8, 9), 1, sum(t.entrust_balance- t.repaid_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   exchange_type,
                   entrust_balance,
                   repaid_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   exchange_type,
                   entrust_balance,
                    repaid_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.init_date between v_bbq_begindate and v_bbq_enddate
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
       and t.srp_contract_status not in ('5')
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je_rh
    select decode(t.exchange_type, '1', 8, 9),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where t.srp_contract_status = 1
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  insert into t_etl_c13_3_je_rh
    select 7, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je_rh
   select 10, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 30
     and t.srp_contract_status = 1
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  -- عʣ1ڣ
  insert into t_etl_c13_3_je_rh
    select 11, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 30
       and to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 365
       and t.srp_contract_status = 1
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  -- عʣ1
  insert into t_etl_c13_3_je_rh
    select 12, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 365
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je_rh t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je_rh
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je_rh
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           1,
           sum(t.entrust_balance - t.repaid_balance)
      from (select init_date,
                   client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select init_date,
                   client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
    --and t.real_date_back > v_bbq_enddate
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --/
  insert into t_etl_c13_3_je_rh
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
       and t.srp_contract_status = 1
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je_rh
    select decode(t.exchange_type, '1', 16, 18),
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
     group by decode(t.exchange_type, '1', 16, 18);
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je_rh
    select 17,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
       and t.report_id like '%XL%';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je_rh
    select 19,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.exchange_type = 2
       and t.stock_property <> '00'
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  insert into t_etl_c13_3_je_rh
    select 15, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je_rh
    select decode(t1.organ_flag, '1', 21, '3', 21, 22),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.hth=t.contract_id and tt.rcflx='ʹӹ˾ʹܿͻ' and tt.sfwy='')
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 21, '3', 21, 22);
  commit;

  insert into t_etl_c13_3_je_rh
    select 20, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je_rh
    select decode(t1.organ_flag, '1', 24, '3', 24, 25),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
        and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.hth=t.contract_id and tt.rcflx='ʹӹ˾ʹܿͻ' and tt.sfwy='')
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 24, '3', 24, 25);
  commit;

  insert into t_etl_c13_3_je_rh
    select 23, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je_rh
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je_rh
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je_rh
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
    select 28 xh,3,
           sum(case
                 when to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') <= 30 then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='05')
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from  kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='05')) s;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  --29 ֤ȯ˾ΪڳۼҵģԪ           
  insert into t_etl_c13_3_je_rh
    select 29 xh,3,
           sum(case
                 when (to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') <= 365) then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='05')
            --and c.srp_contract_status = '1'
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='05')) s
   ;

  --30 ֤ȯ˾ΪڳۼҵģԪ         
  insert into t_etl_c13_3_je_rh
    select 30 xh,3,
           sum(case
                 when to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') > 365 then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='05')
            --and c.srp_contract_status = '1'
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='05')) s;

  insert into t_etl_c13_3_je_rh
    select 27, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_3_je_rh
    select 31,
           0,
           sum(REAL_BACK_BALANCE-ENTRUST_BALANCE+REPAID_BALANCE+SETTLE_INTEREST)
      from (select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status in ('4')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
    select 33, 3, sum(t.entrust_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back < v_bbq_next_enddate
          --and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05')
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
    select 34, 3, sum(t.entrust_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back between v_bbq_enddate and
           v_bbq_next_year_enddate
       and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_rh
    select 35, 3, sum(t.entrust_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back > v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  insert into t_etl_c13_3_je_rh
    select 32, jylx, sum(je)
      from t_etl_c13_3_je_rh t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je_rh
    select 36, 1, max(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 30
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  --ع     У
  insert into t_etl_c13_3_je_rh
    select 36, 2, min(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 30
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05') ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_rh
    select 37, 1, max(t.real_year_rate*100)
      from kods.a_hs08_srpcontract t
     where (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 365)
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_rh
    select 37, 2, min(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 365)
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je_rh
    select 38, 1, max(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 365
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  insert into t_etl_c13_3_je_rh
    select 38, 2, min(t.real_year_rate*100)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 365
    and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='05');
  commit;

  insert into t_etl_c13_3_ywmx1_rh
   select y.client_id,
           y.client_name,
           sum(x.entrust_balance-x.repaid_balance),
           sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price),
           round(sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price),
                 2) / round(sum(x.entrust_balance-x.repaid_balance), 2) * 100,
           0
      from (select t1.client_id,
                   t1.real_date_back,
                   t1.entrust_date,
                   t1.entrust_balance,
                   t1.repaid_balance,
                   t1.real_back_balance,
                   t1.stock_code,
                   t1.entrust_amount,
                   t1.exchange_type,
                   t1.bonus_amount,
                   t1.sum_back_amount,
                   t1.sum_spb_amount
              from kods.a_hs08_srpcontract t1
              where exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t1.client_id and tt.hth=t1.contract_id and tt.sfwy='' and tt.rcflx='ʹӹ˾ʹܿͻ')) x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.client_id = y.client_id
       and x.stock_code = z.stock_code
       and x.exchange_type = z.exchange_type
       --and x.real_date_back > v_bbq_endworkdate
       and x.entrust_date <= v_bbq_enddate
       --and x.entrust_balance-x.repaid_balance > 0
     group by y.client_id, y.client_name having sum(x.entrust_balance-x.repaid_balance)>0
     order by sum(x.entrust_balance-x.repaid_balance) desc;
  commit;

  insert into t_etl_c13_3_ywmx2_rh
  select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.stock_code as stock_code,
                   sum(x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) as entrust_amount,
                   sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price) as sz,
                   sum(x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from (select t1.client_id,
                           t1.real_date_back,
                           t1.entrust_date,
                           t1.entrust_balance,
                           t1.real_back_balance,
                           t1.stock_code,
                           t1.entrust_amount,
                           t1.exchange_type,
                           t1.bonus_amount,
                           t1.sum_back_amount,
                           t1.sum_spb_amount
                      from kods.a_hs08_srpcontract t1
                      where exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t1.client_id and tt.hth=t1.contract_id and tt.sfwy='' and tt.rcflx='ʹӹ˾ʹܿͻ')
                      ) x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.stock_code = z.stock_code
               and x.stock_code = n.stock_code
               and x.exchange_type = z.exchange_type
               --and x.real_date_back > v_bbq_endworkdate
               and x.entrust_date <= v_bbq_enddate
               and x.stock_code = y.stock_code
             group by x.stock_code, y.stock_name, n.capital_amount 
             order by sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price) desc) a
     where rownum < 6;
  commit;
  update t_etl_c13_3_je_rh t set t.je=0 where t.je is null;
  commit;
  cisp_etl_gpzy_jyb_rh;
  commit;
  cisp_etl_gpzy_jyb_ljywgm_rh; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll_rh; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1_rh; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2_rh; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_YCL01
prompt ==========================================
prompt
create or replace procedure cisp_map_hg_c13_3_ycl01
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
delete from t_etl_c13_3_ycl;
delete from T_BKS_ZYRHHY;
commit;
--ڻ㼰ʽ
insert into t_etl_c13_3_ycl
select t.init_date,
       t.contract_id,
       t.join_contract_id,
       t.REPORT_ID,
       decode(t.SRP_CONTRACT_TYPE, '0', 'ʼͬ', 'ͬ'),
       t2.branch_name,
       t.client_id,
       t4.client_name,
       t3.funder_name,
       decode(t3.FUNDER_TYPE,
              '01',
              '֤ȯ˾Ӫ',
              'ʹӹ˾ʹܿͻ'),
       t1.stock_code,
       t1.stock_name,
       t.ENTRUST_AMOUNT,
       t.BONUS_AMOUNT,
       t.SUM_BACK_AMOUNT,
       t.SUM_SPB_AMOUNT,
       t.ENTRUST_BALANCE,
       t.repaid_balance,
       t.date_back,
       t.REAL_DATE_BACK,
       t.real_year_rate,
       ''
       /*case
         when t.real_date_back > v_bbq_enddate then
          ''
         else
          ''
       end*/
  from KODS.A_HS08_SRPCONTRACT t
  left join kods.RZRQ_HS_CLIENT t4
   on t.client_id=t4.client_id
  left join kods.RZRQ_HS_STKCODE t1
    on t.stock_code = t1.stock_code
  left join kods.RZRQ_HS_USER_ALLBRANCH t2
    on t.branch_no = t2.branch_no
  left join kods.A_HS08_GPZY_SRPFUNDER t3
    on t.funder_no = t3.funder_no
 where t3.funder_type in ('01', '05')
    and t.srp_contract_status not in ('4','5')
    and t.contract_id not in ('2015043000000018','2015043000000020','2015043000000022','2015051100000018','2015051100000024','2015051100000026','2014090300000007','2015061100000005')
 order by t.contract_id;
 commit;

update  t_etl_c13_3_ycl t set t.sfwy=(select wybs from t_cisp_htwybs t1 where t1.contract_id=t.hth)
where exists (select 1 from t_cisp_htwybs t1 where t1.contract_id=t.hth);
commit;

insert into T_BKS_ZYRHHY
select rownum,t.*,100000 from T_ETL_C13_3_YCL t order by t.hth;
commit;


end;
/

prompt
prompt Creating procedure CISP_MAP_HG_C13_3_ZYZJ01
prompt ===========================================
prompt
create or replace procedure cisp_map_hg_c13_3_zyzj01
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 31, 'yyyymmdd')
    into v_bbq_next_enddate
    from dual;

  select to_char(to_date(v_bbq_enddate, 'yyyymmdd') + 365, 'yyyymmdd')
    into v_bbq_next_year_enddate
    from dual;

  select max(t.phydate)
    into v_bbq_endworkdate
    from krcs.t_krcs_trdcalendar t
   where t.businessflag = 1
     and t.phydate <= v_bbq_enddate;

  --modify zhenyj 20200601 ͻҪɾ8Լ
/*  delete from KODS.A_HS08_SRPCONTRACT t
   where t.contract_id in ('2014090300000007',
                           '2015043000000018',
                           '2015043000000020',
                           '2015043000000022',
                           '2015051100000018',
                           '2015051100000024',
                           '2015051100000026',
                           '2015061100000005');
  commit;
  --ͻҪ޸
  update kods.A_HS08_SRPCONTRACT t set t.repaid_balance = decode(t.contract_id,'2017012000000005',134500000.00,124450000.00)
  where t.contract_id in ('2017012000000005','2017052300000001');
  commit;*/

  delete from t_etl_c13_3_sl_zyzj;
  delete from t_etl_c13_3_je_zyzj;
  delete from t_etl_c13_3_ywmx1_zyzj;
  delete from t_etl_c13_3_ywmx2_zyzj;
  commit;

  --ǩԼͻ  
  insert into t_etl_c13_3_sl_zyzj
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           1,
           count(distinct t.client_id)
      from kods.a_ygt_his_stockholderjour t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and t.business_flag in ('1477') -- 1447 ƱѺʽعȨ
       --and exists (select 1 from t_etl_c13_3_ycl tt where tt.khbm=t.client_id and tt.rcflx='֤ȯ˾Ӫ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  --ǩԼͻ  ĩ
  insert into t_etl_c13_3_sl_zyzj
    select decode(t1.organ_flag, '1', 2, '3', 2, 3),
           3,
           count(distinct t.client_id)
      from kods.rzrq_hs_stockholder t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.holder_rights like '%t%'
       and t1.organ_flag in ('0', '1', '3')
       and t.asset_prop = '0'
       --and exists (select 1 from t_etl_c13_3_ycl tt where tt.khbm=t.client_id and tt.rcflx='֤ȯ˾Ӫ')
     group by decode(t1.organ_flag, '1', 2, '3', 2, 3);
  commit;

  insert into t_etl_c13_3_sl_zyzj
    select 1, jylx, sum(sl)
      from t_etl_c13_3_sl_zyzj t
     where t.xm in (2, 3)
     group by t.jylx;
  commit;

  --ڴؽ׿ͻ  
  insert into t_etl_c13_3_sl_zyzj
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           1,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t.sign_date between v_bbq_begindate and v_bbq_enddate
       and t1.organ_flag in ('0', '1', '3')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  --ĩ
  insert into t_etl_c13_3_sl_zyzj
    select decode(t1.organ_flag, '1', 5, '3', 5, 6),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and t1.organ_flag in ('0', '1', '3')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
     group by decode(t1.organ_flag, '1', 5, '3', 5, 6);
  commit;

  insert into t_etl_c13_3_sl_zyzj
    select 4, jylx, sum(sl)
      from t_etl_c13_3_sl_zyzj t
     where t.xm in (5, 6)
     group by t.jylx;
  commit;

  --ؽ׽Ԫ 
  insert into t_etl_c13_3_je_zyzj
    select decode(t.exchange_type, '1', 8, 9), 1, sum(t.entrust_balance- t.repaid_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   exchange_type,
                   entrust_balance,
                   repaid_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   exchange_type,
                   entrust_balance,
                    repaid_balance,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.init_date between v_bbq_begindate and v_bbq_enddate
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
       and t.srp_contract_status not in ('5')
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  --ؽ׽Ԫ ĩ
  insert into t_etl_c13_3_je_zyzj
    select decode(t.exchange_type, '1', 8, 9),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where t.srp_contract_status = 1
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
     group by decode(t.exchange_type, '1', 8, 9);
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 7, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (8, 9)
     group by t.jylx;
  commit;

  --   Уعʣ1ڣ
  insert into t_etl_c13_3_je_zyzj
   select 10, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 30
     and t.srp_contract_status = 1
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  -- عʣ1ڣ
  insert into t_etl_c13_3_je_zyzj
    select 11, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 30
       and to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') <= 365
       and t.srp_contract_status = 1
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  -- عʣ1
  insert into t_etl_c13_3_je_zyzj
    select 12, 3, sum(t.entrust_balance-t.repaid_balance)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back,'yyyymmdd') - to_date(v_bbq_enddate,'yyyymmdd') > 365
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;
  --ƽ⹫ʽ
  update t_etl_c13_3_je_zyzj t
     set t.je =
         (select sum(decode(xm, 7, je, -je))
            from t_etl_c13_3_je_zyzj
           where xm in (7, 10, 11)
             and jylx = 3)
   where t.xm = 12
     and jylx = 3;
  commit;

  --/
  insert into t_etl_c13_3_je_zyzj
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           1,
           sum(t.entrust_balance - t.repaid_balance)
      from (select init_date,
                   client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select init_date,
                   client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   repaid_balance,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
    --and t.real_date_back > v_bbq_enddate
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --/
  insert into t_etl_c13_3_je_zyzj
    select decode(t1.organ_flag, '1', 13, '3', 13, 14),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
       and t.srp_contract_status = 1
     group by decode(t1.organ_flag, '1', 13, '3', 13, 14);
  commit;

  --Ѻ֤ȯֵԪ
  insert into t_etl_c13_3_je_zyzj
    select decode(t.exchange_type, '1', 16, 18),
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
     group by decode(t.exchange_type, '1', 16, 18);
  commit;

  --Ѻ֤ȯֵԪ --Ϻ۹ֵ
  insert into t_etl_c13_3_je_zyzj
    select 17,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
       and t.report_id like '%XL%';
  commit;

  --Ѻ֤ȯֵԪ --۹ֵ
  insert into t_etl_c13_3_je_zyzj
    select 19,
           3,
           sum((t.entrust_amount + t.bonus_amount - t.sum_back_amount-t.sum_spb_amount) *
               t1.asset_price)
      from kods.a_hs08_srpcontract t,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) t1
     where t.stock_code = t1.stock_code
       and t.exchange_type = t1.exchange_type
       and t.exchange_type = 2
       and t.stock_property <> '00'
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 15, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (16, 18)
     group by t.jylx;
  commit;

  --ΥԼͻ
  insert into t_etl_c13_3_je_zyzj
    select decode(t1.organ_flag, '1', 21, '3', 21, 22),
           3,
           count(distinct t.client_id)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
       and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.hth=t.contract_id and tt.rcflx='֤ȯ˾Ӫ' and tt.sfwy='')
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 21, '3', 21, 22);
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 20, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (22, 21)
     group by t.jylx;
  commit;
  --ΥԼ
  insert into t_etl_c13_3_je_zyzj
    select decode(t1.organ_flag, '1', 24, '3', 24, 25),
           3,
           sum(t.entrust_balance - t.repaid_balance)
      from kods.a_hs08_srpcontract t,
           (select a.client_id, a.organ_flag as organ_flag
              from kods.rzrq_hs_client a) t1
     where t.client_id = t1.client_id
        and exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t.client_id and tt.hth=t.contract_id and tt.rcflx='֤ȯ˾Ӫ' and tt.sfwy='')
       and t1.organ_flag in ('0', '1', '3')
     group by decode(t1.organ_flag, '1', 24, '3', 24, 25);
  commit;
  
  insert into t_etl_c13_3_je_zyzj
    select 23, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (24, 25)
     group by t.jylx;
  commit;

  --Լϱ
  select round(nvl(sum(je), 0), 2)
    into v_dhgsz
    from t_etl_c13_3_je_zyzj
   where xm = 15
     and jylx = 3;
  select round(nvl(sum(je), 0), 2)
    into v_dhgje
    from t_etl_c13_3_je_zyzj
   where xm = 7
     and jylx = 3;
  insert into t_etl_c13_3_je_zyzj
    select 26, 3, round(v_dhgsz / v_dhgje * 100, 2) from dual;
  commit;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
    select 28 xh,3,
           sum(case
                 when to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') <= 30 then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='01')
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from  kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='01')) s;

  --֤ȯ˾Ϊڳ ۼҵģԪ  -
  --29 ֤ȯ˾ΪڳۼҵģԪ           
  insert into t_etl_c13_3_je_zyzj
    select 29 xh,3,
           sum(case
                 when (to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') <= 365) then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='01')
            --and c.srp_contract_status = '1'
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='01')) s
   ;

  --30 ֤ȯ˾ΪڳۼҵģԪ         
  insert into t_etl_c13_3_je_zyzj
    select 30 xh,3,
           sum(case
                 when to_date(s.date_back, 'yyyymmdd') -
                      to_date(s.entrust_date, 'yyyymmdd') > 365 then --
                  s.entrust_balance
                 else
                  0.0
               end) c
      from (select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_srpcontract c
             where c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status not in ('0', 5)
               and (c.REAL_DATE_BACK > v_bbq_enddate or c.DATE_CLEAR = 0) -- 20170405 zzk date_clear = 0ʾû㼴ΥԼǰ
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='01')
            --and c.srp_contract_status = '1'
            union all
            select c.init_date,
                   c.contract_id,
                   c.srp_contract_type,
                   c.srp_contract_status,
                   c.entrust_balance,
                   c.expire_year_rate,
                   c.client_id,
                   c.date_back,
                   c.funder_no,
                   c.entrust_date
              from kods.a_hs08_his_srpcontract c
             where c.date_clear between v_bbq_begindate and v_bbq_enddate
               and c.entrust_date between v_bbq_begindate and v_bbq_enddate
               and c.srp_contract_status = '4'
               and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where c.funder_no=tt.funder_no and tt.funder_type='01')) s;

  insert into t_etl_c13_3_je_zyzj
    select 27, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (28, 29, 30)
     group by t.jylx;
  commit;

  -- ʵϢ루Ԫ
  insert into t_etl_c13_3_je_zyzj
    select 31,
           0,
           sum(REAL_BACK_BALANCE-ENTRUST_BALANCE+REPAID_BALANCE+SETTLE_INTEREST)
      from (select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_srpcontract
            union all
            select client_id,
                   contract_id,
                   init_date,
                   funder_no,
                   entrust_balance,
                   real_year_rate,
                   real_date_back,
                   repaid_balance,
                   settle_interest,
                   REAL_BACK_BALANCE,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract) t
     where t.real_date_back between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status  in ('4')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
    select 33, 3, sum(t.entrust_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back < v_bbq_next_enddate
          --and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status  in ('4')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01')
       ;
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
    select 34, 3, sum(t.entrust_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back between v_bbq_enddate and
           v_bbq_next_year_enddate
       and t.real_date_back > v_bbq_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  --ʲƻΪڳ ۼҵģԪ  -
  insert into t_etl_c13_3_je_zyzj
    select 35, 3, sum(t.entrust_balance)
      from (select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_srpcontract
             where funder_no not in (1, 71, 81, 91)
            union all
            select client_id,
                   funder_no,
                   contract_id,
                   entrust_balance,
                   real_date_back,
                   entrust_date,
                   init_date,
                   srp_contract_status
              from kods.a_hs08_his_srpcontract
             where funder_no not in (1, 71, 81, 91)) t
     where t.real_date_back > v_bbq_next_year_enddate
       and t.init_date between v_bbq_begindate and v_bbq_enddate
       and t.srp_contract_status not in ('5')
       and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 32, jylx, sum(je)
      from t_etl_c13_3_je_zyzj t
     where t.xm in (33, 34, 35)
     group by t.jylx;
  commit;

  --ع     У
  insert into t_etl_c13_3_je_zyzj
    select 36, 1, max(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 30 
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  --ع     У
  insert into t_etl_c13_3_je_zyzj
    select 36, 2, min(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 30
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01') ;
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_zyzj
    select 37, 1, max(t.real_year_rate*100)
      from kods.a_hs08_srpcontract t
     where (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 365)
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  --ع     У         
  insert into t_etl_c13_3_je_zyzj
    select 37, 2, min(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 30) and
                      (to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') <= 365)
      and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  --ع     У                  
  insert into t_etl_c13_3_je_zyzj
    select 38, 1, max(t.real_year_rate*100)
      from  kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 365
     and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  insert into t_etl_c13_3_je_zyzj
    select 38, 2, min(t.real_year_rate*100)
      from kods.a_hs08_srpcontract t
     where to_date(t.real_date_back, 'yyyymmdd') -
                      to_date(t.entrust_date, 'yyyymmdd') > 365
    and exists (select 1 from kods.A_HS08_GPZY_SRPFUNDER tt where t.funder_no=tt.funder_no and tt.funder_type='01');
  commit;

  insert into t_etl_c13_3_ywmx1_zyzj
   select y.client_id,
           y.client_name,
           sum(x.entrust_balance-x.repaid_balance),
           sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price),
           round(sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price),
                 2) / round(sum(x.entrust_balance-x.repaid_balance), 2) * 100,
           0
      from (select t1.client_id,
                   t1.real_date_back,
                   t1.entrust_date,
                   t1.entrust_balance,
                   t1.repaid_balance,
                   t1.real_back_balance,
                   t1.stock_code,
                   t1.entrust_amount,
                   t1.exchange_type,
                   t1.bonus_amount,
                   t1.sum_back_amount,
                   t1.sum_spb_amount
              from kods.a_hs08_srpcontract t1
              where exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t1.client_id and tt.hth=t1.contract_id and tt.sfwy='' and tt.rcflx='֤ȯ˾Ӫ')) x,
           kods.rzrq_hs_client y,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) z
     where x.client_id = y.client_id
       and x.stock_code = z.stock_code
       and x.exchange_type = z.exchange_type
       --and x.real_date_back > v_bbq_endworkdate
       and x.entrust_date <= v_bbq_enddate
     group by y.client_id, y.client_name having sum(x.entrust_balance-x.repaid_balance)>0
     order by sum(x.entrust_balance-x.repaid_balance) desc;
  commit;

  insert into t_etl_c13_3_ywmx2_zyzj
  select stock_code, entrust_amount, sz, bl, 0, stock_name
      from (select x.stock_code as stock_code,
                   sum(x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) as entrust_amount,
                   sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price) as sz,
                   sum(x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) / n.capital_amount * 100 as bl,
                   y.stock_name as stock_name
              from (select t1.client_id,
                           t1.real_date_back,
                           t1.entrust_date,
                           t1.entrust_balance,
                           t1.real_back_balance,
                           t1.stock_code,
                           t1.entrust_amount,
                           t1.exchange_type,
                           t1.bonus_amount,
                           t1.sum_back_amount,
                           t1.sum_spb_amount
                      from kods.a_hs08_srpcontract t1
                      where exists (select 1 from T_BKS_ZYRHHY tt where tt.khbh=t1.client_id and tt.hth=t1.contract_id and tt.sfwy='' and tt.rcflx='֤ȯ˾Ӫ')
                      ) x,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) z,
                   kods.rzrq_hs_stkcode y,
                   (select stock_code, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) n
             where x.stock_code = z.stock_code
               and x.stock_code = n.stock_code
               and x.exchange_type = z.exchange_type
               --and x.real_date_back > v_bbq_endworkdate
               and x.entrust_date <= v_bbq_enddate
               and x.stock_code = y.stock_code
             group by x.stock_code, y.stock_name, n.capital_amount
             order by sum((x.entrust_amount + x.bonus_amount-x.sum_back_amount-nvl(x.sum_spb_amount,0)) * z.asset_price) desc) a
     where rownum < 6;
  commit;
  update t_etl_c13_3_je_zyzj t set t.je=0 where t.je is null;
  commit;
  cisp_etl_gpzy_jyb_zyzj;
  commit;
  cisp_etl_gpzy_jyb_ljywgm_zyzj; --ۼҵģ
  commit;
  cisp_etl_gpzy_jyb_hgll_zyzj; --ع
  commit;
  cisp_etl_gpzy_jyb_ywmx1_zyzj; --ؽ׽ǰ5
  commit;
  cisp_etl_gpzy_jyb_ywmx2_zyzj; --رֵǰ5
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_1_20190815
prompt =================================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_1_20190815 is
  v_begintime_date varchar(16);
  v_begintime_date int;
  /********************************************************************
  *ܣɴԴݵETLݱݻܹ̣
   *
  *********************************************************************/
  v_begindate varchar2(8);
  v_enddate   varchar2(8);

begin
  --ȡڵڼʱ
      select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

-----------------------------------------------------------------------------------------------
  delete from t_etl_khjyjszj;
  commit;
  ------------------------------------------------------------------------------------------------------------------------------------------
  --ͻ׽ʽ
  --ܣͳC1-1 --ͻڴ,ȡ,ĩ
   insert into t_etl_khjyjszj
    (khlx, jylx, bz, je)
     select 0 khlx, 1 jylx, bz, sum(je) as je
      from (
            select decode(a.money_type, 0, 0, 2, 1, 1, 2) as bz,
                   abs(a.occur_balance) as je --
              from kods.a_hs08_his_operationtotal a
             where a.business_flag in (2001,2003,2005,2020,2041,2064,2089,2405) --
            ) t1
     group by  t1.bz
    union
    --ȡ

  select 0 khlx, 2 jylx, bz, sum(je) as je
      from (
            select decode(a.money_type, 0, 0, 2, 1, 1, 2) as bz,
                   abs(a.occur_balance) as je --
              from kods.a_hs08_his_operationtotal a
             where a.business_flag in (2002,2004,2006,2021,2022,2040,2042,2063,2090,2404)  --ȡ
            ) t1
     group by  t1.bz;

    commit;

    -- ĩ
    ------------------------

    ------------------------
  cisp_process_cwdata_unfi('C1-1','t_etl_khjyjszj','1','1');
    COMMIT;
 insert into t_etl_khjyjszj
    (khlx, jylx, bz, je)
   select 1 as khlx , 3 jylx,
         decode(s.money_type, 0, 0, 2, 1, 1, 2) as bz,
         sum(s.current_balance)
      from kods.rzrq_hs_fund_fund s, kods.rzrq_hs_client a,kods.rzrq_hs_fund_fundaccount b
     where s.client_id=b.client_id
       and s.fund_account=b.fund_account
       and a.organ_flag in ('1','3')
       and a.client_id = s.client_id
       and a.client_status != '3'
     group by decode(s.money_type, 0, 0, 2, 1, 1, 2);
       commit;    
  insert into t_etl_khjyjszj   --ȡĿ
    (khlx, jylx, bz, je)
select 0,3,0, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency=0)
 -(select je from t_etl_khjyjszj where bz=0 and jylx=3 and khlx=1) from dual
 union all
select 0,3,1, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency='1')
 -(select je from t_etl_khjyjszj where bz=1 and jylx=3 and khlx=1) from dual
 union all
select 0,3,2, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency='2')
 -(select je from t_etl_khjyjszj where bz=2 and jylx=3 and khlx=1) from dual ;
commit;
   ------------------------------------------------------------------------------------------------------------------------------------------
  --ʽʻ
  --ܣͳC1-1ʽ˻
  ------------------------------------------------------------------------------------------------------------------------------------------
  delete from t_etl_zjzh;
  --ʽʻ
  --   ʲ˻ˮѡ1001ʽ˻
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,1 jylx, 0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a 
             where a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.fundacct_status<>'3'
             and a.asset_prop = '0';

 insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,1 jylx, bz, sl
       from (select decode(s.exchange_type,'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1104'
     and s.exchange_type in ('H','D')
        group by decode(s.exchange_type, 'H', 1, 'D', 2)
       );           
--Ͽ
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,12 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a --,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.init_date between v_begindate  and  v_enddate
             and a.fundacct_status<>'3'
             and a.asset_prop = '0'
             and a.business_flag = '1001'
             and a.open_type = '2';
            --group by   decode(b.money_type, '0', 0, '2', 1, '1', 2);
            commit;

--֤
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,13 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a --,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.init_date between v_begindate  and  v_enddate
             and a.fundacct_status<>'3'
             and a.asset_prop = '0'
             and a.open_type = '1'; 
            commit;      
--
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,2 jylx,0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a 
             where a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1002'
             and a.asset_prop = '0';
            commit;   
                
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,2 jylx, bz,sl
 from (select decode(s.exchange_type, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
     and s.exchange_type in ('H','D')
      group by decode(s.exchange_type,'H', 1, 'D', 2));
      commit;                
 --ת˻
 
            
--ĩ
insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select decode(c.organ_flag,'1',1,'3',1,0) as khlx,3 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count(distinct a.client_id) as sl
       from  kods.rzrq_hs_fund_fundaccount a,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.client_id = c.client_id
             and a.client_id = b.client_id
             and a.fundacct_status='0'
             and c.organ_flag in ('1','0','3')
             and a.main_flag='1'
             and b.money_type=0
             and a.open_date<=v_enddate
             and a.asset_prop = '0'
            group by   decode(c.organ_flag,'1',1,'3',1,0);
   commit;
   
insert into t_etl_zjzh (khlx, jylx, bz, sl)
select decode(b.organ_flag,'1',1,'3',1,0) as khlx,3 jylx, decode(s.exchange_type,'D',2,'H',1) bz,
            count( s.stock_account) sl
            from kods.rzrq_hs_stockholder s,kods.rzrq_hs_client b
            where s.client_id = b.client_id
            and s.asset_prop in ('0')
            and s.holder_status='0'
            and b.organ_flag in ('1','0','3')
            and s.exchange_type in ('D','H')
            group by decode(b.organ_flag,'1',1,'3',1,0),decode(s.exchange_type,'D',2,'H',1);
   commit;   
   

--Сת
/*insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select 0 as khlx,4 jylx,0 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a --,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.init_date between v_begindate and v_enddate
             and a.business_flag = '1012'
             and a.asset_prop = '0';
    commit;*/

--ϸת
--ϸת
/*insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select decode(c.organ_flag,'1',1,0) as khlx,5 jylx,decode(b.money_type, '0', 0, '2', 1, '1', 2) as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,kods.rzrq_hs_fund_fund b,kods.rzrq_hs_client c
             where a.client_id=b.client_id
             and a.fund_account=b.fund_account
             and a.client_id=c.client_id and a.branch_no=c.branch_no
             and a.fundacct_status<>'3'
             and c.organ_flag in ('1','0')
             and a.asset_prop = '0'
            group by   decode(c.organ_flag,'1',1,0),decode(b.money_type, '0', 0, '2', 1, '1', 2);
            commit;*/

  ----------------------------------------------------------------------------------------------------------------------------------------
  --֤ȯʻ
  ------------------------------------------------------------------------------------------------------------------------------------------
  delete from t_etl_zqzh;
    -- ĩ
  insert into t_etl_zqzh(khlx, jylx, sc, bz, sl)
 select decode(b.organ_flag,'1',1,'3',1,0) as khlx,7 jylx,decode(s.exchange_type,'1',1,'D',1,'2',0,'H',0) sc,
            decode(s.exchange_type,'1',0,'D',2,'2',0,'H',1) bz,
            count( s.stock_account) sl
            from kods.rzrq_hs_stockholder s,kods.rzrq_hs_client b
            where s.client_id = b.client_id
            and s.asset_prop in ('0')
            and s.holder_status='0'
            and s.open_date<=v_enddate
            and b.organ_flag in ('1','0','3')
            and s.exchange_type in ('1','2','D','H')
            group by decode(b.organ_flag,'1',1,'3',1,0),decode(s.exchange_type,'1',0,'D',2,'2',0,'H',1),
            decode(s.exchange_type,'1',1,'D',1,'2',0,'H',0);
     commit;
--0----0----0----0----0----0----0----0----0----0----0----0----0----0--
  delete from t_etl_dlkxh;
  insert into t_etl_dlkxh--ת
     select 3, decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2) as bz,count( s.stock_account)
         from kods.a_hs08_his_stockholderjour s
      where s.business_flag in (1101)
        and s.asset_prop in ('0')
        and s.exchange_type in ('1','2','H','D')
        and s.init_date between v_begindate and v_enddate
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2);
        commit;
   insert into t_etl_dlkxh--ת
        select 4 ,decode(s.money_type, '0', 0, '2', 1, '1', 2) as bz,count(distinct s.stock_account)
        from kods.rzrq_hs_his_hisdeliver s
      where s.business_flag in (4008)
        and s.asset_prop in ('0')
        and s.exchange_type in ('1','2')
        and s.init_date between v_begindate and v_enddate
        group by decode(s.money_type, '0', 0, '2', 1, '1', 2) ;
        commit;
      --ڴ  
 insert into t_etl_dlkxh
   select 5, bz, sum(sl)
     from (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2) as bz,
                  count(s.stock_account) sl
             from kods.a_hs08_his_stockholderjour s
            where s.init_date between v_begindate and v_enddate
              and s.asset_prop in ('0')
              and s.business_flag in ('1104','1101')
              and s.exchange_type in ('1', '2', 'H', 'D')
            group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2))
    group by bz;
--Ͽ
 insert into t_etl_dlkxh
   select 11,bz, sum(sl) from
      (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,
      count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag in ('1104','1101')
      and s.op_entrust_way = '7'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
       )
    group by bz;

--֤
 insert into t_etl_dlkxh
  select 12,bz, sum(sl) from
      (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,
      count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag in ('1104','1101')
      and s.op_entrust_way ='O'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
       )
    group by bz;
 commit;
 --
 insert into t_etl_dlkxh
 select 20 ,bz,sum(sl) from 
 (
   select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 )
 group by bz;
 commit;
 
  --֤
 insert into t_etl_dlkxh
 select 22,bz, sl
        from (
   select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
      and s.open_type='1'
      and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 );
  commit;
  --
 insert into t_etl_dlkxh
 select 21, bz, sl
 from (
    select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from kods.a_hs08_his_stockholderjour s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
      --and s.open_type='2'
      and s.op_entrust_way = '7' -- modify by  zhenyj  20190418
      and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 );
 commit;
-----------------------------------------------------------------------------------
  --    ʽ˻
-----------------------------------------------------------------------------------
 delete from t_etl_fzcjy_zjzh;
  commit;
 insert into t_etl_fzcjy_zjzh
     select 1,3 ,count(distinct a.fund_account)
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
        where c.client_id = a.client_id
          and a.fund_account = b.fund_account
          and b.money_type in (0)
          and c.risk_info like '%2%';
commit;
 insert into t_etl_fzcjy_zjzh
 select 2,3, count(distinct s.fund_account)  from
  kods.rzrq_hs_fund_fundaccount s, kods.a_hs08_clientinfo c
   where --s.client_group='902'
   s.client_id=c.client_id
   and exists (select 1
              from kods.rzrq_hs_stockholder d,kods.rzrq_hs_nonstdholder e
              where d.stock_account = e.stock_account
              and d.fund_account = s.fund_account
              and d.client_id = s.client_id);

  commit;

   insert into t_etl_fzcjy_zjzh
 select 3,3,sum(sl) from(
select 3,3 ,count(distinct a.fund_account) as sl
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
        where c.client_id = a.client_id
          and a.fund_account = b.fund_account
          and b.money_type in (0)
          and c.risk_info like '%6%'
  union all        
select 3,3, count(distinct s.fund_account) as sl  from
  kods.rzrq_hs_fund_fundaccount s, kods.a_hs08_clientinfo c
   where s.fundacct_status='1'
       and s.client_id=c.client_id ) ;
   commit;

---------------------------------------------------------------------------------------------------
  -- -  ֤ȯ˻
---------------------------------------------------------------------------------------------------
delete from t_etl_fzcjy_zqzh;
commit;
  insert into t_etl_fzcjy_zqzh
 select 1 zhlx ,3 jylx ,sum(sl) from
    (select count(distinct a.stock_account) sl
            from kods.rzrq_hs_stockholder a where a.holder_status = 'C' 
            and a.asset_prop = '0'
            and a.exchange_type in ('1','2')
       );
/*
  insert into t_etl_fzcjy_zqzh
  --ɶ(HOLDER_ACC) ˻ 1-˻ 2-ϸ˻ 3-˻ 4-˻
  -- еȡ
  select 2 zhlx ,3 jylx ,count(zqzh) from  a_bhg_djhb;
   commit;
*/
  insert into t_etl_fzcjy_zqzh
 select 3 zhlx ,3 jylx ,sum(sl) from
    (select count(distinct a.stock_account) sl
            from kods.rzrq_hs_stockholder a where a.holder_status = '1' 
            and a.asset_prop = '0'
            and a.exchange_type in ('1','2')
       );

 insert into t_etl_fzcjy_zqzh
  select 2,3,sum(sl) from
  (select count(a.stock_account) sl
        from kods.rzrq_hs_nonstdholder a);
  commit;
  /*-------------------------------------------------------------------------------------------------------------------------
  --ִݻܵݱ
  ------------------------------------------------------------------------------------------------------------------------*/
  cisp_etl_zjzh;
  commit;
  cisp_etl_khjyjszjzl;
   commit;
  cisp_etl_zqzh;
   commit;
  cisp_etl_fzcjy_zjzh;
   commit;
  cisp_etl_fzcjy_zqzh;
  commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_1_2019820V
prompt =================================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_1_2019820v is
  v_begintime_date varchar(16);
  v_begintime_date int;
  /********************************************************************
  *ܣɴԴݵETLݱݻܹ̣
   *
  *********************************************************************/
  v_begindate varchar2(8);
  v_enddate   varchar2(8);

begin
  --ȡڵڼʱ
      select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

-----------------------------------------------------------------------------------------------
  delete from t_etl_khjyjszj;
  commit;
  ------------------------------------------------------------------------------------------------------------------------------------------
  --ͻ׽ʽ
  --ܣͳC1-1 --ͻڴ,ȡ,ĩ
   insert into t_etl_khjyjszj
    (khlx, jylx, bz, je)
     select 0 khlx, 1 jylx, bz, sum(je) as je
      from (
            select decode(a.money_type, 0, 0, 2, 1, 1, 2) as bz,
                   abs(a.occur_balance) as je --
              from kods.V_A_HS08_HIS_OPERATIONTOTAL a
             where a.business_flag in (2001,2003,2005,2020,2041,2064,2089,2405) --
            ) t1
     group by  t1.bz
    union
    --ȡ

  select 0 khlx, 2 jylx, bz, sum(je) as je
      from (
            select decode(a.money_type, 0, 0, 2, 1, 1, 2) as bz,
                   abs(a.occur_balance) as je --
              from kods.V_A_HS08_HIS_OPERATIONTOTAL a
             where a.business_flag in (2002,2004,2006,2021,2022,2040,2042,2063,2090,2404)  --ȡ
            ) t1
     group by  t1.bz;

    commit;

    -- ĩ
    ------------------------

    ------------------------
  cisp_process_cwdata_unfi('C1-1','t_etl_khjyjszj','1','1');
    COMMIT;
 insert into t_etl_khjyjszj
    (khlx, jylx, bz, je)
   select 1 as khlx , 3 jylx,
         decode(s.money_type, 0, 0, 2, 1, 1, 2) as bz,
         sum(s.current_balance)
      from kods.V_RZRQ_HS_FUND_FUND s, KODS.V_RZRQ_HS_CLIENT a,kods.rzrq_hs_fund_fundaccount b
     where s.client_id=b.client_id
       and s.fund_account=b.fund_account
       and a.organ_flag in ('1','3')
       and a.client_id = s.client_id
       and a.client_status != '3'
     group by decode(s.money_type, 0, 0, 2, 1, 1, 2);
       commit;    
  insert into t_etl_khjyjszj   --ȡĿ
    (khlx, jylx, bz, je)
select 0,3,0, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency=0)
 -(select je from t_etl_khjyjszj where bz=0 and jylx=3 and khlx=1) from dual
 union all
select 0,3,1, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency='1')
 -(select je from t_etl_khjyjszj where bz=1 and jylx=3 and khlx=1) from dual
 union all
select 0,3,2, (select s.endbalance from t_etl_biz_data s where s.reportid='C1-1' and s.proid=1 and s.currency='2')
 -(select je from t_etl_khjyjszj where bz=2 and jylx=3 and khlx=1) from dual ;
commit;
   ------------------------------------------------------------------------------------------------------------------------------------------
  --ʽʻ
  --ܣͳC1-1ʽ˻
  ------------------------------------------------------------------------------------------------------------------------------------------
  delete from t_etl_zjzh;
  --ʽʻ
  --   ʲ˻ˮѡ1001ʽ˻
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,1 jylx, 0 as bz,
  count( a.fund_account) as sl
       from  KODS.V_RZRQ_HS_HIS_FUNDACCOUNTJOUR a 
             where a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.fundacct_status<>'3'
             and a.asset_prop = '0';

 insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,1 jylx, bz, sl
       from (select decode(s.exchange_type,'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1104'
     and s.exchange_type in ('H','D')
        group by decode(s.exchange_type, 'H', 1, 'D', 2)
       );           
--Ͽ
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,12 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count( a.fund_account) as sl
       from  KODS.V_RZRQ_HS_HIS_FUNDACCOUNTJOUR a --,kods.rzrq_hs_fund_fund b,KODS.V_RZRQ_HS_CLIENT c
             where a.init_date between v_begindate  and  v_enddate
             and a.fundacct_status<>'3'
             and a.asset_prop = '0'
             and a.business_flag = '1001'
             and a.open_type = '2';
            --group by   decode(b.money_type, '0', 0, '2', 1, '1', 2);
            commit;

--֤
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,13 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count( a.fund_account) as sl
       from  KODS.V_RZRQ_HS_HIS_FUNDACCOUNTJOUR a --,KODS.V_RZRQ_HS_FUND_FUND b,KODS.V_RZRQ_HS_CLIENT c
             where a.init_date between v_begindate  and  v_enddate
             and a.fundacct_status<>'3'
             and a.asset_prop = '0'
             and a.open_type = '1'; 
            commit;      
--
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,2 jylx,0 as bz,
  count( a.fund_account) as sl
       from  KODS.V_RZRQ_HS_HIS_FUNDACCOUNTJOUR a 
             where a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1002'
             and a.asset_prop = '0';
            commit;   
                
insert into t_etl_zjzh
    (khlx, jylx, bz, sl)
 select 0 khlx,2 jylx, bz,sl
 from (select decode(s.exchange_type, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
     and s.exchange_type in ('H','D')
      group by decode(s.exchange_type,'H', 1, 'D', 2));
      commit;                
 --ת˻
 
            
--ĩ
insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select decode(c.organ_flag,'1',1,'3',1,0) as khlx,3 jylx,/*decode(b.money_type, '0', 0, '2', 1, '1', 2)*/0 as bz,
  count(distinct a.client_id) as sl
       from  kods.rzrq_hs_fund_fundaccount a,KODS.V_RZRQ_HS_FUND_FUND b,KODS.V_RZRQ_HS_CLIENT c
             where a.client_id = c.client_id
             and a.client_id = b.client_id
             and a.fundacct_status='0'
             and c.organ_flag in ('1','0','3')
             and a.main_flag='1'
             and b.money_type=0
             and a.open_date<=v_enddate
             and a.asset_prop = '0'
            group by   decode(c.organ_flag,'1',1,'3',1,0);
   commit;
   
insert into t_etl_zjzh (khlx, jylx, bz, sl)
select decode(b.organ_flag,'1',1,'3',1,0) as khlx,3 jylx, decode(s.exchange_type,'D',2,'H',1) bz,
            count( s.stock_account) sl
            from KODS.V_RZRQ_HS_STOCKHOLDER s,KODS.V_RZRQ_HS_CLIENT b
            where s.client_id = b.client_id
            and s.asset_prop in ('0')
            and s.holder_status='0'
            and b.organ_flag in ('1','0','3')
            and s.exchange_type in ('D','H')
            group by decode(b.organ_flag,'1',1,'3',1,0),decode(s.exchange_type,'D',2,'H',1);
   commit;   
   

--Сת
/*insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select 0 as khlx,4 jylx,0 as bz,
  count( a.fund_account) as sl
       from  KODS.V_RZRQ_HS_HIS_FUNDACCOUNTJOUR a --,KODS.V_RZRQ_HS_FUND_FUND b,KODS.V_RZRQ_HS_CLIENT c
             where a.init_date between v_begindate and v_enddate
             and a.business_flag = '1012'
             and a.asset_prop = '0';
    commit;*/

--ϸת
--ϸת
/*insert into t_etl_zjzh (khlx, jylx, bz, sl)
 select decode(c.organ_flag,'1',1,0) as khlx,5 jylx,decode(b.money_type, '0', 0, '2', 1, '1', 2) as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,KODS.V_RZRQ_HS_FUND_FUND b,KODS.V_RZRQ_HS_CLIENT c
             where a.client_id=b.client_id
             and a.fund_account=b.fund_account
             and a.client_id=c.client_id and a.branch_no=c.branch_no
             and a.fundacct_status<>'3'
             and c.organ_flag in ('1','0')
             and a.asset_prop = '0'
            group by   decode(c.organ_flag,'1',1,0),decode(b.money_type, '0', 0, '2', 1, '1', 2);
            commit;*/

  ----------------------------------------------------------------------------------------------------------------------------------------
  --֤ȯʻ
  ------------------------------------------------------------------------------------------------------------------------------------------
  delete from t_etl_zqzh;
    -- ĩ
  insert into t_etl_zqzh(khlx, jylx, sc, bz, sl)
 select decode(b.organ_flag,'1',1,'3',1,0) as khlx,7 jylx,decode(s.exchange_type,'1',1,'D',1,'2',0,'H',0) sc,
            decode(s.exchange_type,'1',0,'D',2,'2',0,'H',1) bz,
            count( s.stock_account) sl
            from KODS.V_RZRQ_HS_STOCKHOLDER s,KODS.V_RZRQ_HS_CLIENT b
            where s.client_id = b.client_id
            and s.asset_prop in ('0')
            and s.holder_status='0'
            and s.open_date<=v_enddate
            and b.organ_flag in ('1','0','3')
            and s.exchange_type in ('1','2','D','H')
            group by decode(b.organ_flag,'1',1,'3',1,0),decode(s.exchange_type,'1',0,'D',2,'2',0,'H',1),
            decode(s.exchange_type,'1',1,'D',1,'2',0,'H',0);
     commit;
--0----0----0----0----0----0----0----0----0----0----0----0----0----0--
  delete from t_etl_dlkxh;
  insert into t_etl_dlkxh--ת
     select 3, decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2) as bz,count( s.stock_account)
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.business_flag in (1101)
        and s.asset_prop in ('0')
        and s.exchange_type in ('1','2','H','D')
        and s.init_date between v_begindate and v_enddate
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2);
        commit;
   insert into t_etl_dlkxh--ת
        select 4 ,decode(s.money_type, '0', 0, '2', 1, '1', 2) as bz,count(distinct s.stock_account)
        from KODS.V_RZRQ_HS_HIS_HISDELIVER s
      where s.business_flag in (4008)
        and s.asset_prop in ('0')
        and s.exchange_type in ('1','2')
        and s.init_date between v_begindate and v_enddate
        group by decode(s.money_type, '0', 0, '2', 1, '1', 2) ;
        commit;
      --ڴ  
 insert into t_etl_dlkxh
   select 5, bz, sum(sl)
     from (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2) as bz,
                  count(s.stock_account) sl
             from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
            where s.init_date between v_begindate and v_enddate
              and s.asset_prop in ('0')
              and s.business_flag in ('1104','1101')
              and s.exchange_type in ('1', '2', 'H', 'D')
            group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2))
    group by bz;
--Ͽ
 insert into t_etl_dlkxh
   select 11,bz, sum(sl) from
      (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,
      count(s.stock_account) sl
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag in ('1104','1101')
      and s.op_entrust_way = '7'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
       )
    group by bz;

--֤
 insert into t_etl_dlkxh
  select 12,bz, sum(sl) from
      (select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,
      count(s.stock_account) sl
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag in ('1104','1101')
      and s.op_entrust_way ='O'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
       )
    group by bz;
 commit;
 --
 insert into t_etl_dlkxh
 select 20 ,bz,sum(sl) from 
 (
   select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
     and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 )
 group by bz;
 commit;
 
  --֤
 insert into t_etl_dlkxh
 select 22,bz, sl
        from (
   select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
      and s.open_type='1'
      and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 );
  commit;
  --
 insert into t_etl_dlkxh
 select 21, bz, sl
 from (
    select decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)  as bz,count(s.stock_account) sl
         from KODS.V_A_HS08_HIS_STOCKHOLDERJOUR s
      where s.init_date between v_begindate and v_enddate
      and s.asset_prop in ('0')
      and s.business_flag = '1102'
      --and s.open_type='2'
      and s.op_entrust_way = '7' -- modify by  zhenyj  20190418
      and s.exchange_type in ('1','2','H','D')
        group by decode(s.exchange_type, '1', 0, '2', 0, 'H', 1, 'D', 2)
 );
 commit;
-----------------------------------------------------------------------------------
  --    ʽ˻
-----------------------------------------------------------------------------------
 delete from t_etl_fzcjy_zjzh;
  commit;
 insert into t_etl_fzcjy_zjzh
     select 1,3 ,count(distinct a.fund_account)
        from KODS.V_RZRQ_HS_FUND_FUNDACCOUNT a, KODS.V_RZRQ_HS_FUND_FUND b,KODS.V_A_HS08_CLIENTINFO c
        where c.client_id = a.client_id
          and a.fund_account = b.fund_account
          and b.money_type in (0)
          and c.risk_info like '%2%';
commit;
 insert into t_etl_fzcjy_zjzh
 select 2,3, count(distinct s.fund_account)  from
  KODS.V_RZRQ_HS_FUND_FUNDACCOUNT s, KODS.V_A_HS08_CLIENTINFO c
   where --s.client_group='902'
   s.client_id=c.client_id
   and exists (select 1
              from KODS.V_RZRQ_HS_STOCKHOLDER d,KODS.V_RZRQ_HS_NONSTDHOLDER e
              where d.stock_account = e.stock_account
              and d.fund_account = s.fund_account
              and d.client_id = s.client_id);

  commit;

   insert into t_etl_fzcjy_zjzh
 select 3,3,sum(sl) from(
select 3,3 ,count(distinct a.fund_account) as sl
        from KODS.V_RZRQ_HS_FUND_FUNDACCOUNT a, KODS.V_RZRQ_HS_FUND_FUND b,KODS.V_A_HS08_CLIENTINFO c
        where c.client_id = a.client_id
          and a.fund_account = b.fund_account
          and b.money_type in (0)
          and c.risk_info like '%6%'
  union all        
select 3,3, count(distinct s.fund_account) as sl  from
  KODS.V_RZRQ_HS_FUND_FUNDACCOUNT s, KODS.V_A_HS08_CLIENTINFO c
   where s.fundacct_status='1'
       and s.client_id=c.client_id ) ;
   commit;

---------------------------------------------------------------------------------------------------
  -- -  ֤ȯ˻
---------------------------------------------------------------------------------------------------
delete from t_etl_fzcjy_zqzh;
commit;
  insert into t_etl_fzcjy_zqzh
 select 1 zhlx ,3 jylx ,sum(sl) from
    (select count(distinct a.stock_account) sl
            from KODS.V_RZRQ_HS_STOCKHOLDER a where a.holder_status = 'C' 
            and a.asset_prop = '0'
            and a.exchange_type in ('1','2')
       );
/*
  insert into t_etl_fzcjy_zqzh
  --ɶ(HOLDER_ACC) ˻ 1-˻ 2-ϸ˻ 3-˻ 4-˻
  -- еȡ
  select 2 zhlx ,3 jylx ,count(zqzh) from  a_bhg_djhb;
   commit;
*/
  insert into t_etl_fzcjy_zqzh
 select 3 zhlx ,3 jylx ,sum(sl) from
    (select count(distinct a.stock_account) sl
            from KODS.V_RZRQ_HS_STOCKHOLDER a where a.holder_status = '1' 
            and a.asset_prop = '0'
            and a.exchange_type in ('1','2')
       );

 insert into t_etl_fzcjy_zqzh
  select 2,3,sum(sl) from
  (select count(a.stock_account) sl
        from KODS.V_RZRQ_HS_NONSTDHOLDER a);
  commit;
  /*-------------------------------------------------------------------------------------------------------------------------
  --ִݻܵݱ
  ------------------------------------------------------------------------------------------------------------------------*/
  cisp_etl_zjzh;
  commit;
  cisp_etl_khjyjszjzl;
   commit;
  cisp_etl_zqzh;
   commit;
  cisp_etl_fzcjy_zjzh;
   commit;
  cisp_etl_fzcjy_zqzh;
  commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_2_20190725
prompt =================================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_2_20190725 is
  /***************************************
  *ܣҵ״ԴETL  
  ֱ   3500 20150708
  ***************************************/
  --v_date integer;
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
 -- select max(t1.busi_date) into v_date from a_ksd_his_done t1;
  --ȡڵڼʱ
  /*select to_char(t.p001) || '01'into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.p001) || '31' into v_enddate  from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;*/
 select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;    
-----------------------------------------------------------------------------------------------------
--   ½
-----------------------------------------------------------------------------------------------------
  delete from t_etl_jy;
  commit;
  --A
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,1 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('0','c')            --֤ͣƱ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --B
    insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,
               decode(t1.exchange_type, 'H', '2', 'D', '3') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')            --֤ͣƱ
               and t1.money_type !='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')
               and t2.asset_prop = '0'
            group by  decode(t1.exchange_type, 'H', '2', 'D', '3'),decode(t3.organ_flag,'1',1,'3',1,0);
    commit;
--
  insert into t_etl_jy
       select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,4 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('6','L','T','j','l')--T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ETF
  insert into t_etl_jy
    select  0 as khlx,5 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('T')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t2.asset_prop = '0'
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               ;
  commit;
  --LOF
  insert into t_etl_jy
      select  0 as khlx,6 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('L')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
              ;
    commit;

  --ծȯ
  insert into t_etl_jy
    select decode(t3.organ_flag,'1',1,'3',1,0) as khlx,7 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001','4050','4151','4152')  --֤ȯ ֤ȯ
               and t1.stock_type in ('9','X','Y','U','u','a')--9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
           group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ȩ֤
  insert into t_etl_jy
    select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,8 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('D')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  

  --۹
  --06۹ȯUF2.0ԴRZRQ_HS_HIS_HISDELIVERȡ
  --add by jiangbt 20150202
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.RZRQ_HS_HIS_HISDELIVER  t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','c','3')            --֤ͣƱ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('G','S')         ---۹
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;

  --ʻع
  insert into t_etl_jy
     select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,10 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4003','4089','4103','4149')
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ȯع
  insert into t_etl_jy
  select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,11 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4004','4090','4104',4140) --modify by zhenyj 20190508 4140 ۻع
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ͻ 
  insert into t_etl_jy
     select   0 as khlx,12 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z')
               and t1.money_type ='0'
               and t1.op_entrust_way  in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2','G','S')         ---1.Ϻ 2.
               and t2.asset_prop = '0';
  commit;

  --ϽסB
  insert into t_etl_jy
   select   0 as khlx, decode(t1.exchange_type, 'H', '13', 'D', '14') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')
               and t1.money_type !='0'
               and t1.op_entrust_way in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')      ---D.Ϻ H.
               and t2.asset_prop ='0'
               group by decode(t1.exchange_type, 'H', '13', 'D', '14');
  commit;

---------------------------------------------------------------------------------------------------------------
--    йֵ
---------------------------------------------------------------------------------------------------------------
  --A-ֵ
  insert into t_etl_jy
    select  khlx, 1 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in('0','c')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --B-ֵ
  insert into t_etl_jy
   select  khlx,  zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx, 3 zqlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in('0') --֤ͣƱ(0)
               and t1.exchange_type in ('D','H')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='1'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx,zqlx;
  commit;
  ---ֵ
  insert into t_etl_jy
     select  khlx, 4 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('6','L','T','j','l')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --ETF-ֵ
  insert into t_etl_jy
    select  0 khlx, 5 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('T'/*,'j','l'*/)
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --LOF
 insert into t_etl_jy
    select  0 khlx, 6 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('L')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --ծȯ
  insert into t_etl_jy
     select  khlx, 7 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('9','X','Y','U','u','a','Z') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --Ȩ֤
  insert into t_etl_jy
     select  khlx, 8 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
              decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('D')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;

  insert into t_etl_jy
     select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from kods.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t1.exchange_type in ('G','S') --ͨ
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
-------------------------------------------------------------------------------------------
--  
-------------------------------------------------------------------------------------------
delete from t_etl_bczl where jylx=1;
commit;


--ڴɷתý׽
insert into t_etl_bczl(jylx,je,bz)
   select 1 jylx, sum(je) je, 0 bz  from (
      select   decode(t1.money_type, '1', t1.business_balance*s.a002,
                '2',t1.business_balance*s.a003,t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1, t_bks_t007 s
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','z')           --֤ͣƱ۹ɷ
               and t1.exchange_type in ('9','A')
            ) t;
commit;

  cisp_etl_zqjy;
  commit;
  cisp_etl_bczl;
  commit;
end ;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_2_20190815
prompt =================================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_2_20190815 is
  /***************************************
  *ܣҵ״ԴETL  
  ֱ   3500 20150708
  ***************************************/
  --v_date integer;
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
 -- select max(t1.busi_date) into v_date from a_ksd_his_done t1;
  --ȡڵڼʱ
  /*select to_char(t.p001) || '01'into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.p001) || '31' into v_enddate  from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;*/
 select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;    
-----------------------------------------------------------------------------------------------------
--   ½
-----------------------------------------------------------------------------------------------------
  delete from t_etl_jy;
  commit;
  --A
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,1 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('0','c','e')            --֤ͣƱ eƴ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --B
    insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,
               decode(t1.exchange_type, 'H', '2', 'D', '3') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')            --֤ͣƱ
               and t1.money_type !='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')
               and t2.asset_prop = '0'
            group by  decode(t1.exchange_type, 'H', '2', 'D', '3'),decode(t3.organ_flag,'1',1,'3',1,0);
    commit;
--
  insert into t_etl_jy
       select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,4 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('6','L','T','j','l')--T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ETF
  insert into t_etl_jy
    select  0 as khlx,5 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('T')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t2.asset_prop = '0'
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               ;
  commit;
  --LOF
  insert into t_etl_jy
      select  0 as khlx,6 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('L')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
              ;
    commit;

  --ծȯ
  insert into t_etl_jy
    select decode(t3.organ_flag,'1',1,'3',1,0) as khlx,7 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001','4050','4151','4152')  --֤ȯ ֤ȯ
               and t1.stock_type in ('9','X','Y','U','u','a')--9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
           group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ȩ֤
  insert into t_etl_jy
    select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,8 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('D')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  

  --۹
  --06۹ȯUF2.0ԴRZRQ_HS_HIS_HISDELIVERȡ
  --add by jiangbt 20150202
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.RZRQ_HS_HIS_HISDELIVER  t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','c','3')            --֤ͣƱ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('G','S')         ---۹
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
    --ƴƾ֤
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('g')            --֤ͣƴƾ֤
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1')         ---1.Ϻ 
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;

  --ʻع
  insert into t_etl_jy
     select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,10 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4003','4089','4103','4149')
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ȯع
  insert into t_etl_jy
  select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,11 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where  t1.business_flag in ('4004','4090','4104',4140) --modify by zhenyj 20190508 4140 ۻع
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ͻ 
  insert into t_etl_jy
     select   0 as khlx,12 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z','e','g')
               and t1.money_type ='0'
               and t1.op_entrust_way  in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2','G','S')         ---1.Ϻ 2.
               and t2.asset_prop = '0';
  commit;

  --ϽסB
  insert into t_etl_jy
   select   0 as khlx, decode(t1.exchange_type, 'H', '13', 'D', '14') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client t3
             where t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')
               and t1.money_type !='0'
               and t1.op_entrust_way in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')      ---D.Ϻ H.
               and t2.asset_prop ='0'
               group by decode(t1.exchange_type, 'H', '13', 'D', '14');
  commit;

---------------------------------------------------------------------------------------------------------------
--    йֵ
---------------------------------------------------------------------------------------------------------------
  --A-ֵ
  insert into t_etl_jy
    select  khlx, 1 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in('0','c','e')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --B-ֵ
  insert into t_etl_jy
   select  khlx,  zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx, 3 zqlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in('0') --֤ͣƱ(0)
               and t1.exchange_type in ('D','H')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='1'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx,zqlx;
  commit;
  ---ֵ
  insert into t_etl_jy
     select  khlx, 4 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('6','L','T','j','l')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --ETF-ֵ
  insert into t_etl_jy
    select  0 khlx, 5 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('T'/*,'j','l'*/)
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --LOF
 insert into t_etl_jy
    select  0 khlx, 6 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('L')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --ծȯ
  insert into t_etl_jy
     select  khlx, 7 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('9','X','Y','U','u','a','Z') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --Ȩ֤
  insert into t_etl_jy
     select  khlx, 8 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
              decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in ('D')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;

  insert into t_etl_jy
     select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from kods.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t1.exchange_type in ('G','S') --ͨ
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
     
  commit;
  --ƴƾ֤-ֵ
  insert into t_etl_jy
    select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_client c,
        (select * from kods.rzrq_hs_His_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_His_hisprice)) b
             where t1.stock_type in('g')
               and t1.exchange_type in ('1')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
     commit;
-------------------------------------------------------------------------------------------
--  
-------------------------------------------------------------------------------------------
delete from t_etl_bczl where jylx=1;
commit;


--ڴɷתý׽
insert into t_etl_bczl(jylx,je,bz)
   select 1 jylx, sum(je) je, 0 bz  from (
      select   decode(t1.money_type, '1', t1.business_balance*s.a002,
                '2',t1.business_balance*s.a003,t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1, t_bks_t007 s
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','z')           --֤ͣƱ۹ɷ
               and t1.exchange_type in ('9','A')
            ) t;
commit;

  cisp_etl_zqjy;
  commit;
  cisp_etl_bczl;
  commit;
end ;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_2_2019820V
prompt =================================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_2_2019820v is
  /***************************************
  *ܣҵ״ԴETL  
  ֱ   3500 20150708
  ***************************************/
  --v_date integer;
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
 -- select max(t1.busi_date) into v_date from a_ksd_his_done t1;
  --ȡڵڼʱ
  /*select to_char(t.p001) || '01'into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.p001) || '31' into v_enddate  from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;*/
 select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;    
-----------------------------------------------------------------------------------------------------
--   ½
-----------------------------------------------------------------------------------------------------
  delete from t_etl_jy;
  commit;
  --A
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,1 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('0','c','e')            --֤ͣƱ eƴ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --B
    insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,
               decode(t1.exchange_type, 'H', '2', 'D', '3') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')            --֤ͣƱ
               and t1.money_type !='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')
               and t2.asset_prop = '0'
            group by  decode(t1.exchange_type, 'H', '2', 'D', '3'),decode(t3.organ_flag,'1',1,'3',1,0);
    commit;
--
  insert into t_etl_jy
       select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,4 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('6','L','T','j','l')--T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ETF
  insert into t_etl_jy
    select  0 as khlx,5 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('T')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t2.asset_prop = '0'
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               ;
  commit;
  --LOF
  insert into t_etl_jy
      select  0 as khlx,6 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('L')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
              ;
    commit;

  --ծȯ
  insert into t_etl_jy
    select decode(t3.organ_flag,'1',1,'3',1,0) as khlx,7 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4050','4151','4152')  --֤ȯ ֤ȯ
               and t1.stock_type in ('9','X','Y','U','u','a')--9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
           group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ȩ֤
  insert into t_etl_jy
    select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,8 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('D')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  

  --۹
  --06۹ȯUF2.0ԴRZRQ_HS_HIS_HISDELIVERȡ
  --add by jiangbt 20150202
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER  t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','c','3')            --֤ͣƱ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('G','S')         ---۹
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
    --ƴƾ֤
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('g')            --֤ͣƴƾ֤
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1')         ---1.Ϻ 
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;

  --ʻع
  insert into t_etl_jy
     select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,10 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4003','4089','4103','4149')
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ȯع
  insert into t_etl_jy
  select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,11 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4004','4090','4104',4140) --modify by zhenyj 20190508 4140 ۻع
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ͻ 
  insert into t_etl_jy
     select   0 as khlx,12 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z','e','g')
               and t1.money_type ='0'
               and t1.op_entrust_way  in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2','G','S')         ---1.Ϻ 2.
               and t2.asset_prop = '0';
  commit;

  --ϽסB
  insert into t_etl_jy
   select   0 as khlx, decode(t1.exchange_type, 'H', '13', 'D', '14') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT t3
             where t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')
               and t1.money_type !='0'
               and t1.op_entrust_way in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')      ---D.Ϻ H.
               and t2.asset_prop ='0'
               group by decode(t1.exchange_type, 'H', '13', 'D', '14');
  commit;

---------------------------------------------------------------------------------------------------------------
--    йֵ
---------------------------------------------------------------------------------------------------------------
  --A-ֵ
  insert into t_etl_jy
    select  khlx, 1 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('0','c','e')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --B-ֵ
  insert into t_etl_jy
   select  khlx,  zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx, 3 zqlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('0') --֤ͣƱ(0)
               and t1.exchange_type in ('D','H')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='1'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx,zqlx;
  commit;
  ---ֵ
  insert into t_etl_jy
     select  khlx, 4 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('6','L','T','j','l')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --ETF-ֵ
  insert into t_etl_jy
    select  0 khlx, 5 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('T'/*,'j','l'*/)
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --LOF
 insert into t_etl_jy
    select  0 khlx, 6 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('L')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --ծȯ
  insert into t_etl_jy
     select  khlx, 7 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('9','X','Y','U','u','a','Z') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --Ȩ֤
  insert into t_etl_jy
     select  khlx, 8 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
              decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('D')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;

  insert into t_etl_jy
     select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t1.exchange_type in ('G','S') --ͨ
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
     
  commit;
  --ƴƾ֤-ֵ
  insert into t_etl_jy
    select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.V_RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.V_RZRQ_HS_CLIENT c,
        (select * from KODS.V_RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.V_RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('g')
               and t1.exchange_type in ('1')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
     commit;
-------------------------------------------------------------------------------------------
--  
-------------------------------------------------------------------------------------------
delete from t_etl_bczl where jylx=1;
commit;


--ڴɷתý׽
insert into t_etl_bczl(jylx,je,bz)
   select 1 jylx, sum(je) je, 0 bz  from (
      select   decode(t1.money_type, '1', t1.business_balance*s.a002,
                '2',t1.business_balance*s.a003,t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1, t_bks_t007 s
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','z')           --֤ͣƱ۹ɷ
               and t1.exchange_type in ('9','A')
            ) t;
commit;

  cisp_etl_zqjy;
  commit;
  cisp_etl_bczl;
  commit;
end ;
/

prompt
prompt Creating procedure CISP_MAP_HS_JJYW_C1_2_20200218
prompt =================================================
prompt
create or replace procedure cisp_map_hs_jjyw_c1_2_20200218 is
  /***************************************
  *ܣҵ״ԴETL  
  ֱ   3500 20150708
  ***************************************/
  --v_date integer;
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
 -- select max(t1.busi_date) into v_date from a_ksd_his_done t1;
  --ȡڵڼʱ
  /*select to_char(t.p001) || '01'into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.p001) || '31' into v_enddate  from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;*/
 select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;    
-----------------------------------------------------------------------------------------------------
--   ½
-----------------------------------------------------------------------------------------------------
  delete from t_etl_jy;
  commit;
  --A
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,1 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('0','c','e')            --֤ͣƱ eƴ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --B
    insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,
               decode(t1.exchange_type, 'H', '2', 'D', '3') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')            --֤ͣƱ
               and t1.money_type !='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')
               and t2.asset_prop = '0'
            group by  decode(t1.exchange_type, 'H', '2', 'D', '3'),decode(t3.organ_flag,'1',1,'3',1,0);
    commit;
--
  insert into t_etl_jy
       select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,4 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('6','L','T','j','l')--T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ETF
  insert into t_etl_jy
    select  0 as khlx,5 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('T')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t2.asset_prop = '0'
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               ;
  commit;
  --LOF
  insert into t_etl_jy
      select  0 as khlx,6 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('L')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
              ;
    commit;

  --ծȯ
  insert into t_etl_jy
    select decode(t3.organ_flag,'1',1,'3',1,0) as khlx,7 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4050','4151','4152')  --֤ȯ ֤ȯ
               and t1.stock_type in ('9','X','Y','U','u','a')--9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
           group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ȩ֤
  insert into t_etl_jy
    select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,8 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('D')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  

  --۹
  --06۹ȯUF2.0ԴRZRQ_HS_HIS_HISDELIVERȡ
  --add by jiangbt 20150202
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER  t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','c','3')            --֤ͣƱ
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('G','S')         ---۹
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
    --ƴƾ֤
  insert into t_etl_jy
      select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,9 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ Ҫӵ
               and t1.stock_type in ('g')            --֤ͣƴƾ֤
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1')         ---1.Ϻ 
               and t1.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;

  --ʻع
  insert into t_etl_jy
     select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,10 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4003','4089','4103','4149')
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --ȯع
  insert into t_etl_jy
  select   decode(t3.organ_flag,'1',1,'3',1,0) as khlx,11 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where  t1.business_flag in ('4004','4090','4104',4140) --modify by zhenyj 20190508 4140 ۻع
               and t1.stock_type in ('Q','Z')
               and t1.money_type ='0'
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
               and t2.asset_prop = '0'
            group by  decode(t3.organ_flag,'1',1,'3',1,0);
  commit;
  --Ͻ 
  insert into t_etl_jy
     select   0 as khlx,12 zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z','e','g')
               and t1.money_type ='0'
               and t1.op_entrust_way  in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('1','2','G','S')         ---1.Ϻ 2.
               and t2.asset_prop = '0';
  commit;

  --ϽסB
  insert into t_etl_jy
   select   0 as khlx, decode(t1.exchange_type, 'H', '13', 'D', '14') zqlx, 1 jylx,
                 sum(t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1,KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT t3
             where t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')
               and t1.money_type !='0'
               and t1.op_entrust_way in ('7','8','9')
               and t3.organ_flag in ('1','0','3')
               and t1.fund_account=t2.fund_account
               and t1.client_id=t2.client_id
               and t1.client_id = t3.client_id
               and t1.exchange_type in ('H','D')      ---D.Ϻ H.
               and t2.asset_prop ='0'
               group by decode(t1.exchange_type, 'H', '13', 'D', '14');
  commit;

---------------------------------------------------------------------------------------------------------------
--    йֵ
---------------------------------------------------------------------------------------------------------------
  --A-ֵ
  insert into t_etl_jy
    select  khlx, 1 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('0','c','e')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --B-ֵ
  insert into t_etl_jy
   select  khlx,  zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx, 3 zqlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('0') --֤ͣƱ(0)
               and t1.exchange_type in ('D','H')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='1'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx,zqlx;
  commit;
  ---ֵ
  insert into t_etl_jy
     select  khlx, 4 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('6','L','T','j','l')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --ETF-ֵ
  insert into t_etl_jy
    select  0 khlx, 5 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('T'/*,'j','l'*/)
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --LOF
 insert into t_etl_jy
    select  0 khlx, 6 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('L')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
          ) t  ;
  commit;
  --ծȯ
  insert into t_etl_jy
     select  khlx, 7 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('9','X','Y','U','u','a','Z') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
  commit;
  --Ȩ֤
  insert into t_etl_jy
     select  khlx, 8 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
              decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('D')
               and t1.exchange_type in ('1','2')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;

  insert into t_etl_jy
     select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t1.exchange_type in ('G','S') --ͨ
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
     
  commit;
  --ƴƾ֤-ֵ
  insert into t_etl_jy
    select  khlx, 9 zqlx, 2 jylx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz,
               decode(c.organ_flag,'1',1,'3',1,0) as khlx
        from KODS.V_RZRQ_HS_STOCK t1, KODS.RZRQ_HS_FUND_FUNDACCOUNT t2,KODS.RZRQ_HS_CLIENT c,
        (select * from KODS.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from KODS.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in('g')
               and t1.exchange_type in ('1')
               and c.organ_flag in ('1','0','3')
               and t1.exchange_type=b.exchange_type
               and t1.fund_account=t2.fund_account
               and t1.client_id = t2.client_id
               and t2.client_id = c.client_id
               and t1.money_type='0'
               and t2.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by decode(c.organ_flag,'1',1,'3',1,0)
          ) t
     group by khlx;
     commit;
-------------------------------------------------------------------------------------------
--  
-------------------------------------------------------------------------------------------
delete from t_etl_bczl where jylx=1;
commit;


--ڴɷתý׽
insert into t_etl_bczl(jylx,je,bz)
   select 1 jylx, sum(je) je, 0 bz  from (
      select   decode(t1.money_type, '1', t1.business_balance*s.a002,
                '2',t1.business_balance*s.a003,t1.business_balance) je
              from KODS.V_RZRQ_HS_HIS_HISDELIVER t1, t_bks_t007 s
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','z')           --֤ͣƱ۹ɷ
               and t1.exchange_type in ('9','A')
            ) t;
commit;

  cisp_etl_zqjy;
  commit;
  cisp_etl_bczl;
  commit;
end ;
/

prompt
prompt Creating procedure CISP_MAP_JJYW_C7_1_20200819
prompt ==============================================
prompt
create or replace procedure cisp_map_jjyw_c7_1_20200819
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION: C7-1ծȯعҵܱ-Ѻʽծȯع   ͶӰetl
  -- RETURN:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
 is
  v_bbq           varchar2(6);--
  v_bbq_begindate varchar2(8);
  v_bbq_enddate   varchar2(8);
  v_bbqqsrq         number; --ȡһ
  v_endbusinessdate number; --ȡڵһ
  v_firstbusinessdate number; --ȡ׸
  V_bmid          varchar2(32);--id

begin
   --ȡڵڼʱ
      select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_bbq_begindate, v_bbq_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;
   select max(clear_date) into v_bbqqsrq from kods.xy_hs08_std_bond_balance;

delete from t_etl_c7_1_ymwdqje;
delete from T_ETL_C7_1_bczl;
delete from t_etl_zyszqhg_zy_gs;
commit;



--ʻع Ӫ
   insert into t_etl_c7_1_ymwdqje
    SELECT 1 xm,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
                then t.today_mort_bal
                when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
                then t.today_mort_bal
          else 0 end
          ) as wdqze,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
          then t.today_mort_bal else 0 end) as shajswdq,
       sum(case when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
          then t.today_mort_bal else 0 end) as shejswdq,
       0 as yhjwdq,
       sum(case when t.mkt_code ='01' then t.today_mort_bal
                when t.mkt_code ='02' then t.today_mort_bal
           else 0 end) as fseze,
       sum(case when t.mkt_code='01' then t.today_mort_bal else 0 end) as shajsfse,
       sum(case when t.mkt_code='02' then t.today_mort_bal else 0 end) as shejsfse,
       0 as yhjfse,
       'ʻع Ӫ'
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       AND buy_back_type  in ( '001','002','003','004') --δ
       --and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       and t.settle_dept_code in ('DBZQZY0888','DBZQZY0889','DBZQZY0890')  --ȡϺӪֹ˾
       ;
       commit;
--ʻع  
  insert into t_etl_c7_1_ymwdqje
    SELECT 2 xm,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
                then t.today_mort_bal
                when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
                then t.today_mort_bal*100
          else 0 end
          ) as wdqze,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
          then t.today_mort_bal else 0 end) as shajswdq,
       sum(case when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
          then t.today_mort_bal*100 else 0 end) as shejswdq,
       0 as yhjwdq,
       sum(case when t.mkt_code ='01' then t.today_mort_bal
                when t.mkt_code ='02' then t.today_mort_bal*100
           else 0 end) as fseze,
       sum(case when t.mkt_code='01' then t.today_mort_bal else 0 end) as shajsfse,
       sum(case when t.mkt_code='02' then t.today_mort_bal*100 else 0 end) as shejsfse,
       0 as yhjfse,
       'ʻع  '
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       AND buy_back_type  in ( '001','002','003','004') --δ
       --and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22')  --ȡϺӪֹ˾ 
       ;
       commit;


-- ȯع  Ӫ
    insert into t_etl_c7_1_ymwdqje
    SELECT 3 xm,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
                then t.today_borrow_bal
                when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
                then t.today_borrow_bal*100
          else 0 end
          ) as wdqze,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
          then t.today_borrow_bal else 0 end) as shajswdq,
       sum(case when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
          then t.today_borrow_bal*100 else 0 end) as shejswdq,
       0 as yhjwdq,
       sum(case when t.mkt_code ='01' then t.today_borrow_bal
                when t.mkt_code ='02' then t.today_borrow_bal*100
           else 0 end) as fseze,
       sum(case when t.mkt_code='01' then t.today_borrow_bal else 0 end) as shajsfse,
       sum(case when t.mkt_code='02' then t.today_borrow_bal*100 else 0 end) as shejsfse,
       0 as yhjfse,
       'ȯع  Ӫ'
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       AND buy_back_type  in ( '001','002','003','004') --δ
       --and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       and t.settle_dept_code in ('DBZQZY0888','DBZQZY0889','DBZQZY0890')  --ȡϺӪֹ˾
       ;
       commit;

 --ȯع  
     insert into t_etl_c7_1_ymwdqje
    SELECT 4 xm,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
                then t.today_borrow_bal
                when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
                then t.today_borrow_bal*100
          else 0 end
          ) as wdqze,
       sum(case when t.mkt_code ='01' and t.clear_date=v_bbqqsrq
          then t.today_borrow_bal else 0 end) as shajswdq,
       sum(case when t.mkt_code ='02' and t.clear_date=v_bbqqsrq
          then t.today_borrow_bal*100 else 0 end) as shejswdq,
       0 as yhjwdq,
       sum(case when t.mkt_code ='01' then t.today_borrow_bal
                when t.mkt_code ='02' then t.today_borrow_bal*100
           else 0 end) as fseze,
       sum(case when t.mkt_code='01' then t.today_borrow_bal else 0 end) as shajsfse,
       sum(case when t.mkt_code='02' then t.today_borrow_bal*100 else 0 end) as shejsfse,
       0 as yhjfse,
       'ȯع  '
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       AND buy_back_type  in ( '001','002','003','004') --δ
       --and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22')  --ȡϺӪֹ˾ 
       ;
       commit;



--

--ծйܽ(ֵ)

 insert into T_ETL_C7_1_bczl     
   SELECT 1 xm,
       sum(case when t.mkt_code ='01' then nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)
                when t.mkt_code ='02' then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100
           else 0 end) as tgjeze,
       nvl(sum(case when t.mkt_code  = '01'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100 end),0) as shejystgje,
       0 yhj
   FROM kods.xy_hs08_inv_bond_balance t
  WHERE t.mkt_code in('02','01')--Ϻ
    and t.inv_prop='0'
    and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
    and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
    AND CLEAR_DATE = v_bbqqsrq;
  commit;

--ծ׼ȯйܽ
 insert into T_ETL_C7_1_bczl
   SELECT 2 xm,
       sum(case when t.mkt_code ='01' then t.std_bond_bal
                when t.mkt_code ='02' then t.std_bond_bal*100
           else 0 end) as tgjeze,
       nvl(sum(case when t.mkt_code  = '01'    then nvl(t.std_bond_bal,0) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then nvl(t.std_bond_bal,0)*100 end),0) as shejystgje,
       0 yhj
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       and t.inv_prop='0'
       AND buy_back_type  in ( '001','002','003','004') --δ
       and t.bond_type in ('01'/*,'02','03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
       and t.clear_date=v_bbqqsrq
       ;
       commit;

--ծйܽ(ֵ)
insert into T_ETL_C7_1_bczl
  SELECT 3 xm,
       sum(case when t.mkt_code ='01' then nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)
                when t.mkt_code ='02' then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100
           else 0 end) as tgjeze,
       nvl(sum(case when t.mkt_code  = '01'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0)) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then (nvl(t.YEST_BAL,0)+nvl(t.settle_net,0)+nvl(t.post_net,0))*100 end),0) as shejystgje,
       0 yhj
   FROM kods.xy_hs08_inv_bond_balance t
  WHERE t.mkt_code in('02','01')--Ϻ
    and t.inv_prop='0'
    and t.bond_type in (/*'01',*/'02'/*,'03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
    and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
    AND CLEAR_DATE = v_bbqqsrq;
  commit;


--ծ׼ȯйܽ
 insert into T_ETL_C7_1_bczl
SELECT 4 xm,
       sum(case when t.mkt_code ='01' then t.std_bond_bal
                when t.mkt_code ='02' then t.std_bond_bal*100
           else 0 end) as tgjeze,  --׼ȯֶSTD_BOND_BALֶλܼȥ׼ȯֶSTD_BOND_AVA_BAL
       nvl(sum(case when t.mkt_code  = '01'    then nvl(t.std_bond_bal,0) end),0) as shajystgje,
       nvl(sum(case when t.mkt_code  = '02'    then nvl(t.std_bond_bal,0)*100 end),0) as shejystgje,
       0 yhj
  FROM kods.xy_hs08_std_bond_balance t
 WHERE t.mkt_code in('02','01')--Ϻ
       AND (buy_back_type  in ( '001','002','003','004') or  buy_back_type is null)--δ
       and t.inv_prop ='0'
       and t.bond_type in (/*'01'*/'02'/*,'03'*/)--'01'ծ '02'ծ '03'ծȯ  ֹծծڹծ
       and t.settle_dept_code not in ('DBZQZY0888','DBZQZY0889','DBZQZY0890','DBZQGDSY22','###ESIM60')  --ȡҵ
       and t.clear_date=v_bbqqsrq
       ;
       commit;

--ʻع 
insert into t_etl_zyszqhg_zy_gs
     select item,
           p_class,
           sum(ordamount_wdq) as ordamount_wdq,
           sum(ordamount_wdq_shg) as ordamount_wdq_shg,
           sum(ordamount_wdq_she) as ordamount_wdq_she,
           sum(ordamount_wdq_cnbd) as ordamount_wdq_cnbd,
           sum(ordamount_y) as ordamount_y,
           sum(ordamount_y_shg) as ordamount_y_shg,
           sum(ordamount_y_she) as ordamount_y_she,
           sum(ordamount_y_cnbd) as ordamount_y_cnbd
      from (select decode(a.trdtype, '40', '1', '2') as item, --1ʻعȯع
                   case
                     when d.p_class = 'ծ' then
                      '1'
                     when d.p_class = 'ծ' or d.p_class is null then
                      '2'
                     else
                      '3'
                   end as p_class, --1 ծ 2ծ 3ծȯ
                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') then
                      case
                        when a.m_type = 'X_CNBD' then
                         c.disamount
                        else
                         b.amount
                      end
                     else
                      0
                   end ordamount_wdq, --δ:ܶ
                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') and a.m_type = 'XSHG' then
                      b.amount
                     else
                      0
                   end ordamount_wdq_shg, --δ:Ͻ
                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') and a.m_type = 'XSHE' then
                      b.amount
                     else
                      0
                   end ordamount_wdq_she, --δ:

                   case
                     when replace(b.fstsetdate,'-','') <= v_bbq_enddate and
                          v_bbq_enddate < replace(b.endsetdate,'-','') and a.m_type = 'X_CNBD' then
                      c.disamount
                     else
                      0
                   end ordamount_wdq_cnbd, --δ:м

                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate then
                      case
                        when a.m_type = 'X_CNBD' then
                         c.disamount
                        else
                         b.amount
                      end
                     else
                      0
                   end ordamount_y, --귢ۼ:ܶ
                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate and a.m_type = 'XSHG' then
                      b.amount
                     else
                      0
                   end ordamount_y_shg, --귢ۼ:Ͻ
                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate and a.m_type = 'XSHE' then
                      b.amount
                     else
                      0
                   end ordamount_y_she, --귢ۼ:

                   case
                     when replace(b.fstsetdate,'-','') between
                          substr(v_bbq_enddate, 1, 4) || '0101' and
                          v_bbq_enddate and a.m_type = 'X_CNBD' then
                      c.disamount
                     else
                      0
                   end ordamount_y_cnbd --귢ۼ:м

              from kods.ht_ttrd_otc_trade a
             inner join kods.ht_ttrd_otc_iblb b
                on a.i_code = b.i_code
              left join kods.ht_ttrd_otc_pledgebond c
                on a.i_code = c.i_code
              left join kods.ht_vbond_include_issue d
                on c.p_i_code = d.i_code
               and c.p_a_type = d.a_type
               and c.p_m_type = d.m_type
             where a.trdtype in ('40', '41')
               and a.ordstatus = 7
               and a.sysordid != a.union_sysordid
               and ((replace(b.fstsetdate,'-','') between
                   substr(v_bbq_enddate, 1, 4) || '0101' and v_bbq_enddate) or
                   (replace(b.fstsetdate,'-','') < substr(v_bbq_enddate, 1, 4) || '0101' and
                   replace(b.endsetdate,'-','') >= substr(v_bbq_enddate, 1, 4) || '0101'))
                   ) t
     group by item, p_class;
     
commit;

 t_etl_wdq;
 commit;

/*--벿id
select t.department_id  into V_bmid from KGRP.acl_department t  WHERE t.department_name = '̶Ͷʲ';

select max(period) into v_bbq
     from kgrp.t_task_info_instance t
    where task_id = '0031';
    --ڱ
  select to_char(trunc(to_date(v_bbq, 'yyyymm'), 'mm'), 'yyyymmdd'),
         to_char(last_day(to_date(v_bbq, 'yyyymm')), 'yyyymmdd')
    into v_bbq_begindate, v_bbq_enddate
    from dual;
    --ȡڵһ
  select max(t.nature_day)
    into v_endbusinessdate
    from kgrp.spm_calendar t
   where t.nature_day between v_bbq_begindate and v_bbq_enddate
     and t.is_holiday = 0;
   --ȡһ
  select min(t.nature_day)
    into v_firstbusinessdate
    from kgrp.spm_calendar t
   where t.nature_day between substr(v_bbq,0,4)||'0101' and v_bbq_enddate
     and t.is_holiday = 0;
\*-----------------------------------------------------ҵ-------------------------------------------*\
---------------------------------------------δڽ-------------------------------------------
delete from t_etl_c7_1_ymwdq t where t.xm in(1,5,9,14,18,22);--ɾETLоҵ񲿷
commit;
 --Ӫծʻع
  insert into t_etl_c7_1_ymwdq
  select 1 xm, a.je+b.je+c.je ze ,a.je shjys ,b.je szjys ,c.je yhj, V_bmid bmid  from
 --Ͻ
( select nvl(sum(t.en_mcje),0) je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='1' --Ϻ
         and t.l_ywlb='1301'--ҵ 
         and t.l_ztbh in (1004,1005)--ȡ1004 ȡ1005
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate--
         and to_char(t.d_dqrq,'yyyymmdd')>v_endbusinessdate)a,--ڵ
 --
( select nvl(sum(t.en_mcje),0)je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='2' --
         and t.l_ywlb='1301'--ҵ 
         and t.l_ztbh in (1004,1005)
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate
         and to_char(t.d_dqrq,'yyyymmdd')>v_endbusinessdate)b,
 --м
(select nvl(sum(t.amount),0) je
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature = '4' --ծ
 and t.buyorsell = 'B' --ع
 and t.value_date <= v_endbusinessdate  --ڽ
 and t.maturity_date> v_endbusinessdate)c; --ڽ
 --Ӫҵծʻع
 insert into t_etl_c7_1_ymwdq
         select 5 xm,
                0 as ze,
                0 as shjys,
                0 as szjys,
                (select nvl(sum(t.amount),0) yhjje
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature in ( '1' ,'26')--ҵծ
 and t.buyorsell = 'B' --ع
 and t.value_date <= v_endbusinessdate  --ڽ
 and t.maturity_date> v_endbusinessdate) yhj
 , V_bmid bmid
              from dual;
 --Ӫծȯʻع
  insert into t_etl_c7_1_ymwdq
         select 9 xm,
                0 as ze,
                0 as shjys,
                0 as szjys,
                (select nvl(sum(t.amount),0) yhjje
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t
 where t.bondscode  not in  (select secucode from RODS.A_JY_D_Bond_Code  where bondnature  in ('1','4','26') )--޳ҵծ ծ
 and t.buyorsell = 'B' --ع
 and t.value_date <= v_endbusinessdate  --ڽ
 and t.maturity_date> v_endbusinessdate) yhj, V_bmid bmid
              from dual;
 --Ӫծȯع
   insert into t_etl_c7_1_ymwdq
  select 14 xm, a.je+b.je+c.je ze ,a.je shjys ,b.je szjys ,c.je yhj , V_bmid bmid from
  --Ͻ
( select nvl(sum(t.en_mrje),0) je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='1' --Ϻ
         and t.l_ywlb='1302'--ҵ ȯ
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate--
         and to_char(t.d_dqrq,'yyyymmdd')>v_endbusinessdate)a,--ڵ
 --
( select nvl(sum(t.en_mrje),0)je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='2' --
         and t.l_ywlb='1302'--ҵ ȯ
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate
         and to_char(t.d_dqrq,'yyyymmdd')>v_endbusinessdate)b,
 --м
(select nvl(sum(t.amount),0) je
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature = '4' --ծ
 and t.buyorsell = 'S' --ع
 and t.value_date <= v_endbusinessdate  --ڽ
 and t.maturity_date> v_endbusinessdate)c; --ڽ
  --Ӫҵծȯع
 insert into t_etl_c7_1_ymwdq
         select 18 xm,
                0 as ze,
                0 as shjys,
                0 as szjys,
                (select nvl(sum(t.amount),0) yhjje
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature in('1' ,'26')--ҵծ
 and t.buyorsell = 'S' --ع
 and t.value_date <= v_endbusinessdate  --ڽ
 and t.maturity_date> v_endbusinessdate) yhj, V_bmid bmid
              from dual;
 --Ӫծȯȯع
  insert into t_etl_c7_1_ymwdq
         select 22 xm,
                0 as ze,
                0 as shjys,
                0 as szjys,
               (select nvl(sum(t.amount),0) yhjje
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t
 where t.bondscode  not in  (select secucode from RODS.A_JY_D_Bond_Code  where bondnature  in ('1','4','26') )--޳ҵծ ծ
 and t.buyorsell = 'S' --ع
 and t.value_date <= v_endbusinessdate  --ڽ
 and t.maturity_date> v_endbusinessdate) yhj, V_bmid bmid
              from dual;
  commit;
---------------------------------------------ۼƷ-------------------------------------------
delete from t_etl_c7_1_bnfse t where t.xm in (1,5,9,14,18,22);--ɾETLӪҵ񲿷
commit;
--ʻعۼƷ
 insert into t_etl_c7_1_bnfse
  select 1 xm, a.je+b.je+c.je ze ,a.je shjys ,b.je szjys, c.je yhj , V_bmid bmid from
  --Ͻ
( select nvl(sum(t.en_mcje),0) je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='1' --Ϻ
         and t.l_ywlb='1301'--ҵ 
         and t.l_ztbh in (1004,1005)--ȡ1004 ȡ1005
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate
         and to_char(t.d_rq,'yyyymmdd')>=v_firstbusinessdate)a,
 --
( select nvl(sum(t.en_mcje),0)je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='2' --
         and t.l_ywlb='1301'--ҵ 
         and t.l_ztbh in (1004,1005)--ȡ1004 ȡ1005
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate
         and to_char(t.d_rq,'yyyymmdd')>=v_firstbusinessdate)b,
 --м
 (select nvl(sum(t.amount),0) je
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature = '4' --ծ
 and t.buyorsell = 'B' --ع
 and t.value_date between  v_firstbusinessdate  and v_endbusinessdate  --ڽ
  )c  ;
 --ҵծʻعۼƷ
 insert into t_etl_c7_1_bnfse
 select 5 xm, nvl(sum(t.amount),0) ze,0 shjys,0 szjys ,nvl(sum(t.amount),0) yhj, V_bmid bmid
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature in( '1','26') --ҵծ
 and t.buyorsell = 'B' --ع
 and t.value_date between  v_firstbusinessdate  and v_endbusinessdate;  --ڽ
  --ծʻعۼƷ
 insert into t_etl_c7_1_bnfse
 select 9 xm, nvl(sum(t.amount),0) ze,0 shjys,0 szjys ,nvl(sum(t.amount),0) yhj, V_bmid bmid
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t
 where t.bondscode  not in  (select secucode from RODS.A_JY_D_Bond_Code  where bondnature  in ('1','4','26') )--޳ҵծ ծ
 and t.buyorsell = 'B' --ع
 and t.value_date between  v_firstbusinessdate  and v_endbusinessdate;  --ڽ


--ȯعۼƷ
 insert into t_etl_c7_1_bnfse
  select 14 xm, a.je+b.je+c.je ze ,a.je shjys ,b.je szjys,c.je yhj, V_bmid bmid   from
  --Ͻ
( select nvl(sum(t.en_mrje),0) je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='1' --Ϻ
         and t.l_ywlb='1302'--ҵ ȯ
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate
         and to_char(t.d_rq,'yyyymmdd')>=v_firstbusinessdate)a,
 --
( select nvl(sum(t.en_mrje),0)je from rods.a_hsgz_m_vjk_wbfk_jylsb t
   where t.l_sclb='2' --
         and t.l_ywlb='1302'--ҵ ȯ
         and to_char(t.d_rq,'yyyymmdd')<=v_endbusinessdate
         and to_char(t.d_rq,'yyyymmdd')>=v_firstbusinessdate)b,
  --ծȯعۼƷ
 (select nvl(sum(t.amount),0) je
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature = '4' --ҵծ
 and t.buyorsell = 'S' --ع
 and t.value_date between  v_firstbusinessdate  and v_endbusinessdate  --ڽ
  )c ;
  --ҵծȯعۼƷ
 insert into t_etl_c7_1_bnfse
 select 18 xm, nvl(sum(t.amount),0) ze,0 shjys,0 szjys ,nvl(sum(t.amount),0) yhj, V_bmid bmid
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t, RODS.A_JY_D_Bond_Code t1
 where t.bondscode = t1.secucode
 and t1.bondnature in( '1','26')  --ծծ
 and t.buyorsell = 'S' --ع
 and t.value_date between  v_firstbusinessdate  and v_endbusinessdate;  --ڽ
  --ծȯعۼƷ
 insert into t_etl_c7_1_bnfse
 select 22 xm, nvl(sum(t.amount),0) ze,0 shjys,0 szjys ,nvl(sum(t.amount),0) yhj, V_bmid bmid
  from RODS.A_JYZX_M_PAYMENT_LDREPODEALS t
 where t.bondscode  not in  (select secucode from RODS.A_JY_D_Bond_Code  where bondnature  in ('1','4','26') )--޳ҵծ ծ
 and t.buyorsell = 'S' --ع
 and t.value_date between  v_firstbusinessdate  and v_endbusinessdate;  --ڽ

 commit;
---------------------------------------------------------------------------------------------------------------
delete from t_etl_c7_1_bczl t where t.jylx=1;--ɾӪ
commit;
--ծйܽֵ
--Ͻ
insert into  t_etl_c7_1_bczl
select 2 xm,1 jylx, sum(t.l_zqcc*nvl(t3.mz,100)) je ,V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2,
      (select t.innercode,
              sum(t.earlyrepayratio) mz
        from RODS.A_JY_M_InstalRedempPrin t
       where to_char(t.earlyrepaydate,'yyyymmdd')>v_bbq_enddate
          and  t.InstalmentRepayType = '1'
         group by t.innercode )t3
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.innercode=t3.innercode(+)
   and t1.bondnature= '4' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '1' --Ϻ
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '83' --Դг  Ϻ
   and t.l_tzlx <> '5'
   and t.l_ztbh in ('1004','1005');

\*select 2 xm,1 jylx, nvl(sum(t.l_zqcc*100),0) je, V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.bondnature = '4' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '1' --Ϻ
   and t1.secumarket = '83' --Դг  Ϻ
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t.l_tzlx <> '5'; --5Խڸծʲ*\
--
insert into  t_etl_c7_1_bczl
select 3 xm,1 jylx, sum(t.l_zqcc*nvl(t3.mz,100)) je ,V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2,
      (select t.innercode,
              sum(t.earlyrepayratio) mz
        from RODS.A_JY_M_InstalRedempPrin t
       where to_char(t.earlyrepaydate,'yyyymmdd')>v_bbq_enddate
          and  t.InstalmentRepayType = '1'
         group by t.innercode )t3
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.innercode=t3.innercode(+)
   and t1.bondnature= '4' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '2' --Ϻ
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '90' --Դг  Ϻ
   and t.l_tzlx <> '5'
   and t.l_ztbh in ('1004','1005');

\*select 3 xm,1 jylx, nvl(sum(t.l_zqcc*100),0) je, V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.bondnature = '4' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '2' --
    and t1.secumarket = '90' --Դг  
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t.l_tzlx <> '5'; --5Խڸծʲ*\
--м
insert into  t_etl_c7_1_bczl
select 4 xm,1 jylx, sum(t.l_zqcc*nvl(t3.mz,100)) je ,V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2,
      (select t.innercode,
              sum(t.earlyrepayratio) mz
        from RODS.A_JY_M_InstalRedempPrin t
       where to_char(t.earlyrepaydate,'yyyymmdd')>v_bbq_enddate
          and  t.InstalmentRepayType = '1'
         group by t.innercode )t3
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.innercode=t3.innercode(+)
   and t1.bondnature= '4' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '3' --Ϻ
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '89' --Դг  Ϻ
   and t.l_tzlx <> '5'
   and t.l_ztbh in ('1004','1005');

\*select 4 xm,1 jylx, nvl(sum(t.l_zqcc*100),0) je, V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.bondnature = '4' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '3' --м
    and t1.secumarket = '89' --Դг  м
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t.l_tzlx <> '5'; --5Խڸծʲ*\
--ծ׼йܽ
--Ͻ
insert into  t_etl_c7_1_bczl
SELECT 6 xm,1 jylx, SUM(JE) JE,V_bmid bmid
FROM
(select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100)))*100,0) je
                   --  V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025'\*,'52000008'*\) --52000025
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('D'\*,'0'*\)--DϺ 0
   and t1.bondnature = '4'--ծ
   and t1.secumarket = '83' --Դг  Ϻ
   and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('LHTZ1001') AND T.PERIOD=v_bbq AND t.zqlb='3')--̨ˣֻȡ̨ά
   UNION ALL
   select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100)))*100,0) je
                   --  V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000008') --ű52000008
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('D'\*,'0'*\)--DϺ 0
   and t1.bondnature = '4'--ծ
   and t1.secumarket = '83' --Դг  Ϻ
   and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('GDSY1001') AND T.PERIOD=v_bbq AND t.zqlb='3'));--̨ˣֻȡ̨ά

\*select 6 xm,1 jylx,
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100)))*100,0) je,
                     V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025','52000008') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('D'\*,'0'*\)--DϺ 0
   and t1.bondnature = '4'--ծ
   and t1.secumarket = '83' --Դг  Ϻ
    ;*\
commit;
--
insert into  t_etl_c7_1_bczl
SELECT 7 xm,1 jylx,SUM(JE) JE,V_bmid bmid
FROM
(select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100)))*100,0) je
              --      V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025'\*,'52000008'*\) --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('0'\*,'0'*\)--DϺ 0
   and t1.secumarket = '90' --Դг  
   and t1.bondnature = '4'
   and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('LHTZ1001') AND T.PERIOD=v_bbq AND t.zqlb='3')--̨ˣֻȡ̨ά
   union all
   select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100)))*100,0) je
              --      V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000008') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('0'\*,'0'*\)--DϺ 0
   and t1.secumarket = '90' --Դг  
   and t1.bondnature = '4'
    and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('GDSY1001') AND T.PERIOD=v_bbq AND t.zqlb='3'));--̨ˣֻȡ̨ά

\*select 7 xm,1 jylx,
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100)))*100,0) je,
                    V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025','52000008') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('0'\*,'0'*\)--DϺ 0
   and t1.secumarket = '90' --Դг  
   and t1.bondnature = '4' ;--ծ;*\
commit;
--м  

--ҵծйֵ
--Ͻ
insert into  t_etl_c7_1_bczl
select 10 xm,1 jylx, sum(t.l_zqcc*nvl(t3.mz,100)) je ,V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2,
      (select t.innercode,
              sum(t.earlyrepayratio) mz
        from RODS.A_JY_M_InstalRedempPrin t
       where to_char(t.earlyrepaydate,'yyyymmdd')>v_bbq_enddate
          and  t.InstalmentRepayType = '1'
         group by t.innercode )t3
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.innercode=t3.innercode(+)
   and t1.bondnature in ('1','26') --ծ ھԴ·죬˼ֻծȯھԴзΪ33 ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '1' --Ϻ
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '83' --Դг  Ϻ
   and t.l_tzlx <> '5'
   and t.l_ztbh in ('1004','1005');

\*select 10 xm,1 jylx, nvl(sum(t.l_zqcc*100),0) je, V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.bondnature= '1' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '1' --Ϻ
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '83' --Դг  Ϻ
   and t.l_tzlx <> '5'; --5Խڸծʲ*\
--
insert into  t_etl_c7_1_bczl
 select 11 xm,1 jylx, sum(t.l_zqcc*nvl(t3.mz,100)) je ,V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2,
      (select t.innercode,
              sum(t.earlyrepayratio) mz
        from RODS.A_JY_M_InstalRedempPrin t
       where to_char(t.earlyrepaydate,'yyyymmdd')>v_bbq_enddate
          and  t.InstalmentRepayType = '1'
         group by t.innercode )t3
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.innercode=t3.innercode(+)
   and t1.bondnature in ('1','26') --ծ ھԴ·죬˼ֻծȯھԴзΪ33 ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '2' --Ϻ
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '90' --Դг  Ϻ
   and t.l_tzlx <> '5'
   and t.l_ztbh in ('1004','1005');

\*select 11 xm,1 jylx, nvl(sum(t.l_zqcc*100),0) je, V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.bondnature = '1' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '2' --
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '90' --Դг  
   and t.l_tzlx <> '5'; --5Խڸծʲ*\
--м
insert into  t_etl_c7_1_bczl
select 12 xm,1 jylx, sum(t.l_zqcc*nvl(t3.mz,100)) je ,V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2,
      (select t.innercode,
              sum(t.earlyrepayratio) mz
        from RODS.A_JY_M_InstalRedempPrin t
       where to_char(t.earlyrepaydate,'yyyymmdd')>v_bbq_enddate
          and  t.InstalmentRepayType = '1'
         group by t.innercode )t3
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.innercode=t3.innercode(+)
   and t1.bondnature in ( '1','26') --ծ   ھԴ·죬˼ֻծȯھԴзΪ33 ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '3' --м
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '89' --Դг  м
   and t.l_tzlx <> '5'
   and t.l_ztbh in ('1004','1005');

\*select 12 xm,1 jylx, nvl(sum(t.l_zqcc*100),0) je, V_bmid bmid
  from RODS.A_HSGZ_M_TACCOUNTZQJC t,
       RODS.A_JY_D_BOND_CODE      t1,
       rods.a_hsgz_m_tzqxx        t2
 where t.l_zqnm = t2.l_zqnm
   and t.vc_zqdm = t1.secucode
   and t1.bondnature = '1' --ծ
   and t2.l_zqlb = '2' --ծȯ
   and t2.l_sclb = '3' --м
   and to_char(t.d_date, 'yyyymmdd') = v_bbq_enddate
   and t.vc_zqdm <> '150024'
   and t1.secumarket = '89' --Դг  м
   and t.l_tzlx <> '5'; --5Խڸծʲ*\
commit;
--ҵծ׼йֵ
--Ͻ
insert into  t_etl_c7_1_bczl
SELECT 14 xm,1 jylx,SUM(JE) JE,V_bmid bmid
 FROM
(select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100))),0) je
                  --   V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025'\*,'52000008'*\) --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('D'\*,'0'*\)--DϺ 0
   and t1.secumarket = '83' --Դг  Ϻ
   and t1.bondnature  in ('1','26')
   and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('LHTZ1001') AND T.PERIOD=v_bbq AND t.zqlb='3')--̨ˣֻȡ̨ά
   UNION ALL
   select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100))),0) je
                  --   V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000008') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('D'\*,'0'*\)--DϺ 0
   and t1.secumarket = '83' --Դг  Ϻ
   and t1.bondnature  in ('1','26')
   and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('GDSY1001') AND T.PERIOD=v_bbq AND t.zqlb='3'));--̨ˣֻȡ̨ά

\*select 14 xm,1 jylx,
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100))),0) je,
                     V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025','52000008') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('D'\*,'0'*\)--DϺ 0
    and t1.secumarket = '83' --Դг  Ϻ
   and t1.bondnature = '1' ;--ҵծ;*\
commit;
--
insert into  t_etl_c7_1_bczl
SELECT 15 xm,1 jylx,SUM(JE) JE,V_bmid bmid
 FROM
(select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100))),0) je
                    --V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('0'\*,'0'*\)--DϺ 0
   and t1.secumarket = '90' --Դг  
   and t1.bondnature in( '1','26')
   and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('LHTZ1001') AND T.PERIOD=v_bbq AND t.zqlb='3')--̨ˣֻȡ̨ά
   UNION ALL
   select
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100))),0) je
                   -- V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000008') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('0'\*,'0'*\)--DϺ 0
   and t1.secumarket = '90' --Դг  
   and t1.bondnature in  ('1','26')
   and b.vc_report_code in (select  t.zqdm from KGRP.T_CISP_BKS_CCMX t where t.department_id in('GDSY1001') AND T.PERIOD=v_bbq AND t.zqlb='3'))--̨ˣֻȡ̨ά

\*select 15 xm,1 jylx,
 nvl((sum(nvl(a.en_current_impawn_amount + a.en_impawn_amount -
          a.en_return_amount,
          0) *
      decode(a.c_market_no,
             '1',
             nvl2(tb.en_curr_face_price,
                  tb.en_curr_face_price / 100,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 20305) / 100,
                    ts.en_again_coefficient) / 100,
             '2',
             nvl2(tb.en_curr_face_price,
                  1,
                  b.en_face_values / decode(b.c_asset_class, '3', 100, 1)) *
             nvl(d.l_ratio, 100) *
             decode(ts.en_again_coefficient,
                    null,
                    (select to_number(nvl(min(a.vc_value), 100))
                       from rods.a_zyo32_m_tsysparameter a
                      where a.l_serial_no = 61429) / 100,
                    ts.en_again_coefficient) / 100))),0) je,
                    V_bmid bmid
  from rods.a_zyo32_m_tunitstock    a,
       rods.a_zyo32_m_tstockinfo    b,
       rods.a_zyo32_m_thgratio      d,
      rods.a_zyo32_m_tbondproperty tb,
       rods.a_zyo32_m_TSTOCKHOLDER  ts,
       RODS.A_JY_D_BOND_CODE t1
 where a.vc_inter_code = b.vc_inter_code
   and substr(a.vc_inter_code,0,6)=t1.secucode
   and a.l_date = b.l_date
   and b.vc_inter_code = d.vc_inter_code
   and d.c_parameter_type = '4'
   and a.l_date = tb.l_date(+)
   and a.vc_stockholder_id = ts.vc_stockholder_id
   and b.c_market_no = ts.c_market_no
   and a.vc_inter_code = tb.vc_inter_code(+)
   and a.l_current_amount > 0
   and a.l_fund_id in ('52000025','52000008') --
   --and a.l_date=v_bbq_enddate--ֲ
   and substr(a.vc_stockholder_id,0,1)in ('0'\*,'0'*\)--DϺ 0
   and t1.secumarket = '90' --Դг  
   and t1.bondnature = '1' ;--ҵծ;*\
commit;
--м  


  P_OUT_FLAG := 1;
  P_OUT_MSG  := 'C7-1ծȯعҵܱ-Ѻʽծȯع';
EXCEPTION
  WHEN OTHERS THEN
    ROLLBACK;
    P_OUT_FLAG   := 0;
    P_OUT_MSG    := 'C7-1ծȯعҵܱ-Ѻʽծȯع쳣';
    P_OUT_RESULT := 'C7-1ծȯعҵܱ-Ѻʽծȯع쳣' || SQLERRM;*/
END ;
/

prompt
prompt Creating procedure CISP_MAP_JJYW_SFCG_20190815
prompt ==============================================
prompt
create or replace procedure cisp_map_jjyw_sfcg_20190815 is
  v_bbq_begindate int;
  v_bbq_enddate   int;
  v_bbq           varchar2(8);
  v_sqsl          int;
  v_bmid          varchar2(12);
begin


  select to_number(to_char(a005, 'YYYYMMDD')),
         to_number(to_char(a006, 'YYYYMMDD')),
         to_char(a005, 'YYYYMM') || '--'
    into v_bbq_begindate, v_bbq_enddate, v_bbq
    from t_b00_d004
   where c001 = 1001101
     and d100 = 1006002
     and a002 = 1013001;
     v_bmid:=50001;

  select nvl(b4,0)
    into v_sqsl
    from t_csrc0710_0_6
   where userid = v_bmid
     and bbq = (select max(substr(bbq, 1, 6) || '--')
                  from t_csrc0710_0_6
                 where substr(bbq, 1, 6) < substr(v_bbq, 1, 6));

  delete from t_etl_sfcg;
  commit;

  insert into t_etl_sfcg t
    (moneytype, fundbal)
    SELECT 1 as moneytype, count(distinct a.fund_account) as sl
      FROM kods.rzrq_hs_bankexchaccount a, kods.rzrq_hs_bankarg b,kods.rzrq_hs_fund_fundaccount c
     WHERE a.money_type = '0'
       and a.bank_no = b.bank_no
       and bank_type = '2'
       and a.fund_account = c.fund_account
       and c.fundacct_status='0'
       and c.main_flag='1'
       --and a.branch_no not in (88, 99)
  union all
    select 2 as moneytype, count(a.fund_account) - v_sqsl as sl
      FROM kods.rzrq_hs_bankexchaccount a, kods.rzrq_hs_bankarg b,kods.rzrq_hs_fund_fundaccount c
     WHERE money_type = '0'
       and a.bank_no = b.bank_no
       and bank_type = '2'
       and a.fund_account = c.fund_account
       and c.fundacct_status='0'
       and c.main_flag = '1'
       --and a.branch_no not in (88, 99)
    union all
    SELECT 3 as moneytype, sum(a.occur_balance) as je
      FROM kods.A_HS08_HIS_OPERATIONTOTAL a, kods.rzrq_hs_bankarg b
     where a.init_date = (select max(init_date)
                            from kods.A_HS08_HIS_OPERATIONTOTAL
                           where init_date <= v_bbq_enddate and op_branch_no <>'8888')
       --and a.branch_no not in (88, 99)
       AND money_type = '0'
       and BUSINess_flag = 5201
       and a.bank_no = b.bank_no
       and bank_type = '2';

  commit;

  cisp_etl_sfcg;
  commit;
end cisp_map_jjyw_sfcg_20190815;
/

prompt
prompt Creating procedure CISP_MAP_JJYW_SFCG_20190820V
prompt ===============================================
prompt
create or replace procedure cisp_map_jjyw_sfcg_20190820v is
  v_bbq_begindate int;
  v_bbq_enddate   int;
  v_bbq           varchar2(8);
  v_sqsl          int;
  v_bmid          varchar2(12);
begin


  select to_number(to_char(a005, 'YYYYMMDD')),
         to_number(to_char(a006, 'YYYYMMDD')),
         to_char(a005, 'YYYYMM') || '--'
    into v_bbq_begindate, v_bbq_enddate, v_bbq
    from t_b00_d004
   where c001 = 1001101
     and d100 = 1006002
     and a002 = 1013001;
     v_bmid:=50001;

  select nvl(b4,0)
    into v_sqsl
    from t_csrc0710_0_6
   where userid = v_bmid
     and bbq = (select max(substr(bbq, 1, 6) || '--')
                  from t_csrc0710_0_6
                 where substr(bbq, 1, 6) < substr(v_bbq, 1, 6));

  delete from t_etl_sfcg;
  commit;

  insert into t_etl_sfcg t
    (moneytype, fundbal)
    SELECT 1 as moneytype, count(distinct a.fund_account) as sl
      FROM KODS.RZRQ_HS_BANKEXCHACCOUNT a, KODS.RZRQ_HS_BANKARG b,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT c
     WHERE a.money_type = '0'
       and a.bank_no = b.bank_no
       and bank_type = '2'
       and a.fund_account = c.fund_account
       and c.fundacct_status='0'
       and c.main_flag='1'
       --and a.branch_no not in (88, 99)
  union all
    select 2 as moneytype, count(a.fund_account) - v_sqsl as sl
      FROM KODS.RZRQ_HS_BANKEXCHACCOUNT a, KODS.RZRQ_HS_BANKARG b,KODS.V_RZRQ_HS_FUND_FUNDACCOUNT c
     WHERE money_type = '0'
       and a.bank_no = b.bank_no
       and bank_type = '2'
       and a.fund_account = c.fund_account
       and c.fundacct_status='0'
       and c.main_flag = '1'
       --and a.branch_no not in (88, 99)
    union all
    SELECT 3 as moneytype, sum(a.occur_balance) as je
      FROM kods.A_HS08_HIS_OPERATIONTOTAL a, KODS.RZRQ_HS_BANKARG b
     where a.init_date = (select max(init_date)
                            from kods.A_HS08_HIS_OPERATIONTOTAL
                           where init_date <= v_bbq_enddate and op_branch_no <>'8888')
       --and a.branch_no not in (88, 99)
       AND money_type = '0'
       and BUSINess_flag = 5201
       and a.bank_no = b.bank_no
       and bank_type = '2';

  commit;

  cisp_etl_sfcg;
  commit;
end cisp_map_jjyw_sfcg;
/

prompt
prompt Creating procedure CISP_MAP_JY_RZRQ_20190725
prompt ============================================
prompt
create or replace procedure cisp_map_jy_rzrq_20190725
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  C1-2:ױ(ͶӰetl:t_etl_jy)
-- RETURN:
-- AUTHOR:       wuxg
-- CREATE DATE:  2015/07/08
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
  v_bbq_begindate    number;
  v_bbq_enddate      number;
begin
   delete from  t_etl_jy_rzrq;

   select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_bbq_begindate, v_bbq_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

 insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   )     select t.khlx,
          1 zqlx,  --A
          1 jylx,  --
          sum(abs(je)) je
     from (
             select decode(b.organ_flag, '1',1 ,'3',1, '0') khlx,
                  business_balance je --ɽ
             from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
          where a.client_id = b.client_id
              and business_flag in
             (4001,4002,4701, 4702, 4703, 4704, 4705, 4706)
                   --4001֤ȯ ,4002֤ȯ
                   --4211  ,4212  
                   -- 4213ȯ,4214  ȯ,
                   --4215 ƽ,4216  ƽ
              and a.stock_type in ('0','3' ,'c')--in ('T','j','l') --   T ETL
              and trim(a.exchange_type) in ('1','2')
              and a.asset_prop='7'
              and init_date between v_bbq_begindate and v_bbq_enddate
          ) t
    group by t.khlx;
    commit;
    insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) 
   select t.khlx,
          4 zqlx,  --
          1 jylx,  --
          sum(abs(je)) je
     from (
           select decode(b.organ_flag, '1',1 ,'3',1, '0') khlx,
                  business_balance je --ɽ
             from kods.rzrq_hs_his_hisdeliver a,
            kods.rzrq_hs_client b
          where  a.client_id = b.client_id
            and business_flag in
             (4001,4002,4701, 4702, 4703, 4704, 4705, 4706)
             --4001֤ȯ ,4002֤ȯ
             --4211  ,4212  
             -- 4213ȯ,4214  ȯ,
             --4215 ƽ,4216  ƽ
              and a.stock_type in ('6','L','T','j','l')
              and trim(a.exchange_type) in ('1','2')
              and a.asset_prop='7'
              -- T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF
              and init_date between v_bbq_begindate and v_bbq_enddate
          ) t
    group by t.khlx;
    commit;

   
  insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) 
   select t.khlx,
          5 zqlx,  --ETF
          1 jylx,  --
          sum(abs(je)) je
     from (
             select decode(b.organ_flag, '1',1 ,'3',1, '0') khlx,
                  business_balance je --ɽ
             from kods.rzrq_hs_his_hisdeliver a, kods.rzrq_hs_client b
          where a.client_id = b.client_id
              and business_flag in
             (4001,4002,4701, 4702, 4703, 4704, 4705, 4706)
                   --4001֤ȯ ,4002֤ȯ
                   --4211  ,4212  
                   -- 4213ȯ,4214  ȯ,
                   --4215 ƽ,4216  ƽ
              and a.stock_type in ('T'/*,'j','l'*/) --   T ETL
              and trim(a.exchange_type) in ('1','2')
              and a.asset_prop='7'
              and init_date between v_bbq_begindate      and v_bbq_enddate
          ) t
    group by t.khlx;
    commit;

  insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) select t.khlx,
          6 zqlx,  --LOF
          1 jylx,  --
          sum(abs(je)) je
     from (
             select decode(b.organ_flag, '1',1 ,'3',1, '0') khlx,
                  business_balance je --ɽ
             from kods.rzrq_hs_his_hisdeliver a,
            kods.rzrq_hs_client b
          where a.client_id = b.client_id
              and business_flag in
             (4001,4002,4701, 4702, 4703, 4704, 4705, 4706)
                   --4001֤ȯ ,4002֤ȯ
                   --4211  ,4212  
                   -- 4213ȯ,4214  ȯ,
                   --4215 ƽ,4216  ƽ
              and a.stock_type in ('L') --  L LOF
              and trim(a.exchange_type) in ('1','2')
              and a.asset_prop='7'
              and init_date between v_bbq_begindate              and v_bbq_enddate
          ) t
    group by t.khlx;
    commit;
   
   insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   )
   select t.khlx,
          7 zqlx,  --ծȯ
          1 jylx,  --
          sum(abs(je)) je
     from (
             select decode(b.organ_flag, '1',1 ,'3',1, '0') khlx,
                  business_balance je --ɽ
             from kods.rzrq_hs_his_hisdeliver a,
            kods.rzrq_hs_client b
          where a.client_id = b.client_id
              and business_flag in
             (4001,4002,4701, 4702, 4703, 4704, 4705, 4706)
                   --4001֤ȯ ,4002֤ȯ
                   --4211  ,4212  
                   -- 4213ȯ,4214  ȯ,
                   --4215 ƽ,4216  ƽ
              and a.stock_type in  ('9','X','Y','U','u','a') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
              and trim(a.exchange_type) in ('1','2')
              and a.asset_prop='7'
              and init_date between v_bbq_begindate   and v_bbq_enddate
          ) t
    group by t.khlx;
    commit;
   
  insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) 
   select t.khlx,
          12 zqlx, --Ͻ
          1 jylx,  --
          sum(je) je
     from (
         select decode(b.organ_flag, '1',1 ,'3',1, '0') khlx,
                business_balance je --ɽ
           from kods.rzrq_hs_his_hisdeliver a,
            kods.rzrq_hs_client b
          where a.client_id = b.client_id
            and business_flag in
           (4001,4002,4701, 4702, 4703, 4704, 4705, 4706)
                 --4001֤ȯ ,4002֤ȯ
                 --4211  ,4212  
                 -- 4213ȯ,4214  ȯ,
                 --4215 ƽ,4216  ƽ
            and a.op_entrust_way in ('7') --ίзʽί7 
            and trim(a.exchange_type) in ('1','2')
            and a.asset_prop='7'
            and init_date between v_bbq_begindate  and v_bbq_enddate
          ) t
    group by t.khlx;
    commit;

 
 insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   )
   select t.khlx,
          1 zqlx, --AƱ
          2 jylx, --ָй
          sum(je) je
     from (
          select decode(c.organ_flag, '1',1 ,'3',1, '0') khlx,
                 a.current_amount * b.ASSET_PRICE je
            from kods.rzrq_hs_stock a,
             kods.rzrq_hs_his_hisprice b,
             kods.rzrq_hs_client c,
             kods.rzrq_hs_fund_fundaccount d
           where b.stock_code = a.stock_code
             and a.client_id=c.client_id
             and a.fund_account=d.fund_account
             and a.stock_type in ('0', 'c') --A,ҵ
             and trim(a.exchange_type) in ('1','2')
             and d.asset_prop='7'
             and b.init_date =(select max(init_date)
             from kods.rzrq_hs_his_hisprice where init_date<=v_bbq_enddate)
          ) t
    group by t.khlx;
    commit;
 
 insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) 
   select t.khlx,
          4 zqlx, --
          2 jylx, --ָй
          sum(je) je
     from (
          select decode(c.organ_flag, '1',1 ,'3',1, '0') khlx,
                 a.current_amount * b.asset_price je
            from kods.rzrq_hs_stock a,
             kods.rzrq_hs_his_hisprice b,
             kods.rzrq_hs_client c,
             kods.rzrq_hs_fund_fundaccount d
           where b.stock_code = a.stock_code
             and a.client_id=c.client_id
             and a.stock_type in ('T', 'L', '6','j','l') -- T ETLL LOF6 Ͷʻ
             and trim(a.exchange_type) in ('1','2')
             and a.fund_account=d.fund_account
             and d.asset_prop='7'
             and b.init_date = (select max(init_date)
             from kods.rzrq_hs_his_hisprice where init_date<=v_bbq_enddate)
          ) t
    group by t.khlx;
    commit;

insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) 
   select t.khlx,
          5 zqlx, --ETF
          2 jylx, --ָй
          sum(je) je
     from (
             select decode(c.organ_flag, '1',1 ,'3',1, '0') khlx,
                 a.current_amount * b.last_price je
            from kods.rzrq_hs_stock a,
             kods.rzrq_hs_his_hisprice b,
             kods.rzrq_hs_client c,
             kods.rzrq_hs_fund_fundaccount d
           where b.stock_code = a.stock_code
             and a.client_id=c.client_id
             and a.fund_account=d.fund_account
             and a.stock_type in ('T'/*,'j','l'*/) -- T ETL
             and trim(a.exchange_type) in ('1','2')
             and d.asset_prop='7'
             and b.init_date = (select max(init_date)
             from kods.rzrq_hs_his_hisprice where init_date<=v_bbq_enddate)
          ) t
    group by t.khlx;
    commit;

  insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) 
   select t.khlx,
          6 zqlx, --LOF
          2 jylx, --ָй
          sum(je) je
     from (
              select decode(c.organ_flag, '1',1 ,'3',1, '0') khlx,
                 a.current_amount * b.last_price je
            from kods.rzrq_hs_stock a,
             kods.rzrq_hs_his_hisprice b,
             kods.rzrq_hs_client c,
             kods.rzrq_hs_fund_fundaccount d
           where b.stock_code = a.stock_code
             and a.client_id=c.client_id
             and a.fund_account=d.fund_account
             and a.stock_type in ('L') -- T L LOF
             and trim(a.exchange_type) in ('1','2')
             and d.asset_prop='7'
             and b.init_date = (select max(init_date)
             from kods.rzrq_hs_his_hisprice where init_date<=v_bbq_enddate)
          ) t
    group by t.khlx;
    commit;

   insert into t_etl_jy_rzrq(
          khlx,
          zqlx,
          jylx,
          je
   ) 
   select t.khlx,
          7 zqlx, --ծȯ
          2 jylx, --ָй
          sum(je) je
     from (
              select decode(c.organ_flag, '1',1 ,'3',1, '0') khlx,
                 a.current_amount * b.last_price je
            from kods.rzrq_hs_stock a,
             kods.rzrq_hs_his_hisprice b,
             kods.rzrq_hs_client c,
             kods.rzrq_hs_fund_fundaccount d
           where b.stock_code = a.stock_code
             and a.client_id=c.client_id
             and a.fund_account=d.fund_account
             and a.stock_type in  ('9','X','Y','U','u','a','Z') --9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
             and trim(a.exchange_type) in ('1','2')
             and d.asset_prop='7'
             and b.init_date = (select max(init_date)
             from kods.rzrq_hs_his_hisprice where init_date<=v_bbq_enddate)
          ) t
    group by t.khlx;
    commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_LRJG
prompt ================================
prompt
create or replace procedure cisp_map_lrjg
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  ܱ
-- RETURN:
-- AUTHOR:       wuxg
-- CREATE DATE:  2014/8/12
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
begin

   cisp_process_cwdata_unfi('B2-1','t_etl_lr','0','1');
   delete from t_etl_lr;
   commit;

   insert into t_etl_lr (xm,bqje)
   select t.proid,periodcrbalance
  from t_etl_biz_data t
 where t.reportid = 'B2-1'
   ;
  commit;

    --Ӫҵ
   insert into t_etl_lr(xm,bqje,bnlj)
   select 1010,sum(bqje),sum(bnlj)
   from t_etl_lr
   where xm in( 1020,
                1180,
                1340,
                1410,
                1440,
                1450
   );
commit;

   --֤ȯҵ
   insert into t_etl_lr(xm,bqje,bnlj)
   select 1030,sum(bqje),sum(bnlj)
   from t_etl_lr
   where xm in( 1040,
                1050,
                1060
   );
commit;

   --Ͷҵ
   insert into t_etl_lr(xm,bqje,bnlj)
   select 1070,sum(bqje),sum(bnlj)
   from t_etl_lr
   where xm in( 1080,
                1090,
                1100
   );
commit;

   --Ӫҵ֧
   insert into t_etl_lr(xm,bqje,bnlj)
   select 2010,sum(bqje),sum(bnlj)
   from t_etl_lr
   where xm in( 2020,  --Ӫҵ˰𼰸
                2030,  --ҵ񼰹
                2080,  --ʲֵʧ
                2090  --ҵɱ
   );
commit;

   --Ӫҵ
   insert into t_etl_lr(xm,bqje,bnlj)
   select 3010,sum(case when xm = 2010 then -bqje else bqje end),sum(case when xm = 2010 then -bnlj else bnlj end)
   from t_etl_lr
   where xm in( 1010,  --Ӫҵ
                2010  --Ӫҵ֧
   );
commit;

   --ܶ
   insert into t_etl_lr(xm,bqje,bnlj)
   select 4010,sum(case when xm = 3030 then -bqje else bqje end),sum(case when xm = 3030 then -bnlj else bnlj end)
   from t_etl_lr
   where xm in( 3010,  --Ӫҵ
                3020,  --Ӫҵ
                3030  --Ӫҵ֧
   );
commit;

   --
   insert into t_etl_lr(xm,bqje,bnlj)
   select 5010,sum(case when xm = 4020 then -bqje else bqje end),sum(case when xm = 4020 then -bnlj else bnlj end)
   from t_etl_lr
   where xm in( 4010,  --ܶ
                4020  --˰
   );
    commit;

    --ۺ
   update t_etl_lr set bqje = round(bqje*0.75,2),bnlj = round(bnlj*0.75,2)
   where xm = 6010;
   commit;


   --ۺ
   insert into t_etl_lr(xm,bqje,bnlj)
   select 7010,sum(bqje),sum(bnlj)
   from t_etl_lr
   where xm in( 5010,  --
                6010   --ۺ
   );
commit;

    cisp_etl_lr;

end;
/

prompt
prompt Creating procedure CISP_MAP_RZRQ_ZB_20200817
prompt ============================================
prompt
create or replace procedure cisp_map_rzrq_zb_20200817
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:        hucc
  -- CREATE DATE:   20120619
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate number; --ʼ
  v_bbq_enddate   number; --ֹ
  v_bmid          varchar(80); --ID
  v_date          number;
  /*20120618 by hucc in ֤ȯ*/
begin

  --ɾȯETL
  delete from T_ETL_RZRQ_C10; -- a -- where a.xm not in('37','38','36','39'/*,'40','41','44'*/); --ȯC10-1
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  v_bmid := '50008'; --ýײID

  select max(p001)
    into v_date
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001102;
  --C10-1ܲȯ
  /*************   ˻    ***********/
  cisp_process_cwdata_unfi('C10-1', 't_etl_rzrq_c10', '1', '1');
  commit;

  --1 ˾չȯҵ֤ȯӪҵ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 1 as id, count(distinct a.branch_no) s1
      from kods.rzrq_hs_his_hisassetdebit a
     where a.branch_no not in ('7777'); /*,krcs.t_ctl_t036 b*/
  --where a.branch_no=b.p001
  --and b.a008='1023008';

  --2 ڳʽ˻  ʼ

  --3 ʽ˻
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 3 as id, count(*)
      from kods.rzrq_hs_fund_fundaccount
     where asset_prop = '7'
          --and business_flag in (1001, 1020)
       and branch_no not in ('7777')
       and open_date between v_bbq_begindate and v_bbq_enddate;
  --4 ڼʽ˻ 
  insert into T_ETL_RZRQ_C10
    (XM, JE)
    select 4, nvl(count(*), 0)
      from kods.rzrq_hs_fund_fundaccount t
     where t.fundacct_status = '3' --˻
       and t.asset_prop = '7' --˻
       and t.cancel_date between v_bbq_begindate and v_bbq_enddate
       and t.branch_no not in ('7777');

  --5 ĩʽ˻
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 5, count(distinct a.fund_account)
      from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_client b
     where a.client_id = b.client_id
       and a.fundacct_status <> '3' --Ϊ˻
       and a.asset_prop = '7' --˻
       and b.organ_flag in ('0', '1', '3') --0Ϊ 1Ϊ;
       and a.branch_no not in ('7777')
       and a.open_date <= v_bbq_enddate;

  --6 Уͻ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 6, nvl(count(distinct a.fund_account), 0)
      from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_client b
     where a.client_id = b.client_id
       and a.fundacct_status <> '3' --Ϊ˻
       and a.asset_prop = '7' --˻
       and b.organ_flag in ('1', '3')
       and a.branch_no not in ('7777')
       and a.open_date <= v_bbq_enddate;

  --7 Уδ˽ծȨծϵĿͻ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 7, nvl(count(fund_account), 0) s1
      from kods.rzrq_hs_his_hisassetdebit a
     where (a.fin_close_balance + a.slo_close_balance + --ʸծ+ȯծ
           a.fare_close_debit + a.other_close_debit + --зøծծ
           a.fin_close_interest + a.slo_close_interest + --ʸծϢȯծϢ
           a.fare_close_interest + a.other_close_interest > 0) --зøծϢծϢ
       and a.init_date =
           (select max(init_date)
              from kods.rzrq_hs_his_hisassetdebit t
             where t.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  /*************   ȯ    ***********/

  --8 ĩ»ȷȯҵܹģ˾ܶȣ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 8, sum(t.crdt_total_quota) as s1
      from kods.RZRQ_HS_CASHQUOTA t
     where t.cashgroup_no = '1'
       and t.cashquota_type in ('3');

  --9 УͻѻʹõŶ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 9, nvl(s1, 0) as balance
      from (select /*case
                             when sum(nvl(m.total_max_quota, 0)) = 0 then --ܶ
                              sum(nvl(m.finance_max_quota, 0)) +--ʶ
                              sum(nvl(shortsell_max_quota, 0)) --ȯֵ
                             else
                              sum(nvl(m.total_max_quota, 0))
                           end s1*/
             sum(nvl(m.total_max_quota, 0)) as s1
              from kods.rzrq_hs_crdtcontract m
             where m.branch_no not in ('7777')) a;

  --ʼ 10 ڳȯ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 10, v
      from t_b30_f001
     where p003 = 1206001
       and p001 = v_date
       and p002 = 10190;

  --       11    Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 11, v
      from t_b30_f001
     where p003 = 1206001
       and p001 = v_date
       and p002 = 10200;
  --       12  ȯֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 12, v
      from t_b30_f001
     where p003 = 1206001
       and p001 = v_date
       and p002 = 10210;
  --13·ȯ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 13, nvl(sum(business_balance), 0) balance
      from (select nvl(sum(abs(clear_balance)), 0) business_balance
              from kods.rzrq_hs_his_hisdeliver
             where init_date <= v_bbq_enddate
               and init_date >= v_bbq_begindate
               and business_flag = 4702
            union all
            select nvl(sum(business_balance), 0) business_balance
              from kods.rzrq_hs_his_hisdeliver
             where init_date <= v_bbq_enddate
               and init_date >= v_bbq_begindate
               and business_flag = 4703) a;

  --14    Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 14, nvl(sum(abs(clear_balance)), 0) business_balance
      from kods.rzrq_hs_his_hisdeliver
     where init_date <= v_bbq_enddate
       and init_date >= v_bbq_begindate
       and business_flag = 4702;

  --15 ȯȯʱֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 15, nvl(sum(business_balance), 0) business_balance
      from kods.rzrq_hs_his_hisdeliver
     where init_date <= v_bbq_enddate
       and init_date >= v_bbq_begindate
       and business_flag = 4703;

  --18         ȯȯʱֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 18, sum(business_balance + slo_stockret_balance) as s1
      from (select sum(abs(business_balance)) as business_balance
              from kods.RZRQ_HS_HIS_BUSINESSTOTAL
             where init_date between v_bbq_begindate and v_bbq_enddate
               and business_flag in (4704, 4706, 4724, 4727, 4728)),
           
           (select nvl(sum(a.slo_stockret_amount * b.asset_price), 0) as slo_stockret_balance
              from kods.RZRQ_HS_HIS_SECRDTMTSL a,
                   kods.RZRQ_HS_HIS_HISPRICE   b
             where a.stock_code = b.stock_code
               and a.exchange_type = b.exchange_type
               and a.init_date = b.init_date
               and a.init_date between v_bbq_begindate and v_bbq_enddate);
  --19 ĩȯ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 19,
           sum(a.fin_close_balance + a.fare_close_debit +
               a.other_close_debit + a.slo_close_balance) as s1 --ʸծ+ȯծ
      from kods.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(a.init_date)
                          from kods.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');
  --20 Уʽ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 20,
           sum(fin_close_balance + a.fare_close_debit + a.other_close_debit) as s1 --ʸծ
      from kods.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(a.init_date)
                          from kods.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --21 Уȯֵ
  insert into T_ETL_RZRQ_C10
    select 21, sum(slo_close_balance) as s1 --ȯծ
      from kods.rzrq_hs_his_hisassetdebit a
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --17  Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 17 as id, COALESCE(a.je - b.je, 0)
      from (select COALESCE(sum(a.je), 0) as je
              from T_ETL_RZRQ_C10 a
             where a.xm in ('11', '14')) a,
           (select COALESCE(sum(a.je), 0) as je
              from T_ETL_RZRQ_C10 a
             where a.xm in ('20')) b;

  --16   ڹ黹ȯ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 16 as id, COALESCE(a.je, 0)
      from (select COALESCE(sum(a.je), 0) as je
              from T_ETL_RZRQ_C10 a
             where a.xm in ('17', '18')) a;

  --22 ˾ۼƶԿͻʡȯʣ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 22, nvl(count(*), 0) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702, 4703) --4702,4702ȯ
       and init_date between v_bbq_begindate and v_bbq_enddate
       and branch_no not in ('7777');

  --23 Уʱʣ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 23, nvl(count(*), 0) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4702) --4702
       and init_date between v_bbq_begindate and v_bbq_enddate
       and branch_no not in ('7777');

  --24 ȯʣ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 24, nvl(count(*), 0) s1
      from kods.rzrq_hs_his_hisdeliver
     where business_flag in (4703) --4214ȯ
       and init_date between v_bbq_begindate and v_bbq_enddate
       and branch_no not in ('7777');

  /*************       ***********/

  --25 ĩͻֵ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 25,
           nvl(sum(a.current_balance), 0) + nvl(sum(market_close_value), 0) + nvl(sum(correct_balance), 0) as s1 --ǰ
      from kods.rzrq_hs_his_hisassetdebit a
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --26 Уʽ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 26, nvl(sum(current_balance), 0) as s1 --ǰ
      from kods.rzrq_hs_his_hisassetdebit a
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777');

  --27 ֤ȯֵ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 27, nvl(sum(market_close_value), 0) as s1
      from kods.rzrq_hs_his_hisassetdebit
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and branch_no not in ('7777');
  --28  ޣ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 28, nvl(sum(correct_balance), 0) as s1 --ʽ
      from kods.rzrq_hs_his_hisassetdebit 
     where init_date = (select max(a.init_date)
                          from kods.rzrq_hs_his_hisassetdebit a
                         where a.init_date <= v_bbq_enddate)
       and branch_no not in ('7777');
  --29 ĩάֵ%
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 29, /*case
                    when sum(a.fin_close_balance + a.slo_close_balance +
                                   a.fin_close_interest + a.slo_close_interest +
                                   a.fare_close_interest + a.other_close_interest +
                                   a.fare_close_debit + a.other_close_debit) = 0 then
                     -1
                    else*/
           round(sum(assure_close_balance) * 100 /
                  /*sum(a.fin_close_balance + a.slo_close_balance +
                  a.fin_close_interest + a.slo_close_interest +
                  a.fare_close_interest + a.other_close_interest +
                  a.fare_close_debit + a.other_close_debit)*/
                  sum(a.fin_close_balance + a.slo_close_balance +
                      a.fare_close_debit + a.fin_pre_interest +
                      a.other_close_debit + a.refcost_close_fare),
                  2)
           /*end*/ s1
      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
     where init_date = (select max(a.init_date)
                          from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and ( /*a.fin_close_balance + a.slo_close_balance +
                                   a.fin_close_interest + a.slo_close_interest +
                                   a.fare_close_interest + a.other_close_interest +
                                   a.fare_close_debit + a.other_close_debit*/
            a.fin_close_balance + a.slo_close_balance + a.fare_close_debit +
            a.fin_pre_interest + a.other_close_debit + a.refcost_close_fare) > 0
       and a.branch_no not in ('7777');

  --30 ĩ͵Ŀͻ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 30, nvl(count(*), 0) s1
      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
     where a.close_rate < '1.3'
       and a.close_rate <> -1.00
       and init_date = (select max(a.init_date)
                          from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                         where a.init_date <= v_bbq_enddate)
       and a.branch_no not in ('7777'); --άֵ130

  /*************   ǿƽ    ***********/

  --31 ۼƱǿƽֵĿͻ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 31, nvl(s1, 0)
      from (select count(distinct fund_account) s1
              from kods.rzrq_hs_his_hisdeliver
             where business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;

  --32 ۼǿƽִ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 32, nvl(s1, 0)
      from (select count(*) s1
              from kods.rzrq_hs_his_hisdeliver
             where business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;

  --33 ۼǿƽֽ׽

  insert into T_ETL_RZRQ_C10
    select 33, nvl(s1, 0)
      from (select sum(business_balance) s1
              from kods.rzrq_hs_his_hisdeliver
             where business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;

  --34 ۼƾǿƽδʵֵծȨ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 34, nvl(s1, 0)
      from (select sum(nvl(fin_close_balance, 0) + nvl(slo_close_balance, 0) +
                       nvl(fare_close_debit, 0) + nvl(other_close_debit, 0) +
                       nvl(fare_close_interest, 0) +
                       nvl(other_close_interest, 0) +
                       nvl(fin_close_interest, 0) +
                       nvl(slo_close_interest, 0) +
                       nvl(fin_close_fine_interest, 0) +
                       nvl(slo_close_fine_interest, 0) +
                       nvl(other_close_fine_interest, 0)) as s1
              from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
             where a.close_rate >= 0
               and a.close_rate < 1
               and init_date =
                   (select max(a.init_date)
                      from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                     where a.init_date <= v_bbq_enddate)
               and branch_no not in ('7777')) a;

  --35 УĩջծȨ
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 35,
           nvl(a.occur_balance, 0) + nvl(c.occur_balance, 0) as occur_balance
    
      from (select nvl(sum(abs(occur_balance)), 0) occur_balance
              from KODS.RZRQ_HS_HIS_HISFUNDJOUR
             where business_flag in (4217, 4218, 4220) --Ϣ֧,ȯϢ֧,Ϣ֧
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a,
           (select nvl(sum(abs(fare0)), 0) occur_balance
              from KODS.RZRQ_HS_HIS_HISDELIVER
             where business_flag in (4702, 4212, 4216) --4702,4212,4216ƽ
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) c;
  commit;

  /*--ҵ  
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
       select 37,
             nvl(a.occur_balance, 0) + nvl(c.occur_balance, 0) -
         nvl(d.occur_balance, 0) - nvl(a1.occur_balance, 0) as occur_balance
    from (select nvl(sum(abs(occur_balance)), 0) occur_balance
            from kods.rzrq_hs_his_hisfundjour a
           where (business_flag in (2712,2715,2718,2721,2724,2795,2732,2735,2738,2741,2744,2778)  or
                 (a.business_flag = 2779 and exists
                (select compact_id
                 from kods.rzrq_hs_his_compact
                 where compact_type in('0','2') 
                   and compact_id = substr(a.remark, 6, 23))))
             and init_date <= v_bbq_enddate) a,
       (select nvl(sum(abs(occur_balance)), 0) occur_balance
          from kods.rzrq_hs_his_hisfundjour a
         where (business_flag in (2712,2715,2718,2721,2724,2795,2732,2735,2738,2741,2744,2778)  or
                 (a.business_flag in(2779,2769) and exists
                (select compact_id
                 from kods.rzrq_hs_his_compact
                 where compact_type in('0','2') 
                   and compact_id = substr(a.remark, 6, 23))))
             and init_date <= (select MAX(init_date)
                        from  kods.a_hs08_exchangedate t
                        where  t.init_date  < =v_bbq_enddate)) a1,
      (select nvl(sum(fin_close_interest + fare_close_interest +other_close_interest),0) occur_balance
        from kods.rzrq_hs_his_hisassetdebit 
       where init_date = (select max(init_date)
                          from kods.rzrq_hs_his_hisassetdebit
                          where init_date <= v_bbq_enddate)) c,
      (select nvl(sum(fin_close_interest + fare_close_interest +other_close_interest),0) occur_balance
        from kods.rzrq_hs_his_hisassetdebit
       where init_date = (select MAX(init_date)
                        from  kods.a_hs08_exchangedate t
                        where  t.init_date  < = v_bbq_begindate)) d;
  */

  --38        ȯҵ  

insert into T_ETL_RZRQ_C10
  (Xm, Je)
select 38,
       nvl(a.occur_balance, 0) + nvl(c.occur_balance, 0) -
       nvl(d.occur_balance, 0) - nvl(a1.occur_balance, 0) as occur_balance
  from (select nvl(sum(abs(occur_balance)), 0) occur_balance
          from (select occur_balance occur_balance, init_date
                  from kods.rzrq_hs_his_hisfundjour a
                 where business_flag in (2701, 2794)
                union all
                select occur_balance, init_date
                  from kods.rzrq_hs_his_hisfundjour a
                 where a.business_flag = 2779
                   and exists
                 (select compact_id
                          from kods.rzrq_hs_his_compact
                         where compact_type = 1
                         and  substr(a.remark,6,23) = compact_id))
         where init_date <= v_bbq_enddate) a,
       (select nvl(sum(abs(occur_balance)), 0) occur_balance
          from (select occur_balance, init_date
                  from kods.rzrq_hs_his_hisfundjour a
                 where business_flag in (2701, 2794)
                union all
                select occur_balance, init_date
                  from kods.rzrq_hs_his_hisfundjour a
                 where a.business_flag = 2779
                   and exists
                 (select compact_id
                          from kods.rzrq_hs_his_compact
                         where compact_type = '1'
                            and  substr(a.remark,6,23) = compact_id))
         where init_date =
               (select MAX(init_date)
                  from kods.rzrq_hs_his_hisfundjour t
                 where t.init_date < = v_bbq_enddate)) a1,
       (select nvl(sum(slo_close_interest), 0) occur_balance
          from kods.rzrq_hs_his_hisassetdebit
         where init_date = (select max(init_date)
                              from kods.rzrq_hs_his_hisassetdebit
                             where init_date <= v_bbq_enddate)) c,
       (select nvl(sum(slo_close_interest), 0) occur_balance
          from kods.rzrq_hs_his_hisassetdebit
         where init_date =
               (select MAX(init_date)
                  from kods.a_hs08_exchangedate t
                 where t.init_date < = v_bbq_enddate)) d;
commit;
  --36 ȯҵ

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 36, nvl(sum(abs(t.periodcrbalance)), 0)
      from t_etl_biz_data t
     where t.reportid = 'C10-1'
       and t.proid = 1
       and t.currency = 3;
  commit;
  insert into t_etl_rzrq_c10
    (xm, je)
    select 37, sum(decode(xm, 36, je, -je))
      from t_etl_rzrq_c10 t
     where t.xm in (36, 38);
  commit;

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 40, round(nvl(a.rate, 0), 4)
      from (select case
                     when sum(nvl(a.compact_balance, 0)) <> 0 then
                      round(sum(nvl(a.compact_balance, 0) *
                                nvl(a.year_rate, 0)) /
                            sum(nvl(a.compact_balance, 0)) / 360 * 1000,
                            6)
                     else
                      round(avg(nvl(a.year_rate, 0)) / 360 * 1000, 6)
                   end rate
              from kods.rzrq_hs_his_compact a
             where init_date >= v_bbq_begindate
               and init_date <= v_bbq_enddate
               and compact_type = '0'
               and compact_status <> '3'
               and nvl(a.compact_balance, 0) <> 0) a;

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 41, nvl(a.rate, 0)
      from (select case
                     when sum(nvl(a.compact_balance, 0)) <> 0 then
                      round(sum(nvl(a.compact_balance, 0) *
                                nvl(a.year_rate, 0)) /
                            sum(nvl(a.compact_balance, 0)) / 360 * 1000,
                            6)
                     else
                      round(avg(nvl(a.year_rate, 0)) / 360 * 1000, 6)
                   end rate
              from kods.rzrq_hs_his_compact a
             where init_date >= v_bbq_begindate
               and init_date <= v_bbq_enddate
               and compact_type = '1'
               and compact_status <> '3'
               and nvl(a.compact_balance, 0) <> 0) a;
  /*************   ע    ***********/
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 42, business_balance --+ c.occur_balance
      from (select nvl(sum(abs(b.business_balance)), 0) as business_balance /*,
                           nvl(sum(b.fare0), 0) as total_income*/
              from kods.rzrq_hs_his_businesstotal b
             where b.init_date >= v_bbq_begindate
               and b.init_date <= v_bbq_enddate
               and b.asset_prop = '7'
               and b.business_flag in (4701, 4702, 4703, 4704, 4705, 4706));

  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 43,
           nvl(a.occur_balance, 0) /*+ nvl(c.occur_balance, 0)*/ as occur_balance
      from (select nvl(sum(FARE0 - EXCHANGE_FARE0 + FARE3 + FAREX -
                           EXCHANGE_FARE3 - EXCHANGE_FARE4 - EXCHANGE_FARE5 -
                           EXCHANGE_FARE6 - EXCHANGE_FAREX),
                       0) occur_balance
              from kods.rzrq_hs_his_hisdeliver a
            --4211  ,4212  
            -- 4213  ȯ,4214  ȯ,
            --4215  ƽ,4216  ƽ
             where business_flag in (4701, 4702, 4703, 4704, 4705, 4706)
               and init_date between v_bbq_begindate and v_bbq_enddate
               and branch_no not in ('7777')) a;
  commit;
  --44 ȯͻ֤ȯ׵ƽӶ()
  insert into T_ETL_RZRQ_C10
    (Xm, Je)
    select 44 as id,
           round(COALESCE(nvl(a.sxf, 1) / nvl(b.jsr, 0), 0) * 1000, 4)
      from (select b.je as sxf from T_ETL_RZRQ_C10 b where b.xm in ('43')) a,
           (select b.je as jsr from T_ETL_RZRQ_C10 b where b.xm in ('42')) b;
  commit;
  cisp_etl_rzrq_c10_1;
  commit;

  -- E1-7-1
  -- add by hucc 20120517
  --һĩȯߵǰ10ͻϸ

  delete from t_B40_A001;
  commit;
  insert into t_B40_A001
    (P001, A002, A003, A004, A005, A006, A100, W100)
    select b.client_name,
           a.total_balance,
           a.fin_close_balance,
           a.slo_close_balance,
           a.assure_close_balance,
           case
             when a.close_rate * 100 = 9999999999999 then
              -1
             else
              close_rate * 100
           end close_rate,
           '100000',
           v_bmid
      from (select rownum id,
                   client_id,
                   total_balance,
                   fin_close_balance,
                   slo_close_balance,
                   assure_close_balance,
                   close_rate
              from (select fund_account,
                           client_id,
                           fin_close_balance,
                           slo_close_balance,
                           fin_close_balance + slo_close_balance as total_balance,
                           assure_close_balance,
                           close_rate
                      from kods.RZRQ_HS_HIS_HISASSETDEBIT a
                     where init_date =
                           (select max(init_date)
                              from kods.RZRQ_HS_HIS_HISASSETDEBIT
                             where init_date <= v_bbq_enddate)
                       and close_rate <> '99999999999.99'
                       and branch_no not in ('7777')
                     order by fin_close_balance + slo_close_balance desc) a
             where rownum <= 10) a,
           kods.RZRQ_HS_CLIENT b
     where a.client_id = b.client_id
     order by a.id;
  commit;

  --ĩάֵ͵10ͻϸάֵĿͻϸͳƣ
  delete from t_B40_A002;
  commit;
  insert into t_B40_A002
    (P001, A002, A003, A004, A005, A006, A100, W100)
    select b.client_name,
           total_balance,
           fin_close_balance,
           slo_close_balance,
           assure_close_balance,
           close_rate,
           '100000',
           v_bmid
      from (select rownum id,
                   client_id,
                   total_balance,
                   fin_close_balance,
                   slo_close_balance,
                   assure_close_balance,
                   case
                     when close_rate * 100 = 9999999999999 then
                      -1
                     else
                      close_rate * 100
                   end close_rate
              from (select fund_account,
                           client_id,
                           fin_close_balance,
                           slo_close_balance,
                           fin_close_balance + slo_close_balance as total_balance,
                           assure_close_balance,
                           close_rate
                      from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                             where init_date <= v_bbq_enddate)
                       and close_rate >= 1.3
                       and close_rate <> '99999999999.99'
                       and branch_no not in ('7777')
                     order by close_rate asc) a
             where rownum <= 10) a,
           KODS.RZRQ_HS_CLIENT b
     where a.client_id = b.client_id
     order by to_number(id);
  commit;

  --ġĩ֤ȯֵǰ10֤ȯ
  delete from t_B40_A003;
  commit;
  insert into t_B40_A003
    (P001, A002, A003, A004, A005, A100, W100)
    select stock_name,
           stock_code,
           capital_amount,
           compact_amount,
           business_balance,
           '100000',
           v_bmid
      from (select stock_name,
       stock_code,
       capital_amount,
       compact_amount,
       business_balance
  from (select a.stock_name,
               a.stock_code,
               nvl(c.capital_amount, 0) as capital_amount,
               nvl(a.compact_amount, 0) as compact_amount,
               nvl(a.compact_amount, 0) * nvl(b.asset_price, 0) as business_balance
          from (select stock_code,
                       stock_name,
                       exchange_type,
                       sum(abs(a.compact_amount)) compact_amount
                  from KODS.RZRQ_HS_HIS_COMPACT a
                 where init_date =
                       (select max(init_date)
                          from KODS.RZRQ_HS_HIS_COMPACT a
                         where a.init_date <= v_bbq_enddate)
                   and a.compact_type = '0'
                --and a.debit_status <> '2'
                 group by stock_code, stock_name, exchange_type) a
          left join (select stock_code, exchange_type, asset_price
                      from KODS.RZRQ_HS_HIS_HISPRICE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISPRICE a
                             where a.init_date <= v_bbq_enddate)) b
            on a.stock_code = b.stock_code
           and a.exchange_type = b.exchange_type
          left join (select stock_code, exchange_type, capital_amount
                      from KODS.RZRQ_HS_HIS_HISASSURECODE
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSURECODE a
                             where a.init_date <= v_bbq_enddate)) c
            on a.stock_code = c.stock_code
           and a.exchange_type = c.exchange_type) a
 order by business_balance desc --159937
 ) a
     where rownum <= 10;
  commit;
  --塢ĩȯ֤ȯֵǰ10֤ȯ
  delete from t_B40_A004;
  commit;
  insert into t_B40_A004
    (P001, A002, A003, A004, A005, A100, W100)
    select stock_name,
           stock_code,
           capital_amount,
           compact_amount,
           business_balance,
           '100000',
           v_bmid
      from (select stock_name,
                   stock_code,
                   capital_amount,
                   compact_amount,
                   business_balance
              from (select a.stock_name,
                           a.stock_code,
                           nvl(c.capital_amount, 0) as capital_amount,
                           nvl(a.compact_amount, 0) as compact_amount,
                           nvl(a.compact_amount, 0) * nvl(b.asset_price, 0) as business_balance
                      from (select stock_code,
                                   stock_name,
                                   sum(abs(a.compact_amount)) compact_amount
                              from KODS.RZRQ_HS_HIS_COMPACT a
                             where init_date =
                                   (select max(init_date)
                                      from KODS.RZRQ_HS_HIS_COMPACT a
                                     where a.init_date <= v_bbq_enddate)
                               and a.compact_type = '1'
                               and abs(a.compact_amount) <> 0
                            --and a.debit_status <> '2'
                             group by stock_code, stock_name) a
                      left join (select stock_code, asset_price
                                  from KODS.RZRQ_HS_HIS_HISPRICE
                                 where init_date =
                                       (select max(init_date)
                                          from KODS.RZRQ_HS_HIS_HISPRICE a
                                         where a.init_date <= v_bbq_enddate)) b
                        on a.stock_code = b.stock_code
                      left join (select stock_code, capital_amount
                                  from KODS.RZRQ_HS_HIS_HISASSURECODE
                                 where init_date =
                                       (select max(init_date)
                                          from KODS.RZRQ_HS_HIS_HISASSURECODE a
                                         where a.init_date <= v_bbq_enddate)) c
                        on a.stock_code = c.stock_code) a
             order by business_balance desc) a
     where rownum <= 10;
  commit;
  --ĩֵǰ10֤ȯ

  delete from t_B40_A005;
  commit;
  insert into t_B40_A005
    (P001, A002, A003, A004, A100, W100)
    select stock_name, stock_code, balance, rate, '100000', v_bmid
      from (select rownum pm, stock_name, stock_code, balance, rate
              from (select stock_name,
                           stock_code,
                           round(balance, 2) balance,
                           round(balance * 100 /
                                 (select sum(assure_close_balance)
                                    from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                                   where init_date =
                                         (select max(init_date)
                                            from KODS.RZRQ_HS_HIS_HISASSETDEBIT a
                                           where a.init_date <= v_bbq_enddate)),
                                 4) as rate
                      from (select a.stock_code,
                                   d.stock_name,
                                   a.current_amount * nvl(c.asset_price, 0) as balance
                              from (select stock_code,
                                           stock_type,
                                           EXCHANGE_TYPE,
                                           sum(current_amount) current_amount
                                      from KODS.RZRQ_HS_STOCK            a,
                                           kods.rzrq_hs_fund_fundaccount b
                                     where a.fund_account = b.fund_account
                                       and exists
                                     (select *
                                              from KODS.RZRQ_HS_HIS_HISASSURECODE c
                                             where a.stock_code = c.stock_code)
                                       and a.branch_no not in ('7777')
                                       and b.asset_prop = '7'
                                     group by stock_code,
                                              stock_type,
                                              EXCHANGE_TYPE) a,
                                   (select stock_code,
                                           EXCHANGE_TYPE,
                                           asset_price
                                      from KODS.RZRQ_HS_HIS_HISPRICE t
                                     where init_date =
                                           (select max(init_date)
                                              from KODS.RZRQ_HS_HIS_HISPRICE
                                             where init_date <= v_bbq_enddate)
                                    /*and t.exchange_type='2'*/
                                    ) c,
                                   (select stock_code, stock_name, stock_type
                                      from KODS.rzrq_hs_stkcode) d
                             where a.stock_code = c.stock_code
                               and a.EXCHANGE_TYPE = c.EXCHANGE_TYPE
                               and a.stock_code = d.stock_code
                               and a.stock_type = d.stock_type) a
                     order by balance desc) a
             where rownum <= 10) t;
  commit;
  --ߡ10ǿƽֽϸ

  delete from t_B40_A006;
  commit;
  insert into t_B40_A006
    (P001, A002, A003, A004, A100, W100)
    select client_name,
           to_date(init_date, 'yyyy-mm-dd'),
           business_balance,
           0,
           '100000',
           v_bmid
      from (select rownum pm,
                   fund_account,
                   client_id,
                   client_name,
                   init_date,
                   business_balance,
                   0
              from (select fund_account,
                           client_id,
                           client_name,
                           init_date,
                           abs(business_balance) as business_balance
                      from kods.Rzrq_Hs_His_Hisdeliver T
                     where init_date between v_bbq_begindate and
                           v_bbq_enddate
                       and business_flag in (4705, 4706, 4727, 4728) --4215ƽ,4216ƽ
                     order by business_balance desc) a)
                     where pm<=10;
  commit;
  -- E1_7_3 ȯҵϸܱ

  --ĩάֵͻϸ

  delete from t_B50_A001;
  commit;
  insert into t_B50_A001
    (P001, A002, A003, A004, a005, A006, A100, W100)
    select b.client_name,
           total_balance,
           fin_close_balance,
           slo_close_balance,
           assure_close_balance,
           close_rate,
           '100000',
           v_bmid
      from (select rownum id,
                   client_id,
                   total_balance,
                   fin_close_balance,
                   slo_close_balance,
                   assure_close_balance,
                   case
                     when close_rate * 100 = 9999999999999 then
                      -1
                     else
                      close_rate * 100
                   end close_rate
              from (select fund_account,
                           client_id,
                           fin_close_balance,
                           slo_close_balance,
                           fin_close_balance + slo_close_balance as total_balance,
                           assure_close_balance,
                           close_rate
                      from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                     where init_date =
                           (select max(init_date)
                              from KODS.RZRQ_HS_HIS_HISASSETDEBIT
                             where init_date <= v_bbq_enddate)
                       and close_rate < 1.3 --άֵ1.3
                       and close_rate <> -1.00
                       and branch_no not in ('7777')
                     order by close_rate asc) a) a,
           KODS.RZRQ_HS_CLIENT b
     where a.client_id = b.client_id
     order by to_number(id);
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_YHJSCYZ_C8_1
prompt ========================================
prompt
create or replace procedure cisp_map_yhjscyz_c8_1 is
  v_bbq_begindate int;
  v_bbq_enddate   int;

begin

  select to_number(to_char(a005, 'YYYYMMDD')),
         to_number(to_char(a006, 'YYYYMMDD'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where c001 = 1001101
     and d100 = 1006002
     and a002 = 1013001;

  --Ӳȡ
  cisp_process_cwdata_unfi('C8-1', 't_etl_yhjscyz', '0', '1');
  -- мг
  delete from t_etl_yhjscyz;
  commit;
  insert into t_etl_yhjscyz
    (xm, bqzj, bqjs)
    select m.proid,
           decode(m.proid,4,sum(m.perioddrbalance),14,sum(m.perioddrbalance),9,sum(m.perioddrbalance),10,sum(m.perioddrbalance),11,sum(m.perioddrbalance),sum(m.periodcrbalance)),
           decode(m.proid,4,sum(m.periodcrbalance),14,sum(m.periodcrbalance),9,sum(m.periodcrbalance),10,sum(m.periodcrbalance),11,sum(m.periodcrbalance),sum(m.perioddrbalance))
      from t_etl_biz_data m
     where m.reportid = 'C8-1'
     group by m.proid;
  commit;

  --ͬҵ
  insert into t_etl_yhjscyz
    (xm, bqzj, bqjs)
    select 1, nvl(sum(m.bqzj),0), nvl(sum(m.bqjs),0)
      from t_etl_yhjscyz m
     where  m.xm in (2, 3);
  commit;

  /*--ծȯع
  insert into t_etl_yhjscyz
    (xm, bqzj, bqjs)
    select 6, nvl(sum(m.bqzj),0), nvl(sum(m.bqjs),0)
      from t_etl_yhjscyz m
     where m.xm in (7, 8);
  commit;

  --ծȯع
  insert into t_etl_yhjscyz
    (xm, bqzj, bqjs)
    select 9, nvl(sum(m.bqzj),0), nvl(sum(m.bqjs),0)
      from t_etl_yhjscyz m
     where m.xm in (10, 11);
  commit;*/

  --ծȯع
  insert into t_etl_yhjscyz
    (xm, bqzj, bqjs)
    select 5, nvl(sum(m.bqzj),0), nvl(sum(m.bqjs),0)
      from t_etl_yhjscyz m
     where  m.xm in (6, 9);
  commit;


  cisp_etl_yhjscyz_c8_1;
exception
  when others then
    rollback;
end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A2_1_20200331
prompt =============================================
prompt
create or replace procedure cisp_map_yyb_a2_1_20200331 is
  /********************************************************************
  *ܣɴԴݵETLݱݻܹ̣A2-1ͻʲ״
  *  
  *********************************************************************/
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin
  --ȡڵڼʱ
  select to_char(t.A005, 'yyyymmdd')
    into v_begindate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.A006, 'yyyymmdd')
    into v_enddate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;

  delete from t_etl_yyb_khjyjszj;
  commit;
  cisp_process_cwdata_unfi('B-A2-1', 't_etl_yyb_khjyjszj', '1', '0');
  commit;

  insert into t_etl_yyb_khjyjszj
    select t1.p001, t.proid, t.endbalance
      from t_etl_biz_data t, krcs.t_ctl_t036 t1
     where t.reportid = 'B-A2-1'
       and t.company = t1.a023
       and t.currency = 0;
  commit;

  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je)
  /* --ڲ-С˻
   select a.branch_no,3 jylx,sum(b.current_balance)
     from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
  where c.client_id = a.client_id
    and a.fund_account = b.fund_account
    and b.money_type = '0'
    and c.risk_info like '%6%'
  group by a.branch_no
  union all*/
    select a.branch_no, 5 jylx, sum(b.current_balance)
      from kods.rzrq_hs_fund_fundaccount a,
           kods.rzrq_hs_fund_fund        b,
           kods.a_hs08_clientinfo        c
     where c.client_id = a.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%2%'
     group by a.branch_no;
  commit;
  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je) --ϸ
    select to_number(trim(b.branch_no)) yyb,
           6 jylx,
           sum(b.current_balance) je
      from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b
     where a.client_id = b.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
          --and a.client_group='902'
       and a.asset_prop in ('0') --ֻȡ̨
       and exists
     (select 1
              from kods.rzrq_hs_stockholder d, kods.rzrq_hs_nonstdholder e
             where d.stock_account = e.stock_account
               and d.fund_account = b.fund_account
               and d.client_id = b.client_id)
     group by b.branch_no;
  commit;
  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je) --ָй֤ȯֵȥ߹ܶ
    select yyb, 9 zqlx, sum(zqsz)
      from (select t1.branch_no as yyb,
                   9 zqlx,
                   sum((t1.current_amount + abs(t1.correct_amount)) *
                       b.asset_price) zqsz
              from kods.rzrq_hs_stock t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('0',
                                     'c',
                                     '6',
                                     'L',
                                     'T',
                                     'j',
                                     'l',
                                     '9',
                                     'X',
                                     'Y',
                                     'U',
                                     'u',
                                     'a',
                                     'Z',
                                     'e') --e ƴ
               and t3.fundacct_status != '3'
               and t1.exchange_type in ('1', '2')
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.client_id = t3.client_id
               and t1.money_type = '0'
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code = t1.stock_code
             group by t1.branch_no
            union all
            select a.branch_no as yyb,
                   9 zqlx,
                   -sum(greatest(nvl(b.current_amount, 0) -
                                 nvl(a.available_amount, 0),
                                 0) * c.asset_price) as zqsz --
              from kods.A_HS08_EXTSTOCKREAL a,
                   kods.rzrq_hs_stockreal b,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) c
             where a.client_id = b.client_id
               and a.stock_code = b.stock_code
               and a.exchange_type = b.exchange_type
               and trim(c.stock_code) = trim(a.stock_code)
               and b.stock_flag = '1'
             group by a.branch_no
            
            union all --۹ͨ
            select t1.branch_no,
                   9 zqlx,
                   sum((t1.current_amount + t1.correct_amount) *
                       b.asset_price) zqsz
              from kods.rzrq_hs_stock t1,
                   kods.rzrq_hs_fund_fundaccount t3,
                   (select *
                      from kods.rzrq_hs_his_hisprice
                     where init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('0')
               and t3.fundacct_status != '3'
               and t1.exchange_type in ('G', 'S')
               and t1.exchange_type = b.exchange_type
               and t1.branch_no = t3.branch_no
               and t1.client_id = t3.client_id
               and t1.money_type = '0'
               and t1.fund_account = t3.fund_account
               and t1.branch_no not in
                   (select p001
                      from krcs.t_ctl_t036 t
                     where t.a006 in (1004002))
                  --and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004014,1004001,1004005,1004008))--һЩӪҵ
               and b.stock_code = t1.stock_code
             group by t1.branch_no
            union all
            select s.yyb, 9 as zqlx, sum(s.je) as zqsz --϶ʽ
              from (select sum(abs(t.occur_balance)) je, t.branch_no yyb
                      from /*a_hs_contstk*/ kods.rzrq_hs_his_hisfundjour t
                     where t.business_flag in ('44170')
                       and t.init_date =
                           (select max(init_date)
                              from kods.rzrq_hs_his_hisfundjour
                             where init_date <= v_enddate)
                     group by t.branch_no) s
             group by yyb)
     group by yyb;
  commit;

  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je)
  --ָй֤ͨȯֵ
    select to_number(yyb), 10, sum(zqsz)
      from (select trim(t.open_brh) as yyb, 10 as jylx, sum(t.zqsz) as zqsz
              from ( /*select b.branch_no as open_brh,
                                               sum((a.yest_sec_bal + a.settle_sec_net +
                                                   a.post_sec_net) * c.asset_price) as zqsz
                                          from (select m.inv_acc,m.sec_code,m.yest_sec_bal,m.settle_sec_net,m.post_sec_net
                                                  from kods.xy60_inv_sec_balance m,
                                                       kods.xy60_sys_sec_custody n
                                                 where m.mkt_code = '01'
                                                   and n.mkt_code = '01'
                                                   and n.sec_class = 'XL'
                                                   and trim(m.sec_id) = trim(n.sec_id)) a,
                                               kods.rzrq_hs_stockholder b,
                                               (select stock_code,asset_price
                                                  from kods.rzrq_hs_his_hisprice
                                                 where init_date =
                                                       (select max(init_date) from kods.rzrq_hs_his_hisprice)) c
                                         where trim(c.stock_code) = trim(a.sec_code)
                                           and trim(a.inv_acc) = trim(b.stock_account)
                                           and b.exchange_type = '1'
                                         group by b.branch_no*/
                    select b.branch_no as open_brh,
                            sum((m.yest_sec_bal + m.settle_sec_net +
                                m.post_sec_net) * c.asset_price) as zqsz
                      from kods.xy60_inv_sec_balance m,
                            kods.xy60_sys_sec_custody n,
                            kods.rzrq_hs_stockholder b,
                            (select stock_code, asset_price
                               from kods.rzrq_hs_his_hisprice
                              where init_date =
                                    (select max(init_date)
                                       from kods.rzrq_hs_his_hisprice)) c
                     where m.sec_id = n.sec_id
                       and m.inv_acc = b.stock_account
                       and m.mkt_code = '01'
                       and n.mkt_code = '01'
                       and n.sec_class = 'XL'
                       and trim(c.stock_code) = trim(m.sec_code)
                       and trim(m.inv_acc) = trim(b.stock_account)
                       and b.exchange_type = '1'
                     group by b.branch_no
                    union all
                    select b.branch_no as open_brh,
                            sum(nvl(a.stock_mkt, 0)) as zqsz
                      from kods.xy60_sec_vou_limited_sale /*xy60_SA_SJSFW_CL*/ a,
                            kods.rzrq_hs_stockholder       b
                     where trim(b.stock_account) = trim(a.inv_acc)
                       and a.mkt_code = '02' --A
                       and b.exchange_type = '2'
                    --and a.Seat_Code='054900'
                     group by b.branch_no
                    union all --
                    select b.branch_no as open_brh,
                            sum(nvl(a.stock_mkt, 0)) as zqsz
                      from kods.xy60_sec_vou_limited_sale /*xy60_SA_SJSFW_CL*/ a,
                            kods.rzrq_hs_stockholder       b
                     where trim(b.stock_account) = trim(a.inv_acc)
                       and a.mkt_code = '13' --
                       and b.exchange_type = '2'
                     group by b.branch_no
                    union all
                    select a.branch_no as open_brh,
                            sum(greatest(nvl(b.current_amount, 0) -
                                         nvl(a.available_amount, 0),
                                         0) * c.asset_price) as zqsz --
                      from kods.A_HS08_EXTSTOCKREAL a,
                            kods.rzrq_hs_stockreal b,
                            (select *
                               from kods.rzrq_hs_his_hisprice
                              where init_date =
                                    (select max(init_date)
                                       from kods.rzrq_hs_his_hisprice)) c
                     where a.client_id = b.client_id
                       and a.stock_code = b.stock_code
                       and a.exchange_type = b.exchange_type
                       and trim(c.stock_code) = trim(a.stock_code)
                       and b.stock_flag = '1'
                     group by a.branch_no) t
             group by t.open_brh)
     group by yyb;
  commit;

  insert into t_etl_yyb_khjyjszj
    (yyb, jylx, je)
  --ɷתϵͳ֤ȯֵ
    select a.branch_no,
           11,
           sum((a.current_amount + abs(a.correct_amount)) * asset_price) as gpsz
      from kods.rzrq_hs_stock a,
           kods.rzrq_hs_fund_fundaccount c,
           (select *
              from kods.rzrq_hs_his_hisprice
             where init_date =
                   (select max(init_date) from kods.rzrq_hs_his_hisprice)) b
     where a.exchange_type = b.exchange_type
       and a.fund_account = c.fund_account
       and c.asset_prop = '0'
       and a.stock_code = b.stock_code
       and a.money_type = 0
       and a.stock_type in ('0', 'z')
       and a.exchange_type in ('9', 'A')
     group by a.branch_no
    
    union all
    
    --̨ͻ׽ʽ
    select s.branch_no, 14, sum(s.current_balance)
      from kods.rzrq_hs_fund_fund        s,
           kods.rzrq_hs_client           a,
           kods.rzrq_hs_fund_fundaccount b
     where s.fund_account = b.fund_account
       and b.asset_prop = '0'
       and s.money_type = 0
       and a.organ_flag in ('1', '0', '3')
       and a.client_id = s.client_id
       and a.client_status != '3'
     group by s.branch_no
    
    union all
    
    --Уĩϡ깺ʽ
    
    /*  select s.yyb, 13 as jylx,  sum(s.je) as je
     from (select sum(t.BUSINESS_AMOUNT * t.BUSINESS_PRICE) je,
                  t.branch_no yyb
             from \*a_hs_contstk*\ kods.A_HS08_SETTUNFINISHED t
            where trim(t.stock_type) in
                  ('4', '7', 'J', 'K', 'M', 'N', 'P', 'G')
              and t.unfinished_type='7'
            group by t.branch_no) s
    group by yyb;*/
    select s.yyb, 13 as jylx, sum(s.je) as je
      from (select sum(abs(t.occur_balance)) je, t.branch_no yyb
              from /*a_hs_contstk*/ kods.rzrq_hs_his_hisfundjour t
             where t.business_flag in ('44170')
               and t.init_date =
                   (select max(init_date)
                      from kods.rzrq_hs_his_hisfundjour
                     where init_date <= v_enddate)
             group by t.branch_no) s
     group by yyb;

  ----select * from a_hs_sysdictionary d where d.dict_entry='1206' :˵ҵֶ
  commit;
  update t_etl_yyb_khjyjszj t --ڲ-=23110102+231102-С-ϸ
     set t.je =
         (select sum(decode(jylx, 3, je, 5, -je, 6, -je))
            from t_etl_yyb_khjyjszj
           where yyb = t.yyb)
   where t.jylx = 3;
  commit;
  ------------------------------------------------------------------------------------------------------------------------------------------
  --ͻʽֲ
  ------------------------------------------------------------------------------------------------------------------------------------------

  delete from t_etl_yyb_khzjfb;
  insert into t_etl_yyb_khzjfb
    (yyb, yhdm, yhmc, khsl, zjye)
    select to_char(a.branch_no), a.bank_no, b.a003, a.sl, a.ye
      from (select t1.branch_no,
                   coalesce(t3.bank_no, '9999') bank_no,
                   count(*) sl,
                   sum(t1.current_balance) ye
              from kods.rzrq_hs_fund_fund        t1,
                   kods.rzrq_hs_fund_fundaccount t2,
                   kods.rzrq_hs_bankarg          t3
             where t1.bank_no = t3.bank_no
               and t1.fund_account = t2.fund_account
               and t3.bank_type = '2'
               and t1.money_type = '0'
               and t2.fundacct_status <> '3'
               and t2.asset_prop = '0'
               and t2.open_date <= v_enddate
             group by t1.branch_no, coalesce(t3.bank_no, '9999')) a,
           (select p002, a003 from t_bks_t031 where p001 = 101) b
     where a.bank_no = b.p002;
  commit;

  cisp_etl_yyb_khjyjszj;
  cisp_etl_yyb_khzjfb;
  commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A3_1_20190506
prompt =============================================
prompt
create or replace procedure cisp_map_yyb_a3_1_20190506 is
  /********************************************************************
  *ܣӪҵʻԴETL
  *ʱ䣺2015-09-08
  *
  *********************************************************************/

  v_begindate varchar2(8);
  v_enddate   varchar2(8);


begin

  --ȡڵڼʱ
 /* select to_char(t.p001) || '01'
    into v_begindate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.p001) || '31'
    into v_enddate
    from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;*/
     select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

   --˻
  delete from t_etl_yyb_zjzh;
  commit;
  --ͳʽ˻
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 1 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;

--ʽ˻Ͽ
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 12 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             --and a.open_type = '2'
             and a.op_entrust_way = '7'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;
--ʽ˻֤
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 13 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('0')
             --and a.open_type = '1'
             and a.op_entrust_way = 'O'
             group by a.branch_no;
  commit;

--ͳʽ˻ĩ
  insert into t_etl_yyb_zjzh
   select a.branch_no as yyb, decode(b.organ_flag,'1',1,'3',1,0) as khlx , 3 jylx ,9 as bz,
  count(distinct a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,kods.rzrq_hs_client b,kods.rzrq_hs_fund_fund c
             where   a.client_id=b.client_id
             and a.client_id = c.client_id
             and a.branch_no=b.branch_no
             and a.fundacct_status<>'3'
             --and c.money_type = '0'
             and a.open_date < = v_enddate
             and b.organ_flag in ('1','0','3')
             and a.asset_prop in ('0'/*,'7'*/)
             group by a.branch_no,decode(b.organ_flag,'1',1,'3',1,0) ;
  commit;

  delete from t_etl_yyb_zqzh;
  commit;

   --ͳ֤ȯ˻
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1,'3',1, 0) as khlx,
           1 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.init_date  between  v_begindate  and  v_enddate
               and a.business_flag in ('1104','1101')
               and a.exchange_type in ('1','2','D','H')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3',1, 0),t.bz;
  commit;


     --ͳ֤ȯ˻Ͽ
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1,'3',1, 0) as khlx,
           12 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.Init_Date  between  v_begindate  and  v_enddate
               and a.exchange_type in ('1','2','D','H')
               and a.business_flag in ('1104','1101')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.open_type = '2') t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3',1, 0),t.bz;
     commit;

     --ͳ֤ȯ˻Ӽ֤
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1,'3',1, 0) as khlx,
           13 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.init_date  between  v_begindate  and  v_enddate
               and a.business_flag in ('1104','1101')
               and a.exchange_type in ('1','2','D','H')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.open_type = '1') t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3',1, 0),t.bz;




   --ͳ֤ȯ˻ĩ
  insert into t_etl_yyb_zqzh
   select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' , 1 , 0) as khlx,
           3 as jylx,
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and (a.exchange_type in ('1','2') and b.fundacct_status<>'3'
               -- or a.exchange_type in ('D','H') and b.fundacct_status='0')
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and b.open_date < =v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 , 0),t.bz;
     commit;

 --ͳƻʻ
 delete t_etl_yyb_jjzh ;
 commit;
 insert into t_etl_yyb_jjzh
    select yyb,0,1,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' or substr(a.stock_account,1,3)='001' 
               or a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;


    --ͳƻʻϿ
  insert into t_etl_yyb_jjzh
    select yyb,0,12,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               OR substr(a.stock_account,1,3)='001' 
               OR a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.open_type = '2'
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and  a.op_entrust_way in ('7','8')
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;

     --ͳƻʻ֤
  insert into t_etl_yyb_jjzh
    select yyb,0,13,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               or substr(a.stock_account,1,3)='001' 
               or a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.open_type = '1'
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and a.prodta_no  in ('98','99')
               and a.op_entrust_way='4'
               )t
     group by t.yyb) group by yyb;
     commit;

--ͳƻʻĩ
 insert into t_etl_yyb_jjzh
   select yyb,khlx,3,sum(sl) from
      (select t.yyb yyb, decode(t.organ_flag, '1', 1 , '3' , 1, 0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.stock_account like 'F%' 
               --and substr(a.stock_account,1,3)='001' 
               --and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0','7')
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1, '3', 1, 0)
      union all
      select t.yyb yyb, decode(t.organ_flag, '1', 1 , '3' , 1, 0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and a.stock_account like 'F%' 
               and substr(a.stock_account,1,3)='001' 
               --and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1, '3' , 1 , 0)
      union all
      select t.yyb yyb, decode(t.organ_flag, '1', 1, '3',1, 0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and a.stock_account like 'F%' 
               --and substr(a.stock_account,1,3)='001' 
               and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3' , 1 , 0)
      union all
     select t.yyb yyb,decode(t.organ_flag, '1', 1 , '3' , 1, 0) as khlx,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,c.organ_flag,
                   /*a.stock_account*/a.secum_account
              from /*kods.a_hs08_ofstockholder*/kods.a_hs_secumholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c  ---˱ֻ98 99ͷ
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and c.organ_flag in ('1','0','3')
               and a.prodta_no in ('98','99')
               and b.open_date < =v_enddate
               )t
     group by t.yyb,decode(t.organ_flag, '1', 1, '3', 1 , 0)) group by yyb,khlx;
     commit;

----------------------------------------------------------------------------------------------
  --˻淶
----------------------------------------------------------------------------------------------

  delete from t_etl_yyb_zhgf_zjzh;
  commit;

 --RMB˻ʽ˻
  insert into t_etl_yyb_zhgf_zjzh
    select s.branch_no,55 jylx,count(s.fund_account),sum(a.current_balance)
        from kods.RZRQ_hs_FUND_fundaccount s, kods.Rzrq_Hs_Fund_Fund a,kods.RZRQ_HS_CLIENT B
        where a.money_type='0' and a.fund_account=s.fund_account
         and a.client_id=s.client_id
         AND S.CLIENT_ID = B.CLIENT_ID
         AND A.CLIENT_ID = B.CLIENT_ID
         and B.organ_flag in ('1','0','3')
         AND S.ASSET_PROP in ('0'/*,'7'*/)
         and s.fundacct_status<>'3'
        group by s.branch_no   
 union all --˻ʽ˻
 select t1.branch_no,1 jylx,count(t2.fund_account)sl,sum(t1.current_balance)  je
          from kods.rzrq_hs_fund_fund t1 , kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_bankarg t3
          where t1.bank_no = t3.bank_no
            and t1.fund_account = t2.fund_account
            and t3.bank_type in ('2','4')
            and t1.money_type = '0'
            and t2.fundacct_status <> '3'
            and t2.asset_prop in ('0'/*,'7'*/)
            and t2.main_flag = '1'
            and t2.open_date<=v_enddate
          group by t1.branch_no      

  --ϸ˻ʽ˻
 union all
   select a.branch_no,2 jylx,count(a.fund_account),sum(b.current_balance)
         from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b
     where a.client_id = b.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
      -- and a.client_group='902'
       and a.ASSET_PROP in ('0'/*,'7'*/)
       and exists (select 1
              from kods.rzrq_hs_stockholder d,kods.rzrq_hs_nonstdholder e
              where d.stock_account = e.stock_account
              and d.fund_account = b.fund_account
              and d.client_id = b.client_id)
     group by a.branch_no

  union all
  --С˻ʽ˻
 select a.branch_no,3 jylx,count(a.fund_account),sum(b.current_balance)
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
     where c.client_id = a.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%2%'
     group by a.branch_no

 /*union all
  --˻ʽ˻
       select a.branch_no,4 jylx,count(a.fund_account),sum(b.current_balance)
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
     where c.client_id = a.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%6%'
     group by a.branch_no*/
 union all
  --ʽ˻
   select s.branch_no,5 jylx,count(distinct a.fund_account),sum(a.current_balance)
        from kods.RZRQ_hs_FUND_fundaccount s, kods.RZRQ_hs_fund_FUND a,kods.rzrq_hs_bankarg c
        where a.money_type='0' 
        and a.fund_account=s.fund_account 
        and s.fundacct_status<>'3'
        and a.bank_no=c.bank_no 
        and c.bank_type in ('2','4')
        and a.client_id=s.client_id
        and s.main_flag='0'
        AND S.ASSET_PROP in ('0'/*,'7'*/)
        group by s.branch_no;
        commit;
   ---˺żʽ
  /* delete from t_etl_yyb_zhgf_zjzh where jylx=1;
   commit;*/
   --update t_etl_yyb_zhgf_zjzh t set t.zjye =(select sum(decode(jylx,55,zjye,-zjye))
    --from (select * from t_etl_yyb_zhgf_zjzh union all select * from t_etl_yyb_zhgf_zjzh_rzrq) where yyb=t.yyb)
    --where t.jylx=1; 
  /* insert into t_etl_yyb_zhgf_zjzh
    select yyb,1,sum(decode(jylx,55,sl,-sl)),sum(decode(jylx,55,zjye,-zjye))
    from (select * from t_etl_yyb_zhgf_zjzh union all select * from t_etl_yyb_zhgf_zjzh_rzrq)
    group by yyb;*/
    ---˺żʽ
   delete from t_etl_yyb_zhgf_zjzh where jylx=4;
   commit;
   insert into t_etl_yyb_zhgf_zjzh
    select yyb,4,sum(decode(jylx,55,sl,-sl)),sum(decode(jylx,55,zjye,-zjye))
    from t_etl_yyb_zhgf_zjzh
    group by yyb;
  commit; 
    
    
  commit;

--------------------------------------------------------------------------------------------------
-- ˻淶   ֤ȯֵ
---------------------------------------------------------------------------------------------------
  delete from t_etl_yyb_zhgf_zqzh;
  commit;
  --ϸ˻֤ȯ˻
    insert into t_etl_yyb_zhgf_zqzh
select yyb,2,sum(sl),sum(sz)je from
   (select c.branch_no yyb,count(distinct c.fund_account) sl,sum((c.current_amount+abs(c.correct_amount))*d.asset_price) sz
    from kods.RZRQ_hs_stock c ,kods.rzrq_hs_nonstdholder a,
        (select * from kods.RZRQ_hs_HIS_hisprice where init_date=(select max(init_date) from kods.RZRQ_hs_HIS_hisprice)) d
           where   a.exchange_type IN ('1','2')
               and c.stock_code=d.stock_code
               AND A.STOCK_ACCOUNT = C.STOCK_ACCOUNT
     group by c.branch_no) 
     group by yyb;


  commit;
  --С˻֤ȯ˻
  insert into t_etl_yyb_zhgf_zqzh
    select yyb, 3, sum(sl), 0 zqsz
      from (select a.branch_no yyb, count(distinct a.stock_account) as sl
              from kods.rzrq_hs_stockholder a
             where holder_status = 'C'
               and a.exchange_type in ('1', '2')
               and a.asset_prop = '0'
             group by a.branch_no)
     group by yyb;
  commit;

 --˻֤ȯ˻

insert into t_etl_yyb_zhgf_zqzh
select a.branch_no yyb,4,count(a.stock_account) sl, sum((b.current_amount+abs(b.correct_amount))*c.asset_price)sz
        from kods.RZRQ_hs_stockholder a,kods.rzrq_hs_stock b,
        (select * from kods.RZRQ_hs_HIS_hisprice where init_date=(select max(init_date) from kods.RZRQ_hs_HIS_hisprice))c
      where a.stock_account=b.stock_account
         and b.stock_code=c.stock_code
         and a.exchange_type IN ('1','2')
         and a.asset_prop = '0'
         and a.holder_status = '1'
        group by a.branch_no;
commit;


     delete from t_etl_yyb_zhgf_zqzh where jylx=1;
    commit;
    ---ϸ֤ȯ
   insert into  t_etl_yyb_zhgf_zqzh s
    select c.yyb,1,sum(c.sl)-nvl(sum(b.sl),0),nvl(sum(s.je)-nvl(sum(b.sz),0),0)
      from  (select yyb,sum(sl) sl,sum(zqsz) sz from t_etl_yyb_zhgf_zqzh
      where jylx in (2,3,4) group by yyb)  b right join 
      (select yyb,sum(sl) sl from (select * from t_etl_yyb_zqzh union all select * from t_etl_yyb_zqzh_rzrq)  
      where jylx=3 and bz=0 group by yyb) c on b.yyb=c.yyb left join 
     (select yyb,sum(je) je from (select yyb,je from t_etl_yyb_khjyjszj where jylx=9 
      union all 
      select yyb,je from t_etl_yyb_khjyjszj_rzrq where jylx=9)group by yyb) s
     on  c.yyb=s.yyb
     group by c.yyb;
     commit;

-----     -------------------------------------------------------------------------------------
  --˻䶯
-------------------------------------------------------------------------------------
  delete from t_etl_yyb_zhbd_zjzh;
  commit;


  cisp_etl_yyb_zjzh;
  commit;
  cisp_etl_yyb_zqzh;
  commit;
  cisp_etl_yyb_jjzh;
  commit;
  cisp_etl_yyb_zhgf_zjzh;
  commit;
  cisp_etl_yyb_zhgf_zqzh;
  commit;
  cisp_etl_yyb_zhbd_zjzh;
  commit;
  cisp_etl_yyb_zhbd_zqzh;
  commit;

end ;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A3_1_20200331
prompt =============================================
prompt
create or replace procedure cisp_map_yyb_a3_1_20200331 is
  /********************************************************************
  *ܣӪҵʻԴETL
  *ʱ䣺2015-09-08
  *
  *********************************************************************/

  v_begindate varchar2(8);
  v_enddate   varchar2(8);


begin

  --ȡڵڼʱ
     select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;

   --˻
  delete from t_etl_yyb_zjzh;
  commit;
  --ͳʽ˻
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 1 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;

--ʽ˻Ͽ
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 12 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             --and a.open_type = '2'
             and a.op_entrust_way = '7'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;
--ʽ˻֤
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 13 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('0')
             --and a.open_type = '1'
             and a.op_entrust_way = 'O'
             group by a.branch_no;
  commit;
  
  --ʽ˻
  insert into t_etl_yyb_zjzh
  select a.branch_no as yyb,0 as khlx , 22 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1002'
             and a.op_entrust_way = '7'
             and a.asset_prop in ('0')
             group by a.branch_no;
  commit;


--ͳʽ˻ĩ
  insert into t_etl_yyb_zjzh
   select a.branch_no as yyb, decode(b.organ_flag,'1',1,'3',1,0) as khlx , 3 jylx ,9 as bz,
  count(distinct a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,kods.rzrq_hs_client b,kods.rzrq_hs_fund_fund c
             where   a.client_id=b.client_id
             and a.client_id = c.client_id
             and a.branch_no=b.branch_no
             and a.fundacct_status<>'3'
             --and c.money_type = '0'
             and a.open_date < = v_enddate
             and b.organ_flag in ('1','0','3')
             and a.asset_prop in ('0'/*,'7'*/)
             group by a.branch_no,decode(b.organ_flag,'1',1,'3',1,0) ;
  commit;

  delete from t_etl_yyb_zqzh;
  commit;

   --ͳ֤ȯ˻
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1,'3',1, 0) as khlx,
           1 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.init_date  between  v_begindate  and  v_enddate
               and a.business_flag in ('1104','1101')
               and a.exchange_type in ('1','2','D','H')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3',1, 0),t.bz;
  commit;


     --ͳ֤ȯ˻Ͽ
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1,'3',1, 0) as khlx,
           12 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.Init_Date  between  v_begindate  and  v_enddate
               and a.exchange_type in ('1','2','D','H')
               and a.business_flag in ('1104','1101')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.op_entrust_way = '7') t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3',1, 0),t.bz;
     commit;

     --ͳ֤ȯ˻Ӽ֤
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1,'3',1, 0) as khlx,
           13 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.init_date  between  v_begindate  and  v_enddate
               and a.business_flag in ('1104','1101')
               and a.exchange_type in ('1','2','D','H')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.op_entrust_way ='O') t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3',1, 0),t.bz;

     --ͳ֤ȯ˻ڼ
  insert into t_etl_yyb_zqzh
     select t.yyb yyb,
           decode(t.organ_flag, '1', 1,'3',1, 0) as khlx,
           22 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.Init_Date  between  v_begindate  and  v_enddate
               and a.exchange_type in ('1','2','D','H')
               and a.business_flag in ('1102')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and a.op_entrust_way = '7') t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3',1, 0),t.bz;
     commit;

   --ͳ֤ȯ˻ĩ
  insert into t_etl_yyb_zqzh
   select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' , 1 , 0) as khlx,
           3 as jylx,
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and (a.exchange_type in ('1','2') and b.fundacct_status<>'3'
               -- or a.exchange_type in ('D','H') and b.fundacct_status='0')
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and a.stock_account not like 'F%' 
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and b.open_date < =v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 ,'3' ,1 , 0),t.bz;
     commit;

 --ͳƻʻ
 delete t_etl_yyb_jjzh ;
 commit;
 insert into t_etl_yyb_jjzh
    select yyb,0,1,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' or substr(a.stock_account,1,3)='001' 
               or a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;


    --ͳƻʻϿ
  insert into t_etl_yyb_jjzh
    select yyb,0,12,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               OR substr(a.stock_account,1,3)='001' 
               OR a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.op_entrust_way = '7'
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and  a.op_entrust_way in ('7','8')
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;

     --ͳƻʻ֤
  insert into t_etl_yyb_jjzh
    select yyb,0,13,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               or substr(a.stock_account,1,3)='001' 
               or a.stock_account  like '05%')
               and a.business_flag in ('1101','1104')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.op_entrust_way = 'O'
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo  a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44101'
               and  a.asset_prop in ('0')
               and a.prodta_no  in ('98','99')
               and a.op_entrust_way='4'
               )t
     group by t.yyb) group by yyb;
     commit;
     
 --˻  
insert into t_etl_yyb_jjzh  
 select yyb,0,22,sum(sl) from
      (select t.yyb yyb,
           count(distinct t.stock_account) as sl
      from (select a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a
             where a.init_date  between v_begindate  and  v_enddate
               and (a.stock_account like 'F%' 
               OR substr(a.stock_account,1,3)='001' 
               OR a.stock_account  like '05%')
               and a.business_flag in ('1102')
               and a.asset_prop in ('0'/*,'7'*/)
               and a.op_entrust_way = '7' --
                ) t
     group by t.yyb
      union all
     select t.yyb yyb,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,
                   a.secum_account
              from kods.a_hs_his_secumdealinfo a  ---˱ֻ98 99ͷ
             where  a.init_date between v_begindate  and  v_enddate
               and  a.business_flag='44102'
               and  a.asset_prop in ('0')
               and  a.op_entrust_way in ('7') --
               and a.prodta_no  in ('98','99')
               )t
     group by t.yyb) group by yyb;
     commit;
     
--ͳƻʻĩ
 insert into t_etl_yyb_jjzh
   select yyb,khlx,3,sum(sl) from
      (select t.yyb yyb, decode(t.organ_flag, '1', 1 , '3' , 1, 0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.stock_account like 'F%' 
               --and substr(a.stock_account,1,3)='001' 
               --and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0','7')
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1, '3', 1, 0)
      union all
      select t.yyb yyb, decode(t.organ_flag, '1', 1 , '3' , 1, 0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and a.stock_account like 'F%' 
               and substr(a.stock_account,1,3)='001' 
               --and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1, '3' , 1 , 0)
      union all
      select t.yyb yyb, decode(t.organ_flag, '1', 1, '3',1, 0) as khlx,
           count( t.stock_account) as sl
      from (select c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               --and a.stock_account like 'F%' 
               --and substr(a.stock_account,1,3)='001' 
               and a.stock_account  like '05%'
               and b.fundacct_status<>'3'
               and a.asset_prop in ('0'/*,'7'*/)
               and b.open_date <=v_enddate
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1,'3' , 1 , 0)
      union all
     select t.yyb yyb,decode(t.organ_flag, '1', 1 , '3' , 1, 0) as khlx,
           count( t.secum_account) as sl
      from (select a.branch_no as yyb,c.organ_flag,
                   /*a.stock_account*/a.secum_account
              from /*kods.a_hs08_ofstockholder*/kods.a_hs_secumholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c  ---˱ֻ98 99ͷ
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and c.organ_flag in ('1','0','3')
               and a.prodta_no in ('98','99')
               and b.open_date < =v_enddate
               )t
     group by t.yyb,decode(t.organ_flag, '1', 1, '3', 1 , 0)) group by yyb,khlx;
     commit;

----------------------------------------------------------------------------------------------
  --˻淶
----------------------------------------------------------------------------------------------

  delete from t_etl_yyb_zhgf_zjzh;
  commit;

 --RMB˻ʽ˻
  insert into t_etl_yyb_zhgf_zjzh
    select s.branch_no,55 jylx,count(s.fund_account),sum(a.current_balance)
        from kods.RZRQ_hs_FUND_fundaccount s, kods.Rzrq_Hs_Fund_Fund a,kods.RZRQ_HS_CLIENT B
        where a.money_type='0' and a.fund_account=s.fund_account
         and a.client_id=s.client_id
         AND S.CLIENT_ID = B.CLIENT_ID
         AND A.CLIENT_ID = B.CLIENT_ID
         and B.organ_flag in ('1','0','3')
         AND S.ASSET_PROP in ('0'/*,'7'*/)
         and s.fundacct_status<>'3'
        group by s.branch_no   
 union all --˻ʽ˻
 select t1.branch_no,1 jylx,count(t2.fund_account)sl,sum(t1.current_balance)  je
          from kods.rzrq_hs_fund_fund t1 , kods.rzrq_hs_fund_fundaccount t2,kods.rzrq_hs_bankarg t3
          where t1.bank_no = t3.bank_no
            and t1.fund_account = t2.fund_account
            and t3.bank_type in ('2','4')
            and t1.money_type = '0'
            and t2.fundacct_status <> '3'
            and t2.asset_prop in ('0'/*,'7'*/)
            and t2.main_flag = '1'
            and t2.open_date<=v_enddate
          group by t1.branch_no      

  --ϸ˻ʽ˻
 union all
   select a.branch_no,2 jylx,count(a.fund_account),sum(b.current_balance)
         from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b
     where a.client_id = b.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
      -- and a.client_group='902'
       and a.ASSET_PROP in ('0'/*,'7'*/)
       and exists (select 1
              from kods.rzrq_hs_stockholder d,kods.rzrq_hs_nonstdholder e
              where d.stock_account = e.stock_account
              and d.fund_account = b.fund_account
              and d.client_id = b.client_id)
     group by a.branch_no

  union all
  --С˻ʽ˻
 select a.branch_no,3 jylx,count(a.fund_account),sum(b.current_balance)
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
     where c.client_id = a.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%2%'
     group by a.branch_no

 /*union all
  --˻ʽ˻
       select a.branch_no,4 jylx,count(a.fund_account),sum(b.current_balance)
        from kods.rzrq_hs_fund_fundaccount a, kods.rzrq_hs_fund_fund b,kods.a_hs08_clientinfo c
     where c.client_id = a.client_id
       and a.fund_account = b.fund_account
       and b.money_type = '0'
       and c.risk_info like '%6%'
     group by a.branch_no*/
 union all
  --ʽ˻
   select s.branch_no,5 jylx,count(distinct a.fund_account),sum(a.current_balance)
        from kods.RZRQ_hs_FUND_fundaccount s, kods.RZRQ_hs_fund_FUND a,kods.rzrq_hs_bankarg c
        where a.money_type='0' 
        and a.fund_account=s.fund_account 
        and s.fundacct_status<>'3'
        and a.bank_no=c.bank_no 
        and c.bank_type in ('2','4')
        and a.client_id=s.client_id
        and s.main_flag='0'
        AND S.ASSET_PROP in ('0'/*,'7'*/)
        group by s.branch_no;
        commit;
   ---˺żʽ
  /* delete from t_etl_yyb_zhgf_zjzh where jylx=1;
   commit;*/
   --update t_etl_yyb_zhgf_zjzh t set t.zjye =(select sum(decode(jylx,55,zjye,-zjye))
    --from (select * from t_etl_yyb_zhgf_zjzh union all select * from t_etl_yyb_zhgf_zjzh_rzrq) where yyb=t.yyb)
    --where t.jylx=1; 
  /* insert into t_etl_yyb_zhgf_zjzh
    select yyb,1,sum(decode(jylx,55,sl,-sl)),sum(decode(jylx,55,zjye,-zjye))
    from (select * from t_etl_yyb_zhgf_zjzh union all select * from t_etl_yyb_zhgf_zjzh_rzrq)
    group by yyb;*/
    ---˺żʽ
   delete from t_etl_yyb_zhgf_zjzh where jylx=4;
   commit;
   insert into t_etl_yyb_zhgf_zjzh
    select yyb,4,sum(decode(jylx,55,sl,-sl)),sum(decode(jylx,55,zjye,-zjye))
    from t_etl_yyb_zhgf_zjzh
    group by yyb;
  commit; 
    
    
  commit;

--------------------------------------------------------------------------------------------------
-- ˻淶   ֤ȯֵ
---------------------------------------------------------------------------------------------------
  delete from t_etl_yyb_zhgf_zqzh;
  commit;
  --ϸ˻֤ȯ˻
    insert into t_etl_yyb_zhgf_zqzh
select yyb,2,sum(sl),sum(sz)je from
   (select c.branch_no yyb,count(distinct c.fund_account) sl,sum((c.current_amount+abs(c.correct_amount))*d.asset_price) sz
    from kods.RZRQ_hs_stock c ,kods.rzrq_hs_nonstdholder a,
        (select * from kods.RZRQ_hs_HIS_hisprice where init_date=(select max(init_date) from kods.RZRQ_hs_HIS_hisprice)) d
           where   a.exchange_type IN ('1','2')
               and c.stock_code=d.stock_code
               AND A.STOCK_ACCOUNT = C.STOCK_ACCOUNT
     group by c.branch_no) 
     group by yyb;


  commit;
  --С˻֤ȯ˻
  insert into t_etl_yyb_zhgf_zqzh
    select yyb, 3, sum(sl), 0 zqsz
      from (select a.branch_no yyb, count(distinct a.stock_account) as sl
              from kods.rzrq_hs_stockholder a
             where holder_status = 'C'
               and a.exchange_type in ('1', '2')
               and a.asset_prop = '0'
             group by a.branch_no)
     group by yyb;
  commit;

 --˻֤ȯ˻

insert into t_etl_yyb_zhgf_zqzh
select a.branch_no yyb,4,count(a.stock_account) sl, sum((b.current_amount+abs(b.correct_amount))*c.asset_price)sz
        from kods.RZRQ_hs_stockholder a,kods.rzrq_hs_stock b,
        (select * from kods.RZRQ_hs_HIS_hisprice where init_date=(select max(init_date) from kods.RZRQ_hs_HIS_hisprice))c
      where a.stock_account=b.stock_account
         and b.stock_code=c.stock_code
         and a.exchange_type IN ('1','2')
         and a.asset_prop = '0'
         and a.holder_status = '1'
        group by a.branch_no;
commit;


     delete from t_etl_yyb_zhgf_zqzh where jylx=1;
    commit;
    ---ϸ֤ȯ
   insert into  t_etl_yyb_zhgf_zqzh s
    select c.yyb,1,sum(c.sl)-nvl(sum(b.sl),0),nvl(sum(s.je)-nvl(sum(b.sz),0),0)
      from  (select yyb,sum(sl) sl,sum(zqsz) sz from t_etl_yyb_zhgf_zqzh
      where jylx in (2,3,4) group by yyb)  b right join 
      (select yyb,sum(sl) sl from (select * from t_etl_yyb_zqzh union all select * from t_etl_yyb_zqzh_rzrq)  
      where jylx=3 and bz=0 group by yyb) c on b.yyb=c.yyb left join 
     (select yyb,sum(je) je from (select yyb,je from t_etl_yyb_khjyjszj where jylx=9 
      union all 
      select yyb,je from t_etl_yyb_khjyjszj_rzrq where jylx=9
       and yyb not in (select p001 from krcs.t_ctl_t036 t where t.a006 = '1004028'))group by yyb) s
     on  c.yyb=s.yyb
     group by c.yyb;
     commit;

-----     -------------------------------------------------------------------------------------
  --˻䶯
-------------------------------------------------------------------------------------
  delete from t_etl_yyb_zhbd_zjzh;
  commit;


  cisp_etl_yyb_zjzh;
  commit;
  cisp_etl_yyb_zqzh;
  commit;
  cisp_etl_yyb_jjzh;
  commit;
  cisp_etl_yyb_zhgf_zjzh;
  commit;
  cisp_etl_yyb_zhgf_zqzh;
  commit;
  cisp_etl_yyb_zhbd_zjzh;
  commit;
  cisp_etl_yyb_zhbd_zqzh;
  commit;

end ;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A4_1_20200331
prompt =============================================
prompt
create or replace procedure cisp_map_yyb_a4_1_20200331 is
  /********************************************************************
  *ܣӪҵ֤ȯԴETL
  *ʱ䣺
   
  *********************************************************************/
  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin

  --ȡڵڼʱ
 /* select to_char(t.p001) || '01' into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(t.p001) || '31'into v_enddate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;*/
     select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;
  --׽
  delete from t_etl_yyb_zqjy;
  commit;
  --- select * from a_hs_sysdictionary d where  d.dict_entry=1206-- ע
  --A
   --A
  insert into t_etl_yyb_zqjy
    select trim(yyb), 1 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb, t1.business_balance jyje, t1.fare0 fee
              from kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0', 'c', 'e') --֤ͣƱ e  ƴ
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;

  --B
  insert into t_etl_yyb_zqjy
    select trim(yyb), zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,t1.exchange_type,
                   decode(trim(t1.exchange_type), 'H', '2', 'D', '3') zqlx,
                   t1.business_balance jyje,
                   t1.fare0 fee
              from kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0') --֤ͣƱ
               and trim(t1.money_type) != '0'
               and t1.asset_prop in ('0')
               and trim(t1.exchange_type) in ('H', 'D') ---D.Ϻ H.
            ) t
     group by yyb, zqlx
     union all   --Ϻ֤ҪѻͨеB
     select trim(yyb), zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb,t1.exchange_type,
                   /*decode(trim(t1.exchange_type), 'G',*/ '3'/*)*/ zqlx,
                   round(sum(t1.business_balance)/(select nvl(sum(a002),0) from t_bks_t007),2)  jyje,
                   round(sum(t1.fare0)/(select nvl(sum(a002),0) from t_bks_t007),2) fee
              from kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0') --֤ͣƱ
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('G','S') ---D.Ϻ H.
               and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))
               group by t1.branch_no,t1.exchange_type
            ) t
     group by yyb, zqlx;
  commit;
  --('6', 'L', 'T','1','N')
  insert into t_etl_yyb_zqjy
    select trim(yyb), 4 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb, t1.business_balance jyje, t1.fare0 fee
              from /*a_hs_hisdeliver*/kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4001','4002') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('6','L','T','j','l') --T ETLL LOF6 Ͷʻ, j  ETF,l   ծETF
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
             ) t
     group by yyb;
  commit;
   --ծȯ ('9', 'X', 'Y', 'U', 'u','I')
  insert into t_etl_yyb_zqjy
    select yyb, 5 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb, t1.business_balance jyje, t1.fare0 fee
              from kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001','4050') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('9', 'X', 'Y', 'U', 'u','a')----9 ˹ծ X ƾ֤ծ Y ҵתծ U ҵծȯ u ˾ծ a ˽ļծ
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
   --Ȩ֤
  insert into t_etl_yyb_zqjy
    select yyb, 6 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb, t1.business_balance jyje, t1.fare0 fee
              from /*a_hs_hisdeliver*/kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) = 'D'
               and trim(t1.money_type) = '0'
               and trim(t1.asset_prop) in ('0')
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;
  
  --֤ȯ ͨ
    insert into t_etl_yyb_zqjy
    select yyb, 7 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select to_char(t1.branch_no) yyb, t1.business_balance jyje, t1.fare0 fee
              from kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4002', '4001') --֤ȯ ֤ȯ
               and trim(t1.stock_type) in ('0')--Ʊ
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('G','S') ---ͨ
               and t1.branch_no not in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))--(select p001 from krcs.t_ctl_t036 t where t.a006 in(1004014,1004001,1004005,1004008))
            ) t
     group by yyb;
   --ʻع
  insert into t_etl_yyb_zqjy
    select yyb, 8 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb, t1.business_balance jyje, t1.fare0 fee
              from kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4003', '4103') --('4003','4089','4103')
               and trim(t1.stock_type) in ('Q', 'Z')
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;

  --ȯع
  insert into t_etl_yyb_zqjy
    select yyb, 9 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (select t1.branch_no yyb, t1.business_balance jyje, t1.fare0 fee
              from kods.rzrq_hs_his_hisdeliver t1
             where t1.business_flag in ('4004','4090','4104','4140') --4090-ʽع 4140 ۻع
               and trim(t1.stock_type) in ('Q', 'Z')
               and trim(t1.money_type) = '0'
               and trim(t1.exchange_type) in ('1', '2') ---1.Ϻ 2.
            ) t
     group by yyb;
  commit;
 --Ͻ 
  insert into t_etl_yyb_zqjy
      select yyb, 10 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (
      select        t1.branch_no  yyb,
                    t1.business_balance jyje,
                   (fare0/*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                    -exchange_fare5-exchange_fare6-exchange_farex*/) fee
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account 
             and t2.asset_prop = '0'
               and  t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z' ,'e') --e ƴ
               and t1.money_type ='0'
               --and t1.op_entrust_way ='7' --not in ('0','2','4')
               and t1.op_entrust_way in ('7','8','9')  --7ί  8ֻί
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
            ) t
     group by yyb
     union all
     select yyb, 10 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf  --Ϻּϸ۹ͨ
      from (
      select        t1.branch_no  yyb,
                    t1.business_balance jyje,
                   (fare0/*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                    -exchange_fare5-exchange_fare6-exchange_farex*/) fee
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account 
             and t2.asset_prop = '0'
               and  t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z','e')
               and t1.money_type ='0'
               --and t1.op_entrust_way ='7' --not in ('0','2','4')
               and t1.op_entrust_way in ('7','8','9')  --7ί  8ֻί
               and t1.exchange_type in ('G','S')         ---۹ͨ ϺҪ
               --and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))
            ) t
     group by yyb;
  commit;
    --ϽסB
  insert into t_etl_yyb_zqjy
     select yyb,  zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (
      select        t1.branch_no  yyb,
                    decode(t1.exchange_type, 'H', '11', 'D', '12') zqlx,
                    t1.business_balance jyje,
                   (fare0/*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                    -exchange_fare5-exchange_fare6-exchange_farex*/) fee
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account 
             and t2.asset_prop = '0'
               and   t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')            --֤ͣƱ
               and t1.money_type !='0'
               --and t1.op_entrust_way ='7' --not in ('0','2','4')
               and t1.op_entrust_way in ('7','8','9')  --7ί  8ֻί
               and t1.exchange_type in ('H','D')         ---D.Ϻ H.
            ) t
     group by yyb,zqlx;

  commit;
  --ֳ 
  insert into t_etl_yyb_zqjy
    select yyb, 20 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (
      select        t1.branch_no  yyb,
                    t1.business_balance jyje,
                    (fare0/*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                    -exchange_fare5-exchange_fare6-exchange_farex*/) fee
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account 
             and t2.asset_prop = '0'
               and  t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z','e')--e ƴ
               and t1.money_type ='0'
               and t1.op_entrust_way in ('1','7','8','5','9')
               and t1.exchange_type in ('1','2')         ---1.Ϻ 2.
            ) t
     group by yyb
     union all 
     select yyb, 20 zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (
      select        t1.branch_no  yyb,
                    t1.business_balance jyje,
                    (fare0/*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                    -exchange_fare5-exchange_fare6-exchange_farex*/) fee
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account 
             and t2.asset_prop = '0'
               and  t1.business_flag in ('4002','4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')
               and t1.stock_type in ('0','c','6','L','T','j','l','9','X','Y','U','u','a','Q', 'Z' ,'e')
               and t1.money_type ='0'
               and t1.op_entrust_way in ('1','7','8','5','9')
               and t1.exchange_type in ('G','S')         ---1.Ϻ 2.  Ϻּϸ۹ͨ
               --and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))
            ) t
     group by yyb;
  commit;
  --ֳסB
  insert into t_etl_yyb_zqjy
     select yyb, zqlx, sum(t.jyje) jyje, sum(t.fee) sxf
      from (
      select        t1.branch_no  yyb,
                    decode(t1.exchange_type, 'H', '21', 'D', '22') zqlx,
                    t1.business_balance jyje,
                   (fare0/*-exchange_fare0+fare3+farex-exchange_fare3-exchange_fare4
                    -exchange_fare5-exchange_fare6-exchange_farex*/) fee
              from kods.rzrq_hs_his_hisdeliver t1,kods.rzrq_hs_fund_fundaccount t2
             where t1.fund_account = t2.fund_account 
             and t2.asset_prop ='0'
               and  t1.business_flag in ('4002', '4001','4003','4004','4050','4103','4104','4123','4137','4138','4140','4149','4150','4151','4152')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0')            --֤ͣƱ
               and t1.money_type !='0'
               and t1.op_entrust_way in ('1','7','8','5','9')
               and t1.exchange_type in ('H','D')         ---D.Ϻ H.
            ) t
     group by yyb,zqlx;

  commit;
  -------------------------------------------------------------------------------------------------------
  --   ֤ȯֵ
  -------------------------------------------------------------------------------------------------------
  delete from t_etl_yyb_zqsz;
  commit;
 --A-ֵ
  insert into t_etl_yyb_zqsz
    select yyb,1 zqlx,sum(zqsz) from
    (select t1.branch_no as yyb,sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price) zqsz  from  
         kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t3,
        (select * from kods.rzrq_hs_his_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in('0','c' ,'e') --0 Ʊcҵ e ƴ
               and t1.exchange_type in ('1','2')
               and t3.fundacct_status!='3'
               and t1.exchange_type=b.exchange_type
               and t1.branch_no=t3.branch_no
               and t1.client_id = t3.client_id and t1.money_type='0'
               and t1.fund_account = t3.fund_account
               and b.stock_code=t1.stock_code
               and t3.asset_prop = '0'
               group by t1.branch_no
               union all
              select a.branch_no as yyb,
               -sum(greatest(nvl(b.current_amount, 0) -
                            nvl(a.available_amount, 0),
                            0) * c.asset_price) as zqsz --  
          from kods.A_HS08_EXTSTOCKREAL a,
               kods.rzrq_hs_stockreal b,
               (select *
                  from kods.rzrq_hs_his_hisprice
                 where init_date =
                       (select max(init_date) from kods.rzrq_hs_his_hisprice)) c
         where a.client_id = b.client_id
           and a.stock_code = b.stock_code
           and a.exchange_type = b.exchange_type
           and trim(c.stock_code) = trim(a.stock_code)
           and b.stock_flag = '1'
         group by a.branch_no)
         group by yyb;
  commit;
  
  --B-ֵ
  insert into t_etl_yyb_zqsz
      select  t1.branch_no yyb,decode(t1.exchange_type,'D',3,'H',2),sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price)  zqsz
        from kods.rzrq_hs_stock t1,kods.rzrq_hs_fund_fundaccount t3,
        (select * from kods.rzrq_hs_his_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in('0') --֤ͣƱ(0)
               and t3.fundacct_status!='3'
               and t1.exchange_type in ('D','H')
               and t1.exchange_type=b.exchange_type
               and t1.branch_no=t3.branch_no
               and t1.client_id = t3.client_id 
               and t1.money_type in (1,2)
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by t1.branch_no,decode(t1.exchange_type,'D',3,'H',2)
       union all  --Ϻ֤ҪBֱͨ
        select yyb, 2 zqlx, sum(t.zqsz) zqsz  from (
      select round(sum((t1.current_amount+t1.correct_amount)*b.asset_price)/(select nvl(sum(a002),0) from t_bks_t007),2)  zqsz,
              t1.branch_no yyb
        from kods.RZRQ_HS_STOCK t1,kods.rzrq_hs_fund_fundaccount t3,
        (select * from kods.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from kods.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t3.fundacct_status!='3'
               and t1.exchange_type in ('G','S')
               and t1.exchange_type=b.exchange_type
               and t1.branch_no=t3.branch_no
               and t1.money_type='0'
               and t1.fund_account = t3.fund_account
               and b.stock_code=t1.stock_code
               and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))
               group by t1.branch_no
          ) t
     group by yyb;        
               
  commit;
  ---ֵ
  insert into t_etl_yyb_zqsz
          select t1.branch_no, 4 zqlx, sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price) zqsz  from 
        kods.rzrq_hs_stock t1,kods.rzrq_hs_fund_fundaccount t3,
        (select * from kods.rzrq_hs_his_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('6','L','T','j','l')
               and t3.fundacct_status!='3'
               and t1.exchange_type in ('1','2')
               and t1.exchange_type=b.exchange_type
               and t1.branch_no=t3.branch_no
               and t1.client_id = t3.client_id and t1.money_type='0'
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by t1.branch_no
         union all
       select s.yyb, 4 as zqlx,  sum(s.je) as zqsz --ʽ㵽ֵ
      from (select sum(abs(t.occur_balance)) je,
                   t.branch_no yyb
              from /*a_hs_contstk*/ kods.rzrq_hs_his_hisfundjour t
             where 
                t.business_flag in ('44170')
               and t.init_date = (select max(init_date) from kods.rzrq_hs_his_hisfundjour where init_date<=v_enddate) 
             group by t.branch_no) s
     group by yyb;           
  commit;
  --ծȯ-ֵ
  insert into t_etl_yyb_zqsz
     select t1.branch_no, 5 zqlx, sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price) zqsz  
        from kods.rzrq_hs_stock t1, kods.rzrq_hs_fund_fundaccount t3,
        (select * from kods.rzrq_hs_his_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('9','X','Y','U','u','a','Z')
               and t3.fundacct_status!='3'
               and t1.exchange_type in ('1','2')
               and t1.exchange_type=b.exchange_type
               and t1.branch_no=t3.branch_no
               and t1.client_id = t3.client_id and t1.money_type='0'
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by t1.branch_no;


  commit;
  --Ȩ֤-ֵ
  insert into t_etl_yyb_zqsz
      select t1.branch_no, 6 zqlx, sum((t1.current_amount+abs(t1.correct_amount))*b.asset_price) zqsz
        from kods.rzrq_hs_stock t1,kods.rzrq_hs_fund_fundaccount t3,
        (select * from kods.rzrq_hs_his_hisprice where init_date=(select max(init_date) from kods.rzrq_hs_his_hisprice)) b
             where t1.stock_type in ('D')
               and t3.fundacct_status!='3'
               and t1.exchange_type in ('1','2')
               and t1.exchange_type=b.exchange_type
               and t1.branch_no=t3.branch_no
               and t1.client_id = t3.client_id and t1.money_type='0'
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code=t1.stock_code
               group by t1.branch_no;
  commit;
  
  --֤ȯ-۹-ֵ ֻвӪҵȡͨ ĳɳϺּBУӪҵ֤ȯ
  insert into t_etl_yyb_zqsz
       select yyb, 7 zqlx, sum(t.zqsz) zqsz  from (
      select sum((t1.current_amount+t1.correct_amount)*b.asset_price)  zqsz,
              t1.branch_no yyb
        from kods.RZRQ_HS_STOCK t1,kods.rzrq_hs_fund_fundaccount t3,
        (select * from kods.RZRQ_HS_HIS_HISPRICE where init_date=(select max(init_date) from kods.RZRQ_HS_HIS_HISPRICE)) b
             where t1.stock_type in ('0')
               and t3.fundacct_status!='3'
               and t1.exchange_type in ('G','S')
               and t1.exchange_type=b.exchange_type
               and t1.branch_no=t3.branch_no
               and t1.money_type='0'
               and t1.fund_account = t3.fund_account
               and t3.asset_prop = '0'
               and b.stock_code=t1.stock_code
               and t1.branch_no not in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004002))
               --and t1.branch_no in (select p001 from krcs.t_ctl_t036 t where t.a006 in(1004014,1004001,1004005,1004008))
               group by t1.branch_no
          ) t
     group by yyb;
  commit;

----------------------------------------
--ڴɷתý׽
----------------------------------------
  delete from t_etl_yyb_dbzz;
  commit;
  insert into t_etl_yyb_dbzz --У 0- 1-۱ 2-Ԫ
     select yyb, 0 bz, sum(t.je) je  from (
      select    t1.branch_no  yyb,
                decode(t1.money_type, '1', t1.business_balance*s.a002,
                '2',t1.business_balance*s.a003,t1.business_balance) je
              from kods.rzrq_hs_his_hisdeliver t1, t_bks_t007 s
             where  t1.business_flag in ('4002', '4001')  --֤ȯ ֤ȯ
               and t1.stock_type in ('0','z')           --֤ͣƱ۹ɷ
               and t1.exchange_type in ('9','A')
            ) t
     group by yyb;
  commit;
  -------Ӷ
    delete from t_etl_yyb_yjl;
   commit;
      delete t_db_b4_04;
      commit;
  insert into t_db_b4_04
      select yyb,3002,to_char(maxsl,'fm990.0999')  from t_etl_yyb_yjl ;
  insert into t_db_b4_04
      select yyb,3003, to_char(minsl,'fm990.0999')   from t_etl_yyb_yjl ;
      commit;



  ---------------END----------------

  cisp_etl_yyb_zqjy;
  commit;
  cisp_etl_yyb_zqjy_gtsxf;
  commit;
  CISP_ETL_YYB_ZQJY_FXC;
  commit;
  cisp_etl_yyb_dbzz;
 commit;

end ;
/

prompt
prompt Creating procedure CISP_MAP_YYB_A5_1_20190401
prompt =============================================
prompt
create or replace procedure cisp_map_YYB_A5_1_20190401 is

  v_begindate varchar2(8);
  v_enddate   varchar2(8);
begin

  --ȡڵڼʱ
  select to_char(a005,'YYYYMMDD') into v_begindate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;
  select to_char(a006,'YYYYMMDD') into v_enddate from t_b00_d004 t
   where t.a002 = 1013001
     and t.c001 = 1001101
     and t.d100 = 1006002;

  delete from T_ETL_YYB_XSJRCP_FSE /*where xm not in(24,25)*/;
   /******************************Ӷ***********************************/
   --1.֤ȯͶʻ
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
      SELECT yyb,1,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT PROD_CODE) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG in ('44124','44142','44150')
            and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
            and init_date between substr(v_enddate,1,4)||0101 and v_enddate
            GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(BUSINESS_BALANCE) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_secumdealinfo
             WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
             and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
             GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(BUSINESS_BALANCE) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo
                WHERE BUSINESS_FLAG in ('44124','44142','44150')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=11)
                GROUP BY BRANCH_NO) group by yyb;
     commit;
  --3.˾ʲƻ
      insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select yyb,3,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
    from
      (
      select branch_no yyb,0 bqzjsl,0 bqzjje,count(distinct prod_code) as BNZJSL ,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44122','44139','44130')
      and prod_code  in (select jjdm from t_bks_t100 where fxzl=12)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        group by branch_no
     /*union all
     select branch_no yyb,0 bqzjsl,0 bqzjje,count(distinct prod_code)as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by branch_no  */
     union all
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,count(distinct prod_code) as BNJSSL
      from kods.a_hs_his_secumdealinfo_bnlj where   business_flag in ('44124','44142','44150')
      and prod_code in (select jjdm from t_bks_t100 where fxzl=12)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        group by branch_no
     /* union all  
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,count(distinct t.prod_code) as BNJSSL 
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       group by branch_no */
     /*union all
      select branch_no yyb,count(distinct fund_code) as BQZJSL,sum(balance) BQZJJE,0 BNZJSL ,0 bqjssl,0 bqjsje,0 BNJSSL
      from kods.a_hs08_his_ofdeliver where  business_flag in ('122','139','130')
      and fund_code in (select jjdm from t_bks_t100 where fxzl=12)
        group by branch_no*/
     union all
      select branch_no yyb,count (distinct t.prod_code) as BQZJSL,sum(abs(t.business_balance)) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL 
      from kods.a_hs_his_secumdealinfo t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and t.business_balance<>0
       group by branch_no
     /*union all
      select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count(distinct fund_code) as BQJSSL,sum(balance) BQJSJE,0 BNJSSL
        from kods.a_hs08_his_ofdeliver where  business_flag in ('124','142','150')
        and fund_code in (select jjdm from t_bks_t100 where fxzl=12)
        group by branch_no*/
      union all
       select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count (distinct t.prod_code) as BQJSSL,sum(t.business_balance) BQJSJE,0 BNJSSL
       from kods.a_hs_his_secumdealinfo t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and t.entrust_balance<>0
       group by branch_no 
      )group by yyb;
    commit;
    
    
    --3.˾ʲƻ
      insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select yyb,4,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
    from
      (
      select yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from (
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL ,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44122','44139','44130')
      and prod_code  in (select jjdm from t_bks_t100 where fxzl=13)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
     union all
     select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      )  group by yyb 
     union all
     select  yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,count(distinct BNJSSL) as BNJSSL from (
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje,prod_code as BNJSSL
      from kods.a_hs_his_secumdealinfo_bnlj where   business_flag in ('44124','44142','44150')
      and prod_code in (select jjdm from t_bks_t100 where fxzl=13)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate      
      union all  
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL ,0 bqjssl,0 bqjsje, t.prod_code as BNJSSL 
      from kods.a_hs_his_secumdeliver_bnlj t
       where business_flag in('44124','44150','44142')
       and t.prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        )group by yyb   
     union all
     /* select branch_no yyb,count(distinct fund_code) as BQZJSL,sum(balance) BQZJJE,0 BNZJSL ,0 bqjssl,0 bqjsje,0 BNJSSL
      from kods.a_hs08_his_ofdeliver where  business_flag in ('122','139','130')
      and fund_code in (select jjdm from t_bks_t100 where fxzl=13)
        group by branch_no
     union all*/
      select branch_no yyb,count (distinct t.prod_code) as BQZJSL,sum(t.business_balance) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL 
      from kods.a_hs_his_secumdealinfo t
       where business_flag in('44122','44130','44139')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and t.business_balance<>0
       group by branch_no
    /* union all
      select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count(distinct fund_code) as BQJSSL,sum(balance) BQJSJE,0 BNJSSL
        from kods.a_hs08_his_ofdeliver where  business_flag in ('124','142','150')
        and fund_code in (select jjdm from t_bks_t100 where fxzl=13)
        group by branch_no*/
      union all
       select branch_no yyb,0 BQZJSL,0 BQZJJE,0 BNZJSL ,count (distinct t.prod_code) as BQJSSL,sum(t.business_balance) BQJSJE,0 BNJSSL
       from kods.a_hs_his_secumdealinfo t
       where business_flag in('44124','44150','44142')
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
       and t.entrust_balance<>0
       group by branch_no 
      )group by yyb;
    commit;
    
    --֤ȯ˾ʲƻ
    insert into T_ETL_YYB_XSJRCP_FSE
    select t.yyb,2,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL),sum(T.BQJSSL),sum(T.BQJSJE),sum(T.BNJSSL) from T_ETL_YYB_XSJRCP_FSE t where t.xm in (3,4) group by t.yyb ;
    commit;
    --
    insert into T_ETL_YYB_XSJRCP_FSE
     SELECT yyb,5,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT prod_code) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('43130') 
           and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG in('43142','43150')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(abs(entrust_amount)) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_bankmdeliver
             WHERE BUSINESS_FLAG IN ('43130')  
             and prod_code in (select jjdm from t_bks_t100 where fxzl=14)           
                GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(abs(entrust_amount)) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver
                WHERE BUSINESS_FLAG in('43142','43150')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=14)
                GROUP BY BRANCH_NO) group by yyb;
    commit;
    --6.
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
      SELECT yyb,6,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT PROD_CODE) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG in ('44124','44142','44150')
            and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
            and init_date between substr(v_enddate,1,4)||0101 and v_enddate
            GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(BUSINESS_BALANCE) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_secumdealinfo
             WHERE BUSINESS_FLAG IN ('44122', '44139', '44130')
             and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
             GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(BUSINESS_BALANCE) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo
                WHERE BUSINESS_FLAG in ('44124','44142','44150')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=15)
                GROUP BY BRANCH_NO) group by yyb;
     commit;
    --ڲƷ
    insert into T_ETL_YYB_XSJRCP_FSE
     SELECT yyb,8,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0) FROM 
     (
     SELECT  YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT BNZJSL) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl FROM (
     SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,prod_code AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG IN ('44122','44139','44130')
           and prod_code  in (select jjdm from t_bks_t100 where fxzl=17)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje, prod_code AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_secumdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('44122','44130','44139')
          and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
          and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
          and init_date between substr(v_enddate,1,4)||0101 and v_enddate
          ) GROUP BY YYB      
       union all 
       SELECT  YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT BNJSSL) AS BNJSSL FROM (
       SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje,PROD_code AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo_bnlj
           WHERE BUSINESS_FLAG in ('44124','44142','44150')
            and PROD_code  in (select jjdm from t_bks_t100 where fxzl=17)
            and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        union all           
       SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje,  prod_code AS BNJSSL
                 FROM KODS.a_hs_his_secumdeliver_bnlj
           WHERE BUSINESS_FLAG in('44124','44150','44142')
           and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           )group by yyb
       /*union all
       SELECT BRANCH_NO YYB,COUNT(DISTINCT fund_code) AS BQZJSL, SUM(balance) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs08_his_ofdeliver
             WHERE BUSINESS_FLAG IN ('122','139','130') 
             and fund_code  in (select jjdm from t_bks_t100 where fxzl=17)           
                GROUP BY BRANCH_NO*/
      union all        
        SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(business_balance) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_secumdealinfo
             WHERE BUSINESS_FLAG IN ('44122','44130','44139')  
             and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
             and business_balance<>0         
                GROUP BY BRANCH_NO  
       /*union all
       SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT fund_code) AS BQJSSL, SUM(balance) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs08_his_ofdeliver
                WHERE BUSINESS_FLAG in('44124','44142','44150')
                and fund_code  in (select jjdm from t_bks_t100 where fxzl=17)
                GROUP BY BRANCH_NO      */     
       union all
       SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(business_balance) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_secumdealinfo
                WHERE BUSINESS_FLAG in('44124','44150','44142')
                and prod_code in (select jjdm from t_bks_t100 where fxzl=17)
                and entrust_balance<>0
                GROUP BY BRANCH_NO         
     ) group by yyb;
     commit;
    --˷ϼ
    insert into T_ETL_YYB_XSJRCP_FSE
    select t.yyb,101,sum(t.BQZJSL),sum(t.BQZJJE),sum(t.BNZJSL) ,SUM(T.BQJSSL),SUM(T.BQJSJE),SUM(T.BNJSSL)
           from T_ETL_YYB_XSJRCP_FSE t where t.xm in(1,2,5,6,7,8)
                group by t.yyb;
    commit;
     /*******************************************************************/
    --10.̶ڲƷ
      insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    -- select t.yyb,10,t.BQZJSL,t.BQZJJE,t.BNZJSL,T.BQJSSL,T.BQJSJE,T.BNJSSL from T_ETL_YYB_XSJRCP_FSE t where t.xm = 5 ;
    SELECT yyb,10,NVL(sum(BQZJSL), 0),NVL(sum(BQZJJE), 0), NVL(sum(BNZJSL), 0),NVL(sum(BQJSSL), 0), NVL(sum(BQJSJE), 0),NVL(sum(BNJSSL), 0)
      FROM 
     (SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,COUNT(DISTINCT prod_code) AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('43130') 
           and prod_code in (select jjdm from t_bks_t100 where syzl=21)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all      
    SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje, COUNT(DISTINCT prod_code) AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG in('43142','43150')
           and prod_code in (select jjdm from t_bks_t100 where syzl=21)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
           GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,COUNT(DISTINCT prod_code) AS BQZJSL, SUM(abs(entrust_amount)) BQZJJE,0 AS BNZJSL,0 bqjssl,0 bqjsje, 0 AS BNJSSL
              FROM kods.a_hs_his_bankmdeliver
             WHERE BUSINESS_FLAG IN ('43130')  
             and prod_code in (select jjdm from t_bks_t100 where syzl=21)           
                GROUP BY BRANCH_NO
    union all
     SELECT BRANCH_NO YYB,0 AS BQZJSL, 0 BQZJJE,0 AS BNZJSL,
                      COUNT(DISTINCT prod_code) AS BQJSSL, SUM(abs(entrust_amount)) BQJSJE,0 AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver
                WHERE BUSINESS_FLAG in('43142','43150')
                and prod_code in (select jjdm from t_bks_t100 where syzl=21)
                GROUP BY BRANCH_NO) group by yyb;
    --11.ڲƷ
     insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
  select yyb,11,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
  from(
  select yyb,0 bqzjsl,0 bqzjje, count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from(
  select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
  from kods.a_hs_his_secumdealinfo_bnlj 
    where   business_flag in ('44122','44139','44130')
      and prod_code in (select jjdm from t_bks_t100 where syzl=22)
      and init_date between substr(v_enddate,1,4)||0101 and v_enddate
     union all
     select branch_no yyb,0 bqzjsl,0 bqzjje,prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
    from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      union all 
     SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje, prod_code AS BNZJSL, 0 bqjssl,0 bqjsje,0 bnjssl
            FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG IN ('43130') 
           and prod_code in (select jjdm from t_bks_t100 where syzl=22)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )group by yyb
     union all
     select  yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, count(distinct BNJSSL) as BNJSSL  from (
      select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44124','44142','44150')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      union all
      select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdeliver_bnlj 
       where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      union all
      SELECT BRANCH_NO YYB, 0 bqzjsl,0 bqzjje,0 AS BNZJSL,0 bqjssl,0 bqjsje,  prod_code AS BNJSSL
                 FROM KODS.a_hs_his_bankmdeliver_bnlj
           WHERE BUSINESS_FLAG in('43142','43150')
           and prod_code in (select jjdm from t_bks_t100 where syzl=22)
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       ) group  by yyb
      union all
      select  branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(entrust_amount)) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL
       from kods.a_hs_his_bankmdeliver 
       where   business_flag in ('43130')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        group by branch_no
      union all
      select  branch_no yyb,count(distinct prod_code) bqzjsl,sum(business_balance) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo
       where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
       and business_balance<>0
        group by branch_no  
      union all
      select  branch_no yyb,0 bqzjsl,0 BQZJJE,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(entrust_amount)) bqjsje,0 BNJSSL
       from kods.a_hs_his_bankmdeliver 
       where  business_flag in ('43142','43150')
       and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        group by branch_no
      union all
      select  branch_no yyb,0 bqzjsl,0 BQZJJE,0 BNZJSL,count(distinct prod_code) bqjssl,sum(business_balance) bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo 
       where  business_flag in ('44124','44150','44142')
        and prod_code in (select jjdm from t_bks_t100 where syzl=22)
        and entrust_balance<>0
        group by branch_no  
      ) group by YYB;
      commit;
  --ڲƷ    
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)    
  select yyb,13,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
  from(
     select  yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from (
     select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
    from kods.a_hs_his_secumdeliver_bnlj where
       business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        union all
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
    from kods.a_hs_his_secumdealinfo_bnlj where
       business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
        )group by yyb
      union all
      select yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,count(distinct BNJSSL) as BNJSSL from (
      select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdeliver_bnlj 
       where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)  
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       union all
       select  branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code as BNJSSL
       from kods.a_hs_his_secumdealinfo_bnlj
       where business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24)  
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )group by yyb
      union all
      select  branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(business_balance)) BQZJJE,0 BNZJSL,0 bqjssl,0 bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo
       where business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
       and business_balance<>0
        group by branch_no  
      union all
      select  branch_no yyb,0 bqzjsl,0 BQZJJE,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(business_balance)) bqjsje,0 BNJSSL
       from kods.a_hs_his_secumdealinfo
       where  business_flag in ('44124','44150','44142')
        and prod_code in (select jjdm from t_bks_t100 where syzl=24) 
        and entrust_balance<>0
        group by branch_no  
      ) group by YYB;     
     commit;
     --15.ṹڲƷ
     insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
   select yyb,15,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
 from(
 select yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl  from (
 select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdealinfo_bnlj where  business_flag in ('44122','44139','44130')
        and prod_code  in (select jjdm from t_bks_t100 where syfl=31)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
      union all
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdeliver_bnlj where  business_flag in ('44122','44130','44139')
        and  prod_code in (select jjdm from t_bks_t100 where syfl=31)
        and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate
        )group by yyb 
      union all
      select yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,count(distinct bnjssl) bnjssl from (
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,prod_code bnjssl
       from kods.a_hs_his_secumdealinfo_bnlj
       where  business_flag in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where syfl=31) 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      union all 
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code bnjssl
       from kods.a_hs_his_secumdeliver_bnlj where  business_flag in('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       ) group by yyb
       union all
      /*select branch_no yyb,count(distinct fund_code) bqzjsl,sum(balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where  business_flag in ('122','139','130')
       and fund_code  in (select jjdm from t_bks_t100 where syfl=31) 
        group by branch_no
        union all*/
        select branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo 
       where  business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and business_balance<>0 
        group by branch_no
            /*union all
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct fund_code) bqjssl,sum(balance) bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where   business_flag in ('124','142','150')
        and fund_code  in (select jjdm from t_bks_t100 where syfl=31) 
        group by branch_no*/
        union all
       select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(entrust_balance)) bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo
       where   business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where syfl=31)
       and entrust_balance<>0 
        group by branch_no 
      ) group by YYB;
    /******************************۷ʽ*************************************/
    commit;
    --(˾)
    insert into T_ETL_YYB_XSJRCP_FSE
      select yyb,17,NVL(sum(BQZJSL),0),NVL(sum(BQZJJE),0),NVL(sum(BNZJSL),0),NVL(sum(BQJSSL),0),NVL(sum(BQJSJE),0),NVL(sum(BNJSSL),0)
     from(
     select yyb,0 bqzjsl,0 bqzjje,count(distinct BNZJSL) as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl from (
     select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdealinfo_bnlj
        where  business_flag in ('44122','44139','44130')
        and prod_code  in (select jjdm from t_bks_t100 where fsfl=41)
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
      union all
      select branch_no yyb,0 bqzjsl,0 bqzjje, prod_code as BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
        from kods.a_hs_his_secumdeliver_bnlj 
        where  business_flag in ('44122','44130','44139')
        and  prod_code in (select jjdm from t_bks_t100 where fsfl=41)
        and  prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
        and init_date between substr(v_enddate,1,4)||0101 and v_enddate 
        ) group by yyb  
      union all
      select yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,count(distinct bnjssl) as BNJSSL from (
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code bnjssl
       from kods.a_hs_his_secumdealinfo_bnlj
       where  business_flag  in ('44124','44142','44150')
       and prod_code  in (select jjdm from t_bks_t100 where fsfl=41) 
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
      union all 
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, prod_code bnjssl
       from kods.a_hs_his_secumdeliver_bnlj where  business_flag in('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41) 
       and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
       and init_date between substr(v_enddate,1,4)||0101 and v_enddate
       )group  by  yyb
       /*union all
      select branch_no yyb,count(distinct fund_code) bqzjsl,sum(balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where  business_flag in ('44122','44139','44130')
       and fund_code  in (select jjdm from t_bks_t100 where fsfl=41) 
        group by branch_no*/
        union all
        select branch_no yyb,count(distinct prod_code) bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo where  business_flag in ('44122','44130','44139')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41) 
       and business_balance<>0
        group by branch_no
            /*union all
      select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct fund_code) bqjssl,sum(balance) bqjsje,0 bnjssl
       from kods.a_hs08_his_ofdeliver where   business_flag in ('124','142','150')
        and fund_code  in (select jjdm from t_bks_t100 where fsfl=41) 
        group by branch_no*/
        union all
       select branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,count(distinct prod_code) bqjssl,sum(abs(business_balance)) bqjsje,0 bnjssl
       from kods.a_hs_his_secumdealinfo where   business_flag in ('44124','44150','44142')
       and prod_code in (select jjdm from t_bks_t100 where fsfl=41)
       and entrust_balance<>0 
        group by branch_no 
      ) group by YYB;
    commit;
    
    insert into T_ETL_YYB_XSJRCP_FSE
    select t.yyb,18,sum(decode(xm,101,t.BQZJSL,-t.BQZJSL)),
                    sum(decode(xm,101,t.BQZJJE,-t.BQZJJE)),
                    sum(decode(xm,101,t.BNZJSL,-t.BNZJSL)),
                    sum(decode(xm,101,t.BQJSSL,-t.BQJSSL)),
                    sum(decode(xm,101,t.BQJSJE,-t.BQJSJE)),
                    sum(decode(xm,101,t.BNJSSL,-t.BNJSSL))
                    from T_ETL_YYB_XSJRCP_FSE t
                    where t.xm in( 101,17)
                    group by t.yyb;
     commit;
  
    /******************************ͷ*************************************/
   --21.
  insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select nvl(a.yyb,b.yyb),21,NVL(sum(c.BQZJSL), 0),NVL(sum(c.BQZJJE), 0),NVL(sum(a.BNZJSL), 0),NVL(sum(d.BQJSSL), 0),NVL(sum(d.BQJSJE), 0),NVL(sum(b.BNJSSL), 0)
  from (
    select yyb,count(distinct BNZJSL) BNZJSL from(
    select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44122', '44139', '44130')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id 
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb) a
          full join 
        (select yyb,count(distinct bnjssl) bnjssl from (
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44142','44150')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
         union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb)b on a.yyb=b.yyb
         full join
        (select yyb,count(distinct bqzjsl) bqzjsl,sum(bqzjje) bqzjje from(
        /*select a.branch_no yyb, a.client_id bqzjsl,sum(a.balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('122', '139', '130')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver a, kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and a.business_balance<>0
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(entrust_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a, kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
         group by a.branch_no,a.client_id )
         group by yyb)c on nvl(a.yyb,b.yyb)=c.yyb
         full join 
        (select yyb,count(distinct bqjssl) bqjssl,sum(bqjsje) bqjsje  from (
        /*select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(a.balance) bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('124','142','150')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
           and a.entrust_balance<>0
         group by a.branch_no,a.client_id
         union all
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a, kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag in ('1','3')
         group by a.branch_no,a.client_id)
         group by yyb)d  on nvl(b.yyb,c.yyb)=d.yyb 
         --where a.yyb=b.yyb and a.yyb=c.yyb and a.yyb=d.yyb
         group by a.yyb,b.yyb,c.yyb,d.yyb;
     commit;
     
        --22.
     insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
  select nvl(a.yyb,b.yyb),22,NVL(sum(c.BQZJSL), 0),NVL(sum(c.BQZJJE), 0),NVL(sum(a.BNZJSL), 0),NVL(sum(d.BQJSSL), 0),NVL(sum(d.BQJSJE), 0),NVL(sum(b.BNJSSL), 0)
  from (
    select yyb,count(distinct BNZJSL) BNZJSL from(
    select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44122', '44139', '44130')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a, kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id 
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje, a.client_id BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb) a
          full join 
        (select yyb,count(distinct bnjssl) bnjssl from (
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdealinfo_bnlj a ,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44142','44150')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_secumdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and prod_code in ('SE0061','SD7881','S38490','AF5009','SN0050','AF5031','SD9400','AF5034','AF5014','SM0688','SF2231','SH2351','SD9471','SE5990','AF1136','AF5015','S67887','SK2772','S34109','AF5020','AF5016','SR9477','AF5047','AF5017','AF5029','SH6303','SJ4390','SL8639','SH8519','SN4252','S38491','SK3689','SK4573','SL1165','SL0498','SK1628','SL4532','SP7827','SP8648','S40686','SP5005','SL1424','SN5691','SM2375','SR3653','SM7205')
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id
         union all
        select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje, a.client_id bnjssl
          from kods.a_hs_his_bankmdeliver_bnlj a,kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and init_date between substr(v_enddate,1,4)||0101 and v_enddate
         group by a.branch_no,a.client_id )
         group by yyb)b on a.yyb=b.yyb
         full join
        (select yyb,count(distinct bqzjsl) bqzjsl,sum(bqzjje) bqzjje from(
        /*select a.branch_no yyb, a.client_id bqzjsl,sum(a.balance) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('122', '139', '130')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(business_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_secumdeliver a,kods.rzrq_hs_client c
         where a.business_flag in ('44122','44130','44139')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and a.business_balance<>0
         group by a.branch_no,a.client_id
        union all
        select a.branch_no yyb, a.client_id bqzjsl,sum(abs(entrust_balance)) bqzjje,0 BNZJSL,0 bqjssl,0 bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a,kods.rzrq_hs_client c
         where a.business_flag in ('43130')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
         group by a.branch_no,a.client_id )
         group by yyb)c on nvl(a.yyb,b.yyb)=c.yyb
         full join 
        (select yyb,count(distinct bqjssl) bqjssl,sum(bqjsje) bqjsje  from (
        /*select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(a.balance) bqjsje,0 bnjssl
          from kods.a_hs08_his_ofdeliver a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
         where a.business_flag in ('124','142','150')
           and a.client_id = b.client_id
           and b.client_id = c.client_id
           and c.organ_flag = '1'
         group by a.branch_no,a.client_id
         union all*/
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_secumdealinfo a,kods.rzrq_hs_client c
         where a.business_flag in ('44124','44150','44142')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
           and a.entrust_balance<>0
         group by a.branch_no,a.client_id
         union all
         select a.branch_no yyb,0 bqzjsl,0 bqzjje,0 BNZJSL, a.client_id bqjssl,sum(abs(a.entrust_balance)) bqjsje,0 bnjssl
          from kods.a_hs_his_bankmdeliver a,kods.rzrq_hs_client c
         where a.business_flag in ('43142','43150')
           and a.client_id = c.client_id
           and c.organ_flag = '0'
         group by a.branch_no,a.client_id)
         group by yyb)d  on nvl(b.yyb,c.yyb)=d.yyb 
         --where a.yyb=b.yyb and a.yyb=c.yyb and a.yyb=d.yyb
         group by a.yyb,b.yyb,c.yyb,d.yyb;
     commit;


    update T_ETL_YYB_XSJRCP_FSE t set t.BQZJJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQZJJE,0),-nvl(t1.BQZJJE,0))) from T_ETL_YYB_XSJRCP_FSE t1
                    where t1.xm in(101,21) and t.yyb = t1.yyb ),
                    t.BQJSJE =
             (select sum(decode(t1.xm,101,nvl(t1.BQJSJE,0),-nvl(t1.BQJSJE,0))) from T_ETL_YYB_XSJRCP_FSE t1
                    where t1.xm in(101,21) and t.yyb = t1.yyb )
                    where t.xm=22;
                commit;

   delete T_ETL_YYB_XSJRCP_QMYE;
    /******************************ĩ***********************************/
      --1.֤ȯͶʻ
  insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,1,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select t.branch_no yyb,nvl(count(distinct t.prod_code),0) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
       where t.prod_code = b.prod_code
       and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=11)
       and t.current_amount<>0
       group by t.branch_no
       
      )a;
      commit;

  --3.˾ʲƻ
     insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,3,a.qmsl,a.qmje
    from (
      select yyb,nvl(sum(qmsl),0) as qmsl ,nvl(sum(qmje),0) as qmje from (
      select t.branch_no yyb,nvl(count(distinct t.prod_code),0) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
       where t.prod_code = b.prod_code
       and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
       and t.prod_code in (select jjdm from t_bks_t100 where fxzl=12)
       and t.current_amount<>0
       group by t.branch_no)
       group by yyb  
      ) a;

    commit;
    
  --4.˾ʲƻ
     insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,4,a.qmsl,a.qmje
    from (
      select yyb,nvl(sum(qmsl),0) as qmsl ,nvl(sum(qmje),0) as qmje from (
      select t.branch_no yyb,nvl(count(distinct t.prod_code),0) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
       where t.prod_code = b.prod_code
        and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
        and t.prod_code in (select jjdm from t_bks_t100 where fxzl=13)
        and t.current_amount<>0
       group by t.branch_no)
       group by yyb  
      ) a;

    commit;  
    
    
 --֤ȯ˾ʲƻ
    insert into T_ETL_YYB_XSJRCP_QMYE
    select t.yyb,2,sum(t.qmsl),sum(t.qmje) from T_ETL_YYB_XSJRCP_QMYE t where t.xm in (3,4) group by t.yyb;

    commit;
    
    insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,5,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select branch_no yyb,count(distinct prod_code) as qmsl,sum(current_amount) as qmje from kods.a_hs08_bankmshare
      where prod_code in (select jjdm from t_bks_t100 where fxzl=14)
      and current_amount <> 0
      group by branch_no
      ) a;
      commit;
    insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,8,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select yyb,sum(qmsl) qmsl,sum(qmje) qmje from (
      select t.branch_no as yyb,count(distinct t.prod_code) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
      where t.prod_code = b.prod_code
      and t.current_amount<>0
      and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
      and t.prod_code in (select jjdm from t_bks_t100 where fxzl=17)
      group by t.branch_no)
      group by yyb
      ) a;
      commit;  
    --˷ϼ
    insert into T_ETL_YYB_XSJRCP_QMYE
    select t.yyb,101,sum(t.qmsl),sum(t.qmje)
           from T_ETL_YYB_XSJRCP_QMYE t
                where t.xm in(1,2,5,6,7,8)
                group by t.yyb;

    commit;

    --10.̶ڲƷ
      insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   --select a.yyb,10,a.qmsl,a.qmje from T_ETL_YYB_XSJRCP_QMYE a where xm=5;
   select a.yyb,5,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select branch_no yyb,count(distinct prod_code) as qmsl,sum(current_amount) as qmje from kods.a_hs08_bankmshare
      where prod_code in (select jjdm from t_bks_t100 where syzl=21)
      and current_amount <> 0
      group by branch_no
      ) a;

     --11.ڲƷ
   insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,11,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
       select yyb,sum(qmsl) qmsl,sum(qmje) qmje from (
      select branch_no as yyb,count(distinct t.prod_code) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
      where t.prod_code = b.prod_code
      and t.current_amount<>0
      and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
      and t.prod_code in (select jjdm from t_bks_t100 where syzl=22)
      group by branch_no
      union all
       select branch_no yyb,count(distinct prod_code) as qmsl,sum(current_amount) as qmje from kods.a_hs08_bankmshare
      where prod_code in (select jjdm from t_bks_t100 where syzl=22)
      and current_amount <> 0
      group by branch_no
      )
      group by yyb
      ) a;
      commit;
    --ڲƷ
     insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
     select a.yyb,13,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select t.branch_no as yyb,count(distinct t.prod_code) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
      where t.prod_code = b.prod_code
      and t.current_amount<>0
      and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
      and t.prod_code in (select jjdm from t_bks_t100 where syzl=24)
      group by t.branch_no
      union all
      select branch_no as yyb,count(distinct t.prod_code) as qmsl,round(sum(current_amount),2) as qmje from kods.a_hs08_bankmshare t
      where t.current_amount<>0
      and t.prod_code  in (select jjdm from t_bks_t100 where syzl=24)
      group by branch_no
      ) a;
      commit;
  
    --15.ṹڲƷ
   insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,15,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select yyb,sum(qmsl) qmsl,sum(qmje) qmje from (
      select branch_no as yyb,count(distinct t.prod_code) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_bankmshare t,
      kods.a_hs_his_prodprice b
      where t.prod_code = b.prod_code
      and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
      and t.current_amount<>0
      and t.prod_code  in (select jjdm from t_bks_t100 where syfl=31)
      group by branch_no
       union all
       select t.branch_no as yyb,count(distinct t.prod_code) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
      where t.prod_code = b.prod_code
      and t.current_amount<>0
      and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
      and t.prod_code in (select jjdm from t_bks_t100 where syfl=31)
      group by t.branch_no
      )
      group by yyb
      ) a;
   /******************************۷ʽ*************************************/
    commit;
    --(qita˾)
    insert into T_ETL_YYB_XSJRCP_QMYE
    select a.yyb,17,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select yyb,sum(qmsl) qmsl,sum(qmje) qmje from (
      select branch_no as yyb,count(distinct prod_code) as qmsl,sum(current_amount) as qmje from kods.a_hs08_bankmshare
      where prod_code  in (select jjdm from t_bks_t100 where fsfl=41)
      and current_amount <> 0
      group by branch_no
       union all
      select t.branch_no as yyb,count(distinct t.prod_code) as qmsl,round(sum(t.current_amount*b.net_value),2) as qmje from kods.a_hs08_secumshare t,
      kods.a_hs_his_prodprice b
      where t.prod_code = b.prod_code
      and t.current_amount <> 0
      and b.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
      and t.prod_code  in (select jjdm from t_bks_t100 where fsfl=41)
      group by t.branch_no      )
      group by yyb
      ) a;

    commit;
    --
    insert into T_ETL_YYB_XSJRCP_QMYE
    select t.yyb,18,sum(decode(xm,101,t.qmsl,-t.qmsl)),
                    sum(decode(xm,101,t.qmje,-t.qmje))
                    from T_ETL_YYB_XSJRCP_QMYE t
                         where t.xm in( 101,17)
                         group by t.yyb;


    /******************************ͷ*************************************/
  --21.
   insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
   select a.yyb,21,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select yyb,count(distinct qmsl) qmsl,sum(qmje) qmje from 
      (
      select a.branch_no yyb,a.client_id as qmsl,round(sum(a.current_amount*d.net_value),2) as qmje 
      from kods.a_hs08_secumshare a,kods.rzrq_hs_client c ,kods.a_hs_his_prodprice d
      where a.client_id = c.client_id
      and   a.prod_code = d.prod_code
      and a.current_amount<>0
      and d.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate)
      and c.organ_flag in ('1','3') 
      group by a.branch_no,a.client_id
      union all
      select a.branch_no yyb, a.client_id as qmsl,sum(a.current_amount) as qmje 
      from kods.a_hs08_bankmshare a,kods.rzrq_hs_client c 
      where a.client_id=c.client_id 
      and a.current_amount<>0
      and c.organ_flag in ('1','3') 
      group by a.branch_no,a.client_id)
      group by yyb
      )a;
      commit;
      --
   insert into T_ETL_YYB_XSJRCP_QMYE(YYB,XM,QMSL,QMJE)
    select a.yyb,22,nvl(a.qmsl,0),nvl(a.qmje,0)
    from (
      select yyb,count(distinct qmsl) qmsl,sum(qmje) qmje from 
      (
      select a.branch_no yyb,a.client_id as qmsl,round(sum(a.current_amount*d.net_value),2) as qmje 
      from kods.a_hs08_secumshare a,kods.rzrq_hs_client c,kods.a_hs_his_prodprice d
      where a.client_id=c.client_id 
      and a.prod_code = d.prod_code
      and a.current_amount<>0
      and d.init_date = (select max(init_date) from kods.a_hs_his_prodprice where init_date<= v_enddate) 
      and c.organ_flag ='0' 
      group by a.branch_no,a.client_id
      union all
      select a.branch_no yyb, a.client_id as qmsl,sum(a.current_amount) as qmje 
      from kods.a_hs08_bankmshare a,kods.rzrq_hs_client c 
      where a.client_id=c.client_id
      and c.organ_flag ='0' 
      and a.current_amount<>0
      group by a.branch_no,a.client_id)
      group by yyb
      )a;
      commit;
      update T_ETL_YYB_XSJRCP_QMYE t set t.qmje =
             (select sum(decode(t1.xm,101,nvl(t1.qmje,0),-nvl(t1.qmje,0))) from T_ETL_YYB_XSJRCP_QMYE t1
                    where t1.xm in(101,21) and t.yyb = t1.yyb )
                    where t.xm=22;
 delete T_ETL_YYB_XSJRCP_QMYE where xm =101;
    commit;
    
   --
   insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select yyb,24,0,NVL(sum(a.BQZJJE),0),0,0,0,0
    from (
      /* select a.branch_no yyb,sum(a.fare_sx) BQZJJE  from kods.a_hs08_his_ofdeliver a
       where a.business_flag in ('122','139','130'\*,'124','142','150'*\)
       group by a.branch_no
       union all*/
       select a.branch_no yyb,sum(a.fare_sx) BQZJJE  from kods.a_hs_his_secumdealinfo a
       where a.business_flag in ('44122','44130','44139'/*,'44124','44150','44142'*/)
       and a.business_balance<>0 
       group by a.branch_no
       union all
       select a.branch_no yyb,sum(a.RATIO_SX) BQZJJE  from kods.a_hs_his_bankmdeliver a
       where a.business_flag  in ('43130'/*,'43142'*/)
       group by a.branch_no
        )a group by yyb;
      --
      insert into T_ETL_YYB_XSJRCP_FSE(YYB,XM,BQZJSL,BQZJJE,BNZJSL,BQJSSL,BQJSJE,BNJSSL)
    select yyb,25,0,NVL(sum(a.BQZJJE),0),0,0,0,0
    from ( 
       select a.branch_no yyb,sum(a.fare_sx) BQZJJE  from kods.a_hs_his_secumdealinfo a
       where a.business_flag in ('44122','44139','44130'/*,'124','142','150'*/)
       and prod_code in  (select jjdm from t_bks_t100 where fsfl=42)
       group by a.branch_no
       /*union all
       select a.branch_no yyb,sum(a.fare_sx) BQZJJE  from kods.a_hs_his_secumdeliver a
       where a.business_flag in ('44122','44130'\*,'44124','44150','44142'*\)
       and  prod_code in  (select jjdm from t_bks_t100 where fsfl=42)
       and a.business_balance<>0 
       group by a.branch_no*/
       )a group by yyb;  
       commit;

  cisp_etl_yyb_XSJRCP;
  /**
     ҵĿǰû
  **/

 -- krcs_etl_yyb_dlxs;
 -- krcs_etl_yyb_dlxs_cwsr;
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_ZJZH_RZRQ_0506
prompt ==============================================
prompt
create or replace procedure cisp_map_yyb_zjzh_rzrq_0506
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  a3-1:ʽ˻(ʻ)(ͶӰetl:T_ETL_ZJZH)
-- RETURN:
-- AUTHOR:       hucc
-- CREATE DATE:  2012/05/26
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
  v_begindate    number;
  v_enddate      number;
begin
   delete from  t_etl_yyb_zjzh_rzrq;

   select to_number(to_char(a005, 'yyyymmdd')),
          to_number(to_char(a006, 'yyyymmdd'))
     into v_begindate, v_enddate
     from t_b00_d004
    where a002 = 1013001
      and c001 = 1001101;
   --ʽ˻
   insert into t_etl_yyb_zjzh_rzrq( yyb, khlx, jylx, bz, sl)
     select a.branch_no as yyb,0 as khlx , 1 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('7')
             and a.branch_no not in(select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
             group by a.branch_no;
     
   insert into t_etl_yyb_zjzh_rzrq
  select a.branch_no as yyb,0 as khlx , 12 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             --and a.open_type = '2'
             and a.op_entrust_way = '7'
             and a.asset_prop in ('7')
             and a.branch_no not in(select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
             group by a.branch_no;
  commit;
--ʽ˻֤
  insert into t_etl_yyb_zjzh_rzrq
  select a.branch_no as yyb,0 as khlx , 13 jylx ,9 as bz,
  count( a.fund_account) as sl
       from  kods.rzrq_hs_his_fundaccountjour a
             where  a.init_date between v_begindate  and  v_enddate
             and a.business_flag = '1001'
             and a.asset_prop in ('7')
             and a.branch_no not in(select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
             --and a.open_type = '1'
             and a.op_entrust_way = 'O'
             group by a.branch_no;
  commit;        

   insert into t_etl_yyb_zjzh_rzrq( yyb, khlx, jylx, bz, sl)
   --ĩʽ˻
      select a.branch_no as yyb, decode(b.organ_flag,'1',1,'3',1,0) as khlx , 3 jylx ,9 as bz,
  count(distinct a.fund_account) as sl
       from  kods.rzrq_hs_fund_fundaccount a,kods.rzrq_hs_client b,kods.rzrq_hs_fund_fund c
             where   a.client_id=b.client_id
             and a.client_id = c.client_id
             and b.branch_no=b.branch_no
             and a.fundacct_status<>'3'
             and c.money_type = '0'
             and a.open_date < = v_enddate
             and b.organ_flag in ('1','0','3')
             and a.asset_prop in ('7')
             and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
             group by a.branch_no,decode(b.organ_flag,'1',1,'3',1,0) ;--Ϊ

    commit;
end;
/

prompt
prompt Creating procedure CISP_MAP_YYB_ZQZH_RZRQ_0506
prompt ==============================================
prompt
create or replace procedure cisp_map_yyb_zqzh_rzrq_0506
-- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:  a3-1:֤ȯ˻(ʻ)(ͶӰetl:t_etl_zqzh')
  -- RETURN:
  -- AUTHOR:       hucc
  -- CREATE DATE:  2012/05/26
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************
 is
  v_begindate number;
  v_enddate   number;
begin
  delete from t_etl_yyb_zqzh_rzrq;
  commit;

  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_begindate, v_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
  insert into t_etl_yyb_zqzh_rzrq
    (yyb, khlx, jylx, bz, sl)
    select t.yyb yyb,
           decode(t.organ_flag, '1', 1 ,'3' , 1 , 0) as khlx,
           1 as jylx, --̨ϵͳĿ
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.a_hs08_his_stockholderjour a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and a.init_date  between  v_begindate  and  v_enddate
               and a.business_flag in ('1104','1101')
               and a.exchange_type in ('1','2','D','H')
               and b.asset_prop in (/*'0',*/'7')
               --and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1 , '3', 1 , 0),t.bz;
     commit;
  --ĩ
  insert into t_etl_yyb_zqzh_rzrq
    (yyb, khlx, jylx, bz, sl)
    select t.yyb yyb,
           decode(t.organ_flag, '1', 1 , '3' , 1, 0) as khlx,
           3 as jylx,
           t.bz bz,
           count(distinct t.stock_account) as sl
      from (select decode(a.Exchange_Type,'1', 0,'D',2,'2',0,'H',1) as bz,c.organ_flag,a.branch_no as yyb,
                   a.stock_account
              from kods.rzrq_hs_stockholder a, kods.rzrq_hs_fund_fundaccount b,kods.rzrq_hs_client c
             where a.client_id = b.client_id
               and b.client_id = c.client_id
               and a.fund_account=b.fund_account
               and b.fundacct_status<>'3'
               and a.asset_prop in (/*'0',*/'7')
               and a.stock_account not like 'F%'
               and a.stock_account not like '001%'
               and a.stock_account not like '05%'
               and b.open_date < =v_enddate
               --and a.branch_no not in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005))
               and c.organ_flag in ('1','0','3')) t
     group by t.yyb,decode(t.organ_flag, '1', 1, '3', 1 , 0),t.bz;
  commit;
  delete from t_etl_yyb_zqzh_rzrq t where t.yyb in (select t.p001 from krcs.t_ctl_t036 t where t.a006 in(1004013,1004011,1004015,1004005));
  commit;

end;
/

prompt
prompt Creating procedure CISP_MAP_ZCFZ
prompt ================================
prompt
create or replace procedure cisp_map_zcfz
-- *************************************************************************
-- SYSTEM:       ϵͳ
-- SUBSYS:
-- PROGRAM:
-- DESCRIPTION:  ʲծܱ
-- RETURN:
-- AUTHOR:       gaoj
-- CREATE DATE:  2014/8/12
-- COPYRIGHT:
-- VERSION:
-- EDIT HISTORY:
-- *************************************************************************
is
begin

   cisp_process_cwdata_unfi('B1-1','t_etl_zcfz','0','1');
    delete from t_etl_zcfz;

    insert into t_etl_zcfz(xm,qmye,ncye)
    select t.proid,sum(t.endbalance),sum(t.ncbalance)
    from t_etl_biz_data t
    where t.reportid='B1-1'
    group by t.proid;
    commit;

    --ʲϼ
    insert into t_etl_zcfz(xm,qmye,ncye)
    select 1380,sum(qmye),sum(ncye)
    from t_etl_zcfz
    where xm in(  1010,  --ʽ
      1060,  --㱸
      1100,  --ʽ
      1110,  --ڳʽ
      1120,  --Խʲ
      1140,  --ʲ
      1150,  --뷵۽ʲ
      1180,  --ӦϢ
      1190,  --֤
      1230,  --ɹ۽ʲ
      1240,  --Ͷ
      1250,  --ڹȨͶ
      1260,  --ͶԷز
      1270,  --̶ʲ
      1290,  --ʲ
      1300,  --
      1310,  --˰ʲ
      1320  --ʲ
     );

commit;
     --븺ծϼ
     insert into t_etl_zcfz(xm,qmye,ncye)
     select 1660,sum(qmye),sum(ncye)
     from t_etl_zcfz
     where xm in(  1390,  --ڽ
      1420,  --ʽ
      1440,  --Խڸծ
      1450,  --ڸծ
      1460,  --عʲ
      1480,  --֤ȯ
      1490,  --ý״֤ȯ
      1500,  --֤ȯ
      1510,  --Ӧְн
      1520,  --Ӧ˰
      1530,  --ӦϢ
      1540,  --ԤƸծ
      1550,  --ڽ
      1560,  --Ӧծȯ
      1590,  --˰ծ
      1600,  --ծ
      1630
     );

commit;
   -- Ȩϼ
   insert into t_etl_zcfz(xm,qmye,ncye)
   select 1760,sum(decode(xm,1700,-qmye,qmye)),sum(decode(xm,1700,-ncye,ncye))
   from t_etl_zcfz
   where xm in(  1670,  --ʵʱ
    1690,  --ʱ
    1700,  --
    1710,  --ӯ๫
    1720,  --һ׼
    1730,  --׷׼
    1740,  --δ
    1750  --ұ
   );
commit;
   -- ծȨϼ
   insert into t_etl_zcfz(xm,qmye,ncye)
   select 1770,sum(qmye),sum(ncye)
   from t_etl_zcfz
   where xm in(  1660,  --ծϼ
                1760  --Ȩϼ
   );
commit;

cisp_etl_zcfz;
commit;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1105010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1105010
(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1105010 and a008 in
           (select p001
              from krcs.t_ctl_t036
             where a008 = 1023002
               and w100 =v_org and b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Ϣδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_b0 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

       insert into t_csrc0707_b0(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              UPID    ,
              USERNAME,
              G8      ,
              C11     ,
              G11     ,
              K11     ,
              C13     ,
              G13     ,
              C15     ,
              F15     ,
              I15     ,
              L15     ,
              C17     ,
              F17     ,
              I17     ,
              L17     ,
              D21     ,
              C19     ,
              I19
       )
       select BBQ,
              v_USER,
              0,
              null,
              0,
              UPID    ,
              USERNAME,
              G8      ,
              C11     ,
              G11     ,
              K11     ,
              C13     ,
              G13     ,
              C15     ,
              F15     ,
              I15     ,
              L15     ,
              C17     ,
              F17     ,
              I17     ,
              L17     ,
              D21     ,
              C19     ,
              I19
         from t_csrc0707_b0
        where BBQ = v_P001 and userid in
           (select p001
              from krcs.t_ctl_t036
             where a008 = 1023002
               and w100 =v_org and b001=1001101);



    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,a020=v_KJAXUSER WHERE P001=1105010 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1105010;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1105010 and a008 =v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1105010!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1105020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1105020
(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

       select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1105020 and a008 in
           (select p001
              from krcs.t_ctl_t036
             where a008 = 1023002
               and w100 =v_org and b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʾδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_b1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

       insert into t_csrc0707_b1(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              B3      ,
              C3      ,
              B4      ,
              C4      ,
              B6      ,
              C6      ,
              B7      ,
              C7      ,
              B9      ,
              C9      ,
              B10     ,
              C10     ,
              B13     ,
              C13     ,
              B14     ,
              C14     ,
              B16     ,
              C16     ,
              B17     ,
              C17     ,
              B19     ,
              C19     ,
              B20     ,
              C20     ,
              B22     ,
              C22     ,
              B23     ,
              C23     ,
              B25     ,
              C25     ,
              B26     ,
              C26     ,
              B28     ,
              C28     ,
              B29     ,
              C29     ,
              B30     ,
              C30     ,
              B32     ,
              C32     ,
              B33     ,
              C33     ,
              B35     ,
              C35     ,
              B36     ,
              C36     ,
              B38     ,
              C38     ,
              B39     ,
              C39     ,
              B41     ,
              C41     ,
              B42     ,
              C42     ,
              B44     ,
              C44     ,
              B45     ,
              C45     ,
              B47     ,
              C47     ,
              B48     ,
              C48
       )
       select BBQ,
              v_USER,
              0,
              null,
              0,
              B3      ,
              C3      ,
              B4      ,
              C4      ,
              B6      ,
              C6      ,
              B7      ,
              C7      ,
              B9      ,
              C9      ,
              B10     ,
              C10     ,
              B13     ,
              C13     ,
              B14     ,
              C14     ,
              B16     ,
              C16     ,
              B17     ,
              C17     ,
              B19     ,
              C19     ,
              B20     ,
              C20     ,
              B22     ,
              C22     ,
              B23     ,
              C23     ,
              B25     ,
              C25     ,
              B26     ,
              C26     ,
              B28     ,
              C28     ,
              B29     ,
              C29     ,
              B30     ,
              C30     ,
              B32     ,
              C32     ,
              B33     ,
              C33     ,
              B35     ,
              C35     ,
              B36     ,
              C36     ,
              B38     ,
              C38     ,
              B39     ,
              C39     ,
              B41     ,
              C41     ,
              B42     ,
              C42     ,
              B44     ,
              C44     ,
              B45     ,
              C45     ,
              B47     ,
              C47     ,
              B48     ,
              C48
         from t_csrc0707_b1
        where BBQ = v_P001 and userid in
           (select p001
              from krcs.t_ctl_t036
             where a008 = 1023002
               and w100 =v_org and b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1105020 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1105020;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1105020 and a008 = v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1105020!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1105030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1105030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      select p002 into v_orgfrom krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1105030 and a008 in
           (select p001
              from krcs.t_ctl_t036
             where a008 = 1023002
               and w100 =v_org and b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ҵδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_b2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

       insert into t_csrc0707_b2(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              B2 ,
              C2 ,
              D2 ,
              E2 ,
              B3 ,
              C3 ,
              D3 ,
              E3 ,
              B4 ,
              C4 ,
              D4 ,
              E4 ,
              B5 ,
              C5 ,
              D5 ,
              E5 ,
              B6 ,
              C6 ,
              D6 ,
              E6 ,
              B7 ,
              C7 ,
              D7 ,
              E7 ,
              B8 ,
              C8 ,
              D8 ,
              E8 ,
              B9 ,
              C9 ,
              D9 ,
              E9 ,
              B10,
              C10,
              D10,
              E10,
              B11,
              C11,
              D11,
              E11,
              B12,
              C12,
              D12,
              E12,
              B13,
              C13,
              D13,
              E13,
              B14,
              C14,
              D14,
              E14,
              B15,
              C15,
              D15,
              E15,
              B16,
              C16,
              D16,
              E16,
              B17,
              C17,
              D17,
              E17,
              B18,
              C18,
              D18,
              E18,
              B19,
              C19,
              D19,
              E19,
              B20,
              C20,
              D20,
              E20,
              B21,
              C21,
              D21,
              E21,
              B22,
              C22,
              D22,
              E22,
              B23,
              C23,
              D23,
              E23,
              B24,
              C24,
              D24,
              E24,
              B25,
              C25,
              D25,
              E25,
              B26,
              C26,
              D26,
              E26,
              B27,
              C27,
              D27,
              E27,
              B28,
              C28,
              D28,
              E28,
              B29,
              C29,
              D29,
              E29,
              B30,
              C30,
              D30,
              E30,
              B31,
              C31,
              D31,
              E31,
              B32,
              C32,
              D32,
              E32,
              B33,
              C33,
              D33,
              E33
       )
       select BBQ,
              v_USER,
              0,
              null,
              0,
              B2 ,
              C2 ,
              D2 ,
              E2 ,
              B3 ,
              C3 ,
              D3 ,
              E3 ,
              B4 ,
              C4 ,
              D4 ,
              E4 ,
              B5 ,
              C5 ,
              D5 ,
              E5 ,
              B6 ,
              C6 ,
              D6 ,
              E6 ,
              B7 ,
              C7 ,
              D7 ,
              E7 ,
              B8 ,
              C8 ,
              D8 ,
              E8 ,
              B9 ,
              C9 ,
              D9 ,
              E9 ,
              B10,
              C10,
              D10,
              E10,
              B11,
              C11,
              D11,
              E11,
              B12,
              C12,
              D12,
              E12,
              B13,
              C13,
              D13,
              E13,
              B14,
              C14,
              D14,
              E14,
              B15,
              C15,
              D15,
              E15,
              B16,
              C16,
              D16,
              E16,
              B17,
              C17,
              D17,
              E17,
              B18,
              C18,
              D18,
              E18,
              B19,
              C19,
              D19,
              E19,
              B20,
              C20,
              D20,
              E20,
              B21,
              C21,
              D21,
              E21,
              B22,
              C22,
              D22,
              E22,
              B23,
              C23,
              D23,
              E23,
              B24,
              C24,
              D24,
              E24,
              B25,
              C25,
              D25,
              E25,
              B26,
              C26,
              D26,
              E26,
              B27,
              C27,
              D27,
              E27,
              B28,
              C28,
              D28,
              E28,
              B29,
              C29,
              D29,
              E29,
              B30,
              C30,
              D30,
              E30,
              B31,
              C31,
              D31,
              E31,
              B32,
              C32,
              D32,
              E32,
              B33,
              C33,
              D33,
              E33
         from t_csrc0707_b2
        where BBQ = v_P001 and userid in
           (select p001
              from krcs.t_ctl_t036
             where a008 = 1023002
               and w100 =v_org and b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1105030 and  a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1105030;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1105030 and  a008 = v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1105030!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110010(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
						                                       v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

     select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from KRCS.t_sys_t024
   where a011 = 1009002
     and p001 = 1110010
     and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'A1-1 ʱδͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC1226_A1_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC1226_A1_1
    (BBQ,
USERID,
BTYPE,
OPTION1,
SHTAG,
M3,
N3,
P3,
Q3,
M4,
N4,
P4,
Q4,
M5,
N5,
P5,
Q5,
M6,
N6,
P6,
Q6,
M7,
N7,
P7,
Q7,
M8,
N8,
P8,
Q8,
M9,
N9,
P9,
Q9,
M10,
N10,
P10,
Q10,
M11,
N11,
P11,
Q11,
M12,
N12,
P12,
Q12,
M13,
N13,
P13,
Q13,
M14,
N14,
P14,
Q14,
M15,
N15,
P15,
Q15,
M16,
N16,
P16,
Q16,
M17,
N17,
P17,
Q17,
M18,
N18,
P18,
Q18,
M19,
N19,
P19,
Q19,
M20,
N20,
P20,
Q20,
M21,
N21,
P21,
Q21,
M22,
N22,
P22,
Q22,
M23,
N23,
P23,
Q23,
M24,
N24,
P24,
Q24,
M25,
N25,
P25,
Q25,
M26,
N26,
P26,
Q26,
M27,
N27,
P27,
Q27,
M28,
N28,
P28,
Q28,
M29,
N29,
P29,
Q29,
M30,
N30,
P30,
Q30,
M31,
N31,
P31,
Q31,
M32,
N32,
P32,
Q32,
M33,
N33,
O33,
P33,
Q33,
M34,
N34,
P34,
Q34,
M35,
N35,
P35,
Q35,
M36,
N36,
P36,
Q36,
M37,
N37,
P37,
Q37,
M38,
N38,
P38,
Q38,
M39,
N39,
P39,
Q39,
M40,
N40,
P40,
Q40,
M41,
N41,
P41,
Q41,
M42,
N42,
P42,
Q42,
M43,
N43,
P43,
Q43,
M44,
N44,
P44,
Q44,
M45,
N45,
P45,
Q45,
M46,
N46,
P46,
Q46,
M47,
N47,
P47,
Q47,
M48,
N48,
P48,
Q48,
M49,
N49,
O49,
P49,
Q49,
M50,
N50,
P50,
Q50,
M51,
N51,
P51,
Q51,
M52,
N52,
P52,
Q52,
M53,
N53,
P53,
Q53,
M54,
N54,
P54,
Q54,
M55,
N55,
P55,
Q55,
M56,
N56,
P56,
Q56,
M57,
N57,
P57,
Q57,
M58,
N58,
P58,
Q58,
M59,
N59,
P59,
Q59,
M60,
N60,
P60,
Q60,
M61,
N61,
P61,
Q61,
M62,
N62,
P62,
Q62,
M63,
N63,
P63,
Q63,
M64,
N64,
P64,
Q64,
M65,
N65,
P65,
Q65,
M66,
N66,
P66,
Q66,
M67,
N67,
P67,
Q67,
M68,
N68,
P68,
Q68,
M69,
N69,
P69,
Q69,
M70,
N70,
P70,
Q70,
M71,
N71,
P71,
Q71,
M72,
N72,
P72,
Q72,
M73,
N73,
P73,
Q73,
M74,
N74,
P74,
Q74,
M75,
N75,
P75,
Q75,
M76,
N76,
P76,
Q76,
M77,
N77,
P77,
Q77,
M78,
N78,
P78,
Q78,
M79,
N79,
P79,
Q79,
M80,
N80,
P80,
Q80,
M81,
N81,
P81,
Q81,
M82,
N82,
O82,
P82,
Q82,
M83,
N83,
P83,
Q83,
M84,
N84,
P84,
Q84,
M85,
N85,
O85,
P85,
Q85,
M86,
N86,
P86,
Q86,
M87,
N87,
O87,
P87,
Q87,
M88,
N88,
O88,
P88,
Q88,
M89,
N89,
P89,
Q89,
A91,
A93)
    select BBQ,
           v_USER,
           0,
           null,
           0,
M3,
N3,
P3,
Q3,
M4,
N4,
P4,
Q4,
M5,
N5,
P5,
Q5,
M6,
N6,
P6,
Q6,
M7,
N7,
P7,
Q7,
M8,
N8,
P8,
Q8,
M9,
N9,
P9,
Q9,
M10,
N10,
P10,
Q10,
M11,
N11,
P11,
Q11,
M12,
N12,
P12,
Q12,
M13,
N13,
P13,
Q13,
M14,
N14,
P14,
Q14,
M15,
N15,
P15,
Q15,
M16,
N16,
P16,
Q16,
M17,
N17,
P17,
Q17,
M18,
N18,
P18,
Q18,
M19,
N19,
P19,
Q19,
M20,
N20,
P20,
Q20,
M21,
N21,
P21,
Q21,
M22,
N22,
P22,
Q22,
M23,
N23,
P23,
Q23,
M24,
N24,
P24,
Q24,
M25,
N25,
P25,
Q25,
M26,
N26,
P26,
Q26,
M27,
N27,
P27,
Q27,
M28,
N28,
P28,
Q28,
M29,
N29,
P29,
Q29,
M30,
N30,
P30,
Q30,
M31,
N31,
P31,
Q31,
M32,
N32,
P32,
Q32,
M33,
N33,
O33,
P33,
Q33,
M34,
N34,
P34,
Q34,
M35,
N35,
P35,
Q35,
M36,
N36,
P36,
Q36,
M37,
N37,
P37,
Q37,
M38,
N38,
P38,
Q38,
M39,
N39,
P39,
Q39,
M40,
N40,
P40,
Q40,
M41,
N41,
P41,
Q41,
M42,
N42,
P42,
Q42,
M43,
N43,
P43,
Q43,
M44,
N44,
P44,
Q44,
M45,
N45,
P45,
Q45,
M46,
N46,
P46,
Q46,
M47,
N47,
P47,
Q47,
M48,
N48,
P48,
Q48,
M49,
N49,
O49,
P49,
Q49,
M50,
N50,
P50,
Q50,
M51,
N51,
P51,
Q51,
M52,
N52,
P52,
Q52,
M53,
N53,
P53,
Q53,
M54,
N54,
P54,
Q54,
M55,
N55,
P55,
Q55,
M56,
N56,
P56,
Q56,
M57,
N57,
P57,
Q57,
M58,
N58,
P58,
Q58,
M59,
N59,
P59,
Q59,
M60,
N60,
P60,
Q60,
M61,
N61,
P61,
Q61,
M62,
N62,
P62,
Q62,
M63,
N63,
P63,
Q63,
M64,
N64,
P64,
Q64,
M65,
N65,
P65,
Q65,
M66,
N66,
P66,
Q66,
M67,
N67,
P67,
Q67,
M68,
N68,
P68,
Q68,
M69,
N69,
P69,
Q69,
M70,
N70,
P70,
Q70,
M71,
N71,
P71,
Q71,
M72,
N72,
P72,
Q72,
M73,
N73,
P73,
Q73,
M74,
N74,
P74,
Q74,
M75,
N75,
P75,
Q75,
M76,
N76,
P76,
Q76,
M77,
N77,
P77,
Q77,
M78,
N78,
P78,
Q78,
M79,
N79,
P79,
Q79,
M80,
N80,
P80,
Q80,
M81,
N81,
P81,
Q81,
M82,
N82,
O82,
P82,
Q82,
M83,
N83,
P83,
Q83,
M84,
N84,
P84,
Q84,
M85,
N85,
O85,
P85,
Q85,
M86,
N86,
P86,
Q86,
M87,
N87,
O87,
P87,
Q87,
M88,
N88,
O88,
P88,
Q88,
M89,
N89,
P89,
Q89,
A91,
A93
      from T_CSRC1226_A1_1
     where BBQ = v_P001 and userid in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1110010  and a008 = v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>A1-1' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1110010;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1110010  and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1110010!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110020(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
						                                        v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

   select p002 into v_orgfrom krcs.t_sys_user where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from KRCS.t_sys_t024
   where a011 = 1009002
     and p001 = 1110020 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'A2-1 տָܱδͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC1226_A2_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1226_A2_1
    (  BBQ,
  USERID,
  BTYPE,
  OPTION1,
  SHTAG,
  C2,
  D2,
  E2,
  F2,
  G2,
  C3,
  D3,
  E3,
  F3,
  G3,
  C4,
  D4,
  G4,
  C5,
  D5,
  G5,
  C6,
  D6,
  G6,
  C7,
  D7,
  G7,
  C8,
  D8,
  G8,
  C9,
  D9,
  G9,
  C10,
  D10,
  G10,
  A12,
  C12,
  D12,
  E12,
  F12,
  G12,
  A13,
  C13,
  D13,
  E13,
  F13,
  G13,
  A14,
  C14,
  D14,
  E14,
  F14,
  G14,
  A15,
  C15,
  D15,
  E15,
  F15,
  G15,
  A16,
  C16,
  D16,
  E16,
  F16,
  G16,
  C17,
  D17,
  G17,
  A19,
  C19,
  D19,
  E19,
  F19,
  G19,
  A20,
  C20,
  D20,
  E20,
  F20,
  G20,
  A21,
  C21,
  D21,
  E21,
  F21,
  G21,
  A22,
  C22,
  D22,
  E22,
  F22,
  G22,
  A23,
  C23,
  D23,
  E23,
  F23,
  G23,
  C24,
  D24,
  G24,
  A26,
  C26,
  D26,
  E26,
  F26,
  G26,
  A27,
  C27,
  D27,
  E27,
  F27,
  G27,
  A28,
  C28,
  D28,
  E28,
  F28,
  G28,
  A29,
  C29,
  D29,
  E29,
  F29,
  G29,
  A30,
  C30,
  D30,
  E30,
  F30,
  G30,
  C31,
  D31,
  G31,
  A33,
  C33,
  D33,
  E33,
  F33,
  G33,
  A34,
  C34,
  D34,
  E34,
  F34,
  G34,
  A35,
  C35,
  D35,
  E35,
  F35,
  G35,
  A36,
  C36,
  D36,
  E36,
  F36,
  G36,
  A37,
  C37,
  D37,
  E37,
  F37,
  G37,
  C38,
  D38,
  G38,
  A40,
  C40,
  D40,
  E40,
  F40,
  G40,
  A41,
  C41,
  D41,
  E41,
  F41,
  G41,
  A42,
  C42,
  D42,
  E42,
  F42,
  G42,
  A43,
  C43,
  D43,
  E43,
  F43,
  G43,
  A44,
  C44,
  D44,
  E44,
  F44,
  G44,
  C45,
  D45,
  G45,
  A47,
  C47,
  D47,
  E47,
  F47,
  G47,
  A48,
  C48,
  D48,
  E48,
  F48,
  G48,
  A49,
  C49,
  D49,
  E49,
  F49,
  G49,
  A50,
  C50,
  D50,
  E50,
  F50,
  G50,
  A51,
  C51,
  D51,
  E51,
  F51,
  G51 )
    select BBQ,
           v_USER,
           0,
           null,
           0,
           C2,
  D2,
  E2,
  F2,
  G2,
  C3,
  D3,
  E3,
  F3,
  G3,
  C4,
  D4,
  G4,
  C5,
  D5,
  G5,
  C6,
  D6,
  G6,
  C7,
  D7,
  G7,
  C8,
  D8,
  G8,
  C9,
  D9,
  G9,
  C10,
  D10,
  G10,
  A12,
  C12,
  D12,
  E12,
  F12,
  G12,
  A13,
  C13,
  D13,
  E13,
  F13,
  G13,
  A14,
  C14,
  D14,
  E14,
  F14,
  G14,
  A15,
  C15,
  D15,
  E15,
  F15,
  G15,
  A16,
  C16,
  D16,
  E16,
  F16,
  G16,
  C17,
  D17,
  G17,
  A19,
  C19,
  D19,
  E19,
  F19,
  G19,
  A20,
  C20,
  D20,
  E20,
  F20,
  G20,
  A21,
  C21,
  D21,
  E21,
  F21,
  G21,
  A22,
  C22,
  D22,
  E22,
  F22,
  G22,
  A23,
  C23,
  D23,
  E23,
  F23,
  G23,
  C24,
  D24,
  G24,
  A26,
  C26,
  D26,
  E26,
  F26,
  G26,
  A27,
  C27,
  D27,
  E27,
  F27,
  G27,
  A28,
  C28,
  D28,
  E28,
  F28,
  G28,
  A29,
  C29,
  D29,
  E29,
  F29,
  G29,
  A30,
  C30,
  D30,
  E30,
  F30,
  G30,
  C31,
  D31,
  G31,
  A33,
  C33,
  D33,
  E33,
  F33,
  G33,
  A34,
  C34,
  D34,
  E34,
  F34,
  G34,
  A35,
  C35,
  D35,
  E35,
  F35,
  G35,
  A36,
  C36,
  D36,
  E36,
  F36,
  G36,
  A37,
  C37,
  D37,
  E37,
  F37,
  G37,
  C38,
  D38,
  G38,
  A40,
  C40,
  D40,
  E40,
  F40,
  G40,
  A41,
  C41,
  D41,
  E41,
  F41,
  G41,
  A42,
  C42,
  D42,
  E42,
  F42,
  G42,
  A43,
  C43,
  D43,
  E43,
  F43,
  G43,
  A44,
  C44,
  D44,
  E44,
  F44,
  G44,
  C45,
  D45,
  G45,
  A47,
  C47,
  D47,
  E47,
  F47,
  G47,
  A48,
  C48,
  D48,
  E48,
  F48,
  G48,
  A49,
  C49,
  D49,
  E49,
  F49,
  G49,
  A50,
  C50,
  D50,
  E50,
  F50,
  G50,
  A51,
  C51,
  D51,
  E51,
  F51,
  G51
      from T_CSRC1226_A2_1
     where BBQ = v_P001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1110020 and a008=v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>A2-1' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1110020;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1110020 and a008=v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1110020!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from KRCS.T_SYS_USER T1,
              KRCS.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	   select p002 into v_orgfrom krcs.t_sys_user where p001=v_KJAXUSER;

        select count(*) into v_count from KRCS.t_sys_t024 where a011=1009002 and p001=1110030 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='A2-2 ʱ׼δͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC1226_A2_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

insert into T_CSRC1226_A2_2
  (  BBQ,
  USERID,
  BTYPE,
  OPTION1,
  SHTAG ,
  D1,
  O4,
  P4,
  H5,
  I5,
  O5,
  P5,
  O6,
  P6,
  H7,
  I7,
  O7,
  P7,
  H8,
  I8,
  O8,
  P8,
  H9,
  I9,
  O9,
  P9,
  H10,
  I10,
  O10,
  P10,
  H11,
  I11,
  O11,
  P11,
  H12,
  I12,
  O12,
  P12,
  H13,
  I13,
  O13,
  P13,
  H14,
  I14,
  O14,
  P14,
  H15,
  I15,
  O15,
  P15,
  H16,
  I16,
  O16,
  P16,
  H17,
  I17,
  O17,
  P17,
  H18,
  I18,
  O18,
  P18,
  H19,
  I19,
  O19,
  P19,
  H20,
  I20,
  O20,
  P20,
  H21,
  I21,
  O21,
  P21,
  H22,
  I22,
  O22,
  P22,
  H23,
  I23,
  O23,
  P23,
  H24,
  I24,
  O24,
  P24,
  H25,
  I25,
  O25,
  P25,
  H26,
  I26,
  O26,
  P26,
  H27,
  I27,
  O27,
  P27,
  H28,
  I28,
  O28,
  P28,
  H29,
  I29,
  O29,
  P29,
  H30,
  I30,
  O30,
  P30,
  H31,
  I31,
  O31,
  P31,
  H32,
  I32,
  O32,
  P32,
  H33,
  I33,
  O33,
  P33,
  H34,
  I34,
  O34,
  P34,
  H35,
  I35,
  O35,
  P35,
  H36,
  I36,
  O36,
  P36,
  H37,
  I37,
  O37,
  P37,
  H38,
  I38,
  O38,
  P38,
  H39,
  I39,
  O39,
  P39,
  H40,
  I40,
  O40,
  P40,
  H41,
  I41,
  O41,
  P41,
  O42,
  P42,
  H43,
  I43,
  O43,
  P43,
  H44,
  I44,
  O44,
  P44,
  H45,
  I45,
  O45,
  P45,
  H46,
  I46,
  O46,
  P46,
  O47,
  P47,
  H48,
  I48,
  O48,
  P48,
  H49,
  I49,
  O49,
  P49,
  H50,
  I50,
  O50,
  P50,
  H51,
  I51,
  O51,
  P51,
  O52,
  P52,
  H53,
  I53,
  O53,
  P53,
  H54,
  I54,
  O54,
  P54,
  O55,
  P55,
  H56,
  I56,
  O56,
  P56,
  H57,
  I57,
  O57,
  P57,
  O58,
  P58,
  H59,
  I59,
  O59,
  P59,
  H60,
  I60,
  O60,
  P60,
  H61,
  I61,
  O61,
  P61,
  H62,
  I62,
  O62,
  P62,
  H63,
  I63,
  O63,
  P63,
  O64,
  P64,
  A66
)
  select BBQ,
         v_USER,
         0,
         null,
         0,
         D1,
  O4,
  P4,
  H5,
  I5,
  O5,
  P5,
  O6,
  P6,
  H7,
  I7,
  O7,
  P7,
  H8,
  I8,
  O8,
  P8,
  H9,
  I9,
  O9,
  P9,
  H10,
  I10,
  O10,
  P10,
  H11,
  I11,
  O11,
  P11,
  H12,
  I12,
  O12,
  P12,
  H13,
  I13,
  O13,
  P13,
  H14,
  I14,
  O14,
  P14,
  H15,
  I15,
  O15,
  P15,
  H16,
  I16,
  O16,
  P16,
  H17,
  I17,
  O17,
  P17,
  H18,
  I18,
  O18,
  P18,
  H19,
  I19,
  O19,
  P19,
  H20,
  I20,
  O20,
  P20,
  H21,
  I21,
  O21,
  P21,
  H22,
  I22,
  O22,
  P22,
  H23,
  I23,
  O23,
  P23,
  H24,
  I24,
  O24,
  P24,
  H25,
  I25,
  O25,
  P25,
  H26,
  I26,
  O26,
  P26,
  H27,
  I27,
  O27,
  P27,
  H28,
  I28,
  O28,
  P28,
  H29,
  I29,
  O29,
  P29,
  H30,
  I30,
  O30,
  P30,
  H31,
  I31,
  O31,
  P31,
  H32,
  I32,
  O32,
  P32,
  H33,
  I33,
  O33,
  P33,
  H34,
  I34,
  O34,
  P34,
  H35,
  I35,
  O35,
  P35,
  H36,
  I36,
  O36,
  P36,
  H37,
  I37,
  O37,
  P37,
  H38,
  I38,
  O38,
  P38,
  H39,
  I39,
  O39,
  P39,
  H40,
  I40,
  O40,
  P40,
  H41,
  I41,
  O41,
  P41,
  O42,
  P42,
  H43,
  I43,
  O43,
  P43,
  H44,
  I44,
  O44,
  P44,
  H45,
  I45,
  O45,
  P45,
  H46,
  I46,
  O46,
  P46,
  O47,
  P47,
  H48,
  I48,
  O48,
  P48,
  H49,
  I49,
  O49,
  P49,
  H50,
  I50,
  O50,
  P50,
  H51,
  I51,
  O51,
  P51,
  O52,
  P52,
  H53,
  I53,
  O53,
  P53,
  H54,
  I54,
  O54,
  P54,
  O55,
  P55,
  H56,
  I56,
  O56,
  P56,
  H57,
  I57,
  O57,
  P57,
  O58,
  P58,
  H59,
  I59,
  O59,
  P59,
  H60,
  I60,
  O60,
  P60,
  H61,
  I61,
  O61,
  P61,
  H62,
  I62,
  O62,
  P62,
  H63,
  I63,
  O63,
  P63,
  O64,
  P64,
  A66
    from T_CSRC1226_A2_2
   where BBQ = v_P001  and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1110030 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>A2-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1110030;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;



end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from KRCS.T_SYS_USER T1,
              KRCS.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	 select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from KRCS.t_sys_t024 where a011=1009002 and p001=1110040 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ͻ׽ʽȫԼܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_A3_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_A3_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           C4  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           C5  ,
           D5  ,
           E5  ,
           F5  ,
           G5  ,
           C6  ,
           D6  ,
           E6  ,
           F6  ,
           G6  ,
           C9  ,
           D9  ,
           E9  ,
           F9  ,
           G9  ,
           C10 ,
           D10 ,
           E10 ,
           F10 ,
           G10 ,
           C11 ,
           D11 ,
           E11 ,
           F11 ,
           G11 ,
           C12 ,
           D12 ,
           E12 ,
           F12 ,
           G12 ,
           C13 ,
           D13 ,
           E13 ,
           F13 ,
           G13 ,
           C16 ,
           D16 ,
           E16 ,
           F16 ,
           G16 ,
           C17 ,
           D17 ,
           E17 ,
           F17 ,
           G17 ,
           C18 ,
           D18 ,
           E18 ,
           F18 ,
           G18 ,
           C19 ,
           D19 ,
           E19 ,
           F19 ,
           G19 ,
           C21 ,
           D21 ,
           E21 ,
           F21 ,
           G21 ,
           C22 ,
           D22 ,
           E22 ,
           F22 ,
           G22 ,
           C23 ,
           D23 ,
           E23 ,
           F23 ,
           G23 ,
           C24 ,
           D24 ,
           E24 ,
           F24 ,
           G24 ,
           C25 ,
           D25 ,
           E25 ,
           F25 ,
           G25 ,
           C26 ,
           D26 ,
           E26 ,
           F26 ,
           G26 ,
           C27 ,
           D27 ,
           E27 ,
           F27 ,
           G27 ,
           C28 ,
           D28 ,
           E28 ,
           F28 ,
           G28 ,
           C29 ,
           D29 ,
           E29 ,
           F29 ,
           G29 ,
           C31 ,
           D31 ,
           E31 ,
           F31 ,
           G31 ,
           C34 ,
           D34 ,
           E34 ,
           F34 ,
           G34 ,
           C35 ,
           D35 ,
           E35 ,
           F35 ,
           G35 ,
           C36 ,
           D36 ,
           E36 ,
           F36 ,
           G36 ,
           C37 ,
           D37 ,
           E37 ,
           F37 ,
           G37 ,
           C38 ,
           D38 ,
           E38 ,
           F38 ,
           G38
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(C4)  ,
           sum(D4)  ,
           sum(E4)  ,
           sum(F4)  ,
           substrb(catstr(G4),1,255)  ,
           sum(C5)  ,
           sum(D5)  ,
           sum(E5)  ,
           sum(F5)  ,
           substrb(catstr(G5),1,255)  ,
           sum(C6)  ,
           sum(D6)  ,
           sum(E6)  ,
           sum(F6)  ,
           substrb(catstr(G6),1,255)  ,
           sum(C9)  ,
           sum(D9)  ,
           sum(E9)  ,
           sum(F9)  ,
           substrb(catstr(G9),1,255)  ,
           sum(C10) ,
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           substrb(catstr(G10),1,255) ,
           sum(C11) ,
           sum(D11) ,
           sum(E11) ,
           sum(F11) ,
           substrb(catstr(G11),1,255) ,
           sum(C12) ,
           sum(D12) ,
           sum(E12) ,
           sum(F12) ,
           substrb(catstr(G12),1,255) ,
           sum(C13) ,
           sum(D13) ,
           sum(E13) ,
           sum(F13) ,
           substrb(catstr(G13),1,255) ,
           sum(C16) ,
           sum(D16) ,
           sum(E16) ,
           sum(F16) ,
           substrb(catstr(G16),1,255) ,
           sum(C17) ,
           sum(D17) ,
           sum(E17) ,
           sum(F17) ,
           substrb(catstr(G17),1,255) ,
           sum(C18) ,
           sum(D18) ,
           sum(E18) ,
           sum(F18) ,
           substrb(catstr(G18),1,255) ,
           sum(C19) ,
           sum(D19) ,
           sum(E19) ,
           sum(F19) ,
           substrb(catstr(G19),1,255) ,
           sum(C21) ,
           sum(D21) ,
           sum(E21) ,
           sum(F21) ,
           substrb(catstr(G21),1,255) ,
           sum(C22) ,
           sum(D22) ,
           sum(E22) ,
           sum(F22) ,
           substrb(catstr(G22),1,255) ,
           sum(C23) ,
           sum(D23) ,
           sum(E23) ,
           sum(F23) ,
           substrb(catstr(G23),1,255) ,
           sum(C24) ,
           sum(D24) ,
           sum(E24) ,
           sum(F24) ,
           substrb(catstr(G24),1,255) ,
           sum(C25) ,
           sum(D25) ,
           sum(E25) ,
           sum(F25) ,
           substrb(catstr(G25),1,255) ,
           sum(C26) ,
           sum(D26) ,
           sum(E26) ,
           sum(F26) ,
           substrb(catstr(G26),1,255) ,
           sum(C27) ,
           sum(D27) ,
           sum(E27) ,
           sum(F27) ,
           substrb(catstr(G27),1,255) ,
           sum(C28) ,
           sum(D28) ,
           sum(E28) ,
           sum(F28) ,
           substrb(catstr(G28),1,255),
           sum(C29) ,
           sum(D29) ,
           sum(E29) ,
           sum(F29) ,
           substrb(catstr(G29),1,255) ,
           sum(C31) ,
           sum(D31) ,
           sum(E31) ,
           sum(F31) ,
           substrb(catstr(G31),1,255) ,
           sum(C34) ,
           sum(D34) ,
           sum(E34) ,
           sum(F34) ,
           substrb(catstr(G34),1,255) ,
           sum(C35) ,
           sum(D35) ,
           sum(E35) ,
           sum(F35) ,
           substrb(catstr(G35),1,255) ,
           sum(C36) ,
           sum(D36) ,
           sum(E36) ,
           sum(F36) ,
           substrb(catstr(G36),1,255) ,
           sum(C37) ,
           sum(D37) ,
           sum(E37) ,
           sum(F37) ,
           substrb(catstr(G37),1,255) ,
           sum(C38) ,
           sum(D38) ,
           sum(E38) ,
           sum(F38),
           substrb(catstr(G38),1,255)
         from T_CSRC0707_A3_1
        where BBQ = v_P001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1110040 and  a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>A3-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1110040;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_task);
    commit;

    exception when others then
                rollback;
               update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=1110040 and  a008 = v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1110040!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110050
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110050(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
						                                        v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from KRCS.t_sys_t024
   where a011 = 1009002
     and p001 = 1110050 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'A4-1 ԸʣLCRδͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC0320_A4_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0320_A4_1
     (BBQ,
      USERID,
      BTYPE,
      OPTION1,
      SHTAG,
      C2,
      D2,
      E2,
      C3,
      E3,
      C4,
      E4,
      C5,
      E5,
      C6,
      E6,
      C7,
      E7,
      C8,
      E8,
      C9,
      E9,
      C10,
      E10,
      C11,
      E11,
      C12,
      E12,
      C13,
      E13,
      C14,
      E14,
      C15,
      D15,
      E15,
      C16,
      D16,
      E16,
      C17,
      D17,
      E17,
      C18,
      E18,
      C19,
      E19,
      C20,
      D20,
      E20,
      C21,
      E21,
      C22,
      E22,
      C23,
      E23,
      C24,
      E24,
      C25,
      E25,
      C26,
      E26,
      C27,
      E27,
      C28,
      E28,
      C29,
      E29,
      C30,
      E30,
      C31,
      E31,
      C32,
      E32,
      C33,
      E33,
      C34,
      E34,
      C35,
      D35,
      E35,
      C36,
      D36,
      E36,
      C37,
      E37,
      C38,
      E38,
      C39,
      E39,
      C40,
      D40,
      E40,
      C41,
      D41,
      E41,
      C42,
      E42,
      C43,
      E43,
      C44,
      E44,
      C45,
      E45,
      C46,
      E46,
      C47,
      D47,
      E47,
      C48,
      D48,
      E48,
      C49,
      E49,
      C50,
      E50,
      C51,
      E51,
      C52,
      D52,
      E52,
      C53,
      D53,
      E53,
      C54,
      E54,
      C55,
      E55,
      C56,
      E56,
      C57,
      D57,
      E57,
      C58,
      D58,
      E58,
      C59,
      E59,
      C60,
      D60,
      E60,
      C61,
      D61,
      E61,
      C62,
      E62,
      C63,
      D63,
      E63,
      C64,
      D64,
      E64,
      C65,
      D65,
      E65,
      C66,
      E66,
      C67,
      E67,
      C68,
      E68,
      C69,
      E69,
      C70,
      E70,
      C71,
      D71,
      E71,
      C72,
      D72,
      E72,
      C73,
      E73,
      C74,
      E74,
      C75,
      D75,
      E75,
      C76,
      E76,
      C77,
      E77,
      C78,
      D78,
      E78,
      C79,
      D79,
      E79,
      E80
      )
    select BBQ,
          v_USER,
          0,
          null,
          0,
		  sum( C2 ),
		  sum(D2),
		  sum( E2 ),
		  sum( C3 ),
		  sum( E3 ),
		  sum( C4 ),
		  sum( E4 ),
		  sum( C5 ),
		  sum( E5 ),
		  sum( C6 ),
		  sum( E6 ),
		  sum( C7 ),
		  sum( E7 ),
		  sum( C8 ),
		  sum( E8 ),
		  sum( C9 ),
		  sum( E9 ),
		  sum( C10 ),
		  sum( E10 ),
		  sum( C11 ),
		  sum( E11 ),
		  sum( C12 ),
		  sum( E12 ),
		  sum( C13 ),
		  sum( E13 ),
		  sum( C14 ),
		  sum( E14 ),
		  sum( C15 ),
		  sum(D15),
		  sum( E15 ),
		  sum( C16 ),
		  sum(D16),
		  sum( E16 ),
		  sum( C17 ),
		  sum(D17),
		  sum( E17 ),
		  sum( C18 ),
		  sum( E18 ),
		  sum( C19 ),
		  sum( E19 ),
		  sum( C20 ),
		  sum(D20),
		  sum( E20 ),
		  sum( C21 ),
		  sum( E21 ),
		  sum( C22 ),
		  sum( E22 ),
		  sum( C23 ),
		  sum( E23 ),
		  sum( C24 ),
		  sum( E24 ),
		  sum( C25 ),
		  sum( E25 ),
		  sum( C26 ),
		  sum( E26 ),
		  sum( C27 ),
		  sum( E27 ),
		  sum( C28 ),
		  sum( E28 ),
		  sum( C29 ),
		  sum( E29 ),
		  sum( C30 ),
		  sum( E30 ),
		  sum( C31 ),
		  sum( E31 ),
		  sum( C32 ),
		  sum( E32 ),
		  sum( C33 ),
		  sum( E33 ),
		  sum( C34 ),
		  sum( E34 ),
		  sum( C35 ),
		  sum(D35),
		  sum( E35 ),
		  sum( C36 ),
		  sum(D36),
		  sum( E36 ),
		  sum( C37 ),
		  sum( E37 ),
		  sum( C38 ),
		  sum( E38 ),
		  sum( C39 ),
		  sum( E39 ),
		  sum( C40 ),
		  sum(D40),
		  sum( E40 ),
		  sum( C41 ),
		  sum(D41),
		  sum( E41 ),
		  sum( C42 ),
		  sum( E42 ),
		  sum( C43 ),
		  sum( E43 ),
		  sum( C44 ),
		  sum( E44 ),
		  sum( C45 ),
		  sum( E45 ),
		  sum( C46 ),
		  sum( E46 ),
		  sum( C47 ),
		  sum(D47),
		  sum( E47 ),
		  sum( C48 ),
		  sum(D48),
		  sum( E48 ),
		  sum( C49 ),
		  sum( E49 ),
		  sum( C50 ),
		  sum( E50 ),
		  sum( C51 ),
		  sum( E51 ),
		  sum( C52 ),
		  sum(D52),
		  sum( E52 ),
		  sum( C53 ),
		  sum(D53),
		  sum( E53 ),
		  sum( C54 ),
		  sum( E54 ),
		  sum( C55 ),
		  sum( E55 ),
		  sum( C56 ),
		  sum( E56 ),
		  sum( C57 ),
		  sum(D57),
		  sum( E57 ),
		  sum( C58 ),
		  sum(D58),
		  sum( E58 ),
		  sum( C59 ),
		  sum( E59 ),
		  sum( C60 ),
		  sum(D60),
		  sum( E60 ),
		  sum( C61 ),
		  sum(D61),
		  sum( E61 ),
		  sum( C62 ),
		  sum( E62 ),
		  sum( C63 ),
		  sum(D63),
		  sum( E63 ),
		  sum( C64 ),
		  sum(D64),
		  sum( E64 ),
		  sum( C65 ),
		  sum(D65),
		  sum( E65 ),
		  sum( C66 ),
		  sum( E66 ),
		  sum( C67 ),
		  sum( E67 ),
		  sum( C68 ),
		  sum( E68 ),
		  sum( C69 ),
		  sum( E69 ),
		  sum( C70 ),
		  sum( E70 ),
		  sum( C71 ),
		  sum(D71),
		  sum( E71 ),
		  sum( C72 ),
		  sum(D72),
		  sum( E72 ),
		  sum( C73 ),
		  sum( E73 ),
		  sum( C74 ),
		  sum( E74 ),
		  sum( C75 ),
		  sum(D75),
		  sum( E75 ),
		  sum( C76 ),
		  sum( E76 ),
		  sum( C77 ),
		  sum( E77 ),
		  sum( C78 ),
		  sum(D78),
		  sum( E78 ),
		  sum( C79 ),
		  sum(D79),
		  sum( E79 ),
		  sum( E80 )
		  from T_CSRC0320_A4_1
		 where BBQ = v_P001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
	 group by BBQ;

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1110050 and a008=v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>A4-1' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1110050;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1110050 and a008=v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1110050!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110060
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110060(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
						                                        v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from KRCS.t_sys_t024
   where a011 = 1009002
     and p001 = 1110060 and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'A4-2 ȶʽʣNSFRδͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC0320_A4_2
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0320_A4_2
     (BBQ,
      USERID,
      BTYPE,
      OPTION1,
      SHTAG,
      C2,
      D2,
      E2,
      C3,
      E3,
      C4,
      D4,
      E4,
      C5,
      D5,
      E5,
      C6,
      E6,
      C7,
      E7,
      C8,
      E8,
      C9,
      D9,
      E9,
      C10,
      E10,
      C11,
      D11,
      E11,
      C12,
      D12,
      E12,
      C13,
      D13,
      E13,
      C14,
      E14,
      C15,
      E15,
      C16,
      E16,
      C17,
      E17,
      C18,
      E18,
      C19,
      E19,
      C20,
      D20,
      E20,
      C21,
      D21,
      E21,
      C22,
      E22,
      C23,
      E23,
      C24,
      E24,
      C25,
      E25,
      C26,
      E26,
      C27,
      D27,
      E27,
      C28,
      D28,
      E28,
      C29,
      E29,
      C30,
      E30,
      C31,
      E31,
      C32,
      E32,
      C33,
      E33,
      C34,
      D34,
      E34,
      C35,
      D35,
      E35,
      C36,
      E36,
      C37,
      E37,
      C38,
      E38,
      C39,
      D39,
      E39,
      C40,
      E40,
      C41,
      E41,
      C42,
      D42,
      E42,
      C43,
      E43,
      C44,
      E44,
      C45,
      E45,
      C46,
      D46,
      E46,
      C47,
      E47,
      C48,
      E48,
      C49,
      D49,
      E49,
      C50,
      E50,
      C51,
      D51,
      E51,
      C52,
      E52,
      C53,
      E53,
      C54,
      E54,
      C55,
      E55,
      C56,
      E56,
      C57,
      E57,
      C58,
      D58,
      E58,
      C59,
      D59,
      E59,
      C60,
      D60,
      E60,
      C61,
      E61,
      C62,
      E62,
      C63,
      E63,
      C64,
      D64,
      E64,
      C65,
      D65,
      E65,
      C66,
      E66,
      C67,
      E67,
      C68,
      E68,
      C69,
      E69,
      C70,
      E70,
      C71,
      E71,
      C72,
      D72,
      E72,
      E73
      )
    select BBQ,
            v_USER,
            0,
            null,
            0,
            sum( C2 ),
            sum(D2),
            sum( E2 ),
            sum( C3 ),
            sum( E3 ),
            sum( C4 ),
            sum(D4),
            sum( E4 ),
            sum( C5 ),
            sum(D5),
            sum( E5 ),
            sum( C6 ),
            sum( E6 ),
            sum( C7 ),
            sum( E7 ),
            sum( C8 ),
            sum( E8 ),
            sum( C9 ),
            sum(D9),
            sum( E9 ),
            sum( C10 ),
            sum( E10 ),
            sum( C11 ),
            sum(D11),
            sum( E11 ),
            sum( C12 ),
            sum(D12),
            sum( E12 ),
            sum( C13 ),
            sum(D13),
            sum( E13 ),
            sum( C14 ),
            sum( E14 ),
            sum( C15 ),
            sum( E15 ),
            sum( C16 ),
            sum( E16 ),
            sum( C17 ),
            sum( E17 ),
            sum( C18 ),
            sum( E18 ),
            sum( C19 ),
            sum( E19 ),
            sum( C20 ),
            sum(D20),
            sum( E20 ),
            sum( C21 ),
            sum(D21),
            sum( E21 ),
            sum( C22 ),
            sum( E22 ),
            sum( C23 ),
            sum( E23 ),
            sum( C24 ),
            sum( E24 ),
            sum( C25 ),
            sum( E25 ),
            sum( C26 ),
            sum( E26 ),
            sum( C27 ),
            sum(D27),
            sum( E27 ),
            sum( C28 ),
            sum(D28),
            sum( E28 ),
            sum( C29 ),
            sum( E29 ),
            sum( C30 ),
            sum( E30 ),
            sum( C31 ),
            sum( E31 ),
            sum( C32 ),
            sum( E32 ),
            sum( C33 ),
            sum( E33 ),
            sum( C34 ),
            sum(D34),
            sum( E34 ),
            sum( C35 ),
            sum(D35),
            sum( E35 ),
            sum( C36 ),
            sum( E36 ),
            sum( C37 ),
            sum( E37 ),
            sum( C38 ),
            sum( E38 ),
            sum( C39 ),
            sum(D39),
            sum( E39 ),
            sum( C40 ),
            sum( E40 ),
            sum( C41 ),
            sum( E41 ),
            sum( C42 ),
            sum(D42),
            sum( E42 ),
            sum( C43 ),
            sum( E43 ),
            sum( C44 ),
            sum( E44 ),
            sum( C45 ),
            sum( E45 ),
            sum( C46 ),
            sum(D46),
            sum( E46 ),
            sum( C47 ),
            sum( E47 ),
            sum( C48 ),
            sum( E48 ),
            sum( C49 ),
            sum(D49),
            sum( E49 ),
            sum( C50 ),
            sum( E50 ),
            sum( C51 ),
            sum(D51),
            sum( E51 ),
            sum( C52 ),
            sum( E52 ),
            sum( C53 ),
            sum( E53 ),
            sum( C54 ),
            sum( E54 ),
            sum( C55 ),
            sum( E55 ),
            sum( C56 ),
            sum( E56 ),
            sum( C57 ),
            sum( E57 ),
            sum( C58 ),
            sum(D58),
            sum( E58 ),
            sum( C59 ),
            sum(D59),
            sum( E59 ),
            sum( C60 ),
            sum(D60),
            sum( E60 ),
            sum( C61 ),
            sum( E61 ),
            sum( C62 ),
            sum( E62 ),
            sum( C63 ),
            sum( E63 ),
            sum( C64 ),
            sum(D64),
            sum( E64 ),
            sum( C65 ),
            sum(D65),
            sum( E65 ),
            sum( C66 ),
            sum( E66 ),
            sum( C67 ),
            sum( E67 ),
            sum( C68 ),
            sum( E68 ),
            sum( C69 ),
            sum( E69 ),
            sum( C70 ),
            sum( E70 ),
            sum( C71 ),
            sum( E71 ),
            sum( C72 ),
            sum(D72),
            sum( E72 ),
            sum( E73 )
      from T_CSRC0320_A4_2
     where BBQ = v_P001  and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) group by BBQ;

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1110060 and a008=v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>A4-2' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1110060;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1110060 and a008=v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1110060!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110130
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110130 (errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
  V_ORGNAME  varchar(256);

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1110130;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
   SELECT T2.A003 INTO V_ORGNAME FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC1107_A1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1107_A1(BBQ,USERID,BTYPE,OPTION1,SHTAG,C3,D3,F3,G3,C4,D4,F4,G4,C5,D5,F5,G5,C6,D6,F6,G6,C7,D7,F7,G7,C8,D8,F8,G8,C9,D9,F9,G9,C10,D10,F10,G10,C11,D11,F11,G11,C12,D12,F12,G12,C13,D13,F13,G13,C14,D14,F14,G14,C15,D15,F15,G15,C16,D16,F16,G16,C17,D17,F17,G17,C18,D18,F18,G18,C19,D19,F19,G19,C20,D20,F20,G20,C21,D21,F21,G21,C22,D22,F22,G22,C23,D23,F23,G23,C24,D24,F24,G24,C25,D25,F25,G25,C26,D26,F26,G26,C27,D27,F27,G27,C28,D28,F28,G28,C29,D29,F29,G29,C30,D30,F30,G30,C31,D31,F31,G31,C32,D32,F32,G32,A34,A36)
   select   v_P001,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C3,0)),SUM(nvl(D3,0)),SUM(nvl(F3,0)),SUM(nvl(G3,0)),SUM(nvl(C4,0)),SUM(nvl(D4,0)),SUM(nvl(F4,0)),SUM(nvl(G4,0)),SUM(nvl(C5,0)),SUM(nvl(D5,0)),SUM(nvl(F5,0)),SUM(nvl(G5,0)),SUM(nvl(C6,0)),SUM(nvl(D6,0)),SUM(nvl(F6,0)),SUM(nvl(G6,0)),SUM(nvl(C7,0)),SUM(nvl(D7,0)),SUM(nvl(F7,0)),SUM(nvl(G7,0)),SUM(nvl(C8,0)),SUM(nvl(D8,0)),SUM(nvl(F8,0)),SUM(nvl(G8,0)),SUM(nvl(C9,0)),SUM(nvl(D9,0)),SUM(nvl(F9,0)),SUM(nvl(G9,0)),SUM(nvl(C10,0)),SUM(nvl(D10,0)),SUM(nvl(F10,0)),SUM(nvl(G10,0)),SUM(nvl(C11,0)),SUM(nvl(D11,0)),SUM(nvl(F11,0)),SUM(nvl(G11,0)),SUM(nvl(C12,0)),SUM(nvl(D12,0)),SUM(nvl(F12,0)),SUM(nvl(G12,0)),SUM(nvl(C13,0)),SUM(nvl(D13,0)),SUM(nvl(F13,0)),SUM(nvl(G13,0)),SUM(nvl(C14,0)),SUM(nvl(D14,0)),SUM(nvl(F14,0)),SUM(nvl(G14,0)),SUM(nvl(C15,0)),SUM(nvl(D15,0)),SUM(nvl(F15,0)),SUM(nvl(G15,0)),SUM(nvl(C16,0)),SUM(nvl(D16,0)),SUM(nvl(F16,0)),SUM(nvl(G16,0)),SUM(nvl(C17,0)),SUM(nvl(D17,0)),SUM(nvl(F17,0)),SUM(nvl(G17,0)),SUM(nvl(C18,0)),SUM(nvl(D18,0)),SUM(nvl(F18,0)),SUM(nvl(G18,0)),SUM(nvl(C19,0)),SUM(nvl(D19,0)),SUM(nvl(F19,0)),SUM(nvl(G19,0)),SUM(nvl(C20,0)),SUM(nvl(D20,0)),SUM(nvl(F20,0)),SUM(nvl(G20,0)),SUM(nvl(C21,0)),SUM(nvl(D21,0)),SUM(nvl(F21,0)),SUM(nvl(G21,0)),SUM(nvl(C22,0)),SUM(nvl(D22,0)),SUM(nvl(F22,0)),SUM(nvl(G22,0)),SUM(nvl(C23,0)),SUM(nvl(D23,0)),SUM(nvl(F23,0)),SUM(nvl(G23,0)),SUM(nvl(C24,0)),SUM(nvl(D24,0)),SUM(nvl(F24,0)),SUM(nvl(G24,0)),SUM(nvl(C25,0)),SUM(nvl(D25,0)),SUM(nvl(F25,0)),SUM(nvl(G25,0)),SUM(nvl(C26,0)),SUM(nvl(D26,0)),SUM(nvl(F26,0)),SUM(nvl(G26,0)),SUM(nvl(C27,0)),SUM(nvl(D27,0)),SUM(nvl(F27,0)),SUM(nvl(G27,0)),SUM(nvl(C28,0)),SUM(nvl(D28,0)),SUM(nvl(F28,0)),SUM(nvl(G28,0)),SUM(nvl(C29,0)),SUM(nvl(D29,0)),SUM(nvl(F29,0)),SUM(nvl(G29,0)),SUM(nvl(C30,0)),SUM(nvl(D30,0)),SUM(nvl(F30,0)),SUM(nvl(G30,0)),SUM(nvl(C31,0)),SUM(nvl(D31,0)),SUM(nvl(F31,0)),SUM(nvl(G31,0)),SUM(nvl(C32,0)),SUM(nvl(D32,0)),SUM(nvl(F32,0)),SUM(nvl(G32,0)),substrb(catstr(A34),1,4000),substrb(catstr(A36),1,4000)
        from T_CSRC1107_A1
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110140
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110140(errcode    out int,
                                                     errmsg     out varchar2,
                                                     v_KJAXUSER varchar2,
                                                     v_TASK     varchar2,
                                                     v_P001     varchar2,
                                                     v_P002     varchar2,
                                                     v_P003     varchar2) is
  v_temp     varchar(256);
  v_USER     integer;
  v_count    number;
  v_org      number;
  v_reportid number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1110140;

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  select p002 into v_org from krcs.t_sys_user where p001 = v_KJAXUSER;

  select count(*)
    into v_count
    from KRCS.t_sys_t024
   where a011 = 1009002
     and p001 = v_reportid
     and a008 in (select x.p001
                    from krcs.t_ctl_t036 x, krcs.t_sys_t015 x2
                   where x.p001 = x2.a006
                     and x.w100 = x2.w100
                     and x2.w100 = v_org
                     and x.a008 = 1023002
                     and x2.p001 = v_TASK
                     and x.b001 = 1001101);

  select A005 || A004
    into v_temp
    from krcs.t_sys_t004
   where p001 = v_reportid;
  if v_count > 0 then
    errcode := 0;
    errmsg  := v_temp || ' δͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC1107_A2
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1107_A2
    (BBQ,
     USERID,
     BTYPE,
     OPTION1,
     SHTAG,
     C3,
     D3,
     F3,
     G3,
     C4,
     D4,
     F4,
     G4,
     C5,
     D5,
     F5,
     G5,
     C6,
     D6,
     F6,
     G6,
     C7,
     D7,
     F7,
     G7,
     C8,
     D8,
     F8,
     G8,
     C9,
     D9,
     F9,
     G9,
     C10,
     D10,
     F10,
     G10,
     C11,
     D11,
     F11,
     G11,
     C12,
     D12,
     F12,
     G12,
     C13,
     D13,
     F13,
     G13,
     C14,
     D14,
     F14,
     G14,
     C15,
     D15,
     F15,
     G15,
     C16,
     D16,
     F16,
     G16,
     C17,
     D17,
     F17,
     G17,
     C18,
     D18,
     F18,
     G18,
     C19,
     D19,
     F19,
     G19,
     C20,
     D20,
     F20,
     G20,
     C21,
     D21,
     F21,
     G21,
     C22,
     D22,
     F22,
     G22,
     C23,
     D23,
     F23,
     G23,
     C24,
     D24,
     F24,
     G24,
     C25,
     D25,
     F25,
     G25,
     C26,
     D26,
     F26,
     G26,
     C27,
     D27,
     F27,
     G27,
     C28,
     D28,
     F28,
     G28,
     C29,
     D29,
     F29,
     G29,
     C30,
     D30,
     F30,
     G30,
     C31,
     D31,
     F31,
     G31,
     C32,
     D32,
     F32,
     G32,
     C33,
     D33,
     F33,
     G33,
     C34,
     D34,
     F34,
     G34,
     C35,
     D35,
     F35,
     G35,
     C36,
     D36,
     F36,
     G36,
     C37,
     D37,
     F37,
     G37,
     C38,
     D38,
     F38,
     G38,
     C39,
     D39,
     F39,
     G39,
     C40,
     D40,
     F40,
     G40,
     C41,
     D41,
     F41,
     G41,
     C42,
     D42,
     F42,
     G42,
     C43,
     D43,
     F43,
     G43,
     C44,
     D44,
     F44,
     G44,
     C45,
     D45,
     F45,
     G45,
     C46,
     D46,
     F46,
     G46,
     C47,
     D47,
     F47,
     G47,
     C48,
     D48,
     F48,
     G48,
     C49,
     D49,
     F49,
     G49,
     C50,
     D50,
     F50,
     G50,
     C51,
     D51,
     F51,
     G51,
     C52,
     D52,
     F52,
     G52,
     C53,
     D53,
     F53,
     G53,
     C54,
     D54,
     F54,
     G54,
     C55,
     D55,
     F55,
     G55,
     C56,
     D56,
     F56,
     G56,
     C57,
     D57,
     F57,
     G57,
     C58,
     D58,
     F58,
     G58,
     C59,
     D59,
     F59,
     G59,
     C60,
     D60,
     F60,
     G60,
     C61,
     D61,
     F61,
     G61,
     C62,
     D62,
     F62,
     G62,
     C63,
     D63,
     F63,
     G63,
     C64,
     D64,
     F64,
     G64,
     C65,
     D65,
     F65,
     G65,
     C66,
     D66,
     F66,
     G66,
     C67,
     D67,
     F67,
     G67,
     C68,
     D68,
     F68,
     G68,
     C69,
     D69,
     F69,
     G69,
     C70,
     D70,
     F70,
     G70,
     C71,
     D71,
     F71,
     G71,
     C72,
     D72,
     F72,
     G72,
     C73,
     D73,
     F73,
     G73,
     C74,
     D74,
     F74,
     G74,
     C75,
     D75,
     F75,
     G75,
     C76,
     D76,
     F76,
     G76,
     C77,
     D77,
     F77,
     G77,
     C78,
     D78,
     F78,
     G78,
     C79,
     D79,
     F79,
     G79,
     C80,
     D80,
     F80,
     G80,
     C81,
     D81,
     F81,
     G81,
     C82,
     D82,
     F82,
     G82,
     C83,
     D83,
     F83,
     G83,
     C84,
     D84,
     F84,
     G84,
     C85,
     D85,
     F85,
     G85,
     C86,
     D86,
     F86,
     G86,
     C87,
     D87,
     F87,
     G87,
     C88,
     D88,
     F88,
     G88,
     C89,
     D89,
     F89,
     G89,
     C90,
     D90,
     F90,
     G90,
     C91,
     D91,
     F91,
     G91,
     C92,
     D92,
     F92,
     G92,
     C93,
     D93,
     F93,
     G93,
     C94,
     D94,
     F94,
     G94,
     C95,
     D95,
     F95,
     G95,
     C96,
     D96,
     F96,
     G96,
     C97,
     D97,
     F97,
     G97,
     C98,
     D98,
     F98,
     G98,
     C99,
     D99,
     F99,
     G99,
     C100,
     D100,
     F100,
     G100,
     C101,
     D101,
     F101,
     G101,
     A102)
    select BBQ,
           v_USER,
           0,
           null,
           0,
           SUM(nvl(C3, 0)),
           SUM(nvl(D3, 0)),
           SUM(nvl(F3, 0)),
           SUM(nvl(G3, 0)),
           SUM(nvl(C4, 0)),
           SUM(nvl(D4, 0)),
           SUM(nvl(F4, 0)),
           SUM(nvl(G4, 0)),
           SUM(nvl(C5, 0)),
           SUM(nvl(D5, 0)),
           SUM(nvl(F5, 0)),
           SUM(nvl(G5, 0)),
           SUM(nvl(C6, 0)),
           SUM(nvl(D6, 0)),
           SUM(nvl(F6, 0)),
           SUM(nvl(G6, 0)),
           SUM(nvl(C7, 0)),
           SUM(nvl(D7, 0)),
           SUM(nvl(F7, 0)),
           SUM(nvl(G7, 0)),
           SUM(nvl(C8, 0)),
           SUM(nvl(D8, 0)),
           SUM(nvl(F8, 0)),
           SUM(nvl(G8, 0)),
           SUM(nvl(C9, 0)),
           SUM(nvl(D9, 0)),
           SUM(nvl(F9, 0)),
           SUM(nvl(G9, 0)),
           SUM(nvl(C10, 0)),
           SUM(nvl(D10, 0)),
           SUM(nvl(F10, 0)),
           SUM(nvl(G10, 0)),
           SUM(nvl(C11, 0)),
           SUM(nvl(D11, 0)),
           SUM(nvl(F11, 0)),
           SUM(nvl(G11, 0)),
           SUM(nvl(C12, 0)),
           SUM(nvl(D12, 0)),
           SUM(nvl(F12, 0)),
           SUM(nvl(G12, 0)),
           SUM(nvl(C13, 0)),
           SUM(nvl(D13, 0)),
           SUM(nvl(F13, 0)),
           SUM(nvl(G13, 0)),
           SUM(nvl(C14, 0)),
           SUM(nvl(D14, 0)),
           SUM(nvl(F14, 0)),
           SUM(nvl(G14, 0)),
           SUM(nvl(C15, 0)),
           SUM(nvl(D15, 0)),
           SUM(nvl(F15, 0)),
           SUM(nvl(G15, 0)),
           SUM(nvl(C16, 0)),
           SUM(nvl(D16, 0)),
           SUM(nvl(F16, 0)),
           SUM(nvl(G16, 0)),
           SUM(nvl(C17, 0)),
           SUM(nvl(D17, 0)),
           SUM(nvl(F17, 0)),
           SUM(nvl(G17, 0)),
           SUM(nvl(C18, 0)),
           SUM(nvl(D18, 0)),
           SUM(nvl(F18, 0)),
           SUM(nvl(G18, 0)),
           SUM(nvl(C19, 0)),
           SUM(nvl(D19, 0)),
           SUM(nvl(F19, 0)),
           SUM(nvl(G19, 0)),
           SUM(nvl(C20, 0)),
           SUM(nvl(D20, 0)),
           SUM(nvl(F20, 0)),
           SUM(nvl(G20, 0)),
           SUM(nvl(C21, 0)),
           SUM(nvl(D21, 0)),
           SUM(nvl(F21, 0)),
           SUM(nvl(G21, 0)),
           SUM(nvl(C22, 0)),
           SUM(nvl(D22, 0)),
           SUM(nvl(F22, 0)),
           SUM(nvl(G22, 0)),
           SUM(nvl(C23, 0)),
           SUM(nvl(D23, 0)),
           SUM(nvl(F23, 0)),
           SUM(nvl(G23, 0)),
           SUM(nvl(C24, 0)),
           SUM(nvl(D24, 0)),
           SUM(nvl(F24, 0)),
           SUM(nvl(G24, 0)),
           SUM(nvl(C25, 0)),
           SUM(nvl(D25, 0)),
           SUM(nvl(F25, 0)),
           SUM(nvl(G25, 0)),
           SUM(nvl(C26, 0)),
           SUM(nvl(D26, 0)),
           SUM(nvl(F26, 0)),
           SUM(nvl(G26, 0)),
           SUM(nvl(C27, 0)),
           SUM(nvl(D27, 0)),
           SUM(nvl(F27, 0)),
           SUM(nvl(G27, 0)),
           SUM(nvl(C28, 0)),
           SUM(nvl(D28, 0)),
           SUM(nvl(F28, 0)),
           SUM(nvl(G28, 0)),
           SUM(nvl(C29, 0)),
           SUM(nvl(D29, 0)),
           SUM(nvl(F29, 0)),
           SUM(nvl(G29, 0)),
           SUM(nvl(C30, 0)),
           SUM(nvl(D30, 0)),
           SUM(nvl(F30, 0)),
           SUM(nvl(G30, 0)),
           SUM(nvl(C31, 0)),
           SUM(nvl(D31, 0)),
           SUM(nvl(F31, 0)),
           SUM(nvl(G31, 0)),
           SUM(nvl(C32, 0)),
           SUM(nvl(D32, 0)),
           SUM(nvl(F32, 0)),
           SUM(nvl(G32, 0)),
           SUM(nvl(C33, 0)),
           SUM(nvl(D33, 0)),
           SUM(nvl(F33, 0)),
           SUM(nvl(G33, 0)),
           SUM(nvl(C34, 0)),
           SUM(nvl(D34, 0)),
           SUM(nvl(F34, 0)),
           SUM(nvl(G34, 0)),
           SUM(nvl(C35, 0)),
           SUM(nvl(D35, 0)),
           SUM(nvl(F35, 0)),
           SUM(nvl(G35, 0)),
           SUM(nvl(C36, 0)),
           SUM(nvl(D36, 0)),
           SUM(nvl(F36, 0)),
           SUM(nvl(G36, 0)),
           SUM(nvl(C37, 0)),
           SUM(nvl(D37, 0)),
           SUM(nvl(F37, 0)),
           SUM(nvl(G37, 0)),
           SUM(nvl(C38, 0)),
           SUM(nvl(D38, 0)),
           SUM(nvl(F38, 0)),
           SUM(nvl(G38, 0)),
           SUM(nvl(C39, 0)),
           SUM(nvl(D39, 0)),
           SUM(nvl(F39, 0)),
           SUM(nvl(G39, 0)),
           SUM(nvl(C40, 0)),
           SUM(nvl(D40, 0)),
           SUM(nvl(F40, 0)),
           SUM(nvl(G40, 0)),
           SUM(nvl(C41, 0)),
           SUM(nvl(D41, 0)),
           SUM(nvl(F41, 0)),
           SUM(nvl(G41, 0)),
           SUM(nvl(C42, 0)),
           SUM(nvl(D42, 0)),
           SUM(nvl(F42, 0)),
           SUM(nvl(G42, 0)),
           SUM(nvl(C43, 0)),
           SUM(nvl(D43, 0)),
           SUM(nvl(F43, 0)),
           SUM(nvl(G43, 0)),
           SUM(nvl(C44, 0)),
           SUM(nvl(D44, 0)),
           SUM(nvl(F44, 0)),
           SUM(nvl(G44, 0)),
           SUM(nvl(C45, 0)),
           SUM(nvl(D45, 0)),
           SUM(nvl(F45, 0)),
           SUM(nvl(G45, 0)),
           SUM(nvl(C46, 0)),
           SUM(nvl(D46, 0)),
           SUM(nvl(F46, 0)),
           SUM(nvl(G46, 0)),
           SUM(nvl(C47, 0)),
           SUM(nvl(D47, 0)),
           SUM(nvl(F47, 0)),
           SUM(nvl(G47, 0)),
           SUM(nvl(C48, 0)),
           SUM(nvl(D48, 0)),
           SUM(nvl(F48, 0)),
           SUM(nvl(G48, 0)),
           SUM(nvl(C49, 0)),
           SUM(nvl(D49, 0)),
           SUM(nvl(F49, 0)),
           SUM(nvl(G49, 0)),
           SUM(nvl(C50, 0)),
           SUM(nvl(D50, 0)),
           SUM(nvl(F50, 0)),
           SUM(nvl(G50, 0)),
           SUM(nvl(C51, 0)),
           SUM(nvl(D51, 0)),
           SUM(nvl(F51, 0)),
           SUM(nvl(G51, 0)),
           SUM(nvl(C52, 0)),
           SUM(nvl(D52, 0)),
           SUM(nvl(F52, 0)),
           SUM(nvl(G52, 0)),
           SUM(nvl(C53, 0)),
           SUM(nvl(D53, 0)),
           SUM(nvl(F53, 0)),
           SUM(nvl(G53, 0)),
           SUM(nvl(C54, 0)),
           SUM(nvl(D54, 0)),
           SUM(nvl(F54, 0)),
           SUM(nvl(G54, 0)),
           SUM(nvl(C55, 0)),
           SUM(nvl(D55, 0)),
           SUM(nvl(F55, 0)),
           SUM(nvl(G55, 0)),
           SUM(nvl(C56, 0)),
           SUM(nvl(D56, 0)),
           SUM(nvl(F56, 0)),
           SUM(nvl(G56, 0)),
           SUM(nvl(C57, 0)),
           SUM(nvl(D57, 0)),
           SUM(nvl(F57, 0)),
           SUM(nvl(G57, 0)),
           SUM(nvl(C58, 0)),
           SUM(nvl(D58, 0)),
           SUM(nvl(F58, 0)),
           SUM(nvl(G58, 0)),
           SUM(nvl(C59, 0)),
           SUM(nvl(D59, 0)),
           SUM(nvl(F59, 0)),
           SUM(nvl(G59, 0)),
           SUM(nvl(C60, 0)),
           SUM(nvl(D60, 0)),
           SUM(nvl(F60, 0)),
           SUM(nvl(G60, 0)),
           SUM(nvl(C61, 0)),
           SUM(nvl(D61, 0)),
           SUM(nvl(F61, 0)),
           SUM(nvl(G61, 0)),
           SUM(nvl(C62, 0)),
           SUM(nvl(D62, 0)),
           SUM(nvl(F62, 0)),
           SUM(nvl(G62, 0)),
           SUM(nvl(C63, 0)),
           SUM(nvl(D63, 0)),
           SUM(nvl(F63, 0)),
           SUM(nvl(G63, 0)),
           SUM(nvl(C64, 0)),
           SUM(nvl(D64, 0)),
           SUM(nvl(F64, 0)),
           SUM(nvl(G64, 0)),
           SUM(nvl(C65, 0)),
           SUM(nvl(D65, 0)),
           SUM(nvl(F65, 0)),
           SUM(nvl(G65, 0)),
           SUM(nvl(C66, 0)),
           SUM(nvl(D66, 0)),
           SUM(nvl(F66, 0)),
           SUM(nvl(G66, 0)),
           SUM(nvl(C67, 0)),
           SUM(nvl(D67, 0)),
           SUM(nvl(F67, 0)),
           SUM(nvl(G67, 0)),
           SUM(nvl(C68, 0)),
           SUM(nvl(D68, 0)),
           SUM(nvl(F68, 0)),
           SUM(nvl(G68, 0)),
           SUM(nvl(C69, 0)),
           SUM(nvl(D69, 0)),
           SUM(nvl(F69, 0)),
           SUM(nvl(G69, 0)),
           SUM(nvl(C70, 0)),
           SUM(nvl(D70, 0)),
           SUM(nvl(F70, 0)),
           SUM(nvl(G70, 0)),
           SUM(nvl(C71, 0)),
           SUM(nvl(D71, 0)),
           SUM(nvl(F71, 0)),
           SUM(nvl(G71, 0)),
           SUM(nvl(C72, 0)),
           SUM(nvl(D72, 0)),
           SUM(nvl(F72, 0)),
           SUM(nvl(G72, 0)),
           SUM(nvl(C73, 0)),
           SUM(nvl(D73, 0)),
           SUM(nvl(F73, 0)),
           SUM(nvl(G73, 0)),
           SUM(nvl(C74, 0)),
           SUM(nvl(D74, 0)),
           SUM(nvl(F74, 0)),
           SUM(nvl(G74, 0)),
           SUM(nvl(C75, 0)),
           SUM(nvl(D75, 0)),
           SUM(nvl(F75, 0)),
           SUM(nvl(G75, 0)),
           SUM(nvl(C76, 0)),
           SUM(nvl(D76, 0)),
           SUM(nvl(F76, 0)),
           SUM(nvl(G76, 0)),
           SUM(nvl(C77, 0)),
           SUM(nvl(D77, 0)),
           SUM(nvl(F77, 0)),
           SUM(nvl(G77, 0)),
           SUM(nvl(C78, 0)),
           SUM(nvl(D78, 0)),
           SUM(nvl(F78, 0)),
           SUM(nvl(G78, 0)),
           SUM(nvl(C79, 0)),
           SUM(nvl(D79, 0)),
           SUM(nvl(F79, 0)),
           SUM(nvl(G79, 0)),
           SUM(nvl(C80, 0)),
           SUM(nvl(D80, 0)),
           SUM(nvl(F80, 0)),
           SUM(nvl(G80, 0)),
           SUM(nvl(C81, 0)),
           SUM(nvl(D81, 0)),
           SUM(nvl(F81, 0)),
           SUM(nvl(G81, 0)),
           SUM(nvl(C82, 0)),
           SUM(nvl(D82, 0)),
           SUM(nvl(F82, 0)),
           SUM(nvl(G82, 0)),
           SUM(nvl(C83, 0)),
           SUM(nvl(D83, 0)),
           SUM(nvl(F83, 0)),
           SUM(nvl(G83, 0)),
           SUM(nvl(C84, 0)),
           SUM(nvl(D84, 0)),
           SUM(nvl(F84, 0)),
           SUM(nvl(G84, 0)),
           SUM(nvl(C85, 0)),
           SUM(nvl(D85, 0)),
           SUM(nvl(F85, 0)),
           SUM(nvl(G85, 0)),
           SUM(nvl(C86, 0)),
           SUM(nvl(D86, 0)),
           SUM(nvl(F86, 0)),
           SUM(nvl(G86, 0)),
           SUM(nvl(C87, 0)),
           SUM(nvl(D87, 0)),
           SUM(nvl(F87, 0)),
           SUM(nvl(G87, 0)),
           SUM(nvl(C88, 0)),
           SUM(nvl(D88, 0)),
           SUM(nvl(F88, 0)),
           SUM(nvl(G88, 0)),
           SUM(nvl(C89, 0)),
           SUM(nvl(D89, 0)),
           SUM(nvl(F89, 0)),
           SUM(nvl(G89, 0)),
           SUM(nvl(C90, 0)),
           SUM(nvl(D90, 0)),
           SUM(nvl(F90, 0)),
           SUM(nvl(G90, 0)),
           SUM(nvl(C91, 0)),
           SUM(nvl(D91, 0)),
           SUM(nvl(F91, 0)),
           SUM(nvl(G91, 0)),
           SUM(nvl(C92, 0)),
           SUM(nvl(D92, 0)),
           SUM(nvl(F92, 0)),
           SUM(nvl(G92, 0)),
           SUM(nvl(C93, 0)),
           SUM(nvl(D93, 0)),
           SUM(nvl(F93, 0)),
           SUM(nvl(G93, 0)),
           SUM(nvl(C94, 0)),
           SUM(nvl(D94, 0)),
           SUM(nvl(F94, 0)),
           SUM(nvl(G94, 0)),
           SUM(nvl(C95, 0)),
           SUM(nvl(D95, 0)),
           SUM(nvl(F95, 0)),
           SUM(nvl(G95, 0)),
           SUM(nvl(C96, 0)),
           SUM(nvl(D96, 0)),
           SUM(nvl(F96, 0)),
           SUM(nvl(G96, 0)),
           SUM(nvl(C97, 0)),
           SUM(nvl(D97, 0)),
           SUM(nvl(F97, 0)),
           SUM(nvl(G97, 0)),
           SUM(nvl(C98, 0)),
           SUM(nvl(D98, 0)),
           SUM(nvl(F98, 0)),
           SUM(nvl(G98, 0)),
           SUM(nvl(C99, 0)),
           SUM(nvl(D99, 0)),
           SUM(nvl(F99, 0)),
           SUM(nvl(G99, 0)),
           SUM(nvl(C100, 0)),
           SUM(nvl(D100, 0)),
           SUM(nvl(F100, 0)),
           SUM(nvl(G100, 0)),
           SUM(nvl(C101, 0)),
           SUM(nvl(D101, 0)),
           SUM(nvl(F101, 0)),
           SUM(nvl(G101, 0)),
           substrb(catstr(A102), 1, 4000)

      from T_CSRC1107_A2
     where BBQ = v_P001
       and userid in (select x.p001
                        from krcs.t_ctl_t036 x, krcs.t_sys_t015 x2
                       where x.p001 = x2.a006
                         and x.w100 = x2.w100
                         and x2.w100 = v_org
                         and x.a008 = 1023002
                         and x2.p001 = v_TASK
                         and x.b001 = 1001101)
     group by BBQ;

  update KRCS.T_SYS_T014
     SET A010 = 1015001,
         A009 = 1016002,
         A011 = 1009002,
         A012 = 1020002,
         A020 = v_KJAXUSER
   WHERE P001 = v_reportid
     and a008 = v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>' || A005 || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003, A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp, v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014
       SET A010 = 1015002
     WHERE P001 = v_reportid
       and a008 = v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_' || v_reportid || '!';
    return;
end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110150
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110150 (errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
  V_ORGNAME  varchar(256);

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1110150;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
   SELECT T2.A003 INTO V_ORGNAME FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC1107_A3
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1107_A3(BBQ,USERID,BTYPE,OPTION1,SHTAG,D2,F2,D3,F3,D4,F4,D5,F5,D6,F6,D7,F7,D8,F8,D9,F9,D10,F10,D11,F11,D12,F12,D13,F13,D14,F14,D15,F15,D16,F16,D17,F17,D18,F18,D19,F19,D20,F20,D21,F21,D22,F22,D23,F23,D24,F24,D25,F25,D26,F26)
   select   v_P001,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(D2,0)),SUM(nvl(F2,0)),SUM(nvl(D3,0)),SUM(nvl(F3,0)),SUM(nvl(D4,0)),SUM(nvl(F4,0)),SUM(nvl(D5,0)),SUM(nvl(F5,0)),SUM(nvl(D6,0)),SUM(nvl(F6,0)),SUM(nvl(D7,0)),SUM(nvl(F7,0)),SUM(nvl(D8,0)),SUM(nvl(F8,0)),SUM(nvl(D9,0)),SUM(nvl(F9,0)),SUM(nvl(D10,0)),SUM(nvl(F10,0)),SUM(nvl(D11,0)),SUM(nvl(F11,0)),SUM(nvl(D12,0)),SUM(nvl(F12,0)),SUM(nvl(D13,0)),SUM(nvl(F13,0)),SUM(nvl(D14,0)),SUM(nvl(F14,0)),SUM(nvl(D15,0)),SUM(nvl(F15,0)),SUM(nvl(D16,0)),SUM(nvl(F16,0)),SUM(nvl(D17,0)),SUM(nvl(F17,0)),SUM(nvl(D18,0)),SUM(nvl(F18,0)),SUM(nvl(D19,0)),SUM(nvl(F19,0)),SUM(nvl(D20,0)),SUM(nvl(F20,0)),SUM(nvl(D21,0)),SUM(nvl(F21,0)),SUM(nvl(D22,0)),SUM(nvl(F22,0)),SUM(nvl(D23,0)),SUM(nvl(F23,0)),SUM(nvl(D24,0)),SUM(nvl(F24,0)),SUM(nvl(D25,0)),SUM(nvl(F25,0)),SUM(nvl(D26,0)),SUM(nvl(F26,0))
        from T_CSRC1107_A3
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110160
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110160 (errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
  V_ORGNAME  varchar(256);

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1110160;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
   SELECT T2.A003 INTO V_ORGNAME FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC1107_A4
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1107_A4(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,E2,C3,E3,C4,E4,C5,E5,C6,E6,C7,E7,C8,E8,C9,E9,C10,E10,C11,E11,C12,E12,C13,E13,C14,E14,C15,E15,C16,E16,C17,E17,C18,E18,C19,E19,C20,E20,C21,E21,C22,E22,C23,E23,C24,E24,C25,E25,C26,E26,C27,E27,C28,E28,C29,E29,C30,E30,C31,E31,C32,E32,C33,E33,C34,E34,C35,E35,C36,E36,C37,E37,C38,E38,C39,E39,C40,E40,C41,E41,C42,E42,C43,E43,C44,E44,C45,E45,C46,E46,C47,E47,C48,E48,C49,E49,C50,E50,C51,E51,C52,E52,C53,E53,C54,E54,C55,E55,C56,E56,C57,E57,C58,E58,C59,E59,C60,E60,C61,E61,C62,E62,C63,E63,C64,E64,C65,E65,C66,E66,C67,E67,C68,E68,C69,E69,C70,E70,C71,E71,C72,E72)
   select   v_P001,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C2,0)),SUM(nvl(E2,0)),SUM(nvl(C3,0)),SUM(nvl(E3,0)),SUM(nvl(C4,0)),SUM(nvl(E4,0)),SUM(nvl(C5,0)),SUM(nvl(E5,0)),SUM(nvl(C6,0)),SUM(nvl(E6,0)),SUM(nvl(C7,0)),SUM(nvl(E7,0)),SUM(nvl(C8,0)),SUM(nvl(E8,0)),SUM(nvl(C9,0)),SUM(nvl(E9,0)),SUM(nvl(C10,0)),SUM(nvl(E10,0)),SUM(nvl(C11,0)),SUM(nvl(E11,0)),SUM(nvl(C12,0)),SUM(nvl(E12,0)),SUM(nvl(C13,0)),SUM(nvl(E13,0)),SUM(nvl(C14,0)),SUM(nvl(E14,0)),SUM(nvl(C15,0)),SUM(nvl(E15,0)),SUM(nvl(C16,0)),SUM(nvl(E16,0)),SUM(nvl(C17,0)),SUM(nvl(E17,0)),SUM(nvl(C18,0)),SUM(nvl(E18,0)),SUM(nvl(C19,0)),SUM(nvl(E19,0)),SUM(nvl(C20,0)),SUM(nvl(E20,0)),SUM(nvl(C21,0)),SUM(nvl(E21,0)),SUM(nvl(C22,0)),SUM(nvl(E22,0)),SUM(nvl(C23,0)),SUM(nvl(E23,0)),SUM(nvl(C24,0)),SUM(nvl(E24,0)),SUM(nvl(C25,0)),SUM(nvl(E25,0)),SUM(nvl(C26,0)),SUM(nvl(E26,0)),SUM(nvl(C27,0)),SUM(nvl(E27,0)),SUM(nvl(C28,0)),SUM(nvl(E28,0)),SUM(nvl(C29,0)),SUM(nvl(E29,0)),SUM(nvl(C30,0)),SUM(nvl(E30,0)),SUM(nvl(C31,0)),SUM(nvl(E31,0)),SUM(nvl(C32,0)),SUM(nvl(E32,0)),SUM(nvl(C33,0)),SUM(nvl(E33,0)),SUM(nvl(C34,0)),SUM(nvl(E34,0)),SUM(nvl(C35,0)),SUM(nvl(E35,0)),SUM(nvl(C36,0)),SUM(nvl(E36,0)),SUM(nvl(C37,0)),SUM(nvl(E37,0)),SUM(nvl(C38,0)),SUM(nvl(E38,0)),SUM(nvl(C39,0)),SUM(nvl(E39,0)),SUM(nvl(C40,0)),SUM(nvl(E40,0)),SUM(nvl(C41,0)),SUM(nvl(E41,0)),SUM(nvl(C42,0)),SUM(nvl(E42,0)),SUM(nvl(C43,0)),SUM(nvl(E43,0)),SUM(nvl(C44,0)),SUM(nvl(E44,0)),SUM(nvl(C45,0)),SUM(nvl(E45,0)),SUM(nvl(C46,0)),SUM(nvl(E46,0)),SUM(nvl(C47,0)),SUM(nvl(E47,0)),SUM(nvl(C48,0)),SUM(nvl(E48,0)),SUM(nvl(C49,0)),SUM(nvl(E49,0)),SUM(nvl(C50,0)),SUM(nvl(E50,0)),SUM(nvl(C51,0)),SUM(nvl(E51,0)),SUM(nvl(C52,0)),SUM(nvl(E52,0)),SUM(nvl(C53,0)),SUM(nvl(E53,0)),SUM(nvl(C54,0)),SUM(nvl(E54,0)),SUM(nvl(C55,0)),SUM(nvl(E55,0)),SUM(nvl(C56,0)),SUM(nvl(E56,0)),SUM(nvl(C57,0)),SUM(nvl(E57,0)),SUM(nvl(C58,0)),SUM(nvl(E58,0)),SUM(nvl(C59,0)),SUM(nvl(E59,0)),SUM(nvl(C60,0)),SUM(nvl(E60,0)),SUM(nvl(C61,0)),SUM(nvl(E61,0)),SUM(nvl(C62,0)),SUM(nvl(E62,0)),SUM(nvl(C63,0)),SUM(nvl(E63,0)),SUM(nvl(C64,0)),SUM(nvl(E64,0)),SUM(nvl(C65,0)),SUM(nvl(E65,0)),SUM(nvl(C66,0)),SUM(nvl(E66,0)),SUM(nvl(C67,0)),SUM(nvl(E67,0)),SUM(nvl(C68,0)),SUM(nvl(E68,0)),SUM(nvl(C69,0)),SUM(nvl(E69,0)),SUM(nvl(C70,0)),SUM(nvl(E70,0)),SUM(nvl(C71,0)),SUM(nvl(E71,0)),SUM(nvl(C72,0)),SUM(nvl(E72,0))
        from T_CSRC1107_A4
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110170
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110170 (errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
  V_ORGNAME  varchar(256);

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1110170;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
   SELECT T2.A003 INTO V_ORGNAME FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC1107_A5
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1107_A5(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,E2,C3,E3,C4,E4,C5,E5,C6,E6,C7,E7,C8,E8,C9,E9,C10,E10,C11,E11,C12,E12,C13,E13,C14,E14,C15,E15,C16,E16,C17,E17,C18,E18,C19,E19,C20,E20,C21,E21,C22,E22,C23,E23,C24,E24,C25,E25,C26,E26,C27,E27,C28,E28,C29,E29,C30,E30,C31,E31,C32,E32,C33,E33,C34,E34,C35,E35,C36,E36,C37,E37,C38,E38,C39,E39,C40,E40,C41,E41,C42,E42,C43,E43,C44,E44,C45,E45,C46,E46,C47,E47,C48,E48,C49,E49,C50,E50,C51,E51,C52,E52,C53,E53,C54,E54,C55,E55,C56,E56,C57,E57,C58,E58,C59,E59,C60,E60,C61,E61,C62,E62,C63,E63,C64,E64,C65,E65,C66,E66,C67,E67,C68,E68,C69,E69,C70,E70,C71,E71,C72,E72,C73,E73,C74,E74,C75,E75)
   select   v_P001,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C2,0)),SUM(nvl(E2,0)),SUM(nvl(C3,0)),SUM(nvl(E3,0)),SUM(nvl(C4,0)),SUM(nvl(E4,0)),SUM(nvl(C5,0)),SUM(nvl(E5,0)),SUM(nvl(C6,0)),SUM(nvl(E6,0)),SUM(nvl(C7,0)),SUM(nvl(E7,0)),SUM(nvl(C8,0)),SUM(nvl(E8,0)),SUM(nvl(C9,0)),SUM(nvl(E9,0)),SUM(nvl(C10,0)),SUM(nvl(E10,0)),SUM(nvl(C11,0)),SUM(nvl(E11,0)),SUM(nvl(C12,0)),SUM(nvl(E12,0)),SUM(nvl(C13,0)),SUM(nvl(E13,0)),SUM(nvl(C14,0)),SUM(nvl(E14,0)),SUM(nvl(C15,0)),SUM(nvl(E15,0)),SUM(nvl(C16,0)),SUM(nvl(E16,0)),SUM(nvl(C17,0)),SUM(nvl(E17,0)),SUM(nvl(C18,0)),SUM(nvl(E18,0)),SUM(nvl(C19,0)),SUM(nvl(E19,0)),SUM(nvl(C20,0)),SUM(nvl(E20,0)),SUM(nvl(C21,0)),SUM(nvl(E21,0)),SUM(nvl(C22,0)),SUM(nvl(E22,0)),SUM(nvl(C23,0)),SUM(nvl(E23,0)),SUM(nvl(C24,0)),SUM(nvl(E24,0)),SUM(nvl(C25,0)),SUM(nvl(E25,0)),SUM(nvl(C26,0)),SUM(nvl(E26,0)),SUM(nvl(C27,0)),SUM(nvl(E27,0)),SUM(nvl(C28,0)),SUM(nvl(E28,0)),SUM(nvl(C29,0)),SUM(nvl(E29,0)),SUM(nvl(C30,0)),SUM(nvl(E30,0)),SUM(nvl(C31,0)),SUM(nvl(E31,0)),SUM(nvl(C32,0)),SUM(nvl(E32,0)),SUM(nvl(C33,0)),SUM(nvl(E33,0)),SUM(nvl(C34,0)),SUM(nvl(E34,0)),SUM(nvl(C35,0)),SUM(nvl(E35,0)),SUM(nvl(C36,0)),SUM(nvl(E36,0)),SUM(nvl(C37,0)),SUM(nvl(E37,0)),SUM(nvl(C38,0)),SUM(nvl(E38,0)),SUM(nvl(C39,0)),SUM(nvl(E39,0)),SUM(nvl(C40,0)),SUM(nvl(E40,0)),SUM(nvl(C41,0)),SUM(nvl(E41,0)),SUM(nvl(C42,0)),SUM(nvl(E42,0)),SUM(nvl(C43,0)),SUM(nvl(E43,0)),SUM(nvl(C44,0)),SUM(nvl(E44,0)),SUM(nvl(C45,0)),SUM(nvl(E45,0)),SUM(nvl(C46,0)),SUM(nvl(E46,0)),SUM(nvl(C47,0)),SUM(nvl(E47,0)),SUM(nvl(C48,0)),SUM(nvl(E48,0)),SUM(nvl(C49,0)),SUM(nvl(E49,0)),SUM(nvl(C50,0)),SUM(nvl(E50,0)),SUM(nvl(C51,0)),SUM(nvl(E51,0)),SUM(nvl(C52,0)),SUM(nvl(E52,0)),SUM(nvl(C53,0)),SUM(nvl(E53,0)),SUM(nvl(C54,0)),SUM(nvl(E54,0)),SUM(nvl(C55,0)),SUM(nvl(E55,0)),SUM(nvl(C56,0)),SUM(nvl(E56,0)),SUM(nvl(C57,0)),SUM(nvl(E57,0)),SUM(nvl(C58,0)),SUM(nvl(E58,0)),SUM(nvl(C59,0)),SUM(nvl(E59,0)),SUM(nvl(C60,0)),SUM(nvl(E60,0)),SUM(nvl(C61,0)),SUM(nvl(E61,0)),SUM(nvl(C62,0)),SUM(nvl(E62,0)),SUM(nvl(C63,0)),SUM(nvl(E63,0)),SUM(nvl(C64,0)),SUM(nvl(E64,0)),SUM(nvl(C65,0)),SUM(nvl(E65,0)),SUM(nvl(C66,0)),SUM(nvl(E66,0)),SUM(nvl(C67,0)),SUM(nvl(E67,0)),SUM(nvl(C68,0)),SUM(nvl(E68,0)),SUM(nvl(C69,0)),SUM(nvl(E69,0)),SUM(nvl(C70,0)),SUM(nvl(E70,0)),SUM(nvl(C71,0)),SUM(nvl(E71,0)),SUM(nvl(C72,0)),SUM(nvl(E72,0)),SUM(nvl(C73,0)),SUM(nvl(E73,0)),SUM(nvl(C74,0)),SUM(nvl(E74,0)),SUM(nvl(C75,0)),SUM(nvl(E75,0))
        from T_CSRC1107_A5
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110180
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110180 (errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
  V_ORGNAME  varchar(256);

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1110180;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
   SELECT T2.A003 INTO V_ORGNAME FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC1107_A6
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1107_A6(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,D2,G2,C3,D3,G3,C4,D4,G4,C5,D5,G5,C6,D6,G6,C7,D7,G7,C8,D8,G8,C9,D9,G9,C10,D10,G10,C11,D11,G11,C12,D12,G12,C13,D13,G13,C14,D14,G14,C15,D15,G15,C16,D16,G16,A19,C19,D19,G19,A20,C20,D20,G20,A21,C21,D21,G21,A22,C22,D22,G22,A23,C23,D23,G23,A26,C26,D26,G26,A27,C27,D27,G27,A28,C28,D28,G28,A29,C29,D29,G29,A30,C30,D30,G30,A33,C33,D33,G33,A34,C34,D34,G34,A35,C35,D35,G35,A36,C36,D36,G36,A37,C37,D37,G37,C38,D38,G38,A41,C41,D41,G41,A42,C42,D42,G42,A43,C43,D43,G43,A44,C44,D44,G44,A45,C45,D45,G45,A48,C48,D48,G48,A49,C49,D49,G49,A50,C50,D50,G50,A51,C51,D51,G51,A52,C52,D52,G52)
   select   v_P001,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C2,0)),SUM(nvl(D2,0)),substrb(catstr(G2),1,255),SUM(nvl(C3,0)),SUM(nvl(D3,0)),substrb(catstr(G3),1,255),SUM(nvl(C4,0)),SUM(nvl(D4,0)),substrb(catstr(G4),1,255),SUM(nvl(C5,0)),SUM(nvl(D5,0)),substrb(catstr(G5),1,255),SUM(nvl(C6,0)),SUM(nvl(D6,0)),substrb(catstr(G6),1,255),SUM(nvl(C7,0)),SUM(nvl(D7,0)),substrb(catstr(G7),1,255),SUM(nvl(C8,0)),SUM(nvl(D8,0)),substrb(catstr(G8),1,255),SUM(nvl(C9,0)),SUM(nvl(D9,0)),substrb(catstr(G9),1,255),SUM(nvl(C10,0)),SUM(nvl(D10,0)),substrb(catstr(G10),1,255),SUM(nvl(C11,0)),SUM(nvl(D11,0)),substrb(catstr(G11),1,255),SUM(nvl(C12,0)),SUM(nvl(D12,0)),substrb(catstr(G12),1,255),SUM(nvl(C13,0)),SUM(nvl(D13,0)),substrb(catstr(G13),1,255),SUM(nvl(C14,0)),SUM(nvl(D14,0)),substrb(catstr(G14),1,255),SUM(nvl(C15,0)),SUM(nvl(D15,0)),substrb(catstr(G15),1,255),SUM(nvl(C16,0)),SUM(nvl(D16,0)),substrb(catstr(G16),1,255),substrb(catstr(A19),1,255),SUM(nvl(C19,0)),SUM(nvl(D19,0)),substrb(catstr(G19),1,255),substrb(catstr(A20),1,255),SUM(nvl(C20,0)),SUM(nvl(D20,0)),substrb(catstr(G20),1,255),substrb(catstr(A21),1,255),SUM(nvl(C21,0)),SUM(nvl(D21,0)),substrb(catstr(G21),1,255),substrb(catstr(A22),1,255),SUM(nvl(C22,0)),SUM(nvl(D22,0)),substrb(catstr(G22),1,255),substrb(catstr(A23),1,255),SUM(nvl(C23,0)),SUM(nvl(D23,0)),substrb(catstr(G23),1,255),substrb(catstr(A26),1,255),SUM(nvl(C26,0)),SUM(nvl(D26,0)),substrb(catstr(G26),1,255),substrb(catstr(A27),1,255),SUM(nvl(C27,0)),SUM(nvl(D27,0)),substrb(catstr(G27),1,255),substrb(catstr(A28),1,255),SUM(nvl(C28,0)),SUM(nvl(D28,0)),substrb(catstr(G28),1,255),substrb(catstr(A29),1,255),SUM(nvl(C29,0)),SUM(nvl(D29,0)),substrb(catstr(G29),1,255),substrb(catstr(A30),1,255),SUM(nvl(C30,0)),SUM(nvl(D30,0)),substrb(catstr(G30),1,255),substrb(catstr(A33),1,255),SUM(nvl(C33,0)),SUM(nvl(D33,0)),substrb(catstr(G33),1,255),substrb(catstr(A34),1,255),SUM(nvl(C34,0)),SUM(nvl(D34,0)),substrb(catstr(G34),1,255),substrb(catstr(A35),1,255),SUM(nvl(C35,0)),SUM(nvl(D35,0)),substrb(catstr(G35),1,255),substrb(catstr(A36),1,255),SUM(nvl(C36,0)),SUM(nvl(D36,0)),substrb(catstr(G36),1,255),substrb(catstr(A37),1,255),SUM(nvl(C37,0)),SUM(nvl(D37,0)),substrb(catstr(G37),1,255),SUM(nvl(C38,0)),SUM(nvl(D38,0)),substrb(catstr(G38),1,255),substrb(catstr(A41),1,255),SUM(nvl(C41,0)),SUM(nvl(D41,0)),substrb(catstr(G41),1,255),substrb(catstr(A42),1,255),SUM(nvl(C42,0)),SUM(nvl(D42,0)),substrb(catstr(G42),1,255),substrb(catstr(A43),1,255),SUM(nvl(C43,0)),SUM(nvl(D43,0)),substrb(catstr(G43),1,255),substrb(catstr(A44),1,255),SUM(nvl(C44,0)),SUM(nvl(D44,0)),substrb(catstr(G44),1,255),substrb(catstr(A45),1,255),SUM(nvl(C45,0)),SUM(nvl(D45,0)),substrb(catstr(G45),1,255),substrb(catstr(A48),1,255),SUM(nvl(C48,0)),SUM(nvl(D48,0)),substrb(catstr(G48),1,255),substrb(catstr(A49),1,255),SUM(nvl(C49,0)),SUM(nvl(D49,0)),substrb(catstr(G49),1,255),substrb(catstr(A50),1,255),SUM(nvl(C50,0)),SUM(nvl(D50,0)),substrb(catstr(G50),1,255),substrb(catstr(A51),1,255),SUM(nvl(C51,0)),SUM(nvl(D51,0)),substrb(catstr(G51),1,255),substrb(catstr(A52),1,255),SUM(nvl(C52,0)),SUM(nvl(D52,0)),substrb(catstr(G52),1,255)
        from T_CSRC1107_A6
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1110190
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1110190(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK     varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp     varchar(256);
  v_USER     integer;
  v_count    number;
  v_reportid number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1110190;

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  select count(*)
    into v_count
    from krcs.t_sys_t024
   where a011 = 1009002
     and p001 = v_reportid;

  select A005 || A004 into v_temp from krcs.t_sys_t004 where p001 = v_reportid;
  if v_count > 0 then
    errcode := 0;
    errmsg  := v_temp || 'δͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC1107_A7
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1107_A7
(BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           C4  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           C5  ,
           D5  ,
           E5  ,
           F5  ,
           G5  ,
           C6  ,
           D6  ,
           E6  ,
           F6  ,
           G6  ,
           C9  ,
           D9  ,
           E9  ,
           F9  ,
           G9  ,
           C10 ,
           D10 ,
           E10 ,
           F10 ,
           G10 ,
           C11 ,
           D11 ,
           E11 ,
           F11 ,
           G11 ,
           C12 ,
           D12 ,
           E12 ,
           F12 ,
           G12 ,
           C13 ,
           D13 ,
           E13 ,
           F13 ,
           G13 ,
           C16 ,
           D16 ,
           E16 ,
           F16 ,
           G16 ,
           C17 ,
           D17 ,
           E17 ,
           F17 ,
           G17 ,
           C18 ,
           D18 ,
           E18 ,
           F18 ,
           G18 ,
           C19 ,
           D19 ,
           E19 ,
           F19 ,
           G19 ,
           C21 ,
           D21 ,
           E21 ,
           F21 ,
           G21 ,
           C22 ,
           D22 ,
           E22 ,
           F22 ,
           G22 ,
           C23 ,
           D23 ,
           E23 ,
           F23 ,
           G23 ,
           C24 ,
           D24 ,
           E24 ,
           F24 ,
           G24 ,
           C25 ,
           D25 ,
           E25 ,
           F25 ,
           G25 ,
           C26 ,
           D26 ,
           E26 ,
           F26 ,
           G26 ,
           C27 ,
           D27 ,
           E27 ,
           F27 ,
           G27 ,
           C28 ,
           D28 ,
           E28 ,
           F28 ,
           G28 ,
           C29 ,
           D29 ,
           E29 ,
           F29 ,
           G29 ,
           C31 ,
           D31 ,
           E31 ,
           F31 ,
           G31 ,
           C34 ,
           D34 ,
           E34 ,
           F34 ,
           G34 ,
           C35 ,
           D35 ,
           E35 ,
           F35 ,
           G35 ,
           C36 ,
           D36 ,
           E36 ,
           F36 ,
           G36 ,
           C37 ,
           D37 ,
           E37 ,
           F37 ,
           G37 ,
           C38 ,
           D38 ,
           E38 ,
           F38 ,
           G38
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(C4)  ,
           sum(D4)  ,
           sum(E4)  ,
           sum(F4)  ,
           substrb(catstr(G4),1,255)  ,
           sum(C5)  ,
           sum(D5)  ,
           sum(E5)  ,
           sum(F5)  ,
           substrb(catstr(G5),1,255)  ,
           sum(C6)  ,
           sum(D6)  ,
           sum(E6)  ,
           sum(F6)  ,
           substrb(catstr(G6),1,255)  ,
           sum(C9)  ,
           sum(D9)  ,
           sum(E9)  ,
           sum(F9)  ,
           substrb(catstr(G9),1,255)  ,
           sum(C10) ,
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           substrb(catstr(G10),1,255) ,
           sum(C11) ,
           sum(D11) ,
           sum(E11) ,
           sum(F11) ,
           substrb(catstr(G11),1,255) ,
           sum(C12) ,
           sum(D12) ,
           sum(E12) ,
           sum(F12) ,
           substrb(catstr(G12),1,255) ,
           sum(C13) ,
           sum(D13) ,
           sum(E13) ,
           sum(F13) ,
           substrb(catstr(G13),1,255) ,
           sum(C16) ,
           sum(D16) ,
           sum(E16) ,
           sum(F16) ,
           substrb(catstr(G16),1,255) ,
           sum(C17) ,
           sum(D17) ,
           sum(E17) ,
           sum(F17) ,
           substrb(catstr(G17),1,255) ,
           sum(C18) ,
           sum(D18) ,
           sum(E18) ,
           sum(F18) ,
           substrb(catstr(G18),1,255) ,
           sum(C19) ,
           sum(D19) ,
           sum(E19) ,
           sum(F19) ,
           substrb(catstr(G19),1,255) ,
           sum(C21) ,
           sum(D21) ,
           sum(E21) ,
           sum(F21) ,
           substrb(catstr(G21),1,255) ,
           sum(C22) ,
           sum(D22) ,
           sum(E22) ,
           sum(F22) ,
           substrb(catstr(G22),1,255) ,
           sum(C23) ,
           sum(D23) ,
           sum(E23) ,
           sum(F23) ,
           substrb(catstr(G23),1,255) ,
           sum(C24) ,
           sum(D24) ,
           sum(E24) ,
           sum(F24) ,
           substrb(catstr(G24),1,255) ,
           sum(C25) ,
           sum(D25) ,
           sum(E25) ,
           sum(F25) ,
           substrb(catstr(G25),1,255) ,
           sum(C26) ,
           sum(D26) ,
           sum(E26) ,
           sum(F26) ,
           substrb(catstr(G26),1,255) ,
           sum(C27) ,
           sum(D27) ,
           sum(E27) ,
           sum(F27) ,
           substrb(catstr(G27),1,255) ,
           sum(C28) ,
           sum(D28) ,
           sum(E28) ,
           sum(F28) ,
           substrb(catstr(G28),1,255),
           sum(C29) ,
           sum(D29) ,
           sum(E29) ,
           sum(F29) ,
           substrb(catstr(G29),1,255) ,
           sum(C31) ,
           sum(D31) ,
           sum(E31) ,
           sum(F31) ,
           substrb(catstr(G31),1,255) ,
           sum(C34) ,
           sum(D34) ,
           sum(E34) ,
           sum(F34) ,
           substrb(catstr(G34),1,255) ,
           sum(C35) ,
           sum(D35) ,
           sum(E35) ,
           sum(F35) ,
           substrb(catstr(G35),1,255) ,
           sum(C36) ,
           sum(D36) ,
           sum(E36) ,
           sum(F36) ,
           substrb(catstr(G36),1,255) ,
           sum(C37) ,
           sum(D37) ,
           sum(E37) ,
           sum(F37) ,
           substrb(catstr(G37),1,255) ,
           sum(C38) ,
           sum(D38) ,
           sum(E38) ,
           sum(F38) ,
           substrb(catstr(G38),1,255)
      from T_CSRC1107_A7
     where BBQ = v_P001
     group by bbq;

  update krcs.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002
   WHERE P001 = v_reportid;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>' || A005 || A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = v_reportid;

  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003)
  VALUES
    (v_KJAXUSER, sysdate, v_temp);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_' || v_reportid || '!';
    return;
end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1115010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1115010(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

        select p002 into v_orgfrom krcs.t_sys_user where p001=v_KJAXUSER;
        select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1115010 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʲծܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0120_B1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0120_B1_1(
            BBQ,
            USERID,
            BTYPE,
            OPTION1,
            SHTAG,
            C3,
            D3,
            G3,
            H3,
            C4,
            D4,
            G4,
            H4,
            C5,
            D5,
            G5,
            H5,
            C6,
            D6,
            G6,
            H6,
            C7,
            D7,
            G7,
            H7,
            C8,
            D8,
            G8,
            H8,
            C9,
            D9,
            G9,
            H9,
            C10,
            D10,
            G10,
            H10,
            C11,
            D11,
            G11,
            H11,
            C12,
            D12,
            G12,
            H12,
            C13,
            D13,
            G13,
            H13,
            C14,
            D14,
            G14,
            H14,
            C15,
            D15,
            G15,
            H15,
            C16,
            D16,
            G16,
            H16,
            C17,
            D17,
            G17,
            H17,
            C18,
            D18,
            G18,
            H18,
            C19,
            D19,
            G19,
            H19,
            C20,
            D20,
            G20,
            H20,
            C21,
            D21,
            G21,
            H21,
            C22,
            D22,
            G22,
            H22,
            C23,
            D23,
            G23,
            H23,
            C24,
            D24,
            G24,
            H24,
            C25,
            D25,
            G25,
            H25,
            C26,
            D26,
            G26,
            H26,
            C27,
            D27,
            G27,
            H27,
            C28,
            D28,
            G28,
            H28,
            C29,
            D29,
            G29,
            H29,
            C30,
            D30,
            G30,
            H30,
            C31,
            D31,
            C32,
            D32,
            G32,
            H32,
            C33,
            D33,
            G33,
            H33,
            C34,
            D34,
            G34,
            H34,
            C35,
            D35,
            G35,
            H35,
            C36,
            D36,
            G36,
            H36,
            C37,
            D37,
            G37,
            H37,
            C38,
            D38,
            G38,
            H38,
            C39,
            D39,
            G39,
            H39,
            G40,
            H40,
            G41,
            H41,
            C43,
            D43,
            G43,
            H43,
            C47,
            D47,
            G47,
            H47,
            C48,
            D48,
            G48,
            H48,
            C49,
            D49,
            C50,
            D50,
            G50,
            H50,
            C51,
            D51,
            G51,
            H51,
            C52,
            D52,
            G52,
            H52,
            C53,
            D53,
            C54,
            D54,
            G54,
            H54,
            C55,
            D55,
            G55,
            H55,
            C56,
            D56,
            G56,
            H56,
            C58,
            D58,
            G58,
            H58,
            C59,
            D59,
            G59,
            H59,
            C60,
            D60,
            C61,
            D61,
            C62,
            D62
          )

 select     BBQ,
            v_user,
            0,
            null,
            0,
            sum(nvl(C3,0)),
            sum(nvl(D3,0)),
            sum(nvl(G3,0)),
            sum(nvl(H3,0)),
            sum(nvl(C4,0)),
            sum(nvl(D4,0)),
            sum(nvl(G4,0)),
            sum(nvl(H4,0)),
            sum(nvl(C5,0)),
            sum(nvl(D5,0)),
            sum(nvl(G5,0)),
            sum(nvl(H5,0)),
            sum(nvl(C6,0)),
            sum(nvl(D6,0)),
            sum(nvl(G6,0)),
            sum(nvl(H6,0)),
            sum(nvl(C7,0)),
            sum(nvl(D7,0)),
            sum(nvl(G7,0)),
            sum(nvl(H7,0)),
            sum(nvl(C8,0)),
            sum(nvl(D8,0)),
            sum(nvl(G8,0)),
            sum(nvl(H8,0)),
            sum(nvl(C9,0)),
            sum(nvl(D9,0)),
            sum(nvl(G9,0)),
            sum(nvl(H9,0)),
            sum(nvl(C10,0)),
            sum(nvl(D10,0)),
            sum(nvl(G10,0)),
            sum(nvl(H10,0)),
            sum(nvl(C11,0)),
            sum(nvl(D11,0)),
            sum(nvl(G11,0)),
            sum(nvl(H11,0)),
            sum(nvl(C12,0)),
            sum(nvl(D12,0)),
            sum(nvl(G12,0)),
            sum(nvl(H12,0)),
            sum(nvl(C13,0)),
            sum(nvl(D13,0)),
            sum(nvl(G13,0)),
            sum(nvl(H13,0)),
            sum(nvl(C14,0)),
            sum(nvl(D14,0)),
            sum(nvl(G14,0)),
            sum(nvl(H14,0)),
            sum(nvl(C15,0)),
            sum(nvl(D15,0)),
            sum(nvl(G15,0)),
            sum(nvl(H15,0)),
            sum(nvl(C16,0)),
            sum(nvl(D16,0)),
            sum(nvl(G16,0)),
            sum(nvl(H16,0)),
            sum(nvl(C17,0)),
            sum(nvl(D17,0)),
            sum(nvl(G17,0)),
            sum(nvl(H17,0)),
            sum(nvl(C18,0)),
            sum(nvl(D18,0)),
            sum(nvl(G18,0)),
            sum(nvl(H18,0)),
            sum(nvl(C19,0)),
            sum(nvl(D19,0)),
            sum(nvl(G19,0)),
            sum(nvl(H19,0)),
            sum(nvl(C20,0)),
            sum(nvl(D20,0)),
            sum(nvl(G20,0)),
            sum(nvl(H20,0)),
            sum(nvl(C21,0)),
            sum(nvl(D21,0)),
            sum(nvl(G21,0)),
            sum(nvl(H21,0)),
            sum(nvl(C22,0)),
            sum(nvl(D22,0)),
            sum(nvl(G22,0)),
            sum(nvl(H22,0)),
            sum(nvl(C23,0)),
            sum(nvl(D23,0)),
            sum(nvl(G23,0)),
            sum(nvl(H23,0)),
            sum(nvl(C24,0)),
            sum(nvl(D24,0)),
            sum(nvl(G24,0)),
            sum(nvl(H24,0)),
            sum(nvl(C25,0)),
            sum(nvl(D25,0)),
            sum(nvl(G25,0)),
            sum(nvl(H25,0)),
            sum(nvl(C26,0)),
            sum(nvl(D26,0)),
            sum(nvl(G26,0)),
            sum(nvl(H26,0)),
            sum(nvl(C27,0)),
            sum(nvl(D27,0)),
            sum(nvl(G27,0)),
            sum(nvl(H27,0)),
            sum(nvl(C28,0)),
            sum(nvl(D28,0)),
            sum(nvl(G28,0)),
            sum(nvl(H28,0)),
            sum(nvl(C29,0)),
            sum(nvl(D29,0)),
            sum(nvl(G29,0)),
            sum(nvl(H29,0)),
            sum(nvl(C30,0)),
            sum(nvl(D30,0)),
            sum(nvl(G30,0)),
            sum(nvl(H30,0)),
            sum(nvl(C31,0)),
            sum(nvl(D31,0)),
            sum(nvl(C32,0)),
            sum(nvl(D32,0)),
            sum(nvl(G32,0)),
            sum(nvl(H32,0)),
            sum(nvl(C33,0)),
            sum(nvl(D33,0)),
            sum(nvl(G33,0)),
            sum(nvl(H33,0)),
            sum(nvl(C34,0)),
            sum(nvl(D34,0)),
            sum(nvl(G34,0)),
            sum(nvl(H34,0)),
            sum(nvl(C35,0)),
            sum(nvl(D35,0)),
            sum(nvl(G35,0)),
            sum(nvl(H35,0)),
            sum(nvl(C36,0)),
            sum(nvl(D36,0)),
            sum(nvl(G36,0)),
            sum(nvl(H36,0)),
            sum(nvl(C37,0)),
            sum(nvl(D37,0)),
            sum(nvl(G37,0)),
            sum(nvl(H37,0)),
            sum(nvl(C38,0)),
            sum(nvl(D38,0)),
            sum(nvl(G38,0)),
            sum(nvl(H38,0)),
            sum(nvl(C39,0)),
            sum(nvl(D39,0)),
            sum(nvl(G39,0)),
            sum(nvl(H39,0)),
            sum(nvl(G40,0)),
            sum(nvl(H40,0)),
            sum(nvl(G41,0)),
            sum(nvl(H41,0)),
            sum(nvl(C43,0)),
            sum(nvl(D43,0)),
            sum(nvl(G43,0)),
            sum(nvl(H43,0)),
            sum(nvl(C47,0)),
            sum(nvl(D47,0)),
            sum(nvl(G47,0)),
            sum(nvl(H47,0)),
            sum(nvl(C48,0)),
            sum(nvl(D48,0)),
            sum(nvl(G48,0)),
            sum(nvl(H48,0)),
            sum(nvl(C49,0)),
            sum(nvl(D49,0)),
            sum(nvl(C50,0)),
            sum(nvl(D50,0)),
            sum(nvl(G50,0)),
            sum(nvl(H50,0)),
            sum(nvl(C51,0)),
            sum(nvl(D51,0)),
            sum(nvl(G51,0)),
            sum(nvl(H51,0)),
            sum(nvl(C52,0)),
            sum(nvl(D52,0)),
            sum(nvl(G52,0)),
            sum(nvl(H52,0)),
            sum(nvl(C53,0)),
            sum(nvl(D53,0)),
            sum(nvl(C54,0)),
            sum(nvl(D54,0)),
            sum(nvl(G54,0)),
            sum(nvl(H54,0)),
            sum(nvl(C55,0)),
            sum(nvl(D55,0)),
            sum(nvl(G55,0)),
            sum(nvl(H55,0)),
            sum(nvl(C56,0)),
            sum(nvl(D56,0)),
            sum(nvl(G56,0)),
            sum(nvl(H56,0)),
            sum(nvl(C58,0)),
            sum(nvl(D58,0)),
            sum(nvl(G58,0)),
            sum(nvl(H58,0)),
            sum(nvl(C59,0)),
            sum(nvl(D59,0)),
            sum(nvl(G59,0)),
            sum(nvl(H59,0)),
            sum(nvl(C60,0)),
            sum(nvl(D60,0)),
            sum(nvl(C61,0)),
            sum(nvl(D61,0)),
            sum(nvl(C62,0)),
            sum(nvl(D62,0))
         from T_CSRC0120_B1_1
        where BBQ = v_p001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1115010 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1115010;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1115010 and a008=v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1115010!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1115020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1115020(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';



       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1115020  and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0120_B2_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0120_B2_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
          C2,
          D2,
          C3,
          D3,
          C4,
          D4,
          C5,
          D5,
          C6,
          D6,
          C7,
          D7,
          C8,
          D8,
          C9,
          D9,
          C10,
          D10,
          C11,
          D11,
          C12,
          D12,
          C13,
          D13,
          C14,
          D14,
          C15,
          D15,
          C16,
          D16,
          C17,
          D17,
          C18,
          D18,
          C19,
          D19,
          C20,
          D20,
          C21,
          D21,
          C22,
          D22,
          C23,
          D23,
          C24,
          D24,
          C25,
          D25,
          C26,
          D26,
          C27,
          D27,
          C28,
          D28,
          C29,
          D29,
          C30,
          D30,
          C31,
          D31,
          C32,
          D32,
          C33,
          D33,
          C34,
          D34,
          C35,
          D35,
          C36,
          D36,
          C37,
          D37,
          C38,
          D38,
          C39,
          D39,
          C40,
          D40,
          C41,
          D41,
          C42,
          D42,
          C43,
          D43,
          C44,
          D44,
          C45,
          D45,
          C46,
          D46,
          C47,
          D47,
          C48,
          D48,
          C49,
          D49,
          C50,
          D50,
          C51,
          D51,
          C52,
          D52,
          C53,
          D53,
          C54,
          D54,
          C55,
          D55,
          C56,
          D56,
          C57,
          D57,
          C58,
          D58,
          C59,
          D59,
          C60,
          D60,
          C61,
          D61,
          C62,
          D62,
          C63,
          D63,
          C66,
          D66,
          C67,
          D67,
          C68,
          D68
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
          C2,
          D2,
          C3,
          D3,
          C4,
          D4,
          C5,
          D5,
          C6,
          D6,
          C7,
          D7,
          C8,
          D8,
          C9,
          D9,
          C10,
          D10,
          C11,
          D11,
          C12,
          D12,
          C13,
          D13,
          C14,
          D14,
          C15,
          D15,
          C16,
          D16,
          C17,
          D17,
          C18,
          D18,
          C19,
          D19,
          C20,
          D20,
          C21,
          D21,
          C22,
          D22,
          C23,
          D23,
          C24,
          D24,
          C25,
          D25,
          C26,
          D26,
          C27,
          D27,
          C28,
          D28,
          C29,
          D29,
          C30,
          D30,
          C31,
          D31,
          C32,
          D32,
          C33,
          D33,
          C34,
          D34,
          C35,
          D35,
          C36,
          D36,
          C37,
          D37,
          C38,
          D38,
          C39,
          D39,
          C40,
          D40,
          C41,
          D41,
          C42,
          D42,
          C43,
          D43,
          C44,
          D44,
          C45,
          D45,
          C46,
          D46,
          C47,
          D47,
          C48,
          D48,
          C49,
          D49,
          C50,
          D50,
          C51,
          D51,
          C52,
          D52,
          C53,
          D53,
          C54,
          D54,
          C55,
          D55,
          C56,
          D56,
          C57,
          D57,
          C58,
          D58,
          C59,
          D59,
          C60,
          D60,
          C61,
          D61,
          C62,
          D62,
          C63,
          D63,
          C66,
          D66,
          C67,
          D67,
          C68,
          D68
         from T_CSRC0120_B2_1
        where BBQ = v_P001 and userid in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1115020 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B2-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1115020;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1115020 and a008=v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1115020!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1115030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1115030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1115030 and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Ȩ䶯ܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_B3_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_B3_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           C2  ,
           D2  ,
           E2  ,
           F2  ,
           G2  ,
           H2  ,
           I2  ,
           J2  ,
           K2  ,
           C3  ,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           H3  ,
           I3  ,
           J3  ,
           K3  ,
           C4  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           H4  ,
           I4  ,
           J4  ,
           K4  ,
           C5  ,
           D5  ,
           E5  ,
           F5  ,
           G5  ,
           H5  ,
           I5  ,
           J5  ,
           K5  ,
           C6  ,
           D6  ,
           E6  ,
           F6  ,
           G6  ,
           H6  ,
           I6  ,
           J6  ,
           K6  ,
           C7  ,
           D7  ,
           E7  ,
           F7  ,
           G7  ,
           H7  ,
           I7  ,
           J7  ,
           K7  ,
           C8  ,
           D8  ,
           E8  ,
           F8  ,
           G8  ,
           H8  ,
           I8  ,
           J8  ,
           K8  ,
           C9  ,
           D9  ,
           E9  ,
           F9  ,
           G9  ,
           H9  ,
           I9  ,
           J9  ,
           K9  ,
           C10 ,
           D10 ,
           E10 ,
           F10 ,
           G10 ,
           H10 ,
           I10 ,
           J10 ,
           K10 ,
           C11 ,
           D11 ,
           E11 ,
           F11 ,
           G11 ,
           H11 ,
           I11 ,
           J11 ,
           K11 ,
           C12 ,
           D12 ,
           E12 ,
           F12 ,
           G12 ,
           H12 ,
           I12 ,
           J12 ,
           K12 ,
           C13 ,
           D13 ,
           E13 ,
           F13 ,
           G13 ,
           H13 ,
           I13 ,
           J13 ,
           K13 ,
           C14 ,
           D14 ,
           E14 ,
           F14 ,
           G14 ,
           H14 ,
           I14 ,
           J14 ,
           K14 ,
           C15 ,
           D15 ,
           E15 ,
           F15 ,
           G15 ,
           H15 ,
           I15 ,
           J15 ,
           K15 ,
           C16 ,
           D16 ,
           E16 ,
           F16 ,
           G16 ,
           H16 ,
           I16 ,
           J16 ,
           K16 ,
           C17 ,
           D17 ,
           E17 ,
           F17 ,
           G17 ,
           H17 ,
           I17 ,
           J17 ,
           K17 ,
           C18 ,
           D18 ,
           E18 ,
           F18 ,
           G18 ,
           H18 ,
           I18 ,
           J18 ,
           K18 ,
           C19 ,
           D19 ,
           E19 ,
           F19 ,
           G19 ,
           H19 ,
           I19 ,
           J19 ,
           K19 ,
           C20 ,
           D20 ,
           E20 ,
           F20 ,
           G20 ,
           H20 ,
           I20 ,
           J20 ,
           K20 ,
           C21 ,
           D21 ,
           E21 ,
           F21 ,
           G21 ,
           H21 ,
           I21 ,
           J21 ,
           K21 ,
           C22 ,
           D22 ,
           E22 ,
           F22 ,
           G22 ,
           H22 ,
           I22 ,
           J22 ,
           K22 ,
           C23 ,
           D23 ,
           E23 ,
           F23 ,
           G23 ,
           H23 ,
           I23 ,
           J23 ,
           K23 ,
           C24 ,
           D24 ,
           E24 ,
           F24 ,
           G24 ,
           H24 ,
           I24 ,
           J24 ,
           K24 ,
           C25 ,
           D25 ,
           E25 ,
           F25 ,
           G25 ,
           H25 ,
           I25 ,
           J25 ,
           K25 ,
           C26 ,
           D26 ,
           E26 ,
           F26 ,
           G26 ,
           H26 ,
           I26 ,
           J26 ,
           K26 ,
           C27 ,
           D27 ,
           E27 ,
           F27 ,
           G27 ,
           H27 ,
           I27 ,
           J27 ,
           K27 ,
           C28 ,
           D28 ,
           E28 ,
           F28 ,
           G28 ,
           H28 ,
           I28 ,
           J28 ,
           K28 ,
           C29 ,
           D29 ,
           E29 ,
           F29 ,
           G29 ,
           H29 ,
           I29 ,
           J29 ,
           K29 ,
           C30 ,
           D30 ,
           E30 ,
           F30 ,
           G30 ,
           H30 ,
           I30 ,
           J30 ,
           K30 ,
           C31 ,
           D31 ,
           E31 ,
           F31 ,
           G31 ,
           H31 ,
           I31 ,
           J31 ,
           K31 ,
           C32 ,
           D32 ,
           E32 ,
           F32 ,
           G32 ,
           H32 ,
           I32 ,
           J32 ,
           K32 ,
           C33 ,
           D33 ,
           E33 ,
           F33 ,
           G33 ,
           H33 ,
           I33 ,
           J33 ,
           K33 ,
           C34 ,
           D34 ,
           E34 ,
           F34 ,
           G34 ,
           H34 ,
           I34 ,
           J34 ,
           K34 ,
           C35 ,
           D35 ,
           E35 ,
           F35 ,
           G35 ,
           H35 ,
           I35 ,
           J35 ,
           K35 ,
           C36 ,
           D36 ,
           E36 ,
           F36 ,
           G36 ,
           H36 ,
           I36 ,
           J36 ,
           K36 ,
           C37 ,
           D37 ,
           E37 ,
           F37 ,
           G37 ,
           H37 ,
           I37 ,
           J37 ,
           K37
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           C2  ,
           D2  ,
           E2  ,
           F2  ,
           G2  ,
           H2  ,
           I2  ,
           J2  ,
           K2  ,
           C3  ,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           H3  ,
           I3  ,
           J3  ,
           K3  ,
           C4  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           H4  ,
           I4  ,
           J4  ,
           K4  ,
           C5  ,
           D5  ,
           E5  ,
           F5  ,
           G5  ,
           H5  ,
           I5  ,
           J5  ,
           K5  ,
           C6  ,
           D6  ,
           E6  ,
           F6  ,
           G6  ,
           H6  ,
           I6  ,
           J6  ,
           K6  ,
           C7  ,
           D7  ,
           E7  ,
           F7  ,
           G7  ,
           H7  ,
           I7  ,
           J7  ,
           K7  ,
           C8  ,
           D8  ,
           E8  ,
           F8  ,
           G8  ,
           H8  ,
           I8  ,
           J8  ,
           K8  ,
           C9  ,
           D9  ,
           E9  ,
           F9  ,
           G9  ,
           H9  ,
           I9  ,
           J9  ,
           K9  ,
           C10 ,
           D10 ,
           E10 ,
           F10 ,
           G10 ,
           H10 ,
           I10 ,
           J10 ,
           K10 ,
           C11 ,
           D11 ,
           E11 ,
           F11 ,
           G11 ,
           H11 ,
           I11 ,
           J11 ,
           K11 ,
           C12 ,
           D12 ,
           E12 ,
           F12 ,
           G12 ,
           H12 ,
           I12 ,
           J12 ,
           K12 ,
           C13 ,
           D13 ,
           E13 ,
           F13 ,
           G13 ,
           H13 ,
           I13 ,
           J13 ,
           K13 ,
           C14 ,
           D14 ,
           E14 ,
           F14 ,
           G14 ,
           H14 ,
           I14 ,
           J14 ,
           K14 ,
           C15 ,
           D15 ,
           E15 ,
           F15 ,
           G15 ,
           H15 ,
           I15 ,
           J15 ,
           K15 ,
           C16 ,
           D16 ,
           E16 ,
           F16 ,
           G16 ,
           H16 ,
           I16 ,
           J16 ,
           K16 ,
           C17 ,
           D17 ,
           E17 ,
           F17 ,
           G17 ,
           H17 ,
           I17 ,
           J17 ,
           K17 ,
           C18 ,
           D18 ,
           E18 ,
           F18 ,
           G18 ,
           H18 ,
           I18 ,
           J18 ,
           K18 ,
           C19 ,
           D19 ,
           E19 ,
           F19 ,
           G19 ,
           H19 ,
           I19 ,
           J19 ,
           K19 ,
           C20 ,
           D20 ,
           E20 ,
           F20 ,
           G20 ,
           H20 ,
           I20 ,
           J20 ,
           K20 ,
           C21 ,
           D21 ,
           E21 ,
           F21 ,
           G21 ,
           H21 ,
           I21 ,
           J21 ,
           K21 ,
           C22 ,
           D22 ,
           E22 ,
           F22 ,
           G22 ,
           H22 ,
           I22 ,
           J22 ,
           K22 ,
           C23 ,
           D23 ,
           E23 ,
           F23 ,
           G23 ,
           H23 ,
           I23 ,
           J23 ,
           K23 ,
           C24 ,
           D24 ,
           E24 ,
           F24 ,
           G24 ,
           H24 ,
           I24 ,
           J24 ,
           K24 ,
           C25 ,
           D25 ,
           E25 ,
           F25 ,
           G25 ,
           H25 ,
           I25 ,
           J25 ,
           K25 ,
           C26 ,
           D26 ,
           E26 ,
           F26 ,
           G26 ,
           H26 ,
           I26 ,
           J26 ,
           K26 ,
           C27 ,
           D27 ,
           E27 ,
           F27 ,
           G27 ,
           H27 ,
           I27 ,
           J27 ,
           K27 ,
           C28 ,
           D28 ,
           E28 ,
           F28 ,
           G28 ,
           H28 ,
           I28 ,
           J28 ,
           K28 ,
           C29 ,
           D29 ,
           E29 ,
           F29 ,
           G29 ,
           H29 ,
           I29 ,
           J29 ,
           K29 ,
           C30 ,
           D30 ,
           E30 ,
           F30 ,
           G30 ,
           H30 ,
           I30 ,
           J30 ,
           K30 ,
           C31 ,
           D31 ,
           E31 ,
           F31 ,
           G31 ,
           H31 ,
           I31 ,
           J31 ,
           K31 ,
           C32 ,
           D32 ,
           E32 ,
           F32 ,
           G32 ,
           H32 ,
           I32 ,
           J32 ,
           K32 ,
           C33 ,
           D33 ,
           E33 ,
           F33 ,
           G33 ,
           H33 ,
           I33 ,
           J33 ,
           K33 ,
           C34 ,
           D34 ,
           E34 ,
           F34 ,
           G34 ,
           H34 ,
           I34 ,
           J34 ,
           K34 ,
           C35 ,
           D35 ,
           E35 ,
           F35 ,
           G35 ,
           H35 ,
           I35 ,
           J35 ,
           K35 ,
           C36 ,
           D36 ,
           E36 ,
           F36 ,
           G36 ,
           H36 ,
           I36 ,
           J36 ,
           K36 ,
           C37 ,
           D37 ,
           E37 ,
           F37 ,
           G37 ,
           H37 ,
           I37 ,
           J37 ,
           K37
         from T_CSRC0707_B3_1
        where BBQ = v_P001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1115030 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B3-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1115030 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1115030 and  a008 = v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1115030!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1115040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1115040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;
	 select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

        select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1115040 and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʲֵ׼ܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_B4_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_B4_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           C3  ,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           C4  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           C5  ,
           D5  ,
           F5  ,
           G5  ,
           C6  ,
           D6  ,
           F6  ,
           G6  ,
           C7  ,
           D7  ,
           F7  ,
           G7  ,
           C8  ,
           D8  ,
           F8  ,
           G8  ,
           C9  ,
           D9  ,
           F9  ,
           G9  ,
           C10 ,
           D10 ,
           F10 ,
           G10 ,
           C11 ,
           D11 ,
           F11 ,
           G11 ,
           C12 ,
           D12 ,
           E12 ,
           F12 ,
           G12 ,
           C13 ,
           D13 ,
           E13 ,
           F13 ,
           G13 ,
           C14 ,
           D14 ,
           E14 ,
           F14 ,
           G14 ,
           C15 ,
           D15 ,
           E15 ,
           F15 ,
           G15 ,
           C16 ,
           D16 ,
           E16 ,
           F16 ,
           G16
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           C3  ,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           C4  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           C5  ,
           D5  ,
           F5  ,
           G5  ,
           C6  ,
           D6  ,
           F6  ,
           G6  ,
           C7  ,
           D7  ,
           F7  ,
           G7  ,
           C8  ,
           D8  ,
           F8  ,
           G8  ,
           C9  ,
           D9  ,
           F9  ,
           G9  ,
           C10 ,
           D10 ,
           F10 ,
           G10 ,
           C11 ,
           D11 ,
           F11 ,
           G11 ,
           C12 ,
           D12 ,
           E12 ,
           F12 ,
           G12 ,
           C13 ,
           D13 ,
           E13 ,
           F13 ,
           G13 ,
           C14 ,
           D14 ,
           E14 ,
           F14 ,
           G14 ,
           C15 ,
           D15 ,
           E15 ,
           F15 ,
           G15 ,
           C16 ,
           D16 ,
           E16 ,
           F16 ,
           G16
         from T_CSRC0707_B4_1
        where BBQ = v_P001 and userid in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);



    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1115040 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B4-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1115040 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1115040 and a008 = v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1115040!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120010(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120010 and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʽ뿪δͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C1_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           E4  ,
           F4  ,
           G4  ,
           H4  ,
           I4  ,
           J4  ,
           K4  ,
           E5  ,
           F5  ,
           G5  ,
           H5  ,
           I5  ,
           J5  ,
           K5  ,
           E6  ,
           F6  ,
           G6  ,
           H6  ,
           I6  ,
           J6  ,
           K6  ,
           E7  ,
           F7  ,
           G7  ,
           H7  ,
           I7  ,
           J7  ,
           K7  ,
           E8  ,
           F8  ,
           G8  ,
           H8  ,
           I8  ,
           J8  ,
           K8  ,
           E9  ,
           F9  ,
           G9  ,
           H9  ,
           I9  ,
           J9  ,
           K9  ,
           E10 ,
           F10 ,
           G10 ,
           H10 ,
           I10 ,
           J10 ,
           K10 ,
           K11 ,
           E12 ,
           F12 ,
           H12 ,
           J12 ,
           K12 ,
           E13 ,
           F13 ,
           H13 ,
           J13 ,
           K13 ,
           E14 ,
           F14 ,
           H14 ,
           J14 ,
           K14 ,
           E15 ,
           F15 ,
           H15 ,
           J15 ,
           K15 ,
           E16 ,
           F16 ,
           H16 ,
           J16 ,
           K16 ,
           E17 ,
           F17 ,
           H17 ,
           J17 ,
           K17 ,
           E18 ,
           F18 ,
           H18 ,
           J18 ,
           K18 ,
           E19 ,
           F19 ,
           H19 ,
           J19 ,
           K19 ,
           E20 ,
           F20 ,
           H20 ,
           J20 ,
           K20 ,
           E21 ,
           F21 ,
           H21 ,
           J21 ,
           K21 ,
           E22 ,
           F22 ,
           H22 ,
           J22 ,
           K22 ,
           E23 ,
           F23 ,
           H23 ,
           J23 ,
           K23 ,
           E24 ,
           F24 ,
           H24 ,
           J24 ,
           K24 ,
           E25 ,
           F25 ,
           H25 ,
           J25 ,
           K25 ,
           E26 ,
           F26 ,
           H26 ,
           J26 ,
           K26 ,
           E27 ,
           F27 ,
           H27 ,
           J27 ,
           K27 ,
            E28 ,
           F28 ,
           H28 ,
           J28 ,
           K28 ,
           E29 ,
            F29 ,
            H29 ,
            J29 ,
            K29 ,
            E30 ,
            F30 ,
            H30 ,
            J30 ,
            K30 ,
            E31 ,
            F31 ,
            H31 ,
            J31 ,
            K31 ,
            E32 ,
            F32 ,
            H32 ,
            J32 ,
            K32 ,
            E33 ,
            F33 ,
            H33 ,
            J33 ,
            K33 ,
            E34 ,
            F34 ,
            H34 ,
            J34 ,
            K34 ,
            E35 ,
            F35 ,
            H35 ,
            J35 ,
            K35 ,
            E36 ,
            F36 ,
            H36 ,
            J36 ,
            K36 ,
            E37 ,
            F37 ,
            H37 ,
            J37 ,
            K37 ,
             E38 ,
            F38 ,
            H38 ,
            J38 ,
            K38 ,
            E39 ,
            F39 ,
             H39 ,
            J39 ,
            K39 ,
            E40 ,
            F40 ,
            H40 ,
            J40 ,
            K40 ,

            E42 ,
            F42 ,
            H42 ,
            J42 ,
            K42 ,
            E43 ,
            F43 ,
            H43 ,
            J43 ,
            K43 ,
            E44 ,
            F44 ,
            H44 ,
            J44 ,
            K44 ,
            E45 ,
            F45 ,
            H45 ,
            J45 ,
            K45 ,
            E46 ,
            F46 ,
            H46 ,
            J46 ,
            K46 ,
            E47 ,
            F47 ,
            H47 ,
            J47 ,
            K47 ,
            E48 ,
            F48 ,
            H48 ,
            J48 ,
            K48 ,
             E49 ,
            F49,
            H49 ,
            J49 ,
            K49 ,
              E52 ,
            K52 ,
             E53 ,
            K53 ,
             E54 ,
            K54 ,
             E55 ,
            K55 ,
             E56 ,
            K56 ,
            E58 ,
            K58 ,
             E59 ,
            K59 ,
             E60 ,
            K60
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(G4 ) ,
           sum(H4 ) ,
           sum(I4 ) ,
           sum(J4 ) ,
           substrb(catstr(k4),1,255),
           sum(E5 ) ,
           sum(F5 ) ,
           sum(G5 ) ,
           sum(H5 ) ,
           sum(I5 ) ,
           sum(J5 ) ,
           substrb(catstr(k5),1,255),
           sum(E6 ) ,
           sum(F6 ) ,
           sum(G6 ) ,
           sum(H6 ) ,
           sum(I6 ) ,
           sum(J6 ) ,
           substrb(catstr(k6),1,255),
           sum(E7 ) ,
           sum(F7 ) ,
           sum(G7 ) ,
           sum(H7 ) ,
           sum(I7 ) ,
           sum(J7 ) ,
           substrb(catstr(k7),1,255),
           sum(E8 ) ,
           sum(F8 ) ,
           sum(G8 ) ,
           sum(H8 ) ,
           sum(I8 ) ,
           sum(J8 ) ,
           substrb(catstr(k8),1,255),
           sum(E9 ) ,
           sum(F9 ) ,
           sum(G9 ) ,
           sum(H9 ) ,
           sum(I9 ) ,
           sum(J9 ) ,
           substrb(catstr(k9),1,255),
           sum(E10) ,
           sum(F10) ,
           sum(G10) ,
           sum(H10) ,
           sum(I10) ,
           sum(J10) ,
           substrb(catstr(k10),1,255),
           substrb(catstr(k11),1,255),
           sum(E12) ,
           sum(F12) ,
           sum(H12) ,
           sum(J12) ,
           substrb(catstr(k12),1,255),
           sum(E13) ,
           sum(F13) ,
           sum(H13) ,
           sum(J13) ,
           substrb(catstr(k13),1,255),
           sum(E14) ,
           sum(F14) ,
           sum(H14) ,
           sum(J14) ,
           substrb(catstr(k14),1,255),
           sum(E15) ,
           sum(F15) ,
           sum(H15) ,
           sum(J15) ,
           substrb(catstr(k15),1,255),
           sum(E16) ,
           sum(F16) ,
           sum(H16) ,
           sum(J16) ,
           substrb(catstr(k16),1,255),
           sum(E17) ,
           sum(F17) ,
           sum(H17) ,
           sum(J17) ,
           substrb(catstr(k17),1,255),
           sum(E18) ,
           sum(F18) ,
           sum(H18) ,
           sum(J18) ,
           substrb(catstr(k18),1,255),
           sum(E19) ,
           sum(F19) ,
           sum(H19) ,
           sum(J19) ,
           substrb(catstr(k19),1,255),
           sum(E20) ,
           sum(F20) ,
           sum(H20) ,
           sum(J20) ,
           substrb(catstr(k20),1,255),
           sum(E21) ,
           sum(F21) ,
           sum(H21) ,
           sum(J21) ,
           substrb(catstr(k21),1,255),
           sum(E22) ,
           sum(F22) ,
           sum(H22) ,
           sum(J22) ,
           substrb(catstr(k22),1,255),
           sum(E23) ,
           sum(F23) ,
           sum(H23) ,
           sum(J23) ,
           substrb(catstr(k23),1,255),
           sum(E24) ,
           sum(F24) ,
           sum(H24) ,
           sum(J24) ,
           substrb(catstr(k24),1,255),
           sum(E25) ,
           sum(F25) ,
           sum(H25) ,
           sum(J25) ,
           substrb(catstr(k25),1,255),
           sum(E26) ,
           sum(F26) ,
           sum(H26) ,
           sum(J26) ,
           substrb(catstr(k26),1,255),
           sum(E27) ,
           sum(F27) ,
           sum(H27) ,
           sum(J27) ,
           substrb(catstr(k27),1,255),
           sum(E28) ,
           sum(F28) ,
           sum(H28) ,
           sum(J28) ,
           substrb(catstr(k28),1,255),
           sum(E29),
              sum(F29),
              sum(H29),
              sum(J29),
              substrb(catstr(k29),1,255),
              sum(E30),
              sum(F30),
              sum(H30),
              sum(J30),
              substrb(catstr(k30),1,255),
              sum(E31),
              sum(F31),
              sum(H31),
              sum(J31),
              substrb(catstr(k31),1,255),
              sum(E32),
              sum(F32),
              sum(H32),
              sum(J32),
              substrb(catstr(k32),1,255),
              sum(E33),
              sum(F33),
              sum(H33),
              sum(J33),
              substrb(catstr(k33),1,255),
              sum(E34),
              sum(F34),
              sum(H34),
              sum(J34),
              substrb(catstr(k34),1,255),
              sum(E35),
              sum(F35),
              sum(H35),
              sum(J35),
              substrb(catstr(k35),1,255),
              sum(E36),
              sum(F36),
              sum(H36),
              sum(J36),
              substrb(catstr(k36),1,255),

              sum(E37),
              sum(F37),
              sum(H37),
              sum(J37),
              substrb(catstr(k37),1,255),
              sum(E38),
              sum(F38),
              sum(H38),
              sum(J38),
              substrb(catstr(k38),1,255),
              sum(E39),
              sum(F39),
              sum(H39),
              sum(J39),
              substrb(catstr(k39),1,255),
              sum(E40),
              sum(F40),
              sum(H40),
              sum(J40),
              substrb(catstr(k40),1,255),

              sum(E42),
              sum(F42),
              sum(H42),
              sum(J42),
              substrb(catstr(k42),1,255),
              sum(E43),
              sum(F43),
              sum(H43),
              sum(J43),
              substrb(catstr(k43),1,255),
              sum(E44),
              sum(F44),
              sum(H44),
              sum(J44),
              substrb(catstr(k44),1,255),
              sum(E45),
              sum(F45),
              sum(H45),
              sum(J45),
              substrb(catstr(k45),1,255),
               sum(E46),
              sum(F46),
              sum(H46),
              sum(J46),
              substrb(catstr(k46),1,255),
              sum(E47),
              sum(F47),
              sum(H47),
              sum(J47),
              substrb(catstr(k47),1,255),
              sum(E48),
              sum(F48),
              sum(H48),
              sum(J48),
              substrb(catstr(k48),1,255),
              sum(E49),
              sum(F49),
              sum(H49),
              sum(J49),
              substrb(catstr(k49),1,255),

              sum(E52),
              substrb(catstr(k52),1,255),
              sum(E53),
              substrb(catstr(k53),1,255),
              sum(E54),
              substrb(catstr(k54),1,255),
              sum(E55),
              substrb(catstr(k55),1,255),
              sum(E56),
              substrb(catstr(k56),1,255),
              sum(E58),
              substrb(catstr(k58),1,255),
              sum(E59),
              substrb(catstr(k59),1,255),
              sum(E60),
              substrb(catstr(k60),1,255)
        from T_CSRC0707_C1_1
        where BBQ = v_P001  and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120010 and  a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120010 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120010 and  a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120010!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120020(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120020 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='δͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C1_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C1_2(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           D3  ,
           E3  ,
           F3  ,
           D4  ,
           E4  ,
           F4  ,
           D5  ,
           E5  ,
           F5  ,
           D6  ,
           E6  ,
           F6  ,
           D7  ,
           E7  ,
           F7  ,
           D8  ,
           E8  ,
           F8  ,
           D9  ,
           E9  ,
           F9  ,
           D10 ,
           E10 ,
           F10 ,
           D11 ,
           E11 ,
           F11 ,
           D12 ,
           E12 ,
           F12 ,
           D13 ,
           E13 ,
           F13 ,
           D14 ,
           E14 ,
           F14 ,
           D15 ,
           E15 ,
           F15 ,
           D16 ,
           E16 ,
           F16 ,
           D17 ,
           E17 ,
           F17 ,
           D18 ,
           E18 ,
           F18 ,
           D19 ,
           E19 ,
           F19 ,
           D20 ,
           E20 ,
           F20 ,
           D21 ,
           E21 ,
           F21 ,
           D22 ,
           E22 ,
           F22 ,
           D23 ,
           E23 ,
           F23 ,
           D24 ,
           E24 ,
           F24 ,
           D25 ,
           E25 ,
           F25 ,
           D26 ,
           E26 ,
           F26 ,
           D27 ,
           E27 ,
           F27 ,
           D28 ,
           E28 ,
           F28 ,
           D29 ,
           E29 ,
           F29 ,
           D30 ,
           E30 ,
           F30 ,
           D31 ,
           E31 ,
           F31 ,
           D32 ,
           E32 ,
           F32 ,
           D34 ,
           D35 ,
           D36 ,
           D37
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(D3 ) ,
           sum(E3 ) ,
           sum(F3 ) ,
           sum(D4 ) ,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(D5 ) ,
           sum(E5 ) ,
           sum(F5 ) ,
           sum(D6 ) ,
           sum(E6 ) ,
           sum(F6 ) ,
           sum(D7 ) ,
           sum(E7 ) ,
           sum(F7 ) ,
           sum(D8 ) ,
           sum(E8 ) ,
           sum(F8 ) ,
           sum(D9 ) ,
           sum(E9 ) ,
           sum(F9 ) ,
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           sum(D11) ,
           sum(E11) ,
           sum(F11) ,
           sum(D12) ,
           sum(E12) ,
           sum(F12) ,
           sum(D13) ,
           sum(E13) ,
           sum(F13) ,
           sum(D14) ,
           sum(E14) ,
           sum(F14) ,
           sum(D15) ,
           sum(E15) ,
           sum(F15) ,
           sum(D16) ,
           sum(E16) ,
           sum(F16) ,
           sum(D17) ,
           sum(E17) ,
           sum(F17) ,
           sum(D18) ,
           sum(E18) ,
           sum(F18) ,
           sum(D19) ,
           sum(E19) ,
           sum(F19) ,
           sum(D20) ,
           sum(E20) ,
           sum(F20) ,
           sum(D21) ,
           sum(E21) ,
           sum(F21) ,
           sum(D22) ,
           sum(E22) ,
           sum(F22) ,
           sum(D23) ,
           sum(E23) ,
           sum(F23) ,
           sum(D24) ,
           sum(E24) ,
           sum(F24) ,
           sum(D25) ,
           sum(E25) ,
           sum(F25) ,
           sum(D26) ,
           sum(E26) ,
           sum(F26) ,
           sum(D27) ,
           sum(E27) ,
           sum(F27) ,
           sum(D28) ,
           sum(E28) ,
           sum(F28) ,
           sum(D29) ,
           sum(E29) ,
           sum(F29) ,
           sum(D30) ,
           sum(E30) ,
           sum(F30) ,
           sum(D31) ,
           sum(E31) ,
           sum(F31) ,
           sum(D32) ,
           sum(E32) ,
           sum(F32) ,
           sum(D34) ,
           sum(D35) ,
           sum(D36) ,
           sum(D37)
        from T_CSRC0707_C1_2
        where BBQ = v_P001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120020 and  a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C1-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120020;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120020 and  a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120020!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

       select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120030 and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='̨ҵδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C1_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C1_3(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           H3  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           H4  ,
           D5  ,
           E5  ,
           F5  ,
           G5  ,
           H5  ,
           D6  ,
           E6  ,
           F6  ,
           G6  ,
           H6  ,
           D7  ,
           E7  ,
           F7  ,
           G7  ,
           H7  ,
           D8  ,
           E8  ,
           F8  ,
           G8  ,
           H8  ,
           D9  ,
           E9  ,
           F9  ,
           G9  ,
           H9  ,
           D10 ,
           E10 ,
           F10 ,
           G10 ,
           H10
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(D3 ) ,
           sum(E3 ) ,
           sum(F3 ) ,
           sum(G3 ) ,
           substrb(catstr(H3),1,255) ,
           sum(D4 ) ,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(G4 ) ,
           substrb(catstr(H4),1,255),
           sum(D5 ) ,
           sum(E5 ) ,
           sum(F5 ) ,
           sum(G5 ) ,
           substrb(catstr(H5),1,255),
           sum(D6 ) ,
           sum(E6 ) ,
           sum(F6 ) ,
           sum(G6 ) ,
           substrb(catstr(H6),1,255),
           sum(D7 ) ,
           sum(E7 ) ,
           sum(F7 ) ,
           sum(G7 ) ,
           substrb(catstr(H7),1,255),
           sum(D8 ) ,
           sum(E8 ) ,
           sum(F8 ) ,
           sum(G8 ) ,
           substrb(catstr(H8),1,255),
           sum(D9 ) ,
           sum(E9 ) ,
           sum(F9 ) ,
           sum(G9 ) ,
           substrb(catstr(H9),1,255),
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           sum(G10) ,
           substrb(catstr(H10),1,255)
        from T_CSRC0707_C1_3
        where BBQ = v_P001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120030 and  a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C1-3'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120030;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120030 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120030!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120040 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ҵܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_c2_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_c2_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            C2 ,
            C3 ,
            C4 ,
            C5 ,
            C6 ,
            C7 ,
            C8 ,
            C9 ,
            C10,
            C13,
            D13,
            E13,
            D14,
            E14,
            C15,
            D15,
            E15,
            C16,
            D16,
            E16,
            C17,
            D17,
            E17,
            C14
          )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            sum(C2) ,
            sum(C3) ,
            sum(C4) ,
            sum(C5) ,
            sum(C6) ,
            sum(C7) ,
            max(C8) ,
            max(C9) ,
            max(C10),
            sum(C13),
            sum(D13),
            sum(E13),
            sum(D14),
            sum(E14),
            sum(C15),
            sum(D15),
            sum(E15),
            sum(C16),
            sum(D16),
            sum(E16),
            sum(C17),
            sum(D17),
            sum(E17),
            sum(C14)
        from t_csrc0707_c2_1
        where BBQ = v_P001 and userid in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
            group by BBQ,BTYPE,OPTION1,SHTAG;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120040 and  a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C2-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120040;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120040 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120040!'||sqlerrm;
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120050
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120050(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120050
       and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ģδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C2_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C2_2(
          BBQ,
          USERID,
          BTYPE,
          OPTION1,
          SHTAG,
          D4  ,
          E4  ,
          F4  ,
          G4  ,
          H4  ,
          I4  ,
          J4  ,
          K4  ,
          L4  ,
          M4  ,
          N4  ,
          O4  ,
          P4  ,
          Q4  ,
          R4  ,
          S4  ,
          T4  ,
          U4  ,
          D5  ,
          E5  ,
          F5  ,
          G5  ,
          H5  ,
          I5  ,
          J5  ,
          K5  ,
          L5  ,
          M5  ,
          N5  ,
          O5  ,
          P5  ,
          Q5  ,
          R5  ,
          S5  ,
          T5  ,
          U5  ,
          D6  ,
          E6  ,
          F6  ,
          G6  ,
          H6  ,
          I6  ,
          J6  ,
          K6  ,
          L6  ,
          M6  ,
          N6  ,
          O6  ,
          P6  ,
          Q6  ,
          R6  ,
          S6  ,
          T6  ,
          U6  ,
          D7  ,
          E7  ,
          F7  ,
          G7  ,
          H7  ,
          I7  ,
          J7  ,
          K7  ,
          L7  ,
          M7  ,
          N7  ,
          O7  ,
          P7  ,
          Q7  ,
          R7  ,
          S7  ,
          T7  ,
          U7  ,
          D8  ,
          E8  ,
          F8  ,
          G8  ,
          H8  ,
          I8  ,
          J8  ,
          K8  ,
          L8  ,
          M8  ,
          N8  ,
          O8  ,
          P8  ,
          Q8  ,
          R8  ,
          S8  ,
          T8  ,
          U8  ,
          D9  ,
          E9  ,
          F9  ,
          G9  ,
          H9  ,
          I9  ,
          J9  ,
          K9  ,
          L9  ,
          M9  ,
          N9  ,
          O9  ,
          P9  ,
          Q9  ,
          R9  ,
          S9  ,
          T9  ,
          U9  ,
          D10 ,
          E10 ,
          F10 ,
          G10 ,
          H10 ,
          I10 ,
          J10 ,
          K10 ,
          L10 ,
          M10 ,
          N10 ,
          O10 ,
          P10 ,
          Q10 ,
          R10 ,
          S10 ,
          T10 ,
          U10 ,
          D11 ,
          E11 ,
          F11 ,
          G11 ,
          H11 ,
          I11 ,
          J11 ,
          K11 ,
          L11 ,
          M11 ,
          N11 ,
          O11 ,
          P11 ,
          Q11 ,
          R11 ,
          S11 ,
          T11 ,
          U11 ,
          D12 ,
          E12 ,
          F12 ,
          G12 ,
          H12 ,
          I12 ,
          J12 ,
          K12 ,
          L12 ,
          M12 ,
          N12 ,
          O12 ,
          P12 ,
          Q12 ,
          R12 ,
          S12 ,
          T12 ,
          U12 ,
          D13 ,
          E13 ,
          F13 ,
          G13 ,
          H13 ,
          I13 ,
          J13 ,
          K13 ,
          L13 ,
          M13 ,
          N13 ,
          O13 ,
          P13 ,
          Q13 ,
          R13 ,
          S13 ,
          T13 ,
          U13 ,
          D14 ,
          E14 ,
          F14 ,
          G14 ,
          H14 ,
          I14 ,
          J14 ,
          K14 ,
          L14 ,
          M14 ,
          N14 ,
          O14 ,
          P14 ,
          Q14 ,
          R14 ,
          S14 ,
          T14 ,
          U14 ,
          D15 ,
          E15 ,
          F15 ,
          G15 ,
          H15 ,
          I15 ,
          J15 ,
          K15 ,
          L15 ,
          M15 ,
          N15 ,
          O15 ,
          P15 ,
          Q15 ,
          R15 ,
          S15 ,
          T15 ,
          U15 ,
          D16 ,
          E16 ,
          F16 ,
          G16 ,
          H16 ,
          I16 ,
          J16 ,
          K16 ,
          L16 ,
          M16 ,
          N16 ,
          O16 ,
          P16 ,
          Q16 ,
          R16 ,
          S16 ,
          T16 ,
          U16 ,
          D17 ,
          E17 ,
          F17 ,
          G17 ,
          H17 ,
          I17 ,
          J17 ,
          K17 ,
          L17 ,
          M17 ,
          N17 ,
          O17 ,
          P17 ,
          Q17 ,
          R17 ,
          S17 ,
          T17 ,
          U17 ,
          D18 ,
          E18 ,
          F18 ,
          G18 ,
          H18 ,
          I18 ,
          J18 ,
          K18 ,
          L18 ,
          M18 ,
          N18 ,
          O18 ,
          P18 ,
          Q18 ,
          R18 ,
          S18 ,
          T18 ,
          U18 ,
          D19 ,
          E19 ,
          F19 ,
          G19 ,
          H19 ,
          I19 ,
          J19 ,
          K19 ,
          L19 ,
          M19 ,
          N19 ,
          O19 ,
          P19 ,
          Q19 ,
          R19 ,
          S19 ,
          T19 ,
          U19 ,
          D20 ,
          E20 ,
          F20 ,
          G20 ,
          H20 ,
          I20 ,
          J20 ,
          K20 ,
          L20 ,
          M20 ,
          N20 ,
          O20 ,
          P20 ,
          Q20 ,
          R20 ,
          S20 ,
          T20 ,
          U20 ,
          D21 ,
          E21 ,
          F21 ,
          G21 ,
          H21 ,
          I21 ,
          J21 ,
          K21 ,
          L21 ,
          M21 ,
          N21 ,
          O21 ,
          P21 ,
          Q21 ,
          R21 ,
          S21 ,
          T21 ,
          U21 ,
          D22 ,
          E22 ,
          F22 ,
          G22 ,
          H22 ,
          I22 ,
          J22 ,
          K22 ,
          L22 ,
          M22 ,
          N22 ,
          O22 ,
          P22 ,
          Q22 ,
          R22 ,
          S22 ,
          T22 ,
          U22
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(D4 ) ,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(G4 ) ,
           sum(H4 ) ,
           sum(I4 ) ,
           sum(J4 ) ,
           sum(K4 ) ,
           sum(L4 ) ,
           sum(M4 ) ,
           sum(N4 ) ,
           sum(O4 ) ,
           sum(P4 ) ,
           sum(Q4 ) ,
           sum(R4 ) ,
           sum(S4 ) ,
           sum(T4 ) ,
           sum(U4 ) ,
           sum(D5 ) ,
           sum(E5 ) ,
           sum(F5 ) ,
           sum(G5 ) ,
           sum(H5 ) ,
           sum(I5 ) ,
           sum(J5 ) ,
           sum(K5 ) ,
           sum(L5 ) ,
           sum(M5 ) ,
           sum(N5 ) ,
           sum(O5 ) ,
           sum(P5 ) ,
           sum(Q5 ) ,
           sum(R5 ) ,
           sum(S5 ) ,
           sum(T5 ) ,
           sum(U5 ) ,
           sum(D6 ) ,
           sum(E6 ) ,
           sum(F6 ) ,
           sum(G6 ) ,
           sum(H6 ) ,
           sum(I6 ) ,
           sum(J6 ) ,
           sum(K6 ) ,
           sum(L6 ) ,
           sum(M6 ) ,
           sum(N6 ) ,
           sum(O6 ) ,
           sum(P6 ) ,
           sum(Q6 ) ,
           sum(R6 ) ,
           sum(S6 ) ,
           sum(T6 ) ,
           sum(U6 ) ,
           sum(D7 ) ,
           sum(E7 ) ,
           sum(F7 ) ,
           sum(G7 ) ,
           sum(H7 ) ,
           sum(I7 ) ,
           sum(J7 ) ,
           sum(K7 ) ,
           sum(L7 ) ,
           sum(M7 ) ,
           sum(N7 ) ,
           sum(O7 ) ,
           sum(P7 ) ,
           sum(Q7 ) ,
           sum(R7 ) ,
           sum(S7 ) ,
           sum(T7 ) ,
           sum(U7 ) ,
           sum(D8 ) ,
           sum(E8 ) ,
           sum(F8 ) ,
           sum(G8 ) ,
           sum(H8 ) ,
           sum(I8 ) ,
           sum(J8 ) ,
           sum(K8 ) ,
           sum(L8 ) ,
           sum(M8 ) ,
           sum(N8 ) ,
           sum(O8 ) ,
           sum(P8 ) ,
           sum(Q8 ) ,
           sum(R8 ) ,
           sum(S8 ) ,
           sum(T8 ) ,
           sum(U8 ) ,
           sum(D9 ) ,
           sum(E9 ) ,
           sum(F9 ) ,
           sum(G9 ) ,
           sum(H9 ) ,
           sum(I9 ) ,
           sum(J9 ) ,
           sum(K9 ) ,
           sum(L9 ) ,
           sum(M9 ) ,
           sum(N9 ) ,
           sum(O9 ) ,
           sum(P9 ) ,
           sum(Q9 ) ,
           sum(R9 ) ,
           sum(S9 ) ,
           sum(T9 ) ,
           sum(U9 ) ,
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           sum(G10) ,
           sum(H10) ,
           sum(I10) ,
           sum(J10) ,
           sum(K10) ,
           sum(L10) ,
           sum(M10) ,
           sum(N10) ,
           sum(O10) ,
           sum(P10) ,
           sum(Q10) ,
           sum(R10) ,
           sum(S10) ,
           sum(T10) ,
           sum(U10) ,
           sum(D11) ,
           sum(E11) ,
           sum(F11) ,
           sum(G11) ,
           sum(H11) ,
           sum(I11) ,
           sum(J11) ,
           sum(K11) ,
           sum(L11) ,
           sum(M11) ,
           sum(N11) ,
           sum(O11) ,
           sum(P11) ,
           sum(Q11) ,
           sum(R11) ,
           sum(S11) ,
           sum(T11) ,
           sum(U11) ,
           sum(D12) ,
           sum(E12) ,
           sum(F12) ,
           sum(G12) ,
           sum(H12) ,
           sum(I12) ,
           sum(J12) ,
           sum(K12) ,
           sum(L12) ,
           sum(M12) ,
           sum(N12) ,
           sum(O12) ,
           sum(P12) ,
           sum(Q12) ,
           sum(R12) ,
           sum(S12) ,
           sum(T12) ,
           sum(U12) ,
           sum(D13) ,
           sum(E13) ,
           sum(F13) ,
           sum(G13) ,
           sum(H13) ,
           sum(I13) ,
           sum(J13) ,
           sum(K13) ,
           sum(L13) ,
           sum(M13) ,
           sum(N13) ,
           sum(O13) ,
           sum(P13) ,
           sum(Q13) ,
           sum(R13) ,
           sum(S13) ,
           sum(T13) ,
           sum(U13) ,
           sum(D14) ,
           sum(E14) ,
           sum(F14) ,
           sum(G14) ,
           sum(H14) ,
           sum(I14) ,
           sum(J14) ,
           sum(K14) ,
           sum(L14) ,
           sum(M14) ,
           sum(N14) ,
           sum(O14) ,
           sum(P14) ,
           sum(Q14) ,
           sum(R14) ,
           sum(S14) ,
           sum(T14) ,
           sum(U14) ,
           sum(D15) ,
           sum(E15) ,
           sum(F15) ,
           sum(G15) ,
           sum(H15) ,
           sum(I15) ,
           sum(J15) ,
           sum(K15) ,
           sum(L15) ,
           sum(M15) ,
           sum(N15) ,
           sum(O15) ,
           sum(P15) ,
           sum(Q15) ,
           sum(R15) ,
           sum(S15) ,
           sum(T15) ,
           sum(U15) ,
           sum(D16) ,
           sum(E16) ,
           sum(F16) ,
           sum(G16) ,
           sum(H16) ,
           sum(I16) ,
           sum(J16) ,
           sum(K16) ,
           sum(L16) ,
           sum(M16) ,
           sum(N16) ,
           sum(O16) ,
           sum(P16) ,
           sum(Q16) ,
           sum(R16) ,
           sum(S16) ,
           sum(T16) ,
           sum(U16) ,
           sum(D17) ,
           sum(E17) ,
           sum(F17) ,
           sum(G17) ,
           sum(H17) ,
           sum(I17) ,
           sum(J17) ,
           sum(K17) ,
           sum(L17) ,
           sum(M17) ,
           sum(N17) ,
           sum(O17) ,
           sum(P17) ,
           sum(Q17) ,
           sum(R17) ,
           sum(S17) ,
           sum(T17) ,
           sum(U17) ,
           sum(D18) ,
           sum(E18) ,
           sum(F18) ,
           sum(G18) ,
           sum(H18) ,
           sum(I18) ,
           sum(J18) ,
           sum(K18) ,
           sum(L18) ,
           sum(M18) ,
           sum(N18) ,
           sum(O18) ,
           sum(P18) ,
           sum(Q18) ,
           sum(R18) ,
           sum(S18) ,
           sum(T18) ,
           sum(U18) ,
           sum(D19) ,
           sum(E19) ,
           sum(F19) ,
           sum(G19) ,
           sum(H19) ,
           sum(I19) ,
           sum(J19) ,
           sum(K19) ,
           sum(L19) ,
           sum(M19) ,
           sum(N19) ,
           sum(O19) ,
           sum(P19) ,
           sum(Q19) ,
           sum(R19) ,
           sum(S19) ,
           sum(T19) ,
           sum(U19) ,
           sum(D20) ,
           sum(E20) ,
           sum(F20) ,
           sum(G20) ,
           sum(H20) ,
           sum(I20) ,
           sum(J20) ,
           sum(K20) ,
           sum(L20) ,
           sum(M20) ,
           sum(N20) ,
           sum(O20) ,
           sum(P20) ,
           sum(Q20) ,
           sum(R20) ,
           sum(S20) ,
           sum(T20) ,
           sum(U20) ,
           sum(D21) ,
           sum(E21) ,
           sum(F21) ,
           sum(G21) ,
           sum(H21) ,
           sum(I21) ,
           sum(J21) ,
           sum(K21) ,
           sum(L21) ,
           sum(M21) ,
           sum(N21) ,
           sum(O21) ,
           sum(P21) ,
           sum(Q21) ,
           sum(R21) ,
           sum(S21) ,
           sum(T21) ,
           sum(U21) ,
           sum(D22) ,
           sum(E22) ,
           sum(F22) ,
           sum(G22) ,
           sum(H22) ,
           sum(I22) ,
           sum(J22) ,
           sum(K22) ,
           sum(L22) ,
           sum(M22) ,
           sum(N22) ,
           sum(O22) ,
           sum(P22) ,
           sum(Q22) ,
           sum(R22) ,
           sum(S22) ,
           sum(T22) ,
           sum(U22)
        from T_CSRC0707_C2_2
        where BBQ = v_P001
          and userid in
        (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120050 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C2-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120050;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120050 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120050!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120060
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120060(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120060
       and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ƱծȯͶδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C3_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C3_1(
          BBQ,
          USERID,
          BTYPE,
          OPTION1,
          SHTAG,
          E4  ,
          F4  ,
          G4  ,
          H4  ,
          I4  ,
          J4  ,
          E5  ,
          F5  ,
          G5  ,
          H5  ,
          I5  ,
          J5  ,
          E6  ,
          F6  ,
          G6  ,
          H6  ,
          I6  ,
          J6  ,
          E7  ,
          F7  ,
          G7  ,
          H7  ,
          I7  ,
          J7  ,
          E8  ,
          F8  ,
          G8  ,
          H8  ,
          I8  ,
          J8  ,
          E9  ,
          F9  ,
          G9  ,
          H9  ,
          I9  ,
          J9  ,
          E10 ,
          F10 ,
          G10 ,
          H10 ,
          I10 ,
          J10 ,
          E11 ,
          F11 ,
          G11 ,
          H11 ,
          I11 ,
          J11 ,
          E12 ,
          F12 ,
          G12 ,
          H12 ,
          I12 ,
          J12 ,
          E13 ,
          F13 ,
          G13 ,
          H13 ,
          I13 ,
          J13 ,
          E14 ,
          F14 ,
          G14 ,
          H14 ,
          I14 ,
          J14 ,
          E15 ,
          F15 ,
          G15 ,
          H15 ,
          I15 ,
          J15 ,
          E16 ,
          F16 ,
          G16 ,
          H16 ,
          I16 ,
          J16 ,
          E17 ,
          F17 ,
          G17 ,
          H17 ,
          I17 ,
          J17 ,
          E18 ,
          F18 ,
          G18 ,
          H18 ,
          I18 ,
          J18 ,
          E19 ,
          F19 ,
          G19 ,
          H19 ,
          I19 ,
          J19 ,
          E20 ,
          F20 ,
          G20 ,
          H20 ,
          I20 ,
          J20 ,
          E21 ,
          F21 ,
          G21 ,
          H21 ,
          I21 ,
          J21 ,
          K21 ,
          E22 ,
          F22 ,
          G22 ,
          H22 ,
          I22 ,
          J22 ,
          K22 ,
          E23 ,
          F23 ,
          G23 ,
          H23 ,
          I23 ,
          J23 ,
          K23 ,
          E24 ,
          F24 ,
          G24 ,
          H24 ,
          I24 ,
          J24 ,
          K24 ,
          E25 ,
          F25 ,
          G25 ,
          H25 ,
          I25 ,
          J25 ,
          K25 ,
          E26 ,
          F26 ,
          G26 ,
          H26 ,
          I26 ,
          J26 ,
          K26 ,
          E27 ,
          F27 ,
          G27 ,
          H27 ,
          I27 ,
          J27 ,
          K27 ,
          E28 ,
          F28 ,
          G28 ,
          H28 ,
          I28 ,
          J28 ,
          K28 ,
          E29 ,
          F29 ,
          G29 ,
          H29 ,
          I29 ,
          J29 ,
          K29 ,
          E30 ,
          F30 ,
          G30 ,
          H30 ,
          I30 ,
          J30 ,
          K30 ,
          E31 ,
          F31 ,
          G31 ,
          H31 ,
          I31 ,
          J31 ,
          K31 ,
          E32 ,
          F32 ,
          G32 ,
          H32 ,
          I32 ,
          J32 ,
          K32 ,
          E33 ,
          F33 ,
          G33 ,
          H33 ,
          I33 ,
          J33 ,
          K33 ,
          E34 ,
          F34 ,
          G34 ,
          H34 ,
          I34 ,
          J34 ,
          K34 ,
          E38 ,
          F38 ,
          G38 ,
          H38 ,
          I38 ,
          J38 ,
          K38 ,
          E39 ,
          F39 ,
          G39 ,
          H39 ,
          I39 ,
          J39 ,
          K39 ,
          E40 ,
          F40 ,
          G40 ,
          H40 ,
          I40 ,
          J40 ,
          K40 ,
          E41 ,
          F41 ,
          G41 ,
          H41 ,
          I41 ,
          J41 ,
          K41 ,
          E42 ,
          F42 ,
          G42 ,
          H42 ,
          I42 ,
          J42 ,
          K42 ,
          E43 ,
          F43 ,
          G43 ,
          H43 ,
          I43 ,
          J43 ,
          K43 ,
          E44 ,
          F44 ,
          G44 ,
          H44 ,
          I44 ,
          J44 ,
          K44 ,
          E45 ,
          F45 ,
          G45 ,
          H45 ,
          I45 ,
          J45 ,
          K45 ,
          D46 ,
          D47
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
          sum(E4 ) ,
          sum(F4 ) ,
          sum(G4 ) ,
          sum(H4 ) ,
          sum(I4 ) ,
          sum(J4 ) ,
          sum(E5 ) ,
          sum(F5 ) ,
          sum(G5 ) ,
          sum(H5 ) ,
          sum(I5 ) ,
          sum(J5 ) ,
          sum(E6 ) ,
          sum(F6 ) ,
          sum(G6 ) ,
          sum(H6 ) ,
          sum(I6 ) ,
          sum(J6 ) ,
          sum(E7 ) ,
          sum(F7 ) ,
          sum(G7 ) ,
          sum(H7 ) ,
          sum(I7 ) ,
          sum(J7 ) ,
          sum(E8 ) ,
          sum(F8 ) ,
          sum(G8 ) ,
          sum(H8 ) ,
          sum(I8 ) ,
          sum(J8 ) ,
          sum(E9 ) ,
          sum(F9 ) ,
          sum(G9 ) ,
          sum(H9 ) ,
          sum(I9 ) ,
          sum(J9 ) ,
          sum(E10) ,
          sum(F10) ,
          sum(G10) ,
          sum(H10) ,
          sum(I10) ,
          sum(J10) ,
          sum(E11) ,
          sum(F11) ,
          sum(G11) ,
          sum(H11) ,
          sum(I11) ,
          sum(J11) ,
          sum(E12) ,
          sum(F12) ,
          sum(G12) ,
          sum(H12) ,
          sum(I12) ,
          sum(J12) ,
          sum(E13) ,
          sum(F13) ,
          sum(G13) ,
          sum(H13) ,
          sum(I13) ,
          sum(J13) ,
          sum(E14) ,
          sum(F14) ,
          sum(G14) ,
          sum(H14) ,
          sum(I14) ,
          sum(J14) ,
          sum(E15) ,
          sum(F15) ,
          sum(G15) ,
          sum(H15) ,
          sum(I15) ,
          sum(J15) ,
          sum(E16) ,
          sum(F16) ,
          sum(G16) ,
          sum(H16) ,
          sum(I16) ,
          sum(J16) ,
          sum(E17) ,
          sum(F17) ,
          sum(G17) ,
          sum(H17) ,
          sum(I17) ,
          sum(J17) ,
          sum(E18) ,
          sum(F18) ,
          sum(G18) ,
          sum(H18) ,
          sum(I18) ,
          sum(J18) ,
          sum(E19) ,
          sum(F19) ,
          sum(G19) ,
          sum(H19) ,
          sum(I19) ,
          sum(J19) ,
          sum(E20) ,
          sum(F20) ,
          sum(G20) ,
          sum(H20) ,
          sum(I20) ,
          sum(J20) ,
          sum(E21) ,
          sum(F21) ,
          sum(G21) ,
          sum(H21) ,
          sum(I21) ,
          sum(J21) ,
          sum(K21) ,
          sum(E22) ,
          sum(F22) ,
          sum(G22) ,
          sum(H22) ,
          sum(I22) ,
          sum(J22) ,
          sum(K22) ,
          sum(E23) ,
          sum(F23) ,
          sum(G23) ,
          sum(H23) ,
          sum(I23) ,
          sum(J23) ,
          sum(K23) ,
          sum(E24) ,
          sum(F24) ,
          sum(G24) ,
          sum(H24) ,
          sum(I24) ,
          sum(J24) ,
          sum(K24) ,
          sum(E25) ,
          sum(F25) ,
          sum(G25) ,
          sum(H25) ,
          sum(I25) ,
          sum(J25) ,
          sum(K25) ,
          sum(E26) ,
          sum(F26) ,
          sum(G26) ,
          sum(H26) ,
          sum(I26) ,
          sum(J26) ,
          sum(K26) ,
          sum(E27) ,
          sum(F27) ,
          sum(G27) ,
          sum(H27) ,
          sum(I27) ,
          sum(J27) ,
          sum(K27) ,
          sum(E28) ,
          sum(F28) ,
          sum(G28) ,
          sum(H28) ,
          sum(I28) ,
          sum(J28) ,
          sum(K28) ,
          sum(E29) ,
          sum(F29) ,
          sum(G29) ,
          sum(H29) ,
          sum(I29) ,
          sum(J29) ,
          sum(K29) ,
          sum(E30) ,
          sum(F30) ,
          sum(G30) ,
          sum(H30) ,
          sum(I30) ,
          sum(J30) ,
          sum(K30) ,
          sum(E31) ,
          sum(F31) ,
          sum(G31) ,
          sum(H31) ,
          sum(I31) ,
          sum(J31) ,
          sum(K31) ,
          sum(E32) ,
          sum(F32) ,
          sum(G32) ,
          sum(H32) ,
          sum(I32) ,
          sum(J32) ,
          sum(K32) ,
          sum(E33) ,
          sum(F33) ,
          sum(G33) ,
          sum(H33) ,
          sum(I33) ,
          sum(J33) ,
          sum(K33) ,
          sum(E34) ,
          sum(F34) ,
          sum(G34) ,
          sum(H34) ,
          sum(I34) ,
          sum(J34) ,
          sum(K34) ,
          sum(E38) ,
          sum(F38) ,
          sum(G38) ,
          sum(H38) ,
          sum(I38) ,
          sum(J38) ,
          sum(K38) ,
          sum(E39) ,
          sum(F39) ,
          sum(G39) ,
          sum(H39) ,
          sum(I39) ,
          sum(J39) ,
          sum(K39) ,
          sum(E40) ,
          sum(F40) ,
          sum(G40) ,
          sum(H40) ,
          sum(I40) ,
          sum(J40) ,
          sum(K40) ,
          sum(E41) ,
          sum(F41) ,
          sum(G41) ,
          sum(H41) ,
          sum(I41) ,
          sum(J41) ,
          sum(K41) ,
          sum(E42) ,
          sum(F42) ,
          sum(G42) ,
          sum(H42) ,
          sum(I42) ,
          sum(J42) ,
          sum(K42) ,
          sum(E43) ,
          sum(F43) ,
          sum(G43) ,
          sum(H43) ,
          sum(I43) ,
          sum(J43) ,
          sum(K43) ,
          sum(E44) ,
          sum(F44) ,
          sum(G44) ,
          sum(H44) ,
          sum(I44) ,
          sum(J44) ,
          sum(K44) ,
          sum(E45) ,
          sum(F45) ,
          sum(G45) ,
          sum(H45) ,
          sum(I45) ,
          sum(J45) ,
          sum(K45) ,
          substrb(catstr(D46),1,255),
          substrb(catstr(D47),1,255)
        from T_CSRC0707_C3_1
        where BBQ = v_P001
        and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120060 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C3-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120060 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120060 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120060!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120070
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120070(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120070
      and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='C3-2 ָڻͶδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_c3_2 WHERE BBQ=v_P001 and USERID=v_USER; commit; /* ɾͬһڵ */

   insert into t_csrc0707_c3_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3
          )
   select a.bbq,
          v_USER,
          a.BTYPE,
          a.OPTION1,
          a.SHTAG,
          a.ishj,
          rownum as a3,
            a.B3,
            a.C3,
            a.D3,
            a.E3,
            a.F3,
            a.G3,
            a.H3,
            a.I3
   from (
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3
        from t_csrc0707_c3_2
        where BBQ = v_P001
        and ishj = 0
        and userid in
          (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        order  by b3
        ) a;

        --ϼ
        insert into t_csrc0707_c3_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3
          )
         select BBQ     ,
                v_USER  ,
                0   ,
                null ,
                0   ,
                1    ,
                null,
                null,
                null,
                sum(D3),
                sum(E3),
                sum(F3),
                sum(G3),
                sum(H3),
                sum(I3)
           from t_csrc0707_c3_2
        where BBQ = v_P001
        and ishj = 0
        and userid = v_USER
        group by bbq;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120070 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>c3_2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120070;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120070 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_1120070!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120080
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120080(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

         select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120080
         and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʲҵδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0128_C4_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0128_C4_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG  ,
            ISHJ   ,
            A3     ,
            B3     ,
            C3    ,
            D3    ,
            E3   ,
            F3     ,
            G3    ,
            H3 ,
            I3     ,
            J3    ,
            K3    ,
            L3     ,
            M3     ,
            N3     ,
            O3     ,
            P3     ,
            Q3     ,
            R3     ,
            S3     ,
            T3     ,
            U3     ,
            V3     ,
            W3     ,
            X3     ,
            Y3     ,
            Z3     ,
            AA3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
            A3     ,
            B3     ,
            C3    ,
            D3    ,
            E3   ,
            F3     ,
            G3    ,
            H3 ,
            I3     ,
            J3    ,
            K3    ,
            L3     ,
            M3     ,
            N3     ,
            O3     ,
            P3     ,
            Q3     ,
            R3     ,
            S3     ,
            T3     ,
            U3     ,
            V3     ,
            W3     ,
            X3     ,
            Y3     ,
            Z3     ,
            AA3
        from T_CSRC0128_C4_1
        where BBQ = v_P001 and ISHJ=0
        and userid in
       (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    --ϼֵ
    insert into T_CSRC0128_C4_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3)
    select v_P001,v_USER,0,null,null,1,
    SUM(J3),SUM(K3),SUM(L3),SUM(M3),SUM(N3),SUM(O3),SUM(P3),SUM(Q3),SUM(R3),SUM(S3),SUM(T3),SUM(U3),SUM(V3),SUM(W3),
    SUM(X3),SUM(Y3),SUM(Z3),SUM(AA3)
      from T_CSRC0128_C4_1
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120080 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C4-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120080 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120080 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120080!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120090
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120090(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120090
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='רʲҵδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0128_C4_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0128_C4_2(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           ishj,
           A3 ,
           B3 ,
           C3 ,
           D3 ,
           E3 ,
           F3 ,
           G3 ,
           H3 ,
           I3 ,
           J3 ,
           K3 ,
           L3 ,
           M3 ,
           N3 ,
           O3 ,
           P3 ,
           Q3 ,
           R3 ,
           S3 ,
           T3 ,
           U3 ,
           V3 ,
           W3 ,
           X3 ,
           Y3 ,
           Z3 ,
           AA3 ,
           AB3 ,
           AC3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3 ,
           B3 ,
           C3 ,
           D3 ,
           E3 ,
           F3 ,
           G3 ,
           H3 ,
           I3 ,
           J3 ,
           K3 ,
           L3 ,
           M3 ,
           N3 ,
           O3 ,
           P3 ,
           Q3 ,
           R3 ,
           S3 ,
           T3 ,
           U3 ,
           V3 ,
           W3 ,
           X3 ,
           Y3 ,
           Z3 ,
           AA3 ,
           AB3 ,
           AC3
        from T_CSRC0128_C4_2
        where BBQ = v_P001 and ISHJ=0
        and userid in
         (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    --ϼ
    insert into T_CSRC0128_C4_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    C3,H3,I3,J3,K3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3,AB3)
    select v_P001,v_USER,0,null,null,1,
    sum(C3),sum(H3),sum(I3),sum(J3),sum(K3),sum(P3),sum(Q3),
    sum(R3),sum(S3),sum(T3),sum(U3),sum(V3),sum(W3),sum(X3),
    sum(Y3),sum(Z3),sum(AA3),sum(AB3)
  from T_CSRC0128_C4_2
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120090 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C4-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120090;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120090 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120090!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120100
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120100(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120100
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʲδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0128_C4_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0128_C4_3(
             BBQ    ,
              USERID ,
              BTYPE  ,
              OPTION1 ,
              SHTAG   ,
              B3      ,
              C3      ,
              D3      ,
              E3      ,
              F3      ,
              G3     ,
              H3     ,
              I3     ,

              B4      ,
              C4      ,
              D4      ,
              E4      ,
              F4      ,
              G4     ,
              H4     ,
              I4     ,

              B5      ,
              C5      ,
              D5      ,
              E5      ,
              F5      ,
              G5     ,
              H5     ,
              I5     ,

              B6      ,
              C6      ,
              D6      ,
              E6      ,
              F6      ,
              G6     ,
              H6     ,
              I6     ,

              B7      ,
              C7      ,
              D7      ,
              E7      ,
              F7      ,
              G7     ,
              H7     ,
              I7     ,

              B8      ,
              C8      ,
              D8      ,
              E8      ,
              F8      ,
              G8     ,
              H8     ,
              I8     ,

              B9      ,
              C9      ,
              D9      ,
              E9      ,
              F9      ,
              G9     ,
              H9     ,
              I9     ,

              B10     ,
              C10     ,
              D10     ,
              E10     ,
              F10     ,
              G10    ,
              H10    ,
              I10    ,

              B11     ,
              C11     ,
              D11     ,
              E11     ,
              F11     ,
              G11    ,
              H11    ,
              I11    ,

              B12     ,
              C12     ,
              D12     ,
              E12     ,
              F12     ,
              G12    ,
              H12    ,
              I12    ,

              B14    ,
      E14    ,
      H14    ,
      B15    ,
      E15    ,
      H15    ,
      B16    ,
      E16    ,
      H16    ,
      B17    ,
      E17    ,
      H17

          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
             B3      ,
              C3      ,
              D3      ,
              E3      ,
              F3      ,
              G3     ,
              H3     ,
              I3     ,

              B4      ,
              C4      ,
              D4      ,
              E4      ,
              F4      ,
              G4     ,
              H4     ,
              I4     ,

              B5      ,
              C5      ,
              D5      ,
              E5      ,
              F5      ,
              G5     ,
              H5     ,
              I5     ,

              B6      ,
              C6      ,
              D6      ,
              E6      ,
              F6      ,
              G6     ,
              H6     ,
              I6     ,

              B7      ,
              C7      ,
              D7      ,
              E7      ,
              F7      ,
              G7     ,
              H7     ,
              I7     ,

              B8      ,
              C8      ,
              D8      ,
              E8      ,
              F8      ,
              G8     ,
              H8     ,
              I8     ,

              B9      ,
              C9      ,
              D9      ,
              E9      ,
              F9      ,
              G9     ,
              H9     ,
              I9     ,

              B10     ,
              C10     ,
              D10     ,
              E10     ,
              F10     ,
              G10    ,
              H10    ,
              I10    ,

              B11     ,
              C11     ,
              D11     ,
              E11     ,
              F11     ,
              G11    ,
              H11    ,
              I11    ,

              B12     ,
              C12     ,
              D12     ,
              E12     ,
              F12     ,
              G12    ,
              H12    ,
              I12    ,

              B14    ,
      E14    ,
      H14    ,
      B15    ,
      E15    ,
      H15    ,
      B16    ,
      E16    ,
      H16    ,
      B17    ,
      E17    ,
      H17
        from T_CSRC0128_C4_3
        where BBQ = v_P001
        and userid in
         (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120100  and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C4-3'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120100 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120100 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120100!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120110
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120110(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

        select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

        select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120110
        and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ҵδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C5_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C5_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           H3  ,
           I3  ,
           J3  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           H4  ,
           I4  ,
           J4  ,
           D5  ,
           E5  ,
           F5  ,
           G5  ,
           H5  ,
           I5  ,
           J5  ,
           D6  ,
           E6  ,
           F6  ,
           G6  ,
           H6  ,
           I6  ,
           J6  ,
           D7  ,
           E7  ,
           F7  ,
           G7  ,
           H7  ,
           I7  ,
           J7  ,
           D8  ,
           E8  ,
           F8  ,
           G8  ,
           H8  ,
           I8  ,
           J8  ,
           D9  ,
           E9  ,
           F9  ,
           G9  ,
           H9  ,
           I9  ,
           J9  ,
           D10 ,
           E10 ,
           F10 ,
           G10 ,
           H10 ,
           I10 ,
           J10 ,
           D11
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(D3 ) ,
           sum(E3 ) ,
           sum(F3 ) ,
           sum(G3 ) ,
           sum(H3 ) ,
           sum(I3 ) ,
           substrb(catstr(J3),1,128),
           sum(D4 ) ,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(G4 ) ,
           sum(H4 ) ,
           sum(I4 ) ,
           substrb(catstr(J4),1,128),
           sum(D5 ) ,
           sum(E5 ) ,
           sum(F5 ) ,
           sum(G5 ) ,
           sum(H5 ) ,
           sum(I5 ) ,
           substrb(catstr(J5),1,128),
           sum(D6 ) ,
           sum(E6 ) ,
           sum(F6 ) ,
           sum(G6 ) ,
           sum(H6 ) ,
           sum(I6 ) ,
           substrb(catstr(J6),1,128),
           sum(D7 ) ,
           sum(E7 ) ,
           sum(F7 ) ,
           sum(G7 ) ,
           sum(H7 ) ,
           sum(I7 ) ,
           substrb(catstr(J7),1,128),
           sum(D8 ) ,
           sum(E8 ) ,
           sum(F8 ) ,
           sum(G8 ) ,
           sum(H8 ) ,
           sum(I8 ) ,
           substrb(catstr(J8),1,128),
           sum(D9 ) ,
           sum(E9 ) ,
           sum(F9 ) ,
           sum(G9 ) ,
           sum(H9 ) ,
           sum(I9 ) ,
           substrb(catstr(J9),1,128),
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           sum(G10) ,
           sum(H10) ,
           sum(I10) ,
           substrb(catstr(J10),1,128),
           substrb(catstr(D11),1,128)
        from T_CSRC0707_C5_1
        where BBQ = v_P001
         and userid in
        (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;




    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120110 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C5-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120110;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120110 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120110!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120120
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120120(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120120
        and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='оѯҵܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_c6_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_c6_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
              C2,
              D2,
              E2,
              F2,
              G2,
              C3,
              D3,
              E3,
              F3,
              G3,
              C4,
              D4,
              E4,
              F4,
              G4,
              C5,
              D5,
              E5,
              F5,
              G5,
              C7,
              D7,
              E7,
              F7,
              C8,
              D8,
              E8,
              F8,
              C9,
              D9,
              E9,
              F9
                      )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
              sum(C2),
              sum(D2),
              sum(E2),
              sum(F2),
              substrb(catstr(G2),1,255),
              sum(C3),
              sum(D3),
              sum(E3),
              sum(F3),
              substrb(catstr(G3),1,255),
              sum(C4),
              sum(D4),
              sum(E4),
              sum(F4),
              substrb(catstr(G4),1,255),
              sum(C5),
              sum(D5),
              sum(E5),
              sum(F5),
              substrb(catstr(G5),1,255),
              sum(C7),
              sum(D7),
              sum(E7),
              sum(F7),
              sum(C8),
              sum(D8),
              sum(E8),
              sum(F8),
              sum(C9),
              sum(D9),
              sum(E9),
              sum(F9)
        from t_csrc0707_c6_1
        where BBQ = v_P001
        and userid in
        (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by BBQ;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120120 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C6-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120120;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120120 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120120!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120130
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120130(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_KJAXUSER varchar2,
						  v_TASK varchar2,
                                                  v_P001     varchar2,
                                                  v_P002     varchar2,
                                                  v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;
begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

     select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from krcs.t_sys_t024
   where a011 = 1009002
     and p001 = 1120130
     and a008 in
         (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'оѯҵܱ-δͨ,ϲδ';
    return;
  end if;

  delete from t_csrc0707_c6_1_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into t_csrc0707_c6_1_1
    (BBQ, USERID, BTYPE, OPTION1, SHTAG, ishj, A2, B2, C2, D2, E2)
    SELECT BBQ, v_USER, BTYPE, OPTION1, SHTAG, ishj, A2, B2, C2, D2, E2
      FROM (select BBQ,
                   v_USER,
                   BTYPE,
                   OPTION1,
                   SHTAG,
                   ishj,
                   rownum as A2,
                   B2,
                   C2,
                   D2,
                   E2
              from t_csrc0707_c6_1_1
             where BBQ = V_P001
              and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
             )
     ORDER BY A2;

  update krcs.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1120130  and a008=v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>C6-1_1' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1120130 ;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_org);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1120130 and a008=v_org;
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1120130!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120140
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120140(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
        v_count number;
	v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120140
          and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Ѻʽծȯعδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C7_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C7_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           H3  ,
           I3  ,
           J3  ,
           K3  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           H4  ,
           I4  ,
           J4  ,
           K4  ,
           D5  ,
           E5  ,
           F5  ,
           G5  ,
           H5  ,
           I5  ,
           J5  ,
           K5  ,
           D6  ,
           E6  ,
           F6  ,
           G6  ,
           H6  ,
           I6  ,
           J6  ,
           K6  ,
           D7  ,
           E7  ,
           F7  ,
           G7  ,
           H7  ,
           I7  ,
           J7  ,
           K7  ,
           D8  ,
           E8  ,
           F8  ,
           G8  ,
           H8  ,
           I8  ,
           J8  ,
           K8  ,
           D9  ,
           E9  ,
           F9  ,
           G9  ,
           H9  ,
           I9  ,
           J9  ,
           K9  ,
           D10 ,
           E10 ,
           F10 ,
           G10 ,
           H10 ,
           I10 ,
           J10 ,
           K10 ,
           D11 ,
           E11 ,
           F11 ,
           G11 ,
           H11 ,
           I11 ,
           J11 ,
           K11 ,
           D12 ,
           E12 ,
           F12 ,
           G12 ,
           H12 ,
           I12 ,
           J12 ,
           K12 ,
           D13 ,
           E13 ,
           F13 ,
           G13 ,
           H13 ,
           I13 ,
           J13 ,
           K13 ,
           D14 ,
           E14 ,
           F14 ,
           G14 ,
           H14 ,
           I14 ,
           J14 ,
           K14 ,
           D15 ,
           E15 ,
           F15 ,
           G15 ,
           H15 ,
           I15 ,
           J15 ,
           K15 ,
           D16 ,
           E16 ,
           F16 ,
           G16 ,
           H16 ,
           I16 ,
           J16 ,
           K16 ,
           D17 ,
           E17 ,
           F17 ,
           G17 ,
           H17 ,
           I17 ,
           J17 ,
           K17 ,
           D18 ,
           E18 ,
           F18 ,
           G18 ,
           H18 ,
           I18 ,
           J18 ,
           K18 ,
           D19 ,
           E19 ,
           F19 ,
           G19 ,
           H19 ,
           I19 ,
           J19 ,
           K19 ,
           D20 ,
           E20 ,
           F20 ,
           G20 ,
           H20 ,
           I20 ,
           J20 ,
           K20 ,
           D21 ,
           E21 ,
           F21 ,
           G21 ,
           H21 ,
           I21 ,
           J21 ,
           K21 ,
           D22 ,
           E22 ,
           F22 ,
           G22 ,
           H22 ,
           I22 ,
           J22 ,
           K22 ,
           D23 ,
           E23 ,
           F23 ,
           G23 ,
           H23 ,
           I23 ,
           J23 ,
           K23 ,
           D24 ,
           E24 ,
           F24 ,
           G24 ,
           H24 ,
           I24 ,
           J24 ,
           K24 ,
           D25 ,
           E25 ,
           F25 ,
           G25 ,
           H25 ,
           I25 ,
           J25 ,
           K25 ,
           D26 ,
           E26 ,
           F26 ,
           G26 ,
           H26 ,
           I26 ,
           J26 ,
           K26 ,
           D27 ,
           E27 ,
           F27 ,
           G27 ,
           H27 ,
           I27 ,
           J27 ,
           K27 ,
           D28 ,
           E28 ,
           F28 ,
           G28 ,
           H28 ,
           I28 ,
           J28 ,
           K28 ,
           D31 ,
           E31 ,
           F31 ,
           G31 ,
           D32 ,
           E32 ,
           F32 ,
           G32 ,
           D33 ,
           E33 ,
           F33 ,
           G33 ,
           D34 ,
           E34 ,
           F34 ,
           G34 ,
           D35 ,
           E35 ,
           F35 ,
           G35 ,
           D36 ,
           E36 ,
           F36 ,
           G36 ,
           D37 ,
           E37 ,
           F37 ,
           G37 ,
           D38 ,
           E38 ,
           F38 ,
           G38 ,
           D39 ,
           E39 ,
           F39 ,
           G39 ,
           D40 ,
           E40 ,
           F40 ,
           G40 ,
           D41 ,
           E41 ,
           F41 ,
           G41 ,
           D42 ,
           E42 ,
           F42 ,
           G42 ,
           D43 ,
           E43 ,
           F43 ,
           G43 ,
           D44 ,
           E44 ,
           F44 ,
           G44 ,
           D45 ,
           E45 ,
           F45 ,
           G45 ,
           D46 ,
           E46 ,
           F46 ,
           G46
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(D3 ) ,
           sum(E3 ) ,
           sum(F3 ) ,
           sum(G3 ) ,
           sum(H3 ) ,
           sum(I3 ) ,
           sum(J3 ) ,
           sum(K3 ) ,
           sum(D4 ) ,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(G4 ) ,
           sum(H4 ) ,
           sum(I4 ) ,
           sum(J4 ) ,
           sum(K4 ) ,
           sum(D5 ) ,
           sum(E5 ) ,
           sum(F5 ) ,
           sum(G5 ) ,
           sum(H5 ) ,
           sum(I5 ) ,
           sum(J5 ) ,
           sum(K5 ) ,
           sum(D6 ) ,
           sum(E6 ) ,
           sum(F6 ) ,
           sum(G6 ) ,
           sum(H6 ) ,
           sum(I6 ) ,
           sum(J6 ) ,
           sum(K6 ) ,
           sum(D7 ) ,
           sum(E7 ) ,
           sum(F7 ) ,
           sum(G7 ) ,
           sum(H7 ) ,
           sum(I7 ) ,
           sum(J7 ) ,
           sum(K7 ) ,
           sum(D8 ) ,
           sum(E8 ) ,
           sum(F8 ) ,
           sum(G8 ) ,
           sum(H8 ) ,
           sum(I8 ) ,
           sum(J8 ) ,
           sum(K8 ) ,
           sum(D9 ) ,
           sum(E9 ) ,
           sum(F9 ) ,
           sum(G9 ) ,
           sum(H9 ) ,
           sum(I9 ) ,
           sum(J9 ) ,
           sum(K9 ) ,
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           sum(G10) ,
           sum(H10) ,
           sum(I10) ,
           sum(J10) ,
           sum(K10) ,
           sum(D11) ,
           sum(E11) ,
           sum(F11) ,
           sum(G11) ,
           sum(H11) ,
           sum(I11) ,
           sum(J11) ,
           sum(K11) ,
           sum(D12) ,
           sum(E12) ,
           sum(F12) ,
           sum(G12) ,
           sum(H12) ,
           sum(I12) ,
           sum(J12) ,
           sum(K12) ,
           sum(D13) ,
           sum(E13) ,
           sum(F13) ,
           sum(G13) ,
           sum(H13) ,
           sum(I13) ,
           sum(J13) ,
           sum(K13) ,
           sum(D14) ,
           sum(E14) ,
           sum(F14) ,
           sum(G14) ,
           sum(H14) ,
           sum(I14) ,
           sum(J14) ,
           sum(K14) ,
           sum(D15) ,
           sum(E15) ,
           sum(F15) ,
           sum(G15) ,
           sum(H15) ,
           sum(I15) ,
           sum(J15) ,
           sum(K15) ,
           sum(D16) ,
           sum(E16) ,
           sum(F16) ,
           sum(G16) ,
           sum(H16) ,
           sum(I16) ,
           sum(J16) ,
           sum(K16) ,
           sum(D17) ,
           sum(E17) ,
           sum(F17) ,
           sum(G17) ,
           sum(H17) ,
           sum(I17) ,
           sum(J17) ,
           sum(K17) ,
           sum(D18) ,
           sum(E18) ,
           sum(F18) ,
           sum(G18) ,
           sum(H18) ,
           sum(I18) ,
           sum(J18) ,
           sum(K18) ,
           sum(D19) ,
           sum(E19) ,
           sum(F19) ,
           sum(G19) ,
           sum(H19) ,
           sum(I19) ,
           sum(J19) ,
           sum(K19) ,
           sum(D20) ,
           sum(E20) ,
           sum(F20) ,
           sum(G20) ,
           sum(H20) ,
           sum(I20) ,
           sum(J20) ,
           sum(K20) ,
           sum(D21) ,
           sum(E21) ,
           sum(F21) ,
           sum(G21) ,
           sum(H21) ,
           sum(I21) ,
           sum(J21) ,
           sum(K21) ,
           sum(D22) ,
           sum(E22) ,
           sum(F22) ,
           sum(G22) ,
           sum(H22) ,
           sum(I22) ,
           sum(J22) ,
           sum(K22) ,
           sum(D23) ,
           sum(E23) ,
           sum(F23) ,
           sum(G23) ,
           sum(H23) ,
           sum(I23) ,
           sum(J23) ,
           sum(K23) ,
           sum(D24) ,
           sum(E24) ,
           sum(F24) ,
           sum(G24) ,
           sum(H24) ,
           sum(I24) ,
           sum(J24) ,
           sum(K24) ,
           sum(D25) ,
           sum(E25) ,
           sum(F25) ,
           sum(G25) ,
           sum(H25) ,
           sum(I25) ,
           sum(J25) ,
           sum(K25) ,
           sum(D26) ,
           sum(E26) ,
           sum(F26) ,
           sum(G26) ,
           sum(H26) ,
           sum(I26) ,
           sum(J26) ,
           sum(K26) ,
           sum(D27) ,
           sum(E27) ,
           sum(F27) ,
           sum(G27) ,
           sum(H27) ,
           sum(I27) ,
           sum(J27) ,
           sum(K27) ,
           sum(D28) ,
           sum(E28) ,
           sum(F28) ,
           sum(G28) ,
           sum(H28) ,
           sum(I28) ,
           sum(J28) ,
           sum(K28) ,
           sum(D31) ,
           sum(E31) ,
           sum(F31) ,
           sum(G31) ,
           sum(D32) ,
           sum(E32) ,
           sum(F32) ,
           sum(G32) ,
           sum(D33) ,
           sum(E33) ,
           sum(F33) ,
           sum(G33) ,
           sum(D34) ,
           sum(E34) ,
           sum(F34) ,
           sum(G34) ,
           sum(D35) ,
           sum(E35) ,
           sum(F35) ,
           sum(G35) ,
           sum(D36) ,
           sum(E36) ,
           sum(F36) ,
           sum(G36) ,
           sum(D37) ,
           sum(E37) ,
           sum(F37) ,
           sum(G37) ,
           sum(D38) ,
           sum(E38) ,
           sum(F38) ,
           sum(G38) ,
           sum(D39) ,
           sum(E39) ,
           sum(F39) ,
           sum(G39) ,
           sum(D40) ,
           sum(E40) ,
           sum(F40) ,
           sum(G40) ,
           sum(D41) ,
           sum(E41) ,
           sum(F41) ,
           sum(G41) ,
           sum(D42) ,
           sum(E42) ,
           sum(F42) ,
           sum(G42) ,
           sum(D43) ,
           sum(E43) ,
           sum(F43) ,
           sum(G43) ,
           sum(D44) ,
           sum(E44) ,
           sum(F44) ,
           sum(G44) ,
           sum(D45) ,
           sum(E45) ,
           sum(F45) ,
           sum(G45) ,
           sum(D46) ,
           sum(E46) ,
           sum(F46) ,
           sum(G46)
        from T_CSRC0707_C7_1
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;




    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120140  and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C7-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120140 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120140 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120140!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120150
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120150(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

       select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120150
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʽծȯعδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C7_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C7_2(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           D3  ,
           E3  ,
           F3  ,
           G3  ,
           H3  ,
           I3  ,
           J3  ,
           K3  ,
           D4  ,
           E4  ,
           F4  ,
           G4  ,
           H4  ,
           I4  ,
           J4  ,
           K4  ,
           D5  ,
           E5  ,
           F5  ,
           H5  ,
           I5  ,
           J5  ,
           K5  ,
           D6  ,
           E6  ,
           F6  ,
           H6  ,
           I6  ,
           J6  ,
           K6  ,
           D7  ,
           E7  ,
           F7  ,
           H7  ,
           I7  ,
           J7  ,
           K7  ,
           D8  ,
           E8  ,
           F8  ,
           H8  ,
           I8  ,
           J8  ,
           K8  ,
           D9  ,
           E9  ,
           F9  ,
           H9  ,
           I9  ,
           J9  ,
           K9  ,
           D10 ,
           E10 ,
           F10 ,
           H10 ,
           I10 ,
           J10 ,
           K10 ,
           D11 ,
           E11 ,
           F11 ,
           H11 ,
           I11 ,
           J11 ,
           K11 ,
           D12 ,
           E12 ,
           F12 ,
           H12 ,
           I12 ,
           J12 ,
           K12 ,
           D13 ,
           E13 ,
           F13 ,
           H13 ,
           I13 ,
           J13 ,
           K13 ,
           D14 ,
           E14 ,
           F14 ,
           H14 ,
           I14 ,
           J14 ,
           K14 ,
           D15 ,
           E15 ,
           F15 ,
           H15 ,
           I15 ,
           J15 ,
           K15 ,
           D16 ,
           E16 ,
           F16 ,
           H16 ,
           I16 ,
           J16 ,
           K16 ,
           D17 ,
           E17 ,
           F17 ,
           H17 ,
           I17 ,
           J17 ,
           K17 ,
           D18 ,
           E18 ,
           F18 ,
           H18 ,
           I18 ,
           J18 ,
           K18 ,
           D19 ,
           E19 ,
           F19 ,
           H19 ,
           I19 ,
           J19 ,
           K19 ,
           D20 ,
           E20 ,
           F20 ,
           H20 ,
           I20 ,
           J20 ,
           K20 ,
           D21 ,
           E21 ,
           F21 ,
           H21 ,
           I21 ,
           J21 ,
           K21 ,
           D22 ,
           E22 ,
           F22 ,
           H22 ,
           I22 ,
           J22 ,
           K22 ,
           D23 ,
           E23 ,
           F23 ,
           H23 ,
           I23 ,
           J23 ,
           K23 ,
           D24 ,
           E24 ,
           F24 ,
           H24 ,
           I24 ,
           J24 ,
           K24 ,
           D25 ,
           E25 ,
           F25 ,
           H25 ,
           I25 ,
           J25 ,
           K25 ,
           D26 ,
           E26 ,
           F26 ,
           H26 ,
           I26 ,
           J26 ,
           K26 ,
           D27 ,
           E27 ,
           F27 ,
           H27 ,
           I27 ,
           J27 ,
           K27 ,
           D28 ,
           E28 ,
           F28 ,
           H28 ,
           I28 ,
           J28 ,
           K28 ,
           G5  ,
           G6  ,
           G7  ,
           G8  ,
           G9  ,
           G10 ,
           G11 ,
           G12 ,
           G13 ,
           G14 ,
           G15 ,
           G16 ,
           G17 ,
           G18 ,
           G19 ,
           G20 ,
           G21 ,
           G22 ,
           G23 ,
           G24 ,
           G25 ,
           G26 ,
           G27 ,
           G28
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(D3 ) ,
           sum(E3 ) ,
           sum(F3 ) ,
           sum(G3 ) ,
           sum(H3 ) ,
           sum(I3 ) ,
           sum(J3 ) ,
           sum(K3 ) ,
           sum(D4 ) ,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(G4 ) ,
           sum(H4 ) ,
           sum(I4 ) ,
           sum(J4 ) ,
           sum(K4 ) ,
           sum(D5 ) ,
           sum(E5 ) ,
           sum(F5 ) ,
           sum(H5 ) ,
           sum(I5 ) ,
           sum(J5 ) ,
           sum(K5 ) ,
           sum(D6 ) ,
           sum(E6 ) ,
           sum(F6 ) ,
           sum(H6 ) ,
           sum(I6 ) ,
           sum(J6 ) ,
           sum(K6 ) ,
           sum(D7 ) ,
           sum(E7 ) ,
           sum(F7 ) ,
           sum(H7 ) ,
           sum(I7 ) ,
           sum(J7 ) ,
           sum(K7 ) ,
           sum(D8 ) ,
           sum(E8 ) ,
           sum(F8 ) ,
           sum(H8 ) ,
           sum(I8 ) ,
           sum(J8 ) ,
           sum(K8 ) ,
           sum(D9 ) ,
           sum(E9 ) ,
           sum(F9 ) ,
           sum(H9 ) ,
           sum(I9 ) ,
           sum(J9 ) ,
           sum(K9 ) ,
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           sum(H10) ,
           sum(I10) ,
           sum(J10) ,
           sum(K10) ,
           sum(D11) ,
           sum(E11) ,
           sum(F11) ,
           sum(H11) ,
           sum(I11) ,
           sum(J11) ,
           sum(K11) ,
           sum(D12) ,
           sum(E12) ,
           sum(F12) ,
           sum(H12) ,
           sum(I12) ,
           sum(J12) ,
           sum(K12) ,
           sum(D13) ,
           sum(E13) ,
           sum(F13) ,
           sum(H13) ,
           sum(I13) ,
           sum(J13) ,
           sum(K13) ,
           sum(D14) ,
           sum(E14) ,
           sum(F14) ,
           sum(H14) ,
           sum(I14) ,
           sum(J14) ,
           sum(K14) ,
           sum(D15) ,
           sum(E15) ,
           sum(F15) ,
           sum(H15) ,
           sum(I15) ,
           sum(J15) ,
           sum(K15) ,
           sum(D16) ,
           sum(E16) ,
           sum(F16) ,
           sum(H16) ,
           sum(I16) ,
           sum(J16) ,
           sum(K16) ,
           sum(D17) ,
           sum(E17) ,
           sum(F17) ,
           sum(H17) ,
           sum(I17) ,
           sum(J17) ,
           sum(K17) ,
           sum(D18) ,
           sum(E18) ,
           sum(F18) ,
           sum(H18) ,
           sum(I18) ,
           sum(J18) ,
           sum(K18) ,
           sum(D19) ,
           sum(E19) ,
           sum(F19) ,
           sum(H19) ,
           sum(I19) ,
           sum(J19) ,
           sum(K19) ,
           sum(D20) ,
           sum(E20) ,
           sum(F20) ,
           sum(H20) ,
           sum(I20) ,
           sum(J20) ,
           sum(K20) ,
           sum(D21) ,
           sum(E21) ,
           sum(F21) ,
           sum(H21) ,
           sum(I21) ,
           sum(J21) ,
           sum(K21) ,
           sum(D22) ,
           sum(E22) ,
           sum(F22) ,
           sum(H22) ,
           sum(I22) ,
           sum(J22) ,
           sum(K22) ,
           sum(D23) ,
           sum(E23) ,
           sum(F23) ,
           sum(H23) ,
           sum(I23) ,
           sum(J23) ,
           sum(K23) ,
           sum(D24) ,
           sum(E24) ,
           sum(F24) ,
           sum(H24) ,
           sum(I24) ,
           sum(J24) ,
           sum(K24) ,
           sum(D25) ,
           sum(E25) ,
           sum(F25) ,
           sum(H25) ,
           sum(I25) ,
           sum(J25) ,
           sum(K25) ,
           sum(D26) ,
           sum(E26) ,
           sum(F26) ,
           sum(H26) ,
           sum(I26) ,
           sum(J26) ,
           sum(K26) ,
           sum(D27) ,
           sum(E27) ,
           sum(F27) ,
           sum(H27) ,
           sum(I27) ,
           sum(J27) ,
           sum(K27) ,
           sum(D28) ,
           sum(E28) ,
           sum(F28) ,
           sum(H28) ,
           sum(I28) ,
           sum(J28) ,
           sum(K28) ,
           sum(G5 ) ,
           sum(G6 ) ,
           sum(G7 ) ,
           sum(G8 ) ,
           sum(G9 ) ,
           sum(G10) ,
           sum(G11) ,
           sum(G12) ,
           sum(G13) ,
           sum(G14) ,
           sum(G15) ,
           sum(G16) ,
           sum(G17) ,
           sum(G18) ,
           sum(G19) ,
           sum(G20) ,
           sum(G21) ,
           sum(G22) ,
           sum(G23) ,
           sum(G24) ,
           sum(G25) ,
           sum(G26) ,
           sum(G27) ,
           sum(G28)
        from T_CSRC0707_C7_2
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;




    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120150 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C7-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120150;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120150 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120150!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120160
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120160(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

        select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120160
        and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='мгܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C8_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C8_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           B2  ,
           C2  ,
           D2  ,
           E2  ,
           F2  ,
           B3  ,
           C3  ,
           D3  ,
           E3  ,
           F3  ,
           B4  ,
           C4  ,
           D4  ,
           E4  ,
           F4  ,
           B5  ,
           C5  ,
           D5  ,
           E5  ,
           F5  ,
           B6  ,
           C6  ,
           D6  ,
           E6  ,
           F6  ,
           B7  ,
           C7  ,
           D7  ,
           E7  ,
           F7  ,
           B8  ,
           C8  ,
           D8  ,
           E8  ,
           F8  ,
           B9  ,
           C9  ,
           D9  ,
           E9  ,
           F9  ,
           B10 ,
           C10 ,
           D10 ,
           E10 ,
           F10 ,
           B11 ,
           C11 ,
           D11 ,
           E11 ,
           F11 ,
           B12 ,
           C12 ,
           D12 ,
           E12 ,
           F12 ,
           B13 ,
           C13 ,
           D13 ,
           E13 ,
           F13 ,
           B14 ,
           C14 ,
           D14 ,
           E14 ,
           F14 ,
           B15 ,
           C15 ,
           D15 ,
           E15 ,
           F15
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(B2 ) ,
           sum(C2 ) ,
           sum(D2 ) ,
           sum(E2 ) ,
           sum(F2 ) ,
           sum(B3 ) ,
           sum(C3 ) ,
           sum(D3 ) ,
           sum(E3 ) ,
           sum(F3 ) ,
           sum(B4 ) ,
           sum(C4 ) ,
           sum(D4 ) ,
           sum(E4 ) ,
           sum(F4 ) ,
           sum(B5 ) ,
           sum(C5 ) ,
           sum(D5 ) ,
           sum(E5 ) ,
           sum(F5 ) ,
           sum(B6 ) ,
           sum(C6 ) ,
           sum(D6 ) ,
           sum(E6 ) ,
           sum(F6 ) ,
           sum(B7 ) ,
           sum(C7 ) ,
           sum(D7 ) ,
           sum(E7 ) ,
           sum(F7 ) ,
           sum(B8 ) ,
           sum(C8 ) ,
           sum(D8 ) ,
           sum(E8 ) ,
           sum(F8 ) ,
           sum(B9 ) ,
           sum(C9 ) ,
           sum(D9 ) ,
           sum(E9 ) ,
           sum(F9 ) ,
           sum(B10) ,
           sum(C10) ,
           sum(D10) ,
           sum(E10) ,
           sum(F10) ,
           sum(B11) ,
           sum(C11) ,
           sum(D11) ,
           sum(E11) ,
           sum(F11) ,
           sum(B12) ,
           sum(C12) ,
           sum(D12) ,
           sum(E12) ,
           sum(F12) ,
           sum(B13) ,
           sum(C13) ,
           sum(D13) ,
           sum(E13) ,
           sum(F13) ,
           sum(B14) ,
           sum(C14) ,
           sum(D14) ,
           sum(E14) ,
           sum(F14) ,
           sum(B15) ,
           sum(C15) ,
           sum(D15) ,
           sum(E15) ,
           sum(F15)
        from T_CSRC0707_C8_1
        where BBQ = v_P001
          and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;



    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120160 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C8-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120160 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120160 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120160!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120170
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120170(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120170
          and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='мгܱ()δͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C8_1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C8_1_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           ishj,
           A2  ,
           B2  ,
           C2  ,
           D2  ,
           E2  ,
           F2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A2  ,
           B2  ,
           C2  ,
           D2  ,
           E2  ,
           F2
        from T_CSRC0707_C8_1_1
        where BBQ = v_P001 and ISHJ=0
          and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

     --ϼ
    insert into t_csrc0707_c8_1_1(bbq,userid,btype,option1,shtag,ishj,b2,c2,d2,e2,f2)
      select v_p001,v_USER,0,NULL,NULL,1,sum(b2),sum(c2),sum(d2),sum(e2),sum(f2)
      from t_csrc0707_c8_1_1 where BBQ = v_p001 and userid=v_USER and ISHJ=0;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120170 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C8-1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120170;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120170 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120170!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120180
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120180(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120180
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Ȩ֤ܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_C9_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_C9_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           ishj,
           A4 ,
           B4 ,
           C4 ,
           D4 ,
           E4 ,
           F4 ,
           G4 ,
           H4 ,
           I4 ,
           J4 ,
           K4 ,
           L4 ,
           M4 ,
           N4 ,
           O4 ,
           P4 ,
           Q4 ,
           R4 ,
           S4 ,
           T4
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A4 ,
           B4 ,
           C4 ,
           D4 ,
           E4 ,
           F4 ,
           G4 ,
           H4 ,
           I4 ,
           J4 ,
           K4 ,
           L4 ,
           M4 ,
           N4 ,
           O4 ,
           P4 ,
           Q4 ,
           R4 ,
           S4 ,
           T4
        from T_CSRC0707_C9_1
        where BBQ = v_P001 and ISHJ=0
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

    insert into T_CSRC0707_C9_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    E4,F4,G4,H4,I4,J4,K4,L4,M4,N4,O4,P4,Q4,R4,T4)
    select v_P001,v_USER,0,null,null,1,
    sum(E4),sum(F4),sum(G4),sum(H4),sum(I4),sum(J4),sum(K4),sum(L4),sum(M4),
    sum(N4),sum(O4) ,sum(P4),sum(Q4),sum(R4),sum(T4)
    from T_CSRC0707_C9_1 where BBQ=v_P001 and USERID=v_USER and ISHJ=0;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120180 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C9-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120180;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120180 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120180!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120190
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120190(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

        select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120190  and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʲծܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC1212_C10_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */


   insert into T_CSRC1212_C10_1(
            BBQ,
            USERID,
            BTYPE,
            OPTION1,
            SHTAG,
            D2  ,
            F2  ,
            D3  ,
            F3  ,
            D4  ,
            F4  ,
            D5  ,
            F5  ,
            D6  ,
            F6  ,
            D7  ,
            F7  ,
            D8  ,
            F8  ,
            D9  ,
            F9  ,
            D10  ,
            F10  ,
            D11  ,
            F11  ,
            D12  ,
            F12  ,
            D13  ,
            F13,
             D14  ,
            F14  ,
            D15  ,
            F15  ,
            D16 ,
            F16  ,
            D17  ,
            F17  ,
            D18  ,
            F18  ,
            D19  ,
            F19  ,
            D20  ,
            F20 ,
            D21 ,
            F21 ,
            D22  ,
            F22  ,
            D23  ,
            F23  ,
            D24  ,
            F24  ,
            D25  ,
            F25,
            D26  ,
            F26  ,
            D27  ,
            F27  ,
            D28 ,
            F28 ,
            D29  ,
            F29 ,
            D30  ,
            F30  ,
            D31  ,
            F31  ,
            D32  ,
            F32  ,
            D33  ,
            F33  ,
            D34  ,
            F34  ,
            D35  ,
            F35  ,
            D36  ,
            F36  ,
            D37  ,
            F37,
             D38  ,
            F38  ,
            D39  ,
            F39  ,
            D40 ,
            F40  ,
            D41  ,
            F41  ,
            D42  ,
            F42  ,
            D43  ,
            F43  ,
            D44  ,
            F44 ,
            D45 ,
            F45
          )
   select   BBQ,
            v_USER,
            0,
            null,
            0,
            D2  ,
            F2  ,
            D3  ,
            F3  ,
            D4  ,
            F4  ,
            D5  ,
            F5  ,
            D6  ,
            F6  ,
            D7  ,
            F7  ,
            D8  ,
            F8  ,
            D9  ,
            F9  ,
            D10  ,
            F10  ,
            D11  ,
            F11  ,
            D12  ,
            F12  ,
            D13  ,
            F13,
             D14  ,
            F14  ,
            D15  ,
            F15  ,
            D16 ,
            F16  ,
            D17  ,
            F17  ,
            D18  ,
            F18  ,
            D19  ,
            F19  ,
            D20  ,
            F20 ,
            D21 ,
            F21 ,
            D22  ,
            F22  ,
            D23  ,
            F23  ,
            D24  ,
            F24  ,
            D25  ,
            F25,
            D26  ,
            F26  ,
            D27  ,
            F27  ,
            D28 ,
            F28 ,
            D29  ,
            F29 ,
            D30  ,
            F30  ,
            D31  ,
            F31  ,
            D32  ,
            F32  ,
            D33  ,
            F33  ,
            D34  ,
            F34  ,
            D35  ,
            F35  ,
            D36  ,
            F36  ,
            D37  ,
            F37,
             D38  ,
            F38  ,
            D39  ,
            F39  ,
            D40 ,
            F40  ,
            D41  ,
            F41  ,
            D42  ,
            F42  ,
            D43  ,
            F43  ,
            D44  ,
            F44 ,
            D45 ,
            F45
         from T_CSRC1212_C10_1
        where BBQ = v_P001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120190 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120190;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120190 and a008 = v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_1120190!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120200
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120200(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

     select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120200
     and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Ϊڻ˾ṩмҵܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_c11_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_c11_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            C2 ,
            C3 ,
            C5 ,
            D5 ,
            E5 ,
            F5 ,
            C6 ,
            D6 ,
            E6 ,
            F6 ,
            C7 ,
            D7 ,
            E7 ,
            F7 ,
            C8 ,
            D8 ,
            E8 ,
            F8 ,
            C9 ,
            D9 ,
            E9 ,
            F9 ,
            C11,
            E11
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            C2 ,
            C3 ,
            C5 ,
            D5 ,
            E5 ,
            F5 ,
            C6 ,
            D6 ,
            E6 ,
            F6 ,
            C7 ,
            D7 ,
            E7 ,
            F7 ,
            C8 ,
            D8 ,
            E8 ,
            F8 ,
            C9 ,
            D9 ,
            E9 ,
            F9 ,
            C11,
            E11
        from t_csrc0707_c11_1
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120200 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C11-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120200;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120200 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120200!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120210
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120210(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120210
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='֤ȯ˾۽ڲƷͳƱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC1227_C12_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC1227_C12_1(
             BBQ ,
            USERID  ,
            BTYPE   ,
            OPTION1,
            SHTAG ,
              C5      ,
              D5     ,
              E5      ,
              F5     ,
              G5      ,
              H5     ,
              I5      ,
              J5     ,
              K5      ,
              L5     ,
              M5     ,
              C6      ,
              D6     ,
              E6      ,
              F6     ,
              G6      ,
              H6     ,
              I6      ,
              J6     ,
              K6      ,
              L6     ,
              M6     ,
              C7      ,
              D7     ,
              E7      ,
              F7     ,
              G7      ,
              H7     ,
              I7      ,
              J7     ,
              K7      ,
              L7     ,
              M7     ,
              C8      ,
              D8     ,
              E8      ,
              F8     ,
              G8      ,
              H8     ,
              I8      ,
              J8     ,
              K8      ,
              L8     ,
              M8     ,
              C9      ,
              D9     ,
              E9      ,
              F9     ,
              G9      ,
              H9     ,
              I9      ,
              J9     ,
              K9      ,
              L9     ,
              M9     ,
              C10     ,
              D10    ,
              E10     ,
              F10    ,
              G10     ,
              H10    ,
              I10     ,
              J10    ,
              K10     ,
              L10    ,
              M10    ,
              C11     ,
              D11    ,
              E11     ,
              F11    ,
              G11     ,
              H11    ,
              I11     ,
              J11    ,
              K11     ,
              L11    ,
              M11    ,
              C12     ,
              D12    ,
              E12     ,
              F12    ,
              G12     ,
              H12    ,
              I12     ,
              J12    ,
              K12     ,
              L12    ,
              M12    ,
              C13     ,
              D13    ,
              E13     ,
              F13    ,
              G13     ,
              H13    ,
              I13     ,
              J13    ,
              K13     ,
              L13    ,
              M13    ,
              C15     ,
              D15    ,
              E15     ,
              F15    ,
              G15     ,
              H15    ,
              I15     ,
              J15    ,
              K15     ,
              L15    ,
              M15    ,
              C16     ,
              D16    ,
              E16     ,
              F16    ,
              G16     ,
              H16    ,
              I16     ,
              J16    ,
              K16     ,
              L16    ,
              M16    ,
              C17     ,
              D17    ,
              E17     ,
              F17    ,
              G17     ,
              H17    ,
              I17     ,
              J17    ,
              K17     ,
              L17    ,
              M17    ,
              C18     ,
              D18    ,
              E18     ,
              F18    ,
              G18     ,
              H18    ,
              I18     ,
              J18    ,
              K18     ,
              L18    ,
              M18    ,
              C19     ,
              D19    ,
              E19     ,
              F19    ,
              G19     ,
              H19    ,
              I19     ,
              J19    ,
              K19     ,
              L19    ,
              M19    ,
              C20     ,
              D20    ,
              E20     ,
              F20    ,
              G20     ,
              H20    ,
              I20     ,
              J20    ,
              K20     ,
              L20    ,
              M20    ,
              C21     ,
              D21    ,
              E21     ,
              F21    ,
              G21     ,
              H21    ,
              I21     ,
              J21    ,
              K21     ,
              L21    ,
              M21    ,
              C23     ,
              D23    ,
              E23     ,
              F23    ,
              G23     ,
              H23    ,
              I23     ,
              J23    ,
              K23     ,
              L23    ,
              M23    ,
              C24     ,
              D24    ,
              E24     ,
              F24    ,
              G24     ,
              H24    ,
              I24     ,
              J24    ,
              K24     ,
              L24    ,
              M24    ,
              C25     ,
              D25    ,
              E25     ,
              F25    ,
              G25     ,
              H25    ,
              I25     ,
              J25    ,
              K25     ,
              L25    ,
              M25    ,
              C26     ,
              D26    ,
              E26     ,
              F26    ,
              G26     ,
              H26    ,
              I26     ,
              J26    ,
              K26     ,
              L26    ,
              M26    ,
              C28     ,
              D28    ,
              E28     ,
              F28    ,
              G28     ,
              H28    ,
              I28     ,
              J28    ,
              K28     ,
              L28    ,
              M28    ,
              C29     ,
              D29    ,
              E29     ,
              F29    ,
              G29     ,
              H29    ,
              I29     ,
              J29    ,
              K29     ,
              L29    ,
              M29    ,
              C30     ,
              D30    ,
              E30     ,
              F30    ,
              G30     ,
              H30    ,
              I30     ,
              J30    ,
              K30     ,
              L30    ,
              M30    ,
              D32    ,
              F32    ,
              M32    ,
              D33    ,
              F33    ,
              M33
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           SUM(C5)      ,
            SUM(D5)      ,
            SUM(E5)      ,
            SUM(F5)      ,
            SUM(G5)      ,
            SUM(H5)      ,
            SUM(I5)      ,
            SUM(J5)      ,
            SUM(K5)      ,
            SUM(L5)      ,
            substrb(catstr(M5),1,255),
            SUM(C6)      ,
            SUM(D6)      ,
            SUM(E6)      ,
            SUM(F6)      ,
            SUM(G6)      ,
            SUM(H6)      ,
            SUM(I6)      ,
            SUM(J6)      ,
            SUM(K6)      ,
            SUM(L6)      ,
            substrb(catstr(M6),1,255),
            SUM(C7)      ,
            SUM(D7)      ,
            SUM(E7)      ,
            SUM(F7)      ,
            SUM(G7)      ,
            SUM(H7)      ,
            SUM(I7)      ,
            SUM(J7)      ,
            SUM(K7)      ,
            SUM(L7)      ,
            substrb(catstr(M7),1,255),
            SUM(C8)      ,
            SUM(D8)      ,
            SUM(E8)      ,
            SUM(F8)      ,
            SUM(G8)      ,
            SUM(H8)      ,
            SUM(I8)      ,
            SUM(J8)      ,
            SUM(K8)      ,
            SUM(L8)      ,
            substrb(catstr(M8),1,255),
            SUM(C9)      ,
            SUM(D9)      ,
            SUM(E9)      ,
            SUM(F9)      ,
            SUM(G9)      ,
            SUM(H9)      ,
            SUM(I9)      ,
            SUM(J9)      ,
            SUM(K9)      ,
            SUM(L9)      ,
            substrb(catstr(M9),1,255),
            SUM(C10)     ,
            SUM(D10)     ,
            SUM(E10)     ,
            SUM(F10)     ,
            SUM(G10)     ,
            SUM(H10)     ,
            SUM(I10)      ,
            SUM(J10)      ,
            SUM(K10)      ,
            SUM(L10)      ,
            substrb(catstr(M10),1,255),
            SUM(C11)     ,
            SUM(D11)     ,
            SUM(E11)     ,
            SUM(F11)     ,
            SUM(G11)     ,
            SUM(H11)     ,
            SUM(I11)      ,
            SUM(J11)      ,
            SUM(K11)      ,
            SUM(L11)      ,
            substrb(catstr(M11),1,255),
            SUM(C12)     ,
            SUM(D12)     ,
            SUM(E12)     ,
            SUM(F12)     ,
            SUM(G12)     ,
            SUM(H12)     ,
            SUM(I12)      ,
            SUM(J12)      ,
            SUM(K12)      ,
            SUM(L12)      ,
            substrb(catstr(M12),1,255),
            SUM(C13)     ,
            SUM(D13)     ,
            SUM(E13)     ,
            SUM(F13)     ,
            SUM(G13)     ,
            SUM(H13)     ,
            SUM(I13)      ,
            SUM(J13)      ,
            SUM(K13)      ,
            SUM(L13)      ,
            substrb(catstr(M13),1,255),
            SUM(C15)     ,
            SUM(D15)     ,
            SUM(E15)     ,
            SUM(F15)     ,
            SUM(G15)     ,
            SUM(H15)     ,
            SUM(I15)      ,
            SUM(J15)      ,
            SUM(K15)      ,
            SUM(L15)      ,
            substrb(catstr(M15),1,255),
            SUM(C16)     ,
            SUM(D16)     ,
            SUM(E16)     ,
            SUM(F16)     ,
            SUM(G16)     ,
            SUM(H16)     ,
            SUM(I16)      ,
            SUM(J16)      ,
            SUM(K16)      ,
            SUM(L16)      ,
            substrb(catstr(M16),1,255),
            SUM(C17)     ,
            SUM(D17)     ,
            SUM(E17)     ,
            SUM(F17)     ,
            SUM(G17)     ,
            SUM(H17)     ,
            SUM(I17)      ,
            SUM(J17)      ,
            SUM(K17)      ,
            SUM(L17)      ,
            substrb(catstr(M17),1,255),
            SUM(C18)     ,
            SUM(D18)     ,
            SUM(E18)     ,
            SUM(F18)     ,
            SUM(G18)     ,
            SUM(H18)     ,
            SUM(I18)      ,
            SUM(J18)      ,
            SUM(K18)      ,
            SUM(L18)      ,
            substrb(catstr(M18),1,255),
            SUM(C19)     ,
            SUM(D19)     ,
            SUM(E19)     ,
            SUM(F19)     ,
            SUM(G19)     ,
            SUM(H19)     ,
            SUM(I19)      ,
            SUM(J19)      ,
            SUM(K19)      ,
            SUM(L19)      ,
            substrb(catstr(M19),1,255),
            SUM(C20)     ,
            SUM(D20)     ,
            SUM(E20)     ,
            SUM(F20)     ,
            SUM(G20)     ,
            SUM(H20)     ,
            SUM(I20)      ,
            SUM(J20)      ,
            SUM(K20)      ,
            SUM(L20)      ,
            substrb(catstr(M20),1,255),
            SUM(C21)     ,
            SUM(D21)     ,
            SUM(E21)     ,
            SUM(F21)     ,
            SUM(G21)     ,
            SUM(H21)     ,
            SUM(I21)      ,
            SUM(J21)      ,
            SUM(K21)      ,
            SUM(L21)      ,
            substrb(catstr(M21),1,255),
            SUM(C23)     ,
            SUM(D23)     ,
            SUM(E23)     ,
            SUM(F23)     ,
            SUM(G23)     ,
            SUM(H23)     ,
            SUM(I23)      ,
            SUM(J23)      ,
            SUM(K23)      ,
            SUM(L23)      ,
            substrb(catstr(M23),1,255),
            SUM(C24)     ,
            SUM(D24)     ,
            SUM(E24)     ,
            SUM(F24)     ,
            SUM(G24)     ,
            SUM(H24)     ,
            SUM(I24)      ,
            SUM(J24)      ,
            SUM(K24)      ,
            SUM(L24)      ,
            substrb(catstr(M24),1,255),
            SUM(C25)     ,
            SUM(D25)     ,
            SUM(E25)     ,
            SUM(F25)     ,
            SUM(G25)     ,
            SUM(H25)     ,
            SUM(I25)      ,
            SUM(J25)      ,
            SUM(K25)      ,
            SUM(L25)      ,
            substrb(catstr(M25),1,255),
            SUM(C26)     ,
            SUM(D26)     ,
            SUM(E26)     ,
            SUM(F26)     ,
            SUM(G26)     ,
            SUM(H26)     ,
            SUM(I26)      ,
            SUM(J26)      ,
            SUM(K26)      ,
            SUM(L26)      ,
            substrb(catstr(M26),1,255),
            SUM(C28)     ,
            SUM(D28)     ,
            SUM(E28)     ,
            SUM(F28)     ,
            SUM(G28)     ,
            SUM(H28)     ,
            SUM(I28)      ,
            SUM(J28)      ,
            SUM(K28)      ,
            SUM(L28)      ,
            substrb(catstr(M28),1,255),
            SUM(C29)     ,
            SUM(D29)     ,
            SUM(E29)     ,
            SUM(F29)     ,
            SUM(G29)     ,
            SUM(H29)     ,
            SUM(I29)      ,
            SUM(J29)      ,
            SUM(K29)      ,
            SUM(L29)      ,
            substrb(catstr(M29),1,255),
            SUM(C30)     ,
            SUM(D30)     ,
            SUM(E30)     ,
            SUM(F30)     ,
            SUM(G30)     ,
            SUM(H30)     ,
            SUM(I30)      ,
            SUM(J30)      ,
            SUM(K30)      ,
            SUM(L30)      ,
            substrb(catstr(M30),1,255),
            SUM(D32)     ,
            SUM(F32)     ,
           substrb(catstr(M32),1,255),
            SUM(D33)     ,
            SUM(F33)     ,
            substrb(catstr(M33),1,255)
        from T_CSRC1227_C12_1
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120210 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C12-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120210;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120210 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120210!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120220
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120220(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120220  and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Ѻʽۻع׼ܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0822_c13_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0822_c13_1(
            BBQ,
            USERID,
            BTYPE,
            OPTION1,
            SHTAG,
            C2,
            D2,
            E2,
            F2,
            C3,
            D3,
            E3,
            F3,
            C4,
            D4,
            E4,
            F4,
            C5,
            D5,
            E5,
            F5,
            C6,
            D6,
            E6,
            F6,
            C7,
            D7,
            E7,
            F7,
            C8,
            D8,
            E8,
            F8,
            C9,
            D9,
            E9,
            F9,
            C10,
            D10,
            E10,
            F10,
            C11,
            F11,
            C12,
            F12,
            C13,
            F13,
            C14,
            F14,
            C15,
            F15,
            C16,
            F16,
            C17,
            F17,
            C18,
            F18,
            C20,
            D20,
            C21,
            D21,
            C22,
            D22,
            C23,
            D23,
            C24,
            D24,
            C27,
            D27,
            C28,
            D28,
            C29,
            D29
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
          SUM(C2),
          SUM(D2),
          SUM(E2),
          SUM(F2),
          SUM(C3),
          SUM(D3),
          SUM(E3),
          SUM(F3),
          SUM(C4),
          SUM(D4),
          SUM(E4),
          SUM(F4),
          SUM(C5),
          SUM(D5),
          SUM(E5),
          SUM(F5),
          SUM(C6),
          SUM(D6),
          SUM(E6),
          SUM(F6),
          SUM(C7),
          SUM(D7),
          SUM(E7),
          SUM(F7),
          SUM(C8),
          SUM(D8),
          SUM(E8),
          SUM(F8),
          SUM(C9),
          SUM(D9),
          SUM(E9),
          SUM(F9),
          SUM(C10),
          SUM(D10),
          SUM(E10),
          SUM(F10),
          SUM(C11),
          SUM(F11),
          SUM(C12),
          SUM(F12),
          SUM(C13),
          SUM(F13),
          SUM(C14),
          SUM(F14),
          SUM(C15),
          SUM(F15),
          SUM(C16),
          SUM(F16),
          SUM(C17),
          SUM(F17),
          SUM(C18),
          SUM(F18),
          SUM(C20),
          SUM(D20),
          SUM(C21),
          SUM(D21),
          SUM(C22),
          SUM(D22),
          SUM(C23),
          SUM(D23),
          SUM(C24),
          SUM(D24),
          SUM(C27),
          SUM(D27),
          SUM(C28),
          SUM(D28),
          SUM(C29),
          SUM(D29)
         from t_csrc0822_c13_1
        where BBQ = v_P001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120220 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>c13-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120220;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120220 and a008=v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_1120220!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120230
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120230(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

        --õ˻
       select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120230
       and a008 in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Լʽ֤ȯ׼ܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0822_C13_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0822_C13_2(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           C2,
            D2,
            E2,
            F2,
            C3,
            D3,
            E3,
            F3,
            C4,
            D4,
            E4,
            F4,
            C5,
            D5,
            E5,
            F5,
            C6,
            D6,
            E6,
            F6,
            C7,
            D7,
            E7,
            F7,
            C8,
            D8,
            E8,
            F8,
            C9,
            D9,
            E9,
            F9,
            C10,
            D10,
            E10,
            F10,
            C11,
            F11,
            C12,
            F12,
            C13,
            D13,
            E13,
            F13,
            C14,
            D14,
            E14,
            F14,
            C15,
            D15,
            E15,
            F15,
            C16,
            D16,
            E16,
            F16,
            C17,
            D17,
            E17,
            F17,
            C18,
            F18,
            C19,
            F19,
            C20,
            F20,
            C21,
            F21,
            C22,
            F22,
            C23,
            F23,
            C24,
            F24,
            C27,
            D27,
            C28,
            D28,
            C29,
            D29,
            C30,
            D30,
            C33,
            D33,
            C34,
            D34,
            A38,
            C38,
            D38,
            E38,
            F38,
            A39,
            C39,
            D39,
            E39,
            F39,
            A40,
            C40,
            D40,
            E40,
            F40,
            A41,
            C41,
            D41,
            E41,
            F41,
            A42,
            C42,
            D42,
            E42,
            F42,
            A44,
            C44,
            D44,
            E44,
            F44,
            A45,
            C45,
            D45,
            E45,
            F45,
            A46,
            C46,
            D46,
            E46,
            F46,
            A47,
            C47,
            D47,
            E47,
            F47,
            A48,
            C48,
            D48,
            E48,
            F48
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(C2),
            sum(D2),
            sum(E2),
            sum(F2),
            sum(C3),
            sum(D3),
            sum(E3),
            sum(F3),
            sum(C4),
            sum(D4),
            sum(E4),
            sum(F4),
            sum(C5),
            sum(D5),
            sum(E5),
            sum(F5),
            sum(C6),
            sum(D6),
            sum(E6),
            sum(F6),
            sum(C7),
            sum(D7),
            sum(E7),
            sum(F7),
            sum(C8),
            sum(D8),
            sum(E8),
            sum(F8),
            sum(C9),
            sum(D9),
            sum(E9),
            sum(F9),
            sum(C10),
            sum(D10),
            sum(E10),
            sum(F10),
            sum(C11),
            sum(F11),
            sum(C12),
            sum(F12),
            sum(C13),
            sum(D13),
            sum(E13),
            sum(F13),
            sum(C14),
            sum(D14),
            sum(E14),
            sum(F14),
            sum(C15),
            sum(D15),
            sum(E15),
            sum(F15),
            sum(C16),
            sum(D16),
            sum(E16),
            sum(F16),
            sum(C17),
            sum(D17),
            sum(E17),
            sum(F17),
            sum(C18),
            sum(F18),
            sum(C19),
            sum(F19),
            sum(C20),
            sum(F20),
            sum(C21),
            sum(F21),
            sum(C22),
            sum(F22),
            sum(C23),
            sum(F23),
            sum(C24),
            sum(F24),
            sum(C27),
            sum(D27),
            sum(C28),
            sum(D28),
            sum(C29),
            sum(D29),
            sum(C30),
            sum(D30),
            sum(C33),
            sum(D33),
            sum(C34),
            sum(D34),
            substrb(catstr(A38),1,255),
            sum(C38),
            sum(D38),
            sum(E38),
            sum(F38),
            substrb(catstr(A39),1,255),
            sum(C39),
            sum(D39),
            sum(E39),
            sum(F39),
            substrb(catstr(A40),1,255),
            sum(C40),
            sum(D40),
            sum(E40),
            sum(F40),
            substrb(catstr(A41),1,255),
            sum(C41),
            sum(D41),
            sum(E41),
            sum(F41),
            substrb(catstr(A42),1,255),
            sum(C42),
            sum(D42),
            sum(E42),
            sum(F42),
            substrb(catstr(A44),1,255),
            sum(C44),
            sum(D44),
            sum(E44),
            sum(F44),
            substrb(catstr(A45),1,255),
            sum(C45),
            sum(D45),
            sum(E45),
            sum(F45),
            substrb(catstr(A46),1,255),
            sum(C46),
            sum(D46),
            sum(E46),
            sum(F46),
            substrb(catstr(A47),1,255),
            sum(C47),
            sum(D47),
            sum(E47),
            sum(F47),
            substrb(catstr(A48),1,255),
            sum(C48),
            sum(D48),
            sum(E48),
            sum(F48)
         from T_CSRC0822_C13_2
        where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120230 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C13-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120230;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120230 and a008=v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120230!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120240
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120240(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

       --õ˻
       select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1120240
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ƱѺʽعҵܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0822_C13_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0822_C13_3(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           C2,
            D2,
            E2,
            F2,
            C3,
            D3,
            E3,
            F3,
            C4,
            D4,
            E4,
            F4,
            C5,
            D5,
            E5,
            F5,
            C6,
            D6,
            E6,
            F6,
            C7,
            D7,
            E7,
            F7,
            C8,
            D8,
            E8,
            F8,
            C9,
            D9,
            E9,
            F9,
            C10,
            D10,
            E10,
            F10,
            C11,
            F11,
            C12,
            F12,
            C13,
            F13,
            C14,
            D14,
            E14,
            F14,
            C15,
            D15,
            E15,
            F15,
            C16,
            D16,
            E16,
            F16,
            C17,
            D17,
            E17,
            F17,
            C18,
            d18,
            E18,
            F18,
            C19,
            d19,
            e19,
            F19,
            C20,
            d20,
            e20,
            F20,
            C21,
            F21,
            C22,
            F22,
            C23,
            F23,
            C24,
            F24,
            C25,
            F25,
            C26,
            F26,
            C27,
            F27,
            C30,
            D30,
            C31,
            D31,
            C32,
            D32,
            C33,
            D33,
            C34,
            D34,
            C35,
            D35,
            C36,
            D36,
            C37,
            D37,
            C38,
            D38,
            C41,
            D41,
            C42,
            D42,
            C43,
            D43,
            A47,
            C47,
            D47,
            E47,
            F47,
            A48,
            C48,
            D48,
            E48,
            F48,
            A49,
            C49,
            D49,
            E49,
            F49,
            A50,
            C50,
            D50,
            E50,
            F50,
            A51,
            C51,
            D51,
            E51,
            F51,
            A53,
            C53,
            D53,
            E53,
            F53,
            A54,
            C54,
            D54,
            E54,
            F54,
            A55,
            C55,
            D55,
            E55,
            F55,
            A56,
            C56,
            D56,
            E56,
            F56,
            A57,
            C57,
            D57,
            E57,
            F57
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           sum(C2),
            sum(D2),
            sum(E2),
            sum(F2),
            sum(C3),
            sum(D3),
            sum(E3),
            sum(F3),
            sum(C4),
            sum(D4),
            sum(E4),
            sum(F4),
            sum(C5),
            sum(D5),
            sum(E5),
            sum(F5),
            sum(C6),
            sum(D6),
            sum(E6),
            sum(F6),
            sum(C7),
            sum(D7),
            sum(E7),
            sum(F7),
            sum(C8),
            sum(D8),
            sum(E8),
            sum(F8),
            sum(C9),
            sum(D9),
            sum(E9),
            sum(F9),
            sum(C10),
            sum(D10),
            sum(E10),
            sum(F10),
            sum(C11),
            sum(F11),
            sum(C12),
            sum(F12),
            sum(C13),
            sum(F13),
            sum(C14),
            sum(D14),
            sum(E14),
            sum(F14),
            sum(C15),
            sum(D15),
            sum(E15),
            sum(F15),
            sum(C16),
            sum(D16),
            sum(E16),
            sum(F16),
            sum(C17),
            sum(D17),
            sum(E17),
            sum(F17),
            sum(C18),
            sum(d18),
            sum(E18),
            sum(F18),
            sum(C19),
            sum(d19),
            sum(e19),
            sum(F19),
            sum(C20),
            sum(d20),
            sum(e20),
            sum(F20),
            sum(C21),
            sum(F21),
            sum(C22),
            sum(F22),
            sum(C23),
            sum(F23),
            sum(C24),
            sum(F24),
            sum(C25),
            sum(F25),
            sum(C26),
            sum(F26),
            sum(C27),
            sum(F27),
            sum(C30),
            sum(D30),
            sum(C31),
            sum(D31),
            sum(C32),
            sum(D32),
            sum(C33),
            sum(D33),
            sum(C34),
            sum(D34),
            sum(C35),
            sum(D35),
            sum(C36),
            sum(D36),
            sum(C37),
            sum(D37),
            sum(C38),
            sum(D38),
            sum(C41),
            sum(D41),
            sum(C42),
            sum(D42),
            sum(C43),
            sum(D43),
            substrb(catstr(A47),1,255),
            sum(C47),
            sum(D47),
            sum(E47),
            sum(F47),
            substrb(catstr(A48),1,255),
            sum(C48),
            sum(D48),
            sum(E48),
            sum(F48),
            substrb(catstr(A49),1,255),
            sum(C49),
            sum(D49),
            sum(E49),
            sum(F49),
            substrb(catstr(A50),1,255),
            sum(C50),
            sum(D50),
            sum(E50),
            sum(F50),
            substrb(catstr(A51),1,255),
            sum(C51),
            sum(D51),
            sum(E51),
            sum(F51),
            substrb(catstr(A53),1,255),
            sum(C53),
            sum(D53),
            sum(E53),
            sum(F53),
            substrb(catstr(A54),1,255),
            sum(C54),
            sum(D54),
            sum(E54),
            sum(F54),
            substrb(catstr(A55),1,255),
            sum(C55),
            sum(D55),
            sum(E55),
            sum(F55),
            substrb(catstr(A56),1,255),
            sum(C56),
            sum(D56),
            sum(E56),
            sum(F56),
            substrb(catstr(A57),1,255),
            sum(C57),
            sum(D57),
            sum(E57),
            sum(F57)
         from T_CSRC0822_C13_3
        where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1120240 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C13-3'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1120240;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1120240 and a008=v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1120240!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120241
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120241 (errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
  V_ORGNAME  varchar(256);

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1120241;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
   SELECT T2.A003 INTO V_ORGNAME FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC0822_C13_3_RH
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC0822_C13_3_RH(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,D2,E2,F2,C3,D3,E3,F3,C4,D4,E4,F4,C5,D5,E5,F5,C6,D6,E6,F6,C7,D7,E7,F7,C8,D8,E8,F8,C9,D9,E9,F9,C10,D10,E10,F10,C11,F11,C12,F12,C13,F13,C14,D14,E14,F14,C15,D15,E15,F15,C16,D16,E16,F16,C17,D17,E17,F17,C18,D18,E18,F18,C19,D19,E19,F19,C20,D20,E20,F20,C21,F21,C22,F22,C23,F23,C24,F24,C25,F25,C26,F26,C27,F27,C30,D30,C31,D31,C32,D32,C33,D33,C34,D34,C35,D35,C36,D36,C37,D37,C38,D38,C41,D41,C42,D42,C43,D43,A47,C47,D47,E47,F47,A48,C48,D48,E48,F48,A49,C49,D49,E49,F49,A50,C50,D50,E50,F50,A51,C51,D51,E51,F51,A53,C53,D53,E53,F53,A54,C54,D54,E54,F54,A55,C55,D55,E55,F55,A56,C56,D56,E56,F56,A57,C57,D57,E57,F57)
   select   v_P001,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C2,0)),SUM(nvl(D2,0)),SUM(nvl(E2,0)),SUM(nvl(F2,0)),SUM(nvl(C3,0)),SUM(nvl(D3,0)),SUM(nvl(E3,0)),SUM(nvl(F3,0)),SUM(nvl(C4,0)),SUM(nvl(D4,0)),SUM(nvl(E4,0)),SUM(nvl(F4,0)),SUM(nvl(C5,0)),SUM(nvl(D5,0)),SUM(nvl(E5,0)),SUM(nvl(F5,0)),SUM(nvl(C6,0)),SUM(nvl(D6,0)),SUM(nvl(E6,0)),SUM(nvl(F6,0)),SUM(nvl(C7,0)),SUM(nvl(D7,0)),SUM(nvl(E7,0)),SUM(nvl(F7,0)),SUM(nvl(C8,0)),SUM(nvl(D8,0)),SUM(nvl(E8,0)),SUM(nvl(F8,0)),SUM(nvl(C9,0)),SUM(nvl(D9,0)),SUM(nvl(E9,0)),SUM(nvl(F9,0)),SUM(nvl(C10,0)),SUM(nvl(D10,0)),SUM(nvl(E10,0)),SUM(nvl(F10,0)),SUM(nvl(C11,0)),SUM(nvl(F11,0)),SUM(nvl(C12,0)),SUM(nvl(F12,0)),SUM(nvl(C13,0)),SUM(nvl(F13,0)),SUM(nvl(C14,0)),SUM(nvl(D14,0)),SUM(nvl(E14,0)),SUM(nvl(F14,0)),SUM(nvl(C15,0)),SUM(nvl(D15,0)),SUM(nvl(E15,0)),SUM(nvl(F15,0)),SUM(nvl(C16,0)),SUM(nvl(D16,0)),SUM(nvl(E16,0)),SUM(nvl(F16,0)),SUM(nvl(C17,0)),SUM(nvl(D17,0)),SUM(nvl(E17,0)),SUM(nvl(F17,0)),SUM(nvl(C18,0)),SUM(nvl(D18,0)),SUM(nvl(E18,0)),SUM(nvl(F18,0)),SUM(nvl(C19,0)),SUM(nvl(D19,0)),SUM(nvl(E19,0)),SUM(nvl(F19,0)),SUM(nvl(C20,0)),SUM(nvl(D20,0)),SUM(nvl(E20,0)),SUM(nvl(F20,0)),SUM(nvl(C21,0)),SUM(nvl(F21,0)),SUM(nvl(C22,0)),SUM(nvl(F22,0)),SUM(nvl(C23,0)),SUM(nvl(F23,0)),SUM(nvl(C24,0)),SUM(nvl(F24,0)),SUM(nvl(C25,0)),SUM(nvl(F25,0)),SUM(nvl(C26,0)),SUM(nvl(F26,0)),SUM(nvl(C27,0)),SUM(nvl(F27,0)),SUM(nvl(C30,0)),SUM(nvl(D30,0)),SUM(nvl(C31,0)),SUM(nvl(D31,0)),SUM(nvl(C32,0)),SUM(nvl(D32,0)),SUM(nvl(C33,0)),SUM(nvl(D33,0)),SUM(nvl(C34,0)),SUM(nvl(D34,0)),SUM(nvl(C35,0)),SUM(nvl(D35,0)),SUM(nvl(C36,0)),SUM(nvl(D36,0)),SUM(nvl(C37,0)),SUM(nvl(D37,0)),SUM(nvl(C38,0)),SUM(nvl(D38,0)),SUM(nvl(C41,0)),SUM(nvl(D41,0)),SUM(nvl(C42,0)),SUM(nvl(D42,0)),SUM(nvl(C43,0)),SUM(nvl(D43,0)),substrb(catstr(A47),1,255),SUM(nvl(C47,0)),SUM(nvl(D47,0)),SUM(nvl(E47,0)),SUM(nvl(F47,0)),substrb(catstr(A48),1,255),SUM(nvl(C48,0)),SUM(nvl(D48,0)),SUM(nvl(E48,0)),SUM(nvl(F48,0)),substrb(catstr(A49),1,255),SUM(nvl(C49,0)),SUM(nvl(D49,0)),SUM(nvl(E49,0)),SUM(nvl(F49,0)),substrb(catstr(A50),1,255),SUM(nvl(C50,0)),SUM(nvl(D50,0)),SUM(nvl(E50,0)),SUM(nvl(F50,0)),substrb(catstr(A51),1,255),SUM(nvl(C51,0)),SUM(nvl(D51,0)),SUM(nvl(E51,0)),SUM(nvl(F51,0)),substrb(catstr(A53),1,255),SUM(nvl(C53,0)),SUM(nvl(D53,0)),SUM(nvl(E53,0)),SUM(nvl(F53,0)),substrb(catstr(A54),1,255),SUM(nvl(C54,0)),SUM(nvl(D54,0)),SUM(nvl(E54,0)),SUM(nvl(F54,0)),substrb(catstr(A55),1,255),SUM(nvl(C55,0)),SUM(nvl(D55,0)),SUM(nvl(E55,0)),SUM(nvl(F55,0)),substrb(catstr(A56),1,255),SUM(nvl(C56,0)),SUM(nvl(D56,0)),SUM(nvl(E56,0)),SUM(nvl(F56,0)),substrb(catstr(A57),1,255),SUM(nvl(C57,0)),SUM(nvl(D57,0)),SUM(nvl(E57,0)),SUM(nvl(F57,0))
        from T_CSRC0822_C13_3_RH
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
    insert into T_CSRC0822_C13_3_RH(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,D2,E2,F2,C3,D3,E3,F3,C4,D4,E4,F4,C5,D5,E5,F5,C6,D6,E6,F6,C7,D7,E7,F7,C8,D8,E8,F8,C9,D9,E9,F9,C10,D10,E10,F10,C11,F11,C12,F12,C13,F13,C14,D14,E14,F14,C15,D15,E15,F15,C16,D16,E16,F16,C17,D17,E17,F17,C18,D18,E18,F18,C19,D19,E19,F19,C20,D20,E20,F20,C21,F21,C22,F22,C23,F23,C24,F24,C25,F25,C26,F26,C27,F27,C30,D30,C31,D31,C32,D32,C33,D33,C34,D34,C35,D35,C36,D36,C37,D37,C38,D38,C41,D41,C42,D42,C43,D43,A47,C47,D47,E47,F47,A48,C48,D48,E48,F48,A49,C49,D49,E49,F49,A50,C50,D50,E50,F50,A51,C51,D51,E51,F51,A53,C53,D53,E53,F53,A54,C54,D54,E54,F54,A55,C55,D55,E55,F55,A56,C56,D56,E56,F56,A57,C57,D57,E57,F57)
   select   BBQ,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C2,0)),SUM(nvl(D2,0)),SUM(nvl(E2,0)),SUM(nvl(F2,0)),SUM(nvl(C3,0)),SUM(nvl(D3,0)),SUM(nvl(E3,0)),SUM(nvl(F3,0)),SUM(nvl(C4,0)),SUM(nvl(D4,0)),SUM(nvl(E4,0)),SUM(nvl(F4,0)),SUM(nvl(C5,0)),SUM(nvl(D5,0)),SUM(nvl(E5,0)),SUM(nvl(F5,0)),SUM(nvl(C6,0)),SUM(nvl(D6,0)),SUM(nvl(E6,0)),SUM(nvl(F6,0)),SUM(nvl(C7,0)),SUM(nvl(D7,0)),SUM(nvl(E7,0)),SUM(nvl(F7,0)),SUM(nvl(C8,0)),SUM(nvl(D8,0)),SUM(nvl(E8,0)),SUM(nvl(F8,0)),SUM(nvl(C9,0)),SUM(nvl(D9,0)),SUM(nvl(E9,0)),SUM(nvl(F9,0)),SUM(nvl(C10,0)),SUM(nvl(D10,0)),SUM(nvl(E10,0)),SUM(nvl(F10,0)),SUM(nvl(C11,0)),SUM(nvl(F11,0)),SUM(nvl(C12,0)),SUM(nvl(F12,0)),SUM(nvl(C13,0)),SUM(nvl(F13,0)),SUM(nvl(C14,0)),SUM(nvl(D14,0)),SUM(nvl(E14,0)),SUM(nvl(F14,0)),SUM(nvl(C15,0)),SUM(nvl(D15,0)),SUM(nvl(E15,0)),SUM(nvl(F15,0)),SUM(nvl(C16,0)),SUM(nvl(D16,0)),SUM(nvl(E16,0)),SUM(nvl(F16,0)),SUM(nvl(C17,0)),SUM(nvl(D17,0)),SUM(nvl(E17,0)),SUM(nvl(F17,0)),SUM(nvl(C18,0)),SUM(nvl(D18,0)),SUM(nvl(E18,0)),SUM(nvl(F18,0)),SUM(nvl(C19,0)),SUM(nvl(D19,0)),SUM(nvl(E19,0)),SUM(nvl(F19,0)),SUM(nvl(C20,0)),SUM(nvl(D20,0)),SUM(nvl(E20,0)),SUM(nvl(F20,0)),SUM(nvl(C21,0)),SUM(nvl(F21,0)),SUM(nvl(C22,0)),SUM(nvl(F22,0)),SUM(nvl(C23,0)),SUM(nvl(F23,0)),SUM(nvl(C24,0)),SUM(nvl(F24,0)),SUM(nvl(C25,0)),SUM(nvl(F25,0)),SUM(nvl(C26,0)),SUM(nvl(F26,0)),SUM(nvl(C27,0)),SUM(nvl(F27,0)),SUM(nvl(C30,0)),SUM(nvl(D30,0)),SUM(nvl(C31,0)),SUM(nvl(D31,0)),SUM(nvl(C32,0)),SUM(nvl(D32,0)),SUM(nvl(C33,0)),SUM(nvl(D33,0)),SUM(nvl(C34,0)),SUM(nvl(D34,0)),SUM(nvl(C35,0)),SUM(nvl(D35,0)),SUM(nvl(C36,0)),SUM(nvl(D36,0)),SUM(nvl(C37,0)),SUM(nvl(D37,0)),SUM(nvl(C38,0)),SUM(nvl(D38,0)),SUM(nvl(C41,0)),SUM(nvl(D41,0)),SUM(nvl(C42,0)),SUM(nvl(D42,0)),SUM(nvl(C43,0)),SUM(nvl(D43,0)),NULL,SUM(nvl(C47,0)),SUM(nvl(D47,0)),SUM(nvl(E47,0)),SUM(nvl(F47,0)),NULL,SUM(nvl(C48,0)),SUM(nvl(D48,0)),SUM(nvl(E48,0)),SUM(nvl(F48,0)),NULL,SUM(nvl(C49,0)),SUM(nvl(D49,0)),SUM(nvl(E49,0)),SUM(nvl(F49,0)),NULL,SUM(nvl(C50,0)),SUM(nvl(D50,0)),SUM(nvl(E50,0)),SUM(nvl(F50,0)),NULL,SUM(nvl(C51,0)),SUM(nvl(D51,0)),SUM(nvl(E51,0)),SUM(nvl(F51,0)),NULL,SUM(nvl(C53,0)),SUM(nvl(D53,0)),SUM(nvl(E53,0)),SUM(nvl(F53,0)),NULL,SUM(nvl(C54,0)),SUM(nvl(D54,0)),SUM(nvl(E54,0)),SUM(nvl(F54,0)),NULL,SUM(nvl(C55,0)),SUM(nvl(D55,0)),SUM(nvl(E55,0)),SUM(nvl(F55,0)),NULL,SUM(nvl(C56,0)),SUM(nvl(D56,0)),SUM(nvl(E56,0)),SUM(nvl(F56,0)),NULL,SUM(nvl(C57,0)),SUM(nvl(D57,0)),SUM(nvl(E57,0)),SUM(nvl(F57,0))
        from T_CSRC0822_C13_3_RH
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120242
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120242 (errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
  V_ORGNAME  varchar(256);

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1120242;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;
   SELECT T2.A003 INTO V_ORGNAME FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2 WHERE T1.P001 = v_KJAXUSER AND T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC0822_C13_3_ZYZJ
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC0822_C13_3_ZYZJ(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,D2,E2,F2,C3,D3,E3,F3,C4,D4,E4,F4,C5,D5,E5,F5,C6,D6,E6,F6,C7,D7,E7,F7,C8,D8,E8,F8,C9,D9,E9,F9,C10,D10,E10,F10,C11,F11,C12,F12,C13,F13,C14,D14,E14,F14,C15,D15,E15,F15,C16,D16,E16,F16,C17,D17,E17,F17,C18,D18,E18,F18,C19,D19,E19,F19,C20,D20,E20,F20,C21,F21,C22,F22,C23,F23,C24,F24,C25,F25,C26,F26,C27,F27,C30,D30,C31,D31,C32,D32,C33,D33,C34,D34,C35,D35,C36,D36,C37,D37,C38,D38,C41,D41,C42,D42,C43,D43,A47,C47,D47,E47,F47,A48,C48,D48,E48,F48,A49,C49,D49,E49,F49,A50,C50,D50,E50,F50,A51,C51,D51,E51,F51,A53,C53,D53,E53,F53,A54,C54,D54,E54,F54,A55,C55,D55,E55,F55,A56,C56,D56,E56,F56,A57,C57,D57,E57,F57)
   select   v_P001,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C2,0)),SUM(nvl(D2,0)),SUM(nvl(E2,0)),SUM(nvl(F2,0)),SUM(nvl(C3,0)),SUM(nvl(D3,0)),SUM(nvl(E3,0)),SUM(nvl(F3,0)),SUM(nvl(C4,0)),SUM(nvl(D4,0)),SUM(nvl(E4,0)),SUM(nvl(F4,0)),SUM(nvl(C5,0)),SUM(nvl(D5,0)),SUM(nvl(E5,0)),SUM(nvl(F5,0)),SUM(nvl(C6,0)),SUM(nvl(D6,0)),SUM(nvl(E6,0)),SUM(nvl(F6,0)),SUM(nvl(C7,0)),SUM(nvl(D7,0)),SUM(nvl(E7,0)),SUM(nvl(F7,0)),SUM(nvl(C8,0)),SUM(nvl(D8,0)),SUM(nvl(E8,0)),SUM(nvl(F8,0)),SUM(nvl(C9,0)),SUM(nvl(D9,0)),SUM(nvl(E9,0)),SUM(nvl(F9,0)),SUM(nvl(C10,0)),SUM(nvl(D10,0)),SUM(nvl(E10,0)),SUM(nvl(F10,0)),SUM(nvl(C11,0)),SUM(nvl(F11,0)),SUM(nvl(C12,0)),SUM(nvl(F12,0)),SUM(nvl(C13,0)),SUM(nvl(F13,0)),SUM(nvl(C14,0)),SUM(nvl(D14,0)),SUM(nvl(E14,0)),SUM(nvl(F14,0)),SUM(nvl(C15,0)),SUM(nvl(D15,0)),SUM(nvl(E15,0)),SUM(nvl(F15,0)),SUM(nvl(C16,0)),SUM(nvl(D16,0)),SUM(nvl(E16,0)),SUM(nvl(F16,0)),SUM(nvl(C17,0)),SUM(nvl(D17,0)),SUM(nvl(E17,0)),SUM(nvl(F17,0)),SUM(nvl(C18,0)),SUM(nvl(D18,0)),SUM(nvl(E18,0)),SUM(nvl(F18,0)),SUM(nvl(C19,0)),SUM(nvl(D19,0)),SUM(nvl(E19,0)),SUM(nvl(F19,0)),SUM(nvl(C20,0)),SUM(nvl(D20,0)),SUM(nvl(E20,0)),SUM(nvl(F20,0)),SUM(nvl(C21,0)),SUM(nvl(F21,0)),SUM(nvl(C22,0)),SUM(nvl(F22,0)),SUM(nvl(C23,0)),SUM(nvl(F23,0)),SUM(nvl(C24,0)),SUM(nvl(F24,0)),SUM(nvl(C25,0)),SUM(nvl(F25,0)),SUM(nvl(C26,0)),SUM(nvl(F26,0)),SUM(nvl(C27,0)),SUM(nvl(F27,0)),SUM(nvl(C30,0)),SUM(nvl(D30,0)),SUM(nvl(C31,0)),SUM(nvl(D31,0)),SUM(nvl(C32,0)),SUM(nvl(D32,0)),SUM(nvl(C33,0)),SUM(nvl(D33,0)),SUM(nvl(C34,0)),SUM(nvl(D34,0)),SUM(nvl(C35,0)),SUM(nvl(D35,0)),SUM(nvl(C36,0)),SUM(nvl(D36,0)),SUM(nvl(C37,0)),SUM(nvl(D37,0)),SUM(nvl(C38,0)),SUM(nvl(D38,0)),SUM(nvl(C41,0)),SUM(nvl(D41,0)),SUM(nvl(C42,0)),SUM(nvl(D42,0)),SUM(nvl(C43,0)),SUM(nvl(D43,0)),substrb(catstr(A47),1,255),SUM(nvl(C47,0)),SUM(nvl(D47,0)),SUM(nvl(E47,0)),SUM(nvl(F47,0)),substrb(catstr(A48),1,255),SUM(nvl(C48,0)),SUM(nvl(D48,0)),SUM(nvl(E48,0)),SUM(nvl(F48,0)),substrb(catstr(A49),1,255),SUM(nvl(C49,0)),SUM(nvl(D49,0)),SUM(nvl(E49,0)),SUM(nvl(F49,0)),substrb(catstr(A50),1,255),SUM(nvl(C50,0)),SUM(nvl(D50,0)),SUM(nvl(E50,0)),SUM(nvl(F50,0)),substrb(catstr(A51),1,255),SUM(nvl(C51,0)),SUM(nvl(D51,0)),SUM(nvl(E51,0)),SUM(nvl(F51,0)),substrb(catstr(A53),1,255),SUM(nvl(C53,0)),SUM(nvl(D53,0)),SUM(nvl(E53,0)),SUM(nvl(F53,0)),substrb(catstr(A54),1,255),SUM(nvl(C54,0)),SUM(nvl(D54,0)),SUM(nvl(E54,0)),SUM(nvl(F54,0)),substrb(catstr(A55),1,255),SUM(nvl(C55,0)),SUM(nvl(D55,0)),SUM(nvl(E55,0)),SUM(nvl(F55,0)),substrb(catstr(A56),1,255),SUM(nvl(C56,0)),SUM(nvl(D56,0)),SUM(nvl(E56,0)),SUM(nvl(F56,0)),substrb(catstr(A57),1,255),SUM(nvl(C57,0)),SUM(nvl(D57,0)),SUM(nvl(E57,0)),SUM(nvl(F57,0))
        from T_CSRC0822_C13_3_ZYZJ
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
    insert into T_CSRC0822_C13_3_ZYZJ(BBQ,USERID,BTYPE,OPTION1,SHTAG,C2,D2,E2,F2,C3,D3,E3,F3,C4,D4,E4,F4,C5,D5,E5,F5,C6,D6,E6,F6,C7,D7,E7,F7,C8,D8,E8,F8,C9,D9,E9,F9,C10,D10,E10,F10,C11,F11,C12,F12,C13,F13,C14,D14,E14,F14,C15,D15,E15,F15,C16,D16,E16,F16,C17,D17,E17,F17,C18,D18,E18,F18,C19,D19,E19,F19,C20,D20,E20,F20,C21,F21,C22,F22,C23,F23,C24,F24,C25,F25,C26,F26,C27,F27,C30,D30,C31,D31,C32,D32,C33,D33,C34,D34,C35,D35,C36,D36,C37,D37,C38,D38,C41,D41,C42,D42,C43,D43,A47,C47,D47,E47,F47,A48,C48,D48,E48,F48,A49,C49,D49,E49,F49,A50,C50,D50,E50,F50,A51,C51,D51,E51,F51,A53,C53,D53,E53,F53,A54,C54,D54,E54,F54,A55,C55,D55,E55,F55,A56,C56,D56,E56,F56,A57,C57,D57,E57,F57)
   select   BBQ,
      v_USER,
      0,
      null,
      0,
     SUM(nvl(C2,0)),SUM(nvl(D2,0)),SUM(nvl(E2,0)),SUM(nvl(F2,0)),SUM(nvl(C3,0)),SUM(nvl(D3,0)),SUM(nvl(E3,0)),SUM(nvl(F3,0)),SUM(nvl(C4,0)),SUM(nvl(D4,0)),SUM(nvl(E4,0)),SUM(nvl(F4,0)),SUM(nvl(C5,0)),SUM(nvl(D5,0)),SUM(nvl(E5,0)),SUM(nvl(F5,0)),SUM(nvl(C6,0)),SUM(nvl(D6,0)),SUM(nvl(E6,0)),SUM(nvl(F6,0)),SUM(nvl(C7,0)),SUM(nvl(D7,0)),SUM(nvl(E7,0)),SUM(nvl(F7,0)),SUM(nvl(C8,0)),SUM(nvl(D8,0)),SUM(nvl(E8,0)),SUM(nvl(F8,0)),SUM(nvl(C9,0)),SUM(nvl(D9,0)),SUM(nvl(E9,0)),SUM(nvl(F9,0)),SUM(nvl(C10,0)),SUM(nvl(D10,0)),SUM(nvl(E10,0)),SUM(nvl(F10,0)),SUM(nvl(C11,0)),SUM(nvl(F11,0)),SUM(nvl(C12,0)),SUM(nvl(F12,0)),SUM(nvl(C13,0)),SUM(nvl(F13,0)),SUM(nvl(C14,0)),SUM(nvl(D14,0)),SUM(nvl(E14,0)),SUM(nvl(F14,0)),SUM(nvl(C15,0)),SUM(nvl(D15,0)),SUM(nvl(E15,0)),SUM(nvl(F15,0)),SUM(nvl(C16,0)),SUM(nvl(D16,0)),SUM(nvl(E16,0)),SUM(nvl(F16,0)),SUM(nvl(C17,0)),SUM(nvl(D17,0)),SUM(nvl(E17,0)),SUM(nvl(F17,0)),SUM(nvl(C18,0)),SUM(nvl(D18,0)),SUM(nvl(E18,0)),SUM(nvl(F18,0)),SUM(nvl(C19,0)),SUM(nvl(D19,0)),SUM(nvl(E19,0)),SUM(nvl(F19,0)),SUM(nvl(C20,0)),SUM(nvl(D20,0)),SUM(nvl(E20,0)),SUM(nvl(F20,0)),SUM(nvl(C21,0)),SUM(nvl(F21,0)),SUM(nvl(C22,0)),SUM(nvl(F22,0)),SUM(nvl(C23,0)),SUM(nvl(F23,0)),SUM(nvl(C24,0)),SUM(nvl(F24,0)),SUM(nvl(C25,0)),SUM(nvl(F25,0)),SUM(nvl(C26,0)),SUM(nvl(F26,0)),SUM(nvl(C27,0)),SUM(nvl(F27,0)),SUM(nvl(C30,0)),SUM(nvl(D30,0)),SUM(nvl(C31,0)),SUM(nvl(D31,0)),SUM(nvl(C32,0)),SUM(nvl(D32,0)),SUM(nvl(C33,0)),SUM(nvl(D33,0)),SUM(nvl(C34,0)),SUM(nvl(D34,0)),SUM(nvl(C35,0)),SUM(nvl(D35,0)),SUM(nvl(C36,0)),SUM(nvl(D36,0)),SUM(nvl(C37,0)),SUM(nvl(D37,0)),SUM(nvl(C38,0)),SUM(nvl(D38,0)),SUM(nvl(C41,0)),SUM(nvl(D41,0)),SUM(nvl(C42,0)),SUM(nvl(D42,0)),SUM(nvl(C43,0)),SUM(nvl(D43,0)),NULL,SUM(nvl(C47,0)),SUM(nvl(D47,0)),SUM(nvl(E47,0)),SUM(nvl(F47,0)),NULL,SUM(nvl(C48,0)),SUM(nvl(D48,0)),SUM(nvl(E48,0)),SUM(nvl(F48,0)),NULL,SUM(nvl(C49,0)),SUM(nvl(D49,0)),SUM(nvl(E49,0)),SUM(nvl(F49,0)),NULL,SUM(nvl(C50,0)),SUM(nvl(D50,0)),SUM(nvl(E50,0)),SUM(nvl(F50,0)),NULL,SUM(nvl(C51,0)),SUM(nvl(D51,0)),SUM(nvl(E51,0)),SUM(nvl(F51,0)),NULL,SUM(nvl(C53,0)),SUM(nvl(D53,0)),SUM(nvl(E53,0)),SUM(nvl(F53,0)),NULL,SUM(nvl(C54,0)),SUM(nvl(D54,0)),SUM(nvl(E54,0)),SUM(nvl(F54,0)),NULL,SUM(nvl(C55,0)),SUM(nvl(D55,0)),SUM(nvl(E55,0)),SUM(nvl(F55,0)),NULL,SUM(nvl(C56,0)),SUM(nvl(D56,0)),SUM(nvl(E56,0)),SUM(nvl(F56,0)),NULL,SUM(nvl(C57,0)),SUM(nvl(D57,0)),SUM(nvl(E57,0)),SUM(nvl(F57,0))
        from T_CSRC0822_C13_3_ZYZJ
        where BBQ = v_P001  and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
       order by to_number(option1);
  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120250
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120250(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1120250;

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
    if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

  delete from T_CSRC1219_C14_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC1219_C14_1
     (BBQ,
      USERID,
      BTYPE,
      OPTION1,
      SHTAG,
      C3,
    D3,
      E3,
      F3,
      G3,
      H3,
      I3,
      J3,
      K3,
      L3,
      M3,
      N3,
      C4,
      D4,
      E4,
      F4,
      G4,
      H4,
      I4,
      J4,
      K4,
      L4,
      M4,
      N4,
      C5,
      D5,
      E5,
      F5,
      G5,
      H5,
      I5,
      J5,
      K5,
      L5,
      M5,
      N5,
      C6,
      D6,
      E6,
      F6,
      G6,
      H6,
      I6,
      J6,
      K6,
      L6,
      M6,
      N6,
      C7,
      D7,
      E7,
      F7,
      G7,
      H7,
      I7,
      J7,
      K7,
      L7,
      M7,
      N7
      )
    select
    BBQ,
    v_USER,
    0,
    null,
    0,
      sum(C3),
    sum(D3),
      sum(E3),
      sum(F3),
      sum(G3),
      sum(H3),
      sum(I3),
      sum(J3),
      sum(K3),
      sum(L3),
      sum(M3),
      sum(N3),
      sum(C4),
      sum(D4),
      sum(E4),
      sum(F4),
      sum(G4),
      sum(H4),
      sum(I4),
      sum(J4),
      sum(K4),
      sum(L4),
      sum(M4),
      sum(N4),
      sum(C5),
      sum(D5),
      sum(E5),
      sum(F5),
      sum(G5),
      sum(H5),
      sum(I5),
      sum(J5),
      sum(K5),
      sum(L5),
      sum(M5),
      sum(N5),
      sum(C6),
      sum(D6),
      sum(E6),
      sum(F6),
      sum(G6),
      sum(H6),
      sum(I6),
      sum(J6),
      sum(K6),
      sum(L6),
      sum(M6),
      sum(N6),
      sum(C7),
      sum(D7),
      sum(E7),
      sum(F7),
      sum(G7),
      sum(H7),
      sum(I7),
      sum(J7),
      sum(K7),
      sum(L7),
      sum(M7),
      sum(N7)
      from T_CSRC1219_C14_1
      where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
      group by bbq;

  update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=v_reportid and a008=v_org;

  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = v_reportid;
   INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120260
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120260(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_reportid number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       v_reportid := 1120260;

       select T2.A002 into v_USER
         from KRCS.T_SYS_USER T1,
              KRCS.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      --õ˻
      select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
      select count(*) into v_count
         from krcs.t_sys_t024
         where a011=1009002
           and p001=v_reportid
           and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc1219_c14_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc1219_c14_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG  ,
            ISHJ   ,
            A3     ,
            B3     ,
            C3    ,
            D3    ,
            E3   ,
            F3     ,
            G3    ,
            H3 ,
            I3     ,
            J3   ,
            K3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
            A3     ,
            B3     ,
            C3    ,
            D3    ,
            E3   ,
            F3     ,
            G3    ,
            H3 ,
            I3     ,
            J3  ,
            K3
        from t_csrc1219_c14_2
        where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) and ISHJ=0
        ;


    --ϼֵ
    insert into t_csrc1219_c14_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    D3,E3,F3,G3,H3,I3,J3,K3)
    select v_P001,v_USER,0,null,null,1,
    SUM(D3),SUM(E3),SUM(F3),SUM(G3),SUM(H3),SUM(I3),SUM(J3),SUM(K3)
      from t_csrc1219_c14_2
    where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) and ISHJ=0;


    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,a020=v_KJAXUSER WHERE P001=v_reportid;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005|| A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=v_reportid and a008 =v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120270
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120270(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1120270;

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

   --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     if v_count > 0  then
       errcode:=0;
       errmsg:=v_temp||'δͨ,ϲδ';
       return;
     end if;

  delete from T_CSRC1219_C14_3
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC1219_C14_3
     (BBQ,
      USERID,
      BTYPE,
      OPTION1,
      SHTAG,
      B2,
      C2,
      D2,
      E2,
      B3,
      C3,
      D3,
      E3,
      B5,
      D5,
      B6,
      D6,
      B7,
      D7,
      B9,
      D9,
      B10,
      D10,
      B11,
      D11
            )
    select
    BBQ,
    v_USER,
    0,
      null,
      0,
      SUM(B2),
      SUM(C2),
      SUM(D2),
      SUM(E2),
      SUM(B3),
      SUM(C3),
      SUM(D3),
      SUM(E3),
      SUM(B5),
      SUM(D5),
      SUM(B6),
      SUM(D6),
      SUM(B7),
      SUM(D7),
      SUM(B9),
      SUM(D9),
      SUM(B10),
      SUM(D10),
      SUM(B11),
      SUM(D11)

      from T_CSRC1219_C14_3
     where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
     group by bbq;

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120280
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120280(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_reportid number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       v_reportid := 1120280;

       select T2.A002 into v_USER
         from KRCS.T_SYS_USER T1,
              KRCS.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

         --õ˻
         select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
         select count(*) into v_count
           from krcs.t_sys_t024
           where a011=1009002
             and p001=v_reportid
             and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
         if v_count > 0  then
            errcode:=0;
            errmsg:=v_temp||'δͨ,ϲδ';
            return;
         end if;

       delete from t_csrc1219_c14_4 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc1219_c14_4(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG  ,
            ISHJ   ,
            A3     ,
            B3     ,
            C3    ,
            D3    ,
            E3   ,
            F3     ,
            G3    ,
            H3 ,
            I3     ,
            J3   ,
            K3,
            L3,
            M3,
            N3,
            O3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
            A3     ,
            B3     ,
            C3    ,
            D3    ,
            E3   ,
            F3     ,
            G3    ,
            H3 ,
            I3     ,
            J3  ,
            K3,
            L3,
            M3,
            N3,
            O3
        from t_csrc1219_c14_4
        where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) and ISHJ=0
        ;


    --ϼֵ
    insert into t_csrc1219_c14_4(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3)
    select v_P001,v_USER,0,null,null,1,
    SUM(D3),SUM(E3),SUM(F3),SUM(G3),SUM(H3),SUM(I3),SUM(J3),SUM(K3),SUM(L3),SUM(M3),SUM(N3),SUM(O3)
      from t_csrc1219_c14_4
    where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) and ISHJ=0;


    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,a020=v_KJAXUSER WHERE P001=v_reportid;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005|| A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=v_reportid and a008 =v_org;
                errcode := 0;
                errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120290
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120290(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1120290;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC1219_C14_5
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC1219_C14_5
     (BBQ,
      USERID,
      BTYPE,
      OPTION1,
      SHTAG,
      B3      ,
  C3      ,
  D3      ,
  E3      ,
  F3      ,
  G3      ,
  B4      ,
  C4      ,
  D4      ,
  E4      ,
  F4      ,
  G4      ,
  B7      ,
  C7      ,
  D7      ,
  E7      ,
  F7      ,
  G7      ,
  B9      ,
  D9      ,
  F9      ,
  B12     ,
  C12     ,
  D12     ,
  F12     ,
  G12     ,
  B13     ,
  C13     ,
  D13     ,
  F13     ,
  G13     ,
  B14     ,
  C14     ,
  D14     ,
  F14     ,
  G14     ,
  B15     ,
  C15     ,
  D15     ,
  F15     ,
  G15     ,
  B17     ,
  D17     ,
  F17     ,
  B18     ,
  D18     ,
  F18     ,
  B19     ,
  D19     ,
  F19     ,
  B20     ,
  D20     ,
  F20     ,
  B22     ,
  B23     ,
  B24     ,
  B25     ,
  B28     ,
  C28     ,
  D28     ,
  F28     ,
  G28     ,
  B29     ,
  C29     ,
  D29     ,
  F29     ,
  G29     ,
  B30     ,
  C30     ,
  D30     ,
  F30     ,
  G30     ,
  B31     ,
  C31     ,
  D31     ,
  F31     ,
  G31     ,
  B34     ,
  C34     ,
  D34     ,
  F34     ,
  G34     ,
  B35     ,
  C35     ,
  D35     ,
  F35     ,
  G35     ,
  B36     ,
  C36     ,
  D36     ,
  F36     ,
  G36     ,
  B37     ,
  C37     ,
  D37     ,
  F37     ,
  G37     ,
  A39
            )
    select
    BBQ,
    v_USER,
    0,
      null,
      0,
      SUM(B3),
  SUM(C3),
  SUM(D3),
  SUM(E3),
  SUM(F3),
  SUM(G3),
  SUM(B4),
  SUM(C4),
  SUM(D4),
  SUM(E4),
  SUM(F4),
  SUM(G4),
  SUM(B7),
  SUM(C7),
  SUM(D7),
  SUM(E7),
  SUM(F7),
  SUM(G7),
  SUM(B9),
  SUM(D9),
  SUM(F9),
  SUM(B12),
  SUM(C12),
  SUM(D12),
  SUM(F12),
  SUM(G12),
  SUM(B13),
  SUM(C13),
  SUM(D13),
  SUM(F13),
  SUM(G13),
  SUM(B14),
  SUM(C14),
  SUM(D14),
  SUM(F14),
  SUM(G14),
  SUM(B15),
  SUM(C15),
  SUM(D15),
  SUM(F15),
  SUM(G15),
  SUM(B17),
  SUM(D17),
  SUM(F17),
  SUM(B18),
  SUM(D18),
  SUM(F18),
  SUM(B19),
  SUM(D19),
  SUM(F19),
  SUM(B20),
  SUM(D20),
  SUM(F20),
  SUM(B22),
  SUM(B23),
  SUM(B24),
  SUM(B25),
  SUM(B28),
  SUM(C28),
  SUM(D28),
  SUM(F28),
  SUM(G28),
  SUM(B29),
  SUM(C29),
  SUM(D29),
  SUM(F29),
  SUM(G29),
  SUM(B30),
  SUM(C30),
  SUM(D30),
  SUM(F30),
  SUM(G30),
  SUM(B31),
  SUM(C31),
  SUM(D31),
  SUM(F31),
  SUM(G31),
  SUM(B34),
  SUM(C34),
  SUM(D34),
  SUM(F34),
  SUM(G34),
  SUM(B35),
  SUM(C35),
  SUM(D35),
  SUM(F35),
  SUM(G35),
  SUM(B36),
  SUM(C36),
  SUM(D36),
  SUM(F36),
  SUM(G36),
  SUM(B37),
  SUM(C37),
  SUM(D37),
  SUM(F37),
  SUM(G37),
  substrb(catstr(A39),1,255)


      from T_CSRC1219_C14_5
     where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) group by bbq;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120300
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120300(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;
begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1120300;

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC1219_C14_6
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC1219_C14_6
     (BBQ,
      USERID,
      BTYPE,
      OPTION1,
      SHTAG,
    B3      ,
  C3      ,
  D3      ,
  E3      ,
  F3      ,
  G3      ,
  B4      ,
  C4      ,
  D4      ,
  E4      ,
  F4      ,
  G4      ,
  B7      ,
  C7      ,
  D7      ,
  E7      ,
  F7      ,
  G7      ,
  B9      ,
  D9      ,
  F9      ,
  B12     ,
  C12     ,
  D12     ,
  F12     ,
  G12     ,
  B13     ,
  C13     ,
  D13     ,
  F13     ,
  G13     ,
  B14     ,
  C14     ,
  D14     ,
  F14     ,
  G14     ,
  B15     ,
  C15     ,
  D15     ,
  F15     ,
  G15     ,
  B16     ,
  C16     ,
  D16     ,
  F16     ,
  G16     ,
  B17     ,
  C17     ,
  D17     ,
  F17     ,
  G17     ,
  B19     ,
  D19     ,
  F19     ,
  B20     ,
  D20     ,
  F20     ,
  B21     ,
  D21     ,
  F21     ,
  B22     ,
  D22     ,
  F22     ,
  B24     ,
  B25     ,
  B26     ,
  B27     ,
  B30     ,
  C30     ,
  D30     ,
  F30     ,
  G30     ,
  B31     ,
  C31     ,
  D31     ,
  F31     ,
  G31     ,
  B32     ,
  C32     ,
  D32     ,
  F32     ,
  G32     ,
  B33     ,
  C33     ,
  D33     ,
  F33     ,
  G33     ,
  B36     ,
  C36     ,
  D36     ,
  F36     ,
  G36     ,
  B37     ,
  C37     ,
  D37     ,
  F37     ,
  G37     ,
  B38     ,
  C38     ,
  D38     ,
  F38     ,
  G38     ,
  B39     ,
  C39     ,
  D39     ,
  F39     ,
  G39     ,
  B42     ,
  C42     ,
  D42     ,
  F42     ,
  G42     ,
  B43     ,
  C43     ,
  D43     ,
  F43     ,
  G43     ,
  B44     ,
  C44     ,
  D44     ,
  F44     ,
  G44     ,
  A46
            )
    select
    BBQ,
    v_USER,
    0,
      null,
      0,
        SUM(B3 ),
  SUM(C3 ),
  SUM(D3 ),
  SUM(E3 ),
  SUM(F3 ),
  SUM(G3 ),
  SUM(B4 ),
  SUM(C4 ),
  SUM(D4 ),
  SUM(E4 ),
  SUM(F4 ),
  SUM(G4 ),
  SUM(B7 ),
  SUM(C7 ),
  SUM(D7 ),
  SUM(E7 ),
  SUM(F7 ),
  SUM(G7 ),
  SUM(B9 ),
  SUM(D9 ),
  SUM(F9 ),
  SUM(B12),
  SUM(C12),
  SUM(D12),
  SUM(F12),
  SUM(G12),
  SUM(B13),
  SUM(C13),
  SUM(D13),
  SUM(F13),
  SUM(G13),
  SUM(B14),
  SUM(C14),
  SUM(D14),
  SUM(F14),
  SUM(G14),
  SUM(B15),
  SUM(C15),
  SUM(D15),
  SUM(F15),
  SUM(G15),
  SUM(B16),
  SUM(C16),
  SUM(D16),
  SUM(F16),
  SUM(G16),
  SUM(B17),
  SUM(C17),
  SUM(D17),
  SUM(F17),
  SUM(G17),
  SUM(B19),
  SUM(D19),
  SUM(F19),
  SUM(B20),
  SUM(D20),
  SUM(F20),
  SUM(B21),
  SUM(D21),
  SUM(F21),
  SUM(B22),
  SUM(D22),
  SUM(F22),
  SUM(B24),
  SUM(B25),
  SUM(B26),
  SUM(B27),
  SUM(B30),
  SUM(C30),
  SUM(D30),
  SUM(F30),
  SUM(G30),
  SUM(B31),
  SUM(C31),
  SUM(D31),
  SUM(F31),
  SUM(G31),
  SUM(B32),
  SUM(C32),
  SUM(D32),
  SUM(F32),
  SUM(G32),
  SUM(B33),
  SUM(C33),
  SUM(D33),
  SUM(F33),
  SUM(G33),
  SUM(B36),
  SUM(C36),
  SUM(D36),
  SUM(F36),
  SUM(G36),
  SUM(B37),
  SUM(C37),
  SUM(D37),
  SUM(F37),
  SUM(G37),
  SUM(B38),
  SUM(C38),
  SUM(D38),
  SUM(F38),
  SUM(G38),
  SUM(B39),
  SUM(C39),
  SUM(D39),
  SUM(F39),
  SUM(G39),
  SUM(B42),
  SUM(C42),
  SUM(D42),
  SUM(F42),
  SUM(G42),
  SUM(B43),
  SUM(C43),
  SUM(D43),
  SUM(F43),
  SUM(G43),
  SUM(B44),
  SUM(C44),
  SUM(D44),
  SUM(F44),
  SUM(G44),
  substrb(catstr(A46),1,255)
      from T_CSRC1219_C14_6
    where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) group by bbq;

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120310
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120310(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_reportid number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       v_reportid := 1120310;

       select T2.A002 into v_USER
         from KRCS.T_SYS_USER T1,
              KRCS.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

         --õ˻
         select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
         select count(*) into v_count
           from krcs.t_sys_t024
           where a011=1009002
             and p001=v_reportid
             and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
         if v_count > 0  then
            errcode:=0;
            errmsg:=v_temp||'δͨ,ϲδ';
            return;
         end if;

       delete from t_csrc1219_c14_7 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc1219_c14_7(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG  ,
            ISHJ   ,
            A2     ,
            B2     ,
            C2    ,
            D2    ,
            E2   ,
            F2     ,
            G2    ,
            H2 ,
            I2     ,
            J2   ,
            K2,
            L2,
            M2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
            A2     ,
            B2     ,
            C2    ,
            D2    ,
            E2   ,
            F2     ,
            G2    ,
            H2 ,
            I2     ,
            J2  ,
            K2,
            L2,
            M2
        from t_csrc1219_c14_7
        where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) and ISHJ=0
        order by a2
        ;


    --ϼֵ
    insert into t_csrc1219_c14_7(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    F2,G2,H2,I2)
    select v_P001,v_USER,0,null,null,1,
    SUM(F2),SUM(G2),SUM(H2),SUM(I2)
      from t_csrc1219_c14_7
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,a020=v_KJAXUSER WHERE P001=v_reportid;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005|| A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=v_reportid and a008 =v_org;
                errcode := 0;
                errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1120320
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1120320(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_reportid number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       v_reportid := 1120320;

       select T2.A002 into v_USER
         from KRCS.T_SYS_USER T1,
              KRCS.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      --õ˻
         select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
         select count(*) into v_count
           from krcs.t_sys_t024
           where a011=1009002
             and p001=v_reportid
             and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
         if v_count > 0  then
            errcode:=0;
            errmsg:=v_temp||'δͨ,ϲδ';
            return;
         end if;

       delete from t_csrc1219_c14_8 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc1219_c14_8(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG  ,
            ISHJ   ,
            A2     ,
            B2     ,
            C2    ,
            D2    ,
            E2   ,
            F2     ,
            G2    ,
            H2 ,
            I2     ,
            J2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
            A2     ,
            B2     ,
            C2    ,
            D2    ,
            E2   ,
            F2     ,
            G2    ,
            H2 ,
            I2     ,
            J2
        from t_csrc1219_c14_8
        where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) and ISHJ=0
        order by a2
        ;


    --ϼֵ
    insert into t_csrc1219_c14_8(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    G2,H2,I2,J2)
    select v_P001,v_USER,0,null,null,1,
   SUM(G2),SUM(H2),SUM(I2),SUM(J2)
      from t_csrc1219_c14_8
     where BBQ = v_P001 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) and ISHJ=0;


    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,a020=v_KJAXUSER WHERE P001=v_reportid;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>'||A005|| A004||'</font>' INTO v_temp FROM KRCS.T_SYS_T004 WHERE P001 = v_reportid;
    INSERT INTO KRCS.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update KRCS.T_SYS_T014 SET A010=1015002 WHERE P001=v_reportid and a008 =v_org;
                errcode := 0;
                errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125010(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_KJAXUSER varchar2,
						  v_TASK varchar2,
                                                  v_P001     varchar2,
                                                  v_P002     varchar2,
                                                  v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;
begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

     select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from krcs.t_sys_t024
   where a011 = 1009002
     and p001 = 1125010
     and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'ɶδͨ,ϲδ';
    return;
  end if;

  delete from t_csrc0707_D1_1_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into t_csrc0707_D1_1_1
    (BBQ,
     USERID,
     BTYPE,
     OPTION1,
     SHTAG,
     ishj,
     A2,
     B2,
     C2,
     D2,
     E2,
     F2,
     G2,
     H2,
     I2,
     J2)
    select BBQ,
           v_USER,
           BTYPE,
           OPTION1,
           SHTAG,
           ishj,
           A2,
           B2,
           C2,
           D2,
           E2,
           F2,
           G2,
           H2,
           I2,
           J2
      from t_csrc0707_D1_1_1
     where BBQ = v_P001
       and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update krcs.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1125010 and a008=v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>D1-1-1' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1125010 ;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1125010 and a008=v_org;
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1125010!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125020(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	 select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125020
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʵʿ˱δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D1_1_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D1_1_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3,
            J3
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3,
            J3
        from t_csrc0707_D1_1_2
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125020 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D1-1-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125020;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125020 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125020!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125030
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ɶδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D1_1_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D1_1_3(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
        from t_csrc0707_D1_1_3
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125030 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D1-1-3'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125030 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125030 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125030!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125040
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='»Աδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D2_1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D2_1_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2
        from t_csrc0707_D2_1_1
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125040 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D2-1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125040;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125040 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125040!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125050
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125050(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125050
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='»鱨δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D2_1_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D2_1_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
        from t_csrc0707_D2_1_2
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        order by B2 asc;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125050 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D2-1-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125050;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125050 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125050!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125060
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125060(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125060
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='רҵίԱᱨδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D2_1_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D2_1_3(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2
        from t_csrc0707_D2_1_3
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125060 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D2-1-3'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125060 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125060 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125060!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125070
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125070(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125070
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='»Աδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D2_1_4 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D2_1_4(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
        from t_csrc0707_D2_1_4
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125070 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D2-1-4'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125070  ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125070 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125070!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125080
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125080(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125080
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='»鱨δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D2_1_5 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D2_1_5(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
        from t_csrc0707_D2_1_5
        where BBQ = v_P001
        and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125080 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D2-1-5'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125080 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125080 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125080!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125090
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125090(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125090
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='˾߹Աδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D2_1_6 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D2_1_6(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
        from t_csrc0707_D2_1_6
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125090 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D2-1-6'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125090;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125090 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125090!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125100
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125100(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125100
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='нδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D2_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D2_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            B2,
            C2,
            D2,
            E2,
            F2,
            B3,
            C3,
            D3,
            E3,
            F3,
            B4,
            C4,
            D4,
            E4,
            F4,
            B5,
            C5,
            D5,
            E5,
            F5,
            B6,
            C6,
            D6,
            E6,
            F6
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            B2,
            C2,
            D2,
            E2,
            F2,
            B3,
            C3,
            D3,
            E3,
            F3,
            B4,
            C4,
            D4,
            E4,
            F4,
            B5,
            C5,
            D5,
            E5,
            F5,
            B6,
            C6,
            D6,
            E6,
            F6
        from t_csrc0707_D2_2
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125100 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D2-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125100 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125100 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125100!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125110
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125110(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125110
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ܲרҵίԱᱨδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D3_1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D3_1_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
        from t_csrc0707_D3_1_1
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125110 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D3-1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125110 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125110 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125110!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125120
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125120(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125120
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ҵñδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D3_1_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D3_1_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
        from t_csrc0707_D3_1_2
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125120 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D3-1-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125120;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125120 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125120!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125130
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125130(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125130
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='㡢ܡITñδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D3_1_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D3_1_3(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
        from t_csrc0707_D3_1_3
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125130 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D3-1-3'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125130  ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125130 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125130!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125140
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125140(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125140
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='աˡϹ沿ñδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D3_1_4 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D3_1_4(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2
        from t_csrc0707_D3_1_4
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125140 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D3-1-4'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125140;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125140 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125140!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125150
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125150(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125150
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ֹ˾δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D4_1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D4_1_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3,
            J3
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3,
            J3
        from t_csrc0707_D4_1_1
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125150 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D4-1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125150 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125150 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125150!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125160
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125160(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125160
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ܲδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D4_1_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D4_1_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3,
            J3
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            H3,
            I3,
            J3
        from t_csrc0707_D4_1_2
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125160 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D4-1-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125160 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125160 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125160!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125170
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125170(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125170
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ӹ˾δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D5_1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D5_1_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3
        from t_csrc0707_D5_1_1
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125170 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D5-1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125170 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125170 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125170!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125180
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125180(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125180
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ӪӪ˾δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D5_1_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D5_1_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A3,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3
        from t_csrc0707_D5_1_2
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125180 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D5-1-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125180;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125180 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125180!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125190
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125190(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125190
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D5_1_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D5_1_3(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2
        from t_csrc0707_D5_1_3
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125190 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D5-1-3'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125190;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125190 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125190!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125200
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125200(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125200
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ڲ˼δͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D6_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D6_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
        from t_csrc0707_D6_1
        where BBQ = v_P001
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125200 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D6-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125200;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125200 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125200!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1125210
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1125210(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1125210
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʦƸδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_D7_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_D7_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            B4,
            C4,
            D4,
            E4,
            F4,
            G4,
            B5,
            C5,
            D5,
            E5,
            F5,
            G5,
            B6,
            C6,
            D6,
            E6,
            F6,
            G6
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            B3,
            C3,
            D3,
            E3,
            F3,
            G3,
            B4,
            C4,
            D4,
            E4,
            F4,
            G4,
            B5,
            C5,
            D5,
            E5,
            F5,
            G5,
            B6,
            C6,
            D6,
            E6,
            F6,
            G6

        from t_csrc0707_D7_1
        where BBQ = v_P001
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1125210 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>D7-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1125210;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1125210 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1125210!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130010(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130010
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='Ŀϸרܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_e1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

    insert into t_csrc0707_e1_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2,
            J2
          )
   select a.bbq,
          v_USER,
          a.BTYPE,
          a.OPTION1,
          a.SHTAG,
          a.ishj,
          rownum as a2,
            a.B2,
            a.C2,
            a.D2,
            a.E2,
            a.F2,
            a.G2,
            a.H2,
            a.I2,
            a.J2
   from (
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2,
            J2
        from t_csrc0707_e1_1
        where BBQ = v_P001
        and ishj = 0
         and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        order  by b2
        ) a;

        --ϼ
        insert into t_csrc0707_e1_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2,
            J2
          )
         select BBQ     ,
                v_USER  ,
                0   ,
                null ,
                0   ,
                1    ,
                null,
                null,
                null,
                null,
                null,
                sum(F2),
                sum(G2),
                null,
                sum(I2),
                null
           from t_csrc0707_e1_1
        where BBQ = v_P001
        and ishj = 0
        and userid = v_USER
        group by bbq;



    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130010 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-1'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130010 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130010 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130010!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130020(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_user integer;
       v_org number;
       v_sql  varchar(4000);                --SQL

      /*****************************************************************************************************************************************/
      /* 洢 cisp_convert_dt_6001 Ӧδ߼ͬģֻ߶ˣ  w100 = v_bmid                                          */
      /* ⣬200812·ݹ̶沿ֹ¼Ϊֱӵ벿űΪĸĶǽеt_db_04_002_02_02Ϊ v_db_04_002_02_02,      */
      /*                                                                                   еt_db_04_002_02_01Ϊ v_db_04_002_02_01 */
      /* 漰 v_db_04_002_02_02 ĵطЩĶЩĶĵط cisp_convert_dt_6001 ӦЩ!!!                        */
      /*****************************************************************************************************************************************/

      /**********************************Ҫ ֲ  ************************************/


      v_zqdm                                varchar(16);                      --֤ȯ
      v_zqmc                                varchar(256);                    --֤ȯ
      v_qmzmcb                              number(20,2);                    --ĩɱ
      v_qmzmcb_sum                          number(20,2);                    --ĩɱ()
      v_qmzmcb_q5m_sum                      number(20,2);                    --ĩɱ(ǰ5)
      v_qmzmgyjz                            number(20,2);                    --ĩ湫ʼֵ
      v_qmzmgyjz_sum                        number(20,2);                    --ĩ湫ʼֵ()
      v_qmzmgyjz_q5m_sum                    number(20,2);                    --ĩ湫ʼֵ(ǰ5)
      v_qmsz                                number(20,2);                    --ĩֵ
      v_qmsz_sum                            number(20,2);                    --ĩֵ()
      v_qmsz_q5m_sum                        number(20,2);                    --ĩֵ(ǰ5)
      v_qmcysl                              number(20,2);                    --ĩ
      v_qmcysl_q5m_sum                      number(20,2);                    --ĩ(ǰ5)
      v_qmcybl                              number(20,2);                    --ĩб
      v_row                                 number;
      v_count                               number;
      /************************************************************************************************/




      --õƱĩֱֲǰ5          ע⽫ͬͨƱͷͨƱΪһ¼
      cursor cur_gp is
      select *
            from (
                   select zqdm,min(zqmc) as zqmc, sum(nvl(qmcys,0)) as qmcys,sum(nvl(qmcybl,0)) as qmcybl,sum(nvl(qmzmcb,0)) as qmzmcb,
                   sum(nvl(qmgyjz,0)) as qmgyjz,sum(nvl(qmsz,0)) as qmsz
                     from (
                            select userid as bmid, b4 as zqmc, c4 as zqdm, d4 as qmcys,e4 as qmcybl,f4 as qmzmcb,g4 as qmgyjz,h4 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c4 is not null
                            union all
                            select userid as bmid, b5 as zqmc, c5 as zqdm, d5 as qmcys,e5 as qmcybl,f5 as qmzmcb,g5 as qmgyjz,h5 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c5 is not null
                            union all
                            select userid as bmid, b6 as zqmc, c6 as zqdm, d6 as qmcys,e6 as qmcybl,f6 as qmzmcb,g6 as qmgyjz,h6 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c6 is not null
                            union all
                            select userid as bmid, b7 as zqmc, c7 as zqdm, d7 as qmcys,e7 as qmcybl,f7 as qmzmcb,g7 as qmgyjz,h7 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c7 is not null
                            union all
                            select userid as bmid, b8 as zqmc, c8 as zqdm, d8 as qmcys,e8 as qmcybl,f8 as qmzmcb,g8 as qmgyjz,h8 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c8 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)

                    group by zqdm
                    order by qmcybl desc
                 )
           where rownum <= 5;

      --õĩɱĩֱֲǰ5
      cursor cur_jj is
      select * from (
      select *
            from (
                   select zqdm,min(zqmc) as zqmc, sum(nvl(qmcys,0)) as qmcys,sum(nvl(qmcybl,0)) as qmcybl,sum(nvl(qmzmcb,0)) as qmzmcb,
                   sum(nvl(qmgyjz,0)) as qmgyjz,sum(nvl(qmsz,0)) as qmsz
                     from (
                            select userid as bmid, b11 as zqmc, c11 as zqdm, d11 as qmcys,e11 as qmcybl,f11 as qmzmcb,g11 as qmgyjz,h11 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c11 is not null
                            union all
                            select userid as bmid, b12 as zqmc, c12 as zqdm, d12 as qmcys,e12 as qmcybl,f12 as qmzmcb,g12 as qmgyjz,h12 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c12 is not null
                            union all
                            select userid as bmid, b13 as zqmc, c13 as zqdm, d13 as qmcys,e13 as qmcybl,f13 as qmzmcb,g13 as qmgyjz,h13 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c13 is not null
                            union all
                            select userid as bmid, b14 as zqmc, c14 as zqdm, d14 as qmcys,e14 as qmcybl,f14 as qmzmcb,g14 as qmgyjz,h14 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c14 is not null
                            union all
                            select userid as bmid, b15 as zqmc, c15 as zqdm, d15 as qmcys,e15 as qmcybl,f15 as qmzmcb,g15 as qmgyjz,h15 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c15 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    group by zqdm
                    order by qmzmcb desc
                 )
           where rownum <= 5
      )
      order by qmcybl desc;

      --õծȯĩɱĩֱֲǰ5
      cursor cur_zq is
      select * from (
      select *
            from (
                   select zqdm,min(zqmc) as zqmc, sum(nvl(qmcys,0)) as qmcys,sum(nvl(qmcybl,0)) as qmcybl,sum(nvl(qmzmcb,0)) as qmzmcb,
                   sum(nvl(qmgyjz,0)) as qmgyjz,sum(nvl(qmsz,0)) as qmsz
                     from (
                            select userid as bmid, b18 as zqmc, c18 as zqdm, d18 as qmcys,e18 as qmcybl,f18 as qmzmcb,g18 as qmgyjz,h18 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c18 is not null
                            union all
                            select userid as bmid, b19 as zqmc, c19 as zqdm, d19 as qmcys,e19 as qmcybl,f19 as qmzmcb,g19 as qmgyjz,h19 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c19 is not null
                            union all
                            select userid as bmid, b20 as zqmc, c20 as zqdm, d20 as qmcys,e20 as qmcybl,f20 as qmzmcb,g20 as qmgyjz,h20 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c20 is not null
                            union all
                            select userid as bmid, b21 as zqmc, c21 as zqdm, d21 as qmcys,e21 as qmcybl,f21 as qmzmcb,g21 as qmgyjz,h21 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c21 is not null
                            union all
                            select userid as bmid, b22 as zqmc, c22 as zqdm, d22 as qmcys,e22 as qmcybl,f22 as qmzmcb,g22 as qmgyjz,h22 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c22 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    group by zqdm
                    order by qmzmcb desc
                 )
           where rownum <= 5
      )
      order by qmcybl desc;

      --õȨ֤ĩɱĩֱֲǰ5
      cursor cur_qz is
      select * from (
      select *
            from (
                   select zqdm,min(zqmc) as zqmc, sum(nvl(qmcys,0)) as qmcys,sum(nvl(qmcybl,0)) as qmcybl,sum(nvl(qmzmcb,0)) as qmzmcb,
                   sum(nvl(qmgyjz,0)) as qmgyjz,sum(nvl(qmsz,0)) as qmsz
                     from (
                            select userid as bmid, b25 as zqmc, c25 as zqdm, d25 as qmcys,e25 as qmcybl,f25 as qmzmcb,g25 as qmgyjz,h25 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c25 is not null
                            union all
                            select userid as bmid, b26 as zqmc, c26 as zqdm, d26 as qmcys,e26 as qmcybl,f26 as qmzmcb,g26 as qmgyjz,h26 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c26 is not null
                            union all
                            select userid as bmid, b27 as zqmc, c27 as zqdm, d27 as qmcys,e27 as qmcybl,f27 as qmzmcb,g27 as qmgyjz,h27 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c27 is not null
                            union all
                            select userid as bmid, b28 as zqmc, c28 as zqdm, d28 as qmcys,e28 as qmcybl,f28 as qmzmcb,g28 as qmgyjz,h28 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c28 is not null
                            union all
                            select userid as bmid, b29 as zqmc, c29 as zqdm, d29 as qmcys,e29 as qmcybl,f29 as qmzmcb,g29 as qmgyjz,h29 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 and c29 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    group by zqdm
                    order by qmzmcb desc
                 )
           where rownum <= 5
      )
      order by qmcybl desc;

      --ծȯ֤ȯɱǰ
      cursor cur_other is
      select * from (
      select *
            from (
                   select zqdm,min(zqmc) as zqmc, sum(nvl(qmcys,0)) as qmcys,sum(nvl(qmcybl,0)) as qmcybl,sum(nvl(qmzmcb,0)) as qmzmcb,
                   sum(nvl(qmgyjz,0)) as qmgyjz,sum(nvl(qmsz,0)) as qmsz
                     from (
                            select userid as bmid, b32 as zqmc, c32 as zqdm, d32 as qmcys,e32 as qmcybl,f32 as qmzmcb,g32 as qmgyjz,h32 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 --and c32 is not null
                            union all
                            select userid as bmid, b33 as zqmc, c33 as zqdm, d33 as qmcys,e33 as qmcybl,f33 as qmzmcb,g33 as qmgyjz,h33 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 --and c33 is not null
                            union all
                            select userid as bmid, b34 as zqmc, c34 as zqdm, d34 as qmcys,e34 as qmcybl,f34 as qmzmcb,g34 as qmgyjz,h34 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 --and c34 is not null
                            union all
                            select userid as bmid, b35 as zqmc, c35 as zqdm, d35 as qmcys,e35 as qmcybl,f35 as qmzmcb,g35 as qmgyjz,h35 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 --and c35 is not null
                            union all
                            select userid as bmid, b36 as zqmc, c36 as zqdm, d36 as qmcys,e36 as qmcybl,f36 as qmzmcb,g36 as qmgyjz,h36 as qmsz from T_CSRC0707_E1_2 where bbq = v_p001 --and c36 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    group by zqdm
                    order by qmzmcb desc
                 )
           where rownum <= 5
           )
            order by qmcybl desc;


    /**********************************************************************************************/

begin
      errcode := 1;
      errmsg  := 'ϲɹ';


      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130020 and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;
      if v_count > 0  then
       errcode:=0;
       errmsg:='֤ȯͶҵֲרܱδͨ,ϲδ';
       return;
      end if;


      select T2.A002 into v_user
        from krcs.T_SYS_USER T1,
             krcs.T_CTL_T036 T2
       where T1.P001 = v_KJAXUSER
         and T1.P002 = T2.P001;

      delete from T_CSRC0707_E1_2 WHERE BBQ=v_p001 and USERID=v_user;  /* ɾͬһڵ */

      --Ȳһؼּ¼
      insert into T_CSRC0707_E1_2( BBQ, userid, btype, option1, shtag ) values( v_p001, v_user, 0, null, null );


       ---------------------------------------------------------------------------
    ----------------------------Ʊֲϸ-------------------------------
    ---------------------------------------------------------------------------

    --ȡͷйƱĩɱʼֵĩֵܺ
    update t_csrc0707_e1_2 set F3=(select sum(nvl(F3,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101) )
    where BBQ=v_p001 and userid = v_user;--ĩɱ
    update t_csrc0707_e1_2 set G3=(select sum(nvl(G3,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩ湫ʼֵ
    update t_csrc0707_e1_2 set H3=(select sum(nvl(H3,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩֵ


    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --Ʊճбǰ5Ʊѭα
    v_row := 4;
    open cur_gp;
    fetch cur_gp into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_gp%found
    loop
          if substr(v_zqdm,1,2) in ('sh','sz','yh') then
             v_zqdm := substr(v_zqdm,3);
          end if;
          --֤ȯǰshszyhȥ
          v_sql := 'update T_CSRC0707_E1_2 set '
                 ||'B'||v_row||'='''||v_zqmc||''','
                 ||'C'||v_row||'='''||v_zqdm||''','
                 ||'D'||v_row||'='||v_qmcysl||','
                 ||'E'||v_row||'='||v_qmcybl||','
                 ||'F'||v_row||'='||v_qmzmcb||','
                 ||'G'||v_row||'='||v_qmzmgyjz||','
                 ||'H'||v_row||'='||v_qmsz||' '
                 ||'where BBQ='''||v_p001||''' and USERID='||v_user;
          execute immediate v_sql;



          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_gp into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_gp;

    --õձǰ5ĩܺ
    update t_csrc0707_e1_2 set D3=v_qmcysl_q5m_sum where BBQ=v_p001 and USERID=v_user;

     --õ5
    update t_csrc0707_e1_2 set F9=f3 - v_qmzmcb_q5m_sum     where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set G9=g3 - v_qmzmgyjz_q5m_sum where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set H9=h3 - v_qmsz_q5m_sum         where BBQ=v_p001 and USERID=v_user;

    ----------------------------------------------------------------------------
    ------------------------------Ʊ----------------------------------
    ----------------------------------------------------------------------------

 /****************************************************************************************************/

    ---------------------------------------------------------------------------
    ----------------------------ֲϸ-------------------------------
    ---------------------------------------------------------------------------

    --ȡͷлĩɱʼֵĩֵܺ
    update t_csrc0707_e1_2 set F10=(select sum(nvl(F10,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩɱ
    update t_csrc0707_e1_2 set G10=(select sum(nvl(G10,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩ湫ʼֵ
    update t_csrc0707_e1_2 set H10=(select sum(nvl(H10,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩֵ


    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --ճбǰ5Ʊѭα
    v_row := 11;
    open cur_jj;
    fetch cur_jj into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_jj%found
    loop
          if substr(v_zqdm,1,2) in ('sh','sz','yh') then
             v_zqdm := substr(v_zqdm,3);
          end if;
          v_sql := 'update T_CSRC0707_E1_2 set '
                 ||'B'||v_row||'='''||v_zqmc||''','
                 ||'C'||v_row||'='''||v_zqdm||''','
                 ||'D'||v_row||'='||v_qmcysl||','
                 ||'E'||v_row||'='||v_qmcybl||','
                 ||'F'||v_row||'='||v_qmzmcb||','
                 ||'G'||v_row||'='||v_qmzmgyjz||','
                 ||'H'||v_row||'='||v_qmsz||' '
                 ||'where BBQ='''||v_p001||''' and USERID='||v_user;
          execute immediate v_sql;

          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_jj into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_jj;


    --õձǰ5ĩܺ
    update t_csrc0707_e1_2 set D10=v_qmcysl_q5m_sum where BBQ=v_p001 and USERID=v_user;

    --õ5
    update t_csrc0707_e1_2 set F16=f10 - v_qmzmcb_q5m_sum     where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set G16=g10 - v_qmzmgyjz_q5m_sum where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set H16=h10 - v_qmsz_q5m_sum         where BBQ=v_p001 and USERID=v_user;


    ----------------------------------------------------------------------------
    ----------------------------------------------------------------
    ----------------------------------------------------------------------------

  /************************************************************************************************/

  ---------------------------------------------------------------------------
    ----------------------------ծȯֲϸ-------------------------------
    ---------------------------------------------------------------------------

    --ȡͷծȯĩɱʼֵĩֵܺ
    update t_csrc0707_e1_2 set F17=(select sum(nvl(F17,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩɱ
    update t_csrc0707_e1_2 set G17=(select sum(nvl(G17,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩ湫ʼֵ
    update t_csrc0707_e1_2 set H17=(select sum(nvl(H17,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩֵ


    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --ծȯճбǰ5Ʊѭα
    v_row := 18;
    open cur_zq;
    fetch cur_zq into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_zq%found
    loop
          if substr(v_zqdm,1,2) in ('sh','sz','yh') then
             v_zqdm := substr(v_zqdm,3);
          end if;
          v_sql := 'update T_CSRC0707_E1_2 set '
                 ||'B'||v_row||'='''||v_zqmc||''','
                 ||'C'||v_row||'='''||v_zqdm||''','
                 ||'D'||v_row||'='||v_qmcysl||','
                 ||'E'||v_row||'='||v_qmcybl||','
                 ||'F'||v_row||'='||v_qmzmcb||','
                 ||'G'||v_row||'='||v_qmzmgyjz||','
                 ||'H'||v_row||'='||v_qmsz||' '
                 ||'where BBQ='''||v_p001||''' and USERID='||v_user;
          execute immediate v_sql;

          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_zq into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_zq;

    --õձǰ5ĩܺͣĩɱĩʼֵĩֵܺ
    update t_csrc0707_e1_2 set D17=v_qmcysl_q5m_sum where BBQ=v_p001 and USERID=v_user;

    --õ5
    update t_csrc0707_e1_2 set F23=f17 - v_qmzmcb_q5m_sum     where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set G23=g17 - v_qmzmgyjz_q5m_sum where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set H23=h17 - v_qmsz_q5m_sum         where BBQ=v_p001 and USERID=v_user;


    ----------------------------------------------------------------------------
    ------------------------------ծȯ----------------------------------
    ----------------------------------------------------------------------------

/*****************************************************************************************************************************/

   ---------------------------------------------------------------------------
    ----------------------------Ȩֲ֤ϸ-------------------------------
    ---------------------------------------------------------------------------
    --ȡͷȨ֤ĩɱʼֵĩֵܺ
    update t_csrc0707_e1_2 set F24=(select sum(nvl(F24,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩɱ
    update t_csrc0707_e1_2 set G24=(select sum(nvl(G24,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩ湫ʼֵ
    update t_csrc0707_e1_2 set H24=(select sum(nvl(H24,0)) from t_csrc0707_e1_2 where BBQ=v_p001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101))
    where BBQ=v_p001 and userid = v_user;--ĩֵ

    v_qmcysl_q5m_sum :=0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    --Ȩ֤ճбǰ5Ʊѭα
    v_row := 25;
    open cur_qz;
    fetch cur_qz into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_qz%found
    loop
          if substr(v_zqdm,1,2) in ('sh','sz','yh') then
             v_zqdm := substr(v_zqdm,3);
          end if;
          v_sql := 'update T_CSRC0707_E1_2 set '
                 ||'B'||v_row||'='''||v_zqmc||''','
                 ||'C'||v_row||'='''||v_zqdm||''','
                 ||'D'||v_row||'='||v_qmcysl||','
                 ||'E'||v_row||'='||v_qmcybl||','
                 ||'F'||v_row||'='||v_qmzmcb||','
                 ||'G'||v_row||'='||v_qmzmgyjz||','
                 ||'H'||v_row||'='||v_qmsz||' '
                 ||'where BBQ='''||v_p001||''' and USERID='||v_user;
          execute immediate v_sql;

          v_row := v_row + 1;

          v_qmcysl_q5m_sum :=v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum :=v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum :=v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum :=v_qmsz_q5m_sum + v_qmsz;

          fetch cur_qz into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_qz;


    --õձǰ5ĩܺͣȨ֤ĩɱĩʼֵĩֵܺ
    update t_csrc0707_e1_2 set D24=v_qmcysl_q5m_sum where BBQ=v_p001 and USERID=v_user;

    --õ5
    update t_csrc0707_e1_2 set F30=f24 - v_qmzmcb_q5m_sum     where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set G30=g24 - v_qmzmgyjz_q5m_sum where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set H30=h24 - v_qmsz_q5m_sum         where BBQ=v_p001 and USERID=v_user;


    ----------------------------------------------------------------------------
    ------------------------------Ȩ֤----------------------------------
    ----------------------------------------------------------------------------
/*************************************************************************************************************************/

---------------------------------------------------------------------------
    ----------------------------ծȯɱǰ5ϸ--------------------------
    ---------------------------------------------------------------------------

    v_qmcysl_q5m_sum := 0;
    v_qmzmcb_q5m_sum :=0;
    v_qmzmgyjz_q5m_sum :=0;
    v_qmsz_q5m_sum :=0;

    v_row := 32;
    open cur_other;
    fetch cur_other into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    while cur_other%found
    loop
          if substr(v_zqdm,1,2) in ('sh','sz','yh') then
             v_zqdm := substr(v_zqdm,3);
          end if;
          v_sql := 'update T_CSRC0707_E1_2 set '
                 ||'B'||v_row||'='''||v_zqmc||''','
                 ||'C'||v_row||'='''||v_zqdm||''','
                 ||'D'||v_row||'='||v_qmcysl||','
                 ||'E'||v_row||'='||v_qmcybl||','
                 ||'F'||v_row||'='||v_qmzmcb||','
                 ||'G'||v_row||'='||v_qmzmgyjz||','
                 ||'H'||v_row||'='||v_qmsz||' '
                 ||'where BBQ='''||v_p001||''' and USERID='||v_user;
          execute immediate v_sql;

          v_qmcysl_q5m_sum := v_qmcysl_q5m_sum + v_qmcysl;
          v_qmzmcb_q5m_sum := v_qmzmcb_q5m_sum + v_qmzmcb;
          v_qmzmgyjz_q5m_sum := v_qmzmgyjz_q5m_sum + v_qmzmgyjz;
          v_qmsz_q5m_sum := v_qmsz_q5m_sum + v_qmsz;
          v_row := v_row + 1;
          fetch cur_other into v_zqdm,v_zqmc,v_qmcysl,v_qmcybl,v_qmzmcb,v_qmzmgyjz,v_qmsz;
    end loop;
    close cur_other;


    update t_csrc0707_e1_2 set D31=v_qmcysl_q5m_sum   where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set F31=v_qmzmcb_q5m_sum   where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set G31=v_qmzmgyjz_q5m_sum where BBQ=v_p001 and USERID=v_user;
    update t_csrc0707_e1_2 set H31=v_qmsz_q5m_sum     where BBQ=v_p001 and USERID=v_user;

    ----------------------------------------------------------------------------
    ----------------------------ծȯǰ5---------------------------
    ----------------------------------------------------------------------------


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130020 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-2'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130020;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130020 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130020!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2
)

is
      v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130030
         and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


      if v_count > 0  then
       errcode:=0;
       errmsg:='E1_3_1ʲҵͶʼʲüܱ--ҵ񱨱δͨ,ϲδ';
       return;
      end if;

      delete from T_CSRC0128_E1_3_1 WHERE BBQ=v_P001 and USERID=v_USER;

      insert into T_CSRC0128_E1_3_1(
                        BBQ    ,
      USERID ,
        BTYPE   ,
        OPTION1 ,
         SHTAG   ,
       C6      ,
      D6      ,
      E6      ,
      F6      ,
      G6      ,
      H6      ,
      I6      ,
      J6      ,
      K6      ,
      L6      ,
      M6      ,
      N6      ,
      O6      ,
      P6      ,
      Q6      ,
      R6      ,
      S6      ,
      T6      ,
      U6      ,
      V6      ,
      W6      ,
      X6      ,
      Y6      ,
      Z6      ,
      AA6     ,
      AB6     ,
      AC6     ,
      AD6     ,
      AE6     ,
      AF6     ,
      AG6     ,
      AH6     ,
      AI6     ,
      AJ6     ,
      AK6     ,
      AL6     ,
      AM6     ,
       C7      ,
      D7      ,
      E7      ,
      F7      ,
      G7      ,
      H7      ,
      I7      ,
      J7      ,
      K7      ,
      L7      ,
      M7      ,
      N7      ,
      O7      ,
      P7      ,
      Q7      ,
      R7      ,
      S7      ,
      T7      ,
      U7      ,
      V7      ,
      W7      ,
      X7      ,
      Y7      ,
      Z7      ,
      AA7     ,
      AB7     ,
      AC7     ,
      AD7     ,
      AE7     ,
      AF7     ,
      AG7     ,
      AH7     ,
      AI7     ,
      AJ7     ,
      AK7     ,
      AL7     ,
      AM7     ,
       C8      ,
      D8      ,
      E8      ,
      F8      ,
      G8      ,
      H8      ,
      I8      ,
      J8      ,
      K8      ,
      L8      ,
      M8      ,
      N8      ,
      O8      ,
      P8      ,
      Q8      ,
      R8      ,
      S8      ,
      T8      ,
      U8      ,
      V8      ,
      W8      ,
      X8      ,
      Y8      ,
      Z8      ,
      AA8     ,
      AB8     ,
      AC8     ,
      AD8     ,
      AE8     ,
      AF8     ,
      AG8     ,
      AH8     ,
      AI8     ,
      AJ8     ,
      AK8     ,
      AL8     ,
      AM8     ,
       C9      ,
      D9      ,
      E9      ,
      F9      ,
      G9      ,
      H9      ,
      I9      ,
      J9      ,
      K9      ,
      L9      ,
      M9      ,
      N9      ,
      O9      ,
      P9      ,
      Q9      ,
      R9      ,
      S9      ,
      T9      ,
      U9      ,
      V9      ,
      W9      ,
      X9      ,
      Y9      ,
      Z9      ,
      AA9     ,
      AB9     ,
      AC9     ,
      AD9     ,
      AE9     ,
      AF9     ,
      AG9     ,
      AH9     ,
      AI9     ,
      AJ9     ,
      AK9     ,
      AL9     ,
      AM9     ,
       C10      ,
      D10      ,
      E10      ,
      F10      ,
      G10      ,
      H10      ,
      I10      ,
      J10      ,
      K10      ,
      L10      ,
      M10      ,
      N10      ,
      O10      ,
      P10      ,
      Q10      ,
      R10      ,
      S10      ,
      T10      ,
      U10      ,
      V10      ,
      W10      ,
      X10      ,
      Y10      ,
      Z10      ,
      AA10     ,
      AB10     ,
      AC10     ,
      AD10     ,
      AE10     ,
      AF10     ,
      AG10     ,
      AH10     ,
      AI10     ,
      AJ10     ,
      AK10     ,
      AL10     ,
      AM10     ,
       C11      ,
      D11      ,
      E11      ,
      F11      ,
      G11      ,
      H11      ,
      I11      ,
      J11      ,
      K11      ,
      L11      ,
      M11      ,
      N11      ,
      O11      ,
      P11      ,
      Q11      ,
      R11      ,
      S11      ,
      T11      ,
      U11      ,
      V11      ,
      W11      ,
      X11      ,
      Y11      ,
      Z11      ,
      AA11     ,
      AB11     ,
      AC11     ,
      AD11     ,
      AE11     ,
      AF11     ,
      AG11     ,
      AH11     ,
      AI11     ,
      AJ11     ,
      AK11     ,
      AL11     ,
      AM11     ,
       C12      ,
      D12      ,
      E12      ,
      F12      ,
      G12      ,
      H12      ,
      I12      ,
      J12      ,
      K12      ,
      L12      ,
      M12      ,
      N12      ,
      O12      ,
      P12      ,
      Q12      ,
      R12      ,
      S12      ,
      T12      ,
      U12      ,
      V12      ,
      W12      ,
      X12      ,
      Y12      ,
      Z12      ,
      AA12     ,
      AB12     ,
      AC12     ,
      AD12     ,
      AE12     ,
      AF12     ,
      AG12     ,
      AH12     ,
      AI12     ,
      AJ12     ,
      AK12     ,
      AL12     ,
      AM12     ,
       C13      ,
      D13      ,
      E13      ,
      F13      ,
      G13      ,
      H13      ,
      I13      ,
      J13      ,
      K13      ,
      L13      ,
      M13      ,
      N13      ,
      O13      ,
      P13      ,
      Q13      ,
      R13      ,
      S13      ,
      T13      ,
      U13      ,
      V13      ,
      W13      ,
      X13      ,
      Y13      ,
      Z13      ,
      AA13     ,
      AB13     ,
      AC13     ,
      AD13     ,
      AE13     ,
      AF13     ,
      AG13     ,
      AH13     ,
      AI13     ,
      AJ13     ,
      AK13     ,
      AL13     ,
      AM13     ,
       C14      ,
      D14      ,
      E14      ,
      F14      ,
      G14      ,
      H14      ,
      I14      ,
      J14      ,
      K14      ,
      L14      ,
      M14      ,
      N14      ,
      O14      ,
      P14      ,
      Q14      ,
      R14      ,
      S14      ,
      T14      ,
      U14      ,
      V14      ,
      W14      ,
      X14      ,
      Y14      ,
      Z14      ,
      AA14     ,
      AB14     ,
      AC14     ,
      AD14     ,
      AE14     ,
      AF14     ,
      AG14     ,
      AH14     ,
      AI14     ,
      AJ14     ,
      AK14     ,
      AL14     ,
      AM14   ,
                    C15      ,
      D15      ,
      E15      ,
      F15      ,
      G15      ,
      H15      ,
      I15      ,
      J15      ,
      K15      ,
      L15      ,
      M15      ,
      N15      ,
      O15      ,
      P15      ,
      Q15      ,
      R15      ,
      S15      ,
      T15      ,
      U15      ,
      V15      ,
      W15      ,
      X15      ,
      Z15      ,
      AA15     ,
      AB15     ,
      AD15     ,
      AE15     ,
      AF15     ,
      AG15     ,
      AH15     ,
      AI15     ,
      AJ15     ,
      AK15     ,
      AL15     ,
      AM15
                    )
            select BBQ     ,
                    v_USER  ,
                    BTYPE   ,
                    OPTION1 ,
                    SHTAG   ,
                     C6      ,
      D6      ,
      E6      ,
      F6      ,
      G6      ,
      H6      ,
      I6      ,
      J6      ,
      K6      ,
      L6      ,
      M6      ,
      N6      ,
      O6      ,
      P6      ,
      Q6      ,
      R6      ,
      S6      ,
      T6      ,
      U6      ,
      V6      ,
      W6      ,
      X6      ,
      Y6      ,
      Z6      ,
      AA6     ,
      AB6     ,
      AC6     ,
      AD6     ,
      AE6     ,
      AF6     ,
      AG6     ,
      AH6     ,
      AI6     ,
      AJ6     ,
      AK6     ,
      AL6     ,
      AM6     ,
       C7      ,
      D7      ,
      E7      ,
      F7      ,
      G7      ,
      H7      ,
      I7      ,
      J7      ,
      K7      ,
      L7      ,
      M7      ,
      N7      ,
      O7      ,
      P7      ,
      Q7      ,
      R7      ,
      S7      ,
      T7      ,
      U7      ,
      V7      ,
      W7      ,
      X7      ,
      Y7      ,
      Z7      ,
      AA7     ,
      AB7     ,
      AC7     ,
      AD7     ,
      AE7     ,
      AF7     ,
      AG7     ,
      AH7     ,
      AI7     ,
      AJ7     ,
      AK7     ,
      AL7     ,
      AM7     ,
       C8      ,
      D8      ,
      E8      ,
      F8      ,
      G8      ,
      H8      ,
      I8      ,
      J8      ,
      K8      ,
      L8      ,
      M8      ,
      N8      ,
      O8      ,
      P8      ,
      Q8      ,
      R8      ,
      S8      ,
      T8      ,
      U8      ,
      V8      ,
      W8      ,
      X8      ,
      Y8      ,
      Z8      ,
      AA8     ,
      AB8     ,
      AC8     ,
      AD8     ,
      AE8     ,
      AF8     ,
      AG8     ,
      AH8     ,
      AI8     ,
      AJ8     ,
      AK8     ,
      AL8     ,
      AM8     ,
       C9      ,
      D9      ,
      E9      ,
      F9      ,
      G9      ,
      H9      ,
      I9      ,
      J9      ,
      K9      ,
      L9      ,
      M9      ,
      N9      ,
      O9      ,
      P9      ,
      Q9      ,
      R9      ,
      S9      ,
      T9      ,
      U9      ,
      V9      ,
      W9      ,
      X9      ,
      Y9      ,
      Z9      ,
      AA9     ,
      AB9     ,
      AC9     ,
      AD9     ,
      AE9     ,
      AF9     ,
      AG9     ,
      AH9     ,
      AI9     ,
      AJ9     ,
      AK9     ,
      AL9     ,
      AM9     ,
       C10      ,
      D10      ,
      E10      ,
      F10      ,
      G10      ,
      H10      ,
      I10      ,
      J10      ,
      K10      ,
      L10      ,
      M10      ,
      N10      ,
      O10      ,
      P10      ,
      Q10      ,
      R10      ,
      S10      ,
      T10      ,
      U10      ,
      V10      ,
      W10      ,
      X10      ,
      Y10      ,
      Z10      ,
      AA10     ,
      AB10     ,
      AC10     ,
      AD10     ,
      AE10     ,
      AF10     ,
      AG10     ,
      AH10     ,
      AI10     ,
      AJ10     ,
      AK10     ,
      AL10     ,
      AM10     ,
       C11      ,
      D11      ,
      E11      ,
      F11      ,
      G11      ,
      H11      ,
      I11      ,
      J11      ,
      K11      ,
      L11      ,
      M11      ,
      N11      ,
      O11      ,
      P11      ,
      Q11      ,
      R11      ,
      S11      ,
      T11      ,
      U11      ,
      V11      ,
      W11      ,
      X11      ,
      Y11      ,
      Z11      ,
      AA11     ,
      AB11     ,
      AC11     ,
      AD11     ,
      AE11     ,
      AF11     ,
      AG11     ,
      AH11     ,
      AI11     ,
      AJ11     ,
      AK11     ,
      AL11     ,
      AM11     ,
       C12      ,
      D12      ,
      E12      ,
      F12      ,
      G12      ,
      H12      ,
      I12      ,
      J12      ,
      K12      ,
      L12      ,
      M12      ,
      N12      ,
      O12      ,
      P12      ,
      Q12      ,
      R12      ,
      S12      ,
      T12      ,
      U12      ,
      V12      ,
      W12      ,
      X12      ,
      Y12      ,
      Z12      ,
      AA12     ,
      AB12     ,
      AC12     ,
      AD12     ,
      AE12     ,
      AF12     ,
      AG12     ,
      AH12     ,
      AI12     ,
      AJ12     ,
      AK12     ,
      AL12     ,
      AM12     ,
       C13      ,
      D13      ,
      E13      ,
      F13      ,
      G13      ,
      H13      ,
      I13      ,
      J13      ,
      K13      ,
      L13      ,
      M13      ,
      N13      ,
      O13      ,
      P13      ,
      Q13      ,
      R13      ,
      S13      ,
      T13      ,
      U13      ,
      V13      ,
      W13      ,
      X13      ,
      Y13      ,
      Z13      ,
      AA13     ,
      AB13     ,
      AC13     ,
      AD13     ,
      AE13     ,
      AF13     ,
      AG13     ,
      AH13     ,
      AI13     ,
      AJ13     ,
      AK13     ,
      AL13     ,
      AM13     ,
       C14      ,
      D14      ,
      E14      ,
      F14      ,
      G14      ,
      H14      ,
      I14      ,
      J14      ,
      K14      ,
      L14      ,
      M14      ,
      N14      ,
      O14      ,
      P14      ,
      Q14      ,
      R14      ,
      S14      ,
      T14      ,
      U14      ,
      V14      ,
      W14      ,
      X14      ,
      Y14      ,
      Z14      ,
      AA14     ,
      AB14     ,
      AC14     ,
      AD14     ,
      AE14     ,
      AF14     ,
      AG14     ,
      AH14     ,
      AI14     ,
      AJ14     ,
      AK14     ,
      AL14     ,
      AM14  ,
        C15      ,
      D15      ,
      E15      ,
      F15      ,
      G15      ,
      H15      ,
      I15      ,
      J15      ,
      K15      ,
      L15      ,
      M15      ,
      N15      ,
      O15      ,
      P15      ,
      Q15      ,
      R15      ,
      S15      ,
      T15      ,
      U15      ,
      V15      ,
      W15      ,
      X15      ,
      Z15      ,
      AA15     ,
      AB15     ,
      AD15     ,
      AE15     ,
      AF15     ,
      AG15     ,
      AH15     ,
      AI15     ,
      AJ15     ,
      AK15     ,
      AL15     ,
      AM15
             from T_CSRC0128_E1_3_1
        where BBQ = v_P001
        and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);



    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130030 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-3-1'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130030;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130030 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130030!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130040
         and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='ʲҵҪֲרܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0128_E1_3_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0128_E1_3_2(
              BBQ    ,
              USERID ,
              BTYPE ,
              OPTION1 ,
              SHTAG   ,
              ISHJ   ,
              A5   ,
              B5    ,
              C5    ,
              D5     ,
              E5      ,
              F5      ,
              G5      ,
              H5      ,
              I5      ,
              J5      ,
              K5      ,
              L5      ,
              M5      ,
              N5      ,
              O5      ,
              P5      ,
              Q5      ,
              R5      ,
              S5      ,
              T5      ,
              U5      ,
              V5      ,
              W5      ,
              X5      ,
              Y5      ,
              Z5      ,
              AA5     ,
              AB5     ,
              AC5     ,
              AD5     ,
              AE5     ,
              AF5     ,
              AG5     ,
              AH5
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A5   ,
              B5    ,
              C5    ,
              D5     ,
              E5      ,
              F5      ,
              G5      ,
              H5      ,
              I5      ,
              J5      ,
              K5      ,
              L5      ,
              M5      ,
              N5      ,
              O5      ,
              P5      ,
              Q5      ,
              R5      ,
              S5      ,
              T5      ,
              U5      ,
              V5      ,
              W5      ,
              X5      ,
              Y5      ,
              Z5      ,
              AA5     ,
              AB5     ,
              AC5     ,
              AD5     ,
              AE5     ,
              AF5     ,
              AG5     ,
              AH5
        from T_CSRC0128_E1_3_2
        where BBQ = v_P001
        and ISHJ=0
        and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

        --ϼֵ
    insert into T_CSRC0128_E1_3_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    e5,f5,g5,h5,i5,j5,k5,l5,M5,N5,O5,P5,Q5,R5,S5,T5,U5,V5,W5,Y5,Z5,Aa5,Ab5,Ac5,Ad5,Ae5,Af5,Ag5,Ah5)
    select v_P001,v_USER,0,null,null,1,
    sum(e5),sum(f5),sum(g5),sum(h5),sum(i5),sum(j5),sum(k5),sum(l5),sum(M5),sum(N5),sum(O5),sum(P5),
    sum(Q5),sum(R5),sum(S5),sum(T5),sum(U5),sum(V5),sum(W5),sum(Y5),sum(Z5),sum(Aa5),sum(Ab5),
    sum(Ac5),sum(Ad5),sum(Ae5),sum(Af5),sum(Ag5),sum(Ah5)
      from T_CSRC0128_E1_3_2
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130040 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-3-2'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130040;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130040 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130040!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130050
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130050(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130050
         and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);--

      if v_count > 0  then
       errcode:=0;
       errmsg:='רʲҵδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0128_E1_3_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0128_E1_3_3(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           ishj,
           A5 ,
           B5 ,
           C5 ,
           D5 ,
           E5 ,
           F5 ,
           G5 ,
           H5 ,
           I5 ,
           J5 ,
           K5 ,
           L5 ,
           M5 ,
           N5 ,
           O5 ,
           P5 ,
           Q5 ,
           R5 ,
           S5 ,
           T5 ,
           U5 ,
           V5 ,
           W5 ,
           X5 ,
           Y5 ,
           Z5 ,
           AA5 ,
           AB5 ,
           AC5 ,
           AD5 ,
           AE5 ,
           AF5 ,
           AG5 ,
           AH5 ,
           AI5
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A5 ,
           B5 ,
           C5 ,
           D5 ,
           E5 ,
           F5 ,
           G5 ,
           H5 ,
           I5 ,
           J5 ,
           K5 ,
           L5 ,
           M5 ,
           N5 ,
           O5 ,
           P5 ,
           Q5 ,
           R5 ,
           S5 ,
           T5 ,
           U5 ,
           V5 ,
           W5 ,
           X5 ,
           Y5 ,
           Z5 ,
           AA5 ,
           AB5 ,
           AC5 ,
           AD5 ,
           AE5 ,
           AF5 ,
           AG5 ,
           AH5 ,
           AI5
        from T_CSRC0128_E1_3_3
        where BBQ = v_P001 and ISHJ=0
          and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    --ϼ
    insert into T_CSRC0128_E1_3_3(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    C5,B5,D5,E5,F5,G5,H5,I5,J5,K5,L5,M5,N5,O5,P5,Q5,R5,S5,T5,V5,W5,X5,Z5,AA5,AB5,AC5,AD5,AE5,AF5,AG5,AH5,AI5)
    select v_P001,v_USER,0,null,null,1,
    sum(C5),sum(B5),sum(D5),sum(E5),sum(F5),sum(G5),
    sum(H5),sum(I5),sum(J5),sum(K5),sum(L5),sum(M5),sum(N5),
    sum(O5),sum(P5),sum(Q5),sum(R5),sum(S5),sum(T5),
    sum(V5),sum(W5),sum(X5),sum(Z5),sum(AA5),sum(AB5),
     sum(AC5),sum(AD5),sum(AE5),sum(AF5),sum(AG5),sum(AH5),sum(AI5)
  from T_CSRC0128_E1_3_3
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;

    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130050 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>C4-2'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130050 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130050 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130050!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130060
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130060(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130060
         and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='E1-4Ŀϸרܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_e1_4 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */


        insert into t_csrc0707_e1_4(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A2      ,
            B2      ,
            C2      ,
            D2      ,
            E2      ,
            F2
          )
          select BBQ,
           v_USER,
           BTYPE,
           OPTION1,
           SHTAG,
           ISHJ,
           A2,
           B2,
           C2,
           D2,
           E2,
           F2
      from t_csrc0707_e1_4
     where BBQ = v_P001
       and ishj = 0
       and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  --ϼ
  insert into t_csrc0707_e1_4
    (       BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ISHJ    ,
            A2      ,
            B2      ,
            C2      ,
            D2      ,
            E2      ,
            F2)
    select BBQ,
           v_USER,
           0,
           null,
           0,
           1,
           null,
           null,
           null,
           sum(D2),
           sum(E2),
           null
      from t_csrc0707_e1_4
     where BBQ = v_P001
       and ishj = 0
       and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
     group by bbq;


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130060 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-4'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130060;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130060 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130060!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130070
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130070(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130070
         and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='E1-5ضƷϯλרܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_E1_5 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_E1_5(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            D2,
            E3,
            F3,
            C4,
            C5,
            D5,
            E5,
            F5
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            D2,
            E3,
            F3,
            C4,
            C5,
            D5,
            E5,
            F5
        from t_csrc0707_E1_5
        where BBQ = v_P001
          and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130070 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-5'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130070 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130070 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130070!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130080
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130080(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130080
         and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='ϵͳʹרܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_E1_6_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_E1_6_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2
        from t_csrc0707_E1_6_1
        where BBQ = v_P001
          and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        order by to_number(option1);


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130080 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-6-1'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130080;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130080 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130080!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130090
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130090(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130090
         and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='Ӳרܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_E1_6_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_E1_6_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2
        from t_csrc0707_E1_6_2
        where BBQ = v_P001
          and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130090 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-6-2'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130090 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130090 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130090!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130100
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130100(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
       v_sum number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130100
       and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='¹ʱרܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_E1_6_3 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

select count(*) into v_sum from t_csrc0707_E1_6_3 where BBQ = v_P001 and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
if v_sum=0 then
   insert into t_csrc0707_E1_6_3(BBQ ,USERID)
     select v_P001,v_USER from dual;
else
   insert into t_csrc0707_E1_6_3(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2
        from t_csrc0707_E1_6_3
        where BBQ = v_P001
          and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
end if;


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130100 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-6-3'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130100;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130100 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130100!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130110
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130110(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130110
       and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='Ӫҵרܱδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0707_E1_6_4 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0707_E1_6_4(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            1,
            max(B2),
            sum(C2),
            sum(D2),
            sum(E2),
            substrb(catstr(F2),1,255),
            substrb(catstr(G2),1,255)
        from t_csrc0707_E1_6_4
        where BBQ = v_P001
          and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq,btype,option1,shtag,ishj;


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130110 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-6-4'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130110;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130110 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130110!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130120
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130120(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_count number;
       v_countRpt number;
       v_user integer;
       v_org number;
       v_temp varchar(256);
       v_sql  varchar(4000);                --SQL
      --õĩȯߵǰ10ͻ
      cursor cur_rzrqzg is
      select *
            from (
                   select khmc,hj,rzje,rqje,dbwjz,wcdbbl
                     from (
                            select userid as bmid, b4 as khmc, c4 as hj, d4 as rzje,e4 as rqje,f4 as dbwjz,g4 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b4 is not null
                            union all
                            select userid as bmid, b5 as khmc, c5 as hj, d5 as rzje,e5 as rqje,f5 as dbwjz,g5 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b5 is not null
                            union all
                            select userid as bmid, b6 as khmc, c6 as hj, d6 as rzje,e6 as rqje,f6 as dbwjz,g6 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b6 is not null
                            union all
                            select userid as bmid, b7 as khmc, c7 as hj, d7 as rzje,e7 as rqje,f7 as dbwjz,g7 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b7 is not null
                            union all
                            select userid as bmid, b8 as khmc, c8 as hj, d8 as rzje,e8 as rqje,f8 as dbwjz,g8 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b8 is not null
                            union all
                            select userid as bmid, b9 as khmc, c9 as hj, d9 as rzje,e9 as rqje,f9 as dbwjz,g9 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b9 is not null
                            union all
                            select userid as bmid, b10 as khmc, c10 as hj, d10 as rzje,e10 as rqje,f10 as dbwjz,g10 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b10 is not null
                            union all
                            select userid as bmid, b11 as khmc, c11 as hj, d11 as rzje,e11 as rqje,f11 as dbwjz,g11 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b11 is not null
                            union all
                            select userid as bmid, b12 as khmc, c12 as hj, d12 as rzje,e12 as rqje,f12 as dbwjz,g12 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b12 is not null
                            union all
                            select userid as bmid, b13 as khmc, c13 as hj, d13 as rzje,e13 as rqje,f13 as dbwjz,g13 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b13 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by hj desc
                 )
           where rownum <= 10;

      --ĩάֵ͵10ͻϸάֵĿͻϸͳƣ
      cursor cur_wcdbbl is
      select *
            from (
                   select khmc,hj,rzje,rqje,dbwjz,wcdbbl
                     from (
                            select userid as bmid, b17 as khmc, c17 as hj, d17 as rzje,e17 as rqje,f17 as dbwjz,g17 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b17 is not null
                            union all
                            select userid as bmid, b18 as khmc, c18 as hj, d18 as rzje,e18 as rqje,f18 as dbwjz,g18 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b18 is not null
                            union all
                            select userid as bmid, b19 as khmc, c19 as hj, d19 as rzje,e19 as rqje,f19 as dbwjz,g19 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b19 is not null
                            union all
                            select userid as bmid, b20 as khmc, c20 as hj, d20 as rzje,e20 as rqje,f20 as dbwjz,g20 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b20 is not null
                            union all
                            select userid as bmid, b21 as khmc, c21 as hj, d21 as rzje,e21 as rqje,f21 as dbwjz,g21 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b21 is not null
                            union all
                            select userid as bmid, b22 as khmc, c22 as hj, d22 as rzje,e22 as rqje,f22 as dbwjz,g22 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b22 is not null
                            union all
                            select userid as bmid, b23 as khmc, c23 as hj, d23 as rzje,e23 as rqje,f23 as dbwjz,g23 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b23 is not null
                            union all
                            select userid as bmid, b24 as khmc, c24 as hj, d24 as rzje,e24 as rqje,f24 as dbwjz,g24 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b24 is not null
                            union all
                            select userid as bmid, b25 as khmc, c25 as hj, d25 as rzje,e25 as rqje,f25 as dbwjz,g25 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b25 is not null
                            union all
                            select userid as bmid, b26 as khmc, c26 as hj, d26 as rzje,e26 as rqje,f26 as dbwjz,g26 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b26 is not null
                          ) where bmid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by wcdbbl asc
                 )
           where rownum <= 10;

      --ĩ֤ȯֵǰ10֤ȯ
      cursor cur_rzmr is
      select *
            from (
                   select zqmc,zqdm,zgb,zqsl,zqsz
                     from (
                            select userid as bmid, b30 as zqmc, c30 as zqdm, d30 as zgb,e30 as zqsl,f30 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b30 is not null
                            union all
                            select userid as bmid, b31 as zqmc, c31 as zqdm, d31 as zgb,e31 as zqsl,f31 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b31 is not null
                            union all
                            select userid as bmid, b32 as zqmc, c32 as zqdm, d32 as zgb,e32 as zqsl,f32 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b32 is not null
                            union all
                            select userid as bmid, b33 as zqmc, c33 as zqdm, d33 as zgb,e33 as zqsl,f33 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b33 is not null
                            union all
                            select userid as bmid, b34 as zqmc, c34 as zqdm, d34 as zgb,e34 as zqsl,f34 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b34 is not null
                            union all
                            select userid as bmid, b35 as zqmc, c35 as zqdm, d35 as zgb,e35 as zqsl,f35 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b35 is not null
                            union all
                            select userid as bmid, b36 as zqmc, c36 as zqdm, d36 as zgb,e36 as zqsl,f36 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b36 is not null
                            union all
                            select userid as bmid, b37 as zqmc, c37 as zqdm, d37 as zgb,e37 as zqsl,f37 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b37 is not null
                            union all
                            select userid as bmid, b38 as zqmc, c38 as zqdm, d38 as zgb,e38 as zqsl,f38 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b38 is not null
                            union all
                            select userid as bmid, b39 as zqmc, c39 as zqdm, d39 as zgb,e39 as zqsl,f39 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b39 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by zqsz desc
                 )
           where rownum <= 10;

     --ĩȯ֤ȯֵǰ10֤ȯ
      cursor cur_rqmc is
      select *
            from (
                   select zqmc,zqdm,zgb,zqsl,zqsz
                     from (
                            select userid as bmid, b43 as zqmc, c43 as zqdm, d43 as zgb,e43 as zqsl,f43 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b43 is not null
                            union all
                            select userid as bmid, b44 as zqmc, c44 as zqdm, d44 as zgb,e44 as zqsl,f44 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b44 is not null
                            union all
                            select userid as bmid, b45 as zqmc, c45 as zqdm, d45 as zgb,e45 as zqsl,f45 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b45 is not null
                            union all
                            select userid as bmid, b46 as zqmc, c46 as zqdm, d46 as zgb,e46 as zqsl,f46 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b46 is not null
                            union all
                            select userid as bmid, b47 as zqmc, c47 as zqdm, d47 as zgb,e47 as zqsl,f47 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b47 is not null
                            union all
                            select userid as bmid, b48 as zqmc, c48 as zqdm, d48 as zgb,e48 as zqsl,f48 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b48 is not null
                            union all
                            select userid as bmid, b49 as zqmc, c49 as zqdm, d49 as zgb,e49 as zqsl,f49 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b49 is not null
                            union all
                            select userid as bmid, b50 as zqmc, c50 as zqdm, d50 as zgb,e50 as zqsl,f50 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b50 is not null
                            union all
                            select userid as bmid, b51 as zqmc, c51 as zqdm, d51 as zgb,e51 as zqsl,f51 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b51 is not null
                            union all
                            select userid as bmid, b52 as zqmc, c52 as zqdm, d52 as zgb,e52 as zqsl,f52 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b52 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by zqsz desc
                 )
           where rownum <= 10;




           --ĩֵǰ10֤ȯ
      cursor cur_dbwsz is
      select *
            from (
                   select zqmc,zqdm,qmsz,dbwbl
                     from (
                            select userid as bmid, b55 as zqmc, c55 as zqdm, d55 as qmsz,e55 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b55 is not null
                            union all
                            select userid as bmid, b56 as zqmc, c56 as zqdm, d56 as qmsz,e56 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b56 is not null
                            union all
                            select userid as bmid, b57 as zqmc, c57 as zqdm, d57 as qmsz,e57 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b57 is not null
                            union all
                            select userid as bmid, b58 as zqmc, c58 as zqdm, d58 as qmsz,e58 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b58 is not null
                            union all
                            select userid as bmid, b59 as zqmc, c59 as zqdm, d59 as qmsz,e59 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b59 is not null
                            union all
                            select userid as bmid, b60 as zqmc, c60 as zqdm, d60 as qmsz,e60 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b60 is not null
                            union all
                            select userid as bmid, b61 as zqmc, c61 as zqdm, d61 as qmsz,e61 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b61 is not null
                            union all
                            select userid as bmid, b62 as zqmc, c62 as zqdm, d62 as qmsz,e62 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b62 is not null
                            union all
                            select userid as bmid, b63 as zqmc, c63 as zqdm, d63 as qmsz,e63 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b63 is not null
                            union all
                            select userid as bmid, b64 as zqmc, c64 as zqdm, d64 as qmsz,e64 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b64 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by qmsz desc
                 )
           where rownum <= 10;


           --10ǿƽֽϸ
      cursor cur_qzpc is
      select *
            from (
                   select khmc,pcsj,pcje,wsxzqje
                     from (
                            select userid as bmid, b67 as khmc, c67 as pcsj, d67 as pcje,e67 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b67 is not null
                            union all
                            select userid as bmid, b68 as khmc, c68 as pcsj, d68 as pcje,e68 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b68 is not null
                            union all
                            select userid as bmid, b69 as khmc, c69 as pcsj, d69 as pcje,e69 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b69 is not null
                            union all
                            select userid as bmid, b70 as khmc, c70 as pcsj, d70 as pcje,e70 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b70 is not null
                            union all
                            select userid as bmid, b71 as khmc, c71 as pcsj, d71 as pcje,e71 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b71 is not null
                            union all
                            select userid as bmid, b72 as khmc, c72 as pcsj, d72 as pcje,e72 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b72 is not null
                            union all
                            select userid as bmid, b73 as khmc, c73 as pcsj, d73 as pcje,e73 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b73 is not null
                            union all
                            select userid as bmid, b74 as khmc, c74 as pcsj, d74 as pcje,e74 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b74 is not null
                            union all
                            select userid as bmid, b75 as khmc, c75 as pcsj, d75 as pcje,e75 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b75 is not null
                            union all
                            select userid as bmid, b76 as khmc, c76 as pcsj, d76 as pcje,e76 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b76 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by pcje desc
                 )
           where rownum <= 10;


    /**********************************************************************************************/

begin
      errcode := 1;
      errmsg  := 'ϲɹ';

       select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;
      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130120
     and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='ȯҵϸרܱδͨ,ϲδ';
       return;
      end if;



     select T2.A002 into v_user
        from krcs.T_SYS_USER T1,
             krcs.T_CTL_T036 T2
       where T1.P001 = v_KJAXUSER
         and T1.P002 = T2.P001;

      delete from T_CSRC0707_E1_7 WHERE BBQ=v_p001 and USERID=v_user;  /* ɾͬһڵ */

    --ĩȯߵǰ10ͻϸ
    v_count :=3;
    for my_rzrqzg in cur_rzrqzg  loop
         v_count :=v_count +1;
          if(v_count =4) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b4,c4,d4,e4,f4,g4)values
                 (v_p001,v_user,'0',null,'0',my_rzrqzg.khmc ,my_rzrqzg.hj,my_rzrqzg.rzje,my_rzrqzg.rqje,my_rzrqzg.dbwjz,my_rzrqzg.wcdbbl);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzrqzg.khmc||''','
                   ||'C'||v_count||'='''||my_rzrqzg.hj||''','
                   ||'D'||v_count||'='||my_rzrqzg.rzje||','
                   ||'E'||v_count||'='||my_rzrqzg.rqje||','
                   ||'F'||v_count||'='||my_rzrqzg.dbwjz||','
                   ||'G'||v_count||'='||my_rzrqzg.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
              v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzrqzg.khmc||''','
                   ||'C'||v_count||'='''||my_rzrqzg.hj||''','
                   ||'D'||v_count||'='||my_rzrqzg.rzje||','
                   ||'E'||v_count||'='||my_rzrqzg.rqje||','
                   ||'F'||v_count||'='||my_rzrqzg.dbwjz||','
                   ||'G'||v_count||'='||my_rzrqzg.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --ĩάֵ͵10ͻϸάֵĿͻϸͳƣ
    v_count :=16;
    for my_wcdbbl in cur_wcdbbl  loop
         v_count :=v_count +1;
          if(v_count =17) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b17,c17,d17,e17,f17,g17)values
                 (v_p001,v_user,'0',null,'0',my_wcdbbl.khmc ,my_wcdbbl.hj,my_wcdbbl.rzje,my_wcdbbl.rqje,my_wcdbbl.dbwjz,my_wcdbbl.wcdbbl);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_wcdbbl.khmc||''','
                   ||'C'||v_count||'='''||my_wcdbbl.hj||''','
                   ||'D'||v_count||'='||my_wcdbbl.rzje||','
                   ||'E'||v_count||'='||my_wcdbbl.rqje||','
                   ||'F'||v_count||'='||my_wcdbbl.dbwjz||','
                   ||'G'||v_count||'='||my_wcdbbl.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_wcdbbl.khmc||''','
                   ||'C'||v_count||'='''||my_wcdbbl.hj||''','
                   ||'D'||v_count||'='||my_wcdbbl.rzje||','
                   ||'E'||v_count||'='||my_wcdbbl.rqje||','
                   ||'F'||v_count||'='||my_wcdbbl.dbwjz||','
                   ||'G'||v_count||'='||my_wcdbbl.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --ĩ֤ȯֵǰ10֤ȯ
    v_count :=29;
    for my_rzmr in cur_rzmr  loop
         v_count :=v_count +1;
          if(v_count =30) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b30,c30,d30,e30,f30)values
                 (v_p001,v_user,'0',null,'0',my_rzmr.zqmc ,my_rzmr.zqdm,my_rzmr.zgb,my_rzmr.zqsl,my_rzmr.zqsz);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzmr.zqmc||''','
                   ||'C'||v_count||'='''||my_rzmr.zqdm||''','
                   ||'D'||v_count||'='||my_rzmr.zgb||','
                   ||'E'||v_count||'='||my_rzmr.zqsl||','
                   ||'F'||v_count||'='||my_rzmr.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzmr.zqmc||''','
                   ||'C'||v_count||'='''||my_rzmr.zqdm||''','
                   ||'D'||v_count||'='||my_rzmr.zgb||','
                   ||'E'||v_count||'='||my_rzmr.zqsl||','
                   ||'F'||v_count||'='||my_rzmr.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --ĩȯ֤ȯֵǰ10֤ȯ
    v_count :=42;
    for my_rqmc in cur_rqmc  loop
         v_count :=v_count +1;
          if(v_count =43) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b43,c43,d43,e43,f43)values
                 (v_p001,v_user,'0',null,'0',my_rqmc.zqmc ,my_rqmc.zqdm,my_rqmc.zgb,my_rqmc.zqsl,my_rqmc.zqsz);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rqmc.zqmc||''','
                   ||'C'||v_count||'='''||my_rqmc.zqdm||''','
                   ||'D'||v_count||'='||my_rqmc.zgb||','
                   ||'E'||v_count||'='||my_rqmc.zqsl||','
                   ||'F'||v_count||'='||my_rqmc.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rqmc.zqmc||''','
                   ||'C'||v_count||'='''||my_rqmc.zqdm||''','
                   ||'D'||v_count||'='||my_rqmc.zgb||','
                   ||'E'||v_count||'='||my_rqmc.zqsl||','
                   ||'F'||v_count||'='||my_rqmc.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;

    --ĩֵǰ10֤ȯ
    v_count :=54;
    for my_dbwsz in cur_dbwsz  loop
         v_count :=v_count +1;
          if(v_count =55) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b55,c55,d55,e55)values
                 (v_p001,v_user,'0',null,'0',my_dbwsz.zqmc ,my_dbwsz.zqdm,my_dbwsz.qmsz,my_dbwsz.dbwbl);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_dbwsz.zqmc||''','
                   ||'C'||v_count||'='''||my_dbwsz.zqdm||''','
                   ||'D'||v_count||'='||my_dbwsz.qmsz||','
                   ||'E'||v_count||'='||my_dbwsz.dbwbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_dbwsz.zqmc||''','
                   ||'C'||v_count||'='''||my_dbwsz.zqdm||''','
                   ||'D'||v_count||'='||my_dbwsz.qmsz||','
                   ||'E'||v_count||'='||my_dbwsz.dbwbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --10ǿƽֽϸ
    v_count :=66;
    for my_qzpc in cur_qzpc  loop
         v_count :=v_count +1;
          if(v_count =55) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b55,c55,d55,e55)values
                 (v_p001,v_user,'0',null,'0',my_qzpc.khmc ,my_qzpc.pcsj,my_qzpc.pcje,my_qzpc.wsxzqje);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_qzpc.khmc||''','
                   ||'C'||v_count||'='''||my_qzpc.pcsj||''','
                   ||'D'||v_count||'='||my_qzpc.pcje||','
                   ||'E'||v_count||'='||my_qzpc.wsxzqje||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_qzpc.khmc||''','
                   ||'C'||v_count||'='''||my_qzpc.pcsj||''','
                   ||'D'||v_count||'='||my_qzpc.pcje||','
                   ||'E'||v_count||'='||my_qzpc.wsxzqje||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;
    --add by zhenyj 20190214 ǿƽͻظ߹˱ return code -1
    update T_CSRC0707_E1_7 t set t.shtag = 1 where t.bbq=v_P001;
    commit;
    

    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130120 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-3-2'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130120;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130120 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130120!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130120_BK
prompt ==============================================
prompt
create or replace procedure cisp_mergereport_1130120_bk(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_count number;
       v_countRpt number;
       v_user integer;
       v_org number;
       v_temp varchar(256);
       v_sql  varchar(4000);                --SQL
      --õĩȯߵǰ10ͻ
      cursor cur_rzrqzg is
      select *
            from (
                   select khmc,hj,rzje,rqje,dbwjz,wcdbbl
                     from (
                            select userid as bmid, b4 as khmc, c4 as hj, d4 as rzje,e4 as rqje,f4 as dbwjz,g4 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b4 is not null
                            union all
                            select userid as bmid, b5 as khmc, c5 as hj, d5 as rzje,e5 as rqje,f5 as dbwjz,g5 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b5 is not null
                            union all
                            select userid as bmid, b6 as khmc, c6 as hj, d6 as rzje,e6 as rqje,f6 as dbwjz,g6 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b6 is not null
                            union all
                            select userid as bmid, b7 as khmc, c7 as hj, d7 as rzje,e7 as rqje,f7 as dbwjz,g7 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b7 is not null
                            union all
                            select userid as bmid, b8 as khmc, c8 as hj, d8 as rzje,e8 as rqje,f8 as dbwjz,g8 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b8 is not null
                            union all
                            select userid as bmid, b9 as khmc, c9 as hj, d9 as rzje,e9 as rqje,f9 as dbwjz,g9 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b9 is not null
                            union all
                            select userid as bmid, b10 as khmc, c10 as hj, d10 as rzje,e10 as rqje,f10 as dbwjz,g10 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b10 is not null
                            union all
                            select userid as bmid, b11 as khmc, c11 as hj, d11 as rzje,e11 as rqje,f11 as dbwjz,g11 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b11 is not null
                            union all
                            select userid as bmid, b12 as khmc, c12 as hj, d12 as rzje,e12 as rqje,f12 as dbwjz,g12 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b12 is not null
                            union all
                            select userid as bmid, b13 as khmc, c13 as hj, d13 as rzje,e13 as rqje,f13 as dbwjz,g13 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b13 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by hj desc
                 )
           where rownum <= 10;

      --ĩάֵ͵10ͻϸάֵĿͻϸͳƣ
      cursor cur_wcdbbl is
      select *
            from (
                   select khmc,hj,rzje,rqje,dbwjz,wcdbbl
                     from (
                            select userid as bmid, b17 as khmc, c17 as hj, d17 as rzje,e17 as rqje,f17 as dbwjz,g17 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b17 is not null
                            union all
                            select userid as bmid, b18 as khmc, c18 as hj, d18 as rzje,e18 as rqje,f18 as dbwjz,g18 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b18 is not null
                            union all
                            select userid as bmid, b19 as khmc, c19 as hj, d19 as rzje,e19 as rqje,f19 as dbwjz,g19 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b19 is not null
                            union all
                            select userid as bmid, b20 as khmc, c20 as hj, d20 as rzje,e20 as rqje,f20 as dbwjz,g20 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b20 is not null
                            union all
                            select userid as bmid, b21 as khmc, c21 as hj, d21 as rzje,e21 as rqje,f21 as dbwjz,g21 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b21 is not null
                            union all
                            select userid as bmid, b22 as khmc, c22 as hj, d22 as rzje,e22 as rqje,f22 as dbwjz,g22 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b22 is not null
                            union all
                            select userid as bmid, b23 as khmc, c23 as hj, d23 as rzje,e23 as rqje,f23 as dbwjz,g23 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b23 is not null
                            union all
                            select userid as bmid, b24 as khmc, c24 as hj, d24 as rzje,e24 as rqje,f24 as dbwjz,g24 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b24 is not null
                            union all
                            select userid as bmid, b25 as khmc, c25 as hj, d25 as rzje,e25 as rqje,f25 as dbwjz,g25 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b25 is not null
                            union all
                            select userid as bmid, b26 as khmc, c26 as hj, d26 as rzje,e26 as rqje,f26 as dbwjz,g26 as wcdbbl from T_CSRC0707_E1_7 where bbq = v_p001 and b26 is not null
                          ) where bmid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by wcdbbl asc
                 )
           where rownum <= 10;

      --ĩ֤ȯֵǰ10֤ȯ
      cursor cur_rzmr is
      select *
            from (
                   select zqmc,zqdm,zgb,zqsl,zqsz
                     from (
                            select userid as bmid, b30 as zqmc, c30 as zqdm, d30 as zgb,e30 as zqsl,f30 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b30 is not null
                            union all
                            select userid as bmid, b31 as zqmc, c31 as zqdm, d31 as zgb,e31 as zqsl,f31 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b31 is not null
                            union all
                            select userid as bmid, b32 as zqmc, c32 as zqdm, d32 as zgb,e32 as zqsl,f32 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b32 is not null
                            union all
                            select userid as bmid, b33 as zqmc, c33 as zqdm, d33 as zgb,e33 as zqsl,f33 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b33 is not null
                            union all
                            select userid as bmid, b34 as zqmc, c34 as zqdm, d34 as zgb,e34 as zqsl,f34 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b34 is not null
                            union all
                            select userid as bmid, b35 as zqmc, c35 as zqdm, d35 as zgb,e35 as zqsl,f35 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b35 is not null
                            union all
                            select userid as bmid, b36 as zqmc, c36 as zqdm, d36 as zgb,e36 as zqsl,f36 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b36 is not null
                            union all
                            select userid as bmid, b37 as zqmc, c37 as zqdm, d37 as zgb,e37 as zqsl,f37 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b37 is not null
                            union all
                            select userid as bmid, b38 as zqmc, c38 as zqdm, d38 as zgb,e38 as zqsl,f38 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b38 is not null
                            union all
                            select userid as bmid, b39 as zqmc, c39 as zqdm, d39 as zgb,e39 as zqsl,f39 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b39 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by zqsz desc
                 )
           where rownum <= 10;

     --ĩȯ֤ȯֵǰ10֤ȯ
      cursor cur_rqmc is
      select *
            from (
                   select zqmc,zqdm,zgb,zqsl,zqsz
                     from (
                            select userid as bmid, b43 as zqmc, c43 as zqdm, d43 as zgb,e43 as zqsl,f43 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b43 is not null
                            union all
                            select userid as bmid, b44 as zqmc, c44 as zqdm, d44 as zgb,e44 as zqsl,f44 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b44 is not null
                            union all
                            select userid as bmid, b45 as zqmc, c45 as zqdm, d45 as zgb,e45 as zqsl,f45 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b45 is not null
                            union all
                            select userid as bmid, b46 as zqmc, c46 as zqdm, d46 as zgb,e46 as zqsl,f46 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b46 is not null
                            union all
                            select userid as bmid, b47 as zqmc, c47 as zqdm, d47 as zgb,e47 as zqsl,f47 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b47 is not null
                            union all
                            select userid as bmid, b48 as zqmc, c48 as zqdm, d48 as zgb,e48 as zqsl,f48 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b48 is not null
                            union all
                            select userid as bmid, b49 as zqmc, c49 as zqdm, d49 as zgb,e49 as zqsl,f49 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b49 is not null
                            union all
                            select userid as bmid, b50 as zqmc, c50 as zqdm, d50 as zgb,e50 as zqsl,f50 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b50 is not null
                            union all
                            select userid as bmid, b51 as zqmc, c51 as zqdm, d51 as zgb,e51 as zqsl,f51 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b51 is not null
                            union all
                            select userid as bmid, b52 as zqmc, c52 as zqdm, d52 as zgb,e52 as zqsl,f52 as zqsz from T_CSRC0707_E1_7 where bbq = v_p001 and b52 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by zqsz desc
                 )
           where rownum <= 10;




           --ĩֵǰ10֤ȯ
      cursor cur_dbwsz is
      select *
            from (
                   select zqmc,zqdm,qmsz,dbwbl
                     from (
                            select userid as bmid, b55 as zqmc, c55 as zqdm, d55 as qmsz,e55 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b55 is not null
                            union all
                            select userid as bmid, b56 as zqmc, c56 as zqdm, d56 as qmsz,e56 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b56 is not null
                            union all
                            select userid as bmid, b57 as zqmc, c57 as zqdm, d57 as qmsz,e57 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b57 is not null
                            union all
                            select userid as bmid, b58 as zqmc, c58 as zqdm, d58 as qmsz,e58 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b58 is not null
                            union all
                            select userid as bmid, b59 as zqmc, c59 as zqdm, d59 as qmsz,e59 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b59 is not null
                            union all
                            select userid as bmid, b60 as zqmc, c60 as zqdm, d60 as qmsz,e60 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b60 is not null
                            union all
                            select userid as bmid, b61 as zqmc, c61 as zqdm, d61 as qmsz,e61 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b61 is not null
                            union all
                            select userid as bmid, b62 as zqmc, c62 as zqdm, d62 as qmsz,e62 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b62 is not null
                            union all
                            select userid as bmid, b63 as zqmc, c63 as zqdm, d63 as qmsz,e63 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b63 is not null
                            union all
                            select userid as bmid, b64 as zqmc, c64 as zqdm, d64 as qmsz,e64 as dbwbl from T_CSRC0707_E1_7 where bbq = v_p001 and b64 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by qmsz desc
                 )
           where rownum <= 10;


           --10ǿƽֽϸ
      cursor cur_qzpc is
      select *
            from (
                   select khmc,pcsj,pcje,wsxzqje
                     from (
                            select userid as bmid, b67 as khmc, c67 as pcsj, d67 as pcje,e67 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b67 is not null
                            union all
                            select userid as bmid, b68 as khmc, c68 as pcsj, d68 as pcje,e68 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b68 is not null
                            union all
                            select userid as bmid, b69 as khmc, c69 as pcsj, d69 as pcje,e69 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b69 is not null
                            union all
                            select userid as bmid, b70 as khmc, c70 as pcsj, d70 as pcje,e70 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b70 is not null
                            union all
                            select userid as bmid, b71 as khmc, c71 as pcsj, d71 as pcje,e71 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b71 is not null
                            union all
                            select userid as bmid, b72 as khmc, c72 as pcsj, d72 as pcje,e72 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b72 is not null
                            union all
                            select userid as bmid, b73 as khmc, c73 as pcsj, d73 as pcje,e73 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b73 is not null
                            union all
                            select userid as bmid, b74 as khmc, c74 as pcsj, d74 as pcje,e74 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b74 is not null
                            union all
                            select userid as bmid, b75 as khmc, c75 as pcsj, d75 as pcje,e75 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b75 is not null
                            union all
                            select userid as bmid, b76 as khmc, c76 as pcsj, d76 as pcje,e76 as wsxzqje from T_CSRC0707_E1_7 where bbq = v_p001 and b76 is not null
                          ) where bmid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
                    order by pcje desc
                 )
           where rownum <= 10;


    /**********************************************************************************************/

begin
      errcode := 1;
      errmsg  := 'ϲɹ';

       select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;
      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130120
     and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='ȯҵϸרܱδͨ,ϲδ';
       return;
      end if;



     select T2.A002 into v_user
        from krcs.T_SYS_USER T1,
             krcs.T_CTL_T036 T2
       where T1.P001 = v_KJAXUSER
         and T1.P002 = T2.P001;

      delete from T_CSRC0707_E1_7 WHERE BBQ=v_p001 and USERID=v_user;  /* ɾͬһڵ */

    --ĩȯߵǰ10ͻϸ
    v_count :=3;
    for my_rzrqzg in cur_rzrqzg  loop
         v_count :=v_count +1;
          if(v_count =4) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b4,c4,d4,e4,f4,g4)values
                 (v_p001,v_user,'0',null,'0',my_rzrqzg.khmc ,my_rzrqzg.hj,my_rzrqzg.rzje,my_rzrqzg.rqje,my_rzrqzg.dbwjz,my_rzrqzg.wcdbbl);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzrqzg.khmc||''','
                   ||'C'||v_count||'='''||my_rzrqzg.hj||''','
                   ||'D'||v_count||'='||my_rzrqzg.rzje||','
                   ||'E'||v_count||'='||my_rzrqzg.rqje||','
                   ||'F'||v_count||'='||my_rzrqzg.dbwjz||','
                   ||'G'||v_count||'='||my_rzrqzg.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
              v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzrqzg.khmc||''','
                   ||'C'||v_count||'='''||my_rzrqzg.hj||''','
                   ||'D'||v_count||'='||my_rzrqzg.rzje||','
                   ||'E'||v_count||'='||my_rzrqzg.rqje||','
                   ||'F'||v_count||'='||my_rzrqzg.dbwjz||','
                   ||'G'||v_count||'='||my_rzrqzg.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --ĩάֵ͵10ͻϸάֵĿͻϸͳƣ
    v_count :=16;
    for my_wcdbbl in cur_wcdbbl  loop
         v_count :=v_count +1;
          if(v_count =17) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b17,c17,d17,e17,f17,g17)values
                 (v_p001,v_user,'0',null,'0',my_wcdbbl.khmc ,my_wcdbbl.hj,my_wcdbbl.rzje,my_wcdbbl.rqje,my_wcdbbl.dbwjz,my_wcdbbl.wcdbbl);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_wcdbbl.khmc||''','
                   ||'C'||v_count||'='''||my_wcdbbl.hj||''','
                   ||'D'||v_count||'='||my_wcdbbl.rzje||','
                   ||'E'||v_count||'='||my_wcdbbl.rqje||','
                   ||'F'||v_count||'='||my_wcdbbl.dbwjz||','
                   ||'G'||v_count||'='||my_wcdbbl.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_wcdbbl.khmc||''','
                   ||'C'||v_count||'='''||my_wcdbbl.hj||''','
                   ||'D'||v_count||'='||my_wcdbbl.rzje||','
                   ||'E'||v_count||'='||my_wcdbbl.rqje||','
                   ||'F'||v_count||'='||my_wcdbbl.dbwjz||','
                   ||'G'||v_count||'='||my_wcdbbl.wcdbbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --ĩ֤ȯֵǰ10֤ȯ
    v_count :=29;
    for my_rzmr in cur_rzmr  loop
         v_count :=v_count +1;
          if(v_count =30) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b30,c30,d30,e30,f30)values
                 (v_p001,v_user,'0',null,'0',my_rzmr.zqmc ,my_rzmr.zqdm,my_rzmr.zgb,my_rzmr.zqsl,my_rzmr.zqsz);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzmr.zqmc||''','
                   ||'C'||v_count||'='''||my_rzmr.zqdm||''','
                   ||'D'||v_count||'='||my_rzmr.zgb||','
                   ||'E'||v_count||'='||my_rzmr.zqsl||','
                   ||'F'||v_count||'='||my_rzmr.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rzmr.zqmc||''','
                   ||'C'||v_count||'='''||my_rzmr.zqdm||''','
                   ||'D'||v_count||'='||my_rzmr.zgb||','
                   ||'E'||v_count||'='||my_rzmr.zqsl||','
                   ||'F'||v_count||'='||my_rzmr.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --ĩȯ֤ȯֵǰ10֤ȯ
    v_count :=42;
    for my_rqmc in cur_rqmc  loop
         v_count :=v_count +1;
          if(v_count =43) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b43,c43,d43,e43,f43)values
                 (v_p001,v_user,'0',null,'0',my_rqmc.zqmc ,my_rqmc.zqdm,my_rqmc.zgb,my_rqmc.zqsl,my_rqmc.zqsz);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rqmc.zqmc||''','
                   ||'C'||v_count||'='''||my_rqmc.zqdm||''','
                   ||'D'||v_count||'='||my_rqmc.zgb||','
                   ||'E'||v_count||'='||my_rqmc.zqsl||','
                   ||'F'||v_count||'='||my_rqmc.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_rqmc.zqmc||''','
                   ||'C'||v_count||'='''||my_rqmc.zqdm||''','
                   ||'D'||v_count||'='||my_rqmc.zgb||','
                   ||'E'||v_count||'='||my_rqmc.zqsl||','
                   ||'F'||v_count||'='||my_rqmc.zqsz||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;

    --ĩֵǰ10֤ȯ
    v_count :=54;
    for my_dbwsz in cur_dbwsz  loop
         v_count :=v_count +1;
          if(v_count =55) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b55,c55,d55,e55)values
                 (v_p001,v_user,'0',null,'0',my_dbwsz.zqmc ,my_dbwsz.zqdm,my_dbwsz.qmsz,my_dbwsz.dbwbl);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_dbwsz.zqmc||''','
                   ||'C'||v_count||'='''||my_dbwsz.zqdm||''','
                   ||'D'||v_count||'='||my_dbwsz.qmsz||','
                   ||'E'||v_count||'='||my_dbwsz.dbwbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                 v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_dbwsz.zqmc||''','
                   ||'C'||v_count||'='''||my_dbwsz.zqdm||''','
                   ||'D'||v_count||'='||my_dbwsz.qmsz||','
                   ||'E'||v_count||'='||my_dbwsz.dbwbl||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;


    --10ǿƽֽϸ
    v_count :=66;
    for my_qzpc in cur_qzpc  loop
         v_count :=v_count +1;
          if(v_count =55) then
             select count(*) into v_countRpt from t_csrc0707_e1_7  where bbq = v_p001 and userid = v_user;
             if(v_countRpt =0) then
                insert into t_csrc0707_e1_7(BBQ,userid,btype,option1,shtag,b55,c55,d55,e55)values
                 (v_p001,v_user,'0',null,'0',my_qzpc.khmc ,my_qzpc.pcsj,my_qzpc.pcje,my_qzpc.wsxzqje);
             else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_qzpc.khmc||''','
                   ||'C'||v_count||'='''||my_qzpc.pcsj||''','
                   ||'D'||v_count||'='||my_qzpc.pcje||','
                   ||'E'||v_count||'='||my_qzpc.wsxzqje||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
             end if;
           else
                   v_sql := 'update T_CSRC0707_E1_7 set '
                   ||'B'||v_count||'='''||my_qzpc.khmc||''','
                   ||'C'||v_count||'='''||my_qzpc.pcsj||''','
                   ||'D'||v_count||'='||my_qzpc.pcje||','
                   ||'E'||v_count||'='||my_qzpc.wsxzqje||' '
                   ||'where BBQ='''||v_p001||''' and USERID='||v_user;
                   execute immediate v_sql;
           end if;
    end loop;



    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130120 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-3-2'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130120;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130120 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130120!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130130
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130130(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_KJAXUSER varchar2,
						  v_TASK varchar2,
                                                  v_P001     varchar2,
                                                  v_P002     varchar2,
                                                  v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;
begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

    select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from krcs.t_sys_t024
   where a011 = 1009002
     and p001 = 1130130
     and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'E1-7-3ȯҵϸܱ';
    return;
  end if;

  delete from t_csrc0707_e1_7_3
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into t_csrc0707_e1_7_3
    (BBQ, USERID, BTYPE, OPTION1, SHTAG, ISHJ, A4, B4, C4, D4, E4, F4, G4)
    select BBQ,
           v_USER,
           BTYPE,
           OPTION1,
           SHTAG,
           ISHJ,
           A4,
           B4,
           C4,
           D4,
           E4,
           F4,
           G4
      from t_csrc0707_e1_7_3
     where BBQ = v_P001
       and ishj = 0
       and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
     order by G4 asc;

  --ϼ
  insert into t_csrc0707_e1_7_3
    (BBQ, USERID, BTYPE, OPTION1, SHTAG, ISHJ, A4, B4, C4, D4, E4, F4, G4)
    select BBQ,
           v_USER,
           0,
           null,
           0,
           1,
           null,
           null,
           sum(C4),
           sum(D4),
           sum(E4),
           sum(F4),
           sum(G4)
      from t_csrc0707_e1_7_3
     where BBQ = v_P001
       and ishj = 0
       and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
     group by bbq;

  update krcs.t_sys_t014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1130130
     and a008 = v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>E1-4' || A004 || '</font>'
    INTO v_temp
    FROM krcs.t_sys_t004
   WHERE P001 = 1130130;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.t_sys_t014
       SET A010 = 1015002
     WHERE P001 = 1130130
       and a008 = v_org;
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1130130!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130140
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130140(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130140
       and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

      if v_count > 0  then
       errcode:=0;
       errmsg:='֤ȯ˾ʻרܱ-ϸδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0707_E1_8_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0707_E1_8_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
           ISHJ,
           A3 ,
           B3 ,
           C3 ,
           D3 ,
           E3 ,
           F3 ,
           G3,
           H3,
           I3,
           J3,
           K3,
           L3,
           M3,
           N3,
           O3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           null,
           ISHJ,
           A3 ,
           B3 ,
           C3 ,
           D3 ,
           E3 ,
           F3 ,
           G3,
           H3,
           I3,
           J3,
           K3,
           L3,
           M3,
           N3,
           O3
        from T_CSRC0707_E1_8_1
        where BBQ = v_P001
          and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.t_sys_t014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130140 and a008 = v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-8-1'||A004||'</font>' INTO v_temp FROM krcs.t_sys_t004 WHERE P001 = 1130140 ;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.t_sys_t014 SET A010=1015002 WHERE P001=1130140 and a008 = v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130140!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130150
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130150(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_KJAXUSER varchar2,
              v_TASK varchar2,
                                                  v_P001     varchar2,
                                                  v_P002     varchar2,
                                                  v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;
begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from krcs.t_sys_t024
   where a011 = 1009002
     and p001 = 1130150
     and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  if v_count > 0 then
    errcode := 0;
    errmsg  := 'E1-8-2֤ȯ˾ʻרܱ-ܱ';
    return;
  end if;

  delete from t_csrc0707_e1_8_2
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into t_csrc0707_e1_8_2
    (BBQ,
     USERID,
     BTYPE,
     OPTION1,
     SHTAG,
     ISHJ,
     A3,
     B3,
     C3,
     D3,
     E3,
     F3,
     G3,
     H3,
     I3,
     J3,
     K3,
     L3,
     M3,
     N3,
     O3,
     P3,
     Q3,
     R3,
     S3)
    select BBQ,
           v_USER,
           BTYPE,
           OPTION1,
           SHTAG,
           ISHJ,
           A3,
           B3,
           C3,
           D3,
           E3,
           F3,
           G3,
           H3,
           I3,
           J3,
           K3,
           L3,
           M3,
           N3,
           O3,
           P3,
           Q3,
           R3,
           S3
      from t_csrc0707_e1_8_2
     where BBQ = v_P001
       and ishj = 0
       and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

     insert into t_csrc0707_e1_8_2(BBQ,userid,btype,shtag,ishj,A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3)
          select v_P001,v_USER,0,0, '1',null,null,sum(C3),sum(D3),sum(E3),sum(F3),sum(G3),sum(H3),sum(I3),
          sum(J3),sum(K3),sum(L3),sum(M3),sum(N3),sum(O3),sum(P3),sum(Q3),sum(R3),sum(S3) from t_csrc0707_e1_8_2
          where ishj = 0 and bbq = v_P001 and userid = v_USER;
      commit;

  update krcs.t_sys_t014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1130150
     and a008 = v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>E1-8-2' || A004 || '</font>'
    INTO v_temp
    FROM krcs.t_sys_t004
   WHERE P001 = 1130150 ;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.t_sys_t014
       SET A010 = 1015002
     WHERE P001 = 1130150
       and a008 = v_org;
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1130150!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130160
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130160(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_KJAXUSER varchar2,
						  v_TASK varchar2,
                                                  v_P001     varchar2,
                                                  v_P002     varchar2,
                                                  v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;
begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

   select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from krcs.t_sys_t024
   where a011 = 1009002
     and p001 = 1130160
     and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  if v_count > 0 then
    errcode := 0;
    errmsg  := 'E1_9֤ȯ˾ֱͶҵ¶ȱδͨ,ϲδ';
    return;
  end if;

  delete from t_csrc0730_e1_9
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into t_csrc0730_e1_9
    (BBQ,
     USERID,
     BTYPE,
     OPTION1,
     SHTAG,
     ISHJ,
     A2,
     B2,
     C2,
     D2,
     E2,
     F2,
     G2,
     H2,
     I2,
     J2,
     K2,
     L2,
     M2,
     N2,
     O2,
     P2

     )
    select BBQ,
           v_USER,
           BTYPE,
           OPTION1,
           SHTAG,
           ISHJ,
           A2,
           B2,
           C2,
           D2,
           E2,
           F2,
           G2,
           H2,
           I2,
           J2,
           K2,
           L2,
           M2,
           N2,
           O2,
           P2
      from t_csrc0730_e1_9
     where BBQ = v_P001
     and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update krcs.t_sys_t014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1130160 and a008 = v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>E1_9' || A004 || '</font>'
    INTO v_temp
    FROM krcs.t_sys_t004
   WHERE P001 = 1130160;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.t_sys_t014 SET A010 = 1015002 WHERE P001 = 1130160 and a008 = v_org;
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1130160!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130170
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130170(errcode    out int,
                                                  errmsg     out varchar2,
                                                  v_KJAXUSER varchar2,
						  v_TASK varchar2,
                                                  v_P001     varchar2,
                                                  v_P002     varchar2,
                                                  v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;
begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from krcs.t_sys_t024
   where a011 = 1009002
     and p001 = 1130170
     and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  if v_count > 0 then
    errcode := 0;
    errmsg  := 'E1_10֤ȯ˾Ͷҵ¶ȱδͨ,ϲδ';
    return;
  end if;

  delete from t_csrc0730_e1_10
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into t_csrc0730_e1_10
    (BBQ,
     USERID,
     BTYPE,
     OPTION1,
     SHTAG,
     ISHJ,
     A2,
     B2,
     C2,
     D2,
     E2,
     F2,
     G2,
     H2,
     I2,
     J2,
     K2,
     L2)
    select BBQ,
           v_USER,
           BTYPE,
           OPTION1,
           SHTAG,
           ISHJ,
           A2,
           B2,
           C2,
           D2,
           E2,
           F2,
           G2,
           H2,
           I2,
           J2,
           K2,
           L2
      from t_csrc0730_e1_10
     where BBQ = v_P001
       and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update krcs.t_sys_t014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1130170 and a008 = v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>E1_10' || A004 || '</font>'
    INTO v_temp
    FROM krcs.t_sys_t004
   WHERE P001 = 1130170;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update krcs.t_sys_t014 SET A010 = 1015002 WHERE P001 = 1130170 and a008 = v_org;
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1130170!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130180
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130180(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130180
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='֤ȯ˾μծ¶ȱμծȯδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0624_e1_11_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0624_e1_11_1(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2,
            J2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2,
            J2
        from t_csrc0624_e1_11_1
        where BBQ = v_P001 and ishj=0
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

   insert into t_csrc0624_e1_11_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,E2,F2,H2,I2)
    select v_P001,v_USER,0,null,null,1,
    sum(E2),sum(F2),sum(H2),sum(I2)
  from t_csrc0624_e1_11_1
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130180 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-11-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1130180 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1130180 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130180!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1130190
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1130190(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

	  select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1130190
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='֤ȯ˾μծ¶ȱμծδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0624_e1_11_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into t_csrc0624_e1_11_2(
            BBQ     ,
            USERID  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2
            )
   select   BBQ     ,
            v_USER  ,
            BTYPE   ,
            OPTION1 ,
            SHTAG   ,
            ishj,
            A2,
            B2,
            C2,
            D2,
            E2,
            F2,
            G2,
            H2,
            I2
        from t_csrc0624_e1_11_2
        where BBQ = v_P001 and ishj=0
        and userid in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

   insert into t_csrc0624_e1_11_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,E2,F2,H2,I2)
    select v_P001,v_USER,0,null,null,1,
    sum(E2),sum(F2),sum(H2),sum(I2)
  from t_csrc0624_e1_11_2
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1130190 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>E1-11-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1130190 ;
    INSERT INTO krcs.T_SYS_LOG(P001, P002, A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

   exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1130190 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1130190!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1131010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1131010(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_USERNAME varchar(200);
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1131010;

  select T2.A002,T2.A003
    into v_USER,v_USERNAME
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0619_F_XXB
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into t_csrc0619_f_xxb(
              BBQ    ,
              USERID ,
              BTYPE  ,
              OPTION1,
              SHTAG  ,
              upid   ,
              username,
              B2     ,
              D2     ,
              B3     ,
              B4     ,
              D4     ,
              B5     ,
              D5     ,
              B6     ,
              B7     ,
              D7     ,
              B8     ,
              D8     ,
              B9     ,
              B10    ,
              D10    ,
              B11    ,
              D11    ,
              B12    ,
              D12    ,
              B13    ,
              D13    ,
              B14    ,
              D14    ,
              B15    ,
              D15    ,
              B16    ,
              D16    ,
              B17    ,
              D17
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           '--'   ,
              v_username,
              B2     ,
              D2     ,
              B3     ,
              B4     ,
              D4     ,
              B5     ,
              D5     ,
              B6     ,
              B7     ,
              D7     ,
              B8     ,
              D8     ,
              B9     ,
              B10    ,
              D10    ,
              B11    ,
              D11    ,
              B12    ,
              D12    ,
              B13    ,
              D13    ,
              B14    ,
              D14    ,
              B15    ,
              D15    ,
              B16    ,
              D16    ,
              B17    ,
              D17
        from t_csrc0619_f_xxb
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1131020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1131020(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1131020;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0619_F1_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into t_csrc0619_f1_1(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A3      ,
              B3      ,
              C3      ,
              D3      ,
              E3      ,
              F3      ,
              G3      ,
              H3      ,
              I3      ,
              J3      ,
              K3      ,
              L3      ,
              M3

          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3      ,
              B3      ,
              C3      ,
              D3      ,
              E3      ,
              F3      ,
              G3      ,
              H3      ,
              I3      ,
              J3      ,
              K3      ,
              L3      ,
              M3
        from t_csrc0619_f1_1
        where BBQ = v_P001 and ISHJ=0
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
        commit;

        --ϼֵ
    insert into t_csrc0619_f1_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    F3)
    select v_P001,v_USER,0,null,null,1,
   SUM(F3)
      from t_csrc0619_f1_1
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1131030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1131030(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1131030;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0619_F1_2
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into t_csrc0619_f1_2(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A3      ,
              B3      ,
              C3      ,
              D3      ,
              E3      ,
              F3      ,
              G3      ,
              H3      ,
              I3      ,
              J3      ,
              K3      ,
              L3      ,
              M3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3      ,
              B3      ,
              C3      ,
              D3      ,
              E3      ,
              F3      ,
              G3      ,
              H3      ,
              I3      ,
              J3      ,
              K3      ,
              L3      ,
              M3

        from t_csrc0619_f1_2
        where BBQ = v_P001 and ISHJ=0 and
 userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  commit;

 --ϼֵ
    insert into t_csrc0619_f1_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    F3)
    select v_P001,v_USER,0,null,null,1,
   SUM(F3)
      from t_csrc0619_f1_2
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1131040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1131040(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1131040;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0619_F2_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into t_csrc0619_f2_1(
                BBQ    ,
                USERID ,
                BTYPE  ,
                OPTION1,
                SHTAG  ,
                ISHJ   ,
                A3     ,
                B3     ,
                C3     ,
                D3     ,
                E3     ,
                F3     ,
                G3     ,
                H3     ,
                I3     ,
                J3     ,
                K3     ,
                L3,
                M3,
                N3,
                O3,
                P3,
                Q3,
                R3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3     ,
                B3     ,
                C3     ,
                D3     ,
                E3     ,
                F3     ,
                G3     ,
                H3     ,
                I3     ,
                J3     ,
                K3    ,
                L3,
                M3,
                N3,
                O3,
                P3,
                Q3,
                R3
        from t_csrc0619_f2_1
        where BBQ = v_P001 and ISHJ=0 and  userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     commit;

    --ϼֵ
    insert into t_csrc0619_f2_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    O3,P3,Q3)
    select v_P001,v_USER,0,null,null,1,
   SUM(O3),SUM(P3),SUM(Q3)
      from t_csrc0619_f2_1
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1131050
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1131050(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1131050;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0619_F2_2
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into t_csrc0619_f2_2(
                BBQ    ,
                USERID ,
                BTYPE  ,
                OPTION1,
                SHTAG  ,
                ISHJ   ,
                A2     ,
                B2     ,
                C2     ,
                D2     ,
                E2     ,
                F2     ,
                G2     ,
                H2     ,
                I2     ,
                J2     ,
                K2     ,
                L2     ,
                M2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A2     ,
                B2     ,
                C2     ,
                D2     ,
                E2     ,
                F2     ,
                G2     ,
                H2     ,
                I2     ,
                J2     ,
                K2     ,
                L2     ,
                M2
        from t_csrc0619_f2_2
        where BBQ = v_P001 and ISHJ=0 and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

        commit;

        --ϼֵ
    insert into t_csrc0619_f2_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    K2)
    select v_P001,v_USER,0,null,null,1,
   SUM(K2)
      from t_csrc0619_f2_2
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132010(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_USERNAME varchar(200);
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132010;

  select T2.A002,T2.A003
    into v_USER,v_USERNAME
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_XXB
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC0811_ZQGS_XXB(
              BBQ    ,
              USERID ,
              BTYPE  ,
              OPTION1,
              SHTAG  ,
              upid   ,
              username,
              B2     ,
              B3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
           '--'   ,
              v_username,
              B2     ,
              B3
        from T_CSRC0811_ZQGS_XXB
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132020(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132020;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_1(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              C2,D2,E2,F2,G2,C3,D3,E3,F3,G3,C4,D4,E4,F4,G4,C5,D5,E5,G5,F5,C6,D6,E6,F6,G6,
              D8,D9,D10,D12,E12,D13,E13,D14,E14,D15,E15,D16,E16,D17,E17,D18,E18,D19,E19,D20,E20,D21,E21,
              D23,E23,D24,E24,D26,E26,D27,D28,D29,D30,D31,D32,D33,D34,D35,D36,D37,D38,D39,D40,D41,D42,D44,D45,D46,D47,D48,
              D50,D51,D52,D53,D54,D55,D56,D57,D59,D60,D61,D62,D63,D64,D65,D66,D68,E68,F68,G68,H68,I68,D69,E69,F69,G69,H69,I69,
              D71,E71,F71,G71,H71,D73,D74,D75,D77,D78,D80,E80,F80,G80,H80,I80,D81,
              A83,D83,E83,F83,G83,H83,A84,D84,E84,F84,G84,H84,A85,D85,E85,F85,G85,H85,A86,D86,E86,F86,G86,H86
              )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           C2,D2,E2,F2,G2,C3,D3,E3,F3,G3,C4,D4,E4,F4,G4,C5,D5,E5,G5,F5,C6,D6,E6,F6,G6,
           D8,D9,D10,D12,E12,D13,E13,D14,E14,D15,E15,D16,E16,D17,E17,D18,E18,D19,E19,D20,E20,D21,E21,
           D23,E23,D24,E24,D26,E26,D27,D28,D29,D30,D31,D32,D33,D34,D35,D36,D37,D38,D39,D40,D41,D42,D44,D45,D46,D47,D48,
           D50,D51,D52,D53,D54,D55,D56,D57,D59,D60,D61,D62,D63,D64,D65,D66,D68,E68,F68,G68,H68,I68,D69,E69,F69,G69,H69,I69,
           D71,E71,F71,G71,H71,D73,D74,D75,D77,D78,D80,E80,F80,G80,H80,I80,D81,
           A83,D83,E83,F83,G83,H83,A84,D84,E84,F84,G84,H84,A85,D85,E85,F85,G85,H85,A86,D86,E86,F86,G86,H86
        from T_CSRC0811_ZQGS_1
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
        commit;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132030(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132030;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_2_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_2_1(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2,S2,T2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2,S2,T2
        from T_CSRC0811_ZQGS_2_1
        where BBQ = v_P001 and ISHJ=0 and
 userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  commit;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132040(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132040;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_2_2
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_2_2(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3
        from T_CSRC0811_ZQGS_2_2
        where BBQ = v_P001 and ISHJ=0 and
 userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  commit;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132050
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132050(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132050;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_2_3
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_2_3(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2
        from T_CSRC0811_ZQGS_2_3
        where BBQ = v_P001 and ISHJ=0 and  userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     commit;

    --ϼֵ
    insert into T_CSRC0811_ZQGS_2_3(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2)
    select v_P001,v_USER,0,null,null,1,null,null,sum(C2),sum(D2),sum(E2),sum(F2),null,sum(H2),sum(I2),null,sum(K2),null,null,null,null,null,null,null
      from T_CSRC0811_ZQGS_2_3
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132060
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132060(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132060;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_2_4
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_2_4(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              D1,D2,D3,D4,D5,D6,D7,D8,D9,D11,D12,D13,D14,D15,D16,D18,D19,D20,D21,D22,D23,D24,
              D25,D26,D27,D28,D29,D30,D31,D32,D33,D34,D35,D36,D37,D38,D39,D40,D41,D42,D43,D44,
              D45,D46,D47,D48,D49,D50,D51,D52,D53,D54,D55,D56,D57,D58,D60,D61,D62,D63,D64,D65,
              D66,D67,D69,D70,D71,D72,D73,D74,D75,D76,D78,D79,D80,D81,D82,D84,D85,D86,D87,D88,
              D90,D91,D92,D93,D94
              )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           D1,D2,D3,D4,D5,D6,D7,D8,D9,D11,D12,D13,D14,D15,D16,D18,D19,D20,D21,D22,D23,D24,
           D25,D26,D27,D28,D29,D30,D31,D32,D33,D34,D35,D36,D37,D38,D39,D40,D41,D42,D43,D44,
           D45,D46,D47,D48,D49,D50,D51,D52,D53,D54,D55,D56,D57,D58,D60,D61,D62,D63,D64,D65,
           D66,D67,D69,D70,D71,D72,D73,D74,D75,D76,D78,D79,D80,D81,D82,D84,D85,D86,D87,D88,
           D90,D91,D92,D93,D94
        from T_CSRC0811_ZQGS_2_4
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
        commit;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132070
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132070(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132070;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_3
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC0811_ZQGS_3(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2,S2,T2,U2,V2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2,S2,T2,U2,V2
        from T_CSRC0811_ZQGS_3
        where BBQ = v_P001 and ISHJ=0 and  userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     commit;

    --ϼֵ
   insert into T_CSRC0811_ZQGS_3(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2,S2,T2,U2,V2)
    select v_P001,v_USER,0,null,null,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,sum(Q2),null,sum(S2),null,null,null
      from T_CSRC0811_ZQGS_3
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132080
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132080(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132080;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_3_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_3_1(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3
        from T_CSRC0811_ZQGS_3_1
        where BBQ = v_P001 and ISHJ=0 and  userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     commit;

    --ϼֵ
    insert into T_CSRC0811_ZQGS_3_1(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3)
    select v_P001,v_USER,0,null,null,1,null,null,null,null,null,null,null,sum(H3),sum(I3),sum(J3),sum(K3),sum(L3),sum(M3),null
      from T_CSRC0811_ZQGS_3_1
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132090
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132090(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132090;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_3_2
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_3_2(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A2,B2,C2,D2,E2,F2,G2,H2,I2,J2
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A2,B2,C2,D2,E2,F2,G2,H2,I2,J2
        from T_CSRC0811_ZQGS_3_2
        where BBQ = v_P001 and ISHJ=0 and  userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     commit;

    --ϼֵ
     insert into T_CSRC0811_ZQGS_3_2(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    A2,B2,C2,D2,E2,F2,G2,H2,I2,J2)
    select v_P001,v_USER,0,null,null,1,null,null,null,null,null,null,null,sum(H2),sum(I2),null
      from T_CSRC0811_ZQGS_3_2
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132100
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132100(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132100;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_4
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_4(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              B3,B4,B5,B6,B7,B9,B10,B11,B12,B13,B15,A17,B17,C17,D17,A18,B18,C18,D18,
              A19,B19,C19,D19,A20,B20,C20,D20,A21,B21,C21,D21,A22,B22,C22,D22,A23,B23,
              C23,D23,A24,B24,C24,D24,A25,B25,C25,D25,A26,B26,C26,D26,A27,B27,C27,D27,
              A28,B28,C28,D28,A29,B29,C29,D29,A30,B30,C30,D30,A31,B31,C31,D31,A32,B32,
              C32,D32,A33,B33,C33,D33,A34,B34,C34,D34,A35,B35,C35,D35,A36,B36,C36,D36,
              A37,B37,C37,D37,A38,B38,C38,D38,A39,B39,C39,D39,A40,B40,C40,D40,A41,B41,
              C41,D41,A42,B42,C42,D42,A43,B43,C43,D43,A44,B44,C44,D44
              )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           B3,B4,B5,B6,B7,B9,B10,B11,B12,B13,B15,A17,B17,C17,D17,A18,B18,C18,D18,
           A19,B19,C19,D19,A20,B20,C20,D20,A21,B21,C21,D21,A22,B22,C22,D22,A23,B23,
           C23,D23,A24,B24,C24,D24,A25,B25,C25,D25,A26,B26,C26,D26,A27,B27,C27,D27,
           A28,B28,C28,D28,A29,B29,C29,D29,A30,B30,C30,D30,A31,B31,C31,D31,A32,B32,
           C32,D32,A33,B33,C33,D33,A34,B34,C34,D34,A35,B35,C35,D35,A36,B36,C36,D36,
           A37,B37,C37,D37,A38,B38,C38,D38,A39,B39,C39,D39,A40,B40,C40,D40,A41,B41,
           C41,D41,A42,B42,C42,D42,A43,B43,C43,D43,A44,B44,C44,D44
        from T_CSRC0811_ZQGS_4
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
        commit;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132110
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132110(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132110;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_5
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_5(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              C2,G2,K2,O2,C4,E4,G4,I4,K4,M4,O4,Q4,C5,E5,G5,I5,K5,M5,O5,Q5,C6,E6,
              G6,I6,K6,M6,O6,Q6,C7,E7,G7,I7,K7,M7,O7,Q7,C8,E8,G8,I8,K8,M8,O8,Q8,
              C9,E9,G9,I9,K9,M9,O9,Q9,C10,G10,K10,O10,C11,G11,K11,O11,C12,E12,G12,
              I12,K12,M12,O12,Q12,C13,E13,G13,I13,K13,M13,O13,Q13,C14,E14,G14,I14,
              K14,M14,O14,Q14,C15,E15,G15,I15,K15,M15,O15,Q15,C16,E16,G16,I16,K16,
              M16,O16,Q16,C17,E17,G17,I17,K17,M17,O17,Q17,C18,E18,G18,I18,K18,M18,
              O18,Q18,C19,E19,G19,I19,K19,M19,O19,Q19,C20,E20,G20,I20,K20,M20,O20,
              Q20,C21,E21,G21,I21,K21,M21,O21,Q21,C22,E22,G22,I22,K22,M22,O22,Q22,
              C23,E23,G23,I23,K23,M23,O23,Q23,C24,E24,G24,I24,K24,M24,O24,Q24,C25,
              E25,G25,I25,K25,M25,O25,Q25,C26,E26,G26,I26,K26,M26,O26,Q26,C27,E27,
              G27,I27,K27,M27,O27,Q27,C28,E28,G28,I28,K28,M28,O28,Q28,C29,E29,G29,
              I29,K29,M29,O29,Q29,C30,E30,G30,I30,K30,M30,O30,Q30,C31,E31,G31,I31,
              K31,M31,O31,Q31,C32,E32,G32,I32,K32,M32,O32,Q32,C33,E33,G33,I33,K33,
              M33,O33,Q33,C34,E34,G34,I34,K34,M34,O34,Q34,C35,E35,G35,I35,K35,M35,
              O35,Q35,C36,E36,G36,I36,K36,M36,O36,Q36,C37,E37,G37,I37,K37,M37,O37,
              Q37,C38,E38,G38,I38,K38,M38,O38,Q38,C39,E39,G39,I39,K39,M39,O39,Q39,
              C41,E41,G41,I41,K41,M41,O41,Q41,C42,E42,G42,I42,K42,M42,O42,Q42,C43,
              E43,G43,I43,K43,M43,O43,Q43,C44,E44,G44,I44,K44,M44,O44,Q44,C45,E45,
              G45,I45,K45,M45,O45,Q45
              )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           C2,G2,K2,O2,C4,E4,G4,I4,K4,M4,O4,Q4,C5,E5,G5,I5,K5,M5,O5,Q5,C6,E6,
           G6,I6,K6,M6,O6,Q6,C7,E7,G7,I7,K7,M7,O7,Q7,C8,E8,G8,I8,K8,M8,O8,Q8,
           C9,E9,G9,I9,K9,M9,O9,Q9,C10,G10,K10,O10,C11,G11,K11,O11,C12,E12,G12,
           I12,K12,M12,O12,Q12,C13,E13,G13,I13,K13,M13,O13,Q13,C14,E14,G14,I14,
           K14,M14,O14,Q14,C15,E15,G15,I15,K15,M15,O15,Q15,C16,E16,G16,I16,K16,
           M16,O16,Q16,C17,E17,G17,I17,K17,M17,O17,Q17,C18,E18,G18,I18,K18,M18,
           O18,Q18,C19,E19,G19,I19,K19,M19,O19,Q19,C20,E20,G20,I20,K20,M20,O20,
           Q20,C21,E21,G21,I21,K21,M21,O21,Q21,C22,E22,G22,I22,K22,M22,O22,Q22,
           C23,E23,G23,I23,K23,M23,O23,Q23,C24,E24,G24,I24,K24,M24,O24,Q24,C25,
           E25,G25,I25,K25,M25,O25,Q25,C26,E26,G26,I26,K26,M26,O26,Q26,C27,E27,
           G27,I27,K27,M27,O27,Q27,C28,E28,G28,I28,K28,M28,O28,Q28,C29,E29,G29,
           I29,K29,M29,O29,Q29,C30,E30,G30,I30,K30,M30,O30,Q30,C31,E31,G31,I31,
           K31,M31,O31,Q31,C32,E32,G32,I32,K32,M32,O32,Q32,C33,E33,G33,I33,K33,
           M33,O33,Q33,C34,E34,G34,I34,K34,M34,O34,Q34,C35,E35,G35,I35,K35,M35,
           O35,Q35,C36,E36,G36,I36,K36,M36,O36,Q36,C37,E37,G37,I37,K37,M37,O37,
           Q37,C38,E38,G38,I38,K38,M38,O38,Q38,C39,E39,G39,I39,K39,M39,O39,Q39,
           C41,E41,G41,I41,K41,M41,O41,Q41,C42,E42,G42,I42,K42,M42,O42,Q42,C43,
           E43,G43,I43,K43,M43,O43,Q43,C44,E44,G44,I44,K44,M44,O44,Q44,C45,E45,
           G45,I45,K45,M45,O45,Q45
        from T_CSRC0811_ZQGS_5
        where BBQ = v_P001
        and userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
        commit;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132120
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132120(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132120;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_6
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_6(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3
        from T_CSRC0811_ZQGS_6
        where BBQ = v_P001 and ISHJ=0 and
 userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  commit;

  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1132130
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1132130(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_reportid number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  v_reportid := 1132130;

  select T2.A002
    into v_USER
    from  KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

  --õ˻
   select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;
   select count(*) into v_count
     from krcs.t_sys_t024
     where a011=1009002
       and p001=v_reportid
       and a008 in (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
   if v_count > 0  then
      errcode:=0;
      errmsg:=v_temp||'δͨ,ϲδ';
      return;
   end if;

  delete from T_CSRC0811_ZQGS_7
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC0811_ZQGS_7(
              BBQ     ,
              USERID  ,
              BTYPE   ,
              OPTION1 ,
              SHTAG   ,
              ISHJ    ,
              A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3,AB3
          )
   select  BBQ,
           v_USER,
           0,
           null,
           1,
           0,
           A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3,AB3
        from T_CSRC0811_ZQGS_7
        where BBQ = v_P001 and ISHJ=0 and  userid in  (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
     commit;

    --ϼֵ
     insert into T_CSRC0811_ZQGS_7(BBQ,USERID,BTYPE,Option1,Shtag,Ishj,
    A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,AA3,AB3)
    select v_P001,v_USER,0,null,null,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,sum(S3),sum(T3),sum(U3),sum(V3),null,null,null,null,null,null
      from T_CSRC0811_ZQGS_7
     where BBQ=v_P001 and USERID=v_USER and ISHJ=0;


  update  KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,a020=v_KJAXUSER
   WHERE P001 = v_reportid;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>'||A005|| A004 || '</font>'
    INTO v_temp
    FROM  KRCS.T_SYS_T004
   WHERE P001 = v_reportid;
  INSERT INTO KRCS.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = v_reportid and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_mergereport_'||v_reportid||'!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1135010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1135010(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1135010
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='G-1 ָڻͶδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0225_g_1 WHERE BBQ=v_P001 and USERID=v_USER; commit; /* ɾͬһڵ */

   insert into t_csrc0225_g_1(
            BBQ ,
            USERID ,
            BTYPE  ,
            OPTION1 ,
            SHTAG  ,
            ISHJ  ,
            A3   ,
            B3   ,
            C3  ,
            D3   ,
            E3    ,
            F3     ,
            G3    ,
            H3     ,
            I3     ,
            J3     ,
            K3     ,
            L3     ,
            M3     ,
            N3     ,
            O3     ,
            P3     ,
            Q3     ,
            R3     ,
            S3     ,
            T3
          )

   select   BBQ ,
            v_USER ,
            0  ,
            NULL ,
            1  ,
            0  ,
            A3   ,
            B3   ,
            C3  ,
            D3   ,
            E3    ,
            F3     ,
            G3    ,
            H3     ,
            I3     ,
            J3     ,
            K3     ,
            L3     ,
            M3     ,
            N3     ,
            O3     ,
            P3     ,
            Q3     ,
            R3     ,
            S3     ,
            T3
        from t_csrc0225_g_1
        where BBQ = v_P001
        and ishj = 0
        and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


        --ϼ
        insert into t_csrc0225_g_1(
            BBQ ,
            USERID ,
            BTYPE  ,
            OPTION1 ,
            SHTAG  ,
            ISHJ  ,
            A3   ,
            B3   ,
            C3  ,
            D3   ,
            E3    ,
            F3     ,
            G3    ,
            H3     ,
            I3     ,
            J3     ,
            K3     ,
            L3     ,
            M3     ,
            N3     ,
            O3     ,
            P3     ,
            Q3     ,
            R3     ,
            S3     ,
            T3
          )
         select v_p001 ,
                v_USER ,
                0  ,
                NULL ,
                NULL  ,
                1  ,
                NULL   ,
                NULL   ,
                sum(C3)  ,
                sum(D3)   ,
                sum(E3)   ,
                sum(F3)    ,
                sum(G3)  ,
                sum(H3)   ,
                sum(I3)   ,
                sum(J3)  ,
                sum(K3)  ,
                sum(L3)  ,
                sum(M3)  ,
                sum(N3)  ,
                sum(O3)  ,
                sum(P3)  ,
                sum(Q3)   ,
                sum(R3)   ,
                sum(S3)   ,
                sum(T3)
           from t_csrc0225_g_1
        where BBQ = v_P001
        and ishj = 0
        and userid = v_USER
        group by bbq;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1135010 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>G-01'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1135010;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1135010 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_1135010!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1135020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1135020(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1135020
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='G-2 ָڻͶδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0225_g_2 WHERE BBQ=v_P001 and USERID=v_USER; commit; /* ɾͬһڵ */

   insert into t_csrc0225_g_2(
            BBQ     ,
	  USERID  ,
	  BTYPE   ,
	  OPTION1 ,
	  SHTAG   ,
	  ISHJ    ,
	  A3     ,
	  B3      ,
	  C3      ,
	  D3      ,
	  E3      ,
	  F3      ,
	  G3     ,
	  H3      ,
	  I3     ,
	  J3      ,
	  K3     ,
	  L3     ,
	  M3     ,
	  N3      ,
	  O3      ,
	  P3      ,
	  Q3      ,
	  R3      ,
	  S3     ,
	  T3      ,
	  U3
          )

   select   BBQ ,
            v_USER ,
            0  ,
            NULL ,
            1  ,
            0  ,
           A3     ,
	  B3      ,
	  C3      ,
	  D3      ,
	  E3      ,
	  F3      ,
	  G3     ,
	  H3      ,
	  I3     ,
	  J3      ,
	  K3     ,
	  L3     ,
	  M3     ,
	  N3      ,
	  O3      ,
	  P3      ,
	  Q3      ,
	  R3      ,
	  S3     ,
	  T3      ,
	  U3
        from t_csrc0225_g_2
        where BBQ = v_P001
        and ishj = 0
        and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


        --ϼ
        insert into t_csrc0225_g_2(
            BBQ ,
            USERID ,
            BTYPE  ,
            OPTION1 ,
            SHTAG  ,
            ISHJ  ,
           A3     ,
	  B3      ,
	  C3      ,
	  D3      ,
	  E3      ,
	  F3      ,
	  G3     ,
	  H3      ,
	  I3     ,
	  J3      ,
	  K3     ,
	  L3     ,
	  M3     ,
	  N3      ,
	  O3      ,
	  P3      ,
	  Q3      ,
	  R3      ,
	  S3     ,
	  T3      ,
	  U3
          )
         select v_p001 ,
                v_USER ,
                0  ,
                NULL ,
                NULL  ,
                1  ,
                NULL   ,
                NULL   ,
                NULL  ,
                NULL   ,
                sum(E3)   ,
                sum(F3)    ,
                sum(G3)  ,
                sum(H3)   ,
                sum(I3)   ,
                sum(J3)  ,
                sum(K3)  ,
                sum(L3)  ,
                sum(M3)  ,
                sum(N3)  ,
                sum(O3)  ,
                sum(P3)  ,
                sum(Q3)   ,
                sum(R3)   ,
                sum(S3)   ,
                sum(T3),
		sum(U3)
           from t_csrc0225_g_2
        where BBQ = v_P001
        and ishj = 0
        and userid = v_USER
        group by bbq;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1135020 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>G-02'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1135020;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1135020 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_1135020!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1135030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1135030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1135030
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='G-3 ָڻͶδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0225_g_3 WHERE BBQ=v_P001 and USERID=v_USER; commit; /* ɾͬһڵ */

   insert into t_csrc0225_g_3(
            BBQ     ,
    USERID  ,
    BTYPE   ,
    OPTION1 ,
    SHTAG   ,
    ISHJ    ,
    A3     ,
    B3      ,
    C3      ,
    D3      ,
    E3      ,
    F3      ,
    G3     ,
    H3      ,
    I3     ,
    J3      ,
    K3     ,
    L3     ,
    M3     ,
    N3      ,
    O3      ,
    P3      ,
    Q3      ,
    R3      ,
    S3     ,
    T3      ,
    U3 ,
    V3
          )

   select   BBQ ,
            v_USER ,
            0  ,
            NULL ,
            1  ,
            0  ,
           A3     ,
    B3      ,
    C3      ,
    D3      ,
    E3      ,
    F3      ,
    G3     ,
    H3      ,
    I3     ,
    J3      ,
    K3     ,
    L3     ,
    M3     ,
    N3      ,
    O3      ,
    P3      ,
    Q3      ,
    R3      ,
    S3     ,
    T3      ,
    U3    ,
    V3
        from t_csrc0225_g_3
        where BBQ = v_P001
        and ishj = 0
        and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


        --ϼ
        insert into t_csrc0225_g_3(
            BBQ ,
            USERID ,
            BTYPE  ,
            OPTION1 ,
            SHTAG  ,
            ISHJ  ,
           A3     ,
    B3      ,
    C3      ,
    D3      ,
    E3      ,
    F3      ,
    G3     ,
    H3      ,
    I3     ,
    J3      ,
    K3     ,
    L3     ,
    M3     ,
    N3      ,
    O3      ,
    P3      ,
    Q3      ,
    R3      ,
    S3     ,
    T3      ,
    U3  ,
    V3
          )
         select v_p001 ,
                v_USER ,
                0  ,
                NULL ,
                NULL  ,
                1  ,
                NULL   ,
                NULL   ,
                NULL  ,
                NULL   ,
                sum(E3)   ,
                sum(F3)    ,
                sum(G3)  ,
                sum(H3)   ,
                sum(I3)   ,
                sum(J3)  ,
                sum(K3)  ,
                sum(L3)  ,
                sum(M3)  ,
                sum(N3)  ,
                sum(O3)  ,
                sum(P3)  ,
                sum(Q3)   ,
                sum(R3)   ,
                sum(S3)   ,
                sum(T3),
    sum(U3),
    sum(V3)
           from t_csrc0225_g_3
        where BBQ = v_P001
        and ishj = 0
        and userid = v_USER
        group by bbq;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1135030 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>G-03'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1135030;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1135030 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_1135030!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1135040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1135040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;
begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

      select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

      select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1135040
      and a008 in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='G-4 ָڻͶδͨ,ϲδ';
       return;
      end if;

       delete from t_csrc0225_g_4 WHERE BBQ=v_P001 and USERID=v_USER; commit; /* ɾͬһڵ */

   insert into t_csrc0225_g_4(
            BBQ     ,
    USERID  ,
    BTYPE   ,
    OPTION1 ,
    SHTAG   ,
    ISHJ    ,
    A3     ,
    B3      ,
    C3      ,
    D3      ,
    E3      ,
    F3      ,
    G3     ,
    H3      ,
    I3     ,
    J3      ,
    K3     ,
    L3     ,
    M3     ,
    N3      ,
    O3      ,
    P3      ,
    Q3      ,
    R3      ,
    S3     ,
    T3      ,
    U3 ,
    V3
          )

   select   BBQ ,
            v_USER ,
            0  ,
            NULL ,
            1  ,
            0  ,
           A3     ,
    B3      ,
    C3      ,
    D3      ,
    E3      ,
    F3      ,
    G3     ,
    H3      ,
    I3     ,
    J3      ,
    K3     ,
    L3     ,
    M3     ,
    N3      ,
    O3      ,
    P3      ,
    Q3      ,
    R3      ,
    S3     ,
    T3      ,
    U3    ,
    V3
        from t_csrc0225_g_4
        where BBQ = v_P001
        and ishj = 0
        and userid in(select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


        --ϼ
        insert into t_csrc0225_g_4(
            BBQ ,
            USERID ,
            BTYPE  ,
            OPTION1 ,
            SHTAG  ,
            ISHJ  ,
           A3     ,
    B3      ,
    C3      ,
    D3      ,
    E3      ,
    F3      ,
    G3     ,
    H3      ,
    I3     ,
    J3      ,
    K3     ,
    L3     ,
    M3     ,
    N3      ,
    O3      ,
    P3      ,
    Q3      ,
    R3      ,
    S3     ,
    T3      ,
    U3  ,
    V3
          )
         select v_p001 ,
                v_USER ,
                0  ,
                NULL ,
                NULL  ,
                1  ,
                NULL   ,
                NULL   ,
                NULL  ,
                NULL   ,
                sum(E3)   ,
                sum(F3)    ,
                sum(G3)  ,
                sum(H3)   ,
                sum(I3)   ,
                sum(J3)  ,
                sum(K3)  ,
                sum(L3)  ,
                sum(M3)  ,
                sum(N3)  ,
                sum(O3)  ,
                sum(P3)  ,
                sum(Q3)   ,
                sum(R3)   ,
                sum(S3)   ,
                sum(T3),
    sum(U3),
    sum(V3)
           from t_csrc0225_g_4
        where BBQ = v_P001
        and ishj = 0
        and userid = v_USER
        group by bbq;

    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1135040 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>G-04'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1135040;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

  exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1135040 and a008=v_org;
                errcode := 0;
                errmsg := 'ڴ洢cisp_mergereport_1135040!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1140010
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1140010(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

     select p002 into v_org from KRCS.T_SYS_USER  where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from KRCS.t_sys_t024
   where a011 = 1009002
     and p001 = 1140010
     and a008 in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'Z-A1-1 ʱδͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC1226_Z_A1_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

   insert into T_CSRC1226_Z_A1_1
    (BBQ,
USERID,
BTYPE,
OPTION1,
SHTAG,
M3,
N3,
P3,
Q3,
M4,
N4,
P4,
Q4,
M5,
N5,
P5,
Q5,
M6,
N6,
P6,
Q6,
M7,
N7,
P7,
Q7,
M8,
N8,
P8,
Q8,
M9,
N9,
P9,
Q9,
M10,
N10,
P10,
Q10,
M11,
N11,
P11,
Q11,
M12,
N12,
P12,
Q12,
M13,
N13,
P13,
Q13,
M14,
N14,
P14,
Q14,
M15,
N15,
P15,
Q15,
M16,
N16,
P16,
Q16,
M17,
N17,
P17,
Q17,
M18,
N18,
P18,
Q18,
M19,
N19,
P19,
Q19,
M20,
N20,
P20,
Q20,
M21,
N21,
P21,
Q21,
M22,
N22,
P22,
Q22,
M23,
N23,
P23,
Q23,
M24,
N24,
P24,
Q24,
M25,
N25,
P25,
Q25,
M26,
N26,
P26,
Q26,
M27,
N27,
P27,
Q27,
M28,
N28,
P28,
Q28,
M29,
N29,
P29,
Q29,
M30,
N30,
P30,
Q30,
M31,
N31,
P31,
Q31,
M32,
N32,
P32,
Q32,
M33,
N33,
O33,
P33,
Q33,
M34,
N34,
P34,
Q34,
M35,
N35,
P35,
Q35,
M36,
N36,
P36,
Q36,
M37,
N37,
P37,
Q37,
M38,
N38,
P38,
Q38,
M39,
N39,
P39,
Q39,
M40,
N40,
P40,
Q40,
M41,
N41,
P41,
Q41,
M42,
N42,
P42,
Q42,
M43,
N43,
P43,
Q43,
M44,
N44,
P44,
Q44,
M45,
N45,
P45,
Q45,
M46,
N46,
P46,
Q46,
M47,
N47,
P47,
Q47,
M48,
N48,
P48,
Q48,
M49,
N49,
O49,
P49,
Q49,
M50,
N50,
P50,
Q50,
M51,
N51,
P51,
Q51,
M52,
N52,
P52,
Q52,
M53,
N53,
P53,
Q53,
M54,
N54,
P54,
Q54,
M55,
N55,
P55,
Q55,
M56,
N56,
P56,
Q56,
M57,
N57,
P57,
Q57,
M58,
N58,
P58,
Q58,
M59,
N59,
P59,
Q59,
M60,
N60,
P60,
Q60,
M61,
N61,
P61,
Q61,
M62,
N62,
P62,
Q62,
M63,
N63,
P63,
Q63,
M64,
N64,
P64,
Q64,
M65,
N65,
P65,
Q65,
M66,
N66,
P66,
Q66,
M67,
N67,
P67,
Q67,
M68,
N68,
P68,
Q68,
M69,
N69,
P69,
Q69,
M70,
N70,
P70,
Q70,
M71,
N71,
P71,
Q71,
M72,
N72,
P72,
Q72,
M73,
N73,
P73,
Q73,
M74,
N74,
P74,
Q74,
M75,
N75,
P75,
Q75,
M76,
N76,
P76,
Q76,
M77,
N77,
P77,
Q77,
M78,
N78,
P78,
Q78,
M79,
N79,
P79,
Q79,
M80,
N80,
P80,
Q80,
M81,
N81,
P81,
Q81,
M82,
N82,
O82,
P82,
Q82,
M83,
N83,
P83,
Q83,
M84,
N84,
P84,
Q84,
M85,
N85,
O85,
P85,
Q85,
M86,
N86,
P86,
Q86,
M87,
N87,
O87,
P87,
Q87,
M88,
N88,
O88,
P88,
Q88,
M89,
N89,
P89,
Q89,
A91,
A93)
    select BBQ,
           v_USER,
           0,
           null,
           0,
M3,
N3,
P3,
Q3,
M4,
N4,
P4,
Q4,
M5,
N5,
P5,
Q5,
M6,
N6,
P6,
Q6,
M7,
N7,
P7,
Q7,
M8,
N8,
P8,
Q8,
M9,
N9,
P9,
Q9,
M10,
N10,
P10,
Q10,
M11,
N11,
P11,
Q11,
M12,
N12,
P12,
Q12,
M13,
N13,
P13,
Q13,
M14,
N14,
P14,
Q14,
M15,
N15,
P15,
Q15,
M16,
N16,
P16,
Q16,
M17,
N17,
P17,
Q17,
M18,
N18,
P18,
Q18,
M19,
N19,
P19,
Q19,
M20,
N20,
P20,
Q20,
M21,
N21,
P21,
Q21,
M22,
N22,
P22,
Q22,
M23,
N23,
P23,
Q23,
M24,
N24,
P24,
Q24,
M25,
N25,
P25,
Q25,
M26,
N26,
P26,
Q26,
M27,
N27,
P27,
Q27,
M28,
N28,
P28,
Q28,
M29,
N29,
P29,
Q29,
M30,
N30,
P30,
Q30,
M31,
N31,
P31,
Q31,
M32,
N32,
P32,
Q32,
M33,
N33,
O33,
P33,
Q33,
M34,
N34,
P34,
Q34,
M35,
N35,
P35,
Q35,
M36,
N36,
P36,
Q36,
M37,
N37,
P37,
Q37,
M38,
N38,
P38,
Q38,
M39,
N39,
P39,
Q39,
M40,
N40,
P40,
Q40,
M41,
N41,
P41,
Q41,
M42,
N42,
P42,
Q42,
M43,
N43,
P43,
Q43,
M44,
N44,
P44,
Q44,
M45,
N45,
P45,
Q45,
M46,
N46,
P46,
Q46,
M47,
N47,
P47,
Q47,
M48,
N48,
P48,
Q48,
M49,
N49,
O49,
P49,
Q49,
M50,
N50,
P50,
Q50,
M51,
N51,
P51,
Q51,
M52,
N52,
P52,
Q52,
M53,
N53,
P53,
Q53,
M54,
N54,
P54,
Q54,
M55,
N55,
P55,
Q55,
M56,
N56,
P56,
Q56,
M57,
N57,
P57,
Q57,
M58,
N58,
P58,
Q58,
M59,
N59,
P59,
Q59,
M60,
N60,
P60,
Q60,
M61,
N61,
P61,
Q61,
M62,
N62,
P62,
Q62,
M63,
N63,
P63,
Q63,
M64,
N64,
P64,
Q64,
M65,
N65,
P65,
Q65,
M66,
N66,
P66,
Q66,
M67,
N67,
P67,
Q67,
M68,
N68,
P68,
Q68,
M69,
N69,
P69,
Q69,
M70,
N70,
P70,
Q70,
M71,
N71,
P71,
Q71,
M72,
N72,
P72,
Q72,
M73,
N73,
P73,
Q73,
M74,
N74,
P74,
Q74,
M75,
N75,
P75,
Q75,
M76,
N76,
P76,
Q76,
M77,
N77,
P77,
Q77,
M78,
N78,
P78,
Q78,
M79,
N79,
P79,
Q79,
M80,
N80,
P80,
Q80,
M81,
N81,
P81,
Q81,
M82,
N82,
O82,
P82,
Q82,
M83,
N83,
P83,
Q83,
M84,
N84,
P84,
Q84,
M85,
N85,
O85,
P85,
Q85,
M86,
N86,
P86,
Q86,
M87,
N87,
O87,
P87,
Q87,
M88,
N88,
O88,
P88,
Q88,
M89,
N89,
P89,
Q89,
A91,
A93
      from T_CSRC1226_Z_A1_1
     where BBQ = v_P001 and userid in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1140010  and a008 = v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>Z-A1-1' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1140010;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1140010  and a008 =v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1140010!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1140020
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1140020(errcode    out int,
                                                   errmsg     out varchar2,
                                                   v_KJAXUSER varchar2,
                                                   v_TASK varchar2,
                                                   v_P001     varchar2,
                                                   v_P002     varchar2,
                                                   v_P003     varchar2) is
  v_temp  varchar(256);
  v_USER  integer;
  v_count number;
  v_org number;

begin
  errcode := 1;
  errmsg  := 'ϲɹ';

  select T2.A002
    into v_USER
    from KRCS.T_SYS_USER T1, KRCS.T_CTL_T036 T2
   where T1.P001 = v_KJAXUSER
     and T1.P002 = T2.P001;

   select p002 into v_orgfrom krcs.t_sys_user where p001=v_KJAXUSER;

  select count(*)
    into v_count
    from KRCS.t_sys_t024
   where a011 = 1009002
     and p001 = 1140020 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
  if v_count > 0 then
    errcode := 0;
    errmsg  := 'Z-A2-1 տָܱδͨ,ϲδ';
    return;
  end if;

  delete from T_CSRC1226_Z_A2_1
   WHERE BBQ = v_P001
     and USERID = v_USER; /* ɾͬһڵ */

  insert into T_CSRC1226_Z_A2_1
    (  BBQ,
  USERID,
  BTYPE,
  OPTION1,
  SHTAG,
  C2,
  D2,
  E2,
  F2,
  G2,
  C3,
  D3,
  E3,
  F3,
  G3,
  C4,
  D4,
  G4,
  C5,
  D5,
  G5,
  C6,
  D6,
  G6,
  C7,
  D7,
  G7,
  C8,
  D8,
  G8,
  C9,
  D9,
  G9,
  C10,
  D10,
  G10,
  A12,
  C12,
  D12,
  E12,
  F12,
  G12,
  A13,
  C13,
  D13,
  E13,
  F13,
  G13,
  A14,
  C14,
  D14,
  E14,
  F14,
  G14,
  A15,
  C15,
  D15,
  E15,
  F15,
  G15,
  A16,
  C16,
  D16,
  E16,
  F16,
  G16,
  C17,
  D17,
  G17,
  A19,
  C19,
  D19,
  E19,
  F19,
  G19,
  A20,
  C20,
  D20,
  E20,
  F20,
  G20,
  A21,
  C21,
  D21,
  E21,
  F21,
  G21,
  A22,
  C22,
  D22,
  E22,
  F22,
  G22,
  A23,
  C23,
  D23,
  E23,
  F23,
  G23,
  C24,
  D24,
  G24,
  A26,
  C26,
  D26,
  E26,
  F26,
  G26,
  A27,
  C27,
  D27,
  E27,
  F27,
  G27,
  A28,
  C28,
  D28,
  E28,
  F28,
  G28,
  A29,
  C29,
  D29,
  E29,
  F29,
  G29,
  A30,
  C30,
  D30,
  E30,
  F30,
  G30,
  C31,
  D31,
  G31,
  A33,
  C33,
  D33,
  E33,
  F33,
  G33,
  A34,
  C34,
  D34,
  E34,
  F34,
  G34,
  A35,
  C35,
  D35,
  E35,
  F35,
  G35,
  A36,
  C36,
  D36,
  E36,
  F36,
  G36,
  A37,
  C37,
  D37,
  E37,
  F37,
  G37,
  C38,
  D38,
  G38,
  A40,
  C40,
  D40,
  E40,
  F40,
  G40,
  A41,
  C41,
  D41,
  E41,
  F41,
  G41,
  A42,
  C42,
  D42,
  E42,
  F42,
  G42,
  A43,
  C43,
  D43,
  E43,
  F43,
  G43,
  A44,
  C44,
  D44,
  E44,
  F44,
  G44,
  C45,
  D45,
  G45,
  A47,
  C47,
  D47,
  E47,
  F47,
  G47,
  A48,
  C48,
  D48,
  E48,
  F48,
  G48,
  A49,
  C49,
  D49,
  E49,
  F49,
  G49,
  A50,
  C50,
  D50,
  E50,
  F50,
  G50,
  A51,
  C51,
  D51,
  E51,
  F51,
  G51 )
    select BBQ,
           v_USER,
           0,
           null,
           0,
           C2,
  D2,
  E2,
  F2,
  G2,
  C3,
  D3,
  E3,
  F3,
  G3,
  C4,
  D4,
  G4,
  C5,
  D5,
  G5,
  C6,
  D6,
  G6,
  C7,
  D7,
  G7,
  C8,
  D8,
  G8,
  C9,
  D9,
  G9,
  C10,
  D10,
  G10,
  A12,
  C12,
  D12,
  E12,
  F12,
  G12,
  A13,
  C13,
  D13,
  E13,
  F13,
  G13,
  A14,
  C14,
  D14,
  E14,
  F14,
  G14,
  A15,
  C15,
  D15,
  E15,
  F15,
  G15,
  A16,
  C16,
  D16,
  E16,
  F16,
  G16,
  C17,
  D17,
  G17,
  A19,
  C19,
  D19,
  E19,
  F19,
  G19,
  A20,
  C20,
  D20,
  E20,
  F20,
  G20,
  A21,
  C21,
  D21,
  E21,
  F21,
  G21,
  A22,
  C22,
  D22,
  E22,
  F22,
  G22,
  A23,
  C23,
  D23,
  E23,
  F23,
  G23,
  C24,
  D24,
  G24,
  A26,
  C26,
  D26,
  E26,
  F26,
  G26,
  A27,
  C27,
  D27,
  E27,
  F27,
  G27,
  A28,
  C28,
  D28,
  E28,
  F28,
  G28,
  A29,
  C29,
  D29,
  E29,
  F29,
  G29,
  A30,
  C30,
  D30,
  E30,
  F30,
  G30,
  C31,
  D31,
  G31,
  A33,
  C33,
  D33,
  E33,
  F33,
  G33,
  A34,
  C34,
  D34,
  E34,
  F34,
  G34,
  A35,
  C35,
  D35,
  E35,
  F35,
  G35,
  A36,
  C36,
  D36,
  E36,
  F36,
  G36,
  A37,
  C37,
  D37,
  E37,
  F37,
  G37,
  C38,
  D38,
  G38,
  A40,
  C40,
  D40,
  E40,
  F40,
  G40,
  A41,
  C41,
  D41,
  E41,
  F41,
  G41,
  A42,
  C42,
  D42,
  E42,
  F42,
  G42,
  A43,
  C43,
  D43,
  E43,
  F43,
  G43,
  A44,
  C44,
  D44,
  E44,
  F44,
  G44,
  C45,
  D45,
  G45,
  A47,
  C47,
  D47,
  E47,
  F47,
  G47,
  A48,
  C48,
  D48,
  E48,
  F48,
  G48,
  A49,
  C49,
  D49,
  E49,
  F49,
  G49,
  A50,
  C50,
  D50,
  E50,
  F50,
  G50,
  A51,
  C51,
  D51,
  E51,
  F51,
  G51
      from T_CSRC1226_Z_A2_1
     where BBQ = v_P001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);

  update KRCS.T_SYS_T014
     SET A010 = 1015001, A009 = 1016002, A011 = 1009002, A012 = 1020002,A020=v_KJAXUSER
   WHERE P001 = 1140020 and a008=v_org;
  SELECT 'ϲ۱ڣ' || replace(v_P001, '-') || 'ID<font color=red>' || P001 ||
         '</font>Ӧıƣ<font color=red>Z-A2-1' || A004 || '</font>'
    INTO v_temp
    FROM krcs.T_SYS_T004
   WHERE P001 = 1140020;
  INSERT INTO krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  VALUES
    (v_KJAXUSER, sysdate, v_temp,v_TASK);
  commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1140020 and a008=v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1140020!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1140030
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1140030(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from KRCS.T_SYS_USER T1,
              KRCS.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

     select p002 into v_orgfrom krcs.t_sys_user where p001=v_KJAXUSER;

        select count(*) into v_count from KRCS.t_sys_t024 where a011=1009002 and p001=1140030 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='Z-A2-2 ʱ׼δͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC1226_Z_A2_2 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

insert into T_CSRC1226_Z_A2_2
  (  BBQ,
  USERID,
  BTYPE,
  OPTION1,
  SHTAG ,
  D1,
  O4,
  P4,
  H5,
  I5,
  O5,
  P5,
  O6,
  P6,
  H7,
  I7,
  O7,
  P7,
  H8,
  I8,
  O8,
  P8,
  H9,
  I9,
  O9,
  P9,
  H10,
  I10,
  O10,
  P10,
  H11,
  I11,
  O11,
  P11,
  H12,
  I12,
  O12,
  P12,
  H13,
  I13,
  O13,
  P13,
  H14,
  I14,
  O14,
  P14,
  H15,
  I15,
  O15,
  P15,
  H16,
  I16,
  O16,
  P16,
  H17,
  I17,
  O17,
  P17,
  H18,
  I18,
  O18,
  P18,
  H19,
  I19,
  O19,
  P19,
  H20,
  I20,
  O20,
  P20,
  H21,
  I21,
  O21,
  P21,
  H22,
  I22,
  O22,
  P22,
  H23,
  I23,
  O23,
  P23,
  H24,
  I24,
  O24,
  P24,
  H25,
  I25,
  O25,
  P25,
  H26,
  I26,
  O26,
  P26,
  H27,
  I27,
  O27,
  P27,
  H28,
  I28,
  O28,
  P28,
  H29,
  I29,
  O29,
  P29,
  H30,
  I30,
  O30,
  P30,
  H31,
  I31,
  O31,
  P31,
  H32,
  I32,
  O32,
  P32,
  H33,
  I33,
  O33,
  P33,
  H34,
  I34,
  O34,
  P34,
  H35,
  I35,
  O35,
  P35,
  H36,
  I36,
  O36,
  P36,
  H37,
  I37,
  O37,
  P37,
  H38,
  I38,
  O38,
  P38,
  H39,
  I39,
  O39,
  P39,
  H40,
  I40,
  O40,
  P40,
  H41,
  I41,
  O41,
  P41,
  O42,
  P42,
  H43,
  I43,
  O43,
  P43,
  H44,
  I44,
  O44,
  P44,
  H45,
  I45,
  O45,
  P45,
  H46,
  I46,
  O46,
  P46,
  O47,
  P47,
  H48,
  I48,
  O48,
  P48,
  H49,
  I49,
  O49,
  P49,
  H50,
  I50,
  O50,
  P50,
  H51,
  I51,
  O51,
  P51,
  O52,
  P52,
  H53,
  I53,
  O53,
  P53,
  H54,
  I54,
  O54,
  P54,
  O55,
  P55,
  H56,
  I56,
  O56,
  P56,
  H57,
  I57,
  O57,
  P57,
  O58,
  P58,
  H59,
  I59,
  O59,
  P59,
  H60,
  I60,
  O60,
  P60,
  H61,
  I61,
  O61,
  P61,
  H62,
  I62,
  O62,
  P62,
  H63,
  I63,
  O63,
  P63,
  O64,
  P64,
  A66
)
  select BBQ,
         v_USER,
         0,
         null,
         0,
         D1,
  O4,
  P4,
  H5,
  I5,
  O5,
  P5,
  O6,
  P6,
  H7,
  I7,
  O7,
  P7,
  H8,
  I8,
  O8,
  P8,
  H9,
  I9,
  O9,
  P9,
  H10,
  I10,
  O10,
  P10,
  H11,
  I11,
  O11,
  P11,
  H12,
  I12,
  O12,
  P12,
  H13,
  I13,
  O13,
  P13,
  H14,
  I14,
  O14,
  P14,
  H15,
  I15,
  O15,
  P15,
  H16,
  I16,
  O16,
  P16,
  H17,
  I17,
  O17,
  P17,
  H18,
  I18,
  O18,
  P18,
  H19,
  I19,
  O19,
  P19,
  H20,
  I20,
  O20,
  P20,
  H21,
  I21,
  O21,
  P21,
  H22,
  I22,
  O22,
  P22,
  H23,
  I23,
  O23,
  P23,
  H24,
  I24,
  O24,
  P24,
  H25,
  I25,
  O25,
  P25,
  H26,
  I26,
  O26,
  P26,
  H27,
  I27,
  O27,
  P27,
  H28,
  I28,
  O28,
  P28,
  H29,
  I29,
  O29,
  P29,
  H30,
  I30,
  O30,
  P30,
  H31,
  I31,
  O31,
  P31,
  H32,
  I32,
  O32,
  P32,
  H33,
  I33,
  O33,
  P33,
  H34,
  I34,
  O34,
  P34,
  H35,
  I35,
  O35,
  P35,
  H36,
  I36,
  O36,
  P36,
  H37,
  I37,
  O37,
  P37,
  H38,
  I38,
  O38,
  P38,
  H39,
  I39,
  O39,
  P39,
  H40,
  I40,
  O40,
  P40,
  H41,
  I41,
  O41,
  P41,
  O42,
  P42,
  H43,
  I43,
  O43,
  P43,
  H44,
  I44,
  O44,
  P44,
  H45,
  I45,
  O45,
  P45,
  H46,
  I46,
  O46,
  P46,
  O47,
  P47,
  H48,
  I48,
  O48,
  P48,
  H49,
  I49,
  O49,
  P49,
  H50,
  I50,
  O50,
  P50,
  H51,
  I51,
  O51,
  P51,
  O52,
  P52,
  H53,
  I53,
  O53,
  P53,
  H54,
  I54,
  O54,
  P54,
  O55,
  P55,
  H56,
  I56,
  O56,
  P56,
  H57,
  I57,
  O57,
  P57,
  O58,
  P58,
  H59,
  I59,
  O59,
  P59,
  H60,
  I60,
  O60,
  P60,
  H61,
  I61,
  O61,
  P61,
  H62,
  I62,
  O62,
  P62,
  H63,
  I63,
  O63,
  P63,
  O64,
  P64,
  A66
    from T_CSRC1226_Z_A2_2
   where BBQ = v_P001  and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update KRCS.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1140030 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>Z-A2-2'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1140030;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;

exception
  when others then
    rollback;
    update KRCS.T_SYS_T014 SET A010 = 1015002 WHERE P001 = 1140030 and a008=v_org; /*޸ת״̬ */
    errcode := 0;
    errmsg  := 'ڴ洢cisp_merge_1140030!';
    return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1140040
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1140040(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';

       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

        select p002 into v_orgfrom krcs.t_sys_user where p001=v_KJAXUSER;
        select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1140040 and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ʲծܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0120_Z_B1_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0120_Z_B1_1(
            BBQ,
            USERID,
            BTYPE,
            OPTION1,
            SHTAG,
            C3,
            D3,
            G3,
            H3,
            C4,
            D4,
            G4,
            H4,
            C5,
            D5,
            G5,
            H5,
            C6,
            D6,
            G6,
            H6,
            C7,
            D7,
            G7,
            H7,
            C8,
            D8,
            G8,
            H8,
            C9,
            D9,
            G9,
            H9,
            C10,
            D10,
            G10,
            H10,
            C11,
            D11,
            G11,
            H11,
            C12,
            D12,
            G12,
            H12,
            C13,
            D13,
            G13,
            H13,
            C14,
            D14,
            G14,
            H14,
            C15,
            D15,
            G15,
            H15,
            C16,
            D16,
            G16,
            H16,
            C17,
            D17,
            G17,
            H17,
            C18,
            D18,
            G18,
            H18,
            C19,
            D19,
            G19,
            H19,
            C20,
            D20,
            G20,
            H20,
            C21,
            D21,
            G21,
            H21,
            C22,
            D22,
            G22,
            H22,
            C23,
            D23,
            G23,
            H23,
            C24,
            D24,
            G24,
            H24,
            C25,
            D25,
            G25,
            H25,
            C26,
            D26,
            G26,
            H26,
            C27,
            D27,
            G27,
            H27,
            C28,
            D28,
            G28,
            H28,
            C29,
            D29,
            G29,
            H29,
            C30,
            D30,
            G30,
            H30,
            C31,
            D31,
            C32,
            D32,
            G32,
            H32,
            C33,
            D33,
            G33,
            H33,
            C34,
            D34,
            G34,
            H34,
            C35,
            D35,
            G35,
            H35,
            C36,
            D36,
            G36,
            H36,
            C37,
            D37,
            G37,
            H37,
            C38,
            D38,
            G38,
            H38,
            C39,
            D39,
            G39,
            H39,
            G40,
            H40,
            G41,
            H41,
            G42,
            H42,
            G43,
            H43,
            C45,
            D45,
            G45,
            H45

          )

 select     BBQ,
            v_user,
            0,
            null,
            0,
            sum(nvl(C3,0)),
            sum(nvl(D3,0)),
            sum(nvl(G3,0)),
            sum(nvl(H3,0)),
            sum(nvl(C4,0)),
            sum(nvl(D4,0)),
            sum(nvl(G4,0)),
            sum(nvl(H4,0)),
            sum(nvl(C5,0)),
            sum(nvl(D5,0)),
            sum(nvl(G5,0)),
            sum(nvl(H5,0)),
            sum(nvl(C6,0)),
            sum(nvl(D6,0)),
            sum(nvl(G6,0)),
            sum(nvl(H6,0)),
            sum(nvl(C7,0)),
            sum(nvl(D7,0)),
            sum(nvl(G7,0)),
            sum(nvl(H7,0)),
            sum(nvl(C8,0)),
            sum(nvl(D8,0)),
            sum(nvl(G8,0)),
            sum(nvl(H8,0)),
            sum(nvl(C9,0)),
            sum(nvl(D9,0)),
            sum(nvl(G9,0)),
            sum(nvl(H9,0)),
            sum(nvl(C10,0)),
            sum(nvl(D10,0)),
            sum(nvl(G10,0)),
            sum(nvl(H10,0)),
            sum(nvl(C11,0)),
            sum(nvl(D11,0)),
            sum(nvl(G11,0)),
            sum(nvl(H11,0)),
            sum(nvl(C12,0)),
            sum(nvl(D12,0)),
            sum(nvl(G12,0)),
            sum(nvl(H12,0)),
            sum(nvl(C13,0)),
            sum(nvl(D13,0)),
            sum(nvl(G13,0)),
            sum(nvl(H13,0)),
            sum(nvl(C14,0)),
            sum(nvl(D14,0)),
            sum(nvl(G14,0)),
            sum(nvl(H14,0)),
            sum(nvl(C15,0)),
            sum(nvl(D15,0)),
            sum(nvl(G15,0)),
            sum(nvl(H15,0)),
            sum(nvl(C16,0)),
            sum(nvl(D16,0)),
            sum(nvl(G16,0)),
            sum(nvl(H16,0)),
            sum(nvl(C17,0)),
            sum(nvl(D17,0)),
            sum(nvl(G17,0)),
            sum(nvl(H17,0)),
            sum(nvl(C18,0)),
            sum(nvl(D18,0)),
            sum(nvl(G18,0)),
            sum(nvl(H18,0)),
            sum(nvl(C19,0)),
            sum(nvl(D19,0)),
            sum(nvl(G19,0)),
            sum(nvl(H19,0)),
            sum(nvl(C20,0)),
            sum(nvl(D20,0)),
            sum(nvl(G20,0)),
            sum(nvl(H20,0)),
            sum(nvl(C21,0)),
            sum(nvl(D21,0)),
            sum(nvl(G21,0)),
            sum(nvl(H21,0)),
            sum(nvl(C22,0)),
            sum(nvl(D22,0)),
            sum(nvl(G22,0)),
            sum(nvl(H22,0)),
            sum(nvl(C23,0)),
            sum(nvl(D23,0)),
            sum(nvl(G23,0)),
            sum(nvl(H23,0)),
            sum(nvl(C24,0)),
            sum(nvl(D24,0)),
            sum(nvl(G24,0)),
            sum(nvl(H24,0)),
            sum(nvl(C25,0)),
            sum(nvl(D25,0)),
            sum(nvl(G25,0)),
            sum(nvl(H25,0)),
            sum(nvl(C26,0)),
            sum(nvl(D26,0)),
            sum(nvl(G26,0)),
            sum(nvl(H26,0)),
            sum(nvl(C27,0)),
            sum(nvl(D27,0)),
            sum(nvl(G27,0)),
            sum(nvl(H27,0)),
            sum(nvl(C28,0)),
            sum(nvl(D28,0)),
            sum(nvl(G28,0)),
            sum(nvl(H28,0)),
            sum(nvl(C29,0)),
            sum(nvl(D29,0)),
            sum(nvl(G29,0)),
            sum(nvl(H29,0)),
            sum(nvl(C30,0)),
            sum(nvl(D30,0)),
            sum(nvl(G30,0)),
            sum(nvl(H30,0)),
            sum(nvl(C31,0)),
            sum(nvl(D31,0)),
            sum(nvl(C32,0)),
            sum(nvl(D32,0)),
            sum(nvl(G32,0)),
            sum(nvl(H32,0)),
            sum(nvl(C33,0)),
            sum(nvl(D33,0)),
            sum(nvl(G33,0)),
            sum(nvl(H33,0)),
            sum(nvl(C34,0)),
            sum(nvl(D34,0)),
            sum(nvl(G34,0)),
            sum(nvl(H34,0)),
            sum(nvl(C35,0)),
            sum(nvl(D35,0)),
            sum(nvl(G35,0)),
            sum(nvl(H35,0)),
            sum(nvl(C36,0)),
            sum(nvl(D36,0)),
            sum(nvl(G36,0)),
            sum(nvl(H36,0)),
            sum(nvl(C37,0)),
            sum(nvl(D37,0)),
            sum(nvl(G37,0)),
            sum(nvl(H37,0)),
            sum(nvl(C38,0)),
            sum(nvl(D38,0)),
            sum(nvl(G38,0)),
            sum(nvl(H38,0)),
            sum(nvl(C39,0)),
            sum(nvl(D39,0)),
            sum(nvl(G39,0)),
            sum(nvl(H39,0)),
            sum(nvl(G40,0)),
            sum(nvl(H40,0)),
            sum(nvl(G41,0)),
            sum(nvl(H41,0)),
            sum(nvl(G42,0)),
            sum(nvl(H42,0)),
            sum(nvl(G43,0)),
            sum(nvl(H43,0)),
            sum(nvl(C45,0)),
            sum(nvl(D45,0)),
            sum(nvl(G45,0)),
            sum(nvl(H45,0))

         from T_CSRC0120_Z_B1_1
        where BBQ = v_p001 and userid in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101)
        group by bbq;


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1140040 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>Z-B1-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1140040;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
               update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1140040 and a008=v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1140040!';
                return;

end;
/

prompt
prompt Creating procedure CISP_MERGEREPORT_1140050
prompt ===========================================
prompt
create or replace procedure cisp_mergereport_1140050(
       errcode out int,
       errmsg out varchar2,
       v_KJAXUSER varchar2,
       v_TASK varchar2,
       v_P001 varchar2 ,
       v_P002 varchar2,
       v_P003 varchar2
)
is
       v_temp varchar(256);
       v_USER  integer;
       v_count number;
       v_org number;

begin
       errcode := 1;
       errmsg  := 'ϲɹ';



       select T2.A002 into v_USER
         from krcs.T_SYS_USER T1,
              krcs.T_CTL_T036 T2
        where T1.P001 = v_KJAXUSER
          and T1.P002 = T2.P001;

     select p002 into v_org from krcs.t_sys_user where p001=v_KJAXUSER;

       select count(*) into v_count from krcs.t_sys_t024 where a011=1009002 and p001=1140050  and a008 in
           (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);
      if v_count > 0  then
       errcode:=0;
       errmsg:='ܱδͨ,ϲδ';
       return;
      end if;

       delete from T_CSRC0120_Z_B2_1 WHERE BBQ=v_P001 and USERID=v_USER;  /* ɾͬһڵ */

   insert into T_CSRC0120_Z_B2_1(
           BBQ,
           USERID,
           BTYPE,
           OPTION1,
           SHTAG,
         C2,
  D2,
  C3,
  D3,
  C4,
  D4,
  C5,
  D5,
  C6,
  D6,
  C7,
  D7,
  C8,
  D8,
  C9,
  D9,
  C10,
  D10,
  C11,
  D11,
  C12,
  D12,
  C13,
  D13,
  C14,
  D14,
  C15,
  D15,
  C16,
  D16,
  C17,
  D17,
  C18,
  D18,
  C19,
  D19,
  C20,
  D20,
  C21,
  D21,
  C22,
  D22,
  C23,
  D23,
  C24,
  D24,
  C25,
  D25,
  C26,
  D26,
  C27,
  D27,
  C28,
  D28,
  C29,
  D29,
  C30,
  D30,
  C31,
  D31,
  C32,
  D32,
  C33,
  D33,
  C34,
  D34,
  C35,
  D35,
  C36,
  D36,
  C37,
  D37,
  C38,
  D38,
  C39,
  D39,
  C40,
  D40,
  C41,
  D41,
  C42,
  D42,
  C43,
  D43,
  C44,
  D44,
  C45,
  D45,
  C46,
  D46,
  C47,
  D47,
  C48,
  D48,
  C49,
  D49,
  C50,
  D50,
  C51,
  D51,
  C52,
  D52,
  C53,
  D53,
  C54,
  D54,
  C55,
  D55,
  C56,
  D56,
  C57,
  D57,
  C58,
  D58,
  C59,
  D59,
  C60,
  D60,
  C61,
  D61,
  C62,
  D62,
  C63,
  D63,
  C64,
  D64,
  C65,
  D65,
  C66,
  D66,
  C67,
  D67,
  C68,
  D68,
  C69,
  D69,
  C70,
  D70,
  C71,
  D71,
  C74,
  D74,
  C75,
  D75,
  C76,
  D76
          )
   select  BBQ,
           v_USER,
           0,
           null,
           0,
         C2,
  D2,
  C3,
  D3,
  C4,
  D4,
  C5,
  D5,
  C6,
  D6,
  C7,
  D7,
  C8,
  D8,
  C9,
  D9,
  C10,
  D10,
  C11,
  D11,
  C12,
  D12,
  C13,
  D13,
  C14,
  D14,
  C15,
  D15,
  C16,
  D16,
  C17,
  D17,
  C18,
  D18,
  C19,
  D19,
  C20,
  D20,
  C21,
  D21,
  C22,
  D22,
  C23,
  D23,
  C24,
  D24,
  C25,
  D25,
  C26,
  D26,
  C27,
  D27,
  C28,
  D28,
  C29,
  D29,
  C30,
  D30,
  C31,
  D31,
  C32,
  D32,
  C33,
  D33,
  C34,
  D34,
  C35,
  D35,
  C36,
  D36,
  C37,
  D37,
  C38,
  D38,
  C39,
  D39,
  C40,
  D40,
  C41,
  D41,
  C42,
  D42,
  C43,
  D43,
  C44,
  D44,
  C45,
  D45,
  C46,
  D46,
  C47,
  D47,
  C48,
  D48,
  C49,
  D49,
  C50,
  D50,
  C51,
  D51,
  C52,
  D52,
  C53,
  D53,
  C54,
  D54,
  C55,
  D55,
  C56,
  D56,
  C57,
  D57,
  C58,
  D58,
  C59,
  D59,
  C60,
  D60,
  C61,
  D61,
  C62,
  D62,
  C63,
  D63,
  C64,
  D64,
  C65,
  D65,
  C66,
  D66,
  C67,
  D67,
  C68,
  D68,
  C69,
  D69,
  C70,
  D70,
  C71,
  D71,
  C74,
  D74,
  C75,
  D75,
  C76,
  D76
         from T_CSRC0120_Z_B2_1
        where BBQ = v_P001 and userid in
            (select x.p001 from krcs.t_ctl_t036 x,krcs.t_sys_t015 x2 where x.p001=x2.a006 and x.w100=x2.w100 and x2.w100=v_org and x.a008=1023002 and x2.p001=v_TASK and x.b001=1001101);


    update krcs.T_SYS_T014 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002,A020=v_KJAXUSER WHERE P001=1140050 and a008=v_org;
    SELECT 'ϲ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>Z-B2-1'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1140050;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER, sysdate, v_temp,v_TASK);
    commit;

    exception when others then
                rollback;
                update krcs.T_SYS_T014 SET A010=1015002 WHERE P001=1140050 and a008=v_org;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢cisp_merge_1140050!';
                return;

end;
/

prompt
prompt Creating procedure CISP_REPORT_CHECK_V1
prompt =======================================
prompt
create or replace procedure cisp_report_check_v1(errcode     out int,
                                                 errmsg      out varchar2,
                                                 v_KJAXUSER  varchar2,
                                                 v_TASK  varchar2,
                                                 v_BRANCHIDS varchar2,
                                                 v_TABLES    varchar2,
                                                 v_type      number, --֧ͣܲ
                                                 v_real_task number,
                                                 v_level     number, --˼0˾ˡ1֧ˡ2ˣ
                                                 v_step      number, --̲
                                                 v_status    number, --˽ͨͨ
                                                 v_kind      number, --1Ϊǿˣ0Ϊͨ
                                                 v_delluser  varchar2, --ǿʱ
                                                 v_msgcontent       varchar2
                                                 ) is
  v_index1        int;
  v_index2        int;
  v_index1_branch int;
  v_index2_branch int;
  v_table         int;
  v_branchid      int;
  v_lock          int;
  v_strtmp        varchar(2048);
  v_strtmp_branch varchar(2048);
  v_count_1       int;
  v_count_2       int;



  v_status_ number;
  v_bbq     number; --

  v_flowid      number; --̱
  v_isfirststep number; --Ƿһ
  v_islaststep  number; --Ƿһ
  v_ischoice    number; --Ƿѡ
  v_backstep    number; --˲
  v_isunlock    number; --δͨʱǷ
  v_realdelluser varchar2(32); --ʵ

  v_nextstep             number; --ǰһ
  v_nextstep_            number; --ǰһ
  v_nextischoice         number; --ǰһǷѡ

  v_count_nextisnotchoice number;--òһǷڱѡ

  v_nextstep_usercount_1 number; --жһ裬Ƿûգûûգ
  v_nextstep_usercount   number; --жһ裬Ƿûգûûգ

  v_backstep_usercount number; --ͬv_nexstep_usercount
  v_msg                varchar(1024);
  v_orgid number;

begin
  v_nextstep := 0;
  v_nextstep_ := 0;
  v_backstep := 0;
  select p002 into v_orgid from krcs.t_sys_user where p001 = v_KJAXUSER;
  --ǿͨ
  if v_kind = 1 then
     v_realdelluser := v_delluser;
  else
     v_realdelluser := v_KJAXUSER;
  end if;



  --õǰ̱
   if v_real_task = 0 then
     v_flowid := v_TASK;
  else
     v_flowid := v_real_task;
  end if;


  --õǰĻϢ
  select A005, A006, A007, A008, A009
    into v_isfirststep, v_islaststep, v_ischoice, v_backstep, v_isunlock
    from krcs.t_sys_t061
   where p001 = v_flowid
     and p002 = v_step;

  --ǰ費һõһ
  if v_islaststep = 1001102 then
    select a.p002
      into v_nextstep_
      from krcs.t_sys_t061 a
     where a.p001 = v_flowid
       and a.p002 = (select min(b.p002)
                        from krcs.t_sys_t061 b
                       where b.p001 = a.p001
                         and b.p002 > v_step);
    --õǰһ裬ǷѡǷ裨һǽ裬ûжˣӦòɣ
    select A007
      into v_nextischoice
      from krcs.t_sys_t061
     where p001 = v_flowid
       and p002 = v_nextstep_;

     --ж²裬ǷڱѡĲ裬ڣͨʱֱӽ
     select count(*)
       into v_count_nextisnotchoice
       from krcs.t_sys_t061
      where p001 = v_flowid
        and p002 > v_step
        and a007 = 1001102;
  end if;

  v_index2        := 1;
  v_index2_branch := 1;
  v_strtmp        := v_TABLES || ',';
  v_strtmp_branch := v_BRANCHIDS || ',';

  loop
    v_index1        := instr(v_strtmp, ',', v_index2);
    v_index1_branch := instr(v_strtmp_branch, ',', v_index2_branch);
    exit when v_index1 <= 0;

    v_table    := substr(v_strtmp, v_index2, v_index1 - v_index2);
    v_branchid := substr(v_strtmp_branch,
                         v_index2_branch,
                         v_index1_branch - v_index2_branch);

    v_index2        := v_index1 + 1;
    v_index2_branch := v_index1_branch + 1;
    v_index1        := instr(v_strtmp, ',', v_index2);
    v_index1_branch := instr(v_strtmp_branch, ',', v_index2_branch);
    exit when v_index1 <= 0;

    v_lock          := to_number(substr(v_strtmp,
                                        v_index2,
                                        v_index1 - v_index2));
    v_index2        := v_index1 + 1;
    v_index2_branch := v_index1_branch + 1;

    v_nextstep_usercount_1 := 0;
    v_nextstep_usercount   := 0;
    v_backstep_usercount   := 0;
    v_nextstep := v_nextstep_;

    --õǰһԱ
    --һѡ
    if v_nextischoice = 1001101 then
      select count(distinct nvl(a.p006,a.p003))
        into v_nextstep_usercount_1
        from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t064 c, krcs.t_sys_t061 d,krcs.t_sys_user_role e,krcs.t_sys_t001 f
       where a.p001 = v_flowid
         and a.p002 = v_nextstep_
         and a.p005 = v_table
         and b.p001=e.p001
         and e.a002=f.p001
        -- and f.a006=v_flowid
         and ((d.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
             or (d.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

         and ((d.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
             (d.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

         and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
         and b.a011 = 1001101
         and c.p001 = a.p001
         and c.p002 = a.p002
         and c.p003 = v_branchid
         and d.p001 = a.p001
         and d.p002 = a.p002;
      v_nextstep_usercount := v_nextstep_usercount_1;
      --ѡһ裬δжˣֱתıѡ裨мNѡԣ
      if v_nextstep_usercount_1 = 0 then
        select count(distinct nvl(a.p006,a.p003))
          into v_nextstep_usercount
          from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
         where a.p001 = v_flowid
           and a.p005 = v_table
           and b.p001=e.p001
           and e.a002=f.p001
           --and f.a006=v_flowid
           and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
               or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

           and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
               (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

           and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
           and b.a011 = 1001101
           and c.p001 = a.p001
           and c.p002 = a.p002

           and a.p002 in (select min(p002)
                            from krcs.t_sys_t061
                           where p001 = a.p001
                             and p002 > v_nextstep_
                             and A007 = 1001102);

           if v_nextstep_usercount > 0 then
              select min(p002) into v_nextstep
                            from krcs.t_sys_t061
                           where p001 = v_flowid
                             and p002 > v_nextstep_
                             and A007 = 1001102;
           end if;

      end if;
    end if;

    --ѡֱͳƲ
    if v_nextischoice = 1001102 then
      select count(distinct nvl(a.p006,a.p003))
        into v_nextstep_usercount
        from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
       where a.p001 = v_flowid
         and a.p002 = v_nextstep_
         and a.p005 = v_table
         and b.p001=e.p001
         and e.a002=f.p001
         --and f.a006=v_flowid
         and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
             or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

         and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
             (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID
         and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
         and b.a011 = 1001101
         and c.p001 = a.p001
         and c.p002 = a.p002;
    end if;

    --õ˲ĲԱڿѡ裬ʱһ
    select count(distinct nvl(a.p006,a.p003))
      into v_backstep_usercount
      from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
     where a.p001 = v_flowid
       and a.p002 = v_backstep
       and a.p005 = v_table
       and b.p001=e.p001
       and e.a002=f.p001
       --and f.a006=v_flowid
       and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
           or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

       and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
           (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID
       and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
       and b.a011 = 1001101
       and c.p001 = a.p001
       and c.p002 = a.p002;

    if (v_lock = 1) then
      --δͨжϻ˲Ƿв
      if v_status = 1009002 and v_backstep > 0 and v_backstep_usercount = 0 then
        v_msg := 'дڱ˲δ ';
        --ͨжһǷв
      else
        if v_status = 1009001 and v_islaststep = 1001102 and
           v_nextstep_usercount = 0 and v_count_nextisnotchoice > 0  then
          v_msg := 'дڱһδ ';

        else
          --õǰ
          select distinct b.p001
            into v_bbq
            from krcs.t_sys_t014 a, cisp.t_b00_d004 b
           where a.p001 = v_table
             and b.a002 = a.a006
             and b.c001 = 1001101;

          --뵱ǰû־
          insert into krcs.t_sys_t063
            (p001, p002, p003, p004, p005, a006, a007, a008,a009)
          values
            (v_flowid,
             v_step,
             v_table,
             v_bbq,
             v_branchid,
             v_KJAXUSER,
             sysdate,
             v_status,
             v_msgcontent
             );

          --ǰ״̬뵽״̬
          delete from krcs.t_sys_t066
           where p001 = v_flowid
             and p002 = v_step
             and p003 = v_table
             and p004 = v_branchid
             and p005 = v_realdelluser;
          insert into krcs.t_sys_t066
            (p001, p002, p003, p004, p005, a006)
          values
            (v_flowid, v_step, v_table, v_branchid, v_realdelluser, v_status);



          select count(distinct m.p006)
            into v_count_1
            from (select a.p001, a.p002, a.p005, b.p001 as p006
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_step
                     and a.p005 = v_table
                     and e.p001=b.p001
                     and e.a002=f.p001
                     --and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002) m,
                 (select * from krcs.t_sys_t066 where p004 = v_branchid and p001=v_flowid) n
           where m.p001 = n.p001(+)
             and m.p002 = n.p002(+)
             and m.p005 = n.p003(+)
             and m.p006 = n.p005(+)
             and n.A006 is null; --ӣǷδ

          select count(distinct m.p006)
            into v_count_2
            from (select a.p001, a.p002, a.p005, b.p001 as p006
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_step
                     and a.p005 = v_table
                     and e.p001=b.p001
                     and e.a002=f.p001
                     --and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002) m,
                 (select * from krcs.t_sys_t066 where p004 = v_branchid and p001=v_flowid) n
           where m.p001 = n.p001(+)
             and m.p002 = n.p002(+)
             and m.p005 = n.p003(+)
             and m.p006 = n.p005(+)
             and n.A006 = 1009002; --ӣǷδͨ

          if v_count_1 = 0 and v_count_2 = 0 then
            v_status_ := 1009001;
           elsif v_count_2 > 0 then
              v_status_ := 1009002;
          end if;

          --˲ͨ
          if v_status_ = 1009002 then
            --ܲ˹˾
            if v_type = 1019001 and v_level = 0 then
              --ǰ沽˼¼ɾ
              delete from krcs.t_sys_t066 t
               where --t.p001 = v_flowid
                -- and p002 between v_backstep and v_step
                 t.p003 = v_table
                 and exists (select 1 from krcs.t_sys_t061 x where x.a004=0 and x.p001=v_flowid and x.p001=t.p001 and x.p002=t.p002)
               --  and p002 in(select t.p002 from krcs.t_sys_t061 t where p001=v_flowid and t.a004=0)
                 ;
                 update krcs.t_sys_t014
                   set A009 = 1016002, A010 = 1015002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              --ǰδͨʱԽ
              if v_isunlock = 1001101 then
              delete from krcs.t_sys_t066 t
               where t.p001 = v_flowid
                 and p002 between v_backstep and v_step
                 and t.p003 = v_table ;

                /*update krcs.t_sys_t014
                   set A009 = 1016002, A010 = 1015002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;*/
                --˲Ϊ0ʱͬʱű
                if v_backstep = 0 then
                  update krcs.t_sys_t024 x
                     set x.A009 = 1016002, x.A010 = 1015002, x.A012 = 1020002,x.a011=1009002
                   where x.p001 = v_table  and x.a002=v_flowid and exists (select t.p001 from krcs.t_ctl_t036 t where t.w100=v_branchid and t.a008=1023002 and t.p001=x.a008);
                end if;
              end if;
            end if;
            --˲ű
            if v_type = 1019001 and v_level = 2 then
              --δͨ,ǰ沽˼¼ɾ
              delete from krcs.t_sys_t066
               where p001 = v_flowid
                 and p002 between v_backstep and v_step
                 and p003 = v_table
                 and p004 = v_branchid;
              --ǰδͨʱԽ
              if v_isunlock = 1001101 then
                update krcs.t_sys_t024
                   set A009 = 1016002, A010 = 1015002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;
            --֧˷֧ṹ  ܲ˷֧
            if v_type = 1019002 and (v_level = 1 or v_level = 0) then
              --δͨ,ǰ沽˼¼ɾ
              delete from krcs.t_sys_t066
               where p001 = v_flowid
                 and p002 between v_backstep and v_step
                 and p003 = v_table
                 and p004 = v_branchid;
                 update krcs.t_sys_t014 t
                     set  A011 = 1009002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              --ǰδͨʱԽ
              if v_isunlock = 1001101 then
                update krcs.t_sys_t014
                   set A009 = 1016002, A010 = 1015002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;

            --ڿ˻أ˻ĿĲ裬뼸״̬Ϊյļ¼ʾδб
            if v_backstep > 0 then
              insert into krcs.t_sys_t066
                (p001, p002, p003, p004, p005, a006)
                select distinct v_flowid, v_backstep, v_table, v_branchid, b.p001, null
                  from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                 where a.p001 = v_flowid
                   and a.p002 = v_backstep
                   and a.p005 = v_table
                   and b.p001=e.p001
                   and f.p001=e.a002
                   --and f.a006=v_flowid
                   and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                       or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                   and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                       (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                   and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                   and b.a011 = 1001101
                   and c.p001 = a.p001
                   and c.p002 = a.p002;
            end if;
          end if;

          --ͨ
          if v_status_ = 1009001 then
            --ܲ˹˾
            if v_type = 1019001 and v_level = 0 then
              --Ӧ˾
             /* update krcs.t_sys_t014
                 set A009 = 1016001
               where p001 = v_table
                 and A008 = v_branchid;
                 */
              --ǰΪһͬ¹˾״̬
              if v_islaststep = 1001101 or (v_count_nextisnotchoice = 0 and v_nextstep_usercount = 0) then
                update krcs.t_sys_t014
                   set A011 = 1009001
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if; --˲ű
            if v_type = 1019001 and v_level = 2 then
              --Ӧű
              /*update t_sys_t024
                 set A009 = 1016001
               where p001 = v_table
                 and A008 = v_branchid;*/

              --ǰΪһͬ²ű״̬
              if v_islaststep = 1001101 or (v_count_nextisnotchoice = 0 and v_nextstep_usercount = 0) then
                update krcs.t_sys_t024
                   set A011 = 1009001
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;
            --֧˷֧ṹ  ܲ˷֧
            if v_type = 1019002 and (v_level = 1 or v_level = 0) then
              --Ӧ֧
             /* update krcst_sys_t014
                 set A009 = 1016001
               where p001 = v_table
                 and A008 = v_branchid;*/
              --ǰΪһͬӪҵ״̬
              if v_islaststep = 1001101 or (v_count_nextisnotchoice = 0 and v_nextstep_usercount = 0) then
                update krcs.t_sys_t014
                   set A011 = 1009001
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;

            --һ
            if v_islaststep = 1001102 then

             --һǿѡ裬Ҷˣ
              if v_nextischoice = 1001101 and v_nextstep_usercount_1 > 0 then
                insert into krcs.t_sys_t066
                  (p001, p002, p003, p004, p005, a006)
                  select distinct v_flowid,
                         v_nextstep,
                         v_table,
                         v_branchid,
                         b.p001,
                         null
                    from krcs.t_sys_t062 a,
                         krcs.t_sys_user b,
                         krcs.t_sys_t064 c,
                         krcs.t_sys_t061 d,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_nextstep
                     and a.p005 = v_table
                     and e.p001=b.p001
                     and f.p001=e.a002
                    -- and f.a006=v_flowid
                     and ((d.A004 = 0 and a.p004 =b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (d.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((d.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (d.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002
                     and c.p003 = v_branchid
                     and d.p001 = a.p001
                     and d.p002 = a.p002;
              end if;

              --һǿѡ裬δˣֱӲ뵽һѡļ¼
              if v_nextischoice = 1001101 and v_nextstep_usercount > 0  then
                insert into krcs.t_sys_t066
                  (p001, p002, p003, p004, p005, a006)
                  select distinct v_flowid,
                         a.p002,
                         v_table,
                         v_branchid,
                         b.p001,
                         null
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p005 = v_table
                     and a.p002 = v_nextstep
                     and e.p001=b.p001
                     and f.p001=e.a002
                    -- and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and  e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002
                     and a.p002 in (select min(p002)
                                      from krcs.t_sys_t061
                                     where p001 = a.p001
                                       and p002 > v_nextstep_
                                       and A007 = 1001102);
              end if;

              --һǱѡ裬
              if v_nextischoice = 1001102 then
                insert into krcs.t_sys_t066
                  (p001, p002, p003, p004, p005, a006)
                  select distinct v_flowid,
                         v_nextstep,
                         v_table,
                         v_branchid,
                         b.p001,
                         null
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_nextstep
                     and a.p005 = v_table
                      and e.p001=b.p001
                     and f.p001=e.a002
                     --and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and  e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002;
              end if;

            end if;

          end if;

        end if;
      end if;

      insert into krcs.T_SYS_LOG
        (P001, P002, A003,A004)
        SELECT v_KJAXUSER,
               sysdate,
               'ˣ۱ڣ' || v_bbq || 'ID<font color=red>' ||
               TO_CHAR(v_table) || '</font>' || A004 || ',ID:' ||
               v_BRANCHID || ',̱ţ' || v_flowid || ',:' || v_type || ',' ||
               '״̬:' || v_status || '',v_task
          FROM KRCS.T_SYS_T014
         WHERE P001 = v_table
           and a002=v_flowid
           and A008 = v_branchid;
    end if;
  end loop;

  errcode := 1;
  errmsg  := '˳ɹ';
  if v_msg is not null then
    errcode := 0;
    errmsg  := 'ɣ ' || v_msg;

  end if;

  commit;

  return;

exception
  when others then
    errcode := 0;
    errmsg  := 'ʧ';
    rollback;
    return;

end;
/

prompt
prompt Creating procedure CISP_REPORT_CHECK_V1_BAK
prompt ===========================================
prompt
create or replace procedure cisp_report_check_v1_bak(errcode     out int,
                                                 errmsg      out varchar2,
                                                 v_KJAXUSER  varchar2,
                                                 v_TASK  varchar2,
                                                 v_BRANCHIDS varchar2,
                                                 v_TABLES    varchar2,
                                                 v_type      number, --֧ͣܲ
                                                 v_real_task number,
                                                 v_level     number, --˼0˾ˡ1֧ˡ2ˣ
                                                 v_step      number, --̲
                                                 v_status    number, --˽ͨͨ
                                                 v_kind      number, --1Ϊǿˣ0Ϊͨ
                                                 v_delluser  varchar2, --ǿʱ
                                                 v_msgcontent       varchar2
                                                 ) is
  v_index1        int;
  v_index2        int;
  v_index1_branch int;
  v_index2_branch int;
  v_table         int;
  v_branchid      int;
  v_lock          int;
  v_strtmp        varchar(2048);
  v_strtmp_branch varchar(2048);
  v_count_1       int;
  v_count_2       int;



  v_status_ number;
  v_bbq     number; --

  v_flowid      number; --̱
  v_isfirststep number; --Ƿһ
  v_islaststep  number; --Ƿһ
  v_ischoice    number; --Ƿѡ
  v_backstep    number; --˲
  v_isunlock    number; --δͨʱǷ
  v_realdelluser varchar2(32); --ʵ

  v_nextstep             number; --ǰһ
  v_nextstep_            number; --ǰһ
  v_nextischoice         number; --ǰһǷѡ

  v_count_nextisnotchoice number;--òһǷڱѡ

  v_nextstep_usercount_1 number; --жһ裬Ƿûգûûգ
  v_nextstep_usercount   number; --жһ裬Ƿûգûûգ

  v_backstep_usercount number; --ͬv_nexstep_usercount
  v_msg                varchar(1024);
  v_orgid number;

begin
  v_nextstep := 0;
  v_nextstep_ := 0;
  v_backstep := 0;
  select p002 into v_orgid from krcs.t_sys_user where p001 = v_KJAXUSER;
  --ǿͨ
  if v_kind = 1 then
     v_realdelluser := v_delluser;
  else
     v_realdelluser := v_KJAXUSER;
  end if;



  --õǰ̱
   if v_real_task = 0 then
     v_flowid := v_TASK;
  else
     v_flowid := v_real_task;
  end if;


  --õǰĻϢ
  select A005, A006, A007, A008, A009
    into v_isfirststep, v_islaststep, v_ischoice, v_backstep, v_isunlock
    from krcs.t_sys_t061
   where p001 = v_flowid
     and p002 = v_step;

  --ǰ費һõһ
  if v_islaststep = 1001102 then
    select a.p002
      into v_nextstep_
      from krcs.t_sys_t061 a
     where a.p001 = v_flowid
       and a.p002 in (select min(b.p002)
                        from krcs.t_sys_t061 b
                       where b.p001 = a.p001
                         and b.p002 > v_step);
    --õǰһ裬ǷѡǷ裨һǽ裬ûжˣӦòɣ
    select A007
      into v_nextischoice
      from krcs.t_sys_t061
     where p001 = v_flowid
       and p002 = v_nextstep_;

     --ж²裬ǷڱѡĲ裬ڣͨʱֱӽ
     select count(*)
       into v_count_nextisnotchoice
       from krcs.t_sys_t061
      where p001 = v_flowid
        and p002 > v_step
        and a007 = 1001102;
  end if;

  v_index2        := 1;
  v_index2_branch := 1;
  v_strtmp        := v_TABLES || ',';
  v_strtmp_branch := v_BRANCHIDS || ',';

  loop
    v_index1        := instr(v_strtmp, ',', v_index2);
    v_index1_branch := instr(v_strtmp_branch, ',', v_index2_branch);
    exit when v_index1 <= 0;

    v_table    := substr(v_strtmp, v_index2, v_index1 - v_index2);
    v_branchid := substr(v_strtmp_branch,
                         v_index2_branch,
                         v_index1_branch - v_index2_branch);

    v_index2        := v_index1 + 1;
    v_index2_branch := v_index1_branch + 1;
    v_index1        := instr(v_strtmp, ',', v_index2);
    v_index1_branch := instr(v_strtmp_branch, ',', v_index2_branch);
    exit when v_index1 <= 0;

    v_lock          := to_number(substr(v_strtmp,
                                        v_index2,
                                        v_index1 - v_index2));
    v_index2        := v_index1 + 1;
    v_index2_branch := v_index1_branch + 1;

    v_nextstep_usercount_1 := 0;
    v_nextstep_usercount   := 0;
    v_backstep_usercount   := 0;
    v_nextstep := v_nextstep_;

    --õǰһԱ
    --һѡ
    if v_nextischoice = 1001101 then
      select count(*)
        into v_nextstep_usercount_1
        from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t064 c, krcs.t_sys_t061 d,krcs.t_sys_user_role e,krcs.t_sys_t001 f
       where a.p001 = v_flowid
         and a.p002 = v_nextstep_
         and a.p005 = v_table
         and b.p001=e.p001
         and e.a002=f.p001
        -- and f.a006=v_flowid
         and ((d.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
             or (d.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

         and ((d.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
             (d.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

         and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
         and b.a011 = 1001101
         and c.p001 = a.p001
         and c.p002 = a.p002
         and c.p003 = v_branchid
         and d.p001 = a.p001
         and d.p002 = a.p002;
      v_nextstep_usercount := v_nextstep_usercount_1;
      --ѡһ裬δжˣֱתıѡ裨мNѡԣ
      if v_nextstep_usercount_1 = 0 then
        select count(*)
          into v_nextstep_usercount
          from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
         where a.p001 = v_flowid
           and a.p005 = v_table
           and b.p001=e.p001
           and e.a002=f.p001
           --and f.a006=v_flowid
           and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
               or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

           and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
               (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

           and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
           and b.a011 = 1001101
           and c.p001 = a.p001
           and c.p002 = a.p002

           and a.p002 in (select min(p002)
                            from krcs.t_sys_t061
                           where p001 = a.p001
                             and p002 > v_nextstep_
                             and A007 = 1001102);

           if v_nextstep_usercount > 0 then
              select min(p002) into v_nextstep
                            from krcs.t_sys_t061
                           where p001 = v_flowid
                             and p002 > v_nextstep_
                             and A007 = 1001102;
           end if;

      end if;
    end if;

    --ѡֱͳƲ
    if v_nextischoice = 1001102 then
      select count(*)
        into v_nextstep_usercount
        from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
       where a.p001 = v_flowid
         and a.p002 = v_nextstep_
         and a.p005 = v_table
         and b.p001=e.p001
         and e.a002=f.p001
         --and f.a006=v_flowid
         and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
             or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

         and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
             (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID
         and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
         and b.a011 = 1001101
         and c.p001 = a.p001
         and c.p002 = a.p002;
    end if;

    --õ˲ĲԱڿѡ裬ʱһ
    select count(*)
      into v_backstep_usercount
      from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
     where a.p001 = v_flowid
       and a.p002 = v_backstep
       and a.p005 = v_table
       and b.p001=e.p001
       and e.a002=f.p001
       --and f.a006=v_flowid
       and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
           or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

       and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
           (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID
       and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
       and b.a011 = 1001101
       and c.p001 = a.p001
       and c.p002 = a.p002;

    if (v_lock = 1) then
      --δͨжϻ˲Ƿв
      if v_status = 1009002 and v_backstep > 0 and v_backstep_usercount = 0 then
        v_msg := 'дڱ˲δ ';
        --ͨжһǷв
      else
        if v_status = 1009001 and v_islaststep = 1001102 and
           v_nextstep_usercount = 0 and v_count_nextisnotchoice > 0  then
          v_msg := 'дڱһδ ';

        else
          --õǰ
          select distinct b.p001
            into v_bbq
            from krcs.t_sys_t014 a, cisp.t_b00_d004 b
           where a.p001 = v_table
             and b.a002 = a.a006
             and b.c001 = 1001101;

          --뵱ǰû־
          insert into krcs.t_sys_t063
            (p001, p002, p003, p004, p005, a006, a007, a008,a009)
          values
            (v_flowid,
             v_step,
             v_table,
             v_bbq,
             v_branchid,
             v_KJAXUSER,
             sysdate,
             v_status,
             v_msgcontent
             );

          --ǰ״̬뵽״̬
          delete from krcs.t_sys_t066
           where p001 = v_flowid
             and p002 = v_step
             and p003 = v_table
             and p004 = v_branchid
             and p005 = v_realdelluser;
          insert into krcs.t_sys_t066
            (p001, p002, p003, p004, p005, a006)
          values
            (v_flowid, v_step, v_table, v_branchid, v_realdelluser, v_status);



          select count(*)
            into v_count_1
            from (select a.p001, a.p002, a.p005, b.p001 as p006
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_step
                     and a.p005 = v_table
                     and e.p001=b.p001
                     and e.a002=f.p001
                     --and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002) m,
                 (select * from krcs.t_sys_t066 where p004 = v_branchid and p001=v_flowid) n
           where m.p001 = n.p001(+)
             and m.p002 = n.p002(+)
             and m.p005 = n.p003(+)
             and m.p006 = n.p005(+)
             and n.A006 is null; --ӣǷδ

          select count(*)
            into v_count_2
            from (select a.p001, a.p002, a.p005, b.p001 as p006
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_step
                     and a.p005 = v_table
                     and e.p001=b.p001
                     and e.a002=f.p001
                     --and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002) m,
                 (select * from krcs.t_sys_t066 where p004 = v_branchid and p001=v_flowid) n
           where m.p001 = n.p001(+)
             and m.p002 = n.p002(+)
             and m.p005 = n.p003(+)
             and m.p006 = n.p005(+)
             and n.A006 = 1009002; --ӣǷδͨ

          if v_count_1 = 0 and v_count_2 = 0 then
            v_status_ := 1009001;
          end if;
          if v_count_1 = 0 and v_count_2 > 0 then
            v_status_ := 1009002;
          end if;
          --˲ͨ
          if v_status_ = 1009002 then
            --ܲ˹˾
            if v_type = 1019001 and v_level = 0 then
              --ǰ沽˼¼ɾ
              delete from krcs.t_sys_t066 t
               where --t.p001 = v_flowid
                -- and p002 between v_backstep and v_step
                 t.p003 = v_table
                 and exists (select 1 from krcs.t_sys_t061 x where x.a004=0 and x.p001=v_flowid and x.p001=t.p001 and x.p002=t.p002)
               --  and p002 in(select t.p002 from krcs.t_sys_t061 t where p001=v_flowid and t.a004=0)
                 ;
                 update krcs.t_sys_t014
                   set A009 = 1016002, A010 = 1015002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              --ǰδͨʱԽ
              if v_isunlock = 1001101 then
              delete from krcs.t_sys_t066 t
               where t.p001 = v_flowid
                 and p002 between v_backstep and v_step
                 and t.p003 = v_table ;

                /*update krcs.t_sys_t014
                   set A009 = 1016002, A010 = 1015002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;*/
                --˲Ϊ0ʱͬʱű
                if v_backstep = 0 then
                  update krcs.t_sys_t024
                     set A009 = 1016002, A010 = 1015002, A012 = 1020002
                   where p001 = v_table  and a002=v_flowid and a008=v_branchid;
                end if;
              end if;
            end if;
            --˲ű
            if v_type = 1019001 and v_level = 2 then
              --δͨ,ǰ沽˼¼ɾ
              delete from krcs.t_sys_t066
               where p001 = v_flowid
                 and p002 between v_backstep and v_step
                 and p003 = v_table
                 and p004 = v_branchid;
              --ǰδͨʱԽ
              if v_isunlock = 1001101 then
                update krcs.t_sys_t024
                   set A009 = 1016002, A010 = 1015002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;
            --֧˷֧ṹ  ܲ˷֧
            if v_type = 1019002 and (v_level = 1 or v_level = 0) then
              --δͨ,ǰ沽˼¼ɾ
              delete from krcs.t_sys_t066
               where p001 = v_flowid
                 and p002 between v_backstep and v_step
                 and p003 = v_table
                 and p004 = v_branchid;
                 update krcs.t_sys_t014 t
                     set  A011 = 1009002, A012 = 1020002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              --ǰδͨʱԽ
              if v_isunlock = 1001101 then
                update krcs.t_sys_t014
                   set A009 = 1016002, A010 = 1015002
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;

            --ڿ˻أ˻ĿĲ裬뼸״̬Ϊյļ¼ʾδб
            if v_backstep > 0 then
              insert into krcs.t_sys_t066
                (p001, p002, p003, p004, p005, a006)
                select v_flowid, v_backstep, v_table, v_branchid, b.p001, null
                  from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                 where a.p001 = v_flowid
                   and a.p002 = v_backstep
                   and a.p005 = v_table
                   and b.p001=e.p001
                   and f.p001=e.a002
                   --and f.a006=v_flowid
                   and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                       or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                   and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                       (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                   and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                   and b.a011 = 1001101
                   and c.p001 = a.p001
                   and c.p002 = a.p002;
            end if;
          end if;

          --ͨ
          if v_status_ = 1009001 then
            --ܲ˹˾
            if v_type = 1019001 and v_level = 0 then
              --Ӧ˾
             /* update krcs.t_sys_t014
                 set A009 = 1016001
               where p001 = v_table
                 and A008 = v_branchid;
                 */
              --ǰΪһͬ¹˾״̬
              if v_islaststep = 1001101 or (v_count_nextisnotchoice = 0 and v_nextstep_usercount = 0) then
                update krcs.t_sys_t014
                   set A011 = 1009001
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if; --˲ű
            if v_type = 1019001 and v_level = 2 then
              --Ӧű
              /*update t_sys_t024
                 set A009 = 1016001
               where p001 = v_table
                 and A008 = v_branchid;*/

              --ǰΪһͬ²ű״̬
              if v_islaststep = 1001101 or (v_count_nextisnotchoice = 0 and v_nextstep_usercount = 0) then
                update krcs.t_sys_t024
                   set A011 = 1009001
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;
            --֧˷֧ṹ  ܲ˷֧
            if v_type = 1019002 and (v_level = 1 or v_level = 0) then
              --Ӧ֧
             /* update krcst_sys_t014
                 set A009 = 1016001
               where p001 = v_table
                 and A008 = v_branchid;*/
              --ǰΪһͬӪҵ״̬
              if v_islaststep = 1001101 or (v_count_nextisnotchoice = 0 and v_nextstep_usercount = 0) then
                update krcs.t_sys_t014
                   set A011 = 1009001
                 where p001 = v_table
                   and a002=v_flowid
                   and A008 = v_branchid;
              end if;
            end if;

            --һ
            if v_islaststep = 1001102 then

             --һǿѡ裬Ҷˣ
              if v_nextischoice = 1001101 and v_nextstep_usercount_1 > 0 then
                insert into krcs.t_sys_t066
                  (p001, p002, p003, p004, p005, a006)
                  select distinct v_flowid,
                         v_nextstep,
                         v_table,
                         v_branchid,
                         b.p001,
                         null
                    from krcs.t_sys_t062 a,
                         krcs.t_sys_user b,
                         krcs.t_sys_t064 c,
                         krcs.t_sys_t061 d,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_nextstep
                     and a.p005 = v_table
                     and e.p001=b.p001
                     and f.p001=e.a002
                    -- and f.a006=v_flowid
                     and ((d.A004 = 0 and a.p004 =b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (d.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((d.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (d.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002
                     and c.p003 = v_branchid
                     and d.p001 = a.p001
                     and d.p002 = a.p002;
              end if;

              --һǿѡ裬δˣֱӲ뵽һѡļ¼
              if v_nextischoice = 1001101 and v_nextstep_usercount > 0  then
                insert into krcs.t_sys_t066
                  (p001, p002, p003, p004, p005, a006)
                  select distinct v_flowid,
                         a.p002,
                         v_table,
                         v_branchid,
                         b.p001,
                         null
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p005 = v_table
                     and a.p002 = v_nextstep
                     and e.p001=b.p001
                     and f.p001=e.a002
                    -- and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and  e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002
                     and a.p002 in (select min(p002)
                                      from krcs.t_sys_t061
                                     where p001 = a.p001
                                       and p002 > v_nextstep_
                                       and A007 = 1001102);
              end if;

              --һǱѡ裬
              if v_nextischoice = 1001102 then
                insert into krcs.t_sys_t066
                  (p001, p002, p003, p004, p005, a006)
                  select distinct v_flowid,
                         v_nextstep,
                         v_table,
                         v_branchid,
                         b.p001,
                         null
                    from krcs.t_sys_t062 a, krcs.t_sys_user b, krcs.t_sys_t061 c,krcs.t_sys_user_role e,krcs.t_sys_t001 f
                   where a.p001 = v_flowid
                     and a.p002 = v_nextstep
                     and a.p005 = v_table
                      and e.p001=b.p001
                     and f.p001=e.a002
                     --and f.a006=v_flowid
                     and ((c.A004 = 0 and a.p004 = b.p002 and b.p002 =(select x.w100 from krcs.t_ctl_t036 x where x.p001=v_branchid)) --ǹ˾ˣŵ100000
                         or (c.A004 <> 0 and a.p004 = v_branchid)) --Ƿ֧ˣŵǷ֧IDID

                     and ((c.A004 <> 2 and a.p004 = b.p002) or --˾Ӫҵˣ˽ɫдŵǻID
                         (c.A004 = 2 and a.p004 = b.a012)) --ˣ˽ɫдŵǲID

                     and ((a.p003 is not null and  e.a002 = a.p003) or (a.p006 is not null and a.p006 = b.p001))
                     and b.a011 = 1001101
                     and c.p001 = a.p001
                     and c.p002 = a.p002;
              end if;

            end if;

          end if;

        end if;
      end if;

      insert into krcs.T_SYS_LOG
        (P001, P002, A003,A004)
        SELECT v_KJAXUSER,
               sysdate,
               'ˣ۱ڣ' || v_bbq || 'ID<font color=red>' ||
               TO_CHAR(v_table) || '</font>' || A004 || ',ID:' ||
               v_BRANCHID || ',̱ţ' || v_flowid || ',:' || v_type || ',' ||
               '״̬:' || v_status || '',v_task
          FROM KRCS.T_SYS_T014
         WHERE P001 = v_table
           and a002=v_flowid
           and A008 = v_branchid;
    end if;
  end loop;

  errcode := 1;
  errmsg  := '˳ɹ';
  if v_msg is not null then
    errcode := 0;
    errmsg  := 'ɣ ' || v_msg;

  end if;

  commit;

  return;

exception
  when others then
    errcode := 0;
    errmsg  := 'ʧ';
    rollback;
    return;

end;
/

prompt
prompt Creating procedure CISP_REPORT_UNLOCK
prompt =====================================
prompt
create or replace procedure cisp_report_unlock(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    v_BRANCHIDS varchar2,
    v_TABLES varchar2,
    v_type char   --'1':ű, '2':˾, '3':ӪҵԼ, '4':ܲӪҵ
)
is
   v_index1 int;
   v_index2 int;
   v_index1_branch int;
   v_index2_branch int;
   v_table int;
   v_branchid int;
   v_lock int;
   v_strtmp varchar(2048);
   v_strtmp_branch varchar(2048);
   v_bbq varchar(25);
begin

   v_index2 := 1;
   v_index2_branch := 1;
   v_strtmp := v_TABLES || ',';
   v_strtmp_branch := v_BRANCHIDS || ',';

   loop
      v_index1 := instr(v_strtmp, ',', v_index2);
      v_index1_branch := instr(v_strtmp_branch, ',', v_index2_branch);
      exit when v_index1 <= 0;

      v_table := substr(v_strtmp, v_index2, v_index1 - v_index2);
      v_branchid := substr(v_strtmp_branch, v_index2_branch, v_index1_branch - v_index2_branch);

      v_index2 := v_index1 + 1;
      v_index2_branch := v_index1_branch + 1;
      v_index1 := instr(v_strtmp, ',', v_index2);
      v_index1_branch := instr(v_strtmp_branch, ',', v_index2_branch);
      exit when v_index1 <= 0;

      v_lock := to_number(substr(v_strtmp, v_index2, v_index1 - v_index2));
      v_index2 := v_index1 + 1;
      v_index2_branch := v_index1_branch + 1;
      if (v_lock=1) then
         --ű
         if v_type = '1' then

            update krcs.T_SYS_T024
               SET A011 = 1009002,
                   A009 = 1016002,
                   A010 = 1015002
             WHERE P001 = v_table
               AND A002=v_TASK
               AND A008 = v_branchid;

            update krcs.t_sys_t014
               set a009 = 1016002,
                   a010 = 1015002,
                   a011 = 1009002,
                   a012 = 1020002
             where p001 = v_table AND A002=v_TASK and a008 in (select p002 from krcs.t_sys_user where p001=v_KJAXUSER);


         end if;

         --˾
         if v_type = '2' then

            update krcs.T_SYS_T014
               SET A011=1009002,
                   A009=1016002,
                   A010 = 1015002,
                   A012=1020002
             WHERE P001 = v_table
               AND A008 = v_branchid;
         end if;

         --ӪҵԼ
         --Ϻ֤ȯĽǣӪҵѾͨ˳ܲĸ󣬵Ҫ޸ݣʱֻӪҵԼнˣ
         --ҪܲӪҵĽֻҪܲ״̬ΪδˣҲ˵ܲҪ½и
        if v_type = '3' then
            update krcs.T_SYS_T014
               SET A016 = 1009002,      --״̬
                   A011 = 1009002,      --״̬
                   A009 = 1016002,      --״̬
                   A010 = 1015002,      --״̬
                   A012 = 1020002       --״̬
             WHERE P001 = v_table
               AND A008 = v_branchid;
         end if;

         --ܲӪҵ
         --˵˹ݲҪ
         if v_type = '4' then

            update krcs.T_SYS_T014
               SET A011 = 1009002,
                   A009 = 1016002
             WHERE P001 = v_table
               AND A008 = v_branchid;
         end if;

         --ͬ°汾V1.0״̬еļ¼ɾ
         delete from krcs.t_sys_t066 where p003 = v_table and p004 = v_branchid;

         select a.p001 into v_bbq from cisp.t_b00_d004 a ,krcs.t_sys_t004 b where a.a002=b.a006  and a.c001=1001101  and b.p001=v_table;
         insert into krcs.T_SYS_LOG(P001,P002,A003,A004)
                SELECT v_KJAXUSER,sysdate,'۱ڣ'||v_bbq||'ID<font color=red>'||TO_CHAR(v_table)||'</font>'||A004||',ID:'||v_BRANCHID||',:'||v_type||'',v_task
                FROM krcs.T_SYS_T014 WHERE P001=v_table AND A008 = v_branchid;

         insert into krcs.t_sys_t063(p001,p002,p003,p004,p005,a006,a007,a008)
         values(v_task,99,v_table,v_bbq,v_branchid,v_KJAXUSER,sysdate,1009003);

     end if;
   end loop;

   errcode := 1;
   errmsg := 'ɹ';
   return;
end;
/

prompt
prompt Creating procedure CISP_SET_REPDATE
prompt ===================================
prompt
create or replace procedure cisp_set_repdate(
    errcode out int,
    errmsg out varchar2,
    kjaxuser varchar2,
    v_task    varchar2,
    v_P001 integer,
    v_P002 integer)
  is
     v_count integer;
  begin
    select count(*) into v_count from T_B00_D004 WHERE C001=1001101 AND A002=v_P002;
    if (v_count!=0) then
       errcode := 1;
       errmsg := 'Ѿͬ͵ĵǰˣñʧܣ';
       return;
    end if;
    update T_B00_D004 SET C001=1001101 WHERE P001=v_P001;
    commit;
    errcode := 1;
    errmsg  := 'ñڳɹ';
  end;
/

prompt
prompt Creating procedure CISP_SUBMIT_REPORT
prompt =====================================
prompt
create or replace procedure cisp_submit_report(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    V_REPORT varchar2,
    V_LEVEL int
    ) is


    v_index11 int;
    v_index12 int;
    v_type int;
    v_reportlist varchar2(4000);
    v_report2 varchar2(16);
  begin

    v_index12 := 1;
    v_reportlist := V_REPORT ;
    select t.a006 into v_type from krcs.t_sys_t005 t where t.p001=v_TASK;

  loop

      v_index11 := instr(v_reportlist, ',', v_index12);
      exit when v_index11 <= 0;
      v_report2  := substr(v_reportlist, v_index12, v_index11 - v_index12);
      v_index12 := v_index11 + 1;
       if v_type = 1019001   then
          update krcs.t_sys_t024 t set t.a009=1016001 where t.p001=v_report2 and t.a008=(select a012 from krcs.t_sys_user where p001=v_KJAXUSER) and t.a002=v_TASK;
       end if;
       if v_type = 1019002 or V_LEVEL=0 then
          update krcs.t_sys_t014 t set t.a009=1016001 where t.p001=v_report2 and t.a008=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER) and t.a002=v_TASK;
       end if;

  end loop;
   commit;
    errcode := 1;
    errmsg := 'ύɹ';
    return;
  end;
/

prompt
prompt Creating procedure CISP_UPD_B04_T011
prompt ====================================
prompt
create or replace procedure cisp_upd_B04_t011(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_p001 integer,
    v_a002 varchar2,
    v_a003 VARCHAR2,
    v_f004 integer,
    v_f005 integer,
    v_a004 VARCHAR2,
    v_a005 VARCHAR2,
    v_a006 VARCHAR2,
    v_a007 VARCHAR2,
    v_a008 VARCHAR2,
    v_a009 NUMBER,
    v_a010 NUMBER,
    v_a011 NUMBER,
    v_a012 NUMBER,
    v_a013 NUMBER,
    v_b001 integer
    ) is
    val_p001 int;
    val_a002 varchar2(16);
    v_count_id int;
    v_count_code int;
     v_orgid number;
     v_bmid number;


     /*ʲҪֲӣ޸*/
begin
  select count(*) into v_count_id from cisp.t_b04_t011 where p001=v_p001 and A100=(select p002 from krcs.t_sys_user
   where p001=v_KJAXUSER);
  select count(*) into v_count_code from cisp.t_b04_t011 where a002=v_a002 and p001<>v_p001 and A100=(select p002 from krcs.t_sys_user
   where p001=v_KJAXUSER);
  SELECT P002 into v_orgid FROM krcs.T_SYS_USER WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  if(v_count_id=0) then
        if(v_count_code = 0 ) then
          insert into cisp.T_B04_T011
(P001,A002,A003,F004,F005,A004,A005,A006,A007,A008,A009,A010,A011,A012,A013,B001,A100)
              values(v_p001,v_a002,v_a003,v_f004,v_f005,to_date(v_a004,'yyyy-mm-
dd'),v_a005,v_a006,v_a007,v_a008,v_a009,v_a010,v_a011,v_a012,v_a013,v_b001,v_orgid) ;
        insert into krcs.T_SYS_LOG (P001,P002,A003) values (v_KJAXUSER,sysdate,'ҵ̨ IDT003
ʲƷƷID<font color=red>'||v_P001||'</font>');
        else
            errcode := 0 ;
            errmsg := 'ƻcodeѾڣ!';
            return;
        end if;
  else
        if(v_count_code = 0 ) then
          update  cisp.T_B04_T011 set  a002 = v_a002, a003 = v_a003, f004 = v_f004,f005 = v_f005,
                  a004 = to_date(v_a004,'yyyy-mm-dd'),a005 = v_a005, a006 = v_a006, a007 = v_a007,
                  a008 = v_a008,a009 = v_a009,a010 = v_a010,a011 = v_a011,a012 = v_a012,a013 =
v_a013,B001=v_b001
           where p001= v_p001 and a100 = v_orgid;
        insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ҵ̨ IDT003޸ļ
ʲƷƷID<font color=red>'||v_P001||'</font>',v_task);
        else
            errcode := 0 ;
            errmsg := 'ƻcodeѾڣ!';
            return;
        end if;
    end if;
    errcode := 1 ;
    return;
end;
/

prompt
prompt Creating procedure CISP_UPD_B05T001
prompt ===================================
prompt
create or replace procedure cisp_upd_B05T001(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task  varchar2,
       v_p001 int,
       v_F002 int,
       v_F003 int,
       v_A003 varchar2,
       v_A004 varchar2,
       v_A005 varchar2,
       v_A006 number,
       v_A007 varchar2,
       v_A008 varchar2,
       v_A015 varchar2,
       v_A016 varchar2,
       v_A009 number,
       v_A010 int,
       v_A011 number,
       v_A012 number,
       v_A013 varchar2,
       v_A014 varchar2,
       v_A017 varchar2,
       v_B001 int
) is
orgid int;
v_live int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_b05_t001 where p001=v_p001 and A100=orgid;

  update cisp.T_B05_T001 set P001=v_P001,F002=v_F002,F003=v_F003,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006,A007=v_A007,B001=v_B001,
					A008=v_A008,A015=to_date(v_A015,'yyyy-mm-dd'),A016=to_date(v_A016,'yyyy-mm-dd'),A009=v_A009,A010=v_A010,A011=v_A011,A012=v_A012,A013=v_A013,A014=v_A014,A017=v_A017
				where P001=v_P001 and A100=orgid;

      insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'רʲϢ ID:['||v_p001||']',v_task);
      errcode := 1;
      errmsg := '³ɹ';

end cisp_upd_B05T001;
/

prompt
prompt Creating procedure CISP_UPD_B06_T011
prompt ====================================
prompt
create or replace procedure cisp_upd_B06_T011(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_p001 integer,
    v_a002 varchar2,
    v_a003 VARCHAR2,
    v_a004 VARCHAR2,
    v_a005 VARCHAR2,
    v_b001 integer
    ) is

    v_count_id int;
    v_count_code int;
     v_orgid number;


begin
  select count(*) into v_count_id from t_b06_t011 where p001=v_p001;
  select count(*) into v_count_code from t_b06_t011 where a002=v_a002 and p001<>v_p001;
  SELECT P002 into v_orgid FROM krcs.T_SYS_USER WHERE P001 = v_KJAXUSER;


  if(v_count_id=0) then
        if(v_count_code = 0 ) then
          insert into cisp.T_B06_T011(P001,A002,A003,A004,A005,B001,a100)
              values(v_p001,v_a002,v_a003,v_a004,v_a005,v_b001,v_orgid) ;
        insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ҵ̨ IDT011
ʲƷƷID<font color=red>'||v_P001||'</font>',v_task);
        else
            errcode := 0 ;
            errmsg := 'ƻcodeѾڣ!';
            return;
        end if;
  else
        if(v_count_code = 0 ) then
          update  cisp.T_B06_T011 set  a002 = v_a002, a003 = v_a003,a004 = v_a004,a005 = v_a005,B001=v_b001
           where p001= v_p001 and a100 = v_orgid;
        insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ҵ̨ IDT011޸ĶʲƷƷID<font color=red>'||v_P001||'</font>',v_task);
        else
            errcode := 0 ;
            errmsg := 'ƻcodeѾڣ!';
            return;
        end if;
    end if;
    errcode := 1 ;
    return;
end;
/

prompt
prompt Creating procedure CISP_UPD_B06_T012
prompt ====================================
prompt
create or replace procedure cisp_upd_B06_T012(errcode  out int,
                                              errmsg   out varchar2,
                                              kjaxuser varchar2,
                                              v_task   varchar2,
                                              v_p001   varchar2,
                                              v_A002   varchar2,
                                              v_A003   varchar2,
                                              v_A004   varchar2) is
  orgid  int;
  v_live int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_b06_t012 where p001=v_p001 and A100=orgid;
  if(v_live>0) then
        update cisp.t_b06_t012 set A002=v_A002,A003=v_A003,A004=v_A004 where p001=v_p001 and A100=orgid;
        insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'޸ҵϵ ID:['||v_p001||']',v_task);
        errcode := 1;
        errmsg := '޸ĳɹ!';
  else
    insert into cisp.t_b06_t012(p001,a002,a003,a004,a100)values(v_p001,v_A002,v_A003,v_A004,orgid);
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ҵϵ ID:['||v_p001||']',v_task);
        errcode := 1;
        errmsg := 'ɹ!';
  end if;
end cisp_upd_B06_T012;
/

prompt
prompt Creating procedure CISP_UPD_B08_D002
prompt ====================================
prompt
create or replace procedure cisp_upd_b08_d002(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task   varchar2,
       v_p001   int,
       v_A002   varchar2
) is

begin
        update cisp.t_b08_d002 set A002=v_A002 where p001=v_p001;
        insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'޸ȯ ID['||v_p001||']',v_task);
         errcode := 1;
         errmsg := '޸ĳɹ!';

end cisp_upd_b08_d002;
/

prompt
prompt Creating procedure CISP_UPD_B09_T002
prompt ====================================
prompt
create or replace procedure cisp_upd_b09_t002(errcode  out int,
                                              errmsg   out varchar2,
                                              kjaxuser varchar2,
                                              v_task   varchar2,
                                              v_p001   varchar2,
                                              v_p002   int,
                                              v_p003   varchar2,
                                              v_A004   number,
                                              v_A005   number,
                                              v_A006   varchar2,
                                              logP001 varchar2,
                                              logA002 varchar2) is
  orgid  int;

begin
  select p002 into orgid from krcs.t_sys_user where p001 = kjaxuser;
  update cisp.T_B12_T002 set P001=to_date(v_P001,'yyyy-mm-dd'),P002=v_P002,P003=v_P003,A004=v_A004,A005=v_A005,A006=v_A006 where P001=to_date(v_P001,'yyyy-mm-dd') and p002=v_P002 and p003=v_P003
			 and a100=orgid;

    insert into krcs.t_sys_log
      (p001, p002, a003, a004)
    values
      (kjaxuser,
       sysdate,
       '޸ĲҵĿϸ :' || to_date(v_p001, 'yyyy-mm-dd') || '] ĿID[' ||
       v_p002 || '[]',
       v_task);
    errcode := 1;
    errmsg  := '޸ĳɹ!';

end cisp_upd_b09_t002;
/

prompt
prompt Creating procedure CISP_UPD_B15_T001
prompt ====================================
prompt
create or replace procedure cisp_upd_B15_t001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A002 varchar2,
    V_A003 varchar2,
    v_A004 varchar2,
    v_A007 varchar2,
    v_A099 varchar2)
    is
     v_orgid number;
     v_bmid number;


begin
  errcode:=1;
  errmsg :='³ɹ!';
  select p002 into v_orgid from krcs.t_sys_user where p001=v_KJAXUSER;
 update cisp.T_B15_T001 set A002=to_date(v_A002,'yyyy-mm-dd'),A003=to_date(v_A003,'yyyy-mm-dd'),
 A004=to_date(v_A004,'yyyy-mm-dd'),a005=v_A007,a099=v_A099
   where a100=v_orgid;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values
  (v_KJAXUSER,sysdate,'ҵ̨ˣIDT001޸ĵͳ--ͳ',v_task);
end cisp_upd_B15_t001;
/

prompt
prompt Creating procedure CISP_UPD_BKST001
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST001(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 number,
       col1 number,
       col2 number,
       col3 number,
       col4 number)
is
       v_count integer;
       v_orgid number;

begin
       select p002 into v_orgid from krcs.t_sys_user where p001= kjaxuser;
       errcode:=1;
       errmsg :='';
       SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T001
              where a004=v_p001 and a100 = v_orgid;
       if (v_count<>4) then
          delete from cisp.T_BKS_T001 where a004=v_p001 and a100 = v_orgid;
          insert into cisp.T_BKS_T001(A004,A005,A006,A007,a100)VALUES(v_p001,'1013100',col1,'',v_orgid);
          insert into cisp.T_BKS_T001(A004,A005,A006,A007,a100)VALUES(v_p001,'1013101',col2,'',v_orgid);
          insert into cisp.T_BKS_T001(A004,A005,A006,A007,a100)VALUES(v_p001,'1013102',col3,'',v_orgid);
          insert into cisp.T_BKS_T001(A004,A005,A006,A007,a100)VALUES(v_p001,'1013199',col4,'',v_orgid);
       else
          update cisp.T_BKS_T001 SET a006=col1 where a004=v_p001 and a005='1013100' and a100 = v_orgid;
          update cisp.T_BKS_T001 SET a006=col2 where a004=v_p001 and a005='1013101' and a100 = v_orgid;
          update cisp.T_BKS_T001 SET a006=col3 where a004=v_p001 and a005='1013102' and a100 = v_orgid;
          update cisp.T_BKS_T001 SET a006=col4 where a004=v_p001 and a005='1013199' and a100 = v_orgid;
       end if;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (KJAXUSER,sysdate,'ҵ̨ˣIDT001޸֤ȯͶѯܣĿID<font color=red>'||v_p001||'</font>',v_task);

end cisp_UPD_BKST001;
/

prompt
prompt Creating procedure CISP_UPD_BKST002
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST002(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             v_p001   int,
                                             v_A003   varchar2,
                                             v_A004   varchar2,
                                             v_A005   int,
                                             v_A006   varchar2,
                                             v_A007   varchar2,
                                             v_A008   varchar2,
                                             v_A009   varchar2,
                                             v_A010   int,
                                             v_A011   int,
                                             v_A012   varchar2) is


  v_A100 int;

begin
  select p002 into v_A100 from krcs.t_sys_user where p001=kjaxuser;
  update cisp.t_bks_t002 set A003=to_date(v_A003,'yyyy-mm-dd'),A004=v_A004,A005=v_A005,A006=v_A006,A007=v_A007,A008=v_A008,A009=to_date(v_A009,'yyyy-mm-dd'),A010=v_A010,A011=v_A011,A012=v_A012 where P001=v_P001 and p002=v_A100;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'ýϢ ID:['||v_p001||']',v_task);
  errcode := 1;
  errmsg := '³ɹ!';
end cisp_UPD_BKST002;
/

prompt
prompt Creating procedure CISP_UPD_BKST003
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST003(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    integer,
                                             vA003    integer,
                                             vA004    integer,
                                             vA006    varchar2) is
  v_orgid number;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  update cisp.T_BKS_T003
     SET A002 = vA002,
         A003 = vA003,
         A004 = vA004,
         A005 = vA002 + vA003 - vA004,
         A006 = vA006
   WHERE P001 = vP001
     and a100 = v_orgid;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT003޸ı˻ڣ<font color=red>' || vP001 || '</font>',v_task);

end cisp_UPD_BKST003;
/

prompt
prompt Creating procedure CISP_UPD_BKST004
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST004(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    integer,
                                             vA003    integer,
                                             vA004    integer,
                                             logP001  varchar2,
                                             logA002  varchar2) is
  v_count integer;
  v_orgid number;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*)
    INTO v_count
    FROM cisp.T_BKS_T004
   where P001 = vP001
     and a100 = v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T004
      (P001, A002, A003, A004, A005, a100)
    VALUES
      (vP001, vA002, vA003, vA004, vA002 + vA003 - vA004, v_orgid);
  else
    update cisp.T_BKS_T004
       SET A002 = vA002,
           A003 = vA003,
           A004 = vA004,
           A005 = vA002 + vA003 - vA004
     where P001 = vP001
       and a100 = v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (KJAXUSER,
     sysdate,
     'ҵ̨ˣIDT004޸֤ȯͶѯԱ䶯' || logP001 || '<font color=red>' ||
     logA002 || '</font>',v_task);

end cisp_UPD_BKST004;
/

prompt
prompt Creating procedure CISP_UPD_BKST005
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST005(error_code out int,
                                             errmsg     out varchar2,
                                             kjaxuser   varchar2,
                                             v_task     varchar2,
                                             v_p001     int,
                                             v_p002     int,
                                             v_p003     int,
                                             v_p004     int,
                                             v_p005     varchar2,
                                             v_p006     varchar2,
                                             v_A007     varchar2,
                                             v_A008     varchar2,
                                             v_A009     int,
                                             v_A010     int,
                                             v_A016     int,
                                             v_A017     int,
                                             v_A011     int,
                                             v_A018     int,
                                             v_A015     varchar2) is
  v_orgid int;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;

     update cisp.T_BKS_T005 set P002=v_p002,P003=v_p003,P004=v_p004,P005=v_P005,P006=v_P006,A007=v_A007,A008=to_date(v_A008,'yyyy-mm-dd'),
					A009=v_A009,A010=v_A010,A016=v_A016,A017=v_A017,A011=v_A011,A018=v_A018,A015=v_A015
				where P001=v_P001 and a100=v_orgid;

     insert into krcs.t_sys_log(p001,p002,a003,a004)
         values(kjaxuser,sysdate,'޸ĳĿ ĿID['||v_p001||']ɹ!',v_task);

         error_code := 1;
         errmsg := '޸ĳɹ!';

end cisp_upd_BKST005;
/

prompt
prompt Creating procedure CISP_UPD_BKST006
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST006(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA003    varchar2,
                                             vA004    varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2) is
  v_count integer;
  v_orgid number;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*)
    INTO v_count
    FROM cisp.T_BKS_T006
   where P001 = vP001
     and a100 = v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T006
      (P001, A003, a004, a100)
    VALUES
      (vP001, vA003, vA004, v_orgid);
  else
    update cisp.T_BKS_T006
       SET A003 = VA003, A004 = VA004
     where P001 = vP001
       and a100 = v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT006޸ıϹ' || logP001 || '<font color=red>' || logA002 ||
     '</font>',v_task);

end cisp_UPD_BKST006;
/

prompt
prompt Creating procedure CISP_UPD_BKST007
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST007(error_code out int,
                                             errmsg     out varchar2,
                                             kjaxuser   varchar2,
                                             v_task     varchar2,
                                             v_A002     number,
                                             v_A003     number) is
begin

     update cisp.t_bks_t007 set A002=v_A002,A003=v_A003 ;

     insert into krcs.t_sys_log(P001,p002,a003,a004)values(kjaxuser,sysdate,'»',v_task);

     error_code := 1;
     errmsg := 'ʸ³ɹ!';
end cisp_upd_BKST007;
/

prompt
prompt Creating procedure CISP_UPD_BKST008
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST008(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2
                                             ) is
  v_count integer;
  v_orgid number;
begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T008 where P001 = vP001 and a100 = v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T008 (P001, A002,a100) VALUES (vP001, vA002, v_orgid);
  else
    update cisp.T_BKS_T008 SET A002 = vA002 where P001 = vP001 and a100 = v_orgid;
  end if;
  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT008޸Ĺ˾ҵ' || logP001 || '<font color=red>' ||
     logA002 || '</font>',v_task);
end cisp_UPD_BKST008;
/

prompt
prompt Creating procedure CISP_UPD_BKST009
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST009(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    integer,
                                             vA003    varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2) is
  v_count integer;
  v_orgid number;
       --  update by zhouly  20130826 ޸a010Ϊa100
begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T009 where P001 = vP001 and a100 = v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T009 (P001, A002, A003,a100) VALUES (vP001, vA002, vA003,v_orgid);
  else
    update cisp.T_BKS_T009 SET A002 = vA002, A003 = vA003 where P001 = vP001 and a100 = v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT009޸֤ȯ˾ʾ' || logP001 || '<font color=red>' ||
     logA002 || '</font>',v_task);
end cisp_UPD_BKST009;
/

prompt
prompt Creating procedure CISP_UPD_BKST010
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST010(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    numeric,
                                             logP001  varchar2,
                                             logA002  varchar2) is
  v_count integer;
  v_orgid number;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*)
    INTO v_count
    FROM cisp.T_BKS_T010
   where P001 = vP001
     and a100 = v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T010
      (P001, A002, B009, a100)
    VALUES
      (vP001, vA002, sysdate, v_orgid);
  else
    update cisp.T_BKS_T010
       SET A002 = vA002, B009 = sysdate
     where P001 = vP001
       and a100 = v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (KJAXUSER,
     sysdate,
     'ҵ̨ˣIDT010޸ϯλʹ' || logP001 || '<font color=red>' || logA002 ||
     '</font>',v_task);

end cisp_UPD_BKST010;
/

prompt
prompt Creating procedure CISP_UPD_BKST012
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST012(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    varchar2,
                                             vA003    varchar2,
                                             vA004    varchar2,
                                             vA005    varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2
                                             ) is
  v_count integer;
  v_orgid number;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001=kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T012 where P001 = vP001 and a100=v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T012
      (P001, A002, A003, A004, A005,a100)
    VALUES
      (vP001, vA002, vA003, vA004, vA005,v_orgid);
  else
    update cisp.T_BKS_T012
       SET A002 = vA002, A003 = vA003, A004 = vA004, A005 = vA005
     where P001 = vP001 and a100 = v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT012޸֤ܱͻϢ'||logP001||'<font color=red>' || logA002 ||
     '</font>',v_task);
end cisp_UPD_BKST012;
/

prompt
prompt Creating procedure CISP_UPD_BKST013
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST013(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    vP001 integer,
    vA002 integer,
    vA003 integer,
    vA004 integer,
    vA005 varchar2,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_orgid number;

  begin
    select p002 into v_orgid from krcs.t_sys_user where p001=v_kjaxuser;
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_BKS_T013 where P001=vP001 and a100 = v_orgid;
    if (v_count=0) then
       insert into cisp.T_BKS_T013(P001,A002,A003,A004,A005,a100) values(vP001, vA002,vA003,vA004,vA005,v_orgid);
    else
       update cisp.T_BKS_T013 set A002=vA002,A003=vA003,A004=vA004,A005=vA005 where P001=vP001 and a100 = v_orgid;
    end if;

    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ҵ̨ˣIDT013޸ıۼƱĿ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_BKST014
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST014(
       errcode  out int,
       errmsg   out varchar2,
       kjaxuser varchar2,
       v_task   varchar2,
       v_A002   int,
       v_A003   int,
       v_A004   number,
       v_A005   varchar2,
       v_A006   int,
       v_A007   int,
       v_A008   number,
       v_A009   int,
       v_A010   int,
       v_A011   int,
       v_A012   int,
       v_A013   int
) is
orgid  int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  update cisp.t_bks_t014 set A002=v_A002,A003=v_A003,A004=v_A004,A005=to_date(v_A005,'yyyy-mm-dd'),A006=v_A006,
                             A007=v_A007,A008=v_A008,A009=v_A009,A010=v_A010,A011=v_A011,A012=v_A012,A013=V_A013
                             where A100=orgid;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'˻淶Ϣ',v_task);
  errcode := 1;
  errmsg := '³ɹ!';
end cisp_upd_BKST014;
/

prompt
prompt Creating procedure CISP_UPD_BKST015
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST015(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task  varchar2,
       v_p001 number,
       v_A002 number,
       v_A003 number,
       v_A004 number,
       v_A005 number,
       v_A006 number,
       logP001 varchar2,
       logA002 varchar2
) is
orgid  int;
v_live int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  select count(*) into v_live from cisp.t_bks_t015 where p001=v_p001 and A100=orgid;
  if(v_live = 0) then
       insert into cisp.t_bks_t015(A002,a003,a004,a005,a006,p001,a100)
       values(v_A002,v_A003,v_A004,v_A005,v_A006,v_p001,orgid);
  else
       update cisp.t_bks_t015
       set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006 where p001=v_p001 and A100=orgid;
  end if;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'޸˻淶Ϣɹ ID:['||v_p001||']',v_task);
  errcode := 1;
  errmsg := '޸ĳɹ!';
end cisp_upd_BKST015;
/

prompt
prompt Creating procedure CISP_UPD_BKST017
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST017(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task   varchar2,
       vP001    integer,
       vA002    varchar2,
       vA003    varchar2,
       logP001  varchar2,
       logA002  varchar2)
is
       v_count integer;
       v_orgid number;

begin
       select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
       errcode:=1; errmsg :='';
       SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T017 where P001=vP001 and a100 = v_orgid;
       if (v_count=0) then
          insert into cisp.T_BKS_T017(P001,A002,A003,a100) VALUES(vP001,vA002,vA003,v_orgid);
       else
          update cisp.T_BKS_T017 SET A002=vA002,A003=vA003 where P001=vP001 and a100 = v_orgid;
       end if;

       insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (kjaxuser,sysdate,'ҵ̨ˣIDT017޸Ԥܱ׼'||logP001||'<font color=red>' ||logA002 || '</font>',v_task);
end cisp_UPD_BKST017;
/

prompt
prompt Creating procedure CISP_UPD_BKST027
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST027(
       errcode out int,
       errmsg out varchar2,
       kjaxuser varchar2,
       v_task varchar2,
       v_p001 int,
       v_A002 int,
       v_A003 number,
       v_A004 varchar2,
       logP001 varchar2,
       logA002 varchar2

) is
orgid int;
yyb_id int;
begin
  select w100 into orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=kjaxuser;
  select p002 into yyb_id from krcs.t_sys_user where p001=kjaxuser;
  delete from cisp.T_BKS_T027 where A001=V_P001 and P001=yyb_id and A100=orgid;
  insert into cisp.T_BKS_T027(P001,A001,A002,A003,A004,a100) VALUES(yyb_id,V_P001,V_A002,V_A003,V_A004,orgid);

  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (kjaxuser,sysdate,'ҵ̨ˣID027޸ӪҵϹӪ'||logP001||'<font color=red>' ||
        logA002 || '</font>',v_task);
  errcode := 1;
  errmsg := '޸ĳɹ';

end cisp_UPD_BKST027;
/

prompt
prompt Creating procedure CISP_UPD_BKST028
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST028(
     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     v_task     varchar2,
     V_P001     integer,
     V_A002     integer,
     V_A003     numeric,
     V_A004     varchar2,
     logP001    varchar2,
     logA002    varchar2)
  is

     V_ORGANID  NUMERIC;
     v_orgid    int;
  begin
       errcode:=1;
       errmsg:='';
       select w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;
       select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;

       delete from cisp.T_BKS_T028 where A001=V_P001 and P001=V_ORGANID and A100=v_orgid;
       insert into cisp.T_BKS_T028(P001,A001,A002,A003,A004,A100) VALUES(V_ORGANID,V_P001,V_A002,V_A003,V_A004,v_orgid);

       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (V_KJAXUSER,sysdate,'ҵ̨ˣID028޸Ϣϵͳ'||logP001||'<font color=red>' ||
        logA002 || '</font>',v_task);

       errcode := 1;
       errmsg := '޸ĳɹ!';
  end cisp_UPD_BKST028;
/

prompt
prompt Creating procedure CISP_UPD_BKST029
prompt ===================================
prompt
create or replace procedure CISP_UPD_BKST029(
     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     v_task     varchar2,
     V_P001     integer,
     V_A002     integer,
     V_A003     numeric,
     V_A004     varchar2,
     logP001    varchar2,
     logA002    varchar2)
  is

     V_ORGANID  NUMERIC;
     V_A100 INT;
  begin
       errcode:=1;
       errmsg:='';
       select x.w100 into V_A100 from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;
       select P002 into V_ORGANID from KRCS.T_SYS_USER where P001 = v_KJAXUSER;

       delete from cisp.T_BKS_T029 where A001=V_P001 and P001=V_ORGANID and A100=V_A100;
       insert into cisp.T_BKS_T029(P001,A001,A002,A003,A004,A100) VALUES(V_ORGANID,V_P001,V_A002,V_A003,V_A004,V_A100);

       insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (V_KJAXUSER,sysdate,'ҵ̨ˣID029޸Ӫҵ߼иծ'||logP001||'<font color=red>' ||
        logA002 || '</font>',v_task);

  end CISP_UPD_BKST029;
/

prompt
prompt Creating procedure CISP_UPD_BKST030
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST030(
     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     V_TASK     varchar2,
     V_P001     integer,
     V_A002     integer,
     V_A003     numeric,
     V_A004     varchar2,
     logP001    varchar2,
     logA002    varchar2)
  is

     V_ORGANID  NUMERIC;
     v_A100 int;
  begin
       errcode:=1;
       errmsg:='';

      select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;
      select x.w100 into v_A100 from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=v_kjaxuser;
       delete from cisp.T_BKS_T030 where A001=V_P001 and P001=V_ORGANID and A100=v_A100;
       insert into T_BKS_T030(P001,A001,A002,A003,A004,A100) VALUES(V_ORGANID,V_P001,V_A002,V_A003,V_A004,v_A100);

       insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (V_KJAXUSER,sysdate,'ҵ̨ˣID030޸Ӫҵش'||logP001||'<font color=red>' ||
        logA002 || '</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_BKST031
prompt ===================================
prompt
create or replace procedure CISP_UPD_BKST031(
     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     V_TASK     varchar2,
     V_P001     varchar2,
     V_P002     varchar2,
     V_A003     integer,
     logP001    varchar2,
     logA002    varchar2)
  is

     V_ORGANID  NUMERIC;
     v_orgid     int;
  begin
       errcode:=1;
       errmsg:='';

       select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;
       select x.w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;

       delete from cisp.T_BKS_T031 where P002=V_P001 and P001=V_ORGANID and A100=v_orgid;
       insert into cisp.T_BKS_T031(P001,P002,A003,A004,a100) VALUES(V_ORGANID,V_P001,V_P002,V_A003,v_orgid);


       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (V_KJAXUSER,sysdate,'ҵ̨ˣID031޸жӦϵ'||logP001||'<font color=red>' ||
        logA002 || '</font>',v_task);

  end CISP_UPD_BKST031;
/

prompt
prompt Creating procedure CISP_UPD_BKST032
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST032(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    varchar2,
                                             vA003    varchar2,
                                             vA004    varchar2,
                                             vA005    varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2) is
  v_count integer;
  v_orgid int;
begin
  errcode := 1;
  errmsg  := '';

  select x.w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=kjaxuser;
  SELECT COUNT(*)
    INTO v_count
    FROM cisp.T_BKS_T032
   where P001 = vP001
     AND P002 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001 = kjaxuser) and A100=v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T032
      (P001, P002, A002, A003, A004, A005,A100)
    VALUES
      (vP001,
       (SELECT P002 FROM krcs.T_SYS_USER WHERE P001 = kjaxuser),
       vA002,
       vA003,
       vA004,
       vA005,
       v_orgid);
  else
    update cisp.T_BKS_T032
       SET A002 = vA002, A003 = vA003, A004 = vA004, A005 = vA005
     where P001 = vP001
       AND P002 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001 = kjaxuser) and A100=v_orgid;
  end if;
  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣID032޸ӪҵϢ' || logP001 || '<font color=red>' || logA002 ||
     '</font>',v_task);

end;
/

prompt
prompt Creating procedure CISP_UPD_BKST034
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST034(

     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     V_TASK     VARCHAR2,
     V_P001     integer,
     V_A003     varchar2,
     V_A005     varchar2,
     V_A009     integer,
     V_A021     integer,
     V_A026     integer,
     V_A027     integer,
     V_A028     integer,
     V_A029     integer,
     V_A030     integer,
     logP001    varchar2,
     logA002    varchar2)
  is

  orgid int;
  begin
       errcode:=1;
       errmsg:='';
       select x.w100 into orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;
       update krcs.t_ctl_t036
       set a003 = V_A003,a005 = V_A005,a009 = V_A009,a021 = V_A021,a026 = V_A026,a027 = V_A027,a028 = V_A028,a029 = V_A029,a030 = V_A030
       where p001 = V_P001 and W100=orgid;


       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (V_KJAXUSER,sysdate,'ҵ̨ˣID034ӪҵϢ'||logP001||'<font color=red>' ||
        logA002 || '</font>',V_TASK);

  end;
/

prompt
prompt Creating procedure CISP_UPD_BKST035
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST035(error_code out int,
                                             errmsg     out varchar2,
                                             kjaxuser   varchar2,
                                             v_task     varchar2,
                                             v_p001     varchar2,
                                             v_A002     varchar2,
                                             v_A003     varchar2,
                                             v_A004     varchar2,
                                             v_A005     varchar2,
                                             logp001    varchar2,
                                             logA002    varchar2

                                             ) is

  orgid int;
begin
  select p002 into orgid from krcs.t_sys_user where p001=kjaxuser;
  update cisp.t_bks_t035 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005 where p001=v_p001 and A100=v_task;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'֤˻淶޸ģID['||v_p001||']',v_task);
  error_code := 1;
  errmsg := '޸ĳɹ!';
end cisp_upd_BKST035;
/

prompt
prompt Creating procedure CISP_UPD_BKST040
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST040(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    integer,
                                             vA003    integer,
                                             logP001  varchar2,
                                             logA002  varchar2)
is
    v_count integer;
    v_orgid number;
       --  update by zhouly  20130826 ޸a010Ϊa100
begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T040 where P001 = vP001 and a100 = v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T040
      (P001, A002, A003,a100)
    VALUES
      (vP001, vA002, vA003,v_orgid);
  else
    update cisp.T_BKS_T040
       SET A002 = vA002, A003 = vA003
     where P001 = vP001 and a100 = v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT040޸Ա'||logP001||'<font color=red>' || logA002 ||
     '</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_BKST041
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST041(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    integer,
                                             vA008    varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2)
is
v_count integer;
v_orgid number;

begin
 select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T041 where P001 = vP001 and a100 = v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T041
      (P001, A002,A008,a100)
    VALUES
      (vP001, vA002,vA008,v_orgid);
  else
    update cisp.T_BKS_T041
       SET A002 = vA002
       , A008 = vA008
     where P001 = vP001 and a100 = v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT041֤ȯӪҵ'||logP001||'<font color=red>' || logA002 ||
     '</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_BKST042
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST042(errcode  out int,
                                             errmsg   out varchar2,
                                             kjaxuser varchar2,
                                             v_task   varchar2,
                                             vP001    integer,
                                             vA002    integer,
                                             vA008    varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2)
is

    v_count integer;
    v_orgid number;

begin
  select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*) INTO v_count FROM cisp.T_BKS_T042 where P001 = vP001 and a100 =v_orgid;
  if (v_count = 0) then
    insert into cisp.T_BKS_T042
      (P001, A002,A008,a100)
    VALUES
      (vP001, vA002,vA008,v_orgid);
  else
    update cisp.T_BKS_T042
       SET A002 = vA002,
       A008 = vA008

     where P001 = vP001 and a100 =v_orgid;
  end if;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (kjaxuser,
     sysdate,
     'ҵ̨ˣIDT042 ҵԱ'||logP001||'<font color=red>' || logA002 ||
     '</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_BKST050
prompt ===================================
prompt
create or replace procedure cisp_upd_BKST050(error_code out int,
                                             errmsg     out varchar2,
                                             kjaxuser   varchar2,
                                             v_task     varchar2,
                                             v_p001     number) is
begin

  update cisp.t_bks_t050 set p001 = v_p001;
  insert into krcs.t_sys_log
    (P001, p002, a003, a004)
  values
    (kjaxuser, sysdate, '޸Ͷ߱Ϊ[' || v_p001 || ']', v_task);
   error_code := 1;
   errmsg := '޸ĳɹ!';
end cisp_upd_BKST050;
/

prompt
prompt Creating procedure CISP_UPD_BKST050_1
prompt =====================================
prompt
create or replace procedure cisp_UPD_BKST050_1(
                                               errcode    out int,
                                               errmsg     out varchar2,
                                               V_KJAXUSER varchar2,
                                               v_task     varchar2,
                                               V_P001     integer,
                                               V_A002     varchar2 --Ŀֵ
                                               ) is

  V_ORGANID NUMERIC;
  v_orgid int;
begin
  errcode := 1;
  errmsg  := '';

  select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;
  select x.w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;
  delete from cisp.T_BKS_T053
   where P001 = V_ORGANID
     and A001 = V_P001
     and A100 = v_orgid;
  insert into cisp.T_BKS_T053
    (P001, A001, A002,A100)
  VALUES
    (V_ORGANID, V_P001, V_A002 , v_orgid);

  insert into krcs.t_sys_log(p001,p002,a003,a004)values(V_KJAXUSER,sysdate,'ҵ̨ά--ӪҵͳƱעһ ID['||V_P001||']',V_TASK);
  commit;

end cisp_UPD_BKST050_1;
/

prompt
prompt Creating procedure CISP_UPD_BKST051
prompt ===================================
prompt
create or replace procedure CISP_UPD_BKST051(
     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     V_TASK     varchar2,
     V_P001     integer,--
     V_A003 varchar2--ѡ
     )
  is

     V_ORGANID  NUMERIC;
     v_orgid  int;
  begin
       errcode:=1;
       errmsg:='';

       select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;
       select x.w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;

       delete from cisp.T_BKS_T051 where A001=V_P001 and P001=V_ORGANID and A100=v_orgid;
       insert into T_BKS_T051(P001,A001,A002,A100) VALUES(V_ORGANID,V_P001,V_A003,v_orgid);

       insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (V_KJAXUSER,sysdate,'ҵ̨ˣID027޸ӪҵϹӪ'||V_P001||']',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_BKST052
prompt ===================================
prompt
create or replace procedure CISP_UPD_BKST052(

                                             errcode    out int,
                                             errmsg     out varchar2,
                                             V_KJAXUSER varchar2,
                                             V_TASK     varchar2,
                                             V_P001     integer,
                                             V_A002     varchar2 --Ŀֵ
                                             )

 is

  V_ORGANID NUMERIC;
  v_orgid int;
begin
  errcode := 1;
  errmsg  := '';

  select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;
  select x.w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;
  delete from cisp.T_BKS_T052
   where P001 = V_ORGANID
     and A001 = V_P001
     and A100 = v_orgid;
  insert into cisp.T_BKS_T052
    (P001, A001, A002,A100)
  VALUES
    (V_ORGANID, V_P001, V_A002 , v_orgid);

  insert into krcs.t_sys_log(p001,p002,a003,a004)values(V_KJAXUSER,sysdate,'ҵ̨ά--֤ӪҵϢͳƱ ID:['||V_P001||']',v_task);
  commit;

end;
/

prompt
prompt Creating procedure CISP_UPD_BKST054
prompt ===================================
prompt
create or replace procedure cisp_UPD_BKST054(
     errcode    out int,
     errmsg     out varchar2,
     V_KJAXUSER varchar2,
     V_TASK     varchar2,
     V_P001     integer,
     V_A003  integer,
     V_A005     numeric
     )
  is

     V_ORGANID  NUMERIC;
     v_orgid  int;
  begin
       errcode:=1;
       errmsg:='';

       select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;
       select x.w100 into v_orgid from krcs.t_ctl_t036 x,krcs.t_sys_user xx where x.p001=xx.p002 and xx.p001=V_KJAXUSER;
       delete from cisp.T_BKS_T054 where A001=V_P001 and P001=V_ORGANID and A100=v_orgid;
       insert into cisp.T_BKS_T054(P001,A001,A002,A003,A100) VALUES(V_ORGANID,V_P001,V_A003,V_A005,v_orgid);
       commit;

       insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (V_KJAXUSER,sysdate,'ҵ̨ˣ޸ӪҵϢͳƱ ID'||V_P001||'',v_task);

  end cisp_UPD_BKST054;
/

prompt
prompt Creating procedure CISP_UPD_BKST064
prompt ===================================
prompt
create or replace procedure CISP_UPD_BKST064(errcode    out int,
                                             errmsg     out varchar2,
                                             V_KJAXUSER varchar2,
                                             V_TASK     varchar2,
                                             V_P001     integer,
                                             V_P002     varchar2,
                                             V_A002     varchar2,
                                             V_A003     varchar2,
                                             V_A004     varchar2

                                             ) is

  V_count_id int;
  v_orgid    int;
begin

  select x.w100
    into v_orgid
    from krcs.t_ctl_t036 x, krcs.t_sys_user xx
   where x.p001 = xx.p002
     and xx.p001 = V_KJAXUSER;
  select count(*)
    into V_count_id
    from cisp.t_bks_t064
   where p001 = V_p001
     and A100 = v_orgid;

  if (V_count_id = 0) then
    insert into cisp.t_bks_t064
      (P001, A002, A003, A004, A100)
    values
      (V_P001, V_A002, V_A003, V_A004, v_orgid);

  else
    update cisp.t_bks_t064
       set A002 = V_A002, A003 = V_A003, A004 = V_A004
     where p001 = V_P001
       and A100 = v_orgid;

  end if;
  insert into krcs.t_sys_log
    (p001, p002, a003, a004)
  values
    (V_KJAXUSER,
     sysdate,
     '޸֤ȯ˾ Ӫҵȯרܱ- ID[' || V_P001 || ']',
     V_TASK);
  errcode := 1;
  errmsg  := '޸ĳɹ!';
end;
/

prompt
prompt Creating procedure CISP_UPD_BKST101
prompt ===================================
prompt
create or replace procedure CISP_UPD_BKST101(
          errcode    out int,
          errmsg     out varchar2,
          kjaxuser varchar2,
          v_task   varchar2,

          V_P001  int,
          V_A001  varchar2,
          V_A002  varchar2,
          V_A003  varchar2,
          V_A004  varchar2,
          V_A005  varchar2,
          V_A006  varchar2,
          V_A007  varchar2,
          V_A008  varchar2,
          V_A009  varchar2,
          V_A010  varchar2,
          V_A011  varchar2,
          V_A012  varchar2,
          V_A013  varchar2,
          V_A014  varchar2
 ) is
     v_orgid number;

begin
      select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
      errcode := 1;
      errmsg  := '޸ĳɹ';

      update  T_BKS_T101 set
          A001  =  V_A001,
          A002  =  V_A002,
          A003  =  V_A003,
          A004  =  V_A004,
          A005  =  V_A005,
          A006  =  V_A006,
          A007  =  V_A007,
          A008  =  V_A008,
          A009  =  V_A009,
          A010  =  V_A010,
          A011  =  V_A011,
          A012  =  V_A012,
          A013  =  V_A013,
          A014  =  V_A014
      where p001=V_P001 and a100=v_orgid;

      insert into krcs.T_SYS_LOG
      (P001, P002, A003,A004)
       values
      (kjaxuser,sysdate,'ҵ̨ˣ۸³ɹ뽻ⲿϢϵͳ漰˻ ID'||V_P001||'',v_task);
       commit;
end CISP_UPD_BKST101;
/

prompt
prompt Creating procedure CISP_UPD_BKST102
prompt ===================================
prompt
create or replace procedure CISP_UPD_BKST102(
                       errcode    out  int,
                       errmsg     out varchar2,
                       kjaxuser varchar2,
                       v_task   varchar2,

                      V_P001  int,
                      V_A001  varchar2,
                      V_A002  varchar2,
                      V_A003  varchar2,
                      V_A004  varchar2,
                      V_A005  varchar2,
                      V_A006  varchar2,
                      V_A007  varchar2,
                      V_A008  varchar2,
                      V_A009  varchar2,
                      V_A011  number,
                      V_A010  varchar2
 ) is
    v_orgid number;

begin
      select p002 into v_orgid from krcs.t_sys_user where p001 = kjaxuser;
      errcode := 1;
      errmsg  := '޸ĳɹ';

      update  T_BKS_T102 set
          A001  =  V_A001,
          A002  =  V_A002,
          A003  =  V_A003,
          A004  =  V_A004,
          A005  =  V_A005,
          A006  =  V_A006,
          A007 = to_date(V_A007,'yyyy-mm-dd'),
          a008  = to_date(V_A008,'yyyy-mm-dd'),
          A009  =  V_A009,
          A010  =  V_A010,
          A011=V_A011
      where p001=V_P001 and a100=v_orgid;

      insert into krcs.T_SYS_LOG
          (P001, P002, A003,A004)
      values
          (kjaxuser, sysdate,'ҵ̨ˣ۸³ɹ뽻ⲿϢϵͳ漰˻ϸ ID'||V_P001||'',v_task);
      commit;
end CISP_UPD_BKST102;
/

prompt
prompt Creating procedure CISP_UPD_BKSZYRHHY
prompt =====================================
prompt
create or replace procedure cisp_UPD_BKSZYRHHY(ERRCODE OUT INT,
    ERRMSG OUT VARCHAR2,
    KJAXUSER VARCHAR2,
    V_TASK VARCHAR2,
    V_P001 VARCHAR2,
    V_JYRQ VARCHAR2,
    V_HTH VARCHAR2,
    V_GLHTH VARCHAR2,
    V_SBHTXH VARCHAR2,
    V_HTLX VARCHAR2,
  V_FZJG VARCHAR2,
  V_KHBH VARCHAR2,
  V_KHXM VARCHAR2,
  V_RCFMC VARCHAR2,
  V_RCFLX VARCHAR2,
  V_ZQDM VARCHAR2,
  V_ZQMC VARCHAR2,
  V_WTSL integer,
  V_HGSL integer,
  V_LJBFJYSL integer,
  V_LJWYMCSL integer,
  V_WTJE NUMBER,
  V_YHJE NUMBER,
  V_DQRQ VARCHAR2,
  V_SJGHRQ VARCHAR2,
  V_WTRQ integer,
  V_JYSC VARCHAR2,
  V_XSBS VARCHAR2,
  V_JGBS VARCHAR2,
  V_HGLL  NUMBER,
  V_SJGHJE  NUMBER,
  V_YJLX  NUMBER,
  V_SFWY  VARCHAR2
    ) IS


  v_A100 int;

begin
  select p002 into v_A100 from krcs.t_sys_user where p001=kjaxuser;
  update CISP.T_BKS_ZYRHHY SET  JYRQ = V_JYRQ, HTH = V_HTH,GLHTH = V_GLHTH,SBHTXH = V_SBHTXH,HTLX  = V_HTLX,FZJG  = V_FZJG,KHBH  = V_KHBH,KHXM  = V_KHXM,RCFMC = V_RCFMC,RCFLX = V_RCFLX,ZQDM  = V_ZQDM,ZQMC  = V_ZQMC,WTSL  = V_WTSL,HGSL  = V_HGSL,LJBFJYSL = V_LJBFJYSL,LJWYMCSL = V_LJWYMCSL,WTJE   = V_WTJE,YHJE   = V_YHJE
   ,DQRQ = V_DQRQ,SJGHRQ = V_SJGHRQ,WTRQ = V_WTRQ,JYSC = V_JYSC,XSBZ = V_XSBS,JGBS = V_JGBS,HGLL = V_HGLL,SJGHJE = V_SJGHJE,YJLX = V_YJLX,SFWY = V_SFWY WHERE P001= V_P001  AND A100 = v_A100;
  insert into krcs.t_sys_log(p001,p002,a003,a004)values(kjaxuser,sysdate,'̨Ϣ ID:['||v_p001||']',v_task);
  errcode := 1;
  errmsg := '³ɹ!';
end cisp_UPD_BKSZYRHHY;
/

prompt
prompt Creating procedure CISP_UPD_BKS_T016
prompt ====================================
prompt
create or replace procedure CISP_UPD_BKS_T016(errcode    out int,
                                              errmsg     out varchar2,
                                              v_KJAXUSER varchar2,
                                              v_TASK     varchar2,
                                              VP001      varchar2,
                                              VA002      varchar2,
                                              VA003      numeric,
                                              VA004      numeric,
                                              VA005      numeric) is
  V_A003 numeric;
  V_A004 numeric;
  V_ORG  number;
begin
  errcode := 1;
  errmsg  := '';

  V_A003 := substr(VA003, 4, 7);
  V_A004 := substr(VA003, 1, 3);

  select p002 into V_ORG from krcs.t_sys_user where p001 = v_KJAXUSER;

  update t_bks_t016
     set A005 = VA004, A006 = v_KJAXUSER, A007 = sysdate
   where P001 = VP001
     and A003 = V_A003
     and A004 = V_A004
     and A100 = V_ORG;

  if VA003 = '1001012' or VA003 = '1001017' then
    delete from t_bks_t019 where P001 = VP001 and A100 = V_ORG;
    insert into T_BKS_T019 (P001, A002, A003 ,A100) values (VP001, VA002, VA005 ,V_ORG);
  end if;

  --ͬһµ֤ȯйɱϢΪܴͬһ֤ȯڲͬС࣬ͬ¹ɱ
  update t_bks_t016
     set A005 = VA004, A006 = v_KJAXUSER, A007 = sysdate
   where P001 = VP001
     and A004 = V_A004
     and A100 = V_ORG;

  insert into KRCS.T_SYS_LOG
    (P001, P002, A003 ,A004)
  values
    (v_KJAXUSER,
     sysdate,
     '֤ȯϢIDBKS_T016޸֤ȯϢ--ɱࣻ룺<font color=red>' ||
     VP001 || '</font>',
     v_TASK);

exception
  when others then
    errcode := 0;
    errmsg  := '洢̷';
    return;
end;
/

prompt
prompt Creating procedure CISP_UPD_BKS_T019
prompt ====================================
prompt
create or replace procedure CISP_UPD_BKS_T019(errcode    out int,
                                              errmsg     out varchar2,
                                              v_KJAXUSER varchar2,
                                              v_TASK     varchar2,
                                              VP001      varchar2,
                                              VA002      varchar2,
                                              VA003      numeric,
                                              VA004      numeric,
                                              VA005      numeric) is
  V_A003 numeric;
  V_A004 numeric;
  V_ORG  number;
begin
  errcode := 1;
  errmsg  := '';
  V_A003  := substr(VA003, 4, 7);
  V_A004  := substr(VA003, 1, 3);

  select p002 into V_ORG from krcs.t_sys_user where p001 = v_KJAXUSER;

  update t_bks_t016
     set A005 = VA004, A006 = v_KJAXUSER, A007 = sysdate
   where P001 = VP001
     and A003 = V_A003
     and A004 = V_A004
     and A100 = V_ORG;

  delete from t_bks_t019 where P001 = VP001 and A100 = V_ORG;
  insert into T_BKS_T019 (P001, A002, A003 ,A100) values (VP001, VA002, VA005 ,V_ORG);

  --ͬһµ֤ȯйɱϢΪܴͬһ֤ȯڲͬС࣬ͬ¹ɱ
  update t_bks_t016
     set A005 = VA004, A006 = v_KJAXUSER, A007 = sysdate
   where P001 = VP001
     and A004 = V_A004
     and A100 = V_ORG;

  insert into KRCS.T_SYS_LOG
    (P001, P002, A003 ,A004)
  values
    (v_KJAXUSER,
     sysdate,
     '֤ȯϢIDBKS_T019޸֤ȯϢ--ͨɹ룺<font color=red>' ||
     VP001 || '</font>',
     v_TASK);

exception
  when others then
    errcode := 0;
    errmsg  := '洢̷';
    return;
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_110006001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_110006001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    v_otitle varchar2,
    v_col1 number,
    v_col2 number,
    v_col3 number,
    v_col4 number,
    v_col5 number)
  is
    v_orgid number;
    v_bmid number;
    v_rowid varchar2(4000);
    v_count integer;

  begin
    errcode:=1;
    errmsg:='';

    SELECT P002,A012 into v_orgid,v_bmid from  krcs.T_SYS_USER WHERE P001=v_KJAXUSER;

    select count(*) into v_count from t_db1_01_001  where a100 = v_orgid and  w100 = v_bmid and p001 = '1001';
    if (v_count =1) then
       select rowid into v_rowid from t_db1_01_001 where  a100 = v_orgid and w100 = v_bmid and p001 = '1001';
       update t_db1_01_001 set a002 = v_col1 where a100 = v_orgid and  w100 = v_bmid and p001 = '1001';
       commit;
       cisp_ins_updrecord('110006001',v_rowid,v_KJAXUSER,1,'','ۼ߿ͻ');
    else
       insert into t_db1_01_001(P001,A002,A100,w100)values('1001',v_col1,v_orgid,v_bmid);
    end if;

    select count(*) into v_count from t_db1_01_001  where a100 = v_orgid and w100 = v_bmid and p001 = '1002';
    if (v_count =1) then
       select rowid into v_rowid from t_db1_01_001 where  a100 = v_orgid and w100 = v_bmid and p001 = '1002';
       update t_db1_01_001 set a002 = v_col2 where a100 = v_orgid and w100 = v_bmid and p001 = '1002';
       commit;
       cisp_ins_updrecord('110006001',v_rowid,v_KJAXUSER,1,'','߿ͻ');
    else
       insert into t_db1_01_001(P001,A002,A100,w100)values('1002',v_col2,v_orgid,v_bmid);
    end if;

    select count(*) into v_count from t_db1_01_001  where a100 = v_orgid and  w100 = v_bmid and p001 = '1003';
    if (v_count =1) then
       select rowid into v_rowid from t_db1_01_001 where  a100 = v_orgid and w100 = v_bmid and p001 = '1003';
       update t_db1_01_001 set a002 = v_col3 where a100 = v_orgid and w100 = v_bmid and p001 = '1003';
       commit;
       cisp_ins_updrecord('110006001',v_rowid,v_KJAXUSER,1,'ʵʩܵĿͻ׽ʽ','ңԪ');
    else
       insert into t_db1_01_001(P001,A002,A100,w100)values('1003',v_col3,v_orgid,v_bmid);
    end if;

    select count(*) into v_count from t_db1_01_001  where a100 = v_orgid and w100 = v_bmid and p001 = '1004';
    if (v_count =1) then
       select rowid into v_rowid from t_db1_01_001 where  a100 = v_orgid and w100 = v_bmid and p001 = '1004';
       update t_db1_01_001 set a002 = v_col4 where a100 = v_orgid and w100 = v_bmid and p001 = '1004';
       commit;
       cisp_ins_updrecord('110006001',v_rowid,v_KJAXUSER,1,'ʵʩܵĿͻ׽ʽ','۱ңԪ');
    else
       insert into t_db1_01_001(P001,A002,A100,w100)values('1004',v_col4,v_orgid,v_bmid);
    end if;

    select count(*) into v_count from t_db1_01_001  where a100 = v_orgid and w100 = v_bmid and p001 = '1005';
    if (v_count =1) then
       select rowid into v_rowid from t_db1_01_001 where  a100 = v_orgid and w100 = v_bmid and p001 = '1005';
       update t_db1_01_001 set a002 = v_col5 where a100 = v_orgid and w100 = v_bmid and p001 = '1005';
       commit;
       cisp_ins_updrecord('110006001',v_rowid,v_KJAXUSER,1,'ʵʩܵĿͻ׽ʽ','۱ңԪ');
    else
       insert into t_db1_01_001(P001,A002,A100,w100)values('1005',v_col5,v_orgid,v_bmid);
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=110006001
     and a004 = v_bmid and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID110006001]޸ĵܽչ:'||v_otitle,v_TASK);
 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111001001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111001001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task   varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    logP001  varchar2,
    logA002  varchar2

)
  is
    v_rowid varchar2(2000);
    v_count integer;

  begin
    errcode:=1;
    errmsg:='';

    select count(*) into v_count from cisp.T_DA_01_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_01_001 where p001=v_P001  AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);

       update cisp.T_DA_01_001 set A002=v_A002, A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
           commit;
           cisp_ins_updrecord('111001001',v_rowid,v_KJAXUSER,1,logP001,logA002);


    else
       insert into cisp.T_DA_01_001(P001,A002,A003,A100,w100)
              SELECT v_P001,v_A002,v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111001001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
 insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111001001޸֤ȯ˾ʱ' || logP001 || '<font color=red>' ||logA002 || '</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2   )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_01_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DA_01_002 where p001=v_P001  AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);

       update cisp.T_DA_01_002 set A002=v_A002,A003=v_A003, A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('111002001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DA_01_002 (P001,A002,A003,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002001޸֤ȯ˾տָܱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002002 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002002 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002002,A005=v_A005,A006=v_A006
           where A004=111002002 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
           commit;
        cisp_ins_updrecord('111002002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,w100)
              SELECT v_P001,v_A002,v_A003,111002002,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
     insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002002޸ĶԵͻʹģ뾻ʱıǰĿͻ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    V_rowid varchar(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002003 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002003 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002003,A005=v_A005,A006=v_A006
           where A004=111002003 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);

           commit;
           cisp_ins_updrecord('111002003',v_rowid,v_KJAXUSER,1,logP001,logA002);

    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,w100)
              SELECT v_P001,v_A002,v_A003,111002003,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
     insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002003޸ĶԵͻȯģ뾻ʱıǰĿͻ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002004 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002004 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002004,A005=v_A005,A006=v_A006
           where A004=111002004 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
        cisp_ins_updrecord('111002004',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002004,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002004޸ĽֻܵƱֵùƱֵǰĹƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002005(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002005 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid  into v_rowid from cisp.T_DA_02_001
           where A004=111002005 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002005,A005=v_A005,A006=v_A006
           where A004=111002005 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
             cisp_ins_updrecord('111002005',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,w100)
              SELECT v_P001,v_A002,v_A003,111002005,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002005
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
     insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002005һȨ֤ȯĳɱ뾻ʱıǰ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002006
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002006(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002006 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002006 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002006,A005=v_A005,A006=v_A006
           where A004=111002006 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
     cisp_ins_updrecord('111002006',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002006,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

     update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002006
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
     insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID111002006һȨ֤ȯֵֵıǰ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002007
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002007(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002007 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002007 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002007,A005=v_A005,A006=v_A006
           where A004=111002007 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
             cisp_ins_updrecord('111002007',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002007,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002007
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002007޸ĽֻܵƱֵùƱֵǰĹƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002008
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002008(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002008 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002008 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002008,A005=v_A005,A006=v_A006
           where A004=111002008 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
 cisp_ins_updrecord('111002008',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002008,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002008
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002008޸ĽֻܵƱֵùƱֵǰĹƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002009
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002009(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002009 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002009 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A005=v_A005,A006=v_A006
           where A004=111002009 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
 cisp_ins_updrecord('111002009',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002009,v_A005,v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002009
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
       insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID111002009޸ĽֻܵƱֵùƱֵǰĹƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002010
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002010(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002010 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002010 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002010,A005=v_A005,A006=v_A006
           where A004=111002010 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
 cisp_ins_updrecord('111002010',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002010,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002010
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002010޸ĽֻܵƱֵùƱֵǰĹƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002011
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002011(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002011 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002011 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002011,A005=v_A005,A006=v_A006
           where A004=111002011 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
    cisp_ins_updrecord('111002011',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002011,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002011
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002011޸ĽֻܵƱֵùƱֵǰĹƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111002012
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111002012(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_Task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_02_001
           where A004=111002012 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DA_02_001
           where A004=111002012 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_02_001 set  P001=v_P001,A002=v_A002,A003=v_A003,A004=111002012,A005=v_A005,A006=v_A006
           where A004=111002012 AND A005=v_A005 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
             cisp_ins_updrecord('111002012',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_02_001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,111002012,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111002012
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111002012޸ĽֻܵƱֵùƱֵǰĹƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111003001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111003001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    logP001  varchar2,
    logA002  varchar2
)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_01_004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_01_004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_01_004 set A002=v_A002, A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
 cisp_ins_updrecord('111003001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_01_004(P001,A002,A003,A100,w100)
              SELECT v_P001,v_A002,v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111003001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
 insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111003001޸֤ȯ˾ʱ׼' || logP001 || '<font color=red>' ||logA002 || '</font>',v_Task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111004001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111004001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 varchar2,
    logP001  varchar2,
    logA002  varchar2   )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DA_01_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DA_01_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DA_01_003 set A002=v_A002,A003=v_A003, A004=v_A004,A005=v_A005, A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
 cisp_ins_updrecord('111004001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DA_01_003 (P001,A002,A003,A004,A005,A006,A100,w100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111004001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

 insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111004001޸Ŀͻ׽ʽȫԼܱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111501001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111501001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A003 number,
    v_A002 number,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DACT_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DACT_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DACT_001 set A002=v_A002, A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
              cisp_ins_updrecord('111501001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DACT_001(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002, v_A003, P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111501001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
 insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111501001޸ʲծԭʼ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111501002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111501002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A003 number,
    v_A002 number,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DACT_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.T_DACT_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DACT_002 set A002=v_A002, A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
 cisp_ins_updrecord('111501002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DACT_002(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002, v_A003, P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111501002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111501002޸ʲծܱϣ'||logP001||'<font color=red>'||v_P001||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111502001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111502001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DACT_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DACT_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DACT_003 set A002=v_A002, A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
              cisp_ins_updrecord('111502001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DACT_003(P001,A002,A003,A100,w100)
              SELECT v_P001, v_A002, v_A003, P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111502001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111502001޸ܱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111503001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111503001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    v_A010 numeric,
    v_A007 numeric,
    v_A008 numeric,
    v_A009 numeric,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DACT_004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.T_DACT_004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DACT_004 set A002=v_A002, A003=v_A003,A004=v_A004,A005=v_A005, A006=v_A006,A010=v_A010,A007=v_A007,A008=v_A008, A009=v_A009
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('111503001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DACT_004(P001,A002,A003,A004,A005,A006,A010,A007,A008,A009,A100,w100)
              SELECT v_P001, v_A002, v_A003,v_A004, v_A005,v_A006,v_A010, v_A007,v_A008, v_A009,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111503001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
 insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID111503001޸Ȩ棨ɶȨ棩䶯ܱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_111504001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_111504001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DACT_005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DACT_005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DACT_005 set A002=v_A002, A003=v_A003,A004=v_A004,A005=v_A005, A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('111504001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DACT_005(P001,A002,A003,A004,A005,A006,A100,w100)
              SELECT v_P001, v_A002, v_A003,v_A004, v_A005,v_A006,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=111504001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
 insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID111504001޸ʲֵ׼ܱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112001001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112001001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_001
           where P001=v_P001 AND P002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_001
           where P001=v_P001 AND P002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_001 set A003=v_A002
           where P001=v_P001 AND P002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
       cisp_ins_updrecord('112001001',v_rowid,v_KJAXUSER,1,logP001,logA002||'');
    else
       insert into cisp.T_DB_01_001 (P001,P002,A003,A100,W100)
              SELECT v_P001,1001,v_A002,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_001
           where P001=v_P001 AND P002=1004 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_01_001 set A003=v_A003
           where P001=v_P001 AND P002=1004 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.T_DB_01_001
           where P001=v_P001 AND P002=1004 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('112001001',v_rowid,v_KJAXUSER,1,logP001,logA002||'Ԫ');
    else
       insert into cisp.T_DB_01_001 (P001,P002,A003,A100,W100)
              SELECT v_P001,1004,v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_001
           where P001=v_P001 AND P002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_01_001 set A003=v_A004
           where P001=v_P001 AND P002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.T_DB_01_001
           where P001=v_P001 AND P002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('112001001',v_rowid,v_KJAXUSER,1,logP001,logA002||'۱');
    else
       insert into cisp.T_DB_01_001 (P001,P002,A003,A100,W100)
              SELECT v_P001,1002,v_A004,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112001001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112001001޸ľҵ񣭿ͻ׽ʽ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112001002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112001002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 integer,
    v_A003 integer,
    v_A004 integer,
    logP001  varchar2,
    logA002  varchar2 )
  is
     v_count1 integer;
     v_count2 integer;
     v_count3 integer;
     v_rowid1 varchar2(4000);
     v_rowid2 varchar2(4000);
     v_rowid3 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';

    select count(1) into v_count1 from cisp.T_DB_01_002 where p001=v_P001 and p002=1001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
    select count(1) into v_count2 from cisp.T_DB_01_002 where p001=v_P001 and p002=1002 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
    select count(1) into v_count3 from cisp.T_DB_01_002 where p001=v_P001 and p002=1003 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);

    if(v_count1 =1) then
        update cisp.T_DB_01_002 set a003 = v_A002 where p001=v_P001 and p002=1001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        commit;
        select rowid into v_rowid1 from cisp.T_DB_01_002 where p001=v_P001 and p002=1001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        cisp_ins_updrecord('112001002',v_rowid1,v_KJAXUSER,1,logP001,logA002||':');
    else
        insert into cisp.T_DB_01_002 (P001,P002,A003,A100,W100)
              SELECT v_P001,1001,v_A002,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    if(v_count2 =1) then
        update cisp.T_DB_01_002 set a003 = v_A003 where p001=v_P001 and p002=1002 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        commit;
        select rowid into v_rowid2 from cisp.T_DB_01_002 where p001=v_P001 and p002=1002 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        cisp_ins_updrecord('112001002',v_rowid2,v_KJAXUSER,1,logP001,logA002||':Ԫ');
    else
        insert into cisp.T_DB_01_002 (P001,P002,A003,A100,W100)
              SELECT v_P001,1002,v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    if(v_count3 =1) then
        update cisp.T_DB_01_002 set a003 = v_A004 where p001=v_P001 and p002=1003 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        commit;
        select rowid into v_rowid3 from cisp.T_DB_01_002 where p001=v_P001 and p002=1003 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        cisp_ins_updrecord('112001002',v_rowid3,v_KJAXUSER,1,logP001,logA002||':۱');
    else
        insert into cisp.T_DB_01_002 (P001,P002,A003,A100,W100)
              SELECT v_P001,1003,v_A004,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112001002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
   insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112001002޸ľҵʽ˻'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112001003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112001003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 integer,
    v_A003 integer,
    v_A004 integer,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_003
           where P001=v_P001 AND P002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_003
           where P001=v_P001 AND P002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_003 set A003=v_A002
           where P001=v_P001 AND P002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112001003',v_rowid,v_KJAXUSER,1,logP001,logA002||'');
    else
       insert into cisp.T_DB_01_003 (P001,P002,A003,A100,W100)
              SELECT v_P001,1001,v_A002,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_003
           where P001=v_P001 AND P002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_01_003 set A003=v_A003
           where P001=v_P001 AND P002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        select rowid into v_rowid from cisp.T_DB_01_003
           where P001=v_P001 AND P002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('112001003',v_rowid,v_KJAXUSER,1,logP001,logA002||'Ϻ¹');
    else
       insert into cisp.T_DB_01_003 (P001,P002,A003,A100,W100)
              SELECT v_P001,1002,v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_003
           where P001=v_P001 AND P002=1003 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_01_003 set A003=v_A004
           where P001=v_P001 AND P002=1003 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.T_DB_01_003
           where P001=v_P001 AND P002=1003 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('112001003',v_rowid,v_KJAXUSER,1,logP001,logA002||'ڣ¹');
    else
       insert into cisp.T_DB_01_003 (P001,P002,A003,A100,W100)
              SELECT v_P001,1003,v_A004,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112001003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
   insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112001003޸ľҵ֤ȯ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112001004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112001004(errcode  out int,
                                             errmsg   out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task    varchar2,
                                             v_P001    integer,
                                             v_A003    integer,
                                             v_A004    integer,
                                             v_A005    integer,
                                             v_A006    integer,
                                             v_A099   varchar2,
                                             logP001  varchar2,
                                             logA002  varchar2)
is
v_count integer;
v_rowid varchar2(4000);
begin
  errcode := 1;
  errmsg  := '';
  SELECT COUNT(*) INTO v_count FROM cisp.T_DB_01_020 where P001 = v_P001
           AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
  if (v_count = 0) then
    insert into cisp.T_DB_01_020
      (P001,A002,A003,A004,A005,A099,W100,A100)
    SELECT v_P001,v_A003,v_A004,v_A005,v_A006,v_A099,a012,P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;

  else
    update cisp.T_DB_01_020 set  A002=v_A003,A003=v_A004,A004=v_A005,A005=v_A006,a099 = v_A099
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    commit;
    SELECT rowid INTO v_rowid FROM cisp.T_DB_01_020 where P001 = v_P001
           AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
     SELECT COUNT(*) INTO v_count FROM cisp.T_DB_01_020 where P001 = v_P001
           AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);

            cisp_ins_updrecord('112001004',v_rowid,v_KJAXUSER,1,logP001,logA002);
  end if;

 insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112001004޸ķ˻'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end ;
/

prompt
prompt Creating procedure CISP_UPD_DT_112002001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112002001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_004
           where P001=v_P001 AND A002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_004
           where P001=v_P001 AND A002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_004 set A003=v_A002,A004=v_A003
           where P001=v_P001 AND A002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112002001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_01_004(P001,A002,A003,A004,A100,W100)
              SELECT v_P001, 1001, v_A002,v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_004
           where P001=v_P001 AND A002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_01_004 set A003=v_A004,A004=v_A005
           where P001=v_P001 AND A002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    else
       insert into cisp.T_DB_01_004(P001,A002,A003,A004,A100,W100)
              SELECT v_P001, 1002, v_A004,v_A005,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112002001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and  p002=v_task;
 insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112002001޸ľҵ񣭽׻ܣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112002002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112002002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_005
           where P001=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_005
           where P001=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_005 set A002=v_A001,A003=v_A004
           where P001=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112002002',v_rowid,v_KJAXUSER,1,'','');
    else
       insert into cisp.T_DB_01_005(P001,A002,A003,A100,W100)
              SELECT 1001, v_A001,v_A004,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_005
           where P001=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_005
           where P001=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_005 set A002=v_A002, A003=v_A005
           where P001=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112002002',v_rowid,v_KJAXUSER,1,'','Ԫ');
    else
       insert into cisp.T_DB_01_005(P001,A002,A003,A100,W100)
              SELECT 1002, v_A002,v_A005,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_005
           where P001=1004 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_005
           where P001=1004 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_005 set A002=v_A003, A003=v_A006
           where P001=1004 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112002002',v_rowid,v_KJAXUSER,1,'','Ԫ');
    else
       insert into cisp.T_DB_01_005(P001,A002,A003,A100,W100)
              SELECT 1004, v_A003,v_A006, P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112002002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112002002޸ľҵϽף--±',v_Task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112002003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112002003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_006
           where P001=v_P001 AND A002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_006
           where P001=v_P001 AND A002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_006 set A003=v_A002
           where P001=v_P001 AND A002=1001 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112002003',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_01_006(P001,A002,A003,A100,W100)
              SELECT v_P001,1001,v_A002,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_006
           where P001=v_P001 AND A002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_006
           where P001=v_P001 AND A002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_006 set A003=v_A003
           where P001=v_P001 AND A002=1002 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112002003',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_01_006(P001,A002,A003,A100,W100)
              SELECT v_P001,1002,v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112002003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112002003޸ľҵֵ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112002004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112002004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 number,
    v_col1 numeric,
    v_col2 numeric,
    v_col3 numeric,
    v_col4 numeric,
    logP001  varchar2,
    logA002  varchar2 )
  is
  v_count number;
  v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(1) into v_count from cisp.T_DB_01_007 where p001=1001301 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER);
     if(v_count =1) then
        update cisp.T_DB_01_007 set a002 = v_col1 where p001=1001301 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        commit;
        select rowid into v_rowid from cisp.T_DB_01_007 where p001=1001301 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        cisp_ins_updrecord('112002004',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
        insert into cisp.T_DB_01_007 (P001,A002,A100,A003,W100)
             values(1001301,v_col1,(SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER),v_P001,(SELECT a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER));
    end if;

    select count(1) into v_count from cisp.T_DB_01_007 where p001=1001302 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER);
     if(v_count =1) then
        update cisp.T_DB_01_007 set a002 = v_col2 where p001=1001302 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        commit;
        select rowid into v_rowid from cisp.T_DB_01_007 where p001=1001302 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        cisp_ins_updrecord('112002004',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
        insert into cisp.T_DB_01_007 (P001,A002,A100,A003,W100)
             values(1001302,v_col2,(SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER),v_P001,(SELECT a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER));
    end if;

    select count(1) into v_count from cisp.T_DB_01_007 where p001=1001303 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER);
     if(v_count =1) then
        update cisp.T_DB_01_007 set a002 = v_col3 where p001=1001303 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        commit;
        select rowid into v_rowid from cisp.T_DB_01_007 where p001=1001303 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        cisp_ins_updrecord('112002004',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
        insert into cisp.T_DB_01_007 (P001,A002,A100,A003,W100)
             values(1001303,v_col3,(SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER),v_P001,(SELECT a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER));
    end if;

    select count(1) into v_count from cisp.T_DB_01_007 where p001=1001304 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001 =v_KJAXUSER);
     if(v_count =1) then
        update cisp.T_DB_01_007 set a002 = v_col4 where p001=1001304 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        commit;
        select rowid into v_rowid from cisp.T_DB_01_007 where p001=1001304 and A003 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
        cisp_ins_updrecord('112002004',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
        insert into cisp.T_DB_01_007 (P001,A002,A100,A003,W100)
             values(1001304,v_col4,(SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER),v_P001,(SELECT a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER));
    end if;


   update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112002004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

   insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112002004޸ľҵ񣭲'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  commit;
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112003001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112003001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_008
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_008
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_008 set A002=v_A001
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003001',v_rowid,v_KJAXUSER,1,'׽','');
    else
       insert into cisp.T_DB_01_008(P001,A002,A100,W100)
              SELECT 1001403,v_A001,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_008
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_008
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_008 set A002=v_A002
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003001',v_rowid,v_KJAXUSER,1,'׽','ڱۼ');
    else
       insert into cisp.T_DB_01_008(P001,A002,A100,W100)
              SELECT 1001404, v_A002,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_008
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_008
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_008 set A002=v_A003
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003001',v_rowid,v_KJAXUSER,1,'Ӷ','');
    else
       insert into cisp.T_DB_01_008(P001,A002,A100,W100)
              SELECT 1001405, v_A003,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_008
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_008
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_008 set A002=v_A004
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003001',v_rowid,v_KJAXUSER,1,'Ӷ','ڱۼ');
    else
       insert into cisp.T_DB_01_008(P001,A002,A100,W100)
              SELECT 1001406, v_A004,P002,a012 FROM krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
    end if;

   update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112003001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
  insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112003001޸ľҵ񣭴',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112003002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112003002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_009
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_009
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_009 set A002=v_A001
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003002',v_rowid,v_KJAXUSER,1,'ʲף','');
    else
       insert into cisp.T_DB_01_009(P001,A002,A100,W100)
              SELECT 1001403,v_A001,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_009
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_009
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_009 set A002=v_A002
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003002',v_rowid,v_KJAXUSER,1,'ʲף','ڱۼ');
    else
       insert into cisp.T_DB_01_009(P001,A002,A100,W100)
              SELECT 1001404, v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_009
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_009
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_009 set A002=v_A003
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003002',v_rowid,v_KJAXUSER,1,'Ӷ','');
    else
       insert into cisp.T_DB_01_009(P001,A002,A100,W100)
              SELECT 1001405, v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_009
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_009
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_009 set A002=v_A004
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003002',v_rowid,v_KJAXUSER,1,'Ӷ','ڱۼ');
    else
       insert into cisp.T_DB_01_009(P001,A002,A100,W100)
              SELECT 1001406, v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112003002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112003002޸ľҵ񣭴ʲ',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112003003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112003003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_010
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_010
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_010 set A002=v_A001
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003003',v_rowid,v_KJAXUSER,1,'ծף','');
    else
       insert into cisp.T_DB_01_010(P001,A002,A100,W100)
              SELECT 1001403,v_A001,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_010
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_010
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_010 set A002=v_A002
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003003',v_rowid,v_KJAXUSER,1,'ծף','ڱۼ');
    else
       insert into cisp.T_DB_01_010(P001,A002,A100,W100)
              SELECT 1001404, v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_010
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_010
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_010 set A002=v_A003
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003003',v_rowid,v_KJAXUSER,1,'Ӷ','');
    else
       insert into cisp.T_DB_01_010(P001,A002,A100,W100)
              SELECT 1001405, v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_010
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_010
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_010 set A002=v_A004
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003003',v_rowid,v_KJAXUSER,1,'Ӷ','ڱۼ');
    else
       insert into cisp.T_DB_01_010(P001,A002,A100,W100)
              SELECT 1001406, v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

   update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112003003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112003003޸ľҵ--ծ',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112003004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112003004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_011
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_011
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_011 set A002=v_A001
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003004',v_rowid,v_KJAXUSER,1,'ծף','');
    else
       insert into cisp.T_DB_01_011(P001,A002,A100,W100)
              SELECT 1001403,v_A001,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_011
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_011
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_011 set A002=v_A002
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003004',v_rowid,v_KJAXUSER,1,'ծף','ڱۼ');
    else
       insert into cisp.T_DB_01_011(P001,A002,A100,W100)
              SELECT 1001404, v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_011
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_011
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_011 set A002=v_A003
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003004',v_rowid,v_KJAXUSER,1,'Ӷ','');
    else
       insert into cisp.T_DB_01_011(P001,A002,A100,W100)
              SELECT 1001405, v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_011
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_011
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_011 set A002=v_A004
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003004',v_rowid,v_KJAXUSER,1,'Ӷ','ڱۼ');
    else
       insert into cisp.T_DB_01_011(P001,A002,A100,W100)
              SELECT 1001406, v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112003004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112003004޸ľҵ--ծ',v_Task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112003005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112003005(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_012
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_012
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_012 set A002=v_A001
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003005',v_rowid,v_KJAXUSER,1,'Ҹծף','');
    else
       insert into cisp.T_DB_01_012(P001,A002,A100,W100)
              SELECT 1001403,v_A001,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_012
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_012
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_012 set A002=v_A002
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003005',v_rowid,v_KJAXUSER,1,'Ҹծף','ڱۼ');
    else
       insert into cisp.T_DB_01_012(P001,A002,A100,W100)
              SELECT 1001404, v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_012
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_012
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_012 set A002=v_A003
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003005',v_rowid,v_KJAXUSER,1,'Ӷ','');
    else
       insert into cisp.T_DB_01_012(P001,A002,A100,W100)
              SELECT 1001405, v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_012
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.T_DB_01_012
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_012 set A002=v_A004
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003005',v_rowid,v_KJAXUSER,1,'Ӷ','ڱۼ');
    else
       insert into cisp.T_DB_01_012(P001,A002,A100,W100)
              SELECT 1001406, v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112003005
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112003005޸ľҵ--Ҹծ',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112003006
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112003006(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_013
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_013
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_013 set A002=v_A001
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003006',v_rowid,v_KJAXUSER,1,'Ҹծף','');
    else
       insert into cisp.T_DB_01_013(P001,A002,A100,W100)
              SELECT 1001403,v_A001,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_013
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_013
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_013 set A002=v_A002
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003006',v_rowid,v_KJAXUSER,1,'Ҹծף','ڱۼ');
    else
       insert into cisp.T_DB_01_013(P001,A002,A100,W100)
              SELECT 1001404, v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_013
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_013
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_013 set A002=v_A003
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003006',v_rowid,v_KJAXUSER,1,'Ӷ','');
    else
       insert into cisp.T_DB_01_013(P001,A002,A100,W100)
              SELECT 1001405, v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_013
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_013
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_013 set A002=v_A004
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003006',v_rowid,v_KJAXUSER,1,'Ӷ','ڱۼ');
    else
       insert into cisp.T_DB_01_013(P001,A002,A100,W100)
              SELECT 1001406, v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112003006
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112003006޸ľҵ--Ҹծ',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112003007
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112003007(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_A001 numeric,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_01_014
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_014
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_014 set A002=v_A001
           where P001=1001403 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003007',v_rowid,v_KJAXUSER,1,'ҵ񣨽ף','');
    else
       insert into cisp.T_DB_01_014(P001,A002,A100,W100)
              SELECT 1001403,v_A001,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_014
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.T_DB_01_014
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_014 set A002=v_A002
           where P001=1001404 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003007',v_rowid,v_KJAXUSER,1,'ҵ񣨽ף','ڱۼ');
    else
       insert into cisp.T_DB_01_014(P001,A002,A100,W100)
              SELECT 1001404, v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_014
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_01_014
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_014 set A002=v_A003
           where P001=1001405 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003007',v_rowid,v_KJAXUSER,1,'Ӷ','');
    else
       insert into cisp.T_DB_01_014(P001,A002,A100,W100)
              SELECT 1001405, v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    select count(*) into v_count from cisp.T_DB_01_014
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.T_DB_01_014
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_01_014 set A002=v_A004
           where P001=1001406 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112003007',v_rowid,v_KJAXUSER,1,'Ӷ','ڱۼ');
    else
       insert into cisp.T_DB_01_014(P001,A002,A100,W100)
              SELECT 1001406, v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112003007
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112003007޸ľҵ--ҵ',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 number,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.t_db_03_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_001 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006,A007=v_A007,A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_001(P001,A001,A002,A003,A004,A005,A006,A007,A008,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004,v_A005, v_A006, v_A007, v_A008, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005001޸ĳҵ-״ηУ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 number,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_003 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006,A007=v_A007,A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_003(P001,A001,A002,A003,A004,A005,A006,A007,A008,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, v_A005, v_A006, v_A007, v_A008, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005002޸ĳҵ-ɣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 number,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.t_db_03_005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_005 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006,A007=v_A007,A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005003',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_005(P001,A001,A002,A003,A004,A005,A006,A007,A008,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004,v_A005, v_A006, v_A007, v_A008,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005003޸ĳҵ-'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 number,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_007
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_007
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_007 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,
                              A005=v_A005,A006=v_A006,A007=v_A007,A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005004',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_007(P001,A001,A002,A003,A004,A005,A006,A007,A008,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004,v_A005, v_A006, v_A007, v_A008, P002,a012
              FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005004޸ĳҵ-ծȯУ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005005(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 number,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_009
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.t_db_03_009
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_009 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006,A007=v_A007,A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005005',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_009(P001,A001,A002,A003,A004,A005,A006,A007,A008,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, v_A005, v_A006, v_A007, v_A008, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005005
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005005޸ĳҵ-'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005006
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005006(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 number,
    v_A005 numeric,
    v_A006 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_011
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.t_db_03_011
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_011 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005006',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_011(P001,A001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003,v_A004, v_A005, v_A006, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005006
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005006޸ĳҵ-״ηУ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005007
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005007(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 number,
    v_A005 numeric,
    v_A006 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_013
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_013
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_013 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005007',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_013(P001,A001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003,v_A004, v_A005, v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005007
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005007޸ĳҵ-ɣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005008
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005008(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 number,
    v_A005 numeric,
    v_A006 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_015
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_015
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_015 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005008',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_015(P001,A001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, v_A005, v_A006, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005008
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005008޸ĳҵ-'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005009
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005009(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 number,
    v_A005 numeric,
    v_A006 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
        v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_017
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.t_db_03_017
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_017 set A001=v_A001,A002=v_A002,A003=v_A003,
                              A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005009',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_017(P001,A001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, v_A005, v_A006, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005009
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005009޸ĳҵ-ծȯУ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005010
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005010(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 number,
    v_A005 numeric,
    v_A006 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
            v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_019
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_019
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_019 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005010',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_019(P001,A001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003,v_A004, v_A005, v_A006, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005010
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005010޸ĳҵ-'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005011
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005011(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
     v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_021
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
      select rowid into v_rowid from cisp.t_db_03_021
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_021 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005011',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_021(P001,A001,A002,A003,A004,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005011
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005011޸ĳҵ-ڰת״ηУ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005012
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005012(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
     v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_022
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_022
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_022 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005012',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_022(P001,A001,A002,A003,A004,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005012
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005012޸ĳҵ-ڰתɣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005013
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005013(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
     v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_023
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_023
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_023 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005013',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_023(P001,A001,A002,A003,A004,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;

    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005013
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112005013޸ĳҵ-ڰת'||logP001||'<font color=red>'||logA002||'</font>',v_task);

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005014
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005014(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_024
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_03_024
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_03_024 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112005014',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_024(P001,A001,A002,A003,A004,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005014
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005014޸ĳҵ-ڰתծȯУ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112005015
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112005015(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_Task varchar2,
    v_P001 integer,
    v_A001 number,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_03_025
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_db_03_025 set A001=v_A001,A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.t_db_03_025where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('112005015',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_03_025(P001,A001,A002,A003,A004,A100,W100)
              SELECT v_P001, v_A001, v_A002, v_A003, v_A004, P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112005015
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112005015޸ĳҵ-ڰת'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112006001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112006001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
        v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_04_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
        select rowid into v_rowid from cisp.t_db_04_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_04_003 set P001=v_P001,A002=v_A002, A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112006001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_04_003 (P001,A002,A003,A100,W100)
              SELECT v_P001,v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112006001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112006001޸֤ȯͶҵ-Խʲĩϸ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112006002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112006002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_04_004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_04_004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_04_004 set P001=v_P001,A002=v_A002, A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112006002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_04_004 (P001,A002,A003,A004,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112006002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112006002޸֤ȯͶҵ-ɹʲĩϸ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112006003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112006003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task  varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_04_005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_04_005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_04_005 set P001=v_P001,A002=v_A002, A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112006003',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_04_005 (P001,A002,A003,A100,W100)
              SELECT v_P001,v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112006003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112006003޸֤ȯͶҵ-ڽʲĩϸ'||logP001||'<font color=red>'||logA002||'</font>',v_Task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112006004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112006004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
     v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_04_006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.t_db_04_006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_04_006 set A002=v_A002
           where P001=v_P001 AND  A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
            commit;
            cisp_ins_updrecord('112006004',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.t_db_04_006 (P001,A002,A100,W100)
              SELECT v_P001,v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112006004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112006004޸֤ȯͶҵ-ط˵'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112007001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112007001(errcode    out int,
                                             errmsg     out varchar2,
                                             v_kjaxuser varchar2,
                                             v_task     varchar2,
                                             v_p001     int,
                                             v_A002     int,
                                             v_A003     number,
                                             v_A004     number,
                                             v_A005     number,
                                             v_A006     number,
                                             v_A007     number,
                                             v_A008     number

                                             ) is
   v_rowid varchar2(4000);
begin

select rowid into v_rowid from cisp.T_DB_04_007 where  P001 = v_P001 and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and A100=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER);
  update cisp.T_DB_04_007
     set A002 = v_A002,
         A003 = v_A003,
         A004 = v_A004,
         A005 = v_A005,
         A006 = v_A006,
         A007 = v_A007,
         A008 = v_A008
   where P001 = v_P001
     AND A100 IN (SELECT P002 FROM krcs.T_SYS_USER WHERE P001 = v_kjaxuser)
     and w100 in (select a012 from krcs.t_sys_user where p001 = v_kjaxuser);
      commit;
            cisp_ins_updrecord('112007001',v_rowid,v_KJAXUSER,1,'Ŀ','ָڻͶ');


  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 112007001
     and a004 in (select a012 from krcs.t_sys_user where p001 = v_KJAXUSER)
     and p002 = v_task;


  insert into krcs.t_sys_log
    (p001, p002, a003, a004)
  values
    (v_kjaxuser,
     sysdate,
     '޸ ֤ȯͶҵ񣨹ָڻͶʣID: 112007001',
     v_task);
  errcode := 1;
  errmsg  := '޸ĳɹ!';
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112008001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112008001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,

    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_05_101
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_05_101
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_05_101 set A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112008001',v_rowid,v_KJAXUSER,1,logP001,loga002||v_P001);
    else
       insert into cisp.t_db_05_101 (P001,A002,A003,A004,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112008001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112008001޸ļʲҵ-ĩͻ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112008002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112008002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A006 number,
    v_A007 number,
    v_A008 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_05_102
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_05_102
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_05_102 set A002=v_A002,A003=v_A003,A004=v_A004/*,A005=v_A005*/, A006=v_A006,A007=v_A007, A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112008002',v_rowid,v_KJAXUSER,1,logP001,loga002||v_P001);
    else
       insert into cisp.t_db_05_102 (P001,A002,A003,A004/*,A005*/,A006,A007,A008,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,/*v_A005,*/v_A006,v_A007,v_A008,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112008002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112008002޸ļʲҵ-ʽ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112008003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112008003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_05_103
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_05_103
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_05_103 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112008003',v_rowid,v_KJAXUSER,1,logP001,loga002||v_P001);
    else
       insert into cisp.t_db_05_103 (P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112008003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112008003޸ļʲҵ-ֵ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112009001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112009001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,

    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_06_101
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select rowid into v_rowid from cisp.t_db_06_101
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_06_101 set A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112009001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.t_db_06_101 (P001,A002,A003,A004,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112009001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112009001޸רʲҵ-ĩͻ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112009002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112009002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,

    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_06_102
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_06_102
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_06_102 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112009002',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.t_db_06_102 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112009002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112009002޸רʲҵ-ʵʷйģ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112009003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112009003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,

    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_06_103
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_06_103
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_06_103 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006,A007=v_A007,A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
        cisp_ins_updrecord('112009003',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.t_db_06_103 (P001,A002,A003,A004,A005,A006,A007,A008,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,v_A007,v_A008,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112009003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112009003޸רʲҵ-Ʒֽռ֧'||logP001||'<font color=red>'||logA002||'</font>',v_task);

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112010001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112010001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 integer,
    v_A003 integer,
    v_A004 integer,
    --v_A005 integer,
    v_A006 integer,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_07_101
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_07_101
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_07_101 set A002=v_A002,A003=v_A003, A004=v_A004,/*A005=v_A005,*/A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112010001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.t_db_07_101 (P001,A002,A003,A004/*,A005*/,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,/*v_A005,*/v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112010001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112010001޸Ķʲҵ-'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112010002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112010002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    --v_A005 numeric,
    v_A006 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_07_102
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select rowid into v_rowid from cisp.t_db_07_102
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_07_102 set A002=v_A002,A003=v_A003, A004=v_A004/*,A005=v_A005*/,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
        cisp_ins_updrecord('112010002',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.t_db_07_102 (P001,A002,A003,A004,/*A005,*/A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,/*v_A005,*/v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112010002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112010002޸Ķʲҵ-ʽ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112011001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112011001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 integer,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    v_A007 number,
    v_A008 varchar2,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_08_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_08_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_08_001 set A002=v_A002,A003=v_A003, A004=v_A004,A005=v_A005, A006=v_A006,A007=v_A007, A008=v_A008
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112011001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.t_db_08_001 (P001,A002,A003,A004,A005,A006,A007,A008,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,v_A007,v_A008,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112011001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_Task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112011001޸Ĳҵ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112011002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112011002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_Task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
     v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_db_08_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.t_db_08_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.t_db_08_002 set A002=v_A002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112011002',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.t_db_08_002 (P001,A002,A100,W100)
              SELECT v_P001,v_A002,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112011002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112011002޸Ĳҵ񲹳ϣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112014001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112014001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A007 number,
    v_A008 number,
    v_A009 number,
    v_A010 number,
    v_A011 number,
    v_A012 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_09_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_09_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_09_001 set A002=v_A002,A003=v_A003, A004=v_A004,A007=v_A007, A008=v_A008, A009=v_A009, A010=v_A010, A011=v_A011, A012=v_A012
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112014001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_09_001 (P001,A002,A003,A004,A007,A008,A009,A010,A011,A012,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112014001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112014001޸ѺʽծȯعӪ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112014002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112014002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,

    v_A007 number,
    v_A008 number,
    v_A009 number,
    v_A010 number,
    v_A011 number,
    v_A012 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_09_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_09_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_09_002 set A002=v_A002,A003=v_A003, A004=v_A004,A007=v_A007, A008=v_A008, A009=v_A009,A010=v_A010, A011=v_A011, A012=v_A012
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112014002',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_09_002 (P001,A002,A003,A004,A007,A008,A009,A010,A011,A012,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112014002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112014002޸Ѻʽծȯعʲ'||logP001||'<font color=red>'||logA002||'</font>',v_Task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112014003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112014003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,

    v_A007 number,
    v_A008 number,
    v_A009 number,
    v_A010 number,
    v_A011 number,
    v_A012 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_09_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_09_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_09_003 set A002=v_A002,A003=v_A003, A004=v_A004,A007=v_A007, A008=v_A008, A009=v_A009,A010=v_A010, A011=v_A011, A012=v_A012
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112014003',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_09_003 (P001,A002,A003,A004,A007,A008,A009,A010,A011,A012,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112014003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112014003޸Ѻʽծȯعҵ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112014004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112014004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_10_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_10_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_10_001 set A002=v_A003+v_A004+v_A005,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112014004',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_10_001 (P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001,v_A003+v_A004+v_A005,v_A003,v_A004,v_A005,P002,a012
                     FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112014004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112014004޸ծȯйӪ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112014005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112014005(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_10_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_10_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_10_002 set A002=v_A003+v_A004+v_A005,A003=v_A003, A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112014005',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_10_002 (P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001,v_A003+v_A004+v_A005,v_A003,v_A004,v_A005,P002,a012
                     FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112014005
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112014005޸ծȯйʲ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112014006
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112014006(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_10_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select rowid into v_rowid from cisp.T_DB_10_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_10_003 set A002=v_A003+v_A004+v_A005,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112014006',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_10_003 (P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001,v_A003+v_A004+v_A005,v_A003,v_A004,v_A005,P002,a012
                     FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112014006
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112014006޸ծȯйͿͻ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112015001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112015001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,

    v_A007 number,
    v_A008 number,
    v_A009 number,
    v_A010 number,
    v_A011 number,
    v_A012 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_11_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_11_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_11_001 set A002=v_A002,A003=v_A003, A004=v_A004,A007=v_A007, A008=v_A008, A009=v_A009,A010=v_A010,A011=v_A011,A012=v_A012
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112015001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_11_001 (P001,A002,A003,A004,A007,A008,A009,A010,A011,A012,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112015001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112015001޸ʽծȯعӪ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112015002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112015002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A007 number,
    v_A008 number,
    v_A009 number,
    v_A010 number,
    v_A011 number,
    v_A012 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_11_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_11_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_11_002 set A002=v_A002,A003=v_A003, A004=v_A004,A007=v_A007, A008=v_A008, A009=v_A009,A010=v_A010, A011=v_A011, A012=v_A012
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112015002',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_11_002 (P001,A002,A003,A004,A007,A008,A009,A010,A011,A012,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112015002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112015002޸ʽծȯعʲ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112015003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112015003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,

    v_A007 number,
    v_A008 number,
    v_A009 number,
    v_A010 number,
    v_A011 number,
    v_A012 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);

  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_11_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_11_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_11_003 set A002=v_A002,A003=v_A003, A004=v_A004,A007=v_A007, A008=v_A008, A009=v_A009,A010=v_A010, A011=v_A011, A012=v_A012
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112015003',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_11_003 (P001,A002,A003,A004,A007,A008,A009,A010,A011,A012,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112015003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112015003޸ʽծȯعͿͻ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112016001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112016001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_12_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_12_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_12_001 set A002=v_A002,A003=v_A003, A004=v_A004, A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112016001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_12_001 (P001,A002,A003,A004,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112016001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_Task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112016001޸Ĳмг'||logP001||'<font color=red>'||logA002||'</font>',v_Task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112017001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112017001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A006 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_12_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_12_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_12_002 set A002=v_A002,A003=v_A003, A004=v_A004, A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112017001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_12_002 (P001,A002,A003,A004,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112017001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112017001޸Ĳмгȯ'||logP001||'<font color=red>'||logA002||'</font>',v_Task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112018001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112018001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P003 varchar2,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    v_A009 numeric,
    v_A010 numeric,
    v_A011 numeric,
    v_A012 numeric,
    v_A013 numeric,
    v_A014 numeric,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_13_001
           where P001=v_P003 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_13_001
           where P001=v_P003 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_13_001 set A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006,
              A007=v_A007,A008=v_A008,A009=v_A009,A010=v_A010,A011=v_A011,
              A012=v_A012,A013=v_A013,A014=v_A014
           where P001=v_P003 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
         commit;
        cisp_ins_updrecord('112018001',v_rowid,v_KJAXUSER,1,'Ŀ',loga002);
    else
       insert into cisp.T_DB_13_001(P001,A003,A004,A005,A006,A007,A008,A009,A010,A011,A012,A013,A014,A100,W100)
              SELECT v_P003,v_A003,v_A004,v_A005,v_A006,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,v_A013,v_A014,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112018001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112018001޸ĴϹȨ֤Ȩ֤Ϊ<font color=red>'||v_P003||''||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112019001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112019001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_30_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_30_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_30_001 set A002=v_A002,a003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112019001',v_rowid,v_KJAXUSER,1,'Ŀ','');
    else
       insert into cisp.T_DB_30_001(P001,A002,a003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112019001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'޸ݱά112019001IDΪ<font color=red>'||v_P001||'</font>ȯҵ񣭿',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112019002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112019002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A001 varchar2
    )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_30_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_30_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_30_002 set A001=v_A001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
          commit;
        cisp_ins_updrecord('112019002',v_rowid,v_KJAXUSER,1,'Ŀ','');
    else
       insert into cisp.T_DB_30_002(P001,A001,A100,W100)
              SELECT v_P001, v_A001,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112019002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'޸ݱά112019002IDΪ<font color=red>'||v_P001||'</font>ȯҵ񣭿',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112020001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112020001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_15_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select a002 into v_loga002 from t_b11_d001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_15_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_15_001 set A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
         commit;
        cisp_ins_updrecord('112020001',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_15_001(P001,A002,A003,A004,A100,W100)
              SELECT v_P001, v_A002,v_A003,v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112020001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112020001޸Ϊڻ˾ṩмҵ-ҵܣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112020002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112020002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
     v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_15_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then

    select a002 into v_loga002 from T_B11_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_15_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_15_002 set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112020002',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_15_002(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112020002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
   insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID112020002޸Ϊڻ˾ṩмҵ-Ӷ룻'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112021001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112021001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A003 integer,
    v_A004 number,
    v_A005 integer,
    v_A006 number,
    v_A007 integer,
    v_A008 number,
    v_A009 integer,
    v_A010 number,
    v_A011 integer,
    v_A012 number,
    v_A099  varchar2,
    logP001  varchar2,
    logA002  varchar2 )
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_50_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_50_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_50_001 set A002=v_A003, A003=v_A004,
       A004=v_A005, A005=v_A006,
       A006=v_A007, A007=v_A008,A008=v_A009, A009=v_A010,A010=v_A011, A011=v_A012,

       A099 = v_A099
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112021001',v_rowid,v_KJAXUSER,1,logP001,loga002);
    else
       insert into cisp.T_DB_50_001(P001,A002,A003,A004,A005,A006,A007,A008,A009,A010,A011,a099,A100,W100)
              SELECT v_P001,v_A003,v_A004,v_A005,v_A006,v_A007,v_A008,v_A009,v_A010,v_A011,v_A012,v_A099,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112021001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
 insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112021001֤ȯ˾۽ڲƷͳƣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112022001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112022001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_61_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select a002 into v_loga002 from T_B61_D001 t where t.p001=v_P001 ;
    select rowid into v_rowid from cisp.T_DB_61_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_61_001 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112022001',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_61_001(P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001, v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112022001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112022001޸Ѻʽۻعױ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112022002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112022002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
     v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_61_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select a002 into v_loga002 from T_B61_D001 t where t.p001=v_P001 ;
     select rowid into v_rowid from cisp.T_DB_61_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_61_002 set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112022002',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_61_002(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112022002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112022002޸Ѻʽۻعױۼҵģ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112022003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112022003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_61_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select a002 into v_loga002 from T_B61_D001 t where t.p001=v_P001 ;
    select rowid into v_rowid from cisp.T_DB_61_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_61_003 set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112022003',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_61_003(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112022003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112022003޸Ѻʽۻعױعʣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112023001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112023001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_62_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select a002 into v_loga002 from T_B62_D001 t where t.p001=v_P001 ;
    select rowid into v_rowid from cisp.T_DB_62_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_62_001 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       cisp_ins_updrecord('112023001',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_62_001(P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001, v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112023001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112023001޸Լʽױ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112023002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112023002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
     v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_62_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select a002 into v_loga002 from T_B62_D001 t where t.p001=v_P001 ;
    select rowid into v_rowid from cisp.T_DB_62_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_62_002 set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
        cisp_ins_updrecord('112023002',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_62_002(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112023002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112023002޸Լʽױۼҵģ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112023003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112023003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_62_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select a002 into v_loga002 from T_B62_D001 t where t.p001=v_P001 ;
    select rowid into v_rowid from cisp.T_DB_62_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_62_003 set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112023003',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_62_003(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112023003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112023003޸Լʽױعʣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112023004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112023004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_62_004
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select rowid into v_rowid from cisp.T_DB_62_004
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_62_004 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112023004',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_62_004(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112023004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112023004޸Լʽױؽ׽ǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112023005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112023005(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_62_005
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_62_005
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_62_005 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112023005',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_62_005(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112023005
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112023005޸Լʽױرֵǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112024001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then

    select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_001 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112024001',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_001(P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001, v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024001޸ĹƱѺʽعױ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024001_RH
prompt ===========================================
prompt
create or replace procedure cisp_upd_DT_112024001_RH(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_001_RH
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then

    select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_001_RH
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_001_RH set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        --cisp_ins_updrecord('112024006',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_001_RH(P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001, v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024006
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024006޸ĹƱѺʽعױ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024001_ZYZJ
prompt =============================================
prompt
create or replace procedure cisp_upd_DT_112024001_ZYZJ(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_001_ZYZJ
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then

    select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_001_ZYZJ
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_001_ZYZJ set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        --cisp_ins_updrecord('112024011',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_001_ZYZJ(P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001, v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024011
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024011޸ĹƱѺʽعױ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112024002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_002 set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
          commit;
        cisp_ins_updrecord('112024002',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_002(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024002޸ĹƱѺʽعױۼҵģ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024002_RH
prompt ===========================================
prompt
create or replace procedure cisp_upd_DT_112024002_RH(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_002_RH
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_002_RH
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_002_RH set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
          commit;
        --cisp_ins_updrecord('112024007',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_002_RH(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024007
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024007޸ĹƱѺʽعױۼҵģ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024002_ZYZJ
prompt =============================================
prompt
create or replace procedure cisp_upd_DT_112024002_ZYZJ(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_002_ZYZJ
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_002_ZYZJ
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_002_ZYZJ set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
          commit;
        --cisp_ins_updrecord('112024012',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_002_ZYZJ(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024012
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024012޸ĹƱѺʽعױۼҵģ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112024003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_003 set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112024003',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_003(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024003
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024003޸ĹƱѺʽعױعʣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024003_RH
prompt ===========================================
prompt
create or replace procedure cisp_upd_DT_112024003_RH(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_003_RH
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_003_RH
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_003_RH set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        --cisp_ins_updrecord('112024008',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_003_RH(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024008
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024008޸ĹƱѺʽعױعʣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024003_ZYZJ
prompt =============================================
prompt
create or replace procedure cisp_upd_DT_112024003_ZYZJ(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 number,
    v_A003 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
    v_loga002 varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_003_ZYZJ
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
     select a002 into v_loga002 from T_B63_D001 t where t.p001=v_P001;
    select rowid into v_rowid from cisp.T_DB_63_003_ZYZJ
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_003_ZYZJ set A002=v_A002,A003=v_A003
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        --cisp_ins_updrecord('112024013',v_rowid,v_KJAXUSER,1,'Ŀ',v_loga002);
    else
       insert into cisp.T_DB_63_003_ZYZJ(P001,A002,A003,A100,W100)
              SELECT v_P001, v_A002,v_A003,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024013
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024013޸ĹƱѺʽعױعʣ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112024004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_004
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_63_004
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_004 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        cisp_ins_updrecord('112024004',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_63_004(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024004
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024004޸ĹƱѺʽعױؽ׽ǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024004_RH
prompt ===========================================
prompt
create or replace procedure cisp_upd_DT_112024004_RH(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_004_RH
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_63_004_RH
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_004_RH set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        --cisp_ins_updrecord('112024009',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_63_004_RH(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024009
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024009޸ĹƱѺʽعױؽ׽ǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024004_ZYZJ
prompt =============================================
prompt
create or replace procedure cisp_upd_DT_112024004_ZYZJ(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_004_ZYZJ
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
    select rowid into v_rowid from cisp.T_DB_63_004_ZYZJ
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_004_ZYZJ set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        --cisp_ins_updrecord('112024014',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_63_004_ZYZJ(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024014
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024014޸ĹƱѺʽعױؽ׽ǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_112024005(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_005
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_63_005
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_005 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
         cisp_ins_updrecord('112024005',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_63_005(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024005
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024005޸ĹƱѺʽعױرֵǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024005_RH
prompt ===========================================
prompt
create or replace procedure cisp_upd_DT_112024005_RH(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_005_RH
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_63_005_RH
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_005_RH set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
         --cisp_ins_updrecord('112024010',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_63_005_RH(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024010
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024010޸ĹƱѺʽعױرֵǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_112024005_ZYZJ
prompt =============================================
prompt
create or replace procedure cisp_upd_DT_112024005_ZYZJ(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(4000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_63_005_ZYZJ
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       select rowid into v_rowid from cisp.T_DB_63_005_ZYZJ
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       update cisp.T_DB_63_005_ZYZJ set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where PM=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
         --cisp_ins_updrecord('112024015',v_rowid,v_KJAXUSER,1,'',v_P001);
    else
       insert into cisp.T_DB_63_005_ZYZJ(A002,A003,A004,A005,A006,A100,W100,PM)
              SELECT v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012,v_P001 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=112024015
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID112024015޸ĹƱѺʽعױرֵǰ5'||logP001||'<font color=red>'||logA002||'</font>',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002001(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A011     numeric,
                                             V_A012     integer,
                                             V_A013     numeric) is
  v_rowid varchar2(1000);
  v_count int;
  v_orgid number;
  v_bmid number;


begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  --ݱ
  update cisp.t_db_04_001
     set A002 = V_A002,
         A003 = V_A003,
         A004 = V_A004,
         A005 = V_A005,
         A006 = V_A006,
         A007 = V_A007,
         A008 = V_A008,
         A009 = V_A009,
         A010 = 100,
         A011 = V_A011
   where P001 = V_P001
     AND A002 not in (1012, 1017)
     AND A010 = 100
     AND A100 = v_orgid
     and w100 = v_bmid;
  commit;
  select rowid into v_rowid from cisp.t_db_04_001 where P001 = V_P001
     AND A002 not in (1012, 1017)
     AND A010 = 100
     AND A100 = v_orgid
     and w100 = v_bmid;

  cisp_ins_updrecord('113002001',v_rowid,v_KJAXUSER,1,'ͨ:֤ȯ',v_P001);

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and a100 = v_orgid
     and A004 = 100;

  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P001, V_A003, V_A002, 100, V_A013, v_orgid);

  end if;

  update cisp.t_bks_t016
     set A005 = V_A013,A002 = V_A003
   where A004 = 100
     and a100 = v_orgid
     and P001 = V_P001;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002001޸֤ȯͶҵ-ͨɣ±֤ȯ룺<font color=red>' ||
     v_P001 || '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002001
     and a004 = v_bmid
     and p002=v_task;
/*exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_upd_DT_113002001ִݱдͬ¼';
    return;*/

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002002(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A011     numeric,
                                             V_A012     integer,
                                             V_A013     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;
  v_rowid varchar2(1000);

begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.T_SYS_USER WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  --ݱ
  update cisp.T_DB_04_001
     set A002 = V_A002,
         A003 = V_A003,
         A004 = V_A004,
         A005 = V_A005,
         A006 = V_A006,
         A007 = V_A007,
         A008 = V_A008,
         A009 = V_A009,
         A010 = 100,
         A011 = V_A011
   where P001 = V_P001
     AND A002 in (1012, 1017)
     AND A010 = 100
     AND A100 = v_orgid
     and w100 = v_bmid;

  commit;
  select rowid into v_rowid from  cisp.T_DB_04_001 where P001 = V_P001
     AND A002 in (1012, 1017)
     AND A010 = 100
     AND A100 = v_orgid
     and w100 = v_bmid;
  cisp_ins_updrecord('113002002',v_rowid,v_KJAXUSER,1,'ͨ:֤ȯ',v_P001);

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and a100 = v_orgid
     and A004 = 100;

  --ɱ
  --if V_A012 = 9999 then
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, a100)
    values
      (V_P001, V_A003, V_A002, 100, V_A013, v_orgid);

  end if;

  update cisp.t_bks_t016
     set A005 = V_A013,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
   where A004 = 100
     and P001 = V_P001
     and a100 = v_orgid;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002002޸֤ȯͶҵ-ͨɣ±֤ȯ룺<font color=red>' ||
     v_P001 || '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002002
     and a004 = v_bmid
     and p002= v_task;
  return;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_upd_DT_113002002ִݱдͬ¼';
    return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002003(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A011     numeric,
                                             V_A012     integer,
                                             V_A013     numeric,
                                             V_CA003    integer) is
  v_count integer;
  v_orgid number;
  v_bmid number;
  v_rowid varchar2(1000);
begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  --ݱ

  --ǰ ֻ¹ɱϢ·ࣨ
  if V_CA003 = 1012 or V_CA003 = 1017 then
    update cisp.T_DB_04_001
       set A003 = V_A003,
           A004 = V_A004,
           A005 = V_A005,
           A006 = V_A006,
           A007 = V_A007,
           A008 = V_A008,
           A009 = V_A009,
           A010 = 200,
           A011 = V_A011
     where P001 = V_P001
       AND A002 = V_CA003
       AND A010 = 200
       AND A100 = v_orgid
       and w100 = v_bmid;
    --򣬿Ը·
  else
    update cisp.T_DB_04_001
       set A002 = V_A002,
           A003 = V_A003,
           A004 = V_A004,
           A005 = V_A005,
           A006 = V_A006,
           A007 = V_A007,
           A008 = V_A008,
           A009 = V_A009,
           A010 = 200,
           A011 = V_A011
     where P001 = V_P001
       AND A002 = V_CA003
       AND A010 = 200
       AND A100 = v_orgid
       and w100 = v_bmid;
  end if;

  commit;
  select rowid into v_rowid from cisp.T_DB_04_001 where P001 = V_P001
       AND A002 = V_CA003
       AND A010 = 200
       AND A100 = v_orgid
       and w100 = v_bmid;

  cisp_ins_updrecord('113002003',v_rowid,v_KJAXUSER,1,':֤ȯ',v_P001);

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and a100 = v_orgid
     and A004 = 200;

  --ɱ
  --if V_A012 = 9999 then
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P001, V_A003, V_A002, 200, V_A013, v_orgid);
    --·ࡢɱ
  /*else
    update t_bks_t016
       set A003 = V_A002
     where A004 = 200
       and P001 = V_P001
       and A003 = V_A012;*/
  end if;

  update cisp.t_bks_t016
     set A005 = V_A013,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
   where A004 = 200
     and P001 = V_P001
     and a100 = v_orgid;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002003޸֤ȯͶҵ-𣩣±֤ȯ룺<font color=red>' ||
     v_P001 || '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002003
     and a004 = v_bmid
     and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_upd_DT_113002003ִ,ݱдͬ¼';
    return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002004(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A010     numeric,
                                             V_A012     numeric,
                                             V_A013     integer,
                                             V_A014     numeric) is
  v_count integer;
  v_orgid number;
  v_bmid number;
  v_rowid varchar2(1000);

begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  --ݱ
  update cisp.T_DB_04_002
     set A002 = V_A002,
         A003 = V_A003,
         A004 = V_A004,
         A005 = V_A005,
         A006 = V_A006,
         A007 = V_A007,
         A008 = V_A008,
         A009 = V_A009,
         A010 = V_A010,
         A011 = 300,
         A012 = V_A012
   where P001 = V_P001
     AND A011 = 300
     AND A100 = v_orgid
     and w100 = v_bmid;

  commit;

  select rowid into v_rowid from cisp.T_DB_04_002 where P001 = V_P001 AND A011 = 300 AND A100 = v_orgid and w100 = v_bmid;
  cisp_ins_updrecord('113002004',v_rowid,v_KJAXUSER,1,'ծȯ:֤ȯ',v_P001);

  select count(*)
    into v_count
    from cisp.t_bks_t016
   where P001 = V_P001
     and A003 = V_A002
     and a100 = v_orgid
     and A004 = 300;

  --ɱ
  --if V_A013 = 9999 then
  if v_count = 0 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P001, V_A003, V_A002, 300, V_A014, v_orgid);

  end if;

  update cisp.t_bks_t016
     set A005 = V_A014,A002 = V_A003   --ͬ,ɱmakereport8081ʱ,distinct
   where A004 = 300
     and a100 = v_orgid
     and P001 = V_P001;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002004޸֤ȯͶҵ-ծȯ±֤ȯ룺<font color=red>' || v_P001 ||
     '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002004
   and a004 = v_bmid
   and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_upd_DT_113002004ִݱдͬ¼';
    return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002005(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P001     varchar2,
                                             V_A002     integer,
                                             V_A003     varchar2,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric,
                                             V_A010     numeric,
                                             V_A012     numeric,
                                             V_A013     integer,
                                             V_A014     numeric
                                             )
is
v_rowid varchar2(1000);
begin
  errcode := 1;
  errmsg  := '';

update cisp.T_DB_04_002 set A002=V_A002,A003=V_A003,A004=V_A004,A005=V_A005,A006=V_A006,A007=V_A007,
       A008=V_A008,A009=V_A009,A010=V_A010,A011=400,A012=V_A012 where W100=(select a012 from krcs.t_sys_user where p001=v_KJAXUSER) and
       A100 = (select p002 from krcs.t_sys_user where p001=v_kjaxuser) and p001=V_P001;

commit;

select rowid into v_rowid from cisp.T_DB_04_002 where W100=(select a012 from krcs.t_sys_user where p001=v_KJAXUSER) and
       A100 = (select p002 from krcs.t_sys_user where p001=v_kjaxuser) and p001=V_P001;
cisp_ins_updrecord('113002005',v_rowid,v_KJAXUSER,1,':ĿID',V_P001);

update CISP.t_bks_t016
     set A005 = V_A014,A002 = V_A003 ,A003=V_A002
   where A004 = 400
     and a100 = (select p002 from krcs.t_sys_user where p001=v_KJAXUSER)
     and P001 = V_P001;

 insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002005޸֤ȯͶҵ-±ĿID<font color=red>' || V_P001 ||
     '</font>',v_Task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002005
   and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER)
   and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_upd_dt_113002005ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002006
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002006(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_Task     varchar2,
                                             V_P002     number,
                                             V_A003     numeric,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric
                                             )
is
v_rowid varchar2(1000);
v_count int;
begin
  errcode := 1;
  errmsg  := '';

  select count(1) into v_count from cisp.T_DB_04_002_02_01 where p001='300' and P002=V_P002 and w100 in (select a012 from krcs.t_sys_user where p001=v_KJAXUSER);

  if (v_count =1) then
     update cisp.T_DB_04_002_02_01 set p002=V_P002,a003=V_A003,a004=V_A004,
     a005=V_A005,a006=V_A006,a007=V_A007,a008=V_A008,a009=V_A009 where p001='300' and P002=V_P002 and w100 in (select a012 from krcs.t_sys_user where p001=v_KJAXUSER);
     commit;
     select rowid into v_rowid from cisp.T_DB_04_002_02_01 where p001='300' and P002=V_P002 and w100 in (select a012 from krcs.t_sys_user where p001=v_KJAXUSER);
     cisp_ins_updrecord('113002006',v_rowid,v_KJAXUSER,1,'ծȯ:ĿID',V_P002);
  else
     insert into cisp.T_DB_04_002_02_01(p001,p002,a003,a004,a005,a006,a007,a008,a009,a100,w100)
    select 300,
           V_P002,
           V_A003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           V_A009,
           P002,
           A012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;
  end if;

 insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002006޸֤ȯͶҵ-ծȯ±ĿID<font color=red>' || V_P002 ||
     '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002006
   and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER)
   and p002= v_task;


end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002007
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002007(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P002     number,
                                             V_A003     numeric,
                                             V_A004     numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     numeric
                                             )
is
v_rowid varchar2(1000);
v_count int;
begin
  errcode := 1;
  errmsg  := '';

  select count(1) into v_count  from cisp.T_DB_04_002_02_01 where p001='400' and P002=V_P002 and w100 in (select a012 from krcs.t_sys_user where p001=v_KJAXUSER);

  if (v_count =1) then
    update cisp.T_DB_04_002_02_01
    set p002=V_P002,a003=V_A003,a004=V_A004,a005=V_A005,a006=V_A006,a007=V_A007,a008=V_A008,a009=V_A009
    where p001='400' and P002=V_P002 and w100 in (select a012 from krcs.t_sys_user where p001=v_KJAXUSER);
    commit;
    select rowid into v_rowid  from cisp.T_DB_04_002_02_01 where p001='400' and P002=V_P002 and w100 in (select a012 from krcs.t_sys_user where p001=v_KJAXUSER);
    cisp_ins_updrecord('113002007',v_rowid,v_KJAXUSER,1,'ծȯ:ĿID',V_P002);
  else
    insert into cisp.T_DB_04_002_02_01(p001,p002,a003,a004,a005,a006,a007,a008,a009,a100,w100)
    select 400,
           V_P002,
           V_A003,
           V_A004,
           V_A005,
           V_A006,
           V_A007,
           V_A008,
           V_A009,
           P002,
           A012
      FROM krcs.t_sys_user
     WHERE P001 = v_KJAXUSER;
  end if;

 insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002007޸֤ȯͶҵ-ծȯ±ĿID<font color=red>' || V_P002 ||
     '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002007 and p002=v_task
   and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);


end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002008
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002008(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             v_task     varchar2,
                                             V_P003     varchar2,
                                             V_A002     integer,
                                             V_A004     varchar2,
                                             V_CA005    numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     integer) is
  v_count integer;
  v_orgid number;
  v_bmid number;
  v_rowid varchar2(1000);
begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  --ݱ
  update cisp.T_DB_04_002_02_02
     set A004 = V_A004,
         A005 = V_A005,
         A006 = V_A006,
         A007 = V_A007,
         A008 = V_A008,
         P001 = 300
   where P003 = V_P003
     AND P001 = 300
     AND W100 = v_bmid;
  commit;

  select rowid into v_rowid from cisp.T_DB_04_002_02_02 where P003 = V_P003
     AND P001 = 300
     AND W100 = v_bmid;

  cisp_ins_updrecord('113002008',v_rowid,v_KJAXUSER,1,'ծȯ:̶沿бǰ5:ĿID',v_P003);

  --ɱ
  if V_A009 = 9999 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005 ,A100)
    values
      (V_P003, V_A004, V_A002, 300, V_CA005, v_orgid);
  --¹ɱ
  else
    update cisp.t_bks_t016
       set A003 = V_A002, A005 = V_CA005
     where A004 = 300
       and P001 = V_P003
       and A003 = V_A009
       AND A100 = v_orgid;
  end if;

  update cisp.t_bks_t016
     set A005 = V_CA005
   where A004 = 300
     and P001 = V_P003
     AND A100 = v_orgid;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002008޸֤ȯͶҵ-ծȯ̶沿бǰ5-±֤ȯ룺<font color=red>' || v_P003 ||
     '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002008
   and a004 = v_bmid
   and p002=v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_upd_dt_113002008ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113002009
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113002009(errcode    out int,
                                             errmsg     out varchar2,
                                             v_KJAXUSER varchar2,
                                             V_task     varchar2,
                                             V_P003     varchar2,
                                             V_A002     integer,
                                             V_A004     varchar2,
                                             V_CA005    numeric,
                                             V_A005     numeric,
                                             V_A006     numeric,
                                             V_A007     numeric,
                                             V_A008     numeric,
                                             V_A009     integer) is
  v_count integer;
  v_orgid number;
  v_bmid number;
  v_rowid varchar2(1000);
begin
  errcode := 1;
  errmsg  := '';
  SELECT P002 into v_orgid FROM krcs.t_sys_user WHERE P001 = v_KJAXUSER;  --  ˻ID
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_KJAXUSER;  --  ܲID

  --ݱ
  update cisp.T_DB_04_002_02_02
     set A004 = V_A004,
         A005 = V_A005,
         A006 = V_A006,
         A007 = V_A007,
         A008 = V_A008,
         P001 = 400
   where P003 = V_P003
     AND P001 = 400
     AND A100 = v_orgid
     AND W100 = v_bmid;
  commit;
  select rowid into v_rowid from cisp.T_DB_04_002_02_02 where P003 = V_P003
     AND P001 = 400
     AND A100 = v_orgid
     AND W100 = v_bmid;
  cisp_ins_updrecord('113002009',v_rowid,v_KJAXUSER,1,':̶沿бǰ5-֤ȯ',V_P003);
  --ɱ
  if V_A009 = 9999 then
    insert into cisp.t_bks_t016
      (P001, A002, A003, A004, A005, A100)
    values
      (V_P003, V_A004, V_A002, 400, V_CA005, v_orgid);
  --¹ɱ
  else
    update cisp.t_bks_t016
       set A003 = V_A002, A005 = V_CA005
     where A004 = 400
       and P001 = V_P003
       and A003 = V_A009
       AND A100 = v_orgid;
  end if;

  update cisp.t_bks_t016
     set A005 = V_CA005
   where A004 = 400
     and P001 = V_P003
     AND A100 = v_orgid;

  insert into krcs.T_SYS_LOG
    (P001, P002, A003,A004)
  values
    (v_KJAXUSER,
     sysdate,
     'ݱάID113002009޸֤ȯͶҵ-̶沿бǰ5-±֤ȯ룺<font color=red>' || v_P003 ||
     '</font>',v_task);

  update krcs.T_SYS_T022
     SET A006 = 1015002, A007 = 1010002, A009 = 1009002
   WHERE P001 = 113002009
   and a004 = v_bmid
   and p002 = v_task;
exception
  when others then
    errcode := 0;
    errmsg  := 'cisp_upd_dt_113002009ִ';
    return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113003001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113003001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    v_A009 numeric,
    v_A010 numeric,
    v_A011 numeric,
    v_A012 numeric,
    v_A013 numeric,
    v_A014 numeric,
    v_A015 numeric,
    v_A016 numeric,
    v_A017 numeric,
    v_A018 numeric,
    v_A019 numeric,
    v_A020 varchar2,
    v_A021 numeric,
    v_A022 numeric,
    v_A023 numeric,
    v_A024 varchar2,
    v_A025 numeric,
    v_A026 numeric,
    v_A027 numeric,
    v_A028 varchar2,
    v_A029 numeric,
    v_A030 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(1000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_07_103
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_07_103 set A002=v_A002,A003=v_A003, A004=v_A004,A005=v_A005,A006=v_A006,
           A007=v_A007,A008=v_A008, A009=v_A009,A010=v_A010,A011=v_A011,
           A012=v_A012,A013=v_A013, A014=v_A014,A015=v_A015,A016=v_A016,
           A017=v_A017,A018=v_A018, A019=v_A019,A020=v_A020,A021=v_A021,
           A022=v_A022,A023=v_A023, A024=v_A024,A025=v_A025,
           A026=v_A026,A027=v_A027,A028=v_A028,A029=v_A029,A030=v_A030
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.T_DB_07_103
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113003001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_07_103 (P001,A002,A003,A004,A005,A006,
              A007,A008,A009,A010,A011,
              A012,A013,A014,A015,A016,
              A017,A018,A019,A020,A021,
              A022,A023,A024,A025,A026,A027,A028,A029,A030,
              A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,
              v_A007,v_A008,v_A009,v_A010,v_A011,
              v_A012,v_A013,v_A014,v_A015,v_A016,
              v_A017,v_A018,v_A019,v_A020,v_A021,
              v_A022,v_A023,v_A024,v_A025,v_A026,v_A027,v_A028,v_A029,v_A030,
              P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=113003001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113003001޸Ķʲҵ-Ͷ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113003002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113003002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 integer,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    v_A007 numeric,

    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(1000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_07_104
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_07_104 set A002=v_A002,A003=v_A003, A004=v_A004,A005=v_A005,A006=v_A006,
           A007=v_A007
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
        commit;
        select rowid into v_rowid  from cisp.T_DB_07_104
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113003002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_07_104 (P001,A002,A003,A004,A005,A006,
              A007,
              A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,
              v_A007,
              P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=113003002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113003002޸Ķʲҵ-ʲ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113004001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113004001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    VP001 varchar2,
    VA001 numeric,
    VA002 numeric,
    VA003 numeric,
    VA004 numeric,
    VA005 numeric,
    VA006 numeric,
    VA007 numeric,
    VA008 numeric,
    VA009 numeric,
    VA010 numeric,
    VA011 numeric,
    VA012 numeric,
    VA013 numeric,
    VA014 numeric,
    VA015 numeric,
    VA016 numeric,
    VA017 numeric,
    VA018 numeric,
    VA019 numeric,
    VA020 numeric,
    VA021 numeric,
    VA022 numeric,
    va023 numeric
    )
  is
    v_count integer;
    v_rowid varchar2(1000);
  begin
    errcode:=1;
    errmsg:='succeed!';

    select count(*) into v_count from cisp.T_DB_05_104
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_05_104 set a001=va001,A002=VA002,A004=VA004,A005=VA005,A006=VA006,a007=va007,A008=VA008,A009=VA009,A010=VA010,A011=VA011,
       a012=va012,A013=VA013,A014=VA014,A015=VA015,A016=VA016,a017=va017,A018=VA018,A019=VA019,A020=VA020,A021=VA021,A022=VA022,a023=va023
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.T_DB_05_104
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113004001',v_rowid,v_KJAXUSER,1,'֤ȯ',VP001);
        insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113004001޸ʲҵͶ֤ȯ룺<font color=red>'||VP001||'</font>',v_task);

    else
       insert into cisp.T_DB_05_104 (P001,a001,A002,a003,A004,A005,A006,a007,A008,a009,A010,A011,A012,a013,A014,a015,A016,A017,A018,A019,a020,A021,A022,a023,A100,W100)
              SELECT vp001,va001,VA002,va003,VA004,VA005,VA006,va007,VA008,VA009,VA010,VA011,va012,VA013,VA014,VA015,VA016,va017,VA018,VA019,VA020,VA021,VA022,va023,
              P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
        insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113004001ʲҵͶ֤ȯ룺<font color=red>'||VP001||'</font>',v_task);

    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=113004001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002 = v_task;
    exception when others then
              errcode:=0;
              errmsg :='Ƿظļ¼';
              return;

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113004002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113004002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    VP001 varchar2,
    VA002 number,
    VA003 number,
    VA004 number,
    VA005 number,
    VA006 number,
    VA007 number
    )
  is
    v_count integer;
    v_rowid varchar2(1000);
  begin
    errcode:=1;
    errmsg:='succeed!';

    select count(*) into v_count from cisp.T_DB_05_105
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_05_105 set A002=VA002,A004=VA004,A005=VA005,A006=VA006,a007=va007,a003=va003
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.T_DB_05_105
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113004002',v_rowid,v_KJAXUSER,1,'֤ȯ',VP001);
        insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113004002޸ʲҵʲ֤ȯ룺<font color=red>'||VP001||'</font>',v_task);

    else
       insert into cisp.T_DB_05_105 (P001,A002,a003,A004,A005,A006,a007,A100,W100)
              SELECT vp001,VA002,va003,VA004,VA005,VA006,va007,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
        insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID113004002ʲҵʲ֤ȯ룺<font color=red>'||VP001||'</font>',v_task);

    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=113004002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    exception when others then
              errcode:=0;
              errmsg :='Ƿظļ¼';
              return;

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113005001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113005001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    v_A007 numeric,
    v_A008 numeric,
    v_A009 numeric,
    v_A010 numeric,
    v_A011 numeric,
    v_A012 numeric,
    v_A013 numeric,
    v_A014 numeric,
    v_A015 numeric,
    v_A016 numeric,
    v_A017 numeric,

    v_A022 numeric,
    v_A023 numeric,
    v_A024 varchar2,
    v_A025 numeric,
    v_A026 numeric,
    v_A027 numeric,
    v_A028 varchar2,
    v_A029 numeric,
    v_A030 numeric,
    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(1000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_06_104
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_06_104 set A002=v_A002,A003=v_A003, A004=v_A004,A005=v_A005,A006=v_A006,
           A007=v_A007,A008=v_A008, A009=v_A009,A010=v_A010,A011=v_A011,
           A012=v_A012,A013=v_A013, A014=v_A014,A015=v_A015,A016=v_A016,
           A017=v_A017,
           A022=v_A022,A023=v_A023, A024=v_A024,A025=v_A025,
           A026=v_A026,A027=v_A027,A028=v_A028,A029=v_A029,A030=v_A030
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.T_DB_06_104
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113005001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_06_104 (P001,A002,A003,A004,A005,A006,
              A007,A008,A009,A010,A011,
              A012,A013,A014,A015,A016,
              A017,
              A022,A023,A024,A025,A026,A027,A028,A029,A030,
              A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,
              v_A007,v_A008,v_A009,v_A010,v_A011,
              v_A012,v_A013,v_A014,v_A015,v_A016,
              v_A017,
              v_A022,v_A023,v_A024,v_A025,v_A026,v_A027,v_A028,v_A029,v_A030,
              P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=113005001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113005001޸רʲҵ-Ͷ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113005002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113005002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 numeric,
    v_A003 numeric,
    v_A004 numeric,
    v_A005 numeric,
    v_A006 numeric,
    v_A007 numeric,

    logP001 varchar2,
    logA002 varchar2)
  is
    v_count integer;
    v_rowid varchar2(1000);
  begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.T_DB_06_105
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.T_DB_06_105 set A002=v_A002,A003=v_A003, A004=v_A004,A005=v_A005,A006=v_A006,
           A007=v_A007
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.T_DB_06_105
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113005002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_06_105 (P001,A002,A003,A004,A005,A006,
              A007,
              A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,
              v_A007,
              P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=113005002
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_Task;

    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113005002޸רʲҵ-ʲ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113012001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113012001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number
    )
is
    v_count integer;
    v_rowid varchar2(1000);
begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_b40_a001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_b40_a001 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.t_b40_a001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113012001',v_rowid,v_KJAXUSER,1,'ͻ',v_P001);
    else
       insert into cisp.t_b40_a001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_KJAXUSER,sysdate,'ȯҵϸרܱ(ĩȯߵǰ10ͻϸ) ID:113012001',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113012002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113012002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number
    )
is
    v_count integer;
    v_rowid varchar2(1000);
begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_b40_a002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_b40_a002 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.t_b40_a002
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113012002',v_rowid,v_KJAXUSER,1,'ͻ',v_P001);
    else
       insert into cisp.t_b40_a002 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_KJAXUSER,sysdate, '޸ ȯҵϸרܱ(ĩάֵ͵10ͻϸάֵĿͻϸͳ),ID:113012002)',V_TASK);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113012003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113012003(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number
    )
is
    v_count integer;
    v_rowid varchar2(1000);
begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_b40_a003
           where P001=v_P001 and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_b40_a003 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001 and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.t_b40_a003
           where P001=v_P001 and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113012003',v_rowid,v_KJAXUSER,1,'֤ȯ',v_P001);
    else
       insert into cisp.t_b40_a003 (P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_KJAXUSER,sysdate,'ȯҵϸרܱ(ĩ֤ȯֵǰ10֤ȯ),ID:113012003 ',V_Task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113012004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113012004(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number
    )
is
    v_count integer;
    v_rowid varchar2(1000);
begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_b40_a004
           where P001=v_P001  and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_b40_a004 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005
           where P001=v_P001  and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.t_b40_a004
           where P001=v_P001  and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113012004',v_rowid,v_KJAXUSER,1,'֤ȯ',v_P001);
    else
       insert into cisp.t_b40_a004 (P001,A002,A003,A004,A005,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_KJAXUSER,sysdate,'ȯҵϸרܱ(ĩȯ֤ȯֵǰ10֤ȯ) ID:113012004',V_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113012005
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113012005(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number
    )
is
    v_count integer;
    v_rowid varchar2(1000);
begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_b40_a005
           where P001=v_P001  and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_b40_a005 set A002=v_A002,A003=v_A003,A004=v_A004
           where P001=v_P001  and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid from cisp.t_b40_a005
           where P001=v_P001  and A002 = v_A002 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113012005',v_rowid,v_KJAXUSER,1,'֤ȯ',v_P001);
    else
       insert into cisp.t_b40_a005 (P001,A002,A003,A004,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_KJAXUSER,sysdate,'ȯҵϸרܱ(ĩֵǰ10֤ȯ) ID:113012005',V_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113012006
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113012006(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 varchar2,
    v_A003 number,
    v_A004 number
    )
is
    v_count integer;
    v_rowid varchar2(1000);
begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_b40_a006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_b40_a006 set A002=to_date(v_A002,'yyyy-mm-dd hh24:mi:ss'),A003=v_A003,A004=v_A004
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.t_b40_a006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113012006',v_rowid,v_KJAXUSER,1,'ͻ',v_P001);
    else
       insert into cisp.t_b40_a006 (P001,A002,A003,A004,A100,W100)
              SELECT v_P001,to_date(v_A002,'yyyy-mm-dd hh24:mi:ss'),v_A003,v_A004,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_KJAXUSER,sysdate,'ȯҵϸרܱ(10ǿƽֽϸ) ID:113012006',v_Task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113013001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113013001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 varchar2,
    v_A002 number,
    v_A003 number,
    v_A004 number,
    v_A005 number,
    v_A006 number
    )
is
    v_count integer;
    v_rowid varchar2(1000);
begin
    errcode:=1;
    errmsg:='';
    select count(*) into v_count from cisp.t_b50_a001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
    if (v_count=1) then
       update cisp.t_b50_a001 set A002=v_A002,A003=v_A003,A004=v_A004,A005=v_A005,A006=v_A006
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.t_b50_a001
           where P001=v_P001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113013001',v_rowid,v_KJAXUSER,1,'ͻ',v_P001);
    else
       insert into cisp.t_b50_a001 (P001,A002,A003,A004,A005,A006,A100,W100)
              SELECT v_P001,v_A002,v_A003,v_A004,v_A005,v_A006,P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;
    end if;
    insert into krcs.t_sys_log(p001,p002,a003,a004)values(v_kjaxuser,sysdate,'޸ ȯҵϸܱ ID:113013001',v_task);
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113014001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113014001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    VP001 integer,
    VA002 varchar2,
    VA003 varchar2,
    VA004 varchar2,
    VA005 numeric,
    VA006 varchar2,
    VA007 varchar2,
    VA008 varchar2,
    VA009 numeric,
    VA010 varchar2,
    VA011 numeric,
    VA012 numeric,
    VA013 varchar2,
    VA014 numeric,
    VA015 varchar2,
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
    )
  is
    v_count integer;
    v_rowid varchar2(1000);
  begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ!';


    select count(*) into v_count from cisp.T_DB_05_020
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);

    if (v_count=1) then
       update cisp.T_DB_05_020 set A002=to_date(VA002,'yyyy-mm-dd'),A003=VA003, A004=VA004,A005=VA005,A006=VA006,
                              A007=to_date(VA007,'yyyy-mm-dd'),A008=to_date(VA008,'yyyy-mm-dd'),A009=VA009,A010=VA010,A011=VA011,
                              A012=VA012,A013=VA013,A014=VA014,A015=to_date(VA015,'yyyy-mm-dd')
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       commit;
       select rowid into v_rowid  from cisp.T_DB_05_020
           where P001=VP001 AND A100 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER)
           and w100 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER);
       cisp_ins_updrecord('113014001',v_rowid,v_KJAXUSER,1,'',VP001);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113014001֤ȯ˾ʻרܱ-ϸ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

    else
       insert into cisp.T_DB_05_020 (P001,A002,A003,A004,A005,A006,A007,A008,A009,A010,A011,A012,A013,A014,A015,A100,W100)
              SELECT VP001,to_date(VA002,'yyyymmdd'),VA003,VA004,VA005,VA006,to_date(VA007,'yyyymmdd'),to_date(VA008,'yyyymmdd'),VA009,VA010,VA011,VA012,VA013,VA014,to_date(VA015,'yyyymmdd'),P002,a012 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER;

       insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113014001֤ȯ˾ʻרܱ-ϸ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
    end if;
    update krcs.T_SYS_T022 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=113014001
    and a004 in (select a012 from krcs.t_sys_user where p001 =v_KJAXUSER) and p002=v_task;
    exception when others then
              errcode:=0;
              errmsg :='Ƿظļ¼';
              return;

 end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113015001
prompt ========================================
prompt
create or replace procedure CISP_upd_DT_113015001(errcode  out int,
                                                  errmsg   out varchar2,
                                                  v_kjaxuser varchar2,
                                                  v_task   varchar2,
                                                  V_P001   integer,
                                                  V_A001   varchar2,
                                                  V_A002   number,
                                                  V_A003   number,
                                                  V_A004   number,
                                                  V_A005   number,
                                                  V_A006   number,
                                                  V_A007   number,
                                                  V_A008   number,
                                                  V_A009   number,
                                                  V_A010   number,
                                                  V_A011   number,
                                                  V_A012   number,
                                                  V_A013   number,
                                                  V_A014   number,
                                                  V_A015   number,
                                                  V_A016   number,
                                                  V_A017   number,
                                                  V_A018   number) is
  v_rowid varchar2(1000);
  v_bmid  number;
  v_orgid number;
begin
  select a012 into v_bmid from krcs.t_sys_user where p001 = v_kjaxuser;
  select rowid
    into v_rowid
    from cisp.t_db_05_025
   where P001 = V_P001
     AND w100 = v_bmid
     and A100 = (select p002 from krcs.t_sys_user where p001 = v_kjaxuser);
  select p002 into v_orgid from krcs.t_sys_user where p001 = v_kjaxuser;

  UPDATE cisp.t_db_05_025
     SET A001 = V_A001,
         A002 = V_A002,
         A003 = V_A003,
         A004 = V_A004,
         A005 = V_A005,
         A006 = V_A006,
         A007 = V_A007,
         A008 = V_A008,
         A009 = V_A009,
         A010 = V_A010,
         A011 = V_A011,
         A012 = V_A012,
         A013 = V_A013,
         A014 = V_A014,
         A015 = V_A015,
         A016 = V_A016,
         A017 = V_A017,
         A018 = V_A018
   WHERE P001 = V_P001
     AND w100 = v_bmid
     and A100 = V_ORGID;
  commit;
  cisp_ins_updrecord('113015001',v_rowid,v_KJAXUSER,1,'ID',V_P001);
  insert into krcs.t_sys_log
    (p001, p002, a003, a004)
  values
    (v_kjaxuser,
     sysdate,
     '޸ ֤ȯ˾ʻרܱ ID:113015001',
     V_TASK);
  errcode := 1;
  errmsg  := ' ޸ĳɹ';

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113104001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113104001(

    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    v_p001 varchar2,
    v_a002 number,
    v_a003 number,
    v_a004 number
    )
      is
    v_orgid number;
    v_bmid number;
    v_count number;
    begin
     errcode:=1;
     errmsg:='';

     SELECT P002,A012 into v_orgid,v_bmid from  krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
     select count(*) into v_count from cisp.T_DB_31_03 t where t.p001=v_p001 and t.w100=v_bmid;

     if v_count=0 then
        insert into cisp.T_DB_31_03 select v_p001,v_a002,v_a003,v_a004,v_bmid  from dual;
     else
        update cisp.T_DB_31_03 t set t.a002=v_a002,t.a003=v_a003,t.a004=v_a004 where t.p001=v_p001 and t.w100=v_bmid;
     end if;

     insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113104001]޸F2-1ɹ',v_TASK);
     commit;


      end;
/

prompt
prompt Creating procedure CISP_UPD_DT_113105001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_113105001(

    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    v_p001 varchar2,
    v_a002 number
    )
      is
    v_orgid number;
    v_bmid number;
    v_count number;
    begin
     errcode:=1;
     errmsg:='';

     SELECT P002,A012 into v_orgid,v_bmid from  krcs.T_SYS_USER WHERE P001=v_KJAXUSER;
     select count(*) into v_count from cisp.T_DB_31_04 t where t.p001=v_p001 and t.w100=v_bmid;

     if v_count=0 then
        insert into cisp.T_DB_31_04 select v_p001,v_a002,v_bmid  from dual;
     else
        update cisp.T_DB_31_04 t set t.a002=v_a002 where t.p001=v_p001 and t.w100=v_bmid;
     end if;

     insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID113105001]޸F2-2ɹ',v_TASK);
     commit;


      end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120503001
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_120503001(

    errcode    out int,
    errmsg     out varchar2,
    V_KJAXUSER varchar2,
    v_task     varchar2,
    V_P001     integer,
    V_A003     number,
    V_A004     number,
    logP001    varchar2,
    logA002    varchar2)
  is
    V_ORGANID  NUMERIC;
    v_rowid varchar2(2000);
    v_count integer;
  begin
    errcode:=1;
    errmsg:='';

    select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;

    select count(1) into v_count from cisp.T_DB_B1_01 where  P002=V_P001 and P001=V_ORGANID;

    if(v_count = 1) then
        update  cisp.T_DB_B1_01 set a003 = nvl(V_A003,0),a004 = nvl(V_A004,0) where P002=V_P001 and P001=V_ORGANID;
        commit;
        select rowid into v_rowid  from cisp.T_DB_B1_01 where  P002=V_P001 and P001=V_ORGANID;
        cisp_ins_updrecord('120503001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
    insert into cisp.T_DB_B1_01(P001,P002,A003,A004) values(V_ORGANID,V_P001,nvl(V_A003,0),nvl(V_A004,0));
    end if;
    update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120503001 and a004=V_ORGANID and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (V_KJAXUSER,sysdate,'ݱάID120503001޸Ӫҵʲծ״'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120503002
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_120503002(

    errcode    out int,
    errmsg     out varchar2,
    v_KJAXUSER varchar2,
    v_task     varchar2,
    V_P001     integer,
    V_A003     number,
    V_A004     number,
    logP001    varchar2,
    logA002    varchar2)
  is
    V_ORGANID  NUMERIC;
    v_rowid varchar2(2000);
    v_count integer;
  begin
    errcode:=1;
    errmsg:='';


    select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;

    select count(1) into v_count from cisp.T_DB_B1_02 where P002=V_P001 and P001=V_ORGANID;

    if(v_count = 1) then
      update cisp.T_DB_B1_02 set a003 = nvl(V_A003,0),a004 = nvl(V_A004,0) where P002=V_P001 and P001=V_ORGANID;
      commit;
      select rowid into v_rowid from cisp.T_DB_B1_02 where P002=V_P001 and P001=V_ORGANID;
      cisp_ins_updrecord('120503002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
      insert into cisp.T_DB_B1_02(P001,P002,A003,A004) values(V_ORGANID,V_P001,nvl(V_A003,0),nvl(V_A004,0));
    end if;

    update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120503002 and a004=V_ORGANID and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID120503002޸Ӫҵ±'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120503003
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_120503003(
    errcode    out int,
    errmsg     out varchar2,
    v_KJAXUSER varchar2,
    v_task     varchar2,
    V_P001     integer,
    V_A003     varchar2,
    logP001    varchar2,
    logA002    varchar2)
  is
    V_ORGANID  NUMERIC;
    v_rowid varchar2(2000);
    v_count integer;
  begin
    errcode:=1;
    errmsg:='';


    select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;

    select count(1) into v_count from cisp.T_DB_B1_03 where P002=V_P001 and P001=V_ORGANID;

    if(v_count = 1) then
       update cisp.T_DB_B1_03 set a003=V_A003 where P002=V_P001 and P001=V_ORGANID;
       commit;
       select rowid into v_rowid from cisp.T_DB_B1_03 where P002=V_P001 and P001=V_ORGANID;
       cisp_ins_updrecord('120503003',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
       insert into cisp.T_DB_B1_03(P001,P002,A003) values(V_ORGANID,V_P001,V_A003);
    end if;

    update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120503003 and a004=V_ORGANID and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120503003޸Ӫҵ(ע)±'||logP001||'<font color=red>'||logA002||'</font>',v_task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120504001
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120504001(
    errcode out int,       ---ش
    errmsg out varchar2,   ---Ϣ
    v_KJAXUSER varchar2,   ---û
    v_task  varchar2,
    v_P001 integer,        ---ĿID
    v_A002 number,        ---ĩ
    v_A003 number,        ---ڳ
    v_A004 varchar2,       ---ע
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
   )
   is
   V_ORGANID  NUMERIC;
    v_rowid varchar2(2000);
    v_count integer;

begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

    select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;

    select count(1) into v_count from cisp.T_DB_B2_01 where P002=V_P001 and P001=V_ORGANID;
    --޸ݱ---

    if(v_count = 1) then
        update cisp.T_DB_B2_01 set a003=nvl(v_A002,0),a004=nvl(v_A003,0),a005 =v_A004 where P002=V_P001 and P001=V_ORGANID;
        commit;
        select rowid into v_rowid from cisp.T_DB_B2_01 where P002=V_P001 and P001=V_ORGANID;
        cisp_ins_updrecord('120504001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
        insert into cisp.T_DB_B2_01 (P001,P002,A003,A004,A005)
              values(V_ORGANID,v_P001,nvl(v_A002,0),nvl(v_A003,0),v_A004 );
    end if;
    --޸ݱ״̬---
    update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120504001 and a004=V_ORGANID and p002=v_task;
    --д־--
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120504001޸Ӫҵʽʲ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


end ;
/

prompt
prompt Creating procedure CISP_UPD_DT_120504002
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120504002(
    errcode out int,       ---ش
    errmsg out varchar2,   ---Ϣ
    v_KJAXUSER varchar2,   ---û
    v_task varchar2,
    v_P002 varchar2,        ---д
    v_A001 number,        ---ϵͳд
    v_A003 varchar2,        ---
    v_A004 number,        ---ڳͻ
    v_A005 number,        ---ڳʽ
    v_A006 number,       ---ĩͻ
    v_A007 number,       ---ĩʽ
    v_A100 varchar2,       ---ע
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
   )
   is
   V_ORGANID  NUMERIC;
   v_rowid varchar2(2000);
   v_count integer;
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

    select P002 into V_ORGANID from krcs.T_SYS_USER where P001 = v_KJAXUSER;

    select count(1) into v_count from cisp.T_DB_B2_02 where P002=V_P002 and P001=V_ORGANID;
    --޸ݱ---
    delete from cisp.t_bks_t031 where p001 = V_ORGANID and P002 = v_P002;
    if(v_count = 1) then
        update cisp.T_DB_B2_02 set a003=v_A003,a004=nvl(v_A004,0),a005=nvl(v_A005,0),
        a006=nvl(v_A006,0),a007=nvl(v_A007,0),a100=v_A100 where P002=V_P002 and P001=V_ORGANID;
        insert into cisp.t_bks_t031(P001,P002,A003,A004) values(V_ORGANID,v_P002,v_A003,v_A001);
        commit;
        select rowid into v_rowid from cisp.T_DB_B2_02 where P002=V_P002 and P001=V_ORGANID;
        cisp_ins_updrecord('120504002',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
        insert into cisp.T_DB_B2_02 (P001,P002,A003,A004,A005,A006,A007,A100)
              values(V_ORGANID,v_P002,v_A003,nvl(v_A004,0),nvl(v_A005,0),nvl(v_A006,0),nvl(v_A007,0),v_A100);
        insert into cisp.t_bks_t031(P001,P002,A003,A004) values(V_ORGANID,v_P002,v_A003,v_A001);
    end if;

    --޸ݱ״̬---
    update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120504002 and a004=V_ORGANID and p002=v_task;
    --д־--
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120504002޸Ӫҵʽֲ'||logP001||'<font color=red>'||logA002||'</font>',v_task);


end ;
/

prompt
prompt Creating procedure CISP_UPD_DT_120505001
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120505001(
    errcode out int,       ---ش
    errmsg out varchar2,   ---Ϣ
    v_KJAXUSER varchar2,   ---û
    v_task varchar2,
    v_P001 integer,        ---ĿID
    v_A002 integer,        ---
   /* v_A003 integer,        ---Bɣ*/
    v_A004 varchar2,       ---ע
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
   )
   is
     v_count integer;
     v_rowid varchar2(2000);
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

    select count(*) into v_count
      from cisp.T_DB_B3_01
     where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
    --޸ݱ---
    if(v_count=1) then
      update cisp.T_DB_B3_01
         set A003= nvl(v_A002,0),A005=v_A004
       where P001 = (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER)
         and P002 = v_P001;
      commit;
      select rowid into v_rowid from cisp.T_DB_B3_01 where P002 = v_P001 and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
      cisp_ins_updrecord('120505001',v_rowid,v_KJAXUSER,1,logP001,logA002);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505001޸Ӫҵʽ˻'||logP001||'<font color=red>'||logA002||'</font>',v_Task);
    else
      insert into cisp.T_DB_B3_01 (P001,P002,A003,A005)
              select P002,v_P001,nvl(v_A002,0),v_A004 from krcs.t_sys_user where P001=v_KJAXUSER;
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505001Ӫҵʽ˻'||logP001||'<font color=red>'||logA002||'</font>',v_task);

    end if;

    exception when others then
      rollback;
      errcode:=0;
      errmsg :='Ƿظļ¼';
      return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120505002
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120505002(
    errcode out int,       ---ش
    errmsg out varchar2,   ---Ϣ
    v_KJAXUSER varchar2,   ---û
    v_task varchar2,
    v_P001 integer,        ---ĿID
    v_A002 integer,        ---Aɣ
    v_A003 integer,        ---Bɣ
    v_A004 varchar2,       ---ע
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
   )
    is
    v_count integer;
    v_rowid varchar2(2000);
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';
    select count(*) into v_count
      from T_DB_B3_02
     where P002 = v_P001
       and p001 in (select P002 FROM krcs.t_sys_user where P001 = v_KJAXUSER);
    --޸ݱ---
    if(v_count=1) then
      update cisp.T_DB_B3_02
         set A003= nvl(v_A002,0),A004 = nvl(v_A003,0),A005=v_A004
       where P001 = (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER)
         and P002 = v_P001;
      commit;
      select rowid into v_rowid from T_DB_B3_02 where P002 = v_P001
       and p001 in (select P002 FROM krcs.t_sys_user where P001 = v_KJAXUSER);
      cisp_ins_updrecord('120505002',v_rowid,v_KJAXUSER,1,logP001,logA002);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505002޸Ӫҵ֤ȯ˻'||logP001||'<font color=red>'||logA002||'</font>',v_task);
    else
      insert into cisp.T_DB_B3_02 (P001,P002,A003,A004,A005)
              select P002,v_P001,nvl(v_A002,0),nvl(v_A003,0),v_A004 from krcs.t_sys_user where P001=v_KJAXUSER;
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505002Ӫҵ֤ȯ˻'||logP001||'<font color=red>'||logA002||'</font>',v_task);

    end if;
     --޸ݱ״̬---
     update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120505002 and a004=(select P002 from krcs.t_sys_user where P001 = v_KJAXUSER) and p002=v_task;

     exception when others then
              rollback;
              errcode:=0;
              errmsg :='Ƿظļ¼';
              return;


end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120505003
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120505003(
    errcode out int,       ---ش
    errmsg out varchar2,   ---Ϣ
    v_KJAXUSER varchar2,   ---û
    v_task varchar2,
    v_P001 integer,        ---ĿID
    v_A002 integer,        ---Aɣ
    v_A004 varchar2,       ---ע
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
   ) is
    v_count integer;
    v_rowid varchar2(2000);
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

   select count(*) into v_count
      from cisp.T_DB_B3_03
     where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
    --޸ݱ---
    if(v_count=1) then
      update cisp.T_DB_B3_03
         set A003= nvl(v_A002,0),A004 = v_A004
       where P001 = (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER)
         and P002 = v_P001;
       commit;
       select rowid into v_rowid from cisp.T_DB_B3_03 where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
       cisp_ins_updrecord('120505003',v_rowid,v_KJAXUSER,1,logP001,logA002);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505003޸Ӫҵ˻'||logP001||'<font color=red>'||logA002||'</font>',v_task);
    else
      insert into cisp.T_DB_B3_03 (P001,P002,A003,A004)
              select P002,v_P001,nvl(v_A002,0),v_A004 from krcs.t_sys_user where P001=v_KJAXUSER;
      insert into krcs.T_SYS_LOG (P001,P002,A003,a004) values (v_KJAXUSER,sysdate,'ݱάID120505003Ӫҵ˻'||logP001||'<font color=red>'||logA002||'</font>',v_task);

    end if;
     --޸ݱ״̬---
     update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120505003 and a004=(select P002 from krcs.t_sys_user where P001 = v_KJAXUSER) and p002=v_Task;

    exception when others then
              rollback;
              errcode:=0;
              errmsg :='Ƿظļ¼';
              return;
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120505004
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120505004(
    errcode out int,       ---ش
    errmsg out varchar2,   ---Ϣ
    v_KJAXUSER varchar2,   ---û
    v_task varchar2,
    v_P001 integer,        ---ĿID
    v_A002 integer,        ---
    v_A003 numeric,        ---ͻ׽ʽԪ
    v_A004 numeric,        ---ĩָй֤ȯֵԪ
    v_A005 varchar2,       ---ע
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
   ) is
    v_count integer;
    v_rowid varchar2(2000);
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

    select count(*) into v_count
      from cisp.T_DB_B3_04
     where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
    --޸ݱ---
    if(v_count=1) then
      update cisp.T_DB_B3_04
         set A003= nvl(v_A002,0),A004 = nvl(v_A003,0),A005=nvl(v_A004,0),A006=v_A005
       where P001 = (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER)
         and P002 = v_P001;
      commit;
      select rowid into v_rowid from cisp.T_DB_B3_04 where P002 = v_P001 and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
      cisp_ins_updrecord('120505004',v_rowid,v_KJAXUSER,1,logP001,logA002);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505004޸Ӫҵ˻淶'||logP001||'<font color=red>'||logA002||'</font>',v_task);
    else
      insert into cisp.T_DB_B3_04 (P001,P002,A003,A004,A005,A006)
              select P002,v_P001,nvl(v_A002,0),nvl(v_A003,0),nvl(v_A004,0),v_A005 from krcs.t_sys_user where P001=v_KJAXUSER;
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID1205050034Ӫҵ˻淶'||logP001||'<font color=red>'||logA002||'</font>',v_Task);

    end if;
 --޸ݱ״̬---
     update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120505004 and a004=(select P002 from krcs.t_sys_user where P001 = v_KJAXUSER) and p002=v_task;

      exception when others then
              rollback;
              errcode:=0;
              errmsg :='Ƿظļ¼';
              return;

end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120505005
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120505005(
    errcode out int,       ---ش
    errmsg out varchar2,   ---Ϣ
    v_KJAXUSER varchar2,   ---û
    v_task varchar2,
    v_P001 integer,        ---ĿID
    v_A002 integer,        ---
    v_A003 integer,        ---ڹ淶
    v_A004 integer,        ---ڼ/ָף
    v_A005 integer,       ---ע
    v_A006 varchar2,       ---ע
    logP001  varchar2,     ---־Ϣ
    logA002  varchar2
   ) is
    v_count integer;
    v_rowid varchar2(2000);
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

    select count(*) into v_count
      from cisp.T_DB_B3_05
     where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
    --޸ݱ---
    if(v_count=1) then
      update cisp.T_DB_B3_05
         set A003= nvl(v_A002,0),A004 = nvl(v_A003,0),A005=nvl(v_A004,0),A006=nvl(v_A005,0),A007=v_A006
       where P001 = (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER)
         and P002 = v_P001;
      commit;
      select rowid into v_rowid from cisp.T_DB_B3_05 where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
      cisp_ins_updrecord('120505005',v_rowid,v_KJAXUSER,1,logP001,logA002);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505005޸Ӫҵ˻䶯'||logP001||'<font color=red>'||logA002||'</font>',v_task);
    else
      insert into cisp.T_DB_B3_05 (P001,P002,A003,A004,A005,A006,A007)
              select P002,v_P001,nvl(v_A002,0),nvl(v_A003,0),nvl(v_A004,0),nvl(v_A005,0),v_A006 from krcs.t_sys_user where P001=v_KJAXUSER;
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120505005Ӫҵ˻䶯'||logP001||'<font color=red>'||logA002||'</font>',v_task);

    end if;
 --޸ݱ״̬---
     update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120505005 and a004=(select P002 from krcs.t_sys_user where P001 = v_KJAXUSER) and p002=v_task;

      exception when others then
              rollback;
              errcode:=0;
              errmsg :='Ƿظļ¼';
              return;

end ;
/

prompt
prompt Creating procedure CISP_UPD_DT_120506001
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120506001(
    errcode    out int, --ش
    errmsg     out varchar2, --Ϣ
    V_KJAXUSER varchar2, --û
    v_Task     varchar2,
    V_P001     integer, --ĿID
    V_A002     numeric, --֤ȯױڽ
    V_A003     numeric, --֤ȯۼƽ
    V_A004     numeric, --ѱ
    V_A005     numeric, --ۼ
    V_A006     numeric, --ĩָй֤ȯֵ
    logP001    varchar2,
    logA002    varchar2
  )
    is
    V_COUNT integer; --¼
    v_rowid varchar2(2000);
begin
  errcode := 1;
  errmsg  := '޸ݳɹ';
  /***޸ݱ¼***/
  select count(*)
    into V_COUNT
    from cisp.T_DB_B4_01
   where P002 = V_P001
     and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);
  if (V_COUNT = 1) then
    update cisp.T_DB_B4_01
       set A003 = nvl(V_A002,0),
           A004 = nvl(V_A003,0),
           A005 = nvl(V_A004,0),
           A006 = nvl(V_A005,0),
           A007 = nvl(V_A006,0)
     where P002 = V_P001
       and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);

     commit;

     select rowid into v_rowid from cisp.T_DB_B4_01 where P002 = V_P001 and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);
     cisp_ins_updrecord('120506001',v_rowid,v_KJAXUSER,1,logP001,logA002);
  else
    insert into cisp.T_DB_B4_01
      (P001,P002, A003, A004, A005, A006, A007)
      select P002,V_P001, nvl(V_A002,0), nvl(V_A003,0), nvl(V_A004,0),nvl(V_A005,0),nvl(V_A006,0)
        from krcs.t_sys_user
       where P001 = V_KJAXUSER;
  end if;
  commit;


  update krcs.T_SYS_T012 set A006 = 1015002, A007 = 1010002, A009 = 1009002
   where P001 = 120506001 and a004=(select P002 from krcs.t_sys_user where P001 = V_KJAXUSER) and p002=v_task;

  insert into krcs.T_SYS_LOG(P001, P002, A003,A004)
  values(V_KJAXUSER,sysdate,'ݱάID120506001Ӫҵ֤ȯ' || logP001 || '<font color=red>' ||logA002 || '</font>',v_task);

exception
  when others then
    rollback;
    errcode := 0;
    errmsg  := '޸ļ¼ʧ';
    return;
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120506002
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120506002(
    errcode    out int, --ش
    errmsg     out varchar2, --Ϣ
    V_KJAXUSER varchar2, --û
    v_task     varchar2,
    V_P001     integer, --ĿID
    V_A002     numeric, --ڽ׽-A
    V_A003     numeric, --ڽ׽-B
    V_A004     numeric, --ڽ׽-B
    V_A005     numeric, --ڱۼƽ-A
    V_A006     numeric, --ڱۼƽ-B
    V_A007     numeric, --ڱۼƽ-B
    logP001    varchar2,
    logA002    varchar2
  )
  is
    V_COUNT integer; --¼
    v_rowid varchar2(2000);
begin
  errcode := 1;
  errmsg  := '';
  /***޸ݱ¼***/
  select count(*)
    into V_COUNT
    from cisp.T_DB_B4_02
   where P002 = V_P001
     and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);
  if (V_COUNT = 1) then
    update cisp.T_DB_B4_02
       set A003 = nvl(V_A002,0),
           A004 = nvl(V_A003,0),
           A005 = nvl(V_A004,0),
           A006 = nvl(V_A005,0),
           A007 = nvl(V_A006,0),
           A008 = nvl(V_A007,0)
     where P002 = V_P001
       and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);
     commit;

     select rowid into v_rowid from cisp.T_DB_B4_02 where P002 = V_P001
     and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);
     cisp_ins_updrecord('120506002',v_rowid,v_KJAXUSER,1,logP001,logA002);
  else
    insert into cisp.T_DB_B4_02(P001,P002,A003,A004,A005,A006,A007,A008)
         select P002,V_P001,nvl(V_A002,0),nvl(V_A003,0),nvl(V_A004,0),nvl(V_A005,0),nvl(V_A006,0),nvl(V_A007,0)
           from krcs.t_sys_user
          where P001 = V_KJAXUSER;
  end if;

  commit;
  update krcs.T_SYS_T012
     set A006 = 1015002, A007 = 1010002, A009 = 1009002
   where P001 = 120506002 and a004=(select P002 from krcs.t_sys_user where P001 = V_KJAXUSER) and p002=v_Task;
  insert into krcs.T_SYS_LOG(P001, P002, A003,A004)
    values(V_KJAXUSER,sysdate,'ݱάID120506002Ӫҵɷݽ' || logP001 || '<font color=red>' ||logA002 || '</font>',v_Task);

  exception when others then
      rollback;
      errcode := 0;
      errmsg  := '޸ļ¼ʧ';
      return;
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120506003
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120506003(

    errcode    out int, --ش
    errmsg     out varchar2, --Ϣ
    V_KJAXUSER varchar2, --û
    v_task     varchar2,
    V_P001     integer, --ĿID
    V_A001     numeric, --֤ȯױڽ׽()
    V_A002     numeric, --֤ȯױڽ׽Ԫ
    V_A003     numeric, --֤ȯױڽ׽۱ң
    V_A004     numeric, --֤ȯڱۼƽ׽ң
    V_A005     numeric, --֤ȯڱۼƽ׽Ԫ
    V_A006     numeric, --֤ȯڱۼƽ׽۱ң

    V_A007     numeric, --ѱڽ׽()
    V_A008     numeric, --ѱڽ׽Ԫ
    V_A009     numeric, --ѱڽ׽۱ң
    V_A010     numeric, --ڱۼƽ׽ң
    V_A011     numeric, --ڱۼƽ׽Ԫ
    V_A012     numeric, --ڱۼƽ׽۱ң
    logP001    varchar2,
    logA002    varchar2
  )
  is
    V_COUNT integer; --¼
    v_rowid varchar2(2000);
begin
  errcode := 1;
  errmsg  := '';
  /***޸ݱ¼***/
  select count(*) into V_COUNT from cisp.T_DB_B4_03
  where P002 = V_P001 and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);
  if (V_COUNT > 0) then
    update cisp.T_DB_B4_03
       set A003 = nvl(V_A001,0),
           A004 = nvl(V_A002,0),
           A005 = nvl(V_A003,0),
           A006 = nvl(V_A004,0),
           A007 = nvl(V_A005,0),
           A008 = nvl(V_A006,0),
           A009 = nvl(V_A007,0),
           A010 = nvl(V_A008,0),
           A011 = nvl(V_A009,0),
           A012 = nvl(V_A010,0),
           A013 = nvl(V_A011,0),
           A014 = nvl(V_A012,0)
     where P002 = V_P001
       and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);

     commit;

     select rowid into v_rowid from cisp.T_DB_B4_03 where P002 = V_P001 and P001 in (select P002 from krcs.t_sys_user where P001 = V_KJAXUSER);
     cisp_ins_updrecord('120506003',v_rowid,v_KJAXUSER,1,logP001,logA002);
  else
    insert into cisp.T_DB_B4_03(P001,P002,A003,A004,A005,A006,A007,A008,A009,A010,A011,A012,A013,A014)
         select P002,
                V_P001,
                nvl(V_A001,0),
                nvl(V_A002,0),
                nvl(V_A003,0),
                nvl(V_A004,0),
                nvl(V_A005,0),
                nvl(V_A006,0),
                nvl(V_A007,0),
                nvl(V_A008,0),
                nvl(V_A009,0),
                nvl(V_A010,0),
                nvl(V_A011,0),
                nvl(V_A012,0)
           from krcs.t_sys_user
          where P001 = V_KJAXUSER;
  end if;

  commit;
  update krcs.T_SYS_T012
     set A006 = 1015002, A007 = 1010002, A009 = 1009002
   where P001 = 120506003 and a004=(select P002 from krcs.t_sys_user where P001 = V_KJAXUSER) and p002=v_task;

  insert into krcs.T_SYS_LOG(P001, P002, A003,A004)
  values(V_KJAXUSER,sysdate,'ݱάID120506003Ӫҵֳ' || logP001 || '<font color=red>' ||logA002 || '</font>',v_task);

  exception when others then
      rollback;
      errcode := 0;
      errmsg  := '޸ļ¼ʧ';
      return;
end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120506004
prompt ========================================
prompt
create or replace procedure cisp_upd_DT_120506004(
    errcode    out int,
    errmsg     out varchar2,
    v_KJAXUSER varchar2,
    v_task     varchar2,
    V_P001     integer,
    V_A003     varchar2,

    logP001    varchar2,
    logA002    varchar2)
  is
    V_ORGANID  NUMERIC;
    v_rowid varchar2(2000);
    v_count  integer;
  begin
    errcode:=1;
    errmsg:='';


    select P002 into V_ORGANID from krcs.t_sys_user where P001 = v_KJAXUSER;

    select count(1) into v_count from cisp.T_DB_B4_04 where P002=V_P001 and P001=V_ORGANID;

    if(v_count = 1) then
      update cisp.T_DB_B4_04 set a003 =V_A003  where P002=V_P001 and P001=V_ORGANID;
      commit;
      select rowid into v_rowid from cisp.T_DB_B4_04 where P002=V_P001 and P001=V_ORGANID;
      if( V_P001 = 3001) then
        cisp_ins_updrecord('120506004',v_rowid,v_KJAXUSER,1,logP001,logA002);
      else
        cisp_ins_updrecord('120506005',v_rowid,v_KJAXUSER,1,logP001,logA002);
      end if;
    else
      insert into cisp.T_DB_B4_04(P001,P002,A003) values(V_ORGANID,V_P001,V_A003);
    end if;


    update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120506004 and a004=V_ORGANID and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120506004޸Ӫҵ֤ȯע±'||logP001||'<font color=red>'||logA002||'</font>',v_Task);
  end;
/

prompt
prompt Creating procedure CISP_UPD_DT_120507001
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_120507001(
    errcode out int,  --ش
    errmsg out varchar2, --Ϣ
    v_KJAXUSER varchar2, --û
    v_task  varchar2,
    v_P001 integer, --ĿID

    v_A003 numeric, --
    v_A004 numeric, --ۼƽ
    v_A005 numeric, --ۼ
    v_A006 numeric, --ע
    v_A007 numeric, --ۼ
    v_A008 numeric, --ע
    v_A009 numeric,
    v_A010 numeric,
    v_A011 numeric,
    v_A012 numeric,
    v_A099 varchar2,
    logP001  varchar2,
    logA002  varchar2)
is
    v_count integer; --¼
    v_rowid varchar2(2000);
begin
    errcode:=1;
    errmsg:='';
    /***޸ݱ¼***/
    select count(*) into v_count from cisp.t_db_b50_01
           where P002=v_P001 and P001 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER);
    if(v_count=1) then
           update cisp.t_db_b50_01
           set A003=nvl(v_A003,0),A004=nvl(v_A004,0),
               A005=nvl(v_A005,0),A006=nvl(v_A006,0),
               A007=nvl(v_A007,0),A008=nvl(v_A008,0),
               A009=nvl(v_A009,0),A010=nvl(v_A010,0),
               A011=nvl(v_A011,0),A012=nvl(v_A012,0),
               A099=v_A099
           where P002=v_P001 and P001 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER);

           commit;
           select rowid into v_rowid from cisp.t_db_b50_01 where P002=v_P001 and P001 IN (SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER);
           cisp_ins_updrecord('120507001',v_rowid,v_KJAXUSER,1,logP001,logA002);
    else
           insert into cisp.t_db_b50_01(P001,P002,A003,A004,A005,A006,A007,A008,A009,A010,A011,A012,A099)
           select P002,v_P001,nvl(v_A003,0),nvl(v_A004,0),nvl(v_A005,0),nvl(v_A006,0),
           nvl(v_A007,0),nvl(v_A008,0),nvl(v_A009,0),nvl(v_A010,0),nvl(v_A011,0),nvl(v_A012,0),v_A099
           from krcs.t_sys_user
           where P001=v_KJAXUSER;
    end if;
    commit;
    update krcs.T_SYS_T012 SET A006=1015002, A007=1010002,A009=1009002 WHERE P001=120507001 and a004=(SELECT P002 FROM krcs.t_sys_user WHERE P001=v_KJAXUSER) and p002=v_task;
    insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID120507001޸Ĵ۲ƷϢ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

    exception when others then
              rollback;
              errcode:=0;
              errmsg:='޸ļ¼ʧ';
              return;
end ;
/

prompt
prompt Creating procedure CISP_UPD_DT_121002001
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_121002001(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 number,
    v_A002 number,
    v_A003 number,
    logP001  varchar2,
    logA002  varchar2
   )
   is
     v_count integer;
     v_rowid varchar2(2000);
     v_logA002 varchar2(2000);
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

    select t.a002 into v_logA002 from cisp.t_db_b_r_001 t where t.p001=v_P001;

    select count(*) into v_count
      from cisp.T_DACT_B_R001
     where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);

    if(v_count=1) then
      update cisp.T_DACT_B_R001
         set A002= nvl(v_A002,0),A003=nvl(v_A003,0)
       where P001 = (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER)
         and P002 = v_P001;

      commit;
      select rowid into v_rowid from cisp.T_DACT_B_R001 where P002 = v_P001 and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
      cisp_ins_updrecord('121002001',v_rowid,v_KJAXUSER,1,'Ŀ',v_logA002);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID121002001޸ӪҵȯרͳƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
    else
      insert into cisp.T_DACT_B_R001 (P001,P002,A002,A003)
              select P002,v_P001,nvl(v_A002,0),nvl(v_A003,0) from krcs.t_sys_user where P001=v_KJAXUSER;
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID121002001޸ӪҵȯרͳƱ'||logP001||'<font color=red>'||logA002||'</font>',v_Task);

    end if;

    exception when others then
      rollback;
      errcode:=0;
      errmsg :='Ƿظļ¼';
      return;

end ;
/

prompt
prompt Creating procedure CISP_UPD_DT_121002002
prompt ========================================
prompt
create or replace procedure cisp_UPD_DT_121002002(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_task varchar2,
    v_P001 number,
    v_A002 varchar2,
    v_A003 number,
    logP001  varchar2,
    logA002  varchar2
   )
   is
     v_count integer;
     v_rowid varchar2(2000);
begin
    errcode:=1;
    errmsg:='޸ļ¼ɹ';

    select count(*) into v_count
      from cisp.T_DACT_B_R002
     where P002 = v_P001
       and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);

    if(v_count=1) then
      update cisp.T_DACT_B_R002
         set A002= v_A002,A003=nvl(v_A003,0)
       where P001 = (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER)
         and P002 = v_P001;

      commit;
      select rowid into v_rowid from cisp.T_DACT_B_R002 where P002 = v_P001 and p001 in (select P002 from krcs.t_sys_user where P001 = v_KJAXUSER);
      cisp_ins_updrecord('121002002',v_rowid,v_KJAXUSER,1,logP001,logA002);
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID121002002޸ӪҵȯרͳƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);
    else
      insert into cisp.T_DACT_B_R002 (P001,P002,A002,A003)
              select P002,v_P001,v_A002,nvl(v_A003,0) from krcs.t_sys_user where P001=v_KJAXUSER;
      insert into krcs.T_SYS_LOG (P001,P002,A003,A004) values (v_KJAXUSER,sysdate,'ݱάID121002002޸ӪҵȯרͳƱ'||logP001||'<font color=red>'||logA002||'</font>',v_task);

    end if;

    exception when others then
      rollback;
      errcode:=0;
      errmsg :='Ƿظļ¼';
      return;

end ;
/

prompt
prompt Creating procedure CISP_UPD_FLOW_TABLE
prompt ======================================
prompt
create or replace procedure cisp_upd_flow_table(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    v_TABLES varchar2,
    v_tableid varchar2,
    v_type varchar2,
    v_cells varchar2,
    v_VALUES varchar2,
    v_total varchar2,
    v_BBQ varchar2
)
is
    type TP_STR_ARRAY is table of varchar2(256);
    v_field_array TP_STR_ARRAY:=TP_STR_ARRAY();
    num int;

    v_pos int;

    tmp   varchar2(8000);
    v_sql varchar2(8000);
    v_sql_del varchar2(8000);
    v_head varchar2(8000);
    v_val varchar2(256);
    v_userid varchar2(100);
    v_coltype varchar2(100);
    v_repname varchar2(100);
    v_repid varchar2(100);
    v_logcontent varchar2(256);
    v_sqllog varchar2(1000);
begin
   tmp := v_cells;
   select decode(v_type,'corp',b.A002,a.a012) into v_userid from KRCS.t_sys_user a ,KRCS.t_ctl_t036 b where b.p001=a.p002 and a.p001=v_KJAXUSER;
   select a004 into v_repname from KRCS.t_sys_t004 where b002=v_tables and a005=v_tableid ;
   select a005 into v_repid from KRCS.t_sys_t004 where b002=v_tables and a005=v_tableid ;
   v_sql_del :='delete from ' ||v_TABLES || ' where bbq= ''' || v_BBQ || ''' and userid= ''' ||v_userid ||'''';
   execute   immediate v_sql_del;
   v_pos := instr( tmp, '|' );
   while v_pos > 0 loop
      v_field_array.EXTEND;
      num := v_field_array.COUNT;
      v_field_array(num) := substr(tmp, 1, v_pos - 1);
      tmp := substr(tmp, v_pos + 1);
      v_pos := instr( tmp, '|' );
   end loop;

   v_sql := 'insert into ' || v_tables ||' (';
   for i in 1..v_field_array.count loop
       if i>1 then
          v_sql := v_sql || ',';
       end if;
       v_sql := v_sql || v_field_array(i);
   end loop;
   v_sql := v_sql || ',BBQ,BTYPE,OPTION1,SHTAG,USERID) values(';

   v_head := v_sql;

   tmp := v_VALUES;

   num := 0;

   v_pos := instr( tmp, '|' );
   while v_pos > 0 loop
      v_val := substr(tmp, 1, v_pos - 1);

      num := num + 1;
      if num > 1 then
         v_sql := v_sql || ',';
      end if;
    v_field_array(num) :=upper(v_field_array(num));
     select COLTYPE into v_coltype from sys.col where tname=v_TABLES and cname=v_field_array(num);
    if v_coltype='NUMBER' then
        if v_val is null then v_val :='''''';
        else
        v_val :=v_val;
        end if;
      end if;
     if v_coltype='VARCHAR2'then
      v_val :='''' || v_val ||'''';
      end if;
      if v_coltype='CHAR'then
      v_val :='''' || v_val ||'''';
      end if;
      if v_coltype='DATE'then
      v_val := 'To_Date('''||v_val||''','||'''yyyy-mm-dd'')';
      end if;
      v_sql := v_sql || v_val;

      if num = v_field_array.count then
         v_sql := v_sql ||','||''''||v_bbq||''''||','||'0'||','||''''''||','||'0'||','|| v_userid ||')';
         dbms_output.put_line( v_sql );
         execute   immediate v_sql;
         v_sql := v_head;
         num := 0;
      end if;

      tmp := substr(tmp, v_pos + 1);
      v_pos := instr( tmp, '|' );
   end loop;
    v_logcontent :='''޸ı۱ڣ'||v_bbq||'IDΪ<font color=red>'||v_repid||'</font>'||v_repname||''||'''';
    v_sqllog :='insert into KRCS.T_SYS_LOG (P001,P002,A003,A004) values ('''||v_KJAXUSER||''',sysdate,'||v_logcontent||','||v_TASK||')';
    execute   immediate v_sqllog;
    errcode := 1;
    errmsg := '޸ıɹ';
end;
/

prompt
prompt Creating procedure CISP_UPD_TABLES
prompt ==================================
prompt
create or replace procedure cisp_upd_tables(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    v_tables varchar2,
    v_tableid varchar2,
    v_type varchar2,
    v_values varchar2,
    v_bbq varchar2)
  is
    v_index1 int;
    v_index2 int;
    v_value varchar2(255);
    v_strtmp varchar2(8000);
    v_sql varchar2(8000);
    v_col varchar2(255);
    v_userid varchar2(100);
    v_coltype varchar2(100);
    v_repname varchar2(100);
    v_repid varchar2(100);
    v_logcontent varchar2(256);
    v_sqllog varchar2(1000);
  begin
    v_index2 := 1;
    v_strtmp := v_values;
    select decode(v_type,'corp',b.A002,a.a012) into v_userid from KRCS.t_sys_user a ,KRCS.t_ctl_t036 b where b.p001=a.p002 and a.p001=v_KJAXUSER;
    select a004 into v_repname from KRCS.t_sys_t004 where b002=v_tables and a005=v_tableid ;
    select a005 into v_repid from KRCS.t_sys_t004 where b002=v_tables and a005=v_tableid ;
  loop
     v_index1 := instr(v_strtmp, '|', v_index2);
     exit when v_index1 <= 0;
     v_col := substr(v_strtmp, v_index2, v_index1 - v_index2);
     v_index2 := v_index1 + 1;
     v_index1 := instr(v_strtmp, '|', v_index2);
      exit when v_index1 <= 0;
      v_value := substr(v_strtmp, v_index2, v_index1 - v_index2);
      v_index2 := v_index1 + 1;
      v_col :=upper(v_col);
      select COLTYPE into v_coltype from sys.col where tname=v_tables and cname=v_col;

        -- exit when v_value=null;
        if v_coltype='NUMBER' then
          if nvl(length(trim(v_value)),0) =0 then
          v_sql:='update '||v_tables||' set '||v_col||'=null where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
          else
          v_sql:='update '||v_tables||' set '||v_col||'=' ||v_value|| ' where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
          end if;
        end if;
        if v_coltype='VARCHAR2'then
          if nvl(length(trim(v_value)),0) =0 then
          v_value:=null;
          v_sql:='update '||v_tables||' set '||v_col||'='||null||' where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
          end if;
          v_sql:='update '||v_tables||' set '||v_col||'=''' ||v_value|| ''' where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
        end if;
        if v_coltype='CHAR'then
           if nvl(length(trim(v_value)),0) =0 then
          v_value:=null;
          v_sql:='update '||v_tables||' set '||v_col||'='||null||' where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
           end if;
          v_sql:='update '||v_tables||' set '||v_col||'=''' ||v_value|| ''' where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
        end if;
        if v_coltype='DATE'then
            if nvl(length(trim(v_value)),0) =0 then
            v_value:=null;
            v_sql:='update '||v_tables||' set '||v_col||'='||null||' where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
            end if;
            v_sql:='update '||v_tables||' set '||v_col||'=''' ||to_date(v_value,'yyyy-mm-dd')|| ''' where bbq='''||v_bbq||''' and userid='''||v_userid||'''';
        end if;
        execute  immediate v_sql;

       end loop;
    v_logcontent :='''޸ı۱ڣ'||v_bbq||'IDΪ<font color=red>'||v_repid||'</font>'||v_repname||''||'''';
    v_sqllog :='insert into KRCS.T_SYS_LOG (P001,P002,A003,A004) values ('''||v_KJAXUSER||''',sysdate,'||v_logcontent||','||v_TASK||')';
    execute immediate v_sqllog;
    errcode := 1;
    errmsg := '޸ıɹ';
    return;
  end;
/

prompt
prompt Creating procedure KRCS_MAKEREPORT_1100030
prompt ==========================================
prompt
create or replace procedure krcs_makereport_1100030(errcode out int, errmsg out varchar2,
       v_KJAXUSER varchar2,v_TASK varchar2 ,v_P001 varchar2, v_P002 varchar2, v_P003 varchar2)
is
    v_temp varchar(256);
    v_userid  integer;
    v_orgid  integer;
    begintime varchar2(8);
    endtime varchar2(8);
    v_status number;
     /*ϵͳͳƱ */
begin
    errcode:=1;
    errmsg := 'ɱɹ';


    delete from T_CSRC0710_0_3 WHERE BBQ=v_P001; /* ɾͬһڵ */
    SELECT  t1.a012,t1.p002  into v_userid,v_orgid
    FROM krcs.T_SYS_USER T1, krcs.T_CTL_T036 T2
    WHERE T1.P001 = v_KJAXUSER
      AND T1.P002 = T2.P001;

    select TO_CHAR(a005,'YYYYMMDD'),TO_CHAR(a006,'YYYYMMDD') into begintime,endtime
    from cisp.t_b00_d004
    where a002=1013001 and c001=1001101 and d100=1006002;


    insert into T_CSRC0710_0_3(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,A2,B2,C2,D2,E2,F2,G2,H2,I2,J2)
      select v_P001,v_userid,0,NULL,1,0,p001,a002,a003,a004,a005,a006,a007,decode(a008,1001101,'T',1001102,'F'),a009,a010 from t_b15_t002 where TO_CHAR(P001,'YYYYMMDD') between begintime and endtime and a100=v_orgid;
    insert into T_CSRC0710_0_3(BBQ,USERID,BTYPE,OPTION1,SHTAG,ISHJ,C2,D2,E2,F2,G2)
      select v_P001,v_userid,0,NULL,null,1,sum(a003),null,sum(a005),sum(a006),sum(a007) from t_b15_t002 where TO_CHAR(P001,'YYYYMMDD') between begintime and endtime and a100=v_orgid;
    update krcs.T_SYS_T024 SET A010=1015001,A009=1016002,A011=1009002,A012=1020002 WHERE P001=1100030 and a008=v_userid;


    SELECT 'ɣ۱ڣ'||replace(v_P001,'-')||'ID<font color=red>'||P001||'</font>Ӧıƣ<font color=red>B0'||A004||'</font>' INTO v_temp FROM krcs.T_SYS_T004 WHERE P001 = 1100030;
    INSERT INTO krcs.T_SYS_LOG(P001,P002,A003,A004) VALUES(v_KJAXUSER,sysdate,v_temp,v_TASK);
    commit;
    exception when others then
                rollback;
                update krcs.T_SYS_T024 SET A010=1015002 WHERE P001=1100030 and a008=v_userid;/*޸ת״̬ */
                errcode := 0;
                errmsg := 'ڴ洢krcs_makereport_1100030!';
                return;
end;
/

prompt
prompt Creating procedure KRCS_SUBMIT_REPORT
prompt =====================================
prompt
create or replace procedure krcs_submit_report(
    errcode out int,
    errmsg out varchar2,
    v_KJAXUSER varchar2,
    v_TASK varchar2,
    V_REPORT varchar2,
    V_LEVEL int
    ) is


    v_index11 int;
    v_index12 int;
    v_type int;
    v_reportlist varchar2(4000);
    v_report2 varchar2(16);
  begin

    v_index12 := 1;
    v_reportlist := V_REPORT ;
    select t.a006 into v_type from krcs.t_sys_t005 t where t.p001=v_TASK;

  loop

      v_index11 := instr(v_reportlist, ',', v_index12);
      exit when v_index11 <= 0;
      v_report2  := substr(v_reportlist, v_index12, v_index11 - v_index12);
      v_index12 := v_index11 + 1;
       if v_type = 1019001   then
          update krcs.t_sys_t024 t set t.a009=1016001 where t.p001=v_report2 and t.a008=(select a012 from krcs.t_sys_user where p001=v_KJAXUSER) and t.a002=v_TASK;
       end if;
       if v_type = 1019002 or V_LEVEL=0 then
          update krcs.t_sys_t014 t set t.a009=1016001 where t.p001=v_report2 and t.a008=(select p002 from krcs.t_sys_user where p001=v_KJAXUSER) and t.a002=v_TASK;
       end if;

  end loop;
   commit;
    errcode := 1;
    errmsg := 'ύɹ';
    return;
  end;
/

prompt
prompt Creating procedure T_C13_3_UPDATEBKS
prompt ====================================
prompt
create or replace procedure t_c13_3_updatebks
 -- *************************************************************************
  -- SYSTEM:       ϵͳ
  -- SUBSYS:
  -- PROGRAM:
  -- DESCRIPTION:
  -- AUTHOR:
  -- CREATE DATE:
  -- COPYRIGHT:
  -- VERSION:
  -- EDIT HISTORY:
  -- *************************************************************************

 as

  v_bbq_begindate         number; --ʼ
  v_bbq_enddate           number; --ֹ
  v_bbq_endworkdate       number; --һ
  v_bbq_next_enddate      number;
  v_bbq_next_year_enddate number;
  v_dhgje                 number(19, 2);
  v_dhgsz                 number(19, 2);
begin
  --ÿʼʱʱ
  select to_number(to_char(a005, 'yyyymmdd')),
         to_number(to_char(a006, 'yyyymmdd'))
    into v_bbq_begindate, v_bbq_enddate
    from t_b00_d004
   where a002 = 1013001
     and c001 = 1001101;
delete from t_c13_3_bchy;
commit;
insert into t_c13_3_bchy
select * from (select t.hth from T_BKS_ZYRHHY t
minus
select t.hth from T_ETL_C13_3_YCL t
);
commit;

delete from t_cisp_htwybs;
commit;
insert into t_cisp_htwybs
select t.hth,t.sfwy from T_BKS_ZYRHHY t;
commit;

end;
/

prompt
prompt Creating type body T_CAT
prompt ========================
prompt
CREATE OR REPLACE TYPE BODY "T_CAT" is
static function ODCIAggregateInitialize(sctx IN OUT t_cat )
return number is
begin
sctx := t_cat('');
return ODCIConst.Success;
end;

member function ODCIAggregateIterate(self IN OUT t_cat, value IN varchar2)
return number is
begin
self.union_mc := self.union_mc || ';' || value;
return ODCIConst.Success;
end;

member function ODCIAggregateTerminate(self IN t_cat, returnValue OUT varchar2, flags IN number) return number is
begin
--ȥͷ';'
if substr(self.union_mc,1,1) = ';' then
   returnValue := substr(self.union_mc,2,length(self.union_mc)-1);
else
   returnValue := self.union_mc;
end if;
return ODCIConst.Success;
end;

member function ODCIAggregateMerge(self IN OUT t_cat , ctx2 IN t_cat ) return number is
begin
return ODCIConst.Success;
end;
end;
/

prompt
prompt Creating trigger TR_OPTION1_C14_4
prompt =================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C14_4" before insert on T_CSRC1219_C14_4 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C14_7
prompt =================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C14_7" before insert on T_CSRC1219_C14_7 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C14_8
prompt =================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C14_8" before insert on T_CSRC1219_C14_8 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C3_2
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C3_2" before insert on T_CSRC0707_C3_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C4_1
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C4_1" before insert on T_CSRC0128_C4_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C4_2
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C4_2" before insert on T_CSRC0128_C4_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C6_1_1
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C6_1_1" before insert on T_CSRC0707_C6_1_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C8_1_1
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C8_1_1" before insert on T_CSRC0707_C8_1_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_C9_1
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_C9_1" before insert on T_CSRC0707_C9_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_1
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_1" before insert on T_CSRC0707_E1_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_10
prompt =================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_10" before insert on T_CSRC0730_E1_10 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_11_1
prompt ===================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_11_1" before insert on t_csrc0624_e1_11_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_11_2
prompt ===================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_11_2" before insert on t_csrc0624_e1_11_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_3_2
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_3_2" before insert on T_CSRC0128_E1_3_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_3_3
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_3_3" before insert on T_CSRC0128_E1_3_3 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_4
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_4" before insert on T_CSRC0707_E1_4 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_6_1
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_6_1" before insert on T_CSRC0707_E1_6_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_6_2
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_6_2" before insert on T_CSRC0707_E1_6_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_6_3
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_6_3" before insert on T_CSRC0707_E1_6_3 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_6_4
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_6_4" before insert on T_CSRC0707_E1_6_4 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_7_3
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_7_3" before insert on T_CSRC0707_E1_7_3 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_8_1
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_8_1" before insert on T_CSRC0707_E1_8_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_8_2
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_8_2" before insert on t_Csrc0707_E1_8_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_E1_9
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_E1_9" before insert on T_CSRC0730_E1_9 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_F1_1
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_F1_1" before insert on T_CSRC0619_F1_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_F1_2
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_F1_2" before insert on T_CSRC0619_F1_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_F2_1
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_F2_1" before insert on T_CSRC0619_F2_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_F2_2
prompt ================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_F2_2" before insert on T_CSRC0619_F2_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_2_1
prompt ====================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_2_1" before insert on T_CSRC0811_zqgs_2_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_2_2
prompt ====================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_2_2" before insert on T_CSRC0811_zqgs_2_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_2_3
prompt ====================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_2_3" before insert on T_CSRC0811_zqgs_2_3 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_3
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_3" before insert on T_CSRC0811_zqgs_3 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_3_1
prompt ====================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_3_1" before insert on T_CSRC0811_zqgs_3_1 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_3_2
prompt ====================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_3_2" before insert on T_CSRC0811_zqgs_3_2 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_6
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_6" before insert on T_CSRC0811_zqgs_6 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/

prompt
prompt Creating trigger TR_OPTION1_ZQGS_7
prompt ==================================
prompt
CREATE OR REPLACE TRIGGER "TR_OPTION1_ZQGS_7" before insert on T_CSRC0811_zqgs_7 for each row
begin select option1_seq.nextval into :new.option1 from dual; end;
/


spool off
